/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/types","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/platform/product/common/productService","vs/base/common/map","fs","os","vs/base/common/process","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/uriIdentity/common/uriIdentity","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/extensions/common/extensions","vs/base/common/performance","vs/editor/common/core/range","vs/base/parts/ipc/common/ipc","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/codicons","vs/base/common/marshalling","vs/base/common/uriIpc","child_process","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/common/mime","vs/base/common/processes","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/decorators","vs/base/common/functional","vs/base/common/json","path","net","vs/base/common/glob","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/workspace/common/workspace","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/node/zip","vs/base/common/amd","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/themables","vs/base/node/id","vs/editor/common/core/position","vs/base/common/htmlContent","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/environmentService","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/remoteLanguagePacks","vs/server/node/extensionsScannerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/common/labels","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/credentials/node/credentialsMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostTestItem","vs/workbench/contrib/terminal/common/remote/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","fs/promises","readline","util","minimist","assert","graceful-fs","https","yauzl","yazl","http","vs/server/node/server.main"],be=function(ce){for(var e=[],D=0,O=ce.length;D<O;D++)e[D]=pe[ce[D]];return e};define(pe[94],be([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class D{static get(){const r=new Map,C=new Map,I=new Map,P=new Map;function w(l,d){l.has(d.detail)||l.set(d.detail,-d.timestamp)}function $(l,d){const m=l.get(d.detail);m&&(m>=0||l.set(d.detail,m+d.timestamp))}let A=[];typeof ce=="function"&&typeof ce.getStats=="function"&&(A=ce.getStats().slice(0).sort((l,d)=>l.timestamp-d.timestamp));for(const l of A)switch(l.type){case 10:w(r,l);break;case 11:case 12:$(r,l);break;case 21:w(C,l);break;case 22:$(C,l);break;case 33:w(I,l);break;case 34:$(I,l);break;case 31:w(P,l);break;case 32:$(P,l);break}let k=0;I.forEach(l=>k+=l);function p(l){const d=[];return l.forEach((m,c)=>d.push([c,m])),d}return{amdLoad:p(r),amdInvoke:p(C),nodeRequire:p(I),nodeEval:p(P),nodeRequireTotal:k}}static toMarkdownTable(r,C){let I="";const P=[];return r.forEach((w,$)=>{P[$]=w.length}),C.forEach(w=>{w.forEach(($,A)=>{typeof $>"u"&&($=w[A]="-");const k=$.toString().length;P[A]=Math.max(k,P[A])})}),r.forEach((w,$)=>{I+=`| ${w+" ".repeat(P[$]-w.toString().length)} `}),I+=`|
`,r.forEach((w,$)=>{I+=`| ${"-".repeat(P[$])} `}),I+=`|
`,C.forEach(w=>{w.forEach(($,A)=>{typeof $<"u"&&(I+=`| ${$+" ".repeat(P[A]-$.toString().length)} `)}),I+=`|
`}),I}}e.$S=D}),define(pe[73],be([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=e.$Ug=e.$Tg=void 0;function D(I){return(P,w,$)=>{let A=null,k=null;if(typeof $.value=="function"?(A="value",k=$.value):typeof $.get=="function"&&(A="get",k=$.get),!k)throw new Error("not supported");$[A]=I(k,w)}}function O(I,P,w){let $=null,A=null;if(typeof w.value=="function"?($="value",A=w.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&($="get",A=w.get),!A)throw new Error("not supported");const k=`$memoize$${P}`;w[$]=function(...p){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,p)}),this[k]}}e.$Tg=O;function r(I,P,w){return D(($,A)=>{const k=`$debounce$${A}`,p=`$debounce$result$${A}`;return function(...l){this[p]||(this[p]=w?w():void 0),clearTimeout(this[k]),P&&(this[p]=P(this[p],...l),l=[this[p]]),this[k]=setTimeout(()=>{$.apply(this,l),this[p]=w?w():void 0},I)}})}e.$Ug=r;function C(I,P,w){return D(($,A)=>{const k=`$throttle$timer$${A}`,p=`$throttle$result$${A}`,l=`$throttle$lastRun$${A}`,d=`$throttle$pending$${A}`;return function(...m){if(this[p]||(this[p]=w?w():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),P&&(this[p]=P(this[p],...m)),this[d])return;const c=this[l]+I;c<=Date.now()?(this[l]=Date.now(),$.apply(this,[this[p]]),this[p]=w?w():void 0):(this[d]=!0,this[k]=setTimeout(()=>{this[d]=!1,this[l]=Date.now(),$.apply(this,[this[p]]),this[p]=w?w():void 0},c-Date.now()))}})}e.$Vg=C}),define(pe[11],be([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class D{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?E.isErrorNoTelemetry(s)?new E(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(a=>{a(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.$U=D,e.$V=new D;function O(t){e.$V.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=O;function r(t){if(!t||typeof t!="object")return!1;const s=t;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}e.$X=r;function C(t){$(t)||e.$V.onUnexpectedError(t)}e.$Y=C;function I(t){$(t)||e.$V.onUnexpectedExternalError(t)}e.$Z=I;function P(t){if(t instanceof Error){const{name:s,message:a}=t,i=t.stacktrace||t.stack;return{$isError:!0,name:s,message:a,stack:i,noTelemetry:E.isErrorNoTelemetry(t)}}return t}e.$1=P;const w="Canceled";function $(t){return t instanceof A?!0:t instanceof Error&&t.name===w&&t.message===w}e.$2=$;class A extends Error{constructor(){super(w),this.name=this.message}}e.$3=A;function k(){const t=new Error(w);return t.name=t.message,t}e.$4=k;function p(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.$5=p;function l(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.$6=l;function d(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.$7=d;function m(t){const s=new Error(`${t} has been disposed`);return s.name="DISPOSED",s}e.$8=m;function c(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.$9=c;class u extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.$0=u;class h extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.$$=h;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=g;class E extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof E)return s;const a=new E;return a.message=s.message,a.stack=s.stack,a}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.$ab=E;class v extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,v.prototype)}}e.$bb=v}),define(pe[18],be([1,0,11]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.CompareResult=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.top=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=void 0;function O(N,B=0){return N[N.length-(1+B)]}e.$9e=O;function r(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.$0e=r;function C(N,B,U=(z,Z)=>z===Z){if(N===B)return!0;if(!N||!B||N.length!==B.length)return!1;for(let z=0,Z=N.length;z<Z;z++)if(!U(N[z],B[z]))return!1;return!0}e.$$e=C;function I(N,B){const U=N.length-1;B<U&&(N[B]=N[U]),N.pop()}e.$_e=I;function P(N,B,U){return w(N.length,z=>U(N[z],B))}e.$af=P;function w(N,B){let U=0,z=N-1;for(;U<=z;){const Z=(U+z)/2|0,de=B(Z);if(de<0)U=Z+1;else if(de>0)z=Z-1;else return Z}return-(U+1)}e.$bf=w;function $(N,B){let U=0,z=N.length;if(z===0)return 0;for(;U<z;){const Z=Math.floor((U+z)/2);B(N[Z])?z=Z:U=Z+1}return U}e.$cf=$;function A(N,B,U){if(N=N|0,N>=B.length)throw new TypeError("invalid index");const z=B[Math.floor(B.length*Math.random())],Z=[],de=[],Ee=[];for(const Pe of B){const Ae=U(Pe,z);Ae<0?Z.push(Pe):Ae>0?de.push(Pe):Ee.push(Pe)}return N<Z.length?A(N,Z,U):N<Z.length+Ee.length?Ee[0]:A(N-(Z.length+Ee.length),de,U)}e.$df=A;function k(N,B){const U=[];let z;for(const Z of N.slice(0).sort(B))!z||B(z[0],Z)!==0?(z=[Z],U.push(z)):z.push(Z);return U}e.$ef=k;function p(N,B,U){const z=[];function Z(Pe,Ae,Fe){if(Ae===0&&Fe.length===0)return;const ge=z[z.length-1];ge&&ge.start+ge.deleteCount===Pe?(ge.deleteCount+=Ae,ge.toInsert.push(...Fe)):z.push({start:Pe,deleteCount:Ae,toInsert:Fe})}let de=0,Ee=0;for(;;){if(de===N.length){Z(de,0,B.slice(Ee));break}if(Ee===B.length){Z(de,N.length-de,[]);break}const Pe=N[de],Ae=B[Ee],Fe=U(Pe,Ae);Fe===0?(de+=1,Ee+=1):Fe<0?(Z(de,1,[]),de+=1):Fe>0&&(Z(de,0,[Ae]),Ee+=1)}return z}e.$ff=p;function l(N,B,U){const z=p(N,B,U),Z=[],de=[];for(const Ee of z)Z.push(...N.slice(Ee.start,Ee.start+Ee.deleteCount)),de.push(...Ee.toInsert);return{removed:Z,added:de}}e.$gf=l;function d(N,B,U){if(U===0)return[];const z=N.slice(0,U).sort(B);return c(N,B,z,U,N.length),z}e.top=d;function m(N,B,U,z,Z){return U===0?Promise.resolve([]):new Promise((de,Ee)=>{(async()=>{const Pe=N.length,Ae=N.slice(0,U).sort(B);for(let Fe=U,ge=Math.min(U+z,Pe);Fe<Pe;Fe=ge,ge=Math.min(ge+z,Pe)){if(Fe>U&&await new Promise(ke=>setTimeout(ke)),Z&&Z.isCancellationRequested)throw new D.$3;c(N,B,Ae,Fe,ge)}return Ae})().then(de,Ee)})}e.$if=m;function c(N,B,U,z,Z){for(const de=U.length;z<Z;z++){const Ee=N[z];if(B(Ee,U[de-1])<0){U.pop();const Pe=$(U,Ae=>B(Ee,Ae)<0);U.splice(Pe,0,Ee)}}}function u(N){return N.filter(B=>!!B)}e.$jf=u;function h(N){let B=0;for(let U=0;U<N.length;U++)N[U]&&(N[B]=N[U],B+=1);N.length=B}e.$kf=h;function g(N,B,U){N.splice(U,0,N.splice(B,1)[0])}e.$lf=g;function E(N){return!Array.isArray(N)||N.length===0}e.$mf=E;function v(N){return Array.isArray(N)&&N.length>0}e.$nf=v;function t(N,B=U=>U){const U=new Set;return N.filter(z=>{const Z=B(z);return U.has(Z)?!1:(U.add(Z),!0)})}e.$of=t;function s(N){const B=new Set;return U=>{const z=N(U);return B.has(z)?!1:(B.add(z),!0)}}e.$pf=s;function a(N,B){const U=i(N,B);if(U!==-1)return N[U]}e.$qf=a;function i(N,B){for(let U=N.length-1;U>=0;U--){const z=N[U];if(B(z))return U}return-1}e.$rf=i;function n(N,B){return N.length>0?N[0]:B}e.$sf=n;function o(N,B){return N.length>0?N[N.length-1]:B}e.$tf=o;function f(N,B,U=(z,Z)=>z===Z){let z=0;for(let Z=0,de=Math.min(N.length,B.length);Z<de&&U(N[Z],B[Z]);Z++)z++;return z}e.$uf=f;function b(N){return[].concat(...N)}e.$vf=b;function y(N,B){let U=typeof B=="number"?N:0;typeof B=="number"?U=N:(U=0,B=N);const z=[];if(U<=B)for(let Z=U;Z<B;Z++)z.push(Z);else for(let Z=U;Z>B;Z--)z.push(Z);return z}e.$wf=y;function S(N,B,U){return N.reduce((z,Z)=>(z[B(Z)]=U?U(Z):Z,z),Object.create(null))}e.$xf=S;function L(N,B){return N.push(B),()=>j(N,B)}e.$yf=L;function j(N,B){const U=N.indexOf(B);if(U>-1)return N.splice(U,1),B}e.$zf=j;function Q(N,B,U){const z=N.slice(0,B),Z=N.slice(B);return z.concat(U,Z)}e.$Af=Q;function le(N,B){let U;if(typeof B=="number"){let z=B;U=()=>{const Z=Math.sin(z++)*179426549;return Z-Math.floor(Z)}}else U=Math.random;for(let z=N.length-1;z>0;z-=1){const Z=Math.floor(U()*(z+1)),de=N[z];N[z]=N[Z],N[Z]=de}}e.$Bf=le;function Y(N,B){const U=N.indexOf(B);U>-1&&(N.splice(U,1),N.unshift(B))}e.$Cf=Y;function ee(N,B){const U=N.indexOf(B);U>-1&&(N.splice(U,1),N.push(B))}e.$Df=ee;function ue(N,B){for(const U of B)N.push(U)}e.$Ef=ue;function X(N,B){return Array.isArray(N)?N.map(B):B(N)}e.$Ff=X;function he(N){return Array.isArray(N)?N:[N]}e.$Gf=he;function x(N){return N[Math.floor(Math.random()*N.length)]}e.$Hf=x;function se(N,B){for(const U of N){const z=B(U);if(z!==void 0)return z}}e.$If=se;function V(N,B,U){const z=H(N,B),Z=N.length,de=U.length;N.length=Z+de;for(let Ee=Z-1;Ee>=z;Ee--)N[Ee+de]=N[Ee];for(let Ee=0;Ee<de;Ee++)N[Ee+z]=U[Ee]}e.$Jf=V;function K(N,B,U,z){const Z=H(N,B),de=N.splice(Z,U);return V(N,Z,z),de}e.$Kf=K;function H(N,B){return B<0?Math.max(B+N.length,0):Math.min(B,N.length)}var te;(function(N){function B(de){return de<0}N.isLessThan=B;function U(de){return de<=0}N.isLessThanOrEqual=U;function z(de){return de>0}N.isGreaterThan=z;function Z(de){return de===0}N.isNeitherLessOrGreaterThan=Z,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(te||(e.CompareResult=te={}));function me(N,B){return(U,z)=>B(N(U),N(z))}e.$Lf=me;function ne(...N){return(B,U)=>{for(const z of N){const Z=z(B,U);if(!te.isNeitherLessOrGreaterThan(Z))return Z}return te.neitherLessOrGreaterThan}}e.$Mf=ne;const q=(N,B)=>N-B;e.$Nf=q;const J=(N,B)=>(0,e.$Nf)(N?1:0,B?1:0);e.$Of=J;function R(N){return(B,U)=>-N(B,U)}e.$Pf=R;function F(N,B){if(N.length===0)return;let U=N[0];for(let z=1;z<N.length;z++){const Z=N[z];B(Z,U)>0&&(U=Z)}return U}e.$Qf=F;function W(N,B){if(N.length===0)return;let U=N[0];for(let z=1;z<N.length;z++){const Z=N[z];B(Z,U)>=0&&(U=Z)}return U}e.$Rf=W;function ie(N,B){return F(N,(U,z)=>-B(U,z))}e.$Sf=ie;function re(N,B){if(N.length===0)return-1;let U=0;for(let z=1;z<N.length;z++){const Z=N[z];B(Z,N[U])>0&&(U=z)}return U}e.$Tf=re;class _{constructor(B){this.f=B,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(B){let U=this.c;for(;U<this.f.length&&B(this.f[U]);)U++;const z=U===this.c?null:this.f.slice(this.c,U);return this.c=U,z}takeFromEndWhile(B){let U=this.d;for(;U>=0&&B(this.f[U]);)U--;const z=U===this.d?null:this.f.slice(U+1,this.d+1);return this.d=U,z}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const B=this.f[this.c];return this.c++,B}removeLast(){const B=this.f[this.d];return this.d--,B}takeCount(B){const U=this.f.slice(this.c,this.c+B);return this.c+=B,U}}e.$Uf=_;class oe{static{this.empty=new oe(B=>{})}constructor(B){this.iterate=B}forEach(B){this.iterate(U=>(B(U),!0))}toArray(){const B=[];return this.iterate(U=>(B.push(U),!0)),B}filter(B){return new oe(U=>this.iterate(z=>B(z)?U(z):!0))}map(B){return new oe(U=>this.iterate(z=>U(B(z))))}some(B){let U=!1;return this.iterate(z=>(U=B(z),!U)),U}findFirst(B){let U;return this.iterate(z=>B(z)?(U=z,!1):!0),U}findLast(B){let U;return this.iterate(z=>(B(z)&&(U=z),!0)),U}findLastMaxBy(B){let U,z=!0;return this.iterate(Z=>((z||te.isGreaterThan(B(Z,U)))&&(z=!1,U=Z),!0)),U}}e.$Vf=oe}),define(pe[95],be([1,0,11]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zb=e.$yb=e.$xb=e.$wb=e.ok=void 0;function O(w,$){if(!w)throw new Error($?`Assertion failed (${$})`:"Assertion Failed")}e.ok=O;function r(w,$="Unreachable"){throw new Error($)}e.$wb=r;function C(w){if(!w)throw new D.$bb("Assertion Failed")}e.$xb=C;function I(w){if(!w()){debugger;w(),(0,D.$Y)(new D.$bb("Assertion Failed"))}}e.$yb=I;function P(w,$){let A=0;for(;A<w.length-1;){const k=w[A],p=w[A+1];if(!$(k,p))return!1;A++}return!0}e.$zb=P}),define(pe[74],be([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function D(O){const r=this;let C=!1,I;return function(){return C||(C=!0,I=O.apply(r,arguments)),I}}e.$cb=D}),define(pe[47],be([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(O){function r(E){return E&&typeof E=="object"&&typeof E[Symbol.iterator]=="function"}O.is=r;const C=Object.freeze([]);function I(){return C}O.empty=I;function*P(E){yield E}O.single=P;function w(E){return r(E)?E:P(E)}O.wrap=w;function $(E){return E||C}O.from=$;function A(E){return!E||E[Symbol.iterator]().next().done===!0}O.isEmpty=A;function k(E){return E[Symbol.iterator]().next().value}O.first=k;function p(E,v){for(const t of E)if(v(t))return!0;return!1}O.some=p;function l(E,v){for(const t of E)if(v(t))return t}O.find=l;function*d(E,v){for(const t of E)v(t)&&(yield t)}O.filter=d;function*m(E,v){let t=0;for(const s of E)yield v(s,t++)}O.map=m;function*c(...E){for(const v of E)for(const t of v)yield t}O.concat=c;function u(E,v,t){let s=t;for(const a of E)s=v(s,a);return s}O.reduce=u;function*h(E,v,t=E.length){for(v<0&&(v+=E.length),t<0?t+=E.length:t>E.length&&(t=E.length);v<t;v++)yield E[v]}O.slice=h;function g(E,v=Number.POSITIVE_INFINITY){const t=[];if(v===0)return[t,E];const s=E[Symbol.iterator]();for(let a=0;a<v;a++){const i=s.next();if(i.done)return[t,O.empty()];t.push(i.value)}return[t,{[Symbol.iterator](){return s}}]}O.consume=g})(D||(e.Iterable=D={}))}),define(pe[75],be([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var r;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(r||(e.ParseErrorCode=r={}));var C;(function(t){t.DEFAULT={allowTrailingComma:!0}})(C||(e.ParseOptions=C={}));function I(t,s=!1){let a=0;const i=t.length;let n="",o=0,f=16,b=0;function y(ee){let ue=0,X=0;for(;ue<ee;){const he=t.charCodeAt(a);if(he>=48&&he<=57)X=X*16+he-48;else if(he>=65&&he<=70)X=X*16+he-65+10;else if(he>=97&&he<=102)X=X*16+he-97+10;else break;a++,ue++}return ue<ee&&(X=-1),X}function S(ee){a=ee,n="",o=0,f=16,b=0}function L(){const ee=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&$(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&$(t.charCodeAt(a)))for(a++;a<t.length&&$(t.charCodeAt(a));)a++;else return b=3,t.substring(ee,a);let ue=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&$(t.charCodeAt(a))){for(a++;a<t.length&&$(t.charCodeAt(a));)a++;ue=a}else b=3;return t.substring(ee,ue)}function j(){let ee="",ue=a;for(;;){if(a>=i){ee+=t.substring(ue,a),b=2;break}const X=t.charCodeAt(a);if(X===34){ee+=t.substring(ue,a),a++;break}if(X===92){if(ee+=t.substring(ue,a),a++,a>=i){b=2;break}switch(t.charCodeAt(a++)){case 34:ee+='"';break;case 92:ee+="\\";break;case 47:ee+="/";break;case 98:ee+="\b";break;case 102:ee+="\f";break;case 110:ee+=`
`;break;case 114:ee+="\r";break;case 116:ee+="	";break;case 117:{const x=y(4);x>=0?ee+=String.fromCharCode(x):b=4;break}default:b=5}ue=a;continue}if(X>=0&&X<=31)if(w(X)){ee+=t.substring(ue,a),b=2;break}else b=6;a++}return ee}function Q(){if(n="",b=0,o=a,a>=i)return o=i,f=17;let ee=t.charCodeAt(a);if(P(ee)){do a++,n+=String.fromCharCode(ee),ee=t.charCodeAt(a);while(P(ee));return f=15}if(w(ee))return a++,n+=String.fromCharCode(ee),ee===13&&t.charCodeAt(a)===10&&(a++,n+=`
`),f=14;switch(ee){case 123:return a++,f=1;case 125:return a++,f=2;case 91:return a++,f=3;case 93:return a++,f=4;case 58:return a++,f=6;case 44:return a++,f=5;case 34:return a++,n=j(),f=10;case 47:{const ue=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<i&&!w(t.charCodeAt(a));)a++;return n=t.substring(ue,a),f=12}if(t.charCodeAt(a+1)===42){a+=2;const X=i-1;let he=!1;for(;a<X;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,he=!0;break}a++}return he||(a++,b=1),n=t.substring(ue,a),f=13}return n+=String.fromCharCode(ee),a++,f=16}case 45:if(n+=String.fromCharCode(ee),a++,a===i||!$(t.charCodeAt(a)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=L(),f=11;default:for(;a<i&&le(ee);)a++,ee=t.charCodeAt(a);if(o!==a){switch(n=t.substring(o,a),n){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return n+=String.fromCharCode(ee),a++,f=16}}function le(ee){if(P(ee)||w(ee))return!1;switch(ee){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Y(){let ee;do ee=Q();while(ee>=12&&ee<=15);return ee}return{setPosition:S,getPosition:()=>a,scan:s?Y:Q,getToken:()=>f,getTokenValue:()=>n,getTokenOffset:()=>o,getTokenLength:()=>a-o,getTokenError:()=>b}}e.$wm=I;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function w(t){return t===10||t===13||t===8232||t===8233}function $(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function k(t,s){const a=[],i=new Object;let n;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function b(y,S,L,j){o.value=y,o.offset=S,o.length=L,o.type=j,o.colonOffset=void 0,n=o}try{g(t,{onObjectBegin:(y,S)=>{if(s<=y)throw i;n=void 0,f=s>y,a.push("")},onObjectProperty:(y,S,L)=>{if(s<S||(b(y,S,L,"property"),a[a.length-1]=y,s<=S+L))throw i},onObjectEnd:(y,S)=>{if(s<=y)throw i;n=void 0,a.pop()},onArrayBegin:(y,S)=>{if(s<=y)throw i;n=void 0,a.push(0)},onArrayEnd:(y,S)=>{if(s<=y)throw i;n=void 0,a.pop()},onLiteralValue:(y,S,L)=>{if(s<S||(b(y,S,L,v(y)),s<=S+L))throw i},onSeparator:(y,S,L)=>{if(s<=S)throw i;if(y===":"&&n&&n.type==="property")n.colonOffset=S,f=!1,n=void 0;else if(y===","){const j=a[a.length-1];typeof j=="number"?a[a.length-1]=j+1:(f=!0,a[a.length-1]=""),n=void 0}}})}catch(y){if(y!==i)throw y}return{path:a,previousNode:n,isAtPropertyKey:f,matches:y=>{let S=0;for(let L=0;S<y.length&&L<a.length;L++)if(y[S]===a[L]||y[S]==="*")S++;else if(y[S]!=="**")return!1;return S===y.length}}}e.$xm=k;function p(t,s=[],a=C.DEFAULT){let i=null,n=[];const o=[];function f(y){Array.isArray(n)?n.push(y):i!==null&&(n[i]=y)}return g(t,{onObjectBegin:()=>{const y={};f(y),o.push(n),n=y,i=null},onObjectProperty:y=>{i=y},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const y=[];f(y),o.push(n),n=y,i=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:f,onError:(y,S,L)=>{s.push({error:y,offset:S,length:L})}},a),n[0]}e.$ym=p;function l(t,s=[],a=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(y){i.type==="property"&&(i.length=y-i.offset,i=i.parent)}function o(y){return i.children.push(y),y}g(t,{onObjectBegin:y=>{i=o({type:"object",offset:y,length:-1,parent:i,children:[]})},onObjectProperty:(y,S,L)=>{i=o({type:"property",offset:S,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:y,offset:S,length:L,parent:i})},onObjectEnd:(y,S)=>{i.length=y+S-i.offset,i=i.parent,n(y+S)},onArrayBegin:(y,S)=>{i=o({type:"array",offset:y,length:-1,parent:i,children:[]})},onArrayEnd:(y,S)=>{i.length=y+S-i.offset,i=i.parent,n(y+S)},onLiteralValue:(y,S,L)=>{o({type:v(y),offset:S,length:L,parent:i,value:y}),n(S+L)},onSeparator:(y,S,L)=>{i.type==="property"&&(y===":"?i.colonOffset=S:y===","&&n(S))},onError:(y,S,L)=>{s.push({error:y,offset:S,length:L})}},a);const b=i.children[0];return b&&delete b.parent,b}e.$zm=l;function d(t,s){if(!t)return;let a=t;for(const i of s)if(typeof i=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let n=!1;for(const o of a.children)if(Array.isArray(o.children)&&o.children[0].value===i){a=o.children[1],n=!0;break}if(!n)return}else{const n=i;if(a.type!=="array"||n<0||!Array.isArray(a.children)||n>=a.children.length)return;a=a.children[n]}return a}e.$Am=d;function m(t){if(!t.parent||!t.parent.children)return[];const s=m(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;s.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&s.push(a)}return s}e.$Bm=m;function c(t){switch(t.type){case"array":return t.children.map(c);case"object":{const s=Object.create(null);for(const a of t.children){const i=a.children[1];i&&(s[a.children[0].value]=c(i))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Cm=c;function u(t,s,a=!1){return s>=t.offset&&s<t.offset+t.length||a&&s===t.offset+t.length}e.$Dm=u;function h(t,s,a=!1){if(u(t,s,a)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=s;n++){const o=h(i[n],s,a);if(o)return o}return t}}e.$Em=h;function g(t,s,a=C.DEFAULT){const i=I(t,!1);function n(me){return me?()=>me(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(me){return me?ne=>me(ne,i.getTokenOffset(),i.getTokenLength()):()=>!0}const f=n(s.onObjectBegin),b=o(s.onObjectProperty),y=n(s.onObjectEnd),S=n(s.onArrayBegin),L=n(s.onArrayEnd),j=o(s.onLiteralValue),Q=o(s.onSeparator),le=n(s.onComment),Y=o(s.onError),ee=a&&a.disallowComments,ue=a&&a.allowTrailingComma;function X(){for(;;){const me=i.scan();switch(i.getTokenError()){case 4:he(14);break;case 5:he(15);break;case 3:he(13);break;case 1:ee||he(11);break;case 2:he(12);break;case 6:he(16);break}switch(me){case 12:case 13:ee?he(10):le();break;case 16:he(1);break;case 15:case 14:break;default:return me}}}function he(me,ne=[],q=[]){if(Y(me),ne.length+q.length>0){let J=i.getToken();for(;J!==17;){if(ne.indexOf(J)!==-1){X();break}else if(q.indexOf(J)!==-1)break;J=X()}}}function x(me){const ne=i.getTokenValue();return me?j(ne):b(ne),X(),!0}function se(){switch(i.getToken()){case 11:{let me=0;try{me=JSON.parse(i.getTokenValue()),typeof me!="number"&&(he(2),me=0)}catch{he(2)}j(me);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return X(),!0}function V(){return i.getToken()!==10?(he(3,[],[2,5]),!1):(x(!1),i.getToken()===6?(Q(":"),X(),te()||he(4,[],[2,5])):he(5,[],[2,5]),!0)}function K(){f(),X();let me=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(me||he(4,[],[]),Q(","),X(),i.getToken()===2&&ue)break}else me&&he(6,[],[]);V()||he(4,[],[2,5]),me=!0}return y(),i.getToken()!==2?he(7,[2],[]):X(),!0}function H(){S(),X();let me=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(me||he(4,[],[]),Q(","),X(),i.getToken()===4&&ue)break}else me&&he(6,[],[]);te()||he(4,[],[4,5]),me=!0}return L(),i.getToken()!==4?he(8,[4],[]):X(),!0}function te(){switch(i.getToken()){case 3:return H();case 1:return K();case 10:return x(!0);default:return se()}}return X(),i.getToken()===17?a.allowEmptyContent?!0:(he(4,[],[]),!1):te()?(i.getToken()!==17&&he(9,[],[]),!0):(he(4,[],[]),!1)}e.$Fm=g;function E(t,s){const a=I(t),i=[];let n,o=0,f;do switch(f=a.getPosition(),n=a.scan(),n){case 12:case 13:case 17:o!==f&&i.push(t.substring(o,f)),s!==void 0&&i.push(a.getTokenValue().replace(/[^\r\n]/g,s)),o=a.getPosition();break}while(n!==17);return i.join("")}e.$Gm=E;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Hm=v}),define(pe[96],be([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class D{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=D}),define(pe[2],be([1,0,74,47]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tb=e.$sb=e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;const r=!1;let C=null;function I(o){C=o}if(e.$db=I,r){const o="__is_disposable_tracked__";I(new class{trackDisposable(f){const b=new Error("Potentially leaked disposable").stack;setTimeout(()=>{f[o]||console.log(b)},3e3)}setParent(f,b){if(f&&f!==h.None)try{f[o]=!0}catch{}}markAsDisposed(f){if(f&&f!==h.None)try{f[o]=!0}catch{}}markAsSingleton(f){}})}function P(o){return C?.trackDisposable(o),o}function w(o){C?.markAsDisposed(o)}function $(o,f){C?.setParent(o,f)}function A(o,f){if(C)for(const b of o)C.setParent(b,f)}function k(o){return C?.markAsSingleton(o),o}e.$eb=k;function p(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.$fb=p;function l(o){if(O.Iterable.is(o)){const f=[];for(const b of o)if(b)try{b.dispose()}catch(y){f.push(y)}if(f.length===1)throw f[0];if(f.length>1)throw new AggregateError(f,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.$gb=l;function d(o){for(const f of o)p(f)&&f.dispose();return[]}e.$hb=d;function m(...o){const f=c(()=>l(o));return A(o,f),f}e.$ib=m;function c(o){const f=P({dispose:(0,D.$cb)(()=>{w(f),o()})});return f}e.$jb=c;class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{l(this.f)}finally{this.f.clear()}}add(f){if(!f)return f;if(f===this)throw new Error("Cannot register a disposable on itself!");return $(f,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(f),f}}e.$kb=u;class h{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new u,P(this),$(this.q,this)}dispose(){w(this),this.q.dispose()}B(f){if(f===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(f)}}e.$lb=h;class g{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(f){this.b||f===this.a||(this.a?.dispose(),f&&$(f,this),this.a=f)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const f=this.a;return this.a=void 0,f&&$(f,null),f}}e.$mb=g;class E{constructor(f){this.b=f,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$nb=E;class v{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(f){let b=f;return this.unset=()=>b=void 0,this.isset=()=>b!==void 0,this.dispose=()=>{b&&(b(),b=void 0,w(this))},this}}e.$ob=v;class t{constructor(){this.a=new Map}acquire(f,...b){let y=this.a.get(f);y||(y={counter:0,object:this.b(f,...b)},this.a.set(f,y));const{object:S}=y,L=(0,D.$cb)(()=>{--y.counter===0&&(this.c(f,y.object),this.a.delete(f))});return y.counter++,{object:S,dispose:L}}}e.$pb=t;class s{constructor(f){this.a=f}async acquire(f,...b){const y=this.a.acquire(f,...b);try{return{object:await y.object,dispose:()=>y.dispose()}}catch(S){throw y.dispose(),S}}}e.$qb=s;class a{constructor(f){this.object=f}dispose(){}}e.$rb=a;function i(o){const f=new u;try{o(f)}finally{f.dispose()}}e.$sb=i;class n{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{l(this.a.values())}finally{this.a.clear()}}has(f){return this.a.has(f)}get(f){return this.a.get(f)}set(f,b,y=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),y||this.a.get(f)?.dispose(),this.a.set(f,b)}deleteAndDispose(f){this.a.get(f)?.dispose(),this.a.delete(f)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$tb=n}),define(pe[97],be([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ub=void 0;class D{static{this.Undefined=new D(void 0)}constructor(C){this.element=C,this.next=D.Undefined,this.prev=D.Undefined}}class O{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let C=this.a;for(;C!==D.Undefined;){const I=C.next;C.prev=D.Undefined,C.next=D.Undefined,C=I}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(C){return this.d(C,!1)}push(C){return this.d(C,!0)}d(C,I){const P=new D(C);if(this.a===D.Undefined)this.a=P,this.b=P;else if(I){const $=this.b;this.b=P,P.prev=$,$.next=P}else{const $=this.a;this.a=P,P.next=$,$.prev=P}this.c+=1;let w=!1;return()=>{w||(w=!0,this.e(P))}}shift(){if(this.a!==D.Undefined){const C=this.a.element;return this.e(this.a),C}}pop(){if(this.b!==D.Undefined){const C=this.b.element;return this.e(this.b),C}}e(C){if(C.prev!==D.Undefined&&C.next!==D.Undefined){const I=C.prev;I.next=C.next,C.next.prev=I}else C.prev===D.Undefined&&C.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):C.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):C.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let C=this.a;for(;C!==D.Undefined;)yield C.element,C=C.next}}e.$ub=O}),define(pe[27],be([1,0]),function(ce,e){"use strict";var D,O,r;Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.Touch=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=void 0;function C(m,c,u){let h=m.get(c);return h===void 0&&(h=u,m.set(c,h)),h}e.$ki=C;function I(m){const c=[];return m.forEach((u,h)=>{c.push(`${h} => ${u}`)}),`Map(${m.size}) {${c.join(", ")}}`}e.$li=I;function P(m){const c=[];return m.forEach(u=>{c.push(u)}),`Set(${m.size}) {${c.join(", ")}}`}e.$mi=P;class w{constructor(c,u){this.uri=c,this.value=u}}class ${static{this.a=c=>c.toString()}constructor(c,u){this[D]="ResourceMap",c instanceof $?(this.b=new Map(c.b),this.c=u??$.a):(this.b=new Map,this.c=c??$.a)}set(c,u){return this.b.set(this.c(c),new w(c,u)),this}get(c){return this.b.get(this.c(c))?.value}has(c){return this.b.has(this.c(c))}get size(){return this.b.size}clear(){this.b.clear()}delete(c){return this.b.delete(this.c(c))}forEach(c,u){typeof u<"u"&&(c=c.bind(u));for(const[h,g]of this.b)c(g.value,g.uri,this)}*values(){for(const c of this.b.values())yield c.value}*keys(){for(const c of this.b.values())yield c.uri}*entries(){for(const c of this.b.values())yield[c.uri,c.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.b)yield[c.uri,c.value]}}e.$ni=$;class A{constructor(c,u){this[O]="ResourceSet",!c||typeof c=="function"?this.a=new $(c):(this.a=new $(u),c.forEach(this.add,this))}get size(){return this.a.size}add(c){return this.a.set(c,c),this}clear(){this.a.clear()}delete(c){return this.a.delete(c)}forEach(c,u){this.a.forEach((h,g)=>c.call(u,g,g,this))}has(c){return this.a.has(c)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$oi=A;var k;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(k||(e.Touch=k={}));class p{constructor(){this[r]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(c){return this.a.has(c)}get(c,u=0){const h=this.a.get(c);if(h)return u!==0&&this.j(h,u),h.value}set(c,u,h=0){let g=this.a.get(c);if(g)g.value=u,h!==0&&this.j(g,h);else{switch(g={key:c,value:u,next:void 0,previous:void 0},h){case 0:this.h(g);break;case 1:this.g(g);break;case 2:this.h(g);break;default:this.h(g);break}this.a.set(c,g),this.d++}return this}delete(c){return!!this.remove(c)}remove(c){const u=this.a.get(c);if(u)return this.a.delete(c),this.i(u),this.d--,u.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const c=this.b;return this.a.delete(c.key),this.i(c),this.d--,c.value}forEach(c,u){const h=this.e;let g=this.b;for(;g;){if(u?c.bind(u)(g.value,g.key,this):c(g.value,g.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const c=this,u=this.e;let h=this.b;const g={[Symbol.iterator](){return g},next(){if(c.e!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const E={value:h.key,done:!1};return h=h.next,E}else return{value:void 0,done:!0}}};return g}values(){const c=this,u=this.e;let h=this.b;const g={[Symbol.iterator](){return g},next(){if(c.e!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const E={value:h.value,done:!1};return h=h.next,E}else return{value:void 0,done:!0}}};return g}entries(){const c=this,u=this.e;let h=this.b;const g={[Symbol.iterator](){return g},next(){if(c.e!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const E={value:[h.key,h.value],done:!1};return h=h.next,E}else return{value:void 0,done:!0}}};return g}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(c){if(c>=this.size)return;if(c===0){this.clear();return}let u=this.b,h=this.size;for(;u&&h>c;)this.a.delete(u.key),u=u.next,h--;this.b=u,this.d=h,u&&(u.previous=void 0),this.e++}g(c){if(!this.b&&!this.c)this.c=c;else if(this.b)c.next=this.b,this.b.previous=c;else throw new Error("Invalid list");this.b=c,this.e++}h(c){if(!this.b&&!this.c)this.b=c;else if(this.c)c.previous=this.c,this.c.next=c;else throw new Error("Invalid list");this.c=c,this.e++}i(c){if(c===this.b&&c===this.c)this.b=void 0,this.c=void 0;else if(c===this.b){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.b=c.next}else if(c===this.c){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.c=c.previous}else{const u=c.next,h=c.previous;if(!u||!h)throw new Error("Invalid list");u.previous=h,h.next=u}c.next=void 0,c.previous=void 0,this.e++}j(c,u){if(!this.b||!this.c)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(c===this.b)return;const h=c.next,g=c.previous;c===this.c?(g.next=void 0,this.c=g):(h.previous=g,g.next=h),c.previous=void 0,c.next=this.b,this.b.previous=c,this.b=c,this.e++}else if(u===2){if(c===this.c)return;const h=c.next,g=c.previous;c===this.b?(h.previous=void 0,this.b=h):(h.previous=g,g.next=h),c.next=void 0,c.previous=this.c,this.c.next=c,this.c=c,this.e++}}}toJSON(){const c=[];return this.forEach((u,h)=>{c.push([h,u])}),c}fromJSON(c){this.clear();for(const[u,h]of c)this.set(u,h)}}e.$pi=p;class l extends p{constructor(c,u=1){super(),this.k=c,this.l=Math.min(Math.max(0,u),1)}get limit(){return this.k}set limit(c){this.k=c,this.m()}get ratio(){return this.l}set ratio(c){this.l=Math.min(Math.max(0,c),1),this.m()}get(c,u=2){return super.get(c,u)}peek(c){return super.get(c,0)}set(c,u){return super.set(c,u,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$qi=l;class d{constructor(){this.a=new Map}add(c){return this.a.set(c,(this.a.get(c)||0)+1),this}delete(c){let u=this.a.get(c)||0;return u===0?!1:(u--,u===0?this.a.delete(c):this.a.set(c,u),!0)}has(c){return this.a.has(c)}}e.$ri=d}),function(ce,e){typeof define=="function"&&define.amd?define(pe[142],be([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ce=typeof globalThis<"u"?globalThis:ce||self,e(ce.marked={}))}(this,function(ce){"use strict";function e(re,_){for(var oe=0;oe<_.length;oe++){var N=_[oe];N.enumerable=N.enumerable||!1,N.configurable=!0,"value"in N&&(N.writable=!0),Object.defineProperty(re,N.key,N)}}function D(re,_,oe){return _&&e(re.prototype,_),oe&&e(re,oe),Object.defineProperty(re,"prototype",{writable:!1}),re}function O(re,_){if(re){if(typeof re=="string")return r(re,_);var oe=Object.prototype.toString.call(re).slice(8,-1);if(oe==="Object"&&re.constructor&&(oe=re.constructor.name),oe==="Map"||oe==="Set")return Array.from(re);if(oe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(oe))return r(re,_)}}function r(re,_){(_==null||_>re.length)&&(_=re.length);for(var oe=0,N=new Array(_);oe<_;oe++)N[oe]=re[oe];return N}function C(re,_){var oe=typeof Symbol<"u"&&re[Symbol.iterator]||re["@@iterator"];if(oe)return(oe=oe.call(re)).next.bind(oe);if(Array.isArray(re)||(oe=O(re))||_&&re&&typeof re.length=="number"){oe&&(re=oe);var N=0;return function(){return N>=re.length?{done:!0}:{done:!1,value:re[N++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function I(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ce.defaults=I();function P(re){ce.defaults=re}var w=/[&<>"']/,$=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(_){return p[_]};function d(re,_){if(_){if(w.test(re))return re.replace($,l)}else if(A.test(re))return re.replace(k,l);return re}var m=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function c(re){return re.replace(m,function(_,oe){return oe=oe.toLowerCase(),oe==="colon"?":":oe.charAt(0)==="#"?oe.charAt(1)==="x"?String.fromCharCode(parseInt(oe.substring(2),16)):String.fromCharCode(+oe.substring(1)):""})}var u=/(^|[^\[])\^/g;function h(re,_){re=typeof re=="string"?re:re.source,_=_||"";var oe={replace:function(B,U){return U=U.source||U,U=U.replace(u,"$1"),re=re.replace(B,U),oe},getRegex:function(){return new RegExp(re,_)}};return oe}var g=/[^\w:]/g,E=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(re,_,oe){if(re){var N;try{N=decodeURIComponent(c(oe)).replace(g,"").toLowerCase()}catch{return null}if(N.indexOf("javascript:")===0||N.indexOf("vbscript:")===0||N.indexOf("data:")===0)return null}_&&!E.test(oe)&&(oe=n(_,oe));try{oe=encodeURI(oe).replace(/%25/g,"%")}catch{return null}return oe}var t={},s=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(re,_){t[" "+re]||(s.test(re)?t[" "+re]=re+"/":t[" "+re]=y(re,"/",!0)),re=t[" "+re];var oe=re.indexOf(":")===-1;return _.substring(0,2)==="//"?oe?_:re.replace(a,"$1")+_:_.charAt(0)==="/"?oe?_:re.replace(i,"$1")+_:re+_}var o={exec:function(){}};function f(re){for(var _=1,oe,N;_<arguments.length;_++){oe=arguments[_];for(N in oe)Object.prototype.hasOwnProperty.call(oe,N)&&(re[N]=oe[N])}return re}function b(re,_){var oe=re.replace(/\|/g,function(U,z,Z){for(var de=!1,Ee=z;--Ee>=0&&Z[Ee]==="\\";)de=!de;return de?"|":" |"}),N=oe.split(/ \|/),B=0;if(N[0].trim()||N.shift(),N.length>0&&!N[N.length-1].trim()&&N.pop(),N.length>_)N.splice(_);else for(;N.length<_;)N.push("");for(;B<N.length;B++)N[B]=N[B].trim().replace(/\\\|/g,"|");return N}function y(re,_,oe){var N=re.length;if(N===0)return"";for(var B=0;B<N;){var U=re.charAt(N-B-1);if(U===_&&!oe)B++;else if(U!==_&&oe)B++;else break}return re.slice(0,N-B)}function S(re,_){if(re.indexOf(_[1])===-1)return-1;for(var oe=re.length,N=0,B=0;B<oe;B++)if(re[B]==="\\")B++;else if(re[B]===_[0])N++;else if(re[B]===_[1]&&(N--,N<0))return B;return-1}function L(re){re&&re.sanitize&&!re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function j(re,_){if(_<1)return"";for(var oe="";_>1;)_&1&&(oe+=re),_>>=1,re+=re;return oe+re}function Q(re,_,oe,N){var B=_.href,U=_.title?d(_.title):null,z=re[1].replace(/\\([\[\]])/g,"$1");if(re[0].charAt(0)!=="!"){N.state.inLink=!0;var Z={type:"link",raw:oe,href:B,title:U,text:z,tokens:N.inlineTokens(z)};return N.state.inLink=!1,Z}return{type:"image",raw:oe,href:B,title:U,text:d(z)}}function le(re,_){var oe=re.match(/^(\s+)(?:```)/);if(oe===null)return _;var N=oe[1];return _.split(`
`).map(function(B){var U=B.match(/^\s+/);if(U===null)return B;var z=U[0];return z.length>=N.length?B.slice(N.length):B}).join(`
`)}var Y=function(){function re(oe){this.options=oe||ce.defaults}var _=re.prototype;return _.space=function(N){var B=this.rules.block.newline.exec(N);if(B&&B[0].length>0)return{type:"space",raw:B[0]}},_.code=function(N){var B=this.rules.block.code.exec(N);if(B){var U=B[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:B[0],codeBlockStyle:"indented",text:this.options.pedantic?U:y(U,`
`)}}},_.fences=function(N){var B=this.rules.block.fences.exec(N);if(B){var U=B[0],z=le(U,B[3]||"");return{type:"code",raw:U,lang:B[2]?B[2].trim():B[2],text:z}}},_.heading=function(N){var B=this.rules.block.heading.exec(N);if(B){var U=B[2].trim();if(/#$/.test(U)){var z=y(U,"#");(this.options.pedantic||!z||/ $/.test(z))&&(U=z.trim())}return{type:"heading",raw:B[0],depth:B[1].length,text:U,tokens:this.lexer.inline(U)}}},_.hr=function(N){var B=this.rules.block.hr.exec(N);if(B)return{type:"hr",raw:B[0]}},_.blockquote=function(N){var B=this.rules.block.blockquote.exec(N);if(B){var U=B[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:B[0],tokens:this.lexer.blockTokens(U,[]),text:U}}},_.list=function(N){var B=this.rules.block.list.exec(N);if(B){var U,z,Z,de,Ee,Pe,Ae,Fe,ge,ke,ye,Te,ze=B[1].trim(),_e=ze.length>1,Ve={type:"list",raw:"",ordered:_e,start:_e?+ze.slice(0,-1):"",loose:!1,items:[]};ze=_e?"\\d{1,9}\\"+ze.slice(-1):"\\"+ze,this.options.pedantic&&(ze=_e?ze:"[*+-]");for(var Xe=new RegExp("^( {0,3}"+ze+")((?:[	 ][^\\n]*)?(?:\\n|$))");N&&(Te=!1,!(!(B=Xe.exec(N))||this.rules.block.hr.test(N)));){if(U=B[0],N=N.substring(U.length),Fe=B[2].split(`
`,1)[0],ge=N.split(`
`,1)[0],this.options.pedantic?(de=2,ye=Fe.trimLeft()):(de=B[2].search(/[^ ]/),de=de>4?1:de,ye=Fe.slice(de),de+=B[1].length),Pe=!1,!Fe&&/^ *$/.test(ge)&&(U+=ge+`
`,N=N.substring(ge.length+1),Te=!0),!Te)for(var Ze=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),$e=new RegExp("^ {0,"+Math.min(3,de-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),De=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:```|~~~)"),Re=new RegExp("^ {0,"+Math.min(3,de-1)+"}#");N&&(ke=N.split(`
`,1)[0],Fe=ke,this.options.pedantic&&(Fe=Fe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(De.test(Fe)||Re.test(Fe)||Ze.test(Fe)||$e.test(N)));){if(Fe.search(/[^ ]/)>=de||!Fe.trim())ye+=`
`+Fe.slice(de);else if(!Pe)ye+=`
`+Fe;else break;!Pe&&!Fe.trim()&&(Pe=!0),U+=ke+`
`,N=N.substring(ke.length+1)}Ve.loose||(Ae?Ve.loose=!0:/\n *\n *$/.test(U)&&(Ae=!0)),this.options.gfm&&(z=/^\[[ xX]\] /.exec(ye),z&&(Z=z[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:U,task:!!z,checked:Z,loose:!1,text:ye}),Ve.raw+=U}Ve.items[Ve.items.length-1].raw=U.trimRight(),Ve.items[Ve.items.length-1].text=ye.trimRight(),Ve.raw=Ve.raw.trimRight();var Ne=Ve.items.length;for(Ee=0;Ee<Ne;Ee++){this.lexer.state.top=!1,Ve.items[Ee].tokens=this.lexer.blockTokens(Ve.items[Ee].text,[]);var Me=Ve.items[Ee].tokens.filter(function(Be){return Be.type==="space"}),qe=Me.every(function(Be){for(var Ke=Be.raw.split(""),He=0,Ye=C(Ke),Je;!(Je=Ye()).done;){var xe=Je.value;if(xe===`
`&&(He+=1),He>1)return!0}return!1});!Ve.loose&&Me.length&&qe&&(Ve.loose=!0,Ve.items[Ee].loose=!0)}return Ve}},_.html=function(N){var B=this.rules.block.html.exec(N);if(B){var U={type:"html",raw:B[0],pre:!this.options.sanitizer&&(B[1]==="pre"||B[1]==="script"||B[1]==="style"),text:B[0]};if(this.options.sanitize){var z=this.options.sanitizer?this.options.sanitizer(B[0]):d(B[0]);U.type="paragraph",U.text=z,U.tokens=this.lexer.inline(z)}return U}},_.def=function(N){var B=this.rules.block.def.exec(N);if(B){B[3]&&(B[3]=B[3].substring(1,B[3].length-1));var U=B[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:U,raw:B[0],href:B[2],title:B[3]}}},_.table=function(N){var B=this.rules.block.table.exec(N);if(B){var U={type:"table",header:b(B[1]).map(function(Ae){return{text:Ae}}),align:B[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:B[3]&&B[3].trim()?B[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(U.header.length===U.align.length){U.raw=B[0];var z=U.align.length,Z,de,Ee,Pe;for(Z=0;Z<z;Z++)/^ *-+: *$/.test(U.align[Z])?U.align[Z]="right":/^ *:-+: *$/.test(U.align[Z])?U.align[Z]="center":/^ *:-+ *$/.test(U.align[Z])?U.align[Z]="left":U.align[Z]=null;for(z=U.rows.length,Z=0;Z<z;Z++)U.rows[Z]=b(U.rows[Z],U.header.length).map(function(Ae){return{text:Ae}});for(z=U.header.length,de=0;de<z;de++)U.header[de].tokens=this.lexer.inline(U.header[de].text);for(z=U.rows.length,de=0;de<z;de++)for(Pe=U.rows[de],Ee=0;Ee<Pe.length;Ee++)Pe[Ee].tokens=this.lexer.inline(Pe[Ee].text);return U}}},_.lheading=function(N){var B=this.rules.block.lheading.exec(N);if(B)return{type:"heading",raw:B[0],depth:B[2].charAt(0)==="="?1:2,text:B[1],tokens:this.lexer.inline(B[1])}},_.paragraph=function(N){var B=this.rules.block.paragraph.exec(N);if(B){var U=B[1].charAt(B[1].length-1)===`
`?B[1].slice(0,-1):B[1];return{type:"paragraph",raw:B[0],text:U,tokens:this.lexer.inline(U)}}},_.text=function(N){var B=this.rules.block.text.exec(N);if(B)return{type:"text",raw:B[0],text:B[0],tokens:this.lexer.inline(B[0])}},_.escape=function(N){var B=this.rules.inline.escape.exec(N);if(B)return{type:"escape",raw:B[0],text:d(B[1])}},_.tag=function(N){var B=this.rules.inline.tag.exec(N);if(B)return!this.lexer.state.inLink&&/^<a /i.test(B[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(B[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(B[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(B[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:B[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(B[0]):d(B[0]):B[0]}},_.link=function(N){var B=this.rules.inline.link.exec(N);if(B){var U=B[2].trim();if(!this.options.pedantic&&/^</.test(U)){if(!/>$/.test(U))return;var z=y(U.slice(0,-1),"\\");if((U.length-z.length)%2===0)return}else{var Z=S(B[2],"()");if(Z>-1){var de=B[0].indexOf("!")===0?5:4,Ee=de+B[1].length+Z;B[2]=B[2].substring(0,Z),B[0]=B[0].substring(0,Ee).trim(),B[3]=""}}var Pe=B[2],Ae="";if(this.options.pedantic){var Fe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Pe);Fe&&(Pe=Fe[1],Ae=Fe[3])}else Ae=B[3]?B[3].slice(1,-1):"";return Pe=Pe.trim(),/^</.test(Pe)&&(this.options.pedantic&&!/>$/.test(U)?Pe=Pe.slice(1):Pe=Pe.slice(1,-1)),Q(B,{href:Pe&&Pe.replace(this.rules.inline._escapes,"$1"),title:Ae&&Ae.replace(this.rules.inline._escapes,"$1")},B[0],this.lexer)}},_.reflink=function(N,B){var U;if((U=this.rules.inline.reflink.exec(N))||(U=this.rules.inline.nolink.exec(N))){var z=(U[2]||U[1]).replace(/\s+/g," ");if(z=B[z.toLowerCase()],!z||!z.href){var Z=U[0].charAt(0);return{type:"text",raw:Z,text:Z}}return Q(U,z,U[0],this.lexer)}},_.emStrong=function(N,B,U){U===void 0&&(U="");var z=this.rules.inline.emStrong.lDelim.exec(N);if(z&&!(z[3]&&U.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Z=z[1]||z[2]||"";if(!Z||Z&&(U===""||this.rules.inline.punctuation.exec(U))){var de=z[0].length-1,Ee,Pe,Ae=de,Fe=0,ge=z[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,B=B.slice(-1*N.length+de);(z=ge.exec(B))!=null;)if(Ee=z[1]||z[2]||z[3]||z[4]||z[5]||z[6],!!Ee){if(Pe=Ee.length,z[3]||z[4]){Ae+=Pe;continue}else if((z[5]||z[6])&&de%3&&!((de+Pe)%3)){Fe+=Pe;continue}if(Ae-=Pe,!(Ae>0)){if(Pe=Math.min(Pe,Pe+Ae+Fe),Math.min(de,Pe)%2){var ke=N.slice(1,de+z.index+Pe);return{type:"em",raw:N.slice(0,de+z.index+Pe+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}var ye=N.slice(2,de+z.index+Pe-1);return{type:"strong",raw:N.slice(0,de+z.index+Pe+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},_.codespan=function(N){var B=this.rules.inline.code.exec(N);if(B){var U=B[2].replace(/\n/g," "),z=/[^ ]/.test(U),Z=/^ /.test(U)&&/ $/.test(U);return z&&Z&&(U=U.substring(1,U.length-1)),U=d(U,!0),{type:"codespan",raw:B[0],text:U}}},_.br=function(N){var B=this.rules.inline.br.exec(N);if(B)return{type:"br",raw:B[0]}},_.del=function(N){var B=this.rules.inline.del.exec(N);if(B)return{type:"del",raw:B[0],text:B[2],tokens:this.lexer.inlineTokens(B[2])}},_.autolink=function(N,B){var U=this.rules.inline.autolink.exec(N);if(U){var z,Z;return U[2]==="@"?(z=d(this.options.mangle?B(U[1]):U[1]),Z="mailto:"+z):(z=d(U[1]),Z=z),{type:"link",raw:U[0],text:z,href:Z,tokens:[{type:"text",raw:z,text:z}]}}},_.url=function(N,B){var U;if(U=this.rules.inline.url.exec(N)){var z,Z;if(U[2]==="@")z=d(this.options.mangle?B(U[0]):U[0]),Z="mailto:"+z;else{var de;do de=U[0],U[0]=this.rules.inline._backpedal.exec(U[0])[0];while(de!==U[0]);z=d(U[0]),U[1]==="www."?Z="http://"+z:Z=z}return{type:"link",raw:U[0],text:z,href:Z,tokens:[{type:"text",raw:z,text:z}]}}},_.inlineText=function(N,B){var U=this.rules.inline.text.exec(N);if(U){var z;return this.lexer.state.inRawBlock?z=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(U[0]):d(U[0]):U[0]:z=d(this.options.smartypants?B(U[0]):U[0]),{type:"text",raw:U[0],text:z}}},re}(),ee={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:o,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ee._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ee._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ee.def=h(ee.def).replace("label",ee._label).replace("title",ee._title).getRegex(),ee.bullet=/(?:[*+-]|\d{1,9}[.)])/,ee.listItemStart=h(/^( *)(bull) */).replace("bull",ee.bullet).getRegex(),ee.list=h(ee.list).replace(/bull/g,ee.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ee.def.source+")").getRegex(),ee._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ee._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ee.html=h(ee.html,"i").replace("comment",ee._comment).replace("tag",ee._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ee.paragraph=h(ee._paragraph).replace("hr",ee.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ee._tag).getRegex(),ee.blockquote=h(ee.blockquote).replace("paragraph",ee.paragraph).getRegex(),ee.normal=f({},ee),ee.gfm=f({},ee.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ee.gfm.table=h(ee.gfm.table).replace("hr",ee.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ee._tag).getRegex(),ee.gfm.paragraph=h(ee._paragraph).replace("hr",ee.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ee.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ee._tag).getRegex(),ee.pedantic=f({},ee.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ee._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:o,paragraph:h(ee.normal._paragraph).replace("hr",ee.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ee.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ue={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:o,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:o,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ue._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ue.punctuation=h(ue.punctuation).replace(/punctuation/g,ue._punctuation).getRegex(),ue.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ue.escapedEmSt=/\\\*|\\_/g,ue._comment=h(ee._comment).replace("(?:-->|$)","-->").getRegex(),ue.emStrong.lDelim=h(ue.emStrong.lDelim).replace(/punct/g,ue._punctuation).getRegex(),ue.emStrong.rDelimAst=h(ue.emStrong.rDelimAst,"g").replace(/punct/g,ue._punctuation).getRegex(),ue.emStrong.rDelimUnd=h(ue.emStrong.rDelimUnd,"g").replace(/punct/g,ue._punctuation).getRegex(),ue._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ue._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ue._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ue.autolink=h(ue.autolink).replace("scheme",ue._scheme).replace("email",ue._email).getRegex(),ue._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ue.tag=h(ue.tag).replace("comment",ue._comment).replace("attribute",ue._attribute).getRegex(),ue._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ue._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ue._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ue.link=h(ue.link).replace("label",ue._label).replace("href",ue._href).replace("title",ue._title).getRegex(),ue.reflink=h(ue.reflink).replace("label",ue._label).replace("ref",ee._label).getRegex(),ue.nolink=h(ue.nolink).replace("ref",ee._label).getRegex(),ue.reflinkSearch=h(ue.reflinkSearch,"g").replace("reflink",ue.reflink).replace("nolink",ue.nolink).getRegex(),ue.normal=f({},ue),ue.pedantic=f({},ue.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",ue._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ue._label).getRegex()}),ue.gfm=f({},ue.normal,{escape:h(ue.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ue.gfm.url=h(ue.gfm.url,"i").replace("email",ue.gfm._extended_email).getRegex(),ue.breaks=f({},ue.gfm,{br:h(ue.br).replace("{2,}","*").getRegex(),text:h(ue.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function X(re){return re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function he(re){var _="",oe,N,B=re.length;for(oe=0;oe<B;oe++)N=re.charCodeAt(oe),Math.random()>.5&&(N="x"+N.toString(16)),_+="&#"+N+";";return _}var x=function(){function re(oe){this.tokens=[],this.tokens.links=Object.create(null),this.options=oe||ce.defaults,this.options.tokenizer=this.options.tokenizer||new Y,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var N={block:ee.normal,inline:ue.normal};this.options.pedantic?(N.block=ee.pedantic,N.inline=ue.pedantic):this.options.gfm&&(N.block=ee.gfm,this.options.breaks?N.inline=ue.breaks:N.inline=ue.gfm),this.tokenizer.rules=N}re.lex=function(N,B){var U=new re(B);return U.lex(N)},re.lexInline=function(N,B){var U=new re(B);return U.inlineTokens(N)};var _=re.prototype;return _.lex=function(N){N=N.replace(/\r\n|\r/g,`
`),this.blockTokens(N,this.tokens);for(var B;B=this.inlineQueue.shift();)this.inlineTokens(B.src,B.tokens);return this.tokens},_.blockTokens=function(N,B){var U=this;B===void 0&&(B=[]),this.options.pedantic?N=N.replace(/\t/g,"    ").replace(/^ +$/gm,""):N=N.replace(/^( *)(\t+)/gm,function(Ae,Fe,ge){return Fe+"    ".repeat(ge.length)});for(var z,Z,de,Ee;N;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ae){return(z=Ae.call({lexer:U},N,B))?(N=N.substring(z.raw.length),B.push(z),!0):!1}))){if(z=this.tokenizer.space(N)){N=N.substring(z.raw.length),z.raw.length===1&&B.length>0?B[B.length-1].raw+=`
`:B.push(z);continue}if(z=this.tokenizer.code(N)){N=N.substring(z.raw.length),Z=B[B.length-1],Z&&(Z.type==="paragraph"||Z.type==="text")?(Z.raw+=`
`+z.raw,Z.text+=`
`+z.text,this.inlineQueue[this.inlineQueue.length-1].src=Z.text):B.push(z);continue}if(z=this.tokenizer.fences(N)){N=N.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.heading(N)){N=N.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.hr(N)){N=N.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.blockquote(N)){N=N.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.list(N)){N=N.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.html(N)){N=N.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.def(N)){N=N.substring(z.raw.length),Z=B[B.length-1],Z&&(Z.type==="paragraph"||Z.type==="text")?(Z.raw+=`
`+z.raw,Z.text+=`
`+z.raw,this.inlineQueue[this.inlineQueue.length-1].src=Z.text):this.tokens.links[z.tag]||(this.tokens.links[z.tag]={href:z.href,title:z.title});continue}if(z=this.tokenizer.table(N)){N=N.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.lheading(N)){N=N.substring(z.raw.length),B.push(z);continue}if(de=N,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ae=1/0,Fe=N.slice(1),ge=void 0;U.options.extensions.startBlock.forEach(function(ke){ge=ke.call({lexer:this},Fe),typeof ge=="number"&&ge>=0&&(Ae=Math.min(Ae,ge))}),Ae<1/0&&Ae>=0&&(de=N.substring(0,Ae+1))}(),this.state.top&&(z=this.tokenizer.paragraph(de))){Z=B[B.length-1],Ee&&Z.type==="paragraph"?(Z.raw+=`
`+z.raw,Z.text+=`
`+z.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Z.text):B.push(z),Ee=de.length!==N.length,N=N.substring(z.raw.length);continue}if(z=this.tokenizer.text(N)){N=N.substring(z.raw.length),Z=B[B.length-1],Z&&Z.type==="text"?(Z.raw+=`
`+z.raw,Z.text+=`
`+z.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Z.text):B.push(z);continue}if(N){var Pe="Infinite loop on byte: "+N.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return this.state.top=!0,B},_.inline=function(N,B){return B===void 0&&(B=[]),this.inlineQueue.push({src:N,tokens:B}),B},_.inlineTokens=function(N,B){var U=this;B===void 0&&(B=[]);var z,Z,de,Ee=N,Pe,Ae,Fe;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(Pe=this.tokenizer.rules.inline.reflinkSearch.exec(Ee))!=null;)ge.includes(Pe[0].slice(Pe[0].lastIndexOf("[")+1,-1))&&(Ee=Ee.slice(0,Pe.index)+"["+j("a",Pe[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Pe=this.tokenizer.rules.inline.blockSkip.exec(Ee))!=null;)Ee=Ee.slice(0,Pe.index)+"["+j("a",Pe[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Pe=this.tokenizer.rules.inline.escapedEmSt.exec(Ee))!=null;)Ee=Ee.slice(0,Pe.index)+"++"+Ee.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;N;)if(Ae||(Fe=""),Ae=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(z=ye.call({lexer:U},N,B))?(N=N.substring(z.raw.length),B.push(z),!0):!1}))){if(z=this.tokenizer.escape(N)){N=N.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.tag(N)){N=N.substring(z.raw.length),Z=B[B.length-1],Z&&z.type==="text"&&Z.type==="text"?(Z.raw+=z.raw,Z.text+=z.text):B.push(z);continue}if(z=this.tokenizer.link(N)){N=N.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.reflink(N,this.tokens.links)){N=N.substring(z.raw.length),Z=B[B.length-1],Z&&z.type==="text"&&Z.type==="text"?(Z.raw+=z.raw,Z.text+=z.text):B.push(z);continue}if(z=this.tokenizer.emStrong(N,Ee,Fe)){N=N.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.codespan(N)){N=N.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.br(N)){N=N.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.del(N)){N=N.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.autolink(N,he)){N=N.substring(z.raw.length),B.push(z);continue}if(!this.state.inLink&&(z=this.tokenizer.url(N,he))){N=N.substring(z.raw.length),B.push(z);continue}if(de=N,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,Te=N.slice(1),ze=void 0;U.options.extensions.startInline.forEach(function(_e){ze=_e.call({lexer:this},Te),typeof ze=="number"&&ze>=0&&(ye=Math.min(ye,ze))}),ye<1/0&&ye>=0&&(de=N.substring(0,ye+1))}(),z=this.tokenizer.inlineText(de,X)){N=N.substring(z.raw.length),z.raw.slice(-1)!=="_"&&(Fe=z.raw.slice(-1)),Ae=!0,Z=B[B.length-1],Z&&Z.type==="text"?(Z.raw+=z.raw,Z.text+=z.text):B.push(z);continue}if(N){var ke="Infinite loop on byte: "+N.charCodeAt(0);if(this.options.silent){console.error(ke);break}else throw new Error(ke)}}return B},D(re,null,[{key:"rules",get:function(){return{block:ee,inline:ue}}}]),re}(),se=function(){function re(oe){this.options=oe||ce.defaults}var _=re.prototype;return _.code=function(N,B,U){var z=(B||"").match(/\S*/)[0];if(this.options.highlight){var Z=this.options.highlight(N,z);Z!=null&&Z!==N&&(U=!0,N=Z)}return N=N.replace(/\n$/,"")+`
`,z?'<pre><code class="'+this.options.langPrefix+d(z,!0)+'">'+(U?N:d(N,!0))+`</code></pre>
`:"<pre><code>"+(U?N:d(N,!0))+`</code></pre>
`},_.blockquote=function(N){return`<blockquote>
`+N+`</blockquote>
`},_.html=function(N){return N},_.heading=function(N,B,U,z){if(this.options.headerIds){var Z=this.options.headerPrefix+z.slug(U);return"<h"+B+' id="'+Z+'">'+N+"</h"+B+`>
`}return"<h"+B+">"+N+"</h"+B+`>
`},_.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},_.list=function(N,B,U){var z=B?"ol":"ul",Z=B&&U!==1?' start="'+U+'"':"";return"<"+z+Z+`>
`+N+"</"+z+`>
`},_.listitem=function(N){return"<li>"+N+`</li>
`},_.checkbox=function(N){return"<input "+(N?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},_.paragraph=function(N){return"<p>"+N+`</p>
`},_.table=function(N,B){return B&&(B="<tbody>"+B+"</tbody>"),`<table>
<thead>
`+N+`</thead>
`+B+`</table>
`},_.tablerow=function(N){return`<tr>
`+N+`</tr>
`},_.tablecell=function(N,B){var U=B.header?"th":"td",z=B.align?"<"+U+' align="'+B.align+'">':"<"+U+">";return z+N+("</"+U+`>
`)},_.strong=function(N){return"<strong>"+N+"</strong>"},_.em=function(N){return"<em>"+N+"</em>"},_.codespan=function(N){return"<code>"+N+"</code>"},_.br=function(){return this.options.xhtml?"<br/>":"<br>"},_.del=function(N){return"<del>"+N+"</del>"},_.link=function(N,B,U){if(N=v(this.options.sanitize,this.options.baseUrl,N),N===null)return U;var z='<a href="'+d(N)+'"';return B&&(z+=' title="'+B+'"'),z+=">"+U+"</a>",z},_.image=function(N,B,U){if(N=v(this.options.sanitize,this.options.baseUrl,N),N===null)return U;var z='<img src="'+N+'" alt="'+U+'"';return B&&(z+=' title="'+B+'"'),z+=this.options.xhtml?"/>":">",z},_.text=function(N){return N},re}(),V=function(){function re(){}var _=re.prototype;return _.strong=function(N){return N},_.em=function(N){return N},_.codespan=function(N){return N},_.del=function(N){return N},_.html=function(N){return N},_.text=function(N){return N},_.link=function(N,B,U){return""+U},_.image=function(N,B,U){return""+U},_.br=function(){return""},re}(),K=function(){function re(){this.seen={}}var _=re.prototype;return _.serialize=function(N){return N.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},_.getNextSafeSlug=function(N,B){var U=N,z=0;if(this.seen.hasOwnProperty(U)){z=this.seen[N];do z++,U=N+"-"+z;while(this.seen.hasOwnProperty(U))}return B||(this.seen[N]=z,this.seen[U]=0),U},_.slug=function(N,B){B===void 0&&(B={});var U=this.serialize(N);return this.getNextSafeSlug(U,B.dryrun)},re}(),H=function(){function re(oe){this.options=oe||ce.defaults,this.options.renderer=this.options.renderer||new se,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new V,this.slugger=new K}re.parse=function(N,B){var U=new re(B);return U.parse(N)},re.parseInline=function(N,B){var U=new re(B);return U.parseInline(N)};var _=re.prototype;return _.parse=function(N,B){B===void 0&&(B=!0);var U="",z,Z,de,Ee,Pe,Ae,Fe,ge,ke,ye,Te,ze,_e,Ve,Xe,Ze,$e,De,Re,Ne=N.length;for(z=0;z<Ne;z++){if(ye=N[z],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Re=this.options.extensions.renderers[ye.type].call({parser:this},ye),Re!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){U+=Re||"";continue}switch(ye.type){case"space":continue;case"hr":{U+=this.renderer.hr();continue}case"heading":{U+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,c(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{U+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(ge="",Fe="",Ee=ye.header.length,Z=0;Z<Ee;Z++)Fe+=this.renderer.tablecell(this.parseInline(ye.header[Z].tokens),{header:!0,align:ye.align[Z]});for(ge+=this.renderer.tablerow(Fe),ke="",Ee=ye.rows.length,Z=0;Z<Ee;Z++){for(Ae=ye.rows[Z],Fe="",Pe=Ae.length,de=0;de<Pe;de++)Fe+=this.renderer.tablecell(this.parseInline(Ae[de].tokens),{header:!1,align:ye.align[de]});ke+=this.renderer.tablerow(Fe)}U+=this.renderer.table(ge,ke);continue}case"blockquote":{ke=this.parse(ye.tokens),U+=this.renderer.blockquote(ke);continue}case"list":{for(Te=ye.ordered,ze=ye.start,_e=ye.loose,Ee=ye.items.length,ke="",Z=0;Z<Ee;Z++)Xe=ye.items[Z],Ze=Xe.checked,$e=Xe.task,Ve="",Xe.task&&(De=this.renderer.checkbox(Ze),_e?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=De+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=De+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:De}):Ve+=De),Ve+=this.parse(Xe.tokens,_e),ke+=this.renderer.listitem(Ve,$e,Ze);U+=this.renderer.list(ke,Te,ze);continue}case"html":{U+=this.renderer.html(ye.text);continue}case"paragraph":{U+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(ke=ye.tokens?this.parseInline(ye.tokens):ye.text;z+1<Ne&&N[z+1].type==="text";)ye=N[++z],ke+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);U+=B?this.renderer.paragraph(ke):ke;continue}default:{var Me='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Me);return}else throw new Error(Me)}}}return U},_.parseInline=function(N,B){B=B||this.renderer;var U="",z,Z,de,Ee=N.length;for(z=0;z<Ee;z++){if(Z=N[z],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Z.type]&&(de=this.options.extensions.renderers[Z.type].call({parser:this},Z),de!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Z.type))){U+=de||"";continue}switch(Z.type){case"escape":{U+=B.text(Z.text);break}case"html":{U+=B.html(Z.text);break}case"link":{U+=B.link(Z.href,Z.title,this.parseInline(Z.tokens,B));break}case"image":{U+=B.image(Z.href,Z.title,Z.text);break}case"strong":{U+=B.strong(this.parseInline(Z.tokens,B));break}case"em":{U+=B.em(this.parseInline(Z.tokens,B));break}case"codespan":{U+=B.codespan(Z.text);break}case"br":{U+=B.br();break}case"del":{U+=B.del(this.parseInline(Z.tokens,B));break}case"text":{U+=B.text(Z.text);break}default:{var Pe='Token with "'+Z.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}}return U},re}();function te(re,_,oe){if(typeof re>"u"||re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(re)+", string expected");if(typeof _=="function"&&(oe=_,_=null),_=f({},te.defaults,_||{}),L(_),oe){var N=_.highlight,B;try{B=x.lex(re,_)}catch(Ee){return oe(Ee)}var U=function(Pe){var Ae;if(!Pe)try{_.walkTokens&&te.walkTokens(B,_.walkTokens),Ae=H.parse(B,_)}catch(Fe){Pe=Fe}return _.highlight=N,Pe?oe(Pe):oe(null,Ae)};if(!N||N.length<3||(delete _.highlight,!B.length))return U();var z=0;te.walkTokens(B,function(Ee){Ee.type==="code"&&(z++,setTimeout(function(){N(Ee.text,Ee.lang,function(Pe,Ae){if(Pe)return U(Pe);Ae!=null&&Ae!==Ee.text&&(Ee.text=Ae,Ee.escaped=!0),z--,z===0&&U()})},0))}),z===0&&U();return}function Z(Ee){if(Ee.message+=`
Please report this to https://github.com/markedjs/marked.`,_.silent)return"<p>An error occurred:</p><pre>"+d(Ee.message+"",!0)+"</pre>";throw Ee}try{var de=x.lex(re,_);if(_.walkTokens){if(_.async)return Promise.all(te.walkTokens(de,_.walkTokens)).then(function(){return H.parse(de,_)}).catch(Z);te.walkTokens(de,_.walkTokens)}return H.parse(de,_)}catch(Ee){Z(Ee)}}te.options=te.setOptions=function(re){return f(te.defaults,re),P(te.defaults),te},te.getDefaults=I,te.defaults=ce.defaults,te.use=function(){for(var re=arguments.length,_=new Array(re),oe=0;oe<re;oe++)_[oe]=arguments[oe];var N=f.apply(void 0,[{}].concat(_)),B=te.defaults.extensions||{renderers:{},childTokens:{}},U;_.forEach(function(z){if(z.extensions&&(U=!0,z.extensions.forEach(function(de){if(!de.name)throw new Error("extension name required");if(de.renderer){var Ee=B.renderers?B.renderers[de.name]:null;Ee?B.renderers[de.name]=function(){for(var Pe=arguments.length,Ae=new Array(Pe),Fe=0;Fe<Pe;Fe++)Ae[Fe]=arguments[Fe];var ge=de.renderer.apply(this,Ae);return ge===!1&&(ge=Ee.apply(this,Ae)),ge}:B.renderers[de.name]=de.renderer}if(de.tokenizer){if(!de.level||de.level!=="block"&&de.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");B[de.level]?B[de.level].unshift(de.tokenizer):B[de.level]=[de.tokenizer],de.start&&(de.level==="block"?B.startBlock?B.startBlock.push(de.start):B.startBlock=[de.start]:de.level==="inline"&&(B.startInline?B.startInline.push(de.start):B.startInline=[de.start]))}de.childTokens&&(B.childTokens[de.name]=de.childTokens)})),z.renderer&&function(){var de=te.defaults.renderer||new se,Ee=function(Fe){var ge=de[Fe];de[Fe]=function(){for(var ke=arguments.length,ye=new Array(ke),Te=0;Te<ke;Te++)ye[Te]=arguments[Te];var ze=z.renderer[Fe].apply(de,ye);return ze===!1&&(ze=ge.apply(de,ye)),ze}};for(var Pe in z.renderer)Ee(Pe);N.renderer=de}(),z.tokenizer&&function(){var de=te.defaults.tokenizer||new Y,Ee=function(Fe){var ge=de[Fe];de[Fe]=function(){for(var ke=arguments.length,ye=new Array(ke),Te=0;Te<ke;Te++)ye[Te]=arguments[Te];var ze=z.tokenizer[Fe].apply(de,ye);return ze===!1&&(ze=ge.apply(de,ye)),ze}};for(var Pe in z.tokenizer)Ee(Pe);N.tokenizer=de}(),z.walkTokens){var Z=te.defaults.walkTokens;N.walkTokens=function(de){var Ee=[];return Ee.push(z.walkTokens.call(this,de)),Z&&(Ee=Ee.concat(Z.call(this,de))),Ee}}U&&(N.extensions=B),te.setOptions(N)})},te.walkTokens=function(re,_){for(var oe=[],N=function(){var Z=U.value;switch(oe=oe.concat(_.call(te,Z)),Z.type){case"table":{for(var de=C(Z.header),Ee;!(Ee=de()).done;){var Pe=Ee.value;oe=oe.concat(te.walkTokens(Pe.tokens,_))}for(var Ae=C(Z.rows),Fe;!(Fe=Ae()).done;)for(var ge=Fe.value,ke=C(ge),ye;!(ye=ke()).done;){var Te=ye.value;oe=oe.concat(te.walkTokens(Te.tokens,_))}break}case"list":{oe=oe.concat(te.walkTokens(Z.items,_));break}default:te.defaults.extensions&&te.defaults.extensions.childTokens&&te.defaults.extensions.childTokens[Z.type]?te.defaults.extensions.childTokens[Z.type].forEach(function(ze){oe=oe.concat(te.walkTokens(Z[ze],_))}):Z.tokens&&(oe=oe.concat(te.walkTokens(Z.tokens,_)))}},B=C(re),U;!(U=B()).done;)N();return oe},te.parseInline=function(re,_){if(typeof re>"u"||re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(re)+", string expected");_=f({},te.defaults,_||{}),L(_);try{var oe=x.lexInline(re,_);return _.walkTokens&&te.walkTokens(oe,_.walkTokens),H.parseInline(oe,_)}catch(N){if(N.message+=`
Please report this to https://github.com/markedjs/marked.`,_.silent)return"<p>An error occurred:</p><pre>"+d(N.message+"",!0)+"</pre>";throw N}},te.Parser=H,te.parser=H.parse,te.Renderer=se,te.TextRenderer=V,te.Lexer=x,te.lexer=x.lex,te.Tokenizer=Y,te.Slugger=K,te.parse=te;var me=te.options,ne=te.setOptions,q=te.use,J=te.walkTokens,R=te.parseInline,F=te,W=H.parse,ie=x.lex;ce.Lexer=x,ce.Parser=H,ce.Renderer=se,ce.Slugger=K,ce.TextRenderer=V,ce.Tokenizer=Y,ce.getDefaults=I,ce.lexer=ie,ce.marked=te,ce.options=me,ce.parse=F,ce.parseInline=R,ce.parser=W,ce.setOptions=ne,ce.use=q,ce.walkTokens=J,Object.defineProperty(ce,"__esModule",{value:!0})}),define(pe[98],be([1,0,27]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.$7k=void 0;const O=new D.$qi(1e4);function r($){return w($,"NFC",O)}e.$7k=r;const C=new D.$qi(1e4);function I($){return w($,"NFD",C)}e.$8k=I;const P=/[^\u0000-\u0080]/;function w($,A,k){if(!$)return $;const p=k.get($);if(p)return p;let l;return P.test($)?l=$.normalize(A):l=$,k.set($,l),l}e.$9k=function(){const $=/[\u0300-\u036f]/g;return function(A){return I(A).replace($,"")}}()}),define(pe[143],be([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$xl=e.$wl=e.rot=e.$ul=void 0;function D(P,w,$){return Math.min(Math.max(P,w),$)}e.$ul=D;function O(P,w){return(w+P%w)%w}e.rot=O;class r{constructor(){this.a=0}getNext(){return this.a++}}e.$wl=r;class C{constructor(){this.a=1,this.b=0}update(w){return this.b=this.b+(w-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$xl=C;class I{constructor(w){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(w),this.c.fill(0,0,w)}update(w){const $=this.c[this.d];return this.c[this.d]=w,this.d=(this.d+1)%this.c.length,this.e-=$,this.e+=w,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$yl=I}),function(){function ce(r){const C=[];typeof r=="number"&&C.push("code/timeOrigin",r);function I(w){C.push(w,Date.now())}function P(){const w=[];for(let $=0;$<C.length;$+=2)w.push({name:C[$],startTime:C[$+1]});return w}return{mark:I,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ce():{mark(r){performance.mark(r)},getMarks(){let r=performance.timeOrigin;typeof r!="number"&&(r=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(r)}];for(const I of performance.getEntriesByType("mark"))C.push({name:I.name,startTime:Math.round(r+I.startTime)});return C}};if(typeof process=="object"){const r=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ce(r)}else return console.trace("perf-util loaded in UNKNOWN environment"),ce()}function D(r){return r.MonacoPerformanceMarks||(r.MonacoPerformanceMarks=e()),r.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=D(O))}(),function(ce,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var O in D)(typeof exports=="object"?exports:ce)[O]=D[O]}}(typeof self<"u"?self:this,function(){return function(ce){var e={};function D(O){if(e[O])return e[O].exports;var r=e[O]={i:O,l:!1,exports:{}};return ce[O].call(r.exports,r,r.exports,D),r.l=!0,r.exports}return D.m=ce,D.c=e,D.d=function(O,r,C){D.o(O,r)||Object.defineProperty(O,r,{enumerable:!0,get:C})},D.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},D.t=function(O,r){if(1&r&&(O=D(O)),8&r||4&r&&typeof O=="object"&&O&&O.__esModule)return O;var C=Object.create(null);if(D.r(C),Object.defineProperty(C,"default",{enumerable:!0,value:O}),2&r&&typeof O!="string")for(var I in O)D.d(C,I,function(P){return O[P]}.bind(null,I));return C},D.n=function(O){var r=O&&O.__esModule?function(){return O.default}:function(){return O};return D.d(r,"a",r),r},D.o=function(O,r){return Object.prototype.hasOwnProperty.call(O,r)},D.p="",D(D.s=0)}([function(ce,e,D){(function(O){var r;e=ce.exports=q,r=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var ge=Array.prototype.slice.call(arguments,0);ge.unshift("SEMVER"),console.log.apply(console,ge)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var C=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],w=e.src=[],$=0,A=$++;w[A]="0|[1-9]\\d*";var k=$++;w[k]="[0-9]+";var p=$++;w[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var l=$++;w[l]="("+w[A]+")\\.("+w[A]+")\\.("+w[A]+")";var d=$++;w[d]="("+w[k]+")\\.("+w[k]+")\\.("+w[k]+")";var m=$++;w[m]="(?:"+w[A]+"|"+w[p]+")";var c=$++;w[c]="(?:"+w[k]+"|"+w[p]+")";var u=$++;w[u]="(?:-("+w[m]+"(?:\\."+w[m]+")*))";var h=$++;w[h]="(?:-?("+w[c]+"(?:\\."+w[c]+")*))";var g=$++;w[g]="[0-9A-Za-z-]+";var E=$++;w[E]="(?:\\+("+w[g]+"(?:\\."+w[g]+")*))";var v=$++,t="v?"+w[l]+w[u]+"?"+w[E]+"?";w[v]="^"+t+"$";var s="[v=\\s]*"+w[d]+w[h]+"?"+w[E]+"?",a=$++;w[a]="^"+s+"$";var i=$++;w[i]="((?:<|>)?=?)";var n=$++;w[n]=w[k]+"|x|X|\\*";var o=$++;w[o]=w[A]+"|x|X|\\*";var f=$++;w[f]="[v=\\s]*("+w[o]+")(?:\\.("+w[o]+")(?:\\.("+w[o]+")(?:"+w[u]+")?"+w[E]+"?)?)?";var b=$++;w[b]="[v=\\s]*("+w[n]+")(?:\\.("+w[n]+")(?:\\.("+w[n]+")(?:"+w[h]+")?"+w[E]+"?)?)?";var y=$++;w[y]="^"+w[i]+"\\s*"+w[f]+"$";var S=$++;w[S]="^"+w[i]+"\\s*"+w[b]+"$";var L=$++;w[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=$++;w[j]="(?:~>?)";var Q=$++;w[Q]="(\\s*)"+w[j]+"\\s+",P[Q]=new RegExp(w[Q],"g");var le=$++;w[le]="^"+w[j]+w[f]+"$";var Y=$++;w[Y]="^"+w[j]+w[b]+"$";var ee=$++;w[ee]="(?:\\^)";var ue=$++;w[ue]="(\\s*)"+w[ee]+"\\s+",P[ue]=new RegExp(w[ue],"g");var X=$++;w[X]="^"+w[ee]+w[f]+"$";var he=$++;w[he]="^"+w[ee]+w[b]+"$";var x=$++;w[x]="^"+w[i]+"\\s*("+s+")$|^$";var se=$++;w[se]="^"+w[i]+"\\s*("+t+")$|^$";var V=$++;w[V]="(\\s*)"+w[i]+"\\s*("+s+"|"+w[f]+")",P[V]=new RegExp(w[V],"g");var K=$++;w[K]="^\\s*("+w[f]+")\\s+-\\s+("+w[f]+")\\s*$";var H=$++;w[H]="^\\s*("+w[b]+")\\s+-\\s+("+w[b]+")\\s*$";var te=$++;w[te]="(<|>)?=?\\s*\\*";for(var me=0;me<35;me++)r(me,w[me]),P[me]||(P[me]=new RegExp(w[me]));function ne(ge,ke){if(ge instanceof q)return ge;if(typeof ge!="string"||ge.length>C||!(ke?P[a]:P[v]).test(ge))return null;try{return new q(ge,ke)}catch{return null}}function q(ge,ke){if(ge instanceof q){if(ge.loose===ke)return ge;ge=ge.version}else if(typeof ge!="string")throw new TypeError("Invalid Version: "+ge);if(ge.length>C)throw new TypeError("version is longer than "+C+" characters");if(!(this instanceof q))return new q(ge,ke);r("SemVer",ge,ke),this.loose=ke;var ye=ge.trim().match(ke?P[a]:P[v]);if(!ye)throw new TypeError("Invalid Version: "+ge);if(this.raw=ge,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(Te){if(/^[0-9]+$/.test(Te)){var ze=+Te;if(ze>=0&&ze<I)return ze}return Te}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=ne,e.valid=function(ge,ke){var ye=ne(ge,ke);return ye?ye.version:null},e.clean=function(ge,ke){var ye=ne(ge.trim().replace(/^[=v]+/,""),ke);return ye?ye.version:null},e.SemVer=q,q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},q.prototype.toString=function(){return this.version},q.prototype.compare=function(ge){return r("SemVer.compare",this.version,this.loose,ge),ge instanceof q||(ge=new q(ge,this.loose)),this.compareMain(ge)||this.comparePre(ge)},q.prototype.compareMain=function(ge){return ge instanceof q||(ge=new q(ge,this.loose)),R(this.major,ge.major)||R(this.minor,ge.minor)||R(this.patch,ge.patch)},q.prototype.comparePre=function(ge){if(ge instanceof q||(ge=new q(ge,this.loose)),this.prerelease.length&&!ge.prerelease.length)return-1;if(!this.prerelease.length&&ge.prerelease.length)return 1;if(!this.prerelease.length&&!ge.prerelease.length)return 0;var ke=0;do{var ye=this.prerelease[ke],Te=ge.prerelease[ke];if(r("prerelease compare",ke,ye,Te),ye===void 0&&Te===void 0)return 0;if(Te===void 0)return 1;if(ye===void 0)return-1;if(ye!==Te)return R(ye,Te)}while(++ke)},q.prototype.inc=function(ge,ke){switch(ge){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ke);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ke);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ke),this.inc("pre",ke);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ke),this.inc("pre",ke);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}ke&&(this.prerelease[0]===ke?isNaN(this.prerelease[1])&&(this.prerelease=[ke,0]):this.prerelease=[ke,0]);break;default:throw new Error("invalid increment argument: "+ge)}return this.format(),this.raw=this.version,this},e.inc=function(ge,ke,ye,Te){typeof ye=="string"&&(Te=ye,ye=void 0);try{return new q(ge,ye).inc(ke,Te).version}catch{return null}},e.diff=function(ge,ke){if(re(ge,ke))return null;var ye=ne(ge),Te=ne(ke);if(ye.prerelease.length||Te.prerelease.length){for(var ze in ye)if((ze==="major"||ze==="minor"||ze==="patch")&&ye[ze]!==Te[ze])return"pre"+ze;return"prerelease"}for(var ze in ye)if((ze==="major"||ze==="minor"||ze==="patch")&&ye[ze]!==Te[ze])return ze},e.compareIdentifiers=R;var J=/^[0-9]+$/;function R(ge,ke){var ye=J.test(ge),Te=J.test(ke);return ye&&Te&&(ge=+ge,ke=+ke),ye&&!Te?-1:Te&&!ye?1:ge<ke?-1:ge>ke?1:0}function F(ge,ke,ye){return new q(ge,ye).compare(new q(ke,ye))}function W(ge,ke,ye){return F(ge,ke,ye)>0}function ie(ge,ke,ye){return F(ge,ke,ye)<0}function re(ge,ke,ye){return F(ge,ke,ye)===0}function _(ge,ke,ye){return F(ge,ke,ye)!==0}function oe(ge,ke,ye){return F(ge,ke,ye)>=0}function N(ge,ke,ye){return F(ge,ke,ye)<=0}function B(ge,ke,ye,Te){var ze;switch(ke){case"===":typeof ge=="object"&&(ge=ge.version),typeof ye=="object"&&(ye=ye.version),ze=ge===ye;break;case"!==":typeof ge=="object"&&(ge=ge.version),typeof ye=="object"&&(ye=ye.version),ze=ge!==ye;break;case"":case"=":case"==":ze=re(ge,ye,Te);break;case"!=":ze=_(ge,ye,Te);break;case">":ze=W(ge,ye,Te);break;case">=":ze=oe(ge,ye,Te);break;case"<":ze=ie(ge,ye,Te);break;case"<=":ze=N(ge,ye,Te);break;default:throw new TypeError("Invalid operator: "+ke)}return ze}function U(ge,ke){if(ge instanceof U){if(ge.loose===ke)return ge;ge=ge.value}if(!(this instanceof U))return new U(ge,ke);r("comparator",ge,ke),this.loose=ke,this.parse(ge),this.semver===z?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}e.rcompareIdentifiers=function(ge,ke){return R(ke,ge)},e.major=function(ge,ke){return new q(ge,ke).major},e.minor=function(ge,ke){return new q(ge,ke).minor},e.patch=function(ge,ke){return new q(ge,ke).patch},e.compare=F,e.compareLoose=function(ge,ke){return F(ge,ke,!0)},e.rcompare=function(ge,ke,ye){return F(ke,ge,ye)},e.sort=function(ge,ke){return ge.sort(function(ye,Te){return e.compare(ye,Te,ke)})},e.rsort=function(ge,ke){return ge.sort(function(ye,Te){return e.rcompare(ye,Te,ke)})},e.gt=W,e.lt=ie,e.eq=re,e.neq=_,e.gte=oe,e.lte=N,e.cmp=B,e.Comparator=U;var z={};function Z(ge,ke){if(ge instanceof Z)return ge.loose===ke?ge:new Z(ge.raw,ke);if(ge instanceof U)return new Z(ge.value,ke);if(!(this instanceof Z))return new Z(ge,ke);if(this.loose=ke,this.raw=ge,this.set=ge.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ge);this.format()}function de(ge){return!ge||ge.toLowerCase()==="x"||ge==="*"}function Ee(ge,ke,ye,Te,ze,_e,Ve,Xe,Ze,$e,De,Re,Ne){return((ke=de(ye)?"":de(Te)?">="+ye+".0.0":de(ze)?">="+ye+"."+Te+".0":">="+ke)+" "+(Xe=de(Ze)?"":de($e)?"<"+(+Ze+1)+".0.0":de(De)?"<"+Ze+"."+(+$e+1)+".0":Re?"<="+Ze+"."+$e+"."+De+"-"+Re:"<="+Xe)).trim()}function Pe(ge,ke){for(var ye=0;ye<ge.length;ye++)if(!ge[ye].test(ke))return!1;if(ke.prerelease.length){for(ye=0;ye<ge.length;ye++)if(r(ge[ye].semver),ge[ye].semver!==z&&ge[ye].semver.prerelease.length>0){var Te=ge[ye].semver;if(Te.major===ke.major&&Te.minor===ke.minor&&Te.patch===ke.patch)return!0}return!1}return!0}function Ae(ge,ke,ye){try{ke=new Z(ke,ye)}catch{return!1}return ke.test(ge)}function Fe(ge,ke,ye,Te){var ze,_e,Ve,Xe,Ze;switch(ge=new q(ge,Te),ke=new Z(ke,Te),ye){case">":ze=W,_e=N,Ve=ie,Xe=">",Ze=">=";break;case"<":ze=ie,_e=oe,Ve=W,Xe="<",Ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ae(ge,ke,Te))return!1;for(var $e=0;$e<ke.set.length;++$e){var De=ke.set[$e],Re=null,Ne=null;if(De.forEach(function(Me){Me.semver===z&&(Me=new U(">=0.0.0")),Re=Re||Me,Ne=Ne||Me,ze(Me.semver,Re.semver,Te)?Re=Me:Ve(Me.semver,Ne.semver,Te)&&(Ne=Me)}),Re.operator===Xe||Re.operator===Ze||(!Ne.operator||Ne.operator===Xe)&&_e(ge,Ne.semver)||Ne.operator===Ze&&Ve(ge,Ne.semver))return!1}return!0}U.prototype.parse=function(ge){var ke=this.loose?P[x]:P[se],ye=ge.match(ke);if(!ye)throw new TypeError("Invalid comparator: "+ge);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new q(ye[2],this.loose):this.semver=z},U.prototype.toString=function(){return this.value},U.prototype.test=function(ge){return r("Comparator.test",ge,this.loose),this.semver===z||(typeof ge=="string"&&(ge=new q(ge,this.loose)),B(ge,this.operator,this.semver,this.loose))},U.prototype.intersects=function(ge,ke){if(!(ge instanceof U))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new Z(ge.value,ke),Ae(this.value,ye,ke);if(ge.operator==="")return ye=new Z(this.value,ke),Ae(ge.semver,ye,ke);var Te=!(this.operator!==">="&&this.operator!==">"||ge.operator!==">="&&ge.operator!==">"),ze=!(this.operator!=="<="&&this.operator!=="<"||ge.operator!=="<="&&ge.operator!=="<"),_e=this.semver.version===ge.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||ge.operator!==">="&&ge.operator!=="<="),Xe=B(this.semver,"<",ge.semver,ke)&&(this.operator===">="||this.operator===">")&&(ge.operator==="<="||ge.operator==="<"),Ze=B(this.semver,">",ge.semver,ke)&&(this.operator==="<="||this.operator==="<")&&(ge.operator===">="||ge.operator===">");return Te||ze||_e&&Ve||Xe||Ze},e.Range=Z,Z.prototype.format=function(){return this.range=this.set.map(function(ge){return ge.join(" ").trim()}).join("||").trim(),this.range},Z.prototype.toString=function(){return this.range},Z.prototype.parseRange=function(ge){var ke=this.loose;ge=ge.trim(),r("range",ge,ke);var ye=ke?P[H]:P[K];ge=ge.replace(ye,Ee),r("hyphen replace",ge),ge=ge.replace(P[V],"$1$2$3"),r("comparator trim",ge,P[V]),ge=(ge=(ge=ge.replace(P[Q],"$1~")).replace(P[ue],"$1^")).split(/\s+/).join(" ");var Te=ke?P[x]:P[se],ze=ge.split(" ").map(function(_e){return function(Ve,Xe){return r("comp",Ve),Ve=function(Ze,$e){return Ze.trim().split(/\s+/).map(function(De){return function(Re,Ne){r("caret",Re,Ne);var Me=Ne?P[he]:P[X];return Re.replace(Me,function(qe,Be,Ke,He,Ye){var Je;return r("caret",Re,qe,Be,Ke,He,Ye),de(Be)?Je="":de(Ke)?Je=">="+Be+".0.0 <"+(+Be+1)+".0.0":de(He)?Je=Be==="0"?">="+Be+"."+Ke+".0 <"+Be+"."+(+Ke+1)+".0":">="+Be+"."+Ke+".0 <"+(+Be+1)+".0.0":Ye?(r("replaceCaret pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),Je=Be==="0"?Ke==="0"?">="+Be+"."+Ke+"."+He+Ye+" <"+Be+"."+Ke+"."+(+He+1):">="+Be+"."+Ke+"."+He+Ye+" <"+Be+"."+(+Ke+1)+".0":">="+Be+"."+Ke+"."+He+Ye+" <"+(+Be+1)+".0.0"):(r("no pr"),Je=Be==="0"?Ke==="0"?">="+Be+"."+Ke+"."+He+" <"+Be+"."+Ke+"."+(+He+1):">="+Be+"."+Ke+"."+He+" <"+Be+"."+(+Ke+1)+".0":">="+Be+"."+Ke+"."+He+" <"+(+Be+1)+".0.0"),r("caret return",Je),Je})}(De,$e)}).join(" ")}(Ve,Xe),r("caret",Ve),Ve=function(Ze,$e){return Ze.trim().split(/\s+/).map(function(De){return function(Re,Ne){var Me=Ne?P[Y]:P[le];return Re.replace(Me,function(qe,Be,Ke,He,Ye){var Je;return r("tilde",Re,qe,Be,Ke,He,Ye),de(Be)?Je="":de(Ke)?Je=">="+Be+".0.0 <"+(+Be+1)+".0.0":de(He)?Je=">="+Be+"."+Ke+".0 <"+Be+"."+(+Ke+1)+".0":Ye?(r("replaceTilde pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),Je=">="+Be+"."+Ke+"."+He+Ye+" <"+Be+"."+(+Ke+1)+".0"):Je=">="+Be+"."+Ke+"."+He+" <"+Be+"."+(+Ke+1)+".0",r("tilde return",Je),Je})}(De,$e)}).join(" ")}(Ve,Xe),r("tildes",Ve),Ve=function(Ze,$e){return r("replaceXRanges",Ze,$e),Ze.split(/\s+/).map(function(De){return function(Re,Ne){Re=Re.trim();var Me=Ne?P[S]:P[y];return Re.replace(Me,function(qe,Be,Ke,He,Ye,Je){r("xRange",Re,qe,Be,Ke,He,Ye,Je);var xe=de(Ke),nt=xe||de(He),rt=nt||de(Ye);return Be==="="&&rt&&(Be=""),xe?qe=Be===">"||Be==="<"?"<0.0.0":"*":Be&&rt?(nt&&(He=0),rt&&(Ye=0),Be===">"?(Be=">=",nt?(Ke=+Ke+1,He=0,Ye=0):rt&&(He=+He+1,Ye=0)):Be==="<="&&(Be="<",nt?Ke=+Ke+1:He=+He+1),qe=Be+Ke+"."+He+"."+Ye):nt?qe=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":rt&&(qe=">="+Ke+"."+He+".0 <"+Ke+"."+(+He+1)+".0"),r("xRange return",qe),qe})}(De,$e)}).join(" ")}(Ve,Xe),r("xrange",Ve),Ve=function(Ze,$e){return r("replaceStars",Ze,$e),Ze.trim().replace(P[te],"")}(Ve,Xe),r("stars",Ve),Ve}(_e,ke)}).join(" ").split(/\s+/);return this.loose&&(ze=ze.filter(function(_e){return!!_e.match(Te)})),ze=ze.map(function(_e){return new U(_e,ke)})},Z.prototype.intersects=function(ge,ke){if(!(ge instanceof Z))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(Te){return ge.set.some(function(ze){return ze.every(function(_e){return Te.intersects(_e,ke)})})})})},e.toComparators=function(ge,ke){return new Z(ge,ke).set.map(function(ye){return ye.map(function(Te){return Te.value}).join(" ").trim().split(" ")})},Z.prototype.test=function(ge){if(!ge)return!1;typeof ge=="string"&&(ge=new q(ge,this.loose));for(var ke=0;ke<this.set.length;ke++)if(Pe(this.set[ke],ge))return!0;return!1},e.satisfies=Ae,e.maxSatisfying=function(ge,ke,ye){var Te=null,ze=null;try{var _e=new Z(ke,ye)}catch{return null}return ge.forEach(function(Ve){_e.test(Ve)&&(Te&&ze.compare(Ve)!==-1||(ze=new q(Te=Ve,ye)))}),Te},e.minSatisfying=function(ge,ke,ye){var Te=null,ze=null;try{var _e=new Z(ke,ye)}catch{return null}return ge.forEach(function(Ve){_e.test(Ve)&&(Te&&ze.compare(Ve)!==1||(ze=new q(Te=Ve,ye)))}),Te},e.validRange=function(ge,ke){try{return new Z(ge,ke).range||"*"}catch{return null}},e.ltr=function(ge,ke,ye){return Fe(ge,ke,"<",ye)},e.gtr=function(ge,ke,ye){return Fe(ge,ke,">",ye)},e.outside=Fe,e.prerelease=function(ge,ke){var ye=ne(ge,ke);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(ge,ke,ye){return ge=new Z(ge,ye),ke=new Z(ke,ye),ge.intersects(ke)},e.coerce=function(ge){if(ge instanceof q)return ge;if(typeof ge!="string")return null;var ke=ge.match(P[L]);return ke==null?null:ne((ke[1]||"0")+"."+(ke[2]||"0")+"."+(ke[3]||"0"))}}).call(this,D(1))},function(ce,e){var D,O,r=ce.exports={};function C(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function P(c){if(D===setTimeout)return setTimeout(c,0);if((D===C||!D)&&setTimeout)return D=setTimeout,setTimeout(c,0);try{return D(c,0)}catch{try{return D.call(null,c,0)}catch{return D.call(this,c,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:C}catch{D=C}try{O=typeof clearTimeout=="function"?clearTimeout:I}catch{O=I}})();var w,$=[],A=!1,k=-1;function p(){A&&w&&(A=!1,w.length?$=w.concat($):k=-1,$.length&&l())}function l(){if(!A){var c=P(p);A=!0;for(var u=$.length;u;){for(w=$,$=[];++k<u;)w&&w[k].run();k=-1,u=$.length}w=null,A=!1,function(h){if(O===clearTimeout)return clearTimeout(h);if((O===I||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(h);try{O(h)}catch{try{return O.call(null,h)}catch{return O.call(this,h)}}}(c)}}function d(c,u){this.fun=c,this.array=u}function m(){}r.nextTick=function(c){var u=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)u[h-1]=arguments[h];$.push(new d(c,u)),$.length!==1||A||P(l)},d.prototype.run=function(){this.fun.apply(null,this.array)},r.title="browser",r.browser=!0,r.env={},r.argv=[],r.version="",r.versions={},r.on=m,r.addListener=m,r.once=m,r.off=m,r.removeListener=m,r.removeAllListeners=m,r.emit=m,r.prependListener=m,r.prependOnceListener=m,r.listeners=function(c){return[]},r.binding=function(c){throw new Error("process.binding is not supported")},r.cwd=function(){return"/"},r.chdir=function(c){throw new Error("process.chdir is not supported")},r.umask=function(){return 0}}])}),define(pe[144],be([1,0]),function(ce,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0;class O{constructor(P,w,$){this.level=P,this.key=w,this.value=$,this.forward=[]}}const r=void 0;class C{constructor(P,w=2**16){this.comparator=P,this[D]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(w)|0),this.e=new O(this.c,r,r)}get size(){return this.f}clear(){this.e=new O(this.c,r,r)}has(P){return!!C.g(this,P,this.comparator)}get(P){return C.g(this,P,this.comparator)?.value}set(P,w){return C.h(this,P,w,this.comparator)&&(this.f+=1),this}delete(P){const w=C.k(this,P,this.comparator);return w&&(this.f-=1),w}forEach(P,w){let $=this.e.forward[0];for(;$;)P.call(w,$.value,$.key,this),$=$.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",w=this.e.forward[0];for(;w;)P+=`node(${w.key}, ${w.value}, lvl:${w.level})`,w=w.forward[0];return P}static g(P,w,$){let A=P.e;for(let k=P.d-1;k>=0;k--)for(;A.forward[k]&&$(A.forward[k].key,w)<0;)A=A.forward[k];if(A=A.forward[0],A&&$(A.key,w)===0)return A}static h(P,w,$,A){const k=[];let p=P.e;for(let l=P.d-1;l>=0;l--){for(;p.forward[l]&&A(p.forward[l].key,w)<0;)p=p.forward[l];k[l]=p}if(p=p.forward[0],p&&A(p.key,w)===0)return p.value=$,!1;{const l=C.j(P);if(l>P.d){for(let d=P.d;d<l;d++)k[d]=P.e;P.d=l}p=new O(l,w,$);for(let d=0;d<l;d++)p.forward[d]=k[d].forward[d],k[d].forward[d]=p;return!0}}static j(P,w=.5){let $=1;for(;Math.random()<w&&$<P.c;)$+=1;return $}static k(P,w,$){const A=[];let k=P.e;for(let p=P.d-1;p>=0;p--){for(;k.forward[p]&&$(k.forward[p].key,w)<0;)k=k.forward[p];A[p]=k}if(k=k.forward[0],!k||$(k.key,w)!==0)return!1;for(let p=0;p<P.d&&A[p].forward[p]===k;p++)A[p].forward[p]=k.forward[p];for(;P.d>0&&P.e.forward[P.d-1]===r;)P.d-=1;return!0}}e.$fr=C}),define(pe[58],be([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(C){return new O(C)}constructor(C){this.c=D&&C===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ac=O}),define(pe[5],be([1,0,11,74,2,97,58]),function(ce,e,D,O,r,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.Event=void 0;const P=!1,w=!1;var $;(function(y){y.None=()=>r.$lb.None;function S(oe){if(w){const{onDidAddListener:N}=oe,B=d.create();let U=0;oe.onDidAddListener=()=>{++U===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),B.print()),N?.()}}}function L(oe,N){return x(oe,()=>{},0,void 0,!0,void 0,N)}y.defer=L;function j(oe){return(N,B=null,U)=>{let z=!1,Z;return Z=oe(de=>{if(!z)return Z?Z.dispose():z=!0,N.call(B,de)},null,U),z&&Z.dispose(),Z}}y.once=j;function Q(oe,N,B){return he((U,z=null,Z)=>oe(de=>U.call(z,N(de)),null,Z),B)}y.map=Q;function le(oe,N,B){return he((U,z=null,Z)=>oe(de=>{N(de),U.call(z,de)},null,Z),B)}y.forEach=le;function Y(oe,N,B){return he((U,z=null,Z)=>oe(de=>N(de)&&U.call(z,de),null,Z),B)}y.filter=Y;function ee(oe){return oe}y.signal=ee;function ue(...oe){return(N,B=null,U)=>(0,r.$ib)(...oe.map(z=>z(Z=>N.call(B,Z),null,U)))}y.any=ue;function X(oe,N,B,U){let z=B;return Q(oe,Z=>(z=N(z,Z),z),U)}y.reduce=X;function he(oe,N){let B;const U={onWillAddFirstListener(){B=oe(z.fire,z)},onDidRemoveLastListener(){B?.dispose()}};N||S(U);const z=new g(U);return N?.add(z),z.event}function x(oe,N,B=100,U=!1,z=!1,Z,de){let Ee,Pe,Ae,Fe=0,ge;const ke={leakWarningThreshold:Z,onWillAddFirstListener(){Ee=oe(Te=>{Fe++,Pe=N(Pe,Te),U&&!Ae&&(ye.fire(Pe),Pe=void 0),ge=()=>{const ze=Pe;Pe=void 0,Ae=void 0,(!U||Fe>1)&&ye.fire(ze),Fe=0},typeof B=="number"?(clearTimeout(Ae),Ae=setTimeout(ge,B)):Ae===void 0&&(Ae=0,queueMicrotask(ge))})},onWillRemoveListener(){z&&Fe>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,Ee.dispose()}};de||S(ke);const ye=new g(ke);return de?.add(ye),ye.event}y.debounce=x;function se(oe,N=0,B){return y.debounce(oe,(U,z)=>U?(U.push(z),U):[z],N,void 0,!0,void 0,B)}y.accumulate=se;function V(oe,N=(U,z)=>U===z,B){let U=!0,z;return Y(oe,Z=>{const de=U||!N(Z,z);return U=!1,z=Z,de},B)}y.latch=V;function K(oe,N,B){return[y.filter(oe,N,B),y.filter(oe,U=>!N(U),B)]}y.split=K;function H(oe,N=!1,B=[]){let U=B.slice(),z=oe(Ee=>{U?U.push(Ee):de.fire(Ee)});const Z=()=>{U?.forEach(Ee=>de.fire(Ee)),U=null},de=new g({onWillAddFirstListener(){z||(z=oe(Ee=>de.fire(Ee)))},onDidAddFirstListener(){U&&(N?setTimeout(Z):Z())},onDidRemoveLastListener(){z&&z.dispose(),z=null}});return de.event}y.buffer=H;class te{constructor(N){this.event=N,this.d=new r.$kb}map(N){return new te(Q(this.event,N,this.d))}forEach(N){return new te(le(this.event,N,this.d))}filter(N){return new te(Y(this.event,N,this.d))}reduce(N,B){return new te(X(this.event,N,B,this.d))}latch(){return new te(V(this.event,void 0,this.d))}debounce(N,B=100,U=!1,z=!1,Z){return new te(x(this.event,N,B,U,z,Z,this.d))}on(N,B,U){return this.event(N,B,U)}once(N,B,U){return j(this.event)(N,B,U)}dispose(){this.d.dispose()}}function me(oe){return new te(oe)}y.chain=me;function ne(oe,N,B=U=>U){const U=(...Ee)=>de.fire(B(...Ee)),z=()=>oe.on(N,U),Z=()=>oe.removeListener(N,U),de=new g({onWillAddFirstListener:z,onDidRemoveLastListener:Z});return de.event}y.fromNodeEventEmitter=ne;function q(oe,N,B=U=>U){const U=(...Ee)=>de.fire(B(...Ee)),z=()=>oe.addEventListener(N,U),Z=()=>oe.removeEventListener(N,U),de=new g({onWillAddFirstListener:z,onDidRemoveLastListener:Z});return de.event}y.fromDOMEventEmitter=q;function J(oe){return new Promise(N=>j(oe)(N))}y.toPromise=J;function R(oe){const N=new g;return oe.then(B=>{N.fire(B)},()=>{N.fire(void 0)}).finally(()=>{N.dispose()}),N.event}y.fromPromise=R;function F(oe,N){return N(void 0),oe(B=>N(B))}y.runAndSubscribe=F;function W(oe,N){let B=null;function U(Z){B?.dispose(),B=new r.$kb,N(Z,B)}U(void 0);const z=oe(Z=>U(Z));return(0,r.$jb)(()=>{z.dispose(),B?.dispose()})}y.runAndSubscribeWithStore=W;class ie{constructor(N,B){this._observable=N,this.d=0,this.f=!1;const U={onWillAddFirstListener:()=>{N.addObserver(this)},onDidRemoveLastListener:()=>{N.removeObserver(this)}};B||S(U),this.emitter=new g(U),B&&B.add(this.emitter)}beginUpdate(N){this.d++}handlePossibleChange(N){}handleChange(N,B){this.f=!0}endUpdate(N){this.d--,this.d===0&&(this._observable.reportChanges(),this.f&&(this.f=!1,this.emitter.fire(this._observable.get())))}}function re(oe,N){return new ie(oe,N).emitter.event}y.fromObservable=re;function _(oe){return N=>{let B=0,U=!1;const z={beginUpdate(){B++},endUpdate(){B--,B===0&&(oe.reportChanges(),U&&(U=!1,N()))},handlePossibleChange(){},handleChange(){U=!0}};return oe.addObserver(z),oe.reportChanges(),{dispose(){oe.removeObserver(z)}}}}y.fromObservableLight=_})($||(e.Event=$={}));class A{static{this.all=new Set}static{this.d=0}constructor(S){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${S}_${A.d++}`,A.all.add(this)}start(S){this.f=new I.$ac,this.listenerCount=S}stop(){if(this.f){const S=this.f.elapsed();this.durations.push(S),this.elapsedOverall+=S,this.invocationCount+=1,this.f=void 0}}}e.$cc=A;let k=-1;function p(y){const S=k;return k=y,{dispose(){k=S}}}e.$dc=p;class l{constructor(S,L=Math.random().toString(18).slice(2,5)){this.threshold=S,this.name=L,this.f=0}dispose(){this.d?.clear()}check(S,L){const j=this.threshold;if(j<=0||L<j)return;this.d||(this.d=new Map);const Q=this.d.get(S.value)||0;if(this.d.set(S.value,Q+1),this.f-=1,this.f<=0){this.f=j*.5;let le,Y=0;for(const[ee,ue]of this.d)(!le||Y<ue)&&(le=ee,Y=ue);console.warn(`[${this.name}] potential listener LEAK detected, having ${L} listeners already. MOST frequent listener (${Y}):`),console.warn(le)}return()=>{const le=this.d.get(S.value)||0;this.d.set(S.value,le-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(S){this.value=S}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class c{constructor(S){this.value=S,this.id=m++}}const u=2,h=(y,S)=>{if(y instanceof c)S(y);else for(let L=0;L<y.length;L++){const j=y[L];j&&S(j)}};class g{constructor(S){this.u=0,this.d=S,this.f=k>0||this.d?.leakWarningThreshold?new l(this.d?.leakWarningThreshold??k):void 0,this.g=this.d?._profName?new A(this.d._profName):void 0,this.t=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.t?.current===this&&this.t.reset(),this.q){if(P){const S=this.q;queueMicrotask(()=>{h(S,L=>L.stack?.print())})}this.q=void 0,this.u=0}this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.m??=(S,L,j)=>{if(this.f&&this.u>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.$lb.None;if(this.j)return r.$lb.None;L&&(S=S.bind(L));const Q=new c(S);let le,Y;this.f&&this.u>=Math.ceil(this.f.threshold*.2)&&(Q.stack=d.create(),le=this.f.check(Q.stack,this.u+1)),P&&(Q.stack=Y??d.create()),this.q?this.q instanceof c?(this.t??=new v,this.q=[this.q,Q]):this.q.push(Q):(this.d?.onWillAddFirstListener?.(this),this.q=Q,this.d?.onDidAddFirstListener?.(this)),this.u++;const ee=(0,r.$jb)(()=>{le?.(),this.v(Q)});return j instanceof r.$kb?j.add(ee):Array.isArray(j)&&j.push(ee),ee},this.m}v(S){if(this.d?.onWillRemoveListener?.(this),!this.q)return;if(this.u===1){this.q=void 0,this.d?.onDidRemoveLastListener?.(this),this.u=0;return}const L=this.q,j=L.indexOf(S);if(j===-1)throw console.log("disposed?",this.j),console.log("size?",this.u),console.log("arr?",JSON.stringify(this.q)),new Error("Attempted to dispose unknown listener");this.u--,L[j]=void 0;const Q=this.t.current===this;if(this.u*u<=L.length){let le=0;for(let Y=0;Y<L.length;Y++)L[Y]?L[le++]=L[Y]:Q&&(this.t.end--,le<this.t.i&&this.t.i--);L.length=le}}w(S,L){if(!S)return;const j=this.d?.onListenerError||D.$Y;if(!j){S.value(L);return}try{S.value(L)}catch(Q){j(Q)}}x(S){const L=S.current.q;for(;S.i<S.end;)this.w(L[S.i++],S.value);S.reset()}fire(S){if(this.t?.current&&(this.x(this.t),this.g?.stop()),this.g?.start(this.u),this.q)if(this.q instanceof c)this.w(this.q,S);else{const L=this.t;L.enqueue(this,S,this.q.length),this.x(L)}this.g?.stop()}hasListeners(){return this.u>0}}e.$ec=g;const E=()=>new v;e.$fc=E;class v{constructor(){this.i=-1,this.end=0}enqueue(S,L,j){this.i=0,this.end=j,this.current=S,this.value=L}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends g{async fireAsync(S,L,j){if(this.q)for(this.h||(this.h=new C.$ub),h(this.q,Q=>this.h.push([Q.value,S]));this.h.size>0&&!L.isCancellationRequested;){const[Q,le]=this.h.shift(),Y=[],ee={...le,token:L,waitUntil:ue=>{if(Object.isFrozen(Y))throw new Error("waitUntil can NOT be called asynchronous");j&&(ue=j(ue,Q)),Y.push(ue)}};try{Q(ee)}catch(ue){(0,D.$Y)(ue);continue}Object.freeze(Y),await Promise.allSettled(Y).then(ue=>{for(const X of ue)X.status==="rejected"&&(0,D.$Y)(X.reason)})}}}e.$gc=t;class s extends g{get isPaused(){return this.h!==0}constructor(S){super(S),this.h=0,this.s=new C.$ub,this.y=S?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.y){if(this.s.size>0){const S=Array.from(this.s);this.s.clear(),super.fire(this.y(S))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(S){this.u&&(this.h!==0?this.s.push(S):super.fire(S))}}e.$hc=s;class a extends s{constructor(S){super(S),this.k=S.delay??100}fire(S){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(S)}}e.$ic=a;class i extends g{constructor(S){super(S),this.h=[],this.k=S?.merge}fire(S){this.hasListeners()&&(this.h.push(S),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(L=>super.fire(L)),this.h=[]}))}}e.$jc=i;class n{constructor(){this.f=!1,this.g=[],this.d=new g({onWillAddFirstListener:()=>this.h(),onDidRemoveLastListener:()=>this.j()})}get event(){return this.d.event}add(S){const L={event:S,listener:null};this.g.push(L),this.f&&this.k(L);const j=()=>{this.f&&this.m(L);const Q=this.g.indexOf(L);this.g.splice(Q,1)};return(0,r.$jb)((0,O.$cb)(j))}h(){this.f=!0,this.g.forEach(S=>this.k(S))}j(){this.f=!1,this.g.forEach(S=>this.m(S))}k(S){S.listener=S.event(L=>this.d.fire(L))}m(S){S.listener&&S.listener.dispose(),S.listener=null}dispose(){this.d.dispose()}}e.$kc=n;class o{constructor(S,L,j,Q){this.d=new r.$kb;const le=this.d.add(new n),Y=this.d.add(new r.$tb);function ee(ue){Y.set(ue,le.add(Q(ue)))}for(const ue of S)ee(ue);this.d.add(L(ue=>{ee(ue)})),this.d.add(j(ue=>{Y.deleteAndDispose(ue)})),this.event=le.event}dispose(){this.d.dispose()}}e.$lc=o;class f{constructor(){this.d=[]}wrapEvent(S){return(L,j,Q)=>S(le=>{const Y=this.d[this.d.length-1];Y?Y.push(()=>L.call(j,le)):L.call(j,le)},void 0,Q)}bufferEvents(S){const L=[];this.d.push(L);const j=S();return this.d.pop(),L.forEach(Q=>Q()),j}}e.$mc=f;class b{constructor(){this.d=!1,this.f=$.None,this.g=r.$lb.None,this.h=new g({onDidAddFirstListener:()=>{this.d=!0,this.g=this.f(this.h.fire,this.h)},onDidRemoveLastListener:()=>{this.d=!1,this.g.dispose()}}),this.event=this.h.event}set input(S){this.f=S,this.d&&(this.g.dispose(),this.g=S(this.h.fire,this.h))}dispose(){this.g.dispose(),this.h.dispose()}}e.$nc=b}),define(pe[20],be([1,0,5]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oc=e.CancellationToken=void 0;const O=Object.freeze(function(P,w){const $=setTimeout(P.bind(w),0);return{dispose(){clearTimeout($)}}});var r;(function(P){function w($){return $===P.None||$===P.Cancelled||$ instanceof C?!0:!$||typeof $!="object"?!1:typeof $.isCancellationRequested=="boolean"&&typeof $.onCancellationRequested=="function"}P.isCancellationToken=w,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(r||(e.CancellationToken=r={}));class C{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new D.$ec),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class I{constructor(w){this.a=void 0,this.b=void 0,this.b=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new C),this.a}cancel(){this.a?this.a instanceof C&&this.a.cancel():this.a=r.Cancelled}dispose(w=!1){w&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof C&&this.a.dispose():this.a=r.None}}e.$oc=I}),define(pe[145],be([1,0,20]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$id=e.$hd=e.$gd=void 0;class O{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new D.$oc,w=this.b(P.token);return this.a={promise:w,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.$gd=O;class r{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const w=JSON.stringify(P);return this.b!==w&&(this.b=w,this.a=this.c(P)),this.a}}e.$hd=r;class C{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const w=this.b(P);return this.a.set(P,w),w}}e.$id=C}),define(pe[48],be([1,0,11,2]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=void 0;function r(E){const v=E;return v?typeof v.read=="function":!1}e.$pc=r;function C(E){const v=E;return v?[v.on,v.pause,v.resume,v.destroy].every(t=>typeof t=="function"):!1}e.$qc=C;function I(E){const v=E;return v?C(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.$rc=I;function P(E,v){return new w(E,v)}e.$sc=P;class w{constructor(v,t){this.e=v,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(v){if(!this.a.destroyed){if(this.a.flowing)this.g(v);else if(this.b.data.push(v),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(v){this.a.destroyed||(this.a.flowing?this.h(v):this.b.error.push(v))}end(v){this.a.destroyed||(typeof v<"u"&&this.write(v),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(v){this.c.data.slice(0).forEach(t=>t(v))}h(v){this.c.error.length===0?(0,D.$Y)(v):this.c.error.slice(0).forEach(t=>t(v))}i(){this.c.end.slice(0).forEach(v=>v())}on(v,t){if(!this.a.destroyed)switch(v){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(v,t){if(this.a.destroyed)return;let s;switch(v){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const a=s.indexOf(t);a>=0&&s.splice(a,1)}}j(){if(this.b.data.length>0){const v=this.e(this.b.data);this.g(v),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const v of this.b.error)this.h(v);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function $(E,v){const t=[];let s;for(;(s=E.read())!==null;)t.push(s);return v(t)}e.$tc=$;function A(E,v,t){const s=[];let a;for(;(a=E.read())!==null&&s.length<t;)s.push(a);return a===null&&s.length>0?v(s):{read:()=>{if(s.length>0)return s.shift();if(typeof a<"u"){const i=a;return a=void 0,i}return E.read()}}}e.$uc=A;function k(E,v){return new Promise((t,s)=>{const a=[];p(E,{onData:i=>{v&&a.push(i)},onError:i=>{v?s(i):t(void 0)},onEnd:()=>{t(v?v(a):void 0)}})})}e.$vc=k;function p(E,v,t){E.on("error",s=>{t?.isCancellationRequested||v.onError(s)}),E.on("end",()=>{t?.isCancellationRequested||v.onEnd()}),E.on("data",s=>{t?.isCancellationRequested||v.onData(s)})}e.$wc=p;function l(E,v){return new Promise((t,s)=>{const a=new O.$kb,i=[],n=b=>{if(i.push(b),i.length>v)return a.dispose(),E.pause(),t({stream:E,buffer:i,ended:!1})},o=b=>s(b),f=()=>t({stream:E,buffer:i,ended:!0});a.add((0,O.$jb)(()=>E.removeListener("error",o))),E.on("error",o),a.add((0,O.$jb)(()=>E.removeListener("end",f))),E.on("end",f),a.add((0,O.$jb)(()=>E.removeListener("data",n))),E.on("data",n)})}e.$xc=l;function d(E,v){const t=P(v);return t.end(E),t}e.$yc=d;function m(){const E=P(()=>{throw new Error("not supported")});return E.end(),E}e.$zc=m;function c(E){let v=!1;return{read:()=>v?null:(v=!0,E)}}e.$Ac=c;function u(E,v,t){const s=P(t);return p(E,{onData:a=>s.write(v.data(a)),onError:a=>s.error(v.error?v.error(a):a),onEnd:()=>s.end()}),s}e.$Bc=u;function h(E,v,t){let s=!1;return{read:()=>{const a=v.read();return s?a:(s=!0,a!==null?t([E,a]):E)}}}e.$Cc=h;function g(E,v,t){let s=!1;const a=P(t);return p(v,{onData:i=>s?a.write(i):(s=!0,a.write(t([E,i]))),onError:i=>a.error(i),onEnd:()=>{s||(s=!0,a.write(E)),a.end()}}),a}e.$Dc=g}),define(pe[15],be([1,0,96,48]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=void 0;const r=typeof Buffer<"u",C=new D.$T(()=>new Uint8Array(256));let I,P;class w{static alloc(L){return r?new w(Buffer.allocUnsafe(L)):new w(new Uint8Array(L))}static wrap(L){return r&&!Buffer.isBuffer(L)&&(L=Buffer.from(L.buffer,L.byteOffset,L.byteLength)),new w(L)}static fromString(L,j){return!(j?.dontUseNodeBuffer||!1)&&r?new w(Buffer.from(L)):(I||(I=new TextEncoder),new w(I.encode(L)))}static fromByteArray(L){const j=w.alloc(L.length);for(let Q=0,le=L.length;Q<le;Q++)j.buffer[Q]=L[Q];return j}static concat(L,j){if(typeof j>"u"){j=0;for(let Y=0,ee=L.length;Y<ee;Y++)j+=L[Y].byteLength}const Q=w.alloc(j);let le=0;for(let Y=0,ee=L.length;Y<ee;Y++){const ue=L[Y];Q.set(ue,le),le+=ue.byteLength}return Q}constructor(L){this.buffer=L,this.byteLength=this.buffer.byteLength}clone(){const L=w.alloc(this.byteLength);return L.set(this),L}toString(){return r?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(L,j){return new w(this.buffer.subarray(L,j))}set(L,j){if(L instanceof w)this.buffer.set(L.buffer,j);else if(L instanceof Uint8Array)this.buffer.set(L,j);else if(L instanceof ArrayBuffer)this.buffer.set(new Uint8Array(L),j);else if(ArrayBuffer.isView(L))this.buffer.set(new Uint8Array(L.buffer,L.byteOffset,L.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(L){return p(this.buffer,L)}writeUInt32BE(L,j){l(this.buffer,L,j)}readUInt32LE(L){return d(this.buffer,L)}writeUInt32LE(L,j){m(this.buffer,L,j)}readUInt8(L){return c(this.buffer,L)}writeUInt8(L,j){u(this.buffer,L,j)}indexOf(L,j=0){return $(this.buffer,L instanceof w?L.buffer:L,j)}}e.$Ec=w;function $(S,L,j=0){const Q=L.byteLength,le=S.byteLength;if(Q===0)return 0;if(Q===1)return S.indexOf(L[0]);if(Q>le-j)return-1;const Y=C.value;Y.fill(L.length);for(let he=0;he<L.length;he++)Y[L[he]]=L.length-he-1;let ee=j+L.length-1,ue=ee,X=-1;for(;ee<le;)if(S[ee]===L[ue]){if(ue===0){X=ee;break}ee--,ue--}else ee+=Math.max(L.length-ue,Y[S[ee]]),ue=L.length-1;return X}e.$Fc=$;function A(S,L){return S[L+0]<<0>>>0|S[L+1]<<8>>>0}e.$Gc=A;function k(S,L,j){S[j+0]=L&255,L=L>>>8,S[j+1]=L&255}e.$Hc=k;function p(S,L){return S[L]*2**24+S[L+1]*2**16+S[L+2]*2**8+S[L+3]}e.$Ic=p;function l(S,L,j){S[j+3]=L,L=L>>>8,S[j+2]=L,L=L>>>8,S[j+1]=L,L=L>>>8,S[j]=L}e.$Jc=l;function d(S,L){return S[L+0]<<0>>>0|S[L+1]<<8>>>0|S[L+2]<<16>>>0|S[L+3]<<24>>>0}e.$Kc=d;function m(S,L,j){S[j+0]=L&255,L=L>>>8,S[j+1]=L&255,L=L>>>8,S[j+2]=L&255,L=L>>>8,S[j+3]=L&255}e.$Lc=m;function c(S,L){return S[L]}e.$Mc=c;function u(S,L,j){S[j]=L}e.$Nc=u;function h(S){return O.$tc(S,L=>w.concat(L))}e.$Oc=h;function g(S){return O.$Ac(S)}e.$Pc=g;function E(S){return O.$vc(S,L=>w.concat(L))}e.$Qc=E;async function v(S){return S.ended?w.concat(S.buffer):w.concat([...S.buffer,await E(S.stream)])}e.$Rc=v;function t(S){return O.$yc(S,L=>w.concat(L))}e.$Sc=t;function s(S){return O.$Bc(S,{data:L=>typeof L=="string"?w.fromString(L):w.wrap(L)},L=>w.concat(L))}e.$Tc=s;function a(S){return O.$sc(L=>w.concat(L),S)}e.$Uc=a;function i(S,L){return O.$Cc(S,L,j=>w.concat(j))}e.$Vc=i;function n(S,L){return O.$Dc(S,L,j=>w.concat(j))}e.$Wc=n;function o(S){let L=0,j=0,Q=0;const le=new Uint8Array(Math.floor(S.length/4*3)),Y=ue=>{switch(j){case 3:le[Q++]=L|ue,j=0;break;case 2:le[Q++]=L|ue>>>2,L=ue<<6,j=3;break;case 1:le[Q++]=L|ue>>>4,L=ue<<4,j=2;break;default:L=ue<<2,j=1}};for(let ue=0;ue<S.length;ue++){const X=S.charCodeAt(ue);if(X>=65&&X<=90)Y(X-65);else if(X>=97&&X<=122)Y(X-97+26);else if(X>=48&&X<=57)Y(X-48+52);else if(X===43||X===45)Y(62);else if(X===47||X===95)Y(63);else{if(X===61)break;throw new SyntaxError(`Unexpected base64 character ${S[ue]}`)}}const ee=Q;for(;j>0;)Y(0);return w.wrap(le).slice(0,ee)}e.$Xc=o;const f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:S},L=!0,j=!1){const Q=j?b:f;let le="";const Y=S.byteLength%3;let ee=0;for(;ee<S.byteLength-Y;ee+=3){const ue=S[ee+0],X=S[ee+1],he=S[ee+2];le+=Q[ue>>>2],le+=Q[(ue<<4|X>>>4)&63],le+=Q[(X<<2|he>>>6)&63],le+=Q[he&63]}if(Y===1){const ue=S[ee+0];le+=Q[ue>>>2],le+=Q[ue<<4&63],L&&(le+="==")}else if(Y===2){const ue=S[ee+0],X=S[ee+1];le+=Q[ue>>>2],le+=Q[(ue<<4|X>>>4)&63],le+=Q[X<<2&63],L&&(le+="=")}return le}e.$Yc=y}),define(pe[17],be([1,0,145,96]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=e.$ge=e.$fe=e.$ee=e.GraphemeBreakType=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=e.$od=e.$nd=e.$md=e.$ld=void 0;function r($e){return!$e||typeof $e!="string"?!0:$e.trim().length===0}e.$ld=r;const C=/{(\d+)}/g;function I($e,...De){return De.length===0?$e:$e.replace(C,function(Re,Ne){const Me=parseInt(Ne,10);return isNaN(Me)||Me<0||Me>=De.length?Re:De[Me]})}e.$md=I;const P=/{([^}]+)}/g;function w($e,De){return $e.replace(P,(Re,Ne)=>De[Ne]??Re)}e.$nd=w;function $($e){return $e.replace(/[<>&]/g,function(De){switch(De){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return De}})}e.$od=$;function A($e){return $e.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$pd=A;function k($e,De){let Re=0;const Ne=De.charCodeAt(0);for(let Me=$e.length-1;Me>=0;Me--)$e.charCodeAt(Me)===Ne&&Re++;return Re}e.$qd=k;function p($e,De,Re="\u2026"){return $e.length<=De?$e:`${$e.substr(0,De)}${Re}`}e.$rd=p;function l($e,De=" "){const Re=d($e,De);return m(Re,De)}e.$sd=l;function d($e,De){if(!$e||!De)return $e;const Re=De.length;if(Re===0||$e.length===0)return $e;let Ne=0;for(;$e.indexOf(De,Ne)===Ne;)Ne=Ne+Re;return $e.substring(Ne)}e.$td=d;function m($e,De){if(!$e||!De)return $e;const Re=De.length,Ne=$e.length;if(Re===0||Ne===0)return $e;let Me=Ne,qe=-1;for(;qe=$e.lastIndexOf(De,Me-1),!(qe===-1||qe+Re!==Me);){if(qe===0)return"";Me=qe}return $e.substring(0,Me)}e.$ud=m;function c($e){return $e.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$vd=c;function u($e){return $e.replace(/\*/g,"")}e.$wd=u;function h($e,De,Re={}){if(!$e)throw new Error("Cannot create regex from empty string");De||($e=A($e)),Re.wholeWord&&(/\B/.test($e.charAt(0))||($e="\\b"+$e),/\B/.test($e.charAt($e.length-1))||($e=$e+"\\b"));let Ne="";return Re.global&&(Ne+="g"),Re.matchCase||(Ne+="i"),Re.multiline&&(Ne+="m"),Re.unicode&&(Ne+="u"),new RegExp($e,Ne)}e.$xd=h;function g($e){return $e.source==="^"||$e.source==="^$"||$e.source==="$"||$e.source==="^\\s*$"?!1:!!($e.exec("")&&$e.lastIndex===0)}e.$yd=g;function E($e){return $e.split(/\r\n|\r|\n/)}e.$zd=E;function v($e){for(let De=0,Re=$e.length;De<Re;De++){const Ne=$e.charCodeAt(De);if(Ne!==32&&Ne!==9)return De}return-1}e.$Ad=v;function t($e,De=0,Re=$e.length){for(let Ne=De;Ne<Re;Ne++){const Me=$e.charCodeAt(Ne);if(Me!==32&&Me!==9)return $e.substring(De,Ne)}return $e.substring(De,Re)}e.$Bd=t;function s($e,De=$e.length-1){for(let Re=De;Re>=0;Re--){const Ne=$e.charCodeAt(Re);if(Ne!==32&&Ne!==9)return Re}return-1}e.$Cd=s;function a($e,De,Re){const Ne=[];let Me=0;for(const qe of $e.matchAll(De)){if(Ne.push($e.slice(Me,qe.index)),qe.index===void 0)throw new Error("match.index should be defined");Me=qe.index+qe[0].length,Ne.push(Re(qe[0],...qe.slice(1),qe.index,$e,qe.groups))}return Ne.push($e.slice(Me)),Promise.all(Ne).then(qe=>qe.join(""))}e.$Dd=a;function i($e,De){return $e<De?-1:$e>De?1:0}e.$Ed=i;function n($e,De,Re=0,Ne=$e.length,Me=0,qe=De.length){for(;Re<Ne&&Me<qe;Re++,Me++){const He=$e.charCodeAt(Re),Ye=De.charCodeAt(Me);if(He<Ye)return-1;if(He>Ye)return 1}const Be=Ne-Re,Ke=qe-Me;return Be<Ke?-1:Be>Ke?1:0}e.$Fd=n;function o($e,De){return f($e,De,0,$e.length,0,De.length)}e.$Gd=o;function f($e,De,Re=0,Ne=$e.length,Me=0,qe=De.length){for(;Re<Ne&&Me<qe;Re++,Me++){let He=$e.charCodeAt(Re),Ye=De.charCodeAt(Me);if(He===Ye)continue;if(He>=128||Ye>=128)return n($e.toLowerCase(),De.toLowerCase(),Re,Ne,Me,qe);y(He)&&(He-=32),y(Ye)&&(Ye-=32);const Je=He-Ye;if(Je!==0)return Je}const Be=Ne-Re,Ke=qe-Me;return Be<Ke?-1:Be>Ke?1:0}e.$Hd=f;function b($e){return $e>=48&&$e<=57}e.$Id=b;function y($e){return $e>=97&&$e<=122}e.$Jd=y;function S($e){return $e>=65&&$e<=90}e.$Kd=S;function L($e,De){return $e.length===De.length&&f($e,De)===0}e.$Ld=L;function j($e,De){const Re=De.length;return De.length>$e.length?!1:f($e,De,0,Re)===0}e.$Md=j;function Q($e,De){const Re=Math.min($e.length,De.length);let Ne;for(Ne=0;Ne<Re;Ne++)if($e.charCodeAt(Ne)!==De.charCodeAt(Ne))return Ne;return Re}e.$Nd=Q;function le($e,De){const Re=Math.min($e.length,De.length);let Ne;const Me=$e.length-1,qe=De.length-1;for(Ne=0;Ne<Re;Ne++)if($e.charCodeAt(Me-Ne)!==De.charCodeAt(qe-Ne))return Ne;return Re}e.$Od=le;function Y($e){return 55296<=$e&&$e<=56319}e.$Pd=Y;function ee($e){return 56320<=$e&&$e<=57343}e.$Qd=ee;function ue($e,De){return($e-55296<<10)+(De-56320)+65536}e.$Rd=ue;function X($e,De,Re){const Ne=$e.charCodeAt(Re);if(Y(Ne)&&Re+1<De){const Me=$e.charCodeAt(Re+1);if(ee(Me))return ue(Ne,Me)}return Ne}e.$Sd=X;function he($e,De){const Re=$e.charCodeAt(De-1);if(ee(Re)&&De>1){const Ne=$e.charCodeAt(De-2);if(Y(Ne))return ue(Ne,Re)}return Re}class x{get offset(){return this.e}constructor(De,Re=0){this.c=De,this.d=De.length,this.e=Re}setOffset(De){this.e=De}prevCodePoint(){const De=he(this.c,this.e);return this.e-=De>=65536?2:1,De}nextCodePoint(){const De=X(this.c,this.d,this.e);return this.e+=De>=65536?2:1,De}eol(){return this.e>=this.d}}e.$Td=x;class se{get offset(){return this.c.offset}constructor(De,Re=0){this.c=new x(De,Re)}nextGraphemeLength(){const De=ke.getInstance(),Re=this.c,Ne=Re.offset;let Me=De.getGraphemeBreakType(Re.nextCodePoint());for(;!Re.eol();){const qe=Re.offset,Be=De.getGraphemeBreakType(Re.nextCodePoint());if(Fe(Me,Be)){Re.setOffset(qe);break}Me=Be}return Re.offset-Ne}prevGraphemeLength(){const De=ke.getInstance(),Re=this.c,Ne=Re.offset;let Me=De.getGraphemeBreakType(Re.prevCodePoint());for(;Re.offset>0;){const qe=Re.offset,Be=De.getGraphemeBreakType(Re.prevCodePoint());if(Fe(Be,Me)){Re.setOffset(qe);break}Me=Be}return Ne-Re.offset}eol(){return this.c.eol()}}e.$Ud=se;function V($e,De){return new se($e,De).nextGraphemeLength()}e.$Vd=V;function K($e,De){return new se($e,De).prevGraphemeLength()}e.$Wd=K;function H($e,De){De>0&&ee($e.charCodeAt(De))&&De--;const Re=De+V($e,De);return[Re-K($e,Re),Re]}e.$Xd=H;function te($e){const De=new se($e);let Re=0;for(;!De.eol();)Re++,De.nextGraphemeLength();return Re}e.$Yd=te;let me;function ne(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function q($e){return me||(me=ne()),me.test($e)}e.$Zd=q;const J=/^[\t\n\r\x20-\x7E]*$/;function R($e){return J.test($e)}e.$1d=R,e.$2d=/[\u2028\u2029]/;function F($e){return e.$2d.test($e)}e.$3d=F;function W($e){return $e>=11904&&$e<=55215||$e>=63744&&$e<=64255||$e>=65281&&$e<=65374}e.$4d=W;function ie($e){return $e>=127462&&$e<=127487||$e===8986||$e===8987||$e===9200||$e===9203||$e>=9728&&$e<=10175||$e===11088||$e===11093||$e>=127744&&$e<=128591||$e>=128640&&$e<=128764||$e>=128992&&$e<=129008||$e>=129280&&$e<=129535||$e>=129648&&$e<=129782}e.$5d=ie;function re($e,De){if($e.length<De)return $e;const Re=/\b/g;let Ne=0;for(;Re.test($e)&&!($e.length-Re.lastIndex<De);)Ne=Re.lastIndex,Re.lastIndex+=1;return $e.substring(Ne).replace(/^\s/,"")}e.$6d=re;const _=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,oe=/\x1b\].*?\x07/g;function N($e){return $e&&($e=$e.replace(_,"").replace(oe,"")),$e}e.$7d=N,e.$8d=String.fromCharCode(65279);function B($e){return!!($e&&$e.length>0&&$e.charCodeAt(0)===65279)}e.$9d=B;function U($e){return B($e)?$e.substr(1):$e}e.$0d=U;function z($e,De){if(!$e||!De||$e.length<De.length)return!1;const Re=De.length,Ne=$e.toLowerCase();let Me=0,qe=-1;for(;Me<Re;){const Be=Ne.indexOf(De[Me],qe+1);if(Be<0)return!1;qe=Be,Me++}return!0}e.$$d=z;function Z($e,De=!1){return $e?(De&&($e=$e.replace(/\\./g,"")),$e.toLowerCase()!==$e):!1}e.$_d=Z;function de($e){return $e.charAt(0).toUpperCase()+$e.slice(1)}e.$ae=de;function Ee($e,De=1){if(De===0)return"";let Re=-1;do Re=$e.indexOf(`
`,Re+1),De--;while(De>0&&Re>=0);return Re===-1?$e:($e[Re-1]==="\r"&&Re--,$e.substr(0,Re))}e.$be=Ee;function Pe($e){return $e=$e%(2*26),$e<26?String.fromCharCode(97+$e):String.fromCharCode(65+$e-26)}e.$ce=Pe;function Ae($e){return ke.getInstance().getGraphemeBreakType($e)}e.$de=Ae;function Fe($e,De){return $e===0?De!==5&&De!==7:$e===2&&De===3?!1:$e===4||$e===2||$e===3||De===4||De===2||De===3?!0:!($e===8&&(De===8||De===9||De===11||De===12)||($e===11||$e===9)&&(De===9||De===10)||($e===12||$e===10)&&De===10||De===5||De===13||De===7||$e===1||$e===13&&De===14||$e===6&&De===6)}var ge;(function($e){$e[$e.Other=0]="Other",$e[$e.Prepend=1]="Prepend",$e[$e.CR=2]="CR",$e[$e.LF=3]="LF",$e[$e.Control=4]="Control",$e[$e.Extend=5]="Extend",$e[$e.Regional_Indicator=6]="Regional_Indicator",$e[$e.SpacingMark=7]="SpacingMark",$e[$e.L=8]="L",$e[$e.V=9]="V",$e[$e.T=10]="T",$e[$e.LV=11]="LV",$e[$e.LVT=12]="LVT",$e[$e.ZWJ=13]="ZWJ",$e[$e.Extended_Pictographic=14]="Extended_Pictographic"})(ge||(e.GraphemeBreakType=ge={}));class ke{static{this.c=null}static getInstance(){return ke.c||(ke.c=new ke),ke.c}constructor(){this.d=ye()}getGraphemeBreakType(De){if(De<32)return De===10?3:De===13?2:4;if(De<127)return 0;const Re=this.d,Ne=Re.length/3;let Me=1;for(;Me<=Ne;)if(De<Re[3*Me])Me=2*Me;else if(De>Re[3*Me+1])Me=2*Me+1;else return Re[3*Me+2];return 0}}function ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te($e,De){if($e===0)return 0;const Re=ze($e,De);if(Re!==void 0)return Re;const Ne=new x(De,$e);return Ne.prevCodePoint(),Ne.offset}e.$ee=Te;function ze($e,De){const Re=new x(De,$e);let Ne=Re.prevCodePoint();for(;_e(Ne)||Ne===65039||Ne===8419;){if(Re.offset===0)return;Ne=Re.prevCodePoint()}if(!ie(Ne))return;let Me=Re.offset;return Me>0&&Re.prevCodePoint()===8205&&(Me=Re.offset),Me}function _e($e){return 127995<=$e&&$e<=127999}var Ve;(function($e){$e[$e.zwj=8205]="zwj",$e[$e.emojiVariantSelector=65039]="emojiVariantSelector",$e[$e.enclosingKeyCap=8419]="enclosingKeyCap"})(Ve||(Ve={})),e.$fe="\xA0";class Xe{static{this.c=new O.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$hd(De=>{function Re(Je){const xe=new Map;for(let nt=0;nt<Je.length;nt+=2)xe.set(Je[nt],Je[nt+1]);return xe}function Ne(Je,xe){const nt=new Map(Je);for(const[rt,it]of xe)nt.set(rt,it);return nt}function Me(Je,xe){if(!Je)return xe;const nt=new Map;for(const[rt,it]of Je)xe.has(rt)&&nt.set(rt,it);return nt}const qe=this.c.value;let Be=De.filter(Je=>!Je.startsWith("_")&&Je in qe);Be.length===0&&(Be=["_default"]);let Ke;for(const Je of Be){const xe=Re(qe[Je]);Ke=Me(Ke,xe)}const He=Re(qe._common),Ye=Ne(He,Ke);return new Xe(Ye)})}static getInstance(De){return Xe.d.get(Array.from(De))}static{this.e=new O.$T(()=>Object.keys(Xe.c.value).filter(De=>!De.startsWith("_")))}static getLocales(){return Xe.e.value}constructor(De){this.f=De}isAmbiguous(De){return this.f.has(De)}getPrimaryConfusable(De){return this.f.get(De)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$ge=Xe;class Ze{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ze.c())),this.d}static isInvisibleCharacter(De){return Ze.e().has(De)}static get codePoints(){return Ze.e()}}e.$he=Ze}),define(pe[146],be([1,0,27,17]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.FuzzyScore=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.or=void 0;function r(...U){return function(z,Z){for(let de=0,Ee=U.length;de<Ee;de++){const Pe=U[de](z,Z);if(Pe)return Pe}return null}}e.or=r,e.$kj=C.bind(void 0,!1),e.$lj=C.bind(void 0,!0);function C(U,z,Z){if(!Z||Z.length<z.length)return null;let de;return U?de=O.$Md(Z,z):de=Z.indexOf(z)===0,de?z.length>0?[{start:0,end:z.length}]:[]:null}function I(U,z){const Z=z.toLowerCase().indexOf(U.toLowerCase());return Z===-1?null:[{start:Z,end:Z+U.length}]}e.$mj=I;function P(U,z){return w(U.toLowerCase(),z.toLowerCase(),0,0)}e.$nj=P;function w(U,z,Z,de){if(Z===U.length)return[];if(de===z.length)return null;if(U[Z]===z[de]){let Ee=null;return(Ee=w(U,z,Z+1,de+1))?u({start:de,end:de+1},Ee):null}return w(U,z,Z,de+1)}function $(U){return 97<=U&&U<=122}function A(U){return 65<=U&&U<=90}e.$oj=A;function k(U){return 48<=U&&U<=57}function p(U){return U===32||U===9||U===10||U===13}const l=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(U=>l.add(U.charCodeAt(0)));function d(U){return p(U)||l.has(U)}function m(U,z){return U===z||d(U)&&d(z)}function c(U){return $(U)||A(U)||k(U)}function u(U,z){return z.length===0?z=[U]:U.end===z[0].start?z[0].start=U.start:z.unshift(U),z}function h(U,z){for(let Z=z;Z<U.length;Z++){const de=U.charCodeAt(Z);if(A(de)||k(de)||Z>0&&!c(U.charCodeAt(Z-1)))return Z}return U.length}function g(U,z,Z,de){if(Z===U.length)return[];if(de===z.length)return null;if(U[Z]!==z[de].toLowerCase())return null;{let Ee=null,Pe=de+1;for(Ee=g(U,z,Z+1,de+1);!Ee&&(Pe=h(z,Pe))<z.length;)Ee=g(U,z,Z+1,Pe),Pe++;return Ee===null?null:u({start:de,end:de+1},Ee)}}function E(U){let z=0,Z=0,de=0,Ee=0,Pe=0;for(let ye=0;ye<U.length;ye++)Pe=U.charCodeAt(ye),A(Pe)&&z++,$(Pe)&&Z++,c(Pe)&&de++,k(Pe)&&Ee++;const Ae=z/U.length,Fe=Z/U.length,ge=de/U.length,ke=Ee/U.length;return{upperPercent:Ae,lowerPercent:Fe,alphaPercent:ge,numericPercent:ke}}function v(U){const{upperPercent:z,lowerPercent:Z}=U;return Z===0&&z>.6}function t(U){const{upperPercent:z,lowerPercent:Z,alphaPercent:de,numericPercent:Ee}=U;return Z>.2&&z<.8&&de>.6&&Ee<.2}function s(U){let z=0,Z=0,de=0,Ee=0;for(let Pe=0;Pe<U.length;Pe++)de=U.charCodeAt(Pe),A(de)&&z++,$(de)&&Z++,p(de)&&Ee++;return(z===0||Z===0)&&Ee===0?U.length<=30:z<=5}function a(U,z){if(!z||(z=z.trim(),z.length===0)||!s(U)||z.length>60)return null;const Z=E(z);if(!t(Z)){if(!v(Z))return null;z=z.toLowerCase()}let de=null,Ee=0;for(U=U.toLowerCase();Ee<z.length&&(de=g(U,z,0,Ee))===null;)Ee=h(z,Ee+1);return de}e.$pj=a;function i(U,z,Z=!1){if(!z||z.length===0)return null;let de=null,Ee=0;for(U=U.toLowerCase(),z=z.toLowerCase();Ee<z.length&&(de=n(U,z,0,Ee,Z))===null;)Ee=o(z,Ee+1);return de}e.$qj=i;function n(U,z,Z,de,Ee){if(Z===U.length)return[];if(de===z.length)return null;if(m(U.charCodeAt(Z),z.charCodeAt(de))){let Pe=null,Ae=de+1;if(Pe=n(U,z,Z+1,de+1,Ee),!Ee)for(;!Pe&&(Ae=o(z,Ae))<z.length;)Pe=n(U,z,Z+1,Ae,Ee),Ae++;return Pe?U.charCodeAt(Z)!==z.charCodeAt(de)?Pe:u({start:de,end:de+1},Pe):null}else return null}function o(U,z){for(let Z=z;Z<U.length;Z++)if(d(U.charCodeAt(Z))||Z>0&&d(U.charCodeAt(Z-1)))return Z;return U.length}const f=r(e.$lj,a,I),b=r(e.$lj,a,P),y=new D.$qi(1e4);function S(U,z,Z=!1){if(typeof U!="string"||typeof z!="string")return null;let de=y.get(U);de||(de=new RegExp(O.$vd(U),"i"),y.set(U,de));const Ee=de.exec(z);return Ee?[{start:Ee.index,end:Ee.index+Ee[0].length}]:Z?b(U,z):f(U,z)}e.$rj=S;function L(U,z){const Z=W(U,U.toLowerCase(),0,z,z.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Z?Q(Z):null}e.$sj=L;function j(U,z,Z,de,Ee,Pe){const Ae=Math.min(13,U.length);for(;Z<Ae;Z++){const Fe=W(U,z,Z,de,Ee,Pe,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Fe)return Fe}return[0,Pe]}e.$tj=j;function Q(U){if(typeof U>"u")return[];const z=[],Z=U[1];for(let de=U.length-1;de>1;de--){const Ee=U[de]+Z,Pe=z[z.length-1];Pe&&Pe.end===Ee?Pe.end=Ee+1:z.push({start:Ee,end:Ee+1})}return z}e.$uj=Q;const le=128;function Y(){const U=[],z=[];for(let Z=0;Z<=le;Z++)z[Z]=0;for(let Z=0;Z<=le;Z++)U.push(z.slice(0));return U}function ee(U){const z=[];for(let Z=0;Z<=U;Z++)z[Z]=0;return z}const ue=ee(2*le),X=ee(2*le),he=Y(),x=Y(),se=Y(),V=!1;function K(U,z,Z,de,Ee){function Pe(Fe,ge,ke=" "){for(;Fe.length<ge;)Fe=ke+Fe;return Fe}let Ae=` |   |${de.split("").map(Fe=>Pe(Fe,3)).join("|")}
`;for(let Fe=0;Fe<=Z;Fe++)Fe===0?Ae+=" |":Ae+=`${z[Fe-1]}|`,Ae+=U[Fe].slice(0,Ee+1).map(ge=>Pe(ge.toString(),3)).join("|")+`
`;return Ae}function H(U,z,Z,de){U=U.substr(z),Z=Z.substr(de),console.log(K(x,U,U.length,Z,Z.length)),console.log(K(se,U,U.length,Z,Z.length)),console.log(K(he,U,U.length,Z,Z.length))}function te(U,z){if(z<0||z>=U.length)return!1;const Z=U.codePointAt(z);switch(Z){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!O.$5d(Z)}}function me(U,z){if(z<0||z>=U.length)return!1;switch(U.charCodeAt(z)){case 32:case 9:return!0;default:return!1}}function ne(U,z,Z){return z[U]!==Z[U]}function q(U,z,Z,de,Ee,Pe,Ae=!1){for(;z<Z&&Ee<Pe;)U[z]===de[Ee]&&(Ae&&(ue[z]=Ee),z+=1),Ee+=1;return z===Z}e.$vj=q;var J;(function(U){U[U.Diag=1]="Diag",U[U.Left=2]="Left",U[U.LeftLeft=3]="LeftLeft"})(J||(J={}));var R;(function(U){U.Default=[-100,0];function z(Z){return!Z||Z.length===2&&Z[0]===-100&&Z[1]===0}U.isDefault=z})(R||(e.FuzzyScore=R={}));class F{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(z,Z){this.firstMatchCanBeWeak=z,this.boostFullMatch=Z}}e.$wj=F;function W(U,z,Z,de,Ee,Pe,Ae=F.default){const Fe=U.length>le?le:U.length,ge=de.length>le?le:de.length;if(Z>=Fe||Pe>=ge||Fe-Z>ge-Pe||!q(z,Z,Fe,Ee,Pe,ge,!0))return;ie(Fe,ge,Z,Pe,z,Ee);let ke=1,ye=1,Te=Z,ze=Pe;const _e=[!1];for(ke=1,Te=Z;Te<Fe;ke++,Te++){const De=ue[Te],Re=X[Te],Ne=Te+1<Fe?X[Te+1]:ge;for(ye=De-Pe+1,ze=De;ze<Ne;ye++,ze++){let Me=Number.MIN_SAFE_INTEGER,qe=!1;ze<=Re&&(Me=re(U,z,Te,Z,de,Ee,ze,ge,Pe,he[ke-1][ye-1]===0,_e));let Be=0;Me!==Number.MAX_SAFE_INTEGER&&(qe=!0,Be=Me+x[ke-1][ye-1]);const Ke=ze>De,He=Ke?x[ke][ye-1]+(he[ke][ye-1]>0?-5:0):0,Ye=ze>De+1&&he[ke][ye-1]>0,Je=Ye?x[ke][ye-2]+(he[ke][ye-2]>0?-5:0):0;if(Ye&&(!Ke||Je>=He)&&(!qe||Je>=Be))x[ke][ye]=Je,se[ke][ye]=3,he[ke][ye]=0;else if(Ke&&(!qe||He>=Be))x[ke][ye]=He,se[ke][ye]=2,he[ke][ye]=0;else if(qe)x[ke][ye]=Be,se[ke][ye]=1,he[ke][ye]=he[ke-1][ye-1]+1;else throw new Error("not possible")}}if(V&&H(U,Z,de,Pe),!_e[0]&&!Ae.firstMatchCanBeWeak)return;ke--,ye--;const Ve=[x[ke][ye],Pe];let Xe=0,Ze=0;for(;ke>=1;){let De=ye;do{const Re=se[ke][De];if(Re===3)De=De-2;else if(Re===2)De=De-1;else break}while(De>=1);Xe>1&&z[Z+ke-1]===Ee[Pe+ye-1]&&!ne(De+Pe-1,de,Ee)&&Xe+1>he[ke][De]&&(De=ye),De===ye?Xe++:Xe=1,Ze||(Ze=De),ke--,ye=De-1,Ve.push(ye)}ge===Fe&&Ae.boostFullMatch&&(Ve[0]+=2);const $e=Ze-Fe;return Ve[0]-=$e,Ve}e.$xj=W;function ie(U,z,Z,de,Ee,Pe){let Ae=U-1,Fe=z-1;for(;Ae>=Z&&Fe>=de;)Ee[Ae]===Pe[Fe]&&(X[Ae]=Fe,Ae--),Fe--}function re(U,z,Z,de,Ee,Pe,Ae,Fe,ge,ke,ye){if(z[Z]!==Pe[Ae])return Number.MIN_SAFE_INTEGER;let Te=1,ze=!1;return Ae===Z-de?Te=U[Z]===Ee[Ae]?7:5:ne(Ae,Ee,Pe)&&(Ae===0||!ne(Ae-1,Ee,Pe))?(Te=U[Z]===Ee[Ae]?7:5,ze=!0):te(Pe,Ae)&&(Ae===0||!te(Pe,Ae-1))?Te=5:(te(Pe,Ae-1)||me(Pe,Ae-1))&&(Te=5,ze=!0),Te>1&&Z===de&&(ye[0]=!0),ze||(ze=ne(Ae,Ee,Pe)||te(Pe,Ae-1)||me(Pe,Ae-1)),Z===de?Ae>ge&&(Te-=ze?3:5):ke?Te+=ze?2:0:Te+=ze?0:1,Ae+1===Fe&&(Te-=ze?3:5),Te}function _(U,z,Z,de,Ee,Pe,Ae){return N(U,z,Z,de,Ee,Pe,!0,Ae)}e.$yj=_;function oe(U,z,Z,de,Ee,Pe,Ae){return N(U,z,Z,de,Ee,Pe,!1,Ae)}e.$zj=oe;function N(U,z,Z,de,Ee,Pe,Ae,Fe){let ge=W(U,z,Z,de,Ee,Pe,Fe);if(ge&&!Ae)return ge;if(U.length>=3){const ke=Math.min(7,U.length-1);for(let ye=Z+1;ye<ke;ye++){const Te=B(U,ye);if(Te){const ze=W(Te,Te.toLowerCase(),Z,de,Ee,Pe,Fe);ze&&(ze[0]-=3,(!ge||ze[0]>ge[0])&&(ge=ze))}}}return ge}function B(U,z){if(z+1>=U.length)return;const Z=U[z],de=U[z+1];if(Z!==de)return U.slice(0,z)+de+Z+U.slice(z+2)}}),define(pe[59],be([1,0,17]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=void 0;function O(u){return r(u,0)}e.$di=O;function r(u,h){switch(typeof u){case"object":return u===null?C(349,h):Array.isArray(u)?w(u,h):$(u,h);case"string":return P(u,h);case"boolean":return I(u,h);case"number":return C(u,h);case"undefined":return C(937,h);default:return C(617,h)}}e.$ei=r;function C(u,h){return(h<<5)-h+u|0}e.$fi=C;function I(u,h){return C(u?433:863,h)}function P(u,h){h=C(149417,h);for(let g=0,E=u.length;g<E;g++)h=C(u.charCodeAt(g),h);return h}e.$gi=P;function w(u,h){return h=C(104579,h),u.reduce((g,E)=>r(E,g),h)}function $(u,h){return h=C(181387,h),Object.keys(u).sort().reduce((g,E)=>(g=P(E,g),r(u[E],g)),h)}class A{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=r(h,this.g),this.g}}e.$hi=A;var k;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function p(u,h,g=32){const E=g-h,v=~((1<<E)-1);return(u<<h|(v&u)>>>E)>>>0}function l(u,h=0,g=u.byteLength,E=0){for(let v=0;v<g;v++)u[h+v]=E}function d(u,h,g="0"){for(;u.length<h;)u=g+u;return u}function m(u,h=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(g=>g.toString(16).padStart(2,"0")).join(""):d((u>>>0).toString(16),h/4)}e.$ii=m;class c{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const g=h.length;if(g===0)return;const E=this.p;let v=this.r,t=this.u,s,a;for(t!==0?(s=t,a=-1,t=0):(s=h.charCodeAt(0),a=0);;){let i=s;if(D.$Pd(s))if(a+1<g){const n=h.charCodeAt(a+1);D.$Qd(n)?(a++,i=D.$Rd(s,n)):i=65533}else{t=s;break}else D.$Qd(s)&&(i=65533);if(v=this.w(E,v,i),a++,a<g)s=h.charCodeAt(a);else break}this.r=v,this.u=t}w(h,g,E){return E<128?h[g++]=E:E<2048?(h[g++]=192|(E&1984)>>>6,h[g++]=128|(E&63)>>>0):E<65536?(h[g++]=224|(E&61440)>>>12,h[g++]=128|(E&4032)>>>6,h[g++]=128|(E&63)>>>0):(h[g++]=240|(E&1835008)>>>18,h[g++]=128|(E&258048)>>>12,h[g++]=128|(E&4032)>>>6,h[g++]=128|(E&63)>>>0),g>=64&&(this.y(),g-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),g}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=c.g,g=this.q;for(let f=0;f<64;f+=4)h.setUint32(f,g.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)h.setUint32(f,p(h.getUint32(f-12,!1)^h.getUint32(f-32,!1)^h.getUint32(f-56,!1)^h.getUint32(f-64,!1),1),!1);let E=this.h,v=this.l,t=this.m,s=this.n,a=this.o,i,n,o;for(let f=0;f<80;f++)f<20?(i=v&t|~v&s,n=1518500249):f<40?(i=v^t^s,n=1859775393):f<60?(i=v&t|v&s|t&s,n=2400959708):(i=v^t^s,n=3395469782),o=p(E,5)+i+a+n+h.getUint32(f*4,!1)&4294967295,a=s,s=t,t=p(v,30),v=E,E=o;this.h=this.h+E&4294967295,this.l=this.l+v&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+a&4294967295}}e.$ji=c}),define(pe[60],be([1,0,17]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(r){r[r.Ignore=0]="Ignore",r[r.Info=1]="Info",r[r.Warning=2]="Warning",r[r.Error=3]="Error"})(O||(O={})),function(r){const C="error",I="warning",P="warn",w="info",$="ignore";function A(p){return p?D.$Ld(C,p)?r.Error:D.$Ld(I,p)||D.$Ld(P,p)?r.Warning:D.$Ld(w,p)?r.Info:r.Ignore:r.Ignore}r.fromValue=A;function k(p){switch(p){case r.Error:return C;case r.Warning:return I;case r.Info:return w;default:return $}}r.toString=k}(O||(O={})),e.default=O}),define(pe[147],be([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=void 0,e.$bc=Symbol("MicrotaskDelay")}),define(pe[61],be([1,0,18,17]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=e.$sh=e.$rh=void 0;class r{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const d=l.charCodeAt(0),m=this.b.charCodeAt(this.c);return d-m}value(){return this.b[this.c]}}e.$rh=r;class C{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,O.$Fd)(l,this.b,0,l.length,this.c,this.d):(0,O.$Hd)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$sh=C;class I{constructor(l=!0,d=!0){this.f=l,this.g=d}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let d=l.length-1;d>=0;d--,this.c--){const m=this.b.charCodeAt(d);if(!(m===47||this.f&&m===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,O.$Fd)(l,this.b,0,l.length,this.d,this.e):(0,O.$Hd)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$th=I;var P;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(P||(P={}));class w{constructor(l,d){this.f=l,this.g=d,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new I(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(3)),this.g(l)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===1)return(0,O.$Gd)(l,this.c.scheme);if(this.d[this.e]===2)return(0,O.$Gd)(l,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(l);if(this.d[this.e]===4)return(0,O.$Ed)(l,this.c.query);if(this.d[this.e]===5)return(0,O.$Ed)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$uh=w;class ${constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(A||(A={}));class k{static forUris(l=()=>!1,d=()=>!1){return new k(new w(l,d))}static forPaths(l=!1){return new k(new I(void 0,!l))}static forStrings(){return new k(new r)}static forConfigKeys(){return new k(new C)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,d){if(d){const m=d.slice(0);(0,D.$Bf)(m);for(const c of m)this.set(c,l)}else{const m=l.slice(0);(0,D.$Bf)(m);for(const c of m)this.set(c[0],c[1])}}set(l,d){const m=this.b.reset(l);let c;this.c||(this.c=new $,this.c.segment=m.value());const u=[];for(c=this.c;;){const g=m.cmp(c.segment);if(g>0)c.left||(c.left=new $,c.left.segment=m.value()),u.push([-1,c]),c=c.left;else if(g<0)c.right||(c.right=new $,c.right.segment=m.value()),u.push([1,c]),c=c.right;else if(m.hasNext())m.next(),c.mid||(c.mid=new $,c.mid.segment=m.value()),u.push([0,c]),c=c.mid;else break}const h=c.value;c.value=d,c.key=l;for(let g=u.length-1;g>=0;g--){const E=u[g][1];E.updateHeight();const v=E.balanceFactor();if(v<-1||v>1){const t=u[g][0],s=u[g+1][0];if(t===1&&s===1)u[g][1]=E.rotateLeft();else if(t===-1&&s===-1)u[g][1]=E.rotateRight();else if(t===1&&s===-1)E.right=u[g+1][1]=u[g+1][1].rotateRight(),u[g][1]=E.rotateLeft();else if(t===-1&&s===1)E.left=u[g+1][1]=u[g+1][1].rotateLeft(),u[g][1]=E.rotateRight();else throw new Error;if(g>0)switch(u[g-1][0]){case-1:u[g-1][1].left=u[g][1];break;case 1:u[g-1][1].right=u[g][1];break;case 0:u[g-1][1].mid=u[g][1];break}else this.c=u[0][1]}}return h}get(l){return this.d(l)?.value}d(l){const d=this.b.reset(l);let m=this.c;for(;m;){const c=d.cmp(m.segment);if(c>0)m=m.left;else if(c<0)m=m.right;else if(d.hasNext())d.next(),m=m.mid;else break}return m}has(l){const d=this.d(l);return!(d?.value===void 0&&d?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,d){const m=this.b.reset(l),c=[];let u=this.c;for(;u;){const h=m.cmp(u.segment);if(h>0)c.push([-1,u]),u=u.left;else if(h<0)c.push([1,u]),u=u.right;else if(m.hasNext())m.next(),c.push([0,u]),u=u.mid;else break}if(u){if(d?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const h=this.f(u.right);if(h.key){const{key:g,value:E,segment:v}=h;this.e(h.key,!1),u.key=g,u.value=E,u.segment=v}}else{const h=u.left??u.right;if(c.length>0){const[g,E]=c[c.length-1];switch(g){case-1:E.left=h;break;case 0:E.mid=h;break;case 1:E.right=h;break}}else this.c=h}for(let h=c.length-1;h>=0;h--){const g=c[h][1];g.updateHeight();const E=g.balanceFactor();if(E>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),c[h][1]=g.rotateLeft()):E<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),c[h][1]=g.rotateRight()),h>0)switch(c[h-1][0]){case-1:c[h-1][1].left=c[h][1];break;case 1:c[h-1][1].right=c[h][1];break;case 0:c[h-1][1].mid=c[h][1];break}else this.c=c[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const d=this.b.reset(l);let m=this.c,c;for(;m;){const u=d.cmp(m.segment);if(u>0)m=m.left;else if(u<0)m=m.right;else if(d.hasNext())d.next(),c=m.value||c,m=m.mid;else break}return m&&m.value||c}findSuperstr(l){return this.g(l,!1)}g(l,d){const m=this.b.reset(l);let c=this.c;for(;c;){const u=m.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(m.hasNext())m.next(),c=c.mid;else return c.mid?this.h(c.mid):d?c.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[d,m]of this)l(m,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const d=[];return this.j(l,d),d[Symbol.iterator]()}j(l,d){l&&(l.left&&this.j(l.left,d),l.value&&d.push([l.key,l.value]),l.mid&&this.j(l.mid,d),l.right&&this.j(l.right,d))}_isBalanced(){const l=d=>{if(!d)return!0;const m=d.balanceFactor();return m<-1||m>1?!1:l(d.left)&&l(d.right)};return l(this.c)}}e.$vh=k}),define(pe[10],be([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=void 0;function D(v){return typeof v=="string"}e.$ie=D;function O(v){return Array.isArray(v)&&v.every(t=>D(t))}e.$je=O;function r(v){return typeof v=="object"&&v!==null&&!Array.isArray(v)&&!(v instanceof RegExp)&&!(v instanceof Date)}e.$ke=r;function C(v){const t=Object.getPrototypeOf(Uint8Array);return typeof v=="object"&&v instanceof t}e.$le=C;function I(v){return typeof v=="number"&&!isNaN(v)}e.$me=I;function P(v){return!!v&&typeof v[Symbol.iterator]=="function"}e.$ne=P;function w(v){return v===!0||v===!1}e.$oe=w;function $(v){return typeof v>"u"}e.$pe=$;function A(v){return!k(v)}e.$qe=A;function k(v){return $(v)||v===null}e.$re=k;function p(v,t){if(!v)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$se=p;function l(v){if(k(v))throw new Error("Assertion Failed: argument is undefined or null");return v}e.$te=l;function d(...v){const t=[];for(let s=0;s<v.length;s++){const a=v[s];if(k(a))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);t.push(a)}return t}e.$ue=d;const m=Object.prototype.hasOwnProperty;function c(v){if(!r(v))return!1;for(const t in v)if(m.call(v,t))return!1;return!0}e.$ve=c;function u(v){return typeof v=="function"}e.$we=u;function h(...v){return v.length>0&&v.every(u)}e.$xe=h;function g(v,t){const s=Math.min(v.length,t.length);for(let a=0;a<s;a++)E(v[a],t[a])}e.$ye=g;function E(v,t){if(D(t)){if(typeof v!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(u(t)){try{if(v instanceof t)return}catch{}if(!k(v)&&v.constructor===t||t.length===1&&t.call(void 0,v)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$ze=E}),define(pe[49],be([1,0,10]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Bj=e.$Aj=void 0;const O=Object.create(null);function r(P,w){if((0,D.$ie)(w)){const $=O[w];if($===void 0)throw new Error(`${P} references an unknown codicon: ${w}`);w=$}return O[P]=w,{id:P}}function C(){return O}e.$Aj=C;function I(){return Object.values(e.$Cj)}e.$Bj=I,e.$Cj={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package_:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),define(pe[22],be([1,0,10]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=void 0;function O(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const h=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([g,E])=>{h[g]=E&&typeof E=="object"?O(E):E}),h}e.$Im=O;function r(u){if(!u||typeof u!="object")return u;const h=[u];for(;h.length>0;){const g=h.shift();Object.freeze(g);for(const E in g)if(C.call(g,E)){const v=g[E];typeof v=="object"&&!Object.isFrozen(v)&&!(0,D.$le)(v)&&h.push(v)}}return u}e.$Jm=r;const C=Object.prototype.hasOwnProperty;function I(u,h){return P(u,h,new Set)}e.$Km=I;function P(u,h,g){if((0,D.$re)(u))return u;const E=h(u);if(typeof E<"u")return E;if(Array.isArray(u)){const v=[];for(const t of u)v.push(P(t,h,g));return v}if((0,D.$ke)(u)){if(g.has(u))throw new Error("Cannot clone recursive data-structure");g.add(u);const v={};for(const t in u)C.call(u,t)&&(v[t]=P(u[t],h,g));return g.delete(u),v}return u}function w(u,h,g=!0){return(0,D.$ke)(u)?((0,D.$ke)(h)&&Object.keys(h).forEach(E=>{E in u?g&&((0,D.$ke)(u[E])&&(0,D.$ke)(h[E])?w(u[E],h[E],g):u[E]=h[E]):u[E]=h[E]}),u):h}e.$Lm=w;function $(u,h){if(u===h)return!0;if(u==null||h===null||h===void 0||typeof u!=typeof h||typeof u!="object"||Array.isArray(u)!==Array.isArray(h))return!1;let g,E;if(Array.isArray(u)){if(u.length!==h.length)return!1;for(g=0;g<u.length;g++)if(!$(u[g],h[g]))return!1}else{const v=[];for(E in u)v.push(E);v.sort();const t=[];for(E in h)t.push(E);if(t.sort(),!$(v,t))return!1;for(g=0;g<v.length;g++)if(!$(u[v[g]],h[v[g]]))return!1}return!0}e.$Mm=$;function A(u){const h=new Set;return JSON.stringify(u,(g,E)=>{if((0,D.$ke)(E)||Array.isArray(E)){if(h.has(E))return"[Circular]";h.add(E)}return E})}e.$Nm=A;function k(u,h){const g=Object.create(null);return!u||!h||Object.keys(h).forEach(v=>{const t=u[v],s=h[v];$(t,s)||(g[v]=s)}),g}e.$Om=k;function p(u,h){const g=h.toLowerCase(),E=Object.keys(u).find(v=>v.toLowerCase()===g);return E?u[E]:u[h]}e.$Pm=p;function l(u,h){const g=Object.create(null);for(const[E,v]of Object.entries(u))h(E,v)&&(g[E]=v);return g}e.$Qm=l;function d(u){let h=[];for(;Object.prototype!==u;)h=h.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return h}e.$Rm=d;function m(u){const h=[];for(const g of d(u))typeof u[g]=="function"&&h.push(g);return h}e.$Sm=m;function c(u,h){const g=v=>function(){const t=Array.prototype.slice.call(arguments,0);return h(v,t)},E={};for(const v of u)E[v]=g(v);return E}e.$Tm=c}),define(pe[99],be([1,0,49]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Dj=e.ThemeColor=void 0;var O;(function(I){function P(w){return w&&typeof w=="object"&&typeof w.id=="string"}I.isThemeColor=P})(O||(e.ThemeColor=O={}));function r(I){return{id:I}}e.$Dj=r;var C;(function(I){I.iconNameSegment="[A-Za-z0-9]+",I.iconNameExpression="[A-Za-z0-9-]+",I.iconModifierExpression="~[A-Za-z]+",I.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${I.iconNameExpression})(${I.iconModifierExpression})?$`);function w(h){const g=P.exec(h.id);if(!g)return w(D.$Cj.error);const[,E,v]=g,t=["codicon","codicon-"+E];return v&&t.push("codicon-modifier-"+v.substring(1)),t}I.asClassNameArray=w;function $(h){return w(h).join(" ")}I.asClassName=$;function A(h){return"."+w(h).join(".")}I.asCSSSelector=A;function k(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||O.isThemeColor(h.color))}I.isThemeIcon=k;const p=new RegExp(`^\\$\\((${I.iconNameExpression}(?:${I.iconModifierExpression})?)\\)$`);function l(h){const g=p.exec(h);if(!g)return;const[,E]=g;return{id:E}}I.fromString=l;function d(h){return{id:h}}I.fromId=d;function m(h,g){let E=h.id;const v=E.lastIndexOf("~");return v!==-1&&(E=E.substring(0,v)),g&&(E=`${E}~${g}`),{id:E}}I.modify=m;function c(h){const g=h.id.lastIndexOf("~");if(g!==-1)return h.id.substring(g+1)}I.getModifier=c;function u(h,g){return h.id===g.id&&h.color?.id===g.color?.id}I.isEqual=u})(C||(e.ThemeIcon=C={}))}),define(pe[148],be([1,0,146,17,99]),function(ce,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=void 0;const C="$(",I=new RegExp(`\\$\\(${r.ThemeIcon.iconNameExpression}(?:${r.ThemeIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(`(\\\\)?${I.source}`,"g");function w(u){return u.replace(P,(h,g)=>g?h:`\\${h}`)}e.$Ej=w;const $=new RegExp(`\\\\${I.source}`,"g");function A(u){return u.replace($,h=>`\\${h}`)}e.$Fj=A;const k=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function p(u){return u.indexOf(C)===-1?u:u.replace(k,(h,g,E,v)=>E?h:g||v||"")}e.$Gj=p;function l(u){return u?u.replace(/\$\((.*?)\)/g,(h,g)=>` ${g} `).trim():""}e.$Hj=l;const d=new RegExp(`\\$\\(${r.ThemeIcon.iconNameCharacter}+\\)`,"g");function m(u){d.lastIndex=0;let h="";const g=[];let E=0;for(;;){const v=d.lastIndex,t=d.exec(u),s=u.substring(v,t?.index);if(s.length>0){h+=s;for(let a=0;a<s.length;a++)g.push(E)}if(!t)break;E+=t[0].length}return{text:h,iconOffsets:g}}e.$Ij=m;function c(u,h,g=!1){const{text:E,iconOffsets:v}=h;if(!v||v.length===0)return(0,D.$rj)(u,E,g);const t=(0,O.$td)(E," "),s=E.length-t.length,a=(0,D.$rj)(u,t,g);if(a)for(const i of a){const n=v[i.start+s]+s;i.start+=n,i.end+=n}return a}e.$Jj=c}),define(pe[23],be([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3e=e.$2e=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(r){return D.test(r)}e.$2e=O,e.$3e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let r;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?r=crypto.getRandomValues.bind(crypto):r=function(P){for(let w=0;w<P.length;w++)P[w]=Math.floor(Math.random()*256);return P};const C=new Uint8Array(16),I=[];for(let P=0;P<256;P++)I.push(P.toString(16).padStart(2,"0"));return function(){r(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let w=0,$="";return $+=I[C[w++]],$+=I[C[w++]],$+=I[C[w++]],$+=I[C[w++]],$+="-",$+=I[C[w++]],$+=I[C[w++]],$+="-",$+=I[C[w++]],$+=I[C[w++]],$+="-",$+=I[C[w++]],$+=I[C[w++]],$+="-",$+=I[C[w++]],$+=I[C[w++]],$+=I[C[w++]],$+=I[C[w++]],$+=I[C[w++]],$+=I[C[w++]],$}}()}),define(pe[149],be([1,0,18,47,23]),function(ce,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=e.$hs=e.$gs=e.$fs=e.$es=void 0;function C(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$es=C;function I(k,p,l){const d={id:(0,r.$3e)(),name:k,uri:p,data:l};return{asString:async()=>"",asFile:()=>d,value:void 0}}e.$fs=I;class P{constructor(){this.a=new Map}get size(){let p=0;for(const l of this.a)p++;return p}has(p){return this.a.has(this.b(p))}matches(p){const l=[...this.a.keys()];return O.Iterable.some(this,([d,m])=>m.asFile())&&l.push("files"),A(w(p),l)}get(p){return this.a.get(this.b(p))?.[0]}append(p,l){const d=this.a.get(p);d?d.push(l):this.a.set(this.b(p),[l])}replace(p,l){this.a.set(this.b(p),[l])}delete(p){this.a.delete(this.b(p))}*[Symbol.iterator](){for(const[p,l]of this.a)for(const d of l)yield[p,d]}b(p){return w(p)}}e.$gs=P;function w(k){return k.toLowerCase()}function $(k,p){return A(w(k),p.map(w))}e.$hs=$;function A(k,p){if(k==="*/*")return p.length>0;if(p.includes(k))return!0;const l=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!l)return!1;const[d,m,c]=l;return c==="*"?p.some(u=>u.startsWith(m+"/")):!1}e.$is=Object.freeze({create:k=>(0,D.$of)(k.map(p=>p.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$is.split(k).filter(p=>!p.startsWith("#"))})}),function(){"use strict";function ce(e,D,O){function r(l){return new Promise(d=>D.exists(l,d))}function C(l){return new Promise((d,m)=>{const c=new Date;D.utimes(l,c,c,u=>u?m(u):d())})}function I(l){return new Promise((d,m)=>D.mkdir(l,{recursive:!0},c=>c&&c.code!=="EEXIST"?m(c):d(l)))}function P(l){return new Promise((d,m)=>D.rm(l,{recursive:!0,force:!0,maxRetries:3},c=>c?m(c):d()))}function w(l){return new Promise((d,m)=>D.readFile(l,"utf8",(c,u)=>c?m(c):d(u)))}function $(l,d){return new Promise((m,c)=>D.writeFile(l,d,"utf8",u=>u?c(u):m()))}async function A(l){const d=e.join(l,"languagepacks.json");try{return JSON.parse(await w(d))}catch{}}function k(l,d){try{for(;d;){if(l[d])return d;{const m=d.lastIndexOf("-");if(m>0)d=d.substring(0,m);else return}}}catch(m){console.error("Resolving language pack configuration failed.",m)}}function p(l,d,m,c,u){const h=function(E){return O.mark("code/didGenerateNls"),Promise.resolve({locale:E,osLocale:u,availableLanguages:{}})};if(O.mark("code/willGenerateNls"),c==="pseudo")return Promise.resolve({locale:c,osLocale:u,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:c,osLocale:u,availableLanguages:{}});if(c&&(c==="en"||c==="en-us"))return Promise.resolve({locale:c,osLocale:u,availableLanguages:{}});const g=c;try{return l?A(d).then(E=>{if(!E)return h(g);const v=k(E,c);if(!v)return h(g);c=v;const t=E[c];let s;return!t||typeof t.hash!="string"||!t.translations||typeof(s=t.translations.vscode)!="string"?h(g):r(s).then(a=>{if(!a)return h(g);const i=t.hash+"."+c,n=e.join(d,"clp",i),o=e.join(n,l),f=e.join(n,"tcf.json"),b=e.join(n,"corrupted.info"),y={locale:g,osLocale:u,availableLanguages:{"*":c},_languagePackId:i,_translationsConfigFile:f,_cacheRoot:n,_resolvedLanguagePackCoreLocation:o,_corruptedFile:b};return r(b).then(S=>{let L;return S?L=P(n):L=Promise.resolve(void 0),L.then(()=>r(o).then(j=>j?(C(o).catch(()=>{}),O.mark("code/didGenerateNls"),y):I(o).then(()=>Promise.all([w(m),w(s)])).then(Q=>{const le=JSON.parse(Q[0]),Y=JSON.parse(Q[1]).contents,ee=Object.keys(le.bundles),ue=[];for(const X of ee){const he=le.bundles[X],x=Object.create(null);for(const se of he){const V=le.keys[se],K=le.messages[se],H=Y[se];let te;if(H){te=[];for(let me=0;me<V.length;me++){const ne=V[me],q=typeof ne=="string"?ne:ne.key;let J=H[q];J===void 0&&(J=K[me]),te.push(J)}}else te=K;x[se]=te}ue.push($(e.join(o,X.replace(/\//g,"!")+".nls.json"),JSON.stringify(x)))}return ue.push($(f,JSON.stringify(t.translations))),Promise.all(ue)}).then(()=>(O.mark("code/didGenerateNls"),y)).catch(Q=>(console.error("Generating translation files failed.",Q),h(c)))))})})}):h(g)}catch(E){return console.error("Generating translation files failed.",E),h(c)}}return{getNLSConfiguration:p}}if(typeof define=="function")define(pe[150],be([76,28,41]),function(e,D,O){return ce(e,D,O)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("fs"),O=require("../common/performance");module.exports=ce(e,D,O)}else throw new Error("Unknown context")}(),define(pe[151],be([1,0,29]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function r(I){const P=I.replace(/\-/g,":").toLowerCase();return!O.has(P)}function C(){const I=(0,D.networkInterfaces)();for(const P in I){const w=I[P];if(w){for(const{mac:$}of w)if(r($))return $}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$tm=C}),define(pe[100],be([1,0,29,61,23,151]),function(ce,e,D,O,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=e.$um=void 0,e.$um=new class{c($){return this.a||(this.a=O.$vh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr($)}value(){if(this.b===void 0){let $=0,A=0;const k=(0,D.networkInterfaces)();for(const p in k){const l=k[p];if(l)for(const{mac:d,internal:m}of l)m||(A+=1,this.c(d.toUpperCase())&&($+=1))}this.b=A>0?$/A:0}return this.b}};let I;async function P($){return I||(I=(async()=>await w($)||r.$3e())()),I}e.$vm=P;async function w($){try{const A=await new Promise((p,l)=>{ce(["crypto"],p,l)}),k=(0,C.$tm)();return A.createHash("sha256").update(k,"utf8").digest("hex")}catch(A){$(A);return}}}),define(pe[152],be([1,0,77]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7e=e.$6e=e.$5e=void 0;function O(P,w,$,A=1){let k=!1;return new Promise(p=>{const l=setTimeout(()=>{if(!k)return k=!0,p(0)},$);r(P,w,A,d=>{if(!k)return k=!0,clearTimeout(l),p(d)})})}e.$5e=O;function r(P,w,$,A){if(w===0)return A(0);const k=new D.Socket;k.once("connect",()=>(I(k),r(P+$,w-1,$,A))),k.once("data",()=>{}),k.once("error",p=>(I(k),p.code!=="ECONNREFUSED"?r(P+$,w-1,$,A):A(P))),k.connect(P,"127.0.0.1")}e.$6e={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function C(P,w,$,A="127.0.0.1"){let k=!1,p,l=1;const d=D.createServer({pauseOnConnect:!0});function m(c,u){k||(k=!0,d.removeAllListeners(),d.close(),p&&clearTimeout(p),u(c))}return new Promise(c=>{p=setTimeout(()=>{m(0,c)},$),d.on("listening",()=>{m(P,c)}),d.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&l<w?(P++,l++,d.listen(P,A)):m(0,c)}),d.on("close",()=>{m(0,c)}),d.listen(P,A)})}e.$7e=C;function I(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(w){console.error(w)}}}),function(){function ce(){function e(){return process.uncHostAllowlist}function D(w){const $=new Set;if(Array.isArray(w))for(const A of w)typeof A=="string"&&$.add(A);return Array.from($)}function O(){const w=e();return w?Array.from(w):[]}function r(w){if(process.platform!=="win32")return;const $=e();if($)if(typeof w=="string")$.add(w.toLowerCase());else for(const A of D(w))r(A)}function C(w){if(typeof w!="string")return;const $=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let A;for(const k of $){if(w.indexOf(k)!==0)continue;const l=w.indexOf("\\",k.length);if(l===-1)continue;const d=w.substring(k.length,l);if(d){A=d;break}}return A}function I(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function P(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:O,addUNCHostToAllowlist:r,getUNCHost:C,disableUNCAccessRestrictions:I,isUNCAccessRestrictionsDisabled:P}}typeof define=="function"?define("vs/base/node/unc",[],function(){return ce()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=ce():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(pe[101],be([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=void 0;class D{constructor(r,C){this.lineNumber=r,this.column=C}with(r=this.lineNumber,C=this.column){return r===this.lineNumber&&C===this.column?this:new D(r,C)}delta(r=0,C=0){return this.with(this.lineNumber+r,this.column+C)}equals(r){return D.equals(this,r)}static equals(r,C){return!r&&!C?!0:!!r&&!!C&&r.lineNumber===C.lineNumber&&r.column===C.column}isBefore(r){return D.isBefore(this,r)}static isBefore(r,C){return r.lineNumber<C.lineNumber?!0:C.lineNumber<r.lineNumber?!1:r.column<C.column}isBeforeOrEqual(r){return D.isBeforeOrEqual(this,r)}static isBeforeOrEqual(r,C){return r.lineNumber<C.lineNumber?!0:C.lineNumber<r.lineNumber?!1:r.column<=C.column}static compare(r,C){const I=r.lineNumber|0,P=C.lineNumber|0;if(I===P){const w=r.column|0,$=C.column|0;return w-$}return I-P}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(r){return new D(r.lineNumber,r.column)}static isIPosition(r){return r&&typeof r.lineNumber=="number"&&typeof r.column=="number"}}e.$Tr=D}),define(pe[42],be([1,0,101]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=void 0;class O{constructor(C,I,P,w){C>P||C===P&&I>w?(this.startLineNumber=P,this.startColumn=w,this.endLineNumber=C,this.endColumn=I):(this.startLineNumber=C,this.startColumn=I,this.endLineNumber=P,this.endColumn=w)}isEmpty(){return O.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return O.containsPosition(this,C)}static containsPosition(C,I){return!(I.lineNumber<C.startLineNumber||I.lineNumber>C.endLineNumber||I.lineNumber===C.startLineNumber&&I.column<C.startColumn||I.lineNumber===C.endLineNumber&&I.column>C.endColumn)}static strictContainsPosition(C,I){return!(I.lineNumber<C.startLineNumber||I.lineNumber>C.endLineNumber||I.lineNumber===C.startLineNumber&&I.column<=C.startColumn||I.lineNumber===C.endLineNumber&&I.column>=C.endColumn)}containsRange(C){return O.containsRange(this,C)}static containsRange(C,I){return!(I.startLineNumber<C.startLineNumber||I.endLineNumber<C.startLineNumber||I.startLineNumber>C.endLineNumber||I.endLineNumber>C.endLineNumber||I.startLineNumber===C.startLineNumber&&I.startColumn<C.startColumn||I.endLineNumber===C.endLineNumber&&I.endColumn>C.endColumn)}strictContainsRange(C){return O.strictContainsRange(this,C)}static strictContainsRange(C,I){return!(I.startLineNumber<C.startLineNumber||I.endLineNumber<C.startLineNumber||I.startLineNumber>C.endLineNumber||I.endLineNumber>C.endLineNumber||I.startLineNumber===C.startLineNumber&&I.startColumn<=C.startColumn||I.endLineNumber===C.endLineNumber&&I.endColumn>=C.endColumn)}plusRange(C){return O.plusRange(this,C)}static plusRange(C,I){let P,w,$,A;return I.startLineNumber<C.startLineNumber?(P=I.startLineNumber,w=I.startColumn):I.startLineNumber===C.startLineNumber?(P=I.startLineNumber,w=Math.min(I.startColumn,C.startColumn)):(P=C.startLineNumber,w=C.startColumn),I.endLineNumber>C.endLineNumber?($=I.endLineNumber,A=I.endColumn):I.endLineNumber===C.endLineNumber?($=I.endLineNumber,A=Math.max(I.endColumn,C.endColumn)):($=C.endLineNumber,A=C.endColumn),new O(P,w,$,A)}intersectRanges(C){return O.intersectRanges(this,C)}static intersectRanges(C,I){let P=C.startLineNumber,w=C.startColumn,$=C.endLineNumber,A=C.endColumn;const k=I.startLineNumber,p=I.startColumn,l=I.endLineNumber,d=I.endColumn;return P<k?(P=k,w=p):P===k&&(w=Math.max(w,p)),$>l?($=l,A=d):$===l&&(A=Math.min(A,d)),P>$||P===$&&w>A?null:new O(P,w,$,A)}equalsRange(C){return O.equalsRange(this,C)}static equalsRange(C,I){return!C&&!I?!0:!!C&&!!I&&C.startLineNumber===I.startLineNumber&&C.startColumn===I.startColumn&&C.endLineNumber===I.endLineNumber&&C.endColumn===I.endColumn}getEndPosition(){return O.getEndPosition(this)}static getEndPosition(C){return new D.$Tr(C.endLineNumber,C.endColumn)}getStartPosition(){return O.getStartPosition(this)}static getStartPosition(C){return new D.$Tr(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,I){return new O(this.startLineNumber,this.startColumn,C,I)}setStartPosition(C,I){return new O(C,I,this.endLineNumber,this.endColumn)}collapseToStart(){return O.collapseToStart(this)}static collapseToStart(C){return new O(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}collapseToEnd(){return O.collapseToEnd(this)}static collapseToEnd(C){return new O(C.endLineNumber,C.endColumn,C.endLineNumber,C.endColumn)}delta(C){return new O(this.startLineNumber+C,this.startColumn,this.endLineNumber+C,this.endColumn)}static fromPositions(C,I=C){return new O(C.lineNumber,C.column,I.lineNumber,I.column)}static lift(C){return C?new O(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,I){return!(C.endLineNumber<I.startLineNumber||C.endLineNumber===I.startLineNumber&&C.endColumn<I.startColumn||I.endLineNumber<C.startLineNumber||I.endLineNumber===C.startLineNumber&&I.endColumn<C.startColumn)}static areIntersecting(C,I){return!(C.endLineNumber<I.startLineNumber||C.endLineNumber===I.startLineNumber&&C.endColumn<=I.startColumn||I.endLineNumber<C.startLineNumber||I.endLineNumber===C.startLineNumber&&I.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,I){if(C&&I){const $=C.startLineNumber|0,A=I.startLineNumber|0;if($===A){const k=C.startColumn|0,p=I.startColumn|0;if(k===p){const l=C.endLineNumber|0,d=I.endLineNumber|0;if(l===d){const m=C.endColumn|0,c=I.endColumn|0;return m-c}return l-d}return k-p}return $-A}return(C?1:0)-(I?1:0)}static compareRangesUsingEnds(C,I){return C.endLineNumber===I.endLineNumber?C.endColumn===I.endColumn?C.startLineNumber===I.startLineNumber?C.startColumn-I.startColumn:C.startLineNumber-I.startLineNumber:C.endColumn-I.endColumn:C.endLineNumber-I.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}toJSON(){return this}}e.$Ur=O}),define(pe[153],be([1,0,42]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=void 0;class O{static insert(C,I){return{range:new D.$Ur(C.lineNumber,C.column,C.lineNumber,C.column),text:I,forceMoveMarkers:!0}}static delete(C){return{range:C,text:null}}static replace(C,I){return{range:C,text:I}}static replaceMove(C,I){return{range:C,text:I,forceMoveMarkers:!0}}}e.$2r=O}),define(pe[154],be([1,0,5,2]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=void 0;class r{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$ec,this.onDidChange=this.c.event,this.d=null}handleChange(P){this.c.fire({changedLanguages:P,changedColorMap:!1})}register(P,w){return this.a.set(P,w),this.handleChange([P]),(0,O.$jb)(()=>{this.a.get(P)===w&&(this.a.delete(P),this.handleChange([P]))})}get(P){return this.a.get(P)||null}registerFactory(P,w){this.b.get(P)?.dispose();const $=new C(this,P,w);return this.b.set(P,$),(0,O.$jb)(()=>{const A=this.b.get(P);!A||A!==$||(this.b.delete(P),A.dispose())})}async getOrCreate(P){const w=this.get(P);if(w)return w;const $=this.b.get(P);return!$||$.isResolved?null:(await $.resolve(),this.get(P))}isResolved(P){if(this.get(P))return!0;const $=this.b.get(P);return!!(!$||$.isResolved)}setColorMap(P){this.d=P,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$ks=r;class C extends O.$lb{get isResolved(){return this.c}constructor(P,w,$){super(),this.f=P,this.g=w,this.h=$,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const P=await this.h.tokenizationSupport;this.c=!0,P&&!this.a&&this.B(this.f.register(this.g,P))}}}),define(pe[155],be([8,9]),function(ce,e){return ce.create("vs/base/common/actions",e)}),define(pe[156],be([1,0,5,2,155]),function(ce,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=void 0;class C extends O.$lb{constructor(p,l="",d="",m=!0,c){super(),this.h=this.B(new D.$ec),this.onDidChange=this.h.event,this.w=!0,this.j=p,this.m=l,this.u=d,this.w=m,this.C=c}get id(){return this.j}get label(){return this.m}set label(p){this.D(p)}D(p){this.m!==p&&(this.m=p,this.h.fire({label:p}))}get tooltip(){return this.n||""}set tooltip(p){this.F(p)}F(p){this.n!==p&&(this.n=p,this.h.fire({tooltip:p}))}get class(){return this.u}set class(p){this.G(p)}G(p){this.u!==p&&(this.u=p,this.h.fire({class:p}))}get enabled(){return this.w}set enabled(p){this.H(p)}H(p){this.w!==p&&(this.w=p,this.h.fire({enabled:p}))}get checked(){return this.z}set checked(p){this.I(p)}I(p){this.z!==p&&(this.z=p,this.h.fire({checked:p}))}async run(p,l){this.C&&await this.C(p)}}e.$7h=C;class I extends O.$lb{constructor(){super(...arguments),this.f=this.B(new D.$ec),this.onWillRun=this.f.event,this.k=this.B(new D.$ec),this.onDidRun=this.k.event}async run(p,l){if(!p.enabled)return;this.f.fire({action:p});let d;try{await this.l(p,l)}catch(m){d=m}this.k.fire({action:p,error:d})}async l(p,l){await p.run(l)}}e.$8h=I;class P{constructor(){this.id=P.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let l=[];for(const d of p)d.length&&(l.length?l=[...l,new P,...d]:l=d);return l}static{this.ID="vs.actions.separator"}async run(){}}e.$9h=P;class w{get actions(){return this.a}constructor(p,l,d,m){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=l,this.class=m,this.a=d}async run(){}}e.$0h=w;class $ extends C{static{this.ID="vs.actions.empty"}constructor(){super($.ID,r.localize(0,null),void 0,!1)}}e.$$h=$;function A(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async()=>k.run(),tooltip:k.label}}e.$_h=A}),define(pe[157],be([8,9]),function(ce,e){return ce.create("vs/base/common/date",e)}),define(pe[158],be([1,0,157]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=void 0;const O=60,r=O*60,C=r*24,I=C*7,P=C*30,w=C*365;function $(k,p,l,d){typeof k!="number"&&(k=k.getTime());const m=Math.round((new Date().getTime()-k)/1e3);if(m<-30)return(0,D.localize)(0,null,$(new Date().getTime()+m*1e3,!1));if(!d&&m<30)return(0,D.localize)(1,null);let c;return m<O?(c=m,p?c===1?l?(0,D.localize)(2,null,c):(0,D.localize)(3,null,c):l?(0,D.localize)(4,null,c):(0,D.localize)(5,null,c):c===1?l?(0,D.localize)(6,null,c):(0,D.localize)(7,null,c):l?(0,D.localize)(8,null,c):(0,D.localize)(9,null,c)):m<r?(c=Math.floor(m/O),p?c===1?l?(0,D.localize)(10,null,c):(0,D.localize)(11,null,c):l?(0,D.localize)(12,null,c):(0,D.localize)(13,null,c):c===1?l?(0,D.localize)(14,null,c):(0,D.localize)(15,null,c):l?(0,D.localize)(16,null,c):(0,D.localize)(17,null,c)):m<C?(c=Math.floor(m/r),p?c===1?l?(0,D.localize)(18,null,c):(0,D.localize)(19,null,c):l?(0,D.localize)(20,null,c):(0,D.localize)(21,null,c):c===1?l?(0,D.localize)(22,null,c):(0,D.localize)(23,null,c):l?(0,D.localize)(24,null,c):(0,D.localize)(25,null,c)):m<I?(c=Math.floor(m/C),p?c===1?(0,D.localize)(26,null,c):(0,D.localize)(27,null,c):c===1?(0,D.localize)(28,null,c):(0,D.localize)(29,null,c)):m<P?(c=Math.floor(m/I),p?c===1?l?(0,D.localize)(30,null,c):(0,D.localize)(31,null,c):l?(0,D.localize)(32,null,c):(0,D.localize)(33,null,c):c===1?l?(0,D.localize)(34,null,c):(0,D.localize)(35,null,c):l?(0,D.localize)(36,null,c):(0,D.localize)(37,null,c)):m<w?(c=Math.floor(m/P),p?c===1?l?(0,D.localize)(38,null,c):(0,D.localize)(39,null,c):l?(0,D.localize)(40,null,c):(0,D.localize)(41,null,c):c===1?l?(0,D.localize)(42,null,c):(0,D.localize)(43,null,c):l?(0,D.localize)(44,null,c):(0,D.localize)(45,null,c)):(c=Math.floor(m/w),p?c===1?l?(0,D.localize)(46,null,c):(0,D.localize)(47,null,c):l?(0,D.localize)(48,null,c):(0,D.localize)(49,null,c):c===1?l?(0,D.localize)(50,null,c):(0,D.localize)(51,null,c):l?(0,D.localize)(52,null,c):(0,D.localize)(53,null,c))}e.$Sl=$;function A(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Tl=A}),define(pe[159],be([8,9]),function(ce,e){return ce.create("vs/base/common/errorMessage",e)}),define(pe[38],be([1,0,18,10,159]),function(ce,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$bi=e.$ai=void 0;function C(k,p){return p&&(k.stack||k.stacktrace)?r.localize(0,null,P(k),I(k.stack)||I(k.stacktrace)):P(k)}function I(k){return Array.isArray(k)?k.join(`
`):k}function P(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?r.localize(1,null,k.message):k.message||r.localize(2,null)}function w(k=null,p=!1){if(!k)return r.localize(3,null);if(Array.isArray(k)){const l=D.$jf(k),d=w(l[0],p);return l.length>1?r.localize(4,null,d,l.length):d}if(O.$ie(k))return k;if(k.detail){const l=k.detail;if(l.error)return C(l.error,p);if(l.exception)return C(l.exception,p)}return k.stack?C(k,p):k.message?k.message:r.localize(5,null)}e.$ai=w;function $(k){const p=k;return p instanceof Error&&Array.isArray(p.actions)}e.$bi=$;function A(k,p){let l;return typeof k=="string"?l=new Error(k):l=k,l.actions=p,l}e.$ci=A}),define(pe[160],be([8,9]),function(ce,e){return ce.create("vs/base/common/jsonErrorMessages",e)}),define(pe[161],be([1,0,160]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=void 0;function O(r){switch(r){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.$dp=O}),define(pe[162],be([8,9]),function(ce,e){return ce.create("vs/base/common/platform",e)}),define(pe[3],be([1,0,162]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let O=!1,r=!1,C=!1,I=!1,P=!1,w=!1,$=!1,A=!1,k=!1,p=!1,l,d=e.$f,m=e.$f,c,u;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?h=e.$g.vscode.process:typeof process<"u"&&(h=process);const g=typeof h?.versions?.electron=="string",E=g&&h?.type==="renderer";if(typeof navigator=="object"&&!E)u=navigator.userAgent,O=u.indexOf("Windows")>=0,r=u.indexOf("Macintosh")>=0,A=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=u.indexOf("Linux")>=0,p=u?.indexOf("Mobi")>=0,w=!0,l=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$f,d=l,m=navigator.language;else if(typeof h=="object"){O=h.platform==="win32",r=h.platform==="darwin",C=h.platform==="linux",I=C&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,$=g,k=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=e.$f,d=e.$f;const b=h.env.VSCODE_NLS_CONFIG;if(b)try{const y=JSON.parse(b),S=y.availableLanguages["*"];l=y.locale,m=y.osLocale,d=S||e.$f,c=y._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var v;(function(b){b[b.Web=0]="Web",b[b.Mac=1]="Mac",b[b.Linux=2]="Linux",b[b.Windows=3]="Windows"})(v||(e.Platform=v={}));function t(b){switch(b){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let s=0;r?s=1:O?s=3:C&&(s=2),e.$i=O,e.$j=r,e.$k=C,e.$l=I,e.$m=P,e.$n=$,e.$o=w,e.$p=w&&typeof e.$g.importScripts=="function",e.$q=A,e.$r=p,e.$s=k,e.$t=s,e.$u=u,e.$v=d;var a;(function(b){function y(){return e.$v}b.value=y;function S(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}b.isDefaultVariant=S;function L(){return e.$v==="en"}b.isDefault=L})(a||(e.Language=a={})),e.$w=l,e.$x=m,e.$y=c,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const b=[];e.$g.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let L=0,j=b.length;L<j;L++){const Q=b[L];if(Q.id===S.data.vscodeScheduleAsyncWork){b.splice(L,1),Q.callback();return}}});let y=0;return S=>{const L=++y;b.push({id:L,callback:S}),e.$g.postMessage({vscodeScheduleAsyncWork:L},"*")}}return b=>setTimeout(b)})();var i;(function(b){b[b.Windows=1]="Windows",b[b.Macintosh=2]="Macintosh",b[b.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=r||A?2:O?1:3;let n=!0,o=!1;function f(){if(!o){o=!0;const b=new Uint8Array(2);b[0]=1,b[1]=2,n=new Uint16Array(b.buffer)[0]===(2<<8)+1}return n}e.$C=f,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(pe[30],be([1,0,3]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.env=e.cwd=void 0;let O;if(typeof D.$g.vscode<"u"&&typeof D.$g.vscode.process<"u"){const r=D.$g.vscode.process;O={get platform(){return r.platform},get arch(){return r.arch},get env(){return r.env},cwd(){return r.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.$2c=O.platform,e.$3c=O.arch}),define(pe[7],be([1,0,30]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fd=e.sep=e.$dd=e.$cd=e.$bd=e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.$5c=e.$4c=void 0;const O=65,r=97,C=90,I=122,P=46,w=47,$=92,A=58,k=63;class p extends Error{constructor(s,a,i){let n;typeof a=="string"&&a.indexOf("not ")===0?(n="must not be",a=a.replace(/^not /,"")):n="must be";const o=s.indexOf(".")!==-1?"property":"argument";let f=`The "${s}" ${o} ${n} of type ${a}`;f+=`. Received type ${typeof i}`,super(f),this.code="ERR_INVALID_ARG_TYPE"}}function l(t,s){if(t===null||typeof t!="object")throw new p(s,"Object",t)}function d(t,s){if(typeof t!="string")throw new p(s,"string",t)}const m=D.$2c==="win32";function c(t){return t===w||t===$}function u(t){return t===w}function h(t){return t>=O&&t<=C||t>=r&&t<=I}function g(t,s,a,i){let n="",o=0,f=-1,b=0,y=0;for(let S=0;S<=t.length;++S){if(S<t.length)y=t.charCodeAt(S);else{if(i(y))break;y=w}if(i(y)){if(!(f===S-1||b===1))if(b===2){if(n.length<2||o!==2||n.charCodeAt(n.length-1)!==P||n.charCodeAt(n.length-2)!==P){if(n.length>2){const L=n.lastIndexOf(a);L===-1?(n="",o=0):(n=n.slice(0,L),o=n.length-1-n.lastIndexOf(a)),f=S,b=0;continue}else if(n.length!==0){n="",o=0,f=S,b=0;continue}}s&&(n+=n.length>0?`${a}..`:"..",o=2)}else n.length>0?n+=`${a}${t.slice(f+1,S)}`:n=t.slice(f+1,S),o=S-f-1;f=S,b=0}else y===P&&b!==-1?++b:b=-1}return n}function E(t,s){l(s,"pathObject");const a=s.dir||s.root,i=s.base||`${s.name||""}${s.ext||""}`;return a?a===s.root?`${a}${i}`:`${a}${t}${i}`:i}e.$4c={resolve(...t){let s="",a="",i=!1;for(let n=t.length-1;n>=-1;n--){let o;if(n>=0){if(o=t[n],d(o,"path"),o.length===0)continue}else s.length===0?o=D.cwd():(o=D.env[`=${s}`]||D.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==s.toLowerCase()&&o.charCodeAt(2)===$)&&(o=`${s}\\`));const f=o.length;let b=0,y="",S=!1;const L=o.charCodeAt(0);if(f===1)c(L)&&(b=1,S=!0);else if(c(L))if(S=!0,c(o.charCodeAt(1))){let j=2,Q=j;for(;j<f&&!c(o.charCodeAt(j));)j++;if(j<f&&j!==Q){const le=o.slice(Q,j);for(Q=j;j<f&&c(o.charCodeAt(j));)j++;if(j<f&&j!==Q){for(Q=j;j<f&&!c(o.charCodeAt(j));)j++;(j===f||j!==Q)&&(y=`\\\\${le}\\${o.slice(Q,j)}`,b=j)}}}else b=1;else h(L)&&o.charCodeAt(1)===A&&(y=o.slice(0,2),b=2,f>2&&c(o.charCodeAt(2))&&(S=!0,b=3));if(y.length>0)if(s.length>0){if(y.toLowerCase()!==s.toLowerCase())continue}else s=y;if(i){if(s.length>0)break}else if(a=`${o.slice(b)}\\${a}`,i=S,S&&s.length>0)break}return a=g(a,!i,"\\",c),i?`${s}\\${a}`:`${s}${a}`||"."},normalize(t){d(t,"path");const s=t.length;if(s===0)return".";let a=0,i,n=!1;const o=t.charCodeAt(0);if(s===1)return u(o)?"\\":t;if(c(o))if(n=!0,c(t.charCodeAt(1))){let b=2,y=b;for(;b<s&&!c(t.charCodeAt(b));)b++;if(b<s&&b!==y){const S=t.slice(y,b);for(y=b;b<s&&c(t.charCodeAt(b));)b++;if(b<s&&b!==y){for(y=b;b<s&&!c(t.charCodeAt(b));)b++;if(b===s)return`\\\\${S}\\${t.slice(y)}\\`;b!==y&&(i=`\\\\${S}\\${t.slice(y,b)}`,a=b)}}}else a=1;else h(o)&&t.charCodeAt(1)===A&&(i=t.slice(0,2),a=2,s>2&&c(t.charCodeAt(2))&&(n=!0,a=3));let f=a<s?g(t.slice(a),!n,"\\",c):"";return f.length===0&&!n&&(f="."),f.length>0&&c(t.charCodeAt(s-1))&&(f+="\\"),i===void 0?n?`\\${f}`:f:n?`${i}\\${f}`:`${i}${f}`},isAbsolute(t){d(t,"path");const s=t.length;if(s===0)return!1;const a=t.charCodeAt(0);return c(a)||s>2&&h(a)&&t.charCodeAt(1)===A&&c(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let s,a;for(let o=0;o<t.length;++o){const f=t[o];d(f,"path"),f.length>0&&(s===void 0?s=a=f:s+=`\\${f}`)}if(s===void 0)return".";let i=!0,n=0;if(typeof a=="string"&&c(a.charCodeAt(0))){++n;const o=a.length;o>1&&c(a.charCodeAt(1))&&(++n,o>2&&(c(a.charCodeAt(2))?++n:i=!1))}if(i){for(;n<s.length&&c(s.charCodeAt(n));)n++;n>=2&&(s=`\\${s.slice(n)}`)}return e.$4c.normalize(s)},relative(t,s){if(d(t,"from"),d(s,"to"),t===s)return"";const a=e.$4c.resolve(t),i=e.$4c.resolve(s);if(a===i||(t=a.toLowerCase(),s=i.toLowerCase(),t===s))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===$;)n++;let o=t.length;for(;o-1>n&&t.charCodeAt(o-1)===$;)o--;const f=o-n;let b=0;for(;b<s.length&&s.charCodeAt(b)===$;)b++;let y=s.length;for(;y-1>b&&s.charCodeAt(y-1)===$;)y--;const S=y-b,L=f<S?f:S;let j=-1,Q=0;for(;Q<L;Q++){const Y=t.charCodeAt(n+Q);if(Y!==s.charCodeAt(b+Q))break;Y===$&&(j=Q)}if(Q!==L){if(j===-1)return i}else{if(S>L){if(s.charCodeAt(b+Q)===$)return i.slice(b+Q+1);if(Q===2)return i.slice(b+Q)}f>L&&(t.charCodeAt(n+Q)===$?j=Q:Q===2&&(j=3)),j===-1&&(j=0)}let le="";for(Q=n+j+1;Q<=o;++Q)(Q===o||t.charCodeAt(Q)===$)&&(le+=le.length===0?"..":"\\..");return b+=j,le.length>0?`${le}${i.slice(b,y)}`:(i.charCodeAt(b)===$&&++b,i.slice(b,y))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const s=e.$4c.resolve(t);if(s.length<=2)return t;if(s.charCodeAt(0)===$){if(s.charCodeAt(1)===$){const a=s.charCodeAt(2);if(a!==k&&a!==P)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(h(s.charCodeAt(0))&&s.charCodeAt(1)===A&&s.charCodeAt(2)===$)return`\\\\?\\${s}`;return t},dirname(t){d(t,"path");const s=t.length;if(s===0)return".";let a=-1,i=0;const n=t.charCodeAt(0);if(s===1)return c(n)?t:".";if(c(n)){if(a=i=1,c(t.charCodeAt(1))){let b=2,y=b;for(;b<s&&!c(t.charCodeAt(b));)b++;if(b<s&&b!==y){for(y=b;b<s&&c(t.charCodeAt(b));)b++;if(b<s&&b!==y){for(y=b;b<s&&!c(t.charCodeAt(b));)b++;if(b===s)return t;b!==y&&(a=i=b+1)}}}}else h(n)&&t.charCodeAt(1)===A&&(a=s>2&&c(t.charCodeAt(2))?3:2,i=a);let o=-1,f=!0;for(let b=s-1;b>=i;--b)if(c(t.charCodeAt(b))){if(!f){o=b;break}}else f=!1;if(o===-1){if(a===-1)return".";o=a}return t.slice(0,o)},basename(t,s){s!==void 0&&d(s,"ext"),d(t,"path");let a=0,i=-1,n=!0,o;if(t.length>=2&&h(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(a=2),s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let f=s.length-1,b=-1;for(o=t.length-1;o>=a;--o){const y=t.charCodeAt(o);if(c(y)){if(!n){a=o+1;break}}else b===-1&&(n=!1,b=o+1),f>=0&&(y===s.charCodeAt(f)?--f===-1&&(i=o):(f=-1,i=b))}return a===i?i=b:i===-1&&(i=t.length),t.slice(a,i)}for(o=t.length-1;o>=a;--o)if(c(t.charCodeAt(o))){if(!n){a=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(a,i)},extname(t){d(t,"path");let s=0,a=-1,i=0,n=-1,o=!0,f=0;t.length>=2&&t.charCodeAt(1)===A&&h(t.charCodeAt(0))&&(s=i=2);for(let b=t.length-1;b>=s;--b){const y=t.charCodeAt(b);if(c(y)){if(!o){i=b+1;break}continue}n===-1&&(o=!1,n=b+1),y===P?a===-1?a=b:f!==1&&(f=1):a!==-1&&(f=-1)}return a===-1||n===-1||f===0||f===1&&a===n-1&&a===i+1?"":t.slice(a,n)},format:E.bind(null,"\\"),parse(t){d(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const a=t.length;let i=0,n=t.charCodeAt(0);if(a===1)return c(n)?(s.root=s.dir=t,s):(s.base=s.name=t,s);if(c(n)){if(i=1,c(t.charCodeAt(1))){let j=2,Q=j;for(;j<a&&!c(t.charCodeAt(j));)j++;if(j<a&&j!==Q){for(Q=j;j<a&&c(t.charCodeAt(j));)j++;if(j<a&&j!==Q){for(Q=j;j<a&&!c(t.charCodeAt(j));)j++;j===a?i=j:j!==Q&&(i=j+1)}}}}else if(h(n)&&t.charCodeAt(1)===A){if(a<=2)return s.root=s.dir=t,s;if(i=2,c(t.charCodeAt(2))){if(a===3)return s.root=s.dir=t,s;i=3}}i>0&&(s.root=t.slice(0,i));let o=-1,f=i,b=-1,y=!0,S=t.length-1,L=0;for(;S>=i;--S){if(n=t.charCodeAt(S),c(n)){if(!y){f=S+1;break}continue}b===-1&&(y=!1,b=S+1),n===P?o===-1?o=S:L!==1&&(L=1):o!==-1&&(L=-1)}return b!==-1&&(o===-1||L===0||L===1&&o===b-1&&o===f+1?s.base=s.name=t.slice(f,b):(s.name=t.slice(f,o),s.base=t.slice(f,b),s.ext=t.slice(o,b))),f>0&&f!==i?s.dir=t.slice(0,f-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const v=(()=>{if(m){const t=/\\/g;return()=>{const s=D.cwd().replace(t,"/");return s.slice(s.indexOf("/"))}}return()=>D.cwd()})();e.$5c={resolve(...t){let s="",a=!1;for(let i=t.length-1;i>=-1&&!a;i--){const n=i>=0?t[i]:v();d(n,"path"),n.length!==0&&(s=`${n}/${s}`,a=n.charCodeAt(0)===w)}return s=g(s,!a,"/",u),a?`/${s}`:s.length>0?s:"."},normalize(t){if(d(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===w,a=t.charCodeAt(t.length-1)===w;return t=g(t,!s,"/",u),t.length===0?s?"/":a?"./":".":(a&&(t+="/"),s?`/${t}`:t)},isAbsolute(t){return d(t,"path"),t.length>0&&t.charCodeAt(0)===w},join(...t){if(t.length===0)return".";let s;for(let a=0;a<t.length;++a){const i=t[a];d(i,"path"),i.length>0&&(s===void 0?s=i:s+=`/${i}`)}return s===void 0?".":e.$5c.normalize(s)},relative(t,s){if(d(t,"from"),d(s,"to"),t===s||(t=e.$5c.resolve(t),s=e.$5c.resolve(s),t===s))return"";const a=1,i=t.length,n=i-a,o=1,f=s.length-o,b=n<f?n:f;let y=-1,S=0;for(;S<b;S++){const j=t.charCodeAt(a+S);if(j!==s.charCodeAt(o+S))break;j===w&&(y=S)}if(S===b)if(f>b){if(s.charCodeAt(o+S)===w)return s.slice(o+S+1);if(S===0)return s.slice(o+S)}else n>b&&(t.charCodeAt(a+S)===w?y=S:S===0&&(y=0));let L="";for(S=a+y+1;S<=i;++S)(S===i||t.charCodeAt(S)===w)&&(L+=L.length===0?"..":"/..");return`${L}${s.slice(o+y)}`},toNamespacedPath(t){return t},dirname(t){if(d(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===w;let a=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===w){if(!i){a=n;break}}else i=!1;return a===-1?s?"/":".":s&&a===1?"//":t.slice(0,a)},basename(t,s){s!==void 0&&d(s,"ext"),d(t,"path");let a=0,i=-1,n=!0,o;if(s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let f=s.length-1,b=-1;for(o=t.length-1;o>=0;--o){const y=t.charCodeAt(o);if(y===w){if(!n){a=o+1;break}}else b===-1&&(n=!1,b=o+1),f>=0&&(y===s.charCodeAt(f)?--f===-1&&(i=o):(f=-1,i=b))}return a===i?i=b:i===-1&&(i=t.length),t.slice(a,i)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===w){if(!n){a=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(a,i)},extname(t){d(t,"path");let s=-1,a=0,i=-1,n=!0,o=0;for(let f=t.length-1;f>=0;--f){const b=t.charCodeAt(f);if(b===w){if(!n){a=f+1;break}continue}i===-1&&(n=!1,i=f+1),b===P?s===-1?s=f:o!==1&&(o=1):s!==-1&&(o=-1)}return s===-1||i===-1||o===0||o===1&&s===i-1&&s===a+1?"":t.slice(s,i)},format:E.bind(null,"/"),parse(t){d(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const a=t.charCodeAt(0)===w;let i;a?(s.root="/",i=1):i=0;let n=-1,o=0,f=-1,b=!0,y=t.length-1,S=0;for(;y>=i;--y){const L=t.charCodeAt(y);if(L===w){if(!b){o=y+1;break}continue}f===-1&&(b=!1,f=y+1),L===P?n===-1?n=y:S!==1&&(S=1):n!==-1&&(S=-1)}if(f!==-1){const L=o===0&&a?1:o;n===-1||S===0||S===1&&n===f-1&&n===o+1?s.base=s.name=t.slice(L,f):(s.name=t.slice(L,n),s.base=t.slice(L,f),s.ext=t.slice(n,f))}return o>0?s.dir=t.slice(0,o-1):a&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$5c.win32=e.$4c.win32=e.$4c,e.$5c.posix=e.$4c.posix=e.$5c,e.$6c=m?e.$4c.normalize:e.$5c.normalize,e.$7c=m?e.$4c.isAbsolute:e.$5c.isAbsolute,e.$8c=m?e.$4c.join:e.$5c.join,e.$9c=m?e.$4c.resolve:e.$5c.resolve,e.$0c=m?e.$4c.relative:e.$5c.relative,e.$$c=m?e.$4c.dirname:e.$5c.dirname,e.$_c=m?e.$4c.basename:e.$5c.basename,e.$ad=m?e.$4c.extname:e.$5c.extname,e.$bd=m?e.$4c.format:e.$5c.format,e.$cd=m?e.$4c.parse:e.$5c.parse,e.$dd=m?e.$4c.toNamespacedPath:e.$5c.toNamespacedPath,e.sep=m?e.$4c.sep:e.$5c.sep,e.$fd=m?e.$4c.delimiter:e.$5c.delimiter}),define(pe[39],be([1,0,7,3,17,10]),function(ce,e,D,O,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=void 0;function I(o){return o===47||o===92}e.$Ae=I;function P(o){return o.replace(/[\\/]/g,D.$5c.sep)}e.$Be=P;function w(o){return o.indexOf("/")===-1&&(o=P(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.$Ce=w;function $(o,f=D.$5c.sep){if(!o)return"";const b=o.length,y=o.charCodeAt(0);if(I(y)){if(I(o.charCodeAt(1))&&!I(o.charCodeAt(2))){let L=3;const j=L;for(;L<b&&!I(o.charCodeAt(L));L++);if(j!==L&&!I(o.charCodeAt(L+1))){for(L+=1;L<b;L++)if(I(o.charCodeAt(L)))return o.slice(0,L+1).replace(/[\\/]/g,f)}}return f}else if(u(y)&&o.charCodeAt(1)===58)return I(o.charCodeAt(2))?o.slice(0,2)+f:o.slice(0,2);let S=o.indexOf("://");if(S!==-1){for(S+=3;S<b;S++)if(I(o.charCodeAt(S)))return o.slice(0,S+1)}return""}e.$De=$;function A(o){if(!O.$i||!o||o.length<5)return!1;let f=o.charCodeAt(0);if(f!==92||(f=o.charCodeAt(1),f!==92))return!1;let b=2;const y=b;for(;b<o.length&&(f=o.charCodeAt(b),f!==92);b++);return!(y===b||(f=o.charCodeAt(b+1),isNaN(f)||f===92))}e.$Ee=A;const k=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(o,f=O.$i){const b=f?k:p;return!(!o||o.length===0||/^\s+$/.test(o)||(b.lastIndex=0,b.test(o))||f&&l.test(o)||o==="."||o===".."||f&&o[o.length-1]==="."||f&&o.length!==o.trim().length||o.length>255)}e.$Fe=d;function m(o,f,b){const y=o===f;return!b||y?y:!o||!f?!1:(0,r.$Ld)(o,f)}e.$Ge=m;function c(o,f,b,y=D.sep){if(o===f)return!0;if(!o||!f||f.length>o.length)return!1;if(b){if(!(0,r.$Md)(o,f))return!1;if(f.length===o.length)return!0;let L=f.length;return f.charAt(f.length-1)===y&&L--,o.charAt(L)===y}return f.charAt(f.length-1)!==y&&(f+=y),o.indexOf(f)===0}e.$He=c;function u(o){return o>=65&&o<=90||o>=97&&o<=122}e.$Ie=u;function h(o,f){return O.$i&&o.endsWith(":")&&(o+=D.sep),(0,D.$7c)(o)||(o=(0,D.$8c)(f,o)),o=(0,D.$6c)(o),O.$i?(o=(0,r.$ud)(o,D.sep),o.endsWith(":")&&(o+=D.sep)):(o=(0,r.$ud)(o,D.sep),o||(o=D.sep)),o}e.$Je=h;function g(o){const f=(0,D.$6c)(o);return O.$i?o.length>3?!1:E(f)&&(o.length===2||f.charCodeAt(2)===92):f===D.$5c.sep}e.$Ke=g;function E(o,f=O.$i){return f?u(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.$Le=E;function v(o,f=O.$i){return E(o,f)?o[0]:void 0}e.$Me=v;function t(o,f,b){return f.length>o.length?-1:o===f?0:(b&&(o=o.toLowerCase(),f=f.toLowerCase()),o.indexOf(f))}e.$Ne=t;function s(o){const f=o.split(":");let b,y,S;for(const L of f){const j=Number(L);(0,C.$me)(j)?y===void 0?y=j:S===void 0&&(S=j):b=b?[b,L].join(":"):L}if(!b)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:b,line:y!==void 0?y:void 0,column:S!==void 0?S:y!==void 0?1:void 0}}e.$Oe=s;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(o,f,b=8){let y="";for(let L=0;L<b;L++){let j;L===0&&O.$i&&!f&&(b===3||b===4)?j=i:j=a,y+=j.charAt(Math.floor(Math.random()*j.length))}let S;return f?S=`${f}-${y}`:S=y,o?(0,D.$8c)(o,S):S}e.$Pe=n}),define(pe[62],be([1,0,7]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=e.$Br=e.$Ar=e.$zr=e.$yr=void 0,e.$yr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},r={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function C(A){const k=(0,D.$ad)(A),p=O[k.toLowerCase()];return p!==void 0?p:I(A)}e.$zr=C;function I(A){const k=(0,D.$ad)(A);return r[k.toLowerCase()]}e.$Ar=I;function P(A){for(const k in r)if(r[k]===A)return k}e.$Br=P;const w=/^(.+)\/(.+?)(;.+)?$/;function $(A,k){const p=w.exec(A);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:k?void 0:A}e.$Cr=$}),define(pe[63],be([1,0,3]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=e.TerminateResponseCode=e.Source=void 0;var O;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(O||(e.Source=O={}));var r;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(r||(e.TerminateResponseCode=r={}));function C(P,...w){const $=w.reduce((p,l)=>(p[l]=!0,p),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(p=>!$[p]).forEach(p=>{for(let l=0;l<A.length;l++)if(p.search(A[l])!==-1){delete P[p];break}})}e.$fl=C;function I(P){P&&(delete P.DEBUG,D.$j&&delete P.DYLD_LIBRARY_PATH,D.$k&&delete P.LD_PRELOAD)}e.$gl=I}),define(pe[4],be([1,0,7,3]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=e.$Re=e.URI=void 0;const r=/^\w[\w\d+.-]*$/,C=/^\//,I=/^\/\//;function P(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!r.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!C.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(i,n){return!i&&!n?"file":i}function $(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==k&&(n=k+n):n=k;break}return n}const A="",k="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(n){return n instanceof l?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,o,f,b,y,S=!1){typeof n=="object"?(this.scheme=n.scheme||A,this.authority=n.authority||A,this.path=n.path||A,this.query=n.query||A,this.fragment=n.fragment||A):(this.scheme=w(n,S),this.authority=o||A,this.path=$(this.scheme,f||A),this.query=b||A,this.fragment=y||A,P(this,S))}get fsPath(){return E(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:f,path:b,query:y,fragment:S}=n;return o===void 0?o=this.scheme:o===null&&(o=A),f===void 0?f=this.authority:f===null&&(f=A),b===void 0?b=this.path:b===null&&(b=A),y===void 0?y=this.query:y===null&&(y=A),S===void 0?S=this.fragment:S===null&&(S=A),o===this.scheme&&f===this.authority&&b===this.path&&y===this.query&&S===this.fragment?this:new c(o,f,b,y,S)}static parse(n,o=!1){const f=p.exec(n);return f?new c(f[2]||A,a(f[4]||A),a(f[5]||A),a(f[7]||A),a(f[9]||A),o):new c(A,A,A,A,A)}static file(n){let o=A;if(O.$i&&(n=n.replace(/\\/g,k)),n[0]===k&&n[1]===k){const f=n.indexOf(k,2);f===-1?(o=n.substring(2),n=k):(o=n.substring(2,f),n=n.substring(f)||k)}return new c("file",o,n,A,A)}static from(n,o){return new c(n.scheme,n.authority,n.path,n.query,n.fragment,o)}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return O.$i&&n.scheme==="file"?f=l.file(D.$4c.join(E(n,!0),...o)).path:f=D.$5c.join(n.path,...o),n.with({path:f})}toString(n=!1){return v(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof l)return n;{const o=new c(n);return o._formatted=n.external??null,o._fsPath=n._sep===m?n.fsPath??null:null,o}}else return n}}e.URI=l;function d(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$Re=d;const m=O.$i?1:void 0;class c extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(n=!1){return n?v(this,!0):(this._formatted||(this._formatted=v(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=m),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const u={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(i,n,o){let f,b=-1;for(let y=0;y<i.length;y++){const S=i.charCodeAt(y);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||n&&S===47||o&&S===91||o&&S===93||o&&S===58)b!==-1&&(f+=encodeURIComponent(i.substring(b,y)),b=-1),f!==void 0&&(f+=i.charAt(y));else{f===void 0&&(f=i.substr(0,y));const L=u[S];L!==void 0?(b!==-1&&(f+=encodeURIComponent(i.substring(b,y)),b=-1),f+=L):b===-1&&(b=y)}}return b!==-1&&(f+=encodeURIComponent(i.substring(b))),f!==void 0?f:i}function g(i){let n;for(let o=0;o<i.length;o++){const f=i.charCodeAt(o);f===35||f===63?(n===void 0&&(n=i.substr(0,o)),n+=u[f]):n!==void 0&&(n+=i[o])}return n!==void 0?n:i}function E(i,n){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,O.$i&&(o=o.replace(/\//g,"\\")),o}e.$Se=E;function v(i,n){const o=n?g:h;let f="",{scheme:b,authority:y,path:S,query:L,fragment:j}=i;if(b&&(f+=b,f+=":"),(y||b==="file")&&(f+=k,f+=k),y){let Q=y.indexOf("@");if(Q!==-1){const le=y.substr(0,Q);y=y.substr(Q+1),Q=le.lastIndexOf(":"),Q===-1?f+=o(le,!1,!1):(f+=o(le.substr(0,Q),!1,!1),f+=":",f+=o(le.substr(Q+1),!1,!0)),f+="@"}y=y.toLowerCase(),Q=y.lastIndexOf(":"),Q===-1?f+=o(y,!1,!0):(f+=o(y.substr(0,Q),!1,!0),f+=y.substr(Q))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const Q=S.charCodeAt(1);Q>=65&&Q<=90&&(S=`/${String.fromCharCode(Q+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const Q=S.charCodeAt(0);Q>=65&&Q<=90&&(S=`${String.fromCharCode(Q+32)}:${S.substr(2)}`)}f+=o(S,!0,!1)}return L&&(f+="?",f+=o(L,!1,!1)),j&&(f+="#",f+=n?j:h(j,!1,!1)),f}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(i){return i.match(s)?i.replace(s,n=>t(n)):i}}),define(pe[163],be([1,0,4]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Gp=e.$Fp=e.$Ep=void 0;function O($){const A=$;return A&&typeof A.type=="string"&&typeof A.severity=="string"}e.$Ep=O;function r($){const A=[];let k;try{const p=JSON.parse($.arguments),l=p[p.length-1];l&&l.__$stack&&(p.pop(),k=l.__$stack),A.push(...p)}catch{A.push("Unable to log remote console arguments",$.arguments)}return{args:A,stack:k}}e.$Fp=r;function C($){if(typeof $!="string")return C(r($).stack);const A=$;if(A){const k=I(A),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(p&&p.length===4)return{uri:D.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$Gp=C;function I($){if(!$)return $;const A=$.indexOf(`
`);return A===-1?$:$.substring(0,A)}function P($,A){const{args:k,stack:p}=r($),l=typeof k[0]=="string"&&k.length===1;let d=I(p);d&&(d=`(${d.trim()})`);let m=[];if(typeof k[0]=="string"?d&&l?m=[`%c[${A}] %c${k[0]} %c${d}`,w("blue"),w(""),w("grey")]:m=[`%c[${A}] %c${k[0]}`,w("blue"),w(""),...k.slice(1)]:m=[`%c[${A}]%`,w("blue"),...k],d&&!l&&m.push(d),typeof console[$.severity]!="function")throw new Error("Unknown console method");console[$.severity].apply(console,m)}e.log=P;function w($){return`color: ${$}`}}),define(pe[50],be([1,0,15,4]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=e.$Xg=e.$Wg=void 0;function r(w){return JSON.stringify(w,I)}e.$Wg=r;function C(w){let $=JSON.parse(w);return $=P($),$}e.$Xg=C;function I(w,$){return $ instanceof RegExp?{$mid:2,source:$.source,flags:$.flags}:$}function P(w,$=0){if(!w||$>200)return w;if(typeof w=="object"){switch(w.$mid){case 1:return O.URI.revive(w);case 2:return new RegExp(w.source,w.flags);case 16:return new Date(w.source)}if(w instanceof D.$Ec||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let A=0;A<w.length;++A)w[A]=P(w[A],$+1);else for(const A in w)Object.hasOwnProperty.call(w,A)&&(w[A]=P(w[A],$+1))}return w}e.$Yg=P}),define(pe[13],be([1,0,11,3,4]),function(ce,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.Schemas=void 0;var C;(function($){$.inMemory="inmemory",$.vscode="vscode",$.internal="private",$.walkThrough="walkThrough",$.walkThroughSnippet="walkThroughSnippet",$.http="http",$.https="https",$.file="file",$.mailto="mailto",$.untitled="untitled",$.data="data",$.command="command",$.vscodeRemote="vscode-remote",$.vscodeRemoteResource="vscode-remote-resource",$.vscodeManagedRemoteResource="vscode-managed-remote-resource",$.vscodeUserData="vscode-userdata",$.vscodeCustomEditor="vscode-custom-editor",$.vscodeNotebookCell="vscode-notebook-cell",$.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",$.vscodeNotebookCellOutput="vscode-notebook-cell-output",$.vscodeInteractiveInput="vscode-interactive-input",$.vscodeSettings="vscode-settings",$.vscodeWorkspaceTrust="vscode-workspace-trust",$.vscodeTerminal="vscode-terminal",$.vscodeChatSesssion="vscode-chat-editor",$.webviewPanel="webview-panel",$.vscodeWebview="vscode-webview",$.extension="extension",$.vscodeFileResource="vscode-file",$.tmp="tmp",$.vsls="vsls",$.vscodeSourceControl="vscode-scm"})(C||(e.Schemas=C={})),e.$Te="vscode-tkn",e.$Ue="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${C.vscodeRemoteResource}`}setPreferredWebSchema(A){this.d=A}setDelegate(A){this.e=A}setServerRootPath(A){this.f=`${A}/${C.vscodeRemoteResource}`}set(A,k,p){this.a[A]=k,this.b[A]=p}setConnectionToken(A,k){this.c[A]=k}getPreferredWebSchema(){return this.d}rewrite(A){if(this.e)try{return this.e(A)}catch(c){return D.$Y(c),A}const k=A.authority;let p=this.a[k];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const l=this.b[k],d=this.c[k];let m=`path=${encodeURIComponent(A.path)}`;return typeof d=="string"&&(m+=`&${e.$Ue}=${encodeURIComponent(d)}`),r.URI.from({scheme:O.$o?this.d:C.vscodeRemoteResource,authority:`${p}:${l}`,path:this.f,query:m})}}e.$Ve=new I,e.$We="vs/../../extensions",e.$Xe="vs/../../node_modules",e.$Ye="vs/../../node_modules.asar",e.$Ze="vs/../../node_modules.asar.unpacked";class P{static{this.a="vscode-app"}asBrowserUri(A){const k=this.b(A,ce);return this.uriToBrowserUri(k)}uriToBrowserUri(A){return A.scheme===C.vscodeRemote?e.$Ve.rewrite(A):A.scheme===C.file&&(O.$m||O.$p&&O.$g.origin===`${C.vscodeFileResource}://${P.a}`)?A.with({scheme:C.vscodeFileResource,authority:A.authority||P.a,query:null,fragment:null}):A}asFileUri(A){const k=this.b(A,ce);return this.uriToFileUri(k)}uriToFileUri(A){return A.scheme===C.vscodeFileResource?A.with({scheme:C.file,authority:A.authority!==P.a?A.authority:null,query:null,fragment:null}):A}b(A,k){return r.URI.isUri(A)?A:r.URI.parse(k.toUrl(A))}}e.$1e=new P;var w;(function($){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);$.CoopAndCoep=Object.freeze(A.get("3"));const k="vscode-coi";function p(d){let m;typeof d=="string"?m=new URL(d).searchParams:d instanceof URL?m=d.searchParams:r.URI.isUri(d)&&(m=new URL(d.toString(!0)).searchParams);const c=m?.get(k);if(c)return A.get(c)}$.getHeadersFromQuery=p;function l(d,m,c){if(!globalThis.crossOriginIsolated)return;const u=m&&c?"3":c?"2":"1";d instanceof URLSearchParams?d.set(k,u):d[k]=u}$.addSearchParam=l})(w||(e.COI=w={}))}),define(pe[164],be([1,0,94,13,3,4]),function(ce,e,D,O,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2C=void 0;class I{constructor(p,l,d){this.id=p,this.dependencies=l,this.callback=d}}class P{static{this.INSTANCE=new P}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,l,d)=>{typeof p!="string"&&(d=l,l=p,p=null),(typeof l!="object"||!Array.isArray(l))&&(d=l,l=null),this.c.push(new I(p,l,d))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const l=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!l)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(l.dependencies)&&l.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${l.dependencies.join(", ")}`);return typeof l.callback=="function"?l.callback([]):l.callback}h(p){return new Promise((l,d)=>{const m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript");const c=()=>{m.removeEventListener("load",u),m.removeEventListener("error",h)},u=g=>{c(),l(this.c.pop())},h=g=>{c(),d(g)};m.addEventListener("load",u),m.addEventListener("error",h),this.f&&(p=this.f.createScriptURL(p)),m.setAttribute("src",p),document.getElementsByTagName("head")[0].appendChild(m)})}i(p){return new Promise((l,d)=>{try{this.f&&(p=this.f.createScriptURL(p)),importScripts(p),l(this.c.pop())}catch(m){d(m)}})}async j(p){try{const l=globalThis._VSCODE_NODE_MODULES.fs,d=globalThis._VSCODE_NODE_MODULES.vm,m=globalThis._VSCODE_NODE_MODULES.module,c=C.URI.parse(p).fsPath,u=l.readFileSync(c).toString(),h=m.wrap(u.replace(/^#!.*/,""));return new d.Script(h).runInThisContext().apply(),this.c.pop()}catch(l){throw l}}}const w=new Map;let $={};typeof globalThis.require=="object"&&($=globalThis.require.paths??{});async function A(k,p,l){if(D.$R){l===void 0&&(l=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),$[k]&&(k=$[k]);const d=`${k}/${p}`;if(w.has(d))return w.get(d);let m;if(/^\w[\w\d+.-]*:\/\//.test(d))m=d;else{const g=`${l&&!r.$o?O.$Ye:O.$Xe}/${d}`;m=O.$1e.asBrowserUri(g).toString(!0)}const c=P.INSTANCE.load(m);return w.set(d,c),c}else return await new Promise((d,m)=>{ce([k],d,m)})}e.$2C=A}),define(pe[19],be([1,0,39,13,7,3,17,4]),function(ce,e,D,O,r,C,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=e.DataUri=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=void 0;function w(l){return(0,P.$Se)(l,!0)}e.$Wf=w;class ${constructor(d){this.a=d}compare(d,m,c=!1){return d===m?0:(0,I.$Ed)(this.getComparisonKey(d,c),this.getComparisonKey(m,c))}isEqual(d,m,c=!1){return d===m?!0:!d||!m?!1:this.getComparisonKey(d,c)===this.getComparisonKey(m,c)}getComparisonKey(d,m=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,m,c=!1){if(d.scheme===m.scheme){if(d.scheme===O.Schemas.file)return D.$He(w(d),w(m),this.a(d))&&d.query===m.query&&(c||d.fragment===m.fragment);if((0,e.$bg)(d.authority,m.authority))return D.$He(d.path,m.path,this.a(d),"/")&&d.query===m.query&&(c||d.fragment===m.fragment)}return!1}joinPath(d,...m){return P.URI.joinPath(d,...m)}basenameOrAuthority(d){return(0,e.$6f)(d)||d.authority}basename(d){return r.$5c.basename(d.path)}extname(d){return r.$5c.extname(d.path)}dirname(d){if(d.path.length===0)return d;let m;return d.scheme===O.Schemas.file?m=P.URI.file(r.$$c(w(d))).path:(m=r.$5c.dirname(d.path),d.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),m="/")),d.with({path:m})}normalizePath(d){if(!d.path.length)return d;let m;return d.scheme===O.Schemas.file?m=P.URI.file(r.$6c(w(d))).path:m=r.$5c.normalize(d.path),d.with({path:m})}relativePath(d,m){if(d.scheme!==m.scheme||!(0,e.$bg)(d.authority,m.authority))return;if(d.scheme===O.Schemas.file){const h=r.$0c(w(d),w(m));return C.$i?D.$Be(h):h}let c=d.path||"/";const u=m.path||"/";if(this.a(d)){let h=0;for(const g=Math.min(c.length,u.length);h<g&&!(c.charCodeAt(h)!==u.charCodeAt(h)&&c.charAt(h).toLowerCase()!==u.charAt(h).toLowerCase());h++);c=u.substr(0,h)+c.substr(h)}return r.$5c.relative(c,u)}resolvePath(d,m){if(d.scheme===O.Schemas.file){const c=P.URI.file(r.$9c(w(d),m));return d.with({authority:c.authority,path:c.path})}return m=D.$Ce(m),d.with({path:r.$5c.resolve(d.path,m)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,m){return d===m||d!==void 0&&m!==void 0&&(0,I.$Ld)(d,m)}hasTrailingPathSeparator(d,m=r.sep){if(d.scheme===O.Schemas.file){const c=w(d);return c.length>D.$De(c).length&&c[c.length-1]===m}else{const c=d.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,m=r.sep){return(0,e.$cg)(d,m)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,m=r.sep){let c=!1;if(d.scheme===O.Schemas.file){const u=w(d);c=u!==void 0&&u.length===D.$De(u).length&&u[u.length-1]===m}else{m="/";const u=d.path;c=u.length===1&&u.charCodeAt(u.length-1)===47}return!c&&!(0,e.$cg)(d,m)?d.with({path:d.path+"/"}):d}}e.$Xf=$,e.$Yf=new $(()=>!1),e.$Zf=new $(l=>l.scheme===O.Schemas.file?!C.$k:!0),e.$1f=new $(l=>!0),e.$2f=e.$Yf.isEqual.bind(e.$Yf),e.$3f=e.$Yf.isEqualOrParent.bind(e.$Yf),e.$4f=e.$Yf.getComparisonKey.bind(e.$Yf),e.$5f=e.$Yf.basenameOrAuthority.bind(e.$Yf),e.$6f=e.$Yf.basename.bind(e.$Yf),e.$7f=e.$Yf.extname.bind(e.$Yf),e.$8f=e.$Yf.dirname.bind(e.$Yf),e.$9f=e.$Yf.joinPath.bind(e.$Yf),e.$0f=e.$Yf.normalizePath.bind(e.$Yf),e.$$f=e.$Yf.relativePath.bind(e.$Yf),e.$_f=e.$Yf.resolvePath.bind(e.$Yf),e.$ag=e.$Yf.isAbsolutePath.bind(e.$Yf),e.$bg=e.$Yf.isEqualAuthority.bind(e.$Yf),e.$cg=e.$Yf.hasTrailingPathSeparator.bind(e.$Yf),e.$dg=e.$Yf.removeTrailingPathSeparator.bind(e.$Yf),e.$eg=e.$Yf.addTrailingPathSeparator.bind(e.$Yf);function A(l,d){const m=[];for(let c=0;c<l.length;c++){const u=d(l[c]);l.some((h,g)=>g===c?!1:(0,e.$3f)(u,d(h)))||m.push(l[c])}return m}e.$fg=A;var k;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function d(m){const c=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(g=>{const[E,v]=g.split(":");E&&v&&c.set(E,v)});const h=m.path.substring(0,m.path.indexOf(";"));return h&&c.set(l.META_DATA_MIME,h),c}l.parseMetaData=d})(k||(e.DataUri=k={}));function p(l,d,m){if(d){let c=l.path;return c&&c[0]!==r.$5c.sep&&(c=r.$5c.sep+c),l.with({scheme:m,authority:d,path:c})}return l.with({scheme:m})}e.$gg=p}),define(pe[14],be([1,0,20,11,5,2,19,3,147]),function(ce,e,D,O,r,C,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.$Rg=e.$Qg=e.Promises=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=void 0;function $(R){return!!R&&typeof R.then=="function"}e.$hg=$;function A(R){const F=new D.$oc,W=R(F.token),ie=new Promise((re,_)=>{const oe=F.token.onCancellationRequested(()=>{oe.dispose(),F.dispose(),_(new O.$3)});Promise.resolve(W).then(N=>{oe.dispose(),F.dispose(),re(N)},N=>{oe.dispose(),F.dispose(),_(N)})});return new class{cancel(){F.cancel()}then(re,_){return ie.then(re,_)}catch(re){return this.then(void 0,re)}finally(re){return ie.finally(re)}}}e.$ig=A;function k(R,F,W){return new Promise((ie,re)=>{const _=F.onCancellationRequested(()=>{_.dispose(),ie(W)});R.then(ie,re).finally(()=>_.dispose())})}e.$jg=k;function p(R,F){return new Promise((W,ie)=>{const re=F.onCancellationRequested(()=>{re.dispose(),ie(new O.$3)});R.then(W,ie).finally(()=>re.dispose())})}e.$kg=p;async function l(R){let F=-1;const W=R.map((ie,re)=>ie.then(_=>(F=re,_)));try{return await Promise.race(W)}finally{R.forEach((ie,re)=>{re!==F&&ie.cancel()})}}e.$lg=l;function d(R,F,W){let ie;const re=setTimeout(()=>{ie?.(void 0),W?.()},F);return Promise.race([R.finally(()=>clearTimeout(re)),new Promise(_=>ie=_)])}e.$mg=d;function m(R){return new Promise((F,W)=>{const ie=R();$(ie)?ie.then(F,W):F(ie)})}e.$ng=m;class c{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(F){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=F,!this.b){const W=()=>{if(this.b=null,this.f)return;const ie=this.queue(this.d);return this.d=null,ie};this.b=new Promise(ie=>{this.a.then(W,W).then(ie)})}return new Promise((W,ie)=>{this.b.then(W,ie)})}return this.a=F(),new Promise((W,ie)=>{this.a.then(re=>{this.a=null,W(re)},re=>{this.a=null,ie(re)})})}dispose(){this.f=!0}}e.$og=c;class u{constructor(){this.a=Promise.resolve(null)}queue(F){return this.a=this.a.then(()=>F(),()=>F())}}e.$pg=u;class h{constructor(){this.a=new Map}queue(F,W){const re=(this.a.get(F)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.a.get(F)===re&&this.a.delete(F)});return this.a.set(F,re),re}}e.$qg=h;const g=(R,F)=>{let W=!0;const ie=setTimeout(()=>{W=!1,F()},R);return{isTriggered:()=>W,dispose:()=>{clearTimeout(ie),W=!1}}},E=R=>{let F=!0;return queueMicrotask(()=>{F&&(F=!1,R())}),{isTriggered:()=>F,dispose:()=>{F=!1}}};class v{constructor(F){this.defaultDelay=F,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(F,W=this.defaultDelay){this.g=F,this.h(),this.b||(this.b=new Promise((re,_)=>{this.d=re,this.f=_}).then(()=>{if(this.b=null,this.d=null,this.g){const re=this.g;return this.g=null,re()}}));const ie=()=>{this.a=null,this.d?.(null)};return this.a=W===w.$bc?E(ie):g(W,ie),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$rg=v;class t{constructor(F){this.a=new v(F),this.b=new c}trigger(F,W){return this.a.trigger(()=>this.b.queue(F),W)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$sg=t;class s{constructor(){this.a=!1,this.b=new Promise((F,W)=>{this.d=F})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$tg=s;class a extends s{constructor(F){super(),this.f=setTimeout(()=>this.open(),F)}open(){clearTimeout(this.f),super.open()}}e.$ug=a;function i(R,F){return F?new Promise((W,ie)=>{const re=setTimeout(()=>{_.dispose(),W()},R),_=F.onCancellationRequested(()=>{clearTimeout(re),_.dispose(),ie(new O.$3)})}):A(W=>i(R,W))}e.$vg=i;function n(R,F=0){const W=setTimeout(R,F);return(0,C.$jb)(()=>clearTimeout(W))}e.$wg=n;function o(R){const F=[];let W=0;const ie=R.length;function re(){return W<ie?R[W++]():null}function _(oe){oe!=null&&F.push(oe);const N=re();return N?N.then(_):Promise.resolve(F)}return Promise.resolve(null).then(_)}e.$xg=o;function f(R,F=ie=>!!ie,W=null){let ie=0;const re=R.length,_=()=>{if(ie>=re)return Promise.resolve(W);const oe=R[ie++];return Promise.resolve(oe()).then(B=>F(B)?Promise.resolve(B):_())};return _()}e.$yg=f;function b(R,F=ie=>!!ie,W=null){if(R.length===0)return Promise.resolve(W);let ie=R.length;const re=()=>{ie=-1;for(const _ of R)_.cancel?.()};return new Promise((_,oe)=>{for(const N of R)N.then(B=>{--ie>=0&&F(B)?(re(),_(B)):ie===0&&_(W)}).catch(B=>{--ie>=0&&(re(),oe(B))})})}e.$zg=b;class y{constructor(F){this.a=0,this.d=F,this.f=[],this.b=0,this.g=new r.$ec}get onDrained(){return this.g.event}get size(){return this.a}queue(F){return this.a++,new Promise((W,ie)=>{this.f.push({factory:F,c:W,e:ie}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const F=this.f.shift();this.b++;const W=F.factory();W.then(F.c,F.e),W.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Ag=y;class S extends y{constructor(){super(1)}}e.$Bg=S;class L{constructor(){this.a=new se,this.b=0}queue(F){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,F())):this.a.run(this.b++,F())}}e.$Cg=L;class j{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const F=new H;return this.b.add(F),F.p}d(){for(const[,F]of this.a)if(F.size>0)return!1;return!0}queueFor(F,W=I.$Yf){const ie=W.getComparisonKey(F);let re=this.a.get(ie);return re||(re=new S,r.Event.once(re.onDrained)(()=>{re?.dispose(),this.a.delete(ie),this.f()}),this.a.set(ie,re)),re}f(){this.d()&&this.g()}g(){for(const F of this.b)F.complete();this.b.clear()}dispose(){for(const[,F]of this.a)F.dispose();this.a.clear(),this.g()}}e.$Dg=j;class Q{constructor(F,W){this.a=-1,typeof F=="function"&&typeof W=="number"&&this.setIfNotSet(F,W)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(F,W){this.cancel(),this.a=setTimeout(()=>{this.a=-1,F()},W)}setIfNotSet(F,W){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,F()},W))}}e.$Eg=Q;class le{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(F,W){this.cancel(),this.a=setInterval(()=>{F()},W)}}e.$Fg=le;class Y{constructor(F,W){this.b=-1,this.a=F,this.d=W,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(F=this.d){this.cancel(),this.b=setTimeout(this.f,F)}get delay(){return this.d}set delay(F){this.d=F}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Gg=Y;class ee{constructor(F,W){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.a=F,this.b=W,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(F=this.b){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(F/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Hg=ee;class ue extends Y{constructor(F,W){super(F,W),this.j=[]}work(F){this.j.push(F),this.isScheduled()||this.schedule()}h(){const F=this.j;this.j=[],this.a?.(F)}dispose(){this.j=[],super.dispose()}}e.$Ig=ue;class X extends C.$lb{constructor(F,W){super(),this.g=F,this.h=W,this.a=[],this.b=this.B(new C.$mb),this.f=!1}get pending(){return this.a.length}work(F){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+F.length>this.g.maxBufferedWork)return!1}else if(this.pending+F.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const W of F)this.a.push(W);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Y(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Jg=X,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Kg=R=>{(0,P.$A)(()=>{if(F)return;const W=Date.now()+15;R(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let F=!1;return{dispose(){F||(F=!0)}}}:e.$Kg=(R,F)=>{const W=requestIdleCallback(R,typeof F=="number"?{timeout:F}:void 0);let ie=!1;return{dispose(){ie||(ie=!0,cancelIdleCallback(W))}}}}();class he{constructor(F){this.d=!1,this.a=()=>{try{this.f=F()}catch(W){this.g=W}finally{this.d=!0}},this.b=(0,e.$Kg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Lg=he;async function x(R,F,W){let ie;for(let re=0;re<W;re++)try{return await R()}catch(_){ie=_,await i(F)}throw ie}e.$Mg=x;class se{isRunning(F){return typeof F=="number"?this.a?.taskId===F:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(F,W,ie){return this.a={taskId:F,cancel:()=>ie?.(),promise:W},W.then(()=>this.d(F),()=>this.d(F)),W}d(F){this.a&&F===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const F=this.b;this.b=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}queue(F){if(this.b)this.b.run=F;else{let W,ie;const re=new Promise((_,oe)=>{W=_,ie=oe});this.b={run:F,promise:re,promiseResolve:W,promiseReject:ie}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ng=se;class V{constructor(F,W=()=>Date.now()){this.d=F,this.f=W,this.a=0,this.b=0}increment(){const F=this.f();return F-this.a>this.d&&(this.a=F,this.b=0),this.b++,this.b}}e.$Og=V;var K;(function(R){R[R.Resolved=0]="Resolved",R[R.Rejected=1]="Rejected"})(K||(K={}));class H{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((F,W)=>{this.a=F,this.b=W})}complete(F){return new Promise(W=>{this.a(F),this.d={outcome:0,value:F},W()})}error(F){return new Promise(W=>{this.b(F),this.d={outcome:1,value:F},W()})}cancel(){return this.error(new O.$3)}}e.$Pg=H;var te;(function(R){async function F(ie){let re;const _=await Promise.all(ie.map(oe=>oe.then(N=>N,N=>{re||(re=N)})));if(typeof re<"u")throw re;return _}R.settled=F;function W(ie){return new Promise(async(re,_)=>{try{await ie(re,_)}catch(oe){_(oe)}})}R.withAsyncBody=W})(te||(e.Promises=te={}));var me;(function(R){R[R.Initial=0]="Initial",R[R.DoneOK=1]="DoneOK",R[R.DoneError=2]="DoneError"})(me||(me={}));class ne{static fromArray(F){return new ne(W=>{W.emitMany(F)})}static fromPromise(F){return new ne(async W=>{W.emitMany(await F)})}static fromPromises(F){return new ne(async W=>{await Promise.all(F.map(async ie=>W.emitOne(await ie)))})}static merge(F){return new ne(async W=>{await Promise.all(F.map(async ie=>{for await(const re of ie)W.emitOne(re)}))})}static{this.EMPTY=ne.fromArray([])}constructor(F){this.a=0,this.b=[],this.d=null,this.f=new r.$ec,queueMicrotask(async()=>{const W={emitOne:ie=>this.g(ie),emitMany:ie=>this.h(ie),reject:ie=>this.k(ie)};try{await Promise.resolve(F(W)),this.j()}catch(ie){this.k(ie)}finally{W.emitOne=void 0,W.emitMany=void 0,W.reject=void 0}})}[Symbol.asyncIterator](){let F=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(F<this.b.length)return{done:!1,value:this.b[F++]};if(this.a===1)return{done:!0,value:void 0};await r.Event.toPromise(this.f.event)}while(!0)}}}static map(F,W){return new ne(async ie=>{for await(const re of F)ie.emitOne(W(re))})}map(F){return ne.map(this,F)}static filter(F,W){return new ne(async ie=>{for await(const re of F)W(re)&&ie.emitOne(re)})}filter(F){return ne.filter(this,F)}static coalesce(F){return ne.filter(F,W=>!!W)}coalesce(){return ne.coalesce(this)}static async toPromise(F){const W=[];for await(const ie of F)W.push(ie);return W}toPromise(){return ne.toPromise(this)}g(F){this.a===0&&(this.b.push(F),this.f.fire())}h(F){this.a===0&&(this.b=this.b.concat(F),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(F){this.a===0&&(this.a=2,this.d=F,this.f.fire())}}e.$Qg=ne;class q extends ne{constructor(F,W){super(W),this.l=F}cancel(){this.l.cancel()}}e.$Rg=q;function J(R){const F=new D.$oc,W=R(F.token);return new q(F,async ie=>{const re=F.token.onCancellationRequested(()=>{re.dispose(),F.dispose(),ie.reject(new O.$3)});try{for await(const _ of W){if(F.token.isCancellationRequested)return;ie.emitOne(_)}re.dispose(),F.dispose()}catch(_){re.dispose(),F.dispose(),ie.reject(_)}})}e.$Sg=J}),define(pe[78],be([1,0,18,14,39,27,7,3,17]),function(ce,e,D,O,r,C,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=void 0;function $(){return Object.create(null)}e.$_i=$,e.$aj="**",e.$bj="/";const A="[/\\\\]",k="[^/\\\\]",p=/\//g;function l(se,V){switch(se){case 0:return"";case 1:return`${k}*?`;default:return`(?:${A}|${k}+${A}${V?`|${A}${k}+`:""})*?`}}function d(se,V){if(!se)return[];const K=[];let H=!1,te=!1,me="";for(const ne of se){switch(ne){case V:if(!H&&!te){K.push(me),me="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":te=!0;break;case"]":te=!1;break}me+=ne}return me&&K.push(me),K}e.$cj=d;function m(se){if(!se)return"";let V="";const K=d(se,e.$bj);if(K.every(H=>H===e.$aj))V=".*";else{let H=!1;K.forEach((te,me)=>{if(te===e.$aj){if(H)return;V+=l(2,me===K.length-1)}else{let ne=!1,q="",J=!1,R="";for(const F of te){if(F!=="}"&&ne){q+=F;continue}if(J&&(F!=="]"||!R)){let W;F==="-"?W=F:(F==="^"||F==="!")&&!R?W="^":F===e.$bj?W="":W=(0,w.$pd)(F),R+=W;continue}switch(F){case"{":ne=!0;continue;case"[":J=!0;continue;case"}":{const ie=`(?:${d(q,",").map(re=>m(re)).join("|")})`;V+=ie,ne=!1,q="";break}case"]":{V+="["+R+"]",J=!1,R="";break}case"?":V+=k;continue;case"*":V+=l(1);continue;default:V+=(0,w.$pd)(F)}}me<K.length-1&&(K[me+1]!==e.$aj||me+2<K.length)&&(V+=A)}H=te===e.$aj})}return V}const c=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new C.$qi(1e4),s=function(){return!1},a=function(){return null};function i(se,V){if(!se)return a;let K;typeof se!="string"?K=se.pattern:K=se,K=K.trim();const H=`${K}_${!!V.trimForExclusions}`;let te=t.get(H);if(te)return n(te,se);let me;return c.test(K)?te=f(K.substr(4),K):(me=u.exec(o(K,V)))?te=b(me[1],K):(V.trimForExclusions?g:h).test(K)?te=y(K,V):(me=E.exec(o(K,V)))?te=S(me[1].substr(1),K,!0):(me=v.exec(o(K,V)))?te=S(me[1],K,!1):te=L(K),t.set(H,te),n(te,se)}function n(se,V){if(typeof V=="string")return se;const K=function(H,te){return(0,r.$He)(H,V.base,!P.$k)?se((0,w.$td)(H.substr(V.base.length),I.sep),te):null};return K.allBasenames=se.allBasenames,K.allPaths=se.allPaths,K.basenames=se.basenames,K.patterns=se.patterns,K}function o(se,V){return V.trimForExclusions&&se.endsWith("/**")?se.substr(0,se.length-2):se}function f(se,V){return function(K,H){return typeof K=="string"&&K.endsWith(se)?V:null}}function b(se,V){const K=`/${se}`,H=`\\${se}`,te=function(ne,q){return typeof ne!="string"?null:q?q===se?V:null:ne===se||ne.endsWith(K)||ne.endsWith(H)?V:null},me=[se];return te.basenames=me,te.patterns=[V],te.allBasenames=me,te}function y(se,V){const K=he(se.slice(1,-1).split(",").map(q=>i(q,V)).filter(q=>q!==a),se),H=K.length;if(!H)return a;if(H===1)return K[0];const te=function(q,J){for(let R=0,F=K.length;R<F;R++)if(K[R](q,J))return se;return null},me=K.find(q=>!!q.allBasenames);me&&(te.allBasenames=me.allBasenames);const ne=K.reduce((q,J)=>J.allPaths?q.concat(J.allPaths):q,[]);return ne.length&&(te.allPaths=ne),te}function S(se,V,K){const H=I.sep===I.$5c.sep,te=H?se:se.replace(p,I.sep),me=I.sep+te,ne=I.$5c.sep+se;let q;return K?q=function(J,R){return typeof J=="string"&&(J===te||J.endsWith(me)||!H&&(J===se||J.endsWith(ne)))?V:null}:q=function(J,R){return typeof J=="string"&&(J===te||!H&&J===se)?V:null},q.allPaths=[(K?"*/":"./")+se],q}function L(se){try{const V=new RegExp(`^${m(se)}$`);return function(K){return V.lastIndex=0,typeof K=="string"&&V.test(K)?se:null}}catch{return a}}function j(se,V,K){return!se||typeof V!="string"?!1:Q(se)(V,void 0,K)}e.$dj=j;function Q(se,V={}){if(!se)return s;if(typeof se=="string"||le(se)){const K=i(se,V);if(K===a)return s;const H=function(te,me){return!!K(te,me)};return K.allBasenames&&(H.allBasenames=K.allBasenames),K.allPaths&&(H.allPaths=K.allPaths),H}return ue(se,V)}e.$ej=Q;function le(se){const V=se;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.$fj=le;function Y(se){return se.allBasenames||[]}e.$gj=Y;function ee(se){return se.allPaths||[]}e.$hj=ee;function ue(se,V){const K=he(Object.getOwnPropertyNames(se).map(q=>X(q,se[q],V)).filter(q=>q!==a)),H=K.length;if(!H)return a;if(!K.some(q=>!!q.requiresSiblings)){if(H===1)return K[0];const q=function(F,W){let ie;for(let re=0,_=K.length;re<_;re++){const oe=K[re](F,W);if(typeof oe=="string")return oe;(0,O.$hg)(oe)&&(ie||(ie=[]),ie.push(oe))}return ie?(async()=>{for(const re of ie){const _=await re;if(typeof _=="string")return _}return null})():null},J=K.find(F=>!!F.allBasenames);J&&(q.allBasenames=J.allBasenames);const R=K.reduce((F,W)=>W.allPaths?F.concat(W.allPaths):F,[]);return R.length&&(q.allPaths=R),q}const te=function(q,J,R){let F,W;for(let ie=0,re=K.length;ie<re;ie++){const _=K[ie];_.requiresSiblings&&R&&(J||(J=(0,I.$_c)(q)),F||(F=J.substr(0,J.length-(0,I.$ad)(q).length)));const oe=_(q,J,F,R);if(typeof oe=="string")return oe;(0,O.$hg)(oe)&&(W||(W=[]),W.push(oe))}return W?(async()=>{for(const ie of W){const re=await ie;if(typeof re=="string")return re}return null})():null},me=K.find(q=>!!q.allBasenames);me&&(te.allBasenames=me.allBasenames);const ne=K.reduce((q,J)=>J.allPaths?q.concat(J.allPaths):q,[]);return ne.length&&(te.allPaths=ne),te}function X(se,V,K){if(V===!1)return a;const H=i(se,K);if(H===a)return a;if(typeof V=="boolean")return H;if(V){const te=V.when;if(typeof te=="string"){const me=(ne,q,J,R)=>{if(!R||!H(ne,q))return null;const F=te.replace("$(basename)",()=>J),W=R(F);return(0,O.$hg)(W)?W.then(ie=>ie?se:null):W?se:null};return me.requiresSiblings=!0,me}}return H}function he(se,V){const K=se.filter(q=>!!q.basenames);if(K.length<2)return se;const H=K.reduce((q,J)=>{const R=J.basenames;return R?q.concat(R):q},[]);let te;if(V){te=[];for(let q=0,J=H.length;q<J;q++)te.push(V)}else te=K.reduce((q,J)=>{const R=J.patterns;return R?q.concat(R):q},[]);const me=function(q,J){if(typeof q!="string")return null;if(!J){let F;for(F=q.length;F>0;F--){const W=q.charCodeAt(F-1);if(W===47||W===92)break}J=q.substr(F)}const R=H.indexOf(J);return R!==-1?te[R]:null};me.basenames=H,me.patterns=te,me.allBasenames=H;const ne=se.filter(q=>!q.basenames);return ne.push(me),ne}function x(se,V){return(0,D.$$e)(se,V,(K,H)=>typeof K=="string"&&typeof H=="string"?K===H:typeof K!="string"&&typeof H!="string"?K.base===H.base&&K.pattern===H.pattern:!1)}e.$ij=x}),define(pe[102],be([1,0,11,148,19,17,4]),function(ce,e,D,O,r,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(P||(e.MarkdownStringTextNewlineStyle=P={}));class w{constructor(u="",h=!1){if(this.value=u,typeof this.value!="string")throw(0,D.$5)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(u,h=0){return this.value+=p(this.supportThemeIcons?(0,O.$Ej)(u):u).replace(/([ \t]+)/g,(g,E)=>"&nbsp;".repeat(E.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,h){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}appendLink(u,h,g){return this.value+="[",this.value+=this.c(h,"]"),this.value+="](",this.value+=this.c(String(u),")"),g&&(this.value+=` "${this.c(this.c(g,'"'),")")}"`),this.value+=")",this}c(u,h){const g=new RegExp((0,C.$pd)(h),"g");return u.replace(g,(E,v)=>u.charAt(v-1)!=="\\"?`\\${E}`:E)}}e.$Kj=w;function $(c){return A(c)?!c.value:Array.isArray(c)?c.every($):!0}e.$Lj=$;function A(c){return c instanceof w?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.$Mj=A;function k(c,u){return c===u?!0:!c||!u?!1:c.value===u.value&&c.isTrusted===u.isTrusted&&c.supportThemeIcons===u.supportThemeIcons&&c.supportHtml===u.supportHtml&&(c.baseUri===u.baseUri||!!c.baseUri&&!!u.baseUri&&(0,r.$2f)(I.URI.from(c.baseUri),I.URI.from(u.baseUri)))}e.$Nj=k;function p(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$Oj=p;function l(c){return c.replace(/"/g,"&quot;")}e.$Pj=l;function d(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$Qj=d;function m(c){const u=[],h=c.split("|").map(E=>E.trim());c=h[0];const g=h[1];if(g){const E=/height=(\d+)/.exec(g),v=/width=(\d+)/.exec(g),t=E?E[1]:"",s=v?v[1]:"",a=isFinite(parseInt(s)),i=isFinite(parseInt(t));a&&u.push(`width="${s}"`),i&&u.push(`height="${t}"`)}return{href:c,dimensions:u}}e.$Rj=m}),define(pe[165],be([1,0,18,39,7,3,19,17]),function(ce,e,D,O,r,C,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cA=e.$bA=e.$aA=e.$_z=e.$$z=e.$0z=e.$9z=e.$8z=e.$7z=e.$6z=void 0;function w(i,n){const{os:o,tildify:f,relative:b}=n;if(b){const L=$(i,b,o);if(typeof L=="string")return L}let y=i.fsPath;if(o===1&&!C.$i?y=y.replace(/\//g,"\\"):o!==1&&C.$i&&(y=y.replace(/\\/g,"/")),o!==1&&f?.userHome){const L=f.userHome.fsPath;let j;i.scheme!==f.userHome.scheme&&i.path.startsWith(r.$5c.sep)?j=f.userHome.with({path:i.path}).fsPath:j=i.fsPath,y=p(j,L,o)}return(o===1?r.$4c:r.$5c).normalize(A(y,o===1))}e.$6z=w;function $(i,n,o){const f=o===1?r.$4c:r.$5c,b=o===3?I.$Yf:I.$1f,y=n.getWorkspace(),S=(0,D.$sf)(y.folders);if(!S)return;i.scheme!==S.uri.scheme&&i.path.startsWith(r.$5c.sep)&&(i=S.uri.with({path:i.path}));const L=n.getWorkspaceFolder(i);if(!L)return;let j;if(b.isEqual(L.uri,i)?j="":j=b.relativePath(L.uri,i)??"",j&&(j=f.normalize(j)),y.folders.length>1&&!n.noPrefix){const Q=L.name?L.name:b.basenameOrAuthority(L.uri);j=j?`${Q} \u2022 ${j}`:Q}return j}function A(i,n=C.$i){return(0,O.$Le)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$7z=A;let k=Object.create(null);function p(i,n,o=C.OS){if(o===1||!i||!n)return i;let f=k.original===n?k.normalized:void 0;f||(f=n,C.$i&&(f=(0,O.$Be)(f)),f=`${(0,P.$ud)(f,r.$5c.sep)}${r.$5c.sep}`,k={original:n,normalized:f});let b=i;return C.$i&&(b=(0,O.$Be)(b)),(o===3?b.startsWith(f):(0,P.$Md)(b,f))?`~/${b.substr(f.length)}`:i}e.$8z=p;function l(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.$9z=l;const d="\u2026",m="\\\\",c="~";function u(i,n=r.sep){const o=new Array(i.length);let f=!1;for(let b=0;b<i.length;b++){const y=i[b];if(y===""){o[b]=`.${n}`;continue}if(!y){o[b]=y;continue}f=!0;let S="",L=y;L.indexOf(m)===0?(S=L.substr(0,L.indexOf(m)+m.length),L=L.substr(L.indexOf(m)+m.length)):L.indexOf(n)===0?(S=L.substr(0,L.indexOf(n)+n.length),L=L.substr(L.indexOf(n)+n.length)):L.indexOf(c)===0&&(S=L.substr(0,L.indexOf(c)+c.length),L=L.substr(L.indexOf(c)+c.length));const j=L.split(n);for(let Q=1;f&&Q<=j.length;Q++)for(let le=j.length-Q;f&&le>=0;le--){f=!1;let Y=j.slice(le,le+Q).join(n);for(let ee=0;!f&&ee<i.length;ee++)if(ee!==b&&i[ee]&&i[ee].indexOf(Y)>-1){const ue=le+Q===j.length,X=le>0&&i[ee].indexOf(n)>-1?n+Y:Y,he=i[ee].endsWith(X);f=!ue||he}if(!f){let ee="";(j[0].endsWith(":")||S!=="")&&(le===1&&(le=0,Q++,Y=j[0]+n+Y),le>0&&(ee=j[0]+n),ee=S+ee),le>0&&(ee=ee+d+n),ee=ee+Y,le+Q<j.length&&(ee=ee+n+d),o[b]=ee}}f&&(o[b]=y)}return o}e.$0z=u;var h;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function g(i,n=Object.create(null)){const o=[];let f=!1,b="";for(const y of i)if(y==="$"||f&&y==="{")b&&o.push({value:b,type:h.TEXT}),b="",f=!0;else if(y==="}"&&f){const S=n[b];if(typeof S=="string")S.length&&o.push({value:S,type:h.VARIABLE});else if(S){const L=o[o.length-1];(!L||L.type!==h.SEPARATOR)&&o.push({value:S.label,type:h.SEPARATOR})}b="",f=!1}else b+=y;return b&&!f&&o.push({value:b,type:h.TEXT}),o.filter((y,S)=>{if(y.type===h.SEPARATOR){const L=o[S-1],j=o[S+1];return[L,j].every(Q=>Q&&(Q.type===h.VARIABLE||Q.type===h.TEXT)&&Q.value.length>0)}return!0}).map(y=>y.value).join("")}e.$$z=g;function E(i,n){return C.$j||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.$j?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.$_z=E;function v(i,n){return C.$j||n?i.replace(/\(&&\w\)|&&/g,""):C.$i?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$aA=v;function t(i){return i.replace(/&/g,"&&")}e.$bA=t;function s(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const o=a(i.substring(0,n));return{name:o.name,parentPath:o.parentPath+i.substring(n)}}}return a(i)}e.$cA=s;function a(i){const n=i.indexOf("/")!==-1?r.$5c:r.$4c,o=n.basename(i),f=n.dirname(i);return o.length?{name:o,parentPath:f}:{name:f,parentPath:""}}}),define(pe[51],be([1,0,15,4]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.$pm=e.$om=void 0;function r(k){return k.toJSON()}class C{constructor(p){this.a=p}transformIncoming(p){const l=this.a.transformIncoming(p);return l===p?p:r(O.URI.from(l))}transformOutgoing(p){const l=this.a.transformOutgoing(p);return l===p?p:r(O.URI.from(l))}transformOutgoingURI(p){const l=this.a.transformOutgoing(p);return l===p?p:O.URI.from(l)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$om=C,e.$pm=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function I(k,p,l){if(!k||l>200)return null;if(typeof k=="object"){if(k instanceof O.URI)return p.transformOutgoing(k);for(const d in k)if(Object.hasOwnProperty.call(k,d)){const m=I(k[d],p,l+1);m!==null&&(k[d]=m)}}return null}function P(k,p){const l=I(k,p,0);return l===null?k:l}e.$qm=P;function w(k,p,l,d){if(!k||d>200)return null;if(typeof k=="object"){if(k.$mid===1)return l?O.URI.revive(p.transformIncoming(k)):p.transformIncoming(k);if(k instanceof D.$Ec)return null;for(const m in k)if(Object.hasOwnProperty.call(k,m)){const c=w(k[m],p,l,d+1);c!==null&&(k[m]=c)}}return null}function $(k,p){const l=w(k,p,!1,0);return l===null?k:l}e.$rm=$;function A(k,p){const l=w(k,p,!0,0);return l===null?k:l}e.$sm=A}),define(pe[166],be([1,0,28,293,294,3]),function(ce,e,D,O,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4e=void 0;async function I(P){if(C.$j||C.$i)return;let w;for(const $ of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{w=await(0,O.open)($,D.constants.R_OK);break}catch{}if(!w){P("Unable to retrieve release information from known identifier paths.");return}try{const $=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),A={id:"unknown"};for await(const k of(0,r.createInterface)({input:w.createReadStream(),crlfDelay:1/0})){if(!k.includes("="))continue;const p=k.split("=")[0].toUpperCase().trim();if($.has(p)){const l=k.split("=")[1].replace(/"/g,"").toLowerCase().trim();p==="ID"||p==="DISTRIB_ID"?A.id=l:p==="ID_LIKE"?A.id_like=l:(p==="VERSION_ID"||p==="DISTRIB_RELEASE")&&(A.version_id=l)}}return A}catch($){P($)}}e.$4e=I}),define(pe[21],be([1,0,28,29,295,14,39,98,7,3,19,4]),function(ce,e,D,O,r,C,I,P,w,$,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(X){X[X.UNLINK=0]="UNLINK",X[X.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function l(X,he=p.UNLINK,x){if((0,I.$Ke)(X))throw new Error("rimraf - will refuse to recursively delete root");return he===p.UNLINK?m(X):d(X,x)}async function d(X,he=(0,I.$Pe)((0,O.tmpdir)())){try{try{await D.promises.rename(X,he)}catch(x){return x.code==="ENOENT"?void 0:m(X)}m(he).catch(x=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function m(X){return(0,r.promisify)(D.rm)(X,{recursive:!0,force:!0,maxRetries:3})}function c(X){if((0,I.$Ke)(X))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(X,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=c;async function u(X,he){return E(await(he?h(X):(0,r.promisify)(D.readdir)(X)))}async function h(X){try{return await(0,r.promisify)(D.readdir)(X,{withFileTypes:!0})}catch(se){console.warn("[node.js fs] readdir with filetypes failed with error: ",se)}const he=[],x=await u(X);for(const se of x){let V=!1,K=!1,H=!1;try{const te=await e.Promises.lstat((0,w.$8c)(X,se));V=te.isFile(),K=te.isDirectory(),H=te.isSymbolicLink()}catch(te){console.warn("[node.js fs] unexpected error from lstat after readdir: ",te)}he.push({name:se,isFile:()=>V,isDirectory:()=>K,isSymbolicLink:()=>H})}return he}function g(X){return E(D.readdirSync(X))}e.readdirSync=g;function E(X){return X.map(he=>typeof he=="string"?$.$j?(0,P.$7k)(he):he:(he.name=$.$j?(0,P.$7k)(he.name):he.name,he))}async function v(X){const he=await u(X),x=[];for(const se of he)await s.existsDirectory((0,w.$8c)(X,se))&&x.push(se);return x}function t(X,he=1e3){return new Promise(x=>{let se=!1;const V=setInterval(()=>{se||(se=!0,D.access(X,K=>{se=!1,K&&(clearInterval(V),x(void 0))}))},he)})}e.whenDeleted=t;var s;(function(X){async function he(V){let K;try{if(K=await e.Promises.lstat(V),!K.isSymbolicLink())return{stat:K}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:K?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};if($.$i&&H.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(te){if(te.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};throw te}throw H}}X.stat=he;async function x(V){try{const{stat:K,symbolicLink:H}=await X.stat(V);return K.isFile()&&H?.dangling!==!0}catch{}return!1}X.existsFile=x;async function se(V){try{const{stat:K,symbolicLink:H}=await X.stat(V);return K.isDirectory()&&H?.dangling!==!0}catch{}return!1}X.existsDirectory=se})(s||(e.SymlinkSupport=s={}));const a=new C.$Dg;function i(X,he,x){return a.queueFor(k.URI.file(X),A.$Zf).queue(()=>{const se=y(x);return new Promise((V,K)=>f(X,he,se,H=>H?K(H):V()))})}let n=!0;function o(X){n=X}e.configureFlushOnWrite=o;function f(X,he,x,se){if(!n)return D.writeFile(X,he,{mode:x.mode,flag:x.flag},se);D.open(X,x.flag,x.mode,(V,K)=>{if(V)return se(V);D.writeFile(K,he,H=>{if(H)return D.close(K,()=>se(H));D.fdatasync(K,te=>(te&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",te),o(!1)),D.close(K,me=>se(me))))})})}function b(X,he,x){const se=y(x);if(!n)return D.writeFileSync(X,he,{mode:se.mode,flag:se.flag});const V=D.openSync(X,se.flag,se.mode);try{D.writeFileSync(V,he);try{D.fdatasyncSync(V)}catch(K){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",K),o(!1)}}finally{D.closeSync(V)}}e.writeFileSync=b;function y(X){return X?{mode:typeof X.mode=="number"?X.mode:438,flag:typeof X.flag=="string"?X.flag:"w"}:{mode:438,flag:"w"}}async function S(X,he,x=6e4){if(X!==he)try{$.$i&&typeof x=="number"?await L(X,he,Date.now(),x):await(0,r.promisify)(D.rename)(X,he)}catch(se){if(X.toLowerCase()!==he.toLowerCase()&&se.code==="EXDEV"||X.endsWith("."))await j(X,he,{preserveSymlinks:!1}),await l(X,p.MOVE);else throw se}}async function L(X,he,x,se,V=0){try{return await(0,r.promisify)(D.rename)(X,he)}catch(K){if(K.code!=="EACCES"&&K.code!=="EPERM"&&K.code!=="EBUSY")throw K;if(Date.now()-x>=se)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${K}`),K;if(V===0){let H=!1;try{const{stat:te}=await s.stat(he);te.isFile()||(H=!0)}catch{}if(H)throw K}return await(0,C.$vg)(Math.min(100,V*10)),L(X,he,x,se,V+1)}}async function j(X,he,x){return le(X,he,{root:{source:X,target:he},options:x,handledSourcePaths:new Set})}const Q=511;async function le(X,he,x){if(x.handledSourcePaths.has(X))return;x.handledSourcePaths.add(X);const{stat:se,symbolicLink:V}=await s.stat(X);if(V){if(x.options.preserveSymlinks)try{return await ue(X,he,x)}catch(K){console.warn("[node.js fs] copy of symlink failed: ",K)}if(V.dangling)return}return se.isDirectory()?Y(X,he,se.mode&Q,x):ee(X,he,se.mode&Q)}async function Y(X,he,x,se){await e.Promises.mkdir(he,{recursive:!0,mode:x});const V=await u(X);for(const K of V)await le((0,w.$8c)(X,K),(0,w.$8c)(he,K),se)}async function ee(X,he,x){await e.Promises.copyFile(X,he),await e.Promises.chmod(he,x)}async function ue(X,he,x){let se=await e.Promises.readlink(X);(0,I.$He)(se,x.root.source,!$.$k)&&(se=(0,w.$8c)(x.root.target,se.substr(x.root.source.length+1))),await e.Promises.symlink(se,he)}e.Promises=new class{get access(){return(0,r.promisify)(D.access)}get stat(){return(0,r.promisify)(D.stat)}get lstat(){return(0,r.promisify)(D.lstat)}get utimes(){return(0,r.promisify)(D.utimes)}get read(){return(X,he,x,se,V)=>new Promise((K,H)=>{D.read(X,he,x,se,V,(te,me,ne)=>te?H(te):K({bytesRead:me,buffer:ne}))})}get readFile(){return(0,r.promisify)(D.readFile)}get write(){return(X,he,x,se,V)=>new Promise((K,H)=>{D.write(X,he,x,se,V,(te,me,ne)=>te?H(te):K({bytesWritten:me,buffer:ne}))})}get appendFile(){return(0,r.promisify)(D.appendFile)}get fdatasync(){return(0,r.promisify)(D.fdatasync)}get truncate(){return(0,r.promisify)(D.truncate)}get copyFile(){return(0,r.promisify)(D.copyFile)}get open(){return(0,r.promisify)(D.open)}get close(){return(0,r.promisify)(D.close)}get symlink(){return(0,r.promisify)(D.symlink)}get readlink(){return(0,r.promisify)(D.readlink)}get chmod(){return(0,r.promisify)(D.chmod)}get mkdir(){return(0,r.promisify)(D.mkdir)}get unlink(){return(0,r.promisify)(D.unlink)}get rmdir(){return(0,r.promisify)(D.rmdir)}get realpath(){return(0,r.promisify)(D.realpath)}async exists(X){try{return await e.Promises.access(X),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return v}get writeFile(){return i}get rm(){return l}get rename(){return S}get copy(){return j}}}),define(pe[167],be([1,0,28,7,3,17,21]),function(ce,e,D,O,r,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=e.$Mp=e.$Lp=void 0;function P(p){if(r.$k)return p;const l=(0,O.$$c)(p);if(p===l)return p;const d=((0,O.$_c)(p)||p).toLowerCase();try{const c=(0,I.readdirSync)(l).filter(u=>u.toLowerCase()===d);if(c.length===1){const u=P(l);if(u)return(0,O.$8c)(u,c[0])}else if(c.length>1){const u=c.indexOf(d);if(u>=0){const h=P(l);if(h)return(0,O.$8c)(h,c[u])}}}catch{}return null}e.$Lp=P;async function w(p){if(r.$k)return p;const l=(0,O.$$c)(p);if(p===l)return p;const d=((0,O.$_c)(p)||p).toLowerCase();try{const c=(await I.Promises.readdir(l)).filter(u=>u.toLowerCase()===d);if(c.length===1){const u=await w(l);if(u)return(0,O.$8c)(u,c[0])}else if(c.length>1){const u=c.indexOf(d);if(u>=0){const h=await w(l);if(h)return(0,O.$8c)(h,c[u])}}}catch{}return null}e.$Mp=w;async function $(p){try{return await I.Promises.realpath(p)}catch{const d=k(p);return await I.Promises.access(d,D.constants.R_OK),d}}e.$Np=$;function A(p){try{return D.realpathSync(p)}catch{const d=k(p);return D.accessSync(d,D.constants.R_OK),d}}e.$Op=A;function k(p){return(0,C.$ud)((0,O.$6c)(p),O.sep)}}),define(pe[103],be([1,0,29,7,21]),function(ce,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=void 0;const C=/^\d+$/,I=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var w;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(w||(w={}));let $;switch(process.arch){case"ia32":$=1;break;case"arm":case"arm64":$=2;break;default:$=0;break}let A;process.env.PROCESSOR_ARCHITEW6432?A=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?A=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?A=1:A=0;class k{constructor(v,t,s){this.exePath=v,this.displayName=t,this.a=s}async exists(){return this.a===void 0&&(this.a=await r.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:E=!1}={}){return E?$===0?process.env["ProgramFiles(x86)"]||null:A===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function l({useAlternateBitness:E=!1,findPreview:v=!1}={}){const t=p({useAlternateBitness:E});if(!t)return null;const s=O.$8c(t,"PowerShell");if(!await r.SymlinkSupport.existsDirectory(s))return null;let a=-1,i=null;for(const f of await r.Promises.readdir(s)){let b=-1;if(v){const S=f.indexOf("-");if(S<0)continue;const L=f.substring(0,S);if(!C.test(L)||f.substring(S+1)!=="preview")continue;b=parseInt(L,10)}else{if(!C.test(f))continue;b=parseInt(f,10)}if(b<=a)continue;const y=O.$8c(s,f,"pwsh.exe");await r.SymlinkSupport.existsFile(y)&&(i=y,a=b)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",o=v?" Preview":"";return new k(i,`PowerShell${o}${n}`,!0)}async function d({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const v=O.$8c(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await r.SymlinkSupport.existsDirectory(v))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=E?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:I,pwshMsixName:"PowerShell (Store)"};for(const a of await r.Promises.readdir(v))if(t.test(a)){const i=O.$8c(v,a,"pwsh.exe");return new k(i,s)}return null}function m(){const E=O.$8c(D.homedir(),".dotnet","tools","pwsh.exe");return new k(E,".NET Core PowerShell Global Tool")}function c(){const E=O.$8c(process.env.windir,$===1&&A!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k(E,"Windows PowerShell",!0)}async function*u(){let E=await l();E&&(yield E),E=await l({useAlternateBitness:!0}),E&&(yield E),E=await d(),E&&(yield E),E=m(),E&&(yield E),E=await l({findPreview:!0}),E&&(yield E),E=await d({findPreview:!0}),E&&(yield E),E=await l({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=c(),E&&(yield E)}async function*h(){for await(const E of u())await E.exists()&&(yield E)}e.$dl=h;async function g(){for await(const E of h())return E;return null}e.$el=g}),define(pe[104],be([1,0,7,3,30,63,10,21]),function(ce,e,D,O,r,C,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$il=e.$hl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function w(k=r.env){return k.comspec||"cmd.exe"}e.$hl=w;function $(k){let p=[],l=!1;const d=function(m){if(l){p.push(m);return}(!k.send(m,u=>{if(u&&console.error(u),l=!1,p.length>0){const h=p.slice(0);p=[],h.forEach(g=>d(g))}})||O.$i)&&(l=!0)};return{send:d}}e.$il=$;var A;(function(k){async function p(l,d,m){if(D.$7c(l))return l;if(d===void 0&&(d=r.cwd()),D.$$c(l)!=="."||(m===void 0&&I.$ie(r.env.PATH)&&(m=r.env.PATH.split(D.$fd)),m===void 0||m.length===0))return D.$8c(d,l);async function u(h){if(await P.Promises.exists(h)){let g;try{g=await P.Promises.stat(h)}catch(E){E.message.startsWith("EACCES")&&(g=await P.Promises.lstat(h))}return g?!g.isDirectory():!1}return!1}for(const h of m){let g;if(D.$7c(h)?g=D.$8c(h,l):g=D.$8c(d,h,l),await u(g))return g;let E=g+".com";if(await u(E)||(E=g+".exe",await u(E)))return E}return D.$8c(d,l)}k.findExecutable=p})(A||(e.win32=A={}))}),define(pe[105],be([1,0,52,13]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=void 0;function r(I){return new Promise((P,w)=>{let $;const A=new Map;function k(l,d,m,c,u){const h=A.get(d);if(l===I||h){const g={name:p(m),cmd:m,pid:l,ppid:d,load:c,mem:u};A.set(l,g),l===I&&($=g),h&&(h.children||(h.children=[]),h.children.push(g),h.children.length>1&&(h.children=h.children.sort((E,v)=>E.pid-v.pid)))}}function p(l){const d=/--utility-sub-type=network/i,m=/--ms-enable-electron-run-as-node/i,c=/--crashes-directory/i,u=/\\pipe\\winpty-control/i,h=/conhost\.exe.+--headless/i,g=/--type=([a-zA-Z-]+)/;if(c.exec(l))return"electron-crash-reporter";if(u.exec(l))return"winpty-agent";if(h.exec(l))return"conpty-agent";let E=g.exec(l);if(E&&E.length===2)return E[1]==="renderer"?"window":E[1]==="utility"?d.exec(l)?"utility-network-service":"utility-process":E[1]==="extensionHost"?"extension-host":E[1];const v=/[a-zA-Z-]+\.js/g;let t="";do E=v.exec(l),E&&(t+=E+" ");while(E);return t&&l.indexOf("node ")<0&&l.indexOf("node.exe")<0?`electron-nodejs (${t})`:m.exec(l)?`electron-nodejs (${l})`:l}if(process.platform==="win32"){const l=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substring(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substring(5):d;new Promise((d,m)=>{ce(["@vscode/windows-process-tree"],d,m)}).then(d=>{d.getProcessList(I,m=>{if(!m){w(new Error(`Root process ${I} not found`));return}d.getProcessCpuUsage(m,c=>{const u=new Map;c.forEach(h=>{const g=l(h.commandLine||"");u.set(h.pid,{name:p(g),cmd:g,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),$=u.get(I),$?(u.forEach(h=>{const g=u.get(h.ppid);g&&(g.children||(g.children=[]),g.children.push(h))}),u.forEach(h=>{h.children&&(h.children=h.children.sort((g,E)=>g.pid-E.pid))}),P($)):w(new Error(`Root process ${I} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let l=function(){let d=[$];const m=[];for(;d.length;){const u=d.shift();u&&(m.push(u.pid),u.children&&(d=d.concat(u.children)))}let c=JSON.stringify(O.$1e.asFileUri("vs/base/node/cpuUsage.sh").fsPath);c+=" "+m.join(" "),(0,D.exec)(c,{},(u,h,g)=>{if(u||g)w(u||new Error(g.toString()));else{const E=h.toString().split(`
`);for(let v=0;v<m.length;v++){const t=A.get(m[v]);t.load=parseFloat(E[v])}if(!$){w(new Error(`Root process ${I} not found`));return}P($)}})};(0,D.exec)("which ps",{},(d,m,c)=>{if(d||c)if(process.platform!=="linux")w(d||new Error(c.toString()));else{const u=JSON.stringify(O.$1e.asFileUri("vs/base/node/ps.sh").fsPath);(0,D.exec)(u,{},(h,g,E)=>{h||E?w(h||new Error(E.toString())):(C(g,k),l())})}else{const u=m.toString().trim(),h="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${u} ${h}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,E,v)=>{g||v&&!v.includes("screen size is bogus")?w(g||new Error(v.toString())):(C(E,k),process.platform==="linux"?l():$?P($):w(new Error(`Root process ${I} not found`)))})}})}})}e.$jr=r;function C(I,P){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,$=I.toString().split(`
`);for(const A of $){const k=w.exec(A.trim());k&&k.length===6&&P(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}}),define(pe[106],be([1,0,29,3,103,104]),function(ce,e,D,O,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=void 0;async function I(k,p){return k===1?O.$i?A():C.$hl(p):w(k,p)}e.$jl=I;let P=null;function w(k,p){if(O.$k&&k===2||O.$j&&k===3)return"/bin/bash";if(!P){let l;if(O.$i)l="/bin/bash";else{if(l=p.SHELL,!l)try{l=(0,D.userInfo)().shell}catch{}l||(l="sh"),l==="/bin/false"&&(l="/bin/bash")}P=l}return P}let $=null;async function A(){return $||($=(await(0,r.$el)()).exePath),$}});var Le=this&&this.__decorate||function(ce,e,D,O){var r=arguments.length,C=r<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,D):O,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(ce,e,D,O);else for(var P=ce.length-1;P>=0;P--)(I=ce[P])&&(C=(r<3?I(C):r>3?I(e,D,C):I(e,D))||C);return r>3&&C&&Object.defineProperty(e,D,C),C};define(pe[43],be([1,0,18,14,15,20,73,11,5,2,50,17,10]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$g=e.ProxyChannel=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.RequestInitiator=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=void 0;var l;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(l||(l={}));function d(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(m||(m={}));function c(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(u||(u={}));function h(V){let K=0;for(let H=0;;H+=7){const te=V.read(1);if(K|=(te.buffer[0]&127)<<H,!(te.buffer[0]&128))return K}}const g=a(0);function E(V,K){if(K===0){V.write(g);return}let H=0;for(let me=K;me!==0;me=me>>>7)H++;const te=r.$Ec.alloc(H);for(let me=0;K!==0;me++)te.buffer[me]=K&127,K=K>>>7,K>0&&(te.buffer[me]|=128);V.write(te)}class v{constructor(K){this.b=K,this.a=0}read(K){const H=this.b.slice(this.a,this.a+K);return this.a+=H.byteLength,H}}e.$Zg=v;class t{constructor(){this.a=[]}get buffer(){return r.$Ec.concat(this.a)}write(K){this.a.push(K)}}e.$1g=t;var s;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(s||(s={}));function a(V){const K=r.$Ec.alloc(1);return K.writeUInt8(V,0),K}const i={Undefined:a(s.Undefined),String:a(s.String),Buffer:a(s.Buffer),VSBuffer:a(s.VSBuffer),Array:a(s.Array),Object:a(s.Object),Uint:a(s.Int)},n=typeof Buffer<"u";function o(V,K){if(typeof K>"u")V.write(i.Undefined);else if(typeof K=="string"){const H=r.$Ec.fromString(K);V.write(i.String),E(V,H.byteLength),V.write(H)}else if(n&&Buffer.isBuffer(K)){const H=r.$Ec.wrap(K);V.write(i.Buffer),E(V,H.byteLength),V.write(H)}else if(K instanceof r.$Ec)V.write(i.VSBuffer),E(V,K.byteLength),V.write(K);else if(Array.isArray(K)){V.write(i.Array),E(V,K.length);for(const H of K)o(V,H)}else if(typeof K=="number"&&(K|0)===K)V.write(i.Uint),E(V,K);else{const H=r.$Ec.fromString(JSON.stringify(K));V.write(i.Object),E(V,H.byteLength),V.write(H)}}e.$2g=o;function f(V){switch(V.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return V.read(h(V)).toString();case s.Buffer:return V.read(h(V)).buffer;case s.VSBuffer:return V.read(h(V));case s.Array:{const H=h(V),te=[];for(let me=0;me<H;me++)te.push(f(V));return te}case s.Object:return JSON.parse(V.read(h(V)).toString());case s.Int:return h(V)}}e.$3g=f;class b{constructor(K,H,te=null,me=1e3){this.h=K,this.j=H,this.k=te,this.l=me,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ne=>this.q(ne)),this.m({type:200})}registerChannel(K,H){this.b.set(K,H),setTimeout(()=>this.w(K),0)}m(K){switch(K.type){case 200:{const H=this.o([K.type]);this.k?.logOutgoing(H,0,1,c(K.type));return}case 201:case 202:case 204:case 203:{const H=this.o([K.type,K.id],K.data);this.k?.logOutgoing(H,K.id,1,c(K.type),K.data);return}}}o(K,H=void 0){const te=new t;return o(te,K),o(te,H),this.p(te.buffer)}p(K){try{return this.h.send(K),K.byteLength}catch{return 0}}q(K){const H=new v(K),te=f(H),me=f(H),ne=te[0];switch(ne){case 100:return this.k?.logIncoming(K.byteLength,te[1],1,`${d(ne)}: ${te[2]}.${te[3]}`,me),this.s({type:ne,id:te[1],channelName:te[2],name:te[3],arg:me});case 102:return this.k?.logIncoming(K.byteLength,te[1],1,`${d(ne)}: ${te[2]}.${te[3]}`,me),this.t({type:ne,id:te[1],channelName:te[2],name:te[3],arg:me});case 101:return this.k?.logIncoming(K.byteLength,te[1],1,`${d(ne)}`),this.u({type:ne,id:te[1]});case 103:return this.k?.logIncoming(K.byteLength,te[1],1,`${d(ne)}`),this.u({type:ne,id:te[1]})}}s(K){const H=this.b.get(K.channelName);if(!H){this.v(K);return}const te=new C.$oc;let me;try{me=H.call(this.j,K.name,K.arg,te.token)}catch(J){me=Promise.reject(J)}const ne=K.id;me.then(J=>{this.m({id:ne,data:J,type:201}),this.d.delete(K.id)},J=>{J instanceof Error?this.m({id:ne,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split?J.stack.split(`
`):J.stack:void 0},type:202}):this.m({id:ne,data:J,type:203}),this.d.delete(K.id)});const q=(0,$.$jb)(()=>te.cancel());this.d.set(K.id,q)}t(K){const H=this.b.get(K.channelName);if(!H){this.v(K);return}const te=K.id,ne=H.listen(this.j,K.name,K.arg)(q=>this.m({id:te,data:q,type:204}));this.d.set(K.id,ne)}u(K){const H=this.d.get(K.id);H&&(H.dispose(),this.d.delete(K.id))}v(K){let H=this.g.get(K.channelName);H||(H=[],this.g.set(K.channelName,H));const te=setTimeout(()=>{console.error(`Unknown channel: ${K.channelName}`),K.type===100&&this.m({id:K.id,data:{name:"Unknown channel",message:`Channel name '${K.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);H.push({request:K,timeoutTimer:te})}w(K){const H=this.g.get(K);if(H){for(const te of H)switch(clearTimeout(te.timeoutTimer),te.request.type){case 100:this.s(te.request);break;case 102:this.t(te.request);break}this.g.delete(K)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,$.$gb)(this.d.values()),this.d.clear()}}e.$4g=b;var y;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class S{constructor(K,H=null){this.l=K,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new w.$ec,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(te=>this.s(te)),this.j=H}getChannel(K){const H=this;return{call(te,me,ne){return H.a?Promise.reject(new P.$3):H.m(K,te,me,ne)},listen(te,me){return H.a?w.Event.None:H.o(K,te,me)}}}m(K,H,te,me=C.CancellationToken.None){const ne=this.g++,J={id:ne,type:100,channelName:K,name:H,arg:te};if(me.isCancellationRequested)return Promise.reject(new P.$3);let R;return new Promise((W,ie)=>{if(me.isCancellationRequested)return ie(new P.$3);const re=()=>{const B=U=>{switch(U.type){case 201:this.f.delete(ne),W(U.data);break;case 202:{this.f.delete(ne);const z=new Error(U.data.message);z.stack=Array.isArray(U.data.stack)?U.data.stack.join(`
`):U.data.stack,z.name=U.data.name,ie(z);break}case 203:this.f.delete(ne),ie(U.data);break}};this.f.set(ne,B),this.p(J)};let _=null;this.b===u.Idle?re():(_=(0,O.$ig)(B=>this.u()),_.then(()=>{_=null,re()}));const oe=()=>{_?(_.cancel(),_=null):this.p({id:ne,type:101}),ie(new P.$3)},N=me.onCancellationRequested(oe);R=(0,$.$ib)((0,$.$jb)(oe),N),this.d.add(R)}).finally(()=>{this.d.delete(R)})}o(K,H,te){const me=this.g++,q={id:me,type:102,channelName:K,name:H,arg:te};let J=null;const R=new w.$ec({onWillAddFirstListener:()=>{J=(0,O.$ig)(W=>this.u()),J.then(()=>{J=null,this.d.add(R),this.p(q)})},onDidRemoveLastListener:()=>{J?(J.cancel(),J=null):(this.d.delete(R),this.p({id:me,type:103}))}}),F=W=>R.fire(W.data);return this.f.set(me,F),R.event}p(K){switch(K.type){case 100:case 102:{const H=this.q([K.type,K.id,K.channelName,K.name],K.arg);this.j?.logOutgoing(H,K.id,0,`${d(K.type)}: ${K.channelName}.${K.name}`,K.arg);return}case 101:case 103:{const H=this.q([K.type,K.id]);this.j?.logOutgoing(H,K.id,0,d(K.type));return}}}q(K,H=void 0){const te=new t;return o(te,K),o(te,H),this.r(te.buffer)}r(K){try{return this.l.send(K),K.byteLength}catch{return 0}}s(K){const H=new v(K),te=f(H),me=f(H),ne=te[0];switch(ne){case 200:return this.j?.logIncoming(K.byteLength,0,0,c(ne)),this.t({type:te[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(K.byteLength,te[1],0,c(ne),me),this.t({type:te[0],id:te[1],data:me})}}t(K){if(K.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(K.id)?.(K)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,$.$gb)(this.d.values()),this.d.clear()}}e.$5g=S,Le([I.$Tg],S.prototype,"onDidInitializePromise",null);class L{get connections(){const K=[];return this.f.forEach(H=>K.push(H)),K}constructor(K){this.a=new Map,this.f=new Set,this.g=new w.$ec,this.onDidAddConnection=this.g.event,this.h=new w.$ec,this.onDidRemoveConnection=this.h.event,K(({protocol:H,onDidClientDisconnect:te})=>{w.Event.once(H.onMessage)(ne=>{const q=new v(ne),J=f(q),R=new b(H,J),F=new S(H);this.a.forEach((ie,re)=>R.registerChannel(re,ie));const W={channelServer:R,channelClient:F,ctx:J};this.f.add(W),this.g.fire(W),te(()=>{R.dispose(),F.dispose(),this.f.delete(W),this.h.fire(W)})})})}getChannel(K,H){const te=this;return{call(me,ne,q){let J;if((0,p.$we)(H)){const F=(0,D.$Hf)(te.connections.filter(H));J=F?Promise.resolve(F):w.Event.toPromise(w.Event.filter(te.onDidAddConnection,H))}else J=H.routeCall(te,me,ne);const R=J.then(F=>F.channelClient.getChannel(K));return Q(R).call(me,ne,q)},listen(me,ne){if((0,p.$we)(H))return te.j(K,H,me,ne);const q=H.routeEvent(te,me,ne).then(J=>J.channelClient.getChannel(K));return Q(q).listen(me,ne)}}}j(K,H,te,me){const ne=this;let q=new $.$kb;const J=new w.$ec({onWillAddFirstListener:()=>{q=new $.$kb;const R=new w.$kc,F=new Map,W=re=>{const oe=re.channelClient.getChannel(K).listen(te,me),N=R.add(oe);F.set(re,N)},ie=re=>{const _=F.get(re);_&&(_.dispose(),F.delete(re))};ne.connections.filter(H).forEach(W),w.Event.filter(ne.onDidAddConnection,H)(W,void 0,q),ne.onDidRemoveConnection(ie,void 0,q),R.event(J.fire,J,q),q.add(R)},onDidRemoveLastListener:()=>{q.dispose()}});return J.event}registerChannel(K,H){this.a.set(K,H),this.f.forEach(te=>{te.channelServer.registerChannel(K,H)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.$6g=L;class j{constructor(K,H,te=null){const me=new t;o(me,H),K.send(me.buffer),this.a=new S(K,te),this.d=new b(K,H,te)}getChannel(K){return this.a.getChannel(K)}registerChannel(K,H){this.d.registerChannel(K,H)}dispose(){this.a.dispose(),this.d.dispose()}}e.$7g=j;function Q(V){return{call(K,H,te){return V.then(me=>me.call(K,H,te))},listen(K,H){const te=new w.$nc;return V.then(me=>te.input=me.listen(K,H)),te.event}}}e.$8g=Q;function le(V){let K=!1;return{call(H,te,me){return K?V.call(H,te,me):(0,O.$vg)(0).then(()=>K=!0).then(()=>V.call(H,te,me))},listen(H,te){if(K)return V.listen(H,te);const me=new w.$nc;return(0,O.$vg)(0).then(()=>K=!0).then(()=>me.input=V.listen(H,te)),me.event}}}e.$9g=le;class Y{constructor(K){this.a=K}routeCall(K){return this.b(K)}routeEvent(K){return this.b(K)}async b(K){for(const H of K.connections)if(await Promise.resolve(this.a(H.ctx)))return Promise.resolve(H);return await w.Event.toPromise(K.onDidAddConnection),await this.b(K)}}e.$0g=Y;var ee;(function(V){function K(ne,q){const J=ne,R=q&&q.disableMarshalling,F=new Map;for(const W in J)te(W)&&F.set(W,w.Event.buffer(J[W],!0));return new class{listen(W,ie,re){const _=F.get(ie);if(_)return _;if(me(ie)){const oe=J[ie];if(typeof oe=="function")return oe.call(J,re)}throw new P.$ab(`Event not found: ${ie}`)}call(W,ie,re){const _=J[ie];if(typeof _=="function"){if(!R&&Array.isArray(re))for(let oe=0;oe<re.length;oe++)re[oe]=(0,A.$Yg)(re[oe]);return _.apply(J,re)}throw new P.$ab(`Method not found: ${ie}`)}}}V.fromService=K;function H(ne,q){const J=q&&q.disableMarshalling;return new Proxy({},{get(R,F){if(typeof F=="string")return q?.properties?.has(F)?q.properties.get(F):me(F)?function(W){return ne.listen(F,W)}:te(F)?ne.listen(F):async function(...W){let ie;q&&!(0,p.$re)(q.context)?ie=[q.context,...W]:ie=W;const re=await ne.call(F,ie);return J?re:(0,A.$Yg)(re)};throw new P.$ab(`Property not found: ${String(F)}`)}})}V.toService=H;function te(ne){return ne[0]==="o"&&ne[1]==="n"&&k.$Kd(ne.charCodeAt(2))}function me(ne){return/^onDynamic/.test(ne)&&k.$Kd(ne.charCodeAt(9))}})(ee||(e.ProxyChannel=ee={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function X(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const K=V.toString();if(K!=="[object Object]")return K}return V}function he(V){return Array.isArray(V)?V.map(X):X(V)}function x(V,K,H,te,me,ne,q){q=he(q);const J=ue[me],R=J[te%J.length];let F=[`%c[${V}]%c[${String(K).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(te).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${R}`];/\($/.test(ne)?(F=F.concat(q),F.push(")")):F.push(q),console.log.apply(console,F)}class se{constructor(K,H){this.d=K,this.f=H,this.a=0,this.b=0}logOutgoing(K,H,te,me,ne){this.b+=K,x(this.d,this.b,K,H,te,me,ne)}logIncoming(K,H,te,me,ne){this.a+=K,x(this.f,this.a,K,H,te,me,ne)}}e.$$g=se}),define(pe[107],be([1,0,15,5,2,43]),function(ce,e,D,O,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dh=e.$ch=e.$bh=e.$ah=e.ProtocolConstants=e.$_g=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var I;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(I||(e.SocketDiagnosticsEventType=I={}));var P;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let o=0;function f(y,S){if(!n.has(y)){const L=String(++o);n.set(y,L)}return n.get(y)}function b(y,S,L,j){if(!i.enableDiagnostics)return;const Q=f(y,S);if(j instanceof D.$Ec||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const le=D.$Ec.alloc(j.byteLength);le.set(j),i.records.push({timestamp:Date.now(),id:Q,label:S,type:L,buff:le})}else i.records.push({timestamp:Date.now(),id:Q,label:S,type:L,data:j})}i.traceSocketEvent=b})(P||(e.SocketDiagnostics=P={}));var w;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w||(e.SocketCloseEventType=w={}));let $=null;function A(){return $||($=D.$Ec.alloc(0)),$}class k{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,o){if(n===0)return A();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const S=this.a[0];return o&&(this.a.shift(),this.b-=n),S}if(this.a[0].byteLength>n){const S=this.a[0].slice(0,n);return o&&(this.a[0]=this.a[0].slice(n),this.b-=n),S}const f=D.$Ec.alloc(n);let b=0,y=0;for(;n>0;){const S=this.a[y];if(S.byteLength>n){const L=S.slice(0,n);f.set(L,b),b+=n,o&&(this.a[y]=S.slice(n),this.b-=n),n-=n}else f.set(S,b),b+=S.byteLength,o?(this.a.shift(),this.b-=S.byteLength):y++,n-=S.byteLength}return f}}e.$_g=k;var p;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(p||(p={}));function l(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(d||(e.ProtocolConstants=d={}));class m{constructor(n,o,f,b){this.type=n,this.id=o,this.ack=f,this.data=b,this.writtenTime=0}get size(){return this.data.byteLength}}class c extends r.$lb{constructor(n){super(),this.f=this.B(new O.$ec),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new k,this.B(this.a.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const o=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=o.readUInt32BE(9),this.g.messageType=o.readUInt8(0),this.g.id=o.readUInt32BE(1),this.g.ack=o.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:l(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const f=this.g.messageType,b=this.g.id,y=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",o),this.f.fire(new m(f,b,y,o)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=D.$Ec.alloc(13);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:l(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(o,n.data)}g(n,o){const f=this.f===0;return this.d.push(n,o),this.f+=n.byteLength+o.byteLength,f}h(){const n=D.$Ec.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,o){this.g(n,o)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class h extends r.$lb{constructor(n){super(),this.f=new O.$ec,this.onMessage=this.f.event,this.g=new O.$ec,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new u(this.a)),this.c=this.B(new c(this.a)),this.B(this.c.onMessage(o=>{o.type===1&&this.f.fire(o.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new m(1,0,0,n))}}e.$ah=h;class g extends C.$7g{static fromSocket(n,o){return new g(new h(n),o)}get onDidDispose(){return this.b.onDidDispose}constructor(n,o,f=null){super(n,o,f),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$bh=g;class E{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new O.$ec({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$ch=E;class v{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,o=this.a;for(;o;)o=o.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let o=0,f=this.a;for(;f;)n[o++]=f.data,f=f.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const o=new v(n);if(!this.a){this.a=o,this.b=o;return}this.b.next=o,this.b=o}}class s{static{this.a=10}static{this.b=null}static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const n=Date.now();for(let o=0;o<s.a;o++)this.c[o]=n-1e3*o;setInterval(()=>{for(let o=s.a;o>=1;o--)this.c[o]=this.c[o-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),o=(1+s.a)*1e3;let f=0;for(let b=0;b<s.a;b++)n-this.c[b]<=o&&f++;return 1-f/s.a}hasHighLoad(){return this.d()>=.5}}class a{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new E,this.onControlMessage=this.u.event,this.v=new E,this.onMessage=this.v.event,this.w=new E,this.onDidDispose=this.w.event,this.x=new E,this.onSocketClose=this.x.event,this.y=new E,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??s.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new r.$kb,this.o=n.socket,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new c(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new m(5,0,0,A());this.p.write(n),this.p.flush()}sendPause(){const n=new m(7,0,0,A());this.p.write(n)}sendResume(){const n=new m(8,0,0,A());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,o){this.a=!0,this.r.dispose(),this.r=new r.$kb,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new c(this.o)),this.r.add(this.q.onMessage(f=>this.z(f))),this.r.add(this.o.onClose(f=>this.x.fire(f))),this.q.acceptChunk(o)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new m(3,0,this.h,A());this.p.write(n);const o=this.b.toArray();for(let f=0,b=o.length;f<b;f++)this.p.write(o[f]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const o=this.b.peek();if(o&&o.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const o=Date.now();o-this.m>1e4&&(this.m=o,this.p.write(new m(6,0,0,A())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const o=this.b.toArray();for(let f=0,b=o.length;f<b;f++)this.p.write(o[f]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const o=++this.c;this.h=this.g;const f=new m(1,o,this.h,n);this.b.push(f),this.a||(this.p.write(f),this.B())}sendControl(n){const o=new m(2,0,0,n);this.p.write(o)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),o=Date.now()-n.writtenTime,f=Date.now()-this.q.lastReadTime,b=Date.now()-this.n;if(o>=2e4&&f>=2e4&&b>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:f});return}const y=Math.max(2e4-o,2e4-f,2e4-b,500);this.f=setTimeout(()=>{this.f=null,this.B()},y)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new m(3,0,this.h,A());this.p.write(n)}D(){this.h=this.g;const n=new m(9,0,this.h,A());this.p.write(n)}}e.$dh=a}),define(pe[108],be([1,0,52,14,15,20,163,11,5,2,22,104,63,43]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=void 0;class d extends l.$4g{constructor(u){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",h=>r.$Ec.wrap(Buffer.from(h,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.$Ip=d;class m{constructor(u,h){this.i=u,this.j=h,this.c=new Set,this.g=new Map,this.h=new w.$ec,this.onDidProcessExit=this.h.event;const g=h&&h.timeout?h.timeout:6e4;this.b=new O.$rg(g),this.d=null,this.f=null}getChannel(u){const h=this;return{call(g,E,v){return h.k(u,g,E,v)},listen(g,E){return h.l(u,g,E)}}}k(u,h,g,E=C.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(P.$4());this.b.cancel();const v=this.n(u),t=(0,O.$ig)(i=>v.call(h,g,i)),s=E.onCancellationRequested(()=>t.cancel()),a=(0,$.$jb)(()=>t.cancel());return this.c.add(a),t.finally(()=>{s.dispose(),this.c.delete(a),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(u,h,g){if(!this.b)return w.Event.None;this.b.cancel();let E;const v=new w.$ec({onWillAddFirstListener:()=>{E=this.n(u).listen(h,g)(v.fire,v),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return v.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],h=Object.create(null);h.env={...(0,A.$Im)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(h.env={...h.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(h.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,p.$gl)(h.env),this.d=(0,D.fork)(this.i,u,h);const g=new w.$ec;w.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,I.$Ep)(n)){(0,I.log)(n,`IPC Library: ${this.j.serverName}`);return}g.fire(r.$Ec.wrap(Buffer.from(n,"base64")))});const v=this.j.useQueue?(0,k.$il)(this.d):this.d,t=n=>this.d&&this.d.connected&&v.send(n.buffer.toString("base64")),s=g.event,a={send:t,onMessage:s};this.f=new l.$5g(a);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,o)=>{process.removeListener("exit",i),this.c.forEach(f=>(0,$.$gb)(f)),this.c.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:o})})}return this.f}n(u){let h=this.g.get(u);return h||(h=this.m.getChannel(u),this.g.set(u,h)),h}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Jp=m}),define(pe[168],be([1,0,14,5,2,50,10]),function(ce,e,D,O,r,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Io=e.StorageState=e.$Ho=e.StorageHint=void 0;var P;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function w(p){const l=p;return l?.changed instanceof Map||l?.deleted instanceof Set}e.$Ho=w;var $;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})($||(e.StorageState=$={}));class A extends r.$lb{static{this.a=100}constructor(l,d=Object.create(null)){super(),this.m=l,this.n=d,this.b=this.B(new O.$hc),this.onDidChangeStorage=this.b.event,this.c=$.None,this.f=new Map,this.g=new D.$sg(A.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(l=>this.r(l)))}r(l){this.b.pause();try{l.changed?.forEach((d,m)=>this.s(m,d)),l.deleted?.forEach(d=>this.s(d,void 0))}finally{this.b.resume()}}s(l,d){if(this.c===$.Closed)return;let m=!1;(0,I.$re)(d)?m=this.f.delete(l):this.f.get(l)!==d&&(this.f.set(l,d),m=!0),m&&this.b.fire({key:l,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===$.None&&(this.c=$.Initialized,this.n.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(l,d){const m=this.f.get(l);return(0,I.$re)(m)?d:m}getBoolean(l,d){const m=this.get(l);return(0,I.$re)(m)?d:m==="true"}getNumber(l,d){const m=this.get(l);return(0,I.$re)(m)?d:parseInt(m,10)}getObject(l,d){const m=this.get(l);return(0,I.$re)(m)?d:(0,C.$Xg)(m)}async set(l,d,m=!1){if(this.c===$.Closed)return;if((0,I.$re)(d))return this.delete(l,m);const c=(0,I.$ke)(d)||Array.isArray(d)?(0,C.$Wg)(d):String(d);if(this.f.get(l)!==c)return this.f.set(l,c),this.j.set(l,c),this.h.delete(l),this.b.fire({key:l,external:m}),this.w()}async delete(l,d=!1){if(!(this.c===$.Closed||!this.f.delete(l)))return this.h.has(l)||this.h.add(l),this.j.delete(l),this.b.fire({key:l,external:d}),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=$.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const l={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(l).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(l){if(this.u)return this.w(l)}async w(l){return this.g.trigger(()=>this.v(),l)}async whenFlushed(){if(this.u)return new Promise(l=>this.l.push(l))}isInMemory(){return this.n.hint===P.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.$Io=A;class k{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(l){l.insert?.forEach((d,m)=>this.a.set(m,d)),l.delete?.forEach(d=>this.a.delete(d))}async close(){}}e.$Jo=k}),define(pe[169],be([8,9]),function(ce,e){return ce.create("vs/base/node/zip",e)}),define(pe[170],be([8,9]),function(ce,e){return ce.create("vs/editor/common/languages",e)}),define(pe[171],be([1,0,49,4,153,42,154,170]),function(ce,e,D,O,r,C,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$Cs=e.$Bs=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$As=e.$zs=e.SymbolKinds=e.SymbolTag=e.$ys=e.$xs=e.SymbolKind=e.$ws=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$vs=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$us=e.$ts=e.$ss=void 0;class w{constructor(ee,ue,X){this.offset=ee,this.type=ue,this.language=X,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$ss=w;class ${constructor(ee,ue){this.tokens=ee,this.endState=ue,this._tokenizationResultBrand=void 0}}e.$ts=$;class A{constructor(ee,ue){this.tokens=ee,this.endState=ue,this._encodedTokenizationResultBrand=void 0}}e.$us=A;var k;(function(Y){Y[Y.Method=0]="Method",Y[Y.Function=1]="Function",Y[Y.Constructor=2]="Constructor",Y[Y.Field=3]="Field",Y[Y.Variable=4]="Variable",Y[Y.Class=5]="Class",Y[Y.Struct=6]="Struct",Y[Y.Interface=7]="Interface",Y[Y.Module=8]="Module",Y[Y.Property=9]="Property",Y[Y.Event=10]="Event",Y[Y.Operator=11]="Operator",Y[Y.Unit=12]="Unit",Y[Y.Value=13]="Value",Y[Y.Constant=14]="Constant",Y[Y.Enum=15]="Enum",Y[Y.EnumMember=16]="EnumMember",Y[Y.Keyword=17]="Keyword",Y[Y.Text=18]="Text",Y[Y.Color=19]="Color",Y[Y.File=20]="File",Y[Y.Reference=21]="Reference",Y[Y.Customcolor=22]="Customcolor",Y[Y.Folder=23]="Folder",Y[Y.TypeParameter=24]="TypeParameter",Y[Y.User=25]="User",Y[Y.Issue=26]="Issue",Y[Y.Snippet=27]="Snippet"})(k||(e.CompletionItemKind=k={}));var p;(function(Y){const ee=new Map;ee.set(0,D.$Cj.symbolMethod),ee.set(1,D.$Cj.symbolFunction),ee.set(2,D.$Cj.symbolConstructor),ee.set(3,D.$Cj.symbolField),ee.set(4,D.$Cj.symbolVariable),ee.set(5,D.$Cj.symbolClass),ee.set(6,D.$Cj.symbolStruct),ee.set(7,D.$Cj.symbolInterface),ee.set(8,D.$Cj.symbolModule),ee.set(9,D.$Cj.symbolProperty),ee.set(10,D.$Cj.symbolEvent),ee.set(11,D.$Cj.symbolOperator),ee.set(12,D.$Cj.symbolUnit),ee.set(13,D.$Cj.symbolValue),ee.set(15,D.$Cj.symbolEnum),ee.set(14,D.$Cj.symbolConstant),ee.set(15,D.$Cj.symbolEnum),ee.set(16,D.$Cj.symbolEnumMember),ee.set(17,D.$Cj.symbolKeyword),ee.set(27,D.$Cj.symbolSnippet),ee.set(18,D.$Cj.symbolText),ee.set(19,D.$Cj.symbolColor),ee.set(20,D.$Cj.symbolFile),ee.set(21,D.$Cj.symbolReference),ee.set(22,D.$Cj.symbolCustomColor),ee.set(23,D.$Cj.symbolFolder),ee.set(24,D.$Cj.symbolTypeParameter),ee.set(25,D.$Cj.account),ee.set(26,D.$Cj.issues);function ue(x){let se=ee.get(x);return se||(console.info("No codicon found for CompletionItemKind "+x),se=D.$Cj.symbolProperty),se}Y.toIcon=ue;const X=new Map;X.set("method",0),X.set("function",1),X.set("constructor",2),X.set("field",3),X.set("variable",4),X.set("class",5),X.set("struct",6),X.set("interface",7),X.set("module",8),X.set("property",9),X.set("event",10),X.set("operator",11),X.set("unit",12),X.set("value",13),X.set("constant",14),X.set("enum",15),X.set("enum-member",16),X.set("enumMember",16),X.set("keyword",17),X.set("snippet",27),X.set("text",18),X.set("color",19),X.set("file",20),X.set("reference",21),X.set("customcolor",22),X.set("folder",23),X.set("type-parameter",24),X.set("typeParameter",24),X.set("account",25),X.set("issue",26);function he(x,se){let V=X.get(x);return typeof V>"u"&&!se&&(V=9),V}Y.fromString=he})(p||(e.CompletionItemKinds=p={}));var l;(function(Y){Y[Y.Deprecated=1]="Deprecated"})(l||(e.CompletionItemTag=l={}));var d;(function(Y){Y[Y.None=0]="None",Y[Y.KeepWhitespace=1]="KeepWhitespace",Y[Y.InsertAsSnippet=4]="InsertAsSnippet"})(d||(e.CompletionItemInsertTextRule=d={}));var m;(function(Y){Y[Y.Invoke=0]="Invoke",Y[Y.TriggerCharacter=1]="TriggerCharacter",Y[Y.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m||(e.CompletionTriggerKind=m={}));var c;(function(Y){Y[Y.Automatic=0]="Automatic",Y[Y.Explicit=1]="Explicit"})(c||(e.InlineCompletionTriggerKind=c={}));class u{constructor(ee,ue,X,he){this.range=ee,this.text=ue,this.completionKind=X,this.isSnippetText=he}equals(ee){return C.$Ur.lift(this.range).equalsRange(ee.range)&&this.text===ee.text&&this.completionKind===ee.completionKind&&this.isSnippetText===ee.isSnippetText}}e.$vs=u;var h;(function(Y){Y[Y.Invoke=1]="Invoke",Y[Y.Auto=2]="Auto"})(h||(e.CodeActionTriggerType=h={}));var g;(function(Y){Y[Y.Invoke=1]="Invoke",Y[Y.TriggerCharacter=2]="TriggerCharacter",Y[Y.ContentChange=3]="ContentChange"})(g||(e.SignatureHelpTriggerKind=g={}));var E;(function(Y){Y[Y.Text=0]="Text",Y[Y.Read=1]="Read",Y[Y.Write=2]="Write"})(E||(e.DocumentHighlightKind=E={}));function v(Y){return Y&&O.URI.isUri(Y.uri)&&C.$Ur.isIRange(Y.range)&&(C.$Ur.isIRange(Y.originSelectionRange)||C.$Ur.isIRange(Y.targetSelectionRange))}e.$ws=v;var t;(function(Y){Y[Y.File=0]="File",Y[Y.Module=1]="Module",Y[Y.Namespace=2]="Namespace",Y[Y.Package=3]="Package",Y[Y.Class=4]="Class",Y[Y.Method=5]="Method",Y[Y.Property=6]="Property",Y[Y.Field=7]="Field",Y[Y.Constructor=8]="Constructor",Y[Y.Enum=9]="Enum",Y[Y.Interface=10]="Interface",Y[Y.Function=11]="Function",Y[Y.Variable=12]="Variable",Y[Y.Constant=13]="Constant",Y[Y.String=14]="String",Y[Y.Number=15]="Number",Y[Y.Boolean=16]="Boolean",Y[Y.Array=17]="Array",Y[Y.Object=18]="Object",Y[Y.Key=19]="Key",Y[Y.Null=20]="Null",Y[Y.EnumMember=21]="EnumMember",Y[Y.Struct=22]="Struct",Y[Y.Event=23]="Event",Y[Y.Operator=24]="Operator",Y[Y.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$xs={[17]:(0,P.localize)(0,null),[16]:(0,P.localize)(1,null),[4]:(0,P.localize)(2,null),[13]:(0,P.localize)(3,null),[8]:(0,P.localize)(4,null),[9]:(0,P.localize)(5,null),[21]:(0,P.localize)(6,null),[23]:(0,P.localize)(7,null),[7]:(0,P.localize)(8,null),[0]:(0,P.localize)(9,null),[11]:(0,P.localize)(10,null),[10]:(0,P.localize)(11,null),[19]:(0,P.localize)(12,null),[5]:(0,P.localize)(13,null),[1]:(0,P.localize)(14,null),[2]:(0,P.localize)(15,null),[20]:(0,P.localize)(16,null),[15]:(0,P.localize)(17,null),[18]:(0,P.localize)(18,null),[24]:(0,P.localize)(19,null),[3]:(0,P.localize)(20,null),[6]:(0,P.localize)(21,null),[14]:(0,P.localize)(22,null),[22]:(0,P.localize)(23,null),[25]:(0,P.localize)(24,null),[12]:(0,P.localize)(25,null)};function s(Y,ee){return(0,P.localize)(26,null,Y,e.$xs[ee])}e.$ys=s;var a;(function(Y){Y[Y.Deprecated=1]="Deprecated"})(a||(e.SymbolTag=a={}));var i;(function(Y){const ee=new Map;ee.set(0,D.$Cj.symbolFile),ee.set(1,D.$Cj.symbolModule),ee.set(2,D.$Cj.symbolNamespace),ee.set(3,D.$Cj.symbolPackage),ee.set(4,D.$Cj.symbolClass),ee.set(5,D.$Cj.symbolMethod),ee.set(6,D.$Cj.symbolProperty),ee.set(7,D.$Cj.symbolField),ee.set(8,D.$Cj.symbolConstructor),ee.set(9,D.$Cj.symbolEnum),ee.set(10,D.$Cj.symbolInterface),ee.set(11,D.$Cj.symbolFunction),ee.set(12,D.$Cj.symbolVariable),ee.set(13,D.$Cj.symbolConstant),ee.set(14,D.$Cj.symbolString),ee.set(15,D.$Cj.symbolNumber),ee.set(16,D.$Cj.symbolBoolean),ee.set(17,D.$Cj.symbolArray),ee.set(18,D.$Cj.symbolObject),ee.set(19,D.$Cj.symbolKey),ee.set(20,D.$Cj.symbolNull),ee.set(21,D.$Cj.symbolEnumMember),ee.set(22,D.$Cj.symbolStruct),ee.set(23,D.$Cj.symbolEvent),ee.set(24,D.$Cj.symbolOperator),ee.set(25,D.$Cj.symbolTypeParameter);function ue(X){let he=ee.get(X);return he||(console.info("No codicon found for SymbolKind "+X),he=D.$Cj.symbolProperty),he}Y.toIcon=ue})(i||(e.SymbolKinds=i={}));class n{static asEditOperation(ee){return r.$2r.replace(C.$Ur.lift(ee.range),ee.text)}}e.$zs=n;class o{static{this.Comment=new o("comment")}static{this.Imports=new o("imports")}static{this.Region=new o("region")}static fromValue(ee){switch(ee){case"comment":return o.Comment;case"imports":return o.Imports;case"region":return o.Region}return new o(ee)}constructor(ee){this.value=ee}}e.$As=o;var f;(function(Y){function ee(ue){return!ue||typeof ue!="object"?!1:typeof ue.id=="string"&&typeof ue.title=="string"}Y.is=ee})(f||(e.Command=f={}));var b;(function(Y){Y[Y.Collapsed=0]="Collapsed",Y[Y.Expanded=1]="Expanded"})(b||(e.CommentThreadCollapsibleState=b={}));var y;(function(Y){Y[Y.Unresolved=0]="Unresolved",Y[Y.Resolved=1]="Resolved"})(y||(e.CommentThreadState=y={}));var S;(function(Y){Y[Y.Editing=0]="Editing",Y[Y.Preview=1]="Preview"})(S||(e.CommentMode=S={}));var L;(function(Y){Y[Y.Published=0]="Published",Y[Y.Draft=1]="Draft"})(L||(e.CommentState=L={}));var j;(function(Y){Y[Y.Type=1]="Type",Y[Y.Parameter=2]="Parameter"})(j||(e.InlayHintKind=j={}));class Q{constructor(ee){this.b=ee,this.a=null}dispose(){this.a&&this.a.then(ee=>{ee&&ee.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Bs=Q,e.$Cs=new I.$ks;var le;(function(Y){Y[Y.None=0]="None",Y[Y.Option=1]="Option",Y[Y.Default=2]="Default",Y[Y.Preferred=3]="Preferred"})(le||(e.ExternalUriOpenerPriority=le={}))}),define(pe[172],be([8,9]),function(ce,e){return ce.create("vs/platform/configuration/common/configurationRegistry",e)}),define(pe[173],be([8,9]),function(ce,e){return ce.create("vs/platform/contextkey/common/contextkey",e)}),define(pe[174],be([8,9]),function(ce,e){return ce.create("vs/platform/contextkey/common/scanner",e)}),define(pe[175],be([8,9]),function(ce,e){return ce.create("vs/platform/environment/node/argv",e)}),define(pe[176],be([8,9]),function(ce,e){return ce.create("vs/platform/environment/node/argvHelper",e)}),define(pe[177],be([8,9]),function(ce,e){return ce.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(pe[178],be([8,9]),function(ce,e){return ce.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(pe[179],be([8,9]),function(ce,e){return ce.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(pe[180],be([8,9]),function(ce,e){return ce.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(pe[181],be([8,9]),function(ce,e){return ce.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(pe[182],be([8,9]),function(ce,e){return ce.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(pe[183],be([8,9]),function(ce,e){return ce.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(pe[184],be([8,9]),function(ce,e){return ce.create("vs/platform/extensions/common/extensionValidator",e)}),define(pe[185],be([8,9]),function(ce,e){return ce.create("vs/platform/files/common/fileService",e)}),define(pe[186],be([8,9]),function(ce,e){return ce.create("vs/platform/files/common/files",e)}),define(pe[187],be([8,9]),function(ce,e){return ce.create("vs/platform/files/common/io",e)}),define(pe[188],be([8,9]),function(ce,e){return ce.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(pe[189],be([8,9]),function(ce,e){return ce.create("vs/platform/languagePacks/common/languagePacks",e)}),define(pe[190],be([8,9]),function(ce,e){return ce.create("vs/platform/markers/common/markers",e)}),define(pe[191],be([8,9]),function(ce,e){return ce.create("vs/platform/request/common/request",e)}),define(pe[192],be([8,9]),function(ce,e){return ce.create("vs/platform/shell/node/shellEnv",e)}),define(pe[193],be([8,9]),function(ce,e){return ce.create("vs/platform/telemetry/common/telemetryService",e)}),define(pe[194],be([8,9]),function(ce,e){return ce.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(pe[195],be([8,9]),function(ce,e){return ce.create("vs/platform/terminal/common/terminalProfiles",e)}),define(pe[196],be([8,9]),function(ce,e){return ce.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(pe[197],be([8,9]),function(ce,e){return ce.create("vs/platform/workspace/common/workspace",e)}),define(pe[198],be([8,9]),function(ce,e){return ce.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(pe[199],be([8,9]),function(ce,e){return ce.create("vs/server/node/serverEnvironmentService",e)}),define(pe[200],be([8,9]),function(ce,e){return ce.create("vs/server/node/serverServices",e)}),define(pe[201],be([8,9]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTelemetry",e)}),define(pe[202],be([8,9]),function(ce,e){return ce.create("vs/workbench/common/editor",e)}),define(pe[203],be([8,9]),function(ce,e){return ce.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(pe[204],be([8,9]),function(ce,e){return ce.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(pe[205],be([1,0,11,174]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.TokenType=void 0;var r;(function($){$[$.LParen=0]="LParen",$[$.RParen=1]="RParen",$[$.Neg=2]="Neg",$[$.Eq=3]="Eq",$[$.NotEq=4]="NotEq",$[$.Lt=5]="Lt",$[$.LtEq=6]="LtEq",$[$.Gt=7]="Gt",$[$.GtEq=8]="GtEq",$[$.RegexOp=9]="RegexOp",$[$.RegexStr=10]="RegexStr",$[$.True=11]="True",$[$.False=12]="False",$[$.In=13]="In",$[$.Not=14]="Not",$[$.And=15]="And",$[$.Or=16]="Or",$[$.Str=17]="Str",$[$.QuotedStr=18]="QuotedStr",$[$.Error=19]="Error",$[$.EOF=20]="EOF"})(r||(e.TokenType=r={}));function C(...$){switch($.length){case 1:return(0,O.localize)(0,null,$[0]);case 2:return(0,O.localize)(1,null,$[0],$[1]);case 3:return(0,O.localize)(2,null,$[0],$[1],$[2]);default:return}}const I=(0,O.localize)(3,null),P=(0,O.localize)(4,null);class w{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,D.$6)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(C("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(C("&&"));break;case 124:this.h(124)?this.k(16):this.l(C("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const k=this.d,p=this.c.substring(this.d,this.e),l={type:19,offset:this.d,lexeme:p};this.g.push({offset:k,lexeme:p,additionalInfo:A}),this.f.push(l)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const k=this.c.substring(this.d,this.e),p=w.b.get(k);p?this.k(p):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,k=!1,p=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(P);return}const d=this.c.charCodeAt(A);if(k)k=!1;else if(d===47&&!p){A++;break}else d===91?p=!0:d===92?k=!0:d===93&&(p=!1);A++}for(;A<this.c.length&&w.a.has(this.c.charCodeAt(A));)A++;this.e=A;const l=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$si=w}),define(pe[206],be([1,0,5,2]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$tn=void 0;class r{constructor(){this.a=new D.$ec,this.b=new D.$ec,this.c=new D.$ec,this.d=new D.$ec}static{this.ChannelName="extensionhostdebugservice"}call(P,w,$){switch(w){case"close":return Promise.resolve(this.a.fire({sessionId:$[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:$[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:$[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:$[0],port:$[1],subId:$[2]}))}throw new Error("Method not implemented.")}listen(P,w,$){switch(w){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$tn=r;class C extends O.$lb{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,w,$){this.b.call("attach",[P,w,$])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,w){this.b.call("terminate",[P,w])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,w){return this.b.call("openExtensionDevelopmentHostWindow",[P,w])}}e.$un=C}),define(pe[207],be([1,0,4]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=void 0;class O{constructor(I){this.a=I}listen(I,P,w){throw new Error("Invalid listen")}call(I,P,w){switch(P){case"download":return this.a.download(D.URI.revive(w[0]),D.URI.revive(w[1]))}throw new Error("Invalid call")}}e.$wn=O;class r{constructor(I,P){this.a=I,this.b=P}async download(I,P){const w=this.b();w&&(I=w.transformOutgoingURI(I),P=w.transformOutgoingURI(P)),await this.a.call("download",[I,P])}}e.$xn=r}),define(pe[208],be([1,0,158,73,13,7,30,19,4]),function(ce,e,D,O,r,C,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=e.$Vl=e.$Ul=void 0,e.$Ul=/^([^.]+\..+):(.+)$/;class ${get appRoot(){return(0,C.$$c)(r.$1e.asFileUri("").fsPath)}get userHome(){return w.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return w.URI.file((0,C.$8c)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.b.tmpDir)}get cacheHome(){return w.URI.file(this.userDataPath)}get stateResource(){return(0,P.$9f)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:r.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$9f)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const l=(0,D.$Tl)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.$8c)(this.userDataPath,"logs",l)}return w.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$9f)(w.URI.file((0,C.$8c)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$9f)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$9f)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$9f)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=I.env.VSCODE_PORTABLE;return l?w.URI.file((0,C.$8c)(l,"argv.json")):(0,P.$9f)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,C.$8c)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,C.$9c)(l):(0,C.$6c)((0,C.$8c)(r.$1e.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const l=this.args["extensions-download-dir"];return l?w.URI.file((0,C.$9c)(l)):w.URI.file((0,C.$8c)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,C.$9c)(l);const d=I.env.VSCODE_EXTENSIONS;if(d)return d;const m=I.env.VSCODE_PORTABLE;return m?(0,C.$8c)(m,"extensions"):(0,P.$9f)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(d=>/^[^:/?#]+?:\/\//.test(d)?w.URI.parse(d):w.URI.file((0,C.$6c)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?w.URI.parse(l):w.URI.file((0,C.$6c)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return A(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!I.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(l=>!e.$Ul.test(l))}get extensionLogLevel(){const l=[];for(const d of this.args.log||[]){const m=e.$Ul.exec(d);m&&m[1]&&m[2]&&l.push([m[1],m[2]])}return l.length?l:void 0}get serviceMachineIdResource(){return(0,P.$9f)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get disableKeytar(){return!!this.args["disable-keytar"]}get policyFile(){if(this.args["__enable-file-policy"]){const l=I.env.VSCODE_PORTABLE;return l?w.URI.file((0,C.$8c)(l,"policy.json")):(0,P.$9f)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(l){this.args.continueOn=l}get args(){return this.a}constructor(l,d,m){this.a=l,this.b=d,this.c=m,this.editSessionId=this.args.editSessionId}}e.$Vl=$,Le([O.$Tg],$.prototype,"appRoot",null),Le([O.$Tg],$.prototype,"userHome",null),Le([O.$Tg],$.prototype,"userDataPath",null),Le([O.$Tg],$.prototype,"appSettingsHome",null),Le([O.$Tg],$.prototype,"tmpDir",null),Le([O.$Tg],$.prototype,"cacheHome",null),Le([O.$Tg],$.prototype,"stateResource",null),Le([O.$Tg],$.prototype,"userRoamingDataHome",null),Le([O.$Tg],$.prototype,"userDataSyncHome",null),Le([O.$Tg],$.prototype,"sync",null),Le([O.$Tg],$.prototype,"machineSettingsResource",null),Le([O.$Tg],$.prototype,"workspaceStorageHome",null),Le([O.$Tg],$.prototype,"localHistoryHome",null),Le([O.$Tg],$.prototype,"keyboardLayoutResource",null),Le([O.$Tg],$.prototype,"argvResource",null),Le([O.$Tg],$.prototype,"isExtensionDevelopment",null),Le([O.$Tg],$.prototype,"untitledWorkspacesHome",null),Le([O.$Tg],$.prototype,"builtinExtensionsPath",null),Le([O.$Tg],$.prototype,"extensionsPath",null),Le([O.$Tg],$.prototype,"extensionDevelopmentLocationURI",null),Le([O.$Tg],$.prototype,"extensionDevelopmentKind",null),Le([O.$Tg],$.prototype,"extensionTestsLocationURI",null),Le([O.$Tg],$.prototype,"debugExtensionHost",null),Le([O.$Tg],$.prototype,"logLevel",null),Le([O.$Tg],$.prototype,"extensionLogLevel",null),Le([O.$Tg],$.prototype,"serviceMachineIdResource",null),Le([O.$Tg],$.prototype,"disableTelemetry",null),Le([O.$Tg],$.prototype,"disableWorkspaceTrust",null),Le([O.$Tg],$.prototype,"disableKeytar",null),Le([O.$Tg],$.prototype,"policyFile",null);function A(p,l){return k(p["inspect-extensions"],p["inspect-brk-extensions"],5870,l,p.debugId,p.extensionEnvironment)}e.$Wl=A;function k(p,l,d,m,c,u){const g=Number(l||p)||(m?null:d),E=g?!!l:!1;let v;if(u)try{v=JSON.parse(u)}catch{}return{port:g,break:E,debugId:c,env:v}}e.$Xl=k}),define(pe[64],be([1,0,296,3,175]),function(ce,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=void 0;const C={o:(0,r.localize)(0,null),e:(0,r.localize)(1,null),t:(0,r.localize)(2,null)};e.$kl=["tunnel","serve-web"],e.$ll={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,r.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,r.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,r.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,r.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,r.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,r.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,r.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,r.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,r.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,r.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,r.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,r.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,r.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,r.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,r.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,r.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,r.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,r.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,r.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,r.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,r.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,r.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,r.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,r.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,r.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,r.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,r.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,r.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,r.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,r.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,r.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,r.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const I={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(m,c,u=I){const h=m.find(o=>o.length>0&&o[0]!=="-"),g={},E=["_"],v=[],t={};let s;for(const o in c){const f=c[o];f.type==="subcommand"?o===h&&(s=f):(f.alias&&(g[o]=f.alias),f.type==="string"||f.type==="string[]"?(E.push(o),f.deprecates&&E.push(...f.deprecates)):f.type==="boolean"&&(v.push(o),f.deprecates&&v.push(...f.deprecates)),f.global&&(t[o]=f))}if(s&&h){const o=t;for(const S in s.options)o[S]=s.options[S];const f=m.filter(S=>S!==h),b=u.getSubcommandReporter?u.getSubcommandReporter(h):void 0,y=P(f,o,b);return{[h]:y,_:[]}}const a=D(m,{string:E,boolean:v,alias:g}),i={},n=a;i._=a._.map(o=>String(o)).filter(o=>o.length>0),delete n._;for(const o in c){const f=c[o];if(f.type==="subcommand")continue;f.alias&&delete n[f.alias];let b=n[o];if(f.deprecates)for(const y of f.deprecates)n.hasOwnProperty(y)&&(b||(b=n[y],b&&u.onDeprecatedOption(y,f.deprecationMessage||(0,r.localize)(37,null,o))),delete n[y]);if(typeof b<"u"){if(f.type==="string[]"){if(Array.isArray(b)||(b=[b]),!f.allowEmptyValue){const y=b.filter(S=>S.length>0);y.length!==b.length&&(u.onEmptyValue(o),b=y.length>0?y:void 0)}}else f.type==="string"&&(Array.isArray(b)?(b=b.pop(),u.onMultipleValues(o,b)):!b&&!f.allowEmptyValue&&(u.onEmptyValue(o),b=void 0));i[o]=b,f.deprecationMessage&&u.onDeprecatedOption(o,f.deprecationMessage)}delete n[o]}for(const o in n)u.onUnknownOption(o);return i}e.$ml=P;function w(m,c){let u="";return c.args&&(Array.isArray(c.args)?u=` <${c.args.join("> <")}>`:u=` <${c.args}>`),c.alias?`-${c.alias} --${m}${u}`:`--${m}${u}`}function $(m,c){const u=[];for(const h in m){const g=m[h],E=w(h,g);u.push([E,g.description])}return A(u,c)}e.$nl=$;function A(m,c){const h=m.reduce((v,t)=>Math.max(v,t[0].length),12)+2+1;if(c-h<25)return m.reduce((v,t)=>v.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const g=c-h-1,E=[];for(const v of m){const t=v[0],s=p(v[1],g),a=k(h-t.length-2);E.push("  "+t+a+s[0]);for(let i=1;i<s.length;i++)E.push(k(h)+s[i])}return E}function k(m){return" ".repeat(m)}function p(m,c){const u=[];for(;m.length;){const h=m.length<c?m.length:m.lastIndexOf(" ",c),g=m.slice(0,h).trim();m=m.slice(h),u.push(g)}return u}function l(m,c,u,h,g){const E=process.stdout.isTTY&&process.stdout.columns||80,v=g?.noInputFiles!==!0?`[${(0,r.localize)(38,null)}...]`:"",t=[`${m} ${u}`];t.push(""),t.push(`${(0,r.localize)(39,null)}: ${c} [${(0,r.localize)(40,null)}]${v}`),t.push(""),g?.noPipe!==!0&&(O.$i?t.push((0,r.localize)(41,null,c)):t.push((0,r.localize)(42,null,c)),t.push(""));const s={},a=[];for(const i in h){const n=h[i];if(n.type==="subcommand")n.description&&a.push({command:i,description:n.description});else if(n.description&&n.cat){let o=s[n.cat];o||(s[n.cat]=o={}),o[i]=n}}for(const i in s){const n=i,o=s[n];o&&(t.push(C[n]),t.push(...$(o,E)),t.push(""))}return a.length&&(t.push((0,r.localize)(43,null)),t.push(...A(a.map(i=>[i.command,i.description]),E)),t.push("")),t.join(`
`)}e.$ol=l;function d(m,c){return`${m||(0,r.localize)(44,null)}
${c||(0,r.localize)(45,null)}
${process.arch}`}e.$pl=d}),define(pe[209],be([1,0,297,176,64]),function(ce,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=e.$rl=e.$ql=void 0;function C(k,p){const l=(g,E)=>{console.warn((0,O.localize)(0,null,g,E))},d=g=>{console.warn((0,O.localize)(1,null,g))},m=(g,E)=>{console.warn((0,O.localize)(2,null,g,E))},c=g=>({onUnknownOption:E=>{r.$kl.includes(g)||console.warn((0,O.localize)(3,null,E,g))},onMultipleValues:l,onEmptyValue:d,onDeprecatedOption:m,getSubcommandReporter:r.$kl.includes(g)?c:void 0}),u={onUnknownOption:g=>{console.warn((0,O.localize)(4,null,g))},onMultipleValues:l,onEmptyValue:d,onDeprecatedOption:m,getSubcommandReporter:c},h=(0,r.$ml)(k,r.$ll,p?u:void 0);return h.goto&&h._.forEach(g=>D(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(g),(0,O.localize)(5,null))),h}function I(k){const p=k.findIndex(l=>!/^-/.test(l));if(p>-1)return[...k.slice(0,p),...k.slice(p+1)]}function P(k){let[,...p]=k;process.env.VSCODE_DEV&&(p=I(p)||[]);const l=!A(process.env);return C(p,l)}e.$ql=P;function w(k){let[,,...p]=k;return process.env.VSCODE_DEV&&(p=I(p)||[]),C(p,!0)}e.$rl=w;function $(k,...p){const l=k.indexOf("--");return l===-1?k.push(...p):k.splice(l,0,...p),k}e.$sl=$;function A(k){return k.VSCODE_CLI==="1"}e.$tl=A}),function(){"use strict";function ce(e,D,O){function r(I,P){const w=C(I,P),$=[w];return e.isAbsolute(w)||$.unshift(O),e.resolve(...$)}function C(I,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let $=process.env.VSCODE_APPDATA;if($)return e.join($,P);const A=I["user-data-dir"];if(A)return A;switch(process.platform){case"win32":if($=process.env.APPDATA,!$){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");$=e.join(k,"AppData","Roaming")}break;case"darwin":$=e.join(D.homedir(),"Library","Application Support");break;case"linux":$=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join($,P)}return{getUserDataPath:r}}if(typeof define=="function")define(pe[210],be([76,29,30]),function(e,D,O){return ce(e,D,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=ce(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(pe[109],be([1,0,29,208,210]),function(ce,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=e.$Yl=void 0;class C extends O.$Vl{constructor($,A){super($,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,r.getUserDataPath)($,A.nameShort)},A)}}e.$Yl=C;function I(w,$){return(0,O.$Xl)(w["inspect-ptyhost"],w["inspect-brk-ptyhost"],5877,$,w.extensionEnvironment)}e.$Zl=I;function P(w,$){return(0,O.$Xl)(w["inspect-sharedprocess"],w["inspect-brk-sharedprocess"],5879,$,w.extensionEnvironment)}e.$1l=P}),define(pe[211],be([1,0,10,180]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=void 0;function r(I,P,w){try{C(I,P,w)}catch($){console.error($?.message??$)}return I}e.$ep=r;function C(I,P,w){const $=(A,k,p)=>{const l=A[k];if((0,D.$ie)(l)){const d=l,m=d.length;if(m>1&&d[0]==="%"&&d[m-1]==="%"){const c=d.substr(1,m-2);let u=P[c];u===void 0&&w&&(u=w[c]);const h=typeof u=="string"?u:u?.message,g=w?.[c],E=typeof g=="string"?g:g?.message;if(!h){E||console.warn(`[${I.name}]: ${(0,O.localize)(0,null,c)}`);return}if(p&&(k==="title"||k==="category")&&E&&E!==h){const v={value:h,original:E};A[k]=v}else A[k]=h}}else if((0,D.$ke)(l))for(const d in l)l.hasOwnProperty(d)&&(d==="commands"?$(l,d,!0):$(l,d,p));else if(Array.isArray(l))for(let d=0;d<l.length;d++)$(l,d,p)};for(const A in I)I.hasOwnProperty(A)&&$(I,A)}}),define(pe[79],be([1,0,19,60,184,53]),function(ce,e,D,O,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function w(u){return u=u.trim(),u==="*"||I.test(u)}e.$to=w;function $(u){if(!w(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=u.match(I);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.$uo=$;function A(u){if(!u)return null;const h=u.majorBase,g=u.majorMustEqual,E=u.minorBase;let v=u.minorMustEqual;const t=u.patchBase;let s=u.patchMustEqual;u.hasCaret&&(h===0||(v=!1),s=!1);let a=0;if(u.preRelease){const i=P.exec(u.preRelease);if(i){const[,n,o,f]=i;a=Date.UTC(Number(n),Number(o)-1,Number(f))}}return{majorBase:h,majorMustEqual:g,minorBase:E,minorMustEqual:v,patchBase:t,patchMustEqual:s,isMinimum:u.hasGreaterEquals,notBefore:a}}e.$vo=A;function k(u,h,g){let E;typeof u=="string"?E=A($(u)):E=u;let v;h instanceof Date?v=h.getTime():typeof h=="string"&&(v=new Date(h).getTime());let t;if(typeof g=="string"?t=A($(g)):t=g,!E||!t)return!1;const s=E.majorBase,a=E.minorBase,i=E.patchBase;let n=t.majorBase,o=t.minorBase,f=t.patchBase;const b=t.notBefore;let y=t.majorMustEqual,S=t.minorMustEqual,L=t.patchMustEqual;return t.isMinimum?s>n?!0:s<n?!1:a>o?!0:a<o||v&&v<b?!1:i>=f:(s===1&&n===0&&(!y||!S||!L)&&(n=1,o=0,f=0,y=!0,S=!1,L=!1),s<n?!1:s>n?!y:a<o?!1:a>o?!S:i<f?!1:i>f?!L:!(v&&v<b))}e.$wo=k;function p(u,h,g,E,v){const t=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return t.push([O.default.Error,r.localize(0,null)]),t;if(typeof E.name!="string")return t.push([O.default.Error,r.localize(1,null,"name")]),t;if(typeof E.version!="string")return t.push([O.default.Error,r.localize(2,null,"version")]),t;if(!E.engines)return t.push([O.default.Error,r.localize(3,null,"engines")]),t;if(typeof E.engines.vscode!="string")return t.push([O.default.Error,r.localize(4,null,"engines.vscode")]),t;if(typeof E.extensionDependencies<"u"&&!c(E.extensionDependencies))return t.push([O.default.Error,r.localize(5,null,"extensionDependencies")]),t;if(typeof E.activationEvents<"u"){if(!c(E.activationEvents))return t.push([O.default.Error,r.localize(6,null,"activationEvents")]),t;if(typeof E.main>"u"&&typeof E.browser>"u")return t.push([O.default.Error,r.localize(7,null,"activationEvents","main","browser")]),t}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&t.push([O.default.Warning,r.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return t.push([O.default.Error,r.localize(9,null,"main")]),t;{const i=(0,D.$9f)(g,E.main);(0,D.$3f)(i,g)||t.push([O.default.Warning,r.localize(10,null,i.path,g.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return t.push([O.default.Error,r.localize(11,null,"browser")]),t;{const i=(0,D.$9f)(g,E.browser);(0,D.$3f)(i,g)||t.push([O.default.Warning,r.localize(12,null,i.path,g.path)])}}if(!C.valid(E.version))return t.push([O.default.Error,r.localize(13,null)]),t;const s=[];if(!l(u,h,E,v,s))for(const i of s)t.push([O.default.Error,i]);return t}e.$xo=p;function l(u,h,g,E,v){return E||typeof g.main>"u"&&typeof g.browser>"u"?!0:m(u,h,g.engines.vscode,v)}e.$yo=l;function d(u,h,g){return u==="*"||m(h,g,u)}e.$zo=d;function m(u,h,g,E=[]){const v=A($(g));if(!v)return E.push(r.localize(14,null,g)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return E.push(r.localize(15,null,g)),!1}else if(!v.majorMustEqual)return E.push(r.localize(16,null,g)),!1;return k(u,h,v)?!0:(E.push(r.localize(17,null,u,g)),!1)}function c(u){if(!Array.isArray(u))return!1;for(let h=0,g=u.length;h<g;h++)if(typeof u[h]!="string")return!1;return!0}}),define(pe[212],be([1,0,15,23]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=void 0;async function r(C,I,P){let w=P&&P.get("storage.serviceMachineId",-1)||null;if(w)return w;try{const A=(await I.readFile(C.serviceMachineIdResource)).value.toString();w=(0,O.$2e)(A)?A:null}catch{w=null}if(!w){w=(0,O.$3e)();try{await I.writeFile(C.serviceMachineIdResource,D.$Ec.fromString(w))}catch{}}return P?.store("storage.serviceMachineId",w,-1,1),w}e.$So=r}),define(pe[65],be([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=void 0;class D{constructor(r,C=[],I=!1){this.ctor=r,this.staticArguments=C,this.supportsDelayedInstantiation=I}}e.$mh=D}),define(pe[213],be([1,0,65]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=e.InstantiationType=void 0;const O=[];var r;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(r||(e.InstantiationType=r={}));function C(P,w,$){w instanceof D.$mh||(w=new D.$mh(w,[],!!$)),O.push([P,w])}e.$dr=C;function I(){return O}e.$er=I}),define(pe[214],be([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=void 0;class D{constructor(C,I){this.key=C,this.data=I,this.incoming=new Map,this.outgoing=new Map}}e.$Up=D;class O{constructor(C){this.b=C,this.a=new Map}roots(){const C=[];for(const I of this.a.values())I.outgoing.size===0&&C.push(I);return C}insertEdge(C,I){const P=this.lookupOrInsertNode(C),w=this.lookupOrInsertNode(I);P.outgoing.set(w.key,w),w.incoming.set(P.key,P)}removeNode(C){const I=this.b(C);this.a.delete(I);for(const P of this.a.values())P.outgoing.delete(I),P.incoming.delete(I)}lookupOrInsertNode(C){const I=this.b(C);let P=this.a.get(I);return P||(P=new D(I,C),this.a.set(I,P)),P}lookup(C){return this.a.get(this.b(C))}isEmpty(){return this.a.size===0}toString(){const C=[];for(const[I,P]of this.a)C.push(`${I}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return C.join(`
`)}findCycleSlow(){for(const[C,I]of this.a){const P=new Set([C]),w=this.c(I,P);if(w)return w}}c(C,I){for(const[P,w]of C.outgoing){if(I.has(P))return[...I,P].join(" -> ");I.add(P);const $=this.c(w,I);if($)return $;I.delete(P)}}}e.$Vp=O}),define(pe[6],be([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qh=e.$ph=e.$oh=e._util=void 0;var D;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function P(w){return w[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=P})(D||(e._util=D={})),e.$oh=r("instantiationService");function O(I,P,w){P[D.DI_TARGET]===P?P[D.DI_DEPENDENCIES].push({id:I,index:w}):(P[D.DI_DEPENDENCIES]=[{id:I,index:w}],P[D.DI_TARGET]=P)}function r(I){if(D.serviceIds.has(I))return D.serviceIds.get(I);const P=function(w,$,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(P,w,A)};return P.toString=()=>I,D.serviceIds.set(I,P),P}e.$ph=r;function C(I){return I}e.$qh=C}),define(pe[24],be([1,0,10,4,6]),function(ce,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.ConfigurationTarget=e.$Xh=e.$Wh=e.$Vh=void 0,e.$Vh=(0,r.$ph)("configurationService");function C(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof O.URI)}e.$Wh=C;function I(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof O.URI)}e.$Xh=I;var P;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function w(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Yh=w;function $(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}e.$Zh=$;function A(u,h){const g=Object.create(null);for(const E in u)k(g,E,u[E],h);return g}e.$1h=A;function k(u,h,g,E){const v=h.split("."),t=v.pop();let s=u;for(let a=0;a<v.length;a++){const i=v[a];let n=s[i];switch(typeof n){case"undefined":n=s[i]=Object.create(null);break;case"object":break;default:E(`Ignoring ${h} as ${v.slice(0,a+1).join(".")} is ${JSON.stringify(n)}`);return}s=n}if(typeof s=="object"&&s!==null)try{s[t]=g}catch{E(`Ignoring ${h} as ${v.join(".")} is ${JSON.stringify(s)}`)}else E(`Ignoring ${h} as ${v.join(".")} is ${JSON.stringify(s)}`)}e.$2h=k;function p(u,h){const g=h.split(".");l(u,g)}e.$3h=p;function l(u,h){const g=h.shift();if(h.length===0){delete u[g];return}if(Object.keys(u).indexOf(g)!==-1){const E=u[g];typeof E=="object"&&!Array.isArray(E)&&(l(E,h),Object.keys(E).length===0&&delete u[g])}}function d(u,h,g){function E(s,a){let i=s;for(const n of a){if(typeof i!="object"||i===null)return;i=i[n]}return i}const v=h.split("."),t=E(u,v);return typeof t>"u"?g:t}e.$4h=d;function m(u,h,g){Object.keys(h).forEach(E=>{E!=="__proto__"&&(E in u?D.$ke(u[E])&&D.$ke(h[E])?m(u[E],h[E],g):g&&(u[E]=h[E]):u[E]=h[E])})}e.$5h=m;function c(u){return u.replace(/[\[\]]/g,"")}e.$6h=c}),define(pe[66],be([1,0,3,17,205,6,173,11]),function(ce,e,D,O,r,C,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.ContextKeyExprType=e.$ti=void 0;const w=new Map;w.set("false",!1),w.set("true",!0),w.set("isMac",D.$j),w.set("isLinux",D.$k),w.set("isWindows",D.$i),w.set("isWeb",D.$o),w.set("isMacNative",D.$j&&!D.$o),w.set("isEdge",D.$G),w.set("isFirefox",D.$E),w.set("isChrome",D.$D),w.set("isSafari",D.$F);function $(J,R){if(w.get(J)!==void 0)throw(0,P.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");w.set(J,R)}e.$ti=$;const A=Object.prototype.hasOwnProperty;var k;(function(J){J[J.False=0]="False",J[J.True=1]="True",J[J.Defined=2]="Defined",J[J.Not=3]="Not",J[J.Equals=4]="Equals",J[J.NotEquals=5]="NotEquals",J[J.And=6]="And",J[J.Regex=7]="Regex",J[J.NotRegex=8]="NotRegex",J[J.Or=9]="Or",J[J.In=10]="In",J[J.NotIn=11]="NotIn",J[J.Greater=12]="Greater",J[J.GreaterEquals=13]="GreaterEquals",J[J.Smaller=14]="Smaller",J[J.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const p={regexParsingWithErrorRecovery:!0},l=(0,I.localize)(0,null),d=(0,I.localize)(1,null),m=(0,I.localize)(2,null),c=(0,I.localize)(3,null),u=(0,I.localize)(4,null),h=(0,I.localize)(5,null),g=(0,I.localize)(6,null),E=(0,I.localize)(7,null);class v{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(R=p){this.k=R,this.d=new r.$si,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(R){if(R===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset(R).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const W=this.D(),ie=W.type===17?h:void 0;throw this.h.push({message:u,offset:W.offset,lexeme:r.$si.getLexeme(W),additionalInfo:ie}),v.c}return F}catch(F){if(F!==v.c)throw F;return}}l(){return this.m()}m(){const R=[this.o()];for(;this.y(16);){const F=this.o();R.push(F)}return R.length===1?R[0]:t.or(...R)}o(){const R=[this.s()];for(;this.y(15);){const F=this.s();R.push(F)}return R.length===1?R[0]:t.and(...R)}s(){if(this.y(2)){const R=this.D();switch(R.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const F=this.l();return this.A(1,c),F?.negate()}case 17:return this.z(),j.create(R.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",R)}}return this.t()}t(){const R=this.D();switch(R.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const F=this.l();return this.A(1,c),F}case 17:{const F=R.lexeme;if(this.z(),this.y(9)){const ie=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ie.type!==10)throw this.B("REGEX",ie);const re=ie.lexeme,_=re.lastIndexOf("/"),oe=_===re.length-1?void 0:this.w(re.substring(_+1));let N;try{N=new RegExp(re.substring(1,_),oe)}catch{throw this.B("REGEX",ie)}return X.create(F,N)}switch(ie.type){case 10:case 19:{const re=[ie.lexeme];this.z();let _=this.D(),oe=0;for(let Z=0;Z<ie.lexeme.length;Z++)ie.lexeme.charCodeAt(Z)===40?oe++:ie.lexeme.charCodeAt(Z)===41&&oe--;for(;!this.E()&&_.type!==15&&_.type!==16;){switch(_.type){case 0:oe++;break;case 1:oe--;break;case 10:case 18:for(let Z=0;Z<_.lexeme.length;Z++)_.lexeme.charCodeAt(Z)===40?oe++:ie.lexeme.charCodeAt(Z)===41&&oe--}if(oe<0)break;re.push(r.$si.getLexeme(_)),this.z(),_=this.D()}const N=re.join(""),B=N.lastIndexOf("/"),U=B===N.length-1?void 0:this.w(N.substring(B+1));let z;try{z=new RegExp(N.substring(1,B),U)}catch{throw this.B("REGEX",ie)}return t.regex(F,z)}case 18:{const re=ie.lexeme;this.z();let _=null;if(!(0,O.$ld)(re)){const oe=re.indexOf("/"),N=re.lastIndexOf("/");if(oe!==N&&oe>=0){const B=re.slice(oe+1,N),U=re[N+1]==="i"?"i":"";try{_=new RegExp(B,U)}catch{throw this.B("REGEX",ie)}}}if(_===null)throw this.B("REGEX",ie);return X.create(F,_)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,m);const ie=this.u();return t.notIn(F,ie)}switch(this.D().type){case 3:{this.z();const ie=this.u();if(this.x().type===18)return t.equals(F,ie);switch(ie){case"true":return t.has(F);case"false":return t.not(F);default:return t.equals(F,ie)}}case 4:{this.z();const ie=this.u();if(this.x().type===18)return t.notEquals(F,ie);switch(ie){case"true":return t.not(F);case"false":return t.has(F);default:return t.notEquals(F,ie)}}case 5:return this.z(),ee.create(F,this.u());case 6:return this.z(),ue.create(F,this.u());case 7:return this.z(),le.create(F,this.u());case 8:return this.z(),Y.create(F,this.u());case 13:return this.z(),t.in(F,this.u());default:return t.has(F)}}case 20:throw this.h.push({message:g,offset:R.offset,lexeme:"",additionalInfo:E}),v.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const R=this.D();switch(R.type){case 17:case 18:return this.z(),R.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(R){return R.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(R){return this.C(R)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(R,F){if(this.C(R))return this.z();throw this.B(F,this.D())}B(R,F,W){const ie=(0,I.localize)(8,null,R,r.$si.getLexeme(F)),re=F.offset,_=r.$si.getLexeme(F);return this.h.push({message:ie,offset:re,lexeme:_,additionalInfo:W}),v.c}C(R){return this.D().type===R}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$ui=v;class t{static false(){return n.INSTANCE}static true(){return o.INSTANCE}static has(R){return f.create(R)}static equals(R,F){return b.create(R,F)}static notEquals(R,F){return L.create(R,F)}static regex(R,F){return X.create(R,F)}static in(R,F){return y.create(R,F)}static notIn(R,F){return S.create(R,F)}static not(R){return j.create(R)}static and(...R){return se.create(R,null,!0)}static or(...R){return V.create(R,null,!0)}static greater(R,F){return le.create(R,F)}static greaterEquals(R,F){return Y.create(R,F)}static smaller(R,F){return ee.create(R,F)}static smallerEquals(R,F){return ue.create(R,F)}static{this.c=new v({regexParsingWithErrorRecovery:!1})}static deserialize(R){return R==null?void 0:this.c.parse(R)}}e.$vi=t;function s(J){const R=new v({regexParsingWithErrorRecovery:!1});return J.map(F=>(R.parse(F),R.lexingErrors.length>0?R.lexingErrors.map(W=>({errorMessage:W.additionalInfo?(0,I.localize)(9,null,W.additionalInfo):(0,I.localize)(10,null),offset:W.offset,length:W.lexeme.length})):R.parsingErrors.length>0?R.parsingErrors.map(W=>({errorMessage:W.additionalInfo?`${W.message}. ${W.additionalInfo}`:W.message,offset:W.offset,length:W.lexeme.length})):[]))}e.$wi=s;function a(J,R){const F=J?J.substituteConstants():void 0,W=R?R.substituteConstants():void 0;return!F&&!W?!0:!F||!W?!1:F.equals(W)}e.$xi=a;function i(J,R){return J.cmp(R)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return o.INSTANCE}}e.$yi=n;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return n.INSTANCE}}e.$zi=o;class f{static create(R,F=null){const W=w.get(R);return typeof W=="boolean"?W?o.INSTANCE:n.INSTANCE:new f(R,F)}constructor(R,F){this.key=R,this.c=F,this.type=2}cmp(R){return R.type!==this.type?this.type-R.type:H(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=w.get(this.key);return typeof R=="boolean"?R?o.INSTANCE:n.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$Ai=f;class b{static create(R,F,W=null){if(typeof F=="boolean")return F?f.create(R,W):j.create(R,W);const ie=w.get(R);return typeof ie=="boolean"?F===(ie?"true":"false")?o.INSTANCE:n.INSTANCE:new b(R,F,W)}constructor(R,F,W){this.c=R,this.d=F,this.f=W,this.type=4}cmp(R){return R.type!==this.type?this.type-R.type:te(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=w.get(this.c);if(typeof R=="boolean"){const F=R?"true":"false";return this.d===F?o.INSTANCE:n.INSTANCE}return this}evaluate(R){return R.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(R){return R.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Bi=b;class y{static create(R,F){return new y(R,F)}constructor(R,F){this.d=R,this.f=F,this.type=10,this.c=null}cmp(R){return R.type!==this.type?this.type-R.type:te(this.d,this.f,R.d,R.f)}equals(R){return R.type===this.type?this.d===R.d&&this.f===R.f:!1}substituteConstants(){return this}evaluate(R){const F=R.getValue(this.f),W=R.getValue(this.d);return Array.isArray(F)?F.includes(W):typeof W=="string"&&typeof F=="object"&&F!==null?A.call(F,W):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(R){return R.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.$Ci=y;class S{static create(R,F){return new S(R,F)}constructor(R,F){this.d=R,this.f=F,this.type=11,this.c=y.create(R,F)}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(R){return R.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Di=S;class L{static create(R,F,W=null){if(typeof F=="boolean")return F?j.create(R,W):f.create(R,W);const ie=w.get(R);return typeof ie=="boolean"?F===(ie?"true":"false")?n.INSTANCE:o.INSTANCE:new L(R,F,W)}constructor(R,F,W){this.c=R,this.d=F,this.f=W,this.type=5}cmp(R){return R.type!==this.type?this.type-R.type:te(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=w.get(this.c);if(typeof R=="boolean"){const F=R?"true":"false";return this.d===F?n.INSTANCE:o.INSTANCE}return this}evaluate(R){return R.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(R){return R.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Ei=L;class j{static create(R,F=null){const W=w.get(R);return typeof W=="boolean"?W?n.INSTANCE:o.INSTANCE:new j(R,F)}constructor(R,F){this.c=R,this.d=F,this.type=3}cmp(R){return R.type!==this.type?this.type-R.type:H(this.c,R.c)}equals(R){return R.type===this.type?this.c===R.c:!1}substituteConstants(){const R=w.get(this.c);return typeof R=="boolean"?R?n.INSTANCE:o.INSTANCE:this}evaluate(R){return!R.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(R){return R.mapNot(this.c)}negate(){return this.d||(this.d=f.create(this.c,this)),this.d}}e.$Fi=j;function Q(J,R){if(typeof J=="string"){const F=parseFloat(J);isNaN(F)||(J=F)}return typeof J=="string"||typeof J=="number"?R(J):n.INSTANCE}class le{static create(R,F,W=null){return Q(F,ie=>new le(R,ie,W))}constructor(R,F,W){this.c=R,this.d=F,this.f=W,this.type=12}cmp(R){return R.type!==this.type?this.type-R.type:te(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Gi=le;class Y{static create(R,F,W=null){return Q(F,ie=>new Y(R,ie,W))}constructor(R,F,W){this.c=R,this.d=F,this.f=W,this.type=13}cmp(R){return R.type!==this.type?this.type-R.type:te(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.$Hi=Y;class ee{static create(R,F,W=null){return Q(F,ie=>new ee(R,ie,W))}constructor(R,F,W){this.c=R,this.d=F,this.f=W,this.type=14}cmp(R){return R.type!==this.type?this.type-R.type:te(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$Ii=ee;class ue{static create(R,F,W=null){return Q(F,ie=>new ue(R,ie,W))}constructor(R,F,W){this.c=R,this.d=F,this.f=W,this.type=15}cmp(R){return R.type!==this.type?this.type-R.type:te(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.$Ji=ue;class X{static create(R,F){return new X(R,F)}constructor(R,F){this.d=R,this.f=F,this.type=7,this.c=null}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.d<R.d)return-1;if(this.d>R.d)return 1;const F=this.f?this.f.source:"",W=R.f?R.f.source:"";return F<W?-1:F>W?1:0}equals(R){if(R.type===this.type){const F=this.f?this.f.source:"",W=R.f?R.f.source:"";return this.d===R.d&&F===W}return!1}substituteConstants(){return this}evaluate(R){const F=R.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const R=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${R}`}keys(){return[this.d]}map(R){return R.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=he.create(this)),this.c}}e.$Ki=X;class he{static create(R){return new he(R)}constructor(R){this.c=R,this.type=8}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(R){return new he(this.c.map(R))}negate(){return this.c}}e.$Li=he;function x(J){let R=null;for(let F=0,W=J.length;F<W;F++){const ie=J[F].substituteConstants();if(J[F]!==ie&&R===null){R=[];for(let re=0;re<F;re++)R[re]=J[re]}R!==null&&(R[F]=ie)}return R===null?J:R}class se{static create(R,F,W){return se.d(R,F,W)}constructor(R,F){this.expr=R,this.c=F,this.type=6}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let F=0,W=this.expr.length;F<W;F++){const ie=i(this.expr[F],R.expr[F]);if(ie!==0)return ie}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let F=0,W=this.expr.length;F<W;F++)if(!this.expr[F].equals(R.expr[F]))return!1;return!0}return!1}substituteConstants(){const R=x(this.expr);return R===this.expr?this:se.create(R,this.c,!1)}evaluate(R){for(let F=0,W=this.expr.length;F<W;F++)if(!this.expr[F].evaluate(R))return!1;return!0}static d(R,F,W){const ie=[];let re=!1;for(const _ of R)if(_){if(_.type===1){re=!0;continue}if(_.type===0)return n.INSTANCE;if(_.type===6){ie.push(..._.expr);continue}ie.push(_)}if(ie.length===0&&re)return o.INSTANCE;if(ie.length!==0){if(ie.length===1)return ie[0];ie.sort(i);for(let _=1;_<ie.length;_++)ie[_-1].equals(ie[_])&&(ie.splice(_,1),_--);if(ie.length===1)return ie[0];for(;ie.length>1;){const _=ie[ie.length-1];if(_.type!==9)break;ie.pop();const oe=ie.pop(),N=ie.length===0,B=V.create(_.expr.map(U=>se.create([U,oe],null,W)),null,N);B&&(ie.push(B),ie.sort(i))}if(ie.length===1)return ie[0];if(W){for(let _=0;_<ie.length;_++)for(let oe=_+1;oe<ie.length;oe++)if(ie[_].negate().equals(ie[oe]))return n.INSTANCE;if(ie.length===1)return ie[0]}return new se(ie,F)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(const F of this.expr)R.push(...F.keys());return R}map(R){return new se(this.expr.map(F=>F.map(R)),null)}negate(){if(!this.c){const R=[];for(const F of this.expr)R.push(F.negate());this.c=V.create(R,this,!0)}return this.c}}e.$Mi=se;class V{static create(R,F,W){return V.d(R,F,W)}constructor(R,F){this.expr=R,this.c=F,this.type=9}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let F=0,W=this.expr.length;F<W;F++){const ie=i(this.expr[F],R.expr[F]);if(ie!==0)return ie}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let F=0,W=this.expr.length;F<W;F++)if(!this.expr[F].equals(R.expr[F]))return!1;return!0}return!1}substituteConstants(){const R=x(this.expr);return R===this.expr?this:V.create(R,this.c,!1)}evaluate(R){for(let F=0,W=this.expr.length;F<W;F++)if(this.expr[F].evaluate(R))return!0;return!1}static d(R,F,W){let ie=[],re=!1;if(R){for(let _=0,oe=R.length;_<oe;_++){const N=R[_];if(N){if(N.type===0){re=!0;continue}if(N.type===1)return o.INSTANCE;if(N.type===9){ie=ie.concat(N.expr);continue}ie.push(N)}}if(ie.length===0&&re)return n.INSTANCE;ie.sort(i)}if(ie.length!==0){if(ie.length===1)return ie[0];for(let _=1;_<ie.length;_++)ie[_-1].equals(ie[_])&&(ie.splice(_,1),_--);if(ie.length===1)return ie[0];if(W){for(let _=0;_<ie.length;_++)for(let oe=_+1;oe<ie.length;oe++)if(ie[_].negate().equals(ie[oe]))return o.INSTANCE;if(ie.length===1)return ie[0]}return new V(ie,F)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(const F of this.expr)R.push(...F.keys());return R}map(R){return new V(this.expr.map(F=>F.map(R)),null)}negate(){if(!this.c){const R=[];for(const F of this.expr)R.push(F.negate());for(;R.length>1;){const F=R.shift(),W=R.shift(),ie=[];for(const re of q(F))for(const _ of q(W))ie.push(se.create([re,_],null,!1));R.unshift(V.create(ie,null,!1))}this.c=V.create(R,this,!0)}return this.c}}e.$Ni=V;class K extends f{static{this.d=[]}static all(){return K.d.values()}constructor(R,F,W){super(R,null),this.f=F,typeof W=="object"?K.d.push({...W,key:R}):W!==!0&&K.d.push({key:R,description:W,type:F!=null?typeof F:void 0})}bindTo(R){return R.createKey(this.key,this.f)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return b.create(this.key,R)}notEqualsTo(R){return L.create(this.key,R)}}e.$Oi=K,e.$Pi=(0,C.$ph)("contextKeyService");function H(J,R){return J<R?-1:J>R?1:0}function te(J,R,F,W){return J<F?-1:J>F?1:R<W?-1:R>W?1:0}function me(J,R){if(J.type===0||R.type===1)return!0;if(J.type===9)return R.type===9?ne(J.expr,R.expr):!1;if(R.type===9){for(const F of R.expr)if(me(J,F))return!0;return!1}if(J.type===6){if(R.type===6)return ne(R.expr,J.expr);for(const F of J.expr)if(me(F,R))return!0;return!1}return J.equals(R)}e.$Qi=me;function ne(J,R){let F=0,W=0;for(;F<J.length&&W<R.length;){const ie=J[F].cmp(R[W]);if(ie<0)return!1;ie===0&&F++,W++}return F===J.length}function q(J){return J.type===9?J.expr:[J]}}),define(pe[80],be([1,0,6]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=void 0,e.$nn=(0,D.$ph)("credentialsService"),e.$on=(0,D.$ph)("credentialsMainService");class O{constructor(){this.a={}}async getPassword(C,I){return this.a[C]?.[I]??null}async setPassword(C,I,P){this.a[C]=this.a[C]??{},this.a[C][I]=P}async deletePassword(C,I){return this.a[C]?.[I]?(delete this.a[C][I],Object.keys(this.a[C]).length===0&&delete this.a[C],!0):!1}async findPassword(C){return JSON.stringify(this.a[C])??null}async findCredentials(C){const I=[];for(const P of Object.keys(this.a[C]||{}))I.push({account:P,password:this.a[C][P]});return I}async clear(){this.a={}}}e.$pn=O}),define(pe[215],be([1,0,6]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8l=e.$7l=e.$6l=e.ID=void 0,e.ID="diagnosticsService",e.$6l=(0,D.$ph)(e.ID);function O(C){return!!C.hostName&&!!C.errorMessage}e.$7l=O;class r{async getPerformanceInfo(I,P){return{}}async getSystemInfo(I,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(I,P){return""}async getWorkspaceFileExtensions(I){return{extensions:[]}}async reportWorkspaceStats(I){}}e.$8l=r}),define(pe[81],be([1,0,6]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=void 0,e.$vn=(0,D.$ph)("downloadService")}),define(pe[25],be([1,0,6]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=void 0,e.$wh=(0,D.$ph)("environmentService"),e.$xh=(0,D.$qh)(e.$wh)}),define(pe[31],be([1,0,178,6]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Rn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=void 0,e.$En="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Fn=new RegExp(e.$En),e.$Gn="__web_extension",e.$Hn="skipWalkthrough",e.$In="extensionsSync",e.$Jn="dependecyOrPackExtensionInstall";function r(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Kn=r;function C(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Ln=C;function I(h,g){switch(h){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Mn=I;function P(h,g){return g==="web"&&!h.includes("web")}e.$Nn=P;function w(h,g,E){return P(g,E)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===E?!0:$(E).includes(h)}e.$On=w;function $(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Pn=$;function A(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.$Qn=A;var k;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var p;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var l;(function(h){h.Install="install",h.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var d;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(d||(e.InstallOperation=d={})),e.$Rn=(0,O.$ph)("extensionGalleryService");var m;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));var c;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class u extends Error{constructor(g,E){super(g),this.code=E,this.name=E}}e.$Sn=u,e.$Tn=(0,O.$ph)("extensionManagementService"),e.$Un="extensionsIdentifiers/disabled",e.$Vn="extensionsIdentifiers/enabled",e.$Wn=(0,O.$ph)("IGlobalExtensionEnablementService"),e.$Xn=(0,O.$ph)("IExtensionTipsService"),e.$Yn=(0,D.localize)(0,null),e.$Zn={value:e.$Yn,original:"Extensions"},e.$1n={value:(0,D.localize)(1,null),original:"Preferences"}}),define(pe[216],be([1,0,5,2,22,4,51,31]),function(ce,e,D,O,r,C,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.$1o=void 0;function w(c,u){return c?C.URI.revive(u?u.transformIncoming(c):c):void 0}function $(c,u){return u?u.transformOutgoingURI(c):c}function A(c,u){u=u||I.$pm;const h=c.manifest;return{...(0,I.$sm)({...c,manifest:void 0},u),manifest:h}}function k(c,u){return c?.profileLocation?(0,I.$sm)(c,u??I.$pm):c}function p(c,u){return u?(0,r.$Km)(c,h=>h instanceof C.URI?u.transformOutgoingURI(h):void 0):c}class l{constructor(u,h){this.a=u,this.b=h,this.onInstallExtension=D.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(u.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=D.Event.buffer(u.onDidUpdateExtensionMetadata,!0)}listen(u,h){const g=this.b(u);switch(h){case"onInstallExtension":return D.Event.map(this.onInstallExtension,E=>({...E,profileLocation:E.profileLocation?$(E.profileLocation,g):E.profileLocation}));case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,E=>E.map(v=>({...v,local:v.local?p(v.local,g):v.local,profileLocation:v.profileLocation?$(v.profileLocation,g):v.profileLocation})));case"onUninstallExtension":return D.Event.map(this.onUninstallExtension,E=>({...E,profileLocation:E.profileLocation?$(E.profileLocation,g):E.profileLocation}));case"onDidUninstallExtension":return D.Event.map(this.onDidUninstallExtension,E=>({...E,profileLocation:E.profileLocation?$(E.profileLocation,g):E.profileLocation}));case"onDidUpdateExtensionMetadata":return D.Event.map(this.onDidUpdateExtensionMetadata,E=>p(E,g))}throw new Error("Invalid listen")}async call(u,h,g){const E=this.b(u);switch(h){case"zip":{const v=A(g[0],E),t=await this.a.zip(v);return $(t,E)}case"unzip":return this.a.unzip(w(g[0],E));case"install":return this.a.install(w(g[0],E),k(g[1],E));case"installFromLocation":return this.a.installFromLocation(w(g[0],E),w(g[1],E));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(g[0],w(g[1],E),w(g[2],E));case"getManifest":return this.a.getManifest(w(g[0],E));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(g[0]);case"installFromGallery":return this.a.installFromGallery(g[0],k(g[1],E));case"installGalleryExtensions":{const v=g[0];return this.a.installGalleryExtensions(v.map(({extension:t,options:s})=>({extension:t,options:k(s,E)??{}})))}case"uninstall":return this.a.uninstall(A(g[0],E),k(g[1],E));case"reinstallFromGallery":return this.a.reinstallFromGallery(A(g[0],E));case"getInstalled":return(await this.a.getInstalled(g[0],w(g[1],E))).map(t=>p(t,E));case"toggleAppliationScope":{const v=await this.a.toggleAppliationScope(A(g[0],E),w(g[1],E));return p(v,E)}case"copyExtensions":return this.a.copyExtensions(w(g[0],E),w(g[1],E));case"updateMetadata":{const v=await this.a.updateMetadata(A(g[0],E),g[1],w(g[2],E));return p(v,E)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(g[0],g[1],g[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$1o=l;class d extends O.$lb{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(u){super(),this.k=u,this.c=this.B(new D.$ec),this.f=this.B(new D.$ec),this.g=this.B(new D.$ec),this.h=this.B(new D.$ec),this.j=this.B(new D.$ec),this.B(this.k.listen("onInstallExtension")(h=>this.l(this.c,{...h,source:this.m(h.source)?C.URI.revive(h.source):h.source,profileLocation:C.URI.revive(h.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(h=>this.l(this.f,h.map(g=>({...g,local:g.local?A(g.local,null):g.local,source:this.m(g.source)?C.URI.revive(g.source):g.source,profileLocation:C.URI.revive(g.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(h=>this.l(this.g,{...h,profileLocation:C.URI.revive(h.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(h=>this.l(this.h,{...h,profileLocation:C.URI.revive(h.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(h=>this.j.fire(A(h,null))))}l(u,h){u.fire(h)}m(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this.n||(this.n=this.k.call("getTargetPlatform")),this.n}async canInstall(u){const h=await this.getTargetPlatform();return u.allTargetPlatforms.some(g=>(0,P.$On)(g,u.allTargetPlatforms,h))}zip(u){return Promise.resolve(this.k.call("zip",[u]).then(h=>C.URI.revive(h)))}unzip(u){return Promise.resolve(this.k.call("unzip",[u]))}install(u,h){return Promise.resolve(this.k.call("install",[u,h])).then(g=>A(g,null))}installFromLocation(u,h){return Promise.resolve(this.k.call("installFromLocation",[u,h])).then(g=>A(g,null))}async installExtensionsFromProfile(u,h,g){return(await this.k.call("installExtensionsFromProfile",[u,h,g])).map(v=>A(v,null))}getManifest(u){return Promise.resolve(this.k.call("getManifest",[u]))}installFromGallery(u,h){return Promise.resolve(this.k.call("installFromGallery",[u,h])).then(g=>A(g,null))}async installGalleryExtensions(u){return(await this.k.call("installGalleryExtensions",[u])).map(g=>({...g,local:g.local?A(g.local,null):g.local,source:this.m(g.source)?C.URI.revive(g.source):g.source,profileLocation:C.URI.revive(g.profileLocation)}))}uninstall(u,h){return Promise.resolve(this.k.call("uninstall",[u,h]))}reinstallFromGallery(u){return Promise.resolve(this.k.call("reinstallFromGallery",[u])).then(h=>A(h,null))}getInstalled(u=null,h){return Promise.resolve(this.k.call("getInstalled",[u,h])).then(g=>g.map(E=>A(E,null)))}updateMetadata(u,h,g){return Promise.resolve(this.k.call("updateMetadata",[u,h,g])).then(E=>A(E,null))}toggleAppliationScope(u,h){return this.k.call("toggleAppliationScope",[u,h]).then(g=>A(g,null))}copyExtensions(u,h){return this.k.call("copyExtensions",[u,h])}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(u,h,g){const E=await this.k.call("download",[u,h,g]);return C.URI.revive(E)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$2o=d;class m{constructor(u){this.a=u}listen(u,h){throw new Error("Invalid listen")}call(u,h,g){switch(h){case"getConfigBasedTips":return this.a.getConfigBasedTips(C.URI.revive(g[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$3o=m}),define(pe[82],be([1,0,6]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=void 0,e.$Xo=(0,D.$ph)("IExtensionSignatureVerificationService");class O{b(){return this.a||(this.a=new Promise((C,I)=>ce(["node-vsce-sign"],async P=>C(P),I))),this.a}async verify(C,I,P){let w;try{w=await this.b()}catch{return!1}return w.verify(C,I,P)}}e.$Yo=O}),define(pe[16],be([1,0,61,7,17,10,4,186,6,3,13]),function(ce,e,D,O,r,C,I,P,w,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileKind=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.FileOperationResult=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.FileChangeType=e.$0j=e.FileOperation=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.FileSystemProviderErrorCode=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Tj=e.$Sj=void 0,e.$Sj=(0,w.$ph)("fileService");function k(H){return H.create===!0}e.$Tj=k;var p;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var l;(function(H){H[H.Readonly=1]="Readonly",H[H.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var d;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileAtomicWrite=32768]="FileAtomicWrite",H[H.FileAtomicDelete=65536]="FileAtomicDelete",H[H.FileClone=131072]="FileClone"})(d||(e.FileSystemProviderCapabilities=d={}));function m(H){return!!(H.capabilities&2)}e.$Uj=m;function c(H){return!!(H.capabilities&8)}e.$Vj=c;function u(H){return!!(H.capabilities&131072)}e.$Wj=u;function h(H){return!!(H.capabilities&4)}e.$Xj=h;function g(H){return!!(H.capabilities&16)}e.$Yj=g;function E(H){return m(H)?!!(H.capabilities&16384):!1}e.$Zj=E;function v(H){return m(H)?!!(H.capabilities&32768):!1}e.$1j=v;function t(H){return!!(H.capabilities&65536)}e.$2j=t;function s(H){return!!(H.capabilities&2048)}e.$3j=s;var a;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsStorageQuota="EntryExceedsStorageQuota",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(a||(e.FileSystemProviderErrorCode=a={}));class i extends Error{static create(te,me){const ne=new i(te.toString(),me);return f(ne,me),ne}constructor(te,me){super(te),this.code=me}}e.$4j=i;function n(H,te){return i.create(H,te)}e.$5j=n;function o(H){return H||n((0,P.localize)(0,null),a.Unknown)}e.$6j=o;function f(H,te){return H.name=te?`${te} (FileSystemError)`:"FileSystemError",H}e.$7j=f;function b(H){if(!H)return a.Unknown;if(H instanceof i)return H.code;const te=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!te)return a.Unknown;switch(te[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.$8j=b;function y(H){if(H instanceof Y)return H.fileOperationResult;switch(b(H)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 9;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileTooLarge:return 7;default:return 10}}e.$9j=y;var S;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(S||(e.FileOperation=S={}));class L{constructor(te,me,ne){this.resource=te,this.operation=me,this.target=ne}isOperation(te){return this.operation===te}}e.$0j=L;var j;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class Q{constructor(te,me){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ne=new Map;for(const q of te){const J=ne.get(q.type);switch(J?J.push([q.resource,q]):ne.set(q.type,[[q.resource,q]]),q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}}for(const[q,J]of ne)switch(q){case 1:this.a=D.$vh.forUris(()=>me),this.a.fill(J);break;case 0:this.b=D.$vh.forUris(()=>me),this.b.fill(J);break;case 2:this.c=D.$vh.forUris(()=>me),this.c.fill(J);break}}contains(te,...me){return this.d(te,{includeChildren:!1},...me)}affects(te,...me){return this.d(te,{includeChildren:!0},...me)}d(te,me,...ne){if(!te)return!1;const q=ne.length>0;return!!((!q||ne.includes(1))&&(this.a?.get(te)||me.includeChildren&&this.a?.findSuperstr(te))||(!q||ne.includes(0))&&(this.b?.get(te)||me.includeChildren&&this.b?.findSuperstr(te))||(!q||ne.includes(2))&&(this.c?.findSubstr(te)||me.includeChildren&&this.c?.findSuperstr(te)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$$j=Q;function le(H,te,me){return!H||!te||H===te||te.length>H.length?!1:(te.charAt(te.length-1)!==O.sep&&(te+=O.sep),me?(0,r.$Md)(H,te):H.indexOf(te)===0)}e.$_j=le;class Y extends Error{constructor(te,me,ne){super(te),this.fileOperationResult=me,this.options=ne}}e.$ak=Y;class ee extends Y{constructor(te,me,ne,q){super(te,me,q),this.fileOperationResult=me,this.size=ne}}e.$bk=ee;class ue extends Y{constructor(te,me,ne){super(te,2,ne),this.stat=me}}e.$ck=ue;var X;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(X||(e.FileOperationResult=X={})),e.$dk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ek={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$fk="files.associations",e.$gk="files.exclude",e.$hk="files.readonlyInclude",e.$ik="files.readonlyExclude",e.$jk="files.readonlyFromPermissions";var he;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(he||(e.FileKind=he={})),e.$kk="";function x(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.$lk=x;async function se(H,te){if(!te.hasProvider(I.URI.from({scheme:H.scheme})))return new Promise(me=>{const ne=te.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===H.scheme&&q.added&&(ne.dispose(),me())})})}e.$mk=se;class V{static{this.KB=1024}static{this.MB=V.KB*V.KB}static{this.GB=V.MB*V.KB}static{this.TB=V.GB*V.KB}static formatSize(te){return(0,C.$me)(te)||(te=0),te<V.KB?(0,P.localize)(1,null,te.toFixed(0)):te<V.MB?(0,P.localize)(2,null,(te/V.KB).toFixed(2)):te<V.GB?(0,P.localize)(3,null,(te/V.MB).toFixed(2)):te<V.TB?(0,P.localize)(4,null,(te/V.GB).toFixed(2)):(0,P.localize)(5,null,(te/V.TB).toFixed(2))}}e.$nk=V;function K(H){const te=typeof H=="string"||H?.scheme===A.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===A.Schemas.file?1024*V.MB:te?10*V.MB:$.$o?50*V.MB:1024*V.MB}e.$ok=K}),define(pe[217],be([1,0,15,38,11,5,2,48,4,23,16]),function(ce,e,D,O,r,C,I,P,w,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=e.$QM=void 0,e.$QM="localFilesystem";class k extends I.$lb{constructor(l,d){super(),this.a=l,this.b=d,this.onDidChangeCapabilities=C.Event.None,this.f=this.B(new C.$ec),this.onDidChangeFile=this.f.event,this.g=this.B(new C.$ec),this.onDidWatchError=this.g.event,this.h=(0,$.$3e)(),this.i()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(l){return this.a.call("stat",[l])}readdir(l){return this.a.call("readdir",[l])}async readFile(l,d){const{buffer:m}=await this.a.call("readFile",[l,d]);return m}readFileStream(l,d,m){const c=(0,P.$sc)(h=>D.$Ec.concat(h.map(g=>D.$Ec.wrap(g))).buffer),u=this.a.listen("readFileStream",[l,d])(h=>{if(h instanceof D.$Ec)c.write(h.buffer);else{if(h==="end")c.end();else{let g;if(h instanceof Error)g=h;else{const E=h;g=(0,A.$5j)(E.message??(0,O.$ai)(E),E.code??A.FileSystemProviderErrorCode.Unknown)}c.error(g),c.end()}u.dispose()}});return m.onCancellationRequested(()=>{c.error((0,r.$4)()),c.end(),u.dispose()}),c}writeFile(l,d,m){return this.a.call("writeFile",[l,D.$Ec.wrap(d),m])}open(l,d){return this.a.call("open",[l,d])}close(l){return this.a.call("close",[l])}async read(l,d,m,c,u){const[h,g]=await this.a.call("read",[l,d,u]);return m.set(h.buffer.slice(0,g),c),g}write(l,d,m,c,u){return this.a.call("write",[l,d,D.$Ec.wrap(m),c,u])}mkdir(l){return this.a.call("mkdir",[l])}delete(l,d){return this.a.call("delete",[l,d])}rename(l,d,m){return this.a.call("rename",[l,d,m])}copy(l,d,m){return this.a.call("copy",[l,d,m])}cloneFile(l,d){return this.a.call("cloneFile",[l,d])}i(){this.B(this.a.listen("fileChange",[this.h])(l=>{if(Array.isArray(l)){const d=l;this.f.fire(d.map(m=>({resource:w.URI.revive(m.resource),type:m.type})))}else{const d=l;this.g.fire(d)}}))}watch(l,d){const m=(0,$.$3e)();return this.a.call("watch",[this.h,m,l,d]),(0,I.$jb)(()=>this.a.call("unwatch",[this.h,m]))}}e.$RM=k}),define(pe[110],be([1,0,15,11,187,16]),function(ce,e,D,O,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=void 0;async function I(A,k,p,l,d,m){let c;try{await P(A,k,p,l,d,m)}catch(u){c=u}finally{c&&d.errorTransformer&&(c=d.errorTransformer(c)),typeof c<"u"&&p.error(c),p.end()}}e.$tp=I;async function P(A,k,p,l,d,m){w(m);const c=await A.open(k,{create:!1});try{w(m);let u=0,h=0,g=d&&typeof d.length=="number"?d.length:void 0,E=D.$Ec.alloc(Math.min(d.bufferSize,typeof g=="number"?g:d.bufferSize)),v=d&&typeof d.position=="number"?d.position:0,t=0;do h=await A.read(c,v,E.buffer,t,E.byteLength-t),v+=h,t+=h,u+=h,typeof g=="number"&&(g-=h),t===E.byteLength&&(await p.write(l(E)),E=D.$Ec.alloc(Math.min(d.bufferSize,typeof g=="number"?g:d.bufferSize)),t=0);while(h>0&&(typeof g!="number"||g>0)&&w(m)&&$(u,d));if(t>0){let s=t;typeof g=="number"&&(s=Math.min(t,g)),p.write(l(E.slice(0,s)))}}catch(u){throw(0,C.$6j)(u)}finally{await A.close(c)}}function w(A){if(A.isCancellationRequested)throw(0,O.$4)();return!0}function $(A,k){if(typeof k?.limits?.size=="number"&&A>k.limits.size)throw(0,C.$5j)((0,r.localize)(0,null),C.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(pe[67],be([1,0,78,2,7,3,4,16]),function(ce,e,D,O,r,C,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=void 0;function w(u){return u.recursive===!0}e.$vp=w;class $ extends O.$lb{static{this.a=5}constructor(h,g,E,v){super(),this.h=h,this.i=g,this.j=E,this.k=v,this.c=this.B(new O.$mb),this.f=void 0,this.g=0}m(){const h=new O.$kb;this.c.value=h,this.b=this.l(h),this.b.setVerboseLogging(this.j),h.add(this.b.onDidChangeFile(g=>this.h(g))),h.add(this.b.onDidLogMessage(g=>this.i(g))),h.add(this.b.onDidError(g=>this.n(g)))}n(h){this.k.restartOnError?this.g<$.a&&this.f?(this.r(`restarting watcher after error: ${h}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${h}`):this.r(h)}p(h){this.g++,this.m(),this.watch(h)}async watch(h){this.f=h,await this.b?.watch(h)}async setVerboseLogging(h){this.j=h,await this.b?.setVerboseLogging(h)}r(h){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${h}`})}s(h){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${h}`})}dispose(){return this.b=void 0,super.dispose()}}e.$wp=$;class A extends ${constructor(h,g,E){super(h,g,E,{type:"node.js",restartOnError:!1})}}e.$xp=A;class k extends ${constructor(h,g,E){super(h,g,E,{type:"universal",restartOnError:!0})}}e.$yp=k;function p(u){return u.map(h=>({type:h.type,resource:I.URI.file(h.path)}))}e.$zp=p;function l(u){const h=new c;for(const g of u)h.processEvent(g);return h.coalesce()}e.$Ap=l;function d(u,h){return typeof h=="string"&&!h.startsWith(D.$aj)&&!(0,r.$7c)(h)?{base:u,pattern:h}:h}e.$Bp=d;function m(u,h){const g=[];for(const E of h)g.push((0,D.$ej)(d(u,E)));return g}e.$Cp=m;class c{constructor(){this.a=new Set,this.b=new Map}c(h){return C.$k?h.path:h.path.toLowerCase()}processEvent(h){const g=this.b.get(this.c(h));let E=!1;if(g){const v=g.type,t=h.type;g.path!==h.path&&(h.type===2||h.type===1)?E=!0:v===1&&t===2?(this.b.delete(this.c(h)),this.a.delete(g)):v===2&&t===1?g.type=0:v===1&&t===0||(g.type=t)}else E=!0;E&&(this.a.add(h),this.b.set(this.c(h),h))}coalesce(){const h=[],g=[];return Array.from(this.a).filter(E=>E.type!==2?(h.push(E),!1):!0).sort((E,v)=>E.path.length-v.path.length).filter(E=>g.some(v=>(0,P.$_j)(E.path,v,!C.$k))?!1:(g.push(E.path),!0)).concat(h)}}}),define(pe[218],be([1,0,28,14,20,39,2,98,7,3,167,21,67]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Pp=void 0;class l extends I.$lb{static{this.a=100}static{this.b=75}constructor(c,u,h,g){super(),this.j=c,this.k=u,this.l=h,this.m=g,this.c=this.B(new O.$Jg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},E=>this.k(E))),this.f=this.B(new O.$Ig(E=>this.u(E),l.b)),this.g=(0,p.$Cp)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,p.$Cp)(this.j.path,this.j.includes):void 0,this.i=new r.$oc,this.ready=this.n()}async n(){try{const c=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const u=await k.Promises.stat(c);this.B(await this.s(c,u.isDirectory()))}catch(c){c.code!=="ENOENT"?this.w(c):this.z(c)}}async r(c){let u=c.path;try{u=await k.Promises.realpath(c.path),c.path===u&&(u=await(0,A.$Mp)(c.path)??c.path),c.path!==u&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${c.path}, real: ${u})`)}catch{}return u}async s(c,u){if($.$j&&(0,C.$He)(c,"/Volumes/",!0))return this.w(`Refusing to watch ${c} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),I.$lb.None;const h=new r.$oc(this.i.token),g=new I.$kb;try{const E=(0,w.$_c)(c),v=(0,D.watch)(c);g.add((0,I.$jb)(()=>{v.removeAllListeners(),v.close()})),this.z(`Started watching: '${c}'`);const t=new Set;if(u)try{for(const a of await k.Promises.readdir(c))t.add(a)}catch(a){this.w(a)}const s=new Map;g.add((0,I.$jb)(()=>{for(const[,a]of s)a.dispose();s.clear()})),v.on("error",(a,i)=>{this.w(`Failed to watch ${c} for changes using fs.watch() (${a}, ${i})`),this.dispose()}),v.on("change",(a,i)=>{if(h.token.isCancellationRequested)return;this.z(`[raw] ["${a}"] ${i}`);let n="";if(i&&(n=i.toString(),$.$j&&(n=(0,P.$7k)(n))),!(!n||a!=="change"&&a!=="rename"))if(u)if(a==="rename"){s.get(n)?.dispose();const o=setTimeout(async()=>{if(s.delete(n),n===E&&!await k.Promises.exists(c)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const f=await this.v((0,w.$8c)(c,n));if(h.token.isCancellationRequested)return;let b;f?t.has(n)?b=0:(b=1,t.add(n)):(t.delete(n),b=2),this.t({path:(0,w.$8c)(this.j.path,n),type:b})},l.a);s.set(n,(0,I.$jb)(()=>clearTimeout(o)))}else{let o;t.has(n)?o=0:(o=1,t.add(n)),this.t({path:(0,w.$8c)(this.j.path,n),type:o})}else if(a==="rename"||n!==E){const o=setTimeout(async()=>{const f=await k.Promises.exists(c);h.token.isCancellationRequested||(f?(this.t({path:this.j.path,type:0},!0),g.add(await this.s(c,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},l.a);g.clear(),g.add((0,I.$jb)(()=>clearTimeout(o)))}else this.t({path:this.j.path,type:0},!0)})}catch(E){await k.Promises.exists(c)&&!h.token.isCancellationRequested&&this.w(`Failed to watch ${c} for changes using fs.watch() (${E.toString()})`)}return(0,I.$jb)(()=>{h.dispose(!0),g.dispose()})}t(c,u=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`),!u&&this.g.some(h=>h(c.path))?this.m&&this.z(` >> ignored (excluded) ${c.path}`):!u&&this.h&&this.h.length>0&&!this.h.some(h=>h(c.path))?this.m&&this.z(` >> ignored (not included) ${c.path}`):this.f.work(c))}u(c){const u=(0,p.$Ap)(c);if(u.length>0){if(this.m)for(const g of u)this.z(`>> normalized ${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`);this.c.work(u)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(c){if($.$k)return k.Promises.exists(c);try{const u=(0,w.$_c)(c);return(await k.Promises.readdir((0,w.$$c)(c))).some(g=>g===u)}catch(u){return this.z(u),!1}}setVerboseLogging(c){this.m=c}w(c){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${c}`})}y(c){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${c}`})}z(c){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${c}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.$Pp=l;async function d(m,c,u,h,g=512){const E=await k.Promises.open(m,"r"),v=Buffer.allocUnsafe(g),t=new r.$oc(h);let s,a=!1;const i={path:m,excludes:[],recursive:!1},n=new l(i,o=>{(async()=>{for(const{type:f}of o)if(f===0){if(a)return;a=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:b}=await k.Promises.read(E,v,0,g,null);if(!b||t.token.isCancellationRequested)break;c(v.slice(0,b))}}catch(b){s=new Error(b),t.dispose(!0)}finally{a=!1}}})()});return await n.ready,u(),new Promise((o,f)=>{t.token.onCancellationRequested(async()=>{n.dispose();try{await k.Promises.close(E)}catch(b){s=new Error(b)}s?f(s):o()})})}e.$Qp=d}),define(pe[219],be([1,0,5,78,2,3,218]),function(ce,e,D,O,r,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0;class P extends r.$lb{constructor(){super(...arguments),this.a=this.B(new D.$ec),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$ec),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch($){const A=this.i($),k=A.filter(l=>{const d=this.c.get(l.path);return d?!(0,O.$ij)(d.request.excludes,l.excludes)||!(0,O.$ij)(d.request.includes,l.includes):!0}),p=Array.from(this.c.values()).filter(({request:l})=>!A.find(d=>d.path===l.path&&(0,O.$ij)(d.excludes,l.excludes)&&(0,O.$ij)(d.includes,l.includes))).map(({request:l})=>l.path);k.length&&this.j(`Request to start watching: ${k.map(l=>`${l.path} (excludes: ${l.excludes.length>0?l.excludes:"<none>"}, includes: ${l.includes&&l.includes.length>0?JSON.stringify(l.includes):"<all>"})`).join(",")}`),p.length&&this.j(`Request to stop watching: ${p.join(",")}`);for(const l of p)this.h(l);for(const l of k)this.g(l)}g($){const A=new I.$Pp($,p=>this.a.fire(p),p=>this.b.fire(p),this.f),k={request:$,instance:A};this.c.set($.path,k)}async stop(){for(const[$]of this.c)this.h($);this.c.clear()}h($){const A=this.c.get($);A&&(this.c.delete($),A.instance.dispose())}i($){const A=new Map;for(const k of $){const p=C.$k?k.path:k.path.toLowerCase();A.set(p,k)}return Array.from(A.values())}async setVerboseLogging($){this.f=$;for(const[,A]of this.c)A.instance.setVerboseLogging($)}j($){this.f&&this.b.fire({type:"trace",message:this.k($)})}k($,A){return A?`[File Watcher (node.js)] ${$} (path: ${A.request.path})`:`[File Watcher (node.js)] ${$}`}}e.$Rp=P}),define(pe[220],be([1,0,67,219]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;class r extends D.$xp{constructor(I,P,w){super(I,P,w),this.m()}l(){return new O.$Rp}}e.$Sp=r}),define(pe[221],be([1,0,13,43,108,67]),function(ce,e,D,O,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;class I extends C.$yp{constructor(w,$,A){super(w,$,A),this.m()}l(w){const $=w.add(new r.$Jp(D.$1e.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add($.onDidProcessExit(({code:A,signal:k})=>this.n(`terminated by itself with code ${A}, signal: ${k}`))),O.ProxyChannel.toService((0,O.$9g)($.getChannel("watcher")))}}e.$Kp=I}),define(pe[83],be([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=void 0;class D{constructor(...r){this.a=new Map;for(const[C,I]of r)this.set(C,I)}set(r,C){const I=this.a.get(r);return this.a.set(r,C),I}has(r){return this.a.has(r)}get(r){return this.a.get(r)}}e.$nh=D}),define(pe[111],be([1,0,14,11,2,65,214,6,83,97]),function(ce,e,D,O,r,C,I,P,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=void 0;const A=!1;class k extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class p{constructor(c=new w.$nh,u=!1,h,g=A){this.f=c,this.g=u,this.h=h,this.i=g,this.o=new Set,this.f.set(P.$oh,this),this._globalGraph=g?h?._globalGraph??new I.$Vp(E=>E):void 0}createChild(c){return new p(c,this.g,this,this.i)}invokeFunction(c,...u){const h=d.traceInvocation(this.i,c);let g=!1;try{return c({get:v=>{if(g)throw(0,O.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(v,h);if(!t)throw new Error(`[invokeFunction] unknown service '${v}'`);return t}},...u)}finally{g=!0,h.stop()}}createInstance(c,...u){let h,g;return c instanceof C.$mh?(h=d.traceCreation(this.i,c.ctor),g=this.j(c.ctor,c.staticArguments.concat(u),h)):(h=d.traceCreation(this.i,c),g=this.j(c,u,h)),h.stop(),g}j(c,u=[],h){const g=P._util.getServiceDependencies(c).sort((t,s)=>t.index-s.index),E=[];for(const t of g){const s=this.m(t.id,h);s||this.u(`[createInstance] ${c.name} depends on UNKNOWN service ${t.id}.`,!1),E.push(s)}const v=g.length>0?g[0].index:u.length;if(u.length!==v){console.trace(`[createInstance] First service dependency of ${c.name} at position ${v+1} conflicts with ${u.length} static arguments`);const t=v-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,v)}return Reflect.construct(c,u.concat(E))}k(c,u){if(this.f.get(c)instanceof C.$mh)this.f.set(c,u);else if(this.h)this.h.k(c,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(c){const u=this.f.get(c);return!u&&this.h?this.h.l(c):u}m(c,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const h=this.l(c);return h instanceof C.$mh?this.q(c,h,u.branch(c,!0)):(u.branch(c,!1),h)}q(c,u,h){if(this.o.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.o.add(c);try{return this.r(c,u,h)}finally{this.o.delete(c)}}r(c,u,h){const g=new I.$Vp(t=>t.id.toString());let E=0;const v=[{id:c,desc:u,_trace:h}];for(;v.length;){const t=v.pop();if(g.lookupOrInsertNode(t),E++>1e3)throw new k(g);for(const s of P._util.getServiceDependencies(t.desc.ctor)){const a=this.l(s.id);if(a||this.u(`[createInstance] ${c} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),a instanceof C.$mh){const i={id:s.id,desc:a,_trace:t._trace.branch(s.id,!0)};g.insertEdge(t,i),v.push(i)}}}for(;;){const t=g.roots();if(t.length===0){if(!g.isEmpty())throw new k(g);break}for(const{data:s}of t){if(this.l(s.id)instanceof C.$mh){const i=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,i)}g.removeNode(s)}}return this.l(c)}s(c,u,h=[],g,E){if(this.f.get(c)instanceof C.$mh)return this.t(c,u,h,g,E);if(this.h)return this.h.s(c,u,h,g,E);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(c,u,h=[],g,E){if(g){const v=new p(void 0,this.g,this,this.i);v.c=String(c);const t=new Map,s=new D.$Lg(()=>{const a=v.j(u,h,E);for(const[i,n]of t){const o=a[i];if(typeof o=="function")for(const f of n)o.apply(a,f)}return t.clear(),a});return new Proxy(Object.create(null),{get(a,i){if(!s.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let f=t.get(i);return f||(f=new $.$ub,t.set(i,f)),(y,S,L)=>{const j=f.push([y,S,L]);return(0,r.$jb)(j)}}if(i in a)return a[i];const n=s.value;let o=n[i];return typeof o!="function"||(o=o.bind(n),a[i]=o),o},set(a,i,n){return s.value[i]=n,!0},getPrototypeOf(a){return u.prototype}})}else return this.j(u,h,E)}u(c,u){if(u&&console.warn(c),this.g)throw new Error(c)}}e.$Wp=p;var l;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(l||(l={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(c,u){return c?new d(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(c,u){return c?new d(1,u.name):d.c}static{this.f=0}constructor(c,u){this.type=c,this.name=u,this.g=Date.now(),this.h=[]}branch(c,u){const h=new d(3,c.toString());return this.h.push([c,u,h]),h}stop(){const c=Date.now()-this.g;d.f+=c;let u=!1;function h(E,v){const t=[],s=new Array(E+1).join("	");for(const[a,i,n]of v.h)if(i&&n){u=!0,t.push(`${s}CREATES -> ${a}`);const o=h(E+1,n);o&&t.push(o)}else t.push(`${s}uses -> ${a}`);return t.join(`
`)}const g=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(c>2||u)&&d.all.add(g.join(`
`))}}e.$Xp=d}),define(pe[222],be([1,0,6]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.$Kz=void 0,e.$Kz=(0,D.$ph)("labelService");var O;(function(r){r[r.SHORT=0]="SHORT",r[r.MEDIUM=1]="MEDIUM",r[r.LONG=2]="LONG"})(O||(e.Verbosity=O={}))});var Ie=this&&this.__param||function(ce,e){return function(D,O){e(D,O,ce)}};define(pe[84],be([1,0,20,2,3,189,31,6]),function(ce,e,D,O,r,C,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$zq=e.$yq=void 0;function w(A){return A.tags.find(k=>k.startsWith("lp-"))?.split("lp-")[1]}e.$yq=w,e.$zq=(0,P.$ph)("languagePackService");let $=class extends O.$lb{constructor(k){super(),this.c=k}async getAvailableLanguages(){const k=new D.$oc;setTimeout(()=>k.cancel(),1e3);let p;try{p=await this.c.query({text:'category:"language packs"',pageSize:20},k.token)}catch{return[]}const d=p.firstPage.filter(m=>m.properties.localizedLanguages?.length&&m.tags.some(c=>c.startsWith("lp-"))).map(m=>{const c=m.properties.localizedLanguages?.[0],u=w(m);return{...this.f(u,c,m),extensionId:m.identifier.id,galleryExtension:m}});return d.push(this.f("en","English")),d}f(k,p,l){const d=p??k;let m;if(d!==k&&(m=`(${k})`),k.toLowerCase()===r.$v.toLowerCase()&&(m??="",m+=(0,C.localize)(0,null)),l?.installCount){m??="";const c=l.installCount;let u;c>1e6?u=`${Math.floor(c/1e5)/10}M`:c>1e3?u=`${Math.floor(c/1e3)}K`:u=String(c),m+=` $(cloud-download) ${u}`}return{id:k,label:d,description:m}}};e.$Aq=$,e.$Aq=$=Le([Ie(0,I.$Rn)],$)}),define(pe[12],be([1,0,38,5,59,2,27,3,19,10,4,66,6]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.log=e.$Ui=e.LogLevel=e.$Ti=e.$Si=e.$Ri=void 0,e.$Ri=(0,p.$ph)("logService"),e.$Si=(0,p.$ph)("loggerService");function l(){return new Date().toISOString()}function d(y){return(0,$.$me)(y)}e.$Ti=d;var m;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$Ui=m.Info;function c(y,S,L){switch(S){case m.Trace:y.trace(L);break;case m.Debug:y.debug(L);break;case m.Info:y.info(L);break;case m.Warning:y.warn(L);break;case m.Error:y.error(L);break;case m.Off:break;default:throw new Error(`Invalid log level ${S}`)}}e.log=c;function u(y,S=!1){let L="";for(let j=0;j<y.length;j++){let Q=y[j];if(Q instanceof Error&&(Q=(0,D.$ai)(Q,S)),typeof Q=="object")try{Q=JSON.stringify(Q)}catch{}L+=(j>0?" ":"")+Q}return L}class h extends C.$lb{constructor(){super(...arguments),this.b=e.$Ui,this.c=this.B(new O.$ec),this.onDidChangeLogLevel=this.c.event}setLevel(S){this.b!==S&&(this.b=S,this.c.fire(this.b))}getLevel(){return this.b}f(S){return this.b!==m.Off&&this.b<=S}}e.$Wi=h;class g extends h{constructor(S){super(),this.h=S}f(S){return this.h||super.f(S)}trace(S,...L){this.f(m.Trace)&&this.g(m.Trace,u([S,...L],!0))}debug(S,...L){this.f(m.Debug)&&this.g(m.Debug,u([S,...L]))}info(S,...L){this.f(m.Info)&&this.g(m.Info,u([S,...L]))}warn(S,...L){this.f(m.Warning)&&this.g(m.Warning,u([S,...L]))}error(S,...L){if(this.f(m.Error))if(S instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=S.stack,this.g(m.Error,u(j))}else this.g(m.Error,u([S,...L]))}flush(){}}e.$Xi=g;class E extends h{constructor(S=e.$Ui){super(),this.setLevel(S),this.g=!P.$i}trace(S,...L){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,S,...L):console.log(`[main ${l()}]`,S,...L))}debug(S,...L){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,S,...L):console.log(`[main ${l()}]`,S,...L))}info(S,...L){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,S,...L):console.log(`[main ${l()}]`,S,...L))}warn(S,...L){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,S,...L):console.warn(`[main ${l()}]`,S,...L))}error(S,...L){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,S,...L):console.error(`[main ${l()}]`,S,...L))}dispose(){}flush(){}}e.$Yi=E;class v extends h{constructor(S=e.$Ui,L=!0){super(),this.g=L,this.setLevel(S)}trace(S,...L){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",S,...L):console.log(S,...L))}debug(S,...L){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",S,...L):console.log(S,...L))}info(S,...L){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",S,...L):console.log(S,...L))}warn(S,...L){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",S,...L):console.log(S,...L))}error(S,...L){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",S,...L):console.error(S,...L))}dispose(){}flush(){}}e.$Zi=v;class t extends h{constructor(S,L=e.$Ui){super(),this.g=S,this.setLevel(L)}trace(S,...L){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(S),...L])}debug(S,...L){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(S),...L])}info(S,...L){this.f(m.Info)&&this.g.log(m.Info,[this.h(S),...L])}warn(S,...L){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(S),...L])}error(S,...L){this.f(m.Error)&&this.g.log(m.Error,[this.h(S),...L])}h(S){return typeof S=="string"?S:(0,D.$ai)(S,this.f(m.Trace))}dispose(){}flush(){}}e.$1i=t;class s extends h{constructor(S){super(),this.g=S,S.length&&this.setLevel(S[0].getLevel())}setLevel(S){for(const L of this.g)L.setLevel(S);super.setLevel(S)}trace(S,...L){for(const j of this.g)j.trace(S,...L)}debug(S,...L){for(const j of this.g)j.debug(S,...L)}info(S,...L){for(const j of this.g)j.info(S,...L)}warn(S,...L){for(const j of this.g)j.warn(S,...L)}error(S,...L){for(const j of this.g)j.error(S,...L)}flush(){for(const S of this.g)S.flush()}dispose(){for(const S of this.g)S.dispose()}}e.$2i=s;class a extends C.$lb{constructor(S,L,j){if(super(),this.h=S,this.j=L,this.b=new I.$ni,this.c=this.B(new O.$ec),this.onDidChangeLoggers=this.c.event,this.f=this.B(new O.$ec),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new O.$ec),this.onDidChangeVisibility=this.g.event,j)for(const Q of j)this.b.set(Q.resource,{logger:void 0,info:Q})}k(S){return(0,$.$ie)(S)?[...this.b.values()].find(L=>L.info.id===S):this.b.get(S)}getLogger(S){return this.k(S)?.logger}createLogger(S,L){const j=this.l(S),Q=(0,$.$ie)(S)?S:L?.id??(0,r.$di)(j.toString()).toString(16);let le=this.b.get(j)?.logger;const Y=L?.logLevel==="always"?m.Trace:L?.logLevel;le||(le=this.m(j,Y??this.getLogLevel(j)??this.h,{...L,id:Q}));const ee={logger:le,info:{resource:j,id:Q,logLevel:Y,name:L?.name,hidden:L?.hidden,extensionId:L?.extensionId,when:L?.when}};return this.registerLogger(ee.info),this.b.set(j,ee),le}l(S){return(0,$.$ie)(S)?(0,w.$9f)(this.j,`${S}.log`):S}setLogLevel(S,L){if(A.URI.isUri(S)){const j=S,Q=L,le=this.b.get(j);le&&Q!==le.info.logLevel&&(le.info.logLevel=Q===this.h?void 0:Q,le.logger?.setLevel(Q),this.b.set(le.info.resource,le),this.f.fire([j,Q]))}else{this.h=S;for(const[j,Q]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&Q.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(S,L){const j=this.k(S);j&&L!==!j.info.hidden&&(j.info.hidden=!L,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,L]))}getLogLevel(S){let L;return S&&(L=this.b.get(S)?.info.logLevel),L??this.h}registerLogger(S){const L=this.b.get(S.resource);L?L.info.hidden!==S.hidden&&this.setVisibility(S.resource,!S.hidden):(this.b.set(S.resource,{info:S,logger:void 0}),this.c.fire({added:[S],removed:[]}))}deregisterLogger(S){const L=this.b.get(S);L&&(L.logger&&L.logger.dispose(),this.b.delete(S),this.c.fire({added:[],removed:[L.info]}))}*getRegisteredLoggers(){for(const S of this.b.values())yield S.info}getRegisteredLogger(S){return this.b.get(S)?.info}dispose(){this.b.forEach(S=>S.logger?.dispose()),this.b.clear(),super.dispose()}}e.$3i=a;class i{constructor(){this.onDidChangeLogLevel=new O.$ec().event}setLevel(S){}getLevel(){return m.Info}trace(S,...L){}debug(S,...L){}info(S,...L){}warn(S,...L){}error(S,...L){}critical(S,...L){}dispose(){}flush(){}}e.$4i=i;class n extends i{}e.$5i=n;function o(y){if(y.verbose)return m.Trace;if(typeof y.logLevel=="string"){const S=b(y.logLevel.toLowerCase());if(S!==void 0)return S}return e.$Ui}e.$6i=o;function f(y){switch(y){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.$7i=f;function b(y){switch(y){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$8i=b,e.$9i=new k.$Oi("logLevel",f(m.Info))}),define(pe[223],be([1,0,80,5,2,12,3,14]),function(ce,e,D,O,r,C,I,P){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=void 0;let $=class extends r.$lb{static{w=this}static{this.a=2500}static{this.b=w.a-100}constructor(k){super(),this.h=k,this.c=this.B(new O.$ec),this.onDidChangePassword=this.c.event,this.g=new P.$qg}async getPassword(k,p){this.h.trace("Going to get password from keytar:",k,p);let l;try{l=await this.i()}catch{return null}return await this.g.queue(k+p,()=>this.k(l,k,p))}async k(k,p,l){this.h.trace("Doing get password from keytar:",p,l);const d=await(0,P.$Mg)(()=>k.getPassword(p,l),50,3);if(!d)return this.h.trace("Did not get a password from keytar for account:",l),d;let m,c;try{const u=JSON.parse(d);m=u.content,c=u.hasNextChunk}catch{}if(!m||!c)return this.h.trace("Got password from keytar for account:",l),d;try{let u=1;for(;c;){const h=await(0,P.$Mg)(()=>k.getPassword(p,`${l}-${u}`),50,3),g=JSON.parse(h);m+=g.content,c=g.hasNextChunk,u++}return this.h.trace(`Got ${u}-chunked password from keytar for account:`,l),m}catch(u){return this.h.error(u),d}}async setPassword(k,p,l){this.h.trace("Going to set password using keytar:",k,p);let d;try{d=await this.i()}catch(m){throw this.j?.(m),m}await this.g.queue(k+p,()=>this.l(d,k,p,l)),this.c.fire({service:k,account:p})}async l(k,p,l,d){if(this.h.trace("Doing set password from keytar:",p,l),!I.$i){await(0,P.$Mg)(()=>k.setPassword(p,l,d),50,3),this.h.trace("Set password from keytar for account:",l);return}if(await this.m(k,p,l),d.length<=w.b){await(0,P.$Mg)(()=>k.setPassword(p,l,d),50,3),this.h.trace("Set password from keytar for account:",l);return}let m=0,c=0,u=!0;for(;u;){const h=d.substring(m,m+w.b);m+=w.b,u=d.length-m>0;const g={content:h,hasNextChunk:u};await(0,P.$Mg)(()=>k.setPassword(p,c?`${l}-${c}`:l,JSON.stringify(g)),50,3),c++}this.h.trace(`Set${c?` ${c}-chunked`:""} password from keytar for account:`,l)}async deletePassword(k,p){this.h.trace("Going to delete password using keytar:",k,p);let l;try{l=await this.i()}catch(m){throw this.j?.(m),m}const d=await this.g.queue(k+p,()=>this.m(l,k,p));return d&&this.c.fire({service:k,account:p}),d}async m(k,p,l){this.h.trace("Doing delete password from keytar:",p,l);const d=await k.getPassword(p,l);if(!d)return this.h.trace("Did not get a password to delete from keytar for account:",l),!1;let m,c;try{const h=JSON.parse(d);m=h.content,c=h.hasNextChunk}catch{}let u=0;if(m&&c)try{for(u++;c;){const h=`${l}-${u}`,g=await k.getPassword(p,h);await k.deletePassword(p,h),c=JSON.parse(g).hasNextChunk,u++}}catch(h){this.h.error(h)}return await k.deletePassword(p,l)?(this.h.trace(`Deleted${u?` ${u}-chunked`:""} password from keytar for account:`,l),!0):(this.h.trace(`Keytar failed to delete${u?` ${u}-chunked`:""} password for account:`,l),!1)}async findPassword(k){let p;try{p=await this.i()}catch{return null}return await p.findPassword(k)}async findCredentials(k){let p;try{p=await this.i()}catch{return[]}return await p.findCredentials(k)}clear(){return this.f instanceof D.$pn?this.f.clear():Promise.resolve()}};e.$qn=$,e.$qn=$=w=Le([Ie(0,C.$Ri)],$)}),define(pe[224],be([1,0,18,14,11,5,2,7,67,12]),function(ce,e,D,O,r,C,I,P,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;class A extends I.$lb{constructor(p,l){super(),this.a=p,this.b=l,this.c=this.B(new C.$ec),this.onDidChangeFile=this.c.event,this.g=this.B(new C.$ec),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new O.$sg(0)),this.s=[],this.t=this.B(new O.$sg(0))}watch(p,l){return l.recursive||this.b?.watcher?.forceUniversal?this.l(p,l):this.u(p,l)}l(p,l){const d={path:this.C(p),excludes:l.excludes,includes:l.includes,recursive:l.recursive},m=(0,D.$yf)(this.j,d);return this.m(),(0,I.$jb)(()=>{m(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(p=>(0,r.$Y)(p))}n(){this.h||(this.h=this.B(this.p(l=>this.c.fire((0,w.$zp)(l)),l=>this.z(l),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const l of this.j)(0,w.$vp)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const l of this.j)(0,w.$vp)(l)&&p.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(p,l){const d={path:this.C(p),excludes:l.excludes,includes:l.includes,recursive:!1},m=(0,D.$yf)(this.s,d);return this.v(),(0,I.$jb)(()=>{m(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(p=>(0,r.$Y)(p))}w(){return this.r||(this.r=this.B(this.y(p=>this.c.fire((0,w.$zp)(p)),p=>this.z(p),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)}))),this.r.watch(this.s)}z(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}C(p){return(0,P.$6c)(p.fsPath)}}e.$Dp=A}),define(pe[112],be([1,0,18,14,15,20,5,59,47,2,61,13,41,19,48,185,16,110,12,11]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l,d,m,c,u,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=void 0;let E=class extends $.$lb{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new I.$ec),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new I.$ec),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new I.$ec),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new I.$ec),this.onDidRunOperation=this.m.event,this.R=this.B(new I.$ec),this.onDidFilesChange=this.R.event,this.S=this.B(new I.$ec),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new O.$Dg)}registerProvider(t,s){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${t}`);const a=new $.$kb;return this.h.set(t,s),this.c.fire({added:!0,scheme:t,provider:s}),a.add(s.onDidChangeFile(i=>this.R.fire(new c.$$j(i,!this.O(s))))),typeof s.onDidWatchError=="function"&&a.add(s.onDidWatchError(i=>this.S.fire(new Error(i)))),a.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:t}))),(0,$.$jb)(()=>{this.c.fire({added:!1,scheme:t,provider:s}),this.h.delete(t),(0,$.$gb)(a)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const s=[];this.f.fire({scheme:t,join(a){s.push(a)}}),!this.h.has(t)&&await O.Promises.settled(s)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,s){const a=this.h.get(t.scheme);return!!(a&&a.capabilities&s)}listCapabilities(){return w.Iterable.map(this.h,([t,s])=>({scheme:t,capabilities:s.capabilities}))}async j(t){if(!(0,l.$ag)(t))throw new c.$ak((0,m.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const s=this.h.get(t.scheme);if(!s){const a=new g.$ab;throw a.message=(0,m.localize)(1,null,t.toString()),a}return s}async k(t){const s=await this.j(t);if((0,c.$Xj)(s)||(0,c.$Uj)(s)||(0,c.$Yj)(s))return s;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const s=await this.j(t);if((0,c.$Xj)(s)||(0,c.$Uj)(s))return s;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,s){try{return await this.n(t,s)}catch(a){throw(0,c.$8j)(a)===c.FileSystemProviderErrorCode.FileNotFound?new c.$ak((0,m.localize)(2,null,this.nb(t)),1):(0,c.$6j)(a)}}async n(t,s){const a=await this.j(t),i=this.O(a),n=s?.resolveTo,o=s?.resolveSingleChildDescendants,f=s?.resolveMetadata,b=await a.stat(t);let y;return this.p(a,t,b,void 0,!!f,(S,L)=>(y||(y=A.$vh.forUris(()=>!i),y.set(t,!0),n&&y.fill(!0,n)),y.get(S.resource)||y.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&o?L===1:!1))}async p(t,s,a,i,n,o){const{providerExtUri:f}=this.N(t),b={resource:s,name:f.basename(s),isFile:(a.type&c.FileType.File)!==0,isDirectory:(a.type&c.FileType.Directory)!==0,isSymbolicLink:(a.type&c.FileType.SymbolicLink)!==0,mtime:a.mtime,ctime:a.ctime,size:a.size,readonly:!!((a.permissions??0)&c.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((a.permissions??0)&c.FilePermission.Locked),etag:(0,c.$lk)({mtime:a.mtime,size:a.size}),children:void 0};if(b.isDirectory&&o(b,i)){try{const y=await t.readdir(s),S=await O.Promises.settled(y.map(async([L,j])=>{try{const Q=f.joinPath(s,L),le=n?await t.stat(Q):{type:j};return await this.p(t,Q,le,y.length,n,o)}catch(Q){return this.b.trace(Q),null}}));b.children=(0,D.$jf)(S)}catch(y){this.b.trace(y),b.children=[]}return b}return b}async resolveAll(t){return O.Promises.settled(t.map(async s=>{try{return{stat:await this.n(s.resource,s.options),success:!0}}catch(a){return this.b.trace(a),{stat:void 0,success:!1}}}))}async stat(t){const s=await this.j(t),a=await s.stat(t);return this.p(s,t,a,void 0,!0,()=>!1)}async exists(t){const s=await this.j(t);try{return!!await s.stat(t)}catch{return!1}}async canCreateFile(t,s){try{await this.r(t,s)}catch(a){return a}return!0}async r(t,s){if(!s?.overwrite&&await this.exists(t))throw new c.$ak((0,m.localize)(3,null,this.nb(t)),3,s)}async createFile(t,s=r.$Ec.fromString(""),a){await this.r(t,a);const i=await this.writeFile(t,s);return this.m.fire(new c.$0j(t,0,i)),i}async writeFile(t,s,a){const i=this.lb(await this.l(t),t),{providerExtUri:n}=this.N(i);try{await this.s(i,t,a)||await this.P(i,n.dirname(t));let f;if((0,c.$Uj)(i)&&!(s instanceof r.$Ec))if((0,d.$qc)(s)){const b=await(0,d.$xc)(s,3);b.ended?f=r.$Ec.concat(b.buffer):f=b}else f=(0,d.$uc)(s,b=>r.$Ec.concat(b),3);else f=s;if(!(0,c.$Xj)(i)||(0,c.$Uj)(i)&&f instanceof r.$Ec)await this.cb(i,t,a,f);else{const b=f instanceof r.$Ec?(0,r.$Pc)(f):f;a?.atomic!==!1&&a?.atomic?.postfix?await this.Y(i,t,(0,l.$9f)((0,l.$8f)(t),`${(0,l.$6f)(t)}${a.atomic.postfix}`),a,b):await this.Z(i,t,a,b)}this.m.fire(new c.$0j(t,4))}catch(o){throw new c.$ak((0,m.localize)(4,null,this.nb(t),(0,c.$6j)(o).toString()),(0,c.$9j)(o),a)}return this.resolve(t,{resolveMetadata:!0})}async s(t,s,a){const i=!!a?.unlock;if(i&&!(t.capabilities&8192))throw new Error((0,m.localize)(5,null,this.nb(s)));if(!!a?.atomic){if(!(t.capabilities&32768))throw new Error((0,m.localize)(6,null,this.nb(s)));if(i)throw new Error((0,m.localize)(7,null,this.nb(s)))}let o;try{o=await t.stat(s)}catch{return}if(o.type&c.FileType.Directory)throw new c.$ak((0,m.localize)(8,null,this.nb(s)),0,a);if(this.mb(s,o),typeof a?.mtime=="number"&&typeof a.etag=="string"&&a.etag!==c.$kk&&typeof o.mtime=="number"&&typeof o.size=="number"&&a.mtime<o.mtime&&a.etag!==(0,c.$lk)({mtime:a.mtime,size:o.size}))throw new c.$ak((0,m.localize)(9,null),3,a);return o}async readFile(t,s,a){const i=await this.k(t);return s?.atomic?this.t(i,t,s,a):this.u(i,t,s,a)}async t(t,s,a,i){return new Promise((n,o)=>{this.X.queueFor(s,this.N(t).providerExtUri).queue(async()=>{try{const f=await this.u(t,s,a,i);n(f)}catch(f){o(f)}})})}async u(t,s,a,i){const n=await this.v(t,s,{...a,preferUnbuffered:!0},i);return{...n,value:await(0,r.$Qc)(n.value)}}async readFileStream(t,s,a){const i=await this.k(t);return this.v(i,t,s,a)}async v(t,s,a,i){const n=new C.$oc(i),o=this.F(s,a).then(b=>b,b=>{throw n.cancel(),b});let f;try{return typeof a?.etag=="string"&&a.etag!==c.$kk&&await o,a?.atomic&&(0,c.$Zj)(t)||!((0,c.$Xj)(t)||(0,c.$Yj)(t))||(0,c.$Uj)(t)&&a?.preferUnbuffered?f=this.D(t,s,a):(0,c.$Yj)(t)?f=this.z(t,s,n.token,a):f=this.C(t,s,n.token,a),{...await o,value:f}}catch(b){throw f&&await(0,d.$vc)(f),this.w(b,s,a)}}w(t,s,a){const i=(0,m.localize)(10,null,this.nb(s),(0,c.$6j)(t).toString());return t instanceof c.$ck?new c.$ck(i,t.stat,a):t instanceof c.$bk?new c.$bk(i,t.fileOperationResult,t.size,t.options):new c.$ak(i,(0,c.$9j)(t),a)}z(t,s,a,i=Object.create(null)){const n=t.readFileStream(s,i,a);return(0,d.$Bc)(n,{data:o=>o instanceof r.$Ec?o:r.$Ec.wrap(o),error:o=>this.w(o,s,i)},o=>r.$Ec.concat(o))}C(t,s,a,i=Object.create(null)){const n=(0,r.$Uc)();return(0,u.$tp)(t,s,n,o=>o,{...i,bufferSize:this.a,errorTransformer:o=>this.w(o,s,i)},a),n}D(t,s,a){const i=(0,d.$sc)(n=>r.$Ec.concat(n));return(async()=>{try{let n;a?.atomic&&(0,c.$Zj)(t)?n=await t.readFile(s,{atomic:!0}):n=await t.readFile(s),typeof a?.position=="number"&&(n=n.slice(a.position)),typeof a?.length=="number"&&(n=n.slice(0,a.length)),this.G(s,n.byteLength,a),i.end(r.$Ec.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async F(t,s){const a=await this.resolve(t,{resolveMetadata:!0});if(a.isDirectory)throw new c.$ak((0,m.localize)(11,null,this.nb(t)),0,s);if(typeof s?.etag=="string"&&s.etag!==c.$kk&&s.etag===a.etag)throw new c.$ck((0,m.localize)(12,null),a,s);return this.G(t,a.size,s),a}G(t,s,a){if(typeof a?.limits?.size=="number"&&s>a.limits.size)throw new c.$bk((0,m.localize)(13,null,this.nb(t)),7,s,a)}async canMove(t,s,a){return this.H(t,s,"move",a)}async canCopy(t,s,a){return this.H(t,s,"copy",a)}async H(t,s,a,i){if(t.toString()!==s.toString())try{const n=a==="move"?this.lb(await this.l(t),t):await this.k(t),o=this.lb(await this.l(s),s);await this.M(n,t,o,s,a,i)}catch(n){return n}return!0}async move(t,s,a){const i=this.lb(await this.l(t),t),n=this.lb(await this.l(s),s),o=await this.I(i,t,n,s,"move",!!a),f=await this.resolve(s,{resolveMetadata:!0});return this.m.fire(new c.$0j(t,o==="move"?2:3,f)),f}async copy(t,s,a){const i=await this.k(t),n=this.lb(await this.l(s),s),o=await this.I(i,t,n,s,"copy",!!a),f=await this.resolve(s,{resolveMetadata:!0});return this.m.fire(new c.$0j(t,o==="copy"?3:2,f)),f}async I(t,s,a,i,n,o){if(s.toString()===i.toString())return n;const{exists:f,isSameResourceWithDifferentPathCase:b}=await this.M(t,s,a,i,n,o);if(f&&!b&&o&&await this.del(i,{recursive:!0}),await this.P(a,this.N(a).providerExtUri.dirname(i)),n==="copy"){if(t===a&&(0,c.$Vj)(t))await t.copy(s,i,{overwrite:o});else{const y=await this.resolve(s);y.isDirectory?await this.L(t,y,a,i):await this.J(t,s,a,i)}return n}else return t===a?(await t.rename(s,i,{overwrite:o}),n):(await this.I(t,s,a,i,"copy",o),await this.del(s,{recursive:!0}),"copy")}async J(t,s,a,i){if((0,c.$Xj)(t)&&(0,c.$Xj)(a))return this.eb(t,s,a,i);if((0,c.$Xj)(t)&&(0,c.$Uj)(a))return this.kb(t,s,a,i);if((0,c.$Uj)(t)&&(0,c.$Xj)(a))return this.ib(t,s,a,i);if((0,c.$Uj)(t)&&(0,c.$Uj)(a))return this.gb(t,s,a,i)}async L(t,s,a,i){await a.mkdir(i),Array.isArray(s.children)&&await O.Promises.settled(s.children.map(async n=>{const o=this.N(a).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.L(t,await this.resolve(n.resource),a,o):this.J(t,n.resource,a,o)}))}async M(t,s,a,i,n,o){let f=!1;if(t===a){const{providerExtUri:y,isPathCaseSensitive:S}=this.N(t);if(S||(f=y.isEqual(s,i)),f&&n==="copy")throw new Error((0,m.localize)(14,null,this.nb(s),this.nb(i)));if(!f&&y.isEqualOrParent(i,s))throw new Error((0,m.localize)(15,null,this.nb(s),this.nb(i)))}const b=await this.exists(i);if(b&&!f){if(!o)throw new c.$ak((0,m.localize)(16,null,this.nb(s),this.nb(i)),4);if(t===a){const{providerExtUri:y}=this.N(t);if(y.isEqualOrParent(s,i))throw new Error((0,m.localize)(17,null,this.nb(s),this.nb(i)))}}return{exists:b,isSameResourceWithDifferentPathCase:f}}N(t){const s=this.O(t);return{providerExtUri:s?l.$Yf:l.$1f,isPathCaseSensitive:s}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const s=this.lb(await this.j(t),t);await this.P(s,t);const a=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new c.$0j(t,0,a)),a}async P(t,s){const a=[],{providerExtUri:i}=this.N(t);for(;!i.isEqual(s,i.dirname(s));)try{if(!((await t.stat(s)).type&c.FileType.Directory))throw new Error((0,m.localize)(18,null,this.nb(s)));break}catch(n){if((0,c.$8j)(n)!==c.FileSystemProviderErrorCode.FileNotFound)throw n;a.push(i.basename(s)),s=i.dirname(s)}for(let n=a.length-1;n>=0;n--){s=i.joinPath(s,a[n]);try{await t.mkdir(s)}catch(o){if((0,c.$8j)(o)!==c.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,s){try{await this.Q(t,s)}catch(a){return a}return!0}async Q(t,s){const a=this.lb(await this.j(t),t),i=!!s?.useTrash;if(i&&!(a.capabilities&4096))throw new Error((0,m.localize)(19,null,this.nb(t)));const n=s?.atomic;if(n&&!(a.capabilities&65536))throw new Error((0,m.localize)(20,null,this.nb(t)));if(i&&n)throw new Error((0,m.localize)(21,null,this.nb(t)));let o;try{o=await a.stat(t)}catch{}if(o)this.mb(t,o);else throw new c.$ak((0,m.localize)(22,null,this.nb(t)),1);if(!!!s?.recursive){const b=await this.resolve(t);if(b.isDirectory&&Array.isArray(b.children)&&b.children.length>0)throw new Error((0,m.localize)(23,null,this.nb(t)))}return a}async del(t,s){const a=await this.Q(t,s),i=!!s?.useTrash,n=!!s?.recursive,o=s?.atomic??!1;await a.delete(t,{recursive:n,useTrash:i,atomic:o}),this.m.fire(new c.$0j(t,1))}async cloneFile(t,s){const a=await this.j(t),i=this.lb(await this.l(s),s);if(a===i&&this.N(a).providerExtUri.isEqual(t,s))return;if(a===i&&(0,c.$Wj)(a))return a.cloneFile(t,s);await this.P(i,this.N(i).providerExtUri.dirname(s));const n=this.X.queueFor(t,this.N(a).providerExtUri);return a===i&&(0,c.$Vj)(a)?n.queue(()=>a.copy(t,s,{overwrite:!0})):n.queue(()=>this.J(a,t,i,s))}watch(t,s={recursive:!1,excludes:[]}){const a=new $.$kb;let i=!1,n=()=>{i=!0};return a.add((0,$.$jb)(()=>n())),(async()=>{try{const o=await this.W(t,s);i?(0,$.$gb)(o):n=()=>(0,$.$gb)(o)}catch(o){this.b.error(o)}})(),a}async W(t,s){const a=await this.j(t),i=(0,P.$di)([this.N(a).providerExtUri.getComparisonKey(t),s]);let n=this.U.get(i);return n||(n={count:0,disposable:a.watch(t,s)},this.U.set(i,n)),n.count+=1,(0,$.$jb)(()=>{n&&(n.count--,n.count===0&&((0,$.$gb)(n.disposable),this.U.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,$.$gb)(t.disposable);this.U.clear()}async Y(t,s,a,i,n){await this.Z(t,a,i,n);try{await t.rename(a,s,{overwrite:!0})}catch(o){try{await t.delete(a,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}async Z(t,s,a,i){return this.X.queueFor(s,this.N(t).providerExtUri).queue(async()=>{const n=await t.open(s,{create:!0,unlock:a?.unlock??!1});try{(0,d.$qc)(i)||(0,d.$rc)(i)?await this.$(t,n,i):await this.ab(t,n,i)}catch(o){throw(0,c.$6j)(o)}finally{await t.close(n)}})}async $(t,s,a){let i=0,n;if((0,d.$rc)(a)){if(a.buffer.length>0){const o=r.$Ec.concat(a.buffer);await this.bb(t,s,o,o.byteLength,i,0),i+=o.byteLength}if(a.ended)return;n=a.stream}else n=a;return new Promise((o,f)=>{(0,d.$wc)(n,{onData:async b=>{n.pause();try{await this.bb(t,s,b,b.byteLength,i,0)}catch(y){return f(y)}i+=b.byteLength,setTimeout(()=>n.resume())},onError:b=>f(b),onEnd:()=>o()})})}async ab(t,s,a){let i=0,n;for(;(n=a.read())!==null;)await this.bb(t,s,n,n.byteLength,i,0),i+=n.byteLength}async bb(t,s,a,i,n,o){let f=0;for(;f<i;){const b=await t.write(s,n+f,a.buffer,o+f,i-f);f+=b}}async cb(t,s,a,i){return this.X.queueFor(s,this.N(t).providerExtUri).queue(()=>this.db(t,s,a,i))}async db(t,s,a,i){let n;i instanceof r.$Ec?n=i:(0,d.$qc)(i)?n=await(0,r.$Qc)(i):(0,d.$rc)(i)?n=await(0,r.$Rc)(i):n=(0,r.$Oc)(i),await t.writeFile(s,n.buffer,{create:!0,overwrite:!0,unlock:a?.unlock??!1,atomic:a?.atomic??!1})}async eb(t,s,a,i){return this.X.queueFor(i,this.N(a).providerExtUri).queue(()=>this.fb(t,s,a,i))}async fb(t,s,a,i){let n,o;try{n=await t.open(s,{create:!1}),o=await a.open(i,{create:!0,unlock:!1});const f=r.$Ec.alloc(this.a);let b=0,y=0,S=0;do S=await t.read(n,b,f.buffer,y,f.byteLength-y),await this.bb(a,o,f,S,b,y),b+=S,y+=S,y===f.byteLength&&(y=0);while(S>0)}catch(f){throw(0,c.$6j)(f)}finally{await O.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof o=="number"?a.close(o):Promise.resolve()])}}async gb(t,s,a,i){return this.X.queueFor(i,this.N(a).providerExtUri).queue(()=>this.hb(t,s,a,i))}async hb(t,s,a,i){return a.writeFile(i,await t.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async ib(t,s,a,i){return this.X.queueFor(i,this.N(a).providerExtUri).queue(()=>this.jb(t,s,a,i))}async jb(t,s,a,i){const n=await a.open(i,{create:!0,unlock:!1});try{const o=await t.readFile(s);await this.bb(a,n,r.$Ec.wrap(o),o.byteLength,0,0)}catch(o){throw(0,c.$6j)(o)}finally{await a.close(n)}}async kb(t,s,a,i){const n=await(0,r.$Qc)(this.C(t,s,C.CancellationToken.None));await this.cb(a,i,void 0,n)}lb(t,s){if(t.capabilities&2048)throw new c.$ak((0,m.localize)(24,null,this.nb(s)),6);return t}mb(t,s){if((s.permissions??0)&c.FilePermission.Readonly)throw new c.$ak((0,m.localize)(25,null,this.nb(t)),6)}nb(t){return t.scheme===k.Schemas.file?t.fsPath:t.toString(!0)}};e.$up=E,e.$up=E=Le([Ie(0,h.$Ri)],E)}),define(pe[68],be([1,0,28,298,14,27,15,5,39,2,7,3,19,48,21,188,16,110,224,38,221,220]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l,d,m,c,u,h,g,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0,(()=>{try{(0,O.gracefulify)(D)}catch(s){console.error(`Error enabling graceful-fs: ${(0,g.$ai)(s)}`)}})();class t extends h.$Dp{static{this.D=!1}constructor(a,i){super(a,i),this.onDidChangeCapabilities=P.Event.None,this.I=new C.$ni(n=>p.$Zf.getComparisonKey(n)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,k.$k&&(this.F|=1024)),this.F}async stat(a){try{const{stat:i,symbolicLink:n}=await d.SymlinkSupport.stat(this.C(a));return{type:this.H(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:c.FilePermission.Locked}}catch(i){throw this.ab(i)}}async G(a){try{return await this.stat(a)}catch{return}}async readdir(a){try{const i=await d.Promises.readdir(this.C(a),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async o=>{try{let f;o.isSymbolicLink()?f=(await this.stat((0,p.$9f)(a,o.name))).type:f=this.H(o),n.push([o.name,f])}catch(f){this.a.trace(f)}})),n}catch(i){throw this.ab(i)}}H(a,i){let n;return i?.dangling?n=c.FileType.Unknown:a.isFile()?n=c.FileType.File:a.isDirectory()?n=c.FileType.Directory:n=c.FileType.Unknown,i&&(n|=c.FileType.SymbolicLink),n}async J(a){const i=this.C(a);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.I.get(a);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const o=new r.$tg;return this.I.set(a,o),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,$.$jb)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.I.get(a)===o&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.I.delete(a)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(a,i){let n;try{i?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(a)})`),n=await this.J(a));const o=this.C(a);return await d.Promises.readFile(o)}catch(o){throw this.ab(o)}finally{n?.dispose()}}L(a){t.D&&this.a.trace(a)}readFileStream(a,i,n){const o=(0,l.$sc)(f=>I.$Ec.concat(f.map(b=>I.$Ec.wrap(b))).buffer);return(0,u.$tp)(this,a,o,f=>f.buffer,{...i,bufferSize:256*1024},n),o}async writeFile(a,i,n){return n?.atomic!==!1&&n?.atomic?.postfix?this.M(a,(0,p.$9f)((0,p.$8f)(a),`${(0,p.$6f)(a)}${n.atomic.postfix}`),i,n):this.N(a,i,n)}async M(a,i,n,o){await this.N(i,n,o);try{await this.rename(i,a,{overwrite:!0})}catch(f){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw f}}async N(a,i,n){let o;try{const f=this.C(a);if(!n.create||!n.overwrite){if(await d.Promises.exists(f)){if(!n.overwrite)throw(0,c.$5j)((0,m.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,c.$5j)((0,m.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(a,{create:!0,unlock:n.unlock}),await this.write(o,0,i,0,i.byteLength)}catch(f){throw await this.bb(a,f)}finally{typeof o=="number"&&await this.close(o)}}static{this.R=!0}static configureFlushOnWrite(a){t.R=a}async open(a,i){const n=this.C(a);let o;(0,c.$Tj)(i)&&(o=await this.J(a));let f;try{if((0,c.$Tj)(i)&&i.unlock)try{const{stat:y}=await d.SymlinkSupport.stat(n);y.mode&128||await d.Promises.chmod(n,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}let b;if((0,c.$Tj)(i)){if(k.$i)try{await d.Promises.truncate(n,0),b="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}b||(b="w")}else b="r";f=await d.Promises.open(n,b)}catch(b){throw o?.dispose(),(0,c.$Tj)(i)?await this.bb(a,b):this.ab(b)}if(this.O.set(f,0),(0,c.$Tj)(i)&&this.Q.set(f,a),o){const b=this.P.get(f);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${f} (${n})`),this.P.set(f,o),b&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${f} (${n})`),b.dispose())}return f}async close(a){const i=this.P.get(a);try{if(this.O.delete(a),this.Q.delete(a)&&t.R)try{await d.Promises.fdatasync(a)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await d.Promises.close(a)}catch(n){throw this.ab(n)}finally{i&&(this.P.get(a)===i&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${a}`),this.P.delete(a)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${a}`),i.dispose())}}async read(a,i,n,o,f){const b=this.S(a,i);let y=null;try{y=(await d.Promises.read(a,n,o,f,b)).bytesRead}catch(S){throw this.ab(S)}finally{this.U(a,b,y)}return y}S(a,i){return i===this.O.get(a)?null:i}U(a,i,n){const o=this.O.get(a);typeof o=="number"&&(typeof i=="number"||(typeof n=="number"?this.O.set(a,o+n):this.O.delete(a)))}async write(a,i,n,o,f){return(0,r.$Mg)(()=>this.W(a,i,n,o,f),100,3)}async W(a,i,n,o,f){const b=this.S(a,i);let y=null;try{y=(await d.Promises.write(a,n,o,f,b)).bytesWritten}catch(S){throw await this.bb(this.Q.get(a),S)}finally{this.U(a,b,y)}return y}async mkdir(a){try{await d.Promises.mkdir(this.C(a))}catch(i){throw this.ab(i)}}async delete(a,i){try{const n=this.C(a);if(i.recursive){let o;i?.atomic!==!1&&i.atomic.postfix&&(o=(0,A.$8c)((0,A.$$c)(n),`${(0,A.$_c)(n)}${i.atomic.postfix}`)),await d.Promises.rm(n,d.RimRafMode.MOVE,o)}else try{await d.Promises.unlink(n)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let f=!1;try{const{stat:b,symbolicLink:y}=await d.SymlinkSupport.stat(n);f=b.isDirectory()&&!y}catch{}if(f)await d.Promises.rmdir(n);else throw o}else throw o}}catch(n){throw this.ab(n)}}async rename(a,i,n){const o=this.C(a),f=this.C(i);if(o!==f)try{await this.X(a,i,"move",n.overwrite),await d.Promises.rename(o,f)}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,m.localize)(2,null,(0,A.$_c)(o),(0,A.$_c)((0,A.$$c)(f)),b.toString()))),this.ab(b)}}async copy(a,i,n){const o=this.C(a),f=this.C(i);if(o!==f)try{await this.X(a,i,"copy",n.overwrite),await d.Promises.copy(o,f,{preserveSymlinks:!0})}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,m.localize)(3,null,(0,A.$_c)(o),(0,A.$_c)((0,A.$$c)(f)),b.toString()))),this.ab(b)}}async X(a,i,n,o){const f=this.C(a),b=this.C(i);let y=!1;if(!!(this.capabilities&1024)||(y=(0,w.$Ge)(f,b,!0)),y){if(n==="copy")throw(0,c.$5j)((0,m.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const L=await this.G(a);if(!L)throw(0,c.$5j)((0,m.localize)(5,null),c.FileSystemProviderErrorCode.FileNotFound);const j=await this.G(i);if(j){if(!o)throw(0,c.$5j)((0,m.localize)(6,null),c.FileSystemProviderErrorCode.FileExists);L.type&c.FileType.File&&j.type&c.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(a,i){return this.Y(a,i,!1)}async Y(a,i,n){const o=this.C(a),f=this.C(i),b=!!(this.capabilities&1024);if((0,w.$Ge)(o,f,!b))return;const y=new $.$kb;try{const[S,L]=await Promise.all([this.J(a),this.J(i)]);y.add(S),y.add(L),n&&await d.Promises.mkdir((0,A.$$c)(f),{recursive:!0}),await d.Promises.copyFile(o,f)}catch(S){if(S.code==="ENOENT"&&!n)return this.Y(a,i,!0);throw this.ab(S)}finally{y.dispose()}}p(a,i,n){return new E.$Kp(o=>a(o),o=>i(o),n)}y(a,i,n){return new v.$Sp(o=>a(o),o=>i(o),n)}ab(a){if(a instanceof c.$4j)return a;let i=a,n;switch(a.code){case"ENOENT":n=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=c.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${a.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=c.FileSystemProviderErrorCode.Unknown;break;default:n=c.FileSystemProviderErrorCode.Unknown}return(0,c.$5j)(i,n)}async bb(a,i){let n=this.ab(i);if(a&&n.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await d.SymlinkSupport.stat(this.C(a));o.mode&128||(n=(0,c.$5j)(i,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return n}}e.$Tp=t}),define(pe[225],be([1,0,5,68,2,15,48,20]),function(ce,e,D,O,r,C,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=void 0;class w extends r.$lb{constructor(k,p){super(),this.a=k,this.b=p,this.w=new Map,this.y=new Map}call(k,p,l){const d=this.c(k);switch(p){case"stat":return this.g(d,l[0]);case"readdir":return this.h(d,l[0]);case"open":return this.l(d,l[0],l[1]);case"close":return this.m(l[0]);case"read":return this.n(l[0],l[1],l[2]);case"readFile":return this.i(d,l[0],l[1]);case"write":return this.p(l[0],l[1],l[2],l[3],l[4]);case"writeFile":return this.k(d,l[0],l[1],l[2]);case"rename":return this.t(d,l[0],l[1],l[2]);case"copy":return this.u(d,l[0],l[1],l[2]);case"cloneFile":return this.v(d,l[0],l[1]);case"mkdir":return this.r(d,l[0]);case"delete":return this.s(d,l[0],l[1]);case"watch":return this.C(d,l[0],l[1],l[2],l[3]);case"unwatch":return this.D(l[0],l[1])}throw new Error(`IPC Command ${p} not found`)}listen(k,p,l){const d=this.c(k);switch(p){case"fileChange":return this.z(d,l[0]);case"readFileStream":return this.j(d,l[0],l[1])}throw new Error(`Unknown event ${p}`)}g(k,p){const l=this.f(k,p,!0);return this.a.stat(l)}h(k,p){const l=this.f(k,p);return this.a.readdir(l)}async i(k,p,l){const d=this.f(k,p,!0),m=await this.a.readFile(d,l);return C.$Ec.wrap(m)}j(k,p,l){const d=this.f(k,p,!0),m=new P.$oc,c=new D.$ec({onDidRemoveLastListener:()=>{m.cancel()}}),u=this.a.readFileStream(d,l,m.token);return(0,I.$wc)(u,{onData:h=>c.fire(C.$Ec.wrap(h)),onError:h=>c.fire(h),onEnd:()=>{c.fire("end"),c.dispose(),m.dispose()}}),c.event}k(k,p,l,d){const m=this.f(k,p);return this.a.writeFile(m,l.buffer,d)}l(k,p,l){const d=this.f(k,p,!0);return this.a.open(d,l)}m(k){return this.a.close(k)}async n(k,p,l){const d=C.$Ec.alloc(l),m=0,c=await this.a.read(k,p,d.buffer,m,l);return[d,c]}p(k,p,l,d,m){return this.a.write(k,p,l.buffer,d,m)}r(k,p){const l=this.f(k,p);return this.a.mkdir(l)}s(k,p,l){const d=this.f(k,p);return this.a.delete(d,l)}t(k,p,l,d){const m=this.f(k,p),c=this.f(k,l);return this.a.rename(m,c,d)}u(k,p,l,d){const m=this.f(k,p),c=this.f(k,l);return this.a.copy(m,c,d)}v(k,p,l){const d=this.f(k,p),m=this.f(k,l);return this.a.cloneFile(d,m)}z(k,p){const l=new D.$ec({onWillAddFirstListener:()=>{this.w.set(p,this.F(k,l))},onDidRemoveLastListener:()=>{(0,r.$gb)(this.w.get(p)),this.w.delete(p)}});return l.event}async C(k,p,l,d,m){const c=this.w.get(p);if(c){const u=this.f(k,d),h=c.watch(l,u,m);this.y.set(p+l,h)}}async D(k,p){const l=k+p,d=this.y.get(l);d&&((0,r.$gb)(d),this.y.delete(l))}dispose(){super.dispose();for(const[,k]of this.y)k.dispose();this.y.clear();for(const[,k]of this.w)k.dispose();this.w.clear()}}e.$pr=w;class $ extends r.$lb{constructor(k,p,l,d){super(),this.c=k,this.f=l,this.g=d,this.a=new Map,this.b=this.B(new O.$Tp(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(p)}h(k){const p=this.B(new D.$ec);this.B(p.event(l=>{k.fire(l.map(d=>({resource:this.c.transformOutgoingURI(d.resource),type:d.type})))})),this.B(this.b.onDidChangeFile(l=>p.fire(l))),this.B(this.b.onDidWatchError(l=>k.fire(l)))}i(k){}j(k){}watch(k,p,l){const d=this.j(this.g);return Array.isArray(d)&&(l.excludes=[...l.excludes,...d]),this.a.set(k,this.b.watch(p,l)),(0,r.$jb)(()=>{(0,r.$gb)(this.a.get(k)),this.a.delete(k)})}dispose(){super.dispose();for(const[,k]of this.a)k.dispose();this.a.clear()}}e.$qr=$}),define(pe[113],be([1,0,4,5,12,2]),function(ce,e,D,O,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=e.$Sq=e.$Rq=void 0;class I extends r.$3i{constructor(k,p,l,d,m){super(p,l,d),this.n=k,this.p=m,this.B(m.listen("onDidChangeLogLevel",k)(c=>{(0,r.$Ti)(c)?super.setLogLevel(c):super.setLogLevel(D.URI.revive(c[0]),c[1])})),this.B(m.listen("onDidChangeVisibility",k)(([c,u])=>super.setVisibility(D.URI.revive(c),u))),this.B(m.listen("onDidChangeLoggers",k)(({added:c,removed:u})=>{for(const h of c)super.registerLogger({...h,resource:D.URI.revive(h.resource)});for(const h of u)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new r.$1i({log:(k,p)=>{this.p.call("consoleLog",[k,p])}})}registerLogger(k){super.registerLogger(k),this.p.call("registerLogger",[k,this.n])}deregisterLogger(k){super.deregisterLogger(k),this.p.call("deregisterLogger",[k,this.n])}setLogLevel(k,p){super.setLogLevel(k,p),this.p.call("setLogLevel",[k,p])}setVisibility(k,p){super.setVisibility(k,p),this.p.call("setVisibility",[this.l(k),p])}m(k,p,l){return new P(this.p,k,p,l,this.n)}static setLogLevel(k,p,l){return k.call("setLogLevel",[p,l])}}e.$Rq=I;class P extends r.$Xi{constructor(k,p,l,d,m){super(d?.logLevel==="always"),this.m=k,this.n=p,this.k=!1,this.l=[],this.setLevel(l),this.m.call("createLogger",[p,d,m]).then(()=>{this.r(this.l),this.k=!0})}g(k,p){const l=[[k,p]];this.k?this.r(l):this.l.push(...l)}r(k){this.m.call("log",[this.n,k])}}class w{constructor(k,p){this.a=k,this.b=p}listen(k,p){const l=this.b(k);switch(p){case"onDidChangeLoggers":return O.Event.map(this.a.onDidChangeLoggers,d=>({added:[...d.added].map(m=>this.c(m,l)),removed:[...d.removed].map(m=>this.c(m,l))}));case"onDidChangeVisibility":return O.Event.map(this.a.onDidChangeVisibility,d=>[l.transformOutgoingURI(d[0]),d[1]]);case"onDidChangeLogLevel":return O.Event.map(this.a.onDidChangeLogLevel,d=>(0,r.$Ti)(d)?d:[l.transformOutgoingURI(d[0]),d[1]])}throw new Error(`Event not found: ${p}`)}async call(k,p,l){const d=this.b(k);switch(p){case"setLogLevel":return(0,r.$Ti)(l[0])?this.a.setLogLevel(l[0]):this.a.setLogLevel(D.URI.revive(d.transformIncoming(l[0][0])),l[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(m=>this.c(m,d)))}throw new Error(`Call not found: ${p}`)}c(k,p){return{...k,resource:p.transformOutgoingURI(k.resource)}}}e.$Sq=w;class $ extends C.$lb{constructor(k,p){super(),p.call("setLogLevel",[k.getLogLevel()]),this.B(k.onDidChangeLogLevel(l=>p.call("setLogLevel",[l]))),p.call("getRegisteredLoggers").then(l=>{for(const d of l)k.registerLogger({...d,resource:D.URI.revive(d.resource)})}),this.B(p.listen("onDidChangeVisibility")(([l,d])=>k.setVisibility(D.URI.revive(l),d))),this.B(p.listen("onDidChangeLoggers")(({added:l,removed:d})=>{for(const m of l)k.registerLogger({...m,resource:D.URI.revive(m.resource)});for(const m of d)k.deregisterLogger(m.resource)}))}}e.$Tq=$}),define(pe[114],be([1,0,2,12]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9M=void 0;class r extends D.$lb{constructor(I,P=[]){super(),this.a=new O.$2i([I,...P]),this.B(I.onDidChangeLogLevel(w=>this.setLevel(w)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(I){this.a.setLevel(I)}getLevel(){return this.a.getLevel()}trace(I,...P){this.a.trace(I,...P)}debug(I,...P){this.a.debug(I,...P)}info(I,...P){this.a.info(I,...P)}warn(I,...P){this.a.warn(I,...P)}error(I,...P){this.a.error(I,...P)}flush(){this.a.flush()}}e.$9M=r}),define(pe[226],be([1,0,16,12]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XM=void 0;var r;(function($){$[$.Trace=0]="Trace",$[$.Debug=1]="Debug",$[$.Info=2]="Info",$[$.Warning=3]="Warning",$[$.Error=4]="Error",$[$.Critical=5]="Critical",$[$.Off=6]="Off"})(r||(r={}));async function C($,A,k,p,l){try{const d=await new Promise((c,u)=>{ce(["@vscode/spdlog"],c,u)});d.setFlushOn(r.Trace);const m=await d.createAsyncRotatingLogger($,A,k,p);return l?m.clearFormatters():m.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),m}catch(d){console.error(d)}return null}function I($,A,k){switch(A){case O.LogLevel.Trace:$.trace(k);break;case O.LogLevel.Debug:$.debug(k);break;case O.LogLevel.Info:$.info(k);break;case O.LogLevel.Warning:$.warn(k);break;case O.LogLevel.Error:$.error(k);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function P($,A){switch(A){case O.LogLevel.Trace:$.setLevel(r.Trace);break;case O.LogLevel.Debug:$.setLevel(r.Debug);break;case O.LogLevel.Info:$.setLevel(r.Info);break;case O.LogLevel.Warning:$.setLevel(r.Warning);break;case O.LogLevel.Error:$.setLevel(r.Error);break;case O.LogLevel.Off:$.setLevel(r.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class w extends O.$Xi{constructor(A,k,p,l,d){super(),this.k=[],this.setLevel(d),this.l=this.n(A,k,p,l),this.B(this.onDidChangeLogLevel(m=>{this.m&&P(this.m,m)}))}async n(A,k,p,l){const d=p?6:1,m=30/d*D.$nk.MB,c=await C(A,k,m,d,l);if(c){this.m=c,P(this.m,this.getLevel());for(const{level:u,message:h}of this.k)I(this.m,u,h);this.k=[]}}g(A,k){this.m?I(this.m,A,k):this.getLevel()<=A&&this.k.push({level:A,message:k})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.$XM=w}),define(pe[115],be([1,0,23,12,226]),function(ce,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YM=void 0;class C extends O.$3i{m(P,w,$){return new r.$XM((0,D.$3e)(),P.fsPath,!$?.donotRotate,!!$?.donotUseFormatters,w)}}e.$YM=C}),define(pe[227],be([1,0,60,190,6]),function(ce,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(w){w[w.Unnecessary=1]="Unnecessary",w[w.Deprecated=2]="Deprecated"})(C||(e.MarkerTag=C={}));var I;(function(w){w[w.Hint=1]="Hint",w[w.Info=2]="Info",w[w.Warning=4]="Warning",w[w.Error=8]="Error"})(I||(e.MarkerSeverity=I={})),function(w){function $(d,m){return m-d}w.compare=$;const A=Object.create(null);A[w.Error]=(0,O.localize)(0,null),A[w.Warning]=(0,O.localize)(1,null),A[w.Info]=(0,O.localize)(2,null);function k(d){return A[d]||""}w.toString=k;function p(d){switch(d){case D.default.Error:return w.Error;case D.default.Warning:return w.Warning;case D.default.Info:return w.Info;case D.default.Ignore:return w.Hint}}w.fromSeverity=p;function l(d){switch(d){case w.Error:return D.default.Error;case w.Warning:return D.default.Warning;case w.Info:return D.default.Info;case w.Hint:return D.default.Ignore}}w.toSeverity=l}(I||(e.MarkerSeverity=I={}));var P;(function(w){const $="";function A(p){return k(p,!0)}w.makeKey=A;function k(p,l){const d=[$];return p.source?d.push(p.source.replace("\xA6","\\\xA6")):d.push($),p.code?typeof p.code=="string"?d.push(p.code.replace("\xA6","\\\xA6")):d.push(p.code.value.replace("\xA6","\\\xA6")):d.push($),p.severity!==void 0&&p.severity!==null?d.push(I.toString(p.severity)):d.push($),p.message&&l?d.push(p.message.replace("\xA6","\\\xA6")):d.push($),p.startLineNumber!==void 0&&p.startLineNumber!==null?d.push(p.startLineNumber.toString()):d.push($),p.startColumn!==void 0&&p.startColumn!==null?d.push(p.startColumn.toString()):d.push($),p.endLineNumber!==void 0&&p.endLineNumber!==null?d.push(p.endLineNumber.toString()):d.push($),p.endColumn!==void 0&&p.endColumn!==null?d.push(p.endColumn.toString()):d.push($),d.push($),d.join("\xA6")}w.makeKeyOptionalMessage=k})(P||(e.IMarkerData=P={})),e.$rs=(0,r.$ph)("markerService")}),define(pe[69],be([1,0,5,47,2,6]),function(ce,e,D,O,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Xm=e.$Wm=void 0,e.$Wm=(0,C.$ph)("policy");class I extends r.$lb{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new D.$ec),this.onDidChange=this.h.event}async updatePolicyDefinitions($){const A=Object.keys(this.f).length;return this.f={...$,...this.f},A!==Object.keys(this.f).length&&await this.i($),O.Iterable.reduce(this.g.entries(),(k,[p,l])=>({...k,[p]:l}),{})}getPolicyValue($){return this.g.get($)}serialize(){return O.Iterable.reduce(Object.entries(this.f),($,[A,k])=>({...$,[A]:{definition:k,value:this.g.get(A)}}),{})}}e.$Xm=I;class P{constructor(){this.onDidChange=D.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Ym=P}),define(pe[54],be([1,0,3,30]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;if(typeof D.$g.vscode<"u"&&typeof D.$g.vscode.context<"u"){const C=D.$g.vscode.context.configuration();if(C)r=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,O.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const C=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:C.version})}}else r={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"vscode",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverGreeting:[],serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webUrl:"https://vscode.dev",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json"},profileTemplatesUrl:"https://az764295.vo.msecnd.net/profile-templates/profile-templates.json",extensionRecommendations:{"ms-dotnettools.csharp":{onFileOpen:[{pathGlob:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}",important:!0},{languages:["csharp"],important:!0},{pathGlob:"{**/project.json,**/appsettings.json}"}]},"ms-python.python":{onFileOpen:[{pathGlob:"{**/*.py}",important:!0},{languages:["python"],important:!0},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.jupyter":{onFileOpen:[{pathGlob:"{**/*.py}",contentPattern:"^#\\s*%%$",important:!0,whenInstalled:["ms-python.python"]},{pathGlob:"{**/*.ipynb}"}]},"golang.Go":{onFileOpen:[{pathGlob:"**/*.go",important:!0},{languages:["go"],important:!0}]},"vscjava.vscode-java-pack":{onFileOpen:[{pathGlob:"{**/*.java}",important:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},{languages:["java"],important:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}]},"ms-vscode.PowerShell":{onFileOpen:[{pathGlob:"{**/*.ps1,**/*.psd1,**/*.psm1}",important:!0},{languages:["powershell"],important:!0},{pathGlob:"{**/*.ps.config,**/*.ps1.config}"}]},"ms-vscode.cpptools-extension-pack":{onFileOpen:[{pathGlob:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}",important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]},{languages:["c","cpp"],important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]}]},"ms-azuretools.vscode-docker":{onFileOpen:[{pathGlob:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}",important:!0},{languages:["dockerfile"],important:!0},{pathGlob:"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}"}]},"vue.volar":{onFileOpen:[{pathGlob:"{**/*.vue}",important:!0},{languages:["vue"],important:!0}]},"ms-vscode.makefile-tools":{onFileOpen:[{pathGlob:"{**/makefile,**/Makefile}",important:!0},{languages:["makefile"],important:!0}]},"ms-vscode.cmake-tools":{onFileOpen:[{pathGlob:"{**/CMakeLists.txt}",important:!0}]},"ms-azure-devops.azure-pipelines":{onFileOpen:[{pathGlob:"{**/azure-pipelines.yaml}",important:!0}]},"msazurermtools.azurerm-vscode-tools":{onFileOpen:[{pathGlob:"{**/azuredeploy.json}",important:!0}]},"ms-vscode-remote.remote-containers":{onFileOpen:[{pathGlob:"{**/devcontainer.json}",important:!0}]},"ms-azuretools.vscode-bicep":{onFileOpen:[{pathGlob:"{**/*.bicep}",important:!0}]},"svelte.svelte-vscode":{onFileOpen:[{pathGlob:"{**/*.svelte}",important:!0}]},"ms-vscode.vscode-github-issue-notebooks":{onFileOpen:[{pathGlob:"{**/*.github-issues}",important:!0}]},"ms-playwright.playwright":{onFileOpen:[{pathGlob:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}",important:!0}]},"vscjava.vscode-gradle":{onFileOpen:[{pathGlob:"{**/gradlew,**/gradlew.bat,**/build.gradle,**/build.gradle.kts,**/settings.gradle,**/settings.gradle.kts}",important:!0}]},"REditorSupport.r":{onFileOpen:[{pathGlob:"{**/*.r}",important:!0},{languages:["r"],important:!0}]},"firefox-devtools.vscode-firefox-debug":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}"}]},"ms-edgedevtools.vscode-edge-devtools":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}"}]},"Ionide.Ionide-fsharp":{onFileOpen:[{pathGlob:"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}"}]},"dbaeumer.vscode-eslint":{onFileOpen:[{pathGlob:"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}"}]},"ms-vscode.vscode-typescript-tslint-plugin":{onFileOpen:[{pathGlob:"{**/tslint.json}"}]},"bmewburn.vscode-intelephense-client":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"xdebug.php-debug":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"rust-lang.rust-analyzer":{onFileOpen:[{pathGlob:"{**/*.rs,**/*.rslib}"}]},"DavidAnson.vscode-markdownlint":{onFileOpen:[{pathGlob:"{**/*.md}"}]},"EditorConfig.EditorConfig":{onFileOpen:[{pathGlob:"{**/.editorconfig}"}]},"HookyQR.beautify":{onFileOpen:[{pathGlob:"{**/.jsbeautifyrc}"}]},"donjayamanne.githistory":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"felipecaputo.git-project-manager":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"eamodio.gitlens":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"Shopify.ruby-lsp":{onFileOpen:[{pathGlob:"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}"}]},"DotJoshJohnson.xml":{onFileOpen:[{pathGlob:"{**/*.xml}"}]},"stylelint.vscode-stylelint":{onFileOpen:[{pathGlob:"{**/.stylelintrc,**/stylelint.config.js}"}]},"ms-mssql.mssql":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"mtxr.sqltools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"usqlextpublisher.usql-vscode-ext":{onFileOpen:[{pathGlob:"{**/*.usql}"}]},"ms-vscode.sublime-keybindings":{onFileOpen:[{pathGlob:"{**/.sublime-project,**/.sublime-workspace}"}]},"k--kato.intellij-idea-keybindings":{onFileOpen:[{pathGlob:"{**/.idea}"}]},"christian-kohler.npm-intellisense":{onFileOpen:[{pathGlob:"{**/package.json}"}]},"cake-build.cake-vscode":{onFileOpen:[{pathGlob:"{**/build.cake}"}]},"Angular.ng-template":{onFileOpen:[{pathGlob:"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}"}]},"vscjava.vscode-maven":{onFileOpen:[{pathGlob:"**/pom.xml"}]},"ms-azuretools.vscode-azureterraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"HashiCorp.terraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"vsciot-vscode.vscode-arduino":{onFileOpen:[{pathGlob:"**/*.ino"}]},"ms-kubernetes-tools.vscode-kubernetes-tools":{onFileOpen:[{pathGlob:"{**/Chart.yaml}"}]},"GoogleCloudTools.cloudcode":{onFileOpen:[{pathGlob:"{**/skaffold.yaml}"}]},"Oracle.oracledevtools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"betterthantomorrow.calva":{onFileOpen:[{pathGlob:"{**/*.clj,**/*.cljs}"}]},"Pivotal.vscode-boot-dev-pack":{onFileOpen:[{pathGlob:"{**/application.properties}"}]},"GitHub.copilot":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.py,**/*.go,**/*.rb}"}],onSettingsEditorOpen:{}},"GitHub.vscode-github-actions":{onFileOpen:[{pathGlob:"{**/.github/workflows/*.yml}",important:!0}]},"circleci.circleci":{onFileOpen:[{pathGlob:"{**/.circleci/config.yml}"}]},"mechatroner.rainbow-csv":{onFileOpen:[{pathGlob:"**/*.csv",important:!0}]},"tomoki1207.pdf":{onFileOpen:[{pathGlob:"**/*.pdf",important:!0}]}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csharp","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","Shopify.ruby-lsp","GitHub.copilot"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",contentPattern:"^\\s*url\\s*=\\s*https:\\/\\/github\\.com.*$"},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}},"pyproject-formatter":{configPath:"pyproject.toml",configName:"Python Formatter",recommendations:{"ms-python.black-formatter":{name:"Black Formatter",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?black"?\\s*[\\].])|("black\\s*["[(<=>!~;@])'},"ms-python.autopep8":{name:"Autopep8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?autopep8"?\\s*[\\].])|("autopep8\\s*["[(<=>!~;@])'}}},"pep8-formatter":{configPath:".pep8",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8"}}},"python-setup-cgf-formatter":{configPath:"setup.cfg",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"tox-ini-formatter":{configPath:"tox.ini",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"pyproject-linter":{configPath:"pyproject.toml",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?pylint"?\\s*[\\].])|("pylint\\s*["[(<=>!~;@])'},"charliermarsh.ruff":{name:"Ruff",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?ruff"?\\s*[\\].])|("ruff\\s*["[(<=>!~;@])'},"ms-python.mypy-type-checker":{name:"Mypy Type Checker",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?mypy"?\\s*[\\].])|("mypy\\s*["[(<=>!~;@])'},"ms-python.flake8":{name:"Flake8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?flake8"?\\s*[\\].])|("flake8\\s*["[(<=>!~;@])'}}},".pylintrc-linter":{configPath:".pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"pylintrc-linter":{configPath:"pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"mypy-ini-linter":{configPath:".mypy.ini",configName:"Python Linter",recommendations:{"ms-python.mypy-type-checker":{name:"Mypy Type Checker"}}},"tox-ini-linter":{configPath:"tox.ini",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}},".flake8-linter":{configPath:".flake8",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8"}}},"python-setup-cgf-linter":{configPath:"setup.cfg",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},azd:{friendlyName:"Azure Dev CLI",windowsPath:"%USERPROFILE%\\AppData\\Local\\Programs\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},"azd-user":{friendlyName:"Azure Dev CLI",windowsPath:"%ProgramFiles%\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],virtualWorkspaceExtensionTips:{"vscode-vfs":{friendlyName:"Remote Repositories",extensionId:"ms-vscode.remote-repositories",startEntry:{helpLink:"https://aka.ms/vscode-remote/remote-repositories",startConnectLabel:"Remote Repository",startCommand:"remoteHub.continueOn.openRepository",priority:5}}},remoteExtensionTips:{wsl:{friendlyName:"WSL",extensionId:"ms-vscode-remote.remote-wsl",supportedPlatforms:["Windows","Web"],startEntry:{helpLink:"https://aka.ms/vscode-remote/wsl",startConnectLabel:"WSL",startCommand:"remote-wsl.connect",priority:3}},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/ssh",startConnectLabel:"SSH ",startCommand:"opensshremotes.openEmptyWindowInCurrentWindow",priority:1}},"dev-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/containers",startConnectLabel:"Dev Container",startCommand:"remote-containers.reopenInContainer",priority:2}},"attached-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},codespaces:{friendlyName:"GitHub Codespaces",extensionId:"github.codespaces",startEntry:{helpLink:"https://aka.ms/vscode-remote-codespaces",startConnectLabel:"GitHub Codespace ",startCommand:"github.codespaces.connect",priority:4}},tunnel:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server",startEntry:{helpLink:"https://aka.ms/remote-tunnels-doc",startConnectLabel:"Tunnel",startCommand:"remote-tunnels.connectCurrentWindowToTunnel",priority:0}}},commandPaletteSuggestedCommandIds:["workbench.action.files.openFile","workbench.action.files.openFileFolder","workbench.action.files.openFolder","workbench.action.remote.showMenu","editor.action.formatDocument","editor.action.commentLine","workbench.action.tasks.runTask","workbench.action.openSettings2","workbench.action.selectTheme","workbench.action.openWalkthrough","workbench.action.openIssueReporter"],extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",serverDocumentationUrl:"https://aka.ms/vscode-server-doc",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",youTubeUrl:"https://aka.ms/vscode-youtube",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",serverLicenseUrl:"https://aka.ms/vscode-server-license",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=521839",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",nodejsRepository:"Microsoft/vscode-node",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05},{surveyId:"csharp.1",surveyUrl:"https://www.research.net/r/8KGJ9V8",languageId:"csharp",editCount:10,userProbability:.05}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver","testMessageContextValue"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","contribShareMenu","contribStatusBarItems","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-toolsai.vscode-ai-remote":["resolvers"],"ms-python.python":["contribEditorContentMenu","quickPickSortByLabel","portsAttributes","testObserver","envShellEvent","quickPickItemTooltip","terminalDataWriteEvent","saveEditor"],"ms-dotnettools.dotnet-interactive-vscode":["notebookMessaging","languageConfigurationAutoClosingPairs"],"GitHub.codespaces":["contribEditSessions","contribMenuBarHome","contribRemoteHelp","contribViewsRemote","resolvers","tunnels","terminalDataWriteEvent","treeViewReveal","notebookKernelSource"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["canonicalUriProvider","contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","contribShareMenu","documentFiltersExclusive","editSessionIdentityProvider","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","shareProvider","scmActionButton","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-vscode-remote.remote-wsl":["resolvers","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode.remote-server":["resolvers","tunnels","contribViewsWelcome"],"ms-vscode.remote-explorer":["contribRemoteHelp","contribViewsRemote","extensionsAny"],"ms-vscode-remote.remote-containers":["contribEditSessions","resolvers","tunnels","workspaceTrust","terminalDimensions","contribRemoteHelp","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"GitHub.vscode-pull-request-github":["contribCommentThreadAdditionalMenu","tokenInformation","contribShareMenu","fileComments","contribCommentPeekContext","codiconDecoration","diffCommand","contribCommentEditorActionsMenu","readonlyMessage","treeViewMarkdownMessage","shareProvider","quickDiffProvider"],"GitHub.copilot":["inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsAdditions"],"GitHub.copilot-chat":["handleIssueUri","interactive","interactiveUserActions","terminalContextMenu","terminalDataWriteEvent","terminalSelection","terminalQuickFixProvider","chatSlashCommands","readonlyMessage","mappedEditsProvider","aiRelatedInformation"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-python.gather":["notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookCellExecutionState"],"ms-toolsai.jupyter-renderers":["contribNotebookStaticPreloads"],"ms-toolsai.jupyter":["notebookDeprecated","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource","interactiveWindow","notebookControllerAffinityHidden","contribNotebookStaticPreloads","quickPickItemTooltip","notebookExecution"],"dbaeumer.vscode-eslint":["notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["tunnels"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-azuretools.vscode-azureresourcegroups":["authGetSessions"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"],"redhat.java":["documentPaste"],"ms-dotnettools.csdevkit":["inlineCompletionsAdditions"],"ms-dotnettools.vscodeintellicode-csharp":["inlineCompletionsAdditions"],"microsoft-IsvExpTools.powerplatform-vscode":["fileSearchProvider","textSearchProvider"],"microsoft-IsvExpTools.powerplatform-vscode-preview":["fileSearchProvider","textSearchProvider"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://*.github.com","https://login.microsoftonline.com","https://*.vscode.dev","https://*.github.dev","https://gh.io","https://portal.azure.com"],trustedExtensionAuthAccess:["vscode.git","vscode.github","ms-vscode.remote-repositories","github.remotehub","ms-vscode.azure-repos","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","ms-vsliveshare.vsliveshare","github.copilot","github.copilot-chat","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{github:{scopes:["user:email"]},microsoft:{scopes:["openid","profile","email","offline_access"]}}},"editSessions.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},tunnelServerQualities:{stable:{serverApplicationName:"code-server"},exploration:{serverApplicationName:"code-server-exploration"},insider:{serverApplicationName:"code-server-insiders"}},tunnelApplicationName:"code-tunnel",tunnelApplicationConfig:{editorWebUrl:"https://vscode.dev",extension:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server"},authenticationProviders:{github:{scopes:["user:email","read:org"]}}},win32TunnelServiceMutex:"vscode-tunnelservice",win32TunnelMutex:"vscode-tunnel",commonlyUsedSettings:["files.autoSave","editor.fontSize","editor.fontFamily","GitHub.copilot.manageExtension","editor.tabSize","editor.renderWhitespace","editor.cursorStyle","editor.multiCursorModifier","editor.insertSpaces","editor.wordWrap","files.exclude","files.associations","workbench.editor.enablePreview"],builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.82.0",sha256:"4fba41b4b764c3f5a6591d6d9a5bdc59b417f2d799071c889c2b54163f256282",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",sha256:"b9dab017506d9e6a469a0f82b392e4cb1d7a25a4843f1db8ba396cbee209cfc5",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode-remote.remote-wsl-recommender",version:"0.0.19",sha256:"926095d290dc7cdb9daf40ef5ae7591db12171ba1af1f61afcb5a368d0fc66aa",repo:"https://github.com/microsoft/vscode-remote-wsl-recommender",metadata:{id:"cb296d3c-017a-4dee-83af-ebb5a5a16e9a",publisherId:{publisherId:"ac9410a2-0d75-40ec-90de-b59bb705801d",publisherName:"ms-vscode-remote",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"},platforms:["win32"],clientOnly:!0}],walkthroughMetadata:[{id:"Setup",steps:[{id:"copilotInstall",title:"Supercharge your coding with AI-based suggestions",description:`Throw that rubber duck away! Code more efficiently with AI at your fingertips. Try [GitHub Copilot](command:extension.open?"github.copilot") free for 60 days.
[Install Copilot](command:workbench.extensions.installExtension?%22github.copilot%22)`,media:{type:"image",altText:"Copilot Statistics",path:"copilotStep.png"}}]}],featuredExtensions:[{id:"github.copilot",title:"GitHub Copilot",description:"Supercharge your coding experience for as little as $10/month with cutting edge AI code generation."}],aiGeneratedWorkspaceTrust:{title:"This workspace was generated by GitHub Copilot",checkboxText:"Trust the contents of all files in this workspace",trustOption:"Yes, I trust the contents",dontTrustOption:"No, I don't trust the contents",startupTrustRequestLearnMore:"If you don't trust the contents of the files generated by GitHub Copilot, we recommend continuing in restricted mode. See [our docs](https://aka.ms/vscode-workspace-trust) to learn more. "},version:"1.82.3",commit:"fdb98833154679dbaa7af67a5a29fe19e55c2b73",date:"2023-10-02T10:18:39.850Z"},Object.keys(r).length===0&&Object.assign(r,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(pe[26],be([1,0,6]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$0i=void 0,e.$0i=(0,D.$ph)("productService"),e.$$i="vscode://schemas/vscode-product"}),define(pe[228],be([1,0,80,12,25,26,223]),function(ce,e,D,O,r,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=void 0;let P=class extends I.$qn{constructor($,A,k){super($),this.p=A,this.r=k}async getSecretStoragePrefix(){return Promise.resolve(`${this.r.urlProtocol}-server`)}async i(){if(this.f)return this.f;if(this.p.disableKeytar)return this.h.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new D.$pn,this.f;try{this.f=await new Promise(($,A)=>{ce(["keytar"],$,A)}),await this.f.findCredentials("test-keytar-loads")}catch($){this.h.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${$.message??$}`),this.f=new D.$pn}return this.f}};e.$rn=P,e.$rn=P=Le([Ie(0,O.$Ri),Ie(1,r.$xh),Ie(2,C.$0i)],P)}),define(pe[35],be([1,0,95,10]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=void 0;class r{constructor(){this.a=new Map}add(I,P){D.ok(O.$ie(I)),D.ok(O.$ke(P)),D.ok(!this.a.has(I),"There is already an extension with this id"),this.a.set(I,P)}knows(I){return this.a.has(I)}as(I){return this.a.get(I)||null}}e.$Um=new r}),define(pe[229],be([1,0,5,35]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=void 0,e.$Vm={JSONContribution:"base.contributions.json"};function r(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class C{constructor(){this.b=new D.$ec,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(w,$){this.a[r(w)]=$,this.b.fire(w)}notifySchemaChanged(w){this.b.fire(w)}getSchemaContributions(){return{schemas:this.a}}}const I=new C;O.$Um.add(e.$Vm.JSONContribution,I)}),define(pe[55],be([1,0,18,5,10,172,24,229,35]),function(ce,e,D,O,r,C,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.ConfigurationScope=e.$Zm=e.EditPresentationTypes=void 0;var $;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})($||(e.EditPresentationTypes=$={})),e.$Zm={Configuration:"base.contributions.configuration"};var A;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$1m={properties:{},patternProperties:{}},e.$2m={properties:{},patternProperties:{}},e.$3m={properties:{},patternProperties:{}},e.$4m={properties:{},patternProperties:{}},e.$5m={properties:{},patternProperties:{}},e.$6m={properties:{},patternProperties:{}},e.$7m="vscode://schemas/settings/resourceLanguage",e.$8m="vscode://schemas/settings/configurationDefaults";const k=w.$Um.as(P.$Vm.JSONContribution);class p{constructor(){this.h=new Set,this.i=new O.$ec,this.onDidSchemaChange=this.i.event,this.j=new O.$ec,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$7m,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const a=new Set;this.n(t,s,a),k.registerSchema(e.$7m,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(t){const s=new Set;this.o(t,s),k.registerSchema(e.$7m,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const a=new Set;this.o(s,a),this.n(t,!1,a),k.registerSchema(e.$7m,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const a=[];for(const{overrides:i,source:n}of t)for(const o in i)if(s.add(o),e.$0m.test(o)){const f=this.a.get(o),b=f?.valuesSources??new Map;if(n)for(const j of Object.keys(i[o]))b.set(j,n);const y={...f?.value||{},...i[o]};this.a.set(o,{source:n,value:y,valuesSources:b});const S=(0,I.$6h)(o),L={type:"object",default:y,description:C.localize(1,null,S),$ref:e.$7m,defaultDefaultValue:y,source:r.$ie(n)?void 0:n,defaultValueSource:n};a.push(...m(o)),this.d[o]=L,this.b.properties[o]=L}else{this.a.set(o,{value:i[o],source:n});const f=this.d[o];f&&(this.w(o,f),this.r(o,f))}this.m(a)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:a,source:i}of t)for(const n in a){const o=this.a.get(n),f=r.$ie(i)?i:i?.id,b=r.$ie(o?.source)?o?.source:o?.source?.id;if(f===b)if(s.add(n),this.a.delete(n),e.$0m.test(n))delete this.d[n],delete this.b.properties[n];else{const y=this.d[n];y&&(this.w(n,y),this.r(n,y))}}this.u()}deltaConfiguration(t){let s=!1;const a=new Set;t.removedDefaults&&(this.l(t.removedDefaults,a),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,a),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,a),t.addedConfigurations&&this.n(t.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,a){t.forEach(i=>{this.p(i,s,i.extensionInfo,i.restrictedProperties,void 0,a),this.c.push(i),this.q(i)})}o(t,s){const a=i=>{if(i.properties)for(const n in i.properties){s.add(n);const o=this.d[n];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>a(n))};for(const i of t){a(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,s=!0,a,i,n=3,o){n=r.$re(t.scope)?n:t.scope;const f=t.properties;if(f)for(const y in f){const S=f[y];if(s&&g(y,S)){delete f[y];continue}if(S.source=a,S.defaultDefaultValue=f[y].default,this.w(y,S),e.$0m.test(y)?S.scope=void 0:(S.scope=r.$re(S.scope)?n:S.scope,S.restricted=r.$re(S.restricted)?!!i?.includes(y):S.restricted),f[y].hasOwnProperty("included")&&!f[y].included){this.f[y]=f[y],delete f[y];continue}else this.d[y]=f[y],f[y].policy?.name&&this.e.set(f[y].policy.name,y);!f[y].deprecationMessage&&f[y].markdownDeprecationMessage&&(f[y].deprecationMessage=f[y].markdownDeprecationMessage),o.add(y)}const b=t.allOf;if(b)for(const y of b)this.p(y,s,a,i,n,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=a=>{const i=a.properties;if(i)for(const o in i)this.r(o,i[o]);a.allOf?.forEach(s)};s(t)}r(t,s){switch(e.$1m.properties[t]=s,s.scope){case 1:e.$2m.properties[t]=s;break;case 2:e.$3m.properties[t]=s;break;case 6:e.$4m.properties[t]=s;break;case 3:e.$5m.properties[t]=s;break;case 4:e.$6m.properties[t]=s;break;case 5:e.$6m.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.$1m.properties[t],s.scope){case 1:delete e.$2m.properties[t];break;case 2:delete e.$3m.properties[t];break;case 6:delete e.$4m.properties[t];break;case 3:delete e.$5m.properties[t];break;case 4:case 5:delete e.$6m.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,a={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.$7m};this.w(s,a),e.$1m.properties[s]=a,e.$2m.properties[s]=a,e.$3m.properties[s]=a,e.$4m.properties[s]=a,e.$5m.properties[s]=a,e.$6m.properties[s]=a}}v(){const t={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.$7m};e.$1m.patternProperties[e.$9m]=t,e.$2m.patternProperties[e.$9m]=t,e.$3m.patternProperties[e.$9m]=t,e.$4m.patternProperties[e.$9m]=t,e.$5m.patternProperties[e.$9m]=t,e.$6m.patternProperties[e.$9m]=t,this.i.fire()}w(t,s){const a=this.a.get(t);let i=a?.value,n=a?.source;r.$pe(i)&&(i=s.defaultDefaultValue,n=void 0),r.$pe(i)&&(i=u(s.type)),s.default=i,s.defaultValueSource=n}}const l="\\[([^\\]]+)\\]",d=new RegExp(l,"g");e.$9m=`^(${l})+$`,e.$0m=new RegExp(e.$9m);function m(v){const t=[];if(e.$0m.test(v)){let s=d.exec(v);for(;s?.length;){const a=s[1].trim();a&&t.push(a),s=d.exec(v)}}return(0,D.$of)(t)}e.$$m=m;function c(v){return v.reduce((t,s)=>`${t}[${s}]`,"")}e.$_m=c;function u(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$an=u;const h=new p;w.$Um.add(e.$Zm.Configuration,h);function g(v,t){return v.trim()?e.$0m.test(v)?C.localize(7,null,v):h.getConfigurationProperties()[v]!==void 0?C.localize(8,null,v):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?C.localize(9,null,v,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:C.localize(6,null)}e.$bn=g;function E(){const v=[],t=h.getConfigurationProperties();for(const s of Object.keys(t))v.push([s,t[s].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.$cn=E}),define(pe[116],be([1,0,18,5,75,2,27,22,10,4,24,55,35]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=void 0;function l(s){return Object.isFrozen(s)?s:P.$Jm(s)}class d{constructor(a={},i=[],n=[],o){this.b=a,this.c=i,this.d=n,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const a=this.raw.map(i=>{if(i instanceof d)return i;const n=new m("");return n.parseRaw(i),n.configurationModel});this.f=a.reduce((i,n)=>n===i?n:i.merge(n),a[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,A.$4h)(this.contents,a):this.contents}inspect(a,i){const n=this.rawConfiguration.getValue(a),o=i?this.rawConfiguration.getOverrideValue(a,i):void 0,f=i?this.rawConfiguration.override(i).getValue(a):n;return{value:n,override:o,merged:f}}getOverrideValue(a,i){const n=this.i(i);return n?a?(0,A.$4h)(n,a):n:void 0}getKeysForOverrideIdentifier(a){const i=[];for(const n of this.overrides)n.identifiers.includes(a)&&i.push(...n.keys);return D.$of(i)}getAllOverrideIdentifiers(){const a=[];for(const i of this.overrides)a.push(...i.identifiers);return D.$of(a)}override(a){let i=this.a.get(a);return i||(i=this.g(a),this.a.set(a,i)),i}merge(...a){const i=P.$Im(this.contents),n=P.$Im(this.overrides),o=[...this.keys],f=this.raw?.length?[...this.raw]:[this];for(const b of a)if(f.push(...b.raw?.length?b.raw:[b]),!b.isEmpty()){this.h(i,b.contents);for(const y of b.overrides){const[S]=n.filter(L=>D.$$e(L.identifiers,y.identifiers));S?(this.h(S.contents,y.contents),S.keys.push(...y.keys),S.keys=D.$of(S.keys)):n.push(P.$Im(y))}for(const y of b.keys)o.indexOf(y)===-1&&o.push(y)}return new d(i,o,n,f.every(b=>b instanceof d)?void 0:f)}g(a){const i=this.i(a);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const o of D.$of([...Object.keys(this.contents),...Object.keys(i)])){let f=this.contents[o];const b=i[o];b&&(typeof f=="object"&&typeof b=="object"?(f=P.$Im(f),this.h(f,b)):f=b),n[o]=f}return new d(n,this.keys,this.overrides)}h(a,i){for(const n of Object.keys(i)){if(n in a&&w.$ke(a[n])&&w.$ke(i[n])){this.h(a[n],i[n]);continue}a[n]=P.$Im(i[n])}}i(a){let i=null,n=null;const o=f=>{f&&(n?this.h(n,f):n=P.$Im(f))};for(const f of this.overrides)f.identifiers.length===1&&f.identifiers[0]===a?i=f.contents:f.identifiers.includes(a)&&o(f.contents);return o(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,i){this.j(a,i,!0)}setValue(a,i){this.j(a,i,!1)}removeValue(a){const i=this.keys.indexOf(a);i!==-1&&(this.keys.splice(i,1),(0,A.$3h)(this.contents,a),k.$0m.test(a)&&this.overrides.splice(this.overrides.findIndex(n=>D.$$e(n.identifiers,(0,k.$$m)(a))),1))}j(a,i,n){(0,A.$2h)(this.contents,a,i,o=>console.error(o)),n=n||this.keys.indexOf(a)===-1,n&&this.keys.push(a),k.$0m.test(a)&&this.overrides.push({identifiers:(0,k.$$m)(a),keys:Object.keys(this.contents[a]),contents:(0,A.$1h)(this.contents[a],o=>console.error(o))})}}e.$dn=d;class m{constructor(a){this.f=a,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new d}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,i){if(!w.$re(a)){const n=this.g(a);this.parseRaw(n,i)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,i){this.a=a;const{contents:n,keys:o,overrides:f,restricted:b,hasExcludedProperties:y}=this.h(a,i);this.b=new d(n,o,f,y?[a]:void 0),this.c=b||[]}g(a){let i={},n=null,o=[];const f=[],b=[];function y(L){Array.isArray(o)?o.push(L):n!==null&&(o[n]=L)}const S={onObjectBegin:()=>{const L={};y(L),f.push(o),o=L,n=null},onObjectProperty:L=>{n=L},onObjectEnd:()=>{o=f.pop()},onArrayBegin:()=>{const L=[];y(L),f.push(o),o=L,n=null},onArrayEnd:()=>{o=f.pop()},onLiteralValue:y,onError:(L,j,Q)=>{b.push({error:L,offset:j,length:Q})}};if(a)try{r.$Fm(a,S),i=o[0]||{}}catch(L){console.error(`Error while parsing settings file ${this.f}: ${L}`),this.d=[L]}return i}h(a,i){const n=p.$Um.as(k.$Zm.Configuration).getConfigurationProperties(),o=this.i(a,n,!0,i);a=o.raw;const f=(0,A.$1h)(a,S=>console.error(`Conflict in settings file ${this.f}: ${S}`)),b=Object.keys(a),y=this.j(a,S=>console.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:f,keys:b,overrides:y,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(a,i,n,o){let f=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:f};const b={},y=[];for(const S in a)if(k.$0m.test(S)&&n){const L=this.i(a[S],i,!1,o);b[S]=L.raw,f=f||L.hasExcludedProperties,y.push(...L.restricted)}else{const L=i[S],j=L?typeof L.scope<"u"?L.scope:3:void 0;L?.restricted&&y.push(S),!o.exclude?.includes(S)&&(o.include?.includes(S)||(j===void 0||o.scopes===void 0||o.scopes.includes(j))&&!(o.skipRestricted&&L?.restricted))?b[S]=a[S]:f=!0}return{raw:b,restricted:y,hasExcludedProperties:f}}j(a,i){const n=[];for(const o of Object.keys(a))if(k.$0m.test(o)){const f={};for(const b in a[o])f[b]=a[o][b];n.push({identifiers:(0,k.$$m)(o),keys:Object.keys(f),contents:(0,A.$1h)(f,i)})}return n}}e.$en=m;class c extends C.$lb{constructor(a,i,n,o){super(),this.c=a,this.f=i,this.g=o,this.b=this.B(new O.$ec),this.onDidChange=this.b.event,this.a=new m(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,f=>f.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,f=>(f.isOperation(0)||f.isOperation(3)||f.isOperation(1)||f.isOperation(4))&&n.isEqual(f.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new d}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$fn=c;class u{constructor(a,i,n,o,f,b,y,S,L,j,Q,le,Y){this.a=a,this.b=i,this.c=n,this.overrideIdentifiers=o,this.d=f,this.f=b,this.g=y,this.h=S,this.i=L,this.j=j,this.k=Q,this.l=le,this.m=Y}get value(){return l(this.c)}n(a,i,n){const o=a.inspect(i,n);return{get value(){return l(o.value)},get override(){return l(o.override)},get merged(){return l(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class h{constructor(a,i,n,o,f=new d,b=new d,y=new I.$ni,S=new d,L=new I.$ni){this.c=a,this.d=i,this.f=n,this.g=o,this.h=f,this.i=b,this.j=y,this.l=S,this.m=L,this.a=null,this.b=new I.$ni,this.n=null}getValue(a,i,n){return this.q(a,i,n).getValue(a)}updateValue(a,i,n={}){let o;n.resource?(o=this.m.get(n.resource),o||(o=new d,this.m.set(n.resource,o))):o=this.l,i===void 0?o.removeValue(a):o.setValue(a,i),n.resource||(this.a=null)}inspect(a,i,n){const o=this.q(a,i,n),f=this.u(i.resource,n),b=i.resource?this.m.get(i.resource)||this.l:this.l,y=new Set;for(const S of o.overrides)for(const L of S.identifiers)o.getOverrideValue(a,L)!==void 0&&y.add(L);return new u(a,i,o.getValue(a),y.size?[...y]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,f||void 0,b)}keys(a){const i=this.u(void 0,a);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(a){this.c=a,this.a=null,this.b.clear()}updatePolicyConfiguration(a){this.d=a}updateApplicationConfiguration(a){this.f=a,this.a=null,this.b.clear()}updateLocalUserConfiguration(a){this.g=a,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(a){this.h=a,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(a){this.i=a,this.a=null,this.b.clear()}updateFolderConfiguration(a,i){this.j.set(a,i),this.b.delete(a)}deleteFolderConfiguration(a){this.p.delete(a),this.b.delete(a)}compareAndUpdateDefaultConfiguration(a,i){const n=[];if(!i){const{added:o,updated:f,removed:b}=v(this.c,a);i=[...o,...f,...b]}for(const o of i)for(const f of(0,k.$$m)(o)){const b=this.c.getKeysForOverrideIdentifier(f),y=a.getKeysForOverrideIdentifier(f),S=[...y.filter(L=>b.indexOf(L)===-1),...b.filter(L=>y.indexOf(L)===-1),...b.filter(L=>!P.$Mm(this.c.override(f).getValue(L),a.override(f).getValue(L)))];n.push([f,S])}return this.updateDefaultConfiguration(a),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(a){const{added:i,updated:n,removed:o}=v(this.d,a),f=[...i,...n,...o];return f.length&&this.updatePolicyConfiguration(a),{keys:f,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:i,updated:n,removed:o,overrides:f}=v(this.applicationConfiguration,a),b=[...i,...n,...o];return b.length&&this.updateApplicationConfiguration(a),{keys:b,overrides:f}}compareAndUpdateLocalUserConfiguration(a){const{added:i,updated:n,removed:o,overrides:f}=v(this.localUserConfiguration,a),b=[...i,...n,...o];return b.length&&this.updateLocalUserConfiguration(a),{keys:b,overrides:f}}compareAndUpdateRemoteUserConfiguration(a){const{added:i,updated:n,removed:o,overrides:f}=v(this.remoteUserConfiguration,a),b=[...i,...n,...o];return b.length&&this.updateRemoteUserConfiguration(a),{keys:b,overrides:f}}compareAndUpdateWorkspaceConfiguration(a){const{added:i,updated:n,removed:o,overrides:f}=v(this.workspaceConfiguration,a),b=[...i,...n,...o];return b.length&&this.updateWorkspaceConfiguration(a),{keys:b,overrides:f}}compareAndUpdateFolderConfiguration(a,i){const n=this.p.get(a),{added:o,updated:f,removed:b,overrides:y}=v(n,i),S=[...o,...f,...b];return(S.length||!n)&&this.updateFolderConfiguration(a,i),{keys:S,overrides:y}}compareAndDeleteFolderConfiguration(a){const i=this.p.get(a);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:n,updated:o,removed:f,overrides:b}=v(i,void 0);return{keys:[...n,...o,...f],overrides:b}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(a,i,n){let o=this.r(i,n);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(a)!==void 0&&(o=o.merge(this.d)),o}r({resource:a},i){let n=this.s();if(i&&a){const o=i.getFolder(a);o&&(n=this.t(o.uri)||n);const f=this.m.get(a);f&&(n=n.merge(f))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(a){let i=this.b.get(a);if(!i){const n=this.s(),o=this.j.get(a);o?(i=n.merge(o),this.b.set(a,i)):i=n}return i}u(a,i){if(i&&a){const n=i.getFolder(a);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((a,i)=>{const{contents:n,overrides:o,keys:f}=this.j.get(i);return a.push([i,{contents:n,overrides:o,keys:f}]),a},[])}}allKeys(){const a=new Set;return this.c.keys.forEach(i=>a.add(i)),this.userConfiguration.keys.forEach(i=>a.add(i)),this.i.keys.forEach(i=>a.add(i)),this.j.forEach(i=>i.keys.forEach(n=>a.add(n))),[...a.values()]}v(){const a=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>a.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>a.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>a.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>a.add(n))),[...a.values()]}w(a){const i=new Set;return this.c.getKeysForOverrideIdentifier(a).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(a).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(a).forEach(o=>i.add(o))),[...i.values()]}static parse(a){const i=this.x(a.defaults),n=this.x(a.policy),o=this.x(a.application),f=this.x(a.user),b=this.x(a.workspace),y=a.folders.reduce((S,L)=>(S.set($.URI.revive(L[0]),this.x(L[1])),S),new I.$ni);return new h(i,n,o,f,new d,b,y,new d,new I.$ni)}static x(a){return new d(a.contents,a.keys,a.overrides)}}e.$gn=h;function g(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const a=new Set,i=new Map;for(const o of s)o.keys.forEach(f=>a.add(f)),o.overrides.forEach(([f,b])=>{const y=(0,I.$ki)(i,f,new Set);b.forEach(S=>y.add(S))});const n=[];return i.forEach((o,f)=>n.push([f,[...o.values()]])),{keys:[...a.values()],overrides:n}}e.$hn=g;class E{constructor(a,i,n,o){this.change=a,this.f=i,this.g=n,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const f of a.keys)this.affectedKeys.add(f);for(const[,f]of a.overrides)for(const b of f)this.affectedKeys.add(b);this.d=this.a;for(const f of this.affectedKeys)this.d+=f+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=h.parse(this.f.data)),this.i}affectsConfiguration(a,i){const n=this.a+a,o=this.d.indexOf(n);if(o<0)return!1;const f=o+n.length;if(f>=this.d.length)return!1;const b=this.d.charCodeAt(f);if(b!==this.b&&b!==this.c)return!1;if(i){const y=this.previousConfiguration?this.previousConfiguration.getValue(a,i,this.f?.workspace):void 0,S=this.g.getValue(a,i,this.h);return!P.$Mm(y,S)}return!0}}e.$in=E;function v(s,a){const{added:i,removed:n,updated:o}=t(a?.rawConfiguration,s?.rawConfiguration),f=[],b=s?.getAllOverrideIdentifiers()||[],y=a?.getAllOverrideIdentifiers()||[];if(a){const S=y.filter(L=>!b.includes(L));for(const L of S)f.push([L,a.getKeysForOverrideIdentifier(L)])}if(s){const S=b.filter(L=>!y.includes(L));for(const L of S)f.push([L,s.getKeysForOverrideIdentifier(L)])}if(a&&s){for(const S of b)if(y.includes(S)){const L=t({contents:s.getOverrideValue(void 0,S)||{},keys:s.getKeysForOverrideIdentifier(S)},{contents:a.getOverrideValue(void 0,S)||{},keys:a.getKeysForOverrideIdentifier(S)});f.push([S,[...L.added,...L.removed,...L.updated]])}}return{added:i,removed:n,updated:o,overrides:f}}function t(s,a){const i=s?a?s.keys.filter(f=>a.keys.indexOf(f)===-1):[...s.keys]:[],n=a?s?a.keys.filter(f=>s.keys.indexOf(f)===-1):[...a.keys]:[],o=[];if(s&&a){for(const f of a.keys)if(s.keys.indexOf(f)!==-1){const b=(0,A.$4h)(a.contents,f),y=(0,A.$4h)(s.contents,f);P.$Mm(b,y)||o.push(f)}}return{added:i,removed:n,updated:o}}}),define(pe[230],be([1,0,18,5,2,22,10,116,55,12,69,35]),function(ce,e,D,O,r,C,I,P,w,$,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=void 0;class p extends r.$lb{constructor(){super(...arguments),this.a=this.B(new O.$ec),this.onDidChangeConfiguration=this.a.event,this.b=new P.$dn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(k.$Um.as(w.$Zm.Configuration).onDidUpdateConfiguration(({properties:c,defaultsOverrides:u})=>this.c(Array.from(c),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(c,u){this.h(c,k.$Um.as(w.$Zm.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:c})}f(){return{}}g(){this.b=new P.$dn;const c=k.$Um.as(w.$Zm.Configuration).getConfigurationProperties();this.h(Object.keys(c),c)}h(c,u){const h=this.f();for(const g of c){const E=h[g],v=u[g];E!==void 0?this.b.addValue(g,E):v?this.b.addValue(g,v.default):this.b.removeValue(g)}}}e.$jn=p;class l{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new P.$dn}async initialize(){return this.configurationModel}}e.$kn=l;let d=class extends r.$lb{get configurationModel(){return this.b}constructor(c,u,h){super(),this.c=c,this.f=u,this.g=h,this.a=this.B(new O.$ec),this.onDidChangeConfiguration=this.a.event,this.b=new P.$dn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(c=>this.i(c))),this.B(this.c.onDidChangeConfiguration(async({properties:c})=>this.j(await this.h(c),!0))),this.b}async h(c){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",c);const u={},h=[],g=k.$Um.as(w.$Zm.Configuration).getConfigurationProperties();for(const E of c){const v=g[E];if(!v){h.push(E);continue}if(v.policy){if(v.type!=="string"&&v.type!=="number"){this.g.warn(`Policy ${v.policy.name} has unsupported type ${v.type}`);continue}h.push(E),u[v.policy.name]={type:v.type}}}return(0,I.$ve)(u)||await this.f.updatePolicyDefinitions(u),h}i(c){this.g.trace("PolicyConfiguration#onDidChangePolicies",c);const u=k.$Um.as(w.$Zm.Configuration).getPolicyConfigurations(),h=(0,D.$jf)(c.map(g=>u.get(g)));this.j(h,!0)}j(c,u){this.g.trace("PolicyConfiguration#update",c);const h=k.$Um.as(w.$Zm.Configuration).getConfigurationProperties(),g=[],E=this.b.isEmpty();for(const v of c){const t=h[v]?.policy?.name;if(t){const s=this.f.getPolicyValue(t);(E?s!==void 0:!(0,C.$Mm)(this.b.getValue(v),s))&&g.push([v,s])}else this.b.getValue(v)!==void 0&&g.push([v,void 0])}if(g.length){this.g.trace("PolicyConfiguration#changed",g);const v=this.b;this.b=new P.$dn;for(const t of v.keys)this.b.setValue(t,v.getValue(t));for(const[t,s]of g)s===void 0?this.b.removeValue(t):this.b.setValue(t,s);u&&this.a.fire(this.b)}}};e.$ln=d,e.$ln=d=Le([Ie(1,A.$Wm),Ie(2,$.$Ri)],d)}),define(pe[117],be([1,0,14,5,2,19,24,116,230,69]),function(ce,e,D,O,r,C,I,P,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0;class A extends r.$lb{constructor(p,l,d,m){super(),this.i=p,this.h=this.B(new O.$ec),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new w.$jn),this.c=d instanceof $.$Ym?new w.$kn:this.B(new w.$ln(this.b,d,m)),this.f=this.B(new P.$fn(this.i,{},C.$Zf,l)),this.a=new P.$gn(this.b.configurationModel,this.c.configurationModel,new P.$dn,new P.$dn),this.g=this.B(new D.$Gg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:c,properties:u})=>this.k(c,u))),this.B(this.c.onDidChangeConfiguration(c=>this.l(c))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[p,l,d]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.$gn(p,l,new P.$dn,d)}getConfigurationData(){return this.a.toData()}getValue(p,l){const d=typeof p=="string"?p:void 0,m=(0,I.$Wh)(p)?p:(0,I.$Wh)(l)?l:{};return this.a.getValue(d,m,void 0)}updateValue(p,l,d,m){return Promise.reject(new Error("not supported"))}inspect(p){return this.a.inspect(p,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const p=await this.f.loadConfiguration();this.j(p)}j(p){const l=this.a.toData(),d=this.a.compareAndUpdateLocalUserConfiguration(p);this.m(d,l,2)}k(p,l){const d=this.a.toData(),m=this.a.compareAndUpdateDefaultConfiguration(p,l);this.m(m,d,7)}l(p){const l=this.a.toData(),d=this.a.compareAndUpdatePolicyConfiguration(p);this.m(d,l,7)}m(p,l,d){const m=new P.$in(p,{data:l},this.a);m.source=d,m.sourceConfig=this.n(d),this.h.fire(m)}n(p){switch(p){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$mn=A}),define(pe[118],be([1,0,11,6]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=e.RemoteAuthorityResolverErrorCode=e.$yk=e.$xk=e.RemoteConnectionType=e.$wk=void 0,e.$wk=(0,O.$ph)("remoteAuthorityResolverService");var r;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(r||(e.RemoteConnectionType=r={}));class C{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$xk=C;class I{constructor(k,p){this.host=k,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$yk=I;var P;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class w extends D.$ab{static isNotAvailable(k){return k instanceof w&&k._code===P.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof w&&k._code===P.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof w&&k._code===P.NoResolverFound}static isInvalidAuthority(k){return k instanceof w&&k._code===P.InvalidAuthority}static isHandled(k){return k instanceof w&&k.isHandled}constructor(k,p=P.Unknown,l){super(k),this._message=k,this._code=p,this._detail=l,this.isHandled=p===P.NotAvailable&&l===!0,Object.setPrototypeOf(this,w.prototype)}}e.$zk=w;function $(A){const k=A.indexOf("+");return k===-1?A:A.substring(0,k)}e.$Ak=$}),define(pe[231],be([1,0,6]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=e.$$M=void 0,e.$$M=(0,D.$ph)("IRemoteExtensionsScannerService"),e.$_M="remoteExtensionsScanner"}),define(pe[56],be([1,0,13]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=void 0;function O($){return $.scheme===D.Schemas.vscodeRemote?$.authority:void 0}e.$Bk=O;function r($){if(!$)return;const A=$.indexOf("+");return A<0?$:$.substr(0,A)}e.$Ck=r;function C($){return`/${$.quality??"oss"}-${$.commit??"dev"}`}e.$Dk=C;function I($){const{host:A,port:k}=w($);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:k}}e.$Ek=I;function P($,A){let{host:k,port:p}=w($);return typeof p>"u"&&(p=A),{host:k,port:p}}e.$Fk=P;function w($){const A=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const k=$.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const p=$.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:$,port:void 0}}}),define(pe[40],be([1,0,17,6,56]),function(ce,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.TargetPlatform=e.ExtensionType=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=void 0,e.$Cl="extensions.user.cache",e.$Dl="extensions.builtin.cache",e.$El="undefined_publisher",e.$Fl=["ui","workspace","web"];function C(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.$Gl=C,e.$Hl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(I||(e.ExtensionType=I={}));var P;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class w{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,u){if(typeof c>"u"||c===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof c=="string"||typeof u=="string"){const h=typeof c=="string"?c:c.value,g=typeof u=="string"?u:u.value;return D.$Ld(h,g)}return c._lower===u._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.$Il=w;class ${get size(){return this.c.size}constructor(c){if(this.c=new Set,c)for(const u of c)this.add(u)}add(c){this.c.add(w.toKey(c))}delete(c){return this.c.delete(w.toKey(c))}has(c){return this.c.has(w.toKey(c))}}e.$Jl=$;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(c){this.c.delete(w.toKey(c))}get(c){return this.c.get(w.toKey(c))}has(c){return this.c.has(w.toKey(c))}set(c,u){this.c.set(w.toKey(c),u)}values(){return this.c.values()}forEach(c){this.c.forEach(c)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Kl=A;function k(m){return p(m)}e.$Ll=k;function p(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.$Ml=p;function l(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.$Nl=l;function d(m,c){if(c){const u=`onResolveRemoteAuthority:${(0,r.$Ck)(c)}`;return!!m.activationEvents?.includes(u)}return!1}e.$Ol=d,e.$Pl=(0,O.$ph)("IBuiltinExtensionsScannerService")}),define(pe[232],be([1,0,2,40,16]),function(ce,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=void 0;class C extends D.$lb{constructor(P,w,$,A,k){super(),this.a=P,this.b=w,this.c=$,this.f=k,this.B(A.onDidInstallExtensions(p=>this.g(p))),this.B(A.onDidUninstallExtension(p=>this.h(p)))}g(P){for(const w of P)w.local&&this.invalidate(w.profileLocation)}h(P){P.error||this.invalidate(P.profileLocation)}async invalidate(P){if(P)for(const w of this.a.profiles)this.c.extUri.isEqual(w.extensionsResource,P)&&await this.i(w);else await this.i(this.a.defaultProfile)}async i(P){try{await this.b.del(this.c.extUri.joinPath(P.cacheHome,O.$Cl))}catch(w){(0,r.$9j)(w)!==1&&this.f.error(w)}}}e.$np=C}),define(pe[44],be([1,0,15,11,2,191,55,6,12,35]),function(ce,e,D,O,r,C,I,P,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0,e.$Ao=(0,P.$ph)("requestService");class A{constructor(v){this.b=v}toJSON(){if(!this.a){const v=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?v[t]="*****":v[t]=this.b[t];this.a=v}return this.a}}class k extends r.$lb{constructor(v){super(),this.b=0,this.a=v.createLogger("network",{name:(0,C.localize)(0,null),when:w.$9i.isEqualTo((0,w.$7i)(w.LogLevel.Trace)).serialize()})}async c(v,t,s){const a=`${v} #${++this.b}: ${t.url}`;this.a.trace(`${a} - begin`,t.type,new A(t.headers??{}));try{const i=await s();return this.a.trace(`${a} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${a} - error`,t.type,(0,O.$9)(i)),i}}}e.$Bo=k;function p(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.$Co=p;function l(E){return E.res.statusCode===204}async function d(E){return l(E)?null:(await(0,D.$Qc)(E.stream)).toString()}e.$Do=d;async function m(E){if(!p(E))throw new Error("Server returned "+E.res.statusCode);return d(E)}e.$Eo=m;async function c(E){if(!p(E))throw new Error("Server returned "+E.res.statusCode);if(l(E))return null;const t=(await(0,D.$Qc)(E.stream)).toString();try{return JSON.parse(t)}catch(s){throw s.message+=`:
`+t,s}}e.$Fo=c;function u(E){g(E)}e.$Go=u;let h;function g(E){const v=$.$Um.as(I.$Zm.Configuration),t=h;h={id:"http",order:15,title:(0,C.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,C.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,C.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,C.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,C.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,C.localize)(6,null),(0,C.localize)(7,null),(0,C.localize)(8,null),(0,C.localize)(9,null)],default:"override",description:(0,C.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,C.localize)(11,null),restricted:!0}}},v.updateConfigurations({add:[h],remove:t?[t]:[]})}g(1)}),define(pe[233],be([1,0,20,13,16,44]),function(ce,e,D,O,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=void 0;let I=class{constructor(w,$){this.a=w,this.b=$}async download(w,$,A=D.CancellationToken.None){if(w.scheme===O.Schemas.file||w.scheme===O.Schemas.vscodeRemote){await this.b.copy(w,$);return}const k={type:"GET",url:w.toString(!0)},p=await this.a.request(k,A);if(p.res.statusCode===200)await this.b.writeFile($,p.stream);else{const l=await(0,C.$Eo)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${l}`)}}};e.$lN=I,e.$lN=I=Le([Ie(0,C.$Ao),Ie(1,r.$Sj)],I)}),define(pe[234],be([1,0,15,20]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=void 0;class r{constructor(P){this.a=P}listen(P,w){throw new Error("Invalid listen")}call(P,w,$,A=O.CancellationToken.None){switch(w){case"request":return this.a.request($[0],A).then(async({res:k,stream:p})=>{const l=await(0,D.$Qc)(p);return[{statusCode:k.statusCode,headers:k.headers},l]});case"resolveProxy":return this.a.resolveProxy($[0])}throw new Error("Invalid call")}}e.$Cq=r;class C{constructor(P){this.a=P}async request(P,w){const[$,A]=await this.a.call("request",[P],w);return{res:$,stream:(0,D.$Sc)(A)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.$Dq=C}),define(pe[235],be([1,0,85,10]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=void 0;function r(I,P){return I.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:I.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function C(I,P,w={}){const $=(0,D.parse)(I),A=w.proxyUrl||r($,P);if(!A)return null;const k=(0,D.parse)(A);if(!/^https?:$/.test(k.protocol||""))return null;const p={host:k.hostname||"",port:k.port||(k.protocol==="https"?"443":"80"),auth:k.auth,rejectUnauthorized:(0,O.$oe)(w.strictSSL)?w.strictSSL:!0};return $.protocol==="http:"?new(await new Promise((l,d)=>{ce(["http-proxy-agent"],l,d)}))(p):new(await new Promise((l,d)=>{ce(["https-proxy-agent"],l,d)}))(p)}e.$Eq=C}),define(pe[86],be([1,0,52,7,192,20,38,11,3,23,106,209,14,143]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zl=void 0;let d;async function m(u,h,g,E){return g["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.$i?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,k.$tl)(E)&&!g["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,k.$tl)(E)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=p.Promises.withAsyncBody(async(v,t)=>{const s=new C.$oc;let a=1e4;const i=u.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(a=(0,l.$ul)(i,1,120)*1e3);const n=setTimeout(()=>{s.dispose(!0),t(new Error((0,r.localize)(0,null)))},a);try{v(await c(h,s.token))}catch(o){!(0,P.$2)(o)&&!s.token.isCancellationRequested?t(new Error((0,r.localize)(1,null,(0,I.$ai)(o)))):v({})}finally{clearTimeout(n),s.dispose()}})),d)}e.$zl=m;async function c(u,h){const g=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",g);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",E);const v=(0,$.$3e)().replace(/-/g,"").substr(0,12),t=new RegExp(v+"({.*})"+v),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",s);const a=await(0,A.$jl)(w.OS,s);return u.trace("getUnixShellEnvironment#shell",a),new Promise((i,n)=>{if(h.isCancellationRequested)return n(new P.$3);const o=(0,O.$_c)(a);let f,b;const y=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(f=`& '${process.execPath}' ${y} -p '''${v}'' + JSON.stringify(process.env) + ''${v}'''`,b=["-Login","-Command"]):o==="nu"?(f=`^'${process.execPath}' ${y} -p '"${v}" + JSON.stringify(process.env) + "${v}"'`,b=["-i","-l","-c"]):(f=`'${process.execPath}' ${y} -p '"${v}" + JSON.stringify(process.env) + "${v}"'`,o==="tcsh"||o==="csh"?b=["-ic"]:b=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(b),f);const S=(0,D.spawn)(a,[...b,f],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});h.onCancellationRequested(()=>(S.kill(),n(new P.$3))),S.on("error",Q=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,I.$ai)(Q)),n(Q)});const L=[];S.stdout.on("data",Q=>L.push(Q));const j=[];S.stderr.on("data",Q=>j.push(Q)),S.on("close",(Q,le)=>{const Y=Buffer.concat(L).toString("utf8");u.trace("getUnixShellEnvironment#raw",Y);const ee=Buffer.concat(j).toString("utf8");if(ee.trim()&&u.trace("getUnixShellEnvironment#stderr",ee),Q||le)return n(new Error((0,r.localize)(2,null,Q,le)));const ue=t.exec(Y),X=ue?ue[1]:"{}";try{const he=JSON.parse(X);g?he.ELECTRON_RUN_AS_NODE=g:delete he.ELECTRON_RUN_AS_NODE,E?he.ELECTRON_NO_ATTACH_CONSOLE=E:delete he.ELECTRON_NO_ATTACH_CONSOLE,delete he.VSCODE_RESOLVING_ENVIRONMENT,delete he.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",he),i(he)}catch(he){u.error("getUnixShellEnvironment#errorCaught",(0,I.$ai)(he)),n(he)}})})}}),define(pe[236],be([1,0,6]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=e.$ZM=void 0,e.$ZM=(0,D.$ph)("stateReadService"),e.$1M=(0,D.$ph)("stateService")}),define(pe[237],be([1,0,14,15,10,25,16,12]),function(ce,e,D,O,r,C,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=e.$3M=e.$2M=e.SaveStrategy=void 0;var w;(function(p){p[p.IMMEDIATE=0]="IMMEDIATE",p[p.DELAYED=1]="DELAYED"})(w||(e.SaveStrategy=w={}));class ${constructor(l,d,m,c){this.f=l,this.g=m,this.h=c,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=d===0?void 0:new D.$sg(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(l){l.fileOperationResult!==1&&this.g.error(l)}}getItem(l,d){const m=this.a[l];return(0,r.$re)(m)?d:m}setItem(l,d){this.setItems([{key:l,data:d}])}setItems(l){let d=!1;for(const{key:m,data:c}of l)this.a[m]!==c&&((0,r.$re)(c)?(0,r.$pe)(this.a[m])||(this.a[m]=void 0,d=!0):(this.a[m]=c,d=!0));d&&this.j()}removeItem(l){(0,r.$pe)(this.a[l])||(this.a[l]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const l=JSON.stringify(this.a,null,4);if(l!==this.b)try{await this.h.writeFile(this.f,O.$Ec.fromString(l),{atomic:{postfix:".vsctmp"}}),this.b=l}catch(d){this.g.error(d)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.$2M=$;let A=class{constructor(l,d,m,c){this.a=new $(d.stateResource,l,m,c)}async init(){await this.a.init()}getItem(l,d){return this.a.getItem(l,d)}};e.$3M=A,e.$3M=A=Le([Ie(1,C.$wh),Ie(2,P.$Ri),Ie(3,I.$Sj)],A);class k extends A{setItem(l,d){this.a.setItem(l,d)}setItems(l){this.a.setItems(l)}removeItem(l){this.a.removeItem(l)}close(){return this.a.close()}}e.$4M=k}),define(pe[119],be([1,0,3,30,23]),function(ce,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=e.$2n=void 0;function C(w){if(D.$t===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}function I(w,$,A,k,p,l,d,m){const c=Object.create(null);c["common.machineId"]=l,c.sessionID=(0,r.$3e)()+Date.now(),c.commitHash=k,c.version=p,c["common.platformVersion"]=(w||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,D.$h)(D.$t),c["common.nodePlatform"]=O.$2c,c["common.nodeArch"]=A,c["common.product"]=m||"desktop",d&&(c["common.msftInternal"]=d);let u=0;const h=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),D.$l&&(c["common.snap"]="true");const g=C($);return g&&(c["common.platformDetail"]=g),c}e.$2n=I;function P(w){const $=O.env.USERDNSDOMAIN;if(!$)return!1;const A=$.toLowerCase();return w.some(k=>A===k)}e.$3n=P}),define(pe[238],be([1,0,18,11,2,22,16]),function(ce,e,D,O,r,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var P;(function($){function A(k,p){return k.callstack<p.callstack?-1:k.callstack>p.callstack?1:0}$.compare=A})(P||(e.ErrorEvent=P={}));class w{static{this.ERROR_FLUSH_TIMEOUT=5*1e3}constructor(A,k=w.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new r.$kb,this.c=A,this.d=k;const p=O.$V.addListener(l=>this.j(l));this.h.add((0,r.$jb)(p)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(A){if(!A||A.code||(A.detail&&A.detail.stack&&(A=A.detail),O.$ab.isErrorNoTelemetry(A)||A instanceof I.$ak||typeof A?.message=="string"&&A.message.includes("Unable to read file")))return;const k=Array.isArray(A.stack)?A.stack.join(`
`):A.stack,p=A.message?A.message:(0,C.$Nm)(A);k&&this.k({msg:p,callstack:k})}k(A){const k=(0,D.$af)(this.g,A,P.compare);k<0?(A.count=1,this.g.splice(~k,0,A)):(this.g[k].count||(this.g[k].count=0),this.g[k].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const A of this.g)this.c.publicLogError2("UnhandledError",A);this.g.length=0}}e.default=w}),define(pe[239],be([1,0,2]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=void 0;class O extends D.$lb{constructor(C,I){super(),this.a=C,this.b=I}async call(C,I,P){switch(I){case"updateTelemetryLevel":{const{telemetryLevel:w}=P;return this.a.updateInjectedTelemetryLevel(w)}case"logTelemetry":{const{eventName:w,data:$}=P;return this.b?this.b.log(w,$):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${I} not found`)}listen(C,I,P){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.$vr=O}),define(pe[32],be([1,0,6]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=void 0,e.$Vk=(0,D.$ph)("telemetryService"),e.$Wk=(0,D.$ph)("customEndpointTelemetryService"),e.$Xk="telemetry.currentSessionDate",e.$Yk="telemetry.firstSessionDate",e.$Zk="telemetry.lastSessionDate",e.$1k="telemetry.machineId",e.$2k="telemetry",e.$3k="telemetry.telemetryLevel",e.$4k="telemetry.enableCrashReporter",e.$5k="telemetry.enableTelemetry";var O;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var r;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(r||(e.TelemetryConfiguration=r={}))}),define(pe[240],be([1,0,29,14,75,13,7,3,4,100,21,105,215,16,26,32]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=e.$lr=e.$kr=void 0;const c=new Map;async function u(t,s){const a=`${t}::${s.join(":")}`,i=c.get(a);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,f=new Map,b=2e4;function y(L,j,Q,le){const Y=j.substring(L.length+1);return O.Promises.withAsyncBody(async ee=>{let ue;try{ue=await A.Promises.readdir(j,{withFileTypes:!0})}catch{ee();return}if(le.count>=b){le.count+=ue.length,le.maxReached=!0,ee();return}let X=ue.length;if(X===0){ee();return}let he=ue;le.count+ue.length>b&&(le.maxReached=!0,X=b-le.count,he=ue.slice(0,X)),le.count+=ue.length;for(const x of he)if(x.isDirectory()){if(Q.includes(x.name)||await y(L,(0,I.$8c)(j,x.name),Q,le),--X===0){ee();return}}else{const se=x.name.lastIndexOf(".");if(se>=0){const V=x.name.substring(se+1);V&&o.set(V,(o.get(V)??0)+1)}for(const V of n)V.relativePathPattern?.test(Y)!==!1&&V.filePattern.test(x.name)&&f.set(V.tag,(f.get(V.tag)??0)+1);if(--X===0){ee();return}}})}const S=O.Promises.withAsyncBody(async L=>{const j={count:0,maxReached:!1};await y(t,t,s,j);const Q=await E(t);L({configFiles:h(f),fileTypes:h(o),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:Q})});return c.set(a,S),S}e.$kr=u;function h(t){return Array.from(t.entries(),([s,a])=>({name:s,count:a})).sort((s,a)=>a.count-s.count)}function g(){const t={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/l.$nk.GB).toFixed(2)}GB (${(D.freemem()/l.$nk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round($.$um.value()*100)}%`},s=D.cpus();return s&&s.length>0&&(t.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),t}e.$lr=g;async function E(t){try{const s=new Map,a=(0,I.$8c)(t,".vscode","launch.json"),i=await A.Promises.readFile(a),n=[],o=(0,r.$ym)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${a}`),[];if((0,r.$Hm)(o)==="object"&&o.configurations)for(const f of o.configurations){const b=f.type;b&&(s.has(b)?s.set(b,s.get(b)+1):s.set(b,1))}return h(s)}catch{return[]}}e.$mr=E;let v=class{constructor(s,a){this.c=s,this.d=a}f(s){const a=[];return a.push(`OS Version:       ${s.os}`),a.push(`CPUs:             ${s.cpus}`),a.push(`Memory (System):  ${s.memory}`),a.push(`VM:               ${s.vmHint}`),a.join(`
`)}g(s){const a=[];a.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),a.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const i=D.cpus();return i&&i.length>0&&a.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),a.push(`Memory (System):  ${(D.totalmem()/l.$nk.GB).toFixed(2)}GB (${(D.freemem()/l.$nk.GB).toFixed(2)}GB free)`),P.$i||a.push(`Load (avg):       ${D.loadavg().map(n=>Math.round(n)).join(", ")}`),a.push(`VM:               ${Math.round($.$um.value()*100)}%`),a.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${s.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.j(s.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(s,a){return Promise.all([(0,k.$jr)(s.mainPID),this.k(s)]).then(async i=>{let[n,o]=i,f=this.m(s,n);return a.forEach(b=>{if((0,p.$7l)(b))f+=`
${b.errorMessage}`,o+=`
${b.errorMessage}`;else if(f+=`

Remote: ${b.hostName}`,b.processes&&(f+=`
${this.m(s,b.processes)}`),b.workspaceMetadata){o+=`
|  Remote: ${b.hostName}`;for(const y of Object.keys(b.workspaceMetadata)){const S=b.workspaceMetadata[y];let L=`${S.fileCount} files`;S.maxFilesReached&&(L=`more than ${L}`),o+=`|    Folder (${y}): ${L}`,o+=this.h(S)}}}),{processInfo:f,workspaceInfo:o}})}async getSystemInfo(s,a){const{memory:i,vmHint:n,os:o,cpus:f}=g(),b={os:o,memory:i,cpus:f,vmHint:n,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:a};return P.$i||(b.load=`${D.loadavg().map(y=>Math.round(y)).join(", ")}`),P.$k&&(b.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(b)}async getDiagnostics(s,a){const i=[];return(0,k.$jr)(s.mainPID).then(async n=>(i.push(""),i.push(this.g(s)),i.push(""),i.push(this.m(s,n)),s.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(s))),a.forEach(o=>{if((0,p.$7l)(o))i.push(`
${o.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${o.hostName}`),i.push(this.f(o.machineInfo)),o.processes&&i.push(this.m(s,o.processes)),o.workspaceMetadata)for(const f of Object.keys(o.workspaceMetadata)){const b=o.workspaceMetadata[f];let y=`${b.fileCount} files`;b.maxFilesReached&&(y=`more than ${y}`),i.push(`Folder (${f}): ${y}`),i.push(this.h(b))}}),i.push(""),i.push(""),i.join(`
`)))}h(s){const a=[];let n=0;const o=(S,L)=>{const j=` ${S}(${L})`;n+j.length>60?(a.push(f),f="|                 ",n=f.length):n+=j.length,f+=j};let f="|      File types:";const b=10,y=s.fileTypes.length>b?b:s.fileTypes.length;for(let S=0;S<y;S++){const L=s.fileTypes[S];o(L.name,L.count)}if(a.push(f),s.configFiles.length>=0&&(f="|      Conf files:",n=0,s.configFiles.forEach(S=>{o(S.name,S.count)}),a.push(f)),s.launchConfigFiles.length>0){let S="|      Launch Configs:";s.launchConfigFiles.forEach(L=>{const j=L.count>1?` ${L.name}(${L.count})`:` ${L.name}`;S+=j}),a.push(S)}return a.join(`
`)}j(s){const a=Math.max(...Object.keys(s).map(i=>i.length));return Object.keys(s).map(i=>`${i}:  ${" ".repeat(a-i.length)}  ${s[i]}`).join(`
                  `)}k(s){const a=[],i=[];return s.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(a.push(`|  Window (${n.title})`),n.folderURIs.forEach(o=>{const f=w.URI.revive(o);if(f.scheme===C.Schemas.file){const b=f.fsPath;i.push(u(b,["node_modules",".git"]).then(y=>{let S=`${y.fileCount} files`;y.maxFilesReached&&(S=`more than ${S}`),a.push(`|    Folder (${(0,I.$_c)(b)}): ${S}`),a.push(this.h(y))}).catch(y=>{a.push(`|      Error: Unable to collect workspace stats for folder ${b} (${y.toString()})`)}))}else a.push(`|    Folder (${f.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>a.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(s,a){const i=new Map;s.windows.forEach(o=>i.set(o.pid,`window [${o.id}] (${o.title})`)),s.pidToNames.forEach(({pid:o,name:f})=>i.set(o,f));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),a&&this.n(s.mainPID,i,n,a,0),n.join(`
`)}n(s,a,i,n,o){const f=o===0;let b;f?b=n.pid===s?`${this.d.applicationName} main`:"remote agent":a.has(n.pid)?b=a.get(n.pid):b=`${"  ".repeat(o)} ${n.name}`;const y=process.platform==="win32"?n.mem:D.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(y/l.$nk.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${b}`),Array.isArray(n.children)&&n.children.forEach(S=>this.n(s,a,i,S,o+1))}async getWorkspaceFileExtensions(s){const a=new Set;for(const{uri:i}of s.folders){const n=w.URI.revive(i);if(n.scheme!==C.Schemas.file)continue;const o=n.fsPath;try{(await u(o,["node_modules",".git"])).fileTypes.forEach(b=>a.add(b.name))}catch{}}return{extensions:[...a]}}async reportWorkspaceStats(s){for(const{uri:a}of s.folders){const i=w.URI.revive(a);if(i.scheme!==C.Schemas.file)continue;const n=i.fsPath;try{const o=await u(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),o.fileTypes.forEach(f=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:f.name,count:f.count})}),o.launchConfigFiles.forEach(f=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:f.name,count:f.count})}),o.configFiles.forEach(f=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:f.name,count:f.count})})}catch{}}}};e.$nr=v,e.$nr=v=Le([Ie(0,m.$Vk),Ie(1,d.$0i)],v)}),define(pe[36],be([1,0,22,10,5,24,56,119,32]),function(ce,e,D,O,r,C,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=void 0;class ${constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$4n=$;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$5n=A,e.$6n=new A;class k{async publicLog(n,o,f){}async publicLogError(n,o,f){}}e.$7n=k,e.$8n="telemetry",e.$9n="extensionTelemetryLog",e.$0n={log:()=>null,flush:()=>Promise.resolve(null)};function p(i,n){return r.Event.debounce(n.onDidChangeConfiguration,(f,b)=>{const y=f?new Set([...f.affectedKeys,...b.affectedKeys]):b.affectedKeys;return{...b,affectedKeys:y}},1e3,!0)(f=>{f.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,C.$Yh)(f.source),configurationKeys:Array.from(f.affectedKeys)})})}e.$$n=p;function l(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry||n.extensionTestsLocationURI)}e.$_n=l;function d(i,n){return!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$ao=d;function m(i){const n=i.getValue(w.$3k),o=i.getValue(w.$4k);if(i.getValue(w.$5k)===!1||o===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$bo=m;function c(i){const n={},o={},f={};g(i,f);for(let b in f){b=b.length>150?b.substr(b.length-149):b;const y=f[b];typeof y=="number"?o[b]=y:typeof y=="boolean"?o[b]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${b} has been trimmed to 8192, the original length is ${y.length}`),n[b]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(n[b]=y)}return{properties:n,measurements:o}}e.$co=c;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(i){if(!i)return"none";const n=(0,I.$Ck)(i);return u.has(n)?n:"other"}e.$do=h;function g(i,n,o=0,f){if(i)for(const b of Object.getOwnPropertyNames(i)){const y=i[b],S=f?f+b:b;Array.isArray(y)?n[S]=(0,D.$Nm)(y):y instanceof Date?n[S]=y.toISOString():(0,O.$ke)(y)?o<2?g(y,n,o+1,S+"."):n[S]=(0,D.$Nm)(y):n[S]=y}}function E(i,n){const o=i.msftInternalDomains||[],f=n.getValue("telemetry.internalTesting");return(0,P.$3n)(o)||f}e.$eo=E;function v(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$fo=v;function t(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let o=i;const f=[];for(const L of n)for(;;){const j=L.exec(i);if(!j)break;f.push([j.index,L.lastIndex])}const b=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(o="";;){const L=y.exec(i);if(!L)break;const j=f.some(([Q,le])=>L.index<le&&Q<y.lastIndex);!b.test(L[0])&&!j&&(o+=i.substring(S,L.index)+"<REDACTED: user-file-path>",S=y.lastIndex)}return S<i.length&&(o+=i.substr(S)),o}function s(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of n)if(o.regex.test(i))return`<REDACTED: ${o.label}>`;return i}function a(i,n){return(0,D.$Km)(i,o=>{if(o instanceof $||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let f=o.replaceAll("%20"," ");f=t(f,n);for(const b of n)f=f.replace(b,"");return f=s(f),f}})}e.$go=a}),define(pe[37],be([1,0,17,31,40,3,4,11,30,36]),function(ce,e,D,O,r,C,I,P,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=void 0;function A(a,i){return a.uuid&&i.uuid?a.uuid===i.uuid:a.id===i.id?!0:(0,D.$Gd)(a.id,i.id)===0}e.$ho=A;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new p(i.identifier,n,o)}static parse(i){const n=k.exec(i);return n&&n[1]&&n[2]?new p({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof p?A(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$io=p;const l=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(a){const i=l.exec(a);return i&&i[1]?[c(i[1]),i[2]]:[c(a),void 0]}e.$jo=d;function m(a,i){return`${a}.${i}`}e.$ko=m;function c(a){return a.toLowerCase()}e.$lo=c;function u(a,i){return c(m(a??r.$El,i))}e.$mo=u;function h(a,i){const n=[],o=f=>{for(const b of n)if(b.some(y=>A(i(y),i(f))))return b;return null};for(const f of a){const b=o(f);b?b.push(f):n.push([f])}return n}e.$no=h;function g(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.$oo=g;function E(a){return{id:new $.$4n(a.identifier.id),name:new $.$4n(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$po=E,e.$qo=new r.$Il("pprice.better-merge");function v(a,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const f=o.shift();if(f&&n.every(b=>!A(b.identifier,{id:f}))){const b=a.filter(y=>A(y.identifier,{id:f}));b.length===1&&(n.push(b[0]),o.push(...b[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$ro=v;async function t(a,i){if(!C.$k)return!1;let n;try{n=(await a.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await a.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){i.debug("Error while getting the os-release file.",(0,P.$9)(f))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(a,i){const n=await t(a,i),o=(0,O.$Mn)(n?"alpine":C.$t,w.$3c);return i.debug("ComputeTargetPlatform:",o),o}e.$so=s}),define(pe[120],be([1,0,20,11,13,19,53,4,179,31,37,40]),function(ce,e,D,O,r,C,I,P,w,$,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=void 0;const p=c=>(0,w.localize)(0,null,c),l=(0,w.localize)(1,null,"ms-dotnettools.csharp");function d(c,u){return u?`${c.publisher}.${c.name}@${c.version}`:`${c.publisher}.${c.name}`}let m=class{constructor(u,h,g){this.a=u,this.b=h,this.d=g}get f(){}async listExtensions(u,h,g){let E=await this.b.getInstalled(1,g);const v=k.$Hl.map(s=>s.toLowerCase());if(h&&h!==""){if(v.indexOf(h.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}E=E.filter(s=>s.manifest.categories?s.manifest.categories.map(i=>i.toLowerCase()).indexOf(h.toLowerCase())>-1:!1)}else if(h===""){this.a.info("Possible Categories: "),v.forEach(s=>{this.a.info(s)});return}this.f&&this.a.info((0,w.localize)(2,null,this.f)),E=E.sort((s,a)=>s.identifier.id.localeCompare(a.identifier.id));let t;for(const s of E)t!==s.identifier.id&&(t=s.identifier.id,this.a.info(d(s.manifest,u)))}async installExtensions(u,h,g,E){const v=[];try{const t=[];u.length&&this.a.info(this.f?(0,w.localize)(3,null,this.f):(0,w.localize)(4,null));const s=[];let a=[];const i=(o,f,b)=>{a.push({id:o,version:f!=="prerelease"?f:void 0,installOptions:{...g,isBuiltin:b,installPreReleaseVersion:f==="prerelease"||g.installPreReleaseVersion}})};for(const o of u)if(o instanceof P.URI)s.push({vsix:o,installOptions:g});else{const[f,b]=(0,A.$jo)(o);i(f,b,!1)}for(const o of h)if(o instanceof P.URI)s.push({vsix:o,installOptions:{...g,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[f,b]=(0,A.$jo)(o);i(f,b,!0)}const n=await this.b.getInstalled(1,g.profileLocation);if(s.length&&await Promise.all(s.map(async({vsix:o,installOptions:f})=>{try{const b=await this.g(o,f,E,n);b&&t.push(b)}catch(b){this.a.error(b),v.push(o.toString())}})),a.length&&(a=a.filter(({id:o,version:f})=>{const b=n.find(y=>(0,A.$ho)(y.identifier,{id:o}));if(b){if(!E&&(!f||f==="prerelease"&&b.preRelease))return this.a.info((0,w.localize)(5,null,o,b.manifest.version,o)),!1;if(f&&b.manifest.version===f)return this.a.info((0,w.localize)(6,null,`${o}@${f}`)),!1}return!0}),a.length)){const o=await this.h(a);await Promise.all(a.map(async f=>{const b=o.get(f.id.toLowerCase());if(b)try{const y=await this.j(f,b,n);y&&t.push(y)}catch(y){this.a.error(y.message||y.stack||y),v.push(f.id)}else this.a.error(`${p(f.version?`${f.id}@${f.version}`:f.id)}
${l}`),v.push(f.id)}))}}catch(t){throw this.a.error((0,w.localize)(7,null,(0,O.$9)(t))),t}if(v.length)throw new Error((0,w.localize)(8,null,v.join(", ")))}async g(u,h,g,E){const v=await this.b.getManifest(u);if(!v)throw new Error("Invalid vsix");if(await this.l(v,g,h.profileLocation,E))try{return await this.b.install(u,h),this.a.info((0,w.localize)(9,null,(0,C.$6f)(u))),v}catch(s){if((0,O.$2)(s))return this.a.info((0,w.localize)(10,null,(0,C.$6f)(u))),null;throw s}return null}async h(u){const h=new Map,g=u.some(t=>t.installOptions.installPreReleaseVersion),E=await this.b.getTargetPlatform(),v=[];for(const t of u)$.$Fn.test(t.id)&&v.push({...t,preRelease:g});if(v.length){const t=await this.d.getExtensions(v,{targetPlatform:E},D.CancellationToken.None);for(const s of t)h.set(s.identifier.id.toLowerCase(),s)}return h}async j({id:u,version:h,installOptions:g},E,v){const t=await this.d.getManifest(E,D.CancellationToken.None);if(t&&!this.k(t))return null;const s=v.find(a=>(0,A.$ho)(a.identifier,E.identifier));if(s){if(E.version===s.manifest.version)return this.a.info((0,w.localize)(11,null,h?`${u}@${h}`:u)),null;this.a.info((0,w.localize)(12,null,u,E.version))}try{g.isBuiltin?this.a.info(h?(0,w.localize)(13,null,u,h):(0,w.localize)(14,null,u)):this.a.info(h?(0,w.localize)(15,null,u,h):(0,w.localize)(16,null,u));const a=await this.b.installFromGallery(E,{...g,installGivenVersion:!!h});return this.a.info((0,w.localize)(17,null,u,a.manifest.version)),t}catch(a){if((0,O.$2)(a))return this.a.info((0,w.localize)(18,null,u)),null;throw a}}k(u){return!0}async l(u,h,g,E){if(!h){const v={id:(0,A.$mo)(u.publisher,u.name)},t=E.find(s=>(0,A.$ho)(v,s.identifier)&&(0,I.gt)(s.manifest.version,u.version));if(t)return this.a.info((0,w.localize)(19,null,t.identifier.id,t.manifest.version,u.version)),!1}return this.k(u)}async uninstallExtensions(u,h,g){const E=async t=>{if(t instanceof P.URI){const s=await this.b.getManifest(t);return d(s)}return t},v=[];for(const t of u){const s=await E(t),i=(await this.b.getInstalled(void 0,g)).filter(n=>(0,A.$ho)(n.identifier,{id:s}));if(!i.length)throw new Error(`${this.m(s)}
${l}`);if(i.some(n=>n.type===0)){this.a.info((0,w.localize)(20,null,s));return}if(!h&&i.some(n=>n.isBuiltin)){this.a.info((0,w.localize)(21,null,s));return}this.a.info((0,w.localize)(22,null,s));for(const n of i)await this.b.uninstall(n,{profileLocation:g}),v.push(n);this.f?this.a.info((0,w.localize)(23,null,s,this.f)):this.a.info((0,w.localize)(24,null,s))}}async locateExtension(u){const h=await this.b.getInstalled();u.forEach(g=>{h.forEach(E=>{if(E.identifier.id===g&&E.location.scheme===r.Schemas.file){this.a.info(E.location.fsPath);return}})})}m(u){return this.f?(0,w.localize)(25,null,u,this.f):(0,w.localize)(26,null,u)}};e.$Zo=m,e.$Zo=m=Le([Ie(1,$.$Tn),Ie(2,$.$Rn)],m)}),define(pe[241],be([1,0,5,2,27,37,40]),function(ce,e,D,O,r,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=void 0;class P extends O.$lb{constructor($,A,k,p,l,d,m){super(),this.f=$,this.g=A,this.h=k,this.i=p,this.j=l,this.k=d,this.l=m,this.a=this.B(new D.$ec),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new O.$tb),this.m().then(null,c=>m.error(c))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles),this.n(),await this.z()}n(){this.B(this.h.onDidChangeProfiles($=>this.p($.added))),this.B(this.i.onAddExtensions($=>this.r($))),this.B(this.i.onDidAddExtensions($=>this.s($))),this.B(this.i.onRemoveExtensions($=>this.t($))),this.B(this.i.onDidRemoveExtensions($=>this.u($))),this.B(this.k.onDidFilesChange($=>this.v($)))}async p($){try{$.length&&await Promise.all($.map(A=>(this.c.set(A.id,(0,O.$ib)(this.k.watch(this.j.extUri.dirname(A.extensionsResource)),this.k.watch(A.extensionsResource))),this.y(A.extensionsResource))))}catch(A){throw this.l.error(A),A}}async r($){for(const A of $.extensions)this.C(this.F(A.identifier,A.version),$.profileLocation)}async s($){for(const A of $.extensions){const k=this.F(A.identifier,A.version);$.error?this.D(k,$.profileLocation):this.C(k,$.profileLocation)}}async t($){for(const A of $.extensions)this.D(this.F(A.identifier,A.version),$.profileLocation)}async u($){const A=[],k=[];for(const p of $.extensions){const l=this.F(p.identifier,p.version);$.error?this.C(l,$.profileLocation):(this.D(l,$.profileLocation),this.b.has(l)||(this.l.debug("Extension is removed from all profiles",p.identifier.id,p.version),k.push(this.f.scanInstalledExtensionAtLocation(p.location).then(d=>{d?A.push(d):this.l.info("Extension not found at the location",p.location.toString())},d=>this.l.error(d)))))}try{await Promise.all(k),A.length&&await this.z(A)}catch(p){this.l.error(p)}}v($){for(const A of this.h.profiles)$.contains(A.extensionsResource,0,1)&&this.w(A.extensionsResource)}async w($){const A=[],k=[],p=await this.i.scanProfileExtensions($),l=new Set,d=new Set;for(const[m,c]of this.b)c.has($)&&d.add(m);for(const m of p){const c=this.F(m.identifier,m.version);l.add(c),d.has(c)||(A.push(m.identifier),this.C(c,$))}for(const m of d)if(!l.has(m)){const c=this.G(m);c&&(k.push(c.identifier),this.D(m,$))}(A.length||k.length)&&this.a.fire({added:A.length?{extensions:A,profileLocation:$}:void 0,removed:k.length?{extensions:k,profileLocation:$}:void 0})}async y($){const A=await this.i.scanProfileExtensions($);for(const k of A)this.C(this.F(k.identifier,k.version),$)}async z($){$||($=(await this.f.scanAllUserInstalledExtensions()).filter(k=>!this.b.has(this.F(k.identifier,k.manifest.version)))),$.length&&await this.f.markAsUninstalled(...$)}C($,A){let k=this.b.get($);k||this.b.set($,k=new r.$oi(p=>this.j.extUri.getComparisonKey(p))),k.add(A)}D($,A){const k=this.b.get($);k&&k.delete(A),k?.size||this.b.delete($)}F($,A){return`${I.$Il.toKey($.id)}@${A}`}G($){const[A,k]=(0,C.$jo)($);return k?{identifier:{id:A},version:k}:void 0}}e.$op=P}),define(pe[242],be([1,0,212,36]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=void 0;async function r(C,I,P,w,$,A,k){const p={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${I.nameShort})`};if((0,O.$_n)(I,P)&&(0,O.$bo)(w)===3){const l=await(0,D.$So)(P,$,A);p["X-Market-User-Id"]=l,p["VSCode-SessionId"]=k.machineId||l}return p}e.$To=r}),define(pe[121],be([1,0,87,18,14,2,13,7,21,25,31,37,12,84,4]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;let m=class extends l.$Aq{constructor(g,E,v,t){super(v),this.h=g,this.i=t,this.g=this.B(new c(E,t)),this.h.registerParticipant({postInstall:async s=>this.j(s),postUninstall:async s=>this.k(s)})}async getBuiltInExtensionTranslationsUri(g,E){const t=(await this.g.getLanguagePacks())[E];if(!t){this.i.warn(`No language pack found for ${E}`);return}const s=t.translations[g];return s?d.URI.file(s):void 0}async getInstalledLanguages(){const g=await this.g.getLanguagePacks(),E=Object.keys(g).map(v=>{const t=g[v];return{...this.f(v,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return E.push(this.f("en","English")),E.sort((v,t)=>v.label.localeCompare(t.label)),E}async j(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",g.identifier.id),await this.update())}async k(g){const E=await this.g.getLanguagePacks();Object.keys(E).some(v=>E[v]&&E[v].extensions.some(t=>(0,k.$ho)(t.extensionIdentifier,g.identifier)))&&(this.i.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,E]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),v=await this.g.update(E);return!(0,O.$$e)(Object.keys(g),Object.keys(v))}};e.$Bq=m,e.$Bq=m=Le([Ie(0,A.$Tn),Ie(1,$.$xh),Ie(2,A.$Rn),Ie(3,p.$Ri)],m);let c=class extends C.$lb{constructor(g,E){super(),this.i=E,this.c={},this.f=(0,P.$8c)(g.userDataPath,"languagepacks.json"),this.g=new r.$Bg}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(g){return this.m(E=>{Object.keys(E).forEach(v=>delete E[v]),this.j(E,...g)}).then(()=>this.c)}j(g,...E){for(const v of E)v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&this.k(g,v);Object.keys(g).forEach(v=>this.l(g[v]))}k(g,E){const v=E.identifier,t=E.manifest.contributes&&E.manifest.contributes.localizations?E.manifest.contributes.localizations:[];for(const s of t)if(E.location.scheme===I.Schemas.file&&u(s)){let a=g[s.languageId];a||(a={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},g[s.languageId]=a);const i=a.extensions.filter(n=>(0,k.$ho)(n.extensionIdentifier,v))[0];i?i.version=E.manifest.version:a.extensions.push({extensionIdentifier:v,version:E.manifest.version});for(const n of s.translations)a.translations[n.id]=(0,P.$8c)(E.location.fsPath,n.path)}}l(g){if(g){const E=(0,D.createHash)("md5");for(const v of g.extensions)E.update(v.extensionIdentifier.uuid||v.extensionIdentifier.id).update(v.version);g.hash=E.digest("hex")}}m(g=()=>null){return this.g.queue(()=>{let E=null;return w.Promises.readFile(this.f,"utf8").then(void 0,v=>v.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(v)).then(v=>{try{return JSON.parse(v)}catch{return{}}}).then(v=>(E=g(v),v)).then(v=>{for(const s of Object.keys(v))v[s]||delete v[s];this.c=v,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),w.Promises.writeFile(this.f,t)}).then(()=>E,v=>this.i.error(v))})}};c=Le([Ie(0,$.$xh),Ie(1,p.$Ri)],c);function u(h){if(typeof h.languageId!="string"||!Array.isArray(h.translations)||h.translations.length===0)return!1;for(const g of h.translations)if(typeof g.id!="string"||typeof g.path!="string")return!1;return!(h.languageName&&typeof h.languageName!="string"||h.localizedLanguageName&&typeof h.localizedLanguageName!="string")}}),define(pe[243],be([1,0,164,11,22,36]),function(ce,e,D,O,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=void 0;const I="https://mobile.events.data.microsoft.com/OneCollector/1.0",P="https://mobile.events.data.microsoft.com/ping";async function w(A,k,p){const l=await(0,D.$2C)("@microsoft/1ds-core-js","dist/ms.core.js"),d=await(0,D.$2C)("@microsoft/1ds-post-js","dist/ms.post.js"),m=new l.AppInsightsCore,c=new d.PostChannel,u={instrumentationKey:A,endpointUrl:I,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[c]]};if(p){u.extensionConfig={};const h={alwaysUseXhrOverride:!0,httpXHROverride:p};u.extensionConfig[c.identifier]=h}return m.initialize(u,[]),m.addTelemetryInitializer(h=>{k&&(h.ext=h.ext??{},h.ext.utc=h.ext.utc??{},h.ext.utc.flags=8462029)}),m}class ${constructor(k,p,l,d,m){this.e=k,this.f=p,this.g=l,this.h=m,this.c=I,this.d=P,this.g||(this.g={}),typeof d=="function"?this.a=d():this.a=d,this.b=null}i(k){if(this.a){if(typeof this.a!="string"){k(this.a);return}this.b||(this.b=w(this.a,this.e,this.h)),this.b.then(p=>{k(p)},p=>{(0,O.$Y)(p),console.error(p)})}}log(k,p){if(!this.a)return;p=(0,r.$Lm)(p,this.g),p=(0,C.$co)(p);const l=this.f+"/"+k;try{this.i(d=>{d.pluginVersionString=p?.properties.version??"Unknown",d.track({name:l,baseData:{name:l,properties:p?.properties,measurements:p?.measurements}})})}catch{}}flush(){return this.a?new Promise(k=>{this.i(p=>{p.unload(!0,()=>{this.a=void 0,k(void 0)})})}):Promise.resolve(void 0)}}e.$VM=$}),define(pe[244],be([1,0,2,22,3,17,193,24,55,54,26,35,32,36]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=void 0;let d=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(u,h,g){this.k=h,this.l=g,this.d={},this.i=new D.$kb,this.j=[],this.b=u.appenders,this.c=u.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,C.$pd)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,C.$pd)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(p.$3k)||E.affectsConfiguration(p.$5k)||E.affectsConfiguration(p.$4k))&&this.m()}))}setExperimentProperty(u,h){this.d[u]=h}m(){let u=(0,l.$bo)(this.k);const h=this.l.enabledTelemetryLevels;if(h){this.h=this.sendErrorTelemetry?h.error:!1;const g=h.usage?3:h.error?2:0;u=Math.min(u,g)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(u,h,g){this.g<h||(g=(0,O.$Lm)(g,this.d),g=(0,l.$go)(g,this.j),g=(0,O.$Lm)(g,this.c),this.b.forEach(E=>E.log(u,g)))}publicLog(u,h){this.n(u,3,h)}publicLog2(u,h){this.publicLog(u,h)}publicLogError(u,h){this.h&&this.n(u,2,h)}publicLogError2(u,h){this.publicLogError(u,h)}};e.$Hq=d,e.$Hq=d=Le([Ie(1,P.$Vh),Ie(2,A.$0i)],d);function m(){const c=(0,I.localize)(0,null,$.default.nameLong),u=$.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",$.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=r.$o?"":(0,I.localize)(3,null),g=(0,I.localize)(4,null),E=(0,I.localize)(5,null),v=(0,I.localize)(6,null),t=(0,I.localize)(7,null),s=`
|       | ${g} | ${E} | ${v} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,I.localize)(8,null);return`
${c} ${u} ${h}

&nbsp;

${t}
${s}

&nbsp;

${a}
`}k.$Um.as(w.$Zm.Configuration).registerConfiguration({id:p.$2k,order:1,type:"object",title:(0,I.localize)(9,null),properties:{[p.$3k]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:m(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),k.$Um.as(w.$Zm.Configuration).registerConfiguration({id:p.$2k,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[p.$5k]:{type:"boolean",markdownDescription:$.default.privacyStatementUrl?(0,I.localize)(16,null,$.default.nameLong,$.default.privacyStatementUrl):(0,I.localize)(15,null,$.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${p.$3k}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(pe[245],be([1,0,24,6,26,32,244,36]),function(ce,e,D,O,r,C,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=e.$sr=void 0;let w=class extends I.$Hq{constructor(A,k,p,l){super(A,p,l),this.o=k}publicLog(A,k){if(!(this.o<3))return super.publicLog(A,k)}publicLog2(A,k){return this.publicLog(A,k)}publicLogError(A,k){return this.o<2?Promise.resolve(void 0):super.publicLogError(A,k)}publicLogError2(A,k){return this.publicLogError(A,k)}async updateInjectedTelemetryLevel(A){if(A===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,A):A,this.o===0&&this.dispose()}};e.$sr=w,e.$sr=w=Le([Ie(2,D.$Vh),Ie(3,r.$0i)],w),e.$tr=new class extends P.$5n{async updateInjectedTelemetryLevel(){}},e.$ur=(0,O.$qh)(C.$Vk)}),define(pe[246],be([1,0,15,20,299,243]),function(ce,e,D,O,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WM=void 0;async function I(A,k){const p=await k.request(A,O.CancellationToken.None),l=(await(0,D.$Qc)(p.stream)).toString(),d=p.res.statusCode??200;return{headers:p.res.headers,statusCode:d,responseData:l}}async function P(A){const k={method:A.type,headers:A.headers};return new Promise((l,d)=>{const m=r.request(A.url??"",k,c=>{c.on("data",function(u){l({headers:c.headers,statusCode:c.statusCode??200,responseData:u.toString()})}),c.on("error",function(u){d(u)})});m.write(A.data,c=>{c&&d(c)}),m.end()})}async function w(A,k,p){const l=typeof k.data=="string"?k.data:new TextDecoder().decode(k.data),d={type:"POST",headers:{...k.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(k.data).toString()},url:k.urlString,data:l};try{const m=A?await I(d,A):await P(d);p(m.statusCode,m.headers,m.responseData)}catch{p(0,{})}}class $ extends C.$VM{constructor(k,p,l,d,m){const c={sendPOST:(u,h)=>{w(k,u,h)}};super(p,l,d,m,c)}}e.$WM=$}),define(pe[247],be([1,0,11,238]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class r extends O.default{i(){(0,D.setUnexpectedErrorHandler)(P=>console.error(P));const I=[];process.on("unhandledRejection",(P,w)=>{I.push(w),setTimeout(()=>{const $=I.indexOf(w);$>=0&&w.catch(A=>{I.splice($,1),(0,D.$2)(A)||(console.warn(`rejected promise not handled within 1 second: ${A}`),A.stack&&console.warn(`stack trace: ${A.stack}`),P&&(0,D.$Y)(P))})},1e3)}),process.on("rejectionHandled",P=>{const w=I.indexOf(P);w>=0&&I.splice(w,1)}),process.on("uncaughtException",P=>{(0,D.$X)(P)||(0,D.$Y)(P)})}}e.default=r}),define(pe[122],be([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var D;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(D||(e.EnvironmentVariableMutatorType=D={}))}),define(pe[123],be([1,0,3,122]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=void 0;const r=new Map([[O.EnvironmentVariableMutatorType.Append,"APPEND"],[O.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[O.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class C{constructor(A){this.collections=A,this.a=new Map,this.b=new Map,A.forEach((k,p)=>{this.d(k,p);const l=k.map.entries();let d=l.next();for(;!d.done;){const m=d.value[1],c=d.value[0];let u=this.a.get(c);if(u||(u=[],this.a.set(c,u)),u.length>0&&u[0].type===O.EnvironmentVariableMutatorType.Replace){d=l.next();continue}const h={extensionIdentifier:p,value:m.value,type:m.type,scope:m.scope,variable:m.variable,options:m.options};h.scope||delete h.scope,u.unshift(h),d=l.next()}})}async applyToProcessEnvironment(A,k,p){let l;D.$i&&(l={},Object.keys(A).forEach(d=>l[d.toLowerCase()]=d));for(const[d,m]of this.getVariableMap(k)){const c=D.$i&&l[d.toLowerCase()]||d;for(const u of m){const h=p?await p(u.value):u.value;if(u.options?.applyAtProcessCreation??!0)switch(u.type){case O.EnvironmentVariableMutatorType.Append:A[c]=(A[c]||"")+h;break;case O.EnvironmentVariableMutatorType.Prepend:A[c]=h+(A[c]||"");break;case O.EnvironmentVariableMutatorType.Replace:A[c]=h;break}if(u.options?.applyAtShellIntegration??!1){const g=`VSCODE_ENV_${r.get(u.type)}`;A[g]=(A[g]?A[g]+":":"")+d+"="+this.c(h)}}}}c(A){return A.replaceAll(":","\\x3a")}diff(A,k){const p=new Map,l=new Map,d=new Map;if(A.getVariableMap(k).forEach((m,c)=>{const u=this.getVariableMap(k).get(c),h=P(m,u);h&&p.set(c,h)}),this.getVariableMap(k).forEach((m,c)=>{const u=A.getVariableMap(k).get(c),h=P(m,u);h&&d.set(c,h)}),this.getVariableMap(k).forEach((m,c)=>{const u=A.getVariableMap(k).get(c),h=w(m,u);h&&l.set(c,h)}),!(p.size===0&&l.size===0&&d.size===0))return{added:p,changed:l,removed:d}}getVariableMap(A){const k=new Map;for(const p of this.a.values()){const l=p.filter(d=>I(d,A));l.length>0&&k.set(l[0].variable,l)}return k}getDescriptionMap(A){const k=new Map;for(const p of this.b.values()){const l=p.filter(d=>I(d,A,!0));for(const d of l)k.set(d.extensionIdentifier,d.description)}return k}d(A,k){if(!A.descriptionMap)return;const p=A.descriptionMap.entries();let l=p.next();for(;!l.done;){const d=l.value[1],m=l.value[0];let c=this.b.get(m);c||(c=[],this.b.set(m,c));const u={extensionIdentifier:k,scope:d.scope,description:d.description};u.scope||delete u.scope,c.push(u),l=p.next()}}}e.$0q=C;function I($,A,k=!1){return $.scope?!!($.scope.workspaceFolder&&A?.workspaceFolder&&$.scope.workspaceFolder.index===A.workspaceFolder.index):k?A===$.scope:!0}function P($,A){if(!A)return $;const k=new Set;A.forEach(l=>k.add(l.extensionIdentifier));const p=[];return $.forEach(l=>{k.has(l.extensionIdentifier)||p.push(l)}),p.length===0?void 0:p}function w($,A){if(!A)return;const k=new Map;A.forEach(l=>k.set(l.extensionIdentifier,l));const p=[];return $.forEach(l=>{const d=k.get(l.extensionIdentifier);d&&(l.type!==d.type||l.value!==d.value||l.scope?.workspaceFolder?.index!==d.scope?.workspaceFolder?.index)&&p.push(d)}),p.length===0?void 0:p}}),define(pe[88],be([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=e.$7q=e.$6q=e.$5q=e.$4q=void 0;function D(w){return[...w.entries()]}e.$4q=D;function O(w){return w?[...w.entries()]:[]}e.$5q=O;function r(w){return new Map(w)}e.$6q=r;function C(w){return new Map(w??[])}e.$7q=C;function I(w){return Array.from(w.entries()).map($=>[$[0],D($[1].map),O($[1].descriptionMap)])}e.$8q=I;function P(w){return new Map(w.map($=>[$[0],{map:r($[1]),descriptionMap:C($[2])}]))}e.$9q=P}),define(pe[248],be([1,0,14,20,5,2,12]),function(ce,e,D,O,r,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;let P=class extends C.$lb{constructor($,A){super(),this.h=A,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new r.$ec),this.onCreateRequest=this.g.event,this.b=$===void 0?15e3:$}createRequest($){return new Promise((A,k)=>{const p=++this.a;this.c.set(p,A),this.g.fire({requestId:p,...$});const l=new O.$oc;(0,D.$vg)(this.b,l.token).then(()=>k(`Request ${p} timed out (${this.b}ms)`)),this.f.set(p,[(0,C.$jb)(()=>l.cancel())])})}acceptReply($,A){const k=this.c.get($);k?(this.c.delete($),(0,C.$gb)(this.f.get($)||[]),this.f.delete($),k(A)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${$}`)}};e.$Uq=P,e.$Uq=P=Le([Ie(1,I.$Ri)],P)}),define(pe[89],be([1,0,6,66,35]),function(ce,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=e.$Pq=e.$Oq=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Nq=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Mq=void 0,e.$Mq=new O.$Oi("terminalTabFocusMode",!1,!0);var C;(function(v){v.DefaultProfile="terminal.integrated.defaultProfile.",v.Profiles="terminal.integrated.profiles."})(C||(e.TerminalSettingPrefix=C={}));var I;(function(v){v.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",v.AutomationProfileLinux="terminal.integrated.automationProfile.linux",v.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",v.AutomationProfileWindows="terminal.integrated.automationProfile.windows",v.ProfilesWindows="terminal.integrated.profiles.windows",v.ProfilesMacOs="terminal.integrated.profiles.osx",v.ProfilesLinux="terminal.integrated.profiles.linux",v.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",v.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",v.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",v.UseWslProfiles="terminal.integrated.useWslProfiles",v.TabsDefaultColor="terminal.integrated.tabs.defaultColor",v.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",v.TabsEnabled="terminal.integrated.tabs.enabled",v.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",v.TabsHideCondition="terminal.integrated.tabs.hideCondition",v.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",v.TabsShowActions="terminal.integrated.tabs.showActions",v.TabsLocation="terminal.integrated.tabs.location",v.TabsFocusMode="terminal.integrated.tabs.focusMode",v.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",v.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",v.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",v.CopyOnSelection="terminal.integrated.copyOnSelection",v.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",v.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",v.FontFamily="terminal.integrated.fontFamily",v.FontSize="terminal.integrated.fontSize",v.LetterSpacing="terminal.integrated.letterSpacing",v.LineHeight="terminal.integrated.lineHeight",v.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",v.TabStopWidth="terminal.integrated.tabStopWidth",v.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",v.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",v.BellDuration="terminal.integrated.bellDuration",v.FontWeight="terminal.integrated.fontWeight",v.FontWeightBold="terminal.integrated.fontWeightBold",v.CursorBlinking="terminal.integrated.cursorBlinking",v.CursorStyle="terminal.integrated.cursorStyle",v.CursorStyleInactive="terminal.integrated.cursorStyleInactive",v.CursorWidth="terminal.integrated.cursorWidth",v.Scrollback="terminal.integrated.scrollback",v.DetectLocale="terminal.integrated.detectLocale",v.DefaultLocation="terminal.integrated.defaultLocation",v.GpuAcceleration="terminal.integrated.gpuAcceleration",v.TerminalTitleSeparator="terminal.integrated.tabs.separator",v.TerminalTitle="terminal.integrated.tabs.title",v.TerminalDescription="terminal.integrated.tabs.description",v.RightClickBehavior="terminal.integrated.rightClickBehavior",v.Cwd="terminal.integrated.cwd",v.ConfirmOnExit="terminal.integrated.confirmOnExit",v.ConfirmOnKill="terminal.integrated.confirmOnKill",v.EnableBell="terminal.integrated.enableBell",v.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",v.AllowChords="terminal.integrated.allowChords",v.AllowMnemonics="terminal.integrated.allowMnemonics",v.TabFocusMode="terminal.integrated.tabFocusMode",v.EnvMacOs="terminal.integrated.env.osx",v.EnvLinux="terminal.integrated.env.linux",v.EnvWindows="terminal.integrated.env.windows",v.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",v.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",v.ShowExitAlert="terminal.integrated.showExitAlert",v.SplitCwd="terminal.integrated.splitCwd",v.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",v.WordSeparators="terminal.integrated.wordSeparators",v.EnableFileLinks="terminal.integrated.enableFileLinks",v.UnicodeVersion="terminal.integrated.unicodeVersion",v.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",v.LocalEchoEnabled="terminal.integrated.localEchoEnabled",v.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",v.LocalEchoStyle="terminal.integrated.localEchoStyle",v.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",v.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",v.HideOnStartup="terminal.integrated.hideOnStartup",v.CustomGlyphs="terminal.integrated.customGlyphs",v.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",v.InheritEnv="terminal.integrated.inheritEnv",v.ShowLinkHover="terminal.integrated.showLinkHover",v.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",v.AutoReplies="terminal.integrated.autoReplies",v.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",v.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",v.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",v.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",v.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",v.EnableImages="terminal.integrated.enableImages",v.SmoothScrolling="terminal.integrated.smoothScrolling",v.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",v.FocusAfterRun="terminal.integrated.focusAfterRun",v.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",v.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",v.DevMode="terminal.integrated.developer.devMode"})(I||(e.TerminalSettingId=I={}));var P;(function(v){v.PowerShell="pwsh",v.Bash="bash",v.Fish="fish",v.Sh="sh",v.Csh="csh",v.Ksh="ksh",v.Zsh="zsh"})(P||(e.PosixShellType=P={}));var w;(function(v){v.CommandPrompt="cmd",v.PowerShell="pwsh",v.Wsl="wsl",v.GitBash="gitbash"})(w||(e.WindowsShellType=w={}));var $;(function(v){v[v.Api=0]="Api",v[v.Process=1]="Process",v[v.Sequence=2]="Sequence",v[v.Config=3]="Config"})($||(e.TitleEventSource=$={}));var A;(function(v){v.LocalPty="localPty",v.PtyHost="ptyHost",v.PtyHostWindow="ptyHostWindow",v.Logger="logger",v.Heartbeat="heartbeat"})(A||(e.TerminalIpcChannels=A={}));var k;(function(v){v.Cwd="cwd",v.InitialCwd="initialCwd",v.FixedDimensions="fixedDimensions",v.Title="title",v.ShellType="shellType",v.HasChildProcesses="hasChildProcesses",v.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",v.OverrideDimensions="overrideDimensions",v.FailedShellIntegrationActivation="failedShellIntegrationActivation",v.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(k||(e.ProcessPropertyType=k={})),e.$Nq=(0,D.$ph)("ptyService");var p;(function(v){v[v.BeatInterval=5e3]="BeatInterval",v[v.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",v[v.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",v[v.SecondWaitMultiplier=1]="SecondWaitMultiplier",v[v.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p||(e.HeartbeatConstants=p={}));var l;(function(v){v[v.Panel=1]="Panel",v[v.Editor=2]="Editor"})(l||(e.TerminalLocation=l={}));var d;(function(v){v.TerminalView="view",v.Editor="editor"})(d||(e.TerminalLocationString=d={}));var m;(function(v){v[v.GraceTime=6e4]="GraceTime",v[v.ShortGraceTime=6e3]="ShortGraceTime"})(m||(e.LocalReconnectConstants=m={}));var c;(function(v){v[v.HighWatermarkChars=1e5]="HighWatermarkChars",v[v.LowWatermarkChars=5e3]="LowWatermarkChars",v[v.CharCountAckSize=5e3]="CharCountAckSize"})(c||(e.FlowControlConstants=c={}));var u;(function(v){v.GitBash="Git Bash",v.Pwsh="PowerShell"})(u||(e.ProfileSource=u={}));var h;(function(v){v[v.Off=0]="Off",v[v.FinalTerm=1]="FinalTerm",v[v.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var g;(function(v){v[v.Unknown=0]="Unknown",v[v.Shutdown=1]="Shutdown",v[v.Process=2]="Process",v[v.User=3]="User",v[v.Extension=4]="Extension"})(g||(e.TerminalExitReason=g={})),e.$Oq={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const s=this.b(t.remoteAuthority);if(this.a.has(s))throw new Error(`A terminal backend with remote authority '${s}' was already registered.`);this.a.set(s,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}r.$Um.add(e.$Oq.Backend,new E),e.$Pq=(0,D.$ph)("localPtyService"),e.$Qq=(0,D.$ph)("terminalLogService")}),define(pe[249],be([1,0,3]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=e.$AM=e.$zM=void 0;function O(I){let P=I;P.includes("\\")&&(P=P.replace(/\\/g,"\\\\"));const w=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return P=P.replace(w,""),`'${P}'`}e.$zM=O;function r(I,P,w){if(!I)return"";if(!P)return I;P.match(/[\/\\]$/)&&(P=P.slice(0,P.length-1));const $=I.replace(/\\/g,"/").toLowerCase(),A=P.replace(/\\/g,"/").toLowerCase();return $.includes(A)?`~${w}${I.slice(P.length+1)}`:I}e.$AM=r;function C(I){return I.match(/^['"].*['"]$/)&&(I=I.substring(1,I.length-1)),D.OS===1&&I&&I[1]===":"?I[0].toUpperCase()+I.substring(1):I}e.$BM=C}),define(pe[250],be([1,0,49,4,195,99]),function(ce,e,D,O,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=e.$Xq=e.$Wq=e.$Vq=void 0;function I(p,l){const d=[{name:null,description:(0,r.localize)(0,null)}];return d.push(...p.map(m=>({name:m.profileName,description:P(m)}))),l&&d.push(...l.map(m=>({name:m.title,description:w(m)}))),{values:d.map(m=>m.name),markdownDescriptions:d.map(m=>m.description)}}e.$Vq=I;function P(p){let l=`$(${C.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:D.$Cj.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?l+=`
- args: "${p.args}"`:l+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(l+=`
- overrideName: ${p.overrideName}`),p.color&&(l+=`
- color: ${p.color}`),p.env&&(l+=`
- env: ${JSON.stringify(p.env)}`),l}function w(p){return`$(${C.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:D.$Cj.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function $(p,l){if(!p&&!l)return!0;if(typeof p=="string"&&typeof l=="string")return p===l;if(Array.isArray(p)&&Array.isArray(l)){if(p.length!==l.length)return!1;for(let d=0;d<p.length;d++)if(p[d]!==l[d])return!1;return!0}return!1}e.$Wq=$;function A(p,l){if(!p&&!l)return!0;if(!p||!l)return!1;if(C.ThemeIcon.isThemeIcon(p)&&C.ThemeIcon.isThemeIcon(l))return p.id===l.id&&p.color===l.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof l=="object"&&"light"in l&&"dark"in l){const d=p,m=l;if((O.URI.isUri(d.light)||k(d.light))&&(O.URI.isUri(d.dark)||k(d.dark))&&(O.URI.isUri(m.light)||k(m.light))&&(O.URI.isUri(m.dark)||k(m.dark)))return d.light.path===m.light.path&&d.dark.path===m.dark.path}if(O.URI.isUri(p)&&O.URI.isUri(l)||k(p)||k(l)){const d=p,m=l;return d.path===m.path&&d.scheme===m.scheme}return!1}e.$Xq=A;function k(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.$Yq=k}),define(pe[251],be([1,0,49,3,194,55,35,250]),function(ce,e,D,O,r,C,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=e.$2q=e.$1q=e.$Zq=void 0,e.$Zq={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$1q={type:"string",enum:Array.from((0,D.$Bj)(),c=>c.id),markdownEnumDescriptions:Array.from((0,D.$Bj)(),c=>`$(${c.id})`)};const w={args:{description:(0,r.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,r.localize)(1,null),type:"boolean"},icon:{description:(0,r.localize)(2,null),...e.$1q},color:{description:(0,r.localize)(3,null),...e.$Zq},env:{markdownDescription:(0,r.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},$={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(5,null),type:["string","array"],items:{type:"string"}},...w}},A={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(6,null),type:["string"],items:{type:"string"}},...w}};function k(c){const u=c===2?"linux":c===1?"osx":"windows";return(0,r.localize)(7,null,(0,O.$h)(c),'```json\n"terminal.integrated.profile.'+u+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const p={id:"terminal",order:100,title:(0,r.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},A],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},A],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},A],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:k(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,r.localize)(12,null),enum:["PowerShell","Git Bash"]},...w}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(13,null),type:"string"},id:{description:(0,r.localize)(14,null),type:"string"},title:{description:(0,r.localize)(15,null),type:"string"},...w}},{type:"null"},$]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:k(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(16,null),type:"string"},id:{description:(0,r.localize)(17,null),type:"string"},title:{description:(0,r.localize)(18,null),type:"string"},...w}},{type:"null"},$]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:k(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(19,null),type:"string"},id:{description:(0,r.localize)(20,null),type:"string"},title:{description:(0,r.localize)(21,null),type:"string"},...w}},{type:"null"},$]}},["terminal.integrated.useWslProfiles"]:{description:(0,r.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,r.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,r.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,r.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,r.localize)(26,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function l(){I.$Um.as(C.$Zm.Configuration).registerConfiguration(p),m()}e.$2q=l;let d;function m(c,u){const h=I.$Um.as(C.$Zm.Configuration);let g;c&&(g=(0,P.$Vq)(c?.profiles,u));const E=d;d={id:"terminal",order:100,title:(0,r.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(28,null),type:["string","null"],default:null,enum:c?.os===3?g?.values:void 0,markdownEnumDescriptions:c?.os===3?g?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(29,null),type:["string","null"],default:null,enum:c?.os===2?g?.values:void 0,markdownEnumDescriptions:c?.os===2?g?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(30,null),type:["string","null"],default:null,enum:c?.os===1?g?.values:void 0,markdownEnumDescriptions:c?.os===1?g?.markdownDescriptions:void 0}}},h.updateConfigurations({add:[d],remove:E?[E]:[]})}e.$3q=m}),define(pe[252],be([1,0,2,13,108,25,109]),function(ce,e,D,O,r,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=void 0;let P=class extends D.$lb{constructor($,A){super(),this.a=$,this.b=A}start(){const $={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.fsPath],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},A=(0,I.$Zl)(this.b.args,this.b.isBuilt);A&&(A.break&&A.port?$.debugBrk=A.port:!A.break&&A.port&&($.debug=A.port));const k=new r.$Jp(O.$1e.asFileUri("bootstrap-fork").fsPath,$),p=new D.$kb;return p.add(k),{client:k,store:p,onDidProcessExit:k.onDidProcessExit}}};e.$eN=P,e.$eN=P=Le([Ie(1,C.$wh)],P)}),define(pe[253],be([1,0,29,13,22,7,3,30,17,10,21,122,88,123]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=e.$$q=void 0;function d(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.$$q=d;async function m(i,n,o,f=P.env,b=A.Promises.exists){if(C.$7c(i))return await b(i)?i:void 0;if(n===void 0&&(n=P.cwd()),C.$$c(i)!=="."){const j=C.$8c(n,i);return await b(j)?j:void 0}const S=(0,r.$Pm)(f,"PATH");if(o===void 0&&(0,$.$ie)(S)&&(o=S.split(C.$fd)),o===void 0||o.length===0){const j=C.$8c(n,i);return await b(j)?j:void 0}for(const j of o){let Q;if(C.$7c(j)?Q=C.$8c(j,i):Q=C.$8c(n,j,i),await b(Q))return Q;if(I.$i){let le=Q+".com";if(await b(le)||(le=Q+".exe",await b(le)))return le}}const L=C.$8c(n,i);return await b(L)?L:void 0}e.$_q=m;function c(i,n,o,f,b){const y=I.$i&&(!n.windowsEnableConpty||d()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||y)return;const S=i.args,L=P.$2c==="win32"?C.$_c(i.executable).toLowerCase():C.$_c(i.executable),j=C.$$c(O.$1e.asFileUri("").fsPath);let Q;const le={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(le.VSCODE_NONCE=n.shellIntegration.nonce),I.$i){if(L==="pwsh.exe"||L==="powershell.exe")return!S||s(S)?Q=g.get(h.WindowsPwsh):t(S)&&(Q=g.get(h.WindowsPwshLogin)),Q?(Q=[...Q],Q[Q.length-1]=(0,w.$md)(Q[Q.length-1],j,""),{newArgs:Q,envMixin:le}):void 0;f.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(L){case"bash":return!S||S.length===0?Q=g.get(h.Bash):a(S)&&(le.VSCODE_SHELL_LOGIN="1",u(n,le),Q=g.get(h.Bash)),Q?(Q=[...Q],Q[Q.length-1]=(0,w.$md)(Q[Q.length-1],j),{newArgs:Q,envMixin:le}):void 0;case"fish":{const Y=o?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ee=C.$8c(j,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return le.XDG_DATA_DIRS=`${Y}:${ee}`,u(n,le),{newArgs:void 0,envMixin:le}}case"pwsh":return!S||s(S)?Q=g.get(h.Pwsh):t(S)&&(Q=g.get(h.PwshLogin)),Q?(Q=[...Q],Q[Q.length-1]=(0,w.$md)(Q[Q.length-1],j,""),{newArgs:Q,envMixin:le}):void 0;case"zsh":{if(!S||S.length===0?Q=g.get(h.Zsh):a(S)?(Q=g.get(h.ZshLogin),u(n,le)):(S===g.get(h.Zsh)||S===g.get(h.ZshLogin))&&(Q=S),!Q)return;Q=[...Q],Q[Q.length-1]=(0,w.$md)(Q[Q.length-1],j);let Y;try{Y=D.userInfo().username}catch{Y="unknown"}const ee=C.$8c(D.tmpdir(),`${Y}-${b.applicationName}-zsh`);le.ZDOTDIR=ee;const ue=o?.ZDOTDIR??D.homedir()??"~";le.USER_ZDOTDIR=ue;const X=[];return X.push({source:C.$8c(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:C.$8c(ee,".zshrc")}),X.push({source:C.$8c(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:C.$8c(ee,".zprofile")}),X.push({source:C.$8c(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:C.$8c(ee,".zshenv")}),X.push({source:C.$8c(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:C.$8c(ee,".zlogin")}),{newArgs:Q,envMixin:le,filesToCopy:X}}}f.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.$ar=c;function u(i,n){if(I.$j&&i.environmentVariableCollections){const o=(0,p.$9q)(i.environmentVariableCollections),b=new l.$0q(o).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),y=[];if(b)for(const S of b)S.type===k.EnvironmentVariableMutatorType.Prepend&&y.push(S.value);y.length>0&&(n.VSCODE_PATH_PREFIX=y.join(""))}}var h;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(h||(h={}));const g=new Map;g.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),g.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),g.set(h.Zsh,["-i"]),g.set(h.ZshLogin,["-il"]),g.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],v=["-nol","-nologo"];function t(i){return typeof i=="string"?E.includes(i.toLowerCase()):i.length===1&&E.includes(i[0].toLowerCase())||i.length===2&&(E.includes(i[0].toLowerCase())||E.includes(i[1].toLowerCase()))&&(v.includes(i[0].toLowerCase())||v.includes(i[1].toLowerCase()))}function s(i){return typeof i=="string"?v.includes(i.toLowerCase()):i.length===0||i?.length===1&&v.includes(i[0].toLowerCase())}function a(i){return i==="string"&&E.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&E.includes(i[0].toLowerCase())}}),define(pe[254],be([1,0,52,49,7,3,10,21,103,253,76]),function(ce,e,D,O,r,C,I,P,w,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;let k,p=!0;function l(n,o,f,b,y=process.env,S,L,j,Q){return S=S||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},C.$i?d(f,S,y,L,b.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:b.getValue("terminal.integrated.profiles.windows"),typeof o=="string"?o:b.getValue("terminal.integrated.defaultProfile.windows"),Q,j):s(S,L,f,n&&typeof n=="object"?{...n}:b.getValue(C.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof o=="string"?o:b.getValue(C.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),Q,j,y)}e.$br=l;async function d(n,o,f,b,y,S,L,j,Q){const le=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),Y=`${process.env.windir}\\${le?"Sysnative":"System32"}`;let ee=!1;(0,$.$$q)()>=16299&&(ee=!0),await h(j);const ue=new Map;if(n){ue.set("PowerShell",{source:"PowerShell",icon:O.$Cj.terminalPowershell,isAutoDetected:!0}),ue.set("Windows PowerShell",{path:`${Y}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:O.$Cj.terminalPowershell,isAutoDetected:!0}),ue.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ue.set("Command Prompt",{path:`${Y}\\cmd.exe`,icon:O.$Cj.terminalCmd,isAutoDetected:!0}),ue.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ue.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:O.$Cj.terminalBash,isAutoDetected:!0});const he=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ue.set("Cmder",{path:`${Y}\\cmd.exe`,args:["/K",he],requiresPath:process.env.CMDER_ROOT?he:{path:he,isUnsafe:!0},isAutoDetected:!0})}a(S,ue);const X=await m(ue.entries(),L,o,f,b,Q);if(n&&y)try{const he=await v(`${Y}\\${ee?"wsl":"bash"}.exe`,L);for(const x of he)(!S||!(x.profileName in S))&&X.push(x)}catch{p&&(b?.info("WSL is not installed, so could not detect WSL profiles"),p=!1)}return X}async function m(n,o,f,b=process.env,y,S){const L=[];for(const[j,Q]of n)L.push(c(j,Q,o,f,b,y,S));return(await Promise.all(L)).filter(j=>!!j)}async function c(n,o,f,b,y=process.env,S,L){if(o===null)return;let j,Q,le;if("source"in o&&!("path"in o)){const X=k?.get(o.source);if(!X)return;j=X.paths,Q=o.args||X.args,o.icon?le=u(o.icon):X.icon&&(le=X.icon)}else j=Array.isArray(o.path)?o.path:[o.path],Q=C.$i||Array.isArray(o.args)?o.args:void 0,le=u(o.icon);let Y;if(L){const X=j.map(x=>typeof x=="string"?x:x.path),he=await L(X);Y=new Array(j.length);for(let x=0;x<j.length;x++)typeof j[x]=="string"?Y[x]=he[x]:Y[x]={path:he[x],isUnsafe:!0}}else Y=j.slice();let ee;if(o.requiresPath){let X;if((0,I.$ie)(o.requiresPath)?X=o.requiresPath:(X=o.requiresPath.path,o.requiresPath.isUnsafe&&(ee=X)),!await b.existsFile(X))return}const ue=await i(n,f,Y,b,y,Q,o.env,o.overrideName,o.isAutoDetected,ee);if(!ue){S?.debug("Terminal profile not validated",n,j);return}return ue.isAutoDetected=o.isAutoDetected,ue.icon=le,ue.color=o.color,ue}function u(n){return typeof n=="string"?{id:n}:n}async function h(n){if(k&&!n)return;const[o,f]=await Promise.all([g(),n||E()]);k=new Map,k.set("Git Bash",{profileName:"Git Bash",paths:o,args:["--login","-i"]}),k.set("PowerShell",{profileName:"PowerShell",paths:f,icon:O.$Cj.terminalPowershell})}async function g(){const n=new Set,o=await(0,$.$_q)("git.exe");if(o){const y=(0,A.dirname)(o);n.add((0,A.resolve)(y,"../.."))}function f(y,S){S&&y.add(S)}f(n,process.env.ProgramW6432),f(n,process.env.ProgramFiles),f(n,process.env["ProgramFiles(X86)"]),f(n,`${process.env.LocalAppData}\\Program`);const b=[];for(const y of n)b.push(`${y}\\Git\\bin\\bash.exe`,`${y}\\Git\\usr\\bin\\bash.exe`,`${y}\\usr\\bin\\bash.exe`);return b.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),b}async function E(){const n=[];for await(const o of(0,w.$dl)())n.push(o.exePath);return n}async function v(n,o){const f=[],b=await new Promise((L,j)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(Q,le)=>{if(Q)return j("Problem occurred when getting wsl distros");L(le)})});if(!b)return[];const y=new RegExp(/[\r?\n]/),S=b.split(y).filter(L=>L.trim().length>0&&L!=="");for(const L of S){if(L===""||L.startsWith("docker-desktop"))continue;const j=`${L} (WSL)`,Q={profileName:j,path:n,args:["-d",`${L}`],isDefault:j===o,icon:t(L),isAutoDetected:!1};f.push(Q)}return f}function t(n){return n.includes("Ubuntu")?O.$Cj.terminalUbuntu:n.includes("Debian")?O.$Cj.terminalDebian:O.$Cj.terminalLinux}async function s(n,o,f,b,y,S,L,j){const Q=new Map;if(f){const le=(await n.readFile("/etc/shells")).toString(),Y=(S||le.split(`
`)).map(ue=>{const X=ue.indexOf("#");return X===-1?ue:ue.substring(0,X)}).filter(ue=>ue.trim().length>0),ee=new Map;for(const ue of Y){let X=(0,r.$_c)(ue),he=ee.get(X)||0;he++,he>1&&(X=`${X} (${he})`),ee.set(X,he),Q.set(X,{path:ue,isAutoDetected:!0})}}return a(b,Q),await m(Q.entries(),y,n,j,o,L)}function a(n,o){if(n)for(const[f,b]of Object.entries(n))b===null||typeof b!="object"||!("path"in b)&&!("source"in b)?o.delete(f):(b.icon=b.icon||o.get(f)?.icon,o.set(f,b))}async function i(n,o,f,b,y,S,L,j,Q,le){if(f.length===0)return Promise.resolve(void 0);const Y=f.shift();if(Y==="")return i(n,o,f,b,y,S,L,j,Q);const ee=typeof Y!="string"&&Y.isUnsafe,ue=typeof Y=="string"?Y:Y.path,X={profileName:n,path:ue,args:S,env:L,overrideName:j,isAutoDetected:Q,isDefault:n===o,isUnsafePath:ee,requiresUnsafePath:le};if((0,r.$_c)(ue)===ue){const x=y.PATH?y.PATH.split(r.$fd):void 0,se=await(0,$.$_q)(ue,void 0,x,void 0,b.existsFile);return se?(X.path=se,X.isFromPath=!0,X):i(n,o,f,b,y,S)}return await b.existsFile((0,r.$6c)(ue))?X:i(n,o,f,b,y,S,L,j,Q)}}),define(pe[255],be([1,0,5,2,3,43,24,12,113,86,248,89,251,254,106,58]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0;var c;(function(h){h[h.MaxRestarts=5]="MaxRestarts"})(c||(c={}));let u=class extends O.$lb{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.P()}constructor(g,E,v,t){super(),this.H=g,this.I=E,this.J=v,this.L=t,this.j=!1,this.k=0,this.l=!0,this.m=!1,this.r=this.B(new D.$ec),this.onPtyHostExit=this.r.event,this.s=this.B(new D.$ec),this.onPtyHostStart=this.s.event,this.t=this.B(new D.$ec),this.onPtyHostUnresponsive=this.t.event,this.u=this.B(new D.$ec),this.onPtyHostResponsive=this.u.event,this.v=this.B(new D.$ec),this.onPtyHostRequestResolveVariables=this.v.event,this.w=this.B(new D.$ec),this.onProcessData=this.w.event,this.y=this.B(new D.$ec),this.onProcessReady=this.y.event,this.z=this.B(new D.$ec),this.onProcessReplay=this.z.event,this.C=this.B(new D.$ec),this.onProcessOrphanQuestion=this.C.event,this.D=this.B(new D.$ec),this.onDidRequestDetach=this.D.event,this.F=this.B(new D.$ec),this.onDidChangeProperty=this.F.event,this.G=this.B(new D.$ec),this.onProcessExit=this.G.event,(0,p.$2q)(),this.B(this.H),this.B((0,O.$jb)(()=>this.Q())),this.i=this.B(new A.$Uq(void 0,this.J)),this.i.onCreateRequest(this.v.fire,this.v),this.H.onRequestConnection&&D.Event.once(this.H.onRequestConnection)(()=>this.h()),this.H.onWillShutdown?.(()=>this.j=!0)}get M(){return this.I.getValue("terminal.integrated.ignoreProcessNames")}async N(){return this.g?.refreshIgnoreProcessNames?.(this.M)}async O(){if(r.$i)return process.env;try{return await(0,$.$zl)(this.I,this.J,{_:[]},process.env)}catch(g){return this.J.error("ptyHost was unable to resolve shell environment",g),{}}}P(){const g=this.H.start(),E=g.client;this.J.getLevel()===P.LogLevel.Trace&&this.J.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),C.ProxyChannel.toService(E.getChannel(k.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.R()),this.R(!0),this.B(g.onDidProcessExit(s=>{this.r.fire(s.code),!this.j&&!this.m&&(this.k<=c.MaxRestarts?(this.J.error(`ptyHost terminated unexpectedly with code ${s.code}`),this.k++,this.restartPtyHost()):this.J.error(`ptyHost terminated unexpectedly with code ${s.code}, giving up`))}));const t=C.ProxyChannel.toService(E.getChannel(k.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(s=>this.w.fire(s))),this.B(t.onProcessReady(s=>this.y.fire(s))),this.B(t.onProcessExit(s=>this.G.fire(s))),this.B(t.onDidChangeProperty(s=>this.F.fire(s))),this.B(t.onProcessReplay(s=>this.z.fire(s))),this.B(t.onProcessOrphanQuestion(s=>this.C.fire(s))),this.B(t.onDidRequestDetach(s=>this.D.fire(s))),this.B(new w.$Tq(this.L,E.getChannel(k.TerminalIpcChannels.Logger))),this.a=g,this.b=t,this.s.fire(),this.B(this.I.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.N()})),this.N(),[g,t]}dispose(){this.m=!0,super.dispose()}async createProcess(g,E,v,t,s,a,i,n,o,f,b){const y=setTimeout(()=>this.W(),k.HeartbeatConstants.CreateProcessTimeout),S=await this.f.createProcess(g,E,v,t,s,a,i,n,o,f,b);return clearTimeout(y),S}updateTitle(g,E,v){return this.f.updateTitle(g,E,v)}updateIcon(g,E,v,t){return this.f.updateIcon(g,E,v,t)}attachToProcess(g){return this.f.attachToProcess(g)}detachFromProcess(g,E){return this.f.detachFromProcess(g,E)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(g){return this.f.start(g)}shutdown(g,E){return this.f.shutdown(g,E)}input(g,E){return this.f.input(g,E)}processBinary(g,E){return this.f.processBinary(g,E)}resize(g,E,v){return this.f.resize(g,E,v)}clearBuffer(g){return this.f.clearBuffer(g)}acknowledgeDataEvent(g,E){return this.f.acknowledgeDataEvent(g,E)}setUnicodeVersion(g,E){return this.f.setUnicodeVersion(g,E)}getInitialCwd(g){return this.f.getInitialCwd(g)}getCwd(g){return this.f.getCwd(g)}async getLatency(){const g=new m.$ac,E=await this.f.getLatency();return g.stop(),[{label:"ptyhostservice<->ptyhost",latency:g.elapsed()},...E]}orphanQuestionReply(g){return this.f.orphanQuestionReply(g)}installAutoReply(g,E){return this.f.installAutoReply(g,E)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(g){return this.f.uninstallAutoReply(g)}getDefaultSystemShell(g){return this.g?.getDefaultSystemShell(g)??(0,d.$jl)(g??r.OS,process.env)}async getProfiles(g,E,v,t=!1){const s=await this.O();return(0,l.$br)(E,v,t,this.I,s,void 0,this.J,this.Y.bind(this,g))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(g,E){return this.f.getWslPath(g,E)}getRevivedPtyNewId(g,E){return this.f.getRevivedPtyNewId(g,E)}setTerminalLayoutInfo(g){return this.f.setTerminalLayoutInfo(g)}async getTerminalLayoutInfo(g){return this.g?.getTerminalLayoutInfo(g)}async requestDetachInstance(g,E){return this.f.requestDetachInstance(g,E)}async acceptDetachInstanceReply(g,E){return this.f.acceptDetachInstanceReply(g,E)}async freePortKillProcess(g){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(g)}async serializeTerminalState(g){return this.f.serializeTerminalState(g)}async reviveTerminalProcesses(g,E,v){return this.f.reviveTerminalProcesses(g,E,v)}async refreshProperty(g,E){return this.f.refreshProperty(g,E)}async updateProperty(g,E,v){return this.f.updateProperty(g,E,v)}async restartPtyHost(){this.Q(),this.l=!0,this.P()}Q(){this.f.shutdownAll(),this.c.store.dispose()}R(g){this.X(),this.n=setTimeout(()=>this.S(),g?k.HeartbeatConstants.ConnectingBeatInterval:k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier),this.l||(this.l=!0,this.u.fire())}S(){this.J.warn(`No ptyHost heartbeat after ${k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.n=void 0,this.p=setTimeout(()=>this.U(),k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.SecondWaitMultiplier)}U(){this.J.error(`No ptyHost heartbeat after ${(k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier+k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.p=void 0,this.l&&(this.l=!1,this.t.fire())}W(){this.X(),this.J.error(`No ptyHost response to createProcess after ${k.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.l&&(this.l=!1,this.t.fire())}X(){this.n&&(clearTimeout(this.n),this.n=void 0),this.p&&(clearTimeout(this.p),this.p=void 0)}Y(g,E){return this.i.createRequest({workspaceId:g,originalText:E})}async acceptPtyHostResolvedVariables(g,E){this.i.acceptReply(g,E)}};e.$cr=u,e.$cr=u=Le([Ie(1,I.$Vh),Ie(2,P.$Ri),Ie(3,P.$Si)],u)}),define(pe[34],be([1,0,6]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=void 0,e.$pk=(0,D.$ph)("IUriIdentityService")}),define(pe[124],be([1,0,34,213,16,19,144,5,2]),function(ce,e,D,O,r,C,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class ${static{this._clock=0}constructor(p){this.uri=p,this.time=$._clock++}touch(){return this.time=$._clock++,this}}let A=class{constructor(p){this.g=p,this.c=new w.$kb,this.f=2**16;const l=new Map,d=m=>{let c=l.get(m.scheme);return c===void 0&&(c=p.hasProvider(m)&&!this.g.hasCapability(m,1024),l.set(m.scheme,c)),c};this.c.add(P.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(m=>{l.delete(m.scheme)})),this.extUri=new C.$Xf(d),this.d=new I.$fr((m,c)=>this.extUri.compare(m,c,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,C.$0f)(p));const l=this.d.get(p);return l?l.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new $(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((d,m)=>d[1].time<m[1].time?1:d[1].time>m[1].time?-1:0);$._clock=0,this.d.clear();const l=this.f*.5;for(let d=0;d<l;d++)this.d.set(p[d][0],p[d][1].touch())}};e.$gr=A,e.$gr=A=Le([Ie(0,r.$Sj)],A),(0,O.$dr)(D.$pk,A,1)}),define(pe[90],be([1,0,197,7,61,19,4,6,13]),function(ce,e,D,O,r,C,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.WorkbenchState=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0,e.$yh=(0,P.$ph)("contextService");function $(i){const n=i;return typeof n?.id=="string"&&I.URI.isUri(n.uri)}e.$zh=$;function A(i){return typeof i?.id=="string"&&!$(i)&&!p(i)}e.$Ah=A,e.$Bh={id:"ext-dev"},e.$Ch={id:"empty-window"};function k(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,O.$_c)(i)}:n?e.$Bh:e.$Ch;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.$Dh=k;function p(i){const n=i;return typeof n?.id=="string"&&I.URI.isUri(n.configPath)}e.$Eh=p;function l(i){const n=i;if(n?.uri)return{id:n.id,uri:I.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:I.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.$Fh=l;var d;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function m(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$Gh=m;function c(i){const n=i;return!!(n&&typeof n=="object"&&I.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$Hh=c;class u{constructor(n,o,f,b,y){this.h=n,this.j=f,this.k=b,this.l=y,this.c=r.$vh.forUris(this.l,()=>!0),this.folders=o}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=r.$vh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ih=u;class h{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,C.$9f)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Jh=h;function g(i){return new h({uri:i,index:0,name:(0,C.$5f)(i)},{uri:i.toString()})}e.$Kh=g,e.$Lh="code-workspace",e.$Mh=`.${e.$Lh}`,e.$Nh=[{name:(0,D.localize)(0,null),extensions:[e.$Lh]}],e.$Oh="workspace.json";function E(i,n){return C.$Zf.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$Ph=E;function v(i){let n;return I.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===w.Schemas.tmp}e.$Qh=v,e.$Rh="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$Rh}e.$Sh=t;function s(i,n){return!E(i,n)&&!v(i)}e.$Th=s;function a(i){return(typeof i=="string"?(0,O.$ad)(i):(0,C.$7f)(i))===e.$Mh}e.$Uh=a}),define(pe[33],be([1,0,59,5,2,19,4,196,25,16,6,12,90,27,34,14,23,17,10]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l,d,m,c,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.ProfileResourceType=void 0;var g;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(g||(e.ProfileResourceType=g={}));function E(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&I.URI.isUri(n.location)&&I.URI.isUri(n.globalStorageHome)&&I.URI.isUri(n.settingsResource)&&I.URI.isUri(n.keybindingsResource)&&I.URI.isUri(n.tasksResource)&&I.URI.isUri(n.snippetsHome)&&I.URI.isUri(n.extensionsResource))}e.$qk=E,e.$rk=(0,A.$ph)("IUserDataProfilesService");function v(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:I.URI.revive(i.location).with({scheme:n}),globalStorageHome:I.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:I.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:I.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:I.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:I.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:I.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:I.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$sk=v;function t(i,n,o,f,b,y){return{id:i,name:n,location:o,isDefault:!1,shortName:b?.shortName,globalStorageHome:y&&b?.useDefaultFlags?.globalState?y.globalStorageHome:(0,C.$9f)(o,"globalStorage"),settingsResource:y&&b?.useDefaultFlags?.settings?y.settingsResource:(0,C.$9f)(o,"settings.json"),keybindingsResource:y&&b?.useDefaultFlags?.keybindings?y.keybindingsResource:(0,C.$9f)(o,"keybindings.json"),tasksResource:y&&b?.useDefaultFlags?.tasks?y.tasksResource:(0,C.$9f)(o,"tasks.json"),snippetsHome:y&&b?.useDefaultFlags?.snippets?y.snippetsHome:(0,C.$9f)(o,"snippets"),extensionsResource:y&&b?.useDefaultFlags?.extensions?y.extensionsResource:(0,C.$9f)(o,"extensions.json"),cacheHome:(0,C.$9f)(f,i),useDefaultFlags:b?.useDefaultFlags,isTransient:b?.transient}}e.$tk=t;let s=class extends r.$lb{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(n,o,f,b){super(),this.n=n,this.r=o,this.s=f,this.t=b,this.f=!0,this.h=this.B(new O.$ec),this.onDidChangeProfiles=this.h.event,this.i=this.B(new O.$ec),this.onWillCreateProfile=this.i.event,this.j=this.B(new O.$ec),this.onWillRemoveProfile=this.j.event,this.k=this.B(new O.$ec),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new l.$ni,emptyWindows:new Map},this.profilesHome=(0,C.$9f)(this.n.userRoamingDataHome,"profiles"),this.g=(0,C.$9f)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(n){this.f!==n&&(this.u=void 0,this.f=n)}isEnabled(){return this.f}get v(){if(!this.u){const n=this.w(),o=[n];if(this.f)try{for(const y of this.J()){if(!y.name||!(0,h.$ie)(y.name)||!y.location){this.t.warn("Skipping the invalid stored profile",y.location||y.name);continue}o.push(t((0,C.$6f)(y.location),y.name,y.location,this.g,{shortName:y.shortName,useDefaultFlags:y.useDefaultFlags},n))}}catch(y){this.t.error(y)}const f=new l.$ni,b=new Map;if(o.length)try{const y=this.M();if(y.workspaces)for(const[S,L]of Object.entries(y.workspaces)){const j=I.URI.parse(S),Q=o.find(le=>le.id===L);Q&&f.set(j,Q)}if(y.emptyWindows)for(const[S,L]of Object.entries(y.emptyWindows)){const j=o.find(Q=>Q.id===L);j&&b.set(S,j)}}catch(y){this.t.error(y)}this.u={profiles:o,workspaces:f,emptyWindows:b}}return this.u}w(){const n=t("__default__profile__",(0,P.localize)(0,null),this.n.userRoamingDataHome,this.g);return{...n,extensionsResource:this.O()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",f=new RegExp(`${(0,u.$pd)(o)}\\s(\\d+)`);let b=0;for(const S of this.profiles){const L=f.exec(S.name),j=L?parseInt(L[1]):0;b=j>b?j:b}const y=`${o} ${b+1}`;return this.createProfile((0,D.$di)((0,c.$3e)()).toString(16),y,{transient:!0},n)}async createNamedProfile(n,o,f){return this.createProfile((0,D.$di)((0,c.$3e)()).toString(16),n,o,f)}async createProfile(n,o,f,b){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=await this.y(n,o,f);return b&&await this.setProfileForWorkspace(b,y),y}async y(n,o,f){if(!(0,h.$ie)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let b=this.l.get(o);return b||(b=(async()=>{try{const y=this.profiles.find(j=>j.name===o||j.id===n);if(y)return y;const S=t(n,o,(0,C.$9f)(this.profilesHome,n),this.g,f,this.defaultProfile);await this.r.createFolder(S.location);const L=[];return this.i.fire({profile:S,join(j){L.push(j)}}),await m.Promises.settled(L),this.D([S],[],[]),S}finally{this.l.delete(o)}})(),this.l.set(o,b)),b}async updateProfile(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let f=this.profiles.find(b=>b.id===n.id);if(!f)throw new Error(`Profile '${n.name}' does not exist`);return f=t(f.id,o.name??f.name,f.location,this.g,{shortName:o.shortName??f.shortName,transient:o.transient??f.isTransient,useDefaultFlags:o.useDefaultFlags??f.useDefaultFlags},this.defaultProfile),this.D([],[],[f]),f}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(b=>b.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const f=[];this.j.fire({profile:o,join(b){f.push(b)}});try{await Promise.allSettled(f)}catch(b){this.t.error(b)}for(const b of[...this.v.emptyWindows.keys()])o.id===this.v.emptyWindows.get(b)?.id&&this.v.emptyWindows.delete(b);for(const b of[...this.v.workspaces.keys()])o.id===this.v.workspaces.get(b)?.id&&this.v.workspaces.delete(b);this.H(),this.D([],[o],[]);try{await this.r.del(o.cacheHome,{recursive:!0})}catch(b){(0,$.$9j)(b)!==1&&this.t.error(b)}}async setProfileForWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const f=this.profiles.find(b=>b.id===o.id);if(!f)throw new Error(`Profile '${o.name}' does not exist`);this.G(n,f)}unsetWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(n,void 0,o)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const n=await this.r.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(f=>!this.s.extUri.isEqual(f.location,o.resource))).map(o=>this.r.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.m.profiles.filter(o=>!this.C(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.z(n);return I.URI.isUri(o)?this.m.workspaces.get(o)??this.v.workspaces.get(o):this.m.emptyWindows.get(o)??this.v.emptyWindows.get(o)}z(n){return(0,p.$zh)(n)?n.uri:(0,p.$Eh)(n)?n.configPath:n.id}C(n){return!!([...this.m.emptyWindows.values()].some(o=>this.s.extUri.isEqual(o.location,n.location))||[...this.m.workspaces.values()].some(o=>this.s.extUri.isEqual(o.location,n.location))||[...this.v.emptyWindows.values()].some(o=>this.s.extUri.isEqual(o.location,n.location))||[...this.v.workspaces.values()].some(o=>this.s.extUri.isEqual(o.location,n.location)))}D(n,o,f){const b=[...this.profiles,...n],y=[];this.m.profiles=[];for(let S of b)S.isDefault||o.some(L=>S.id===L.id)||(S=f.find(L=>S.id===L.id)??S,S.isTransient?this.m.profiles.push(S):y.push({location:S.location,name:S.name,shortName:S.shortName,useDefaultFlags:S.useDefaultFlags}));this.L(y),this.u=void 0,this.F(n,o,f)}F(n,o,f){this.h.fire({added:n,removed:o,updated:f,all:this.profiles})}G(n,o,f){f=o?.isTransient?!0:f,f||this.G(n,void 0,!0);const b=this.z(n),y=f?this.m:this.v;I.URI.isUri(b)?(y.workspaces.delete(b),o&&y.workspaces.set(b,o)):(y.emptyWindows.delete(b),o&&y.emptyWindows.set(b,o)),f||this.H()}H(){const n={};for(const[f,b]of this.v.workspaces.entries())n[f.toString()]=b.id;const o={};for(const[f,b]of this.v.emptyWindows.entries())o[f.toString()]=b.id;this.N({workspaces:n,emptyWindows:o}),this.u=void 0}I(n){const o={},f=this.w();if(n.workspaces)for(const[y,S]of Object.entries(n.workspaces)){const L=I.URI.parse(S);o[y]=this.s.extUri.isEqual(L,f.location)?f.id:this.s.extUri.basename(L)}const b={};if(n.emptyWindows)for(const[y,S]of Object.entries(n.emptyWindows)){const L=I.URI.parse(S);b[y]=this.s.extUri.isEqual(L,f.location)?f.id:this.s.extUri.basename(L)}return{workspaces:o,emptyWindows:b}}J(){return[]}L(n){throw new Error("not implemented")}M(){return{}}N(n){throw new Error("not implemented")}O(){}};e.$uk=s,e.$uk=s=Le([Ie(0,w.$wh),Ie(1,$.$Sj),Ie(2,d.$pk),Ie(3,k.$Ri)],s);class a extends s{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(n){this.a=n}M(){return this.R}N(n){this.R=n}}e.$vk=a}),define(pe[256],be([1,0,18,14,20,11,5,2,3,10,4,177,31,37,40,12,26,32,34,33]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l,d,m,c,u,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=void 0;let E=class extends P.$lb{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}get onDidUpdateExtensionMetadata(){return this.s.event}constructor(n,o,f,b,y,S){super(),this.u=n,this.v=o,this.w=f,this.y=b,this.z=y,this.C=S,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new I.$ec),this.m=this.B(new I.$ec),this.n=this.B(new I.$ec),this.p=this.B(new I.$ec),this.s=this.B(new I.$ec),this.t=[],this.B((0,P.$jb)(()=>{this.j.forEach(({task:L})=>L.cancel()),this.k.forEach(L=>L.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(n){const o=await this.getTargetPlatform();return n.allTargetPlatforms.some(f=>(0,p.$On)(f,n.allTargetPlatforms,o))}async installFromGallery(n,o={}){try{const b=(await this.installGalleryExtensions([{extension:n,options:o}])).find(({identifier:y})=>(0,l.$ho)(y,n.identifier));if(b?.local)return b?.local;throw b?.error?b.error:t(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(f){throw t(f)}}async installGalleryExtensions(n){if(!this.u.isEnabled())throw new p.$Sn(k.localize(0,null),p.ExtensionManagementErrorCode.Internal);const o=[],f=[];await Promise.allSettled(n.map(async({extension:b,options:y})=>{try{const S=await this.J(b,!!y?.installGivenVersion,!!y?.installPreReleaseVersion);f.push({...S,options:y})}catch(S){o.push({identifier:b.identifier,operation:2,source:b,error:S})}})),f.length&&o.push(...await this.D(f));for(const b of o)b.error&&(this.y.error("Failed to install extension.",b.identifier.id),this.y.error(b.error),b.source&&!A.URI.isUri(b.source)&&s(this.v,"extensionGallery:install",{extensionData:(0,l.$po)(b.source),error:b.error}));return o}async uninstall(n,o={}){return this.y.trace("ExtensionManagementService#uninstall",n.identifier.id),this.M(n,o)}async toggleAppliationScope(n,o){if((0,d.$Ll)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let f=await this.updateMetadata(n,{isApplicationScoped:!1},this.C.defaultProfile.extensionsResource);this.w.extUri.isEqual(o,this.C.defaultProfile.extensionsResource)||(f=await this.X(n,this.C.defaultProfile.extensionsResource,o));for(const b of this.C.profiles){const y=(await this.getInstalled(1,b.extensionsResource)).find(S=>(0,l.$ho)(S.identifier,n.identifier));y?this.s.fire(y):this.p.fire({identifier:n.identifier,profileLocation:b.extensionsResource})}return f}else{const f=this.w.extUri.isEqual(o,this.C.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.C.defaultProfile.extensionsResource):await this.X(n,o,this.C.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.m.fire([{identifier:f.identifier,operation:2,local:f,profileLocation:this.C.defaultProfile.extensionsResource,applicationScoped:!0}]),f}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.R(),this.h=n),this.g}registerParticipant(n){this.t.push(n)}async D(n){const o=[];return await Promise.allSettled(n.map(async f=>{try{const b=await this.F(f);o.push(...b)}catch(b){o.push({identifier:{id:(0,l.$mo)(f.manifest.publisher,f.manifest.name)},operation:2,source:f.extension,error:b})}})),this.m.fire(o),o}async F({manifest:n,extension:o,options:f}){const b=f.isApplicationScoped||f.isBuiltin||(0,d.$Ll)(n),y={...f,installOnlyNewlyAddedFromExtensionPack:A.URI.isUri(o)?f.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:b,profileLocation:b?this.C.defaultProfile.extensionsResource:f.profileLocation??this.S()},S=ee=>`${l.$io.create(ee).toString()}${y.profileLocation?`-${y.profileLocation.toString()}`:""}`;if(!A.URI.isUri(o)){const ee=this.j.get(S(o));if(ee)return this.y.info("Extensions is already requested to install",o.identifier.id),await ee.task.waitUntilTaskIsFinished(),[]}const L=[],j=[],Q=[],le=this.U(n,o,y);A.URI.isUri(o)||this.j.set(S(o),{task:le,waitingTasks:[]}),this.l.fire({identifier:le.identifier,source:o,profileLocation:y.profileLocation}),this.y.info("Installing extension:",le.identifier.id),L.push({task:le,manifest:n});let Y=!1;try{if(y.donotIncludePackAndDependencies)this.y.info("Installing the extension without checking dependencies and pack",le.identifier.id);else try{const ue=await this.I(le.identifier,n,!!y.installOnlyNewlyAddedFromExtensionPack,!!y.installPreReleaseVersion,y.profileLocation),X=await this.getInstalled(void 0,y.profileLocation),he={...y,donotIncludePackAndDependencies:!0,context:{...y.context,[p.$Jn]:!0}};for(const{gallery:x,manifest:se}of(0,D.$of)(ue,({gallery:V})=>V.identifier.id)){Y=Y||!!se.extensionDependencies?.some(H=>(0,l.$ho)({id:H},le.identifier));const V=S(x),K=this.j.get(V);if(K){if(this.G(le,K.task)){const H=K.task.identifier;this.y.info("Waiting for already requested installing extension",H.id,le.identifier.id),K.waitingTasks.push(le),j.push(I.Event.toPromise(I.Event.filter(this.onDidInstallExtensions,te=>te.some(me=>(0,l.$ho)(me.identifier,H)))).then(te=>{if(this.y.info("Finished waiting for already requested installing extension",H.id,le.identifier.id),!te.find(ne=>(0,l.$ho)(ne.identifier,H))?.local)throw new Error(`Extension ${H.id} is not installed`)}))}}else if(!X.some(({identifier:H})=>(0,l.$ho)(H,x.identifier))){const H=this.U(se,x,he);this.j.set(V,{task:H,waitingTasks:[le]}),this.l.fire({identifier:H.identifier,source:x,profileLocation:y.profileLocation}),this.y.info("Installing extension:",H.identifier.id,le.identifier.id),L.push({task:H,manifest:se})}}}catch(ue){if(A.URI.isUri(le.source))(0,D.$nf)(n.extensionDependencies)&&this.y.warn("Cannot install dependencies of extension:",le.identifier.id,ue.message),(0,D.$nf)(n.extensionPack)&&this.y.warn("Cannot install packed extensions of extension:",le.identifier.id,ue.message);else throw this.y.error("Error while preparing to install dependencies and extension packs of the extension:",le.identifier.id),ue}const ee=L.reduce((ue,{task:X,manifest:he})=>(ue.set(X.identifier.id.toLowerCase(),{task:X,manifest:he}),ue),new Map);for(;ee.size;){let ue;const X=[...ee.values()].filter(({manifest:he})=>!he.extensionDependencies?.some(x=>ee.has(x.toLowerCase())));X.length?ue=ee.size===1?X:X.filter(({task:he})=>!(he===le&&!Y)):(this.y.info("Found extensions with circular dependencies",X.map(({task:he})=>he.identifier.id)),ue=[...ee.values()]),await this.H(ue.map(async({task:he})=>{const x=new Date().getTime();try{const se=await he.run();if(await this.H(this.t.map(V=>V.postInstall(se,he.source,y,r.CancellationToken.None))),!A.URI.isUri(he.source)){const V=he.operation===3,K=V?void 0:(new Date().getTime()-he.source.lastUpdated)/1e3;if(s(this.v,V?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$po)(he.source),verificationStatus:he.verificationStatus,duration:new Date().getTime()-x,durationSinceUpdate:K}),w.$o&&he.operation!==3)try{await this.u.reportStatistic(se.manifest.publisher,se.manifest.name,se.manifest.version,"install")}catch{}}Q.push({local:se,identifier:he.identifier,operation:he.operation,source:he.source,context:he.options.context,profileLocation:he.profileLocation,applicationScoped:se.isApplicationScoped})}catch(se){throw A.URI.isUri(he.source)||s(this.v,he.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$po)(he.source),verificationStatus:he.verificationStatus,duration:new Date().getTime()-x,error:se}),this.y.error("Error while installing the extension:",he.identifier.id),se}finally{ee.delete(he.identifier.id.toLowerCase())}}))}return j.length&&await this.H(j),Q.forEach(({identifier:ue})=>this.y.info("Extension installed successfully:",ue.id)),Q}catch(ee){if(L.forEach(({task:ue})=>ue.cancel()),Q.length)try{const ue=await Promise.allSettled(Q.map(({local:X})=>this.W(X,{versionOnly:!0,profileLocation:y.profileLocation}).run()));for(let X=0;X<ue.length;X++){const he=ue[X],{identifier:x}=Q[X];he.status==="fulfilled"?this.y.info("Rollback: Uninstalled extension",x.id):this.y.warn("Rollback: Error while uninstalling extension",x.id,(0,C.$9)(he.reason))}}catch(ue){this.y.warn("Error while rolling back extensions",(0,C.$9)(ue),Q.map(({identifier:X})=>X.id))}return L.map(({task:ue})=>({identifier:ue.identifier,operation:2,source:ue.source,context:y.context,profileLocation:y.profileLocation,error:ee}))}finally{for(const{task:ee}of L)ee.source&&!A.URI.isUri(ee.source)&&this.j.delete(S(ee.source))}}G(n,o){for(const[,{task:f,waitingTasks:b}]of this.j.entries())if(f===n&&(b.includes(o)||b.some(y=>this.G(y,o)))||f===o&&b[0]&&!this.G(n,b[0]))return!1;return!0}async H(n){const o=[],f=[],b=await Promise.allSettled(n);for(const y of b)y.status==="fulfilled"?o.push(y.value):f.push(y.reason);if(f.length)throw v(f);return o}async I(n,o,f,b,y){if(!this.u.isEnabled())return[];const S=await this.getInstalled(void 0,y),L=[],j=[],Q=async(le,Y)=>{L.push(le);const ee=Y.extensionDependencies||[],ue=[...ee];if(Y.extensionPack){const X=f?S.find(he=>(0,l.$ho)(he.identifier,le)):void 0;for(const he of Y.extensionPack)X&&X.manifest.extensionPack&&X.manifest.extensionPack.some(x=>(0,l.$ho)({id:x},{id:he}))||ue.every(x=>!(0,l.$ho)({id:x},{id:he}))&&ue.push(he)}if(ue.length){const X=ue.filter(he=>L.every(x=>!(0,l.$ho)(x,{id:he})));if(X.length){const he=await this.u.getExtensions(X.map(x=>({id:x,preRelease:b})),r.CancellationToken.None);for(const x of he){if(L.find(K=>(0,l.$ho)(K,x.identifier)))continue;const se=ee.some(K=>(0,l.$ho)({id:K},x.identifier));let V;try{V=await this.J(x,!1,b)}catch(K){if(se)throw K;this.y.info("Skipping the packed extension as it cannot be installed",x.identifier.id,(0,C.$9)(K));continue}j.push({gallery:V.extension,manifest:V.manifest}),await Q(V.extension.identifier,V.manifest)}}}};return await Q(n,o),j}async J(n,o,f){let b;const y=await this.getExtensionsControlManifest();if(y.malicious.some(j=>(0,l.$ho)(n.identifier,j)))throw new p.$Sn(k.localize(1,null,n.identifier.id),p.ExtensionManagementErrorCode.Malicious);const S=y.deprecated[n.identifier.id.toLowerCase()];if(S?.extension?.autoMigrate){if(this.y.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${S.extension.id}' extension instead.`),b=(await this.u.getExtensions([{id:S.extension.id,preRelease:S.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},r.CancellationToken.None))[0],!b)throw new p.$Sn(k.localize(2,null,n.identifier.id,S.extension.id),p.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const j=await this.getTargetPlatform();throw new p.$Sn(k.localize(3,null,n.identifier.id,this.z.nameLong,(0,p.$Kn)(j)),p.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(b=await this.L(n,o,f),!b)throw!f&&n.properties.isPreReleaseVersion&&(await this.u.getExtensions([n.identifier],r.CancellationToken.None))[0]?new p.$Sn(k.localize(4,null,n.identifier.id),p.ExtensionManagementErrorCode.ReleaseVersionNotFound):new p.$Sn(k.localize(5,null,n.identifier.id,this.z.nameLong,this.z.version),p.ExtensionManagementErrorCode.Incompatible)}this.y.info("Getting Manifest...",b.identifier.id);const L=await this.u.getManifest(b,r.CancellationToken.None);if(L===null)throw new p.$Sn(`Missing manifest for extension ${b.identifier.id}`,p.ExtensionManagementErrorCode.Invalid);if(L.version!==b.version)throw new p.$Sn(`Cannot install '${b.identifier.id}' extension because of version mismatch in Marketplace`,p.ExtensionManagementErrorCode.Invalid);return{extension:b,manifest:L}}async L(n,o,f){const b=await this.getTargetPlatform();let y=null;return!o&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==f&&(y=(await this.u.getExtensions([{...n.identifier,preRelease:f}],{targetPlatform:b,compatible:!0},r.CancellationToken.None))[0]||null),!y&&await this.u.isExtensionCompatible(n,f,b)&&(y=n),y||(o?y=(await this.u.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:b,compatible:!0},r.CancellationToken.None))[0]||null:y=await this.u.getCompatibleExtension(n,f,b)),y}async M(n,o){const f={...o,profileLocation:n.isApplicationScoped?this.C.defaultProfile.extensionsResource:o.profileLocation??this.S()},b=le=>`${le.id.toLowerCase()}${f.versionOnly?`-${n.manifest.version}`:""}${f.profileLocation?`@${f.profileLocation.toString()}`:""}`,y=this.k.get(b(n.identifier));if(y)return this.y.info("Extensions is already requested to uninstall",n.identifier.id),y.waitUntilTaskIsFinished();const S=le=>{const Y=this.W(le,f);return this.k.set(b(Y.extension.identifier),Y),f.profileLocation?this.y.info("Uninstalling extension from the profile:",`${le.identifier.id}@${le.manifest.version}`,f.profileLocation.toString()):this.y.info("Uninstalling extension:",`${le.identifier.id}@${le.manifest.version}`),this.n.fire({identifier:le.identifier,profileLocation:f.profileLocation,applicationScoped:le.isApplicationScoped}),Y},L=(le,Y)=>{Y?f.profileLocation?this.y.error("Failed to uninstall extension from the profile:",`${le.identifier.id}@${le.manifest.version}`,f.profileLocation.toString(),Y.message):this.y.error("Failed to uninstall extension:",`${le.identifier.id}@${le.manifest.version}`,Y.message):f.profileLocation?this.y.info("Successfully uninstalled extension from the profile",`${le.identifier.id}@${le.manifest.version}`,f.profileLocation.toString()):this.y.info("Successfully uninstalled extension:",`${le.identifier.id}@${le.manifest.version}`),s(this.v,"extensionGallery:uninstall",{extensionData:(0,l.$oo)(le),error:Y}),this.p.fire({identifier:le.identifier,error:Y?.code,profileLocation:f.profileLocation,applicationScoped:le.isApplicationScoped})},j=[],Q=[];try{j.push(S(n));const le=await this.getInstalled(1,f.profileLocation);if(f.donotIncludePack)this.y.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const Y=this.P(n,le);for(const ee of Y)this.k.has(b(ee.identifier))?this.y.info("Extensions is already requested to uninstall",ee.identifier.id):j.push(S(ee))}f.donotCheckDependents?this.y.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.N(j.map(Y=>Y.extension),le,n),await this.H(j.map(async Y=>{try{if(await Y.run(),await this.H(this.t.map(ee=>ee.postUninstall(Y.extension,f,r.CancellationToken.None))),Y.extension.identifier.uuid)try{await this.u.reportStatistic(Y.extension.manifest.publisher,Y.extension.manifest.name,Y.extension.manifest.version,"uninstall")}catch{}L(Y.extension)}catch(ee){const ue=ee instanceof p.$Sn?ee:new p.$Sn((0,C.$9)(ee),p.ExtensionManagementErrorCode.Internal);throw L(Y.extension,ue),ue}finally{Q.push(Y)}}))}catch(le){const Y=le instanceof p.$Sn?le:new p.$Sn((0,C.$9)(le),p.ExtensionManagementErrorCode.Internal);for(const ee of j){try{ee.cancel()}catch{}Q.includes(ee)||L(ee.extension,Y)}throw Y}finally{for(const le of j)this.k.delete(b(le.extension.identifier))||this.y.warn("Uninstallation task is not found in the cache",le.extension.identifier.id)}}N(n,o,f){for(const b of n){const y=this.Q(b,o);if(y.length){const S=y.filter(L=>!n.some(j=>(0,l.$ho)(j.identifier,L.identifier)));if(S.length)throw new Error(this.O(b,S,f))}}}O(n,o,f){return f===n?o.length===1?k.localize(6,null,f.manifest.displayName||f.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?k.localize(7,null,f.manifest.displayName||f.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):k.localize(8,null,f.manifest.displayName||f.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?k.localize(9,null,f.manifest.displayName||f.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?k.localize(10,null,f.manifest.displayName||f.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):k.localize(11,null,f.manifest.displayName||f.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}P(n,o,f=[]){if(f.indexOf(n)!==-1)return[];f.push(n);const b=n.manifest.extensionPack?n.manifest.extensionPack:[];if(b.length){const y=o.filter(L=>!L.isBuiltin&&b.some(j=>(0,l.$ho)({id:j},L.identifier))),S=[];for(const L of y)S.push(...this.P(L,o,f));return[...y,...S]}return[]}Q(n,o){return o.filter(f=>f.manifest.extensionDependencies&&f.manifest.extensionDependencies.some(b=>(0,l.$ho)({id:b},n.identifier)))}async R(){try{this.y.trace("ExtensionManagementService.refreshReportedCache");const n=await this.u.getExtensionsControlManifest();return this.y.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.y.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$9o=E,e.$9o=E=Le([Ie(0,p.$Rn),Ie(1,u.$Vk),Ie(2,h.$pk),Ie(3,m.$Ri),Ie(4,c.$0i),Ie(5,g.$rk)],E);function v(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((o,f)=>new Error(`${o.message}${o.message?",":""}${f instanceof Error?f.message:f}`),new Error(""))}e.$0o=v;function t(i){if(i instanceof p.$Sn)return i;const n=new p.$Sn(i.message,p.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}e.$$o=t;function s(i,n,{extensionData:o,verificationStatus:f,duration:b,error:y,durationSinceUpdate:S}){let L,j;(0,$.$qe)(f)&&(f===!0?f="Verified":(f===!1||(L=p.ExtensionManagementErrorCode.Signature,j=f),f="Unverified")),y&&(y instanceof p.$Sn?(L=y.code,y.code===p.ExtensionManagementErrorCode.Signature&&(j=y.message)):L=p.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...o,verificationStatus:f,success:!y,duration:b,errorcode:L,errorcodeDetail:j,durationSinceUpdate:S})}class a{constructor(){this.d=new O.$tg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,O.$ig)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,O.$ig)(n=>new Promise((o,f)=>{const b=n.onCancellationRequested(()=>{b.dispose(),f(new C.$3)})})),this.d.open()),this.g.cancel()}}e.$_o=a}),define(pe[45],be([1,0,14,15,2,5,27,4,31,37,16,6,12,33,34,10,11,32]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l,d,m,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h||(e.ExtensionsProfileScanningErrorCode=h={}));class g extends Error{constructor(a,i){super(a),this.code=i}}e.$ap=g,e.$bp=(0,k.$ph)("IExtensionsProfileScannerService");let E=class extends r.$lb{constructor(a,i,n,o,f,b){super(),this.i=a,this.j=i,this.k=n,this.l=o,this.m=f,this.n=b,this.b=this.B(new C.$ec),this.onAddExtensions=this.b.event,this.c=this.B(new C.$ec),this.onDidAddExtensions=this.c.event,this.f=this.B(new C.$ec),this.onRemoveExtensions=this.f.event,this.g=this.B(new C.$ec),this.onDidRemoveExtensions=this.g.event,this.h=new I.$ni}scanProfileExtensions(a,i){return this.p(a,void 0,i)}async addExtensionsToProfile(a,i){const n=[],o=[];try{return await this.p(i,f=>{const b=[];for(const y of f)a.some(([S])=>(0,$.$ho)(S.identifier,y.identifier)&&S.manifest.version!==y.version)?n.push(y):b.push(y);for(const[y,S]of a){const L=b.findIndex(Q=>(0,$.$ho)(Q.identifier,y.identifier)&&Q.version===y.manifest.version),j={identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:S};L===-1?(o.push(j),b.push(j)):b.splice(L,1,j)}return o.length&&this.b.fire({extensions:o,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),b}),o.length&&this.c.fire({extensions:o,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),o}catch(f){throw o.length&&this.c.fire({extensions:o,error:f,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:f,profileLocation:i}),f}}async updateMetadata(a,i){const n=[];return await this.p(i,o=>{const f=[];for(const b of o){const y=a.find(([S])=>(0,$.$ho)(S.identifier,b.identifier)&&S.manifest.version===b.version);y&&(b.metadata={...b.metadata,...y[1]},n.push(b)),f.push(b)}return f}),n}async removeExtensionFromProfile(a,i){const n=[];try{await this.p(i,o=>{const f=[];for(const b of o)(0,$.$ho)(b.identifier,a.identifier)?n.push(b):f.push(b);return n.length&&this.f.fire({extensions:n,profileLocation:i}),f}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(o){throw n.length&&this.g.fire({extensions:n,error:o,profileLocation:i}),o}}async p(a,i,n){return this.w(a).queue(async()=>{let o=[],f;try{const b=await this.j.readFile(a);f=JSON.parse(b.value.toString().trim()||"[]")}catch(b){if((0,A.$9j)(b)!==1)throw b;if(this.l.extUri.isEqual(a,this.k.defaultProfile.extensionsResource)&&(f=await this.v()),!f&&n?.bailOutWhenFileNotFound)throw new g((0,c.$9)(b),"ERROR_PROFILE_NOT_FOUND")}if(f){Array.isArray(f)||this.r(a);let b=!1;for(const y of f){v(y)||this.r(a);let S;if((0,m.$ie)(y.relativeLocation)&&y.relativeLocation)S=this.t(y.relativeLocation);else if((0,m.$ie)(y.location))S=this.t(y.location),b=!0,y.relativeLocation=y.location,y.location=S.toJSON();else{S=P.URI.revive(y.location);const L=this.s(S);L&&(b=!0,y.relativeLocation=L)}o.push({identifier:y.identifier,location:S,version:y.version,metadata:y.metadata})}b&&await this.j.writeFile(a,O.$Ec.fromString(JSON.stringify(f)))}if(i){o=i(o);const b=o.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.s(y.location),metadata:y.metadata}));await this.j.writeFile(a,O.$Ec.fromString(JSON.stringify(b)))}return o})}r(a){const i=new g(`Invalid extensions content in ${a.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}s(a){return this.l.extUri.isEqual(this.l.extUri.dirname(a),this.i)?this.l.extUri.basename(a):void 0}t(a){return this.l.extUri.joinPath(this.i,a)}async v(){return this.u||(this.u=(async()=>{const a=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),i=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let n;try{n=(await this.j.readFile(a)).value.toString()}catch(f){if((0,A.$9j)(f)===1)return;throw f}this.n.info("Migrating extensions from old default profile location",a.toString());let o;try{const f=JSON.parse(n);Array.isArray(f)&&f.every(b=>v(b))?o=f:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",f)}catch(f){this.n.error(f)}if(o)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,O.$Ec.fromString(JSON.stringify(o)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",a.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(f){if((0,A.$9j)(f)===3)this.n.info("Migration from old default profile location to new location is done by another window",a.toString(),this.k.defaultProfile.extensionsResource.toString());else throw f}try{await this.j.del(a)}catch(f){(0,A.$9j)(f)!==1&&this.n.error(f)}try{await this.j.del(i)}catch(f){(0,A.$9j)(f)!==1&&this.n.error(f)}return o})()),this.u}w(a){let i=this.h.get(a);return i||(i=new D.$Bg,this.h.set(a,i)),i}};e.$cp=E,e.$cp=E=Le([Ie(1,A.$Sj),Ie(2,l.$rk),Ie(3,d.$pk),Ie(4,u.$Vk),Ie(5,p.$Ri)],E);function v(s){return(0,m.$ke)(s)&&(0,w.$Qn)(s.identifier)&&(t(s.location)||(0,m.$ie)(s.location)&&s.location)&&((0,m.$pe)(s.relativeLocation)||(0,m.$ie)(s.relativeLocation))&&s.version&&(0,m.$ie)(s.version)}function t(s){return s?(0,m.$ie)(s.path)&&(0,m.$ie)(s.scheme):!1}}),define(pe[57],be([1,0,18,14,22,15,11,75,161,2,13,7,3,19,53,60,10,4,181,25,37,40,79,16,6,12,26,5,50,45,33,34,211]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l,d,m,c,u,h,g,E,v,t,s,a,i,n,o,f,b,y,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.Translations=void 0;var j;(function(he){function x(se,V){if(se===V)return!0;const K=Object.keys(se),H=new Set;for(const te of Object.keys(V))H.add(te);if(K.length!==H.size)return!1;for(const te of K){if(se[te]!==V[te])return!1;H.delete(te)}return H.size===0}he.equals=x})(j||(e.Translations=j={})),e.$fp=(0,a.$ph)("IExtensionsScannerService");let Q=class extends $.$lb{constructor(x,se,V,K,H,te,me,ne,q,J,R,F){super(),this.systemExtensionsLocation=x,this.userExtensionsLocation=se,this.l=V,this.m=K,this.n=H,this.r=te,this.s=me,this.t=ne,this.u=q,this.v=J,this.w=R,this.y=F,this.g=this.B(new o.$ec),this.onDidChangeCache=this.g.event,this.h=(0,l.$9f)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(ee,this.m,this.h)),this.j=this.B(this.y.createInstance(ee,this.m,this.h)),this.k=this.B(this.y.createInstance(Y,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,E.$so)(this.s,this.t)),this.z}async scanAllExtensions(x,se,V){const[K,H]=await Promise.all([this.scanSystemExtensions(x),this.scanUserExtensions(se)]),te=V?await this.scanExtensionsUnderDevelopment(x,[...K,...H]):[];return this.G(K,H,te,await this.getTargetPlatform(),!0)}async scanSystemExtensions(x){const se=[];se.push(this.H(!!x.useCache,x.language)),se.push(this.I(x.language,!!x.checkControlFile));const[V,K]=await Promise.all(se);return this.F([...V,...K],0,x,!1)}async scanUserExtensions(x){const se=x.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",se);const V=this.w.extUri.isEqual(x.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,K=await this.L(se,!!x.profileLocation,1,!x.includeUninstalled,x.language,!0,V),H=x.useCache&&!K.devMode&&K.excludeObsolete?this.j:this.k;let te;try{te=await H.scanExtensions(K)}catch(me){if(me instanceof b.$ap&&me.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),te=await H.scanExtensions(K);else throw me}return te=await this.F(te,1,x,!0),this.t.trace("Scanned user extensions:",te.length),te}async scanExtensionsUnderDevelopment(x,se){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const V=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(K=>K.scheme===A.Schemas.file).map(async K=>{const H=await this.L(K,!1,1,!0,x.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(H)).map(me=>(me.type=se.find(ne=>(0,E.$ho)(ne.identifier,me.identifier))?.type??me.type,this.k.validate(me,H)))}))).flat();return this.F(V,"development",x,!0)}return[]}async scanExistingExtension(x,se,V){const K=await this.L(x,!1,se,!0,V.language,!0,void 0),H=await this.k.scanExtension(K);return!H||!V.includeInvalid&&!H.isValid?null:H}async scanOneOrMultipleExtensions(x,se,V){const K=await this.L(x,!1,se,!0,V.language,!0,void 0),H=await this.k.scanOneOrMultipleExtensions(K);return this.F(H,se,V,!0)}async scanMetadata(x){const se=(0,l.$9f)(x,"package.json"),V=(await this.s.readFile(se)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(x,se){const V=(0,l.$9f)(x,"package.json"),K=(await this.s.readFile(V)).value.toString(),H=JSON.parse(K);se.isMachineScoped=se.isMachineScoped||void 0,se.isBuiltin=se.isBuiltin||void 0,H.__metadata={...H.__metadata,...se},await this.s.writeFile((0,l.$9f)(x,"package.json"),C.$Ec.fromString(JSON.stringify(H,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(x){if(x instanceof b.$ap&&x.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw x}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const x=await this.scanUserExtensions({includeInvalid:!0});if(x.length)await this.r.addExtensionsToProfile(x.map(se=>[se,se.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,C.$Ec.fromString(JSON.stringify([])))}catch(se){(0,s.$9j)(se)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,I.$9)(se))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(x){this.t.error(x)}finally{this.C=void 0}})()),this.C}async F(x,se,V,K){return V.includeAllVersions||(x=this.G(se===0?x:void 0,se===1?x:void 0,se==="development"?x:void 0,await this.getTargetPlatform(),K)),V.includeInvalid||(x=x.filter(H=>H.isValid)),x.sort((H,te)=>{const me=k.$_c(H.location.fsPath),ne=k.$_c(te.location.fsPath);return me<ne?-1:me>ne?1:0})}G(x,se,V,K,H){const te=(ne,q,J)=>{if(ne.isValid&&!q.isValid)return!1;if(ne.isValid===q.isValid){if(H&&d.gt(ne.manifest.version,q.manifest.version))return this.t.debug(`Skipping extension ${q.location.path} with lower version ${q.manifest.version} in favour of ${ne.location.path} with version ${ne.manifest.version}`),!1;if(d.eq(ne.manifest.version,q.manifest.version)){if(ne.type===0)return this.t.debug(`Skipping extension ${q.location.path} in favour of system extension ${ne.location.path} with same version`),!1;if(ne.targetPlatform===K)return this.t.debug(`Skipping extension ${q.location.path} from different target platform ${q.targetPlatform}`),!1}}return J?this.t.warn(`Overwriting user extension ${ne.location.path} with ${q.location.path}.`):this.t.debug(`Overwriting user extension ${ne.location.path} with ${q.location.path}.`),!0},me=new v.$Kl;return x?.forEach(ne=>{const q=me.get(ne.identifier.id);(!q||te(q,ne,!1))&&me.set(ne.identifier.id,ne)}),se?.forEach(ne=>{const q=me.get(ne.identifier.id);if(!q&&x&&ne.type===0){this.t.debug(`Skipping obsolete system extension ${ne.location.path}.`);return}(!q||te(q,ne,!1))&&me.set(ne.identifier.id,ne)}),V?.forEach(ne=>{const q=me.get(ne.identifier.id);(!q||te(q,ne,!0))&&me.set(ne.identifier.id,ne),me.set(ne.identifier.id,ne)}),[...me.values()]}async H(x,se){this.t.trace("Started scanning system extensions");const V=await this.L(this.systemExtensionsLocation,!1,0,!0,se,!0,void 0),H=await(x&&!V.devMode?this.i:this.k).scanExtensions(V);return this.t.trace("Scanned system extensions:",H.length),H}async I(x,se){const V=this.u.isBuilt?[]:this.v.builtInExtensions;if(!V?.length)return[];this.t.trace("Started scanning dev system extensions");const K=se?await this.J():{},H=[],te=u.URI.file(k.$6c(k.$8c(A.$1e.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ne of V){const q=K[ne.name]||"marketplace";switch(q){case"disabled":break;case"marketplace":H.push((0,l.$9f)(te,ne.name));break;default:H.push(u.URI.file(q));break}}const me=await Promise.all(H.map(async ne=>this.k.scanExtension(await this.L(ne,!1,0,!0,x,!0,void 0))));return this.t.trace("Scanned dev system extensions:",me.length),(0,D.$jf)(me)}async J(){try{const x=await this.s.readFile(this.l);return JSON.parse(x.value.toString())}catch{return{}}}async L(x,se,V,K,H,te,me){const ne=await this.f(H??p.$v),q=await this.M(x),J=se&&!this.w.extUri.isEqual(x,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,R=J?await this.M(J):void 0;return new le(x,q,J,R,se,me,V,K,te,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,H,ne)}async M(x){try{const se=await this.s.stat(x);if(typeof se.mtime=="number")return se.mtime}catch{}}};e.$gp=Q,e.$gp=Q=Le([Ie(4,y.$rk),Ie(5,b.$bp),Ie(6,s.$Sj),Ie(7,i.$Ri),Ie(8,g.$wh),Ie(9,n.$0i),Ie(10,S.$pk),Ie(11,a.$oh)],Q);class le{constructor(x,se,V,K,H,te,me,ne,q,J,R,F,W,ie,re){this.location=x,this.mtime=se,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=K,this.profile=H,this.profileScanOptions=te,this.type=me,this.excludeObsolete=ne,this.validate=q,this.productVersion=J,this.productDate=R,this.productCommit=F,this.devMode=W,this.language=ie,this.translations=re}static createNlsConfiguration(x){return{language:x.language,pseudo:x.language==="pseudo",devMode:x.devMode,translations:x.translations}}static equals(x,se){return(0,l.$2f)(x.location,se.location)&&x.mtime===se.mtime&&(0,l.$2f)(x.applicationExtensionslocation,se.applicationExtensionslocation)&&x.applicationExtensionslocationMtime===se.applicationExtensionslocationMtime&&x.profile===se.profile&&r.$Mm(x.profileScanOptions,se.profileScanOptions)&&x.type===se.type&&x.excludeObsolete===se.excludeObsolete&&x.validate===se.validate&&x.productVersion===se.productVersion&&x.productDate===se.productDate&&x.productCommit===se.productCommit&&x.devMode===se.devMode&&x.language===se.language&&j.equals(x.translations,se.translations)}}e.$hp=le;let Y=class extends $.$lb{constructor(x,se,V,K,H){super(),this.f=x,this.g=se,this.h=V,this.i=K,this.j=H}async scanExtensions(x){const se=x.profile?await this.l(x):await this.k(x);let V={};if(x.excludeObsolete&&x.type===1)try{const K=(await this.i.readFile(this.f)).value.toString();V=JSON.parse(K)}catch{}return(0,c.$ve)(V)?se:se.filter(K=>!V[E.$io.create(K).toString()])}async k(x){const se=await this.i.resolve(x.location);if(!se.children?.length)return[];const V=await Promise.all(se.children.map(async K=>{if(!K.isDirectory||x.type===1&&(0,l.$6f)(K.resource).indexOf(".")===0)return null;const H=new le(K.resource,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(H)}));return(0,D.$jf)(V).sort((K,H)=>K.location.path<H.location.path?-1:1)}async l(x){let se=await this.m(x.location,()=>!0,x);if(x.applicationExtensionslocation&&!this.h.extUri.isEqual(x.location,x.applicationExtensionslocation)){se=se.filter(K=>!K.metadata?.isApplicationScoped);const V=await this.m(x.applicationExtensionslocation,K=>!!K.metadata?.isBuiltin||!!K.metadata?.isApplicationScoped,x);se.push(...V)}return se}async m(x,se,V){const K=await this.g.scanProfileExtensions(x,V.profileScanOptions);if(!K.length)return[];const H=await Promise.all(K.map(async te=>{if(se(te)){const me=new le(te.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(me,te.metadata)}return null}));return(0,D.$jf)(H)}async scanOneOrMultipleExtensions(x){try{if(await this.i.exists((0,l.$9f)(x.location,"package.json"))){const se=await this.scanExtension(x);return se?[se]:[]}else return await this.scanExtensions(x)}catch(se){return this.j.error(`Error scanning extensions at ${x.location.path}:`,(0,I.$9)(se)),[]}}async scanExtension(x,se){try{let V=await this.scanExtensionManifest(x.location);if(V){V.publisher||(V.publisher=v.$El),se=se??V.__metadata,delete V.__metadata;const K=(0,E.$mo)(V.publisher,V.name),H=se?.id?{id:K,uuid:se.id}:{id:K},te=se?.isSystem?0:x.type,me=te===0||!!se?.isBuiltin;V=await this.n(x.location,V,le.createNlsConfiguration(x));const ne={type:te,identifier:H,manifest:V,location:x.location,isBuiltin:me,targetPlatform:se?.targetPlatform??"undefined",metadata:se,isValid:!0,validations:[]};return x.validate?this.validate(ne,x):ne}}catch(V){x.type!==0&&this.j.error(V)}return null}validate(x,se){let V=!0;const K=(0,t.$xo)(se.productVersion,se.productDate,se.location,x.manifest,x.isBuiltin);for(const[H,te]of K)H===m.default.Error&&(V=!1,this.j.error(this.u(se.location,te)));return x.isValid=V,x.validations=K,x}async scanExtensionManifest(x){const se=(0,l.$9f)(x,"package.json");let V;try{V=(await this.i.readFile(se)).value.toString()}catch(H){return(0,s.$9j)(H)!==1&&this.j.error(this.u(x,(0,h.localize)(0,null,se.path,H.message))),null}let K;try{K=JSON.parse(V)}catch{const te=[];(0,P.$ym)(V,te);for(const me of te)this.j.error(this.u(x,(0,h.localize)(1,null,se.path,me.offset,me.length,(0,w.$dp)(me.error))));return null}return(0,P.$Hm)(K)!=="object"?(this.j.error(this.u(x,(0,h.localize)(2,null,se.path))),null):K}async n(x,se,V){const K=await this.r(x,se,V);if(K)try{const H=[],te=await this.s(K.default,H);if(H.length>0)return H.forEach(ne=>{this.j.error(this.u(x,(0,h.localize)(3,null,K.default?.path,(0,w.$dp)(ne.error))))}),se;if((0,P.$Hm)(K)!=="object")return this.j.error(this.u(x,(0,h.localize)(4,null,K.default?.path))),se;const me=K.values||Object.create(null);return(0,L.$ep)(se,me,te)}catch{}return se}async r(x,se,V){const K=(0,l.$9f)(x,"package.nls.json"),H=(q,J)=>{J.forEach(R=>{this.j.error(this.u(x,(0,h.localize)(5,null,q?.path,(0,w.$dp)(R.error))))})},te=q=>{this.j.error(this.u(x,(0,h.localize)(6,null,q?.path)))},me=`${se.publisher}.${se.name}`,ne=V.translations[me];if(ne)try{const q=u.URI.file(ne),J=(await this.i.readFile(q)).value.toString(),R=[],F=(0,P.$ym)(J,R);return R.length>0?(H(q,R),{values:void 0,default:K}):(0,P.$Hm)(F)!=="object"?(te(q),{values:void 0,default:K}):{values:F.contents?F.contents.package:void 0,default:K}}catch{return{values:void 0,default:K}}else{if(!await this.i.exists(K))return;let J;try{J=await this.t(x,V)}catch{return}if(!J.localized)return{values:void 0,default:J.original};try{const R=(await this.i.readFile(J.localized)).value.toString(),F=[],W=(0,P.$ym)(R,F);return F.length>0?(H(J.localized,F),{values:void 0,default:J.original}):(0,P.$Hm)(W)!=="object"?(te(J.localized),{values:void 0,default:J.original}):{values:W,default:J.original}}catch{return{values:void 0,default:J.original}}}}async s(x,se){if(x)try{const V=(await this.i.readFile(x)).value.toString();return(0,P.$ym)(V,se)}catch{}}t(x,se){return new Promise((V,K)=>{const H=te=>{const me=(0,l.$9f)(x,`package.nls.${te}.json`);this.i.exists(me).then(ne=>{ne&&V({localized:me,original:(0,l.$9f)(x,"package.nls.json")});const q=te.lastIndexOf("-");q===-1?V({localized:(0,l.$9f)(x,"package.nls.json"),original:null}):(te=te.substring(0,q),H(te))})};if(se.devMode||se.pseudo||!se.language)return V({localized:(0,l.$9f)(x,"package.nls.json"),original:null});H(se.language)})}u(x,se){return`[${x.path}]: ${se}`}};Y=Le([Ie(1,b.$bp),Ie(2,S.$pk),Ie(3,s.$Sj),Ie(4,i.$Ri)],Y);let ee=class extends Y{constructor(x,se,V,K,H,te,me){super(se,K,H,te,me),this.z=x,this.C=V,this.w=this.B(new O.$sg(3e3)),this.y=this.B(new o.$ec),this.onDidChangeCache=this.y.event}async scanExtensions(x){const se=this.H(x),V=await this.D(se);if(this.v=x,V&&V.input&&le.equals(V.input,this.v))return this.j.debug("Using cached extensions scan result",x.location.toString()),this.w.trigger(()=>this.G()),V.result.map(H=>(H.location=u.URI.revive(H.location),H));const K=await super.scanExtensions(x);return await this.F(se,{input:x,result:K}),K}async D(x){try{const se=await this.i.readFile(x),V=JSON.parse(se.value.toString());return{result:V.result,input:(0,f.$Yg)(V.input)}}catch(se){this.j.debug("Error while reading the extension cache file:",x.path,(0,I.$9)(se))}return null}async F(x,se){try{await this.i.writeFile(x,C.$Ec.fromString(JSON.stringify(se)))}catch(V){this.j.debug("Error while writing the extension cache file:",x.path,(0,I.$9)(V))}}async G(){if(!this.v)return;const x=this.H(this.v),se=await this.D(x);if(!se)return;const V=se.result,K=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!r.$Mm(K,V))try{this.j.info("Invalidating Cache",V,K),await this.i.del(x),this.y.fire()}catch(H){this.j.error(H)}}H(x){const se=this.I(x);return this.h.extUri.joinPath(se.cacheHome,x.type===0?v.$Dl:v.$Cl)}I(x){return x.type===0?this.C.defaultProfile:x.profile?this.h.extUri.isEqual(x.location,this.z.extensionsResource)?this.z:this.C.profiles.find(se=>this.h.extUri.isEqual(x.location,se.extensionsResource))??this.z:this.C.defaultProfile}};ee=Le([Ie(2,y.$rk),Ie(3,b.$bp),Ie(4,S.$pk),Ie(5,s.$Sj),Ie(6,i.$Ri)],ee);function ue(he,x){const se=(0,E.$ko)(he.manifest.publisher,he.manifest.name);return{id:se,identifier:new v.$Il(se),isBuiltin:he.type===0,isUserBuiltin:he.type===1&&he.isBuiltin,isUnderDevelopment:x,extensionLocation:he.location,uuid:he.identifier.uuid,targetPlatform:he.targetPlatform,...he.manifest}}e.$ip=ue;class X extends Q{constructor(x,se,V,K,H,te,me,ne,q,J,R,F){super(x,se,(0,l.$9f)(V,".vscode-oss-dev","extensions","control.json"),K,H,te,me,ne,q,J,R,F),this.N=(async()=>{if(p.$y)try{const W=await this.s.readFile(u.URI.file(p.$y));return JSON.parse(W.value.toString())}catch{}return Object.create(null)})()}f(x){return this.N}}e.$jp=X}),define(pe[257],be([1,0,52,14,38,5,2,13,7,21,12,33]),function(ce,e,D,O,r,C,I,P,w,$,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=void 0;let p=class extends I.$lb{constructor(d,m){super(),this.b=d,this.f=m,this.a=new O.$Ag(5)}async postUninstall(d){const m=this.g(d,"uninstall");m&&(this.f.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(m.script,"uninstall",m.args,!0,d),this.f.info("Finished running post uninstall script",d.identifier.id,d.manifest.version)}catch(c){this.f.error("Failed to run post uninstall script",d.identifier.id,d.manifest.version),this.f.error(c)}}));try{await $.Promises.rm(this.j(d))}catch(c){this.f.error("Error while removing extension storage path",d.identifier.id),this.f.error(c)}}g(d,m){const c=`vscode:${m}`;if(d.location.scheme===P.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[c]=="string"){const u=d.manifest.scripts[c].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(d.identifier.id,d.manifest.version,`${c} should be a node script`),null):{script:(0,w.$8c)(d.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(d,m,c,u,h){return new Promise((g,E)=>{const v=this.i(d,m,c,h);let t;const s=a=>{t&&(clearTimeout(t),t=null),a?E(a):g(void 0)};v.on("error",a=>{s((0,r.$ai)(a)||"Unknown")}),v.on("exit",(a,i)=>{s(a?`post-${m} process exited with code ${a}`:void 0)}),u&&(t=setTimeout(()=>{t=null,v.kill(),E("timed out")},5e3))})}i(d,m,c,u){const h={silent:!0,execArgv:void 0},g=(0,D.fork)(d,[`--type=extension-post-${m}`,...c],h);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const E=C.Event.fromNodeEventEmitter(g.stdout,"data"),v=C.Event.fromNodeEventEmitter(g.stderr,"data");E(a=>this.f.info(u.identifier.id,u.manifest.version,`post-${m}`,a)),v(a=>this.f.error(u.identifier.id,u.manifest.version,`post-${m}`,a));const t=C.Event.any(C.Event.map(E,a=>({data:`%c${a}`,format:[""]})),C.Event.map(v,a=>({data:`%c${a}`,format:["color: red"]})));return C.Event.debounce(t,(a,i)=>a?{data:a.data+i.data,format:[...a.format,...i.format]}:{data:i.data,format:i.format},100)(a=>{console.group(u.identifier.id),console.log(a.data,...a.format),console.groupEnd()}),g}j(d){return(0,w.$8c)(this.b.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};e.$lp=p,e.$lp=p=Le([Ie(0,k.$rk),Ie(1,A.$Ri)],p)}),define(pe[125],be([1,0,12,33,34,32,45,16,25,4]),function(ce,e,D,O,r,C,I,P,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=void 0;let A=class extends I.$cp{constructor(p,l,d,m,c,u){super($.URI.file(p.extensionsPath),l,d,m,c,u)}};e.$8M=A,e.$8M=A=Le([Ie(0,w.$xh),Ie(1,P.$Sj),Ie(2,O.$rk),Ie(3,r.$pk),Ie(4,C.$Vk),Ie(5,D.$Ri)],A)}),define(pe[258],be([1,0,14,5,2,41,10,168,6,33]),function(ce,e,D,O,r,C,I,P,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Mo=e.$Lo=e.$Ko=void 0,e.$Ko="__$__isNewStorageMarker",e.$Lo="__$__targetStorageMarker",e.$Mo=(0,w.$ph)("storageService");var A;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var k;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(k||(e.StorageScope=k={}));var p;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function l(h){const g=h.get(e.$Lo);if(g)try{return JSON.parse(g)}catch{}return Object.create(null)}e.$No=l;class d extends r.$lb{static{this.a=60*1e3}constructor(g={flushInterval:d.a}){super(),this.j=g,this.b=this.B(new O.$hc),this.c=this.B(new O.$hc),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$ec),this.onWillSaveState=this.f.event,this.h=this.B(new D.$Gg(()=>this.k(),this.j.flushInterval)),this.i=this.B(new r.$mb),this.v=void 0,this.y=void 0,this.C=void 0}onDidChangeValue(g,E,v){return O.Event.filter(this.b.event,t=>t.scope===g&&(E===void 0||t.key===E),v)}k(){this.i.value=(0,D.$Kg)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,r.$gb)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.J()}finally{(0,C.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(g,E){const{key:v,external:t}=E;if(v===e.$Lo){switch(g){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:g})}else this.b.fire({scope:g,key:v,target:this.F(g)[v],external:t})}r(g){this.f.fire({reason:g})}get(g,E,v){return this.L(E)?.get(g,v)}getBoolean(g,E,v){return this.L(E)?.getBoolean(g,v)}getNumber(g,E,v){return this.L(E)?.getNumber(g,v)}getObject(g,E,v){return this.L(E)?.getObject(g,v)}storeAll(g,E){this.t(()=>{for(const v of g)this.store(v.key,v.value,v.scope,v.target,E)})}store(g,E,v,t,s=!1){if((0,I.$re)(E)){this.remove(g,v,s);return}this.t(()=>{this.u(g,v,t),this.L(v)?.set(g,E,s)})}remove(g,E,v=!1){this.t(()=>{this.u(g,E,void 0),this.L(E)?.delete(g,v)})}t(g){this.b.pause(),this.c.pause();try{g()}finally{this.b.resume(),this.c.resume()}}keys(g,E){const v=[],t=this.F(g);for(const s of Object.keys(t))t[s]===E&&v.push(s);return v}u(g,E,v,t=!1){const s=this.F(E);typeof v=="number"?s[g]!==v&&(s[g]=v,this.L(E)?.set(e.$Lo,JSON.stringify(s),t)):typeof s[g]=="number"&&(delete s[g],this.L(E)?.set(e.$Lo,JSON.stringify(s),t))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(g){switch(g){case-1:return this.D;case 0:return this.z;default:return this.w}}G(g){const E=this.L(g);return E?l(E):Object.create(null)}isNew(g){return this.getBoolean(e.$Ko,g)===!0}async flush(g=A.NONE){this.f.fire({reason:g});const E=this.L(-1),v=this.L(0),t=this.L(1);switch(g){case A.NONE:await D.Promises.settled([E?.whenFlushed()??Promise.resolve(),v?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await D.Promises.settled([E?.flush(0)??Promise.resolve(),v?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.L(-1)?.items??new Map,E=this.L(0)?.items??new Map,v=this.L(1)?.items??new Map;return u(g,E,v,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(g,E){return this.r(A.NONE),(0,$.$qk)(g)?this.N(g,E):this.O(g,E)}H(g,E){return!(g.id===E.id||m(E)&&m(g))}I(g,E,v){this.t(()=>{const t=new Set;for(const[s,a]of g)t.add(s),E.get(s)!==a&&this.n(v,{key:s,external:!0});for(const[s]of E.items)t.has(s)||this.n(v,{key:s,external:!0})})}}e.$Oo=d;function m(h){return h.isDefault||!!h.useDefaultFlags?.globalState}e.$Po=m;class c extends d{constructor(){super(),this.p=this.B(new P.$Io(new P.$Jo,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new P.$Io(new P.$Jo,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new P.$Io(new P.$Jo,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(g=>this.n(1,g))),this.B(this.P.onDidChangeStorage(g=>this.n(0,g))),this.B(this.p.onDidChangeStorage(g=>this.n(-1,g)))}L(g){switch(g){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(g){return!1}}e.$Qo=c;async function u(h,g,E,v,t,s){const a=j=>{try{return JSON.parse(j)}catch{return j}},i=new Map,n=new Map;h.forEach((j,Q)=>{i.set(Q,j),n.set(Q,a(j))});const o=new Map,f=new Map;g.forEach((j,Q)=>{o.set(Q,j),f.set(Q,a(j))});const b=new Map,y=new Map;E.forEach((j,Q)=>{b.set(Q,j),y.set(Q,a(j))}),console.group(v!==t?`Storage: Application (path: ${v})`:`Storage: Application & Profile (path: ${v}, default profile)`);const S=[];if(i.forEach((j,Q)=>{S.push({key:Q,value:j})}),console.table(S),console.groupEnd(),console.log(n),v!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const j=[];o.forEach((Q,le)=>{j.push({key:le,value:Q})}),console.table(j),console.groupEnd(),console.log(f)}console.group(`Storage: Workspace (path: ${s})`);const L=[];b.forEach((j,Q)=>{L.push({key:Q,value:j})}),console.table(L),console.groupEnd(),console.log(y)}e.$Ro=u}),define(pe[126],be([1,0,18,20,11,3,30,10,4,24,25,31,37,79,16,12,26,44,242,258,32,58]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l,d,m,c,u,h,g,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=e.$Uo=void 0;const t=C.$o?"web":(0,k.$Mn)(C.$t,I.$3c),s="X-Market-Search-Activity-Id";var a;(function(R){R[R.None=0]="None",R[R.IncludeVersions=1]="IncludeVersions",R[R.IncludeFiles=2]="IncludeFiles",R[R.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",R[R.IncludeSharedAccounts=8]="IncludeSharedAccounts",R[R.IncludeVersionProperties=16]="IncludeVersionProperties",R[R.ExcludeNonValidated=32]="ExcludeNonValidated",R[R.IncludeInstallationTargets=64]="IncludeInstallationTargets",R[R.IncludeAssetUri=128]="IncludeAssetUri",R[R.IncludeStatistics=256]="IncludeStatistics",R[R.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",R[R.Unpublished=4096]="Unpublished",R[R.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(a||(a={}));function i(...R){return String(R.reduce((F,W)=>F|W,0))}var n;(function(R){R[R.Tag=1]="Tag",R[R.ExtensionId=4]="ExtensionId",R[R.Category=5]="Category",R[R.ExtensionName=7]="ExtensionName",R[R.Target=8]="Target",R[R.Featured=9]="Featured",R[R.SearchText=10]="SearchText",R[R.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},f={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class S{constructor(F=y){this.d=F}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(F,W=this.d.pageSize){return new S({...this.d,pageNumber:F,pageSize:W})}withFilter(F,...W){const ie=[...this.d.criteria,...W.length?W.map(re=>({filterType:F,value:re})):[{filterType:F}]];return new S({...this.d,criteria:ie})}withSortBy(F){return new S({...this.d,sortBy:F})}withSortOrder(F){return new S({...this.d,sortOrder:F})}withFlags(...F){return new S({...this.d,flags:F.reduce((W,ie)=>W|ie,0)})}withAssetTypes(...F){return new S({...this.d,assetTypes:F})}withSource(F){return new S({...this.d,source:F})}get raw(){const{criteria:F,pageNumber:W,pageSize:ie,sortBy:re,sortOrder:_,flags:oe,assetTypes:N}=this.d;return{filters:[{criteria:F,pageNumber:W,pageSize:ie,sortBy:re,sortOrder:_}],assetTypes:N,flags:oe}}get searchText(){const F=this.d.criteria.filter(W=>W.filterType===n.SearchText)[0];return F&&F.value?F.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(F=>String(F.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function L(R,F){const W=(R||[]).filter(ie=>ie.statisticName===F)[0];return W?W.value:0}function j(R){const F="Microsoft.VisualStudio.Code.Translation.";return R.files.filter(ie=>ie.assetType.indexOf(F)===0).reduce((ie,re)=>{const _=Y(R,re.assetType);return _&&ie.push([re.assetType.substring(F.length),_]),ie},[])}function Q(R){if(R.properties){const F=R.properties.filter(re=>re.key===o.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=F.filter(re=>W.test(re.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return Y(R,o.Repository)}function le(R){return{uri:`${R.fallbackAssetUri}/${o.VSIX}?redirect=true${R.targetPlatform?`&targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${o.VSIX}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}}function Y(R,F){return R.files.filter(ie=>ie.assetType===F)[0]?{uri:`${R.assetUri}/${F}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${F}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}:null}function ee(R,F){const W=R.properties?R.properties.filter(re=>re.key===F):[],ie=W.length>0&&W[0].value;return ie?ie.split(",").map(re=>(0,p.$lo)(re)):[]}function ue(R){const F=R.properties?R.properties.filter(W=>W.key===f.Engine):[];return F.length>0&&F[0].value||""}function X(R){const F=R.properties?R.properties.filter(W=>W.key===f.PreRelease):[];return F.length>0&&F[0].value==="true"}function he(R){const F=R.properties?R.properties.filter(ie=>ie.key===f.LocalizedLanguages):[],W=F.length>0&&F[0].value||"";return W?W.split(","):[]}function x(R){return R.properties?.find(F=>F.key===f.SponsorLink)?.value}function se(R){return R.indexOf("preview")!==-1}function V(R){return R.targetPlatform?(0,k.$Ln)(R.targetPlatform):"undefined"}function K(R){const F=(0,D.$of)(R.versions.map(V)),W=!!R.tags?.includes(k.$Gn),ie=F.indexOf("web");return W?ie===-1&&F.push("web"):ie!==-1&&F.splice(ie,1),F}function H(R,F){const W=(0,k.$Pn)(F);for(let ie=0;ie<R.length;ie++){const re=R[ie];if(re.version===R[ie-1]?.version){let _=ie;const oe=V(re);if(oe===F)for(;_>0&&R[_-1].version===re.version;)_--;else if(W.includes(oe))for(;_>0&&R[_-1].version===re.version&&V(R[_-1])!==F;)_--;_!==ie&&(R.splice(ie,1),R.splice(_,0,re))}}return R}e.$Uo=H;function te(R,F,W){R.telemetryData={index:F,querySource:W,queryActivityId:R.queryContext?.[s]}}function me(R,F,W,ie){const re=R.versions[0],_={manifest:Y(F,o.Manifest),readme:Y(F,o.Details),changelog:Y(F,o.Changelog),license:Y(F,o.License),repository:Q(F),download:le(F),icon:Y(F,o.Icon),signature:Y(F,o.Signature),coreTranslations:j(F)};return{identifier:{id:(0,p.$mo)(R.publisher.publisherName,R.extensionName),uuid:R.extensionId},name:R.extensionName,version:F.version,displayName:R.displayName,publisherId:R.publisher.publisherId,publisher:R.publisher.publisherName,publisherDisplayName:R.publisher.displayName,publisherDomain:R.publisher.domain?{link:R.publisher.domain,verified:!!R.publisher.isDomainVerified}:void 0,publisherSponsorLink:x(re),description:R.shortDescription||"",installCount:L(R.statistics,"install"),rating:L(R.statistics,"averagerating"),ratingCount:L(R.statistics,"ratingcount"),categories:R.categories||[],tags:R.tags||[],releaseDate:Date.parse(R.releaseDate),lastUpdated:Date.parse(R.lastUpdated),allTargetPlatforms:W,assets:_,properties:{dependencies:ee(F,f.Dependency),extensionPack:ee(F,f.ExtensionPack),engine:ue(F),localizedLanguages:he(F),targetPlatform:V(F),isPreReleaseVersion:X(F)},hasPreReleaseVersion:X(re),hasReleaseVersion:!0,preview:se(R.flags),isSigned:!!_.signature,queryContext:ie}}let ne=class{constructor(F,W,ie,re,_,oe,N,B){this.k=W,this.l=ie,this.n=re,this.o=_,this.q=oe,this.u=N,this.w=B;const U=N.extensionsGallery,z=U?.servicePPEUrl&&B.getValue("_extensionsGallery.enablePPE");this.d=z?U.servicePPEUrl:U?.serviceUrl,this.g=z?void 0:U?.searchUrl,this.h=U?.controlUrl,this.j=(0,h.$To)(N.version,N,this.n,this.w,this.q,F,this.o)}x(F=""){return`${this.d}${F}`}isEnabled(){return!!this.d}async getExtensions(F,W,ie){const re=O.CancellationToken.isCancellationToken(W)?{}:W,_=O.CancellationToken.isCancellationToken(W)?W:ie,oe=[],N=[],B=[],U=[];let z=!0;for(const Ee of F){Ee.uuid?N.push(Ee.uuid):oe.push(Ee.id);const Pe=!!(Ee.version||Ee.preRelease);B.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Pe}),Ee.version&&U.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),z=z&&!!Ee.hasPreRelease&&!Pe}if(!N.length&&!oe.length)return[];let Z=new S().withPage(1,F.length);N.length&&(Z=Z.withFilter(n.ExtensionId,...N)),oe.length&&(Z=Z.withFilter(n.ExtensionName,...oe)),(re.queryAllVersions||z)&&(Z=Z.withFlags(Z.flags,a.IncludeVersions)),re.source&&(Z=Z.withSource(re.source));const{extensions:de}=await this.z(Z,{targetPlatform:re.targetPlatform??t,includePreRelease:B,versions:U,compatible:!!re.compatible},_);return re.source&&de.forEach((Ee,Pe)=>te(Ee,Pe,re.source)),de}async getCompatibleExtension(F,W,ie){if((0,k.$Nn)(F.allTargetPlatforms,ie))return null;if(await this.isExtensionCompatible(F,W,ie))return F;const re=new S().withFlags(a.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,F.identifier.uuid),{extensions:_}=await this.z(re,{targetPlatform:ie,compatible:!0,includePreRelease:W},O.CancellationToken.None);return _[0]||null}async isExtensionCompatible(F,W,ie){if(!(0,k.$On)(F.properties.targetPlatform,F.allTargetPlatforms,ie)||!W&&F.properties.isPreReleaseVersion)return!1;let re=F.properties.engine;if(!re){const _=await this.getManifest(F,O.CancellationToken.None);if(!_)throw new Error("Manifest was not found");re=_.engines.vscode}return(0,l.$zo)(re,this.u.version,this.u.date)}async y(F,W,ie,re,_){if(!(0,k.$On)(V(F),re,_)||W!=="any"&&X(F)!==(W==="prerelease"))return!1;if(ie)try{const oe=await this.E(F);if(!(0,l.$zo)(oe,this.u.version,this.u.date))return!1}catch(oe){return this.l.error(`Error while getting the engine for the version ${F.version}.`,(0,r.$9)(oe)),!1}return!0}async query(F,W){let ie=F.text||"";const re=F.pageSize??50;let _=new S().withPage(1,re);ie?(ie=ie.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(z,Z,de)=>(_=_.withFilter(n.Category,de||Z),"")),ie=ie.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(z,Z,de)=>(_=_.withFilter(n.Tag,de||Z),"")),ie=ie.replace(/\bfeatured(\s+|\b|$)/g,()=>(_=_.withFilter(n.Featured),"")),ie=ie.trim(),ie&&(ie=ie.length<200?ie:ie.substring(0,200),_=_.withFilter(n.SearchText,ie)),_=_.withSortBy(0)):F.ids?_=_.withFilter(n.ExtensionId,...F.ids):F.names?_=_.withFilter(n.ExtensionName,...F.names):_=_.withSortBy(4),typeof F.sortBy=="number"&&(_=_.withSortBy(F.sortBy)),typeof F.sortOrder=="number"&&(_=_.withSortOrder(F.sortOrder)),F.source&&(_=_.withSource(F.source));const oe=async(z,Z)=>{const{extensions:de,total:Ee}=await this.z(z,{targetPlatform:t,compatible:!1,includePreRelease:!!F.includePreRelease},Z);return de.forEach((Pe,Ae)=>te(Pe,(z.pageNumber-1)*z.pageSize+Ae,F.source)),{extensions:de,total:Ee}},{extensions:N,total:B}=await oe(_,W),U=async(z,Z)=>{if(Z.isCancellationRequested)throw new r.$3;const{extensions:de}=await oe(_.withPage(z+1),Z);return de};return{firstPage:N,total:B,pageSize:_.pageSize,getPage:U}}async z(F,W,ie){const re=F.flags;F.flags&a.IncludeLatestVersionOnly&&F.flags&a.IncludeVersions&&(F=F.withFlags(F.flags&~a.IncludeVersions,a.IncludeLatestVersionOnly)),!(F.flags&a.IncludeLatestVersionOnly)&&!(F.flags&a.IncludeVersions)&&(F=F.withFlags(F.flags,a.IncludeLatestVersionOnly)),W.versions?.length&&(F=F.withFlags(F.flags&~a.IncludeLatestVersionOnly,a.IncludeVersions)),F=F.withFlags(F.flags,a.IncludeAssetUri,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeStatistics,a.IncludeVersionProperties);const{galleryExtensions:_,total:oe,context:N}=await this.B(F,ie);if(!(F.flags&a.IncludeLatestVersionOnly)){const Z=[];for(const de of _){const Ee=await this.A(de,W,N);Ee&&Z.push(Ee)}return{extensions:Z,total:oe}}const U=[],z=new Map;for(let Z=0;Z<_.length;Z++){const de=_[Z],Ee={id:(0,p.$mo)(de.publisher.publisherName,de.extensionName),uuid:de.extensionId},Pe=(0,P.$oe)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(Fe=>(0,p.$ho)(Fe,Ee))?.includePreRelease;if(W.compatible&&(0,k.$Nn)(K(de),W.targetPlatform))continue;const Ae=await this.A(de,W,N);!Ae||Ae.properties.isPreReleaseVersion&&(!Pe||!Ae.hasReleaseVersion)||!Ae.properties.isPreReleaseVersion&&Ae.properties.targetPlatform!==W.targetPlatform&&Ae.hasPreReleaseVersion?z.set(de.extensionId,Z):U.push([Z,Ae])}if(z.size){const Z=new v.$ac,de=new S().withFlags(re&~a.IncludeLatestVersionOnly,a.IncludeVersions).withPage(1,z.size).withFilter(n.ExtensionId,...z.keys()),{extensions:Ee}=await this.z(de,W,ie);this.o.publicLog2("galleryService:additionalQuery",{duration:Z.elapsed(),count:z.size});for(const Pe of Ee){const Ae=z.get(Pe.identifier.uuid);U.push([Ae,Pe])}}return{extensions:U.sort((Z,de)=>Z[0]-de[0]).map(([,Z])=>Z),total:oe}}async A(F,W,ie){const re={id:(0,p.$mo)(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},_=W.versions?.find(U=>(0,p.$ho)(U,re))?.version,oe=(0,P.$oe)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(U=>(0,p.$ho)(U,re))?.includePreRelease,N=K(F),B=H(F.versions,W.targetPlatform);if(W.compatible&&(0,k.$Nn)(N,W.targetPlatform))return null;for(let U=0;U<B.length;U++){const z=B[U];if(!(_&&z.version!==_)){if(await this.y(z,oe?"any":"release",W.compatible,N,W.targetPlatform))return me(F,z,N,ie);if(_&&z.version===_)return null}}return _||W.compatible?null:me(F,F.versions[0],N)}async B(F,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");F=F.withFlags(F.flags,a.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(a.Unpublished));const ie=await this.j,re=JSON.stringify(F.raw),_={...ie,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(re.length)},oe=new v.$ac;let N,B,U=0;try{if(N=await this.k.request({type:"POST",url:this.g&&F.criteria.some(Z=>Z.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:re,headers:_},W),N.res.statusCode&&N.res.statusCode>=400&&N.res.statusCode<500)return{galleryExtensions:[],total:U};const z=await(0,u.$Fo)(N);if(z){const Z=z.results[0],de=Z.extensions,Ee=Z.resultMetadata&&Z.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return U=Ee&&Ee.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:U,context:{[s]:N.res.headers.activityid}}}return{galleryExtensions:[],total:U}}catch(z){throw B=z,z}finally{this.o.publicLog2("galleryService:query",{...F.telemetryData,requestBodySize:String(re.length),duration:oe.elapsed(),success:!!N&&(0,u.$Co)(N),responseBodySize:N?.res.headers["Content-Length"],statusCode:N?String(N.res.statusCode):void 0,errorCode:B?(0,r.$2)(B)?"canceled":(0,r.$9)(B).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(U)})}}async reportStatistic(F,W,ie,re){if(!this.isEnabled())return;const _=C.$o?this.x(`/itemName/${F}.${W}/version/${ie}/statType/${re==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${F}/extensions/${W}/${ie}/stats?statType=${re}`),oe=C.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",B={...await this.j,Accept:oe};try{await this.k.request({type:"POST",url:_,headers:B},O.CancellationToken.None)}catch{}}async download(F,W,ie){this.l.trace("ExtensionGalleryService#download",F.identifier.id);const re=(0,p.$po)(F),_=new Date().getTime(),oe=Z=>this.o.publicLog("galleryService:downloadVSIX",{...re,duration:Z}),N=ie===2?"install":ie===3?"update":"",B=N?{uri:`${F.assets.download.uri}${w.URI.parse(F.assets.download.uri).query?"&":"?"}${N}=true`,fallbackUri:`${F.assets.download.fallbackUri}${w.URI.parse(F.assets.download.fallbackUri).query?"&":"?"}${N}=true`}:F.assets.download,U=F.queryContext?.[s]?{[s]:F.queryContext[s]}:void 0,z=await this.D(B,U?{headers:U}:void 0);await this.q.writeFile(W,z.stream),oe(new Date().getTime()-_)}async downloadSignatureArchive(F,W){if(!F.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",F.identifier.id);const ie=await this.D(F.assets.signature);await this.q.writeFile(W,ie.stream)}async getReadme(F,W){if(F.assets.readme){const ie=await this.D(F.assets.readme,{},W);return await(0,u.$Eo)(ie)||""}return""}async getManifest(F,W){if(F.assets.manifest){const ie=await this.D(F.assets.manifest,{},W),re=await(0,u.$Eo)(ie);return re?JSON.parse(re):null}return null}async C(F,W){const ie=Y(F,o.Manifest);if(!ie)throw new Error("Manifest was not found");const re={"Accept-Encoding":"gzip"},_=await this.D(ie,{headers:re});return await(0,u.$Fo)(_)}async getCoreTranslation(F,W){const ie=F.assets.coreTranslations.filter(re=>re[0]===W.toUpperCase())[0];if(ie){const re=await this.D(ie[1]),_=await(0,u.$Eo)(re);return _?JSON.parse(_):null}return null}async getChangelog(F,W){if(F.assets.changelog){const ie=await this.D(F.assets.changelog,{},W);return await(0,u.$Eo)(ie)||""}return""}async getAllCompatibleVersions(F,W,ie){let re=new S().withFlags(a.IncludeVersions,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1);F.identifier.uuid?re=re.withFilter(n.ExtensionId,F.identifier.uuid):re=re.withFilter(n.ExtensionName,F.identifier.id);const{galleryExtensions:_}=await this.B(re,O.CancellationToken.None);if(!_.length)return[];const oe=K(_[0]);if((0,k.$Nn)(oe,ie))return[];const N=[];await Promise.all(_[0].versions.map(async z=>{try{await this.y(z,W?"any":"release",!0,oe,ie)&&N.push(z)}catch{}}));const B=[],U=new Set;for(const z of H(N,ie))U.has(z.version)||(U.add(z.version),B.push({version:z.version,date:z.lastUpdated,isPreReleaseVersion:X(z)}));return B}async D(F,W={},ie=O.CancellationToken.None){const re=await this.j,_={type:"GET"},oe={...re,...W.headers||{}};W={...W,..._,headers:oe};const N=F.uri,B=F.fallbackUri,U={...W,url:N};try{const z=await this.k.request(U,ie);if(z.res.statusCode===200)return z;const Z=await(0,u.$Eo)(z);throw new Error(`Expected 200, got back ${z.res.statusCode} instead.

${Z}`)}catch(z){if((0,r.$2)(z))throw z;const Z=(0,r.$9)(z);this.o.publicLog2("galleryService:cdnFallback",{url:N,message:Z});const de={...W,url:B};return this.k.request(de,ie)}}async E(F){let W=ue(F);if(!W){const ie=await this.C(F,O.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");W=ie.engines.vscode}return W}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const F=await this.k.request({type:"GET",url:this.h},O.CancellationToken.None);if(F.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,u.$Fo)(F),ie=[],re={},_=[];if(W){for(const oe of W.malicious)ie.push({id:oe});if(W.migrateToPreRelease)for(const[oe,N]of Object.entries(W.migrateToPreRelease))(!N.engine||(0,l.$zo)(N.engine,this.u.version,this.u.date))&&(re[oe.toLowerCase()]={disallowInstall:!0,extension:{id:N.id,displayName:N.displayName,autoMigrate:{storage:!!N.migrateStorage},preRelease:!0}});if(W.deprecated)for(const[oe,N]of Object.entries(W.deprecated))N&&(re[oe.toLowerCase()]=(0,P.$oe)(N)?{}:N);if(W.search)for(const oe of W.search)_.push(oe)}return{malicious:ie,deprecated:re,search:_}}};ne=Le([Ie(1,u.$Ao),Ie(2,m.$Ri),Ie(3,A.$wh),Ie(4,E.$Vk),Ie(5,d.$Sj),Ie(6,c.$0i),Ie(7,$.$Vh)],ne);let q=class extends ne{constructor(F,W,ie,re,_,oe,N,B){super(F,W,ie,re,_,oe,N,B)}};e.$Vo=q,e.$Vo=q=Le([Ie(0,g.$Mo),Ie(1,u.$Ao),Ie(2,m.$Ri),Ie(3,A.$wh),Ie(4,E.$Vk),Ie(5,d.$Sj),Ie(6,c.$0i),Ie(7,$.$Vh)],q);let J=class extends ne{constructor(F,W,ie,re,_,oe,N){super(void 0,F,W,ie,re,_,oe,N)}};e.$Wo=J,e.$Wo=J=Le([Ie(0,u.$Ao),Ie(1,m.$Ri),Ie(2,A.$wh),Ie(3,E.$Vk),Ie(4,d.$Sj),Ie(5,c.$0i),Ie(6,$.$Vh)],J)}),define(pe[259],be([1,0,5,2,33,51]),function(ce,e,D,O,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dN=e.$cN=void 0;class I{constructor($,A){this.a=$,this.b=A}listen($,A){const k=this.b($);switch(A){case"onDidChangeProfiles":return D.Event.map(this.a.onDidChangeProfiles,p=>({all:p.all.map(l=>(0,C.$qm)({...l},k)),added:p.added.map(l=>(0,C.$qm)({...l},k)),removed:p.removed.map(l=>(0,C.$qm)({...l},k)),updated:p.updated.map(l=>(0,C.$qm)({...l},k))}))}throw new Error(`Invalid listen ${A}`)}async call($,A,k){const p=this.b($);switch(A){case"createProfile":{const l=await this.a.createProfile(k[0],k[1],k[2]);return(0,C.$qm)({...l},p)}case"updateProfile":{let l=(0,r.$sk)((0,C.$rm)(k[0],p),this.a.profilesHome.scheme);return l=await this.a.updateProfile(l,k[1]),(0,C.$qm)({...l},p)}case"removeProfile":{const l=(0,r.$sk)((0,C.$rm)(k[0],p),this.a.profilesHome.scheme);return this.a.removeProfile(l)}}throw new Error(`Invalid call ${A}`)}}e.$cN=I;class P extends O.$lb{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor($,A,k){super(),this.profilesHome=A,this.f=k,this.a=[],this.b=this.B(new D.$ec),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=$.map(p=>(0,r.$sk)(p,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(p=>{const l=p.added.map(c=>(0,r.$sk)(c,this.profilesHome.scheme)),d=p.removed.map(c=>(0,r.$sk)(c,this.profilesHome.scheme)),m=p.updated.map(c=>(0,r.$sk)(c,this.profilesHome.scheme));this.a=p.all.map(c=>(0,r.$sk)(c,this.profilesHome.scheme)),this.b.fire({added:l,removed:d,updated:m,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement($){this.c=$}isEnabled(){return this.c}async createNamedProfile($,A,k){const p=await this.f.call("createNamedProfile",[$,A,k]);return(0,r.$sk)(p,this.profilesHome.scheme)}async createProfile($,A,k,p){const l=await this.f.call("createProfile",[$,A,k,p]);return(0,r.$sk)(l,this.profilesHome.scheme)}async createTransientProfile($){const A=await this.f.call("createTransientProfile",[$]);return(0,r.$sk)(A,this.profilesHome.scheme)}async setProfileForWorkspace($,A){await this.f.call("setProfileForWorkspace",[$,A])}removeProfile($){return this.f.call("removeProfile",[$])}async updateProfile($,A){const k=await this.f.call("updateProfile",[$,A]);return(0,r.$sk)(k,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$dN=P}),define(pe[127],be([1,0,4,25,16,12,236,34,33,10,237]),function(ce,e,D,O,r,C,I,P,w,$,A){"use strict";var k,p;Object.defineProperty(e,"__esModule",{value:!0}),e.$7M=e.$6M=e.$5M=void 0;let l=class extends w.$uk{static{k=this}static{this.a="profileAssociationsMigration"}constructor(u,h,g,E,v){super(g,E,h,v),this.P=u,this.Q=g}J(){return this.P.getItem(k.b,[]).map(h=>({...h,location:(0,$.$ie)(h.location)?this.s.extUri.joinPath(this.profilesHome,h.location):D.URI.revive(h.location)}))}M(){const u=this.P.getItem(k.c,{});return this.P.getItem(k.a,!1)?u:this.I(u)}O(){return this.s.extUri.joinPath(D.URI.file(this.Q.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$5M=l,e.$5M=l=k=Le([Ie(0,I.$ZM),Ie(1,P.$pk),Ie(2,O.$xh),Ie(3,r.$Sj),Ie(4,C.$Ri)],l);let d=p=class extends l{constructor(u,h,g,E,v){super(u,h,g,E,v),this.W=u}L(u){u.length?this.W.setItem(p.b,u.map(h=>({...h,location:this.s.extUri.basename(h.location)}))):this.W.removeItem(p.b)}J(){const u=super.J();return this.W.getItem("userDataProfilesMigration",!1)||(this.L(u),this.W.setItem("userDataProfilesMigration",!0)),u}N(u){u.emptyWindows||u.workspaces?this.W.setItem(p.c,u):this.W.removeItem(p.c)}M(){const u="workspaceAndProfileInfo",h=this.W.getItem(u,void 0);if(h){this.W.removeItem(u);const E=h.reduce((v,{workspace:t,profile:s})=>(v[D.URI.revive(t).toString()]=D.URI.revive(s).toString(),v),{});this.W.setItem(p.c,{workspaces:E})}const g=super.M();return this.W.getItem(p.a,!1)||(this.N(g),this.W.setItem(p.a,!0)),g}};e.$6M=d,e.$6M=d=p=Le([Ie(0,I.$1M),Ie(1,P.$pk),Ie(2,O.$xh),Ie(3,r.$Sj),Ie(4,C.$Ri)],d);let m=class extends d{constructor(u,h,g,E){super(new A.$4M(0,h,E,g),u,h,g,E)}async init(){return await this.W.init(),super.init()}};e.$7M=m,e.$7M=m=Le([Ie(0,P.$pk),Ie(1,O.$xh),Ie(2,r.$Sj),Ie(3,C.$Ri)],m)}),define(pe[128],be([1,0,6]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_l=e.$$l=void 0,e.$$l=(0,D.$ph)("extensionHostStatusService");class O{constructor(){this.a=new Map}setExitInfo(C,I){this.a.set(C,I)}getExitInfo(C){return this.a.get(C)||null}}e.$_l=O}),define(pe[260],be([1,0,5,14]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hm=void 0;function r(I){let P=0,w=0,$=0;I>=1e3&&($=Math.floor(I/1e3),I-=$*1e3),$>=60&&(w=Math.floor($/60),$-=w*60),w>=60&&(P=Math.floor(w/60),w-=P*60);const A=P?`${P}h`:"",k=w?`${w}m`:"",p=$?`${$}s`:"",l=I?`${I}ms`:"";return`${A}${k}${p}${l}`}class C{constructor(P,w,$,A){this.i=P,this.j=w,this.a=new D.$ec,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=$,this.protocol=A,this.e=!1,this.f=new O.$Hg(()=>{this.k(`The reconnection grace time of ${r(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new O.$Hg(()=>{this.k(`The reconnection short grace time of ${r(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${r(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(P){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${P}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${r(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const P=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),P.end(),this.a.fire(void 0)}acceptReconnection(P,w,$){this.d=P,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(w,$),this.protocol.endAcceptReconnection()}}e.$hm=C}),define(pe[129],be([1,0,28,13,7,150,54]),function(ce,e,D,O,r,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.$6k=void 0;const P=r.$8c(O.$1e.asFileUri("").fsPath,"nls.metadata.json"),w=new Map;function $(p){return new Promise(l=>D.exists(p,l))}function A(p,l){return $(P).then(d=>{if(!d||!I.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const m=`${p}||${l}`;let c=w.get(m);return c||(c=C.getNLSConfiguration(I.default.commit,l,P,p,p).then(u=>(k.is(u)&&(u._languagePackSupport=!0),u)),w.set(m,c)),c})}e.$6k=A;var k;(function(p){function l(d){const m=d;return m&&typeof m._languagePackId=="string"}p.is=l})(k||(e.InternalNLSConfiguration=k={}))}),define(pe[130],be([1,0,19,4,25,45,57,16,6,12,26,34,33,129]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UM=void 0;let d=class extends I.$gp{constructor(c,u,h,g,E,v,t,s){super(O.URI.file(E.builtinExtensionsPath),O.URI.file(E.extensionsPath),(0,D.$9f)(E.userHome,".vscode-oss-dev","extensions","control.json"),c.defaultProfile,c,u,h,g,E,v,t,s),this.N=E}async f(c){const u=await(0,l.$6k)(c,this.N.userDataPath);if(l.InternalNLSConfiguration.is(u))try{const h=await this.s.readFile(O.URI.file(u._translationsConfigFile));return JSON.parse(h.value.toString())}catch{}return Object.create(null)}};e.$UM=d,e.$UM=d=Le([Ie(0,p.$rk),Ie(1,C.$bp),Ie(2,P.$Sj),Ie(3,$.$Ri),Ie(4,r.$xh),Ie(5,A.$0i),Ie(6,k.$pk),Ie(7,w.$oh)],d)}),define(pe[261],be([1,0,262,28,7,23,13,21]),function(ce,e,D,O,r,C,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.ServerConnectionTokenType=void 0;const w=/^[0-9A-Za-z_-]+$/;var $;(function(c){c[c.None=0]="None",c[c.Optional=1]="Optional",c[c.Mandatory=2]="Mandatory"})($||(e.ServerConnectionTokenType=$={}));class A{constructor(){this.type=0}validate(u){return!0}}e.$im=A;class k{constructor(u){this.value=u,this.type=2}validate(u){return u===this.value}}e.$jm=k;class p{constructor(u){this.message=u}}e.$km=p;async function l(c,u){const h=c["without-connection-token"],g=c["connection-token"],E=c["connection-token-file"];if(h)return typeof g<"u"||typeof E<"u"?new p("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new A;if(typeof E<"u"){if(typeof g<"u")return new p("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let v;try{v=O.readFileSync(E).toString().replace(/\r?\n$/,"")}catch{return new p(`Unable to read the connection token file at '${E}'.`)}return w.test(v)?new k(v):new p(`The connection token defined in '${E} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof g<"u"?w.test(g)?new k(g):new p(`The connection token '${g} does not adhere to the characters 0-9, a-z, A-Z or -.`):new k(await u())}e.$lm=l;async function d(c){return l(c,async()=>{if(!c["user-data-dir"])return(0,C.$3e)();const h=r.$8c(c["user-data-dir"],"token");try{const v=(await P.Promises.readFile(h)).toString().replace(/\r?\n$/,"");if(w.test(v))return v}catch{}const g=(0,C.$3e)();try{await P.Promises.writeFile(h,g,{mode:384})}catch{}return g})}e.$mm=d;function m(c,u,h){if(c.validate(h.query[I.$Ue]))return!0;const g=D.parse(u.headers.cookie||"");return c.validate(g[I.$Te])}e.$nm=m}),define(pe[46],be([1,0,199,109,64,6,25,73]),function(ce,e,D,O,r,C,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4l=e.$3l=e.$2l=void 0,e.$2l={host:{type:"string",cat:"o",args:"ip-address",description:D.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:D.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:D.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:D.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:D.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:D.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:D.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:D.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:D.localize(8,null)},"user-data-dir":r.$ll["user-data-dir"],"enable-smoke-test-driver":r.$ll["enable-smoke-test-driver"],"disable-telemetry":r.$ll["disable-telemetry"],"disable-workspace-trust":r.$ll["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:r.$ll.log,logsPath:r.$ll.logsPath,"force-disable-user-env":r.$ll["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:D.localize(9,null)},"default-workspace":{type:"string",description:D.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"use-test-resolver":{type:"boolean"},"extensions-dir":r.$ll["extensions-dir"],"extensions-download-dir":r.$ll["extensions-download-dir"],"builtin-extensions-dir":r.$ll["builtin-extensions-dir"],"install-extension":r.$ll["install-extension"],"install-builtin-extension":r.$ll["install-builtin-extension"],"uninstall-extension":r.$ll["uninstall-extension"],"list-extensions":r.$ll["list-extensions"],"locate-extension":r.$ll["locate-extension"],"show-versions":r.$ll["show-versions"],category:r.$ll.category,force:r.$ll.force,"do-not-sync":r.$ll["do-not-sync"],"pre-release":r.$ll["pre-release"],"start-server":{type:"boolean",cat:"e",description:D.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:r.$ll.help,version:r.$ll.version,"locate-shell-integration-path":r.$ll["locate-shell-integration-path"],compatibility:{type:"string"},_:r.$ll._},e.$3l=(0,C.$qh)(I.$wh);class w extends O.$Yl{get userRoamingDataHome(){return this.appSettingsHome}get args(){return super.args}}e.$4l=w,Le([P.$Tg],w.prototype,"userRoamingDataHome",null)}),define(pe[263],be([1,0,28,21,76,85,262,87,39,62,3,12,46,7,13,23,26,44,20,4,15,10,56]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l,d,m,c,u,h,g,E,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jN=e.$iN=e.CacheControl=e.$hN=void 0;const s={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function a(b,y,S,L){y.writeHead(S,{"Content-Type":"text/plain"}),y.end(L)}e.$hN=a;var i;(function(b){b[b.NO_CACHING=0]="NO_CACHING",b[b.ETAG=1]="ETAG",b[b.NO_EXPIRY=2]="NO_EXPIRY"})(i||(e.CacheControl=i={}));async function n(b,y,S,L,j,Q){try{const le=await O.Promises.stat(b);if(y===1){const Y=`W/"${[le.ino,le.size,le.mtime.getTime()].join("-")}"`;if(L.headers["if-none-match"]===Y)return j.writeHead(304),void j.end();Q.Etag=Y}else y===2?Q["Cache-Control"]="public, max-age=31536000":y===0&&(Q["Cache-Control"]="no-store");Q["Content-Type"]=s[(0,l.$ad)(b)]||(0,$.$Ar)(b)||"text/plain",j.writeHead(200,Q),(0,D.createReadStream)(b).pipe(j)}catch(le){return le.code!=="ENOENT"?(S.error(le),console.error(le.toString())):console.error(`File not found: ${b}`),j.writeHead(404,{"Content-Type":"text/plain"}),void j.end("Not found")}}e.$iN=n;const o=(0,l.$$c)(d.$1e.asFileUri("").fsPath);let f=class{constructor(y,S,L,j,Q){this.f=y,this.g=S,this.h=L,this.i=j,this.j=Q,this.a=this.j.extensionsGallery?.resourceUrlTemplate?g.URI.parse(this.j.extensionsGallery.resourceUrlTemplate):void 0;const le=(0,t.$Dk)(Q);this.b=`${le}/static`,this.c=`${le}/callback`,this.d=`${le}/web-extension-resource`}async handle(y,S,L){try{const j=L.pathname;return j.startsWith(this.b)&&j.charCodeAt(this.b.length)===47?this.k(y,S,L):j==="/"?this.n(y,S,L):j===this.c?this.p(S):j.startsWith(this.d)&&j.charCodeAt(this.d.length)===47?this.m(y,S,L):a(y,S,404,"Not found.")}catch(j){return this.h.error(j),console.error(j.toString()),a(y,S,500,"Internal Server Error.")}}async k(y,S,L){const j=Object.create(null),le=decodeURIComponent(L.pathname).substring(this.b.length+1),Y=(0,l.$8c)(o,le);return(0,w.$He)(Y,o,!A.$k)?n(Y,this.g.isBuilt?2:1,this.h,y,S,j):a(y,S,400,"Bad request.")}l(y){const S=y.authority.indexOf(".");return S!==-1?y.authority.substring(S+1):void 0}async m(y,S,L){if(!this.a)return a(y,S,500,"No extension gallery service configured.");const j=decodeURIComponent(L.pathname),Q=(0,l.$6c)(j.substring(this.d.length+1)),le=g.URI.parse(Q).with({scheme:this.a.scheme,authority:Q.substring(0,Q.indexOf("/")),path:Q.substring(Q.indexOf("/")+1)});if(this.l(this.a)!==this.l(le))return a(y,S,403,"Request Forbidden");const Y={},ee=V=>{const K=y.headers[V];K&&((0,v.$ie)(K)||K[0])?Y[V]=(0,v.$ie)(K)?K:K[0]:V!==V.toLowerCase()&&ee(V.toLowerCase())};ee("X-Client-Name"),ee("X-Client-Version"),ee("X-Machine-Id"),ee("X-Client-Commit");const ue=await this.i.request({type:"GET",url:le.toString(!0),headers:Y},h.CancellationToken.None),X=ue.res.statusCode||500;if(X!==200){let V=null;try{V=await(0,u.$Eo)(ue)}catch{}return a(y,S,X,V||`Request failed with status ${X}`)}const he=Object.create(null),x=V=>{const K=ue.res.headers[V];K?he[V]=K:V!==V.toLowerCase()&&x(V.toLowerCase())};x("Cache-Control"),x("Content-Type"),S.writeHead(200,he);const se=await(0,E.$Qc)(ue.stream);return void S.end(se.buffer)}async n(y,S,L){const j=L.query[d.$Ue];if(typeof j=="string"){const q=Object.create(null);q["Set-Cookie"]=I.serialize(d.$Te,j,{sameSite:"lax",maxAge:60*60*24*7});const J=Object.create(null);for(const F in L.query)F!==d.$Ue&&(J[F]=L.query[F]);const R=C.format({pathname:"/",query:J});return q.Location=R,S.writeHead(302,q),void S.end()}const Q=q=>{const J=y.headers[q];return Array.isArray(J)?J[0]:J},le=!this.g.isBuilt&&this.g.args["use-test-resolver"],Y=le?"test+test":Q("x-original-host")||Q("x-forwarded-host")||y.headers.host;if(!Y)return a(y,S,400,"Bad request.");function ee(q){return JSON.stringify(q).replace(/"/g,"&quot;")}let ue;this.g.args["enable-smoke-test-driver"]&&(ue=!1);const X=q=>q&&g.URI.file(r.resolve(q)).with({scheme:d.Schemas.vscodeRemote,authority:Y}),he=d.$1e.asFileUri(this.g.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,x=!this.g.isBuilt&&this.g.args["github-auth"]?{id:(0,m.$3e)(),providerId:"github",accessToken:this.g.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,se={embedderIdentifier:"server-distro",extensionsGallery:this.a?{...this.j.extensionsGallery,resourceUrlTemplate:this.a.with({scheme:"http",authority:Y,path:`${this.d}/${this.a.authority}${this.a.path}`}).toString(!0)}:void 0};if(!this.g.isBuilt)try{const q=JSON.parse((await O.Promises.readFile((0,l.$8c)(o,"product.overrides.json"))).toString());Object.assign(se,q)}catch{}const V={remoteAuthority:Y,_wrapWebWorkerExtHostInIframe:ue,developmentOptions:{enableSmokeTestDriver:this.g.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.h.getLevel()},settingsSyncOptions:!this.g.isBuilt&&this.g.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.g.args["disable-workspace-trust"],folderUri:X(this.g.args["default-folder"]),workspaceUri:X(this.g.args["default-workspace"]),productConfiguration:se,callbackRoute:this.c},K=this.j.extensionsGallery?.nlsBaseUrl,H={WORKBENCH_WEB_CONFIGURATION:ee(V),WORKBENCH_AUTH_SESSION:x?ee(x):"",WORKBENCH_WEB_BASE_URL:this.b,WORKBENCH_NLS_BASE_URL:K?`${K}${K.endsWith("/")?"":"/"}${this.j.commit}/${this.j.version}/`:""};if(le){const q=[];for(const J of["vscode-test-resolver","github-authentication"]){const R=JSON.parse((await O.Promises.readFile(d.$1e.asFileUri(`${d.$We}/${J}/package.json`).fsPath)).toString());q.push({extensionPath:J,packageJSON:R})}H.WORKBENCH_BUILTIN_EXTENSIONS=ee(q)}let te;try{te=(await O.Promises.readFile(he)).toString().replace(/\{\{([^}]+)\}\}/g,(J,R)=>H[R]??"undefined")}catch{return S.writeHead(404,{"Content-Type":"text/plain"}),void S.end("Not found")}const ne={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.o(te).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=' ${le?"":`http://${Y}`};`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==0&&(ne["Set-Cookie"]=I.serialize(d.$Te,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),S.writeHead(200,ne),void S.end(te)}o(y){const S=/<script>([\s\S]+?)<\/script>/img,L=[];let j;for(;j=S.exec(y);){const Q=P.createHash("sha256"),le=j[1].replace(/\r\n/g,`
`),Y=Q.update(Buffer.from(le)).digest().toString("base64");L.push(`'sha256-${Y}'`)}return L}async p(y){const S=d.$1e.asFileUri("vs/code/browser/workbench/callback.html").fsPath,L=(await O.Promises.readFile(S)).toString(),j=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.o(L).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return y.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":j}),void y.end(L)}};e.$jN=f,e.$jN=f=Le([Ie(1,p.$3l),Ie(2,k.$Ri),Ie(3,u.$Ao),Ie(4,c.$0i)],f)}),define(pe[264],be([1,0,6]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2L=void 0,e.$2L=(0,D.$ph)("IExtHostInitDataService")}),define(pe[265],be([1,0,6]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ML=e.$LL=void 0,e.$LL=(0,D.$ph)("IExtHostRpcService");class O{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.dispose=C.dispose.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.$ML=O}),define(pe[70],be([1,0,51]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;function O(C){return{transformIncoming:I=>I.scheme==="vscode-remote"?{scheme:"file",path:I.path,query:I.query,fragment:I.fragment}:I.scheme==="file"?{scheme:"vscode-local",path:I.path,query:I.query,fragment:I.fragment}:I,transformOutgoing:I=>I.scheme==="file"?{scheme:"vscode-remote",authority:C,path:I.path,query:I.query,fragment:I.fragment}:I.scheme==="vscode-local"?{scheme:"file",path:I.path,query:I.query,fragment:I.fragment}:I,transformOutgoingScheme:I=>I==="file"?"vscode-remote":I==="vscode-local"?"file":I}}function r(C){return new D.$om(O(C))}e.$hr=r}),define(pe[266],be([1,0,3,41,4,70,51,105,240,7,19]),function(ce,e,D,O,r,C,I,P,w,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class k{static{this.a=1}constructor(l,d,m,c){this.b=l,this.c=d,this.d=m,this.e=c}async call(l,d,m){switch(d){case"getEnvironmentData":{const c=m,u=(0,C.$hr)(c.remoteAuthority);let h=await this.f(c.profile);return h=(0,I.$qm)(h,u),h}case"getExtensionHostExitInfo":{const c=m;return this.e.getExitInfo(c.reconnectionToken)}case"getDiagnosticInfo":{const c=m,u={machineInfo:(0,w.$lr)()},h=c.includeProcesses?(0,P.$jr)(process.pid):Promise.resolve();let g=[];const E={};if(c.folders){const v=(0,C.$hr)("");g=c.folders.map(s=>r.URI.revive(v.transformIncoming(s))).filter(s=>s.scheme==="file").map(s=>(0,w.$kr)(s.fsPath,["node_modules",".git"]).then(a=>{E[(0,$.$_c)(s.fsPath)]=a}))}return Promise.all([h,...g]).then(([v,t])=>(u.processes=v||void 0,u.workspaceMetadata=c.folders?E:void 0,u))}}throw new Error(`IPC Command ${d} not found`)}listen(l,d,m){throw new Error("Not supported")}async f(l){return l&&!this.d.profiles.some(d=>d.id===l)&&await this.d.createProfile(l,l),{pid:process.pid,connectionToken:this.b.type!==0?this.b.value:"",appRoot:r.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,A.$9f)(this.c.logsHome,`exthost${k.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:D.OS,arch:process.arch,marks:O.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(d=>({...d}))}}}}e.$or=k}),define(pe[267],be([1,0,4,70,68,7,225]),function(ce,e,D,O,r,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class P extends I.$pr{constructor(A,k){super(new r.$Tp(A),A),this.H=k,this.G=new Map,this.B(this.a)}c(A){let k=this.G.get(A.remoteAuthority);return k||(k=(0,O.$hr)(A.remoteAuthority),this.G.set(A.remoteAuthority,k)),k}f(A,k,p=!1){if(p&&k.path==="/vscode-resource"&&k.query){const l=JSON.parse(k.query).requestResourcePath;return D.URI.from({scheme:"file",path:l})}return D.URI.revive(A.transformIncoming(k))}F(A,k){return new w(A,k,this.b,this.H)}}e.$rr=P;class w extends I.$qr{constructor(A,k,p,l){super(A,k,p,l)}i(A){const k=A.args["file-watcher-polling"];if(k){const p=k.split(C.$fd),l=Number(p[0]);if(l>0)return{usePolling:p.length>1?p.slice(1):!0,pollingInterval:l}}}j(A){if(A.extensionsPath)return[C.$5c.join(A.extensionsPath,"**")]}}}),define(pe[91],be([1,0,202,10,4,2,6,35,16,13,38,156,60]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VE=e.$UE=e.$TE=e.EditorsOrder=e.$SE=e.CloseDirection=e.$RE=e.$QE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$PE=e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.$IE=e.EditorInputCapabilities=e.$HE=e.SaveReason=e.Verbosity=e.$GE=e.$FE=e.$EE=e.$DE=e.$CE=e.$BE=e.$AE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$zE=e.$yE=e.$xE=e.$wE=e.$vE=void 0,e.$vE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$wE={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$xE="workbench.editor.sidebysideEditor",e.$yE="workbench.editors.textDiffEditor",e.$zE="workbench.editors.binaryResourceDiffEditor";var l;(function(ne){ne[ne.PROGRAMMATIC=1]="PROGRAMMATIC",ne[ne.USER=2]="USER",ne[ne.EDIT=3]="EDIT",ne[ne.NAVIGATION=4]="NAVIGATION",ne[ne.JUMP=5]="JUMP"})(l||(e.EditorPaneSelectionChangeReason=l={}));var d;(function(ne){ne[ne.IDENTICAL=1]="IDENTICAL",ne[ne.SIMILAR=2]="SIMILAR",ne[ne.DIFFERENT=3]="DIFFERENT"})(d||(e.EditorPaneSelectionCompareResult=d={}));function m(ne){const q=ne;return!!q&&typeof q.getSelection=="function"&&!!q.onDidChangeSelection}e.$AE=m;function c(ne,q,J){for(const R of J.visibleEditorPanes)if(R.group.id===q&&ne.matches(R.input))return R.getViewState()}e.$BE=c;function u(ne){if(o(ne))return!1;const q=ne;return r.URI.isUri(q?.resource)}e.$CE=u;function h(ne){if(o(ne))return!1;const q=ne;return q?.original!==void 0&&q.modified!==void 0}e.$DE=h;function g(ne){if(o(ne)||h(ne))return!1;const q=ne;return q?.primary!==void 0&&q.secondary!==void 0}e.$EE=g;function E(ne){if(o(ne))return!1;const q=ne;return q?q.resource===void 0||q.resource.scheme===$.Schemas.untitled||q.forceUntitled===!0:!1}e.$FE=E;function v(ne){if(o(ne))return!1;const q=ne;return r.URI.isUri(q?.base?.resource)&&r.URI.isUri(q?.input1?.resource)&&r.URI.isUri(q?.input2?.resource)&&r.URI.isUri(q?.result?.resource)}e.$GE=v;var t;(function(ne){ne[ne.SHORT=0]="SHORT",ne[ne.MEDIUM=1]="MEDIUM",ne[ne.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var s;(function(ne){ne[ne.EXPLICIT=1]="EXPLICIT",ne[ne.AUTO=2]="AUTO",ne[ne.FOCUS_CHANGE=3]="FOCUS_CHANGE",ne[ne.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class a{constructor(){this.a=new Map}registerSource(q,J){let R=this.a.get(q);return R||(R={source:q,label:J},this.a.set(q,R)),R.source}getSourceLabel(q){return this.a.get(q)?.label??q}}e.$HE=new a;var i;(function(ne){ne[ne.None=0]="None",ne[ne.Readonly=2]="Readonly",ne[ne.Untitled=4]="Untitled",ne[ne.Singleton=8]="Singleton",ne[ne.RequiresTrust=16]="RequiresTrust",ne[ne.CanSplitInGroup=32]="CanSplitInGroup",ne[ne.ForceDescription=64]="ForceDescription",ne[ne.CanDropIntoEditor=128]="CanDropIntoEditor",ne[ne.MultipleEditors=256]="MultipleEditors",ne[ne.Scratchpad=512]="Scratchpad"})(i||(e.EditorInputCapabilities=i={}));class n extends C.$lb{}e.$IE=n;function o(ne){return ne instanceof n}e.$JE=o;function f(ne){const q=ne;return r.URI.isUri(q?.preferredResource)}function b(ne){const q=ne;return o(q?.primary)&&o(q?.secondary)}e.$KE=b;function y(ne){const q=ne;return o(q?.modified)&&o(q?.original)}e.$LE=y;function S(ne,q,J,R,F){return me(R,[(0,k.$_h)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const W={...J,limits:{size:Number.MAX_VALUE}};ne.openEditor(q,W)}}),(0,k.$_h)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>F.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:p.default.Warning})}e.$ME=S;function L(ne){return o(ne?.editor)}e.$NE=L;function j(ne){const q=ne;return L(ne)&&q?.group!==void 0}e.$OE=j;function Q(ne){const q=ne;return typeof q?.groupId=="number"&&o(q.editor)}e.$PE=Q;var le;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.REPLACE=1]="REPLACE",ne[ne.MOVE=2]="MOVE",ne[ne.UNPIN=3]="UNPIN"})(le||(e.EditorCloseContext=le={}));var Y;(function(ne){ne[ne.GROUP_ACTIVE=0]="GROUP_ACTIVE",ne[ne.GROUP_INDEX=1]="GROUP_INDEX",ne[ne.GROUP_LOCKED=2]="GROUP_LOCKED",ne[ne.EDITOR_OPEN=3]="EDITOR_OPEN",ne[ne.EDITOR_CLOSE=4]="EDITOR_CLOSE",ne[ne.EDITOR_MOVE=5]="EDITOR_MOVE",ne[ne.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ne[ne.EDITOR_LABEL=7]="EDITOR_LABEL",ne[ne.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ne[ne.EDITOR_PIN=9]="EDITOR_PIN",ne[ne.EDITOR_STICKY=10]="EDITOR_STICKY",ne[ne.EDITOR_DIRTY=11]="EDITOR_DIRTY",ne[ne.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(Y||(e.GroupModelChangeKind=Y={}));var ee;(function(ne){ne[ne.PRIMARY=1]="PRIMARY",ne[ne.SECONDARY=2]="SECONDARY",ne[ne.BOTH=3]="BOTH",ne[ne.ANY=4]="ANY"})(ee||(e.SideBySideEditor=ee={}));class ue{getOriginalUri(q,J){if(!q)return;if(v(q))return e.$RE.getOriginalUri(q.result,J);if(J?.supportSideBySide){const{primary:F,secondary:W}=this.a(q);if(F&&W){if(J?.supportSideBySide===ee.BOTH)return{primary:this.getOriginalUri(F,{filterByScheme:J.filterByScheme}),secondary:this.getOriginalUri(W,{filterByScheme:J.filterByScheme})};if(J?.supportSideBySide===ee.ANY)return this.getOriginalUri(F,{filterByScheme:J.filterByScheme})??this.getOriginalUri(W,{filterByScheme:J.filterByScheme});q=J.supportSideBySide===ee.PRIMARY?F:W}}if(h(q)||g(q)||v(q))return;const R=f(q)?q.preferredResource:q.resource;return!R||!J||!J.filterByScheme?R:this.b(R,J.filterByScheme)}a(q){return b(q)||g(q)?{primary:q.primary,secondary:q.secondary}:y(q)||h(q)?{primary:q.modified,secondary:q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(q,J){if(!q)return;if(v(q))return e.$RE.getCanonicalUri(q.result,J);if(J?.supportSideBySide){const{primary:F,secondary:W}=this.a(q);if(F&&W){if(J?.supportSideBySide===ee.BOTH)return{primary:this.getCanonicalUri(F,{filterByScheme:J.filterByScheme}),secondary:this.getCanonicalUri(W,{filterByScheme:J.filterByScheme})};if(J?.supportSideBySide===ee.ANY)return this.getCanonicalUri(F,{filterByScheme:J.filterByScheme})??this.getCanonicalUri(W,{filterByScheme:J.filterByScheme});q=J.supportSideBySide===ee.PRIMARY?F:W}}if(h(q)||g(q)||v(q))return;const R=q.resource;return!R||!J||!J.filterByScheme?R:this.b(R,J.filterByScheme)}b(q,J){if(Array.isArray(J)){if(J.some(R=>q.scheme===R))return q}else if(J===q.scheme)return q}}var X;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.KEYBOARD=1]="KEYBOARD",ne[ne.MOUSE=2]="MOUSE"})(X||(e.EditorCloseMethod=X={}));function he(ne,q,J,R){if(!ne.isSticky(q))return!1;switch(R.preventPinnedEditorClose){case"keyboardAndMouse":return J===X.MOUSE||J===X.KEYBOARD;case"mouse":return J===X.MOUSE;case"keyboard":return J===X.KEYBOARD}return!1}e.$QE=he,e.$RE=new ue;var x;(function(ne){ne[ne.LEFT=0]="LEFT",ne[ne.RIGHT=1]="RIGHT"})(x||(e.CloseDirection=x={}));class se{constructor(){this.c=new Map,this.d=new Map}start(q){const J=this.a=q.get(I.$oh);for(const[R,F]of this.c)this.e(R,F,J);this.c.clear()}e(q,J,R){const F=R.createInstance(J);this.d.set(q,F)}registerFileEditorFactory(q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=q}getFileEditorFactory(){return(0,O.$te)(this.b)}registerEditorSerializer(q,J){if(this.c.has(q)||this.d.has(q))throw new Error(`A editor serializer with type ID '${q}' was already registered.`);return this.a?this.e(q,J,this.a):this.c.set(q,J),(0,C.$jb)(()=>{this.c.delete(q),this.d.delete(q)})}getEditorSerializer(q){return this.d.get(typeof q=="string"?q:q.typeId)}}P.$Um.add(e.$vE.EditorFactory,new se);async function V(ne,q,J){return!ne||!ne.length?[]:await Promise.all(ne.map(async R=>{const F=r.URI.revive(R.fileUri);if(!F){J.info("Cannot resolve the path because it is not valid.",R);return}if(!await q.canHandleResource(F)){J.info("Cannot resolve the path because it cannot be handled",R);return}let ie=R.exists,re=R.type;if(typeof ie!="boolean"||typeof re!="number")try{re=(await q.stat(F)).isDirectory?w.FileType.Directory:w.FileType.Unknown,ie=!0}catch(oe){J.error(oe),ie=!1}if(!ie&&R.openOnlyIfExists){J.info("Cannot resolve the path because it does not exist",R);return}if(re===w.FileType.Directory){J.info("Cannot resolve the path because it is a directory",R);return}const _={...R.options,pinned:!0};return ie?{resource:F,options:_}:{resource:F,options:_,forceUntitled:!0}}))}e.$SE=V;var K;(function(ne){ne[ne.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ne[ne.SEQUENTIAL=1]="SEQUENTIAL"})(K||(e.EditorsOrder=K={}));function H(ne){const q=ne;if(!q)return!1;const J=q;if(J.modified)return H(J.modified);const R=q;return!!(R.contributionsState&&R.viewState&&Array.isArray(R.cursorState))}e.$TE=H;function te(ne){return(0,A.$bi)(ne)}e.$UE=te;function me(ne,q,J){const R=(0,A.$ci)(ne,q);return R.forceMessage=J?.forceMessage,R.forceSeverity=J?.forceSeverity,R.allowDialog=J?.allowDialog,R}e.$VE=me}),define(pe[131],be([1,0,15,78,47,62,13,7,3,66]),function(ce,e,D,O,r,C,I,P,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TH=e.$SH=e.$RH=e.$QH=e.CellStatusbarAlignment=e.$PH=e.$OH=e.$NH=e.NotebookEditorPriority=e.$MH=e.$LH=e.$KH=e.$JH=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$IH=e.$HH=e.$GH=e.$FH=e.CellKind=e.$EH=e.$DH=e.$CH=void 0,e.$CH="workbench.editor.notebook",e.$DH="workbench.editor.notebookTextDiffEditor",e.$EH="workbench.editor.interactive";var A;(function(X){X[X.Markup=1]="Markup",X[X.Code=2]="Code"})(A||(e.CellKind=A={})),e.$FH=["application/json","application/javascript","text/html","image/svg+xml",C.$yr.latex,C.$yr.markdown,"image/png","image/jpeg",C.$yr.text],e.$GH=[C.$yr.latex,C.$yr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",C.$yr.text],e.$HH=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$IH="_notAvailable";var k;(function(X){X[X.Running=1]="Running",X[X.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var p;(function(X){X[X.Unconfirmed=1]="Unconfirmed",X[X.Pending=2]="Pending",X[X.Executing=3]="Executing"})(p||(e.NotebookCellExecutionState=p={}));var l;(function(X){X[X.Unconfirmed=1]="Unconfirmed",X[X.Pending=2]="Pending",X[X.Executing=3]="Executing"})(l||(e.NotebookExecutionState=l={}));var d;(function(X){X[X.WithHardKernelDependency=0]="WithHardKernelDependency",X[X.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",X[X.Pure=2]="Pure",X[X.Never=3]="Never"})(d||(e.NotebookRendererMatch=d={}));var m;(function(X){X.Always="always",X.Never="never",X.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var c;(function(X){X[X.ModelChange=1]="ModelChange",X[X.Move=2]="Move",X[X.ChangeCellLanguage=5]="ChangeCellLanguage",X[X.Initialize=6]="Initialize",X[X.ChangeCellMetadata=7]="ChangeCellMetadata",X[X.Output=8]="Output",X[X.OutputItem=9]="OutputItem",X[X.ChangeCellContent=10]="ChangeCellContent",X[X.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",X[X.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",X[X.ChangeCellMime=13]="ChangeCellMime",X[X.Unknown=100]="Unknown"})(c||(e.NotebookCellsChangeType=c={}));var u;(function(X){X[X.Handle=0]="Handle",X[X.Index=1]="Index"})(u||(e.SelectionStateType=u={}));var h;(function(X){X[X.Replace=1]="Replace",X[X.Output=2]="Output",X[X.Metadata=3]="Metadata",X[X.CellLanguage=4]="CellLanguage",X[X.DocumentMetadata=5]="DocumentMetadata",X[X.Move=6]="Move",X[X.OutputItems=7]="OutputItems",X[X.PartialMetadata=8]="PartialMetadata",X[X.PartialInternalMetadata=9]="PartialInternalMetadata"})(h||(e.CellEditType=h={}));var g;(function(X){X.scheme=I.Schemas.vscodeNotebookCell;const he=["W","X","Y","Z","a","b","c","d","e","f"],x=new RegExp(`^[${he.join("")}]+`),se=7;function V(q,J){const R=J.toString(se),W=`${R.length<he.length?he[R.length-1]:"z"}${R}s${(0,D.$Yc)(D.$Ec.fromString(q.scheme),!0,!0)}`;return q.with({scheme:X.scheme,fragment:W})}X.generate=V;function K(q){if(q.scheme!==X.scheme)return;const J=q.fragment.indexOf("s");if(J<0)return;const R=parseInt(q.fragment.substring(0,J).replace(x,""),se),F=(0,D.$Xc)(q.fragment.substring(J+1)).toString();if(!isNaN(R))return{handle:R,notebook:q.with({scheme:F,fragment:null})}}X.parse=K;function H(q,J){return q.with({scheme:I.Schemas.vscodeNotebookCellOutput,fragment:`op${J??""},${q.scheme!==I.Schemas.file?q.scheme:""}`})}X.generateCellOutputUri=H;function te(q){if(q.scheme!==I.Schemas.vscodeNotebookCellOutput)return;const J=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(q.fragment);if(!J)return;const R=J[1]&&J[1]!==""?J[1]:void 0,F=J[2];return{outputId:R,notebook:q.with({scheme:F||I.Schemas.file,fragment:null})}}X.parseCellOutputUri=te;function me(q,J,R){return X.generate(q,J).with({scheme:R})}X.generateCellPropertyUri=me;function ne(q,J){if(q.scheme===J)return X.parse(q.with({scheme:X.scheme}))}X.parseCellPropertyUri=ne})(g||(e.CellUri=g={}));const E=X=>w.$i?X.replace(/\//g,"\\"):X;class v{constructor(he=[],x=e.$FH){this.e=x,this.d=[...new Set(he)].map(se=>({pattern:se,matches:O.$ej(E(se))}))}sort(he){const x=new Map(r.Iterable.map(he,V=>[V,E(V)]));let se=[];for(const{matches:V}of this.d)for(const[K,H]of x)if(V(H)){se.push(K),x.delete(K);break}return x.size&&(se=se.concat([...x.keys()].sort((V,K)=>this.e.indexOf(V)-this.e.indexOf(K)))),se}prioritize(he,x){const se=this.f(he);if(se===-1){this.d.unshift({pattern:he,matches:O.$ej(E(he))});return}const V=new Set(x.map(H=>this.f(H,se)));V.delete(-1);const K=Array.from(V).sort();this.d.splice(se+1,0,...K.map(H=>this.d[H]));for(let H=K.length-1;H>=0;H--)this.d.splice(K[H],1)}toArray(){return this.d.map(he=>he.pattern)}f(he,x=this.d.length){const se=E(he);for(let V=0;V<x;V++)if(this.d[V].matches(se))return V;return-1}}e.$JH=v;function t(X,he,x,se=(V,K)=>V===K){const V=[];function K(me,ne,q){if(ne===0&&q.length===0)return;const J=V[V.length-1];J&&J.start+J.deleteCount===me?(J.deleteCount+=ne,J.toInsert.push(...q)):V.push({start:me,deleteCount:ne,toInsert:q})}let H=0,te=0;for(;;){if(H===X.length){K(H,0,he.slice(te));break}if(te===he.length){K(H,X.length-H,[]);break}const me=X[H],ne=he[te];if(se(me,ne)){H+=1,te+=1;continue}x(ne)?(K(H,1,[]),H+=1):(K(H,0,[ne]),te+=1)}return V}e.$KH=t,e.$LH=new $.$Oi("notebookEditorCursorAtBoundary","none"),e.$MH=new $.$Oi("notebookEditorCursorAtLineBoundary","none");var s;(function(X){X.default="default",X.option="option"})(s||(e.NotebookEditorPriority=s={}));function a(X){const he=X;return!!((typeof he.include=="string"||O.$fj(he.include))&&(typeof he.exclude=="string"||O.$fj(he.exclude)))}e.$NH=a;function i(X,he,x){if(Array.isArray(X.viewType)&&X.viewType.indexOf(he)>=0||X.viewType===he)return!0;if(X.filenamePattern){const se=a(X.filenamePattern)?X.filenamePattern.include:X.filenamePattern,V=a(X.filenamePattern)?X.filenamePattern.exclude:void 0;if(O.$dj(se,(0,P.$_c)(x.fsPath).toLowerCase()))return!(V&&O.$dj(V,(0,P.$_c)(x.fsPath).toLowerCase()))}return!1}e.$OH=i,e.$PH={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave"};var n;(function(X){X[X.Left=1]="Left",X[X.Right=2]="Right"})(n||(e.CellStatusbarAlignment=n={}));class o{static{this.d="notebook/"}static create(he){return`${o.d}${he}`}static parse(he){if(he.startsWith(o.d))return he.substring(o.d.length)}}e.$QH=o;function f(X){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(X)}e.$RH=f;const b=new TextDecoder;function y(X){const he=[];let x=!1;for(const H of X)(he.length===0||x)&&(he.push(H),x=!0);let se=j(he);const V=D.$Ec.concat(he.map(H=>D.$Ec.wrap(H))),K=ue(V);return se=se||K.byteLength!==V.byteLength,{data:K,didCompression:se}}e.$SH=y,e.$TH=`${String.fromCharCode(27)}[A`;const S=e.$TH.split("").map(X=>X.charCodeAt(0)),L=10;function j(X){let he=!1;return X.forEach((x,se)=>{if(se===0||x.length<e.$TH.length)return;const V=X[se-1],K=x.subarray(0,e.$TH.length);if(K[0]===S[0]&&K[1]===S[1]&&K[2]===S[2]){const H=V.lastIndexOf(L);if(H===-1)return;he=!0,X[se-1]=V.subarray(0,H),X[se]=x.subarray(e.$TH.length)}}),he}function Q(X){let he=X;do X=he,he=X.replace(/[^\n]\x08/gm,"");while(he.length<X.length);return X}function le(X){for(X=X.replace(/\r+\n/gm,`
`);X.search(/\r[^$]/g)>-1;){const he=X.match(/^(.*)\r+/m)[1];let x=X.match(/\r+(.*)$/m)[1];x=x+he.slice(x.length,he.length),X=X.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,x)}return X}const Y="\b".charCodeAt(0),ee="\r".charCodeAt(0);function ue(X){return!X.buffer.includes(Y)&&!X.buffer.includes(ee)?X:D.$Ec.fromString(le(Q(b.decode(X.buffer))))}}),define(pe[132],be([1,0,18,11,102,27,62,17,10,4,23,40,16,118,131]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l,d){"use strict";var m,c,u,h,g,E,v,t,s,a,i,n,o,f,b,y,S,L;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$AL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.TestRunProfileKind=e.TestResultState=e.$hL=e.$gL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$fL=e.$eL=e.$dL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$cL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.ColorThemeKind=e.$9K=e.$8K=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$7K=e.DebugConsoleMode=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$1K=e.$ZK=e.FileChangeType=e.$YK=e.$XK=e.$WK=e.$VK=e.InlineCompletionTriggerKind=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.ConfigurationTarget=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$yK=e.ViewBadge=e.ProgressLocation=e.$xK=e.$wK=e.TaskScope=e.ShellQuoting=e.$vK=e.$uK=e.$tK=e.TaskPanelKind=e.TaskRevealKind=e.$sK=e.TerminalLocation=e.$rK=e.$qK=e.$pK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$oK=e.$nK=e.$mK=e.$lK=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$kK=e.StatusBarAlignment=e.ViewColumn=e.$jK=e.$iK=e.$hK=e.$gK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$fK=e.$eK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.LanguageStatusSeverity=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.CodeActionTriggerKind=e.$4J=e.$3J=e.SymbolTag=e.SymbolKind=e.$2J=e.DocumentHighlightKind=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.DiagnosticSeverity=e.DiagnosticTag=e.$WJ=e.$VJ=e.FileEditType=e.$UJ=e.$TJ=e.$SJ=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function j(T){return Object.assign(T,{apply:function(){const ae=arguments.length===1?[]:arguments[1];return Reflect.construct(T,ae,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(T,[]);{const[ae,...we]=arguments;return Reflect.construct(T,we,ae.constructor)}}})}var Q;(function(T){T[T.Top=0]="Top",T[T.Bottom=1]="Bottom"})(Q||(e.TerminalOutputAnchor=Q={}));var le;(function(T){T[T.TerminalCommand=0]="TerminalCommand",T[T.Opener=1]="Opener",T[T.Command=3]="Command"})(le||(e.TerminalQuickFixType=le={}));let Y=m=class{static from(...M){let ae=M;return new m(function(){if(ae){for(const we of ae)we&&typeof we.dispose=="function"&&we.dispose();ae=void 0}})}#e;constructor(M){this.#e=M}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$LJ=Y,e.$LJ=Y=m=Le([j],Y);let ee=c=class{static Min(...M){if(M.length===0)throw new TypeError;let ae=M[0];for(let we=1;we<M.length;we++){const je=M[we];je.isBefore(ae)&&(ae=je)}return ae}static Max(...M){if(M.length===0)throw new TypeError;let ae=M[0];for(let we=1;we<M.length;we++){const je=M[we];je.isAfter(ae)&&(ae=je)}return ae}static isPosition(M){if(!M)return!1;if(M instanceof c)return!0;const{line:ae,character:we}=M;return typeof ae=="number"&&typeof we=="number"}static of(M){if(M instanceof c)return M;if(this.isPosition(M))return new c(M.line,M.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(M,ae){if(M<0)throw(0,O.$5)("line must be non-negative");if(ae<0)throw(0,O.$5)("character must be non-negative");this.c=M,this.e=ae}isBefore(M){return this.c<M.c?!0:M.c<this.c?!1:this.e<M.e}isBeforeOrEqual(M){return this.c<M.c?!0:M.c<this.c?!1:this.e<=M.e}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this.c===M.c&&this.e===M.e}compareTo(M){return this.c<M.c?-1:this.c>M.line?1:this.e<M.e?-1:this.e>M.e?1:0}translate(M,ae=0){if(M===null||ae===null)throw(0,O.$5)();let we;return typeof M>"u"?we=0:typeof M=="number"?we=M:(we=typeof M.lineDelta=="number"?M.lineDelta:0,ae=typeof M.characterDelta=="number"?M.characterDelta:0),we===0&&ae===0?this:new c(this.line+we,this.character+ae)}with(M,ae=this.character){if(M===null||ae===null)throw(0,O.$5)();let we;return typeof M>"u"?we=this.line:typeof M=="number"?we=M:(we=typeof M.line=="number"?M.line:this.line,ae=typeof M.character=="number"?M.character:this.character),we===this.line&&ae===this.character?this:new c(we,ae)}toJSON(){return{line:this.line,character:this.character}}};e.$MJ=ee,e.$MJ=ee=c=Le([j],ee);let ue=u=class{static isRange(M){return M instanceof u?!0:M?ee.isPosition(M.start)&&ee.isPosition(M.end):!1}static of(M){if(M instanceof u)return M;if(this.isRange(M))return new u(M.start,M.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(M,ae,we,je){let Ge,et;if(typeof M=="number"&&typeof ae=="number"&&typeof we=="number"&&typeof je=="number"?(Ge=new ee(M,ae),et=new ee(we,je)):ee.isPosition(M)&&ee.isPosition(ae)&&(Ge=ee.of(M),et=ee.of(ae)),!Ge||!et)throw new Error("Invalid arguments");Ge.isBefore(et)?(this.c=Ge,this.e=et):(this.c=et,this.e=Ge)}contains(M){return u.isRange(M)?this.contains(M.start)&&this.contains(M.end):ee.isPosition(M)?!(ee.of(M).isBefore(this.c)||this.e.isBefore(M)):!1}isEqual(M){return this.c.isEqual(M.c)&&this.e.isEqual(M.e)}intersection(M){const ae=ee.Max(M.start,this.c),we=ee.Min(M.end,this.e);if(!ae.isAfter(we))return new u(ae,we)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const ae=ee.Min(M.start,this.c),we=ee.Max(M.end,this.end);return new u(ae,we)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(M,ae=this.end){if(M===null||ae===null)throw(0,O.$5)();let we;return M?ee.isPosition(M)?we=M:(we=M.start||this.start,ae=M.end||this.end):we=this.start,we.isEqual(this.c)&&ae.isEqual(this.end)?this:new u(we,ae)}toJSON(){return[this.start,this.end]}};e.$NJ=ue,e.$NJ=ue=u=Le([j],ue);let X=h=class extends ue{static isSelection(M){return M instanceof h?!0:M?ue.isRange(M)&&ee.isPosition(M.anchor)&&ee.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(M,ae,we,je){let Ge,et;if(typeof M=="number"&&typeof ae=="number"&&typeof we=="number"&&typeof je=="number"?(Ge=new ee(M,ae),et=new ee(we,je)):ee.isPosition(M)&&ee.isPosition(ae)&&(Ge=ee.of(M),et=ee.of(ae)),!Ge||!et)throw new Error("Invalid arguments");super(Ge,et),this.f=Ge,this.g=et}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$OJ=X,e.$OJ=X=h=Le([j],X);const he=T=>{if(typeof T!="string"||T.length===0||!/^[0-9A-Za-z_\-]+$/.test(T))throw(0,O.$5)("connectionToken")};class x{static isResolvedAuthority(M){return M&&typeof M=="object"&&typeof M.host=="string"&&typeof M.port=="number"&&(M.connectionToken===void 0||typeof M.connectionToken=="string")}constructor(M,ae,we){if(typeof M!="string"||M.length===0)throw(0,O.$5)("host");if(typeof ae!="number"||ae===0||Math.round(ae)!==ae)throw(0,O.$5)("port");typeof we<"u"&&he(we),this.host=M,this.port=Math.round(ae),this.connectionToken=we}}e.$PJ=x;class se{static isManagedResolvedAuthority(M){return M&&typeof M=="object"&&typeof M.makeConnection=="function"&&(M.connectionToken===void 0||typeof M.connectionToken=="string")}constructor(M,ae){this.makeConnection=M,this.connectionToken=ae,typeof ae<"u"&&he(ae)}}e.$QJ=se;class V extends Error{static NotAvailable(M,ae){return new V(M,l.RemoteAuthorityResolverErrorCode.NotAvailable,ae)}static TemporarilyNotAvailable(M){return new V(M,l.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(M,ae=l.RemoteAuthorityResolverErrorCode.Unknown,we){super(M),this._message=M,this._code=ae,this._detail=we,Object.setPrototypeOf(this,V.prototype)}}e.$RJ=V;var K;(function(T){T[T.LF=1]="LF",T[T.CRLF=2]="CRLF"})(K||(e.EndOfLine=K={}));var H;(function(T){T[T.Replace=1]="Replace",T[T.Append=2]="Append",T[T.Prepend=3]="Prepend"})(H||(e.EnvironmentVariableMutatorType=H={}));let te=g=class{static isTextEdit(M){return M instanceof g?!0:M?ue.isRange(M)&&typeof M.newText=="string":!1}static replace(M,ae){return new g(M,ae)}static insert(M,ae){return g.replace(new ue(M,M),ae)}static delete(M){return g.replace(M,"")}static setEndOfLine(M){const ae=new g(new ue(new ee(0,0),new ee(0,0)),"");return ae.newEol=M,ae}get range(){return this.c}set range(M){if(M&&!ue.isRange(M))throw(0,O.$5)("range");this.c=M}get newText(){return this.e||""}set newText(M){if(M&&typeof M!="string")throw(0,O.$5)("newText");this.e=M}get newEol(){return this.f}set newEol(M){if(M&&typeof M!="number")throw(0,O.$5)("newEol");this.f=M}constructor(M,ae){this.c=M,this.e=ae}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$SJ=te,e.$SJ=te=g=Le([j],te);let me=E=class{static isNotebookCellEdit(M){return M instanceof E?!0:M?Nt.isNotebookRange(M)&&Array.isArray(M.newCells):!1}static replaceCells(M,ae){return new E(M,ae)}static insertCells(M,ae){return new E(new Nt(M,M),ae)}static deleteCells(M){return new E(M,[])}static updateCellMetadata(M,ae){const we=new E(new Nt(M,M),[]);return we.newCellMetadata=ae,we}static updateNotebookMetadata(M){const ae=new E(new Nt(0,0),[]);return ae.newNotebookMetadata=M,ae}constructor(M,ae){this.range=M,this.newCells=ae}};e.$TJ=me,e.$TJ=me=E=Le([j],me);class ne{static isSnippetTextEdit(M){return M instanceof ne?!0:M?ue.isRange(M.range)&&R.isSnippetString(M.snippet):!1}static replace(M,ae){return new ne(M,ae)}static insert(M,ae){return ne.replace(new ue(M,M),ae)}constructor(M,ae){this.range=M,this.snippet=ae}}e.$UJ=ne;var q;(function(T){T[T.File=1]="File",T[T.Text=2]="Text",T[T.Cell=3]="Cell",T[T.CellReplace=5]="CellReplace",T[T.Snippet=6]="Snippet"})(q||(e.FileEditType=q={}));let J=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(M,ae,we,je){this.c.push({_type:1,from:M,to:ae,options:we,metadata:je})}createFile(M,ae,we){this.c.push({_type:1,from:void 0,to:M,options:ae,metadata:we})}deleteFile(M,ae,we){this.c.push({_type:1,from:M,to:void 0,options:ae,metadata:we})}e(M,ae,we){this.c.push({_type:3,metadata:we,uri:M,edit:{editType:5,metadata:ae},notebookMetadata:ae})}f(M,ae,we,je){const Ge=ae.start,et=ae.end;(Ge!==et||we.length>0)&&this.c.push({_type:5,uri:M,index:Ge,count:et-Ge,cells:we,metadata:je})}g(M,ae,we,je){this.c.push({_type:3,metadata:je,uri:M,edit:{editType:3,index:ae,metadata:we}})}replace(M,ae,we,je){this.c.push({_type:2,uri:M,edit:new te(ae,we),metadata:je})}insert(M,ae,we,je){this.replace(M,new ue(ae,ae),we,je)}delete(M,ae,we){this.replace(M,ae,"",we)}has(M){return this.c.some(ae=>ae._type===2&&ae.uri.toString()===M.toString())}set(M,ae){if(ae)for(const we of ae){if(!we)continue;let je,Ge;Array.isArray(we)?(je=we[0],Ge=we[1]):je=we,me.isNotebookCellEdit(je)?je.newCellMetadata?this.g(M,je.range.start,je.newCellMetadata,Ge):je.newNotebookMetadata?this.e(M,je.newNotebookMetadata,Ge):this.f(M,je.range,je.newCells,Ge):ne.isSnippetTextEdit(je)?this.c.push({_type:6,uri:M,range:je.range,edit:je.snippet,metadata:Ge}):this.c.push({_type:2,uri:M,edit:je,metadata:Ge})}else{for(let we=0;we<this.c.length;we++){const je=this.c[we];switch(je._type){case 2:case 6:case 3:case 5:je.uri.toString()===M.toString()&&(this.c[we]=void 0);break}}(0,D.$kf)(this.c)}}get(M){const ae=[];for(const we of this.c)we._type===2&&we.uri.toString()===M.toString()&&ae.push(we.edit);return ae}entries(){const M=new C.$ni;for(const ae of this.c)if(ae._type===2){let we=M.get(ae.uri);we||(we=[ae.uri,[]],M.set(ae.uri,we)),we[1].push(ae.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$VJ=J,e.$VJ=J=Le([j],J);let R=v=class{static isSnippetString(M){return M instanceof v?!0:M?typeof M.value=="string":!1}static c(M){return M.replace(/\$|}|\\/g,"\\$&")}constructor(M){this.e=1,this.value=M||""}appendText(M){return this.value+=v.c(M),this}appendTabstop(M=this.e++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,ae=this.e++){if(typeof M=="function"){const we=new v;we.e=this.e,M(we),this.e=we.e,M=we.value}else M=v.c(M);return this.value+="${",this.value+=ae,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,ae=this.e++){const we=M.map(je=>je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ae,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(M,ae){if(typeof ae=="function"){const we=new v;we.e=this.e,ae(we),this.e=we.e,ae=we.value}else typeof ae=="string"&&(ae=ae.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,ae&&(this.value+=":",this.value+=ae),this.value+="}",this}};e.$WJ=R,e.$WJ=R=v=Le([j],R);var F;(function(T){T[T.Unnecessary=1]="Unnecessary",T[T.Deprecated=2]="Deprecated"})(F||(e.DiagnosticTag=F={}));var W;(function(T){T[T.Hint=3]="Hint",T[T.Information=2]="Information",T[T.Warning=1]="Warning",T[T.Error=0]="Error"})(W||(e.DiagnosticSeverity=W={}));let ie=t=class{static isLocation(M){return M instanceof t?!0:M?ue.isRange(M.range)&&$.URI.isUri(M.uri):!1}constructor(M,ae){if(this.uri=M,ae)if(ue.isRange(ae))this.range=ue.of(ae);else if(ee.isPosition(ae))this.range=new ue(ae,ae);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$XJ=ie,e.$XJ=ie=t=Le([j],ie);let re=class{static is(M){return M?typeof M.message=="string"&&M.location&&ue.isRange(M.location.range)&&$.URI.isUri(M.location.uri):!1}constructor(M,ae){this.location=M,this.message=ae}static isEqual(M,ae){return M===ae?!0:!M||!ae?!1:M.message===ae.message&&M.location.range.isEqual(ae.location.range)&&M.location.uri.toString()===ae.location.uri.toString()}};e.$YJ=re,e.$YJ=re=Le([j],re);let _=class{constructor(M,ae,we=W.Error){if(!ue.isRange(M))throw new TypeError("range must be set");if(!ae)throw new TypeError("message must be set");this.range=M,this.message=ae,this.severity=we}toJSON(){return{severity:W[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,ae){return M===ae?!0:!M||!ae?!1:M.message===ae.message&&M.severity===ae.severity&&M.code===ae.code&&M.severity===ae.severity&&M.source===ae.source&&M.range.isEqual(ae.range)&&(0,D.$$e)(M.tags,ae.tags)&&(0,D.$$e)(M.relatedInformation,ae.relatedInformation,re.isEqual)}};e.$ZJ=_,e.$ZJ=_=Le([j],_);let oe=class{constructor(M,ae){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=ae}};e.$1J=oe,e.$1J=oe=Le([j],oe);var N;(function(T){T[T.Text=0]="Text",T[T.Read=1]="Read",T[T.Write=2]="Write"})(N||(e.DocumentHighlightKind=N={}));let B=class{constructor(M,ae=N.Text){this.range=M,this.kind=ae}toJSON(){return{range:this.range,kind:N[this.kind]}}};e.$2J=B,e.$2J=B=Le([j],B);var U;(function(T){T[T.File=0]="File",T[T.Module=1]="Module",T[T.Namespace=2]="Namespace",T[T.Package=3]="Package",T[T.Class=4]="Class",T[T.Method=5]="Method",T[T.Property=6]="Property",T[T.Field=7]="Field",T[T.Constructor=8]="Constructor",T[T.Enum=9]="Enum",T[T.Interface=10]="Interface",T[T.Function=11]="Function",T[T.Variable=12]="Variable",T[T.Constant=13]="Constant",T[T.String=14]="String",T[T.Number=15]="Number",T[T.Boolean=16]="Boolean",T[T.Array=17]="Array",T[T.Object=18]="Object",T[T.Key=19]="Key",T[T.Null=20]="Null",T[T.EnumMember=21]="EnumMember",T[T.Struct=22]="Struct",T[T.Event=23]="Event",T[T.Operator=24]="Operator",T[T.TypeParameter=25]="TypeParameter"})(U||(e.SymbolKind=U={}));var z;(function(T){T[T.Deprecated=1]="Deprecated"})(z||(e.SymbolTag=z={}));let Z=s=class{static validate(M){if(!M.name)throw new Error("name must not be falsy")}constructor(M,ae,we,je,Ge){this.name=M,this.kind=ae,this.containerName=Ge,typeof we=="string"&&(this.containerName=we),je instanceof ie?this.location=je:we instanceof ue&&(this.location=new ie(je,we)),s.validate(this)}toJSON(){return{name:this.name,kind:U[this.kind],location:this.location,containerName:this.containerName}}};e.$3J=Z,e.$3J=Z=s=Le([j],Z);let de=a=class{static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children?.forEach(a.validate)}constructor(M,ae,we,je,Ge){this.name=M,this.detail=ae,this.kind=we,this.range=je,this.selectionRange=Ge,this.children=[],a.validate(this)}};e.$4J=de,e.$4J=de=a=Le([j],de);var Ee;(function(T){T[T.Invoke=1]="Invoke",T[T.Automatic=2]="Automatic"})(Ee||(e.CodeActionTriggerKind=Ee={}));let Pe=class{constructor(M,ae){this.title=M,this.kind=ae}};e.$5J=Pe,e.$5J=Pe=Le([j],Pe);let Ae=class{static{i=this}static{this.c="."}constructor(M){this.value=M}append(M){return new i(this.value?this.value+i.c+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+i.c)}};e.$6J=Ae,e.$6J=Ae=i=Le([j],Ae);class Fe extends Ae{constructor(M){super(M),this.value=M}}e.$7J=Fe,Ae.Empty=new Ae(""),Ae.QuickFix=Ae.Empty.append("quickfix"),Ae.Refactor=Ae.Empty.append("refactor"),Ae.RefactorExtract=Ae.Refactor.append("extract"),Ae.RefactorInline=Ae.Refactor.append("inline"),Ae.RefactorMove=Ae.Refactor.append("move"),Ae.RefactorRewrite=Ae.Refactor.append("rewrite"),Ae.Source=Ae.Empty.append("source"),Ae.SourceOrganizeImports=Ae.Source.append("organizeImports"),Ae.SourceFixAll=Ae.Source.append("fixAll"),Ae.Notebook=Ae.Empty.append("notebook");let ge=class{constructor(M,ae){if(this.range=M,this.parent=ae,ae&&!ae.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$8J=ge,e.$8J=ge=Le([j],ge);class ke{constructor(M,ae,we,je,Ge,et){this.kind=M,this.name=ae,this.detail=we,this.uri=je,this.range=Ge,this.selectionRange=et}}e.$9J=ke;class ye{constructor(M,ae){this.fromRanges=ae,this.from=M}}e.$0J=ye;class Te{constructor(M,ae){this.fromRanges=ae,this.to=M}}e.$$J=Te;var ze;(function(T){T[T.Information=0]="Information",T[T.Warning=1]="Warning",T[T.Error=2]="Error"})(ze||(e.LanguageStatusSeverity=ze={}));let _e=class{constructor(M,ae){this.range=M,this.command=ae}get isResolved(){return!!this.command}};e.$_J=_e,e.$_J=_e=Le([j],_e);let Ve=n=class{#e;static isMarkdownString(M){return M instanceof n?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}constructor(M,ae=!1){this.#e=new r.$Kj(M,{supportThemeIcons:ae})}get value(){return this.#e.value}set value(M){this.#e.value=M}get isTrusted(){return this.#e.isTrusted}set isTrusted(M){this.#e.isTrusted=M}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(M){this.#e.supportThemeIcons=M}get supportHtml(){return this.#e.supportHtml}set supportHtml(M){this.#e.supportHtml=M}get baseUri(){return this.#e.baseUri}set baseUri(M){this.#e.baseUri=M}appendText(M){return this.#e.appendText(M),this}appendMarkdown(M){return this.#e.appendMarkdown(M),this}appendCodeblock(M,ae){return this.#e.appendCodeblock(ae??"",M),this}};e.$aK=Ve,e.$aK=Ve=n=Le([j],Ve);let Xe=class{constructor(M,ae){this.label=M,this.documentation=ae}};e.$bK=Xe,e.$bK=Xe=Le([j],Xe);let Ze=class{constructor(M,ae){this.label=M,this.documentation=ae,this.parameters=[]}};e.$cK=Ze,e.$cK=Ze=Le([j],Ze);let $e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$dK=$e,e.$dK=$e=Le([j],$e);var De;(function(T){T[T.Invoke=1]="Invoke",T[T.TriggerCharacter=2]="TriggerCharacter",T[T.ContentChange=3]="ContentChange"})(De||(e.SignatureHelpTriggerKind=De={}));var Re;(function(T){T[T.Type=1]="Type",T[T.Parameter=2]="Parameter"})(Re||(e.InlayHintKind=Re={}));let Ne=class{constructor(M){this.value=M}};e.$eK=Ne,e.$eK=Ne=Le([j],Ne);let Me=class{constructor(M,ae,we){this.position=M,this.label=ae,this.kind=we}};e.$fK=Me,e.$fK=Me=Le([j],Me);var qe;(function(T){T[T.Invoke=0]="Invoke",T[T.TriggerCharacter=1]="TriggerCharacter",T[T.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(qe||(e.CompletionTriggerKind=qe={}));var Be;(function(T){T[T.Text=0]="Text",T[T.Method=1]="Method",T[T.Function=2]="Function",T[T.Constructor=3]="Constructor",T[T.Field=4]="Field",T[T.Variable=5]="Variable",T[T.Class=6]="Class",T[T.Interface=7]="Interface",T[T.Module=8]="Module",T[T.Property=9]="Property",T[T.Unit=10]="Unit",T[T.Value=11]="Value",T[T.Enum=12]="Enum",T[T.Keyword=13]="Keyword",T[T.Snippet=14]="Snippet",T[T.Color=15]="Color",T[T.File=16]="File",T[T.Reference=17]="Reference",T[T.Folder=18]="Folder",T[T.EnumMember=19]="EnumMember",T[T.Constant=20]="Constant",T[T.Struct=21]="Struct",T[T.Event=22]="Event",T[T.Operator=23]="Operator",T[T.TypeParameter=24]="TypeParameter",T[T.User=25]="User",T[T.Issue=26]="Issue"})(Be||(e.CompletionItemKind=Be={}));var Ke;(function(T){T[T.Deprecated=1]="Deprecated"})(Ke||(e.CompletionItemTag=Ke={}));let He=class{constructor(M,ae){this.label=M,this.kind=ae}toJSON(){return{label:this.label,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$gK=He,e.$gK=He=Le([j],He);let Ye=class{constructor(M=[],ae=!1){this.items=M,this.isIncomplete=ae}};e.$hK=Ye,e.$hK=Ye=Le([j],Ye);let Je=class{constructor(M,ae,we){this.insertText=M,this.range=ae,this.command=we}};e.$iK=Je,e.$iK=Je=Le([j],Je);let xe=class{constructor(M){this.commands=void 0,this.suppressSuggestions=void 0,this.items=M}};e.$jK=xe,e.$jK=xe=Le([j],xe);var nt;(function(T){T[T.Active=-1]="Active",T[T.Beside=-2]="Beside",T[T.One=1]="One",T[T.Two=2]="Two",T[T.Three=3]="Three",T[T.Four=4]="Four",T[T.Five=5]="Five",T[T.Six=6]="Six",T[T.Seven=7]="Seven",T[T.Eight=8]="Eight",T[T.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var rt;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(rt||(e.StatusBarAlignment=rt={}));function it(T,M){return`${k.$Il.toKey(T)}.${M}`}e.$kK=it;var Mt;(function(T){T[T.Off=0]="Off",T[T.On=1]="On",T[T.Relative=2]="Relative"})(Mt||(e.TextEditorLineNumbersStyle=Mt={}));var bt;(function(T){T[T.Manual=1]="Manual",T[T.AfterDelay=2]="AfterDelay",T[T.FocusOut=3]="FocusOut"})(bt||(e.TextDocumentSaveReason=bt={}));var Lt;(function(T){T[T.Default=0]="Default",T[T.InCenter=1]="InCenter",T[T.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",T[T.AtTop=3]="AtTop"})(Lt||(e.TextEditorRevealType=Lt={}));var lt;(function(T){T[T.Keyboard=1]="Keyboard",T[T.Mouse=2]="Mouse",T[T.Command=3]="Command"})(lt||(e.TextEditorSelectionChangeKind=lt={}));var wt;(function(T){T[T.Undo=1]="Undo",T[T.Redo=2]="Redo"})(wt||(e.TextDocumentChangeReason=wt={}));var Ot;(function(T){T[T.OpenOpen=0]="OpenOpen",T[T.ClosedClosed=1]="ClosedClosed",T[T.OpenClosed=2]="OpenClosed",T[T.ClosedOpen=3]="ClosedOpen"})(Ot||(e.DecorationRangeBehavior=Ot={})),function(T){function M(ae){switch(ae){case"keyboard":return T.Keyboard;case"mouse":return T.Mouse;case"api":return T.Command}}T.fromValue=M}(lt||(e.TextEditorSelectionChangeKind=lt={}));let ft=class{constructor(M,ae){if(ae&&!$.URI.isUri(ae))throw(0,O.$5)("target");if(!ue.isRange(M)||M.isEmpty)throw(0,O.$5)("range");this.range=M,this.target=ae}};e.$lK=ft,e.$lK=ft=Le([j],ft);let vt=class{constructor(M,ae,we,je){this.red=M,this.green=ae,this.blue=we,this.alpha=je}};e.$mK=vt,e.$mK=vt=Le([j],vt);let yt=class{constructor(M,ae){if(ae&&!(ae instanceof vt))throw(0,O.$5)("color");if(!ue.isRange(M)||M.isEmpty)throw(0,O.$5)("range");this.range=M,this.color=ae}};e.$nK=yt,e.$nK=yt=Le([j],yt);let Ct=class{constructor(M){if(!M||typeof M!="string")throw(0,O.$5)("label");this.label=M}};e.$oK=Ct,e.$oK=Ct=Le([j],Ct);var jt;(function(T){T[T.RGB=0]="RGB",T[T.HEX=1]="HEX",T[T.HSL=2]="HSL"})(jt||(e.ColorFormat=jt={}));var gt;(function(T){T[T.Error=0]="Error",T[T.Warning=1]="Warning",T[T.Information=2]="Information"})(gt||(e.SourceControlInputBoxValidationType=gt={}));var Tt;(function(T){T[T.Unknown=0]="Unknown",T[T.Shutdown=1]="Shutdown",T[T.Process=2]="Process",T[T.User=3]="User",T[T.Extension=4]="Extension"})(Tt||(e.TerminalExitReason=Tt={}));class Pt{constructor(M,ae,we){if(this.startIndex=M,this.length=ae,this.tooltip=we,typeof M!="number"||M<0)throw(0,O.$5)("startIndex");if(typeof ae!="number"||ae<1)throw(0,O.$5)("length");if(we!==void 0&&typeof we!="string")throw(0,O.$5)("tooltip")}}e.$pK=Pt;class st{constructor(M){this.uri=M}}e.$qK=st;class ut{constructor(M){this.terminalCommand=M}}e.$rK=ut;var dt;(function(T){T[T.Panel=1]="Panel",T[T.Editor=2]="Editor"})(dt||(e.TerminalLocation=dt={}));class zt{constructor(M){if(this.options=M,typeof M!="object")throw(0,O.$5)("options")}}e.$sK=zt;var It;(function(T){T[T.Always=1]="Always",T[T.Silent=2]="Silent",T[T.Never=3]="Never"})(It||(e.TaskRevealKind=It={}));var Ut;(function(T){T[T.Shared=1]="Shared",T[T.Dedicated=2]="Dedicated",T[T.New=3]="New"})(Ut||(e.TaskPanelKind=Ut={}));let kt=class{static{o=this}static{this.Clean=new o("clean","Clean")}static{this.Build=new o("build","Build")}static{this.Rebuild=new o("rebuild","Rebuild")}static{this.Test=new o("test","Test")}static from(M){switch(M){case"clean":return o.Clean;case"build":return o.Build;case"rebuild":return o.Rebuild;case"test":return o.Test;default:return}}constructor(M,ae){if(this.label=ae,typeof M!="string"||typeof ae!="string")throw(0,O.$5)("name");this.c=M}get id(){return this.c}};e.$tK=kt,e.$tK=kt=o=Le([j],kt);function Ft(T){let M="";for(let ae=0;ae<T.length;ae++)M+=T[ae].replace(/,/g,",,")+",";return M}let ve=class{constructor(M,ae,we){if(typeof M!="string")throw(0,O.$5)("process");this.e=[],this.c=M,ae!==void 0&&(Array.isArray(ae)?(this.e=ae,this.f=we):this.f=ae)}get process(){return this.c}set process(M){if(typeof M!="string")throw(0,O.$5)("process");this.c=M}get args(){return this.e}set args(M){Array.isArray(M)||(M=[]),this.e=M}get options(){return this.f}set options(M){this.f=M}computeId(){const M=[];if(M.push("process"),this.c!==void 0&&M.push(this.c),this.e&&this.e.length>0)for(const ae of this.e)M.push(ae);return Ft(M)}};e.$uK=ve,e.$uK=ve=Le([j],ve);let Se=class{constructor(M,ae,we){if(this.f=[],Array.isArray(ae)){if(!M)throw(0,O.$5)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,O.$5)("command");this.e=M,this.f=ae,this.g=we}else{if(typeof M!="string")throw(0,O.$5)("commandLine");this.c=M,this.g=ae}}get commandLine(){return this.c}set commandLine(M){if(typeof M!="string")throw(0,O.$5)("commandLine");this.c=M}get command(){return this.e?this.e:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,O.$5)("command");this.e=M}get args(){return this.f}set args(M){this.f=M||[]}get options(){return this.g}set options(M){this.g=M}computeId(){const M=[];if(M.push("shell"),this.c!==void 0&&M.push(this.c),this.e!==void 0&&M.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ae of this.f)M.push(typeof ae=="string"?ae:ae.value);return Ft(M)}};e.$vK=Se,e.$vK=Se=Le([j],Se);var fe;(function(T){T[T.Escape=1]="Escape",T[T.Strong=2]="Strong",T[T.Weak=3]="Weak"})(fe||(e.ShellQuoting=fe={}));var G;(function(T){T[T.Global=1]="Global",T[T.Workspace=2]="Workspace"})(G||(e.TaskScope=G={}));class Ce{constructor(M){this.c=M}computeId(){return"customExecution"+(0,A.$3e)()}set callback(M){this.c=M}get callback(){return this.c}}e.$wK=Ce;let Oe=class{static{f=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(M,ae,we,je,Ge,et){this.j=!1,this.k=this.definition=M;let tt;typeof ae=="string"?(this.m=this.name=ae,this.t=this.source=we,this.execution=je,tt=Ge,this.j=!0):ae===G.Global||ae===G.Workspace?(this.target=ae,this.m=this.name=we,this.t=this.source=je,this.execution=Ge,tt=et):(this.target=ae,this.m=this.name=we,this.t=this.source=je,this.execution=Ge,tt=et),typeof tt=="string"?(this.o=[tt],this.q=!0):Array.isArray(tt)?(this.o=tt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(M){this.h=M}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof ve?this.k={type:f.e,id:this.n.computeId()}:this.n instanceof Se?this.k={type:f.f,id:this.n.computeId()}:this.n instanceof Ce?this.k={type:f.c,id:this.n.computeId()}:this.k={type:f.g,id:(0,A.$3e)()}}get definition(){return this.k}set definition(M){if(M==null)throw(0,O.$5)("Kind can't be undefined or null");this.y(),this.k=M}get scope(){return this.l}set target(M){this.y(),this.l=M}get name(){return this.m}set name(M){if(typeof M!="string")throw(0,O.$5)("name");this.y(),this.m=M}get execution(){return this.n}set execution(M){M===null&&(M=void 0),this.y(),this.n=M;const ae=this.k.type;(f.g===ae||f.e===ae||f.f===ae||f.c===ae)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(M){if(Array.isArray(M))this.y(),this.o=M,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.y(),this.r=M}get source(){return this.t}set source(M){if(typeof M!="string"||M.length===0)throw(0,O.$5)("source must be a string of length > 0");this.y(),this.t=M}get group(){return this.u}set group(M){M===null&&(M=void 0),this.y(),this.u=M}get detail(){return this.x}set detail(M){M===null&&(M=void 0),this.x=M}get presentationOptions(){return this.v}set presentationOptions(M){M==null&&(M=Object.create(null)),this.y(),this.v=M}get runOptions(){return this.w}set runOptions(M){M==null&&(M=Object.create(null)),this.y(),this.w=M}};e.$xK=Oe,e.$xK=Oe=f=Le([j],Oe);var We;(function(T){T[T.SourceControl=1]="SourceControl",T[T.Window=10]="Window",T[T.Notification=15]="Notification"})(We||(e.ProgressLocation=We={}));var Ue;(function(T){function M(ae){const we=ae;return(0,w.$me)(we.value)?we.tooltip&&!(0,w.$ie)(we.tooltip)?(console.log("INVALID view badge, invalid tooltip",we.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",we.value),!1)}T.isViewBadge=M})(Ue||(e.ViewBadge=Ue={}));let Qe=b=class{static isTreeItem(M,ae){const we=M;if(we.checkboxState!==void 0){const je=(0,w.$me)(we.checkboxState)?we.checkboxState:(0,w.$ke)(we.checkboxState)&&(0,w.$me)(we.checkboxState.state)?we.checkboxState.state:void 0,Ge=!(0,w.$me)(we.checkboxState)&&(0,w.$ke)(we.checkboxState)?we.checkboxState.tooltip:void 0;if(je===void 0||je!==mt.Checked&&je!==mt.Unchecked||Ge!==void 0&&!(0,w.$ie)(Ge))return console.log("INVALID tree item, invalid checkboxState",we.checkboxState),!1}if(M instanceof b)return!0;if(we.label!==void 0&&!(0,w.$ie)(we.label)&&!we.label?.label)return console.log("INVALID tree item, invalid label",we.label),!1;if(we.id!==void 0&&!(0,w.$ie)(we.id))return console.log("INVALID tree item, invalid id",we.id),!1;if(we.iconPath!==void 0&&!(0,w.$ie)(we.iconPath)&&!$.URI.isUri(we.iconPath)&&(!we.iconPath||!(0,w.$ie)(we.iconPath.id))){const je=we.iconPath;if(!je||!(0,w.$ie)(je.light)&&!$.URI.isUri(je.light)&&!(0,w.$ie)(je.dark)&&!$.URI.isUri(je.dark))return console.log("INVALID tree item, invalid iconPath",we.iconPath),!1}return we.description!==void 0&&!(0,w.$ie)(we.description)&&typeof we.description!="boolean"?(console.log("INVALID tree item, invalid description",we.description),!1):we.resourceUri!==void 0&&!$.URI.isUri(we.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",we.resourceUri),!1):we.tooltip!==void 0&&!(0,w.$ie)(we.tooltip)&&!(we.tooltip instanceof Ve)?(console.log("INVALID tree item, invalid tooltip",we.tooltip),!1):we.command!==void 0&&!we.command.command?(console.log("INVALID tree item, invalid command",we.command),!1):we.collapsibleState!==void 0&&we.collapsibleState<ot.None&&we.collapsibleState>ot.Expanded?(console.log("INVALID tree item, invalid collapsibleState",we.collapsibleState),!1):we.contextValue!==void 0&&!(0,w.$ie)(we.contextValue)?(console.log("INVALID tree item, invalid contextValue",we.contextValue),!1):we.accessibilityInformation!==void 0&&!we.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",we.accessibilityInformation),!1):!0}constructor(M,ae=ot.None){this.collapsibleState=ae,$.URI.isUri(M)?this.resourceUri=M:this.label=M}};e.$yK=Qe,e.$yK=Qe=b=Le([j],Qe);var ot;(function(T){T[T.None=0]="None",T[T.Collapsed=1]="Collapsed",T[T.Expanded=2]="Expanded"})(ot||(e.TreeItemCollapsibleState=ot={}));var mt;(function(T){T[T.Unchecked=0]="Unchecked",T[T.Checked=1]="Checked"})(mt||(e.TreeItemCheckboxState=mt={}));let ht=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(M){this.value=M}};e.$zK=ht,e.$zK=ht=Le([j],ht);class at extends ht{}e.$AK=at;class $t extends at{#e;constructor(M){super(""),this.#e=M}asFile(){return this.#e}}e.$BK=$t;class ai{constructor(M,ae,we,je){this.name=M,this.uri=ae,this._itemId=we,this.c=je}data(){return this.c()}}e.$CK=ai;let Kt=class{#e=new Map;constructor(M){for(const[ae,we]of M??[]){const je=this.#e.get(this.#t(ae));je?je.push(we):this.#e.set(this.#t(ae),[we])}}get(M){return this.#e.get(this.#t(M))?.[0]}set(M,ae){this.#e.set(this.#t(M),[ae])}forEach(M,ae){for(const[we,je]of this.#e)for(const Ge of je)M.call(ae,Ge,we,this)}*[Symbol.iterator](){for(const[M,ae]of this.#e)for(const we of ae)yield[M,we]}#t(M){return M.toLowerCase()}};e.$DK=Kt,e.$DK=Kt=Le([j],Kt);let Jt=class{constructor(M){this.insertText=M}};e.$EK=Jt,e.$EK=Jt=Le([j],Jt);let Yt=class{constructor(M,ae){this.label=ae,this.insertText=M}};e.$FK=Yt,e.$FK=Yt=Le([j],Yt);let At=class{constructor(M,ae){this.id=M,this.color=ae}static isThemeIcon(M){return typeof M.id!="string"?(console.log("INVALID ThemeIcon, invalid id",M.id),!1):!0}};e.$GK=At,e.$GK=At=Le([j],At),At.File=new At("file"),At.Folder=new At("folder");let Xt=class{constructor(M){this.id=M}};e.$HK=Xt,e.$HK=Xt=Le([j],Xt);var Cn;(function(T){T[T.Global=1]="Global",T[T.Workspace=2]="Workspace",T[T.WorkspaceFolder=3]="WorkspaceFolder"})(Cn||(e.ConfigurationTarget=Cn={}));let Zt=class{get base(){return this.c}set base(M){this.c=M,this.e=$.URI.file(M)}get baseUri(){return this.e}set baseUri(M){this.e=M,this.c=M.fsPath}constructor(M,ae){if(typeof M!="string"&&(!M||!$.URI.isUri(M)&&!$.URI.isUri(M.uri)))throw(0,O.$5)("base");if(typeof ae!="string")throw(0,O.$5)("pattern");typeof M=="string"?this.baseUri=$.URI.file(M):$.URI.isUri(M)?this.baseUri=M:this.baseUri=M.uri,this.pattern=ae}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$IK=Zt,e.$IK=Zt=Le([j],Zt);const Pn=new WeakMap;function ci(T,M){Pn.set(T,M)}e.$JK=ci;let Bt=class{constructor(M,ae,we,je){this.enabled=typeof M=="boolean"?M:!0,typeof ae=="string"&&(this.condition=ae),typeof we=="string"&&(this.hitCondition=we),typeof je=="string"&&(this.logMessage=je)}get id(){return this.c||(this.c=Pn.get(this)??(0,A.$3e)()),this.c}};e.$KK=Bt,e.$KK=Bt=Le([j],Bt);let Qt=class extends Bt{constructor(M,ae,we,je,Ge){if(super(ae,we,je,Ge),M===null)throw(0,O.$5)("location");this.location=M}};e.$LK=Qt,e.$LK=Qt=Le([j],Qt);let xt=class extends Bt{constructor(M,ae,we,je,Ge){super(ae,we,je,Ge),this.functionName=M}};e.$MK=xt,e.$MK=xt=Le([j],xt);let _t=class extends Bt{constructor(M,ae,we,je,Ge,et,tt){if(super(je,Ge,et,tt),!ae)throw(0,O.$5)("dataId");this.label=M,this.dataId=ae,this.canPersist=we}};e.$NK=_t,e.$NK=_t=Le([j],_t);let en=class{constructor(M,ae,we){this.command=M,this.args=ae||[],this.options=we}};e.$OK=en,e.$OK=en=Le([j],en);let tn=class{constructor(M,ae){this.port=M,this.host=ae}};e.$PK=tn,e.$PK=tn=Le([j],tn);let nn=class{constructor(M){this.path=M}};e.$QK=nn,e.$QK=nn=Le([j],nn);let sn=class{constructor(M){this.implementation=M}};e.$RK=sn,e.$RK=sn=Le([j],sn);let rn=class{constructor(M,ae,we){this.session=M,this.threadId=ae,this.frameId=we}};e.$SK=rn,e.$SK=rn=Le([j],rn);let on=class{constructor(M,ae){this.session=M,this.threadId=ae}};e.$TK=on,e.$TK=on=Le([j],on);let an=class{constructor(M,ae){this.range=M,this.expression=ae}};e.$UK=an,e.$UK=an=Le([j],an);var In;(function(T){T[T.Invoke=0]="Invoke",T[T.Automatic=1]="Automatic"})(In||(e.InlineCompletionTriggerKind=In={}));let cn=class{constructor(M,ae){this.range=M,this.text=ae}};e.$VK=cn,e.$VK=cn=Le([j],cn);let ln=class{constructor(M,ae,we=!0){this.range=M,this.variableName=ae,this.caseSensitiveLookup=we}};e.$WK=ln,e.$WK=ln=Le([j],ln);let un=class{constructor(M,ae){this.range=M,this.expression=ae}};e.$XK=un,e.$XK=un=Le([j],un);let hn=class{constructor(M,ae){this.frameId=M,this.stoppedLocation=ae}};e.$YK=hn,e.$YK=hn=Le([j],hn);var An;(function(T){T[T.Changed=1]="Changed",T[T.Created=2]="Created",T[T.Deleted=3]="Deleted"})(An||(e.FileChangeType=An={}));let fn=y=class extends Error{static FileExists(M){return new y(M,p.FileSystemProviderErrorCode.FileExists,y.FileExists)}static FileNotFound(M){return new y(M,p.FileSystemProviderErrorCode.FileNotFound,y.FileNotFound)}static FileNotADirectory(M){return new y(M,p.FileSystemProviderErrorCode.FileNotADirectory,y.FileNotADirectory)}static FileIsADirectory(M){return new y(M,p.FileSystemProviderErrorCode.FileIsADirectory,y.FileIsADirectory)}static NoPermissions(M){return new y(M,p.FileSystemProviderErrorCode.NoPermissions,y.NoPermissions)}static Unavailable(M){return new y(M,p.FileSystemProviderErrorCode.Unavailable,y.Unavailable)}constructor(M,ae=p.FileSystemProviderErrorCode.Unknown,we){super($.URI.isUri(M)?M.toString(!0):M),this.code=we?.name??"Unknown",(0,p.$7j)(this,ae),Object.setPrototypeOf(this,y.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}};e.$ZK=fn,e.$ZK=fn=y=Le([j],fn);let dn=class{constructor(M,ae,we){this.start=M,this.end=ae,this.kind=we}};e.$1K=dn,e.$1K=dn=Le([j],dn);var Rn;(function(T){T[T.Comment=1]="Comment",T[T.Imports=2]="Imports",T[T.Region=3]="Region"})(Rn||(e.FoldingRangeKind=Rn={}));var Ln;(function(T){T[T.Collapsed=0]="Collapsed",T[T.Expanded=1]="Expanded"})(Ln||(e.CommentThreadCollapsibleState=Ln={}));var On;(function(T){T[T.Editing=0]="Editing",T[T.Preview=1]="Preview"})(On||(e.CommentMode=On={}));var Fn;(function(T){T[T.Published=0]="Published",T[T.Draft=1]="Draft"})(Fn||(e.CommentState=Fn={}));var Nn;(function(T){T[T.Unresolved=0]="Unresolved",T[T.Resolved=1]="Resolved"})(Nn||(e.CommentThreadState=Nn={}));class li{constructor(M,ae=[]){this.tokenTypes=M,this.tokenModifiers=ae}}e.$2K=li;function ui(T){return typeof T>"u"||(0,w.$je)(T)}class mn{constructor(M){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,M){this.l=!0;for(let ae=0,we=M.tokenTypes.length;ae<we;ae++)this.j.set(M.tokenTypes[ae],ae);for(let ae=0,we=M.tokenModifiers.length;ae<we;ae++)this.k.set(M.tokenModifiers[ae],ae)}}push(M,ae,we,je,Ge){if(typeof M=="number"&&typeof ae=="number"&&typeof we=="number"&&typeof je=="number"&&(typeof Ge=="number"||typeof Ge>"u"))return typeof Ge>"u"&&(Ge=0),this.n(M,ae,we,je,Ge);if(ue.isRange(M)&&typeof ae=="string"&&ui(we))return this.m(M,ae,we);throw(0,O.$5)()}m(M,ae,we){if(!this.l)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ae))throw new Error("`tokenType` is not in the provided legend");const je=M.start.line,Ge=M.start.character,et=M.end.character-M.start.character,tt=this.j.get(ae);let ct=0;if(we)for(const pt of we){if(!this.k.has(pt))throw new Error("`tokenModifier` is not in the provided legend");const Et=this.k.get(pt);ct|=1<<Et>>>0}this.n(je,Ge,et,tt,ct)}n(M,ae,we,je,Ge){if(this.f&&(M<this.c||M===this.c&&ae<this.e)){this.f=!1;const ct=this.g.length/5|0;let pt=0,Et=0;for(let St=0;St<ct;St++){let Rt=this.g[5*St],Ht=this.g[5*St+1];Rt===0?(Rt=pt,Ht+=Et):Rt+=pt,this.g[5*St]=Rt,this.g[5*St+1]=Ht,pt=Rt,Et=Ht}}let et=M,tt=ae;this.f&&this.h>0&&(et-=this.c,et===0&&(tt-=this.e)),this.g[this.h++]=et,this.g[this.h++]=tt,this.g[this.h++]=we,this.g[this.h++]=je,this.g[this.h++]=Ge,this.c=M,this.e=ae}static o(M){const ae=[],we=M.length/5|0;for(let tt=0;tt<we;tt++)ae[tt]=tt;ae.sort((tt,ct)=>{const pt=M[5*tt],Et=M[5*ct];if(pt===Et){const St=M[5*tt+1],Rt=M[5*ct+1];return St-Rt}return pt-Et});const je=new Uint32Array(M.length);let Ge=0,et=0;for(let tt=0;tt<we;tt++){const ct=5*ae[tt],pt=M[ct+0],Et=M[ct+1],St=M[ct+2],Rt=M[ct+3],Ht=M[ct+4],oi=pt-Ge,Li=oi===0?Et-et:Et,Vt=5*tt;je[Vt+0]=oi,je[Vt+1]=Li,je[Vt+2]=St,je[Vt+3]=Rt,je[Vt+4]=Ht,Ge=pt,et=Et}return je}build(M){return this.f?new gn(new Uint32Array(this.g),M):new gn(mn.o(this.g),M)}}e.$3K=mn;class gn{constructor(M,ae){this.resultId=ae,this.data=M}}e.$4K=gn;class hi{constructor(M,ae,we){this.start=M,this.deleteCount=ae,this.data=we}}e.$5K=hi;class fi{constructor(M,ae){this.resultId=ae,this.edits=M}}e.$6K=fi;var Mn;(function(T){T[T.Separate=0]="Separate",T[T.MergeWithParent=1]="MergeWithParent"})(Mn||(e.DebugConsoleMode=Mn={}));let $n=class{static{this.Back={iconPath:new At("arrow-left")}}constructor(){}};e.$7K=$n,e.$7K=$n=Le([j],$n);var jn;(function(T){T[T.Separator=-1]="Separator",T[T.Default=0]="Default"})(jn||(e.QuickPickItemKind=jn={}));var Tn;(function(T){T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(Tn||(e.InputBoxValidationSeverity=Tn={}));var Un;(function(T){T[T.UI=1]="UI",T[T.Workspace=2]="Workspace"})(Un||(e.ExtensionKind=Un={}));class di{static validate(M){if(typeof M.badge=="string"){let ae=(0,P.$Vd)(M.badge,0);if(ae<M.badge.length&&(ae+=(0,P.$Vd)(M.badge,ae)),M.badge.length>ae)throw new Error("The 'badge'-property must be undefined or a short character")}else if(M.badge&&!At.isThemeIcon(M.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty");return!0}constructor(M,ae,we){this.badge=M,this.tooltip=ae,this.color=we}}e.$8K=di;let pn=class{constructor(M){this.kind=M}};e.$9K=pn,e.$9K=pn=Le([j],pn);var zn;(function(T){T[T.Light=1]="Light",T[T.Dark=2]="Dark",T[T.HighContrast=3]="HighContrast",T[T.HighContrastLight=4]="HighContrastLight"})(zn||(e.ColorThemeKind=zn={}));class Nt{static isNotebookRange(M){return M instanceof Nt?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(M,ae){if(M<0)throw(0,O.$5)("start must be positive");if(ae<0)throw(0,O.$5)("end must be positive");M<=ae?(this.c=M,this.e=ae):(this.c=ae,this.e=M)}with(M){let ae=this.c,we=this.e;return M.start!==void 0&&(ae=M.start),M.end!==void 0&&(we=M.end),ae===this.c&&we===this.e?this:new Nt(ae,we)}}e.$0K=Nt;class Wt{static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(ae=>Wt.isNotebookCellData(ae))}static isNotebookCellData(M){return!0}constructor(M,ae,we,je,Ge,et,tt){this.kind=M,this.value=ae,this.languageId=we,this.mime=je,this.outputs=Ge??[],this.metadata=et,this.executionSummary=tt,Wt.validate(this)}}e.$$K=Wt;class mi{constructor(M){this.cells=M}}e.$_K=mi;class Dt{static isNotebookCellOutputItem(M){return M instanceof Dt?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const ae={name:M.name,message:M.message,stack:M.stack};return Dt.json(ae,"application/vnd.code.notebook.error")}static stdout(M){return Dt.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return Dt.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,ae="application/octet-stream"){return new Dt(M,ae)}static#e=new TextEncoder;static text(M,ae=I.$yr.text){const we=Dt.#e.encode(String(M));return new Dt(we,ae)}static json(M,ae="text/x-json"){const we=JSON.stringify(M,void 0,"	");return Dt.text(we,ae)}constructor(M,ae){this.data=M,this.mime=ae;const we=(0,I.$Cr)(ae,!0);if(!we)throw new Error(`INVALID mime type: ${ae}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}}e.$aL=Dt;class Gt{static isNotebookCellOutput(M){return M instanceof Gt?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&Array.isArray(M.items)}static ensureUniqueMimeTypes(M,ae=!1){const we=new Set,je=new Set;for(let Ge=0;Ge<M.length;Ge++){const et=M[Ge],tt=(0,I.$Cr)(et.mime);if(!we.has(tt)||(0,d.$RH)(tt)){we.add(tt);continue}je.add(Ge),ae&&console.warn(`DUPLICATED mime type '${et.mime}' will be dropped`)}return je.size===0?M:M.filter((Ge,et)=>!je.has(et))}constructor(M,ae,we){this.items=Gt.ensureUniqueMimeTypes(M,!0),typeof ae=="string"?(this.id=ae,this.metadata=we):(this.id=(0,A.$3e)(),this.metadata=ae??we)}}e.$bL=Gt;var Bn;(function(T){T[T.Markup=1]="Markup",T[T.Code=2]="Code"})(Bn||(e.NotebookCellKind=Bn={}));var qn;(function(T){T[T.Idle=1]="Idle",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(qn||(e.NotebookCellExecutionState=qn={}));var Hn;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(Hn||(e.NotebookCellStatusBarAlignment=Hn={}));var Vn;(function(T){T[T.Default=0]="Default",T[T.InCenter=1]="InCenter",T[T.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",T[T.AtTop=3]="AtTop"})(Vn||(e.NotebookEditorRevealType=Vn={}));class gi{constructor(M,ae){this.text=M,this.alignment=ae}}e.$cL=gi;var Wn;(function(T){T[T.Default=1]="Default",T[T.Preferred=2]="Preferred"})(Wn||(e.NotebookControllerAffinity=Wn={}));var Gn;(function(T){T[T.Default=1]="Default",T[T.Preferred=2]="Preferred",T[T.Hidden=-1]="Hidden"})(Gn||(e.NotebookControllerAffinity2=Gn={}));class $i{constructor(M,ae=[]){this.uri=M,this.provides=(0,D.$Gf)(ae)}}e.$dL=$i;class pi{constructor(M){this.label=M}}e.$eL=pi;let bn=class{constructor(M,ae){this.label=M,this.timestamp=ae}};e.$fL=bn,e.$fL=bn=Le([j],bn);var Kn;(function(T){T[T.Production=1]="Production",T[T.Development=2]="Development",T[T.Test=3]="Test"})(Kn||(e.ExtensionMode=Kn={}));var Jn;(function(T){T[T.Node=1]="Node",T[T.Webworker=2]="Webworker"})(Jn||(e.ExtensionRuntime=Jn={}));var Yn;(function(T){T[T.Other=0]="Other",T[T.Comment=1]="Comment",T[T.String=2]="String",T[T.RegEx=3]="RegEx"})(Yn||(e.StandardTokenType=Yn={}));class bi{constructor(M,ae){this.ranges=M,this.wordPattern=ae}}e.$gL=bi;class wi{constructor(M){this.c=M}get autoForwardAction(){return this.c}}e.$hL=wi;var Xn;(function(T){T[T.Queued=1]="Queued",T[T.Running=2]="Running",T[T.Passed=3]="Passed",T[T.Failed=4]="Failed",T[T.Skipped=5]="Skipped",T[T.Errored=6]="Errored"})(Xn||(e.TestResultState=Xn={}));var Zn;(function(T){T[T.Run=1]="Run",T[T.Debug=2]="Debug",T[T.Coverage=3]="Coverage"})(Zn||(e.TestRunProfileKind=Zn={}));let wn=class{constructor(M=void 0,ae=void 0,we=void 0,je=!1){this.include=M,this.exclude=ae,this.profile=we,this.continuous=je}};e.$iL=wn,e.$iL=wn=Le([j],wn);let vn=S=class{static diff(M,ae,we){const je=new S(M);return je.expectedOutput=ae,je.actualOutput=we,je}constructor(M){this.message=M}};e.$jL=vn,e.$jL=vn=S=Le([j],vn);let yn=class{constructor(M){this.id=M}};e.$kL=yn,e.$kL=yn=Le([j],yn);let qt=class{constructor(M,ae){this.covered=M,this.total=ae}};e.$lL=qt,e.$lL=qt=Le([j],qt);let En=L=class{static fromDetails(M,ae){const we=new qt(0,0),je=new qt(0,0),Ge=new qt(0,0);for(const tt of ae)if("branches"in tt){we.total+=1,we.covered+=tt.executionCount>0?1:0;for(const ct of tt.branches)je.total+=1,je.covered+=ct.executionCount>0?1:0}else Ge.total+=1,Ge.covered+=tt.executionCount>0?1:0;const et=new L(M,we,je.total>0?je:void 0,Ge.total>0?Ge:void 0);return et.detailedCoverage=ae,et}constructor(M,ae,we,je){this.uri=M,this.statementCoverage=ae,this.branchCoverage=we,this.functionCoverage=je}};e.$mL=En,e.$mL=En=L=Le([j],En);let kn=class{constructor(M,ae,we=[]){this.executionCount=M,this.location=ae,this.branches=we}};e.$nL=kn,e.$nL=kn=Le([j],kn);let Dn=class{constructor(M,ae){this.executionCount=M,this.location=ae}};e.$oL=Dn,e.$oL=Dn=Le([j],Dn);let Sn=class{constructor(M,ae){this.executionCount=M,this.location=ae}};e.$pL=Sn,e.$pL=Sn=Le([j],Sn);var Qn;(function(T){T[T.None=0]="None",T[T.Option=1]="Option",T[T.Default=2]="Default",T[T.Preferred=3]="Preferred"})(Qn||(e.ExternalUriOpenerPriority=Qn={}));var xn;(function(T){T[T.Untrusted=0]="Untrusted",T[T.Trusted=1]="Trusted",T[T.Unspecified=2]="Unspecified"})(xn||(e.WorkspaceTrustState=xn={}));var _n;(function(T){T[T.Notify=1]="Notify",T[T.OpenBrowser=2]="OpenBrowser",T[T.OpenPreview=3]="OpenPreview",T[T.Silent=4]="Silent",T[T.Ignore=5]="Ignore",T[T.OpenBrowserOnce=6]="OpenBrowserOnce"})(_n||(e.PortAutoForwardAction=_n={}));class vi{constructor(M,ae,we,je,Ge,et){this.kind=M,this.name=ae,this.detail=we,this.uri=je,this.range=Ge,this.selectionRange=et}}e.$qL=vi;class yi{constructor(M){this.uri=M}}e.$rL=yi;class Ei{constructor(M,ae){this.original=M,this.modified=ae}}e.$sL=Ei;class ki{constructor(M,ae,we,je){this.base=M,this.input1=ae,this.input2=we,this.result=je}}e.$tL=ki;class Di{constructor(M,ae){this.uri=M,this.viewType=ae}}e.$uL=Di;class Si{constructor(M){this.viewType=M}}e.$vL=Si;class Ci{constructor(M,ae){this.uri=M,this.notebookType=ae}}e.$wL=Ci;class Pi{constructor(M,ae,we){this.original=M,this.modified=ae,this.notebookType=we}}e.$xL=Pi;class Ii{constructor(){}}e.$yL=Ii;class Ai{constructor(M,ae){this.uri=M,this.inputBoxUri=ae}}e.$zL=Ai;var ei;(function(T){T[T.Up=1]="Up",T[T.Down=2]="Down"})(ei||(e.InteractiveSessionVoteDirection=ei={}));var ti;(function(T){T[T.Action=1]="Action",T[T.Toolbar=2]="Toolbar"})(ti||(e.InteractiveSessionCopyKind=ti={}));var ni;(function(T){T[T.Unhelpful=0]="Unhelpful",T[T.Helpful=1]="Helpful",T[T.Undone=2]="Undone",T[T.Accepted=3]="Accepted"})(ni||(e.InteractiveEditorResponseFeedbackKind=ni={}));var ii;(function(T){T[T.System=0]="System",T[T.User=1]="User",T[T.Assistant=2]="Assistant",T[T.Function=3]="Function"})(ii||(e.ChatMessageRole=ii={}));var si;(function(T){T[T.Short=1]="Short",T[T.Medium=2]="Medium",T[T.Full=3]="Full"})(si||(e.ChatVariableLevel=si={}));class Ri{constructor(M,ae){this.role=M,this.content=ae}}e.$AL=Ri;var ri;(function(T){T[T.SymbolInformation=1]="SymbolInformation",T[T.CommandInformation=2]="CommandInformation",T[T.SearchInformation=3]="SearchInformation",T[T.SettingInformation=4]="SettingInformation"})(ri||(e.RelatedInformationType=ri={}))}),define(pe[268],be([1,0,6]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cM=void 0,e.$cM=(0,D.$ph)("environmentVariableService")}),define(pe[269],be([1,0,7,4,63,3,249,10]),function(ce,e,D,O,r,C,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=void 0;function w(v,t){if(t)if(C.$i)for(const s in t){let a=s;for(const n in v)if(s.toLowerCase()===n.toLowerCase()){a=n;break}const i=t[s];i!==void 0&&$(v,a,i)}else Object.keys(t).forEach(s=>{const a=t[s];a!==void 0&&$(v,s,a)})}e.$DM=w;function $(v,t,s){typeof s=="string"?v[t]=s:delete v[t]}function A(v,t,s,a){v.TERM_PROGRAM="vscode",t&&(v.TERM_PROGRAM_VERSION=t),l(v,a)&&(v.LANG=d(s)),v.COLORTERM="truecolor"}e.$EM=A;function k(v,t){if(t)for(const s of Object.keys(t)){const a=t[s];a!=null&&(v[s]=a)}}async function p(v,t){return await Promise.all(Object.entries(t).map(async([s,a])=>{if(typeof a=="string")try{t[s]=await v(a)}catch{t[s]=a}})),t}function l(v,t){if(t==="on")return!0;if(t==="auto"){const s=v.LANG;return!s||s.search(/\.UTF\-8$/)===-1&&s.search(/\.utf8$/)===-1&&s.search(/\.euc.+/)===-1}return!1}e.$FM=l;function d(v){const t=v?v.split("-"):[],s=t.length;if(s===0)return"en_US.UTF-8";if(s===1){const a={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in a&&t.push(a[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.$GM=d;async function m(v,t,s,a,i,n){if(v.cwd){const f=typeof v.cwd=="object"?v.cwd.fsPath:v.cwd,b=await c(f,s);return(0,I.$BM)(b||f)}let o;return!v.ignoreConfigurationCwd&&i&&(s&&(i=await c(i,s,n)),i&&(D.$7c(i)?o=i:a&&(o=D.$8c(a.fsPath,i)))),o||(o=a?a.fsPath:t||""),(0,I.$BM)(o)}e.$HM=m;async function c(v,t,s){if(t)try{return await t(v)}catch(a){s?.error("Could not resolve terminal cwd",a);return}return v}function u(v,t,s){if(s)return a=>s.resolveWithEnvironment(t,v,a)}e.$IM=u;async function h(v,t,s,a,i,n){const o={};if(v.strictEnv)k(o,v.env);else{k(o,n);const f={...t};s&&(f&&await p(s,f),v.env&&await p(s,v.env)),(0,r.$fl)(o,"VSCODE_IPC_HOOK_CLI"),w(o,f),w(o,v.env),A(o,a,C.$v,i)}return o}e.$JM=h;async function g(v,t,s,a,i,n,o=C.$i){let f;if((0,P.$ie)(v)?f=v:(f=v.fsPath,o&&n!==1?f=f.replace(/\\/g,"/"):!o&&n===1&&(f=f.replace(/\//g,"\\"))),!t)return f;const b=f.includes(" "),y=f.includes("(")||f.includes(")"),S=D.$_c(t,".exe"),L=S==="pwsh"||s==="pwsh"||S==="powershell"||s==="powershell";if(L&&(b||f.includes("'")))return`& '${f.replace(/'/g,"''")}'`;if(y&&L)return`& '${f}'`;if(n===1){if(a!==void 0)return a==="gitbash"?(0,I.$zM)(f.replace(/\\/g,"/")):a==="wsl"?i?.getWslPath(f,"win-to-unix")||f:b?`"${f}"`:f;const j=t.toLowerCase();return j.includes("wsl")||j.includes("bash.exe")&&!j.toLowerCase().includes("git")?i?.getWslPath(f,"win-to-unix")||f:b?`"${f}"`:f}return(0,I.$zM)(f)}e.$KM=g;function E(v,t,s){const a=typeof v=="string"?O.URI.parse(v):v;let i=a?t.getWorkspaceFolder(a)??void 0:void 0;if(!i){const n=s.getLastActiveWorkspaceRoot();i=n?t.getWorkspaceFolder(n)??void 0:void 0}return i}e.$LM=E}),define(pe[71],be([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wI=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(C){C.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var O;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class r{static fromExtHostTestItem(I,P,w=I.parent){if(I._isRoot)return new r([P]);const $=[I.id];for(let A=w;A&&A.id!==P;A=A.parent)$.push(A.id);return $.push(P),new r($.reverse())}static isRoot(I){return!I.includes("\0")}static root(I){const P=I.indexOf("\0");return P===-1?I:I.slice(0,P)}static fromString(I){return new r(I.split("\0"))}static join(I,P){return new r([...I.path,P])}static joinToString(I,P){return I.toString()+"\0"+P}static parentId(I){const P=I.lastIndexOf("\0");return P===-1?void 0:I.slice(0,P)}static localId(I){const P=I.lastIndexOf("\0");return P===-1?I:I.slice(P+1)}static isChild(I,P){return P.startsWith(I)&&P[I.length]==="\0"}static compare(I,P){return I===P?0:r.isChild(I,P)?2:r.isChild(P,I)?3:1}constructor(I,P=I.length){if(this.path=I,this.d=P,I.length===0||P<1)throw new Error("cannot create test with empty path")}get rootId(){return new r(this.path,1)}get parentId(){return this.d>1?new r(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let I=1;I<=this.d;I++)yield new r(this.path,I)}*idsToRoot(){for(let I=this.d;I>0;I--)yield new r(this.path,I)}compare(I){if(typeof I=="string")return r.compare(this.toString(),I);for(let P=0;P<I.d&&P<this.d;P++)if(I.path[P]!==this.path[P])return 1;return I.d>this.d?2:I.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let I=1;I<this.d;I++)this.c+="\0",this.c+=this.path[I]}return this.c}}e.$wI=r}),define(pe[92],be([1,0,4,42,71]),function(ce,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DI=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$CI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$BI=e.$AI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$zI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$yI=e.$xI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var C;(function(b){b[b.Unset=0]="Unset",b[b.Queued=1]="Queued",b[b.Running=2]="Running",b[b.Passed=3]="Passed",b[b.Failed=4]="Failed",b[b.Skipped=5]="Skipped",b[b.Errored=6]="Errored"})(C||(e.TestResultState=C={}));var I;(function(b){b[b.Run=1]="Run",b[b.Debug=2]="Debug",b[b.Coverage=3]="Coverage"})(I||(e.ExtTestRunProfileKind=I={}));var P;(function(b){b[b.Run=2]="Run",b[b.Debug=4]="Debug",b[b.Coverage=8]="Coverage",b[b.HasNonDefaultProfile=16]="HasNonDefaultProfile",b[b.HasConfigurable=32]="HasConfigurable",b[b.SupportsContinuousRun=64]="SupportsContinuousRun"})(P||(e.TestRunProfileBitset=P={})),e.$xI=[2,4,8,16,32,64];const w=b=>"runId"in b;e.$yI=w;var $;(function(b){b.serialize=y=>({range:y.range.toJSON(),uri:y.uri.toJSON()}),b.deserialize=y=>({range:O.$Ur.lift(y.range),uri:D.URI.revive(y.uri)})})($||(e.IRichLocation=$={}));var A;(function(b){b[b.Error=0]="Error",b[b.Output=1]="Output"})(A||(e.TestMessageType=A={}));var k;(function(b){b.serialize=y=>({message:y.message,type:0,expected:y.expected,actual:y.actual,contextValue:y.contextValue,location:y.location&&$.serialize(y.location)}),b.deserialize=y=>({message:y.message,type:0,expected:y.expected,actual:y.actual,contextValue:y.contextValue,location:y.location&&$.deserialize(y.location)})})(k||(e.ITestErrorMessage=k={}));const p=(b,y)=>`${y?"s":"e"}${b}`;e.$zI=p;var l;(function(b){b.serialize=y=>({message:y.message,type:1,offset:y.offset,length:y.length,location:y.location&&$.serialize(y.location)}),b.deserialize=y=>({message:y.message,type:1,offset:y.offset,length:y.length,location:y.location&&$.deserialize(y.location)})})(l||(e.ITestOutputMessage=l={}));var d;(function(b){b.serialize=y=>y.type===0?k.serialize(y):l.serialize(y),b.deserialize=y=>y.type===0?k.deserialize(y):l.deserialize(y)})(d||(e.ITestMessage=d={}));var m;(function(b){b.serializeWithoutMessages=y=>({state:y.state,duration:y.duration,messages:[]}),b.serialize=y=>({state:y.state,duration:y.duration,messages:y.messages.map(d.serialize)}),b.deserialize=y=>({state:y.state,duration:y.duration,messages:y.messages.map(d.deserialize)})})(m||(e.ITestTaskState=m={}));const c="\0",u=(b,y)=>b+c+y;e.$AI=u;const h=b=>{const y=b.indexOf(c);return{ctrlId:b.slice(0,y),tagId:b.slice(y+1)}};e.$BI=h;var g;(function(b){b.serialize=y=>({extId:y.extId,label:y.label,tags:y.tags,busy:y.busy,children:void 0,uri:y.uri?.toJSON(),range:y.range?.toJSON()||null,description:y.description,error:y.error,sortText:y.sortText}),b.deserialize=y=>({extId:y.extId,label:y.label,tags:y.tags,busy:y.busy,children:void 0,uri:y.uri?D.URI.revive(y.uri):void 0,range:y.range?O.$Ur.lift(y.range):null,description:y.description,error:y.error,sortText:y.sortText})})(g||(e.ITestItem=g={}));var E;(function(b){b[b.NotExpandable=0]="NotExpandable",b[b.Expandable=1]="Expandable",b[b.BusyExpanding=2]="BusyExpanding",b[b.Expanded=3]="Expanded"})(E||(e.TestItemExpandState=E={}));var v;(function(b){b.serialize=y=>({expand:y.expand,item:g.serialize(y.item)}),b.deserialize=y=>({controllerId:r.$wI.root(y.item.extId),expand:y.expand,item:g.deserialize(y.item)})})(v||(e.InternalTestItem=v={}));var t;(function(b){b.serialize=y=>{let S;return y.item&&(S={},y.item.label!==void 0&&(S.label=y.item.label),y.item.tags!==void 0&&(S.tags=y.item.tags),y.item.busy!==void 0&&(S.busy=y.item.busy),y.item.uri!==void 0&&(S.uri=y.item.uri?.toJSON()),y.item.range!==void 0&&(S.range=y.item.range?.toJSON()),y.item.description!==void 0&&(S.description=y.item.description),y.item.error!==void 0&&(S.error=y.item.error),y.item.sortText!==void 0&&(S.sortText=y.item.sortText)),{extId:y.extId,expand:y.expand,item:S}},b.deserialize=y=>{let S;return y.item&&(S={},y.item.label!==void 0&&(S.label=y.item.label),y.item.tags!==void 0&&(S.tags=y.item.tags),y.item.busy!==void 0&&(S.busy=y.item.busy),y.item.range!==void 0&&(S.range=y.item.range?O.$Ur.lift(y.item.range):null),y.item.description!==void 0&&(S.description=y.item.description),y.item.error!==void 0&&(S.error=y.item.error),y.item.sortText!==void 0&&(S.sortText=y.item.sortText)),{extId:y.extId,expand:y.expand,item:S}}})(t||(e.ITestItemUpdate=t={}));const s=(b,y)=>{y.expand!==void 0&&(b.expand=y.expand),y.item!==void 0&&(b.item=b.item?Object.assign(b.item,y.item):y.item)};e.$CI=s;var a;(function(b){b.serializeWithoutMessages=y=>({...v.serialize(y),ownComputedState:y.ownComputedState,computedState:y.computedState,tasks:y.tasks.map(m.serializeWithoutMessages)}),b.serialize=y=>({...v.serialize(y),ownComputedState:y.ownComputedState,computedState:y.computedState,tasks:y.tasks.map(m.serialize)}),b.deserialize=y=>({...v.deserialize(y),ownComputedState:y.ownComputedState,computedState:y.computedState,tasks:y.tasks.map(m.deserialize),retired:!0})})(a||(e.TestResultItem=a={}));var i;(function(b){b[b.Function=0]="Function",b[b.Statement=1]="Statement"})(i||(e.DetailType=i={}));var n;(function(b){b[b.Add=0]="Add",b[b.Update=1]="Update",b[b.DocumentSynced=2]="DocumentSynced",b[b.Remove=3]="Remove",b[b.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",b[b.Retire=5]="Retire",b[b.AddTag=6]="AddTag",b[b.RemoveTag=7]="RemoveTag"})(n||(e.TestDiffOpType=n={}));var o;(function(b){b.deserialize=y=>y.op===0?{op:y.op,item:v.deserialize(y.item)}:y.op===1?{op:y.op,item:t.deserialize(y.item)}:y.op===2?{op:y.op,uri:D.URI.revive(y.uri),docv:y.docv}:y,b.serialize=y=>y.op===0?{op:y.op,item:v.serialize(y.item)}:y.op===1?{op:y.op,item:t.serialize(y.item)}:y})(o||(e.TestsDiffOp=o={}));class f{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(y){const S=this.p();for(const L of y)switch(L.op){case 0:this.k(v.deserialize(L.item),S);break;case 1:this.l(t.deserialize(L.item),S);break;case 3:this.m(L.itemId,S);break;case 5:this.o(L.itemId);break;case 4:this.updatePendingRoots(L.amount);break;case 6:this.d.set(L.tag.id,L.tag);break;case 7:this.d.delete(L.id);break}S.complete?.()}k(y,S){const L=r.$wI.parentId(y.item.extId)?.toString();let j;if(!L)j=this.q(y),this.g.add(j),this.f.set(y.item.extId,j);else if(this.f.has(L)){const Q=this.f.get(L);Q.children.add(y.item.extId),j=this.q(y,Q),this.f.set(y.item.extId,j)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(y)}`);return}return S.add?.(j),y.expand===2&&this.h++,j}l(y,S){const L=this.f.get(y.extId);if(L)return y.expand!==void 0&&(L.expand===2&&this.h--,y.expand===2&&this.h++),(0,e.$CI)(L,y),S.update?.(L),L}m(y,S){const L=this.f.get(y);if(!L)return;const j=r.$wI.parentId(L.item.extId)?.toString();j?this.f.get(j).children.delete(L.item.extId):this.g.delete(L);const Q=[[y]];for(;Q.length;)for(const le of Q.pop()){const Y=this.f.get(le);Y&&(Q.push(Y.children),this.f.delete(le),S.remove?.(Y,Y!==L),Y.expand===2&&this.h--)}}o(y){}updatePendingRoots(y){this.j+=y}p(){return{}}}e.$DI=f}),define(pe[133],be([1,0,14,5,2,95,92,71]),function(ce,e,D,O,r,C,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.TestItemEventOp=void 0;var w;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk",h[h.DocumentSynced=6]="DocumentSynced"})(w||(e.TestItemEventOp=w={}));const $=(h,g)=>h===g,k=Object.entries({range:(h,g)=>h===g?!0:!h||!g?!1:h.equalsRange(g),busy:$,label:$,description:$,error:$,sortText:$,tags:(h,g)=>!(h.length!==g.length||h.some(E=>!g.includes(E)))}),p=(h,g)=>{let E;for(const[v,t]of k)t(h[v],g[v])||(E?E[v]=g[v]:E={[v]:g[v]});return E};class l extends r.$lb{get root(){return this.m.root}constructor(g){super(),this.m=g,this.f=this.B(new D.$Gg(()=>this.flushDiff(),200)),this.g=this.B(new O.$ec),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(g){this.h=g;for(const E of this.tree.values())this.G(E)}get resolveHandler(){return this.h}collectDiff(){const g=this.k;return this.k=[],g}pushDiff(g){switch(g.op){case 2:{for(const E of this.k)if(E.op===2&&E.uri===g.uri){E.docv=g.docv;return}break}case 1:{const E=this.k[this.k.length-1];if(E){if(E.op===1&&E.item.extId===g.item.extId){(0,I.$CI)(E.item,g.item);return}if(E.op===0&&E.item.item.extId===g.item.extId){(0,I.$CI)(E.item,g.item);return}}break}}this.k.push(g),this.f.isScheduled()||this.f.schedule()}expand(g,E){const v=this.tree.get(g);if(v){if((v.expandLevels===void 0||E>v.expandLevels)&&(v.expandLevels=E),v.expand===1){const t=this.I(v);return t.isOpen()?this.H(v,E-1):t.wait().then(()=>this.H(v,E-1))}else if(v.expand===3)return v.resolveBarrier?.isOpen()===!1?v.resolveBarrier.wait().then(()=>this.H(v,E-1)):this.H(v,E-1)}}dispose(){for(const g of this.tree.values())this.m.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(g,E){switch(E.op){case 3:this.L(P.$wI.joinToString(g.fullId,E.id));break;case 0:this.u(E.item,g);break;case 5:for(const v of E.ops)this.p(g,v);break;case 1:this.w(E.new,E.old,g.fullId.toString());break;case 2:this.G(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:E.update}});break;case 6:this.s(g.actual.uri);break;default:(0,C.$wb)(E)}}s(g){g&&this.pushDiff({op:2,uri:g,docv:this.m.getDocumentVersion(g)})}u(g,E){const v=P.$wI.fromExtHostTestItem(g,this.root.id,E?.actual),t=this.m.getApiFor(g);t.parent&&t.parent!==E?.actual&&this.m.getChildren(t.parent).delete(g.id);let s=this.tree.get(v.toString());if(!s){s={fullId:v,actual:g,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},g.tags.forEach(this.y,this),this.tree.set(s.fullId.toString(),s),this.C(g,E),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:s.expand,item:this.m.toITestItem(g)}}),this.F(g,s,E);return}if(s.actual===g){this.D(g,s,E);return}if(s.actual.uri?.toString()!==g.uri?.toString())return this.L(v.toString()),this.u(g,E);const a=this.m.getChildren(s.actual),i=s.actual,n=p(this.m.toITestItem(i),this.m.toITestItem(g));this.m.getApiFor(i).listener=void 0,s.actual=g,s.expand=0,n&&(n.hasOwnProperty("tags")&&(this.w(g.tags,i.tags,v.toString()),delete n.tags),this.p(s,{op:4,update:n})),this.F(g,s,E);for(const[o,f]of a)this.m.getChildren(g).get(f.id)||this.L(P.$wI.joinToString(v,f.id));this.s(s.actual.uri)}w(g,E,v){const t=new Set(E.map(s=>s.id));for(const s of g)t.delete(s.id)||this.y(s);this.pushDiff({op:1,item:{extId:v,item:{tags:g.map(s=>(0,I.$AI)(this.m.controllerId,s.id))}}}),t.forEach(this.z,this)}y(g){const E=this.j.get(g.id);E?E.refCount++:(this.j.set(g.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,I.$AI)(this.m.controllerId,g.id)}}))}z(g){const E=this.j.get(g);E&&!--E.refCount&&(this.j.delete(g),this.pushDiff({op:7,id:(0,I.$AI)(this.m.controllerId,g)}))}C(g,E){this.m.getApiFor(g).parent=E&&E.actual!==this.root?E.actual:void 0}D(g,E,v){this.C(g,v);const t=this.m.getApiFor(g);t.parent=v?.actual,t.listener=s=>this.p(E,s),this.G(E)}F(g,E,v){this.D(g,E,v);for(const[t,s]of this.m.getChildren(g))this.u(s,E)}G(g){let E;this.h?g.resolveBarrier?E=g.resolveBarrier.isOpen()?3:2:E=g.actual.canResolveChildren?1:0:E=0,E!==g.expand&&(g.expand=E,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:E}}),E===1&&g.expandLevels!==void 0&&this.I(g))}H(g,E){if(E<0)return;const v=[];for(const[t,s]of this.m.getChildren(g.actual)){const a=this.expand(P.$wI.joinToString(g.fullId,s.id),E);(0,D.$hg)(a)&&v.push(a)}if(v.length)return Promise.all(v).then(()=>{})}I(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this.h){const s=new D.$tg;return s.open(),s}g.expand=2,this.J(g);const E=g.resolveBarrier=new D.$tg,v=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,s)};let t;try{t=this.h(g.actual===this.root?void 0:g.actual)}catch(s){v(s)}return(0,D.$hg)(t)?t.catch(v).then(()=>{E.open(),this.G(g)}):(E.open(),this.G(g)),g.resolveBarrier}J(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}L(g){const E=this.tree.get(g);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:g});const v=[E];for(;v.length;){const t=v.pop();if(t){this.m.getApiFor(t.actual).listener=void 0;for(const s of t.actual.tags)this.z(s.id);this.tree.delete(t.fullId.toString());for(const[s,a]of this.m.getChildren(t.actual))v.push(this.tree.get(P.$wI.joinToString(t.fullId,a.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.g.fire(g)}}e.$BL=l;class d extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.$CL=d;class m extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$DL=m;class c extends Error{constructor(g,E,v){super(`TestItem with ID "${g}" is from controller "${E}" and cannot be added as a child of an item from controller "${v}".`)}}e.$EL=c;const u=(h,g,E)=>{let v=new Map;return{get size(){return v.size},forEach(t,s){for(const a of v.values())t.call(s,a,this)},[Symbol.iterator](){return v.entries()},replace(t){const s=new Map,a=new Set(v.keys()),i={op:5,ops:[]};for(const n of t){if(!(n instanceof E))throw new m(n.id);const o=g(n).controllerId;if(o!==h.controllerId)throw new c(n.id,o,h.controllerId);if(s.has(n.id))throw new d(n.id);s.set(n.id,n),a.delete(n.id),i.ops.push({op:0,item:n})}for(const n of a.keys())i.ops.push({op:3,id:n});h.listener?.(i),v=s},add(t){if(!(t instanceof E))throw new m(t.id);v.set(t.id,t),h.listener?.({op:0,item:t})},delete(t){v.delete(t)&&h.listener?.({op:3,id:t})},get(t){return v.get(t)},toJSON(){return Array.from(v.values())}}};e.$FL=u}),define(pe[134],be([1,0,133]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HL=e.$GL=void 0;const O=new WeakMap,r=(I,P)=>{const w={controllerId:P};return O.set(I,w),w};e.$GL=r;const C=I=>{const P=O.get(I);if(!P)throw new D.$DL(I?.id||"<unknown>");return P};e.$HL=C}),define(pe[270],be([1,0,24,6]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dE=e.$cE=e.$bE=e.$aE=e.$_D=e.$$D=e.$0D=e.$9D=e.$8D=e.$7D=e.$6D=e.$5D=e.$4D=e.$3D=e.$2D=e.$1D=e.$ZD=e.$YD=e.$XD=e.$WD=e.$VD=e.$UD=e.$TD=e.$SD=e.$RD=void 0,e.$RD=".vscode",e.$SD="settings",e.$TD=`${e.$RD}/${e.$SD}.json`,e.$UD="vscode://schemas/settings/default",e.$VD="vscode://schemas/settings/user",e.$WD="vscode://schemas/settings/profile",e.$XD="vscode://schemas/settings/machine",e.$YD="vscode://schemas/settings/workspace",e.$ZD="vscode://schemas/settings/folder",e.$1D="vscode://schemas/launch",e.$2D="vscode://schemas/tasks",e.$3D=[1],e.$4D=[2,3,4,5,6],e.$5D=[3,4,5],e.$6D=[1,...e.$5D],e.$7D=[2,3,4,5,6],e.$8D=[3,4,5,6],e.$9D=[4,5,6],e.$0D="tasks",e.$$D="launch",e.$_D=Object.create(null),e.$_D[e.$0D]=`${e.$RD}/${e.$0D}.json`,e.$_D[e.$$D]=`${e.$RD}/${e.$$D}.json`,e.$aE=Object.create(null),e.$aE[e.$0D]=`${e.$0D}.json`,e.$bE=(0,O.$qh)(D.$Vh),e.$cE=`{
	"version": "2.0.0",
	"tasks": []
}`,e.$dE="workbench.settings.applyToAllProfiles"}),define(pe[135],be([1,0,6]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yM=e.VariableKind=e.$xM=void 0,e.$xM=(0,D.$ph)("configurationResolverService");var O;(function(C){C.Unknown="unknown",C.Env="env",C.Config="config",C.Command="command",C.Input="input",C.ExtensionInstallFolder="extensionInstallFolder",C.WorkspaceFolder="workspaceFolder",C.Cwd="cwd",C.WorkspaceFolderBasename="workspaceFolderBasename",C.UserHome="userHome",C.LineNumber="lineNumber",C.SelectedText="selectedText",C.File="file",C.FileWorkspaceFolder="fileWorkspaceFolder",C.RelativeFile="relativeFile",C.RelativeFileDirname="relativeFileDirname",C.FileDirname="fileDirname",C.FileExtname="fileExtname",C.FileBasename="fileBasename",C.FileBasenameNoExtension="fileBasenameNoExtension",C.FileDirnameBasename="fileDirnameBasename",C.ExecPath="execPath",C.ExecInstallFolder="execInstallFolder",C.PathSeparator="pathSeparator"})(O||(e.VariableKind=O={}));class r extends Error{constructor(I,P){super(P),this.variable=I}}e.$yM=r}),define(pe[271],be([1,0,7,30,10,22,3,165,203,135,17]),function(ce,e,D,O,r,C,I,P,w,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(l,d,m,c){this.h=new Map,this.a=l,this.b=d,this.g=m,c&&(this.c=c.then(u=>this.i(u)))}i(l){if(I.$i){const d=Object.create(null);return Object.keys(l).forEach(m=>{d[m.toLowerCase()]=l[m]}),d}return l}resolveWithEnvironment(l,d,m){return this.l({env:this.i(l),userHome:void 0},d?d.uri:void 0,m)}async resolveAsync(l,d){const m={env:await this.c,userHome:await this.g};return this.l(m,l?l.uri:void 0,d)}async j(l,d,m,c){const u=C.$Im(d);I.$i&&u.windows?Object.keys(u.windows).forEach(g=>u[g]=u.windows[g]):I.$j&&u.osx?Object.keys(u.osx).forEach(g=>u[g]=u.osx[g]):I.$k&&u.linux&&Object.keys(u.linux).forEach(g=>u[g]=u.linux[g]),delete u.windows,delete u.osx,delete u.linux;const h={env:await this.c,userHome:await this.g};return this.l(h,l?l.uri:void 0,u,m,c)}async resolveAnyAsync(l,d,m){return this.j(l,d,m)}async resolveAnyMap(l,d,m){const c=new Map;return{newConfig:await this.j(l,d,m,c),resolvedVariables:c}}resolveWithInteractionReplace(l,d,m,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(l,d,m,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(l,d){if(this.h.has(l))throw new Error("Variable "+l+" is contributed twice.");this.h.set(l,d)}async l(l,d,m,c,u){if(r.$ie(m))return this.m(l,d,m,c,u);if(Array.isArray(m))return Promise.all(m.map(h=>this.l(l,d,h,c,u)));if(r.$ke(m)){const h=Object.create(null),g=await Promise.all(Object.keys(m).map(async E=>[await this.m(l,d,E,c,u),await this.l(l,d,m[E],c,u)]));for(const[E,v]of g)h[E]=v;return h}return m}m(l,d,m,c,u){return(0,A.$Dd)(m,k.VARIABLE_REGEXP,async(h,g)=>{if(g.includes(k.VARIABLE_LHS))return h;let E=await this.o(l,h,g,d,c);return u?.set(g,E),E!==h&&r.$ie(E)&&E.match(k.VARIABLE_REGEXP)&&(E=await this.m(l,d,E,c,u)),E})}n(l){return this.b?this.b.getUriLabel(l,{noPrefix:!0}):l.fsPath}async o(l,d,m,c,u){let h;const g=m.split(":");g.length>1&&(m=g[0],h=g[1]);const E=s=>{const a=this.a.getFilePath();if(a)return(0,P.$7z)(a);throw new $.$yM(s,(0,w.localize)(0,null,d))},v=s=>{const a=E(s);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,P.$7z)(i)}throw new $.$yM(s,(0,w.localize)(1,null,d,D.$_c(a)))},t=s=>{if(h){const a=this.a.getFolderUri(h);if(a)return a;throw new $.$yM(s,(0,w.localize)(2,null,d,h))}if(c)return c;throw this.a.getWorkspaceFolderCount()>1?new $.$yM(s,(0,w.localize)(3,null,d)):new $.$yM(s,(0,w.localize)(4,null,d))};switch(m){case"env":if(h){if(l.env){const s=l.env[I.$i?h.toLowerCase():h];if(r.$ie(s))return s}return""}throw new $.$yM($.VariableKind.Env,(0,w.localize)(5,null,d));case"config":if(h){const s=this.a.getConfigurationValue(c,h);if(r.$re(s))throw new $.$yM($.VariableKind.Config,(0,w.localize)(6,null,d,h));if(r.$ke(s))throw new $.$yM($.VariableKind.Config,(0,w.localize)(7,null,d,h));return s}throw new $.$yM($.VariableKind.Config,(0,w.localize)(8,null,d));case"command":return this.p($.VariableKind.Command,d,h,u,"command");case"input":return this.p($.VariableKind.Input,d,h,u,"input");case"extensionInstallFolder":if(h){const s=await this.a.getExtension(h);if(!s)throw new $.$yM($.VariableKind.ExtensionInstallFolder,(0,w.localize)(9,null,d,h));return this.n(s.extensionLocation)}throw new $.$yM($.VariableKind.ExtensionInstallFolder,(0,w.localize)(10,null,d));default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,P.$7z)(this.n(t($.VariableKind.WorkspaceFolder)));case"cwd":return c||h?(0,P.$7z)(this.n(t($.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,P.$7z)(D.$_c(this.n(t($.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(l.userHome)return l.userHome;throw new $.$yM($.VariableKind.UserHome,(0,w.localize)(11,null,d))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new $.$yM($.VariableKind.LineNumber,(0,w.localize)(12,null,d))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new $.$yM($.VariableKind.SelectedText,(0,w.localize)(13,null,d))}case"file":return E($.VariableKind.File);case"fileWorkspaceFolder":return v($.VariableKind.FileWorkspaceFolder);case"relativeFile":return c||h?D.$0c(this.n(t($.VariableKind.RelativeFile)),E($.VariableKind.RelativeFile)):E($.VariableKind.RelativeFile);case"relativeFileDirname":{const s=D.$$c(E($.VariableKind.RelativeFileDirname));if(c||h){const a=D.$0c(this.n(t($.VariableKind.RelativeFileDirname)),s);return a.length===0?".":a}return s}case"fileDirname":return D.$$c(E($.VariableKind.FileDirname));case"fileExtname":return D.$ad(E($.VariableKind.FileExtname));case"fileBasename":return D.$_c(E($.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=D.$_c(E($.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-D.$ad(s).length)}case"fileDirnameBasename":return D.$_c(D.$$c(E($.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||d}case"execInstallFolder":{const s=this.a.getAppRoot();return s||d}case"pathSeparator":return D.sep;default:try{const s=h?`${m}:${h}`:m;return this.p($.VariableKind.Unknown,d,s,u,void 0)}catch{return d}}}}p(l,d,m,c,u){if(m&&c){const h=u===void 0?c[m]:c[u+":"+m];if(typeof h=="string")return h;throw new $.$yM(l,(0,w.localize)(14,null,d))}return d}}e.$MM=k}),define(pe[272],be([1,0,6,91]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WC=e.$VC=e.OpenEditorContext=e.GroupsOrder=e.$UC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$TC=void 0,e.$TC=(0,D.$ph)("editorGroupsService");var r;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(r||(e.GroupDirection=r={}));var C;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(C||(e.GroupOrientation=C={}));var I;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(I||(e.GroupLocation=I={}));var P;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EVEN=1]="EVEN",d[d.TOGGLE=2]="TOGGLE"})(P||(e.GroupsArrangement=P={}));var w;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(w||(e.MergeGroupMode=w={}));function $(d){const m=d;return(0,O.$JE)(m?.editor)&&(0,O.$JE)(m?.replacement)}e.$UC=$;var A;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var k;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function p(d){const m=d;return!!m&&typeof m.id=="number"&&Array.isArray(m.editors)}e.$VC=p;function l(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$WC=l}),define(pe[136],be([1,0,6,272]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1C=e.$ZC=e.$YC=e.$XC=void 0,e.$XC=(0,D.$ph)("editorService"),e.$YC=-1,e.$ZC=-2;function r(C){const I=C;return typeof C=="number"||(0,O.$VC)(I)}e.$1C=r}),define(pe[137],be([1,0,18,15,149,74,102,27,142,50,62,22,10,4,42,171,227,134,91,131,71,92,136,132]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l,d,m,c,u,h,g,E,v,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$KL=e.$JL=e.MarkdownString=e.$IL=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(ve){function Se(G){const{selectionStartLineNumber:Ce,selectionStartColumn:Oe,positionLineNumber:We,positionColumn:Ue}=G,Qe=new s.$MJ(Ce-1,Oe-1),ot=new s.$MJ(We-1,Ue-1);return new s.$OJ(Qe,ot)}ve.to=Se;function fe(G){const{anchor:Ce,active:Oe}=G;return{selectionStartLineNumber:Ce.line+1,selectionStartColumn:Ce.character+1,positionLineNumber:Oe.line+1,positionColumn:Oe.character+1}}ve.from=fe})(a||(e.Selection=a={}));var i;(function(ve){function Se(G){if(!G)return;const{start:Ce,end:Oe}=G;return{startLineNumber:Ce.line+1,startColumn:Ce.character+1,endLineNumber:Oe.line+1,endColumn:Oe.character+1}}ve.from=Se;function fe(G){if(!G)return;const{startLineNumber:Ce,startColumn:Oe,endLineNumber:We,endColumn:Ue}=G;return new s.$NJ(Ce-1,Oe-1,We-1,Ue-1)}ve.to=fe})(i||(e.Range=i={}));var n;(function(ve){function Se(fe){switch(fe){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}ve.to=Se})(n||(e.TokenType=n={}));var o;(function(ve){function Se(G){return new s.$MJ(G.lineNumber-1,G.column-1)}ve.to=Se;function fe(G){return{lineNumber:G.line+1,column:G.character+1}}ve.from=fe})(o||(e.Position=o={}));var f;(function(ve){function Se(Ce,Oe,We){return(0,D.$jf)((0,D.$Gf)(Ce).map(Ue=>fe(Ue,Oe,We)))}ve.from=Se;function fe(Ce,Oe,We){if(typeof Ce=="string")return{$serialized:!0,language:Ce,isBuiltin:We?.isBuiltin};if(Ce)return{$serialized:!0,language:Ce.language,scheme:G(Ce.scheme,Oe),pattern:Me.from(Ce.pattern)??void 0,exclusive:Ce.exclusive,notebookType:Ce.notebookType,isBuiltin:We?.isBuiltin}}function G(Ce,Oe){return Oe&&typeof Ce=="string"?Oe.transformOutgoingScheme(Ce):Ce}})(f||(e.DocumentSelector=f={}));var b;(function(ve){function Se(G){switch(G){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}ve.from=Se;function fe(G){switch(G){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}ve.to=fe})(b||(e.DiagnosticTag=b={}));var y;(function(ve){function Se(G){let Ce;return G.code&&((0,p.$ie)(G.code)||(0,p.$me)(G.code)?Ce=String(G.code):Ce={value:String(G.code.value),target:G.code.target}),{...i.from(G.range),message:G.message,source:G.source,code:Ce,severity:L.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(S.from),tags:Array.isArray(G.tags)?(0,D.$jf)(G.tags.map(b.from)):void 0}}ve.from=Se;function fe(G){const Ce=new s.$ZJ(i.to(G),G.message,L.to(G.severity));return Ce.source=G.source,Ce.code=(0,p.$ie)(G.code)?G.code:G.code?.value,Ce.relatedInformation=G.relatedInformation&&G.relatedInformation.map(S.to),Ce.tags=G.tags&&(0,D.$jf)(G.tags.map(b.to)),Ce}ve.to=fe})(y||(e.Diagnostic=y={}));var S;(function(ve){function Se(G){return{...i.from(G.location.range),message:G.message,resource:G.location.uri}}ve.from=Se;function fe(G){return new s.$YJ(new s.$XJ(G.resource,i.to(G)),G.message)}ve.to=fe})(S||(e.DiagnosticRelatedInformation=S={}));var L;(function(ve){function Se(G){switch(G){case s.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}ve.from=Se;function fe(G){switch(G){case c.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}ve.to=fe})(L||(e.DiagnosticSeverity=L={}));var j;(function(ve){function Se(G){return typeof G=="number"&&G>=s.ViewColumn.One?G-1:G===s.ViewColumn.Beside?t.$ZC:t.$YC}ve.from=Se;function fe(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}ve.to=fe})(j||(e.ViewColumn=j={}));function Q(ve){return typeof ve.range<"u"}function le(ve){return ve.length===0?!0:!!Q(ve[0])}e.$IL=le;var Y;(function(ve){function Se(Ue){return Ue.map(ve.from)}ve.fromMany=Se;function fe(Ue){return Ue&&typeof Ue=="object"&&typeof Ue.language=="string"&&typeof Ue.value=="string"}function G(Ue){let Qe;if(fe(Ue)){const{language:at,value:$t}=Ue;Qe={value:"```"+at+`
`+$t+"\n```\n"}}else s.$aK.isMarkdownString(Ue)?Qe={value:Ue.value,isTrusted:Ue.isTrusted,supportThemeIcons:Ue.supportThemeIcons,supportHtml:Ue.supportHtml,baseUri:Ue.baseUri}:typeof Ue=="string"?Qe={value:Ue}:Qe={value:""};const ot=Object.create(null);Qe.uris=ot;const mt=at=>{try{let $t=l.URI.parse(at,!0);$t=$t.with({query:Ce($t.query,ot)}),ot[at]=$t}catch{}return""},ht=new w.marked.Renderer;return ht.link=mt,ht.image=at=>typeof at=="string"?mt(I.$Rj(at).href):"",(0,w.marked)(Qe.value,{renderer:ht}),Qe}ve.from=G;function Ce(Ue,Qe){if(!Ue)return Ue;let ot;try{ot=(0,$.$Xg)(Ue)}catch{}if(!ot)return Ue;let mt=!1;return ot=(0,k.$Km)(ot,ht=>{if(l.URI.isUri(ht)){const at=`__uri_${Math.random().toString(16).slice(2,8)}`;return Qe[at]=ht,mt=!0,at}else return}),mt?JSON.stringify(ot):Ue}function Oe(Ue){const Qe=new s.$aK(Ue.value,Ue.supportThemeIcons);return Qe.isTrusted=Ue.isTrusted,Qe.supportHtml=Ue.supportHtml,Qe.baseUri=Ue.baseUri?l.URI.from(Ue.baseUri):void 0,Qe}ve.to=Oe;function We(Ue){if(Ue)return typeof Ue=="string"?Ue:ve.from(Ue)}ve.fromStrict=We})(Y||(e.MarkdownString=Y={}));function ee(ve){return le(ve)?ve.map(Se=>({range:i.from(Se.range),hoverMessage:Array.isArray(Se.hoverMessage)?Y.fromMany(Se.hoverMessage):Se.hoverMessage?Y.from(Se.hoverMessage):void 0,renderOptions:Se.renderOptions})):ve.map(Se=>({range:i.from(Se)}))}e.$JL=ee;function ue(ve){return typeof ve>"u"?ve:typeof ve=="string"?l.URI.file(ve):ve}e.$KL=ue;var X;(function(ve){function Se(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?ue(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}ve.from=Se})(X||(e.ThemableDecorationAttachmentRenderOptions=X={}));var he;(function(ve){function Se(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?ue(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?X.from(fe.before):void 0,after:fe.after?X.from(fe.after):void 0}}ve.from=Se})(he||(e.ThemableDecorationRenderOptions=he={}));var x;(function(ve){function Se(fe){if(typeof fe>"u")return fe;switch(fe){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}ve.from=Se})(x||(e.DecorationRangeBehavior=x={}));var se;(function(ve){function Se(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?x.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?he.from(fe.light):void 0,dark:fe.dark?he.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?ue(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?X.from(fe.before):void 0,after:fe.after?X.from(fe.after):void 0}}ve.from=Se})(se||(e.DecorationRenderOptions=se={}));var V;(function(ve){function Se(G){return{text:G.newText,eol:G.newEol&&Ze.from(G.newEol),range:i.from(G.range)}}ve.from=Se;function fe(G){const Ce=new s.$SJ(i.to(G.range),G.text);return Ce.newEol=typeof G.eol>"u"?void 0:Ze.to(G.eol),Ce}ve.to=fe})(V||(e.TextEdit=V={}));var K;(function(ve){function Se(G,Ce){const Oe={edits:[]};if(G instanceof s.$VJ){const We=new P.$oi;for(const Ue of G._allEntries())Ue._type===1&&l.URI.isUri(Ue.to)&&Ue.from===void 0&&We.add(Ue.to);for(const Ue of G._allEntries())if(Ue._type===1){let Qe;Ue.options?.contents&&(ArrayBuffer.isView(Ue.options.contents)?Qe={type:"base64",value:(0,O.$Yc)(O.$Ec.wrap(Ue.options.contents))}:Qe={type:"dataTransferItem",id:Ue.options.contents._itemId}),Oe.edits.push({oldResource:Ue.from,newResource:Ue.to,options:{...Ue.options,contents:Qe},metadata:Ue.metadata})}else Ue._type===2?Oe.edits.push({resource:Ue.uri,textEdit:V.from(Ue.edit),versionId:We.has(Ue.uri)?void 0:Ce?.getTextDocumentVersion(Ue.uri),metadata:Ue.metadata}):Ue._type===6?Oe.edits.push({resource:Ue.uri,textEdit:{range:i.from(Ue.range),text:Ue.edit.value,insertAsSnippet:!0},versionId:We.has(Ue.uri)?void 0:Ce?.getTextDocumentVersion(Ue.uri),metadata:Ue.metadata}):Ue._type===3?Oe.edits.push({metadata:Ue.metadata,resource:Ue.uri,cellEdit:Ue.edit,notebookMetadata:Ue.notebookMetadata,notebookVersionId:Ce?.getNotebookDocumentVersion(Ue.uri)}):Ue._type===5&&Oe.edits.push({metadata:Ue.metadata,resource:Ue.uri,notebookVersionId:Ce?.getNotebookDocumentVersion(Ue.uri),cellEdit:{editType:1,index:Ue.index,count:Ue.count,cells:Ue.cells.map(nt.from)}})}return Oe}ve.from=Se;function fe(G){const Ce=new s.$VJ,Oe=new P.$ni;for(const We of G.edits)if(We.textEdit){const Ue=We,Qe=l.URI.revive(Ue.resource),ot=i.to(Ue.textEdit.range),mt=Ue.textEdit.text,ht=Ue.textEdit.insertAsSnippet;let at;ht?at=s.$UJ.replace(ot,new s.$WJ(mt)):at=s.$SJ.replace(ot,mt);const $t=Oe.get(Qe);$t?$t.push(at):Oe.set(Qe,[at])}else Ce.renameFile(l.URI.revive(We.oldResource),l.URI.revive(We.newResource),We.options);for(const[We,Ue]of Oe)Ce.set(We,Ue);return Ce}ve.to=fe})(K||(e.WorkspaceEdit=K={}));var H;(function(ve){const Se=Object.create(null);Se[s.SymbolKind.File]=0,Se[s.SymbolKind.Module]=1,Se[s.SymbolKind.Namespace]=2,Se[s.SymbolKind.Package]=3,Se[s.SymbolKind.Class]=4,Se[s.SymbolKind.Method]=5,Se[s.SymbolKind.Property]=6,Se[s.SymbolKind.Field]=7,Se[s.SymbolKind.Constructor]=8,Se[s.SymbolKind.Enum]=9,Se[s.SymbolKind.Interface]=10,Se[s.SymbolKind.Function]=11,Se[s.SymbolKind.Variable]=12,Se[s.SymbolKind.Constant]=13,Se[s.SymbolKind.String]=14,Se[s.SymbolKind.Number]=15,Se[s.SymbolKind.Boolean]=16,Se[s.SymbolKind.Array]=17,Se[s.SymbolKind.Object]=18,Se[s.SymbolKind.Key]=19,Se[s.SymbolKind.Null]=20,Se[s.SymbolKind.EnumMember]=21,Se[s.SymbolKind.Struct]=22,Se[s.SymbolKind.Event]=23,Se[s.SymbolKind.Operator]=24,Se[s.SymbolKind.TypeParameter]=25;function fe(Ce){return typeof Se[Ce]=="number"?Se[Ce]:6}ve.from=fe;function G(Ce){for(const Oe in Se)if(Se[Oe]===Ce)return Number(Oe);return s.SymbolKind.Property}ve.to=G})(H||(e.SymbolKind=H={}));var te;(function(ve){function Se(G){switch(G){case s.SymbolTag.Deprecated:return 1}}ve.from=Se;function fe(G){switch(G){case 1:return s.SymbolTag.Deprecated}}ve.to=fe})(te||(e.SymbolTag=te={}));var me;(function(ve){function Se(G){return{name:G.name,kind:H.from(G.kind),tags:G.tags&&G.tags.map(te.from),containerName:G.containerName,location:F.from(G.location)}}ve.from=Se;function fe(G){const Ce=new s.$3J(G.name,H.to(G.kind),G.containerName,F.to(G.location));return Ce.tags=G.tags&&G.tags.map(te.to),Ce}ve.to=fe})(me||(e.WorkspaceSymbol=me={}));var ne;(function(ve){function Se(G){const Ce={name:G.name||"!!MISSING: name!!",detail:G.detail,range:i.from(G.range),selectionRange:i.from(G.selectionRange),kind:H.from(G.kind),tags:G.tags?.map(te.from)??[]};return G.children&&(Ce.children=G.children.map(Se)),Ce}ve.from=Se;function fe(G){const Ce=new s.$4J(G.name,G.detail,H.to(G.kind),i.to(G.range),i.to(G.selectionRange));return(0,D.$nf)(G.tags)&&(Ce.tags=G.tags.map(te.to)),G.children&&(Ce.children=G.children.map(fe)),Ce}ve.to=fe})(ne||(e.DocumentSymbol=ne={}));var q;(function(ve){function Se(G){const Ce=new s.$9J(H.to(G.kind),G.name,G.detail||"",l.URI.revive(G.uri),i.to(G.range),i.to(G.selectionRange));return Ce._sessionId=G._sessionId,Ce._itemId=G._itemId,Ce}ve.to=Se;function fe(G,Ce,Oe){if(Ce=Ce??G._sessionId,Oe=Oe??G._itemId,Ce===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Oe,name:G.name,detail:G.detail,kind:H.from(G.kind),uri:G.uri,range:i.from(G.range),selectionRange:i.from(G.selectionRange),tags:G.tags?.map(te.from)}}ve.from=fe})(q||(e.CallHierarchyItem=q={}));var J;(function(ve){function Se(fe){return new s.$0J(q.to(fe.from),fe.fromRanges.map(G=>i.to(G)))}ve.to=Se})(J||(e.CallHierarchyIncomingCall=J={}));var R;(function(ve){function Se(fe){return new s.$$J(q.to(fe.to),fe.fromRanges.map(G=>i.to(G)))}ve.to=Se})(R||(e.CallHierarchyOutgoingCall=R={}));var F;(function(ve){function Se(G){return{range:G.range&&i.from(G.range),uri:G.uri}}ve.from=Se;function fe(G){return new s.$XJ(l.URI.revive(G.uri),i.to(G.range))}ve.to=fe})(F||(e.location=F={}));var W;(function(ve){function Se(G){const Ce=G,Oe=G;return{originSelectionRange:Ce.originSelectionRange?i.from(Ce.originSelectionRange):void 0,uri:Ce.targetUri?Ce.targetUri:Oe.uri,range:i.from(Ce.targetRange?Ce.targetRange:Oe.range),targetSelectionRange:Ce.targetSelectionRange?i.from(Ce.targetSelectionRange):void 0}}ve.from=Se;function fe(G){return{targetUri:l.URI.revive(G.uri),targetRange:i.to(G.range),targetSelectionRange:G.targetSelectionRange?i.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?i.to(G.originSelectionRange):void 0}}ve.to=fe})(W||(e.DefinitionLink=W={}));var ie;(function(ve){function Se(G){return{range:i.from(G.range),contents:Y.fromMany(G.contents)}}ve.from=Se;function fe(G){return new s.$1J(G.contents.map(Y.to),i.to(G.range))}ve.to=fe})(ie||(e.Hover=ie={}));var re;(function(ve){function Se(G){return{range:i.from(G.range),expression:G.expression}}ve.from=Se;function fe(G){return new s.$UK(i.to(G.range),G.expression)}ve.to=fe})(re||(e.EvaluatableExpression=re={}));var _;(function(ve){function Se(G){if(G instanceof s.$VK)return{type:"text",range:i.from(G.range),text:G.text};if(G instanceof s.$WK)return{type:"variable",range:i.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof s.$XK)return{type:"expression",range:i.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}ve.from=Se;function fe(G){switch(G.type){case"text":return{range:i.to(G.range),text:G.text};case"variable":return{range:i.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:i.to(G.range),expression:G.expression}}}ve.to=fe})(_||(e.InlineValue=_={}));var oe;(function(ve){function Se(G){return{frameId:G.frameId,stoppedLocation:i.from(G.stoppedLocation)}}ve.from=Se;function fe(G){return new s.$YK(G.frameId,i.to(G.stoppedLocation))}ve.to=fe})(oe||(e.InlineValueContext=oe={}));var N;(function(ve){function Se(G){return{range:i.from(G.range),kind:G.kind}}ve.from=Se;function fe(G){return new s.$2J(i.to(G.range),G.kind)}ve.to=fe})(N||(e.DocumentHighlight=N={}));var B;(function(ve){function Se(fe){switch(fe){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}ve.to=Se})(B||(e.CompletionTriggerKind=B={}));var U;(function(ve){function Se(fe){return{triggerKind:B.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}ve.to=Se})(U||(e.CompletionContext=U={}));var z;(function(ve){function Se(G){switch(G){case s.CompletionItemTag.Deprecated:return 1}}ve.from=Se;function fe(G){switch(G){case 1:return s.CompletionItemTag.Deprecated}}ve.to=fe})(z||(e.CompletionItemTag=z={}));var Z;(function(ve){const Se=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function fe(Oe){return Se.get(Oe)??9}ve.from=fe;const G=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Ce(Oe){return G.get(Oe)??s.CompletionItemKind.Property}ve.to=Ce})(Z||(e.CompletionItemKind=Z={}));var de;(function(ve){function Se(fe,G){const Ce=new s.$gK(fe.label);return Ce.insertText=fe.insertText,Ce.kind=Z.to(fe.kind),Ce.tags=fe.tags?.map(z.to),Ce.detail=fe.detail,Ce.documentation=I.$Mj(fe.documentation)?Y.to(fe.documentation):fe.documentation,Ce.sortText=fe.sortText,Ce.filterText=fe.filterText,Ce.preselect=fe.preselect,Ce.commitCharacters=fe.commitCharacters,d.$Ur.isIRange(fe.range)?Ce.range=i.to(fe.range):typeof fe.range=="object"&&(Ce.range={inserting:i.to(fe.range.insert),replacing:i.to(fe.range.replace)}),Ce.keepWhitespace=typeof fe.insertTextRules>"u"?!1:!!(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Ce.insertText=new s.$WJ(fe.insertText):(Ce.insertText=fe.insertText,Ce.textEdit=Ce.range instanceof s.$NJ?new s.$SJ(Ce.range,Ce.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Ce.additionalTextEdits=fe.additionalTextEdits.map(Oe=>V.to(Oe))),Ce.command=G&&fe.command?G.fromInternal(fe.command):void 0,Ce}ve.to=Se})(de||(e.CompletionItem=de={}));var Ee;(function(ve){function Se(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:Y.fromStrict(G.documentation)}}ve.from=Se;function fe(G){return{label:G.label,documentation:I.$Mj(G.documentation)?Y.to(G.documentation):G.documentation}}ve.to=fe})(Ee||(e.ParameterInformation=Ee={}));var Pe;(function(ve){function Se(G){return{label:G.label,documentation:Y.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(Ee.from):[],activeParameter:G.activeParameter}}ve.from=Se;function fe(G){return{label:G.label,documentation:I.$Mj(G.documentation)?Y.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(Ee.to):[],activeParameter:G.activeParameter}}ve.to=fe})(Pe||(e.SignatureInformation=Pe={}));var Ae;(function(ve){function Se(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(Pe.from):[]}}ve.from=Se;function fe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(Pe.to):[]}}ve.to=fe})(Ae||(e.SignatureHelp=Ae={}));var Fe;(function(ve){function Se(fe,G){const Ce=new s.$fK(o.to(G.position),typeof G.label=="string"?G.label:G.label.map(ge.to.bind(void 0,fe)),G.kind&&ke.to(G.kind));return Ce.textEdits=G.textEdits&&G.textEdits.map(V.to),Ce.tooltip=I.$Mj(G.tooltip)?Y.to(G.tooltip):G.tooltip,Ce.paddingLeft=G.paddingLeft,Ce.paddingRight=G.paddingRight,Ce}ve.to=Se})(Fe||(e.InlayHint=Fe={}));var ge;(function(ve){function Se(fe,G){const Ce=new s.$eK(G.label);return Ce.tooltip=I.$Mj(G.tooltip)?Y.to(G.tooltip):G.tooltip,m.Command.is(G.command)&&(Ce.command=fe.fromInternal(G.command)),G.location&&(Ce.location=F.to(G.location)),Ce}ve.to=Se})(ge||(e.InlayHintLabelPart=ge={}));var ke;(function(ve){function Se(G){return G}ve.from=Se;function fe(G){return G}ve.to=fe})(ke||(e.InlayHintKind=ke={}));var ye;(function(ve){function Se(G){return{range:i.from(G.range),url:G.target,tooltip:G.tooltip}}ve.from=Se;function fe(G){let Ce;if(G.url)try{Ce=typeof G.url=="string"?l.URI.parse(G.url,!0):l.URI.revive(G.url)}catch{}return new s.$lK(i.to(G.range),Ce)}ve.to=fe})(ye||(e.DocumentLink=ye={}));var Te;(function(ve){function Se(G){const Ce=new s.$oK(G.label);return G.textEdit&&(Ce.textEdit=V.to(G.textEdit)),G.additionalTextEdits&&(Ce.additionalTextEdits=G.additionalTextEdits.map(Oe=>V.to(Oe))),Ce}ve.to=Se;function fe(G){return{label:G.label,textEdit:G.textEdit?V.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Ce=>V.from(Ce)):void 0}}ve.from=fe})(Te||(e.ColorPresentation=Te={}));var ze;(function(ve){function Se(G){return new s.$mK(G[0],G[1],G[2],G[3])}ve.to=Se;function fe(G){return[G.red,G.green,G.blue,G.alpha]}ve.from=fe})(ze||(e.Color=ze={}));var _e;(function(ve){function Se(G){return{range:i.from(G.range)}}ve.from=Se;function fe(G){return new s.$8J(i.to(G.range))}ve.to=fe})(_e||(e.SelectionRange=_e={}));var Ve;(function(ve){function Se(fe){switch(fe){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}ve.to=Se})(Ve||(e.TextDocumentSaveReason=Ve={}));var Xe;(function(ve){function Se(G){switch(G){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}ve.from=Se;function fe(G){switch(G){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}ve.to=fe})(Xe||(e.TextEditorLineNumbersStyle=Xe={}));var Ze;(function(ve){function Se(G){if(G===s.EndOfLine.CRLF)return 1;if(G===s.EndOfLine.LF)return 0}ve.from=Se;function fe(G){if(G===1)return s.EndOfLine.CRLF;if(G===0)return s.EndOfLine.LF}ve.to=fe})(Ze||(e.EndOfLine=Ze={}));var $e;(function(ve){function Se(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ve.from=Se})($e||(e.ProgressLocation=$e={}));var De;(function(ve){function Se(G){const Ce={start:G.start+1,end:G.end+1};return G.kind&&(Ce.kind=Re.from(G.kind)),Ce}ve.from=Se;function fe(G){const Ce={start:G.start-1,end:G.end-1};return G.kind&&(Ce.kind=Re.to(G.kind)),Ce}ve.to=fe})(De||(e.FoldingRange=De={}));var Re;(function(ve){function Se(G){if(G)switch(G){case s.FoldingRangeKind.Comment:return m.$As.Comment;case s.FoldingRangeKind.Imports:return m.$As.Imports;case s.FoldingRangeKind.Region:return m.$As.Region}}ve.from=Se;function fe(G){if(G)switch(G.value){case m.$As.Comment.value:return s.FoldingRangeKind.Comment;case m.$As.Imports.value:return s.FoldingRangeKind.Imports;case m.$As.Region.value:return s.FoldingRangeKind.Region}}ve.to=fe})(Re||(e.FoldingRangeKind=Re={}));var Ne;(function(ve){function Se(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?i.from(fe.selection):void 0,override:typeof fe.override=="boolean"?h.$wE.id:void 0}}ve.from=Se})(Ne||(e.TextEditorOpenOptions=Ne={}));var Me;(function(ve){function Se(Oe){return Oe instanceof s.$IK?Oe.toJSON():typeof Oe=="string"?Oe:fe(Oe)||G(Oe)?new s.$IK(Oe.baseUri??Oe.base,Oe.pattern).toJSON():Oe}ve.from=Se;function fe(Oe){const We=Oe;return We?l.URI.isUri(We.baseUri)&&typeof We.pattern=="string":!1}function G(Oe){const We=Oe;return We?typeof We.base=="string"&&typeof We.pattern=="string":!1}function Ce(Oe){return typeof Oe=="string"?Oe:new s.$IK(l.URI.revive(Oe.baseUri),Oe.pattern)}ve.to=Ce})(Me||(e.GlobPattern=Me={}));var qe;(function(ve){function Se(fe){if(fe){if(Array.isArray(fe))return fe.map(Se);if(typeof fe=="string")return fe;{const G=fe;return{language:G.language,scheme:G.scheme,pattern:Me.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}ve.from=Se})(qe||(e.LanguageSelector=qe={}));var Be;(function(ve){function Se(G){return!!G&&typeof G=="object"&&"selections"in G&&Array.isArray(G.selections)&&G.selections.every(Ce=>Ce instanceof s.$OJ)&&"related"in G&&Array.isArray(G.related)&&G.related.every(Ce=>Ce&&typeof Ce=="object"&&l.URI.isUri(Ce.uri)&&Ce.range instanceof s.$NJ)}ve.is=Se;function fe(G){return{selections:G.selections.map(Ce=>a.from(Ce)),related:G.related.map(Ce=>({uri:l.URI.from(Ce.uri),range:i.from(Ce.range)}))}}ve.from=fe})(Be||(e.MappedEditsContext=Be={}));var Ke;(function(ve){function Se(G){return{start:G.start,end:G.end}}ve.from=Se;function fe(G){return new s.$0K(G.start,G.end)}ve.to=fe})(Ke||(e.NotebookRange=Ke={}));var He;(function(ve){function Se(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}ve.to=Se;function fe(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}ve.from=fe})(He||(e.NotebookCellExecutionSummary=He={}));var Ye;(function(ve){function Se(fe){if(fe===g.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(fe===g.NotebookCellExecutionState.Pending)return;if(fe===g.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}ve.to=Se})(Ye||(e.NotebookCellExecutionState=Ye={}));var Je;(function(ve){function Se(G){switch(G){case s.NotebookCellKind.Markup:return g.CellKind.Markup;case s.NotebookCellKind.Code:default:return g.CellKind.Code}}ve.from=Se;function fe(G){switch(G){case g.CellKind.Markup:return s.NotebookCellKind.Markup;case g.CellKind.Code:default:return s.NotebookCellKind.Code}}ve.to=fe})(Je||(e.NotebookCellKind=Je={}));var xe;(function(ve){function Se(G){const Ce={metadata:G.metadata??Object.create(null),cells:[]};for(const Oe of G.cells)s.$$K.validate(Oe),Ce.cells.push(nt.from(Oe));return Ce}ve.from=Se;function fe(G){const Ce=new s.$_K(G.cells.map(nt.to));return(0,p.$ve)(G.metadata)||(Ce.metadata=G.metadata),Ce}ve.to=fe})(xe||(e.NotebookData=xe={}));var nt;(function(ve){function Se(G){return{cellKind:Je.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:He.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(it.from):[]}}ve.from=Se;function fe(G){return new s.$$K(Je.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(it.to):void 0,G.metadata,G.internalMetadata?He.to(G.internalMetadata):void 0)}ve.to=fe})(nt||(e.NotebookCellData=nt={}));var rt;(function(ve){function Se(G){return{mime:G.mime,valueBytes:O.$Ec.wrap(G.data)}}ve.from=Se;function fe(G){return new s.$aL(G.valueBytes.buffer,G.mime)}ve.to=fe})(rt||(e.NotebookCellOutputItem=rt={}));var it;(function(ve){function Se(G){return{outputId:G.id,items:G.items.map(rt.from),metadata:G.metadata}}ve.from=Se;function fe(G){const Ce=G.items.map(rt.to);return new s.$bL(Ce,G.outputId,G.metadata)}ve.to=fe})(it||(e.NotebookCellOutput=it={}));var Mt;(function(ve){function Se(Ce){return G(Ce)?{include:Me.from(Ce.include)??void 0,exclude:Me.from(Ce.exclude)??void 0}:Me.from(Ce)??void 0}ve.from=Se;function fe(Ce){return G(Ce)?{include:Me.to(Ce.include),exclude:Me.to(Ce.exclude)}:Me.to(Ce)}ve.to=fe;function G(Ce){const Oe=Ce;return Oe?!(0,p.$re)(Oe.include)&&!(0,p.$re)(Oe.exclude):!1}})(Mt||(e.NotebookExclusiveDocumentPattern=Mt={}));var bt;(function(ve){function Se(fe,G,Ce){const Oe=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Oe,Ce),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}ve.from=Se})(bt||(e.NotebookStatusBarItem=bt={}));var Lt;(function(ve){function Se(fe,G,Ce){const Oe=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:G.toInternal(Oe,Ce),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}ve.from=Se})(Lt||(e.NotebookKernelSourceAction=Lt={}));var lt;(function(ve){function Se(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}ve.from=Se})(lt||(e.NotebookDocumentContentOptions=lt={}));var wt;(function(ve){function Se(G){return{uri:G.uri,provides:G.provides}}ve.from=Se;function fe(G){return new s.$dL(l.URI.revive(G.uri),G.provides)}ve.to=fe})(wt||(e.NotebookRendererScript=wt={}));var Ot;(function(ve){function Se(G){return{message:Y.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:i.from(G.location.range),uri:G.location.uri}}}ve.from=Se;function fe(G){const Ce=new s.$jL(typeof G.message=="string"?G.message:Y.to(G.message));return Ce.actualOutput=G.actual,Ce.expectedOutput=G.expected,Ce.contextValue=G.contextValue,Ce.location=G.location?F.to(G.location):void 0,Ce}ve.to=fe})(Ot||(e.TestMessage=Ot={}));var ft;(function(ve){ve.namespace=v.$AI,ve.denamespace=v.$BI})(ft||(e.TestTag=ft={}));var vt;(function(ve){function Se(G){const Ce=(0,u.$HL)(G).controllerId;return{extId:E.$wI.fromExtHostTestItem(G,Ce).toString(),label:G.label,uri:l.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Oe=>ft.namespace(Ce,Oe.id)),range:d.$Ur.lift(i.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&Y.fromStrict(G.error)||null}}ve.from=Se;function fe(G){return{parent:void 0,error:void 0,id:E.$wI.fromString(G.extId).localId,label:G.label,uri:l.URI.revive(G.uri),tags:(G.tags||[]).map(Ce=>{const{tagId:Oe}=ft.denamespace(Ce);return new s.$kL(Oe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}ve.toPlain=fe})(vt||(e.TestItem=vt={})),function(ve){function Se(G){return{id:G.id}}ve.from=Se;function fe(G){return new s.$kL(G.id)}ve.to=fe}(ft||(e.TestTag=ft={}));var yt;(function(ve){const Se=(G,Ce)=>{const Oe=[];for(const[Ue,Qe]of Ce)E.$wI.compare(Qe.item.extId,Ue)===2&&(Ce.delete(Ue),Oe.push(Qe));const We={...vt.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(Ue=>({state:Ue.state,duration:Ue.duration,messages:Ue.messages.filter(Qe=>Qe.type===0).map(Ot.to)})),children:Oe.map(Ue=>Se(Ue,Ce))};for(const Ue of We.children)Ue.parent=We;return We};function fe(G){const Ce=[],Oe=new Map;for(const We of G.items){Oe.set(We.item.extId,We);const Ue=E.$wI.root(We.item.extId);G.request.targets.some(Qe=>Qe.controllerId===Ue&&Qe.testIds.includes(We.item.extId))&&Ce.push(We)}return{completedAt:G.completedAt,results:Ce.map(We=>Se(We,Oe))}}ve.to=fe})(yt||(e.TestResults=yt={}));var Ct;(function(ve){function Se(Oe){return{covered:Oe.covered,total:Oe.covered}}function fe(Oe){return"line"in Oe?o.from(Oe):i.from(Oe)}function G(Oe){return"branches"in Oe?{count:Oe.executionCount,location:fe(Oe.location),type:1,branches:Oe.branches.length?Oe.branches.map(We=>({count:We.executionCount,location:We.location&&fe(We.location)})):void 0}:{type:0,count:Oe.executionCount,location:fe(Oe.location)}}ve.fromDetailed=G;function Ce(Oe){return{uri:Oe.uri,statement:Se(Oe.statementCoverage),branch:Oe.branchCoverage&&Se(Oe.branchCoverage),function:Oe.functionCoverage&&Se(Oe.functionCoverage),details:Oe.detailedCoverage?.map(G)}}ve.fromFile=Ce})(Ct||(e.TestCoverage=Ct={}));var jt;(function(ve){function Se(fe){switch(fe){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}ve.to=Se})(jt||(e.CodeActionTriggerKind=jt={}));var gt;(function(ve){function Se(G){const Ce=new s.$qL(H.to(G.kind),G.name,G.detail||"",l.URI.revive(G.uri),i.to(G.range),i.to(G.selectionRange));return Ce._sessionId=G._sessionId,Ce._itemId=G._itemId,Ce}ve.to=Se;function fe(G,Ce,Oe){if(Ce=Ce??G._sessionId,Oe=Oe??G._itemId,Ce===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Oe,kind:H.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:i.from(G.range),selectionRange:i.from(G.selectionRange),tags:G.tags?.map(te.from)}}ve.from=fe})(gt||(e.TypeHierarchyItem=gt={}));var Tt;(function(ve){function Se(fe){if(fe)return{value:fe.value,tooltip:fe.tooltip}}ve.from=Se})(Tt||(e.ViewBadge=Tt={}));var Pt;(function(ve){function Se(Oe,We,Ue){const Qe=We.fileData;return Qe?new s.$BK(new s.$CK(Qe.name,l.URI.revive(Qe.uri),Qe.id,(0,C.$cb)(()=>Ue(Qe.id)))):Oe===A.$yr.uriList&&We.uriListData?new s.$AK(Ce(We.uriListData)):new s.$AK(We.asString)}ve.to=Se;async function fe(Oe,We){const Ue=await We.asString();if(Oe===A.$yr.uriList)return{asString:Ue,fileData:void 0,uriListData:G(Ue)};const Qe=We.asFile();return{asString:Ue,fileData:Qe?{name:Qe.name,uri:Qe.uri,id:Qe._itemId??Qe.id}:void 0}}ve.from=fe;function G(Oe){return r.$is.split(Oe).map(We=>{if(We.startsWith("#"))return We;try{return l.URI.parse(We)}catch{}return We})}function Ce(Oe){return r.$is.create(Oe.map(We=>typeof We=="string"?We:l.URI.revive(We)))}})(Pt||(e.DataTransferItem=Pt={}));var st;(function(ve){function Se(G,Ce){const Oe=G.items.map(([We,Ue])=>[We,Pt.to(We,Ue,Ce)]);return new s.$DK(Oe)}ve.toDataTransfer=Se;async function fe(G){const Ce={items:[]},Oe=[];for(const[We,Ue]of G)Oe.push((async()=>{Ce.items.push([We,await Pt.from(We,Ue)])})());return await Promise.all(Oe),Ce}ve.from=fe})(st||(e.DataTransfer=st={}));var ut;(function(ve){function Se(G){return{message:G.message,metadata:G.metadata,title:G.title,tooltip:G.tooltip}}ve.to=Se;function fe(G){return{kind:"reply",message:G.message,metadata:G.metadata,title:G.title,tooltip:G.tooltip}}ve.from=fe})(ut||(e.ChatReplyFollowup=ut={}));var dt;(function(ve){function Se(fe){return typeof fe=="string"?{title:fe,message:fe,kind:"reply"}:"commandId"in fe?{kind:"command",title:fe.title??"",commandId:fe.commandId??"",when:fe.when??"",args:fe.args}:ut.from(fe)}ve.from=Se})(dt||(e.ChatFollowup=dt={}));var zt;(function(ve){function Se(G){const Ce=new s.$AL(It.to(G.role),G.content);return Ce.name=G.name,Ce}ve.to=Se;function fe(G){return{role:It.from(G.role),content:G.content,name:G.name}}ve.from=fe})(zt||(e.ChatMessage=zt={}));var It;(function(ve){function Se(G){switch(G){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}ve.to=Se;function fe(G){switch(G){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}ve.from=fe})(It||(e.ChatMessageRole=It={}));var Ut;(function(ve){function Se(G){return{level:kt.to(G.level),value:G.value,description:G.description}}ve.to=Se;function fe(G){return{level:kt.from(G.level),value:G.value,description:G.description}}ve.from=fe})(Ut||(e.ChatVariable=Ut={}));var kt;(function(ve){function Se(G){switch(G){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}ve.to=Se;function fe(G){switch(G){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}ve.from=fe})(kt||(e.ChatVariableLevel=kt={}));var Ft;(function(ve){function Se(fe,G,Ce){return"terminalCommand"in fe?{terminalCommand:fe.terminalCommand}:"uri"in fe?{uri:fe.uri}:G.toInternal(fe,Ce)}ve.from=Se})(Ft||(e.TerminalQuickFix=Ft={}))}),define(pe[273],be([1,0,42,134,71,133,92,137,4]),function(ce,e,D,O,r,C,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1L=e.$ZL=e.$YL=e.$XL=void 0;const $=(g,E,v,t)=>{let s=E;return{enumerable:!0,configurable:!1,get(){return s},set(a){if(!v(s,a)){const i=s;s=a,g.listener?.(t(a,i))}}}},A=(g,E)=>g===E,k={range:(g,E)=>g===E?!0:!g||!E?!1:g.isEqual(E),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(g,E)=>!(g.length!==E.length||g.some(v=>!E.find(t=>v.id===t.id)))},p=g=>E=>({op:4,update:g(E)}),l=(g,E)=>({range:(()=>{let v;const t=p(s=>({range:D.$Ur.lift(P.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return v},set(s){g.listener?.({op:6}),k.range(v,s)||(v=s,g.listener?.(t(s)))}}})(),label:$(g,E,k.label,p(v=>({label:v}))),description:$(g,void 0,k.description,p(v=>({description:v}))),sortText:$(g,void 0,k.sortText,p(v=>({sortText:v}))),canResolveChildren:$(g,!1,k.canResolveChildren,v=>({op:2,state:v})),busy:$(g,!1,k.busy,p(v=>({busy:v}))),error:$(g,void 0,k.error,p(v=>({error:P.MarkdownString.fromStrict(v)||null}))),tags:$(g,[],k.tags,(v,t)=>({op:1,new:v.map(P.TestTag.from),old:t.map(P.TestTag.from)}))}),d=g=>{const E=r.$wI.fromString(g.extId),v=new c(E.controllerId,E.localId,g.label,w.URI.revive(g.uri)||void 0);return v.range=P.Range.to(g.range||void 0),v.description=g.description||void 0,v.sortText=g.sortText||void 0,v.tags=g.tags.map(t=>P.TestTag.to({id:(0,I.$BI)(t).tagId})),v},m=g=>{let E;for(const v of g.tests){const t=d(v.item);(0,O.$HL)(t).parent=E,E=t}return E};e.$XL=m;class c{constructor(E,v,t,s){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const a=(0,O.$GL)(this,E);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof u?void 0:a.parent}},children:{value:(0,C.$FL)(a,O.$HL,c),enumerable:!0,writable:!1},...l(a,t)})}}e.$YL=c;class u extends c{constructor(E,v){super(E,E,v,void 0),this._isRoot=!0}}e.$ZL=u;class h extends C.$BL{constructor(E,v,t){super({controllerId:E,getDocumentVersion:s=>s&&t.getDocument(s)?.version,getApiFor:O.$HL,getChildren:s=>s.children,root:new u(E,v),toITestItem:P.TestItem.from})}}e.$1L=h}),define(pe[274],be([1,0,270,118,90,88,135,91,136,13,222,268,89]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PM=e.$OM=void 0,e.$OM="remoteterminal";let l=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(m,c,u,h,g,E,v,t,s,a){this.a=m,this.b=c,this.c=u,this.d=h,this.e=g,this.f=E,this.g=v,this.h=t,this.i=s,this.j=a}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(m,c,u,h,g,E,v,t){await this.c.whenRemoteConfigurationLoaded();const s=Object.create(null),a=u?this.d.getWorkspaceFolder(u)??void 0:void 0;let i;try{i=(await this.e.resolveAnyMap(a,{shellLaunchConfig:m,configuration:c})).resolvedVariables}catch(Q){this.h.error(Q)}if(i)for(const[Q,le]of i.entries())(/^config:/.test(Q)||Q==="selectedText"||Q==="lineNumber")&&(s[Q]=le);const n=[];for(const[Q,le]of this.f.collections.entries())n.push([Q,(0,C.$4q)(le.map),(0,C.$5q)(le.descriptionMap)]);const o=await this.g.resolveAuthority(this.a),f=o.options&&o.options.extensionHostEnv,b=this.d.getWorkspace(),y=b.folders,S=u?this.d.getWorkspaceFolder(u):null,L=P.$RE.getOriginalUri(this.i.activeEditor,{supportSideBySide:P.SideBySideEditor.PRIMARY,filterByScheme:[$.Schemas.file,$.Schemas.vscodeUserData,$.Schemas.vscodeRemote]}),j={configuration:c,resolvedVariables:s,envVariableCollections:n,shellLaunchConfig:m,workspaceId:b.id,workspaceName:this.j.getWorkspaceLabel(b),workspaceFolders:y,activeWorkspaceFolder:S,activeFileResource:L,shouldPersistTerminal:g,options:h,cols:E,rows:v,unicodeVersion:t,resolverEnv:f};return await this.b.call("$createProcess",j)}requestDetachInstance(m,c){return this.b.call("$requestDetachInstance",[m,c])}acceptDetachInstanceReply(m,c){return this.b.call("$acceptDetachInstanceReply",[m,c])}attachToProcess(m){return this.b.call("$attachToProcess",[m])}detachFromProcess(m,c){return this.b.call("$detachFromProcess",[m,c])}listProcesses(){return this.b.call("$listProcesses")}getLatency(){return this.b.call("$getLatency")}getPerformanceMarks(){return this.b.call("$getPerformanceMarks")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(m,c){return this.b.call("$processBinary",[m,c])}start(m){return this.b.call("$start",[m])}input(m,c){return this.b.call("$input",[m,c])}acknowledgeDataEvent(m,c){return this.b.call("$acknowledgeDataEvent",[m,c])}setUnicodeVersion(m,c){return this.b.call("$setUnicodeVersion",[m,c])}shutdown(m,c){return this.b.call("$shutdown",[m,c])}resize(m,c,u){return this.b.call("$resize",[m,c,u])}clearBuffer(m){return this.b.call("$clearBuffer",[m])}getInitialCwd(m){return this.b.call("$getInitialCwd",[m])}getCwd(m){return this.b.call("$getCwd",[m])}orphanQuestionReply(m){return this.b.call("$orphanQuestionReply",[m])}sendCommandResult(m,c,u){return this.b.call("$sendCommandResult",[m,c,u])}freePortKillProcess(m){return this.b.call("$freePortKillProcess",[m])}installAutoReply(m,c){return this.b.call("$installAutoReply",[m,c])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(m){return this.b.call("$getDefaultSystemShell",[m])}getProfiles(m,c,u){return this.b.call("$getProfiles",[this.d.getWorkspace().id,m,c,u])}acceptPtyHostResolvedVariables(m,c){return this.b.call("$acceptPtyHostResolvedVariables",[m,c])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(m,c){return this.b.call("$getWslPath",[m,c])}setTerminalLayoutInfo(m){const u={workspaceId:this.d.getWorkspace().id,tabs:m?m.tabs:[]};return this.b.call("$setTerminalLayoutInfo",u)}updateTitle(m,c,u){return this.b.call("$updateTitle",[m,c,u])}updateIcon(m,c,u,h){return this.b.call("$updateIcon",[m,c,u,h])}refreshProperty(m,c){return this.b.call("$refreshProperty",[m,c])}updateProperty(m,c,u){return this.b.call("$updateProperty",[m,c,u])}getTerminalLayoutInfo(){const c={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",c)}reviveTerminalProcesses(m,c,u){return this.b.call("$reviveTerminalProcesses",[m,c,u])}getRevivedPtyNewId(m){return this.b.call("$getRevivedPtyNewId",[m])}serializeTerminalState(m){return this.b.call("$serializeTerminalState",[m])}};e.$PM=l,e.$PM=l=Le([Ie(2,D.$bE),Ie(3,r.$yh),Ie(4,I.$xM),Ie(5,k.$cM),Ie(6,O.$wk),Ie(7,p.$Qq),Ie(8,w.$XC),Ie(9,A.$Kz)],l)}),define(pe[275],be([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.ExtHostConnectionType=void 0;var D;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class O{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(k){this.pipeName=k,this.type=1}serialize(k){k[O.ENV_KEY]=this.pipeName}}e.$am=O;class r{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(k){k[r.ENV_KEY]="1"}}e.$bm=r;class C{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(k){k[C.ENV_KEY]="1"}}e.$cm=C;function I(A){delete A[O.ENV_KEY],delete A[r.ENV_KEY],delete A[C.ENV_KEY]}function P(A,k){I(k),A.serialize(k)}e.$dm=P;function w(A){if(A[O.ENV_KEY])return $(A,new O(A[O.ENV_KEY]));if(A[r.ENV_KEY])return $(A,new r);if(A[C.ENV_KEY])return $(A,new C);throw new Error("No connection information defined in environment!")}e.$em=w;function $(A,k){return I(A),k}}),define(pe[276],be([1,0,15]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$Rl=e.$Ql=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var O;(function($){$[$.Desktop=1]="Desktop",$[$.Web=2]="Web"})(O||(e.UIKind=O={}));var r;(function($){$[$.VersionMismatch=55]="VersionMismatch",$[$.UnexpectedError=81]="UnexpectedError"})(r||(e.ExtensionHostExitCode=r={}));var C;(function($){$[$.Initialized=0]="Initialized",$[$.Ready=1]="Ready",$[$.Terminate=2]="Terminate"})(C||(e.MessageType=C={}));function I($){const A=D.$Ec.alloc(1);switch($){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$Ql=I;function P($,A){if($.byteLength!==1)return!1;switch($.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$Rl=P;var w;(function($){$.Start="START_NATIVE_LOG",$.End="END_NATIVE_LOG"})(w||(e.NativeLogMarkers=w={}))}),define(pe[277],be([1,0,6,5,12,264,276,56,36,22,4,2,201]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6L=e.$5L=e.$4L=e.$3L=void 0;let l=class extends k.$lb{constructor(u,h){super(),this.n=u,this.p=h,this.a=this.B(new O.$ec),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new O.$ec),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.m=new Map,this.j=A.URI.revive(this.n.environment.extensionTelemetryLogResource),this.i=this.n.environment.isExtensionTelemetryLoggingOnly,this.k=h.createLogger(this.j,{id:w.$9n,name:(0,p.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(h.onDidChangeLogLevel(g=>{(0,r.$Ti)(g)&&this.r()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}r(){this.p.setVisibility(this.j,this.g&&this.p.getLogLevel()===r.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(u,h,g){const E=this.getTelemetryDetails(),v=new d(h,g,u,this.k,this.i,this.getBuiltInCommonProperties(u),{isUsageEnabled:E.isUsageEnabled,isErrorsEnabled:E.isErrorsEnabled}),t=this.m.get(u.identifier.value)??[];return this.m.set(u.identifier.value,[...t,v]),v.apiTelemetryLogger}$initializeTelemetryLevel(u,h,g){this.f=u,this.g=h,this.c=g??{usage:!0,error:!0},this.r()}getBuiltInCommonProperties(u){const h=Object.create(null);switch(h["common.extname"]=`${u.publisher}.${u.name}`,h["common.extversion"]=u.version,h["common.vscodemachineid"]=this.n.telemetryInfo.machineId,h["common.vscodesessionid"]=this.n.telemetryInfo.sessionId,h["common.vscodeversion"]=this.n.version,h["common.isnewappinstall"]=m(this.n.telemetryInfo.firstSessionDate),h["common.product"]=this.n.environment.appHost,this.n.uiKind){case I.UIKind.Web:h["common.uikind"]="web";break;case I.UIKind.Desktop:h["common.uikind"]="desktop";break;default:h["common.uikind"]="unknown"}return h["common.remotename"]=(0,P.$Ck)((0,w.$do)(this.n.remote.authority)),h}$onDidChangeTelemetryLevel(u){this.h=this.getTelemetryConfiguration(),this.f=u;const h=this.getTelemetryDetails();this.m.forEach((g,E)=>{const v=g.filter(t=>!t.isDisposed);v.length===0?this.m.delete(E):this.m.set(E,v)}),this.m.forEach(g=>{for(const E of g)E.updateTelemetryEnablements(h.isUsageEnabled,h.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.r()}onExtensionError(u,h){const E=this.m.get(u.value)?.filter(t=>!t.isDisposed);if(!E)return this.m.delete(u.value),!1;let v=!1;for(const t of E)t.ignoreUnhandledExtHostErrors||(t.logError(h),v=!0);return v}};e.$3L=l,e.$3L=l=Le([Ie(0,C.$2L),Ie(1,r.$Si)],l);class d{static validateSender(u){if(typeof u!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof u.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof u.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof u.flush<"u"&&typeof u.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(u,h,g,E,v,t,s){this.g=g,this.h=E,this.i=v,this.j=t,this.a=new O.$ec,this.ignoreUnhandledExtHostErrors=h?.ignoreUnhandledErrors??!1,this.b=h?.ignoreBuiltInCommonProperties??!1,this.c=h?.additionalCommonProperties,this.f=u,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(u,h){this.e&&(this.d={isUsageEnabled:u,isErrorsEnabled:h},this.a.fire(this.e))}mixInCommonPropsAndCleanData(u){let h="properties"in u?u.properties??{}:u;return h=(0,w.$go)(h,[]),this.c&&(h=(0,$.$Lm)(h,this.c)),this.b||(h=(0,$.$Lm)(h,this.j)),"properties"in u?u.properties=h:u=h,u}k(u,h){this.f&&(this.g.publisher==="vscode"?u=this.g.name+"/"+u:u=this.g.identifier.value+"/"+u,h=this.mixInCommonPropsAndCleanData(h||{}),this.i||this.f?.sendEventData(u,h),this.h.trace(u,h))}logUsage(u,h){this.d.isUsageEnabled&&this.k(u,h)}logError(u,h){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof u=="string")this.k(u,h);else{const g={name:u.name,message:u.message,stack:u.stack,cause:u.cause},E=(0,w.$go)(g,[]),v=new Error(E.message,{cause:E.cause});v.stack=E.stack,v.name=E.name,h=this.mixInCommonPropsAndCleanData(h||{}),this.i||this.f.sendErrorData(v,h),this.h.trace("exception",h)}}get apiTelemetryLogger(){if(!this.e){const u=this,h={logUsage:u.logUsage.bind(u),get isUsageEnabled(){return u.d.isUsageEnabled},get isErrorsEnabled(){return u.d.isErrorsEnabled},logError:u.logError.bind(u),dispose:u.dispose.bind(u),onDidChangeEnableStates:u.a.event.bind(u)};this.e=Object.freeze(h)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let u=this.f;this.f=void 0,Promise.resolve(u.flush()).then(u=void 0),this.e=void 0}else this.f=void 0}}e.$4L=d;function m(c){const u=Date.now()-new Date(c).getTime();return isNaN(u)?!1:u<1e3*60*60*24}e.$5L=m,e.$6L=(0,D.$ph)("IExtHostTelemetry")}),define(pe[278],be([1,0,40,204,53]),function(ce,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0M=void 0;function C(I,P,w,$){const A=new D.$Kl;return I.forEach(k=>{const p=A.get(k.identifier);p&&$.warn((0,O.localize)(0,null,p.extensionLocation.fsPath,k.extensionLocation.fsPath)),A.set(k.identifier,k)}),P.forEach(k=>{const p=A.get(k.identifier);if(p)if(p.isBuiltin){if(r.gte(p.version,k.version)){$.warn(`Skipping extension ${k.extensionLocation.path} in favour of the builtin extension ${p.extensionLocation.path}.`);return}k.isBuiltin=!0}else $.warn((0,O.localize)(1,null,p.extensionLocation.fsPath,k.extensionLocation.fsPath));else if(k.isBuiltin){$.warn(`Skipping obsolete builtin extension ${k.extensionLocation.path}`);return}A.set(k.identifier,k)}),w.forEach(k=>{$.info((0,O.localize)(2,null,k.extensionLocation.fsPath));const p=A.get(k.identifier);p&&p.isBuiltin&&(k.isBuiltin=!0),A.set(k.identifier,k)}),Array.from(A.values())}e.$0M=C}),define(pe[279],be([1,0,7,3,30,4,41,51,66,57,278,13]),function(ce,e,D,O,r,C,I,P,w,$,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bN=e.$aN=void 0;class p{constructor(m,c,u,h,g,E,v){this.c=m,this.d=u,this.f=h,this.g=g,this.h=E,this.i=v,this.a=Promise.resolve(),this.b=Promise.resolve();const t=c.args["install-builtin-extension"];if(t){g.trace("Installing builtin extensions passed via args...");const a={isMachineScoped:!!c.args["do-not-sync"],installPreReleaseVersion:!!c.args["pre-release"]};I.mark("code/server/willInstallBuiltinExtensions"),this.b=this.a=m.installExtensions([],this.j(t),a,!!c.args.force).then(()=>{I.mark("code/server/didInstallBuiltinExtensions"),g.trace("Finished installing builtin extensions")},i=>{g.error(i)})}const s=c.args["install-extension"];s&&(g.trace("Installing extensions passed via args..."),this.b=this.a.then(()=>m.installExtensions(this.j(s),[],{isMachineScoped:!!c.args["do-not-sync"],installPreReleaseVersion:!!c.args["pre-release"],isApplicationScoped:!0},!!c.args.force)).then(()=>{g.trace("Finished installing extensions")},a=>{g.error(a)}))}j(m){return m.map(c=>/\.vsix$/i.test(c)?C.URI.file((0,D.$7c)(c)?c:(0,D.$8c)((0,r.cwd)(),c)):c)}whenExtensionsReady(){return this.b}async scanExtensions(m,c,u,h){I.mark("code/server/willScanExtensions"),this.g.trace(`Scanning extensions using UI language: ${m}`),await this.a;const g=u?u.filter(v=>v.scheme===k.Schemas.file).map(v=>v.fsPath):void 0;c=c??this.d.defaultProfile.extensionsResource;const E=await this.k(c,m??O.$v,g,h);return this.g.trace("Scanned Extensions",E),this.r(E),I.mark("code/server/didScanExtensions"),E}async scanSingleExtension(m,c,u){await this.a;const h=m.scheme===k.Schemas.file?m.fsPath:null;if(!h)return null;const g=await this.o(h,c,u??O.$v);return g?(this.r([g]),g):null}async k(m,c,u,h){await this.q(c,h);const[g,E,v]=await Promise.all([this.m(c),this.n(m,c),this.l(c,u)]);return(0,A.$0M)(g,E,v,this.g)}async l(m,c){return c?(await Promise.all(c.map(u=>this.f.scanOneOrMultipleExtensions(C.URI.file((0,D.$9c)(u)),1,{language:m})))).flat().map(u=>(0,$.$ip)(u,!0)):[]}async m(m){return(await this.f.scanSystemExtensions({language:m,useCache:!0})).map(u=>(0,$.$ip)(u,!1))}async n(m,c){return(await this.f.scanUserExtensions({profileLocation:m,language:c,useCache:!0})).map(h=>(0,$.$ip)(h,!1))}async o(m,c,u){const h=C.URI.file((0,D.$9c)(m)),g=c?0:1,E=await this.f.scanExistingExtension(h,g,{language:u});return E?(0,$.$ip)(E,!1):null}async q(m,c){if(!(m===O.$f||!this.h.isEnabled())){try{if((await this.i.getInstalledLanguages()).find(h=>h.id===m)){this.g.trace(`Language Pack ${m} is already installed. Skipping language pack installation.`);return}}catch(u){this.g.error(u)}if(!c){this.g.trace(`No language pack id provided for language ${m}. Skipping language pack installation.`);return}this.g.trace(`Language Pack ${c} for language ${m} is not installed. It will be installed now.`);try{await this.c.installExtensions([c],[],{isMachineScoped:!0},!0)}catch(u){this.g.error(u)}}}r(m){const c=(t,s)=>t.replace(/file/g,"vscode-remote"),u=t=>{let s="";return s+=t.global?"g":"",s+=t.ignoreCase?"i":"",s+=t.multiline?"m":"",new RegExp(c(t.source,!0),s)},h=new class{mapDefined(t){return w.$Ai.create(t)}mapNot(t){return w.$Fi.create(t)}mapEquals(t,s){return t==="resourceScheme"&&typeof s=="string"?w.$Bi.create(t,c(s,!1)):w.$Bi.create(t,s)}mapNotEquals(t,s){return t==="resourceScheme"&&typeof s=="string"?w.$Ei.create(t,c(s,!1)):w.$Ei.create(t,s)}mapGreater(t,s){return w.$Gi.create(t,s)}mapGreaterEquals(t,s){return w.$Hi.create(t,s)}mapSmaller(t,s){return w.$Ii.create(t,s)}mapSmallerEquals(t,s){return w.$Ji.create(t,s)}mapRegex(t,s){return t==="resourceScheme"&&s?w.$Ki.create(t,u(s)):w.$Ki.create(t,s)}mapIn(t,s){return w.$Ci.create(t,s)}mapNotIn(t,s){return w.$Di.create(t,s)}},g=t=>{if(!t||!t.when||!/resourceScheme/.test(t.when))return;const s=w.$vi.deserialize(t.when);if(!s)return;const a=s.map(h);t.when=a.serialize()},E=t=>{if(Array.isArray(t))for(const s of t)g(s);else g(t)},v=t=>{for(const s in t)E(t[s])};m.forEach(t=>{t.contributes&&(t.contributes.menus&&v(t.contributes.menus),t.contributes.keybindings&&E(t.contributes.keybindings),t.contributes.views&&v(t.contributes.views))})}}e.$aN=p;class l{constructor(m,c){this.a=m,this.b=c}listen(m,c){throw new Error("Invalid listen")}async call(m,c,u){const h=this.b(m);switch(c){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const g=u[0],E=u[1]?C.URI.revive(h.transformIncoming(u[1])):void 0,v=Array.isArray(u[2])?u[2].map(a=>C.URI.revive(h.transformIncoming(a))):void 0,t=u[3];return(await this.a.scanExtensions(g,E,v,t)).map(a=>(0,P.$qm)(a,h))}case"scanSingleExtension":{const g=await this.a.scanSingleExtension(C.URI.revive(h.transformIncoming(u[0])),u[1],u[2]);return g?(0,P.$qm)(g,h):null}}throw new Error("Invalid call")}}e.$bN=l}),define(pe[138],be([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5z=e.$4z=e.$3z=e.$2z=void 0;class D{static{this.count=0}constructor(w){this._proxyIdentifierBrand=void 0,this.sid=w,this.nid=++D.count}}e.$2z=D;const O=[];function r(P){const w=new D(P);return O[w.nid]=w,w}e.$3z=r;function C(P){return O[P].sid}e.$4z=C;class I{constructor(w){this.value=w}}e.$5z=I}),define(pe[280],be([1,0,138]),function(ce,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KJ=e.$JJ=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$IJ=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var r;(function(m){m[m.UnknownInput=0]="UnknownInput",m[m.TextInput=1]="TextInput",m[m.TextDiffInput=2]="TextDiffInput",m[m.TextMergeInput=3]="TextMergeInput",m[m.NotebookInput=4]="NotebookInput",m[m.NotebookDiffInput=5]="NotebookDiffInput",m[m.CustomEditorInput=6]="CustomEditorInput",m[m.WebviewEditorInput=7]="WebviewEditorInput",m[m.TerminalEditorInput=8]="TerminalEditorInput",m[m.InteractiveEditorInput=9]="InteractiveEditorInput"})(r||(e.TabInputKind=r={}));var C;(function(m){m[m.TAB_OPEN=0]="TAB_OPEN",m[m.TAB_CLOSE=1]="TAB_CLOSE",m[m.TAB_UPDATE=2]="TAB_UPDATE",m[m.TAB_MOVE=3]="TAB_MOVE"})(C||(e.TabModelOperationKind=C={}));var I;(function(m){m[m.Editable=0]="Editable",m[m.SupportsHotExit=1]="SupportsHotExit"})(I||(e.WebviewEditorCapabilities=I={}));var P;(function(m){m[m.Int8Array=1]="Int8Array",m[m.Uint8Array=2]="Uint8Array",m[m.Uint8ClampedArray=3]="Uint8ClampedArray",m[m.Int16Array=4]="Int16Array",m[m.Uint16Array=5]="Uint16Array",m[m.Int32Array=6]="Int32Array",m[m.Uint32Array=7]="Uint32Array",m[m.Float32Array=8]="Float32Array",m[m.Float64Array=9]="Float64Array",m[m.BigInt64Array=10]="BigInt64Array",m[m.BigUint64Array=11]="BigUint64Array"})(P||(e.WebviewMessageArrayBufferViewType=P={}));var w;(function(m){m[m.Text=1]="Text",m[m.Error=2]="Error",m[m.Rich=3]="Rich"})(w||(e.CellOutputKind=w={}));var $;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})($||(e.NotebookEditorRevealType=$={}));var A;(function(m){m[m.None=0]="None",m[m.Process=1]="Process",m[m.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class k{static{this.a=0}static mixin(c){return c._id=k.a++,c}}e.$IJ=k;var p;(function(m){m.label="a",m.kind="b",m.detail="c",m.documentation="d",m.sortText="e",m.filterText="f",m.preselect="g",m.insertText="h",m.insertTextRules="i",m.range="j",m.commitCharacters="k",m.additionalTextEdits="l",m.kindModifier="m",m.commandIdent="n",m.commandId="o",m.commandArguments="p"})(p||(e.ISuggestDataDtoField=p={}));var l;(function(m){m.defaultRanges="a",m.completions="b",m.isIncomplete="c",m.duration="d"})(l||(e.ISuggestResultDtoField=l={}));var d;(function(m){m[m.Workspace=0]="Workspace",m[m.TextDocument=1]="TextDocument"})(d||(e.ExtHostTestingResource=d={})),e.$JJ={MainThreadAuthentication:(0,D.$3z)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$3z)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$3z)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,D.$3z)("MainThreadChatSlashCommands"),MainThreadChatVariables:(0,D.$3z)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$3z)("MainThreadClipboard"),MainThreadCommands:(0,D.$3z)("MainThreadCommands"),MainThreadComments:(0,D.$3z)("MainThreadComments"),MainThreadConfiguration:(0,D.$3z)("MainThreadConfiguration"),MainThreadConsole:(0,D.$3z)("MainThreadConsole"),MainThreadDebugService:(0,D.$3z)("MainThreadDebugService"),MainThreadDecorations:(0,D.$3z)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$3z)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$3z)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$3z)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$3z)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$3z)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$3z)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$3z)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$3z)("MainThreadErrors"),MainThreadTreeViews:(0,D.$3z)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$3z)("MainThreadDownloadService"),MainThreadKeytar:(0,D.$3z)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,D.$3z)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$3z)("MainThreadLanguages"),MainThreadLogger:(0,D.$3z)("MainThreadLogger"),MainThreadMessageService:(0,D.$3z)("MainThreadMessageService"),MainThreadOutputService:(0,D.$3z)("MainThreadOutputService"),MainThreadProgress:(0,D.$3z)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$3z)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$3z)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$3z)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$3z)("MainThreadSecretState"),MainThreadStorage:(0,D.$3z)("MainThreadStorage"),MainThreadTelemetry:(0,D.$3z)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$3z)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$3z)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$3z)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$3z)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$3z)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$3z)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$3z)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$3z)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$3z)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$3z)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.$3z)("MainThreadExtensionService"),MainThreadSCM:(0,D.$3z)("MainThreadSCM"),MainThreadSearch:(0,D.$3z)("MainThreadSearch"),MainThreadShare:(0,D.$3z)("MainThreadShare"),MainThreadTask:(0,D.$3z)("MainThreadTask"),MainThreadWindow:(0,D.$3z)("MainThreadWindow"),MainThreadLabelService:(0,D.$3z)("MainThreadLabelService"),MainThreadNotebook:(0,D.$3z)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$3z)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$3z)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$3z)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$3z)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$3z)("MainThreadInteractive"),MainThreadChat:(0,D.$3z)("MainThreadChat"),MainThreadInlineChat:(0,D.$3z)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$3z)("MainThreadTheming"),MainThreadTunnelService:(0,D.$3z)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$3z)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$3z)("MainThreadTimeline"),MainThreadTesting:(0,D.$3z)("MainThreadTesting"),MainThreadLocalization:(0,D.$3z)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$3z)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$3z)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$3z)("MainThreadIssueReporter")},e.$KJ={ExtHostCommands:(0,D.$3z)("ExtHostCommands"),ExtHostConfiguration:(0,D.$3z)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$3z)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$3z)("ExtHostDebugService"),ExtHostDecorations:(0,D.$3z)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$3z)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$3z)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$3z)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$3z)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$3z)("ExtHostEditors"),ExtHostTreeViews:(0,D.$3z)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$3z)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$3z)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$3z)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$3z)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$3z)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$3z)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$3z)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$3z)("ExtHostStatusBar"),ExtHostShare:(0,D.$3z)("ExtHostShare"),ExtHostExtensionService:(0,D.$3z)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$3z)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$3z)("ExtHostTerminalService"),ExtHostSCM:(0,D.$3z)("ExtHostSCM"),ExtHostSearch:(0,D.$3z)("ExtHostSearch"),ExtHostTask:(0,D.$3z)("ExtHostTask"),ExtHostWorkspace:(0,D.$3z)("ExtHostWorkspace"),ExtHostWindow:(0,D.$3z)("ExtHostWindow"),ExtHostWebviews:(0,D.$3z)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$3z)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$3z)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$3z)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$3z)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$3z)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$3z)("ExtHostProgress"),ExtHostComments:(0,D.$3z)("ExtHostComments"),ExtHostSecretState:(0,D.$3z)("ExtHostSecretState"),ExtHostStorage:(0,D.$3z)("ExtHostStorage"),ExtHostUrls:(0,D.$3z)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$3z)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$3z)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$3z)("ExtHostOutputService"),ExtHosLabelService:(0,D.$3z)("ExtHostLabelService"),ExtHostNotebook:(0,D.$3z)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$3z)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$3z)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$3z)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$3z)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$3z)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$3z)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$3z)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$3z)("ExtHostChat"),ExtHostChatSlashCommands:(0,D.$3z)("ExtHostChatSlashCommands"),ExtHostChatVariables:(0,D.$3z)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$3z)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,D.$3z)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$3z)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$3z)("ExtHostTheming"),ExtHostTunnelService:(0,D.$3z)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$3z)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$3z)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$3z)("ExtHostTimeline"),ExtHostTesting:(0,D.$3z)("ExtHostTesting"),ExtHostTelemetry:(0,D.$3z)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$3z)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$3z)("ExtHostIssueReporter")}}),define(pe[281],be([1,0,10,132,137,22,280,18,12,50,42,101,4,2,6,265,273,15,138,38,58,36,277]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l,d,m,c,u,h,g,E,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=void 0;let s=class{#e;#t;#n;constructor(b,y,S){this.b=new Map,this.c=new Map,this.#e=b.getProxy(I.$JJ.MainThreadCommands),this.d=y,this.#n=S,this.#t=b.getProxy(I.$JJ.MainThreadTelemetry),this.converter=new a(this,L=>{const j=this.c.get(L);return j?.result===n.Void?j:void 0},y),this.f=[{processArgument(L){return(0,$.$Yg)(L)}},{processArgument(L){return(0,C.$Km)(L,function(j){if(A.$Ur.isIRange(j))return r.Range.to(j);if(k.$Tr.isIPosition(j))return r.Position.to(j);if(A.$Ur.isIRange(j.range)&&p.URI.isUri(j.uri))return r.location.to(j);if(j instanceof u.$Ec)return j.buffer.buffer;if(!Array.isArray(j))return j})}}]}registerArgumentProcessor(b){this.f.push(b)}registerApiCommand(b){const y=this.registerCommand(!1,b.id,async(...S)=>{const L=b.args.map((Q,le)=>{if(!Q.validate(S[le]))throw new Error(`Invalid argument '${Q.name}' when running '${b.id}', received: ${S[le]}`);return Q.convert(S[le])}),j=await this.executeCommand(b.internalId,...L);return b.result.convert(j,S,this.converter)},void 0,{description:b.description,args:b.args,returns:b.result.description});return this.c.set(b.id,b),new O.$LJ(()=>{y.dispose(),this.c.delete(b.id)})}registerCommand(b,y,S,L,j,Q){if(this.d.trace("ExtHostCommands#registerCommand",y),!y.trim().length)throw new Error("invalid id");if(this.b.has(y))throw new Error(`command '${y}' already exists`);return this.b.set(y,{callback:S,thisArg:L,description:j,extension:Q}),b&&this.#e.$registerCommand(y),new O.$LJ(()=>{this.b.delete(y)&&b&&this.#e.$unregisterCommand(y)})}executeCommand(b,...y){return this.d.trace("ExtHostCommands#executeCommand",b),this.g(b,y,!0)}async g(b,y,S){if(this.b.has(b))return this.#e.$fireCommandActivationEvent(b),this.h(b,y,!1);{let L=!1;const j=(0,C.$Km)(y,function(Q){if(Q instanceof O.$MJ)return r.Position.from(Q);if(Q instanceof O.$NJ)return r.Range.from(Q);if(Q instanceof O.$XJ)return r.location.from(Q);if(O.$0K.isNotebookRange(Q))return r.NotebookRange.from(Q);if(Q instanceof ArrayBuffer)return L=!0,u.$Ec.wrap(new Uint8Array(Q));if(Q instanceof Uint8Array)return L=!0,u.$Ec.wrap(Q);if(Q instanceof u.$Ec)return L=!0,Q;if(!Array.isArray(Q))return Q});try{const Q=await this.#e.$executeCommand(b,L?new h.$5z(j):j,S);return(0,$.$Yg)(Q)}catch(Q){if(Q instanceof Error&&Q.message==="$executeCommand:retry")return this.g(b,y,!1);throw Q}}}async h(b,y,S){const L=this.b.get(b);if(!L)throw new Error("Unknown command");const{callback:j,thisArg:Q,description:le}=L;if(le)for(let ee=0;ee<le.args.length;ee++)try{(0,D.$ze)(y[ee],le.args[ee].constraint)}catch{throw new Error(`Running the contributed command: '${b}' failed. Illegal argument '${le.args[ee].name}' - ${le.args[ee].description}`)}const Y=E.$ac.create();try{return await j.apply(Q,y)}catch(ee){if(b===this.converter.delegatingCommandId){const ue=this.converter.getActualCommand(...y);ue&&(b=ue.command)}if(this.d.error(ee,b,L.extension?.identifier),!S)throw ee;if(L.extension?.identifier){const ue=this.#n.onExtensionError(L.extension.identifier,ee);this.d.trace("forwarded error to extension?",ue,L.extension?.identifier)}throw new class extends Error{constructor(){super((0,g.$ai)(ee)),this.id=b,this.source=L.extension?.displayName??L.extension?.name}}}finally{this.j(L,b,Y.elapsed())}}j(b,y,S){b.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:b.extension.identifier.value,id:new v.$4n(y),duration:S})}$executeContributedCommand(b,...y){this.d.trace("ExtHostCommands#$executeContributedCommand",b);const S=this.b.get(b);return S?(y=y.map(L=>this.f.reduce((j,Q)=>Q.processArgument(j,S.extension?.identifier),L)),this.h(b,y,!0)):Promise.reject(new Error(`Contributed command '${b}' does not exist.`))}getCommands(b=!1){return this.d.trace("ExtHostCommands#getCommands",b),this.#e.$getCommands().then(y=>(b&&(y=y.filter(S=>S[0]!=="_")),y))}$getContributedCommandHandlerDescriptions(){const b=Object.create(null);for(const[y,S]of this.b){const{description:L}=S;L&&(b[y]=L)}return Promise.resolve(b)}};e.$7L=s,e.$7L=s=Le([Ie(0,m.$LL),Ie(1,w.$Ri),Ie(2,t.$6L)],s),e.$8L=(0,d.$ph)("IExtHostCommands");class a{constructor(b,y,S){this.d=b,this.f=y,this.g=S,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(b,y){if(!b)return;const S={$ident:void 0,id:b.command,title:b.title,tooltip:b.tooltip};if(!b.command)return S;const L=this.f(b.command);if(L)S.id=L.internalId,S.arguments=L.args.map((j,Q)=>j.convert(b.arguments&&b.arguments[Q]));else if((0,P.$nf)(b.arguments)){const j=`${b.command}/${++this.c}`;this.b.set(j,b),y.add((0,l.$jb)(()=>{this.b.delete(j),this.g.trace("CommandsConverter#DISPOSE",j)})),S.$ident=j,S.id=this.delegatingCommandId,S.arguments=[j],this.g.trace("CommandsConverter#CREATE",b.command,j)}return S}fromInternal(b){return typeof b.$ident=="string"?this.b.get(b.$ident):{command:b.id,title:b.title,arguments:b.arguments}}getActualCommand(...b){return this.b.get(b[0])}h(...b){const y=this.getActualCommand(...b);return this.g.trace("CommandsConverter#EXECUTE",b[0],y?y.command:"MISSING"),y?this.d.executeCommand(y.command,...y.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${b[0]}`)}}e.$9L=a;class i{static{this.Uri=new i("uri","Uri of a text document",b=>p.URI.isUri(b),b=>b)}static{this.Position=new i("position","A position in a text document",b=>O.$MJ.isPosition(b),r.Position.from)}static{this.Range=new i("range","A range in a text document",b=>O.$NJ.isRange(b),r.Range.from)}static{this.Selection=new i("selection","A selection in a text document",b=>O.$OJ.isSelection(b),r.Selection.from)}static{this.Number=new i("number","",b=>typeof b=="number",b=>b)}static{this.String=new i("string","",b=>typeof b=="string",b=>b)}static{this.StringArray=i.Arr(i.String)}static Arr(b){return new i(`${b.name}_array`,`Array of ${b.name}, ${b.description}`,y=>Array.isArray(y)&&y.every(S=>b.validate(S)),y=>y.map(S=>b.convert(S)))}static{this.CallHierarchyItem=new i("item","A call hierarchy item",b=>b instanceof O.$9J,r.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new i("item","A type hierarchy item",b=>b instanceof O.$qL,r.TypeHierarchyItem.from)}static{this.TestItem=new i("testItem","A VS Code TestItem",b=>b instanceof c.$YL,r.TestItem.from)}constructor(b,y,S,L){this.name=b,this.description=y,this.validate=S,this.convert=L}optional(){return new i(this.name,`(optional) ${this.description}`,b=>b==null||this.validate(b),b=>b===void 0?void 0:b===null?null:this.convert(b))}with(b,y){return new i(b??this.name,y??this.description,this.validate,this.convert)}}e.$0L=i;class n{static{this.Void=new n("no result",b=>b)}constructor(b,y){this.description=b,this.convert=y}}e.$$L=n;class o{constructor(b,y,S,L,j){this.id=b,this.internalId=y,this.description=S,this.args=L,this.result=j}}e.$_L=o}),define(pe[282],be([1,0,11,2,13,217]),function(ce,e,D,O,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TM=e.$SM=void 0,e.$SM="remoteFilesystem";class I extends C.$RM{static register(w,$,A){const k=w.getConnection();if(!k)return O.$lb.None;const p=new O.$kb,l=(async()=>{try{const d=await w.getRawEnvironment();d?$.registerProvider(r.Schemas.vscodeRemote,p.add(new I(d,k))):A.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(d){A.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,D.$9)(d))}})();return p.add($.onWillActivateFileSystemProvider(d=>{d.scheme===r.Schemas.vscodeRemote&&d.join(l)})),p}constructor(w,$){super($.getChannel(e.$SM),{pathCaseSensitive:w.os===3})}}e.$TM=I}),define(pe[93],be([1,0,28,14,7,10,21,169,300,301]),function(ce,e,D,O,r,C,I,P,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.zip=e.$5o=e.$4o=void 0,e.$4o="end of central directory record signature not found";const A=new RegExp(e.$4o);class k extends Error{constructor(s,a){let i=a.message;switch(s){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=s,this.cause=a}}e.$5o=k;function p(t){const s=t.externalFileAttributes>>16||33188;return[448,56,7].map(a=>s&a).reduce((a,i)=>a+i,s&61440)}function l(t){if(t instanceof k)return t;let s;return A.test(t.message)&&(s="CorruptZip"),new k(s,t)}function d(t,s,a,i,n,o){const f=r.$$c(s),b=r.$8c(i,f);if(!b.startsWith(i))return Promise.reject(new Error(P.localize(0,null,s)));const y=r.$8c(i,s);let S;return o.onCancellationRequested(()=>{S?.destroy()}),Promise.resolve(I.Promises.mkdir(b,{recursive:!0})).then(()=>new Promise((L,j)=>{if(!o.isCancellationRequested)try{S=(0,D.createWriteStream)(y,{mode:a}),S.once("close",()=>L()),S.once("error",j),t.once("error",j),t.pipe(S)}catch(Q){j(Q)}}))}function m(t,s,a,i){let n=(0,O.$ig)(()=>Promise.resolve()),o=0;return i.onCancellationRequested(()=>{n.cancel(),t.close()}),new Promise((f,b)=>{const y=new O.$pg,S=L=>{L.isCancellationRequested||(o++,t.readEntry())};t.once("error",b),t.once("close",()=>n.then(()=>{i.isCancellationRequested||t.entryCount===o?f():b(new k("Incomplete",new Error(P.localize(1,null,o,t.entryCount))))},b)),t.readEntry(),t.on("entry",L=>{if(i.isCancellationRequested)return;if(!a.sourcePathRegex.test(L.fileName)){S(i);return}const j=L.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(j)){const Y=r.$8c(s,j);n=(0,O.$ig)(ee=>I.Promises.mkdir(Y,{recursive:!0}).then(()=>S(ee)).then(void 0,b));return}const Q=u(t,L),le=p(L);n=(0,O.$ig)(Y=>y.queue(()=>Q.then(ee=>d(ee,j,le,s,a,Y).then(()=>S(Y)))).then(null,b))})})}function c(t,s=!1){return new Promise((a,i)=>{(0,w.open)(t,s?{lazyEntries:!0}:void 0,(n,o)=>{n?i(l(n)):a((0,C.$te)(o))})})}function u(t,s){return new Promise((a,i)=>{t.openReadStream(s,(n,o)=>{n?i(l(n)):a((0,C.$te)(o))})})}function h(t,s){return new Promise((a,i)=>{const n=new $.ZipFile;s.forEach(f=>{f.contents?n.addBuffer(typeof f.contents=="string"?Buffer.from(f.contents,"utf8"):f.contents,f.path):f.localPath&&n.addFile(f.localPath,f.path)}),n.end();const o=(0,D.createWriteStream)(t);n.outputStream.pipe(o),n.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>a(t))})}e.zip=h;function g(t,s,a={},i){const n=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let o=c(t,!0);return a.overwrite&&(o=o.then(f=>I.Promises.rm(s).then(()=>f))),o.then(f=>m(f,s,{sourcePathRegex:n},i))}e.$7o=g;function E(t,s){return c(t).then(a=>new Promise((i,n)=>{a.on("entry",o=>{o.fileName===s&&u(a,o).then(f=>i(f),f=>n(f))}),a.once("close",()=>n(new Error(P.localize(2,null,s))))}))}function v(t,s){return E(t,s).then(a=>new Promise((i,n)=>{const o=[];a.once("error",n),a.on("data",f=>o.push(f)),a.on("end",()=>i(Buffer.concat(o)))}))}e.$8o=v}),define(pe[283],be([1,0,14,11,2,13,19,53,10,23,21,93,24,25,31,37,82,16,12]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l,d,m,c,u,h){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=void 0;let E=class extends r.$lb{static{g=this}static{this.c=".sigzip"}constructor(t,s,a,i,n,o){super(),this.h=s,this.i=a,this.j=i,this.k=n,this.l=o,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.t()}async download(t,s,a){await this.g;const i=(0,I.$9f)(this.extensionsDownloadDir,this.u(t));try{await this.r(t,i,o=>this.i.download(t,o,s))}catch(o){throw new d.$Sn(o.message,d.ExtensionManagementErrorCode.Download)}let n=!1;if(a&&this.m(t)){const o=await this.n(t);try{n=await this.k.verify(i.fsPath,o.fsPath,this.l.getLevel()===h.LogLevel.Trace)}catch(f){const b=f;if(n=b.code,b.output&&this.l.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${b.output}`),n===d.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===d.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new d.$Sn(k.$4o,d.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(o)}catch(f){this.l.error(f)}}}return n===!0?this.l.info(`Extension signature is verified: ${t.identifier.id}`):n===!1?this.l.info(`Extension signature verification is not done: ${t.identifier.id}`):this.l.warn(`Extension signature verification failed with error '${n}': ${t.identifier.id}`),{location:i,verificationStatus:n}}m(t){if(!t.isSigned)return!1;const s=this.j.getValue("extensions.verifySignature");return(0,w.$oe)(s)?s:!0}async n(t){await this.g;const s=(0,I.$9f)(this.extensionsDownloadDir,`${this.u(t)}${g.c}`);return await this.r(t,s,a=>this.i.downloadSignatureArchive(t,a)),s}async r(t,s,a){if(await this.h.exists(s))return;if(s.scheme!==C.Schemas.file){await a(s);return}const i=(0,I.$9f)(this.extensionsDownloadDir,`.${(0,$.$3e)()}`);await this.h.exists(i)||await a(i);try{await A.Promises.rename(i.fsPath,s.fsPath,2*60*1e3)}catch(n){try{await this.h.del(i)}catch{}if(n.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,s.path);else throw this.l.info(`Rename failed because of ${(0,O.$9)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(t){await this.g,await this.h.del(t)}async t(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const s=[],a=[],i=[];for(const f of t.children)if(f.name.endsWith(g.c))i.push(f.resource);else{const b=m.$io.parse(f.name);b&&a.push([b,f])}const n=(0,m.$no)(a,([f])=>f),o=[];for(const f of n)f.sort((b,y)=>P.rcompare(b[0].version,y[0].version)),s.push(...f.slice(1).map(b=>b[1].resource)),o.push(f[0][1]);o.sort((f,b)=>f.mtime-b.mtime),s.push(...o.slice(0,Math.max(0,o.length-this.f)).map(f=>f.resource)),s.push(...i),await D.Promises.settled(s.map(f=>(this.l.trace("Deleting from cache",f.path),this.h.del(f))))}}catch(t){this.l.error(t)}}u(t){return this.f?m.$io.create(t).toString().toLowerCase():(0,$.$3e)()}};e.$kp=E,e.$kp=E=g=Le([Ie(0,l.$xh),Ie(1,u.$Sj),Ie(2,d.$Rn),Ie(3,p.$Vh),Ie(4,c.$Xo),Ie(5,h.$Ri)],E)}),define(pe[284],be([1,0,93,183]),function(ce,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=void 0;function r(C){return(0,D.$8o)(C,"extension/package.json").then(I=>{try{return JSON.parse(I.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.$mp=r}),define(pe[139],be([1,0,14,15,20,38,11,5,59,2,27,13,7,19,53,10,4,23,21,93,182,81,25,256,31,37,45,57,283,257,284,232,241,79,16,6,12,26,32,34,33]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l,d,m,c,u,h,g,E,v,t,s,a,i,n,o,f,b,y,S,L,j,Q,le,Y,ee,ue,X,he){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.$pp=void 0,e.$pp=(0,le.$qh)(a.$Tn);const x=".vsctmp";let se=class extends s.$9o{constructor(q,J,R,F,W,ie,re,_,oe,N,B,U){super(q,J,B,R,N,U),this.bb=W,this.cb=ie,this.db=re,this.eb=oe,this.ab=new Map,this.nb=new A.$oi;const z=this.B(_.createInstance(b.$lp));this.Y=this.B(_.createInstance(V,de=>z.postUninstall(de))),this.Z=this.B(new S.$np(U,oe,B,this,this.y)),this.$=this.B(_.createInstance(f.$kp));const Z=this.B(new L.$op(this,this.bb,U,ie,B,oe,R));this.B(Z.onDidChangeExtensionsByAnotherSource(de=>this.mb(de))),this.ob()}getTargetPlatform(){return this.fb||(this.fb=(0,i.$so)(this.eb,this.y)),this.fb}async zip(q){this.y.trace("ExtensionManagementService#zip",q.identifier.id);const J=await this.lb(q),R=await(0,g.zip)((0,l.$9f)(this.$.extensionsDownloadDir,(0,u.$3e)()).fsPath,J);return c.URI.file(R)}async unzip(q){return this.y.trace("ExtensionManagementService#unzip",q.toString()),(await this.install(q)).identifier}async getManifest(q){const{location:J,cleanup:R}=await this.hb(q),F=p.$9c(J.fsPath);try{return await(0,y.$mp)(F)}finally{await R()}}getInstalled(q,J=this.C.defaultProfile.extensionsResource){return this.Y.scanExtensions(q??null,J)}scanAllUserInstalledExtensions(){return this.Y.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(q){return this.Y.scanUserExtensionAtLocation(q)}async install(q,J={}){this.y.trace("ExtensionManagementService#install",q.toString());const{location:R,cleanup:F}=await this.hb(q);try{const W=await(0,y.$mp)(p.$9c(R.fsPath)),ie=(0,i.$mo)(W.publisher,W.name);if(W.engines&&W.engines.vscode&&!(0,j.$zo)(W.engines.vscode,this.z.version,this.z.date))throw new Error(E.localize(0,null,ie,this.z.version));const _=(await this.D([{manifest:W,extension:R,options:J}])).find(({identifier:oe})=>(0,i.$ho)(oe,{id:ie}));if(_?.local)return _.local;throw _?.error?_.error:(0,s.$$o)(new Error(`Unknown error while installing extension ${ie}`))}finally{await F()}}async installFromLocation(q,J){this.y.trace("ExtensionManagementService#installFromLocation",q.toString());const R=await this.Y.scanUserExtensionAtLocation(q);if(!R)throw new Error(`Cannot find a valid extension from the location ${q.toString()}`);return await this.qb([[R,void 0]],J),this.y.info("Successfully installed extension",R.identifier.id,J.toString()),R}async installExtensionsFromProfile(q,J,R){this.y.trace("ExtensionManagementService#installExtensionsFromProfile",q,J.toString(),R.toString());const F=(await this.Y.scanExtensions(1,J)).filter(W=>q.some(ie=>(0,i.$ho)(ie,W.identifier)));if(F.length){const W=await Promise.all(F.map(ie=>this.Y.scanMetadata(ie,J)));await this.qb(F.map((ie,re)=>[ie,W[re]]),R),this.y.info("Successfully installed extensions",F.map(ie=>ie.identifier.id),R.toString())}return F}async updateMetadata(q,J,R=this.C.defaultProfile.extensionsResource){return this.y.trace("ExtensionManagementService#updateMetadata",q.identifier.id),J.isPreReleaseVersion&&(J.preRelease=!0),J.isMachineScoped=J.isMachineScoped||void 0,J.isBuiltin=J.isBuiltin||void 0,J.pinned=J.pinned||void 0,q=await this.Y.updateMetadata(q,J,R),this.Z.invalidate(R),this.s.fire(q),q}async reinstallFromGallery(q){if(this.y.trace("ExtensionManagementService#reinstallFromGallery",q.identifier.id),!this.u.isEnabled())throw new Error(E.localize(1,null));const J=await this.getTargetPlatform(),[R]=await this.u.getExtensions([{...q.identifier,preRelease:q.preRelease}],{targetPlatform:J,compatible:!0},r.CancellationToken.None);if(!R)throw new Error(E.localize(2,null));await this.Y.setUninstalled(q);try{await this.Y.removeUninstalledExtension(q)}catch(F){throw new Error(E.localize(3,null,(0,C.$ai)(F)))}return this.installFromGallery(R)}X(q,J,R,F){return this.Y.copyExtension(q,J,R,F)}copyExtensions(q,J){return this.Y.copyExtensions(q,J)}markAsUninstalled(...q){return this.Y.setUninstalled(...q)}async cleanUp(){this.y.trace("ExtensionManagementService#cleanUp");try{await this.Y.cleanUp()}catch(q){this.y.error(q)}}async download(q,J,R){const{location:F}=await this.$.download(q,J,!R);return F}async hb(q){if(q.scheme===k.Schemas.file)return{location:q,async cleanup(){}};this.y.trace("Downloading extension from",q.toString());const J=(0,l.$9f)(this.$.extensionsDownloadDir,(0,u.$3e)());return await this.db.download(q,J),this.y.info("Downloaded extension to",J.toString()),{location:J,cleanup:async()=>{try{await this.eb.del(J)}catch(F){this.y.error(F)}}}}S(){return this.C.defaultProfile.extensionsResource}U(q,J,R){if(c.URI.isUri(J))return new te(q,J,R,this.u,this.Y,this.w,this.C,this.bb,this.cb,this.y);const F=i.$io.create(J).toString();let W=this.ab.get(F);return W||(this.ab.set(F,W=new H(q,J,R,this.$,this.Y,this.w,this.C,this.bb,this.cb,this.y)),W.waitUntilTaskIsFinished().finally(()=>this.ab.delete(F))),W}W(q,J){return new me(q,J.profileLocation,this.cb)}async lb(q){const J=async F=>{let W=await h.Promises.readdir(F);W=W.map(_=>p.$8c(F,_));const ie=await Promise.all(W.map(_=>h.Promises.stat(_)));let re=Promise.resolve([]);return ie.forEach((_,oe)=>{const N=W[oe];_.isFile()&&(re=re.then(B=>[...B,N])),_.isDirectory()&&(re=re.then(B=>J(N).then(U=>[...B,...U])))}),re};return(await J(q.location.fsPath)).map(F=>({path:`extension/${p.$0c(q.location.fsPath,F)}`,localPath:F}))}async mb({added:q,removed:J}){if(J)for(const R of J.extensions)this.y.info("Extensions removed from another source",R.id,J.profileLocation.toString()),this.p.fire({identifier:R,profileLocation:J.profileLocation});if(q){const F=(await this.Y.scanExtensions(1,q.profileLocation)).filter(W=>q.extensions.some(ie=>(0,i.$ho)(ie,W.identifier)));this.m.fire(F.map(W=>(this.y.info("Extensions added from another source",W.identifier.id,q.profileLocation.toString()),{identifier:W.identifier,local:W,profileLocation:q.profileLocation,operation:1})))}}async ob(){this.B(this.Y.onExtract(J=>this.nb.add(J)));const q=await this.eb.resolve(this.bb.userExtensionsLocation);for(const J of q.children??[])J.isDirectory&&this.nb.add(J.resource);this.B(this.eb.watch(this.bb.userExtensionsLocation)),this.B(this.eb.onDidFilesChange(J=>this.pb(J)))}async pb(q){if(!q.affects(this.bb.userExtensionsLocation,1))return;const J=[];for(const R of q.rawAdded){if(this.nb.has(R)||!this.w.extUri.isEqual(this.w.extUri.dirname(R),this.bb.userExtensionsLocation)||this.w.extUri.isEqual(R,this.w.extUri.joinPath(this.bb.userExtensionsLocation,".obsolete"))||this.w.extUri.basename(R).startsWith(".")||!(await this.eb.stat(R)).isDirectory)continue;const F=await this.Y.scanUserExtensionAtLocation(R);F&&F.installedTimestamp===void 0&&(this.nb.add(R),J.push(F))}J.length&&(await this.qb(J.map(R=>[R,void 0]),this.C.defaultProfile.extensionsResource),this.y.info("Added extensions to default profile from external source",J.map(R=>R.identifier.id)))}async qb(q,J){const R=q.map(F=>F[0]);await this.rb(R),await this.cb.addExtensionsToProfile(q,J),this.m.fire(R.map(F=>({local:F,identifier:F.identifier,operation:1,profileLocation:J})))}async rb(q){const J=await this.Y.getUninstalledExtensions();for(const R of q){const F=i.$io.create(R);J[F.toString()]&&(this.y.trace("Removing the extension from uninstalled list:",F.id),await this.Y.setInstalled(F),this.y.info("Removed the extension from uninstalled list:",F.id))}}};e.$qp=se,e.$qp=se=Le([Ie(0,a.$Rn),Ie(1,ue.$Vk),Ie(2,Y.$Ri),Ie(3,t.$xh),Ie(4,o.$fp),Ie(5,n.$bp),Ie(6,v.$vn),Ie(7,le.$oh),Ie(8,Q.$Sj),Ie(9,ee.$0i),Ie(10,X.$pk),Ie(11,he.$rk)],se);let V=class extends $.$lb{constructor(q,J,R,F,W,ie){super(),this.j=q,this.k=J,this.l=R,this.m=F,this.n=W,this.p=ie,this.h=this.B(new P.$ec),this.onExtract=this.h.event,this.c=(0,l.$9f)(this.l.userExtensionsLocation,".obsolete"),this.g=new D.$Bg}async cleanUp(){await this.C(),await this.z()}async scanExtensions(q,J){const R={includeInvalid:!0,profileLocation:J};let F=[];return q===null||q===0?F.push(...await this.l.scanAllExtensions({includeInvalid:!0},R,!1)):q===1&&F.push(...await this.l.scanUserExtensions(R)),F=q!==null?F.filter(W=>W.type===q):F,Promise.all(F.map(W=>this.y(W)))}async scanAllUserExtensions(q){const J=await this.l.scanUserExtensions({includeAllVersions:!q,includeInvalid:!0});return Promise.all(J.map(R=>this.y(R)))}async scanUserExtensionAtLocation(q){try{const J=await this.l.scanExistingExtension(q,1,{includeInvalid:!0});if(J)return await this.y(J)}catch(J){this.p.error(J)}return null}async extractUserExtension(q,J,R,F,W){const ie=q.toString(),re=c.URI.file(p.$8c(this.l.userExtensionsLocation.fsPath,`.${(0,u.$3e)()}`)),_=c.URI.file(p.$8c(this.l.userExtensionsLocation.fsPath,ie));let oe=await this.k.exists(_);if(oe&&F){try{await this.t(q.id,_,"removeExisting")}catch{throw new a.$Sn(E.localize(4,null,_.fsPath,q.id),a.ExtensionManagementErrorCode.Delete)}oe=!1}if(!oe)try{try{this.p.trace(`Started extracting the extension from ${J} to ${_.fsPath}`),await(0,g.$7o)(J,re.fsPath,{sourcePath:"extension",overwrite:!0},W),this.p.info(`Extracted extension to ${_}:`,q.id)}catch(N){let B=a.ExtensionManagementErrorCode.Extract;throw N instanceof g.$5o&&(N.type==="CorruptZip"?B=a.ExtensionManagementErrorCode.CorruptZip:N.type==="Incomplete"&&(B=a.ExtensionManagementErrorCode.IncompleteZip)),new a.$Sn(N.message,B)}await this.l.updateMetadata(re,R);try{this.p.trace(`Started renaming the extension from ${re.fsPath} to ${_.fsPath}`),await this.v(re.fsPath,_.fsPath),this.p.info("Renamed to",_.fsPath)}catch(N){if(N.code==="ENOTEMPTY")this.p.info("Rename failed because extension was installed by another source. So ignoring renaming.",q.id);else throw this.p.info(`Rename failed because of ${(0,I.$9)(N)}. Deleted from extracted location`,re),N}this.h.fire(_)}catch(N){try{await this.k.del(re,{recursive:!0})}catch{}throw N}return this.w(_,1)}async scanMetadata(q,J){return J?(await this.s(q,J))?.metadata:this.l.scanMetadata(q.location)}async s(q,J){return(await this.m.scanProfileExtensions(J)).find(F=>(0,i.$ho)(F.identifier,q.identifier))}async updateMetadata(q,J,R){return R?await this.m.updateMetadata([[q,J]],R):await this.l.updateMetadata(q.location,J),this.w(q.location,q.type,R)}getUninstalledExtensions(){return this.u()}async setUninstalled(...q){const J=q.map(R=>i.$io.create(R));await this.u(R=>J.forEach(F=>{R[F.toString()]=!0,this.p.info("Marked extension as uninstalled",F.toString())}))}async setInstalled(q){await this.u(J=>delete J[q.toString()])}async removeExtension(q,J){if(this.n.extUri.isEqualOrParent(q.location,this.l.userExtensionsLocation))return this.t(q.identifier.id,q.location,J)}async removeUninstalledExtension(q){await this.removeExtension(q,"uninstalled"),await this.u(J=>delete J[i.$io.create(q).toString()])}async copyExtension(q,J,R,F){const W=await this.s(q,J),ie=await this.s(q,R);return F={...W?.metadata,...F},ie?await this.m.updateMetadata([[q,{...ie.metadata,...F}]],R):await this.m.addExtensionsToProfile([[q,F]],R),this.w(q.location,q.type,R)}async copyExtensions(q,J){const R=await this.scanExtensions(1,q),F=await Promise.all(R.filter(W=>!W.isApplicationScoped).map(async W=>[W,await this.scanMetadata(W,q)]));await this.m.addExtensionsToProfile(F,J)}async t(q,J,R){this.p.trace(`Deleting ${R} extension from disk`,q,J.fsPath);const F=this.n.extUri.joinPath(this.n.extUri.dirname(J),`${this.n.extUri.basename(J)}.${(0,w.$di)((0,u.$3e)()).toString(16)}${x}`);await this.v(J.fsPath,F.fsPath),await this.k.del(F,{recursive:!0}),this.p.info(`Deleted ${R} extension from disk`,q,J.fsPath)}async u(q){return this.g.queue(async()=>{let J;try{J=(await this.k.readFile(this.c,"utf8")).value.toString()}catch(F){if((0,Q.$9j)(F)!==1)throw F}let R={};if(J)try{R=JSON.parse(J)}catch{}return q&&(q(R),Object.keys(R).length?await this.k.writeFile(this.c,O.$Ec.fromString(JSON.stringify(R))):await this.k.del(this.c)),R})}async v(q,J){try{await h.Promises.rename(q,J,2*60*1e3)}catch(R){throw new a.$Sn(R.message||E.localize(5,null,q,J),R.code||a.ExtensionManagementErrorCode.Rename)}}async w(q,J,R){if(R){const W=(await this.l.scanUserExtensions({profileLocation:R})).find(ie=>this.n.extUri.isEqual(ie.location,q));if(W)return this.y(W)}else{const F=await this.l.scanExistingExtension(q,J,{includeInvalid:!0});if(F)return this.y(F)}throw new Error(E.localize(6,null,q.path))}async y(q){const J=await this.k.resolve(q.location);let R,F;return J.children&&(R=J.children.find(({name:W})=>/^readme(\.txt|\.md|)$/i.test(W))?.resource,F=J.children.find(({name:W})=>/^changelog(\.txt|\.md|)$/i.test(W))?.resource),{identifier:q.identifier,type:q.type,isBuiltin:q.isBuiltin||!!q.metadata?.isBuiltin,location:q.location,manifest:q.manifest,targetPlatform:q.targetPlatform,validations:q.validations,isValid:q.isValid,readmeUrl:R,changelogUrl:F,publisherDisplayName:q.metadata?.publisherDisplayName||null,publisherId:q.metadata?.publisherId||null,isApplicationScoped:!!q.metadata?.isApplicationScoped,isMachineScoped:!!q.metadata?.isMachineScoped,isPreReleaseVersion:!!q.metadata?.isPreReleaseVersion,preRelease:!!q.metadata?.preRelease,installedTimestamp:q.metadata?.installedTimestamp,updated:!!q.metadata?.updated,pinned:!!q.metadata?.pinned}}async z(){const q=await this.getUninstalledExtensions();if(Object.keys(q).length===0){this.p.debug("No uninstalled extensions found.");return}this.p.debug("Removing uninstalled extensions:",Object.keys(q));const J=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),R=new Set;for(const W of J)q[i.$io.create(W).toString()]||R.add(W.identifier.id.toLowerCase());try{const W=(0,i.$no)(J,ie=>ie.identifier);await D.Promises.settled(W.map(async ie=>{const re=ie.sort((_,oe)=>d.rcompare(_.manifest.version,oe.manifest.version))[0];R.has(re.identifier.id.toLowerCase())||await this.j(await this.y(re))}))}catch(W){this.p.error(W)}const F=J.filter(W=>W.metadata&&q[i.$io.create(W).toString()]);await Promise.allSettled(F.map(W=>this.removeUninstalledExtension(W)))}async C(){this.p.trace("ExtensionManagementService#removeTempDeleteFolders");let q;try{q=await this.k.resolve(this.l.userExtensionsLocation)}catch(J){(0,Q.$9j)(J)!==1&&this.p.error(J);return}if(q?.children)try{await Promise.allSettled(q.children.map(async J=>{if(!(!J.isDirectory||!J.name.endsWith(x))){this.p.trace("Deleting the temporarily deleted folder",J.resource.toString());try{await this.k.del(J.resource,{recursive:!0}),this.p.trace("Deleted the temporarily deleted folder",J.resource.toString())}catch(R){(0,Q.$9j)(R)!==1&&this.p.error(R)}}}))}catch{}}};e.$rp=V,e.$rp=V=Le([Ie(1,Q.$Sj),Ie(2,o.$fp),Ie(3,n.$bp),Ie(4,X.$pk),Ie(5,Y.$Ri)],V);class K extends s.$_o{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,m.$pe)(this.options.operation)?this.l:this.options.operation}constructor(q,J,R,F,W,ie,re,_,oe){super(),this.identifier=q,this.source=J,this.options=R,this.m=F,this.n=W,this.o=ie,this.p=re,this.q=_,this.s=oe,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(q){const[J,R]=await this.x(q);return this.j=J.isBuiltin||J.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[J,R]],this.j),J}async u({zipPath:q,key:J,metadata:R},F,W){let ie=await this.v(J);return ie||(this.s.trace("Extracting extension...",J.id),ie=await this.m.extractUserExtension(J,q,R,F,W),this.s.info("Extracting extension completed.",J.id)),ie}async v(q){return await this.w(q)?(this.s.trace("Removing the extension from uninstalled list:",q.id),await this.m.setInstalled(q),this.s.info("Removed the extension from uninstalled list:",q.id),(await this.m.scanAllUserExtensions(!0)).find(F=>i.$io.create(F).equals(q))):void 0}async w(q){return!!(await this.m.getUninstalledExtensions())[q.toString()]}}class H extends K{constructor(q,J,R,F,W,ie,re,_,oe,N){super(J.identifier,J,R,W,ie,re,_,oe,N),this.y=J,this.z=F}async x(q){const R=(await this.m.scanExtensions(null,this.options.profileLocation)).find(re=>(0,i.$ho)(re.identifier,this.y.identifier));R&&(this.l=3);const F={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||R?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||R?.isMachineScoped,isBuiltin:this.options.isBuiltin||R?.isBuiltin,isSystem:R?.type===0?!0:void 0,updated:!!R,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,m.$oe)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:R?.preRelease)};if(R?.manifest.version===this.y.version)return[await this.m.updateMetadata(R,F),F];const{location:W,verificationStatus:ie}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=ie,this.B(W.fsPath),[await this.u({zipPath:W.fsPath,key:i.$io.create(this.y),metadata:F},!1,q),F]}catch(re){try{await this.z.delete(W)}catch(_){this.s.warn("Error while deleting the downloaded file",W.toString(),(0,I.$9)(_))}throw re}}async B(q){try{await(0,y.$mp)(q)}catch(J){throw new a.$Sn((0,s.$0o)(J).message,a.ExtensionManagementErrorCode.Invalid)}}}e.$sp=H;class te extends K{constructor(q,J,R,F,W,ie,re,_,oe,N){super({id:(0,i.$mo)(q.publisher,q.name)},J,R,W,ie,re,_,oe,N),this.y=q,this.z=J,this.A=F}async h(q){const J=await super.h(q);return this.D(J,q),J}async x(q){const J=new i.$io(this.identifier,this.y.version),F=(await this.m.scanExtensions(1,this.options.profileLocation)).find(re=>(0,i.$ho)(this.identifier,re.identifier)),W={isApplicationScoped:this.options.isApplicationScoped||F?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||F?.isMachineScoped,isBuiltin:this.options.isBuiltin||F?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(F)if(this.l=3,J.equals(new i.$io(F.identifier,F.manifest.version)))try{await this.m.removeExtension(F,"existing")}catch{throw new Error(E.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&d.gt(F.manifest.version,this.y.version)&&await this.m.setUninstalled(F);else{const re=await this.v(J);if(re)try{await this.m.removeExtension(re,"existing")}catch{throw new Error(E.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:p.$9c(this.z.fsPath),key:J,metadata:W},!0,q),W]}async D(q,J){try{let[R]=await this.A.getExtensions([{id:q.identifier.id,version:q.manifest.version}],J);if(R||([R]=await this.A.getExtensions([{id:q.identifier.id}],J)),R){const F={id:R.identifier.uuid,publisherDisplayName:R.publisherDisplayName,publisherId:R.publisherId,isPreReleaseVersion:R.properties.isPreReleaseVersion,preRelease:R.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(q,F,this.options.profileLocation)}}catch{}}}class me extends s.$_o{constructor(q,J,R){super(),this.extension=q,this.j=J,this.k=R}async h(q){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(pe[72],be([1,0,87,77,29,285,15,11,5,2,7,3,23,43,107]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=void 0;class m{traceSocketEvent(S,L){d.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,S,L)}constructor(S,L=""){this.f=!0,this.debugLabel=L,this.socket=S,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,P.$Y)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(S){const L=j=>{this.traceSocketEvent("read",j),S(I.$Ec.wrap(j))};return this.socket.on("data",L),{dispose:()=>this.socket.off("data",L)}}onClose(S){const L=j=>{S({type:0,hadError:j,error:void 0})};return this.socket.on("close",L),{dispose:()=>this.socket.off("close",L)}}onEnd(S){const L=()=>{S()};return this.socket.on("end",L),{dispose:()=>this.socket.off("end",L)}}write(S){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",S),this.socket.write(S.buffer,L=>{if(L){if(L.code==="EPIPE")return;(0,P.$Y)(L)}})}catch(L){if(L.code==="EPIPE")return;(0,P.$Y)(L)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((S,L)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),S();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),S()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$eh=m;var c;(function(y){y[y.MinHeaderByteSize=2]="MinHeaderByteSize",y[y.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(c||(c={}));var u;(function(y){y[y.PeekHeader=1]="PeekHeader",y[y.ReadHeader=2]="ReadHeader",y[y.ReadBody=3]="ReadBody",y[y.Fin=4]="Fin"})(u||(u={}));class h extends $.$lb{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(S,L){this.socket.traceSocketEvent(S,L)}constructor(S,L,j,Q){super(),this.f=this.B(new w.$ec),this.g=this.B(new w.$ec),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=S,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:L,inflateBytesLength:j?.byteLength||0,recordInflateBytes:Q}),this.a=this.B(new g(this,L,j,Q,this.f,(le,Y)=>this.k(le,Y))),this.B(this.a.onError(le=>{console.error(le),(0,P.$Y)(le),this.g.fire({type:0,hadError:!0,error:le})})),this.b=new d.$_g,this.B(this.socket.onData(le=>this.l(le))),this.B(this.socket.onClose(async le=>{this.a.isProcessingReadQueue()&&await w.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(le)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(S){return this.f.event(S)}onClose(S){return this.g.event(S)}onEnd(S){return this.socket.onEnd(S)}write(S){let L=0;for(;L<S.byteLength;)this.a.writeMessage(S.slice(L,Math.min(L+262144,S.byteLength))),L+=262144}k(S,L){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",S);let j=2;S.byteLength<126?j+=0:S.byteLength<2**16?j+=2:j+=8;const Q=I.$Ec.alloc(j);if(L?Q.writeUInt8(194,0):Q.writeUInt8(130,0),S.byteLength<126)Q.writeUInt8(S.byteLength,1);else if(S.byteLength<2**16){Q.writeUInt8(126,1);let le=1;Q.writeUInt8(S.byteLength>>>8&255,++le),Q.writeUInt8(S.byteLength>>>0&255,++le)}else{Q.writeUInt8(127,1);let le=1;Q.writeUInt8(0,++le),Q.writeUInt8(0,++le),Q.writeUInt8(0,++le),Q.writeUInt8(0,++le),Q.writeUInt8(S.byteLength>>>24&255,++le),Q.writeUInt8(S.byteLength>>>16&255,++le),Q.writeUInt8(S.byteLength>>>8&255,++le),Q.writeUInt8(S.byteLength>>>0&255,++le)}this.socket.write(I.$Ec.concat([Q,S]))}end(){this.h=!0,this.socket.end()}l(S){if(S.byteLength!==0){for(this.b.acceptChunk(S);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const L=this.b.peek(this.j.readLen),j=L.readUInt8(0),Q=(j&128)>>>7,le=(j&64)>>>6,Y=L.readUInt8(1),ee=(Y&128)>>>7,ue=Y&127;this.j.state=2,this.j.readLen=2+(ee?4:0)+(ue===126?2:0)+(ue===127?8:0),this.j.fin=Q,this.j.firstFrameOfMessage&&(this.j.compressed=!!le),this.j.firstFrameOfMessage=!!Q,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const L=this.b.read(this.j.readLen),j=L.readUInt8(1),Q=(j&128)>>>7;let le=j&127,Y=1;le===126?le=L.readUInt8(++Y)*2**8+L.readUInt8(++Y):le===127&&(le=L.readUInt8(++Y)*0+L.readUInt8(++Y)*0+L.readUInt8(++Y)*0+L.readUInt8(++Y)*0+L.readUInt8(++Y)*2**24+L.readUInt8(++Y)*2**16+L.readUInt8(++Y)*2**8+L.readUInt8(++Y));let ee=0;Q&&(ee=L.readUInt8(++Y)*2**24+L.readUInt8(++Y)*2**16+L.readUInt8(++Y)*2**8+L.readUInt8(++Y)),this.j.state=3,this.j.readLen=le,this.j.mask=ee,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const L=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",L),t(L,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",L),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(L,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await w.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$fh=h;class g extends $.$lb{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:I.$Ec.alloc(0)}constructor(S,L,j,Q,le,Y){super(),this.l=S,this.m=le,this.n=Y,this.a=this.B(new w.$ec),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new w.$ec),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new w.$ec),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,L?(this.b=this.B(new E(this.l,Q,j,{windowBits:15})),this.f=this.B(new v(this.l,{windowBits:15})),this.B(this.b.onError(ee=>this.a.fire(ee))),this.B(this.f.onError(ee=>this.a.fire(ee)))):(this.b=null,this.f=null)}writeMessage(S){this.g.push(S),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const S=this.g.shift();if(this.f){const L=await this.s(this.f,S);this.n(L,!0)}else this.n(S,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(S,L){return new Promise((j,Q)=>{S.write(L),S.flush(le=>j(le))})}acceptFrame(S,L,j){this.h.push({data:S,isCompressed:L,isLastFrameOfMessage:j}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const S=this.h.shift();if(this.b&&S.isCompressed){const L=await this.w(this.b,S.data,S.isLastFrameOfMessage);this.m.fire(L)}else this.m.fire(S.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(S,L,j){return new Promise((Q,le)=>{S.write(L),j&&S.write(I.$Ec.fromByteArray([0,0,255,255])),S.flush(Y=>Q(Y))})}}class E extends $.$lb{get recordedInflateBytes(){return this.j?I.$Ec.concat(this.f):I.$Ec.alloc(0)}constructor(S,L,j,Q){super(),this.h=S,this.j=L,this.a=this.B(new w.$ec),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,C.createInflateRaw)(Q),this.b.on("error",le=>{this.h.traceSocketEvent("zlibInflateError",{message:le?.message,code:le?.code}),this.a.fire(le)}),this.b.on("data",le=>{this.h.traceSocketEvent("zlibInflateData",le),this.g.push(I.$Ec.wrap(le))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(S){this.j&&this.f.push(S.clone()),this.h.traceSocketEvent("zlibInflateWrite",S),this.b.write(S.buffer)}flush(S){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const L=I.$Ec.concat(this.g);this.g.length=0,S(L)})}}class v extends $.$lb{constructor(S,L){super(),this.g=S,this.a=this.B(new w.$ec),this.onError=this.a.event,this.f=[],this.b=(0,C.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(I.$Ec.wrap(j))})}write(S){this.g.traceSocketEvent("zlibDeflateWrite",S.buffer),this.b.write(S.buffer)}flush(S){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let L=I.$Ec.concat(this.f);this.f.length=0,L=L.slice(0,L.byteLength-4),S(L)})}}function t(y,S){if(S===0)return;const L=y.byteLength>>>2;for(let ue=0;ue<L;ue++){const X=y.readUInt32BE(ue*4);y.writeUInt32BE(X^S,ue*4)}const j=L*4,Q=y.byteLength-j,le=S>>>24&255,Y=S>>>16&255,ee=S>>>8&255;Q>=1&&y.writeUInt8(y.readUInt8(j)^le,j),Q>=2&&y.writeUInt8(y.readUInt8(j+1)^Y,j+1),Q>=3&&y.writeUInt8(y.readUInt8(j+2)^ee,j+2)}e.$gh=process.env.XDG_RUNTIME_DIR;const s={[2]:107,[1]:103};function a(){const y=(0,p.$3e)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${y}-sock`;const S=process.platform!=="darwin"&&e.$gh?e.$gh:(0,r.tmpdir)(),L=(0,A.$8c)(S,`vscode-ipc-${y}.sock`);return n(L),L}e.$hh=a;function i(y,S,L){const j=(0,D.createHash)("md5").update(y).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${j}-${L}-${S}-sock`;const Q=L.substr(0,4),le=S.substr(0,6),Y=j.substr(0,8);let ee;return process.platform!=="darwin"&&e.$gh&&!process.env.VSCODE_PORTABLE?ee=(0,A.$8c)(e.$gh,`vscode-${Y}-${Q}-${le}.sock`):ee=(0,A.$8c)(y,`${Q}-${le}.sock`),n(ee),ee}e.$ih=i;function n(y){const S=s[k.$t];typeof S=="number"&&y.length>=S&&console.warn(`WARNING: IPC handle "${y}" is longer than ${S} chars, try a shorter --user-data-dir`)}class o extends l.$6g{static b(S){const L=w.Event.fromNodeEventEmitter(S,"connection");return w.Event.map(L,j=>({protocol:new d.$ah(new m(j,"ipc-server-connection")),onDidClientDisconnect:w.Event.once(w.Event.fromNodeEventEmitter(j,"close"))}))}constructor(S){super(o.b(S)),this.d=S}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$jh=o;function f(y){return new Promise((S,L)=>{const j=(0,O.createServer)();j.on("error",L),j.listen(y,()=>{j.removeListener("error",L),S(new o(j))})})}e.$kh=f;function b(y,S){return new Promise((L,j)=>{const Q=(0,O.createConnection)(y,()=>{Q.removeListener("error",j),L(d.$bh.fromSocket(new m(Q,`ipc-client${S}`),S))});Q.once("error",j)})}e.$lh=b}),define(pe[140],be([1,0,85,14,15,11,10,24,25,86,12,44,235,285]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=e.$Fq=void 0;let d=class extends k.$Bo{constructor(h,g,E,v){super(v),this.j=h,this.k=g,this.l=E,this.m(),this.B(h.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.m()}))}m(){const h=this.j.getValue("http");this.f=h?.proxy,this.g=!!h?.proxyStrictSSL,this.h=h?.proxyAuthorization}async request(h,g){const{f:E,g:v}=this;let t;try{t=await(0,$.$zl)(this.j,this.l,this.k.args,process.env)}catch(i){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,C.$9)(i)))}const s={...process.env,...t},a=h.agent?h.agent:await(0,p.$Eq)(h.url||"",s,{proxyUrl:E,strictSSL:v});return h.agent=a,h.strictSSL=v,this.h&&(h.headers={...h.headers||{},"Proxy-Authorization":this.h}),this.c(h.isChromiumNetwork?"electron":"node",h,()=>c(h,g))}async resolveProxy(h){}};e.$Fq=d,e.$Fq=d=Le([Ie(0,P.$Vh),Ie(1,w.$xh),Ie(2,A.$Ri),Ie(3,A.$Si)],d);async function m(u){return((0,D.parse)(u.url).protocol==="https:"?await new Promise((E,v)=>{ce(["https"],E,v)}):await new Promise((E,v)=>{ce(["http"],E,v)})).request}async function c(u,h){return O.Promises.withAsyncBody(async(g,E)=>{const v=(0,D.parse)(u.url),t=u.getRawRequest?u.getRawRequest(u):await m(u),s={hostname:v.hostname,port:v.port?parseInt(v.port):v.protocol==="https:"?443:80,protocol:v.protocol,path:v.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,I.$oe)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(s.auth=u.user+":"+u.password);const a=t(s,i=>{const n=(0,I.$me)(u.followRedirects)?u.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)c({...u,url:i.headers.location,followRedirects:n-1},h).then(g,E);else{let o=i;!u.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,l.createGunzip)())),g({res:i,stream:(0,r.$Tc)(o)})}});a.on("error",E),u.timeout&&a.setTimeout(u.timeout),u.isChromiumNetwork&&a.removeHeader("Content-Length"),u.data&&typeof u.data=="string"&&a.write(u.data),a.end(),h.onCancellationRequested(()=>{a.abort(),E(new C.$3)})})}e.$Gq=c}),define(pe[141],be([1,0,52,77,129,13,7,15,5,72,86,12,46,3,63,128,2,275,24]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l,d,m,c,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gm=e.$fm=void 0;async function g(i={},n,o,f,b,y){const S=await(0,r.$6k)(o,f.userDataPath);let L={};if(n)try{L=await(0,A.$zl)(y,b,f.args,process.env)}catch(ue){b.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",ue)}const Q={...process.env,...L,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(S,void 0,0),...i},le=f.isBuilt?(0,I.$8c)(f.appRoot,"bin"):(0,I.$8c)(f.appRoot,"resources","server","bin-dev"),Y=(0,I.$8c)(le,"remote-cli");let ee=t(Q,"PATH");return ee?ee=Y+I.$fd+ee:ee=Y,s(Q,"PATH",ee),f.args["without-browser-env-var"]||(Q.BROWSER=(0,I.$8c)(le,"helpers",l.$i?"browser.cmd":"browser.sh")),a(Q),Q}e.$fm=g;class E{constructor(n,o){this.socket=n,this.initialDataChunk=o}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let n,o,f;return this.socket instanceof $.$eh?(n=!0,o=!1,f=P.$Ec.alloc(0)):(n=!1,o=this.socket.permessageDeflate,f=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:n,permessageDeflate:o,inflateBytes:f.buffer.toString("base64")}}}let v=class{constructor(n,o,f,b,y,S,L,j){this.i=n,this.j=y,this.l=S,this.m=L,this.n=j,this.b=new w.$ec,this.onClose=this.b.event,this.c=!l.$i||!this.j.args["socket-path"],this.d=!1,this.f=o,this.g=null,this.h=new E(f,b),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(n){this.l.info(`${this.o}${n}`)}q(n){this.l.error(`${this.o}${n}`)}async r(n,o){const f=new c.$kb;f.add(o.socket),f.add((0,c.$jb)(()=>{n.destroy()}));const b=()=>{f.dispose()};f.add(o.socket.onEnd(b)),f.add(o.socket.onClose(b)),f.add(w.Event.fromNodeEventEmitter(n,"end")(b)),f.add(w.Event.fromNodeEventEmitter(n,"close")(b)),f.add(w.Event.fromNodeEventEmitter(n,"error")(b)),f.add(o.socket.onData(y=>n.write(y.buffer))),f.add(w.Event.fromNodeEventEmitter(n,"data")(y=>{o.socket.write(P.$Ec.wrap(y))})),o.initialDataChunk.byteLength>0&&n.write(o.initialDataChunk.buffer)}async s(n,o){await o.socketDrain();const f=o.toIExtHostSocketMessage();let b;o.socket instanceof $.$eh?b=o.socket.socket:b=o.socket.socket.socket,n.send(f,b)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const n={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(n)}acceptReconnection(n,o,f){this.f=n,this.p("The client has reconnected.");const b=new E(o,f);if(!this.g){this.h=b;return}this.s(this.g,b)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(n){try{let o=process.execArgv?process.execArgv.filter(Y=>!/^--inspect(-brk)?=/.test(Y)):[];n.port&&!process.pkg&&(o=[`--inspect${n.break?"-brk":""}=${n.port}`]);const f=await g(n.env,!0,n.language,this.j,this.l,this.n);(0,d.$gl)(f);let b;if(this.c)(0,u.$dm)(new u.$bm,f),b=null;else{const{namedPipeServer:Y,pipeName:ee}=await this.u();(0,u.$dm)(new u.$am(ee),f),b=Y}const y={env:f,execArgv:o,silent:!0};y.execArgv.unshift("--dns-result-order=ipv4first");const S=["--type=extensionHost","--transformURIs"],L=this.j.args["use-host-proxy"];S.push(`--useHostProxy=${L?"true":"false"}`),this.g=D.fork(C.$1e.asFileUri("bootstrap-fork").fsPath,S,y);const j=this.g.pid;this.p(`<${j}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const Q=w.Event.fromNodeEventEmitter(this.g.stdout,"data"),le=w.Event.fromNodeEventEmitter(this.g.stderr,"data");if(Q(Y=>this.p(`<${j}> ${Y}`)),le(Y=>this.p(`<${j}><stderr> ${Y}`)),this.g.on("error",Y=>{this.q(`<${j}> Extension Host Process had an error`),this.l.error(Y),this.t()}),this.g.on("exit",(Y,ee)=>{this.m.setExitInfo(this.i,{code:Y,signal:ee}),this.p(`<${j}> Extension Host Process exited with code: ${Y}, signal: ${ee}.`),this.t()}),b)b.on("connection",Y=>{b.close(),this.r(Y,this.h)});else{const Y=ee=>{ee.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",Y),this.s(this.g,this.h),this.h=null)};this.g.on("message",Y)}}catch(o){console.error("ExtensionHostConnection errored"),o&&console.error(o)}}u(){return new Promise((n,o)=>{const f=(0,$.$hh)(),b=O.createServer();b.on("error",o),b.listen(f,()=>{b?.removeListener("error",o),n({pipeName:f,namedPipeServer:b})})})}};e.$gm=v,e.$gm=v=Le([Ie(4,p.$3l),Ie(5,k.$Ri),Ie(6,m.$$l),Ie(7,h.$Vh)],v);function t(i,n){const o=Object.keys(i).filter(b=>b.toLowerCase()===n.toLowerCase()),f=o.length>0?o[0]:n;return i[f]}function s(i,n,o){const f=Object.keys(i).filter(y=>y.toLowerCase()===n.toLowerCase()),b=f.length>0?f[0]:n;i[b]=o}function a(i){for(const n of Object.keys(i))i[n]===null&&delete i[n]}}),define(pe[286],be([1,0,83,12,65,117,24,44,140,36,32,31,126,139,82,111,54,2,112,68,13,16,26,46,120,84,121,11,4,7,30,233,81,34,124,64,3,57,130,33,45,69,127,125,114,115,198,287]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l,d,m,c,u,h,g,E,v,t,s,a,i,n,o,f,b,y,S,L,j,Q,le,Y,ee,ue,X,he,x,se,V,K,H,te,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class ne extends u.$lb{constructor(F,W){super(),this.a=F,this.b=W,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const F=await this.f();await F.invokeFunction(async W=>{const ie=W.get(I.$Vh),re=W.get(O.$Ri);Y.$i&&(ie.getValue("security.restrictUNCAccess")===!1?(0,me.disableUNCAccessRestrictions)():(0,me.addUNCHostToAllowlist)(ie.getValue("security.allowedUNCHosts")));try{await this.g(F.createInstance(a.$Zo,new O.$Zi(re.getLevel(),!1)))}catch(_){throw re.error(_),console.error((0,o.$9)(_)),_}})}async f(){const F=new D.$nh,W={_serviceBrand:void 0,...c.default};F.set(t.$0i,W);const ie=new s.$4l(this.a,W);F.set(s.$3l,ie);const re=new H.$YM((0,O.$6i)(ie),ie.logsHome);F.set(O.$Si,re);const _=new K.$9M(this.B(re.createLogger("remoteCLI",{name:(0,te.localize)(0,null)})));F.set(O.$Ri,_),_.trace(`Remote configuration data at ${this.b}`),_.trace("process arguments:",this.a);const oe=this.B(new h.$up(_));F.set(v.$Sj,oe),oe.registerProvider(E.Schemas.file,this.B(new g.$Tp(_)));const N=new Q.$gr(oe);F.set(j.$pk,N);const B=this.B(new se.$7M(N,ie,oe,_));F.set(X.$rk,B);const U=this.B(new C.$mn(B.defaultProfile.settingsResource,oe,new x.$Ym,_));return F.set(I.$Vh,U),await Promise.all([U.initialize(),B.init()]),F.set(P.$Ao,new r.$mh(w.$Fq)),F.set(L.$vn,new r.$mh(S.$lN)),F.set(A.$Vk,$.$6n),F.set(k.$Rn,new r.$mh(p.$Wo)),F.set(he.$bp,new r.$mh(V.$8M)),F.set(ee.$fp,new r.$mh(ue.$UM)),F.set(d.$Xo,new r.$mh(d.$Yo)),F.set(l.$pp,new r.$mh(l.$qp)),F.set(i.$zq,new r.$mh(n.$Bq)),new m.$Wp(F)}async g(F){if(this.a["list-extensions"])return F.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const W={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return F.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),W,!!this.a.force)}else{if(this.a["uninstall-extension"])return F.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["locate-extension"])return F.locateExtension(this.a["locate-extension"])}}h(F){return F.map(W=>/\.vsix$/i.test(W)?f.URI.file((0,b.$7c)(W)?W:(0,b.$8c)((0,y.cwd)(),W)):W)}}function q(R){setTimeout(()=>process.exit(R),0)}async function J(R,F,W){if(R.help){const re=c.default.serverApplicationName+(Y.$i?".cmd":"");console.log((0,le.$ol)(c.default.nameLong,re,c.default.version,W,{noInputFiles:!0,noPipe:!0}));return}if(R.version){console.log((0,le.$pl)(c.default.version,c.default.commit));return}const ie=new ne(R,F);try{await ie.run(),q(0)}catch{q(1)}finally{ie.dispose()}}e.run=J}),define(pe[288],be([1,0,72,302,28,281,4,12,90]),function(ce,e,D,O,r,C,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bM=e.$aM=void 0;class ${constructor(p,l,d){this.b=p,this.c=l,this.f=d,this.a=O.createServer((m,c)=>this.h(m,c)),this.g().catch(m=>(l.error(m),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",p=>this.c.error(p))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(p,l){const d=(c,u)=>{l.writeHead(c,{"content-type":"application/json"}),l.end(JSON.stringify(u||null),h=>h&&this.c.error(h))},m=[];p.setEncoding("utf8"),p.on("data",c=>m.push(c)),p.on("end",async()=>{try{const c=JSON.parse(m.join(""));let u;switch(c.type){case"open":u=await this.i(c);break;case"openExternal":u=await this.j(c);break;case"status":u=await this.l(c);break;case"extensionManagement":u=await this.k(c);break;default:d(404,`Unknown message type: ${c.type}`);break}d(200,u)}catch(c){const u=c instanceof Error?c.message:JSON.stringify(c);d(500,u),this.c.error("Error while processing pipe request",c)}})}async i(p){const{fileURIs:l,folderURIs:d,forceNewWindow:m,diffMode:c,mergeMode:u,addMode:h,forceReuseWindow:g,gotoLineMode:E,waitMarkerFilePath:v,remoteAuthority:t}=p,s=[];if(Array.isArray(d))for(const o of d)try{s.push({folderUri:I.URI.parse(o)})}catch{}if(Array.isArray(l))for(const o of l)try{(0,w.$Uh)(o)?s.push({workspaceUri:I.URI.parse(o)}):s.push({fileUri:I.URI.parse(o)})}catch{}const a=v?I.URI.file(v):void 0,n={forceNewWindow:m,diffMode:c,mergeMode:u,addMode:h,gotoLineMode:E,forceReuseWindow:g,preferNewWindow:!g&&!a&&!h,waitMarkerFileURI:a,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",s,n)}async j(p){for(const l of p.uris){const d=I.URI.parse(l),m=d.scheme==="file"?d:l;await this.b.executeCommand("_remoteCLI.openExternal",m)}}async k(p){const l=m=>m?.map(c=>/\.vsix$/i.test(c)?I.URI.parse(c):c),d={list:p.list,install:l(p.install),uninstall:l(p.uninstall),force:p.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",d)}async l(p){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&r.existsSync(this.f)&&r.unlinkSync(this.f)}}e.$aM=$;let A=class extends ${constructor(p,l){super(p,l,(0,D.$hh)())}};e.$bM=A,e.$bM=A=Le([Ie(0,C.$8L),Ie(1,P.$Ri)],A)}),define(pe[289],be([1,0,29,5,22,2,7,3,4,72,70,288,123,88,269,271,141]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l,d,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=void 0;class u extends m.$MM{constructor(E,v,t,s,a){super({getFolderUri:i=>{const n=v.filter(o=>o.name===i);if(n&&n.length>0)return n[0].uri},getWorkspaceFolderCount:()=>v.length,getConfigurationValue:(i,n)=>s[`config:${n}`],getExecPath:()=>E.VSCODE_EXEC_PATH,getAppRoot:()=>E.VSCODE_CWD,getFilePath:()=>{if(t)return I.$6c(t.fsPath)},getSelectedText:()=>s.selectedText,getLineNumber:()=>s.lineNumber,getExtension:async i=>{const o=(await a.getInstalled()).find(f=>f.identifier.id===i);return o&&{extensionLocation:o.location}}},void 0,Promise.resolve(D.homedir()),Promise.resolve(E))}}class h extends C.$lb{constructor(E,v,t,s,a,i){super(),this.g=E,this.h=v,this.i=t,this.j=s,this.l=a,this.m=i,this.a=0,this.b=new Map,this.c=this.B(new O.$ec),this.onExecuteCommand=this.c.event}async call(E,v,t){switch(v){case"$restartPtyHost":return this.i.restartPtyHost.apply(this.i,t);case"$createProcess":{const s=(0,A.$hr)(E.remoteAuthority);return this.n(s,t)}case"$attachToProcess":return this.i.attachToProcess.apply(this.i,t);case"$detachFromProcess":return this.i.detachFromProcess.apply(this.i,t);case"$listProcesses":return this.i.listProcesses.apply(this.i,t);case"$getLatency":return this.i.getLatency.apply(this.i,t);case"$getPerformanceMarks":return this.i.getPerformanceMarks.apply(this.i,t);case"$orphanQuestionReply":return this.i.orphanQuestionReply.apply(this.i,t);case"$acceptPtyHostResolvedVariables":return this.i.acceptPtyHostResolvedVariables.apply(this.i,t);case"$start":return this.i.start.apply(this.i,t);case"$input":return this.i.input.apply(this.i,t);case"$acknowledgeDataEvent":return this.i.acknowledgeDataEvent.apply(this.i,t);case"$shutdown":return this.i.shutdown.apply(this.i,t);case"$resize":return this.i.resize.apply(this.i,t);case"$clearBuffer":return this.i.clearBuffer.apply(this.i,t);case"$getInitialCwd":return this.i.getInitialCwd.apply(this.i,t);case"$getCwd":return this.i.getCwd.apply(this.i,t);case"$processBinary":return this.i.processBinary.apply(this.i,t);case"$sendCommandResult":return this.r(t[0],t[1],t[2]);case"$installAutoReply":return this.i.installAutoReply.apply(this.i,t);case"$uninstallAllAutoReplies":return this.i.uninstallAllAutoReplies.apply(this.i,t);case"$getDefaultSystemShell":return this.s.apply(this,t);case"$getProfiles":return this.t.apply(this,t);case"$getEnvironment":return this.u();case"$getWslPath":return this.w(t[0],t[1]);case"$getTerminalLayoutInfo":return this.i.getTerminalLayoutInfo(t);case"$setTerminalLayoutInfo":return this.i.setTerminalLayoutInfo(t);case"$serializeTerminalState":return this.i.serializeTerminalState.apply(this.i,t);case"$reviveTerminalProcesses":return this.i.reviveTerminalProcesses.apply(this.i,t);case"$getRevivedPtyNewId":return this.i.getRevivedPtyNewId.apply(this.i,t);case"$setUnicodeVersion":return this.i.setUnicodeVersion.apply(this.i,t);case"$reduceConnectionGraceTime":return this.y();case"$updateIcon":return this.i.updateIcon.apply(this.i,t);case"$updateTitle":return this.i.updateTitle.apply(this.i,t);case"$updateProperty":return this.i.updateProperty.apply(this.i,t);case"$refreshProperty":return this.i.refreshProperty.apply(this.i,t);case"$requestDetachInstance":return this.i.requestDetachInstance(t[0],t[1]);case"$acceptDetachedInstance":return this.i.acceptDetachInstanceReply(t[0],t[1]);case"$freePortKillProcess":return this.i.freePortKillProcess.apply(this.i,t);case"$acceptDetachInstanceReply":return this.i.acceptDetachInstanceReply.apply(this.i,t)}throw new Error(`IPC Command ${v} not found`)}listen(E,v,t){switch(v){case"$onPtyHostExitEvent":return this.i.onPtyHostExit||O.Event.None;case"$onPtyHostStartEvent":return this.i.onPtyHostStart||O.Event.None;case"$onPtyHostUnresponsiveEvent":return this.i.onPtyHostUnresponsive||O.Event.None;case"$onPtyHostResponsiveEvent":return this.i.onPtyHostResponsive||O.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.i.onPtyHostRequestResolveVariables||O.Event.None;case"$onProcessDataEvent":return this.i.onProcessData;case"$onProcessReadyEvent":return this.i.onProcessReady;case"$onProcessExitEvent":return this.i.onProcessExit;case"$onProcessReplayEvent":return this.i.onProcessReplay;case"$onProcessOrphanQuestion":return this.i.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.i.onDidRequestDetach||O.Event.None;case"$onDidChangeProperty":return this.i.onDidChangeProperty}throw new Error(`IPC Command ${v} not found`)}async n(E,v){const t={name:v.shellLaunchConfig.name,executable:v.shellLaunchConfig.executable,args:v.shellLaunchConfig.args,cwd:typeof v.shellLaunchConfig.cwd=="string"||typeof v.shellLaunchConfig.cwd>"u"?v.shellLaunchConfig.cwd:w.URI.revive(E.transformIncoming(v.shellLaunchConfig.cwd)),env:v.shellLaunchConfig.env,useShellEnvironment:v.shellLaunchConfig.useShellEnvironment,reconnectionProperties:v.shellLaunchConfig.reconnectionProperties,type:v.shellLaunchConfig.type,isFeatureTerminal:v.shellLaunchConfig.isFeatureTerminal},s=await(0,c.$fm)(v.resolverEnv,!!v.shellLaunchConfig.useShellEnvironment,P.$v,this.g,this.h,this.m);this.h.trace("baseEnv",s);const a=ue=>({uri:w.URI.revive(E.transformIncoming(ue.uri)),name:ue.name,index:ue.index,toResource:()=>{throw new Error("Not implemented")}}),i=v.workspaceFolders.map(a),n=v.activeWorkspaceFolder?a(v.activeWorkspaceFolder):void 0,o=v.activeFileResource?w.URI.revive(E.transformIncoming(v.activeFileResource)):void 0,f=new u(s,i,o,v.resolvedVariables,this.l),b=d.$IM(n,process.env,f),y=await d.$HM(t,D.homedir(),b,n?.uri,v.configuration["terminal.integrated.cwd"],this.h);t.cwd=y;const S=P.$i?"terminal.integrated.env.windows":P.$j?"terminal.integrated.env.osx":"terminal.integrated.env.linux",L=v.configuration[S],j=await d.$JM(t,L,b,this.j.version,v.configuration["terminal.integrated.detectLocale"],s);if(!t.strictEnv){const ue=[];for(const[se,V,K]of v.envVariableCollections)ue.push([se,{map:(0,l.$6q)(V),descriptionMap:(0,l.$7q)(K)}]);const X=new Map(ue),he=new p.$0q(X),x=n?n??void 0:void 0;await he.applyToProcessEnvironment(j,{workspaceFolder:x},b)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:t,initialCwd:y,cols:v.cols,rows:v.rows,env:j});const Q=(0,$.$hh)();j.VSCODE_IPC_HOOK_CLI=Q;const le=await this.i.createProcess(t,y,v.cols,v.rows,v.unicodeVersion,j,s,v.options,v.shouldPersistTerminal,v.workspaceId,v.workspaceName),Y={executeCommand:(ue,...X)=>this.p(le,ue,X,E)},ee=new k.$aM(Y,this.h,Q);return this.i.onProcessExit(ue=>ue.id===le&&ee.dispose()),{persistentTerminalId:le,resolvedShellLaunchConfig:t}}p(E,v,t,s){let a,i;const n=new Promise((b,y)=>{a=b,i=y}),o=++this.a;this.b.set(o,{resolve:a,reject:i,uriTransformer:s});const f=(0,r.$Km)(t,b=>{if(b&&b.$mid===1)return s.transformOutgoing(b);if(b&&b instanceof w.URI)return s.transformOutgoingURI(b)});return this.c.fire({reqId:o,persistentProcessId:E,commandId:v,commandArgs:f}),n}r(E,v,t){const s=this.b.get(E);if(!s)return;this.b.delete(E);const a=(0,r.$Km)(t,i=>{if(i&&i.$mid===1)return s.uriTransformer.transformIncoming(i)});v?s.reject(a):s.resolve(a)}s(E){return this.i.getDefaultSystemShell(E)}async t(E,v,t,s){return this.i.getProfiles(E,v,t,s)||[]}u(){return{...process.env}}w(E,v){return this.i.getWslPath(E,v)}y(){return this.i.reduceConnectionGraceTime()}}e.$NM=h}),define(pe[290],be([1,0,29,5,2,13,7,100,21,43,24,117,80,228,206,81,207,25,126,31,82,120,216,139,16,112,68,65,111,83,84,121,12,54,26,44,234,140,119,32,36,247,89,255,34,124,266,267,239,245,289,70,46,274,282,128,57,130,45,33,69,246,115,127,125,114,113,200,279,231,259,252]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l,d,m,c,u,h,g,E,v,t,s,a,i,n,o,f,b,y,S,L,j,Q,le,Y,ee,ue,X,he,x,se,V,K,H,te,me,ne,q,J,R,F,W,ie,re,_,oe,N,B,U,z,Z,de,Ee,Pe,Ae,Fe,ge,ke,ye,Te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=e.$fN=void 0;const ze="monacoworkbench";async function _e(Me,qe,Be,Ke){const He=new b.$nh,Ye=new Ze,Je={_serviceBrand:void 0,...j.default};He.set(Q.$0i,Je);const xe=new F.$4l(qe,Je);He.set(u.$wh,xe),He.set(u.$xh,xe);const nt=new Z.$YM((0,L.$6i)(xe),xe.logsHome);He.set(L.$Si,nt),Ye.registerChannel("logger",new Ae.$Sq(nt,st=>Xe(st.remoteAuthority)));const rt=nt.createLogger("remoteagent",{name:(0,Fe.localize)(0,null)}),it=new Pe.$9M(rt,[new $e((0,L.$6i)(xe))]);He.set(L.$Ri,it),setTimeout(()=>Ne(xe.logsHome.fsPath).then(null,st=>it.error(st)),1e4),it.onDidChangeLogLevel(st=>(0,L.log)(it,st,`Log level changed to ${(0,L.$7i)(it.getLevel())}`)),it.trace(`Remote configuration data at ${Be}`),it.trace("process arguments:",xe.args),Array.isArray(Je.serverGreeting)&&it.info(`

${Je.serverGreeting.join(`
`)}

`),Ye.registerChannel(d.$tn.ChannelName,new d.$tn);const Mt=new $.$0g(st=>st.clientId==="renderer"),bt=Ke.add(new i.$up(it));He.set(a.$Sj,bt),bt.registerProvider(C.Schemas.file,Ke.add(new n.$Tp(it)));const Lt=new H.$gr(bt);He.set(K.$pk,Lt);const lt=new k.$mn(xe.machineSettingsResource,bt,new U.$Ym,it);He.set(A.$Vh,lt);const wt=new de.$7M(Lt,xe,bt,it);He.set(B.$rk,wt),Ye.registerChannel("userDataProfiles",new ye.$cN(wt,st=>Xe(st.remoteAuthority)));const[,,Ot]=await Promise.all([lt.initialize(),wt.init(),(0,P.$vm)(it.error.bind(it))]),ft=new re.$_l;He.set(re.$$l,ft);const vt=new ee.$Fq(lt,xe,it,nt);He.set(le.$Ao,vt);let yt=he.$0n;const Ct=(0,he.$eo)(Je,lt);if((0,he.$_n)(Je,xe)){Je.aiConfig&&Je.aiConfig.ariaKey&&(yt=new z.$WM(vt,Ct,ze,null,Je.aiConfig.ariaKey),Ke.add((0,r.$jb)(()=>yt?.flush())));const st={appenders:[yt],commonProperties:(0,ue.$2n)((0,D.release)(),(0,D.hostname)(),process.arch,Je.commit,Je.version+"-remote",Ot,Ct,"remoteAgent"),piiPaths:(0,he.$fo)(xe)},ut=xe.args["telemetry-level"];let dt=3;ut==="all"?dt=3:ut==="error"?dt=2:ut==="crash"?dt=1:ut!==void 0&&(dt=0),He.set(q.$ur,new o.$mh(q.$sr,[st,dt]))}else He.set(q.$ur,q.$tr);He.set(g.$Rn,new o.$mh(h.$Wo));const jt=Ye.getChannel("download",Mt);He.set(m.$vn,new c.$xn(jt,()=>Xe("renderer"))),He.set(N.$bp,new o.$mh(Ee.$8M)),He.set(_.$fp,new o.$mh(oe.$UM)),He.set(E.$Xo,new o.$mh(E.$Yo)),He.set(s.$pp,new o.$mh(s.$qp));const gt=new f.$Wp(He);He.set(y.$zq,gt.createInstance(S.$Bq));const Tt=gt.createInstance(Te.$eN,{graceTime:108e5,shortGraceTime:3e5,scrollback:lt.getValue("terminal.integrated.persistentSessionScrollback")??100}),Pt=gt.createInstance(V.$cr,Tt);return He.set(se.$Nq,Pt),He.set(p.$on,new o.$mh(l.$rn)),gt.invokeFunction(st=>{const ut=st.get(s.$pp),dt=st.get(_.$fp),zt=st.get(g.$Rn),It=st.get(y.$zq),Ut=new te.$or(Me,xe,wt,ft);Ye.registerChannel("remoteextensionsenvironment",Ut);const kt=new ne.$vr(st.get(q.$ur),yt);Ye.registerChannel("telemetry",kt),Ye.registerChannel(W.$OM,new J.$NM(xe,it,Pt,Je,ut,lt));const Ft=new ge.$aN(gt.createInstance(v.$Zo,it),xe,wt,dt,it,zt,It);Ye.registerChannel(ke.$_M,new ge.$bN(Ft,G=>Xe(G.remoteAuthority)));const ve=new me.$rr(it,xe);Ye.registerChannel(ie.$SM,ve),Ye.registerChannel("request",new Y.$Cq(st.get(le.$Ao)));const Se=new t.$1o(ut,G=>Xe(G.remoteAuthority));Ye.registerChannel("extensions",Se);const fe=$.ProxyChannel.fromService(st.get(p.$on));return Ye.registerChannel("credentials",fe),Ft.whenExtensionsReady().then(()=>ut.cleanUp()),Ke.add(new x.default(st.get(X.$Vk))),{telemetryService:st.get(X.$Vk)}}),{socketServer:Ye,instantiationService:gt}}e.$fN=_e;const Ve=Object.create(null);function Xe(Me){return Ve[Me]||(Ve[Me]=(0,R.$hr)(Me)),Ve[Me]}class Ze extends $.$6g{constructor(){const qe=new O.$ec;super(qe.event),this.b=qe}acceptConnection(qe,Be){this.b.fire({protocol:qe,onDidClientDisconnect:Be})}}e.$gN=Ze;class $e extends L.$Wi{constructor(qe=L.$Ui){super(),this.setLevel(qe),this.g=!!process.stdout.isTTY}trace(qe,...Be){this.f(L.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${De()}]\x1B[0m`,qe,...Be):console.log(`[${De()}]`,qe,...Be))}debug(qe,...Be){this.f(L.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${De()}]\x1B[0m`,qe,...Be):console.log(`[${De()}]`,qe,...Be))}info(qe,...Be){this.f(L.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${De()}]\x1B[0m`,qe,...Be):console.log(`[${De()}]`,qe,...Be))}warn(qe,...Be){this.f(L.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${De()}]\x1B[0m`,qe,...Be):console.warn(`[${De()}]`,qe,...Be))}error(qe,...Be){this.f(L.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${De()}]\x1B[0m`,qe,...Be):console.error(`[${De()}]`,qe,...Be))}dispose(){}flush(){}}function De(){const Me=new Date;return`${Re(Me.getHours())}:${Re(Me.getMinutes())}:${Re(Me.getSeconds())}`}function Re(Me){return Me<10?`0${Me}`:String(Me)}async function Ne(Me){const qe=I.$_c(Me),Be=I.$$c(Me),Ye=(await w.Promises.readdir(Be)).filter(xe=>/^\d{8}T\d{6}$/.test(xe)).sort().filter(xe=>xe!==qe),Je=Ye.slice(0,Math.max(0,Ye.length-9));await Promise.all(Je.map(xe=>w.Promises.rm(I.$8c(Be,xe))))}}),define(pe[291],be([1,0,87,28,77,292,85,94,15,11,39,2,13,7,41,3,17,4,23,166,152,287,107,72,24,6,12,26,56,32,141,260,261,46,290,263]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p,l,d,m,c,u,h,g,E,v,t,s,a,i,n,o,f,b,y,S,L,j,Q,le){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=void 0;const Y=5*60*1e3;let ee=class extends k.$lb{constructor(x,se,V,K,H,te,me,ne){super(),this.k=x,this.l=se,this.m=V,this.n=H,this.p=te,this.r=me,this.s=ne,this.h=X.create(this.p),this.i=(0,f.$Dk)(te),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=K?this.s.createInstance(le.$jN,this.l):null,this.r.info("Extension host agent started."),this.F(!0)}async handleRequest(x,se){if(x.method!=="GET")return(0,le.$hN)(x,se,405,`Unsupported method ${x.method}`);if(!x.url)return(0,le.$hN)(x,se,400,"Bad request.");const V=I.parse(x.url,!0);let K=V.pathname;if(!K)return(0,le.$hN)(x,se,400,"Bad request.");if(K.startsWith(this.i)&&K.charCodeAt(this.i.length)===47&&(K=K.substring(this.i.length)),K==="/version")return se.writeHead(200,{"Content-Type":"text/plain"}),void se.end(this.p.commit||"");if(K==="/delay-shutdown")return this.H(),se.writeHead(200),void se.end("OK");if(!(0,L.$nm)(this.l,x,V))return(0,le.$hN)(x,se,403,"Forbidden.");if(K==="/vscode-remote-resource"){const H=V.query.path;if(typeof H!="string")return(0,le.$hN)(x,se,400,"Bad request.");let te;try{te=u.URI.from({scheme:p.Schemas.file,path:H}).fsPath}catch{return(0,le.$hN)(x,se,400,"Bad request.")}const me=Object.create(null);this.n.isBuilt&&((0,A.$He)(te,this.n.builtinExtensionsPath,!m.$k)||(0,A.$He)(te,this.n.extensionsPath,!m.$k))&&(me["Cache-Control"]="public, max-age=31536000"),me.Vary="Origin";const ne=x.headers.origin;return ne&&this.h.matches(ne)&&(me["Access-Control-Allow-Origin"]=ne),(0,le.$iN)(te,1,this.r,x,se,me)}if(this.g){this.g.handle(x,se,V);return}return se.writeHead(404,{"Content-Type":"text/plain"}),void se.end("Not found")}handleUpgrade(x,se){let V=(0,h.$3e)(),K=!1,H=!1;if(x.url){const R=I.parse(x.url,!0).query;typeof R.reconnectionToken=="string"&&(V=R.reconnectionToken),R.reconnection==="true"&&(K=!0),R.skipWebSocketFrames==="true"&&(H=!0)}if(x.headers.upgrade===void 0||x.headers.upgrade.toLowerCase()!=="websocket"){se.end("HTTP/1.1 400 Bad Request");return}const te=x.headers["sec-websocket-key"],me=D.createHash("sha1");me.update(te+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const q=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${me.digest("base64")}`];let J=!1;if(!H&&!this.n.args["disable-websocket-compression"]&&x.headers["sec-websocket-extensions"]){const R=Array.isArray(x.headers["sec-websocket-extensions"])?x.headers["sec-websocket-extensions"]:[x.headers["sec-websocket-extensions"]];for(const F of R)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(F)){if(/\b(permessage-deflate)\b/.test(F)){J=!0,q.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(F)){J=!0,q.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}se.write(q.join(`\r
`)+`\r
\r
`),se.setTimeout(0),se.setNoDelay(!0),H?this.v(new s.$eh(se,`server-connection-${V}`),K,V):this.v(new s.$fh(new s.$eh(se,`server-connection-${V}`),J,null,!0),K,V)}handleServerError(x){this.r.error("Error occurred in server"),this.r.error(x)}t(x){let se;return x instanceof s.$eh?se=x.socket:se=x.socket.socket,se.remoteAddress||"<unknown>"}async u(x,se,V){const K=se.getSocket();this.r.error(`${x} ${V}.`);const H={type:"error",reason:V};se.sendControl(w.$Ec.fromString(JSON.stringify(H))),se.dispose(),await K.drain(),K.dispose()}v(x,se,V){const K=this.t(x),H=`[${K}][${V.substr(0,8)}]`,te=new t.$dh({socket:x}),me=this.m?new this.m.validator:null,ne=this.m?new this.m.signer:null;let q;(function(W){W[W.WaitingForAuth=0]="WaitingForAuth",W[W.WaitingForConnectionType=1]="WaitingForConnectionType",W[W.Done=2]="Done",W[W.Error=3]="Error"})(q||(q={}));let J=0;const R=W=>{J=3,F.dispose(),this.u(H,te,W)},F=te.onControlMessage(W=>{if(J===0){let ie;try{ie=JSON.parse(W.toString())}catch{return R("Malformed first message")}if(ie.type!=="auth")return R("Invalid first message");if(this.l.type===2&&!this.l.validate(ie.auth))return R("Unauthorized client refused: auth mismatch");let re=(0,h.$3e)();if(ne)try{re=ne.sign(ie.data)}catch{}let _=(0,h.$3e)();if(me)try{_=me.createNewMessage(_)}catch{}const oe={type:"sign",data:_,signedData:re};te.sendControl(w.$Ec.fromString(JSON.stringify(oe))),J=1}else if(J===1){let ie;try{ie=JSON.parse(W.toString())}catch{return R("Malformed second message")}if(ie.type!=="connectionType")return R("Invalid second message");if(typeof ie.signedData!="string")return R("Invalid second message field type");const re=ie.commit,_=this.p.commit;if(re&&_&&re!==_)return R("Client refused: version mismatch");let oe=!1;if(!me)oe=!0;else if(this.l.validate(ie.signedData))oe=!0;else try{oe=me.validate(ie.signedData)==="ok"}catch{}if(!oe){if(this.n.isBuilt)return R("Unauthorized client refused");this.r.error(`${H} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const N in this.b)this.b[N].shortenReconnectionGraceTimeIfNecessary();for(const N in this.a)this.a[N].shortenReconnectionGraceTimeIfNecessary();J=2,F.dispose(),this.w(K,H,te,x,se,V,ie)}})}async w(x,se,V,K,H,te,me){const ne=me.desiredConnectionType===1?`${se}[ManagementConnection]`:me.desiredConnectionType===2?`${se}[ExtensionHostConnection]`:se;if(me.desiredConnectionType===1)if(H){if(!this.b[te])return this.f.has(te)?this.u(ne,V,"Unknown reconnection token (seen before)"):this.u(ne,V,"Unknown reconnection token (never seen)");V.sendControl(w.$Ec.fromString(JSON.stringify({type:"ok"})));const q=V.readEntireBuffer();V.dispose(),this.b[te].acceptReconnection(x,K,q)}else{if(this.b[te])return this.u(ne,V,"Duplicate reconnection token");V.sendControl(w.$Ec.fromString(JSON.stringify({type:"ok"})));const q=new S.$hm(this.r,te,x,V);this.k.acceptConnection(q.protocol,q.onClose),this.b[te]=q,this.f.add(te),q.onClose(()=>{delete this.b[te]})}else if(me.desiredConnectionType===2){const q=me.args||{language:"en"},J=await this.C(q);if(J.port&&this.r.trace(`${ne} - startParams debug port ${J.port}`),this.r.trace(`${ne} - startParams language: ${J.language}`),this.r.trace(`${ne} - startParams env: ${JSON.stringify(J.env)}`),H){if(!this.a[te])return this.f.has(te)?this.u(ne,V,"Unknown reconnection token (seen before)"):this.u(ne,V,"Unknown reconnection token (never seen)");V.sendPause(),V.sendControl(w.$Ec.fromString(JSON.stringify(J.port?{debugPort:J.port}:{})));const R=V.readEntireBuffer();V.dispose(),this.a[te].acceptReconnection(x,K,R)}else{if(this.a[te])return this.u(ne,V,"Duplicate reconnection token");V.sendPause(),V.sendControl(w.$Ec.fromString(JSON.stringify(J.port?{debugPort:J.port}:{})));const R=V.readEntireBuffer();V.dispose();const F=this.s.createInstance(y.$gm,te,x,K,R);this.a[te]=F,this.f.add(te),F.onClose(()=>{delete this.a[te],this.D()}),F.start(J)}}else if(me.desiredConnectionType===3){const q=me.args;this.y(V,q)}else return this.u(ne,V,"Unknown initial data received")}async y(x,se){const V=x.getSocket().socket,K=x.readEntireBuffer();x.dispose(),V.pause();const H=await this.z(se.host,se.port);K.byteLength>0&&H.write(K.buffer),H.on("end",()=>V.end()),H.on("close",()=>V.end()),H.on("error",()=>V.destroy()),V.on("end",()=>H.end()),V.on("close",()=>H.end()),V.on("error",()=>H.destroy()),H.pipe(V),V.pipe(H)}z(x,se){return new Promise((V,K)=>{const H=r.createConnection({host:x,port:se,autoSelectFamily:!0},()=>{H.removeListener("error",K),H.pause(),V(H)});H.once("error",K)})}C(x){return typeof x.port=="number"?(0,E.$5e)(x.port,10,5e3).then(se=>(x.port=se,x)):(x.debugId=void 0,x.port=void 0,x.break=void 0,Promise.resolve(x))}async D(){if(!this.n.args["enable-remote-auto-shutdown"])return;this.I(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.r.info("Last EH closed, waiting before shutting down"),this.F())}F(x=!1){this.n.args["enable-remote-auto-shutdown"]&&(this.n.args["remote-auto-shutdown-without-delay"]&&!x?this.G():this.j=setTimeout(()=>{this.j=void 0,this.G()},Y))}G(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.r.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.r.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}H(){this.j&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.r.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.I(),this.F())}I(){this.j&&(console.log("Cancelling previous shutdown timeout"),this.r.info("Cancelling previous shutdown timeout"),clearTimeout(this.j),this.j=void 0)}};ee=Le([Ie(4,j.$3l),Ie(5,o.$0i),Ie(6,n.$Ri),Ie(7,i.$oh)],ee);async function ue(he,x,se){const V=await(0,L.$mm)(x);V instanceof L.$km&&(console.warn(V.message),process.exit(1));function K(oe){(0,$.setUnexpectedErrorHandler)(N=>{(0,$.$X)(N)&&N.stack&&/unexpectedErrorHandler/.test(N.stack)||oe(N)})}const H=[];K(oe=>{H.push(oe),console.error(oe)});let te=!1;process.on("SIGPIPE",()=>{te||(te=!0,(0,$.$Y)(new Error("Unexpected SIGPIPE")))});const me=new k.$kb,{socketServer:ne,instantiationService:q}=await(0,Q.$fN)(V,x,se,me);q.invokeFunction(oe=>{const N=oe.get(n.$Ri);H.forEach(B=>N.error(B)),H.length=0,K(B=>N.error(B))}),q.invokeFunction(oe=>{const N=oe.get(a.$Vh);m.$i&&(N.getValue("security.restrictUNCAccess")===!1?(0,v.disableUNCAccessRestrictions)():(0,v.addUNCHostToAllowlist)(N.getValue("security.allowedUNCHosts")))}),q.invokeFunction(oe=>{const N=oe.get(n.$Ri);if(m.$i&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const B=(0,l.$8c)(process.env.HOMEDRIVE,"node_modules"),U=(0,l.$$c)((0,l.$8c)(process.env.HOMEDRIVE,process.env.HOMEPATH)),z=(0,l.$8c)(U,"node_modules");if(O.existsSync(B)||O.existsSync(z)){const Z=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${B}
* ${z}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;N.warn(Z),console.warn(Z),process.exit(0)}}});const J=q.invokeFunction(oe=>{const N=oe.get(n.$Ri);if(O.existsSync((0,l.$8c)(p.$1e.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(U){N.error(U)}return null}),R=O.existsSync(p.$1e.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(R&&he&&typeof he!="string"){const oe=V.type!==0?`?${p.$Ue}=${V.value}`:"";console.log(`Web UI available at http://localhost${he.port===80?"":`:${he.port}`}/${oe}`)}const F=q.createInstance(ee,ne,V,J,R);d.mark("code/server/ready");const W=C.performance.now(),ie=global.vscodeServerStartTime,re=global.vscodeServerListenTime,_=global.vscodeServerCodeLoadedTime;if(q.invokeFunction(async oe=>{const N=oe.get(b.$Vk);if(N.publicLog2("serverStart",{startTime:ie,startedTime:re,codeLoadedTime:_,readyTime:W}),m.$k){const B=oe.get(n.$Ri),U=await(0,g.$4e)(B.error.bind(B));U&&N.publicLog2("serverPlatformInfo",{platformId:U.id,platformVersionId:U.version_id,platformIdLike:U.id_like})}}),x["print-startup-performance"]){const oe=P.$S.get();let N="";N+=`

### Load AMD-module
`,N+=P.$S.toMarkdownTable(["Module","Duration"],oe.amdLoad),N+=`

### Load commonjs-module
`,N+=P.$S.toMarkdownTable(["Module","Duration"],oe.nodeRequire),N+=`

### Invoke AMD-module factory
`,N+=P.$S.toMarkdownTable(["Module","Duration"],oe.amdInvoke),N+=`

### Invoke commonjs-module
`,N+=P.$S.toMarkdownTable(["Module","Duration"],oe.nodeEval),N+=`Start-up time: ${re-ie}
`,N+=`Code loading time: ${_-ie}
`,N+=`Initialized time: ${W-ie}
`,N+=`
`,console.log(N)}return F}e.$kN=ue;class X{static create(x){const se=x.webEndpointUrlTemplate,V=x.commit,K=x.quality;if(!se||!V||!K)return new X(null);const H=(0,h.$3e)(),me=new URL(se.replace("{{uuid}}",H).replace("{{commit}}",V).replace("{{quality}}",K)).origin,ne=(0,c.$pd)(me).replace(H,"[a-zA-Z0-9\\-]+");try{const q=(0,c.$xd)(`^${ne}$`,!0,{matchCase:!1});return new X(q)}catch{return new X(null)}}constructor(x){this.a=x}matches(x){return this.a?this.a.test(x):!1}}}),define(pe[303],be([1,0,29,28,13,286,291,64,7,292,46,54,41]),function(ce,e,D,O,r,C,I,P,w,$,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,p.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=$.performance.now();const l={onMultipleValues:(i,n)=>{console.error(`Option '${i}' can only be defined once. Using value ${n}.`)},onEmptyValue:i=>{console.error(`Ignoring option '${i}': Value must not be empty.`)},onUnknownOption:i=>{console.error(`Ignoring option '${i}': not supported for server.`)},onDeprecatedOption:(i,n)=>{console.warn(`Option '${i}' is deprecated: ${n}`)}},d=(0,P.$ml)(process.argv.slice(2),A.$2l,l),m=d["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,w.$8c)(D.homedir(),k.default.serverDataFolderName||".vscode-remote"),c=(0,w.$8c)(m,"data"),u=(0,w.$8c)(c,"User"),h=(0,w.$8c)(u,"globalStorage"),g=(0,w.$8c)(u,"History"),E=(0,w.$8c)(c,"Machine");d["user-data-dir"]=c;const v=(0,w.$$c)(r.$1e.asFileUri("").fsPath),t=(0,w.$8c)(v,"extensions");d["builtin-extensions-dir"]=t,d["extensions-dir"]=d["extensions-dir"]||(0,w.$8c)(m,"extensions"),[m,d["extensions-dir"],c,u,E,h,g].forEach(i=>{try{O.existsSync(i)||O.mkdirSync(i,{mode:448})}catch(n){console.error(n)}});function s(){(0,C.run)(d,m,A.$2l)}e.spawnCli=s;function a(i){return(0,I.$kN)(i,d,m)}e.createServer=a})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/fdb98833154679dbaa7af67a5a29fe19e55c2b73/core/vs/server/node/server.main.js.map
