/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/base/common/platform","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/platform/log/common/log","vs/base/common/arrays","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/base/common/extpath","vs/workbench/api/common/extHostCommands","vs/editor/common/core/range","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/stopwatch","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/severity","vs/base/common/process","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/errorMessage","child_process","vs/platform/contextkey/common/contextkey","vs/base/common/iterator","fs","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/themables","net","vs/editor/common/core/position","os","vs/platform/remote/common/remoteHosts","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/mime","vs/base/common/processes","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/labels","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatSlashCommand","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(me){for(var e=[],S=0,F=me.length;S<F;S++)e[S]=Se[me[S]];return e};define(Se[153],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class S{static get(){const h=new Map,L=new Map,A=new Map,f=new Map;function w(k,C){k.has(C.detail)||k.set(C.detail,-C.timestamp)}function g(k,C){const E=k.get(C.detail);E&&(E>=0||k.set(C.detail,E+C.timestamp))}let P=[];typeof me=="function"&&typeof me.getStats=="function"&&(P=me.getStats().slice(0).sort((k,C)=>k.timestamp-C.timestamp));for(const k of P)switch(k.type){case 10:w(h,k);break;case 11:case 12:g(h,k);break;case 21:w(L,k);break;case 22:g(L,k);break;case 33:w(A,k);break;case 34:g(A,k);break;case 31:w(f,k);break;case 32:g(f,k);break}let I=0;A.forEach(k=>I+=k);function $(k){const C=[];return k.forEach((E,n)=>C.push([n,E])),C}return{amdLoad:$(h),amdInvoke:$(L),nodeRequire:$(A),nodeEval:$(f),nodeRequireTotal:I}}static toMarkdownTable(h,L){let A="";const f=[];return h.forEach((w,g)=>{f[g]=w.length}),L.forEach(w=>{w.forEach((g,P)=>{typeof g>"u"&&(g=w[P]="-");const I=g.toString().length;f[P]=Math.max(I,f[P])})}),h.forEach((w,g)=>{A+=`| ${w+" ".repeat(f[g]-w.toString().length)} `}),A+=`|
`,h.forEach((w,g)=>{A+=`| ${"-".repeat(f[g])} `}),A+=`|
`,L.forEach(w=>{w.forEach((g,P)=>{typeof g<"u"&&(A+=`| ${g+" ".repeat(f[P]-g.toString().length)} `)}),A+=`|
`}),A}}e.$S=S}),define(Se[69],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=void 0;function S(A,f){const w=Object.create(null);for(const g of A){const P=f(g);let I=w[P];I||(I=w[P]=[]),I.push(g)}return w}e.$I=S;function F(A,f){const w=[],g=[];for(const P of A)f.has(P)||w.push(P);for(const P of f)A.has(P)||g.push(P);return{removed:w,added:g}}e.$J=F;function h(A,f){const w=[],g=[];for(const[P,I]of A)f.has(P)||w.push(I);for(const[P,I]of f)A.has(P)||g.push(I);return{removed:w,added:g}}e.$K=h;class L{constructor(){this.a=new Map}add(f,w){let g=this.a.get(f);g||(g=new Set,this.a.set(f,g)),g.add(w)}delete(f,w){const g=this.a.get(f);g&&(g.delete(w),g.size===0&&this.a.delete(f))}forEach(f,w){const g=this.a.get(f);g&&g.forEach(w)}get(f){const w=this.a.get(f);return w||new Set}}e.$L=L}),define(Se[70],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=e.$Ug=e.$Tg=void 0;function S(A){return(f,w,g)=>{let P=null,I=null;if(typeof g.value=="function"?(P="value",I=g.value):typeof g.get=="function"&&(P="get",I=g.get),!I)throw new Error("not supported");g[P]=A(I,w)}}function F(A,f,w){let g=null,P=null;if(typeof w.value=="function"?(g="value",P=w.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(g="get",P=w.get),!P)throw new Error("not supported");const I=`$memoize$${f}`;w[g]=function(...$){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,$)}),this[I]}}e.$Tg=F;function h(A,f,w){return S((g,P)=>{const I=`$debounce$${P}`,$=`$debounce$result$${P}`;return function(...k){this[$]||(this[$]=w?w():void 0),clearTimeout(this[I]),f&&(this[$]=f(this[$],...k),k=[this[$]]),this[I]=setTimeout(()=>{g.apply(this,k),this[$]=w?w():void 0},A)}})}e.$Ug=h;function L(A,f,w){return S((g,P)=>{const I=`$throttle$timer$${P}`,$=`$throttle$result$${P}`,k=`$throttle$lastRun$${P}`,C=`$throttle$pending$${P}`;return function(...E){if(this[$]||(this[$]=w?w():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),f&&(this[$]=f(this[$],...E)),this[C])return;const n=this[k]+A;n<=Date.now()?(this[k]=Date.now(),g.apply(this,[this[$]]),this[$]=w?w():void 0):(this[C]=!0,this[I]=setTimeout(()=>{this[C]=!1,this[k]=Date.now(),g.apply(this,[this[$]]),this[$]=w?w():void 0},n-Date.now()))}})}e.$Vg=L}),define(Se[8],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class S{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?v.isErrorNoTelemetry(r)?new v(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(s=>{s(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}e.$U=S,e.$V=new S;function F(t){e.$V.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=F;function h(t){if(!t||typeof t!="object")return!1;const r=t;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}e.$X=h;function L(t){g(t)||e.$V.onUnexpectedError(t)}e.$Y=L;function A(t){g(t)||e.$V.onUnexpectedExternalError(t)}e.$Z=A;function f(t){if(t instanceof Error){const{name:r,message:s}=t,i=t.stacktrace||t.stack;return{$isError:!0,name:r,message:s,stack:i,noTelemetry:v.isErrorNoTelemetry(t)}}return t}e.$1=f;const w="Canceled";function g(t){return t instanceof P?!0:t instanceof Error&&t.name===w&&t.message===w}e.$2=g;class P extends Error{constructor(){super(w),this.name=this.message}}e.$3=P;function I(){const t=new Error(w);return t.name=t.message,t}e.$4=I;function $(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.$5=$;function k(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.$6=k;function C(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.$7=C;function E(t){const r=new Error(`${t} has been disposed`);return r.name="DISPOSED",r}e.$8=E;function n(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.$9=n;class o extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.$0=o;class a extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.$$=a;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=m;class v extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof v)return r;const s=new v;return s.message=r.message,s.stack=r.stack,s}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.$ab=v;class D extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,D.prototype)}}e.$bb=D}),define(Se[18],De([1,0,8]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.CompareResult=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.top=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=void 0;function F(K,ee=0){return K[K.length-(1+ee)]}e.$9e=F;function h(K){if(K.length===0)throw new Error("Invalid tail call");return[K.slice(0,K.length-1),K[K.length-1]]}e.$0e=h;function L(K,ee,G=(X,he)=>X===he){if(K===ee)return!0;if(!K||!ee||K.length!==ee.length)return!1;for(let X=0,he=K.length;X<he;X++)if(!G(K[X],ee[X]))return!1;return!0}e.$$e=L;function A(K,ee){const G=K.length-1;ee<G&&(K[ee]=K[G]),K.pop()}e.$_e=A;function f(K,ee,G){return w(K.length,X=>G(K[X],ee))}e.$af=f;function w(K,ee){let G=0,X=K-1;for(;G<=X;){const he=(G+X)/2|0,Ie=ee(he);if(Ie<0)G=he+1;else if(Ie>0)X=he-1;else return he}return-(G+1)}e.$bf=w;function g(K,ee){let G=0,X=K.length;if(X===0)return 0;for(;G<X;){const he=Math.floor((G+X)/2);ee(K[he])?X=he:G=he+1}return G}e.$cf=g;function P(K,ee,G){if(K=K|0,K>=ee.length)throw new TypeError("invalid index");const X=ee[Math.floor(ee.length*Math.random())],he=[],Ie=[],U=[];for(const Q of ee){const _=G(Q,X);_<0?he.push(Q):_>0?Ie.push(Q):U.push(Q)}return K<he.length?P(K,he,G):K<he.length+U.length?U[0]:P(K-(he.length+U.length),Ie,G)}e.$df=P;function I(K,ee){const G=[];let X;for(const he of K.slice(0).sort(ee))!X||ee(X[0],he)!==0?(X=[he],G.push(X)):X.push(he);return G}e.$ef=I;function $(K,ee,G){const X=[];function he(Q,_,oe){if(_===0&&oe.length===0)return;const Z=X[X.length-1];Z&&Z.start+Z.deleteCount===Q?(Z.deleteCount+=_,Z.toInsert.push(...oe)):X.push({start:Q,deleteCount:_,toInsert:oe})}let Ie=0,U=0;for(;;){if(Ie===K.length){he(Ie,0,ee.slice(U));break}if(U===ee.length){he(Ie,K.length-Ie,[]);break}const Q=K[Ie],_=ee[U],oe=G(Q,_);oe===0?(Ie+=1,U+=1):oe<0?(he(Ie,1,[]),Ie+=1):oe>0&&(he(Ie,0,[_]),U+=1)}return X}e.$ff=$;function k(K,ee,G){const X=$(K,ee,G),he=[],Ie=[];for(const U of X)he.push(...K.slice(U.start,U.start+U.deleteCount)),Ie.push(...U.toInsert);return{removed:he,added:Ie}}e.$gf=k;function C(K,ee,G){if(G===0)return[];const X=K.slice(0,G).sort(ee);return n(K,ee,X,G,K.length),X}e.top=C;function E(K,ee,G,X,he){return G===0?Promise.resolve([]):new Promise((Ie,U)=>{(async()=>{const Q=K.length,_=K.slice(0,G).sort(ee);for(let oe=G,Z=Math.min(G+X,Q);oe<Q;oe=Z,Z=Math.min(Z+X,Q)){if(oe>G&&await new Promise(le=>setTimeout(le)),he&&he.isCancellationRequested)throw new S.$3;n(K,ee,_,oe,Z)}return _})().then(Ie,U)})}e.$if=E;function n(K,ee,G,X,he){for(const Ie=G.length;X<he;X++){const U=K[X];if(ee(U,G[Ie-1])<0){G.pop();const Q=g(G,_=>ee(U,_)<0);G.splice(Q,0,U)}}}function o(K){return K.filter(ee=>!!ee)}e.$jf=o;function a(K){let ee=0;for(let G=0;G<K.length;G++)K[G]&&(K[ee]=K[G],ee+=1);K.length=ee}e.$kf=a;function m(K,ee,G){K.splice(G,0,K.splice(ee,1)[0])}e.$lf=m;function v(K){return!Array.isArray(K)||K.length===0}e.$mf=v;function D(K){return Array.isArray(K)&&K.length>0}e.$nf=D;function t(K,ee=G=>G){const G=new Set;return K.filter(X=>{const he=ee(X);return G.has(he)?!1:(G.add(he),!0)})}e.$of=t;function r(K){const ee=new Set;return G=>{const X=K(G);return ee.has(X)?!1:(ee.add(X),!0)}}e.$pf=r;function s(K,ee){const G=i(K,ee);if(G!==-1)return K[G]}e.$qf=s;function i(K,ee){for(let G=K.length-1;G>=0;G--){const X=K[G];if(ee(X))return G}return-1}e.$rf=i;function c(K,ee){return K.length>0?K[0]:ee}e.$sf=c;function l(K,ee){return K.length>0?K[K.length-1]:ee}e.$tf=l;function b(K,ee,G=(X,he)=>X===he){let X=0;for(let he=0,Ie=Math.min(K.length,ee.length);he<Ie&&G(K[he],ee[he]);he++)X++;return X}e.$uf=b;function y(K){return[].concat(...K)}e.$vf=y;function u(K,ee){let G=typeof ee=="number"?K:0;typeof ee=="number"?G=K:(G=0,ee=K);const X=[];if(G<=ee)for(let he=G;he<ee;he++)X.push(he);else for(let he=G;he>ee;he--)X.push(he);return X}e.$wf=u;function d(K,ee,G){return K.reduce((X,he)=>(X[ee(he)]=G?G(he):he,X),Object.create(null))}e.$xf=d;function p(K,ee){return K.push(ee),()=>R(K,ee)}e.$yf=p;function R(K,ee){const G=K.indexOf(ee);if(G>-1)return K.splice(G,1),ee}e.$zf=R;function O(K,ee,G){const X=K.slice(0,ee),he=K.slice(ee);return X.concat(G,he)}e.$Af=O;function j(K,ee){let G;if(typeof ee=="number"){let X=ee;G=()=>{const he=Math.sin(X++)*179426549;return he-Math.floor(he)}}else G=Math.random;for(let X=K.length-1;X>0;X-=1){const he=Math.floor(G()*(X+1)),Ie=K[X];K[X]=K[he],K[he]=Ie}}e.$Bf=j;function T(K,ee){const G=K.indexOf(ee);G>-1&&(K.splice(G,1),K.unshift(ee))}e.$Cf=T;function z(K,ee){const G=K.indexOf(ee);G>-1&&(K.splice(G,1),K.push(ee))}e.$Df=z;function B(K,ee){for(const G of ee)K.push(G)}e.$Ef=B;function M(K,ee){return Array.isArray(K)?K.map(ee):ee(K)}e.$Ff=M;function Y(K){return Array.isArray(K)?K:[K]}e.$Gf=Y;function J(K){return K[Math.floor(Math.random()*K.length)]}e.$Hf=J;function fe(K,ee){for(const G of K){const X=ee(G);if(X!==void 0)return X}}e.$If=fe;function se(K,ee,G){const X=V(K,ee),he=K.length,Ie=G.length;K.length=he+Ie;for(let U=he-1;U>=X;U--)K[U+Ie]=K[U];for(let U=0;U<Ie;U++)K[U+X]=G[U]}e.$Jf=se;function ie(K,ee,G,X){const he=V(K,ee),Ie=K.splice(he,G);return se(K,he,X),Ie}e.$Kf=ie;function V(K,ee){return ee<0?Math.max(ee+K.length,0):Math.min(ee,K.length)}var re;(function(K){function ee(Ie){return Ie<0}K.isLessThan=ee;function G(Ie){return Ie<=0}K.isLessThanOrEqual=G;function X(Ie){return Ie>0}K.isGreaterThan=X;function he(Ie){return Ie===0}K.isNeitherLessOrGreaterThan=he,K.greaterThan=1,K.lessThan=-1,K.neitherLessOrGreaterThan=0})(re||(e.CompareResult=re={}));function pe(K,ee){return(G,X)=>ee(K(G),K(X))}e.$Lf=pe;function ae(...K){return(ee,G)=>{for(const X of K){const he=X(ee,G);if(!re.isNeitherLessOrGreaterThan(he))return he}return re.neitherLessOrGreaterThan}}e.$Mf=ae;const ne=(K,ee)=>K-ee;e.$Nf=ne;const x=(K,ee)=>(0,e.$Nf)(K?1:0,ee?1:0);e.$Of=x;function N(K){return(ee,G)=>-K(ee,G)}e.$Pf=N;function q(K,ee){if(K.length===0)return;let G=K[0];for(let X=1;X<K.length;X++){const he=K[X];ee(he,G)>0&&(G=he)}return G}e.$Qf=q;function de(K,ee){if(K.length===0)return;let G=K[0];for(let X=1;X<K.length;X++){const he=K[X];ee(he,G)>=0&&(G=he)}return G}e.$Rf=de;function ye(K,ee){return q(K,(G,X)=>-ee(G,X))}e.$Sf=ye;function ve(K,ee){if(K.length===0)return-1;let G=0;for(let X=1;X<K.length;X++){const he=K[X];ee(he,K[G])>0&&(G=X)}return G}e.$Tf=ve;class we{constructor(ee){this.f=ee,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(ee){let G=this.c;for(;G<this.f.length&&ee(this.f[G]);)G++;const X=G===this.c?null:this.f.slice(this.c,G);return this.c=G,X}takeFromEndWhile(ee){let G=this.d;for(;G>=0&&ee(this.f[G]);)G--;const X=G===this.d?null:this.f.slice(G+1,this.d+1);return this.d=G,X}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const ee=this.f[this.c];return this.c++,ee}removeLast(){const ee=this.f[this.d];return this.d--,ee}takeCount(ee){const G=this.f.slice(this.c,this.c+ee);return this.c+=ee,G}}e.$Uf=we;class Ee{static{this.empty=new Ee(ee=>{})}constructor(ee){this.iterate=ee}forEach(ee){this.iterate(G=>(ee(G),!0))}toArray(){const ee=[];return this.iterate(G=>(ee.push(G),!0)),ee}filter(ee){return new Ee(G=>this.iterate(X=>ee(X)?G(X):!0))}map(ee){return new Ee(G=>this.iterate(X=>G(ee(X))))}some(ee){let G=!1;return this.iterate(X=>(G=ee(X),!G)),G}findFirst(ee){let G;return this.iterate(X=>ee(X)?(G=X,!1):!0),G}findLast(ee){let G;return this.iterate(X=>(ee(X)&&(G=X),!0)),G}findLastMaxBy(ee){let G,X=!0;return this.iterate(he=>((X||re.isGreaterThan(ee(he,G)))&&(X=!1,G=he),!0)),G}}e.$Vf=Ee}),define(Se[54],De([1,0,8]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zb=e.$yb=e.$xb=e.$wb=e.ok=void 0;function F(w,g){if(!w)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=F;function h(w,g="Unreachable"){throw new Error(g)}e.$wb=h;function L(w){if(!w)throw new S.$bb("Assertion Failed")}e.$xb=L;function A(w){if(!w()){debugger;w(),(0,S.$Y)(new S.$bb("Assertion Failed"))}}e.$yb=A;function f(w,g){let P=0;for(;P<w.length-1;){const I=w[P],$=w[P+1];if(!g(I,$))return!1;P++}return!0}e.$zb=f}),define(Se[71],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function S(F){const h=this;let L=!1,A;return function(){return L||(L=!0,A=F.apply(h,arguments)),A}}e.$cb=S}),define(Se[117],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RL=e.$QL=void 0;class S{constructor(h){this.a=h,this.b=0}nextId(){return this.a+ ++this.b}}e.$QL=S,e.$RL=new S("id#")}),define(Se[48],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(F){function h(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}F.is=h;const L=Object.freeze([]);function A(){return L}F.empty=A;function*f(v){yield v}F.single=f;function w(v){return h(v)?v:f(v)}F.wrap=w;function g(v){return v||L}F.from=g;function P(v){return!v||v[Symbol.iterator]().next().done===!0}F.isEmpty=P;function I(v){return v[Symbol.iterator]().next().value}F.first=I;function $(v,D){for(const t of v)if(D(t))return!0;return!1}F.some=$;function k(v,D){for(const t of v)if(D(t))return t}F.find=k;function*C(v,D){for(const t of v)D(t)&&(yield t)}F.filter=C;function*E(v,D){let t=0;for(const r of v)yield D(r,t++)}F.map=E;function*n(...v){for(const D of v)for(const t of D)yield t}F.concat=n;function o(v,D,t){let r=t;for(const s of v)r=D(r,s);return r}F.reduce=o;function*a(v,D,t=v.length){for(D<0&&(D+=v.length),t<0?t+=v.length:t>v.length&&(t=v.length);D<t;D++)yield v[D]}F.slice=a;function m(v,D=Number.POSITIVE_INFINITY){const t=[];if(D===0)return[t,v];const r=v[Symbol.iterator]();for(let s=0;s<D;s++){const i=r.next();if(i.done)return[t,F.empty()];t.push(i.value)}return[t,{[Symbol.iterator](){return r}}]}F.consume=m})(S||(e.Iterable=S={}))}),define(Se[154],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var h;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(h||(e.ParseErrorCode=h={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function A(t,r=!1){let s=0;const i=t.length;let c="",l=0,b=16,y=0;function u(z){let B=0,M=0;for(;B<z;){const Y=t.charCodeAt(s);if(Y>=48&&Y<=57)M=M*16+Y-48;else if(Y>=65&&Y<=70)M=M*16+Y-65+10;else if(Y>=97&&Y<=102)M=M*16+Y-97+10;else break;s++,B++}return B<z&&(M=-1),M}function d(z){s=z,c="",l=0,b=16,y=0}function p(){const z=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&g(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&g(t.charCodeAt(s)))for(s++;s<t.length&&g(t.charCodeAt(s));)s++;else return y=3,t.substring(z,s);let B=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&g(t.charCodeAt(s))){for(s++;s<t.length&&g(t.charCodeAt(s));)s++;B=s}else y=3;return t.substring(z,B)}function R(){let z="",B=s;for(;;){if(s>=i){z+=t.substring(B,s),y=2;break}const M=t.charCodeAt(s);if(M===34){z+=t.substring(B,s),s++;break}if(M===92){if(z+=t.substring(B,s),s++,s>=i){y=2;break}switch(t.charCodeAt(s++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const J=u(4);J>=0?z+=String.fromCharCode(J):y=4;break}default:y=5}B=s;continue}if(M>=0&&M<=31)if(w(M)){z+=t.substring(B,s),y=2;break}else y=6;s++}return z}function O(){if(c="",y=0,l=s,s>=i)return l=i,b=17;let z=t.charCodeAt(s);if(f(z)){do s++,c+=String.fromCharCode(z),z=t.charCodeAt(s);while(f(z));return b=15}if(w(z))return s++,c+=String.fromCharCode(z),z===13&&t.charCodeAt(s)===10&&(s++,c+=`
`),b=14;switch(z){case 123:return s++,b=1;case 125:return s++,b=2;case 91:return s++,b=3;case 93:return s++,b=4;case 58:return s++,b=6;case 44:return s++,b=5;case 34:return s++,c=R(),b=10;case 47:{const B=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!w(t.charCodeAt(s));)s++;return c=t.substring(B,s),b=12}if(t.charCodeAt(s+1)===42){s+=2;const M=i-1;let Y=!1;for(;s<M;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,Y=!0;break}s++}return Y||(s++,y=1),c=t.substring(B,s),b=13}return c+=String.fromCharCode(z),s++,b=16}case 45:if(c+=String.fromCharCode(z),s++,s===i||!g(t.charCodeAt(s)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=p(),b=11;default:for(;s<i&&j(z);)s++,z=t.charCodeAt(s);if(l!==s){switch(c=t.substring(l,s),c){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return c+=String.fromCharCode(z),s++,b=16}}function j(z){if(f(z)||w(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let z;do z=O();while(z>=12&&z<=15);return z}return{setPosition:d,getPosition:()=>s,scan:r?T:O,getToken:()=>b,getTokenValue:()=>c,getTokenOffset:()=>l,getTokenLength:()=>s-l,getTokenError:()=>y}}e.$wm=A;function f(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function w(t){return t===10||t===13||t===8232||t===8233}function g(t){return t>=48&&t<=57}var P;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(P||(P={}));function I(t,r){const s=[],i=new Object;let c;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function y(u,d,p,R){l.value=u,l.offset=d,l.length=p,l.type=R,l.colonOffset=void 0,c=l}try{m(t,{onObjectBegin:(u,d)=>{if(r<=u)throw i;c=void 0,b=r>u,s.push("")},onObjectProperty:(u,d,p)=>{if(r<d||(y(u,d,p,"property"),s[s.length-1]=u,r<=d+p))throw i},onObjectEnd:(u,d)=>{if(r<=u)throw i;c=void 0,s.pop()},onArrayBegin:(u,d)=>{if(r<=u)throw i;c=void 0,s.push(0)},onArrayEnd:(u,d)=>{if(r<=u)throw i;c=void 0,s.pop()},onLiteralValue:(u,d,p)=>{if(r<d||(y(u,d,p,D(u)),r<=d+p))throw i},onSeparator:(u,d,p)=>{if(r<=d)throw i;if(u===":"&&c&&c.type==="property")c.colonOffset=d,b=!1,c=void 0;else if(u===","){const R=s[s.length-1];typeof R=="number"?s[s.length-1]=R+1:(b=!0,s[s.length-1]=""),c=void 0}}})}catch(u){if(u!==i)throw u}return{path:s,previousNode:c,isAtPropertyKey:b,matches:u=>{let d=0;for(let p=0;d<u.length&&p<s.length;p++)if(u[d]===s[p]||u[d]==="*")d++;else if(u[d]!=="**")return!1;return d===u.length}}}e.$xm=I;function $(t,r=[],s=L.DEFAULT){let i=null,c=[];const l=[];function b(u){Array.isArray(c)?c.push(u):i!==null&&(c[i]=u)}return m(t,{onObjectBegin:()=>{const u={};b(u),l.push(c),c=u,i=null},onObjectProperty:u=>{i=u},onObjectEnd:()=>{c=l.pop()},onArrayBegin:()=>{const u=[];b(u),l.push(c),c=u,i=null},onArrayEnd:()=>{c=l.pop()},onLiteralValue:b,onError:(u,d,p)=>{r.push({error:u,offset:d,length:p})}},s),c[0]}e.$ym=$;function k(t,r=[],s=L.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(u){i.type==="property"&&(i.length=u-i.offset,i=i.parent)}function l(u){return i.children.push(u),u}m(t,{onObjectBegin:u=>{i=l({type:"object",offset:u,length:-1,parent:i,children:[]})},onObjectProperty:(u,d,p)=>{i=l({type:"property",offset:d,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:u,offset:d,length:p,parent:i})},onObjectEnd:(u,d)=>{i.length=u+d-i.offset,i=i.parent,c(u+d)},onArrayBegin:(u,d)=>{i=l({type:"array",offset:u,length:-1,parent:i,children:[]})},onArrayEnd:(u,d)=>{i.length=u+d-i.offset,i=i.parent,c(u+d)},onLiteralValue:(u,d,p)=>{l({type:D(u),offset:d,length:p,parent:i,value:u}),c(d+p)},onSeparator:(u,d,p)=>{i.type==="property"&&(u===":"?i.colonOffset=d:u===","&&c(d))},onError:(u,d,p)=>{r.push({error:u,offset:d,length:p})}},s);const y=i.children[0];return y&&delete y.parent,y}e.$zm=k;function C(t,r){if(!t)return;let s=t;for(const i of r)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let c=!1;for(const l of s.children)if(Array.isArray(l.children)&&l.children[0].value===i){s=l.children[1],c=!0;break}if(!c)return}else{const c=i;if(s.type!=="array"||c<0||!Array.isArray(s.children)||c>=s.children.length)return;s=s.children[c]}return s}e.$Am=C;function E(t){if(!t.parent||!t.parent.children)return[];const r=E(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}e.$Bm=E;function n(t){switch(t.type){case"array":return t.children.map(n);case"object":{const r=Object.create(null);for(const s of t.children){const i=s.children[1];i&&(r[s.children[0].value]=n(i))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Cm=n;function o(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}e.$Dm=o;function a(t,r,s=!1){if(o(t,r,s)){const i=t.children;if(Array.isArray(i))for(let c=0;c<i.length&&i[c].offset<=r;c++){const l=a(i[c],r,s);if(l)return l}return t}}e.$Em=a;function m(t,r,s=L.DEFAULT){const i=A(t,!1);function c(pe){return pe?()=>pe(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(pe){return pe?ae=>pe(ae,i.getTokenOffset(),i.getTokenLength()):()=>!0}const b=c(r.onObjectBegin),y=l(r.onObjectProperty),u=c(r.onObjectEnd),d=c(r.onArrayBegin),p=c(r.onArrayEnd),R=l(r.onLiteralValue),O=l(r.onSeparator),j=c(r.onComment),T=l(r.onError),z=s&&s.disallowComments,B=s&&s.allowTrailingComma;function M(){for(;;){const pe=i.scan();switch(i.getTokenError()){case 4:Y(14);break;case 5:Y(15);break;case 3:Y(13);break;case 1:z||Y(11);break;case 2:Y(12);break;case 6:Y(16);break}switch(pe){case 12:case 13:z?Y(10):j();break;case 16:Y(1);break;case 15:case 14:break;default:return pe}}}function Y(pe,ae=[],ne=[]){if(T(pe),ae.length+ne.length>0){let x=i.getToken();for(;x!==17;){if(ae.indexOf(x)!==-1){M();break}else if(ne.indexOf(x)!==-1)break;x=M()}}}function J(pe){const ae=i.getTokenValue();return pe?R(ae):y(ae),M(),!0}function fe(){switch(i.getToken()){case 11:{let pe=0;try{pe=JSON.parse(i.getTokenValue()),typeof pe!="number"&&(Y(2),pe=0)}catch{Y(2)}R(pe);break}case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return M(),!0}function se(){return i.getToken()!==10?(Y(3,[],[2,5]),!1):(J(!1),i.getToken()===6?(O(":"),M(),re()||Y(4,[],[2,5])):Y(5,[],[2,5]),!0)}function ie(){b(),M();let pe=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(pe||Y(4,[],[]),O(","),M(),i.getToken()===2&&B)break}else pe&&Y(6,[],[]);se()||Y(4,[],[2,5]),pe=!0}return u(),i.getToken()!==2?Y(7,[2],[]):M(),!0}function V(){d(),M();let pe=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(pe||Y(4,[],[]),O(","),M(),i.getToken()===4&&B)break}else pe&&Y(6,[],[]);re()||Y(4,[],[4,5]),pe=!0}return p(),i.getToken()!==4?Y(8,[4],[]):M(),!0}function re(){switch(i.getToken()){case 3:return V();case 1:return ie();case 10:return J(!0);default:return fe()}}return M(),i.getToken()===17?s.allowEmptyContent?!0:(Y(4,[],[]),!1):re()?(i.getToken()!==17&&Y(9,[],[]),!0):(Y(4,[],[]),!1)}e.$Fm=m;function v(t,r){const s=A(t),i=[];let c,l=0,b;do switch(b=s.getPosition(),c=s.scan(),c){case 12:case 13:case 17:l!==b&&i.push(t.substring(l,b)),r!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,r)),l=s.getPosition();break}while(c!==17);return i.join("")}e.$Gm=v;function D(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Hm=D}),define(Se[55],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class S{constructor(h){this.d=h,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(h){this.c=h}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=S}),define(Se[3],De([1,0,71,48]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tb=e.$sb=e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;const h=!1;let L=null;function A(l){L=l}if(e.$db=A,h){const l="__is_disposable_tracked__";A(new class{trackDisposable(b){const y=new Error("Potentially leaked disposable").stack;setTimeout(()=>{b[l]||console.log(y)},3e3)}setParent(b,y){if(b&&b!==a.None)try{b[l]=!0}catch{}}markAsDisposed(b){if(b&&b!==a.None)try{b[l]=!0}catch{}}markAsSingleton(b){}})}function f(l){return L?.trackDisposable(l),l}function w(l){L?.markAsDisposed(l)}function g(l,b){L?.setParent(l,b)}function P(l,b){if(L)for(const y of l)L.setParent(y,b)}function I(l){return L?.markAsSingleton(l),l}e.$eb=I;function $(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.$fb=$;function k(l){if(F.Iterable.is(l)){const b=[];for(const y of l)if(y)try{y.dispose()}catch(u){b.push(u)}if(b.length===1)throw b[0];if(b.length>1)throw new AggregateError(b,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.$gb=k;function C(l){for(const b of l)$(b)&&b.dispose();return[]}e.$hb=C;function E(...l){const b=n(()=>k(l));return P(l,b),b}e.$ib=E;function n(l){const b=f({dispose:(0,S.$cb)(()=>{w(b),l()})});return b}e.$jb=n;class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,f(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{k(this.f)}finally{this.f.clear()}}add(b){if(!b)return b;if(b===this)throw new Error("Cannot register a disposable on itself!");return g(b,this),this.g?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(b),b}}e.$kb=o;class a{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new o,f(this),g(this.q,this)}dispose(){w(this),this.q.dispose()}B(b){if(b===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(b)}}e.$lb=a;class m{constructor(){this.b=!1,f(this)}get value(){return this.b?void 0:this.a}set value(b){this.b||b===this.a||(this.a?.dispose(),b&&g(b,this),this.a=b)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const b=this.a;return this.a=void 0,b&&g(b,null),b}}e.$mb=m;class v{constructor(b){this.b=b,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$nb=v;class D{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,f(this)}set(b){let y=b;return this.unset=()=>y=void 0,this.isset=()=>y!==void 0,this.dispose=()=>{y&&(y(),y=void 0,w(this))},this}}e.$ob=D;class t{constructor(){this.a=new Map}acquire(b,...y){let u=this.a.get(b);u||(u={counter:0,object:this.b(b,...y)},this.a.set(b,u));const{object:d}=u,p=(0,S.$cb)(()=>{--u.counter===0&&(this.c(b,u.object),this.a.delete(b))});return u.counter++,{object:d,dispose:p}}}e.$pb=t;class r{constructor(b){this.a=b}async acquire(b,...y){const u=this.a.acquire(b,...y);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(d){throw u.dispose(),d}}}e.$qb=r;class s{constructor(b){this.object=b}dispose(){}}e.$rb=s;function i(l){const b=new o;try{l(b)}finally{b.dispose()}}e.$sb=i;class c{constructor(){this.a=new Map,this.b=!1,f(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{k(this.a.values())}finally{this.a.clear()}}has(b){return this.a.has(b)}get(b){return this.a.get(b)}set(b,y,u=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),u||this.a.get(b)?.dispose(),this.a.set(b,y)}deleteAndDispose(b){this.a.get(b)?.dispose(),this.a.delete(b)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$tb=c}),define(Se[72],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ub=void 0;class S{static{this.Undefined=new S(void 0)}constructor(L){this.element=L,this.next=S.Undefined,this.prev=S.Undefined}}class F{constructor(){this.a=S.Undefined,this.b=S.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===S.Undefined}clear(){let L=this.a;for(;L!==S.Undefined;){const A=L.next;L.prev=S.Undefined,L.next=S.Undefined,L=A}this.a=S.Undefined,this.b=S.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,A){const f=new S(L);if(this.a===S.Undefined)this.a=f,this.b=f;else if(A){const g=this.b;this.b=f,f.prev=g,g.next=f}else{const g=this.a;this.a=f,f.next=g,g.prev=f}this.c+=1;let w=!1;return()=>{w||(w=!0,this.e(f))}}shift(){if(this.a!==S.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==S.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==S.Undefined&&L.next!==S.Undefined){const A=L.prev;A.next=L.next,L.next.prev=A}else L.prev===S.Undefined&&L.next===S.Undefined?(this.a=S.Undefined,this.b=S.Undefined):L.next===S.Undefined?(this.b=this.b.prev,this.b.next=S.Undefined):L.prev===S.Undefined&&(this.a=this.a.next,this.a.prev=S.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==S.Undefined;)yield L.element,L=L.next}}e.$ub=F}),define(Se[28],De([1,0]),function(me,e){"use strict";var S,F,h;Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.Touch=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=void 0;function L(E,n,o){let a=E.get(n);return a===void 0&&(a=o,E.set(n,a)),a}e.$ki=L;function A(E){const n=[];return E.forEach((o,a)=>{n.push(`${a} => ${o}`)}),`Map(${E.size}) {${n.join(", ")}}`}e.$li=A;function f(E){const n=[];return E.forEach(o=>{n.push(o)}),`Set(${E.size}) {${n.join(", ")}}`}e.$mi=f;class w{constructor(n,o){this.uri=n,this.value=o}}class g{static{this.a=n=>n.toString()}constructor(n,o){this[S]="ResourceMap",n instanceof g?(this.b=new Map(n.b),this.c=o??g.a):(this.b=new Map,this.c=n??g.a)}set(n,o){return this.b.set(this.c(n),new w(n,o)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,o){typeof o<"u"&&(n=n.bind(o));for(const[a,m]of this.b)n(m.value,m.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}e.$ni=g;class P{constructor(n,o){this[F]="ResourceSet",!n||typeof n=="function"?this.a=new g(n):(this.a=new g(o),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,o){this.a.forEach((a,m)=>n.call(o,m,m,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$oi=P;var I;(function(E){E[E.None=0]="None",E[E.AsOld=1]="AsOld",E[E.AsNew=2]="AsNew"})(I||(e.Touch=I={}));class ${constructor(){this[h]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,o=0){const a=this.a.get(n);if(a)return o!==0&&this.j(a,o),a.value}set(n,o,a=0){let m=this.a.get(n);if(m)m.value=o,a!==0&&this.j(m,a);else{switch(m={key:n,value:o,next:void 0,previous:void 0},a){case 0:this.h(m);break;case 1:this.g(m);break;case 2:this.h(m);break;default:this.h(m);break}this.a.set(n,m),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this.a.get(n);if(o)return this.a.delete(n),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,o){const a=this.e;let m=this.b;for(;m;){if(o?n.bind(o)(m.value,m.key,this):n(m.value,m.key,this),this.e!==a)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const n=this,o=this.e;let a=this.b;const m={[Symbol.iterator](){return m},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const v={value:a.key,done:!1};return a=a.next,v}else return{value:void 0,done:!0}}};return m}values(){const n=this,o=this.e;let a=this.b;const m={[Symbol.iterator](){return m},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const v={value:a.value,done:!1};return a=a.next,v}else return{value:void 0,done:!0}}};return m}entries(){const n=this,o=this.e;let a=this.b;const m={[Symbol.iterator](){return m},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const v={value:[a.key,a.value],done:!1};return a=a.next,v}else return{value:void 0,done:!0}}};return m}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this.b,a=this.size;for(;o&&a>n;)this.a.delete(o.key),o=o.next,a--;this.b=o,this.d=a,o&&(o.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const o=n.next,a=n.previous;if(!o||!a)throw new Error("Invalid list");o.previous=a,a.next=o}n.next=void 0,n.previous=void 0,this.e++}j(n,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this.b)return;const a=n.next,m=n.previous;n===this.c?(m.next=void 0,this.c=m):(a.previous=m,m.next=a),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(o===2){if(n===this.c)return;const a=n.next,m=n.previous;n===this.b?(a.previous=void 0,this.b=a):(a.previous=m,m.next=a),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((o,a)=>{n.push([a,o])}),n}fromJSON(n){this.clear();for(const[o,a]of n)this.set(o,a)}}e.$pi=$;class k extends ${constructor(n,o=1){super(),this.k=n,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$qi=k;class C{constructor(){this.a=new Map}add(n){return this.a.set(n,(this.a.get(n)||0)+1),this}delete(n){let o=this.a.get(n)||0;return o===0?!1:(o--,o===0?this.a.delete(n):this.a.set(n,o),!0)}has(n){return this.a.has(n)}}e.$ri=C}),function(me,e){typeof define=="function"&&define.amd?define(Se[155],De([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(ve,we){for(var Ee=0;Ee<we.length;Ee++){var K=we[Ee];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(ve,K.key,K)}}function S(ve,we,Ee){return we&&e(ve.prototype,we),Ee&&e(ve,Ee),Object.defineProperty(ve,"prototype",{writable:!1}),ve}function F(ve,we){if(ve){if(typeof ve=="string")return h(ve,we);var Ee=Object.prototype.toString.call(ve).slice(8,-1);if(Ee==="Object"&&ve.constructor&&(Ee=ve.constructor.name),Ee==="Map"||Ee==="Set")return Array.from(ve);if(Ee==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ee))return h(ve,we)}}function h(ve,we){(we==null||we>ve.length)&&(we=ve.length);for(var Ee=0,K=new Array(we);Ee<we;Ee++)K[Ee]=ve[Ee];return K}function L(ve,we){var Ee=typeof Symbol<"u"&&ve[Symbol.iterator]||ve["@@iterator"];if(Ee)return(Ee=Ee.call(ve)).next.bind(Ee);if(Array.isArray(ve)||(Ee=F(ve))||we&&ve&&typeof ve.length=="number"){Ee&&(ve=Ee);var K=0;return function(){return K>=ve.length?{done:!0}:{done:!1,value:ve[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=A();function f(ve){me.defaults=ve}var w=/[&<>"']/,g=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,$={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(we){return $[we]};function C(ve,we){if(we){if(w.test(ve))return ve.replace(g,k)}else if(P.test(ve))return ve.replace(I,k);return ve}var E=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function n(ve){return ve.replace(E,function(we,Ee){return Ee=Ee.toLowerCase(),Ee==="colon"?":":Ee.charAt(0)==="#"?Ee.charAt(1)==="x"?String.fromCharCode(parseInt(Ee.substring(2),16)):String.fromCharCode(+Ee.substring(1)):""})}var o=/(^|[^\[])\^/g;function a(ve,we){ve=typeof ve=="string"?ve:ve.source,we=we||"";var Ee={replace:function(ee,G){return G=G.source||G,G=G.replace(o,"$1"),ve=ve.replace(ee,G),Ee},getRegex:function(){return new RegExp(ve,we)}};return Ee}var m=/[^\w:]/g,v=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function D(ve,we,Ee){if(ve){var K;try{K=decodeURIComponent(n(Ee)).replace(m,"").toLowerCase()}catch{return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}we&&!v.test(Ee)&&(Ee=c(we,Ee));try{Ee=encodeURI(Ee).replace(/%25/g,"%")}catch{return null}return Ee}var t={},r=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(ve,we){t[" "+ve]||(r.test(ve)?t[" "+ve]=ve+"/":t[" "+ve]=u(ve,"/",!0)),ve=t[" "+ve];var Ee=ve.indexOf(":")===-1;return we.substring(0,2)==="//"?Ee?we:ve.replace(s,"$1")+we:we.charAt(0)==="/"?Ee?we:ve.replace(i,"$1")+we:ve+we}var l={exec:function(){}};function b(ve){for(var we=1,Ee,K;we<arguments.length;we++){Ee=arguments[we];for(K in Ee)Object.prototype.hasOwnProperty.call(Ee,K)&&(ve[K]=Ee[K])}return ve}function y(ve,we){var Ee=ve.replace(/\|/g,function(G,X,he){for(var Ie=!1,U=X;--U>=0&&he[U]==="\\";)Ie=!Ie;return Ie?"|":" |"}),K=Ee.split(/ \|/),ee=0;if(K[0].trim()||K.shift(),K.length>0&&!K[K.length-1].trim()&&K.pop(),K.length>we)K.splice(we);else for(;K.length<we;)K.push("");for(;ee<K.length;ee++)K[ee]=K[ee].trim().replace(/\\\|/g,"|");return K}function u(ve,we,Ee){var K=ve.length;if(K===0)return"";for(var ee=0;ee<K;){var G=ve.charAt(K-ee-1);if(G===we&&!Ee)ee++;else if(G!==we&&Ee)ee++;else break}return ve.slice(0,K-ee)}function d(ve,we){if(ve.indexOf(we[1])===-1)return-1;for(var Ee=ve.length,K=0,ee=0;ee<Ee;ee++)if(ve[ee]==="\\")ee++;else if(ve[ee]===we[0])K++;else if(ve[ee]===we[1]&&(K--,K<0))return ee;return-1}function p(ve){ve&&ve.sanitize&&!ve.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(ve,we){if(we<1)return"";for(var Ee="";we>1;)we&1&&(Ee+=ve),we>>=1,ve+=ve;return Ee+ve}function O(ve,we,Ee,K){var ee=we.href,G=we.title?C(we.title):null,X=ve[1].replace(/\\([\[\]])/g,"$1");if(ve[0].charAt(0)!=="!"){K.state.inLink=!0;var he={type:"link",raw:Ee,href:ee,title:G,text:X,tokens:K.inlineTokens(X)};return K.state.inLink=!1,he}return{type:"image",raw:Ee,href:ee,title:G,text:C(X)}}function j(ve,we){var Ee=ve.match(/^(\s+)(?:```)/);if(Ee===null)return we;var K=Ee[1];return we.split(`
`).map(function(ee){var G=ee.match(/^\s+/);if(G===null)return ee;var X=G[0];return X.length>=K.length?ee.slice(K.length):ee}).join(`
`)}var T=function(){function ve(Ee){this.options=Ee||me.defaults}var we=ve.prototype;return we.space=function(K){var ee=this.rules.block.newline.exec(K);if(ee&&ee[0].length>0)return{type:"space",raw:ee[0]}},we.code=function(K){var ee=this.rules.block.code.exec(K);if(ee){var G=ee[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ee[0],codeBlockStyle:"indented",text:this.options.pedantic?G:u(G,`
`)}}},we.fences=function(K){var ee=this.rules.block.fences.exec(K);if(ee){var G=ee[0],X=j(G,ee[3]||"");return{type:"code",raw:G,lang:ee[2]?ee[2].trim():ee[2],text:X}}},we.heading=function(K){var ee=this.rules.block.heading.exec(K);if(ee){var G=ee[2].trim();if(/#$/.test(G)){var X=u(G,"#");(this.options.pedantic||!X||/ $/.test(X))&&(G=X.trim())}return{type:"heading",raw:ee[0],depth:ee[1].length,text:G,tokens:this.lexer.inline(G)}}},we.hr=function(K){var ee=this.rules.block.hr.exec(K);if(ee)return{type:"hr",raw:ee[0]}},we.blockquote=function(K){var ee=this.rules.block.blockquote.exec(K);if(ee){var G=ee[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ee[0],tokens:this.lexer.blockTokens(G,[]),text:G}}},we.list=function(K){var ee=this.rules.block.list.exec(K);if(ee){var G,X,he,Ie,U,Q,_,oe,Z,le,be,ze,qe=ee[1].trim(),_e=qe.length>1,Ze={type:"list",raw:"",ordered:_e,start:_e?+qe.slice(0,-1):"",loose:!1,items:[]};qe=_e?"\\d{1,9}\\"+qe.slice(-1):"\\"+qe,this.options.pedantic&&(qe=_e?qe:"[*+-]");for(var it=new RegExp("^( {0,3}"+qe+")((?:[	 ][^\\n]*)?(?:\\n|$))");K&&(ze=!1,!(!(ee=it.exec(K))||this.rules.block.hr.test(K)));){if(G=ee[0],K=K.substring(G.length),oe=ee[2].split(`
`,1)[0],Z=K.split(`
`,1)[0],this.options.pedantic?(Ie=2,be=oe.trimLeft()):(Ie=ee[2].search(/[^ ]/),Ie=Ie>4?1:Ie,be=oe.slice(Ie),Ie+=ee[1].length),Q=!1,!oe&&/^ *$/.test(Z)&&(G+=Z+`
`,K=K.substring(Z.length+1),ze=!0),!ze)for(var et=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Pe=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Oe=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),We=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");K&&(le=K.split(`
`,1)[0],oe=le,this.options.pedantic&&(oe=oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Oe.test(oe)||We.test(oe)||et.test(oe)||Pe.test(K)));){if(oe.search(/[^ ]/)>=Ie||!oe.trim())be+=`
`+oe.slice(Ie);else if(!Q)be+=`
`+oe;else break;!Q&&!oe.trim()&&(Q=!0),G+=le+`
`,K=K.substring(le.length+1)}Ze.loose||(_?Ze.loose=!0:/\n *\n *$/.test(G)&&(_=!0)),this.options.gfm&&(X=/^\[[ xX]\] /.exec(be),X&&(he=X[0]!=="[ ] ",be=be.replace(/^\[[ xX]\] +/,""))),Ze.items.push({type:"list_item",raw:G,task:!!X,checked:he,loose:!1,text:be}),Ze.raw+=G}Ze.items[Ze.items.length-1].raw=G.trimRight(),Ze.items[Ze.items.length-1].text=be.trimRight(),Ze.raw=Ze.raw.trimRight();var Re=Ze.items.length;for(U=0;U<Re;U++){this.lexer.state.top=!1,Ze.items[U].tokens=this.lexer.blockTokens(Ze.items[U].text,[]);var Qe=Ze.items[U].tokens.filter(function(ce){return ce.type==="space"}),ue=Qe.every(function(ce){for(var Ce=ce.raw.split(""),Ve=0,je=L(Ce),Xe;!(Xe=je()).done;){var rt=Xe.value;if(rt===`
`&&(Ve+=1),Ve>1)return!0}return!1});!Ze.loose&&Qe.length&&ue&&(Ze.loose=!0,Ze.items[U].loose=!0)}return Ze}},we.html=function(K){var ee=this.rules.block.html.exec(K);if(ee){var G={type:"html",raw:ee[0],pre:!this.options.sanitizer&&(ee[1]==="pre"||ee[1]==="script"||ee[1]==="style"),text:ee[0]};if(this.options.sanitize){var X=this.options.sanitizer?this.options.sanitizer(ee[0]):C(ee[0]);G.type="paragraph",G.text=X,G.tokens=this.lexer.inline(X)}return G}},we.def=function(K){var ee=this.rules.block.def.exec(K);if(ee){ee[3]&&(ee[3]=ee[3].substring(1,ee[3].length-1));var G=ee[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:G,raw:ee[0],href:ee[2],title:ee[3]}}},we.table=function(K){var ee=this.rules.block.table.exec(K);if(ee){var G={type:"table",header:y(ee[1]).map(function(_){return{text:_}}),align:ee[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ee[3]&&ee[3].trim()?ee[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(G.header.length===G.align.length){G.raw=ee[0];var X=G.align.length,he,Ie,U,Q;for(he=0;he<X;he++)/^ *-+: *$/.test(G.align[he])?G.align[he]="right":/^ *:-+: *$/.test(G.align[he])?G.align[he]="center":/^ *:-+ *$/.test(G.align[he])?G.align[he]="left":G.align[he]=null;for(X=G.rows.length,he=0;he<X;he++)G.rows[he]=y(G.rows[he],G.header.length).map(function(_){return{text:_}});for(X=G.header.length,Ie=0;Ie<X;Ie++)G.header[Ie].tokens=this.lexer.inline(G.header[Ie].text);for(X=G.rows.length,Ie=0;Ie<X;Ie++)for(Q=G.rows[Ie],U=0;U<Q.length;U++)Q[U].tokens=this.lexer.inline(Q[U].text);return G}}},we.lheading=function(K){var ee=this.rules.block.lheading.exec(K);if(ee)return{type:"heading",raw:ee[0],depth:ee[2].charAt(0)==="="?1:2,text:ee[1],tokens:this.lexer.inline(ee[1])}},we.paragraph=function(K){var ee=this.rules.block.paragraph.exec(K);if(ee){var G=ee[1].charAt(ee[1].length-1)===`
`?ee[1].slice(0,-1):ee[1];return{type:"paragraph",raw:ee[0],text:G,tokens:this.lexer.inline(G)}}},we.text=function(K){var ee=this.rules.block.text.exec(K);if(ee)return{type:"text",raw:ee[0],text:ee[0],tokens:this.lexer.inline(ee[0])}},we.escape=function(K){var ee=this.rules.inline.escape.exec(K);if(ee)return{type:"escape",raw:ee[0],text:C(ee[1])}},we.tag=function(K){var ee=this.rules.inline.tag.exec(K);if(ee)return!this.lexer.state.inLink&&/^<a /i.test(ee[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ee[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):C(ee[0]):ee[0]}},we.link=function(K){var ee=this.rules.inline.link.exec(K);if(ee){var G=ee[2].trim();if(!this.options.pedantic&&/^</.test(G)){if(!/>$/.test(G))return;var X=u(G.slice(0,-1),"\\");if((G.length-X.length)%2===0)return}else{var he=d(ee[2],"()");if(he>-1){var Ie=ee[0].indexOf("!")===0?5:4,U=Ie+ee[1].length+he;ee[2]=ee[2].substring(0,he),ee[0]=ee[0].substring(0,U).trim(),ee[3]=""}}var Q=ee[2],_="";if(this.options.pedantic){var oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Q);oe&&(Q=oe[1],_=oe[3])}else _=ee[3]?ee[3].slice(1,-1):"";return Q=Q.trim(),/^</.test(Q)&&(this.options.pedantic&&!/>$/.test(G)?Q=Q.slice(1):Q=Q.slice(1,-1)),O(ee,{href:Q&&Q.replace(this.rules.inline._escapes,"$1"),title:_&&_.replace(this.rules.inline._escapes,"$1")},ee[0],this.lexer)}},we.reflink=function(K,ee){var G;if((G=this.rules.inline.reflink.exec(K))||(G=this.rules.inline.nolink.exec(K))){var X=(G[2]||G[1]).replace(/\s+/g," ");if(X=ee[X.toLowerCase()],!X||!X.href){var he=G[0].charAt(0);return{type:"text",raw:he,text:he}}return O(G,X,G[0],this.lexer)}},we.emStrong=function(K,ee,G){G===void 0&&(G="");var X=this.rules.inline.emStrong.lDelim.exec(K);if(X&&!(X[3]&&G.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var he=X[1]||X[2]||"";if(!he||he&&(G===""||this.rules.inline.punctuation.exec(G))){var Ie=X[0].length-1,U,Q,_=Ie,oe=0,Z=X[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Z.lastIndex=0,ee=ee.slice(-1*K.length+Ie);(X=Z.exec(ee))!=null;)if(U=X[1]||X[2]||X[3]||X[4]||X[5]||X[6],!!U){if(Q=U.length,X[3]||X[4]){_+=Q;continue}else if((X[5]||X[6])&&Ie%3&&!((Ie+Q)%3)){oe+=Q;continue}if(_-=Q,!(_>0)){if(Q=Math.min(Q,Q+_+oe),Math.min(Ie,Q)%2){var le=K.slice(1,Ie+X.index+Q);return{type:"em",raw:K.slice(0,Ie+X.index+Q+1),text:le,tokens:this.lexer.inlineTokens(le)}}var be=K.slice(2,Ie+X.index+Q-1);return{type:"strong",raw:K.slice(0,Ie+X.index+Q+1),text:be,tokens:this.lexer.inlineTokens(be)}}}}}},we.codespan=function(K){var ee=this.rules.inline.code.exec(K);if(ee){var G=ee[2].replace(/\n/g," "),X=/[^ ]/.test(G),he=/^ /.test(G)&&/ $/.test(G);return X&&he&&(G=G.substring(1,G.length-1)),G=C(G,!0),{type:"codespan",raw:ee[0],text:G}}},we.br=function(K){var ee=this.rules.inline.br.exec(K);if(ee)return{type:"br",raw:ee[0]}},we.del=function(K){var ee=this.rules.inline.del.exec(K);if(ee)return{type:"del",raw:ee[0],text:ee[2],tokens:this.lexer.inlineTokens(ee[2])}},we.autolink=function(K,ee){var G=this.rules.inline.autolink.exec(K);if(G){var X,he;return G[2]==="@"?(X=C(this.options.mangle?ee(G[1]):G[1]),he="mailto:"+X):(X=C(G[1]),he=X),{type:"link",raw:G[0],text:X,href:he,tokens:[{type:"text",raw:X,text:X}]}}},we.url=function(K,ee){var G;if(G=this.rules.inline.url.exec(K)){var X,he;if(G[2]==="@")X=C(this.options.mangle?ee(G[0]):G[0]),he="mailto:"+X;else{var Ie;do Ie=G[0],G[0]=this.rules.inline._backpedal.exec(G[0])[0];while(Ie!==G[0]);X=C(G[0]),G[1]==="www."?he="http://"+X:he=X}return{type:"link",raw:G[0],text:X,href:he,tokens:[{type:"text",raw:X,text:X}]}}},we.inlineText=function(K,ee){var G=this.rules.inline.text.exec(K);if(G){var X;return this.lexer.state.inRawBlock?X=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(G[0]):C(G[0]):G[0]:X=C(this.options.smartypants?ee(G[0]):G[0]),{type:"text",raw:G[0],text:X}}},ve}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=a(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=a(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=a(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=a(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=a(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=a(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=b({},z),z.gfm=b({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=a(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=a(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=b({},z.normal,{html:a(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:a(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var B={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};B._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",B.punctuation=a(B.punctuation).replace(/punctuation/g,B._punctuation).getRegex(),B.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,B.escapedEmSt=/\\\*|\\_/g,B._comment=a(z._comment).replace("(?:-->|$)","-->").getRegex(),B.emStrong.lDelim=a(B.emStrong.lDelim).replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimAst=a(B.emStrong.rDelimAst,"g").replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimUnd=a(B.emStrong.rDelimUnd,"g").replace(/punct/g,B._punctuation).getRegex(),B._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,B._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,B._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,B.autolink=a(B.autolink).replace("scheme",B._scheme).replace("email",B._email).getRegex(),B._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,B.tag=a(B.tag).replace("comment",B._comment).replace("attribute",B._attribute).getRegex(),B._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,B._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,B._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,B.link=a(B.link).replace("label",B._label).replace("href",B._href).replace("title",B._title).getRegex(),B.reflink=a(B.reflink).replace("label",B._label).replace("ref",z._label).getRegex(),B.nolink=a(B.nolink).replace("ref",z._label).getRegex(),B.reflinkSearch=a(B.reflinkSearch,"g").replace("reflink",B.reflink).replace("nolink",B.nolink).getRegex(),B.normal=b({},B),B.pedantic=b({},B.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:a(/^!?\[(label)\]\((.*?)\)/).replace("label",B._label).getRegex(),reflink:a(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",B._label).getRegex()}),B.gfm=b({},B.normal,{escape:a(B.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),B.gfm.url=a(B.gfm.url,"i").replace("email",B.gfm._extended_email).getRegex(),B.breaks=b({},B.gfm,{br:a(B.br).replace("{2,}","*").getRegex(),text:a(B.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function M(ve){return ve.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Y(ve){var we="",Ee,K,ee=ve.length;for(Ee=0;Ee<ee;Ee++)K=ve.charCodeAt(Ee),Math.random()>.5&&(K="x"+K.toString(16)),we+="&#"+K+";";return we}var J=function(){function ve(Ee){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ee||me.defaults,this.options.tokenizer=this.options.tokenizer||new T,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var K={block:z.normal,inline:B.normal};this.options.pedantic?(K.block=z.pedantic,K.inline=B.pedantic):this.options.gfm&&(K.block=z.gfm,this.options.breaks?K.inline=B.breaks:K.inline=B.gfm),this.tokenizer.rules=K}ve.lex=function(K,ee){var G=new ve(ee);return G.lex(K)},ve.lexInline=function(K,ee){var G=new ve(ee);return G.inlineTokens(K)};var we=ve.prototype;return we.lex=function(K){K=K.replace(/\r\n|\r/g,`
`),this.blockTokens(K,this.tokens);for(var ee;ee=this.inlineQueue.shift();)this.inlineTokens(ee.src,ee.tokens);return this.tokens},we.blockTokens=function(K,ee){var G=this;ee===void 0&&(ee=[]),this.options.pedantic?K=K.replace(/\t/g,"    ").replace(/^ +$/gm,""):K=K.replace(/^( *)(\t+)/gm,function(_,oe,Z){return oe+"    ".repeat(Z.length)});for(var X,he,Ie,U;K;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(_){return(X=_.call({lexer:G},K,ee))?(K=K.substring(X.raw.length),ee.push(X),!0):!1}))){if(X=this.tokenizer.space(K)){K=K.substring(X.raw.length),X.raw.length===1&&ee.length>0?ee[ee.length-1].raw+=`
`:ee.push(X);continue}if(X=this.tokenizer.code(K)){K=K.substring(X.raw.length),he=ee[ee.length-1],he&&(he.type==="paragraph"||he.type==="text")?(he.raw+=`
`+X.raw,he.text+=`
`+X.text,this.inlineQueue[this.inlineQueue.length-1].src=he.text):ee.push(X);continue}if(X=this.tokenizer.fences(K)){K=K.substring(X.raw.length),ee.push(X);continue}if(X=this.tokenizer.heading(K)){K=K.substring(X.raw.length),ee.push(X);continue}if(X=this.tokenizer.hr(K)){K=K.substring(X.raw.length),ee.push(X);continue}if(X=this.tokenizer.blockquote(K)){K=K.substring(X.raw.length),ee.push(X);continue}if(X=this.tokenizer.list(K)){K=K.substring(X.raw.length),ee.push(X);continue}if(X=this.tokenizer.html(K)){K=K.substring(X.raw.length),ee.push(X);continue}if(X=this.tokenizer.def(K)){K=K.substring(X.raw.length),he=ee[ee.length-1],he&&(he.type==="paragraph"||he.type==="text")?(he.raw+=`
`+X.raw,he.text+=`
`+X.raw,this.inlineQueue[this.inlineQueue.length-1].src=he.text):this.tokens.links[X.tag]||(this.tokens.links[X.tag]={href:X.href,title:X.title});continue}if(X=this.tokenizer.table(K)){K=K.substring(X.raw.length),ee.push(X);continue}if(X=this.tokenizer.lheading(K)){K=K.substring(X.raw.length),ee.push(X);continue}if(Ie=K,this.options.extensions&&this.options.extensions.startBlock&&function(){var _=1/0,oe=K.slice(1),Z=void 0;G.options.extensions.startBlock.forEach(function(le){Z=le.call({lexer:this},oe),typeof Z=="number"&&Z>=0&&(_=Math.min(_,Z))}),_<1/0&&_>=0&&(Ie=K.substring(0,_+1))}(),this.state.top&&(X=this.tokenizer.paragraph(Ie))){he=ee[ee.length-1],U&&he.type==="paragraph"?(he.raw+=`
`+X.raw,he.text+=`
`+X.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=he.text):ee.push(X),U=Ie.length!==K.length,K=K.substring(X.raw.length);continue}if(X=this.tokenizer.text(K)){K=K.substring(X.raw.length),he=ee[ee.length-1],he&&he.type==="text"?(he.raw+=`
`+X.raw,he.text+=`
`+X.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=he.text):ee.push(X);continue}if(K){var Q="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return this.state.top=!0,ee},we.inline=function(K,ee){return ee===void 0&&(ee=[]),this.inlineQueue.push({src:K,tokens:ee}),ee},we.inlineTokens=function(K,ee){var G=this;ee===void 0&&(ee=[]);var X,he,Ie,U=K,Q,_,oe;if(this.tokens.links){var Z=Object.keys(this.tokens.links);if(Z.length>0)for(;(Q=this.tokenizer.rules.inline.reflinkSearch.exec(U))!=null;)Z.includes(Q[0].slice(Q[0].lastIndexOf("[")+1,-1))&&(U=U.slice(0,Q.index)+"["+R("a",Q[0].length-2)+"]"+U.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Q=this.tokenizer.rules.inline.blockSkip.exec(U))!=null;)U=U.slice(0,Q.index)+"["+R("a",Q[0].length-2)+"]"+U.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Q=this.tokenizer.rules.inline.escapedEmSt.exec(U))!=null;)U=U.slice(0,Q.index)+"++"+U.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;)if(_||(oe=""),_=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(be){return(X=be.call({lexer:G},K,ee))?(K=K.substring(X.raw.length),ee.push(X),!0):!1}))){if(X=this.tokenizer.escape(K)){K=K.substring(X.raw.length),ee.push(X);continue}if(X=this.tokenizer.tag(K)){K=K.substring(X.raw.length),he=ee[ee.length-1],he&&X.type==="text"&&he.type==="text"?(he.raw+=X.raw,he.text+=X.text):ee.push(X);continue}if(X=this.tokenizer.link(K)){K=K.substring(X.raw.length),ee.push(X);continue}if(X=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(X.raw.length),he=ee[ee.length-1],he&&X.type==="text"&&he.type==="text"?(he.raw+=X.raw,he.text+=X.text):ee.push(X);continue}if(X=this.tokenizer.emStrong(K,U,oe)){K=K.substring(X.raw.length),ee.push(X);continue}if(X=this.tokenizer.codespan(K)){K=K.substring(X.raw.length),ee.push(X);continue}if(X=this.tokenizer.br(K)){K=K.substring(X.raw.length),ee.push(X);continue}if(X=this.tokenizer.del(K)){K=K.substring(X.raw.length),ee.push(X);continue}if(X=this.tokenizer.autolink(K,Y)){K=K.substring(X.raw.length),ee.push(X);continue}if(!this.state.inLink&&(X=this.tokenizer.url(K,Y))){K=K.substring(X.raw.length),ee.push(X);continue}if(Ie=K,this.options.extensions&&this.options.extensions.startInline&&function(){var be=1/0,ze=K.slice(1),qe=void 0;G.options.extensions.startInline.forEach(function(_e){qe=_e.call({lexer:this},ze),typeof qe=="number"&&qe>=0&&(be=Math.min(be,qe))}),be<1/0&&be>=0&&(Ie=K.substring(0,be+1))}(),X=this.tokenizer.inlineText(Ie,M)){K=K.substring(X.raw.length),X.raw.slice(-1)!=="_"&&(oe=X.raw.slice(-1)),_=!0,he=ee[ee.length-1],he&&he.type==="text"?(he.raw+=X.raw,he.text+=X.text):ee.push(X);continue}if(K){var le="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(le);break}else throw new Error(le)}}return ee},S(ve,null,[{key:"rules",get:function(){return{block:z,inline:B}}}]),ve}(),fe=function(){function ve(Ee){this.options=Ee||me.defaults}var we=ve.prototype;return we.code=function(K,ee,G){var X=(ee||"").match(/\S*/)[0];if(this.options.highlight){var he=this.options.highlight(K,X);he!=null&&he!==K&&(G=!0,K=he)}return K=K.replace(/\n$/,"")+`
`,X?'<pre><code class="'+this.options.langPrefix+C(X,!0)+'">'+(G?K:C(K,!0))+`</code></pre>
`:"<pre><code>"+(G?K:C(K,!0))+`</code></pre>
`},we.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},we.html=function(K){return K},we.heading=function(K,ee,G,X){if(this.options.headerIds){var he=this.options.headerPrefix+X.slug(G);return"<h"+ee+' id="'+he+'">'+K+"</h"+ee+`>
`}return"<h"+ee+">"+K+"</h"+ee+`>
`},we.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},we.list=function(K,ee,G){var X=ee?"ol":"ul",he=ee&&G!==1?' start="'+G+'"':"";return"<"+X+he+`>
`+K+"</"+X+`>
`},we.listitem=function(K){return"<li>"+K+`</li>
`},we.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},we.paragraph=function(K){return"<p>"+K+`</p>
`},we.table=function(K,ee){return ee&&(ee="<tbody>"+ee+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+ee+`</table>
`},we.tablerow=function(K){return`<tr>
`+K+`</tr>
`},we.tablecell=function(K,ee){var G=ee.header?"th":"td",X=ee.align?"<"+G+' align="'+ee.align+'">':"<"+G+">";return X+K+("</"+G+`>
`)},we.strong=function(K){return"<strong>"+K+"</strong>"},we.em=function(K){return"<em>"+K+"</em>"},we.codespan=function(K){return"<code>"+K+"</code>"},we.br=function(){return this.options.xhtml?"<br/>":"<br>"},we.del=function(K){return"<del>"+K+"</del>"},we.link=function(K,ee,G){if(K=D(this.options.sanitize,this.options.baseUrl,K),K===null)return G;var X='<a href="'+C(K)+'"';return ee&&(X+=' title="'+ee+'"'),X+=">"+G+"</a>",X},we.image=function(K,ee,G){if(K=D(this.options.sanitize,this.options.baseUrl,K),K===null)return G;var X='<img src="'+K+'" alt="'+G+'"';return ee&&(X+=' title="'+ee+'"'),X+=this.options.xhtml?"/>":">",X},we.text=function(K){return K},ve}(),se=function(){function ve(){}var we=ve.prototype;return we.strong=function(K){return K},we.em=function(K){return K},we.codespan=function(K){return K},we.del=function(K){return K},we.html=function(K){return K},we.text=function(K){return K},we.link=function(K,ee,G){return""+G},we.image=function(K,ee,G){return""+G},we.br=function(){return""},ve}(),ie=function(){function ve(){this.seen={}}var we=ve.prototype;return we.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},we.getNextSafeSlug=function(K,ee){var G=K,X=0;if(this.seen.hasOwnProperty(G)){X=this.seen[K];do X++,G=K+"-"+X;while(this.seen.hasOwnProperty(G))}return ee||(this.seen[K]=X,this.seen[G]=0),G},we.slug=function(K,ee){ee===void 0&&(ee={});var G=this.serialize(K);return this.getNextSafeSlug(G,ee.dryrun)},ve}(),V=function(){function ve(Ee){this.options=Ee||me.defaults,this.options.renderer=this.options.renderer||new fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new se,this.slugger=new ie}ve.parse=function(K,ee){var G=new ve(ee);return G.parse(K)},ve.parseInline=function(K,ee){var G=new ve(ee);return G.parseInline(K)};var we=ve.prototype;return we.parse=function(K,ee){ee===void 0&&(ee=!0);var G="",X,he,Ie,U,Q,_,oe,Z,le,be,ze,qe,_e,Ze,it,et,Pe,Oe,We,Re=K.length;for(X=0;X<Re;X++){if(be=K[X],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(We=this.options.extensions.renderers[be.type].call({parser:this},be),We!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(be.type))){G+=We||"";continue}switch(be.type){case"space":continue;case"hr":{G+=this.renderer.hr();continue}case"heading":{G+=this.renderer.heading(this.parseInline(be.tokens),be.depth,n(this.parseInline(be.tokens,this.textRenderer)),this.slugger);continue}case"code":{G+=this.renderer.code(be.text,be.lang,be.escaped);continue}case"table":{for(Z="",oe="",U=be.header.length,he=0;he<U;he++)oe+=this.renderer.tablecell(this.parseInline(be.header[he].tokens),{header:!0,align:be.align[he]});for(Z+=this.renderer.tablerow(oe),le="",U=be.rows.length,he=0;he<U;he++){for(_=be.rows[he],oe="",Q=_.length,Ie=0;Ie<Q;Ie++)oe+=this.renderer.tablecell(this.parseInline(_[Ie].tokens),{header:!1,align:be.align[Ie]});le+=this.renderer.tablerow(oe)}G+=this.renderer.table(Z,le);continue}case"blockquote":{le=this.parse(be.tokens),G+=this.renderer.blockquote(le);continue}case"list":{for(ze=be.ordered,qe=be.start,_e=be.loose,U=be.items.length,le="",he=0;he<U;he++)it=be.items[he],et=it.checked,Pe=it.task,Ze="",it.task&&(Oe=this.renderer.checkbox(et),_e?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Oe+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Oe+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Oe}):Ze+=Oe),Ze+=this.parse(it.tokens,_e),le+=this.renderer.listitem(Ze,Pe,et);G+=this.renderer.list(le,ze,qe);continue}case"html":{G+=this.renderer.html(be.text);continue}case"paragraph":{G+=this.renderer.paragraph(this.parseInline(be.tokens));continue}case"text":{for(le=be.tokens?this.parseInline(be.tokens):be.text;X+1<Re&&K[X+1].type==="text";)be=K[++X],le+=`
`+(be.tokens?this.parseInline(be.tokens):be.text);G+=ee?this.renderer.paragraph(le):le;continue}default:{var Qe='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(Qe);return}else throw new Error(Qe)}}}return G},we.parseInline=function(K,ee){ee=ee||this.renderer;var G="",X,he,Ie,U=K.length;for(X=0;X<U;X++){if(he=K[X],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[he.type]&&(Ie=this.options.extensions.renderers[he.type].call({parser:this},he),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(he.type))){G+=Ie||"";continue}switch(he.type){case"escape":{G+=ee.text(he.text);break}case"html":{G+=ee.html(he.text);break}case"link":{G+=ee.link(he.href,he.title,this.parseInline(he.tokens,ee));break}case"image":{G+=ee.image(he.href,he.title,he.text);break}case"strong":{G+=ee.strong(this.parseInline(he.tokens,ee));break}case"em":{G+=ee.em(this.parseInline(he.tokens,ee));break}case"codespan":{G+=ee.codespan(he.text);break}case"br":{G+=ee.br();break}case"del":{G+=ee.del(this.parseInline(he.tokens,ee));break}case"text":{G+=ee.text(he.text);break}default:{var Q='Token with "'+he.type+'" type was not found.';if(this.options.silent){console.error(Q);return}else throw new Error(Q)}}}return G},ve}();function re(ve,we,Ee){if(typeof ve>"u"||ve===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");if(typeof we=="function"&&(Ee=we,we=null),we=b({},re.defaults,we||{}),p(we),Ee){var K=we.highlight,ee;try{ee=J.lex(ve,we)}catch(U){return Ee(U)}var G=function(Q){var _;if(!Q)try{we.walkTokens&&re.walkTokens(ee,we.walkTokens),_=V.parse(ee,we)}catch(oe){Q=oe}return we.highlight=K,Q?Ee(Q):Ee(null,_)};if(!K||K.length<3||(delete we.highlight,!ee.length))return G();var X=0;re.walkTokens(ee,function(U){U.type==="code"&&(X++,setTimeout(function(){K(U.text,U.lang,function(Q,_){if(Q)return G(Q);_!=null&&_!==U.text&&(U.text=_,U.escaped=!0),X--,X===0&&G()})},0))}),X===0&&G();return}function he(U){if(U.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+C(U.message+"",!0)+"</pre>";throw U}try{var Ie=J.lex(ve,we);if(we.walkTokens){if(we.async)return Promise.all(re.walkTokens(Ie,we.walkTokens)).then(function(){return V.parse(Ie,we)}).catch(he);re.walkTokens(Ie,we.walkTokens)}return V.parse(Ie,we)}catch(U){he(U)}}re.options=re.setOptions=function(ve){return b(re.defaults,ve),f(re.defaults),re},re.getDefaults=A,re.defaults=me.defaults,re.use=function(){for(var ve=arguments.length,we=new Array(ve),Ee=0;Ee<ve;Ee++)we[Ee]=arguments[Ee];var K=b.apply(void 0,[{}].concat(we)),ee=re.defaults.extensions||{renderers:{},childTokens:{}},G;we.forEach(function(X){if(X.extensions&&(G=!0,X.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var U=ee.renderers?ee.renderers[Ie.name]:null;U?ee.renderers[Ie.name]=function(){for(var Q=arguments.length,_=new Array(Q),oe=0;oe<Q;oe++)_[oe]=arguments[oe];var Z=Ie.renderer.apply(this,_);return Z===!1&&(Z=U.apply(this,_)),Z}:ee.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ee[Ie.level]?ee[Ie.level].unshift(Ie.tokenizer):ee[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?ee.startBlock?ee.startBlock.push(Ie.start):ee.startBlock=[Ie.start]:Ie.level==="inline"&&(ee.startInline?ee.startInline.push(Ie.start):ee.startInline=[Ie.start]))}Ie.childTokens&&(ee.childTokens[Ie.name]=Ie.childTokens)})),X.renderer&&function(){var Ie=re.defaults.renderer||new fe,U=function(oe){var Z=Ie[oe];Ie[oe]=function(){for(var le=arguments.length,be=new Array(le),ze=0;ze<le;ze++)be[ze]=arguments[ze];var qe=X.renderer[oe].apply(Ie,be);return qe===!1&&(qe=Z.apply(Ie,be)),qe}};for(var Q in X.renderer)U(Q);K.renderer=Ie}(),X.tokenizer&&function(){var Ie=re.defaults.tokenizer||new T,U=function(oe){var Z=Ie[oe];Ie[oe]=function(){for(var le=arguments.length,be=new Array(le),ze=0;ze<le;ze++)be[ze]=arguments[ze];var qe=X.tokenizer[oe].apply(Ie,be);return qe===!1&&(qe=Z.apply(Ie,be)),qe}};for(var Q in X.tokenizer)U(Q);K.tokenizer=Ie}(),X.walkTokens){var he=re.defaults.walkTokens;K.walkTokens=function(Ie){var U=[];return U.push(X.walkTokens.call(this,Ie)),he&&(U=U.concat(he.call(this,Ie))),U}}G&&(K.extensions=ee),re.setOptions(K)})},re.walkTokens=function(ve,we){for(var Ee=[],K=function(){var he=G.value;switch(Ee=Ee.concat(we.call(re,he)),he.type){case"table":{for(var Ie=L(he.header),U;!(U=Ie()).done;){var Q=U.value;Ee=Ee.concat(re.walkTokens(Q.tokens,we))}for(var _=L(he.rows),oe;!(oe=_()).done;)for(var Z=oe.value,le=L(Z),be;!(be=le()).done;){var ze=be.value;Ee=Ee.concat(re.walkTokens(ze.tokens,we))}break}case"list":{Ee=Ee.concat(re.walkTokens(he.items,we));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[he.type]?re.defaults.extensions.childTokens[he.type].forEach(function(qe){Ee=Ee.concat(re.walkTokens(he[qe],we))}):he.tokens&&(Ee=Ee.concat(re.walkTokens(he.tokens,we)))}},ee=L(ve),G;!(G=ee()).done;)K();return Ee},re.parseInline=function(ve,we){if(typeof ve>"u"||ve===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");we=b({},re.defaults,we||{}),p(we);try{var Ee=J.lexInline(ve,we);return we.walkTokens&&re.walkTokens(Ee,we.walkTokens),V.parseInline(Ee,we)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+C(K.message+"",!0)+"</pre>";throw K}},re.Parser=V,re.parser=V.parse,re.Renderer=fe,re.TextRenderer=se,re.Lexer=J,re.lexer=J.lex,re.Tokenizer=T,re.Slugger=ie,re.parse=re;var pe=re.options,ae=re.setOptions,ne=re.use,x=re.walkTokens,N=re.parseInline,q=re,de=V.parse,ye=J.lex;me.Lexer=J,me.Parser=V,me.Renderer=fe,me.Slugger=ie,me.TextRenderer=se,me.Tokenizer=T,me.getDefaults=A,me.lexer=ye,me.marked=re,me.options=pe,me.parse=q,me.parseInline=N,me.parser=de,me.setOptions=ae,me.use=ne,me.walkTokens=x,Object.defineProperty(me,"__esModule",{value:!0})}),define(Se[73],De([1,0,28]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.$7k=void 0;const F=new S.$qi(1e4);function h(g){return w(g,"NFC",F)}e.$7k=h;const L=new S.$qi(1e4);function A(g){return w(g,"NFD",L)}e.$8k=A;const f=/[^\u0000-\u0080]/;function w(g,P,I){if(!g)return g;const $=I.get(g);if($)return $;let k;return f.test(g)?k=g.normalize(P):k=g,I.set(g,k),k}e.$9k=function(){const g=/[\u0300-\u036f]/g;return function(P){return A(P).replace(g,"")}}()}),define(Se[118],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$xl=e.$wl=e.rot=e.$ul=void 0;function S(f,w,g){return Math.min(Math.max(f,w),g)}e.$ul=S;function F(f,w){return(w+f%w)%w}e.rot=F;class h{constructor(){this.a=0}getNext(){return this.a++}}e.$wl=h;class L{constructor(){this.a=1,this.b=0}update(w){return this.b=this.b+(w-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$xl=L;class A{constructor(w){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(w),this.c.fill(0,0,w)}update(w){const g=this.c[this.d];return this.c[this.d]=w,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=w,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$yl=A}),function(){function me(h){const L=[];typeof h=="number"&&L.push("code/timeOrigin",h);function A(w){L.push(w,Date.now())}function f(){const w=[];for(let g=0;g<L.length;g+=2)w.push({name:L[g],startTime:L[g+1]});return w}return{mark:A,getMarks:f}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(h){performance.mark(h)},getMarks(){let h=performance.timeOrigin;typeof h!="number"&&(h=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(h)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(h+A.startTime)});return L}};if(typeof process=="object"){const h=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(h)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function S(h){return h.MonacoPerformanceMarks||(h.MonacoPerformanceMarks=e()),h.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=S(F))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var F in S)(typeof exports=="object"?exports:me)[F]=S[F]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function S(F){if(e[F])return e[F].exports;var h=e[F]={i:F,l:!1,exports:{}};return me[F].call(h.exports,h,h.exports,S),h.l=!0,h.exports}return S.m=me,S.c=e,S.d=function(F,h,L){S.o(F,h)||Object.defineProperty(F,h,{enumerable:!0,get:L})},S.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},S.t=function(F,h){if(1&h&&(F=S(F)),8&h||4&h&&typeof F=="object"&&F&&F.__esModule)return F;var L=Object.create(null);if(S.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:F}),2&h&&typeof F!="string")for(var A in F)S.d(L,A,function(f){return F[f]}.bind(null,A));return L},S.n=function(F){var h=F&&F.__esModule?function(){return F.default}:function(){return F};return S.d(h,"a",h),h},S.o=function(F,h){return Object.prototype.hasOwnProperty.call(F,h)},S.p="",S(S.s=0)}([function(me,e,S){(function(F){var h;e=me.exports=ne,h=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,f=e.re=[],w=e.src=[],g=0,P=g++;w[P]="0|[1-9]\\d*";var I=g++;w[I]="[0-9]+";var $=g++;w[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=g++;w[k]="("+w[P]+")\\.("+w[P]+")\\.("+w[P]+")";var C=g++;w[C]="("+w[I]+")\\.("+w[I]+")\\.("+w[I]+")";var E=g++;w[E]="(?:"+w[P]+"|"+w[$]+")";var n=g++;w[n]="(?:"+w[I]+"|"+w[$]+")";var o=g++;w[o]="(?:-("+w[E]+"(?:\\."+w[E]+")*))";var a=g++;w[a]="(?:-?("+w[n]+"(?:\\."+w[n]+")*))";var m=g++;w[m]="[0-9A-Za-z-]+";var v=g++;w[v]="(?:\\+("+w[m]+"(?:\\."+w[m]+")*))";var D=g++,t="v?"+w[k]+w[o]+"?"+w[v]+"?";w[D]="^"+t+"$";var r="[v=\\s]*"+w[C]+w[a]+"?"+w[v]+"?",s=g++;w[s]="^"+r+"$";var i=g++;w[i]="((?:<|>)?=?)";var c=g++;w[c]=w[I]+"|x|X|\\*";var l=g++;w[l]=w[P]+"|x|X|\\*";var b=g++;w[b]="[v=\\s]*("+w[l]+")(?:\\.("+w[l]+")(?:\\.("+w[l]+")(?:"+w[o]+")?"+w[v]+"?)?)?";var y=g++;w[y]="[v=\\s]*("+w[c]+")(?:\\.("+w[c]+")(?:\\.("+w[c]+")(?:"+w[a]+")?"+w[v]+"?)?)?";var u=g++;w[u]="^"+w[i]+"\\s*"+w[b]+"$";var d=g++;w[d]="^"+w[i]+"\\s*"+w[y]+"$";var p=g++;w[p]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var R=g++;w[R]="(?:~>?)";var O=g++;w[O]="(\\s*)"+w[R]+"\\s+",f[O]=new RegExp(w[O],"g");var j=g++;w[j]="^"+w[R]+w[b]+"$";var T=g++;w[T]="^"+w[R]+w[y]+"$";var z=g++;w[z]="(?:\\^)";var B=g++;w[B]="(\\s*)"+w[z]+"\\s+",f[B]=new RegExp(w[B],"g");var M=g++;w[M]="^"+w[z]+w[b]+"$";var Y=g++;w[Y]="^"+w[z]+w[y]+"$";var J=g++;w[J]="^"+w[i]+"\\s*("+r+")$|^$";var fe=g++;w[fe]="^"+w[i]+"\\s*("+t+")$|^$";var se=g++;w[se]="(\\s*)"+w[i]+"\\s*("+r+"|"+w[b]+")",f[se]=new RegExp(w[se],"g");var ie=g++;w[ie]="^\\s*("+w[b]+")\\s+-\\s+("+w[b]+")\\s*$";var V=g++;w[V]="^\\s*("+w[y]+")\\s+-\\s+("+w[y]+")\\s*$";var re=g++;w[re]="(<|>)?=?\\s*\\*";for(var pe=0;pe<35;pe++)h(pe,w[pe]),f[pe]||(f[pe]=new RegExp(w[pe]));function ae(Z,le){if(Z instanceof ne)return Z;if(typeof Z!="string"||Z.length>L||!(le?f[s]:f[D]).test(Z))return null;try{return new ne(Z,le)}catch{return null}}function ne(Z,le){if(Z instanceof ne){if(Z.loose===le)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof ne))return new ne(Z,le);h("SemVer",Z,le),this.loose=le;var be=Z.trim().match(le?f[s]:f[D]);if(!be)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(ze){if(/^[0-9]+$/.test(ze)){var qe=+ze;if(qe>=0&&qe<A)return qe}return ze}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=ae,e.valid=function(Z,le){var be=ae(Z,le);return be?be.version:null},e.clean=function(Z,le){var be=ae(Z.trim().replace(/^[=v]+/,""),le);return be?be.version:null},e.SemVer=ne,ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ne.prototype.toString=function(){return this.version},ne.prototype.compare=function(Z){return h("SemVer.compare",this.version,this.loose,Z),Z instanceof ne||(Z=new ne(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},ne.prototype.compareMain=function(Z){return Z instanceof ne||(Z=new ne(Z,this.loose)),N(this.major,Z.major)||N(this.minor,Z.minor)||N(this.patch,Z.patch)},ne.prototype.comparePre=function(Z){if(Z instanceof ne||(Z=new ne(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var le=0;do{var be=this.prerelease[le],ze=Z.prerelease[le];if(h("prerelease compare",le,be,ze),be===void 0&&ze===void 0)return 0;if(ze===void 0)return 1;if(be===void 0)return-1;if(be!==ze)return N(be,ze)}while(++le)},ne.prototype.inc=function(Z,le){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,le,be,ze){typeof be=="string"&&(ze=be,be=void 0);try{return new ne(Z,be).inc(le,ze).version}catch{return null}},e.diff=function(Z,le){if(ve(Z,le))return null;var be=ae(Z),ze=ae(le);if(be.prerelease.length||ze.prerelease.length){for(var qe in be)if((qe==="major"||qe==="minor"||qe==="patch")&&be[qe]!==ze[qe])return"pre"+qe;return"prerelease"}for(var qe in be)if((qe==="major"||qe==="minor"||qe==="patch")&&be[qe]!==ze[qe])return qe},e.compareIdentifiers=N;var x=/^[0-9]+$/;function N(Z,le){var be=x.test(Z),ze=x.test(le);return be&&ze&&(Z=+Z,le=+le),be&&!ze?-1:ze&&!be?1:Z<le?-1:Z>le?1:0}function q(Z,le,be){return new ne(Z,be).compare(new ne(le,be))}function de(Z,le,be){return q(Z,le,be)>0}function ye(Z,le,be){return q(Z,le,be)<0}function ve(Z,le,be){return q(Z,le,be)===0}function we(Z,le,be){return q(Z,le,be)!==0}function Ee(Z,le,be){return q(Z,le,be)>=0}function K(Z,le,be){return q(Z,le,be)<=0}function ee(Z,le,be,ze){var qe;switch(le){case"===":typeof Z=="object"&&(Z=Z.version),typeof be=="object"&&(be=be.version),qe=Z===be;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof be=="object"&&(be=be.version),qe=Z!==be;break;case"":case"=":case"==":qe=ve(Z,be,ze);break;case"!=":qe=we(Z,be,ze);break;case">":qe=de(Z,be,ze);break;case">=":qe=Ee(Z,be,ze);break;case"<":qe=ye(Z,be,ze);break;case"<=":qe=K(Z,be,ze);break;default:throw new TypeError("Invalid operator: "+le)}return qe}function G(Z,le){if(Z instanceof G){if(Z.loose===le)return Z;Z=Z.value}if(!(this instanceof G))return new G(Z,le);h("comparator",Z,le),this.loose=le,this.parse(Z),this.semver===X?this.value="":this.value=this.operator+this.semver.version,h("comp",this)}e.rcompareIdentifiers=function(Z,le){return N(le,Z)},e.major=function(Z,le){return new ne(Z,le).major},e.minor=function(Z,le){return new ne(Z,le).minor},e.patch=function(Z,le){return new ne(Z,le).patch},e.compare=q,e.compareLoose=function(Z,le){return q(Z,le,!0)},e.rcompare=function(Z,le,be){return q(le,Z,be)},e.sort=function(Z,le){return Z.sort(function(be,ze){return e.compare(be,ze,le)})},e.rsort=function(Z,le){return Z.sort(function(be,ze){return e.rcompare(be,ze,le)})},e.gt=de,e.lt=ye,e.eq=ve,e.neq=we,e.gte=Ee,e.lte=K,e.cmp=ee,e.Comparator=G;var X={};function he(Z,le){if(Z instanceof he)return Z.loose===le?Z:new he(Z.raw,le);if(Z instanceof G)return new he(Z.value,le);if(!(this instanceof he))return new he(Z,le);if(this.loose=le,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function Ie(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function U(Z,le,be,ze,qe,_e,Ze,it,et,Pe,Oe,We,Re){return((le=Ie(be)?"":Ie(ze)?">="+be+".0.0":Ie(qe)?">="+be+"."+ze+".0":">="+le)+" "+(it=Ie(et)?"":Ie(Pe)?"<"+(+et+1)+".0.0":Ie(Oe)?"<"+et+"."+(+Pe+1)+".0":We?"<="+et+"."+Pe+"."+Oe+"-"+We:"<="+it)).trim()}function Q(Z,le){for(var be=0;be<Z.length;be++)if(!Z[be].test(le))return!1;if(le.prerelease.length){for(be=0;be<Z.length;be++)if(h(Z[be].semver),Z[be].semver!==X&&Z[be].semver.prerelease.length>0){var ze=Z[be].semver;if(ze.major===le.major&&ze.minor===le.minor&&ze.patch===le.patch)return!0}return!1}return!0}function _(Z,le,be){try{le=new he(le,be)}catch{return!1}return le.test(Z)}function oe(Z,le,be,ze){var qe,_e,Ze,it,et;switch(Z=new ne(Z,ze),le=new he(le,ze),be){case">":qe=de,_e=K,Ze=ye,it=">",et=">=";break;case"<":qe=ye,_e=Ee,Ze=de,it="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(_(Z,le,ze))return!1;for(var Pe=0;Pe<le.set.length;++Pe){var Oe=le.set[Pe],We=null,Re=null;if(Oe.forEach(function(Qe){Qe.semver===X&&(Qe=new G(">=0.0.0")),We=We||Qe,Re=Re||Qe,qe(Qe.semver,We.semver,ze)?We=Qe:Ze(Qe.semver,Re.semver,ze)&&(Re=Qe)}),We.operator===it||We.operator===et||(!Re.operator||Re.operator===it)&&_e(Z,Re.semver)||Re.operator===et&&Ze(Z,Re.semver))return!1}return!0}G.prototype.parse=function(Z){var le=this.loose?f[J]:f[fe],be=Z.match(le);if(!be)throw new TypeError("Invalid comparator: "+Z);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new ne(be[2],this.loose):this.semver=X},G.prototype.toString=function(){return this.value},G.prototype.test=function(Z){return h("Comparator.test",Z,this.loose),this.semver===X||(typeof Z=="string"&&(Z=new ne(Z,this.loose)),ee(Z,this.operator,this.semver,this.loose))},G.prototype.intersects=function(Z,le){if(!(Z instanceof G))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new he(Z.value,le),_(this.value,be,le);if(Z.operator==="")return be=new he(this.value,le),_(Z.semver,be,le);var ze=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),qe=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),_e=this.semver.version===Z.semver.version,Ze=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),it=ee(this.semver,"<",Z.semver,le)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),et=ee(this.semver,">",Z.semver,le)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return ze||qe||_e&&Ze||it||et},e.Range=he,he.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},he.prototype.toString=function(){return this.range},he.prototype.parseRange=function(Z){var le=this.loose;Z=Z.trim(),h("range",Z,le);var be=le?f[V]:f[ie];Z=Z.replace(be,U),h("hyphen replace",Z),Z=Z.replace(f[se],"$1$2$3"),h("comparator trim",Z,f[se]),Z=(Z=(Z=Z.replace(f[O],"$1~")).replace(f[B],"$1^")).split(/\s+/).join(" ");var ze=le?f[J]:f[fe],qe=Z.split(" ").map(function(_e){return function(Ze,it){return h("comp",Ze),Ze=function(et,Pe){return et.trim().split(/\s+/).map(function(Oe){return function(We,Re){h("caret",We,Re);var Qe=Re?f[Y]:f[M];return We.replace(Qe,function(ue,ce,Ce,Ve,je){var Xe;return h("caret",We,ue,ce,Ce,Ve,je),Ie(ce)?Xe="":Ie(Ce)?Xe=">="+ce+".0.0 <"+(+ce+1)+".0.0":Ie(Ve)?Xe=ce==="0"?">="+ce+"."+Ce+".0 <"+ce+"."+(+Ce+1)+".0":">="+ce+"."+Ce+".0 <"+(+ce+1)+".0.0":je?(h("replaceCaret pr",je),je.charAt(0)!=="-"&&(je="-"+je),Xe=ce==="0"?Ce==="0"?">="+ce+"."+Ce+"."+Ve+je+" <"+ce+"."+Ce+"."+(+Ve+1):">="+ce+"."+Ce+"."+Ve+je+" <"+ce+"."+(+Ce+1)+".0":">="+ce+"."+Ce+"."+Ve+je+" <"+(+ce+1)+".0.0"):(h("no pr"),Xe=ce==="0"?Ce==="0"?">="+ce+"."+Ce+"."+Ve+" <"+ce+"."+Ce+"."+(+Ve+1):">="+ce+"."+Ce+"."+Ve+" <"+ce+"."+(+Ce+1)+".0":">="+ce+"."+Ce+"."+Ve+" <"+(+ce+1)+".0.0"),h("caret return",Xe),Xe})}(Oe,Pe)}).join(" ")}(Ze,it),h("caret",Ze),Ze=function(et,Pe){return et.trim().split(/\s+/).map(function(Oe){return function(We,Re){var Qe=Re?f[T]:f[j];return We.replace(Qe,function(ue,ce,Ce,Ve,je){var Xe;return h("tilde",We,ue,ce,Ce,Ve,je),Ie(ce)?Xe="":Ie(Ce)?Xe=">="+ce+".0.0 <"+(+ce+1)+".0.0":Ie(Ve)?Xe=">="+ce+"."+Ce+".0 <"+ce+"."+(+Ce+1)+".0":je?(h("replaceTilde pr",je),je.charAt(0)!=="-"&&(je="-"+je),Xe=">="+ce+"."+Ce+"."+Ve+je+" <"+ce+"."+(+Ce+1)+".0"):Xe=">="+ce+"."+Ce+"."+Ve+" <"+ce+"."+(+Ce+1)+".0",h("tilde return",Xe),Xe})}(Oe,Pe)}).join(" ")}(Ze,it),h("tildes",Ze),Ze=function(et,Pe){return h("replaceXRanges",et,Pe),et.split(/\s+/).map(function(Oe){return function(We,Re){We=We.trim();var Qe=Re?f[d]:f[u];return We.replace(Qe,function(ue,ce,Ce,Ve,je,Xe){h("xRange",We,ue,ce,Ce,Ve,je,Xe);var rt=Ie(Ce),ot=rt||Ie(Ve),$t=ot||Ie(je);return ce==="="&&$t&&(ce=""),rt?ue=ce===">"||ce==="<"?"<0.0.0":"*":ce&&$t?(ot&&(Ve=0),$t&&(je=0),ce===">"?(ce=">=",ot?(Ce=+Ce+1,Ve=0,je=0):$t&&(Ve=+Ve+1,je=0)):ce==="<="&&(ce="<",ot?Ce=+Ce+1:Ve=+Ve+1),ue=ce+Ce+"."+Ve+"."+je):ot?ue=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":$t&&(ue=">="+Ce+"."+Ve+".0 <"+Ce+"."+(+Ve+1)+".0"),h("xRange return",ue),ue})}(Oe,Pe)}).join(" ")}(Ze,it),h("xrange",Ze),Ze=function(et,Pe){return h("replaceStars",et,Pe),et.trim().replace(f[re],"")}(Ze,it),h("stars",Ze),Ze}(_e,le)}).join(" ").split(/\s+/);return this.loose&&(qe=qe.filter(function(_e){return!!_e.match(ze)})),qe=qe.map(function(_e){return new G(_e,le)})},he.prototype.intersects=function(Z,le){if(!(Z instanceof he))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(ze){return Z.set.some(function(qe){return qe.every(function(_e){return ze.intersects(_e,le)})})})})},e.toComparators=function(Z,le){return new he(Z,le).set.map(function(be){return be.map(function(ze){return ze.value}).join(" ").trim().split(" ")})},he.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new ne(Z,this.loose));for(var le=0;le<this.set.length;le++)if(Q(this.set[le],Z))return!0;return!1},e.satisfies=_,e.maxSatisfying=function(Z,le,be){var ze=null,qe=null;try{var _e=new he(le,be)}catch{return null}return Z.forEach(function(Ze){_e.test(Ze)&&(ze&&qe.compare(Ze)!==-1||(qe=new ne(ze=Ze,be)))}),ze},e.minSatisfying=function(Z,le,be){var ze=null,qe=null;try{var _e=new he(le,be)}catch{return null}return Z.forEach(function(Ze){_e.test(Ze)&&(ze&&qe.compare(Ze)!==1||(qe=new ne(ze=Ze,be)))}),ze},e.validRange=function(Z,le){try{return new he(Z,le).range||"*"}catch{return null}},e.ltr=function(Z,le,be){return oe(Z,le,"<",be)},e.gtr=function(Z,le,be){return oe(Z,le,">",be)},e.outside=oe,e.prerelease=function(Z,le){var be=ae(Z,le);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(Z,le,be){return Z=new he(Z,be),le=new he(le,be),Z.intersects(le)},e.coerce=function(Z){if(Z instanceof ne)return Z;if(typeof Z!="string")return null;var le=Z.match(f[p]);return le==null?null:ae((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,S(1))},function(me,e){var S,F,h=me.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function f(n){if(S===setTimeout)return setTimeout(n,0);if((S===L||!S)&&setTimeout)return S=setTimeout,setTimeout(n,0);try{return S(n,0)}catch{try{return S.call(null,n,0)}catch{return S.call(this,n,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:L}catch{S=L}try{F=typeof clearTimeout=="function"?clearTimeout:A}catch{F=A}})();var w,g=[],P=!1,I=-1;function $(){P&&w&&(P=!1,w.length?g=w.concat(g):I=-1,g.length&&k())}function k(){if(!P){var n=f($);P=!0;for(var o=g.length;o;){for(w=g,g=[];++I<o;)w&&w[I].run();I=-1,o=g.length}w=null,P=!1,function(a){if(F===clearTimeout)return clearTimeout(a);if((F===A||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(a);try{F(a)}catch{try{return F.call(null,a)}catch{return F.call(this,a)}}}(n)}}function C(n,o){this.fun=n,this.array=o}function E(){}h.nextTick=function(n){var o=new Array(arguments.length-1);if(arguments.length>1)for(var a=1;a<arguments.length;a++)o[a-1]=arguments[a];g.push(new C(n,o)),g.length!==1||P||f(k)},C.prototype.run=function(){this.fun.apply(null,this.array)},h.title="browser",h.browser=!0,h.env={},h.argv=[],h.version="",h.versions={},h.on=E,h.addListener=E,h.once=E,h.off=E,h.removeListener=E,h.removeAllListeners=E,h.emit=E,h.prependListener=E,h.prependOnceListener=E,h.listeners=function(n){return[]},h.binding=function(n){throw new Error("process.binding is not supported")},h.cwd=function(){return"/"},h.chdir=function(n){throw new Error("process.chdir is not supported")},h.umask=function(){return 0}}])}),define(Se[37],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=void 0;const S=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(L){return new F(L)}constructor(L){this.c=S&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ac=F}),define(Se[4],De([1,0,8,71,3,72,37]),function(me,e,S,F,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.Event=void 0;const f=!1,w=!1;var g;(function(u){u.None=()=>h.$lb.None;function d(Ee){if(w){const{onDidAddListener:K}=Ee,ee=C.create();let G=0;Ee.onDidAddListener=()=>{++G===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ee.print()),K?.()}}}function p(Ee,K){return J(Ee,()=>{},0,void 0,!0,void 0,K)}u.defer=p;function R(Ee){return(K,ee=null,G)=>{let X=!1,he;return he=Ee(Ie=>{if(!X)return he?he.dispose():X=!0,K.call(ee,Ie)},null,G),X&&he.dispose(),he}}u.once=R;function O(Ee,K,ee){return Y((G,X=null,he)=>Ee(Ie=>G.call(X,K(Ie)),null,he),ee)}u.map=O;function j(Ee,K,ee){return Y((G,X=null,he)=>Ee(Ie=>{K(Ie),G.call(X,Ie)},null,he),ee)}u.forEach=j;function T(Ee,K,ee){return Y((G,X=null,he)=>Ee(Ie=>K(Ie)&&G.call(X,Ie),null,he),ee)}u.filter=T;function z(Ee){return Ee}u.signal=z;function B(...Ee){return(K,ee=null,G)=>(0,h.$ib)(...Ee.map(X=>X(he=>K.call(ee,he),null,G)))}u.any=B;function M(Ee,K,ee,G){let X=ee;return O(Ee,he=>(X=K(X,he),X),G)}u.reduce=M;function Y(Ee,K){let ee;const G={onWillAddFirstListener(){ee=Ee(X.fire,X)},onDidRemoveLastListener(){ee?.dispose()}};K||d(G);const X=new m(G);return K?.add(X),X.event}function J(Ee,K,ee=100,G=!1,X=!1,he,Ie){let U,Q,_,oe=0,Z;const le={leakWarningThreshold:he,onWillAddFirstListener(){U=Ee(ze=>{oe++,Q=K(Q,ze),G&&!_&&(be.fire(Q),Q=void 0),Z=()=>{const qe=Q;Q=void 0,_=void 0,(!G||oe>1)&&be.fire(qe),oe=0},typeof ee=="number"?(clearTimeout(_),_=setTimeout(Z,ee)):_===void 0&&(_=0,queueMicrotask(Z))})},onWillRemoveListener(){X&&oe>0&&Z?.()},onDidRemoveLastListener(){Z=void 0,U.dispose()}};Ie||d(le);const be=new m(le);return Ie?.add(be),be.event}u.debounce=J;function fe(Ee,K=0,ee){return u.debounce(Ee,(G,X)=>G?(G.push(X),G):[X],K,void 0,!0,void 0,ee)}u.accumulate=fe;function se(Ee,K=(G,X)=>G===X,ee){let G=!0,X;return T(Ee,he=>{const Ie=G||!K(he,X);return G=!1,X=he,Ie},ee)}u.latch=se;function ie(Ee,K,ee){return[u.filter(Ee,K,ee),u.filter(Ee,G=>!K(G),ee)]}u.split=ie;function V(Ee,K=!1,ee=[]){let G=ee.slice(),X=Ee(U=>{G?G.push(U):Ie.fire(U)});const he=()=>{G?.forEach(U=>Ie.fire(U)),G=null},Ie=new m({onWillAddFirstListener(){X||(X=Ee(U=>Ie.fire(U)))},onDidAddFirstListener(){G&&(K?setTimeout(he):he())},onDidRemoveLastListener(){X&&X.dispose(),X=null}});return Ie.event}u.buffer=V;class re{constructor(K){this.event=K,this.d=new h.$kb}map(K){return new re(O(this.event,K,this.d))}forEach(K){return new re(j(this.event,K,this.d))}filter(K){return new re(T(this.event,K,this.d))}reduce(K,ee){return new re(M(this.event,K,ee,this.d))}latch(){return new re(se(this.event,void 0,this.d))}debounce(K,ee=100,G=!1,X=!1,he){return new re(J(this.event,K,ee,G,X,he,this.d))}on(K,ee,G){return this.event(K,ee,G)}once(K,ee,G){return R(this.event)(K,ee,G)}dispose(){this.d.dispose()}}function pe(Ee){return new re(Ee)}u.chain=pe;function ae(Ee,K,ee=G=>G){const G=(...U)=>Ie.fire(ee(...U)),X=()=>Ee.on(K,G),he=()=>Ee.removeListener(K,G),Ie=new m({onWillAddFirstListener:X,onDidRemoveLastListener:he});return Ie.event}u.fromNodeEventEmitter=ae;function ne(Ee,K,ee=G=>G){const G=(...U)=>Ie.fire(ee(...U)),X=()=>Ee.addEventListener(K,G),he=()=>Ee.removeEventListener(K,G),Ie=new m({onWillAddFirstListener:X,onDidRemoveLastListener:he});return Ie.event}u.fromDOMEventEmitter=ne;function x(Ee){return new Promise(K=>R(Ee)(K))}u.toPromise=x;function N(Ee){const K=new m;return Ee.then(ee=>{K.fire(ee)},()=>{K.fire(void 0)}).finally(()=>{K.dispose()}),K.event}u.fromPromise=N;function q(Ee,K){return K(void 0),Ee(ee=>K(ee))}u.runAndSubscribe=q;function de(Ee,K){let ee=null;function G(he){ee?.dispose(),ee=new h.$kb,K(he,ee)}G(void 0);const X=Ee(he=>G(he));return(0,h.$jb)(()=>{X.dispose(),ee?.dispose()})}u.runAndSubscribeWithStore=de;class ye{constructor(K,ee){this._observable=K,this.d=0,this.f=!1;const G={onWillAddFirstListener:()=>{K.addObserver(this)},onDidRemoveLastListener:()=>{K.removeObserver(this)}};ee||d(G),this.emitter=new m(G),ee&&ee.add(this.emitter)}beginUpdate(K){this.d++}handlePossibleChange(K){}handleChange(K,ee){this.f=!0}endUpdate(K){this.d--,this.d===0&&(this._observable.reportChanges(),this.f&&(this.f=!1,this.emitter.fire(this._observable.get())))}}function ve(Ee,K){return new ye(Ee,K).emitter.event}u.fromObservable=ve;function we(Ee){return K=>{let ee=0,G=!1;const X={beginUpdate(){ee++},endUpdate(){ee--,ee===0&&(Ee.reportChanges(),G&&(G=!1,K()))},handlePossibleChange(){},handleChange(){G=!0}};return Ee.addObserver(X),Ee.reportChanges(),{dispose(){Ee.removeObserver(X)}}}}u.fromObservableLight=we})(g||(e.Event=g={}));class P{static{this.all=new Set}static{this.d=0}constructor(d){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${d}_${P.d++}`,P.all.add(this)}start(d){this.f=new A.$ac,this.listenerCount=d}stop(){if(this.f){const d=this.f.elapsed();this.durations.push(d),this.elapsedOverall+=d,this.invocationCount+=1,this.f=void 0}}}e.$cc=P;let I=-1;function $(u){const d=I;return I=u,{dispose(){I=d}}}e.$dc=$;class k{constructor(d,p=Math.random().toString(18).slice(2,5)){this.threshold=d,this.name=p,this.f=0}dispose(){this.d?.clear()}check(d,p){const R=this.threshold;if(R<=0||p<R)return;this.d||(this.d=new Map);const O=this.d.get(d.value)||0;if(this.d.set(d.value,O+1),this.f-=1,this.f<=0){this.f=R*.5;let j,T=0;for(const[z,B]of this.d)(!j||T<B)&&(j=z,T=B);console.warn(`[${this.name}] potential listener LEAK detected, having ${p} listeners already. MOST frequent listener (${T}):`),console.warn(j)}return()=>{const j=this.d.get(d.value)||0;this.d.set(d.value,j-1)}}}class C{static create(){return new C(new Error().stack??"")}constructor(d){this.value=d}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let E=0;class n{constructor(d){this.value=d,this.id=E++}}const o=2,a=(u,d)=>{if(u instanceof n)d(u);else for(let p=0;p<u.length;p++){const R=u[p];R&&d(R)}};class m{constructor(d){this.u=0,this.d=d,this.f=I>0||this.d?.leakWarningThreshold?new k(this.d?.leakWarningThreshold??I):void 0,this.g=this.d?._profName?new P(this.d._profName):void 0,this.t=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.t?.current===this&&this.t.reset(),this.q){if(f){const d=this.q;queueMicrotask(()=>{a(d,p=>p.stack?.print())})}this.q=void 0,this.u=0}this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.m??=(d,p,R)=>{if(this.f&&this.u>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),h.$lb.None;if(this.j)return h.$lb.None;p&&(d=d.bind(p));const O=new n(d);let j,T;this.f&&this.u>=Math.ceil(this.f.threshold*.2)&&(O.stack=C.create(),j=this.f.check(O.stack,this.u+1)),f&&(O.stack=T??C.create()),this.q?this.q instanceof n?(this.t??=new D,this.q=[this.q,O]):this.q.push(O):(this.d?.onWillAddFirstListener?.(this),this.q=O,this.d?.onDidAddFirstListener?.(this)),this.u++;const z=(0,h.$jb)(()=>{j?.(),this.v(O)});return R instanceof h.$kb?R.add(z):Array.isArray(R)&&R.push(z),z},this.m}v(d){if(this.d?.onWillRemoveListener?.(this),!this.q)return;if(this.u===1){this.q=void 0,this.d?.onDidRemoveLastListener?.(this),this.u=0;return}const p=this.q,R=p.indexOf(d);if(R===-1)throw console.log("disposed?",this.j),console.log("size?",this.u),console.log("arr?",JSON.stringify(this.q)),new Error("Attempted to dispose unknown listener");this.u--,p[R]=void 0;const O=this.t.current===this;if(this.u*o<=p.length){let j=0;for(let T=0;T<p.length;T++)p[T]?p[j++]=p[T]:O&&(this.t.end--,j<this.t.i&&this.t.i--);p.length=j}}w(d,p){if(!d)return;const R=this.d?.onListenerError||S.$Y;if(!R){d.value(p);return}try{d.value(p)}catch(O){R(O)}}x(d){const p=d.current.q;for(;d.i<d.end;)this.w(p[d.i++],d.value);d.reset()}fire(d){if(this.t?.current&&(this.x(this.t),this.g?.stop()),this.g?.start(this.u),this.q)if(this.q instanceof n)this.w(this.q,d);else{const p=this.t;p.enqueue(this,d,this.q.length),this.x(p)}this.g?.stop()}hasListeners(){return this.u>0}}e.$ec=m;const v=()=>new D;e.$fc=v;class D{constructor(){this.i=-1,this.end=0}enqueue(d,p,R){this.i=0,this.end=R,this.current=d,this.value=p}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends m{async fireAsync(d,p,R){if(this.q)for(this.h||(this.h=new L.$ub),a(this.q,O=>this.h.push([O.value,d]));this.h.size>0&&!p.isCancellationRequested;){const[O,j]=this.h.shift(),T=[],z={...j,token:p,waitUntil:B=>{if(Object.isFrozen(T))throw new Error("waitUntil can NOT be called asynchronous");R&&(B=R(B,O)),T.push(B)}};try{O(z)}catch(B){(0,S.$Y)(B);continue}Object.freeze(T),await Promise.allSettled(T).then(B=>{for(const M of B)M.status==="rejected"&&(0,S.$Y)(M.reason)})}}}e.$gc=t;class r extends m{get isPaused(){return this.h!==0}constructor(d){super(d),this.h=0,this.s=new L.$ub,this.y=d?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.y){if(this.s.size>0){const d=Array.from(this.s);this.s.clear(),super.fire(this.y(d))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(d){this.u&&(this.h!==0?this.s.push(d):super.fire(d))}}e.$hc=r;class s extends r{constructor(d){super(d),this.k=d.delay??100}fire(d){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(d)}}e.$ic=s;class i extends m{constructor(d){super(d),this.h=[],this.k=d?.merge}fire(d){this.hasListeners()&&(this.h.push(d),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(p=>super.fire(p)),this.h=[]}))}}e.$jc=i;class c{constructor(){this.f=!1,this.g=[],this.d=new m({onWillAddFirstListener:()=>this.h(),onDidRemoveLastListener:()=>this.j()})}get event(){return this.d.event}add(d){const p={event:d,listener:null};this.g.push(p),this.f&&this.k(p);const R=()=>{this.f&&this.m(p);const O=this.g.indexOf(p);this.g.splice(O,1)};return(0,h.$jb)((0,F.$cb)(R))}h(){this.f=!0,this.g.forEach(d=>this.k(d))}j(){this.f=!1,this.g.forEach(d=>this.m(d))}k(d){d.listener=d.event(p=>this.d.fire(p))}m(d){d.listener&&d.listener.dispose(),d.listener=null}dispose(){this.d.dispose()}}e.$kc=c;class l{constructor(d,p,R,O){this.d=new h.$kb;const j=this.d.add(new c),T=this.d.add(new h.$tb);function z(B){T.set(B,j.add(O(B)))}for(const B of d)z(B);this.d.add(p(B=>{z(B)})),this.d.add(R(B=>{T.deleteAndDispose(B)})),this.event=j.event}dispose(){this.d.dispose()}}e.$lc=l;class b{constructor(){this.d=[]}wrapEvent(d){return(p,R,O)=>d(j=>{const T=this.d[this.d.length-1];T?T.push(()=>p.call(R,j)):p.call(R,j)},void 0,O)}bufferEvents(d){const p=[];this.d.push(p);const R=d();return this.d.pop(),p.forEach(O=>O()),R}}e.$mc=b;class y{constructor(){this.d=!1,this.f=g.None,this.g=h.$lb.None,this.h=new m({onDidAddFirstListener:()=>{this.d=!0,this.g=this.f(this.h.fire,this.h)},onDidRemoveLastListener:()=>{this.d=!1,this.g.dispose()}}),this.event=this.h.event}set input(d){this.f=d,this.d&&(this.g.dispose(),this.g=d(this.h.fire,this.h))}dispose(){this.g.dispose(),this.h.dispose()}}e.$nc=y}),define(Se[22],De([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oc=e.CancellationToken=void 0;const F=Object.freeze(function(f,w){const g=setTimeout(f.bind(w),0);return{dispose(){clearTimeout(g)}}});var h;(function(f){function w(g){return g===f.None||g===f.Cancelled||g instanceof L?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}f.isCancellationToken=w,f.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),f.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(h||(e.CancellationToken=h={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new S.$ec),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(w){this.a=void 0,this.b=void 0,this.b=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new L),this.a}cancel(){this.a?this.a instanceof L&&this.a.cancel():this.a=h.Cancelled}dispose(w=!1){w&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof L&&this.a.dispose():this.a=h.None}}e.$oc=A}),define(Se[156],De([1,0,22]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$id=e.$hd=e.$gd=void 0;class F{constructor(f){this.b=f,this.a=null}get(){if(this.a)return this.a;const f=new S.$oc,w=this.b(f.token);return this.a={promise:w,dispose:()=>{this.a=null,f.cancel(),f.dispose()}},this.a}}e.$gd=F;class h{constructor(f){this.c=f,this.a=void 0,this.b=void 0}get(f){const w=JSON.stringify(f);return this.b!==w&&(this.b=w,this.a=this.c(f)),this.a}}e.$hd=h;class L{get cachedValues(){return this.a}constructor(f){this.b=f,this.a=new Map}get(f){if(this.a.has(f))return this.a.get(f);const w=this.b(f);return this.a.set(f,w),w}}e.$id=L}),define(Se[96],De([1,0,8,3]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=void 0;function h(v){const D=v;return D?typeof D.read=="function":!1}e.$pc=h;function L(v){const D=v;return D?[D.on,D.pause,D.resume,D.destroy].every(t=>typeof t=="function"):!1}e.$qc=L;function A(v){const D=v;return D?L(D.stream)&&Array.isArray(D.buffer)&&typeof D.ended=="boolean":!1}e.$rc=A;function f(v,D){return new w(v,D)}e.$sc=f;class w{constructor(D,t){this.e=D,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(D){if(!this.a.destroyed){if(this.a.flowing)this.g(D);else if(this.b.data.push(D),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(D){this.a.destroyed||(this.a.flowing?this.h(D):this.b.error.push(D))}end(D){this.a.destroyed||(typeof D<"u"&&this.write(D),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(D){this.c.data.slice(0).forEach(t=>t(D))}h(D){this.c.error.length===0?(0,S.$Y)(D):this.c.error.slice(0).forEach(t=>t(D))}i(){this.c.end.slice(0).forEach(D=>D())}on(D,t){if(!this.a.destroyed)switch(D){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(D,t){if(this.a.destroyed)return;let r;switch(D){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const s=r.indexOf(t);s>=0&&r.splice(s,1)}}j(){if(this.b.data.length>0){const D=this.e(this.b.data);this.g(D),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const D of this.b.error)this.h(D);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(v,D){const t=[];let r;for(;(r=v.read())!==null;)t.push(r);return D(t)}e.$tc=g;function P(v,D,t){const r=[];let s;for(;(s=v.read())!==null&&r.length<t;)r.push(s);return s===null&&r.length>0?D(r):{read:()=>{if(r.length>0)return r.shift();if(typeof s<"u"){const i=s;return s=void 0,i}return v.read()}}}e.$uc=P;function I(v,D){return new Promise((t,r)=>{const s=[];$(v,{onData:i=>{D&&s.push(i)},onError:i=>{D?r(i):t(void 0)},onEnd:()=>{t(D?D(s):void 0)}})})}e.$vc=I;function $(v,D,t){v.on("error",r=>{t?.isCancellationRequested||D.onError(r)}),v.on("end",()=>{t?.isCancellationRequested||D.onEnd()}),v.on("data",r=>{t?.isCancellationRequested||D.onData(r)})}e.$wc=$;function k(v,D){return new Promise((t,r)=>{const s=new F.$kb,i=[],c=y=>{if(i.push(y),i.length>D)return s.dispose(),v.pause(),t({stream:v,buffer:i,ended:!1})},l=y=>r(y),b=()=>t({stream:v,buffer:i,ended:!0});s.add((0,F.$jb)(()=>v.removeListener("error",l))),v.on("error",l),s.add((0,F.$jb)(()=>v.removeListener("end",b))),v.on("end",b),s.add((0,F.$jb)(()=>v.removeListener("data",c))),v.on("data",c)})}e.$xc=k;function C(v,D){const t=f(D);return t.end(v),t}e.$yc=C;function E(){const v=f(()=>{throw new Error("not supported")});return v.end(),v}e.$zc=E;function n(v){let D=!1;return{read:()=>D?null:(D=!0,v)}}e.$Ac=n;function o(v,D,t){const r=f(t);return $(v,{onData:s=>r.write(D.data(s)),onError:s=>r.error(D.error?D.error(s):s),onEnd:()=>r.end()}),r}e.$Bc=o;function a(v,D,t){let r=!1;return{read:()=>{const s=D.read();return r?s:(r=!0,s!==null?t([v,s]):v)}}}e.$Cc=a;function m(v,D,t){let r=!1;const s=f(t);return $(D,{onData:i=>r?s.write(i):(r=!0,s.write(t([v,i]))),onError:i=>s.error(i),onEnd:()=>{r||(r=!0,s.write(v)),s.end()}}),s}e.$Dc=m}),define(Se[21],De([1,0,55,96]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=void 0;const h=typeof Buffer<"u",L=new S.$T(()=>new Uint8Array(256));let A,f;class w{static alloc(p){return h?new w(Buffer.allocUnsafe(p)):new w(new Uint8Array(p))}static wrap(p){return h&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new w(p)}static fromString(p,R){return!(R?.dontUseNodeBuffer||!1)&&h?new w(Buffer.from(p)):(A||(A=new TextEncoder),new w(A.encode(p)))}static fromByteArray(p){const R=w.alloc(p.length);for(let O=0,j=p.length;O<j;O++)R.buffer[O]=p[O];return R}static concat(p,R){if(typeof R>"u"){R=0;for(let T=0,z=p.length;T<z;T++)R+=p[T].byteLength}const O=w.alloc(R);let j=0;for(let T=0,z=p.length;T<z;T++){const B=p[T];O.set(B,j),j+=B.byteLength}return O}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=w.alloc(this.byteLength);return p.set(this),p}toString(){return h?this.buffer.toString():(f||(f=new TextDecoder),f.decode(this.buffer))}slice(p,R){return new w(this.buffer.subarray(p,R))}set(p,R){if(p instanceof w)this.buffer.set(p.buffer,R);else if(p instanceof Uint8Array)this.buffer.set(p,R);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),R);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return $(this.buffer,p)}writeUInt32BE(p,R){k(this.buffer,p,R)}readUInt32LE(p){return C(this.buffer,p)}writeUInt32LE(p,R){E(this.buffer,p,R)}readUInt8(p){return n(this.buffer,p)}writeUInt8(p,R){o(this.buffer,p,R)}indexOf(p,R=0){return g(this.buffer,p instanceof w?p.buffer:p,R)}}e.$Ec=w;function g(d,p,R=0){const O=p.byteLength,j=d.byteLength;if(O===0)return 0;if(O===1)return d.indexOf(p[0]);if(O>j-R)return-1;const T=L.value;T.fill(p.length);for(let Y=0;Y<p.length;Y++)T[p[Y]]=p.length-Y-1;let z=R+p.length-1,B=z,M=-1;for(;z<j;)if(d[z]===p[B]){if(B===0){M=z;break}z--,B--}else z+=Math.max(p.length-B,T[d[z]]),B=p.length-1;return M}e.$Fc=g;function P(d,p){return d[p+0]<<0>>>0|d[p+1]<<8>>>0}e.$Gc=P;function I(d,p,R){d[R+0]=p&255,p=p>>>8,d[R+1]=p&255}e.$Hc=I;function $(d,p){return d[p]*2**24+d[p+1]*2**16+d[p+2]*2**8+d[p+3]}e.$Ic=$;function k(d,p,R){d[R+3]=p,p=p>>>8,d[R+2]=p,p=p>>>8,d[R+1]=p,p=p>>>8,d[R]=p}e.$Jc=k;function C(d,p){return d[p+0]<<0>>>0|d[p+1]<<8>>>0|d[p+2]<<16>>>0|d[p+3]<<24>>>0}e.$Kc=C;function E(d,p,R){d[R+0]=p&255,p=p>>>8,d[R+1]=p&255,p=p>>>8,d[R+2]=p&255,p=p>>>8,d[R+3]=p&255}e.$Lc=E;function n(d,p){return d[p]}e.$Mc=n;function o(d,p,R){d[R]=p}e.$Nc=o;function a(d){return F.$tc(d,p=>w.concat(p))}e.$Oc=a;function m(d){return F.$Ac(d)}e.$Pc=m;function v(d){return F.$vc(d,p=>w.concat(p))}e.$Qc=v;async function D(d){return d.ended?w.concat(d.buffer):w.concat([...d.buffer,await v(d.stream)])}e.$Rc=D;function t(d){return F.$yc(d,p=>w.concat(p))}e.$Sc=t;function r(d){return F.$Bc(d,{data:p=>typeof p=="string"?w.fromString(p):w.wrap(p)},p=>w.concat(p))}e.$Tc=r;function s(d){return F.$sc(p=>w.concat(p),d)}e.$Uc=s;function i(d,p){return F.$Cc(d,p,R=>w.concat(R))}e.$Vc=i;function c(d,p){return F.$Dc(d,p,R=>w.concat(R))}e.$Wc=c;function l(d){let p=0,R=0,O=0;const j=new Uint8Array(Math.floor(d.length/4*3)),T=B=>{switch(R){case 3:j[O++]=p|B,R=0;break;case 2:j[O++]=p|B>>>2,p=B<<6,R=3;break;case 1:j[O++]=p|B>>>4,p=B<<4,R=2;break;default:p=B<<2,R=1}};for(let B=0;B<d.length;B++){const M=d.charCodeAt(B);if(M>=65&&M<=90)T(M-65);else if(M>=97&&M<=122)T(M-97+26);else if(M>=48&&M<=57)T(M-48+52);else if(M===43||M===45)T(62);else if(M===47||M===95)T(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${d[B]}`)}}const z=O;for(;R>0;)T(0);return w.wrap(j).slice(0,z)}e.$Xc=l;const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:d},p=!0,R=!1){const O=R?y:b;let j="";const T=d.byteLength%3;let z=0;for(;z<d.byteLength-T;z+=3){const B=d[z+0],M=d[z+1],Y=d[z+2];j+=O[B>>>2],j+=O[(B<<4|M>>>4)&63],j+=O[(M<<2|Y>>>6)&63],j+=O[Y&63]}if(T===1){const B=d[z+0];j+=O[B>>>2],j+=O[B<<4&63],p&&(j+="==")}else if(T===2){const B=d[z+0],M=d[z+1];j+=O[B>>>2],j+=O[(B<<4|M>>>4)&63],j+=O[M<<2&63],p&&(j+="=")}return j}e.$Yc=u}),define(Se[15],De([1,0,156,55]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=e.$ge=e.$fe=e.$ee=e.GraphemeBreakType=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=e.$od=e.$nd=e.$md=e.$ld=void 0;function h(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}e.$ld=h;const L=/{(\d+)}/g;function A(Pe,...Oe){return Oe.length===0?Pe:Pe.replace(L,function(We,Re){const Qe=parseInt(Re,10);return isNaN(Qe)||Qe<0||Qe>=Oe.length?We:Oe[Qe]})}e.$md=A;const f=/{([^}]+)}/g;function w(Pe,Oe){return Pe.replace(f,(We,Re)=>Oe[Re]??We)}e.$nd=w;function g(Pe){return Pe.replace(/[<>&]/g,function(Oe){switch(Oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Oe}})}e.$od=g;function P(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$pd=P;function I(Pe,Oe){let We=0;const Re=Oe.charCodeAt(0);for(let Qe=Pe.length-1;Qe>=0;Qe--)Pe.charCodeAt(Qe)===Re&&We++;return We}e.$qd=I;function $(Pe,Oe,We="\u2026"){return Pe.length<=Oe?Pe:`${Pe.substr(0,Oe)}${We}`}e.$rd=$;function k(Pe,Oe=" "){const We=C(Pe,Oe);return E(We,Oe)}e.$sd=k;function C(Pe,Oe){if(!Pe||!Oe)return Pe;const We=Oe.length;if(We===0||Pe.length===0)return Pe;let Re=0;for(;Pe.indexOf(Oe,Re)===Re;)Re=Re+We;return Pe.substring(Re)}e.$td=C;function E(Pe,Oe){if(!Pe||!Oe)return Pe;const We=Oe.length,Re=Pe.length;if(We===0||Re===0)return Pe;let Qe=Re,ue=-1;for(;ue=Pe.lastIndexOf(Oe,Qe-1),!(ue===-1||ue+We!==Qe);){if(ue===0)return"";Qe=ue}return Pe.substring(0,Qe)}e.$ud=E;function n(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$vd=n;function o(Pe){return Pe.replace(/\*/g,"")}e.$wd=o;function a(Pe,Oe,We={}){if(!Pe)throw new Error("Cannot create regex from empty string");Oe||(Pe=P(Pe)),We.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let Re="";return We.global&&(Re+="g"),We.matchCase||(Re+="i"),We.multiline&&(Re+="m"),We.unicode&&(Re+="u"),new RegExp(Pe,Re)}e.$xd=a;function m(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}e.$yd=m;function v(Pe){return Pe.split(/\r\n|\r|\n/)}e.$zd=v;function D(Pe){for(let Oe=0,We=Pe.length;Oe<We;Oe++){const Re=Pe.charCodeAt(Oe);if(Re!==32&&Re!==9)return Oe}return-1}e.$Ad=D;function t(Pe,Oe=0,We=Pe.length){for(let Re=Oe;Re<We;Re++){const Qe=Pe.charCodeAt(Re);if(Qe!==32&&Qe!==9)return Pe.substring(Oe,Re)}return Pe.substring(Oe,We)}e.$Bd=t;function r(Pe,Oe=Pe.length-1){for(let We=Oe;We>=0;We--){const Re=Pe.charCodeAt(We);if(Re!==32&&Re!==9)return We}return-1}e.$Cd=r;function s(Pe,Oe,We){const Re=[];let Qe=0;for(const ue of Pe.matchAll(Oe)){if(Re.push(Pe.slice(Qe,ue.index)),ue.index===void 0)throw new Error("match.index should be defined");Qe=ue.index+ue[0].length,Re.push(We(ue[0],...ue.slice(1),ue.index,Pe,ue.groups))}return Re.push(Pe.slice(Qe)),Promise.all(Re).then(ue=>ue.join(""))}e.$Dd=s;function i(Pe,Oe){return Pe<Oe?-1:Pe>Oe?1:0}e.$Ed=i;function c(Pe,Oe,We=0,Re=Pe.length,Qe=0,ue=Oe.length){for(;We<Re&&Qe<ue;We++,Qe++){const Ve=Pe.charCodeAt(We),je=Oe.charCodeAt(Qe);if(Ve<je)return-1;if(Ve>je)return 1}const ce=Re-We,Ce=ue-Qe;return ce<Ce?-1:ce>Ce?1:0}e.$Fd=c;function l(Pe,Oe){return b(Pe,Oe,0,Pe.length,0,Oe.length)}e.$Gd=l;function b(Pe,Oe,We=0,Re=Pe.length,Qe=0,ue=Oe.length){for(;We<Re&&Qe<ue;We++,Qe++){let Ve=Pe.charCodeAt(We),je=Oe.charCodeAt(Qe);if(Ve===je)continue;if(Ve>=128||je>=128)return c(Pe.toLowerCase(),Oe.toLowerCase(),We,Re,Qe,ue);u(Ve)&&(Ve-=32),u(je)&&(je-=32);const Xe=Ve-je;if(Xe!==0)return Xe}const ce=Re-We,Ce=ue-Qe;return ce<Ce?-1:ce>Ce?1:0}e.$Hd=b;function y(Pe){return Pe>=48&&Pe<=57}e.$Id=y;function u(Pe){return Pe>=97&&Pe<=122}e.$Jd=u;function d(Pe){return Pe>=65&&Pe<=90}e.$Kd=d;function p(Pe,Oe){return Pe.length===Oe.length&&b(Pe,Oe)===0}e.$Ld=p;function R(Pe,Oe){const We=Oe.length;return Oe.length>Pe.length?!1:b(Pe,Oe,0,We)===0}e.$Md=R;function O(Pe,Oe){const We=Math.min(Pe.length,Oe.length);let Re;for(Re=0;Re<We;Re++)if(Pe.charCodeAt(Re)!==Oe.charCodeAt(Re))return Re;return We}e.$Nd=O;function j(Pe,Oe){const We=Math.min(Pe.length,Oe.length);let Re;const Qe=Pe.length-1,ue=Oe.length-1;for(Re=0;Re<We;Re++)if(Pe.charCodeAt(Qe-Re)!==Oe.charCodeAt(ue-Re))return Re;return We}e.$Od=j;function T(Pe){return 55296<=Pe&&Pe<=56319}e.$Pd=T;function z(Pe){return 56320<=Pe&&Pe<=57343}e.$Qd=z;function B(Pe,Oe){return(Pe-55296<<10)+(Oe-56320)+65536}e.$Rd=B;function M(Pe,Oe,We){const Re=Pe.charCodeAt(We);if(T(Re)&&We+1<Oe){const Qe=Pe.charCodeAt(We+1);if(z(Qe))return B(Re,Qe)}return Re}e.$Sd=M;function Y(Pe,Oe){const We=Pe.charCodeAt(Oe-1);if(z(We)&&Oe>1){const Re=Pe.charCodeAt(Oe-2);if(T(Re))return B(Re,We)}return We}class J{get offset(){return this.e}constructor(Oe,We=0){this.c=Oe,this.d=Oe.length,this.e=We}setOffset(Oe){this.e=Oe}prevCodePoint(){const Oe=Y(this.c,this.e);return this.e-=Oe>=65536?2:1,Oe}nextCodePoint(){const Oe=M(this.c,this.d,this.e);return this.e+=Oe>=65536?2:1,Oe}eol(){return this.e>=this.d}}e.$Td=J;class fe{get offset(){return this.c.offset}constructor(Oe,We=0){this.c=new J(Oe,We)}nextGraphemeLength(){const Oe=le.getInstance(),We=this.c,Re=We.offset;let Qe=Oe.getGraphemeBreakType(We.nextCodePoint());for(;!We.eol();){const ue=We.offset,ce=Oe.getGraphemeBreakType(We.nextCodePoint());if(oe(Qe,ce)){We.setOffset(ue);break}Qe=ce}return We.offset-Re}prevGraphemeLength(){const Oe=le.getInstance(),We=this.c,Re=We.offset;let Qe=Oe.getGraphemeBreakType(We.prevCodePoint());for(;We.offset>0;){const ue=We.offset,ce=Oe.getGraphemeBreakType(We.prevCodePoint());if(oe(ce,Qe)){We.setOffset(ue);break}Qe=ce}return Re-We.offset}eol(){return this.c.eol()}}e.$Ud=fe;function se(Pe,Oe){return new fe(Pe,Oe).nextGraphemeLength()}e.$Vd=se;function ie(Pe,Oe){return new fe(Pe,Oe).prevGraphemeLength()}e.$Wd=ie;function V(Pe,Oe){Oe>0&&z(Pe.charCodeAt(Oe))&&Oe--;const We=Oe+se(Pe,Oe);return[We-ie(Pe,We),We]}e.$Xd=V;function re(Pe){const Oe=new fe(Pe);let We=0;for(;!Oe.eol();)We++,Oe.nextGraphemeLength();return We}e.$Yd=re;let pe;function ae(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ne(Pe){return pe||(pe=ae()),pe.test(Pe)}e.$Zd=ne;const x=/^[\t\n\r\x20-\x7E]*$/;function N(Pe){return x.test(Pe)}e.$1d=N,e.$2d=/[\u2028\u2029]/;function q(Pe){return e.$2d.test(Pe)}e.$3d=q;function de(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}e.$4d=de;function ye(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}e.$5d=ye;function ve(Pe,Oe){if(Pe.length<Oe)return Pe;const We=/\b/g;let Re=0;for(;We.test(Pe)&&!(Pe.length-We.lastIndex<Oe);)Re=We.lastIndex,We.lastIndex+=1;return Pe.substring(Re).replace(/^\s/,"")}e.$6d=ve;const we=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Ee=/\x1b\].*?\x07/g;function K(Pe){return Pe&&(Pe=Pe.replace(we,"").replace(Ee,"")),Pe}e.$7d=K,e.$8d=String.fromCharCode(65279);function ee(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===65279)}e.$9d=ee;function G(Pe){return ee(Pe)?Pe.substr(1):Pe}e.$0d=G;function X(Pe,Oe){if(!Pe||!Oe||Pe.length<Oe.length)return!1;const We=Oe.length,Re=Pe.toLowerCase();let Qe=0,ue=-1;for(;Qe<We;){const ce=Re.indexOf(Oe[Qe],ue+1);if(ce<0)return!1;ue=ce,Qe++}return!0}e.$$d=X;function he(Pe,Oe=!1){return Pe?(Oe&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}e.$_d=he;function Ie(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}e.$ae=Ie;function U(Pe,Oe=1){if(Oe===0)return"";let We=-1;do We=Pe.indexOf(`
`,We+1),Oe--;while(Oe>0&&We>=0);return We===-1?Pe:(Pe[We-1]==="\r"&&We--,Pe.substr(0,We))}e.$be=U;function Q(Pe){return Pe=Pe%(2*26),Pe<26?String.fromCharCode(97+Pe):String.fromCharCode(65+Pe-26)}e.$ce=Q;function _(Pe){return le.getInstance().getGraphemeBreakType(Pe)}e.$de=_;function oe(Pe,Oe){return Pe===0?Oe!==5&&Oe!==7:Pe===2&&Oe===3?!1:Pe===4||Pe===2||Pe===3||Oe===4||Oe===2||Oe===3?!0:!(Pe===8&&(Oe===8||Oe===9||Oe===11||Oe===12)||(Pe===11||Pe===9)&&(Oe===9||Oe===10)||(Pe===12||Pe===10)&&Oe===10||Oe===5||Oe===13||Oe===7||Pe===1||Pe===13&&Oe===14||Pe===6&&Oe===6)}var Z;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(Z||(e.GraphemeBreakType=Z={}));class le{static{this.c=null}static getInstance(){return le.c||(le.c=new le),le.c}constructor(){this.d=be()}getGraphemeBreakType(Oe){if(Oe<32)return Oe===10?3:Oe===13?2:4;if(Oe<127)return 0;const We=this.d,Re=We.length/3;let Qe=1;for(;Qe<=Re;)if(Oe<We[3*Qe])Qe=2*Qe;else if(Oe>We[3*Qe+1])Qe=2*Qe+1;else return We[3*Qe+2];return 0}}function be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(Pe,Oe){if(Pe===0)return 0;const We=qe(Pe,Oe);if(We!==void 0)return We;const Re=new J(Oe,Pe);return Re.prevCodePoint(),Re.offset}e.$ee=ze;function qe(Pe,Oe){const We=new J(Oe,Pe);let Re=We.prevCodePoint();for(;_e(Re)||Re===65039||Re===8419;){if(We.offset===0)return;Re=We.prevCodePoint()}if(!ye(Re))return;let Qe=We.offset;return Qe>0&&We.prevCodePoint()===8205&&(Qe=We.offset),Qe}function _e(Pe){return 127995<=Pe&&Pe<=127999}var Ze;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})(Ze||(Ze={})),e.$fe="\xA0";class it{static{this.c=new F.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new S.$hd(Oe=>{function We(Xe){const rt=new Map;for(let ot=0;ot<Xe.length;ot+=2)rt.set(Xe[ot],Xe[ot+1]);return rt}function Re(Xe,rt){const ot=new Map(Xe);for(const[$t,Ct]of rt)ot.set($t,Ct);return ot}function Qe(Xe,rt){if(!Xe)return rt;const ot=new Map;for(const[$t,Ct]of Xe)rt.has($t)&&ot.set($t,Ct);return ot}const ue=this.c.value;let ce=Oe.filter(Xe=>!Xe.startsWith("_")&&Xe in ue);ce.length===0&&(ce=["_default"]);let Ce;for(const Xe of ce){const rt=We(ue[Xe]);Ce=Qe(Ce,rt)}const Ve=We(ue._common),je=Re(Ve,Ce);return new it(je)})}static getInstance(Oe){return it.d.get(Array.from(Oe))}static{this.e=new F.$T(()=>Object.keys(it.c.value).filter(Oe=>!Oe.startsWith("_")))}static getLocales(){return it.e.value}constructor(Oe){this.f=Oe}isAmbiguous(Oe){return this.f.has(Oe)}getPrimaryConfusable(Oe){return this.f.get(Oe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$ge=it;class et{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(et.c())),this.d}static isInvisibleCharacter(Oe){return et.e().has(Oe)}static get codePoints(){return et.e()}}e.$he=et}),define(Se[119],De([1,0,28,15]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.FuzzyScore=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.or=void 0;function h(...G){return function(X,he){for(let Ie=0,U=G.length;Ie<U;Ie++){const Q=G[Ie](X,he);if(Q)return Q}return null}}e.or=h,e.$kj=L.bind(void 0,!1),e.$lj=L.bind(void 0,!0);function L(G,X,he){if(!he||he.length<X.length)return null;let Ie;return G?Ie=F.$Md(he,X):Ie=he.indexOf(X)===0,Ie?X.length>0?[{start:0,end:X.length}]:[]:null}function A(G,X){const he=X.toLowerCase().indexOf(G.toLowerCase());return he===-1?null:[{start:he,end:he+G.length}]}e.$mj=A;function f(G,X){return w(G.toLowerCase(),X.toLowerCase(),0,0)}e.$nj=f;function w(G,X,he,Ie){if(he===G.length)return[];if(Ie===X.length)return null;if(G[he]===X[Ie]){let U=null;return(U=w(G,X,he+1,Ie+1))?o({start:Ie,end:Ie+1},U):null}return w(G,X,he,Ie+1)}function g(G){return 97<=G&&G<=122}function P(G){return 65<=G&&G<=90}e.$oj=P;function I(G){return 48<=G&&G<=57}function $(G){return G===32||G===9||G===10||G===13}const k=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>k.add(G.charCodeAt(0)));function C(G){return $(G)||k.has(G)}function E(G,X){return G===X||C(G)&&C(X)}function n(G){return g(G)||P(G)||I(G)}function o(G,X){return X.length===0?X=[G]:G.end===X[0].start?X[0].start=G.start:X.unshift(G),X}function a(G,X){for(let he=X;he<G.length;he++){const Ie=G.charCodeAt(he);if(P(Ie)||I(Ie)||he>0&&!n(G.charCodeAt(he-1)))return he}return G.length}function m(G,X,he,Ie){if(he===G.length)return[];if(Ie===X.length)return null;if(G[he]!==X[Ie].toLowerCase())return null;{let U=null,Q=Ie+1;for(U=m(G,X,he+1,Ie+1);!U&&(Q=a(X,Q))<X.length;)U=m(G,X,he+1,Q),Q++;return U===null?null:o({start:Ie,end:Ie+1},U)}}function v(G){let X=0,he=0,Ie=0,U=0,Q=0;for(let be=0;be<G.length;be++)Q=G.charCodeAt(be),P(Q)&&X++,g(Q)&&he++,n(Q)&&Ie++,I(Q)&&U++;const _=X/G.length,oe=he/G.length,Z=Ie/G.length,le=U/G.length;return{upperPercent:_,lowerPercent:oe,alphaPercent:Z,numericPercent:le}}function D(G){const{upperPercent:X,lowerPercent:he}=G;return he===0&&X>.6}function t(G){const{upperPercent:X,lowerPercent:he,alphaPercent:Ie,numericPercent:U}=G;return he>.2&&X<.8&&Ie>.6&&U<.2}function r(G){let X=0,he=0,Ie=0,U=0;for(let Q=0;Q<G.length;Q++)Ie=G.charCodeAt(Q),P(Ie)&&X++,g(Ie)&&he++,$(Ie)&&U++;return(X===0||he===0)&&U===0?G.length<=30:X<=5}function s(G,X){if(!X||(X=X.trim(),X.length===0)||!r(G)||X.length>60)return null;const he=v(X);if(!t(he)){if(!D(he))return null;X=X.toLowerCase()}let Ie=null,U=0;for(G=G.toLowerCase();U<X.length&&(Ie=m(G,X,0,U))===null;)U=a(X,U+1);return Ie}e.$pj=s;function i(G,X,he=!1){if(!X||X.length===0)return null;let Ie=null,U=0;for(G=G.toLowerCase(),X=X.toLowerCase();U<X.length&&(Ie=c(G,X,0,U,he))===null;)U=l(X,U+1);return Ie}e.$qj=i;function c(G,X,he,Ie,U){if(he===G.length)return[];if(Ie===X.length)return null;if(E(G.charCodeAt(he),X.charCodeAt(Ie))){let Q=null,_=Ie+1;if(Q=c(G,X,he+1,Ie+1,U),!U)for(;!Q&&(_=l(X,_))<X.length;)Q=c(G,X,he+1,_,U),_++;return Q?G.charCodeAt(he)!==X.charCodeAt(Ie)?Q:o({start:Ie,end:Ie+1},Q):null}else return null}function l(G,X){for(let he=X;he<G.length;he++)if(C(G.charCodeAt(he))||he>0&&C(G.charCodeAt(he-1)))return he;return G.length}const b=h(e.$lj,s,A),y=h(e.$lj,s,f),u=new S.$qi(1e4);function d(G,X,he=!1){if(typeof G!="string"||typeof X!="string")return null;let Ie=u.get(G);Ie||(Ie=new RegExp(F.$vd(G),"i"),u.set(G,Ie));const U=Ie.exec(X);return U?[{start:U.index,end:U.index+U[0].length}]:he?y(G,X):b(G,X)}e.$rj=d;function p(G,X){const he=de(G,G.toLowerCase(),0,X,X.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return he?O(he):null}e.$sj=p;function R(G,X,he,Ie,U,Q){const _=Math.min(13,G.length);for(;he<_;he++){const oe=de(G,X,he,Ie,U,Q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return oe}return[0,Q]}e.$tj=R;function O(G){if(typeof G>"u")return[];const X=[],he=G[1];for(let Ie=G.length-1;Ie>1;Ie--){const U=G[Ie]+he,Q=X[X.length-1];Q&&Q.end===U?Q.end=U+1:X.push({start:U,end:U+1})}return X}e.$uj=O;const j=128;function T(){const G=[],X=[];for(let he=0;he<=j;he++)X[he]=0;for(let he=0;he<=j;he++)G.push(X.slice(0));return G}function z(G){const X=[];for(let he=0;he<=G;he++)X[he]=0;return X}const B=z(2*j),M=z(2*j),Y=T(),J=T(),fe=T(),se=!1;function ie(G,X,he,Ie,U){function Q(oe,Z,le=" "){for(;oe.length<Z;)oe=le+oe;return oe}let _=` |   |${Ie.split("").map(oe=>Q(oe,3)).join("|")}
`;for(let oe=0;oe<=he;oe++)oe===0?_+=" |":_+=`${X[oe-1]}|`,_+=G[oe].slice(0,U+1).map(Z=>Q(Z.toString(),3)).join("|")+`
`;return _}function V(G,X,he,Ie){G=G.substr(X),he=he.substr(Ie),console.log(ie(J,G,G.length,he,he.length)),console.log(ie(fe,G,G.length,he,he.length)),console.log(ie(Y,G,G.length,he,he.length))}function re(G,X){if(X<0||X>=G.length)return!1;const he=G.codePointAt(X);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!F.$5d(he)}}function pe(G,X){if(X<0||X>=G.length)return!1;switch(G.charCodeAt(X)){case 32:case 9:return!0;default:return!1}}function ae(G,X,he){return X[G]!==he[G]}function ne(G,X,he,Ie,U,Q,_=!1){for(;X<he&&U<Q;)G[X]===Ie[U]&&(_&&(B[X]=U),X+=1),U+=1;return X===he}e.$vj=ne;var x;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(x||(x={}));var N;(function(G){G.Default=[-100,0];function X(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}G.isDefault=X})(N||(e.FuzzyScore=N={}));class q{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(X,he){this.firstMatchCanBeWeak=X,this.boostFullMatch=he}}e.$wj=q;function de(G,X,he,Ie,U,Q,_=q.default){const oe=G.length>j?j:G.length,Z=Ie.length>j?j:Ie.length;if(he>=oe||Q>=Z||oe-he>Z-Q||!ne(X,he,oe,U,Q,Z,!0))return;ye(oe,Z,he,Q,X,U);let le=1,be=1,ze=he,qe=Q;const _e=[!1];for(le=1,ze=he;ze<oe;le++,ze++){const Oe=B[ze],We=M[ze],Re=ze+1<oe?M[ze+1]:Z;for(be=Oe-Q+1,qe=Oe;qe<Re;be++,qe++){let Qe=Number.MIN_SAFE_INTEGER,ue=!1;qe<=We&&(Qe=ve(G,X,ze,he,Ie,U,qe,Z,Q,Y[le-1][be-1]===0,_e));let ce=0;Qe!==Number.MAX_SAFE_INTEGER&&(ue=!0,ce=Qe+J[le-1][be-1]);const Ce=qe>Oe,Ve=Ce?J[le][be-1]+(Y[le][be-1]>0?-5:0):0,je=qe>Oe+1&&Y[le][be-1]>0,Xe=je?J[le][be-2]+(Y[le][be-2]>0?-5:0):0;if(je&&(!Ce||Xe>=Ve)&&(!ue||Xe>=ce))J[le][be]=Xe,fe[le][be]=3,Y[le][be]=0;else if(Ce&&(!ue||Ve>=ce))J[le][be]=Ve,fe[le][be]=2,Y[le][be]=0;else if(ue)J[le][be]=ce,fe[le][be]=1,Y[le][be]=Y[le-1][be-1]+1;else throw new Error("not possible")}}if(se&&V(G,he,Ie,Q),!_e[0]&&!_.firstMatchCanBeWeak)return;le--,be--;const Ze=[J[le][be],Q];let it=0,et=0;for(;le>=1;){let Oe=be;do{const We=fe[le][Oe];if(We===3)Oe=Oe-2;else if(We===2)Oe=Oe-1;else break}while(Oe>=1);it>1&&X[he+le-1]===U[Q+be-1]&&!ae(Oe+Q-1,Ie,U)&&it+1>Y[le][Oe]&&(Oe=be),Oe===be?it++:it=1,et||(et=Oe),le--,be=Oe-1,Ze.push(be)}Z===oe&&_.boostFullMatch&&(Ze[0]+=2);const Pe=et-oe;return Ze[0]-=Pe,Ze}e.$xj=de;function ye(G,X,he,Ie,U,Q){let _=G-1,oe=X-1;for(;_>=he&&oe>=Ie;)U[_]===Q[oe]&&(M[_]=oe,_--),oe--}function ve(G,X,he,Ie,U,Q,_,oe,Z,le,be){if(X[he]!==Q[_])return Number.MIN_SAFE_INTEGER;let ze=1,qe=!1;return _===he-Ie?ze=G[he]===U[_]?7:5:ae(_,U,Q)&&(_===0||!ae(_-1,U,Q))?(ze=G[he]===U[_]?7:5,qe=!0):re(Q,_)&&(_===0||!re(Q,_-1))?ze=5:(re(Q,_-1)||pe(Q,_-1))&&(ze=5,qe=!0),ze>1&&he===Ie&&(be[0]=!0),qe||(qe=ae(_,U,Q)||re(Q,_-1)||pe(Q,_-1)),he===Ie?_>Z&&(ze-=qe?3:5):le?ze+=qe?2:0:ze+=qe?0:1,_+1===oe&&(ze-=qe?3:5),ze}function we(G,X,he,Ie,U,Q,_){return K(G,X,he,Ie,U,Q,!0,_)}e.$yj=we;function Ee(G,X,he,Ie,U,Q,_){return K(G,X,he,Ie,U,Q,!1,_)}e.$zj=Ee;function K(G,X,he,Ie,U,Q,_,oe){let Z=de(G,X,he,Ie,U,Q,oe);if(Z&&!_)return Z;if(G.length>=3){const le=Math.min(7,G.length-1);for(let be=he+1;be<le;be++){const ze=ee(G,be);if(ze){const qe=de(ze,ze.toLowerCase(),he,Ie,U,Q,oe);qe&&(qe[0]-=3,(!Z||qe[0]>Z[0])&&(Z=qe))}}}return Z}function ee(G,X){if(X+1>=G.length)return;const he=G[X],Ie=G[X+1];if(he!==Ie)return G.slice(0,X)+Ie+he+G.slice(X+2)}}),define(Se[74],De([1,0,15]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=void 0;function F(o){return h(o,0)}e.$di=F;function h(o,a){switch(typeof o){case"object":return o===null?L(349,a):Array.isArray(o)?w(o,a):g(o,a);case"string":return f(o,a);case"boolean":return A(o,a);case"number":return L(o,a);case"undefined":return L(937,a);default:return L(617,a)}}e.$ei=h;function L(o,a){return(a<<5)-a+o|0}e.$fi=L;function A(o,a){return L(o?433:863,a)}function f(o,a){a=L(149417,a);for(let m=0,v=o.length;m<v;m++)a=L(o.charCodeAt(m),a);return a}e.$gi=f;function w(o,a){return a=L(104579,a),o.reduce((m,v)=>h(v,m),a)}function g(o,a){return a=L(181387,a),Object.keys(o).sort().reduce((m,v)=>(m=f(v,m),h(o[v],m)),a)}class P{constructor(){this.g=0}get value(){return this.g}hash(a){return this.g=h(a,this.g),this.g}}e.$hi=P;var I;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function $(o,a,m=32){const v=m-a,D=~((1<<v)-1);return(o<<a|(D&o)>>>v)>>>0}function k(o,a=0,m=o.byteLength,v=0){for(let D=0;D<m;D++)o[a+D]=v}function C(o,a,m="0"){for(;o.length<a;)o=m+o;return o}function E(o,a=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(m=>m.toString(16).padStart(2,"0")).join(""):C((o>>>0).toString(16),a/4)}e.$ii=E;class n{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(a){const m=a.length;if(m===0)return;const v=this.p;let D=this.r,t=this.u,r,s;for(t!==0?(r=t,s=-1,t=0):(r=a.charCodeAt(0),s=0);;){let i=r;if(S.$Pd(r))if(s+1<m){const c=a.charCodeAt(s+1);S.$Qd(c)?(s++,i=S.$Rd(r,c)):i=65533}else{t=r;break}else S.$Qd(r)&&(i=65533);if(D=this.w(v,D,i),s++,s<m)r=a.charCodeAt(s);else break}this.r=D,this.u=t}w(a,m,v){return v<128?a[m++]=v:v<2048?(a[m++]=192|(v&1984)>>>6,a[m++]=128|(v&63)>>>0):v<65536?(a[m++]=224|(v&61440)>>>12,a[m++]=128|(v&4032)>>>6,a[m++]=128|(v&63)>>>0):(a[m++]=240|(v&1835008)>>>18,a[m++]=128|(v&258048)>>>12,a[m++]=128|(v&4032)>>>6,a[m++]=128|(v&63)>>>0),m>=64&&(this.y(),m-=64,this.t+=64,a[0]=a[64+0],a[1]=a[64+1],a[2]=a[64+2]),m}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),E(this.h)+E(this.l)+E(this.m)+E(this.n)+E(this.o)}x(){this.p[this.r++]=128,k(this.p,this.r),this.r>56&&(this.y(),k(this.p));const a=8*this.t;this.q.setUint32(56,Math.floor(a/4294967296),!1),this.q.setUint32(60,a%4294967296,!1),this.y()}y(){const a=n.g,m=this.q;for(let b=0;b<64;b+=4)a.setUint32(b,m.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)a.setUint32(b,$(a.getUint32(b-12,!1)^a.getUint32(b-32,!1)^a.getUint32(b-56,!1)^a.getUint32(b-64,!1),1),!1);let v=this.h,D=this.l,t=this.m,r=this.n,s=this.o,i,c,l;for(let b=0;b<80;b++)b<20?(i=D&t|~D&r,c=1518500249):b<40?(i=D^t^r,c=1859775393):b<60?(i=D&t|D&r|t&r,c=2400959708):(i=D^t^r,c=3395469782),l=$(v,5)+i+s+c+a.getUint32(b*4,!1)&4294967295,s=r,r=t,t=$(D,30),D=v,v=l;this.h=this.h+v&4294967295,this.l=this.l+D&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+s&4294967295}}e.$ji=n}),define(Se[40],De([1,0,15]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(h){h[h.Ignore=0]="Ignore",h[h.Info=1]="Info",h[h.Warning=2]="Warning",h[h.Error=3]="Error"})(F||(F={})),function(h){const L="error",A="warning",f="warn",w="info",g="ignore";function P($){return $?S.$Ld(L,$)?h.Error:S.$Ld(A,$)||S.$Ld(f,$)?h.Warning:S.$Ld(w,$)?h.Info:h.Ignore:h.Ignore}h.fromValue=P;function I($){switch($){case h.Error:return L;case h.Warning:return A;case h.Info:return w;default:return g}}h.toString=I}(F||(F={})),e.default=F}),define(Se[157],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=void 0,e.$bc=Symbol("MicrotaskDelay")}),define(Se[75],De([1,0,18,15]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=e.$sh=e.$rh=void 0;class h{constructor(){this.b="",this.c=0}reset(k){return this.b=k,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(k){const C=k.charCodeAt(0),E=this.b.charCodeAt(this.c);return C-E}value(){return this.b[this.c]}}e.$rh=h;class L{constructor(k=!0){this.e=k}reset(k){return this.b=k,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let k=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(k)this.c++;else break;else k=!1;return this}cmp(k){return this.e?(0,F.$Fd)(k,this.b,0,k.length,this.c,this.d):(0,F.$Hd)(k,this.b,0,k.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$sh=L;class A{constructor(k=!0,C=!0){this.f=k,this.g=C}reset(k){this.d=0,this.e=0,this.b=k,this.c=k.length;for(let C=k.length-1;C>=0;C--,this.c--){const E=this.b.charCodeAt(C);if(!(E===47||this.f&&E===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let k=!0;for(;this.e<this.c;this.e++){const C=this.b.charCodeAt(this.e);if(C===47||this.f&&C===92)if(k)this.d++;else break;else k=!1}return this}cmp(k){return this.g?(0,F.$Fd)(k,this.b,0,k.length,this.d,this.e):(0,F.$Hd)(k,this.b,0,k.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$th=A;var f;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(f||(f={}));class w{constructor(k,C){this.f=k,this.g=C,this.d=[],this.e=0}reset(k){return this.c=k,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(k)),this.b.reset(k.path),this.b.value()&&this.d.push(3)),this.g(k)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(k){if(this.d[this.e]===1)return(0,F.$Gd)(k,this.c.scheme);if(this.d[this.e]===2)return(0,F.$Gd)(k,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(k);if(this.d[this.e]===4)return(0,F.$Ed)(k,this.c.query);if(this.d[this.e]===5)return(0,F.$Ed)(k,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$uh=w;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const k=this.right;return this.right=k.left,k.left=this,this.updateHeight(),k.updateHeight(),k}rotateRight(){const k=this.left;return this.left=k.right,k.right=this,this.updateHeight(),k.updateHeight(),k}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(P||(P={}));class I{static forUris(k=()=>!1,C=()=>!1){return new I(new w(k,C))}static forPaths(k=!1){return new I(new A(void 0,!k))}static forStrings(){return new I(new h)}static forConfigKeys(){return new I(new L)}constructor(k){this.b=k}clear(){this.c=void 0}fill(k,C){if(C){const E=C.slice(0);(0,S.$Bf)(E);for(const n of E)this.set(n,k)}else{const E=k.slice(0);(0,S.$Bf)(E);for(const n of E)this.set(n[0],n[1])}}set(k,C){const E=this.b.reset(k);let n;this.c||(this.c=new g,this.c.segment=E.value());const o=[];for(n=this.c;;){const m=E.cmp(n.segment);if(m>0)n.left||(n.left=new g,n.left.segment=E.value()),o.push([-1,n]),n=n.left;else if(m<0)n.right||(n.right=new g,n.right.segment=E.value()),o.push([1,n]),n=n.right;else if(E.hasNext())E.next(),n.mid||(n.mid=new g,n.mid.segment=E.value()),o.push([0,n]),n=n.mid;else break}const a=n.value;n.value=C,n.key=k;for(let m=o.length-1;m>=0;m--){const v=o[m][1];v.updateHeight();const D=v.balanceFactor();if(D<-1||D>1){const t=o[m][0],r=o[m+1][0];if(t===1&&r===1)o[m][1]=v.rotateLeft();else if(t===-1&&r===-1)o[m][1]=v.rotateRight();else if(t===1&&r===-1)v.right=o[m+1][1]=o[m+1][1].rotateRight(),o[m][1]=v.rotateLeft();else if(t===-1&&r===1)v.left=o[m+1][1]=o[m+1][1].rotateLeft(),o[m][1]=v.rotateRight();else throw new Error;if(m>0)switch(o[m-1][0]){case-1:o[m-1][1].left=o[m][1];break;case 1:o[m-1][1].right=o[m][1];break;case 0:o[m-1][1].mid=o[m][1];break}else this.c=o[0][1]}}return a}get(k){return this.d(k)?.value}d(k){const C=this.b.reset(k);let E=this.c;for(;E;){const n=C.cmp(E.segment);if(n>0)E=E.left;else if(n<0)E=E.right;else if(C.hasNext())C.next(),E=E.mid;else break}return E}has(k){const C=this.d(k);return!(C?.value===void 0&&C?.mid===void 0)}delete(k){return this.e(k,!1)}deleteSuperstr(k){return this.e(k,!0)}e(k,C){const E=this.b.reset(k),n=[];let o=this.c;for(;o;){const a=E.cmp(o.segment);if(a>0)n.push([-1,o]),o=o.left;else if(a<0)n.push([1,o]),o=o.right;else if(E.hasNext())E.next(),n.push([0,o]),o=o.mid;else break}if(o){if(C?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const a=this.f(o.right);if(a.key){const{key:m,value:v,segment:D}=a;this.e(a.key,!1),o.key=m,o.value=v,o.segment=D}}else{const a=o.left??o.right;if(n.length>0){const[m,v]=n[n.length-1];switch(m){case-1:v.left=a;break;case 0:v.mid=a;break;case 1:v.right=a;break}}else this.c=a}for(let a=n.length-1;a>=0;a--){const m=n[a][1];m.updateHeight();const v=m.balanceFactor();if(v>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),n[a][1]=m.rotateLeft()):v<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),n[a][1]=m.rotateRight()),a>0)switch(n[a-1][0]){case-1:n[a-1][1].left=n[a][1];break;case 1:n[a-1][1].right=n[a][1];break;case 0:n[a-1][1].mid=n[a][1];break}else this.c=n[0][1]}}}f(k){for(;k.left;)k=k.left;return k}findSubstr(k){const C=this.b.reset(k);let E=this.c,n;for(;E;){const o=C.cmp(E.segment);if(o>0)E=E.left;else if(o<0)E=E.right;else if(C.hasNext())C.next(),n=E.value||n,E=E.mid;else break}return E&&E.value||n}findSuperstr(k){return this.g(k,!1)}g(k,C){const E=this.b.reset(k);let n=this.c;for(;n;){const o=E.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(E.hasNext())E.next(),n=n.mid;else return n.mid?this.h(n.mid):C?n.value:void 0}}hasElementOrSubtree(k){return this.g(k,!0)!==void 0}forEach(k){for(const[C,E]of this)k(E,C)}*[Symbol.iterator](){yield*this.h(this.c)}h(k){const C=[];return this.j(k,C),C[Symbol.iterator]()}j(k,C){k&&(k.left&&this.j(k.left,C),k.value&&C.push([k.key,k.value]),k.mid&&this.j(k.mid,C),k.right&&this.j(k.right,C))}_isBalanced(){const k=C=>{if(!C)return!0;const E=C.balanceFactor();return E<-1||E>1?!1:k(C.left)&&k(C.right)};return k(this.c)}}e.$vh=I}),define(Se[19],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=void 0;function S(D){return typeof D=="string"}e.$ie=S;function F(D){return Array.isArray(D)&&D.every(t=>S(t))}e.$je=F;function h(D){return typeof D=="object"&&D!==null&&!Array.isArray(D)&&!(D instanceof RegExp)&&!(D instanceof Date)}e.$ke=h;function L(D){const t=Object.getPrototypeOf(Uint8Array);return typeof D=="object"&&D instanceof t}e.$le=L;function A(D){return typeof D=="number"&&!isNaN(D)}e.$me=A;function f(D){return!!D&&typeof D[Symbol.iterator]=="function"}e.$ne=f;function w(D){return D===!0||D===!1}e.$oe=w;function g(D){return typeof D>"u"}e.$pe=g;function P(D){return!I(D)}e.$qe=P;function I(D){return g(D)||D===null}e.$re=I;function $(D,t){if(!D)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$se=$;function k(D){if(I(D))throw new Error("Assertion Failed: argument is undefined or null");return D}e.$te=k;function C(...D){const t=[];for(let r=0;r<D.length;r++){const s=D[r];if(I(s))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(s)}return t}e.$ue=C;const E=Object.prototype.hasOwnProperty;function n(D){if(!h(D))return!1;for(const t in D)if(E.call(D,t))return!1;return!0}e.$ve=n;function o(D){return typeof D=="function"}e.$we=o;function a(...D){return D.length>0&&D.every(o)}e.$xe=a;function m(D,t){const r=Math.min(D.length,t.length);for(let s=0;s<r;s++)v(D[s],t[s])}e.$ye=m;function v(D,t){if(S(t)){if(typeof D!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(D instanceof t)return}catch{}if(!I(D)&&D.constructor===t||t.length===1&&t.call(void 0,D)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$ze=v}),define(Se[76],De([1,0,19]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Bj=e.$Aj=void 0;const F=Object.create(null);function h(f,w){if((0,S.$ie)(w)){const g=F[w];if(g===void 0)throw new Error(`${f} references an unknown codicon: ${w}`);w=g}return F[f]=w,{id:f}}function L(){return F}e.$Aj=L;function A(){return Object.values(e.$Cj)}e.$Bj=A,e.$Cj={add:h("add",6e4),plus:h("plus",6e4),gistNew:h("gist-new",6e4),repoCreate:h("repo-create",6e4),lightbulb:h("lightbulb",60001),lightBulb:h("light-bulb",60001),repo:h("repo",60002),repoDelete:h("repo-delete",60002),gistFork:h("gist-fork",60003),repoForked:h("repo-forked",60003),gitPullRequest:h("git-pull-request",60004),gitPullRequestAbandoned:h("git-pull-request-abandoned",60004),recordKeys:h("record-keys",60005),keyboard:h("keyboard",60005),tag:h("tag",60006),tagAdd:h("tag-add",60006),tagRemove:h("tag-remove",60006),gitPullRequestLabel:h("git-pull-request-label",60006),person:h("person",60007),personFollow:h("person-follow",60007),personOutline:h("person-outline",60007),personFilled:h("person-filled",60007),gitBranch:h("git-branch",60008),gitBranchCreate:h("git-branch-create",60008),gitBranchDelete:h("git-branch-delete",60008),sourceControl:h("source-control",60008),mirror:h("mirror",60009),mirrorPublic:h("mirror-public",60009),star:h("star",60010),starAdd:h("star-add",60010),starDelete:h("star-delete",60010),starEmpty:h("star-empty",60010),comment:h("comment",60011),commentAdd:h("comment-add",60011),alert:h("alert",60012),warning:h("warning",60012),search:h("search",60013),searchSave:h("search-save",60013),logOut:h("log-out",60014),signOut:h("sign-out",60014),logIn:h("log-in",60015),signIn:h("sign-in",60015),eye:h("eye",60016),eyeUnwatch:h("eye-unwatch",60016),eyeWatch:h("eye-watch",60016),circleFilled:h("circle-filled",60017),primitiveDot:h("primitive-dot",60017),closeDirty:h("close-dirty",60017),debugBreakpoint:h("debug-breakpoint",60017),debugBreakpointDisabled:h("debug-breakpoint-disabled",60017),debugHint:h("debug-hint",60017),primitiveSquare:h("primitive-square",60018),edit:h("edit",60019),pencil:h("pencil",60019),info:h("info",60020),issueOpened:h("issue-opened",60020),gistPrivate:h("gist-private",60021),gitForkPrivate:h("git-fork-private",60021),lock:h("lock",60021),mirrorPrivate:h("mirror-private",60021),close:h("close",60022),removeClose:h("remove-close",60022),x:h("x",60022),repoSync:h("repo-sync",60023),sync:h("sync",60023),clone:h("clone",60024),desktopDownload:h("desktop-download",60024),beaker:h("beaker",60025),microscope:h("microscope",60025),vm:h("vm",60026),deviceDesktop:h("device-desktop",60026),file:h("file",60027),fileText:h("file-text",60027),more:h("more",60028),ellipsis:h("ellipsis",60028),kebabHorizontal:h("kebab-horizontal",60028),mailReply:h("mail-reply",60029),reply:h("reply",60029),organization:h("organization",60030),organizationFilled:h("organization-filled",60030),organizationOutline:h("organization-outline",60030),newFile:h("new-file",60031),fileAdd:h("file-add",60031),newFolder:h("new-folder",60032),fileDirectoryCreate:h("file-directory-create",60032),trash:h("trash",60033),trashcan:h("trashcan",60033),history:h("history",60034),clock:h("clock",60034),folder:h("folder",60035),fileDirectory:h("file-directory",60035),symbolFolder:h("symbol-folder",60035),logoGithub:h("logo-github",60036),markGithub:h("mark-github",60036),github:h("github",60036),terminal:h("terminal",60037),console:h("console",60037),repl:h("repl",60037),zap:h("zap",60038),symbolEvent:h("symbol-event",60038),error:h("error",60039),stop:h("stop",60039),variable:h("variable",60040),symbolVariable:h("symbol-variable",60040),array:h("array",60042),symbolArray:h("symbol-array",60042),symbolModule:h("symbol-module",60043),symbolPackage:h("symbol-package",60043),symbolNamespace:h("symbol-namespace",60043),symbolObject:h("symbol-object",60043),symbolMethod:h("symbol-method",60044),symbolFunction:h("symbol-function",60044),symbolConstructor:h("symbol-constructor",60044),symbolBoolean:h("symbol-boolean",60047),symbolNull:h("symbol-null",60047),symbolNumeric:h("symbol-numeric",60048),symbolNumber:h("symbol-number",60048),symbolStructure:h("symbol-structure",60049),symbolStruct:h("symbol-struct",60049),symbolParameter:h("symbol-parameter",60050),symbolTypeParameter:h("symbol-type-parameter",60050),symbolKey:h("symbol-key",60051),symbolText:h("symbol-text",60051),symbolReference:h("symbol-reference",60052),goToFile:h("go-to-file",60052),symbolEnum:h("symbol-enum",60053),symbolValue:h("symbol-value",60053),symbolRuler:h("symbol-ruler",60054),symbolUnit:h("symbol-unit",60054),activateBreakpoints:h("activate-breakpoints",60055),archive:h("archive",60056),arrowBoth:h("arrow-both",60057),arrowDown:h("arrow-down",60058),arrowLeft:h("arrow-left",60059),arrowRight:h("arrow-right",60060),arrowSmallDown:h("arrow-small-down",60061),arrowSmallLeft:h("arrow-small-left",60062),arrowSmallRight:h("arrow-small-right",60063),arrowSmallUp:h("arrow-small-up",60064),arrowUp:h("arrow-up",60065),bell:h("bell",60066),bold:h("bold",60067),book:h("book",60068),bookmark:h("bookmark",60069),debugBreakpointConditionalUnverified:h("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:h("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:h("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:h("debug-breakpoint-data-unverified",60072),debugBreakpointData:h("debug-breakpoint-data",60073),debugBreakpointDataDisabled:h("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:h("debug-breakpoint-log-unverified",60074),debugBreakpointLog:h("debug-breakpoint-log",60075),debugBreakpointLogDisabled:h("debug-breakpoint-log-disabled",60075),briefcase:h("briefcase",60076),broadcast:h("broadcast",60077),browser:h("browser",60078),bug:h("bug",60079),calendar:h("calendar",60080),caseSensitive:h("case-sensitive",60081),check:h("check",60082),checklist:h("checklist",60083),chevronDown:h("chevron-down",60084),dropDownButton:h("drop-down-button",60084),chevronLeft:h("chevron-left",60085),chevronRight:h("chevron-right",60086),chevronUp:h("chevron-up",60087),chromeClose:h("chrome-close",60088),chromeMaximize:h("chrome-maximize",60089),chromeMinimize:h("chrome-minimize",60090),chromeRestore:h("chrome-restore",60091),circle:h("circle",60092),circleOutline:h("circle-outline",60092),debugBreakpointUnverified:h("debug-breakpoint-unverified",60092),circleSlash:h("circle-slash",60093),circuitBoard:h("circuit-board",60094),clearAll:h("clear-all",60095),clippy:h("clippy",60096),closeAll:h("close-all",60097),cloudDownload:h("cloud-download",60098),cloudUpload:h("cloud-upload",60099),code:h("code",60100),collapseAll:h("collapse-all",60101),colorMode:h("color-mode",60102),commentDiscussion:h("comment-discussion",60103),compareChanges:h("compare-changes",60157),creditCard:h("credit-card",60105),dash:h("dash",60108),dashboard:h("dashboard",60109),database:h("database",60110),debugContinue:h("debug-continue",60111),debugDisconnect:h("debug-disconnect",60112),debugPause:h("debug-pause",60113),debugRestart:h("debug-restart",60114),debugStart:h("debug-start",60115),debugStepInto:h("debug-step-into",60116),debugStepOut:h("debug-step-out",60117),debugStepOver:h("debug-step-over",60118),debugStop:h("debug-stop",60119),debug:h("debug",60120),deviceCameraVideo:h("device-camera-video",60121),deviceCamera:h("device-camera",60122),deviceMobile:h("device-mobile",60123),diffAdded:h("diff-added",60124),diffIgnored:h("diff-ignored",60125),diffModified:h("diff-modified",60126),diffRemoved:h("diff-removed",60127),diffRenamed:h("diff-renamed",60128),diff:h("diff",60129),discard:h("discard",60130),editorLayout:h("editor-layout",60131),emptyWindow:h("empty-window",60132),exclude:h("exclude",60133),extensions:h("extensions",60134),eyeClosed:h("eye-closed",60135),fileBinary:h("file-binary",60136),fileCode:h("file-code",60137),fileMedia:h("file-media",60138),filePdf:h("file-pdf",60139),fileSubmodule:h("file-submodule",60140),fileSymlinkDirectory:h("file-symlink-directory",60141),fileSymlinkFile:h("file-symlink-file",60142),fileZip:h("file-zip",60143),files:h("files",60144),filter:h("filter",60145),flame:h("flame",60146),foldDown:h("fold-down",60147),foldUp:h("fold-up",60148),fold:h("fold",60149),folderActive:h("folder-active",60150),folderOpened:h("folder-opened",60151),gear:h("gear",60152),gift:h("gift",60153),gistSecret:h("gist-secret",60154),gist:h("gist",60155),gitCommit:h("git-commit",60156),gitCompare:h("git-compare",60157),gitMerge:h("git-merge",60158),githubAction:h("github-action",60159),githubAlt:h("github-alt",60160),globe:h("globe",60161),grabber:h("grabber",60162),graph:h("graph",60163),gripper:h("gripper",60164),heart:h("heart",60165),home:h("home",60166),horizontalRule:h("horizontal-rule",60167),hubot:h("hubot",60168),inbox:h("inbox",60169),issueClosed:h("issue-closed",60324),issueReopened:h("issue-reopened",60171),issues:h("issues",60172),italic:h("italic",60173),jersey:h("jersey",60174),json:h("json",60175),bracket:h("bracket",60175),kebabVertical:h("kebab-vertical",60176),key:h("key",60177),law:h("law",60178),lightbulbAutofix:h("lightbulb-autofix",60179),linkExternal:h("link-external",60180),link:h("link",60181),listOrdered:h("list-ordered",60182),listUnordered:h("list-unordered",60183),liveShare:h("live-share",60184),loading:h("loading",60185),location:h("location",60186),mailRead:h("mail-read",60187),mail:h("mail",60188),markdown:h("markdown",60189),megaphone:h("megaphone",60190),mention:h("mention",60191),milestone:h("milestone",60192),gitPullRequestMilestone:h("git-pull-request-milestone",60192),mortarBoard:h("mortar-board",60193),move:h("move",60194),multipleWindows:h("multiple-windows",60195),mute:h("mute",60196),noNewline:h("no-newline",60197),note:h("note",60198),octoface:h("octoface",60199),openPreview:h("open-preview",60200),package_:h("package",60201),paintcan:h("paintcan",60202),pin:h("pin",60203),play:h("play",60204),run:h("run",60204),plug:h("plug",60205),preserveCase:h("preserve-case",60206),preview:h("preview",60207),project:h("project",60208),pulse:h("pulse",60209),question:h("question",60210),quote:h("quote",60211),radioTower:h("radio-tower",60212),reactions:h("reactions",60213),references:h("references",60214),refresh:h("refresh",60215),regex:h("regex",60216),remoteExplorer:h("remote-explorer",60217),remote:h("remote",60218),remove:h("remove",60219),replaceAll:h("replace-all",60220),replace:h("replace",60221),repoClone:h("repo-clone",60222),repoForcePush:h("repo-force-push",60223),repoPull:h("repo-pull",60224),repoPush:h("repo-push",60225),report:h("report",60226),requestChanges:h("request-changes",60227),rocket:h("rocket",60228),rootFolderOpened:h("root-folder-opened",60229),rootFolder:h("root-folder",60230),rss:h("rss",60231),ruby:h("ruby",60232),saveAll:h("save-all",60233),saveAs:h("save-as",60234),save:h("save",60235),screenFull:h("screen-full",60236),screenNormal:h("screen-normal",60237),searchStop:h("search-stop",60238),server:h("server",60240),settingsGear:h("settings-gear",60241),settings:h("settings",60242),shield:h("shield",60243),smiley:h("smiley",60244),sortPrecedence:h("sort-precedence",60245),splitHorizontal:h("split-horizontal",60246),splitVertical:h("split-vertical",60247),squirrel:h("squirrel",60248),starFull:h("star-full",60249),starHalf:h("star-half",60250),symbolClass:h("symbol-class",60251),symbolColor:h("symbol-color",60252),symbolCustomColor:h("symbol-customcolor",60252),symbolConstant:h("symbol-constant",60253),symbolEnumMember:h("symbol-enum-member",60254),symbolField:h("symbol-field",60255),symbolFile:h("symbol-file",60256),symbolInterface:h("symbol-interface",60257),symbolKeyword:h("symbol-keyword",60258),symbolMisc:h("symbol-misc",60259),symbolOperator:h("symbol-operator",60260),symbolProperty:h("symbol-property",60261),wrench:h("wrench",60261),wrenchSubaction:h("wrench-subaction",60261),symbolSnippet:h("symbol-snippet",60262),tasklist:h("tasklist",60263),telescope:h("telescope",60264),textSize:h("text-size",60265),threeBars:h("three-bars",60266),thumbsdown:h("thumbsdown",60267),thumbsup:h("thumbsup",60268),tools:h("tools",60269),triangleDown:h("triangle-down",60270),triangleLeft:h("triangle-left",60271),triangleRight:h("triangle-right",60272),triangleUp:h("triangle-up",60273),twitter:h("twitter",60274),unfold:h("unfold",60275),unlock:h("unlock",60276),unmute:h("unmute",60277),unverified:h("unverified",60278),verified:h("verified",60279),versions:h("versions",60280),vmActive:h("vm-active",60281),vmOutline:h("vm-outline",60282),vmRunning:h("vm-running",60283),watch:h("watch",60284),whitespace:h("whitespace",60285),wholeWord:h("whole-word",60286),window:h("window",60287),wordWrap:h("word-wrap",60288),zoomIn:h("zoom-in",60289),zoomOut:h("zoom-out",60290),listFilter:h("list-filter",60291),listFlat:h("list-flat",60292),listSelection:h("list-selection",60293),selection:h("selection",60293),listTree:h("list-tree",60294),debugBreakpointFunctionUnverified:h("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:h("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:h("debug-breakpoint-function-disabled",60296),debugStackframeActive:h("debug-stackframe-active",60297),circleSmallFilled:h("circle-small-filled",60298),debugStackframeDot:h("debug-stackframe-dot",60298),debugStackframe:h("debug-stackframe",60299),debugStackframeFocused:h("debug-stackframe-focused",60299),debugBreakpointUnsupported:h("debug-breakpoint-unsupported",60300),symbolString:h("symbol-string",60301),debugReverseContinue:h("debug-reverse-continue",60302),debugStepBack:h("debug-step-back",60303),debugRestartFrame:h("debug-restart-frame",60304),callIncoming:h("call-incoming",60306),callOutgoing:h("call-outgoing",60307),menu:h("menu",60308),expandAll:h("expand-all",60309),feedback:h("feedback",60310),gitPullRequestReviewer:h("git-pull-request-reviewer",60310),groupByRefType:h("group-by-ref-type",60311),ungroupByRefType:h("ungroup-by-ref-type",60312),account:h("account",60313),gitPullRequestAssignee:h("git-pull-request-assignee",60313),bellDot:h("bell-dot",60314),debugConsole:h("debug-console",60315),library:h("library",60316),output:h("output",60317),runAll:h("run-all",60318),syncIgnored:h("sync-ignored",60319),pinned:h("pinned",60320),githubInverted:h("github-inverted",60321),debugAlt:h("debug-alt",60305),serverProcess:h("server-process",60322),serverEnvironment:h("server-environment",60323),pass:h("pass",60324),stopCircle:h("stop-circle",60325),playCircle:h("play-circle",60326),record:h("record",60327),debugAltSmall:h("debug-alt-small",60328),vmConnect:h("vm-connect",60329),cloud:h("cloud",60330),merge:h("merge",60331),exportIcon:h("export",60332),graphLeft:h("graph-left",60333),magnet:h("magnet",60334),notebook:h("notebook",60335),redo:h("redo",60336),checkAll:h("check-all",60337),pinnedDirty:h("pinned-dirty",60338),passFilled:h("pass-filled",60339),circleLargeFilled:h("circle-large-filled",60340),circleLarge:h("circle-large",60341),circleLargeOutline:h("circle-large-outline",60341),combine:h("combine",60342),gather:h("gather",60342),table:h("table",60343),variableGroup:h("variable-group",60344),typeHierarchy:h("type-hierarchy",60345),typeHierarchySub:h("type-hierarchy-sub",60346),typeHierarchySuper:h("type-hierarchy-super",60347),gitPullRequestCreate:h("git-pull-request-create",60348),runAbove:h("run-above",60349),runBelow:h("run-below",60350),notebookTemplate:h("notebook-template",60351),debugRerun:h("debug-rerun",60352),workspaceTrusted:h("workspace-trusted",60353),workspaceUntrusted:h("workspace-untrusted",60354),workspaceUnspecified:h("workspace-unspecified",60355),terminalCmd:h("terminal-cmd",60356),terminalDebian:h("terminal-debian",60357),terminalLinux:h("terminal-linux",60358),terminalPowershell:h("terminal-powershell",60359),terminalTmux:h("terminal-tmux",60360),terminalUbuntu:h("terminal-ubuntu",60361),terminalBash:h("terminal-bash",60362),arrowSwap:h("arrow-swap",60363),copy:h("copy",60364),personAdd:h("person-add",60365),filterFilled:h("filter-filled",60366),wand:h("wand",60367),debugLineByLine:h("debug-line-by-line",60368),inspect:h("inspect",60369),layers:h("layers",60370),layersDot:h("layers-dot",60371),layersActive:h("layers-active",60372),compass:h("compass",60373),compassDot:h("compass-dot",60374),compassActive:h("compass-active",60375),azure:h("azure",60376),issueDraft:h("issue-draft",60377),gitPullRequestClosed:h("git-pull-request-closed",60378),gitPullRequestDraft:h("git-pull-request-draft",60379),debugAll:h("debug-all",60380),debugCoverage:h("debug-coverage",60381),runErrors:h("run-errors",60382),folderLibrary:h("folder-library",60383),debugContinueSmall:h("debug-continue-small",60384),beakerStop:h("beaker-stop",60385),graphLine:h("graph-line",60386),graphScatter:h("graph-scatter",60387),pieChart:h("pie-chart",60388),bracketDot:h("bracket-dot",60389),bracketError:h("bracket-error",60390),lockSmall:h("lock-small",60391),azureDevops:h("azure-devops",60392),verifiedFilled:h("verified-filled",60393),newLine:h("newline",60394),layout:h("layout",60395),layoutActivitybarLeft:h("layout-activitybar-left",60396),layoutActivitybarRight:h("layout-activitybar-right",60397),layoutPanelLeft:h("layout-panel-left",60398),layoutPanelCenter:h("layout-panel-center",60399),layoutPanelJustify:h("layout-panel-justify",60400),layoutPanelRight:h("layout-panel-right",60401),layoutPanel:h("layout-panel",60402),layoutSidebarLeft:h("layout-sidebar-left",60403),layoutSidebarRight:h("layout-sidebar-right",60404),layoutStatusbar:h("layout-statusbar",60405),layoutMenubar:h("layout-menubar",60406),layoutCentered:h("layout-centered",60407),layoutSidebarRightOff:h("layout-sidebar-right-off",60416),layoutPanelOff:h("layout-panel-off",60417),layoutSidebarLeftOff:h("layout-sidebar-left-off",60418),target:h("target",60408),indent:h("indent",60409),recordSmall:h("record-small",60410),errorSmall:h("error-small",60411),arrowCircleDown:h("arrow-circle-down",60412),arrowCircleLeft:h("arrow-circle-left",60413),arrowCircleRight:h("arrow-circle-right",60414),arrowCircleUp:h("arrow-circle-up",60415),heartFilled:h("heart-filled",60420),map:h("map",60421),mapFilled:h("map-filled",60422),circleSmall:h("circle-small",60423),bellSlash:h("bell-slash",60424),bellSlashDot:h("bell-slash-dot",60425),commentUnresolved:h("comment-unresolved",60426),gitPullRequestGoToChanges:h("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:h("git-pull-request-new-changes",60428),searchFuzzy:h("search-fuzzy",60429),commentDraft:h("comment-draft",60430),send:h("send",60431),sparkle:h("sparkle",60432),insert:h("insert",60433),mic:h("mic",60434),dialogError:h("dialog-error","error"),dialogWarning:h("dialog-warning","warning"),dialogInfo:h("dialog-info","info"),dialogClose:h("dialog-close","close"),treeItemExpanded:h("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:h("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:h("tree-filter-on-type-off","list-selection"),treeFilterClear:h("tree-filter-clear","close"),treeItemLoading:h("tree-item-loading","loading"),menuSelection:h("menu-selection","check"),menuSubmenu:h("menu-submenu","chevron-right"),menuBarMore:h("menubar-more","more"),scrollbarButtonLeft:h("scrollbar-button-left","triangle-left"),scrollbarButtonRight:h("scrollbar-button-right","triangle-right"),scrollbarButtonUp:h("scrollbar-button-up","triangle-up"),scrollbarButtonDown:h("scrollbar-button-down","triangle-down"),toolBarMore:h("toolbar-more","more"),quickInputBack:h("quick-input-back","arrow-left")}}),define(Se[23],De([1,0,19]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=void 0;function F(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const a=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([m,v])=>{a[m]=v&&typeof v=="object"?F(v):v}),a}e.$Im=F;function h(o){if(!o||typeof o!="object")return o;const a=[o];for(;a.length>0;){const m=a.shift();Object.freeze(m);for(const v in m)if(L.call(m,v)){const D=m[v];typeof D=="object"&&!Object.isFrozen(D)&&!(0,S.$le)(D)&&a.push(D)}}return o}e.$Jm=h;const L=Object.prototype.hasOwnProperty;function A(o,a){return f(o,a,new Set)}e.$Km=A;function f(o,a,m){if((0,S.$re)(o))return o;const v=a(o);if(typeof v<"u")return v;if(Array.isArray(o)){const D=[];for(const t of o)D.push(f(t,a,m));return D}if((0,S.$ke)(o)){if(m.has(o))throw new Error("Cannot clone recursive data-structure");m.add(o);const D={};for(const t in o)L.call(o,t)&&(D[t]=f(o[t],a,m));return m.delete(o),D}return o}function w(o,a,m=!0){return(0,S.$ke)(o)?((0,S.$ke)(a)&&Object.keys(a).forEach(v=>{v in o?m&&((0,S.$ke)(o[v])&&(0,S.$ke)(a[v])?w(o[v],a[v],m):o[v]=a[v]):o[v]=a[v]}),o):a}e.$Lm=w;function g(o,a){if(o===a)return!0;if(o==null||a===null||a===void 0||typeof o!=typeof a||typeof o!="object"||Array.isArray(o)!==Array.isArray(a))return!1;let m,v;if(Array.isArray(o)){if(o.length!==a.length)return!1;for(m=0;m<o.length;m++)if(!g(o[m],a[m]))return!1}else{const D=[];for(v in o)D.push(v);D.sort();const t=[];for(v in a)t.push(v);if(t.sort(),!g(D,t))return!1;for(m=0;m<D.length;m++)if(!g(o[D[m]],a[D[m]]))return!1}return!0}e.$Mm=g;function P(o){const a=new Set;return JSON.stringify(o,(m,v)=>{if((0,S.$ke)(v)||Array.isArray(v)){if(a.has(v))return"[Circular]";a.add(v)}return v})}e.$Nm=P;function I(o,a){const m=Object.create(null);return!o||!a||Object.keys(a).forEach(D=>{const t=o[D],r=a[D];g(t,r)||(m[D]=r)}),m}e.$Om=I;function $(o,a){const m=a.toLowerCase(),v=Object.keys(o).find(D=>D.toLowerCase()===m);return v?o[v]:o[a]}e.$Pm=$;function k(o,a){const m=Object.create(null);for(const[v,D]of Object.entries(o))a(v,D)&&(m[v]=D);return m}e.$Qm=k;function C(o){let a=[];for(;Object.prototype!==o;)a=a.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return a}e.$Rm=C;function E(o){const a=[];for(const m of C(o))typeof o[m]=="function"&&a.push(m);return a}e.$Sm=E;function n(o,a){const m=D=>function(){const t=Array.prototype.slice.call(arguments,0);return a(D,t)},v={};for(const D of o)v[D]=m(D);return v}e.$Tm=n}),define(Se[56],De([1,0,76]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Dj=e.ThemeColor=void 0;var F;(function(A){function f(w){return w&&typeof w=="object"&&typeof w.id=="string"}A.isThemeColor=f})(F||(e.ThemeColor=F={}));function h(A){return{id:A}}e.$Dj=h;var L;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const f=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function w(a){const m=f.exec(a.id);if(!m)return w(S.$Cj.error);const[,v,D]=m,t=["codicon","codicon-"+v];return D&&t.push("codicon-modifier-"+D.substring(1)),t}A.asClassNameArray=w;function g(a){return w(a).join(" ")}A.asClassName=g;function P(a){return"."+w(a).join(".")}A.asCSSSelector=P;function I(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||F.isThemeColor(a.color))}A.isThemeIcon=I;const $=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function k(a){const m=$.exec(a);if(!m)return;const[,v]=m;return{id:v}}A.fromString=k;function C(a){return{id:a}}A.fromId=C;function E(a,m){let v=a.id;const D=v.lastIndexOf("~");return D!==-1&&(v=v.substring(0,D)),m&&(v=`${v}~${m}`),{id:v}}A.modify=E;function n(a){const m=a.id.lastIndexOf("~");if(m!==-1)return a.id.substring(m+1)}A.getModifier=n;function o(a,m){return a.id===m.id&&a.color?.id===m.color?.id}A.isEqual=o})(L||(e.ThemeIcon=L={}))}),define(Se[158],De([1,0,119,15,56]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=void 0;const L="$(",A=new RegExp(`\\$\\(${h.ThemeIcon.iconNameExpression}(?:${h.ThemeIcon.iconModifierExpression})?\\)`,"g"),f=new RegExp(`(\\\\)?${A.source}`,"g");function w(o){return o.replace(f,(a,m)=>m?a:`\\${a}`)}e.$Ej=w;const g=new RegExp(`\\\\${A.source}`,"g");function P(o){return o.replace(g,a=>`\\${a}`)}e.$Fj=P;const I=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function $(o){return o.indexOf(L)===-1?o:o.replace(I,(a,m,v,D)=>v?a:m||D||"")}e.$Gj=$;function k(o){return o?o.replace(/\$\((.*?)\)/g,(a,m)=>` ${m} `).trim():""}e.$Hj=k;const C=new RegExp(`\\$\\(${h.ThemeIcon.iconNameCharacter}+\\)`,"g");function E(o){C.lastIndex=0;let a="";const m=[];let v=0;for(;;){const D=C.lastIndex,t=C.exec(o),r=o.substring(D,t?.index);if(r.length>0){a+=r;for(let s=0;s<r.length;s++)m.push(v)}if(!t)break;v+=t[0].length}return{text:a,iconOffsets:m}}e.$Ij=E;function n(o,a,m=!1){const{text:v,iconOffsets:D}=a;if(!D||D.length===0)return(0,S.$rj)(o,v,m);const t=(0,F.$td)(v," "),r=v.length-t.length,s=(0,S.$rj)(o,t,m);if(s)for(const i of s){const c=D[i.start+r]+r;i.start+=c,i.end+=c}return s}e.$Jj=n}),define(Se[120],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kd=e.$jd=e.Constants=void 0;var S;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(S||(e.Constants=S={}));function F(L){return L<0?0:L>255?255:L|0}e.$jd=F;function h(L){return L<0?0:L>4294967295?4294967295:L|0}e.$kd=h}),define(Se[31],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3e=e.$2e=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(h){return S.test(h)}e.$2e=F,e.$3e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let h;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?h=crypto.getRandomValues.bind(crypto):h=function(f){for(let w=0;w<f.length;w++)f[w]=Math.floor(Math.random()*256);return f};const L=new Uint8Array(16),A=[];for(let f=0;f<256;f++)A.push(f.toString(16).padStart(2,"0"));return function(){h(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let w=0,g="";return g+=A[L[w++]],g+=A[L[w++]],g+=A[L[w++]],g+=A[L[w++]],g+="-",g+=A[L[w++]],g+=A[L[w++]],g+="-",g+=A[L[w++]],g+=A[L[w++]],g+="-",g+=A[L[w++]],g+=A[L[w++]],g+="-",g+=A[L[w++]],g+=A[L[w++]],g+=A[L[w++]],g+=A[L[w++]],g+=A[L[w++]],g+=A[L[w++]],g}}()}),define(Se[159],De([1,0,18,48,31]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=e.$hs=e.$gs=e.$fs=e.$es=void 0;function L(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}e.$es=L;function A(I,$,k){const C={id:(0,h.$3e)(),name:I,uri:$,data:k};return{asString:async()=>"",asFile:()=>C,value:void 0}}e.$fs=A;class f{constructor(){this.a=new Map}get size(){let $=0;for(const k of this.a)$++;return $}has($){return this.a.has(this.b($))}matches($){const k=[...this.a.keys()];return F.Iterable.some(this,([C,E])=>E.asFile())&&k.push("files"),P(w($),k)}get($){return this.a.get(this.b($))?.[0]}append($,k){const C=this.a.get($);C?C.push(k):this.a.set(this.b($),[k])}replace($,k){this.a.set(this.b($),[k])}delete($){this.a.delete(this.b($))}*[Symbol.iterator](){for(const[$,k]of this.a)for(const C of k)yield[$,C]}b($){return w($)}}e.$gs=f;function w(I){return I.toLowerCase()}function g(I,$){return P(w(I),$.map(w))}e.$hs=g;function P(I,$){if(I==="*/*")return $.length>0;if($.includes(I))return!0;const k=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!k)return!1;const[C,E,n]=k;return n==="*"?$.some(o=>o.startsWith(E+"/")):!1}e.$is=Object.freeze({create:I=>(0,S.$of)(I.map($=>$.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$is.split(I).filter($=>!$.startsWith("#"))})}),define(Se[160],De([1,0,57]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7e=e.$6e=e.$5e=void 0;function F(f,w,g,P=1){let I=!1;return new Promise($=>{const k=setTimeout(()=>{if(!I)return I=!0,$(0)},g);h(f,w,P,C=>{if(!I)return I=!0,clearTimeout(k),$(C)})})}e.$5e=F;function h(f,w,g,P){if(w===0)return P(0);const I=new S.Socket;I.once("connect",()=>(A(I),h(f+g,w-1,g,P))),I.once("data",()=>{}),I.once("error",$=>(A(I),$.code!=="ECONNREFUSED"?h(f+g,w-1,g,P):P(f))),I.connect(f,"127.0.0.1")}e.$6e={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(f,w,g,P="127.0.0.1"){let I=!1,$,k=1;const C=S.createServer({pauseOnConnect:!0});function E(n,o){I||(I=!0,C.removeAllListeners(),C.close(),$&&clearTimeout($),o(n))}return new Promise(n=>{$=setTimeout(()=>{E(0,n)},g),C.on("listening",()=>{E(f,n)}),C.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&k<w?(f++,k++,C.listen(f,P)):E(0,n)}),C.on("close",()=>{E(0,n)}),C.listen(f,P)})}e.$7e=L;function A(f){try{f.removeAllListeners("connect"),f.removeAllListeners("error"),f.end(),f.destroy(),f.unref()}catch(w){console.error(w)}}}),define(Se[121],De([1,0,120]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0r=e.$9r=void 0;class F{constructor(f){const w=(0,S.$jd)(f);this.c=w,this.a=F.d(w),this.b=new Map}static d(f){const w=new Uint8Array(256);return w.fill(f),w}set(f,w){const g=(0,S.$jd)(w);f>=0&&f<256?this.a[f]=g:this.b.set(f,g)}get(f){return f>=0&&f<256?this.a[f]:this.b.get(f)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$9r=F;var h;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(h||(h={}));class L{constructor(){this.a=new F(0)}add(f){this.a.set(f,1)}has(f){return this.a.get(f)===1}clear(){return this.a.clear()}}e.$0r=L}),define(Se[58],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=void 0;class S{constructor(h,L){this.lineNumber=h,this.column=L}with(h=this.lineNumber,L=this.column){return h===this.lineNumber&&L===this.column?this:new S(h,L)}delta(h=0,L=0){return this.with(this.lineNumber+h,this.column+L)}equals(h){return S.equals(this,h)}static equals(h,L){return!h&&!L?!0:!!h&&!!L&&h.lineNumber===L.lineNumber&&h.column===L.column}isBefore(h){return S.isBefore(this,h)}static isBefore(h,L){return h.lineNumber<L.lineNumber?!0:L.lineNumber<h.lineNumber?!1:h.column<L.column}isBeforeOrEqual(h){return S.isBeforeOrEqual(this,h)}static isBeforeOrEqual(h,L){return h.lineNumber<L.lineNumber?!0:L.lineNumber<h.lineNumber?!1:h.column<=L.column}static compare(h,L){const A=h.lineNumber|0,f=L.lineNumber|0;if(A===f){const w=h.column|0,g=L.column|0;return w-g}return A-f}clone(){return new S(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(h){return new S(h.lineNumber,h.column)}static isIPosition(h){return h&&typeof h.lineNumber=="number"&&typeof h.column=="number"}}e.$Tr=S}),define(Se[34],De([1,0,58]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=void 0;class F{constructor(L,A,f,w){L>f||L===f&&A>w?(this.startLineNumber=f,this.startColumn=w,this.endLineNumber=L,this.endColumn=A):(this.startLineNumber=L,this.startColumn=A,this.endLineNumber=f,this.endColumn=w)}isEmpty(){return F.isEmpty(this)}static isEmpty(L){return L.startLineNumber===L.endLineNumber&&L.startColumn===L.endColumn}containsPosition(L){return F.containsPosition(this,L)}static containsPosition(L,A){return!(A.lineNumber<L.startLineNumber||A.lineNumber>L.endLineNumber||A.lineNumber===L.startLineNumber&&A.column<L.startColumn||A.lineNumber===L.endLineNumber&&A.column>L.endColumn)}static strictContainsPosition(L,A){return!(A.lineNumber<L.startLineNumber||A.lineNumber>L.endLineNumber||A.lineNumber===L.startLineNumber&&A.column<=L.startColumn||A.lineNumber===L.endLineNumber&&A.column>=L.endColumn)}containsRange(L){return F.containsRange(this,L)}static containsRange(L,A){return!(A.startLineNumber<L.startLineNumber||A.endLineNumber<L.startLineNumber||A.startLineNumber>L.endLineNumber||A.endLineNumber>L.endLineNumber||A.startLineNumber===L.startLineNumber&&A.startColumn<L.startColumn||A.endLineNumber===L.endLineNumber&&A.endColumn>L.endColumn)}strictContainsRange(L){return F.strictContainsRange(this,L)}static strictContainsRange(L,A){return!(A.startLineNumber<L.startLineNumber||A.endLineNumber<L.startLineNumber||A.startLineNumber>L.endLineNumber||A.endLineNumber>L.endLineNumber||A.startLineNumber===L.startLineNumber&&A.startColumn<=L.startColumn||A.endLineNumber===L.endLineNumber&&A.endColumn>=L.endColumn)}plusRange(L){return F.plusRange(this,L)}static plusRange(L,A){let f,w,g,P;return A.startLineNumber<L.startLineNumber?(f=A.startLineNumber,w=A.startColumn):A.startLineNumber===L.startLineNumber?(f=A.startLineNumber,w=Math.min(A.startColumn,L.startColumn)):(f=L.startLineNumber,w=L.startColumn),A.endLineNumber>L.endLineNumber?(g=A.endLineNumber,P=A.endColumn):A.endLineNumber===L.endLineNumber?(g=A.endLineNumber,P=Math.max(A.endColumn,L.endColumn)):(g=L.endLineNumber,P=L.endColumn),new F(f,w,g,P)}intersectRanges(L){return F.intersectRanges(this,L)}static intersectRanges(L,A){let f=L.startLineNumber,w=L.startColumn,g=L.endLineNumber,P=L.endColumn;const I=A.startLineNumber,$=A.startColumn,k=A.endLineNumber,C=A.endColumn;return f<I?(f=I,w=$):f===I&&(w=Math.max(w,$)),g>k?(g=k,P=C):g===k&&(P=Math.min(P,C)),f>g||f===g&&w>P?null:new F(f,w,g,P)}equalsRange(L){return F.equalsRange(this,L)}static equalsRange(L,A){return!L&&!A?!0:!!L&&!!A&&L.startLineNumber===A.startLineNumber&&L.startColumn===A.startColumn&&L.endLineNumber===A.endLineNumber&&L.endColumn===A.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(L){return new S.$Tr(L.endLineNumber,L.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(L){return new S.$Tr(L.startLineNumber,L.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(L,A){return new F(this.startLineNumber,this.startColumn,L,A)}setStartPosition(L,A){return new F(L,A,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(L){return new F(L.startLineNumber,L.startColumn,L.startLineNumber,L.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(L){return new F(L.endLineNumber,L.endColumn,L.endLineNumber,L.endColumn)}delta(L){return new F(this.startLineNumber+L,this.startColumn,this.endLineNumber+L,this.endColumn)}static fromPositions(L,A=L){return new F(L.lineNumber,L.column,A.lineNumber,A.column)}static lift(L){return L?new F(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):null}static isIRange(L){return L&&typeof L.startLineNumber=="number"&&typeof L.startColumn=="number"&&typeof L.endLineNumber=="number"&&typeof L.endColumn=="number"}static areIntersectingOrTouching(L,A){return!(L.endLineNumber<A.startLineNumber||L.endLineNumber===A.startLineNumber&&L.endColumn<A.startColumn||A.endLineNumber<L.startLineNumber||A.endLineNumber===L.startLineNumber&&A.endColumn<L.startColumn)}static areIntersecting(L,A){return!(L.endLineNumber<A.startLineNumber||L.endLineNumber===A.startLineNumber&&L.endColumn<=A.startColumn||A.endLineNumber<L.startLineNumber||A.endLineNumber===L.startLineNumber&&A.endColumn<=L.startColumn)}static compareRangesUsingStarts(L,A){if(L&&A){const g=L.startLineNumber|0,P=A.startLineNumber|0;if(g===P){const I=L.startColumn|0,$=A.startColumn|0;if(I===$){const k=L.endLineNumber|0,C=A.endLineNumber|0;if(k===C){const E=L.endColumn|0,n=A.endColumn|0;return E-n}return k-C}return I-$}return g-P}return(L?1:0)-(A?1:0)}static compareRangesUsingEnds(L,A){return L.endLineNumber===A.endLineNumber?L.endColumn===A.endColumn?L.startLineNumber===A.startLineNumber?L.startColumn-A.startColumn:L.startLineNumber-A.startLineNumber:L.endColumn-A.endColumn:L.endLineNumber-A.endLineNumber}static spansMultipleLines(L){return L.endLineNumber>L.startLineNumber}toJSON(){return this}}e.$Ur=F}),define(Se[161],De([1,0,34]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=void 0;class F{static insert(L,A){return{range:new S.$Ur(L.lineNumber,L.column,L.lineNumber,L.column),text:A,forceMoveMarkers:!0}}static delete(L){return{range:L,text:null}}static replace(L,A){return{range:L,text:A}}static replaceMove(L,A){return{range:L,text:A,forceMoveMarkers:!0}}}e.$2r=F}),define(Se[162],De([1,0,58,34]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=e.SelectionDirection=void 0;var h;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(h||(e.SelectionDirection=h={}));class L extends F.$Ur{constructor(f,w,g,P){super(f,w,g,P),this.selectionStartLineNumber=f,this.selectionStartColumn=w,this.positionLineNumber=g,this.positionColumn=P}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(f){return L.selectionsEqual(this,f)}static selectionsEqual(f,w){return f.selectionStartLineNumber===w.selectionStartLineNumber&&f.selectionStartColumn===w.selectionStartColumn&&f.positionLineNumber===w.positionLineNumber&&f.positionColumn===w.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(f,w){return this.getDirection()===0?new L(this.startLineNumber,this.startColumn,f,w):new L(f,w,this.startLineNumber,this.startColumn)}getPosition(){return new S.$Tr(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new S.$Tr(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(f,w){return this.getDirection()===0?new L(f,w,this.endLineNumber,this.endColumn):new L(this.endLineNumber,this.endColumn,f,w)}static fromPositions(f,w=f){return new L(f.lineNumber,f.column,w.lineNumber,w.column)}static fromRange(f,w){return w===0?new L(f.startLineNumber,f.startColumn,f.endLineNumber,f.endColumn):new L(f.endLineNumber,f.endColumn,f.startLineNumber,f.startColumn)}static liftSelection(f){return new L(f.selectionStartLineNumber,f.selectionStartColumn,f.positionLineNumber,f.positionColumn)}static selectionsArrEqual(f,w){if(f&&!w||!f&&w)return!1;if(!f&&!w)return!0;if(f.length!==w.length)return!1;for(let g=0,P=f.length;g<P;g++)if(!this.selectionsEqual(f[g],w[g]))return!1;return!0}static isISelection(f){return f&&typeof f.selectionStartLineNumber=="number"&&typeof f.selectionStartColumn=="number"&&typeof f.positionLineNumber=="number"&&typeof f.positionColumn=="number"}static createWithDirection(f,w,g,P,I){return I===0?new L(f,w,g,P):new L(g,P,f,w)}}e.$3r=L}),define(Se[163],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=void 0,e.$Lr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[164],De([1,0,121]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=e.$$r=e.WordCharacterClass=void 0;var F;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(F||(e.WordCharacterClass=F={}));class h extends S.$9r{constructor(f){super(0);for(let w=0,g=f.length;w<g;w++)this.set(f.charCodeAt(w),2);this.set(32,1),this.set(9,1)}}e.$$r=h;function L(A){const f={};return w=>(f.hasOwnProperty(w)||(f[w]=A(w)),f[w])}e.$_r=L(A=>new h(A))}),define(Se[122],De([1,0,48,3,72]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qr=e.$Pr=e.$Or=e.$Nr=e.$Mr=void 0,e.$Mr="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function L(I=""){let $="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.$Mr)I.indexOf(k)>=0||($+="\\"+k);return $+="\\s]+)",new RegExp($,"g")}e.$Nr=L();function A(I){let $=e.$Nr;if(I&&I instanceof RegExp)if(I.global)$=I;else{let k="g";I.ignoreCase&&(k+="i"),I.multiline&&(k+="m"),I.unicode&&(k+="u"),$=new RegExp(I.source,k)}return $.lastIndex=0,$}e.$Or=A;const f=new h.$ub;f.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function w(I){const $=f.unshift(I);return(0,F.$jb)($)}e.$Pr=w;function g(I,$,k,C,E){if(E||(E=S.Iterable.first(f)),k.length>E.maxLen){let v=I-E.maxLen/2;return v<0?v=0:C+=v,k=k.substring(v,I+E.maxLen/2),g(I,$,k,C,E)}const n=Date.now(),o=I-1-C;let a=-1,m=null;for(let v=1;!(Date.now()-n>=E.timeBudget);v++){const D=o-E.windowSize*v;$.lastIndex=Math.max(0,D);const t=P($,k,o,a);if(!t&&m||(m=t,D<=0))break;a=D}if(m){const v={word:m[0],startColumn:C+1+m.index,endColumn:C+1+m.index+m[0].length};return $.lastIndex=0,v}return null}e.$Qr=g;function P(I,$,k,C){let E;for(;E=I.exec($);){const n=E.index||0;if(n<=k&&I.lastIndex>=k)return E;if(C>0&&n>C)return null}return null}}),define(Se[165],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=e.$Hs=e.IndentAction=void 0;var S;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(S||(e.IndentAction=S={}));class F{constructor(f){if(this.e=null,this.f=!1,this.open=f.open,this.close=f.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(f.notIn))for(let w=0,g=f.notIn.length;w<g;w++)switch(f.notIn[w]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(f){switch(f){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(f,w){if(f.getTokenCount()===0)return!0;const g=f.findTokenIndexAtOffset(w-2),P=f.getStandardTokenType(g);return this.isOK(P)}g(f,w){for(let g=f;g<=w;g++){const P=String.fromCharCode(g);if(!this.open.includes(P)&&!this.close.includes(P))return P}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Hs=F;class h{constructor(f){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const w of f)L(this.autoClosingPairsOpenByStart,w.open.charAt(0),w),L(this.autoClosingPairsOpenByEnd,w.open.charAt(w.open.length-1),w),L(this.autoClosingPairsCloseByStart,w.close.charAt(0),w),L(this.autoClosingPairsCloseByEnd,w.close.charAt(w.close.length-1),w),w.close.length===1&&w.open.length===1&&L(this.autoClosingPairsCloseSingleChar,w.close,w)}}e.$Is=h;function L(A,f,w){A.has(f)?A.get(f).push(w):A.set(f,[w])}}),define(Se[166],De([1,0,121]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sY=e.$rY=e.$qY=e.State=void 0;var F;(function(k){k[k.Invalid=0]="Invalid",k[k.Start=1]="Start",k[k.H=2]="H",k[k.HT=3]="HT",k[k.HTT=4]="HTT",k[k.HTTP=5]="HTTP",k[k.F=6]="F",k[k.FI=7]="FI",k[k.FIL=8]="FIL",k[k.BeforeColon=9]="BeforeColon",k[k.AfterColon=10]="AfterColon",k[k.AlmostThere=11]="AlmostThere",k[k.End=12]="End",k[k.Accept=13]="Accept",k[k.LastKnownState=14]="LastKnownState"})(F||(e.State=F={}));class h{constructor(C,E,n){const o=new Uint8Array(C*E);for(let a=0,m=C*E;a<m;a++)o[a]=n;this.a=o,this.rows=C,this.cols=E}get(C,E){return this.a[C*this.cols+E]}set(C,E,n){this.a[C*this.cols+E]=n}}class L{constructor(C){let E=0,n=0;for(let a=0,m=C.length;a<m;a++){const[v,D,t]=C[a];D>E&&(E=D),v>n&&(n=v),t>n&&(n=t)}E++,n++;const o=new h(n,E,0);for(let a=0,m=C.length;a<m;a++){const[v,D,t]=C[a];o.set(v,D,t)}this.a=o,this.b=E}nextState(C,E){return E<0||E>=this.b?0:this.a.get(C,E)}}e.$qY=L;let A=null;function f(){return A===null&&(A=new L([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var w;(function(k){k[k.None=0]="None",k[k.ForceTermination=1]="ForceTermination",k[k.CannotEndIn=2]="CannotEndIn"})(w||(w={}));let g=null;function P(){if(g===null){g=new S.$9r(0);const k=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let E=0;E<k.length;E++)g.set(k.charCodeAt(E),1);const C=".,;:";for(let E=0;E<C.length;E++)g.set(C.charCodeAt(E),2)}return g}class I{static a(C,E,n,o,a){let m=a-1;do{const v=E.charCodeAt(m);if(C.get(v)!==2)break;m--}while(m>o);if(o>0){const v=E.charCodeAt(o-1),D=E.charCodeAt(m);(v===40&&D===41||v===91&&D===93||v===123&&D===125)&&m--}return{range:{startLineNumber:n,startColumn:o+1,endLineNumber:n,endColumn:m+2},url:E.substring(o,m+1)}}static computeLinks(C,E=f()){const n=P(),o=[];for(let a=1,m=C.getLineCount();a<=m;a++){const v=C.getLineContent(a),D=v.length;let t=0,r=0,s=0,i=1,c=!1,l=!1,b=!1,y=!1;for(;t<D;){let u=!1;const d=v.charCodeAt(t);if(i===13){let p;switch(d){case 40:c=!0,p=0;break;case 41:p=c?0:1;break;case 91:b=!0,l=!0,p=0;break;case 93:b=!1,p=l?0:1;break;case 123:y=!0,p=0;break;case 125:p=y?0:1;break;case 39:case 34:case 96:s===d?p=1:s===39||s===34||s===96?p=0:p=1;break;case 42:p=s===42?1:0;break;case 124:p=s===124?1:0;break;case 32:p=b?0:1;break;default:p=n.get(d)}p===1&&(o.push(I.a(n,v,a,r,t)),u=!0)}else if(i===12){let p;d===91?(l=!0,p=0):p=n.get(d),p===1?u=!0:i=13}else i=E.nextState(i,d),i===0&&(u=!0);u&&(i=1,c=!1,l=!1,y=!1,r=t+1,s=d),t++}i===13&&o.push(I.a(n,v,a,r,D))}return o}}e.$rY=I;function $(k){return!k||typeof k.getLineCount!="function"||typeof k.getLineContent!="function"?[]:I.computeLinks(k)}e.$sY=$}),define(Se[123],De([1,0,23]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8t=e.$7t=e.$6t=e.$5t=e.ModelConstants=e.PositionAffinity=e.$4t=e.TrackedRangeStickiness=e.$3t=e.$2t=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var F;(function(v){v[v.Left=1]="Left",v[v.Center=2]="Center",v[v.Right=4]="Right",v[v.Full=7]="Full"})(F||(e.OverviewRulerLane=F={}));var h;(function(v){v[v.Left=1]="Left",v[v.Right=2]="Right"})(h||(e.GlyphMarginLane=h={}));var L;(function(v){v[v.Inline=1]="Inline",v[v.Gutter=2]="Gutter"})(L||(e.MinimapPosition=L={}));var A;(function(v){v[v.Both=0]="Both",v[v.Right=1]="Right",v[v.Left=2]="Left",v[v.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var f;(function(v){v[v.TextDefined=0]="TextDefined",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(f||(e.EndOfLinePreference=f={}));var w;(function(v){v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(w||(e.DefaultEndOfLine=w={}));var g;(function(v){v[v.LF=0]="LF",v[v.CRLF=1]="CRLF"})(g||(e.EndOfLineSequence=g={}));class P{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(D){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,D.tabSize|0),D.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,D.indentSize|0),this.a=!1),this.insertSpaces=!!D.insertSpaces,this.defaultEOL=D.defaultEOL|0,this.trimAutoWhitespace=!!D.trimAutoWhitespace,this.bracketPairColorizationOptions=D.bracketPairColorizationOptions}equals(D){return this.tabSize===D.tabSize&&this.a===D.a&&this.indentSize===D.indentSize&&this.insertSpaces===D.insertSpaces&&this.defaultEOL===D.defaultEOL&&this.trimAutoWhitespace===D.trimAutoWhitespace&&(0,S.$Mm)(this.bracketPairColorizationOptions,D.bracketPairColorizationOptions)}createChangeEvent(D){return{tabSize:this.tabSize!==D.tabSize,indentSize:this.indentSize!==D.indentSize,insertSpaces:this.insertSpaces!==D.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==D.trimAutoWhitespace}}}e.$2t=P;class I{constructor(D,t){this._findMatchBrand=void 0,this.range=D,this.matches=t}}e.$3t=I;var $;(function(v){v[v.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",v[v.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",v[v.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",v[v.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})($||(e.TrackedRangeStickiness=$={}));function k(v){return v&&typeof v.read=="function"}e.$4t=k;var C;(function(v){v[v.Left=0]="Left",v[v.Right=1]="Right",v[v.None=2]="None",v[v.LeftOfInjectedText=3]="LeftOfInjectedText",v[v.RightOfInjectedText=4]="RightOfInjectedText"})(C||(e.PositionAffinity=C={}));var E;(function(v){v[v.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E||(e.ModelConstants=E={}));class n{constructor(D,t,r,s,i,c){this.identifier=D,this.range=t,this.text=r,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=i,this._isTracked=c}}e.$5t=n;class o{constructor(D,t,r){this.regex=D,this.wordSeparators=t,this.simpleSearch=r}}e.$6t=o;class a{constructor(D,t,r){this.reverseEdits=D,this.changes=t,this.trimAutoWhitespaceLineNumbers=r}}e.$7t=a;function m(v){return!v.isTooLargeForSyncing()&&!v.isForSimpleWidget}e.$8t=m}),define(Se[167],De([1,0,18,120]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bu=e.$Au=e.$zu=void 0;class h{constructor(w){this.a=w,this.b=new Uint32Array(w.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(w,g){w=(0,F.$kd)(w);const P=this.a,I=this.b,$=g.length;return $===0?!1:(this.a=new Uint32Array(P.length+$),this.a.set(P.subarray(0,w),0),this.a.set(P.subarray(w),w+$),this.a.set(g,w),w-1<this.c[0]&&(this.c[0]=w-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue(w,g){return w=(0,F.$kd)(w),g=(0,F.$kd)(g),this.a[w]===g?!1:(this.a[w]=g,w-1<this.c[0]&&(this.c[0]=w-1),!0)}removeValues(w,g){w=(0,F.$kd)(w),g=(0,F.$kd)(g);const P=this.a,I=this.b;if(w>=P.length)return!1;const $=P.length-w;return g>=$&&(g=$),g===0?!1:(this.a=new Uint32Array(P.length-g),this.a.set(P.subarray(0,w),0),this.a.set(P.subarray(w+g),w),this.b=new Uint32Array(this.a.length),w-1<this.c[0]&&(this.c[0]=w-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(w){return w<0?0:(w=(0,F.$kd)(w),this.d(w))}d(w){if(w<=this.c[0])return this.b[w];let g=this.c[0]+1;g===0&&(this.b[0]=this.a[0],g++),w>=this.a.length&&(w=this.a.length-1);for(let P=g;P<=w;P++)this.b[P]=this.b[P-1]+this.a[P];return this.c[0]=Math.max(this.c[0],w),this.b[w]}getIndexOf(w){w=Math.floor(w),this.getTotalSum();let g=0,P=this.a.length-1,I=0,$=0,k=0;for(;g<=P;)if(I=g+(P-g)/2|0,$=this.b[I],k=$-this.a[I],w<k)P=I-1;else if(w>=$)g=I+1;else break;return new A(I,w-k)}}e.$zu=h;class L{constructor(w){this.a=w,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(w){return this.g(),w===0?0:this.d[w-1]}getIndexOf(w){this.g();const g=this.e[w],P=g>0?this.d[g-1]:0;return new A(g,w-P)}removeValues(w,g){this.a.splice(w,g),this.f(w)}insertValues(w,g){this.a=(0,S.$Af)(this.a,w,g),this.f(w)}f(w){this.b=!1,this.c=Math.min(this.c,w-1)}g(){if(!this.b){for(let w=this.c+1,g=this.a.length;w<g;w++){const P=this.a[w],I=w>0?this.d[w-1]:0;this.d[w]=I+P;for(let $=0;$<P;$++)this.e[I+$]=w}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(w,g){this.a[w]!==g&&(this.a[w]=g,this.f(w))}}e.$Au=L;class A{constructor(w,g){this.index=w,this.remainder=g,this._prefixSumIndexOfResultBrand=void 0,this.index=w,this.remainder=g}}e.$Bu=A}),define(Se[168],De([1,0,15,58,167]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cu=void 0;class L{constructor(f,w,g,P){this.d=f,this.f=w,this.g=g,this.h=P,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(f){f.eol&&f.eol!==this.g&&(this.g=f.eol,this.j=null);const w=f.changes;for(const g of w)this.o(g.range),this.p(new F.$Tr(g.range.startLineNumber,g.range.startColumn),g.text);this.h=f.versionId,this.k=null}l(){if(!this.j){const f=this.g.length,w=this.f.length,g=new Uint32Array(w);for(let P=0;P<w;P++)g[P]=this.f[P].length+f;this.j=new h.$zu(g)}}n(f,w){this.f[f]=w,this.j&&this.j.setValue(f,this.f[f].length+this.g.length)}o(f){if(f.startLineNumber===f.endLineNumber){if(f.startColumn===f.endColumn)return;this.n(f.startLineNumber-1,this.f[f.startLineNumber-1].substring(0,f.startColumn-1)+this.f[f.startLineNumber-1].substring(f.endColumn-1));return}this.n(f.startLineNumber-1,this.f[f.startLineNumber-1].substring(0,f.startColumn-1)+this.f[f.endLineNumber-1].substring(f.endColumn-1)),this.f.splice(f.startLineNumber,f.endLineNumber-f.startLineNumber),this.j&&this.j.removeValues(f.startLineNumber,f.endLineNumber-f.startLineNumber)}p(f,w){if(w.length===0)return;const g=(0,S.$zd)(w);if(g.length===1){this.n(f.lineNumber-1,this.f[f.lineNumber-1].substring(0,f.column-1)+g[0]+this.f[f.lineNumber-1].substring(f.column-1));return}g[g.length-1]+=this.f[f.lineNumber-1].substring(f.column-1),this.n(f.lineNumber-1,this.f[f.lineNumber-1].substring(0,f.column-1)+g[0]);const P=new Uint32Array(g.length-1);for(let I=1;I<g.length;I++)this.f.splice(f.lineNumber+I-1,0,g[I]),P[I-1]=g[I].length+this.g.length;this.j&&this.j.insertValues(f.lineNumber,P)}}e.$Cu=L}),define(Se[169],De([1,0,15,164,58,34,123]),function(me,e,S,F,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bC=e.$aC=e.$_B=e.$$B=e.$0B=e.$9B=void 0;const f=999;class w{constructor(a,m,v,D){this.searchString=a,this.isRegex=m,this.matchCase=v,this.wordSeparators=D}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=g(this.searchString):a=this.searchString.indexOf(`
`)>=0;let m=null;try{m=S.$xd(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch{return null}if(!m)return null;let v=!this.isRegex&&!a;return v&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(v=this.matchCase),new A.$6t(m,this.wordSeparators?(0,F.$_r)(this.wordSeparators):null,v?this.searchString:null)}}e.$9B=w;function g(o){if(!o||o.length===0)return!1;for(let a=0,m=o.length;a<m;a++){const v=o.charCodeAt(a);if(v===10)return!0;if(v===92){if(a++,a>=m)break;const D=o.charCodeAt(a);if(D===110||D===114||D===87)return!0}}return!1}e.$0B=g;function P(o,a,m){if(!m)return new A.$3t(o,null);const v=[];for(let D=0,t=a.length;D<t;D++)v[D]=a[D];return new A.$3t(o,v)}e.$$B=P;class I{constructor(a){const m=[];let v=0;for(let D=0,t=a.length;D<t;D++)a.charCodeAt(D)===10&&(m[v++]=D);this.a=m}findLineFeedCountBeforeOffset(a){const m=this.a;let v=0,D=m.length-1;if(D===-1||a<=m[0])return 0;for(;v<D;){const t=v+((D-v)/2>>0);m[t]>=a?D=t-1:m[t+1]>=a?(v=t,D=t):v=t+1}return v+1}}class ${static findMatches(a,m,v,D,t){const r=m.parseSearchRequest();return r?r.regex.multiline?this.b(a,v,new n(r.wordSeparators,r.regex),D,t):this.c(a,v,r,D,t):[]}static a(a,m,v,D,t,r){let s,i=0;D?(i=D.findLineFeedCountBeforeOffset(t),s=m+t+i):s=m+t;let c;if(D){const u=D.findLineFeedCountBeforeOffset(t+r.length)-i;c=s+r.length+u}else c=s+r.length;const l=a.getPositionAt(s),b=a.getPositionAt(c);return new L.$Ur(l.lineNumber,l.column,b.lineNumber,b.column)}static b(a,m,v,D,t){const r=a.getOffsetAt(m.getStartPosition()),s=a.getValueInRange(m,1),i=a.getEOL()===`\r
`?new I(s):null,c=[];let l=0,b;for(v.reset(0);b=v.next(s);)if(c[l++]=P(this.a(a,r,s,i,b.index,b[0]),b,D),l>=t)return c;return c}static c(a,m,v,D,t){const r=[];let s=0;if(m.startLineNumber===m.endLineNumber){const c=a.getLineContent(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);return s=this.d(v,c,m.startLineNumber,m.startColumn-1,s,r,D,t),r}const i=a.getLineContent(m.startLineNumber).substring(m.startColumn-1);s=this.d(v,i,m.startLineNumber,m.startColumn-1,s,r,D,t);for(let c=m.startLineNumber+1;c<m.endLineNumber&&s<t;c++)s=this.d(v,a.getLineContent(c),c,0,s,r,D,t);if(s<t){const c=a.getLineContent(m.endLineNumber).substring(0,m.endColumn-1);s=this.d(v,c,m.endLineNumber,0,s,r,D,t)}return r}static d(a,m,v,D,t,r,s,i){const c=a.wordSeparators;if(!s&&a.simpleSearch){const y=a.simpleSearch,u=y.length,d=m.length;let p=-u;for(;(p=m.indexOf(y,p+u))!==-1;)if((!c||E(c,m,d,p,u))&&(r[t++]=new A.$3t(new L.$Ur(v,p+1+D,v,p+1+u+D),null),t>=i))return t;return t}const l=new n(a.wordSeparators,a.regex);let b;l.reset(0);do if(b=l.next(m),b&&(r[t++]=P(new L.$Ur(v,b.index+1+D,v,b.index+1+b[0].length+D),b,s),t>=i))return t;while(b);return t}static findNextMatch(a,m,v,D){const t=m.parseSearchRequest();if(!t)return null;const r=new n(t.wordSeparators,t.regex);return t.regex.multiline?this.e(a,v,r,D):this.f(a,v,r,D)}static e(a,m,v,D){const t=new h.$Tr(m.lineNumber,1),r=a.getOffsetAt(t),s=a.getLineCount(),i=a.getValueInRange(new L.$Ur(t.lineNumber,t.column,s,a.getLineMaxColumn(s)),1),c=a.getEOL()===`\r
`?new I(i):null;v.reset(m.column-1);const l=v.next(i);return l?P(this.a(a,r,i,c,l.index,l[0]),l,D):m.lineNumber!==1||m.column!==1?this.e(a,new h.$Tr(1,1),v,D):null}static f(a,m,v,D){const t=a.getLineCount(),r=m.lineNumber,s=a.getLineContent(r),i=this.g(v,s,r,m.column,D);if(i)return i;for(let c=1;c<=t;c++){const l=(r+c-1)%t,b=a.getLineContent(l+1),y=this.g(v,b,l+1,1,D);if(y)return y}return null}static g(a,m,v,D,t){a.reset(D-1);const r=a.next(m);return r?P(new L.$Ur(v,r.index+1,v,r.index+1+r[0].length),r,t):null}static findPreviousMatch(a,m,v,D){const t=m.parseSearchRequest();if(!t)return null;const r=new n(t.wordSeparators,t.regex);return t.regex.multiline?this.h(a,v,r,D):this.j(a,v,r,D)}static h(a,m,v,D){const t=this.b(a,new L.$Ur(1,1,m.lineNumber,m.column),v,D,10*f);if(t.length>0)return t[t.length-1];const r=a.getLineCount();return m.lineNumber!==r||m.column!==a.getLineMaxColumn(r)?this.h(a,new h.$Tr(r,a.getLineMaxColumn(r)),v,D):null}static j(a,m,v,D){const t=a.getLineCount(),r=m.lineNumber,s=a.getLineContent(r).substring(0,m.column-1),i=this.k(v,s,r,D);if(i)return i;for(let c=1;c<=t;c++){const l=(t+r-c-1)%t,b=a.getLineContent(l+1),y=this.k(v,b,l+1,D);if(y)return y}return null}static k(a,m,v,D){let t=null,r;for(a.reset(0);r=a.next(m);)t=P(new L.$Ur(v,r.index+1,v,r.index+1+r[0].length),r,D);return t}}e.$_B=$;function k(o,a,m,v,D){if(v===0)return!0;const t=a.charCodeAt(v-1);if(o.get(t)!==0||t===13||t===10)return!0;if(D>0){const r=a.charCodeAt(v);if(o.get(r)!==0)return!0}return!1}function C(o,a,m,v,D){if(v+D===m)return!0;const t=a.charCodeAt(v+D);if(o.get(t)!==0||t===13||t===10)return!0;if(D>0){const r=a.charCodeAt(v+D-1);if(o.get(r)!==0)return!0}return!1}function E(o,a,m,v,D){return k(o,a,m,v,D)&&C(o,a,m,v,D)}e.$aC=E;class n{constructor(a,m){this._wordSeparators=a,this.a=m,this.b=-1,this.c=0}reset(a){this.a.lastIndex=a,this.b=-1,this.c=0}next(a){const m=a.length;let v;do{if(this.b+this.c===m||(v=this.a.exec(a),!v))return null;const D=v.index,t=v[0].length;if(D===this.b&&t===this.c){if(t===0){S.$Sd(a,m,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=D,this.c=t,!this._wordSeparators||E(this._wordSeparators,a,m,D,t))return v}while(v);return null}}e.$bC=n}),define(Se[170],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W6=e.$V6=void 0;class S{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const A=this.a.get(L);return this.a.delete(L),A}}addDragOperationTransfer(L,A){this.a.set(L,A)}}e.$V6=S;class F{constructor(L){this.identifier=L}}e.$W6=F}),define(Se[171],De([1,0,4,3]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=void 0;class h{constructor(){this.a=new Map,this.b=new Map,this.c=new S.$ec,this.onDidChange=this.c.event,this.d=null}handleChange(f){this.c.fire({changedLanguages:f,changedColorMap:!1})}register(f,w){return this.a.set(f,w),this.handleChange([f]),(0,F.$jb)(()=>{this.a.get(f)===w&&(this.a.delete(f),this.handleChange([f]))})}get(f){return this.a.get(f)||null}registerFactory(f,w){this.b.get(f)?.dispose();const g=new L(this,f,w);return this.b.set(f,g),(0,F.$jb)(()=>{const P=this.b.get(f);!P||P!==g||(this.b.delete(f),P.dispose())})}async getOrCreate(f){const w=this.get(f);if(w)return w;const g=this.b.get(f);return!g||g.isResolved?null:(await g.resolve(),this.get(f))}isResolved(f){if(this.get(f))return!0;const g=this.b.get(f);return!!(!g||g.isResolved)}setColorMap(f){this.d=f,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$ks=h;class L extends F.$lb{get isResolved(){return this.c}constructor(f,w,g){super(),this.f=f,this.g=w,this.h=g,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const f=await this.h.tokenizationSupport;this.c=!0,f&&!this.a&&this.B(this.f.register(this.g,f))}}}),define(Se[172],De([11,12]),function(me,e){return me.create("vs/base/common/actions",e)}),define(Se[173],De([1,0,4,3,172]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=void 0;class L extends F.$lb{constructor($,k="",C="",E=!0,n){super(),this.h=this.B(new S.$ec),this.onDidChange=this.h.event,this.w=!0,this.j=$,this.m=k,this.u=C,this.w=E,this.C=n}get id(){return this.j}get label(){return this.m}set label($){this.D($)}D($){this.m!==$&&(this.m=$,this.h.fire({label:$}))}get tooltip(){return this.n||""}set tooltip($){this.F($)}F($){this.n!==$&&(this.n=$,this.h.fire({tooltip:$}))}get class(){return this.u}set class($){this.G($)}G($){this.u!==$&&(this.u=$,this.h.fire({class:$}))}get enabled(){return this.w}set enabled($){this.H($)}H($){this.w!==$&&(this.w=$,this.h.fire({enabled:$}))}get checked(){return this.z}set checked($){this.I($)}I($){this.z!==$&&(this.z=$,this.h.fire({checked:$}))}async run($,k){this.C&&await this.C($)}}e.$7h=L;class A extends F.$lb{constructor(){super(...arguments),this.f=this.B(new S.$ec),this.onWillRun=this.f.event,this.k=this.B(new S.$ec),this.onDidRun=this.k.event}async run($,k){if(!$.enabled)return;this.f.fire({action:$});let C;try{await this.l($,k)}catch(E){C=E}this.k.fire({action:$,error:C})}async l($,k){await $.run(k)}}e.$8h=A;class f{constructor(){this.id=f.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...$){let k=[];for(const C of $)C.length&&(k.length?k=[...k,new f,...C]:k=C);return k}static{this.ID="vs.actions.separator"}async run(){}}e.$9h=f;class w{get actions(){return this.a}constructor($,k,C,E){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=$,this.label=k,this.class=E,this.a=C}async run(){}}e.$0h=w;class g extends L{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,h.localize(0,null),void 0,!1)}}e.$$h=g;function P(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async()=>I.run(),tooltip:I.label}}e.$_h=P}),define(Se[174],De([11,12]),function(me,e){return me.create("vs/base/common/date",e)}),define(Se[175],De([1,0,174]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=void 0;const F=60,h=F*60,L=h*24,A=L*7,f=L*30,w=L*365;function g(I,$,k,C){typeof I!="number"&&(I=I.getTime());const E=Math.round((new Date().getTime()-I)/1e3);if(E<-30)return(0,S.localize)(0,null,g(new Date().getTime()+E*1e3,!1));if(!C&&E<30)return(0,S.localize)(1,null);let n;return E<F?(n=E,$?n===1?k?(0,S.localize)(2,null,n):(0,S.localize)(3,null,n):k?(0,S.localize)(4,null,n):(0,S.localize)(5,null,n):n===1?k?(0,S.localize)(6,null,n):(0,S.localize)(7,null,n):k?(0,S.localize)(8,null,n):(0,S.localize)(9,null,n)):E<h?(n=Math.floor(E/F),$?n===1?k?(0,S.localize)(10,null,n):(0,S.localize)(11,null,n):k?(0,S.localize)(12,null,n):(0,S.localize)(13,null,n):n===1?k?(0,S.localize)(14,null,n):(0,S.localize)(15,null,n):k?(0,S.localize)(16,null,n):(0,S.localize)(17,null,n)):E<L?(n=Math.floor(E/h),$?n===1?k?(0,S.localize)(18,null,n):(0,S.localize)(19,null,n):k?(0,S.localize)(20,null,n):(0,S.localize)(21,null,n):n===1?k?(0,S.localize)(22,null,n):(0,S.localize)(23,null,n):k?(0,S.localize)(24,null,n):(0,S.localize)(25,null,n)):E<A?(n=Math.floor(E/L),$?n===1?(0,S.localize)(26,null,n):(0,S.localize)(27,null,n):n===1?(0,S.localize)(28,null,n):(0,S.localize)(29,null,n)):E<f?(n=Math.floor(E/A),$?n===1?k?(0,S.localize)(30,null,n):(0,S.localize)(31,null,n):k?(0,S.localize)(32,null,n):(0,S.localize)(33,null,n):n===1?k?(0,S.localize)(34,null,n):(0,S.localize)(35,null,n):k?(0,S.localize)(36,null,n):(0,S.localize)(37,null,n)):E<w?(n=Math.floor(E/f),$?n===1?k?(0,S.localize)(38,null,n):(0,S.localize)(39,null,n):k?(0,S.localize)(40,null,n):(0,S.localize)(41,null,n):n===1?k?(0,S.localize)(42,null,n):(0,S.localize)(43,null,n):k?(0,S.localize)(44,null,n):(0,S.localize)(45,null,n)):(n=Math.floor(E/w),$?n===1?k?(0,S.localize)(46,null,n):(0,S.localize)(47,null,n):k?(0,S.localize)(48,null,n):(0,S.localize)(49,null,n):n===1?k?(0,S.localize)(50,null,n):(0,S.localize)(51,null,n):k?(0,S.localize)(52,null,n):(0,S.localize)(53,null,n))}e.$Sl=g;function P(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Tl=P}),define(Se[176],De([11,12]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(Se[45],De([1,0,18,19,176]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$bi=e.$ai=void 0;function L(I,$){return $&&(I.stack||I.stacktrace)?h.localize(0,null,f(I),A(I.stack)||A(I.stacktrace)):f(I)}function A(I){return Array.isArray(I)?I.join(`
`):I}function f(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?h.localize(1,null,I.message):I.message||h.localize(2,null)}function w(I=null,$=!1){if(!I)return h.localize(3,null);if(Array.isArray(I)){const k=S.$jf(I),C=w(k[0],$);return k.length>1?h.localize(4,null,C,k.length):C}if(F.$ie(I))return I;if(I.detail){const k=I.detail;if(k.error)return L(k.error,$);if(k.exception)return L(k.exception,$)}return I.stack?L(I,$):I.message?I.message:h.localize(5,null)}e.$ai=w;function g(I){const $=I;return $ instanceof Error&&Array.isArray($.actions)}e.$bi=g;function P(I,$){let k;return typeof I=="string"?k=new Error(I):k=I,k.actions=$,k}e.$ci=P}),define(Se[177],De([11,12]),function(me,e){return me.create("vs/base/common/platform",e)}),define(Se[9],De([1,0,177]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let F=!1,h=!1,L=!1,A=!1,f=!1,w=!1,g=!1,P=!1,I=!1,$=!1,k,C=e.$f,E=e.$f,n,o;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?a=e.$g.vscode.process:typeof process<"u"&&(a=process);const m=typeof a?.versions?.electron=="string",v=m&&a?.type==="renderer";if(typeof navigator=="object"&&!v)o=navigator.userAgent,F=o.indexOf("Windows")>=0,h=o.indexOf("Macintosh")>=0,P=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=o.indexOf("Linux")>=0,$=o?.indexOf("Mobi")>=0,w=!0,k=S.getConfiguredDefaultLocale(S.localize(0,null))||e.$f,C=k,E=navigator.language;else if(typeof a=="object"){F=a.platform==="win32",h=a.platform==="darwin",L=a.platform==="linux",A=L&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,g=m,I=!!a.env.CI||!!a.env.BUILD_ARTIFACTSTAGINGDIRECTORY,k=e.$f,C=e.$f;const y=a.env.VSCODE_NLS_CONFIG;if(y)try{const u=JSON.parse(y),d=u.availableLanguages["*"];k=u.locale,E=u.osLocale,C=d||e.$f,n=u._translationsConfigFile}catch{}f=!0}else console.error("Unable to resolve platform.");var D;(function(y){y[y.Web=0]="Web",y[y.Mac=1]="Mac",y[y.Linux=2]="Linux",y[y.Windows=3]="Windows"})(D||(e.Platform=D={}));function t(y){switch(y){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let r=0;h?r=1:F?r=3:L&&(r=2),e.$i=F,e.$j=h,e.$k=L,e.$l=A,e.$m=f,e.$n=g,e.$o=w,e.$p=w&&typeof e.$g.importScripts=="function",e.$q=P,e.$r=$,e.$s=I,e.$t=r,e.$u=o,e.$v=C;var s;(function(y){function u(){return e.$v}y.value=u;function d(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}y.isDefaultVariant=d;function p(){return e.$v==="en"}y.isDefault=p})(s||(e.Language=s={})),e.$w=k,e.$x=E,e.$y=n,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const y=[];e.$g.addEventListener("message",d=>{if(d.data&&d.data.vscodeScheduleAsyncWork)for(let p=0,R=y.length;p<R;p++){const O=y[p];if(O.id===d.data.vscodeScheduleAsyncWork){y.splice(p,1),O.callback();return}}});let u=0;return d=>{const p=++u;y.push({id:p,callback:d}),e.$g.postMessage({vscodeScheduleAsyncWork:p},"*")}}return y=>setTimeout(y)})();var i;(function(y){y[y.Windows=1]="Windows",y[y.Macintosh=2]="Macintosh",y[y.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=h||P?2:F?1:3;let c=!0,l=!1;function b(){if(!l){l=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,c=new Uint16Array(y.buffer)[0]===(2<<8)+1}return c}e.$C=b,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(Se[41],De([1,0,9]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.env=e.cwd=void 0;let F;if(typeof S.$g.vscode<"u"&&typeof S.$g.vscode.process<"u"){const h=S.$g.vscode.process;F={get platform(){return h.platform},get arch(){return h.arch},get env(){return h.env},cwd(){return h.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return S.$i?"win32":S.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.$2c=F.platform,e.$3c=F.arch}),define(Se[14],De([1,0,41]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fd=e.sep=e.$dd=e.$cd=e.$bd=e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.$5c=e.$4c=void 0;const F=65,h=97,L=90,A=122,f=46,w=47,g=92,P=58,I=63;class $ extends Error{constructor(r,s,i){let c;typeof s=="string"&&s.indexOf("not ")===0?(c="must not be",s=s.replace(/^not /,"")):c="must be";const l=r.indexOf(".")!==-1?"property":"argument";let b=`The "${r}" ${l} ${c} of type ${s}`;b+=`. Received type ${typeof i}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function k(t,r){if(t===null||typeof t!="object")throw new $(r,"Object",t)}function C(t,r){if(typeof t!="string")throw new $(r,"string",t)}const E=S.$2c==="win32";function n(t){return t===w||t===g}function o(t){return t===w}function a(t){return t>=F&&t<=L||t>=h&&t<=A}function m(t,r,s,i){let c="",l=0,b=-1,y=0,u=0;for(let d=0;d<=t.length;++d){if(d<t.length)u=t.charCodeAt(d);else{if(i(u))break;u=w}if(i(u)){if(!(b===d-1||y===1))if(y===2){if(c.length<2||l!==2||c.charCodeAt(c.length-1)!==f||c.charCodeAt(c.length-2)!==f){if(c.length>2){const p=c.lastIndexOf(s);p===-1?(c="",l=0):(c=c.slice(0,p),l=c.length-1-c.lastIndexOf(s)),b=d,y=0;continue}else if(c.length!==0){c="",l=0,b=d,y=0;continue}}r&&(c+=c.length>0?`${s}..`:"..",l=2)}else c.length>0?c+=`${s}${t.slice(b+1,d)}`:c=t.slice(b+1,d),l=d-b-1;b=d,y=0}else u===f&&y!==-1?++y:y=-1}return c}function v(t,r){k(r,"pathObject");const s=r.dir||r.root,i=r.base||`${r.name||""}${r.ext||""}`;return s?s===r.root?`${s}${i}`:`${s}${t}${i}`:i}e.$4c={resolve(...t){let r="",s="",i=!1;for(let c=t.length-1;c>=-1;c--){let l;if(c>=0){if(l=t[c],C(l,"path"),l.length===0)continue}else r.length===0?l=S.cwd():(l=S.env[`=${r}`]||S.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==r.toLowerCase()&&l.charCodeAt(2)===g)&&(l=`${r}\\`));const b=l.length;let y=0,u="",d=!1;const p=l.charCodeAt(0);if(b===1)n(p)&&(y=1,d=!0);else if(n(p))if(d=!0,n(l.charCodeAt(1))){let R=2,O=R;for(;R<b&&!n(l.charCodeAt(R));)R++;if(R<b&&R!==O){const j=l.slice(O,R);for(O=R;R<b&&n(l.charCodeAt(R));)R++;if(R<b&&R!==O){for(O=R;R<b&&!n(l.charCodeAt(R));)R++;(R===b||R!==O)&&(u=`\\\\${j}\\${l.slice(O,R)}`,y=R)}}}else y=1;else a(p)&&l.charCodeAt(1)===P&&(u=l.slice(0,2),y=2,b>2&&n(l.charCodeAt(2))&&(d=!0,y=3));if(u.length>0)if(r.length>0){if(u.toLowerCase()!==r.toLowerCase())continue}else r=u;if(i){if(r.length>0)break}else if(s=`${l.slice(y)}\\${s}`,i=d,d&&r.length>0)break}return s=m(s,!i,"\\",n),i?`${r}\\${s}`:`${r}${s}`||"."},normalize(t){C(t,"path");const r=t.length;if(r===0)return".";let s=0,i,c=!1;const l=t.charCodeAt(0);if(r===1)return o(l)?"\\":t;if(n(l))if(c=!0,n(t.charCodeAt(1))){let y=2,u=y;for(;y<r&&!n(t.charCodeAt(y));)y++;if(y<r&&y!==u){const d=t.slice(u,y);for(u=y;y<r&&n(t.charCodeAt(y));)y++;if(y<r&&y!==u){for(u=y;y<r&&!n(t.charCodeAt(y));)y++;if(y===r)return`\\\\${d}\\${t.slice(u)}\\`;y!==u&&(i=`\\\\${d}\\${t.slice(u,y)}`,s=y)}}}else s=1;else a(l)&&t.charCodeAt(1)===P&&(i=t.slice(0,2),s=2,r>2&&n(t.charCodeAt(2))&&(c=!0,s=3));let b=s<r?m(t.slice(s),!c,"\\",n):"";return b.length===0&&!c&&(b="."),b.length>0&&n(t.charCodeAt(r-1))&&(b+="\\"),i===void 0?c?`\\${b}`:b:c?`${i}\\${b}`:`${i}${b}`},isAbsolute(t){C(t,"path");const r=t.length;if(r===0)return!1;const s=t.charCodeAt(0);return n(s)||r>2&&a(s)&&t.charCodeAt(1)===P&&n(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,s;for(let l=0;l<t.length;++l){const b=t[l];C(b,"path"),b.length>0&&(r===void 0?r=s=b:r+=`\\${b}`)}if(r===void 0)return".";let i=!0,c=0;if(typeof s=="string"&&n(s.charCodeAt(0))){++c;const l=s.length;l>1&&n(s.charCodeAt(1))&&(++c,l>2&&(n(s.charCodeAt(2))?++c:i=!1))}if(i){for(;c<r.length&&n(r.charCodeAt(c));)c++;c>=2&&(r=`\\${r.slice(c)}`)}return e.$4c.normalize(r)},relative(t,r){if(C(t,"from"),C(r,"to"),t===r)return"";const s=e.$4c.resolve(t),i=e.$4c.resolve(r);if(s===i||(t=s.toLowerCase(),r=i.toLowerCase(),t===r))return"";let c=0;for(;c<t.length&&t.charCodeAt(c)===g;)c++;let l=t.length;for(;l-1>c&&t.charCodeAt(l-1)===g;)l--;const b=l-c;let y=0;for(;y<r.length&&r.charCodeAt(y)===g;)y++;let u=r.length;for(;u-1>y&&r.charCodeAt(u-1)===g;)u--;const d=u-y,p=b<d?b:d;let R=-1,O=0;for(;O<p;O++){const T=t.charCodeAt(c+O);if(T!==r.charCodeAt(y+O))break;T===g&&(R=O)}if(O!==p){if(R===-1)return i}else{if(d>p){if(r.charCodeAt(y+O)===g)return i.slice(y+O+1);if(O===2)return i.slice(y+O)}b>p&&(t.charCodeAt(c+O)===g?R=O:O===2&&(R=3)),R===-1&&(R=0)}let j="";for(O=c+R+1;O<=l;++O)(O===l||t.charCodeAt(O)===g)&&(j+=j.length===0?"..":"\\..");return y+=R,j.length>0?`${j}${i.slice(y,u)}`:(i.charCodeAt(y)===g&&++y,i.slice(y,u))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$4c.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===g){if(r.charCodeAt(1)===g){const s=r.charCodeAt(2);if(s!==I&&s!==f)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(a(r.charCodeAt(0))&&r.charCodeAt(1)===P&&r.charCodeAt(2)===g)return`\\\\?\\${r}`;return t},dirname(t){C(t,"path");const r=t.length;if(r===0)return".";let s=-1,i=0;const c=t.charCodeAt(0);if(r===1)return n(c)?t:".";if(n(c)){if(s=i=1,n(t.charCodeAt(1))){let y=2,u=y;for(;y<r&&!n(t.charCodeAt(y));)y++;if(y<r&&y!==u){for(u=y;y<r&&n(t.charCodeAt(y));)y++;if(y<r&&y!==u){for(u=y;y<r&&!n(t.charCodeAt(y));)y++;if(y===r)return t;y!==u&&(s=i=y+1)}}}}else a(c)&&t.charCodeAt(1)===P&&(s=r>2&&n(t.charCodeAt(2))?3:2,i=s);let l=-1,b=!0;for(let y=r-1;y>=i;--y)if(n(t.charCodeAt(y))){if(!b){l=y;break}}else b=!1;if(l===-1){if(s===-1)return".";l=s}return t.slice(0,l)},basename(t,r){r!==void 0&&C(r,"ext"),C(t,"path");let s=0,i=-1,c=!0,l;if(t.length>=2&&a(t.charCodeAt(0))&&t.charCodeAt(1)===P&&(s=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let b=r.length-1,y=-1;for(l=t.length-1;l>=s;--l){const u=t.charCodeAt(l);if(n(u)){if(!c){s=l+1;break}}else y===-1&&(c=!1,y=l+1),b>=0&&(u===r.charCodeAt(b)?--b===-1&&(i=l):(b=-1,i=y))}return s===i?i=y:i===-1&&(i=t.length),t.slice(s,i)}for(l=t.length-1;l>=s;--l)if(n(t.charCodeAt(l))){if(!c){s=l+1;break}}else i===-1&&(c=!1,i=l+1);return i===-1?"":t.slice(s,i)},extname(t){C(t,"path");let r=0,s=-1,i=0,c=-1,l=!0,b=0;t.length>=2&&t.charCodeAt(1)===P&&a(t.charCodeAt(0))&&(r=i=2);for(let y=t.length-1;y>=r;--y){const u=t.charCodeAt(y);if(n(u)){if(!l){i=y+1;break}continue}c===-1&&(l=!1,c=y+1),u===f?s===-1?s=y:b!==1&&(b=1):s!==-1&&(b=-1)}return s===-1||c===-1||b===0||b===1&&s===c-1&&s===i+1?"":t.slice(s,c)},format:v.bind(null,"\\"),parse(t){C(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const s=t.length;let i=0,c=t.charCodeAt(0);if(s===1)return n(c)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(n(c)){if(i=1,n(t.charCodeAt(1))){let R=2,O=R;for(;R<s&&!n(t.charCodeAt(R));)R++;if(R<s&&R!==O){for(O=R;R<s&&n(t.charCodeAt(R));)R++;if(R<s&&R!==O){for(O=R;R<s&&!n(t.charCodeAt(R));)R++;R===s?i=R:R!==O&&(i=R+1)}}}}else if(a(c)&&t.charCodeAt(1)===P){if(s<=2)return r.root=r.dir=t,r;if(i=2,n(t.charCodeAt(2))){if(s===3)return r.root=r.dir=t,r;i=3}}i>0&&(r.root=t.slice(0,i));let l=-1,b=i,y=-1,u=!0,d=t.length-1,p=0;for(;d>=i;--d){if(c=t.charCodeAt(d),n(c)){if(!u){b=d+1;break}continue}y===-1&&(u=!1,y=d+1),c===f?l===-1?l=d:p!==1&&(p=1):l!==-1&&(p=-1)}return y!==-1&&(l===-1||p===0||p===1&&l===y-1&&l===b+1?r.base=r.name=t.slice(b,y):(r.name=t.slice(b,l),r.base=t.slice(b,y),r.ext=t.slice(l,y))),b>0&&b!==i?r.dir=t.slice(0,b-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const D=(()=>{if(E){const t=/\\/g;return()=>{const r=S.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>S.cwd()})();e.$5c={resolve(...t){let r="",s=!1;for(let i=t.length-1;i>=-1&&!s;i--){const c=i>=0?t[i]:D();C(c,"path"),c.length!==0&&(r=`${c}/${r}`,s=c.charCodeAt(0)===w)}return r=m(r,!s,"/",o),s?`/${r}`:r.length>0?r:"."},normalize(t){if(C(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===w,s=t.charCodeAt(t.length-1)===w;return t=m(t,!r,"/",o),t.length===0?r?"/":s?"./":".":(s&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return C(t,"path"),t.length>0&&t.charCodeAt(0)===w},join(...t){if(t.length===0)return".";let r;for(let s=0;s<t.length;++s){const i=t[s];C(i,"path"),i.length>0&&(r===void 0?r=i:r+=`/${i}`)}return r===void 0?".":e.$5c.normalize(r)},relative(t,r){if(C(t,"from"),C(r,"to"),t===r||(t=e.$5c.resolve(t),r=e.$5c.resolve(r),t===r))return"";const s=1,i=t.length,c=i-s,l=1,b=r.length-l,y=c<b?c:b;let u=-1,d=0;for(;d<y;d++){const R=t.charCodeAt(s+d);if(R!==r.charCodeAt(l+d))break;R===w&&(u=d)}if(d===y)if(b>y){if(r.charCodeAt(l+d)===w)return r.slice(l+d+1);if(d===0)return r.slice(l+d)}else c>y&&(t.charCodeAt(s+d)===w?u=d:d===0&&(u=0));let p="";for(d=s+u+1;d<=i;++d)(d===i||t.charCodeAt(d)===w)&&(p+=p.length===0?"..":"/..");return`${p}${r.slice(l+u)}`},toNamespacedPath(t){return t},dirname(t){if(C(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===w;let s=-1,i=!0;for(let c=t.length-1;c>=1;--c)if(t.charCodeAt(c)===w){if(!i){s=c;break}}else i=!1;return s===-1?r?"/":".":r&&s===1?"//":t.slice(0,s)},basename(t,r){r!==void 0&&C(r,"ext"),C(t,"path");let s=0,i=-1,c=!0,l;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let b=r.length-1,y=-1;for(l=t.length-1;l>=0;--l){const u=t.charCodeAt(l);if(u===w){if(!c){s=l+1;break}}else y===-1&&(c=!1,y=l+1),b>=0&&(u===r.charCodeAt(b)?--b===-1&&(i=l):(b=-1,i=y))}return s===i?i=y:i===-1&&(i=t.length),t.slice(s,i)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===w){if(!c){s=l+1;break}}else i===-1&&(c=!1,i=l+1);return i===-1?"":t.slice(s,i)},extname(t){C(t,"path");let r=-1,s=0,i=-1,c=!0,l=0;for(let b=t.length-1;b>=0;--b){const y=t.charCodeAt(b);if(y===w){if(!c){s=b+1;break}continue}i===-1&&(c=!1,i=b+1),y===f?r===-1?r=b:l!==1&&(l=1):r!==-1&&(l=-1)}return r===-1||i===-1||l===0||l===1&&r===i-1&&r===s+1?"":t.slice(r,i)},format:v.bind(null,"/"),parse(t){C(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const s=t.charCodeAt(0)===w;let i;s?(r.root="/",i=1):i=0;let c=-1,l=0,b=-1,y=!0,u=t.length-1,d=0;for(;u>=i;--u){const p=t.charCodeAt(u);if(p===w){if(!y){l=u+1;break}continue}b===-1&&(y=!1,b=u+1),p===f?c===-1?c=u:d!==1&&(d=1):c!==-1&&(d=-1)}if(b!==-1){const p=l===0&&s?1:l;c===-1||d===0||d===1&&c===b-1&&c===l+1?r.base=r.name=t.slice(p,b):(r.name=t.slice(p,c),r.base=t.slice(p,b),r.ext=t.slice(c,b))}return l>0?r.dir=t.slice(0,l-1):s&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$5c.win32=e.$4c.win32=e.$4c,e.$5c.posix=e.$4c.posix=e.$5c,e.$6c=E?e.$4c.normalize:e.$5c.normalize,e.$7c=E?e.$4c.isAbsolute:e.$5c.isAbsolute,e.$8c=E?e.$4c.join:e.$5c.join,e.$9c=E?e.$4c.resolve:e.$5c.resolve,e.$0c=E?e.$4c.relative:e.$5c.relative,e.$$c=E?e.$4c.dirname:e.$5c.dirname,e.$_c=E?e.$4c.basename:e.$5c.basename,e.$ad=E?e.$4c.extname:e.$5c.extname,e.$bd=E?e.$4c.format:e.$5c.format,e.$cd=E?e.$4c.parse:e.$5c.parse,e.$dd=E?e.$4c.toNamespacedPath:e.$5c.toNamespacedPath,e.sep=E?e.$4c.sep:e.$5c.sep,e.$fd=E?e.$4c.delimiter:e.$5c.delimiter}),define(Se[124],De([1,0,55,14]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=e.$$p=e.$0p=e.$9p=e.$8p=e.$7p=e.$6p=e.$5p=e.$4p=e.$3p=e.$2p=e.$1p=void 0;const h=new S.$T(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),L=new S.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new S.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function f(y,u,d=!1){const p=y||"",R=u||"",O=h.value.collator.compare(p,R);return h.value.collatorIsNumeric&&O===0&&p!==R?p<R?-1:1:O}e.$1p=f;function w(y,u){const d=L.value.collator;return y=y||"",u=u||"",v(d,y,u)}e.$2p=w;function g(y,u){const d=L.value.collator;return y=y||"",u=u||"",s(y,u)||v(d,y,u)}e.$3p=g;function P(y,u){const d=L.value.collator;return y=y||"",u=u||"",r(y,u)||v(d,y,u)}e.$4p=P;function I(y,u){return y=y||"",u=u||"",y===u?0:y<u?-1:1}e.$5p=I;function $(y,u){const[d,p]=a(y),[R,O]=a(u);let j=h.value.collator.compare(p,O);if(j===0){if(h.value.collatorIsNumeric&&p!==O)return p<O?-1:1;if(j=h.value.collator.compare(d,R),h.value.collatorIsNumeric&&j===0&&d!==R)return d<R?-1:1}return j}e.$6p=$;function k(y,u){y=y||"",u=u||"";const d=m(y),p=m(u),R=L.value.collator,O=A.value.collator;return v(O,d,p)||v(R,y,u)}e.$7p=k;function C(y,u){y=y||"",u=u||"";const d=m(y),p=m(u),R=L.value.collator,O=A.value.collator;return v(O,d,p)||s(y,u)||v(R,y,u)}e.$8p=C;function E(y,u){y=y||"",u=u||"";const d=m(y),p=m(u),R=L.value.collator,O=A.value.collator;return v(O,d,p)||r(y,u)||v(R,y,u)}e.$9p=E;function n(y,u){y=y||"",u=u||"";const d=m(y).toLowerCase(),p=m(u).toLowerCase();return d!==p?d<p?-1:1:y!==u?y<u?-1:1:0}e.$0p=n;const o=/^(.*?)(\.([^.]*))?$/;function a(y,u=!1){const d=y?o.exec(y):[];let p=[d&&d[1]||"",d&&d[3]||""];return u&&(!p[0]&&p[1]||p[0]&&p[0].charAt(0)===".")&&(p=[p[0]+"."+p[1],""]),p}function m(y){const u=y?o.exec(y):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function v(y,u,d){const p=y.compare(u,d);return p!==0?p:u.length!==d.length?u.length<d.length?-1:1:0}function D(y){const u=y.charAt(0);return u.toLocaleUpperCase()!==u}function t(y){const u=y.charAt(0);return u.toLocaleLowerCase()!==u}function r(y,u){return D(y)&&t(u)?-1:t(y)&&D(u)?1:0}function s(y,u){return t(y)&&D(u)?-1:D(y)&&t(u)?1:0}function i(y,u,d=!1){return d||(y=y&&y.toLowerCase(),u=u&&u.toLowerCase()),y===u?0:y<u?-1:1}function c(y,u,d=!1){const p=y.split(F.sep),R=u.split(F.sep),O=p.length-1,j=R.length-1;let T,z;for(let B=0;;B++){if(T=O===B,z=j===B,T&&z)return f(p[B],R[B],d);if(T)return-1;if(z)return 1;const M=i(p[B],R[B],d);if(M!==0)return M}}e.$$p=c;function l(y,u,d){const p=y.toLowerCase(),R=u.toLowerCase(),O=b(y,u,d);if(O)return O;const j=p.endsWith(d),T=R.endsWith(d);if(j!==T)return j?-1:1;const z=f(p,R);return z!==0?z:p.localeCompare(R)}e.$_p=l;function b(y,u,d){const p=y.toLowerCase(),R=u.toLowerCase(),O=p.startsWith(d),j=R.startsWith(d);if(O!==j)return O?-1:1;if(O&&j){if(p.length<R.length)return-1;if(p.length>R.length)return 1}return 0}e.$aq=b}),define(Se[32],De([1,0,14,9,15,19]),function(me,e,S,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=void 0;function A(l){return l===47||l===92}e.$Ae=A;function f(l){return l.replace(/[\\/]/g,S.$5c.sep)}e.$Be=f;function w(l){return l.indexOf("/")===-1&&(l=f(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.$Ce=w;function g(l,b=S.$5c.sep){if(!l)return"";const y=l.length,u=l.charCodeAt(0);if(A(u)){if(A(l.charCodeAt(1))&&!A(l.charCodeAt(2))){let p=3;const R=p;for(;p<y&&!A(l.charCodeAt(p));p++);if(R!==p&&!A(l.charCodeAt(p+1))){for(p+=1;p<y;p++)if(A(l.charCodeAt(p)))return l.slice(0,p+1).replace(/[\\/]/g,b)}}return b}else if(o(u)&&l.charCodeAt(1)===58)return A(l.charCodeAt(2))?l.slice(0,2)+b:l.slice(0,2);let d=l.indexOf("://");if(d!==-1){for(d+=3;d<y;d++)if(A(l.charCodeAt(d)))return l.slice(0,d+1)}return""}e.$De=g;function P(l){if(!F.$i||!l||l.length<5)return!1;let b=l.charCodeAt(0);if(b!==92||(b=l.charCodeAt(1),b!==92))return!1;let y=2;const u=y;for(;y<l.length&&(b=l.charCodeAt(y),b!==92);y++);return!(u===y||(b=l.charCodeAt(y+1),isNaN(b)||b===92))}e.$Ee=P;const I=/[\\/:\*\?"<>\|]/g,$=/[\\/]/g,k=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function C(l,b=F.$i){const y=b?I:$;return!(!l||l.length===0||/^\s+$/.test(l)||(y.lastIndex=0,y.test(l))||b&&k.test(l)||l==="."||l===".."||b&&l[l.length-1]==="."||b&&l.length!==l.trim().length||l.length>255)}e.$Fe=C;function E(l,b,y){const u=l===b;return!y||u?u:!l||!b?!1:(0,h.$Ld)(l,b)}e.$Ge=E;function n(l,b,y,u=S.sep){if(l===b)return!0;if(!l||!b||b.length>l.length)return!1;if(y){if(!(0,h.$Md)(l,b))return!1;if(b.length===l.length)return!0;let p=b.length;return b.charAt(b.length-1)===u&&p--,l.charAt(p)===u}return b.charAt(b.length-1)!==u&&(b+=u),l.indexOf(b)===0}e.$He=n;function o(l){return l>=65&&l<=90||l>=97&&l<=122}e.$Ie=o;function a(l,b){return F.$i&&l.endsWith(":")&&(l+=S.sep),(0,S.$7c)(l)||(l=(0,S.$8c)(b,l)),l=(0,S.$6c)(l),F.$i?(l=(0,h.$ud)(l,S.sep),l.endsWith(":")&&(l+=S.sep)):(l=(0,h.$ud)(l,S.sep),l||(l=S.sep)),l}e.$Je=a;function m(l){const b=(0,S.$6c)(l);return F.$i?l.length>3?!1:v(b)&&(l.length===2||b.charCodeAt(2)===92):b===S.$5c.sep}e.$Ke=m;function v(l,b=F.$i){return b?o(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.$Le=v;function D(l,b=F.$i){return v(l,b)?l[0]:void 0}e.$Me=D;function t(l,b,y){return b.length>l.length?-1:l===b?0:(y&&(l=l.toLowerCase(),b=b.toLowerCase()),l.indexOf(b))}e.$Ne=t;function r(l){const b=l.split(":");let y,u,d;for(const p of b){const R=Number(p);(0,L.$me)(R)?u===void 0?u=R:d===void 0&&(d=R):y=y?[y,p].join(":"):p}if(!y)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:y,line:u!==void 0?u:void 0,column:d!==void 0?d:u!==void 0?1:void 0}}e.$Oe=r;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function c(l,b,y=8){let u="";for(let p=0;p<y;p++){let R;p===0&&F.$i&&!b&&(y===3||y===4)?R=i:R=s,u+=R.charAt(Math.floor(Math.random()*R.length))}let d;return b?d=`${b}-${u}`:d=u,l?(0,S.$8c)(l,d):d}e.$Pe=c}),define(Se[125],De([1,0,124,119,74,14,9,15]),function(me,e,S,F,h,L,A,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=e.$bq=void 0;const w=0,g=[w,[]];function P(Y,J,fe,se){if(!Y||!J)return g;const ie=Y.length,V=J.length;if(ie<V)return g;const re=Y.toLowerCase();return I(J,fe,V,Y,re,ie,se)}e.$bq=P;function I(Y,J,fe,se,ie,V,re){const pe=[],ae=[];for(let q=0;q<fe;q++){const de=q*V,ye=de-V,ve=q>0,we=Y[q],Ee=J[q];for(let K=0;K<V;K++){const ee=K>0,G=de+K,X=G-1,he=ye+K-1,Ie=ee?pe[X]:0,U=ve&&ee?pe[he]:0,Q=ve&&ee?ae[he]:0;let _;!U&&ve?_=0:_=$(we,Ee,se,ie,K,Q),_&&U+_>=Ie&&(re||ve||ie.startsWith(J,K))?(ae[G]=Q+1,pe[G]=U+_):(ae[G]=w,pe[G]=Ie)}}const ne=[];let x=fe-1,N=V-1;for(;x>=0&&N>=0;){const q=x*V+N;ae[q]===w||(ne.push(N),x--),N--}return[pe[fe*V-1],ne.reverse()]}function $(Y,J,fe,se,ie,V){let re=0;if(!k(J,se[ie]))return re;if(re+=1,V>0&&(re+=V*5),Y===fe[ie]&&(re+=1),ie===0)re+=8;else{const pe=C(fe.charCodeAt(ie-1));pe?re+=pe:(0,F.$oj)(fe.charCodeAt(ie))&&V===0&&(re+=2)}return re}function k(Y,J){return Y===J?!0:Y==="/"||Y==="\\"?J==="/"||J==="\\":!1}function C(Y){switch(Y){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const E=[void 0,[]];function n(Y,J,fe=0,se=0){const ie=J;return ie.values&&ie.values.length>1?o(Y,ie.values,fe,se):a(Y,J,fe,se)}e.$cq=n;function o(Y,J,fe,se){let ie=0;const V=[];for(const re of J){const[pe,ae]=a(Y,re,fe,se);if(typeof pe!="number")return E;ie+=pe,V.push(...ae)}return[ie,y(V)]}function a(Y,J,fe,se){const ie=(0,F.$xj)(J.original,J.originalLowercase,fe,Y,Y.toLowerCase(),se,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ie?[ie[0],(0,F.$uj)(ie)]:E}const m=Object.freeze({score:0}),v=1<<18,D=1<<17,t=1<<16;function r(Y,J,fe,se){const ie=se.values?se.values:[se];return(0,h.$di)({[se.normalized]:{values:ie.map(re=>({value:re.normalized,expectContiguousMatch:re.expectContiguousMatch})),label:Y,description:J,allowNonContiguousMatches:fe}})}function s(Y,J,fe,se,ie){if(!Y||!J.normalized)return m;const V=se.getItemLabel(Y);if(!V)return m;const re=se.getItemDescription(Y),pe=r(V,re,fe,J),ae=ie[pe];if(ae)return ae;const ne=i(V,re,se.getItemPath(Y),J,fe);return ie[pe]=ne,ne}e.$dq=s;function i(Y,J,fe,se,ie){const V=!fe||!se.containsPathSeparator;return fe&&(A.$k?se.pathNormalized===fe:(0,f.$Ld)(se.pathNormalized,fe))?{score:v,labelMatch:[{start:0,end:Y.length}],descriptionMatch:J?[{start:0,end:J.length}]:void 0}:se.values&&se.values.length>1?c(Y,J,fe,se.values,V,ie):l(Y,J,fe,se,V,ie)}function c(Y,J,fe,se,ie,V){let re=0;const pe=[],ae=[];for(const ne of se){const{score:x,labelMatch:N,descriptionMatch:q}=l(Y,J,fe,ne,ie,V);if(x===w)return m;re+=x,N&&pe.push(...N),q&&ae.push(...q)}return{score:re,labelMatch:y(pe),descriptionMatch:y(ae)}}function l(Y,J,fe,se,ie,V){if(ie||!J){const[re,pe]=P(Y,se.normalized,se.normalizedLowercase,V&&!se.expectContiguousMatch);if(re){const ae=(0,F.$lj)(se.normalized,Y);let ne;if(ae){ne=D;const x=Math.round(se.normalized.length/Y.length*100);ne+=x}else ne=t;return{score:ne+re,labelMatch:ae||b(pe)}}}if(J){let re=J;fe&&(re=`${J}${L.sep}`);const pe=re.length,ae=`${re}${Y}`,[ne,x]=P(ae,se.normalized,se.normalizedLowercase,V&&!se.expectContiguousMatch);if(ne){const N=b(x),q=[],de=[];return N.forEach(ye=>{ye.start<pe&&ye.end>pe?(q.push({start:0,end:ye.end-pe}),de.push({start:ye.start,end:pe})):ye.start>=pe?q.push({start:ye.start-pe,end:ye.end-pe}):de.push(ye)}),{score:ne,labelMatch:q,descriptionMatch:de}}}return m}function b(Y){const J=[];if(!Y)return J;let fe;for(const se of Y)fe&&fe.end===se?fe.end+=1:(fe={start:se,end:se+1},J.push(fe));return J}function y(Y){const J=Y.sort((ie,V)=>ie.start-V.start),fe=[];let se;for(const ie of J)!se||!u(se,ie)?(se=ie,fe.push(ie)):(se.start=Math.min(se.start,ie.start),se.end=Math.max(se.end,ie.end));return fe}function u(Y,J){return!(Y.end<J.start||J.end<Y.start)}function d(Y,J,fe,se,ie,V){const re=s(Y,fe,se,ie,V),pe=s(J,fe,se,ie,V),ae=re.score,ne=pe.score;if((ae===v||ne===v)&&ae!==ne)return ae===v?-1:1;if(ae>t||ne>t){if(ae!==ne)return ae>ne?-1:1;if(ae<D&&ne<D){const we=R(re.labelMatch,pe.labelMatch);if(we!==0)return we}const ye=ie.getItemLabel(Y)||"",ve=ie.getItemLabel(J)||"";if(ye.length!==ve.length)return ye.length-ve.length}if(ae!==ne)return ae>ne?-1:1;const x=Array.isArray(re.labelMatch)&&re.labelMatch.length>0,N=Array.isArray(pe.labelMatch)&&pe.labelMatch.length>0;if(x&&!N)return-1;if(N&&!x)return 1;const q=p(Y,re,ie),de=p(J,pe,ie);return q&&de&&q!==de?de>q?-1:1:O(Y,J,fe,ie)}e.$eq=d;function p(Y,J,fe){let se=-1,ie=-1;if(J.descriptionMatch&&J.descriptionMatch.length?se=J.descriptionMatch[0].start:J.labelMatch&&J.labelMatch.length&&(se=J.labelMatch[0].start),J.labelMatch&&J.labelMatch.length){if(ie=J.labelMatch[J.labelMatch.length-1].end,J.descriptionMatch&&J.descriptionMatch.length){const V=fe.getItemDescription(Y);V&&(ie+=V.length)}}else J.descriptionMatch&&J.descriptionMatch.length&&(ie=J.descriptionMatch[J.descriptionMatch.length-1].end);return ie-se}function R(Y,J){if(!Y&&!J||(!Y||!Y.length)&&(!J||!J.length))return 0;if(!J||!J.length)return-1;if(!Y||!Y.length)return 1;const fe=Y[0].start,ie=Y[Y.length-1].end-fe,V=J[0].start,pe=J[J.length-1].end-V;return ie===pe?0:pe<ie?1:-1}function O(Y,J,fe,se){const ie=se.getItemLabel(Y)||"",V=se.getItemLabel(J)||"",re=se.getItemDescription(Y),pe=se.getItemDescription(J),ae=ie.length+(re?re.length:0),ne=V.length+(pe?pe.length:0);if(ae!==ne)return ae-ne;const x=se.getItemPath(Y),N=se.getItemPath(J);return x&&N&&x.length!==N.length?x.length-N.length:ie!==V?(0,S.$_p)(ie,V,fe.normalized):re&&pe&&re!==pe?(0,S.$_p)(re,pe,fe.normalized):x&&N&&x!==N?(0,S.$_p)(x,N,fe.normalized):0}function j(Y){return Y.startsWith('"')&&Y.endsWith('"')}const T=" ";function z(Y){typeof Y!="string"&&(Y="");const J=Y.toLowerCase(),{pathNormalized:fe,normalized:se,normalizedLowercase:ie}=B(Y),V=fe.indexOf(L.sep)>=0,re=j(Y);let pe;const ae=Y.split(T);if(ae.length>1)for(const ne of ae){const x=j(ne),{pathNormalized:N,normalized:q,normalizedLowercase:de}=B(ne);q&&(pe||(pe=[]),pe.push({original:ne,originalLowercase:ne.toLowerCase(),pathNormalized:N,normalized:q,normalizedLowercase:de,expectContiguousMatch:x}))}return{original:Y,originalLowercase:J,pathNormalized:fe,normalized:se,normalizedLowercase:ie,values:pe,containsPathSeparator:V,expectContiguousMatch:re}}e.$fq=z;function B(Y){let J;A.$i?J=Y.replace(/\//g,L.sep):J=Y.replace(/\\/g,L.sep);const fe=(0,f.$wd)(J).replace(/\s|"/g,"");return{pathNormalized:J,normalized:fe,normalizedLowercase:fe.toLowerCase()}}function M(Y){return Array.isArray(Y)?z(Y.map(J=>J.original).join(T)):z(Y.original)}e.$gq=M}),define(Se[97],De([1,0,14]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=e.$Br=e.$Ar=e.$zr=e.$yr=void 0,e.$yr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},h={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(P){const I=(0,S.$ad)(P),$=F[I.toLowerCase()];return $!==void 0?$:A(P)}e.$zr=L;function A(P){const I=(0,S.$ad)(P);return h[I.toLowerCase()]}e.$Ar=A;function f(P){for(const I in h)if(h[I]===P)return I}e.$Br=f;const w=/^(.+)\/(.+?)(;.+)?$/;function g(P,I){const $=w.exec(P);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:I?void 0:P}e.$Cr=g}),define(Se[98],De([1,0,9]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=e.TerminateResponseCode=e.Source=void 0;var F;(function(f){f[f.stdout=0]="stdout",f[f.stderr=1]="stderr"})(F||(e.Source=F={}));var h;(function(f){f[f.Success=0]="Success",f[f.Unknown=1]="Unknown",f[f.AccessDenied=2]="AccessDenied",f[f.ProcessNotFound=3]="ProcessNotFound"})(h||(e.TerminateResponseCode=h={}));function L(f,...w){const g=w.reduce(($,k)=>($[k]=!0,$),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(f).filter($=>!g[$]).forEach($=>{for(let k=0;k<P.length;k++)if($.search(P[k])!==-1){delete f[$];break}})}e.$fl=L;function A(f){f&&(delete f.DEBUG,S.$j&&delete f.DYLD_LIBRARY_PATH,S.$k&&delete f.LD_PRELOAD)}e.$gl=A}),define(Se[2],De([1,0,14,9]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=e.$Re=e.URI=void 0;const h=/^\w[\w\d+.-]*$/,L=/^\//,A=/^\/\//;function f(i,c){if(!i.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!h.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!L.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(i,c){return!i&&!c?"file":i}function g(i,c){switch(i){case"https":case"http":case"file":c?c[0]!==I&&(c=I+c):c=I;break}return c}const P="",I="/",$=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class k{static isUri(c){return c instanceof k?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,l,b,y,u,d=!1){typeof c=="object"?(this.scheme=c.scheme||P,this.authority=c.authority||P,this.path=c.path||P,this.query=c.query||P,this.fragment=c.fragment||P):(this.scheme=w(c,d),this.authority=l||P,this.path=g(this.scheme,b||P),this.query=y||P,this.fragment=u||P,f(this,d))}get fsPath(){return v(this,!1)}with(c){if(!c)return this;let{scheme:l,authority:b,path:y,query:u,fragment:d}=c;return l===void 0?l=this.scheme:l===null&&(l=P),b===void 0?b=this.authority:b===null&&(b=P),y===void 0?y=this.path:y===null&&(y=P),u===void 0?u=this.query:u===null&&(u=P),d===void 0?d=this.fragment:d===null&&(d=P),l===this.scheme&&b===this.authority&&y===this.path&&u===this.query&&d===this.fragment?this:new n(l,b,y,u,d)}static parse(c,l=!1){const b=$.exec(c);return b?new n(b[2]||P,s(b[4]||P),s(b[5]||P),s(b[7]||P),s(b[9]||P),l):new n(P,P,P,P,P)}static file(c){let l=P;if(F.$i&&(c=c.replace(/\\/g,I)),c[0]===I&&c[1]===I){const b=c.indexOf(I,2);b===-1?(l=c.substring(2),c=I):(l=c.substring(2,b),c=c.substring(b)||I)}return new n("file",l,c,P,P)}static from(c,l){return new n(c.scheme,c.authority,c.path,c.query,c.fragment,l)}static joinPath(c,...l){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return F.$i&&c.scheme==="file"?b=k.file(S.$4c.join(v(c,!0),...l)).path:b=S.$5c.join(c.path,...l),c.with({path:b})}toString(c=!1){return D(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof k)return c;{const l=new n(c);return l._formatted=c.external??null,l._fsPath=c._sep===E?c.fsPath??null:null,l}}else return c}}e.URI=k;function C(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$Re=C;const E=F.$i?1:void 0;class n extends k{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(c=!1){return c?D(this,!0):(this._formatted||(this._formatted=D(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=E),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function a(i,c,l){let b,y=-1;for(let u=0;u<i.length;u++){const d=i.charCodeAt(u);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||c&&d===47||l&&d===91||l&&d===93||l&&d===58)y!==-1&&(b+=encodeURIComponent(i.substring(y,u)),y=-1),b!==void 0&&(b+=i.charAt(u));else{b===void 0&&(b=i.substr(0,u));const p=o[d];p!==void 0?(y!==-1&&(b+=encodeURIComponent(i.substring(y,u)),y=-1),b+=p):y===-1&&(y=u)}}return y!==-1&&(b+=encodeURIComponent(i.substring(y))),b!==void 0?b:i}function m(i){let c;for(let l=0;l<i.length;l++){const b=i.charCodeAt(l);b===35||b===63?(c===void 0&&(c=i.substr(0,l)),c+=o[b]):c!==void 0&&(c+=i[l])}return c!==void 0?c:i}function v(i,c){let l;return i.authority&&i.path.length>1&&i.scheme==="file"?l=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?c?l=i.path.substr(1):l=i.path[1].toLowerCase()+i.path.substr(2):l=i.path,F.$i&&(l=l.replace(/\//g,"\\")),l}e.$Se=v;function D(i,c){const l=c?m:a;let b="",{scheme:y,authority:u,path:d,query:p,fragment:R}=i;if(y&&(b+=y,b+=":"),(u||y==="file")&&(b+=I,b+=I),u){let O=u.indexOf("@");if(O!==-1){const j=u.substr(0,O);u=u.substr(O+1),O=j.lastIndexOf(":"),O===-1?b+=l(j,!1,!1):(b+=l(j.substr(0,O),!1,!1),b+=":",b+=l(j.substr(O+1),!1,!0)),b+="@"}u=u.toLowerCase(),O=u.lastIndexOf(":"),O===-1?b+=l(u,!1,!0):(b+=l(u.substr(0,O),!1,!0),b+=u.substr(O))}if(d){if(d.length>=3&&d.charCodeAt(0)===47&&d.charCodeAt(2)===58){const O=d.charCodeAt(1);O>=65&&O<=90&&(d=`/${String.fromCharCode(O+32)}:${d.substr(3)}`)}else if(d.length>=2&&d.charCodeAt(1)===58){const O=d.charCodeAt(0);O>=65&&O<=90&&(d=`${String.fromCharCode(O+32)}:${d.substr(2)}`)}b+=l(d,!0,!1)}return p&&(b+="?",b+=l(p,!1,!1)),R&&(b+="#",b+=c?R:a(R,!1,!1)),b}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(r)?i.replace(r,c=>t(c)):i}}),define(Se[178],De([1,0,2]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Gp=e.$Fp=e.$Ep=void 0;function F(g){const P=g;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$Ep=F;function h(g){const P=[];let I;try{const $=JSON.parse(g.arguments),k=$[$.length-1];k&&k.__$stack&&($.pop(),I=k.__$stack),P.push(...$)}catch{P.push("Unable to log remote console arguments",g.arguments)}return{args:P,stack:I}}e.$Fp=h;function L(g){if(typeof g!="string")return L(h(g).stack);const P=g;if(P){const I=A(P),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if($&&$.length===4)return{uri:S.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}e.$Gp=L;function A(g){if(!g)return g;const P=g.indexOf(`
`);return P===-1?g:g.substring(0,P)}function f(g,P){const{args:I,stack:$}=h(g),k=typeof I[0]=="string"&&I.length===1;let C=A($);C&&(C=`(${C.trim()})`);let E=[];if(typeof I[0]=="string"?C&&k?E=[`%c[${P}] %c${I[0]} %c${C}`,w("blue"),w(""),w("grey")]:E=[`%c[${P}] %c${I[0]}`,w("blue"),w(""),...I.slice(1)]:E=[`%c[${P}]%`,w("blue"),...I],C&&!k&&E.push(C),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,E)}e.log=f;function w(g){return`color: ${g}`}}),define(Se[77],De([1,0,21,2]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=e.$Xg=e.$Wg=void 0;function h(w){return JSON.stringify(w,A)}e.$Wg=h;function L(w){let g=JSON.parse(w);return g=f(g),g}e.$Xg=L;function A(w,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function f(w,g=0){if(!w||g>200)return w;if(typeof w=="object"){switch(w.$mid){case 1:return F.URI.revive(w);case 2:return new RegExp(w.source,w.flags);case 16:return new Date(w.source)}if(w instanceof S.$Ec||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let P=0;P<w.length;++P)w[P]=f(w[P],g+1);else for(const P in w)Object.hasOwnProperty.call(w,P)&&(w[P]=f(w[P],g+1))}return w}e.$Yg=f}),define(Se[16],De([1,0,8,9,2]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.Schemas=void 0;var L;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$Te="vscode-tkn",e.$Ue="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${L.vscodeRemoteResource}`}set(P,I,$){this.a[P]=I,this.b[P]=$}setConnectionToken(P,I){this.c[P]=I}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(n){return S.$Y(n),P}const I=P.authority;let $=this.a[I];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const k=this.b[I],C=this.c[I];let E=`path=${encodeURIComponent(P.path)}`;return typeof C=="string"&&(E+=`&${e.$Ue}=${encodeURIComponent(C)}`),h.URI.from({scheme:F.$o?this.d:L.vscodeRemoteResource,authority:`${$}:${k}`,path:this.f,query:E})}}e.$Ve=new A,e.$We="vs/../../extensions",e.$Xe="vs/../../node_modules",e.$Ye="vs/../../node_modules.asar",e.$Ze="vs/../../node_modules.asar.unpacked";class f{static{this.a="vscode-app"}asBrowserUri(P){const I=this.b(P,me);return this.uriToBrowserUri(I)}uriToBrowserUri(P){return P.scheme===L.vscodeRemote?e.$Ve.rewrite(P):P.scheme===L.file&&(F.$m||F.$p&&F.$g.origin===`${L.vscodeFileResource}://${f.a}`)?P.with({scheme:L.vscodeFileResource,authority:P.authority||f.a,query:null,fragment:null}):P}asFileUri(P){const I=this.b(P,me);return this.uriToFileUri(I)}uriToFileUri(P){return P.scheme===L.vscodeFileResource?P.with({scheme:L.file,authority:P.authority!==f.a?P.authority:null,query:null,fragment:null}):P}b(P,I){return h.URI.isUri(P)?P:h.URI.parse(I.toUrl(P))}}e.$1e=new f;var w;(function(g){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(P.get("3"));const I="vscode-coi";function $(C){let E;typeof C=="string"?E=new URL(C).searchParams:C instanceof URL?E=C.searchParams:h.URI.isUri(C)&&(E=new URL(C.toString(!0)).searchParams);const n=E?.get(I);if(n)return P.get(n)}g.getHeadersFromQuery=$;function k(C,E,n){if(!globalThis.crossOriginIsolated)return;const o=E&&n?"3":n?"2":"1";C instanceof URLSearchParams?C.set(I,o):C[I]=o}g.addSearchParam=k})(w||(e.COI=w={}))}),define(Se[179],De([1,0,153,16,9,2]),function(me,e,S,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2C=void 0;class A{constructor($,k,C){this.id=$,this.dependencies=k,this.callback=C}}class f{static{this.INSTANCE=new f}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,k,C)=>{typeof $!="string"&&(C=k,k=$,$=null),(typeof k!="object"||!Array.isArray(k))&&(C=k,k=null),this.c.push(new A($,k,C))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const k=await(this.a?this.i($):this.b?this.h($):this.j($));if(!k)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(k.dependencies)&&k.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${k.dependencies.join(", ")}`);return typeof k.callback=="function"?k.callback([]):k.callback}h($){return new Promise((k,C)=>{const E=document.createElement("script");E.setAttribute("async","async"),E.setAttribute("type","text/javascript");const n=()=>{E.removeEventListener("load",o),E.removeEventListener("error",a)},o=m=>{n(),k(this.c.pop())},a=m=>{n(),C(m)};E.addEventListener("load",o),E.addEventListener("error",a),this.f&&($=this.f.createScriptURL($)),E.setAttribute("src",$),document.getElementsByTagName("head")[0].appendChild(E)})}i($){return new Promise((k,C)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),k(this.c.pop())}catch(E){C(E)}})}async j($){try{const k=globalThis._VSCODE_NODE_MODULES.fs,C=globalThis._VSCODE_NODE_MODULES.vm,E=globalThis._VSCODE_NODE_MODULES.module,n=L.URI.parse($).fsPath,o=k.readFileSync(n).toString(),a=E.wrap(o.replace(/^#!.*/,""));return new C.Script(a).runInThisContext().apply(),this.c.pop()}catch(k){throw k}}}const w=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function P(I,$,k){if(S.$R){k===void 0&&(k=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[I]&&(I=g[I]);const C=`${I}/${$}`;if(w.has(C))return w.get(C);let E;if(/^\w[\w\d+.-]*:\/\//.test(C))E=C;else{const m=`${k&&!h.$o?F.$Ye:F.$Xe}/${C}`;E=F.$1e.asBrowserUri(m).toString(!0)}const n=f.INSTANCE.load(E);return w.set(C,n),n}else return await new Promise((C,E)=>{me([I],C,E)})}e.$2C=P}),define(Se[24],De([1,0,32,16,14,9,15,2]),function(me,e,S,F,h,L,A,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=e.DataUri=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=void 0;function w(k){return(0,f.$Se)(k,!0)}e.$Wf=w;class g{constructor(C){this.a=C}compare(C,E,n=!1){return C===E?0:(0,A.$Ed)(this.getComparisonKey(C,n),this.getComparisonKey(E,n))}isEqual(C,E,n=!1){return C===E?!0:!C||!E?!1:this.getComparisonKey(C,n)===this.getComparisonKey(E,n)}getComparisonKey(C,E=!1){return C.with({path:this.a(C)?C.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(C){return this.a(C)}isEqualOrParent(C,E,n=!1){if(C.scheme===E.scheme){if(C.scheme===F.Schemas.file)return S.$He(w(C),w(E),this.a(C))&&C.query===E.query&&(n||C.fragment===E.fragment);if((0,e.$bg)(C.authority,E.authority))return S.$He(C.path,E.path,this.a(C),"/")&&C.query===E.query&&(n||C.fragment===E.fragment)}return!1}joinPath(C,...E){return f.URI.joinPath(C,...E)}basenameOrAuthority(C){return(0,e.$6f)(C)||C.authority}basename(C){return h.$5c.basename(C.path)}extname(C){return h.$5c.extname(C.path)}dirname(C){if(C.path.length===0)return C;let E;return C.scheme===F.Schemas.file?E=f.URI.file(h.$$c(w(C))).path:(E=h.$5c.dirname(C.path),C.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${C.toString})) resulted in a relative path`),E="/")),C.with({path:E})}normalizePath(C){if(!C.path.length)return C;let E;return C.scheme===F.Schemas.file?E=f.URI.file(h.$6c(w(C))).path:E=h.$5c.normalize(C.path),C.with({path:E})}relativePath(C,E){if(C.scheme!==E.scheme||!(0,e.$bg)(C.authority,E.authority))return;if(C.scheme===F.Schemas.file){const a=h.$0c(w(C),w(E));return L.$i?S.$Be(a):a}let n=C.path||"/";const o=E.path||"/";if(this.a(C)){let a=0;for(const m=Math.min(n.length,o.length);a<m&&!(n.charCodeAt(a)!==o.charCodeAt(a)&&n.charAt(a).toLowerCase()!==o.charAt(a).toLowerCase());a++);n=o.substr(0,a)+n.substr(a)}return h.$5c.relative(n,o)}resolvePath(C,E){if(C.scheme===F.Schemas.file){const n=f.URI.file(h.$9c(w(C),E));return C.with({authority:n.authority,path:n.path})}return E=S.$Ce(E),C.with({path:h.$5c.resolve(C.path,E)})}isAbsolutePath(C){return!!C.path&&C.path[0]==="/"}isEqualAuthority(C,E){return C===E||C!==void 0&&E!==void 0&&(0,A.$Ld)(C,E)}hasTrailingPathSeparator(C,E=h.sep){if(C.scheme===F.Schemas.file){const n=w(C);return n.length>S.$De(n).length&&n[n.length-1]===E}else{const n=C.path;return n.length>1&&n.charCodeAt(n.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(C.fsPath)}}removeTrailingPathSeparator(C,E=h.sep){return(0,e.$cg)(C,E)?C.with({path:C.path.substr(0,C.path.length-1)}):C}addTrailingPathSeparator(C,E=h.sep){let n=!1;if(C.scheme===F.Schemas.file){const o=w(C);n=o!==void 0&&o.length===S.$De(o).length&&o[o.length-1]===E}else{E="/";const o=C.path;n=o.length===1&&o.charCodeAt(o.length-1)===47}return!n&&!(0,e.$cg)(C,E)?C.with({path:C.path+"/"}):C}}e.$Xf=g,e.$Yf=new g(()=>!1),e.$Zf=new g(k=>k.scheme===F.Schemas.file?!L.$k:!0),e.$1f=new g(k=>!0),e.$2f=e.$Yf.isEqual.bind(e.$Yf),e.$3f=e.$Yf.isEqualOrParent.bind(e.$Yf),e.$4f=e.$Yf.getComparisonKey.bind(e.$Yf),e.$5f=e.$Yf.basenameOrAuthority.bind(e.$Yf),e.$6f=e.$Yf.basename.bind(e.$Yf),e.$7f=e.$Yf.extname.bind(e.$Yf),e.$8f=e.$Yf.dirname.bind(e.$Yf),e.$9f=e.$Yf.joinPath.bind(e.$Yf),e.$0f=e.$Yf.normalizePath.bind(e.$Yf),e.$$f=e.$Yf.relativePath.bind(e.$Yf),e.$_f=e.$Yf.resolvePath.bind(e.$Yf),e.$ag=e.$Yf.isAbsolutePath.bind(e.$Yf),e.$bg=e.$Yf.isEqualAuthority.bind(e.$Yf),e.$cg=e.$Yf.hasTrailingPathSeparator.bind(e.$Yf),e.$dg=e.$Yf.removeTrailingPathSeparator.bind(e.$Yf),e.$eg=e.$Yf.addTrailingPathSeparator.bind(e.$Yf);function P(k,C){const E=[];for(let n=0;n<k.length;n++){const o=C(k[n]);k.some((a,m)=>m===n?!1:(0,e.$3f)(o,C(a)))||E.push(k[n])}return E}e.$fg=P;var I;(function(k){k.META_DATA_LABEL="label",k.META_DATA_DESCRIPTION="description",k.META_DATA_SIZE="size",k.META_DATA_MIME="mime";function C(E){const n=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(m=>{const[v,D]=m.split(":");v&&D&&n.set(v,D)});const a=E.path.substring(0,E.path.indexOf(";"));return a&&n.set(k.META_DATA_MIME,a),n}k.parseMetaData=C})(I||(e.DataUri=I={}));function $(k,C,E){if(C){let n=k.path;return n&&n[0]!==h.$5c.sep&&(n=h.$5c.sep+n),k.with({scheme:E,authority:C,path:n})}return k.with({scheme:E})}e.$gg=$}),define(Se[13],De([1,0,22,8,4,3,24,9,157]),function(me,e,S,F,h,L,A,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.$Rg=e.$Qg=e.Promises=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=void 0;function g(N){return!!N&&typeof N.then=="function"}e.$hg=g;function P(N){const q=new S.$oc,de=N(q.token),ye=new Promise((ve,we)=>{const Ee=q.token.onCancellationRequested(()=>{Ee.dispose(),q.dispose(),we(new F.$3)});Promise.resolve(de).then(K=>{Ee.dispose(),q.dispose(),ve(K)},K=>{Ee.dispose(),q.dispose(),we(K)})});return new class{cancel(){q.cancel()}then(ve,we){return ye.then(ve,we)}catch(ve){return this.then(void 0,ve)}finally(ve){return ye.finally(ve)}}}e.$ig=P;function I(N,q,de){return new Promise((ye,ve)=>{const we=q.onCancellationRequested(()=>{we.dispose(),ye(de)});N.then(ye,ve).finally(()=>we.dispose())})}e.$jg=I;function $(N,q){return new Promise((de,ye)=>{const ve=q.onCancellationRequested(()=>{ve.dispose(),ye(new F.$3)});N.then(de,ye).finally(()=>ve.dispose())})}e.$kg=$;async function k(N){let q=-1;const de=N.map((ye,ve)=>ye.then(we=>(q=ve,we)));try{return await Promise.race(de)}finally{N.forEach((ye,ve)=>{ve!==q&&ye.cancel()})}}e.$lg=k;function C(N,q,de){let ye;const ve=setTimeout(()=>{ye?.(void 0),de?.()},q);return Promise.race([N.finally(()=>clearTimeout(ve)),new Promise(we=>ye=we)])}e.$mg=C;function E(N){return new Promise((q,de)=>{const ye=N();g(ye)?ye.then(q,de):q(ye)})}e.$ng=E;class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(q){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=q,!this.b){const de=()=>{if(this.b=null,this.f)return;const ye=this.queue(this.d);return this.d=null,ye};this.b=new Promise(ye=>{this.a.then(de,de).then(ye)})}return new Promise((de,ye)=>{this.b.then(de,ye)})}return this.a=q(),new Promise((de,ye)=>{this.a.then(ve=>{this.a=null,de(ve)},ve=>{this.a=null,ye(ve)})})}dispose(){this.f=!0}}e.$og=n;class o{constructor(){this.a=Promise.resolve(null)}queue(q){return this.a=this.a.then(()=>q(),()=>q())}}e.$pg=o;class a{constructor(){this.a=new Map}queue(q,de){const ve=(this.a.get(q)??Promise.resolve()).catch(()=>{}).then(de).finally(()=>{this.a.get(q)===ve&&this.a.delete(q)});return this.a.set(q,ve),ve}}e.$qg=a;const m=(N,q)=>{let de=!0;const ye=setTimeout(()=>{de=!1,q()},N);return{isTriggered:()=>de,dispose:()=>{clearTimeout(ye),de=!1}}},v=N=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,N())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};class D{constructor(q){this.defaultDelay=q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(q,de=this.defaultDelay){this.g=q,this.h(),this.b||(this.b=new Promise((ve,we)=>{this.d=ve,this.f=we}).then(()=>{if(this.b=null,this.d=null,this.g){const ve=this.g;return this.g=null,ve()}}));const ye=()=>{this.a=null,this.d?.(null)};return this.a=de===w.$bc?v(ye):m(de,ye),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$rg=D;class t{constructor(q){this.a=new D(q),this.b=new n}trigger(q,de){return this.a.trigger(()=>this.b.queue(q),de)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$sg=t;class r{constructor(){this.a=!1,this.b=new Promise((q,de)=>{this.d=q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$tg=r;class s extends r{constructor(q){super(),this.f=setTimeout(()=>this.open(),q)}open(){clearTimeout(this.f),super.open()}}e.$ug=s;function i(N,q){return q?new Promise((de,ye)=>{const ve=setTimeout(()=>{we.dispose(),de()},N),we=q.onCancellationRequested(()=>{clearTimeout(ve),we.dispose(),ye(new F.$3)})}):P(de=>i(N,de))}e.$vg=i;function c(N,q=0){const de=setTimeout(N,q);return(0,L.$jb)(()=>clearTimeout(de))}e.$wg=c;function l(N){const q=[];let de=0;const ye=N.length;function ve(){return de<ye?N[de++]():null}function we(Ee){Ee!=null&&q.push(Ee);const K=ve();return K?K.then(we):Promise.resolve(q)}return Promise.resolve(null).then(we)}e.$xg=l;function b(N,q=ye=>!!ye,de=null){let ye=0;const ve=N.length,we=()=>{if(ye>=ve)return Promise.resolve(de);const Ee=N[ye++];return Promise.resolve(Ee()).then(ee=>q(ee)?Promise.resolve(ee):we())};return we()}e.$yg=b;function y(N,q=ye=>!!ye,de=null){if(N.length===0)return Promise.resolve(de);let ye=N.length;const ve=()=>{ye=-1;for(const we of N)we.cancel?.()};return new Promise((we,Ee)=>{for(const K of N)K.then(ee=>{--ye>=0&&q(ee)?(ve(),we(ee)):ye===0&&we(de)}).catch(ee=>{--ye>=0&&(ve(),Ee(ee))})})}e.$zg=y;class u{constructor(q){this.a=0,this.d=q,this.f=[],this.b=0,this.g=new h.$ec}get onDrained(){return this.g.event}get size(){return this.a}queue(q){return this.a++,new Promise((de,ye)=>{this.f.push({factory:q,c:de,e:ye}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const q=this.f.shift();this.b++;const de=q.factory();de.then(q.c,q.e),de.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Ag=u;class d extends u{constructor(){super(1)}}e.$Bg=d;class p{constructor(){this.a=new fe,this.b=0}queue(q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,q())):this.a.run(this.b++,q())}}e.$Cg=p;class R{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const q=new V;return this.b.add(q),q.p}d(){for(const[,q]of this.a)if(q.size>0)return!1;return!0}queueFor(q,de=A.$Yf){const ye=de.getComparisonKey(q);let ve=this.a.get(ye);return ve||(ve=new d,h.Event.once(ve.onDrained)(()=>{ve?.dispose(),this.a.delete(ye),this.f()}),this.a.set(ye,ve)),ve}f(){this.d()&&this.g()}g(){for(const q of this.b)q.complete();this.b.clear()}dispose(){for(const[,q]of this.a)q.dispose();this.a.clear(),this.g()}}e.$Dg=R;class O{constructor(q,de){this.a=-1,typeof q=="function"&&typeof de=="number"&&this.setIfNotSet(q,de)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(q,de){this.cancel(),this.a=setTimeout(()=>{this.a=-1,q()},de)}setIfNotSet(q,de){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,q()},de))}}e.$Eg=O;class j{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(q,de){this.cancel(),this.a=setInterval(()=>{q()},de)}}e.$Fg=j;class T{constructor(q,de){this.b=-1,this.a=q,this.d=de,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(q=this.d){this.cancel(),this.b=setTimeout(this.f,q)}get delay(){return this.d}set delay(q){this.d=q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Gg=T;class z{constructor(q,de){de%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${de}ms is not a multiple of 1000ms.`),this.a=q,this.b=de,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(q=this.b){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Hg=z;class B extends T{constructor(q,de){super(q,de),this.j=[]}work(q){this.j.push(q),this.isScheduled()||this.schedule()}h(){const q=this.j;this.j=[],this.a?.(q)}dispose(){this.j=[],super.dispose()}}e.$Ig=B;class M extends L.$lb{constructor(q,de){super(),this.g=q,this.h=de,this.a=[],this.b=this.B(new L.$mb),this.f=!1}get pending(){return this.a.length}work(q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+q.length>this.g.maxBufferedWork)return!1}else if(this.pending+q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const de of q)this.a.push(de);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new T(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Jg=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Kg=N=>{(0,f.$A)(()=>{if(q)return;const de=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,de-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0)}}}:e.$Kg=(N,q)=>{const de=requestIdleCallback(N,typeof q=="number"?{timeout:q}:void 0);let ye=!1;return{dispose(){ye||(ye=!0,cancelIdleCallback(de))}}}}();class Y{constructor(q){this.d=!1,this.a=()=>{try{this.f=q()}catch(de){this.g=de}finally{this.d=!0}},this.b=(0,e.$Kg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Lg=Y;async function J(N,q,de){let ye;for(let ve=0;ve<de;ve++)try{return await N()}catch(we){ye=we,await i(q)}throw ye}e.$Mg=J;class fe{isRunning(q){return typeof q=="number"?this.a?.taskId===q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(q,de,ye){return this.a={taskId:q,cancel:()=>ye?.(),promise:de},de.then(()=>this.d(q),()=>this.d(q)),de}d(q){this.a&&q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const q=this.b;this.b=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}queue(q){if(this.b)this.b.run=q;else{let de,ye;const ve=new Promise((we,Ee)=>{de=we,ye=Ee});this.b={run:q,promise:ve,promiseResolve:de,promiseReject:ye}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ng=fe;class se{constructor(q,de=()=>Date.now()){this.d=q,this.f=de,this.a=0,this.b=0}increment(){const q=this.f();return q-this.a>this.d&&(this.a=q,this.b=0),this.b++,this.b}}e.$Og=se;var ie;(function(N){N[N.Resolved=0]="Resolved",N[N.Rejected=1]="Rejected"})(ie||(ie={}));class V{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((q,de)=>{this.a=q,this.b=de})}complete(q){return new Promise(de=>{this.a(q),this.d={outcome:0,value:q},de()})}error(q){return new Promise(de=>{this.b(q),this.d={outcome:1,value:q},de()})}cancel(){return this.error(new F.$3)}}e.$Pg=V;var re;(function(N){async function q(ye){let ve;const we=await Promise.all(ye.map(Ee=>Ee.then(K=>K,K=>{ve||(ve=K)})));if(typeof ve<"u")throw ve;return we}N.settled=q;function de(ye){return new Promise(async(ve,we)=>{try{await ye(ve,we)}catch(Ee){we(Ee)}})}N.withAsyncBody=de})(re||(e.Promises=re={}));var pe;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(pe||(pe={}));class ae{static fromArray(q){return new ae(de=>{de.emitMany(q)})}static fromPromise(q){return new ae(async de=>{de.emitMany(await q)})}static fromPromises(q){return new ae(async de=>{await Promise.all(q.map(async ye=>de.emitOne(await ye)))})}static merge(q){return new ae(async de=>{await Promise.all(q.map(async ye=>{for await(const ve of ye)de.emitOne(ve)}))})}static{this.EMPTY=ae.fromArray([])}constructor(q){this.a=0,this.b=[],this.d=null,this.f=new h.$ec,queueMicrotask(async()=>{const de={emitOne:ye=>this.g(ye),emitMany:ye=>this.h(ye),reject:ye=>this.k(ye)};try{await Promise.resolve(q(de)),this.j()}catch(ye){this.k(ye)}finally{de.emitOne=void 0,de.emitMany=void 0,de.reject=void 0}})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(q<this.b.length)return{done:!1,value:this.b[q++]};if(this.a===1)return{done:!0,value:void 0};await h.Event.toPromise(this.f.event)}while(!0)}}}static map(q,de){return new ae(async ye=>{for await(const ve of q)ye.emitOne(de(ve))})}map(q){return ae.map(this,q)}static filter(q,de){return new ae(async ye=>{for await(const ve of q)de(ve)&&ye.emitOne(ve)})}filter(q){return ae.filter(this,q)}static coalesce(q){return ae.filter(q,de=>!!de)}coalesce(){return ae.coalesce(this)}static async toPromise(q){const de=[];for await(const ye of q)de.push(ye);return de}toPromise(){return ae.toPromise(this)}g(q){this.a===0&&(this.b.push(q),this.f.fire())}h(q){this.a===0&&(this.b=this.b.concat(q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(q){this.a===0&&(this.a=2,this.d=q,this.f.fire())}}e.$Qg=ae;class ne extends ae{constructor(q,de){super(de),this.l=q}cancel(){this.l.cancel()}}e.$Rg=ne;function x(N){const q=new S.$oc,de=N(q.token);return new ne(q,async ye=>{const ve=q.token.onCancellationRequested(()=>{ve.dispose(),q.dispose(),ye.reject(new F.$3)});try{for await(const we of de){if(q.token.isCancellationRequested)return;ye.emitOne(we)}ve.dispose(),q.dispose()}catch(we){ve.dispose(),q.dispose(),ye.reject(we)}})}e.$Sg=x}),define(Se[35],De([1,0,18,13,32,28,14,9,15]),function(me,e,S,F,h,L,A,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=void 0;function g(){return Object.create(null)}e.$_i=g,e.$aj="**",e.$bj="/";const P="[/\\\\]",I="[^/\\\\]",$=/\//g;function k(fe,se){switch(fe){case 0:return"";case 1:return`${I}*?`;default:return`(?:${P}|${I}+${P}${se?`|${P}${I}+`:""})*?`}}function C(fe,se){if(!fe)return[];const ie=[];let V=!1,re=!1,pe="";for(const ae of fe){switch(ae){case se:if(!V&&!re){ie.push(pe),pe="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":re=!0;break;case"]":re=!1;break}pe+=ae}return pe&&ie.push(pe),ie}e.$cj=C;function E(fe){if(!fe)return"";let se="";const ie=C(fe,e.$bj);if(ie.every(V=>V===e.$aj))se=".*";else{let V=!1;ie.forEach((re,pe)=>{if(re===e.$aj){if(V)return;se+=k(2,pe===ie.length-1)}else{let ae=!1,ne="",x=!1,N="";for(const q of re){if(q!=="}"&&ae){ne+=q;continue}if(x&&(q!=="]"||!N)){let de;q==="-"?de=q:(q==="^"||q==="!")&&!N?de="^":q===e.$bj?de="":de=(0,w.$pd)(q),N+=de;continue}switch(q){case"{":ae=!0;continue;case"[":x=!0;continue;case"}":{const ye=`(?:${C(ne,",").map(ve=>E(ve)).join("|")})`;se+=ye,ae=!1,ne="";break}case"]":{se+="["+N+"]",x=!1,N="";break}case"?":se+=I;continue;case"*":se+=k(1);continue;default:se+=(0,w.$pd)(q)}}pe<ie.length-1&&(ie[pe+1]!==e.$aj||pe+2<ie.length)&&(se+=P)}V=re===e.$aj})}return se}const n=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,v=/^\*\*((\/[\w\.-]+)+)\/?$/,D=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.$qi(1e4),r=function(){return!1},s=function(){return null};function i(fe,se){if(!fe)return s;let ie;typeof fe!="string"?ie=fe.pattern:ie=fe,ie=ie.trim();const V=`${ie}_${!!se.trimForExclusions}`;let re=t.get(V);if(re)return c(re,fe);let pe;return n.test(ie)?re=b(ie.substr(4),ie):(pe=o.exec(l(ie,se)))?re=y(pe[1],ie):(se.trimForExclusions?m:a).test(ie)?re=u(ie,se):(pe=v.exec(l(ie,se)))?re=d(pe[1].substr(1),ie,!0):(pe=D.exec(l(ie,se)))?re=d(pe[1],ie,!1):re=p(ie),t.set(V,re),c(re,fe)}function c(fe,se){if(typeof se=="string")return fe;const ie=function(V,re){return(0,h.$He)(V,se.base,!f.$k)?fe((0,w.$td)(V.substr(se.base.length),A.sep),re):null};return ie.allBasenames=fe.allBasenames,ie.allPaths=fe.allPaths,ie.basenames=fe.basenames,ie.patterns=fe.patterns,ie}function l(fe,se){return se.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function b(fe,se){return function(ie,V){return typeof ie=="string"&&ie.endsWith(fe)?se:null}}function y(fe,se){const ie=`/${fe}`,V=`\\${fe}`,re=function(ae,ne){return typeof ae!="string"?null:ne?ne===fe?se:null:ae===fe||ae.endsWith(ie)||ae.endsWith(V)?se:null},pe=[fe];return re.basenames=pe,re.patterns=[se],re.allBasenames=pe,re}function u(fe,se){const ie=Y(fe.slice(1,-1).split(",").map(ne=>i(ne,se)).filter(ne=>ne!==s),fe),V=ie.length;if(!V)return s;if(V===1)return ie[0];const re=function(ne,x){for(let N=0,q=ie.length;N<q;N++)if(ie[N](ne,x))return fe;return null},pe=ie.find(ne=>!!ne.allBasenames);pe&&(re.allBasenames=pe.allBasenames);const ae=ie.reduce((ne,x)=>x.allPaths?ne.concat(x.allPaths):ne,[]);return ae.length&&(re.allPaths=ae),re}function d(fe,se,ie){const V=A.sep===A.$5c.sep,re=V?fe:fe.replace($,A.sep),pe=A.sep+re,ae=A.$5c.sep+fe;let ne;return ie?ne=function(x,N){return typeof x=="string"&&(x===re||x.endsWith(pe)||!V&&(x===fe||x.endsWith(ae)))?se:null}:ne=function(x,N){return typeof x=="string"&&(x===re||!V&&x===fe)?se:null},ne.allPaths=[(ie?"*/":"./")+fe],ne}function p(fe){try{const se=new RegExp(`^${E(fe)}$`);return function(ie){return se.lastIndex=0,typeof ie=="string"&&se.test(ie)?fe:null}}catch{return s}}function R(fe,se,ie){return!fe||typeof se!="string"?!1:O(fe)(se,void 0,ie)}e.$dj=R;function O(fe,se={}){if(!fe)return r;if(typeof fe=="string"||j(fe)){const ie=i(fe,se);if(ie===s)return r;const V=function(re,pe){return!!ie(re,pe)};return ie.allBasenames&&(V.allBasenames=ie.allBasenames),ie.allPaths&&(V.allPaths=ie.allPaths),V}return B(fe,se)}e.$ej=O;function j(fe){const se=fe;return se?typeof se.base=="string"&&typeof se.pattern=="string":!1}e.$fj=j;function T(fe){return fe.allBasenames||[]}e.$gj=T;function z(fe){return fe.allPaths||[]}e.$hj=z;function B(fe,se){const ie=Y(Object.getOwnPropertyNames(fe).map(ne=>M(ne,fe[ne],se)).filter(ne=>ne!==s)),V=ie.length;if(!V)return s;if(!ie.some(ne=>!!ne.requiresSiblings)){if(V===1)return ie[0];const ne=function(q,de){let ye;for(let ve=0,we=ie.length;ve<we;ve++){const Ee=ie[ve](q,de);if(typeof Ee=="string")return Ee;(0,F.$hg)(Ee)&&(ye||(ye=[]),ye.push(Ee))}return ye?(async()=>{for(const ve of ye){const we=await ve;if(typeof we=="string")return we}return null})():null},x=ie.find(q=>!!q.allBasenames);x&&(ne.allBasenames=x.allBasenames);const N=ie.reduce((q,de)=>de.allPaths?q.concat(de.allPaths):q,[]);return N.length&&(ne.allPaths=N),ne}const re=function(ne,x,N){let q,de;for(let ye=0,ve=ie.length;ye<ve;ye++){const we=ie[ye];we.requiresSiblings&&N&&(x||(x=(0,A.$_c)(ne)),q||(q=x.substr(0,x.length-(0,A.$ad)(ne).length)));const Ee=we(ne,x,q,N);if(typeof Ee=="string")return Ee;(0,F.$hg)(Ee)&&(de||(de=[]),de.push(Ee))}return de?(async()=>{for(const ye of de){const ve=await ye;if(typeof ve=="string")return ve}return null})():null},pe=ie.find(ne=>!!ne.allBasenames);pe&&(re.allBasenames=pe.allBasenames);const ae=ie.reduce((ne,x)=>x.allPaths?ne.concat(x.allPaths):ne,[]);return ae.length&&(re.allPaths=ae),re}function M(fe,se,ie){if(se===!1)return s;const V=i(fe,ie);if(V===s)return s;if(typeof se=="boolean")return V;if(se){const re=se.when;if(typeof re=="string"){const pe=(ae,ne,x,N)=>{if(!N||!V(ae,ne))return null;const q=re.replace("$(basename)",()=>x),de=N(q);return(0,F.$hg)(de)?de.then(ye=>ye?fe:null):de?fe:null};return pe.requiresSiblings=!0,pe}}return V}function Y(fe,se){const ie=fe.filter(ne=>!!ne.basenames);if(ie.length<2)return fe;const V=ie.reduce((ne,x)=>{const N=x.basenames;return N?ne.concat(N):ne},[]);let re;if(se){re=[];for(let ne=0,x=V.length;ne<x;ne++)re.push(se)}else re=ie.reduce((ne,x)=>{const N=x.patterns;return N?ne.concat(N):ne},[]);const pe=function(ne,x){if(typeof ne!="string")return null;if(!x){let q;for(q=ne.length;q>0;q--){const de=ne.charCodeAt(q-1);if(de===47||de===92)break}x=ne.substr(q)}const N=V.indexOf(x);return N!==-1?re[N]:null};pe.basenames=V,pe.patterns=re,pe.allBasenames=V;const ae=fe.filter(ne=>!ne.basenames);return ae.push(pe),ae}function J(fe,se){return(0,S.$$e)(fe,se,(ie,V)=>typeof ie=="string"&&typeof V=="string"?ie===V:typeof ie!="string"&&typeof V!="string"?ie.base===V.base&&ie.pattern===V.pattern:!1)}e.$ij=J}),define(Se[78],De([1,0,8,158,24,15,2]),function(me,e,S,F,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.MarkdownStringTextNewlineStyle=void 0;var f;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(f||(e.MarkdownStringTextNewlineStyle=f={}));class w{constructor(o="",a=!1){if(this.value=o,typeof this.value!="string")throw(0,S.$5)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1,this.supportHtml=a.supportHtml??!1)}appendText(o,a=0){return this.value+=$(this.supportThemeIcons?(0,F.$Ej)(o):o).replace(/([ \t]+)/g,(m,v)=>"&nbsp;".repeat(v.length)).replace(/\>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,a){return this.value+="\n```",this.value+=o,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}appendLink(o,a,m){return this.value+="[",this.value+=this.c(a,"]"),this.value+="](",this.value+=this.c(String(o),")"),m&&(this.value+=` "${this.c(this.c(m,'"'),")")}"`),this.value+=")",this}c(o,a){const m=new RegExp((0,L.$pd)(a),"g");return o.replace(m,(v,D)=>o.charAt(D-1)!=="\\"?`\\${v}`:v)}}e.$Kj=w;function g(n){return P(n)?!n.value:Array.isArray(n)?n.every(g):!0}e.$Lj=g;function P(n){return n instanceof w?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||typeof n.isTrusted=="object"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.$Mj=P;function I(n,o){return n===o?!0:!n||!o?!1:n.value===o.value&&n.isTrusted===o.isTrusted&&n.supportThemeIcons===o.supportThemeIcons&&n.supportHtml===o.supportHtml&&(n.baseUri===o.baseUri||!!n.baseUri&&!!o.baseUri&&(0,h.$2f)(A.URI.from(n.baseUri),A.URI.from(o.baseUri)))}e.$Nj=I;function $(n){return n.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$Oj=$;function k(n){return n.replace(/"/g,"&quot;")}e.$Pj=k;function C(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$Qj=C;function E(n){const o=[],a=n.split("|").map(v=>v.trim());n=a[0];const m=a[1];if(m){const v=/height=(\d+)/.exec(m),D=/width=(\d+)/.exec(m),t=v?v[1]:"",r=D?D[1]:"",s=isFinite(parseInt(r)),i=isFinite(parseInt(t));s&&o.push(`width="${r}"`),i&&o.push(`height="${t}"`)}return{href:n,dimensions:o}}e.$Rj=E}),define(Se[126],De([1,0,18,32,14,9,24,15]),function(me,e,S,F,h,L,A,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cA=e.$bA=e.$aA=e.$_z=e.$$z=e.$0z=e.$9z=e.$8z=e.$7z=e.$6z=void 0;function w(i,c){const{os:l,tildify:b,relative:y}=c;if(y){const p=g(i,y,l);if(typeof p=="string")return p}let u=i.fsPath;if(l===1&&!L.$i?u=u.replace(/\//g,"\\"):l!==1&&L.$i&&(u=u.replace(/\\/g,"/")),l!==1&&b?.userHome){const p=b.userHome.fsPath;let R;i.scheme!==b.userHome.scheme&&i.path.startsWith(h.$5c.sep)?R=b.userHome.with({path:i.path}).fsPath:R=i.fsPath,u=$(R,p,l)}return(l===1?h.$4c:h.$5c).normalize(P(u,l===1))}e.$6z=w;function g(i,c,l){const b=l===1?h.$4c:h.$5c,y=l===3?A.$Yf:A.$1f,u=c.getWorkspace(),d=(0,S.$sf)(u.folders);if(!d)return;i.scheme!==d.uri.scheme&&i.path.startsWith(h.$5c.sep)&&(i=d.uri.with({path:i.path}));const p=c.getWorkspaceFolder(i);if(!p)return;let R;if(y.isEqual(p.uri,i)?R="":R=y.relativePath(p.uri,i)??"",R&&(R=b.normalize(R)),u.folders.length>1&&!c.noPrefix){const O=p.name?p.name:y.basenameOrAuthority(p.uri);R=R?`${O} \u2022 ${R}`:O}return R}function P(i,c=L.$i){return(0,F.$Le)(i,c)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$7z=P;let I=Object.create(null);function $(i,c,l=L.OS){if(l===1||!i||!c)return i;let b=I.original===c?I.normalized:void 0;b||(b=c,L.$i&&(b=(0,F.$Be)(b)),b=`${(0,f.$ud)(b,h.$5c.sep)}${h.$5c.sep}`,I={original:c,normalized:b});let y=i;return L.$i&&(y=(0,F.$Be)(y)),(l===3?y.startsWith(b):(0,f.$Md)(y,b))?`~/${y.substr(b.length)}`:i}e.$8z=$;function k(i,c){return i.replace(/^~($|\/|\\)/,`${c}$1`)}e.$9z=k;const C="\u2026",E="\\\\",n="~";function o(i,c=h.sep){const l=new Array(i.length);let b=!1;for(let y=0;y<i.length;y++){const u=i[y];if(u===""){l[y]=`.${c}`;continue}if(!u){l[y]=u;continue}b=!0;let d="",p=u;p.indexOf(E)===0?(d=p.substr(0,p.indexOf(E)+E.length),p=p.substr(p.indexOf(E)+E.length)):p.indexOf(c)===0?(d=p.substr(0,p.indexOf(c)+c.length),p=p.substr(p.indexOf(c)+c.length)):p.indexOf(n)===0&&(d=p.substr(0,p.indexOf(n)+n.length),p=p.substr(p.indexOf(n)+n.length));const R=p.split(c);for(let O=1;b&&O<=R.length;O++)for(let j=R.length-O;b&&j>=0;j--){b=!1;let T=R.slice(j,j+O).join(c);for(let z=0;!b&&z<i.length;z++)if(z!==y&&i[z]&&i[z].indexOf(T)>-1){const B=j+O===R.length,M=j>0&&i[z].indexOf(c)>-1?c+T:T,Y=i[z].endsWith(M);b=!B||Y}if(!b){let z="";(R[0].endsWith(":")||d!=="")&&(j===1&&(j=0,O++,T=R[0]+c+T),j>0&&(z=R[0]+c),z=d+z),j>0&&(z=z+C+c),z=z+T,j+O<R.length&&(z=z+c+C),l[y]=z}}b&&(l[y]=u)}return l}e.$0z=o;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function m(i,c=Object.create(null)){const l=[];let b=!1,y="";for(const u of i)if(u==="$"||b&&u==="{")y&&l.push({value:y,type:a.TEXT}),y="",b=!0;else if(u==="}"&&b){const d=c[y];if(typeof d=="string")d.length&&l.push({value:d,type:a.VARIABLE});else if(d){const p=l[l.length-1];(!p||p.type!==a.SEPARATOR)&&l.push({value:d.label,type:a.SEPARATOR})}y="",b=!1}else y+=u;return y&&!b&&l.push({value:y,type:a.TEXT}),l.filter((u,d)=>{if(u.type===a.SEPARATOR){const p=l[d-1],R=l[d+1];return[p,R].every(O=>O&&(O.type===a.VARIABLE||O.type===a.TEXT)&&O.value.length>0)}return!0}).map(u=>u.value).join("")}e.$$z=m;function v(i,c){return L.$j||c?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$j?"&":"&&"):i.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.$_z=v;function D(i,c){return L.$j||c?i.replace(/\(&&\w\)|&&/g,""):L.$i?i.replace(/&&|&/g,l=>l==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$aA=D;function t(i){return i.replace(/&/g,"&&")}e.$bA=t;function r(i){if(i.endsWith("]")){const c=i.lastIndexOf(" [",i.length-2);if(c!==-1){const l=s(i.substring(0,c));return{name:l.name,parentPath:l.parentPath+i.substring(c)}}}return s(i)}e.$cA=r;function s(i){const c=i.indexOf("/")!==-1?h.$5c:h.$4c,l=c.basename(i),b=c.dirname(i);return l.length?{name:l,parentPath:b}:{name:b,parentPath:""}}}),define(Se[127],De([1,0,21,2]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.$pm=e.$om=void 0;function h(I){return I.toJSON()}class L{constructor($){this.a=$}transformIncoming($){const k=this.a.transformIncoming($);return k===$?$:h(F.URI.from(k))}transformOutgoing($){const k=this.a.transformOutgoing($);return k===$?$:h(F.URI.from(k))}transformOutgoingURI($){const k=this.a.transformOutgoing($);return k===$?$:F.URI.from(k)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$om=L,e.$pm=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function A(I,$,k){if(!I||k>200)return null;if(typeof I=="object"){if(I instanceof F.URI)return $.transformOutgoing(I);for(const C in I)if(Object.hasOwnProperty.call(I,C)){const E=A(I[C],$,k+1);E!==null&&(I[C]=E)}}return null}function f(I,$){const k=A(I,$,0);return k===null?I:k}e.$qm=f;function w(I,$,k,C){if(!I||C>200)return null;if(typeof I=="object"){if(I.$mid===1)return k?F.URI.revive($.transformIncoming(I)):$.transformIncoming(I);if(I instanceof S.$Ec)return null;for(const E in I)if(Object.hasOwnProperty.call(I,E)){const n=w(I[E],$,k,C+1);n!==null&&(I[E]=n)}}return null}function g(I,$){const k=w(I,$,!1,0);return k===null?I:k}e.$rm=g;function P(I,$){const k=w(I,$,!0,0);return k===null?I:k}e.$sm=P}),define(Se[29],De([1,0,49,59,360,13,32,73,14,9,24,2]),function(me,e,S,F,h,L,A,f,w,g,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var $;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function k(M,Y=$.UNLINK,J){if((0,A.$Ke)(M))throw new Error("rimraf - will refuse to recursively delete root");return Y===$.UNLINK?E(M):C(M,J)}async function C(M,Y=(0,A.$Pe)((0,F.tmpdir)())){try{try{await S.promises.rename(M,Y)}catch(J){return J.code==="ENOENT"?void 0:E(M)}E(Y).catch(J=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function E(M){return(0,h.promisify)(S.rm)(M,{recursive:!0,force:!0,maxRetries:3})}function n(M){if((0,A.$Ke)(M))throw new Error("rimraf - will refuse to recursively delete root");S.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=n;async function o(M,Y){return v(await(Y?a(M):(0,h.promisify)(S.readdir)(M)))}async function a(M){try{return await(0,h.promisify)(S.readdir)(M,{withFileTypes:!0})}catch(fe){console.warn("[node.js fs] readdir with filetypes failed with error: ",fe)}const Y=[],J=await o(M);for(const fe of J){let se=!1,ie=!1,V=!1;try{const re=await e.Promises.lstat((0,w.$8c)(M,fe));se=re.isFile(),ie=re.isDirectory(),V=re.isSymbolicLink()}catch(re){console.warn("[node.js fs] unexpected error from lstat after readdir: ",re)}Y.push({name:fe,isFile:()=>se,isDirectory:()=>ie,isSymbolicLink:()=>V})}return Y}function m(M){return v(S.readdirSync(M))}e.readdirSync=m;function v(M){return M.map(Y=>typeof Y=="string"?g.$j?(0,f.$7k)(Y):Y:(Y.name=g.$j?(0,f.$7k)(Y.name):Y.name,Y))}async function D(M){const Y=await o(M),J=[];for(const fe of Y)await r.existsDirectory((0,w.$8c)(M,fe))&&J.push(fe);return J}function t(M,Y=1e3){return new Promise(J=>{let fe=!1;const se=setInterval(()=>{fe||(fe=!0,S.access(M,ie=>{fe=!1,ie&&(clearInterval(se),J(void 0))}))},Y)})}e.whenDeleted=t;var r;(function(M){async function Y(se){let ie;try{if(ie=await e.Promises.lstat(se),!ie.isSymbolicLink())return{stat:ie}}catch{}try{return{stat:await e.Promises.stat(se),symbolicLink:ie?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&ie)return{stat:ie,symbolicLink:{dangling:!0}};if(g.$i&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(se)),symbolicLink:{dangling:!1}}}catch(re){if(re.code==="ENOENT"&&ie)return{stat:ie,symbolicLink:{dangling:!0}};throw re}throw V}}M.stat=Y;async function J(se){try{const{stat:ie,symbolicLink:V}=await M.stat(se);return ie.isFile()&&V?.dangling!==!0}catch{}return!1}M.existsFile=J;async function fe(se){try{const{stat:ie,symbolicLink:V}=await M.stat(se);return ie.isDirectory()&&V?.dangling!==!0}catch{}return!1}M.existsDirectory=fe})(r||(e.SymlinkSupport=r={}));const s=new L.$Dg;function i(M,Y,J){return s.queueFor(I.URI.file(M),P.$Zf).queue(()=>{const fe=u(J);return new Promise((se,ie)=>b(M,Y,fe,V=>V?ie(V):se()))})}let c=!0;function l(M){c=M}e.configureFlushOnWrite=l;function b(M,Y,J,fe){if(!c)return S.writeFile(M,Y,{mode:J.mode,flag:J.flag},fe);S.open(M,J.flag,J.mode,(se,ie)=>{if(se)return fe(se);S.writeFile(ie,Y,V=>{if(V)return S.close(ie,()=>fe(V));S.fdatasync(ie,re=>(re&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",re),l(!1)),S.close(ie,pe=>fe(pe))))})})}function y(M,Y,J){const fe=u(J);if(!c)return S.writeFileSync(M,Y,{mode:fe.mode,flag:fe.flag});const se=S.openSync(M,fe.flag,fe.mode);try{S.writeFileSync(se,Y);try{S.fdatasyncSync(se)}catch(ie){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",ie),l(!1)}}finally{S.closeSync(se)}}e.writeFileSync=y;function u(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function d(M,Y,J=6e4){if(M!==Y)try{g.$i&&typeof J=="number"?await p(M,Y,Date.now(),J):await(0,h.promisify)(S.rename)(M,Y)}catch(fe){if(M.toLowerCase()!==Y.toLowerCase()&&fe.code==="EXDEV"||M.endsWith("."))await R(M,Y,{preserveSymlinks:!1}),await k(M,$.MOVE);else throw fe}}async function p(M,Y,J,fe,se=0){try{return await(0,h.promisify)(S.rename)(M,Y)}catch(ie){if(ie.code!=="EACCES"&&ie.code!=="EPERM"&&ie.code!=="EBUSY")throw ie;if(Date.now()-J>=fe)throw console.error(`[node.js fs] rename failed after ${se} retries with error: ${ie}`),ie;if(se===0){let V=!1;try{const{stat:re}=await r.stat(Y);re.isFile()||(V=!0)}catch{}if(V)throw ie}return await(0,L.$vg)(Math.min(100,se*10)),p(M,Y,J,fe,se+1)}}async function R(M,Y,J){return j(M,Y,{root:{source:M,target:Y},options:J,handledSourcePaths:new Set})}const O=511;async function j(M,Y,J){if(J.handledSourcePaths.has(M))return;J.handledSourcePaths.add(M);const{stat:fe,symbolicLink:se}=await r.stat(M);if(se){if(J.options.preserveSymlinks)try{return await B(M,Y,J)}catch(ie){console.warn("[node.js fs] copy of symlink failed: ",ie)}if(se.dangling)return}return fe.isDirectory()?T(M,Y,fe.mode&O,J):z(M,Y,fe.mode&O)}async function T(M,Y,J,fe){await e.Promises.mkdir(Y,{recursive:!0,mode:J});const se=await o(M);for(const ie of se)await j((0,w.$8c)(M,ie),(0,w.$8c)(Y,ie),fe)}async function z(M,Y,J){await e.Promises.copyFile(M,Y),await e.Promises.chmod(Y,J)}async function B(M,Y,J){let fe=await e.Promises.readlink(M);(0,A.$He)(fe,J.root.source,!g.$k)&&(fe=(0,w.$8c)(J.root.target,fe.substr(J.root.source.length+1))),await e.Promises.symlink(fe,Y)}e.Promises=new class{get access(){return(0,h.promisify)(S.access)}get stat(){return(0,h.promisify)(S.stat)}get lstat(){return(0,h.promisify)(S.lstat)}get utimes(){return(0,h.promisify)(S.utimes)}get read(){return(M,Y,J,fe,se)=>new Promise((ie,V)=>{S.read(M,Y,J,fe,se,(re,pe,ae)=>re?V(re):ie({bytesRead:pe,buffer:ae}))})}get readFile(){return(0,h.promisify)(S.readFile)}get write(){return(M,Y,J,fe,se)=>new Promise((ie,V)=>{S.write(M,Y,J,fe,se,(re,pe,ae)=>re?V(re):ie({bytesWritten:pe,buffer:ae}))})}get appendFile(){return(0,h.promisify)(S.appendFile)}get fdatasync(){return(0,h.promisify)(S.fdatasync)}get truncate(){return(0,h.promisify)(S.truncate)}get copyFile(){return(0,h.promisify)(S.copyFile)}get open(){return(0,h.promisify)(S.open)}get close(){return(0,h.promisify)(S.close)}get symlink(){return(0,h.promisify)(S.symlink)}get readlink(){return(0,h.promisify)(S.readlink)}get chmod(){return(0,h.promisify)(S.chmod)}get mkdir(){return(0,h.promisify)(S.mkdir)}get unlink(){return(0,h.promisify)(S.unlink)}get rmdir(){return(0,h.promisify)(S.rmdir)}get realpath(){return(0,h.promisify)(S.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return D}get writeFile(){return i}get rm(){return k}get rename(){return d}get copy(){return R}}}),define(Se[99],De([1,0,49,14,9,15,29]),function(me,e,S,F,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=e.$Mp=e.$Lp=void 0;function f($){if(h.$k)return $;const k=(0,F.$$c)($);if($===k)return $;const C=((0,F.$_c)($)||$).toLowerCase();try{const n=(0,A.readdirSync)(k).filter(o=>o.toLowerCase()===C);if(n.length===1){const o=f(k);if(o)return(0,F.$8c)(o,n[0])}else if(n.length>1){const o=n.indexOf(C);if(o>=0){const a=f(k);if(a)return(0,F.$8c)(a,n[o])}}}catch{}return null}e.$Lp=f;async function w($){if(h.$k)return $;const k=(0,F.$$c)($);if($===k)return $;const C=((0,F.$_c)($)||$).toLowerCase();try{const n=(await A.Promises.readdir(k)).filter(o=>o.toLowerCase()===C);if(n.length===1){const o=await w(k);if(o)return(0,F.$8c)(o,n[0])}else if(n.length>1){const o=n.indexOf(C);if(o>=0){const a=await w(k);if(a)return(0,F.$8c)(a,n[o])}}}catch{}return null}e.$Mp=w;async function g($){try{return await A.Promises.realpath($)}catch{const C=I($);return await A.Promises.access(C,S.constants.R_OK),C}}e.$Np=g;function P($){try{return S.realpathSync($)}catch{const C=I($);return S.accessSync(C,S.constants.R_OK),C}}e.$Op=P;function I($){return(0,L.$ud)((0,F.$6c)($),F.sep)}}),define(Se[100],De([1,0,14,9,41,98,19,29]),function(me,e,S,F,h,L,A,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$il=e.$hl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function w(I=h.env){return I.comspec||"cmd.exe"}e.$hl=w;function g(I){let $=[],k=!1;const C=function(E){if(k){$.push(E);return}(!I.send(E,o=>{if(o&&console.error(o),k=!1,$.length>0){const a=$.slice(0);$=[],a.forEach(m=>C(m))}})||F.$i)&&(k=!0)};return{send:C}}e.$il=g;var P;(function(I){async function $(k,C,E){if(S.$7c(k))return k;if(C===void 0&&(C=h.cwd()),S.$$c(k)!=="."||(E===void 0&&A.$ie(h.env.PATH)&&(E=h.env.PATH.split(S.$fd)),E===void 0||E.length===0))return S.$8c(C,k);async function o(a){if(await f.Promises.exists(a)){let m;try{m=await f.Promises.stat(a)}catch(v){v.message.startsWith("EACCES")&&(m=await f.Promises.lstat(a))}return m?!m.isDirectory():!1}return!1}for(const a of E){let m;if(S.$7c(a)?m=S.$8c(a,k):m=S.$8c(C,a,k),await o(m))return m;let v=m+".com";if(await o(v)||(v=m+".exe",await o(v)))return v}return S.$8c(C,k)}I.findExecutable=$})(P||(e.win32=P={}))});var Je=this&&this.__decorate||function(me,e,S,F){var h=arguments.length,L=h<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,S):F,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(me,e,S,F);else for(var f=me.length-1;f>=0;f--)(A=me[f])&&(L=(h<3?A(L):h>3?A(e,S,L):A(e,S))||L);return h>3&&L&&Object.defineProperty(e,S,L),L};define(Se[79],De([1,0,18,13,21,22,70,8,4,3,77,15,19]),function(me,e,S,F,h,L,A,f,w,g,P,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$g=e.ProxyChannel=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.RequestInitiator=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=void 0;var k;(function(se){se[se.Promise=100]="Promise",se[se.PromiseCancel=101]="PromiseCancel",se[se.EventListen=102]="EventListen",se[se.EventDispose=103]="EventDispose"})(k||(k={}));function C(se){switch(se){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(se){se[se.Initialize=200]="Initialize",se[se.PromiseSuccess=201]="PromiseSuccess",se[se.PromiseError=202]="PromiseError",se[se.PromiseErrorObj=203]="PromiseErrorObj",se[se.EventFire=204]="EventFire"})(E||(E={}));function n(se){switch(se){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(se){se[se.Uninitialized=0]="Uninitialized",se[se.Idle=1]="Idle"})(o||(o={}));function a(se){let ie=0;for(let V=0;;V+=7){const re=se.read(1);if(ie|=(re.buffer[0]&127)<<V,!(re.buffer[0]&128))return ie}}const m=s(0);function v(se,ie){if(ie===0){se.write(m);return}let V=0;for(let pe=ie;pe!==0;pe=pe>>>7)V++;const re=h.$Ec.alloc(V);for(let pe=0;ie!==0;pe++)re.buffer[pe]=ie&127,ie=ie>>>7,ie>0&&(re.buffer[pe]|=128);se.write(re)}class D{constructor(ie){this.b=ie,this.a=0}read(ie){const V=this.b.slice(this.a,this.a+ie);return this.a+=V.byteLength,V}}e.$Zg=D;class t{constructor(){this.a=[]}get buffer(){return h.$Ec.concat(this.a)}write(ie){this.a.push(ie)}}e.$1g=t;var r;(function(se){se[se.Undefined=0]="Undefined",se[se.String=1]="String",se[se.Buffer=2]="Buffer",se[se.VSBuffer=3]="VSBuffer",se[se.Array=4]="Array",se[se.Object=5]="Object",se[se.Int=6]="Int"})(r||(r={}));function s(se){const ie=h.$Ec.alloc(1);return ie.writeUInt8(se,0),ie}const i={Undefined:s(r.Undefined),String:s(r.String),Buffer:s(r.Buffer),VSBuffer:s(r.VSBuffer),Array:s(r.Array),Object:s(r.Object),Uint:s(r.Int)},c=typeof Buffer<"u";function l(se,ie){if(typeof ie>"u")se.write(i.Undefined);else if(typeof ie=="string"){const V=h.$Ec.fromString(ie);se.write(i.String),v(se,V.byteLength),se.write(V)}else if(c&&Buffer.isBuffer(ie)){const V=h.$Ec.wrap(ie);se.write(i.Buffer),v(se,V.byteLength),se.write(V)}else if(ie instanceof h.$Ec)se.write(i.VSBuffer),v(se,ie.byteLength),se.write(ie);else if(Array.isArray(ie)){se.write(i.Array),v(se,ie.length);for(const V of ie)l(se,V)}else if(typeof ie=="number"&&(ie|0)===ie)se.write(i.Uint),v(se,ie);else{const V=h.$Ec.fromString(JSON.stringify(ie));se.write(i.Object),v(se,V.byteLength),se.write(V)}}e.$2g=l;function b(se){switch(se.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return se.read(a(se)).toString();case r.Buffer:return se.read(a(se)).buffer;case r.VSBuffer:return se.read(a(se));case r.Array:{const V=a(se),re=[];for(let pe=0;pe<V;pe++)re.push(b(se));return re}case r.Object:return JSON.parse(se.read(a(se)).toString());case r.Int:return a(se)}}e.$3g=b;class y{constructor(ie,V,re=null,pe=1e3){this.h=ie,this.j=V,this.k=re,this.l=pe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel(ie,V){this.b.set(ie,V),setTimeout(()=>this.w(ie),0)}m(ie){switch(ie.type){case 200:{const V=this.o([ie.type]);this.k?.logOutgoing(V,0,1,n(ie.type));return}case 201:case 202:case 204:case 203:{const V=this.o([ie.type,ie.id],ie.data);this.k?.logOutgoing(V,ie.id,1,n(ie.type),ie.data);return}}}o(ie,V=void 0){const re=new t;return l(re,ie),l(re,V),this.p(re.buffer)}p(ie){try{return this.h.send(ie),ie.byteLength}catch{return 0}}q(ie){const V=new D(ie),re=b(V),pe=b(V),ae=re[0];switch(ae){case 100:return this.k?.logIncoming(ie.byteLength,re[1],1,`${C(ae)}: ${re[2]}.${re[3]}`,pe),this.s({type:ae,id:re[1],channelName:re[2],name:re[3],arg:pe});case 102:return this.k?.logIncoming(ie.byteLength,re[1],1,`${C(ae)}: ${re[2]}.${re[3]}`,pe),this.t({type:ae,id:re[1],channelName:re[2],name:re[3],arg:pe});case 101:return this.k?.logIncoming(ie.byteLength,re[1],1,`${C(ae)}`),this.u({type:ae,id:re[1]});case 103:return this.k?.logIncoming(ie.byteLength,re[1],1,`${C(ae)}`),this.u({type:ae,id:re[1]})}}s(ie){const V=this.b.get(ie.channelName);if(!V){this.v(ie);return}const re=new L.$oc;let pe;try{pe=V.call(this.j,ie.name,ie.arg,re.token)}catch(x){pe=Promise.reject(x)}const ae=ie.id;pe.then(x=>{this.m({id:ae,data:x,type:201}),this.d.delete(ie.id)},x=>{x instanceof Error?this.m({id:ae,data:{message:x.message,name:x.name,stack:x.stack?x.stack.split?x.stack.split(`
`):x.stack:void 0},type:202}):this.m({id:ae,data:x,type:203}),this.d.delete(ie.id)});const ne=(0,g.$jb)(()=>re.cancel());this.d.set(ie.id,ne)}t(ie){const V=this.b.get(ie.channelName);if(!V){this.v(ie);return}const re=ie.id,ae=V.listen(this.j,ie.name,ie.arg)(ne=>this.m({id:re,data:ne,type:204}));this.d.set(ie.id,ae)}u(ie){const V=this.d.get(ie.id);V&&(V.dispose(),this.d.delete(ie.id))}v(ie){let V=this.g.get(ie.channelName);V||(V=[],this.g.set(ie.channelName,V));const re=setTimeout(()=>{console.error(`Unknown channel: ${ie.channelName}`),ie.type===100&&this.m({id:ie.id,data:{name:"Unknown channel",message:`Channel name '${ie.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);V.push({request:ie,timeoutTimer:re})}w(ie){const V=this.g.get(ie);if(V){for(const re of V)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(ie)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$gb)(this.d.values()),this.d.clear()}}e.$4g=y;var u;(function(se){se[se.LocalSide=0]="LocalSide",se[se.OtherSide=1]="OtherSide"})(u||(e.RequestInitiator=u={}));class d{constructor(ie,V=null){this.l=ie,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new w.$ec,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=V}getChannel(ie){const V=this;return{call(re,pe,ae){return V.a?Promise.reject(new f.$3):V.m(ie,re,pe,ae)},listen(re,pe){return V.a?w.Event.None:V.o(ie,re,pe)}}}m(ie,V,re,pe=L.CancellationToken.None){const ae=this.g++,x={id:ae,type:100,channelName:ie,name:V,arg:re};if(pe.isCancellationRequested)return Promise.reject(new f.$3);let N;return new Promise((de,ye)=>{if(pe.isCancellationRequested)return ye(new f.$3);const ve=()=>{const ee=G=>{switch(G.type){case 201:this.f.delete(ae),de(G.data);break;case 202:{this.f.delete(ae);const X=new Error(G.data.message);X.stack=Array.isArray(G.data.stack)?G.data.stack.join(`
`):G.data.stack,X.name=G.data.name,ye(X);break}case 203:this.f.delete(ae),ye(G.data);break}};this.f.set(ae,ee),this.p(x)};let we=null;this.b===o.Idle?ve():(we=(0,F.$ig)(ee=>this.u()),we.then(()=>{we=null,ve()}));const Ee=()=>{we?(we.cancel(),we=null):this.p({id:ae,type:101}),ye(new f.$3)},K=pe.onCancellationRequested(Ee);N=(0,g.$ib)((0,g.$jb)(Ee),K),this.d.add(N)}).finally(()=>{this.d.delete(N)})}o(ie,V,re){const pe=this.g++,ne={id:pe,type:102,channelName:ie,name:V,arg:re};let x=null;const N=new w.$ec({onWillAddFirstListener:()=>{x=(0,F.$ig)(de=>this.u()),x.then(()=>{x=null,this.d.add(N),this.p(ne)})},onDidRemoveLastListener:()=>{x?(x.cancel(),x=null):(this.d.delete(N),this.p({id:pe,type:103}))}}),q=de=>N.fire(de.data);return this.f.set(pe,q),N.event}p(ie){switch(ie.type){case 100:case 102:{const V=this.q([ie.type,ie.id,ie.channelName,ie.name],ie.arg);this.j?.logOutgoing(V,ie.id,0,`${C(ie.type)}: ${ie.channelName}.${ie.name}`,ie.arg);return}case 101:case 103:{const V=this.q([ie.type,ie.id]);this.j?.logOutgoing(V,ie.id,0,C(ie.type));return}}}q(ie,V=void 0){const re=new t;return l(re,ie),l(re,V),this.r(re.buffer)}r(ie){try{return this.l.send(ie),ie.byteLength}catch{return 0}}s(ie){const V=new D(ie),re=b(V),pe=b(V),ae=re[0];switch(ae){case 200:return this.j?.logIncoming(ie.byteLength,0,0,n(ae)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(ie.byteLength,re[1],0,n(ae),pe),this.t({type:re[0],id:re[1],data:pe})}}t(ie){if(ie.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(ie.id)?.(ie)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$gb)(this.d.values()),this.d.clear()}}e.$5g=d,Je([A.$Tg],d.prototype,"onDidInitializePromise",null);class p{get connections(){const ie=[];return this.f.forEach(V=>ie.push(V)),ie}constructor(ie){this.a=new Map,this.f=new Set,this.g=new w.$ec,this.onDidAddConnection=this.g.event,this.h=new w.$ec,this.onDidRemoveConnection=this.h.event,ie(({protocol:V,onDidClientDisconnect:re})=>{w.Event.once(V.onMessage)(ae=>{const ne=new D(ae),x=b(ne),N=new y(V,x),q=new d(V);this.a.forEach((ye,ve)=>N.registerChannel(ve,ye));const de={channelServer:N,channelClient:q,ctx:x};this.f.add(de),this.g.fire(de),re(()=>{N.dispose(),q.dispose(),this.f.delete(de),this.h.fire(de)})})})}getChannel(ie,V){const re=this;return{call(pe,ae,ne){let x;if((0,$.$we)(V)){const q=(0,S.$Hf)(re.connections.filter(V));x=q?Promise.resolve(q):w.Event.toPromise(w.Event.filter(re.onDidAddConnection,V))}else x=V.routeCall(re,pe,ae);const N=x.then(q=>q.channelClient.getChannel(ie));return O(N).call(pe,ae,ne)},listen(pe,ae){if((0,$.$we)(V))return re.j(ie,V,pe,ae);const ne=V.routeEvent(re,pe,ae).then(x=>x.channelClient.getChannel(ie));return O(ne).listen(pe,ae)}}}j(ie,V,re,pe){const ae=this;let ne=new g.$kb;const x=new w.$ec({onWillAddFirstListener:()=>{ne=new g.$kb;const N=new w.$kc,q=new Map,de=ve=>{const Ee=ve.channelClient.getChannel(ie).listen(re,pe),K=N.add(Ee);q.set(ve,K)},ye=ve=>{const we=q.get(ve);we&&(we.dispose(),q.delete(ve))};ae.connections.filter(V).forEach(de),w.Event.filter(ae.onDidAddConnection,V)(de,void 0,ne),ae.onDidRemoveConnection(ye,void 0,ne),N.event(x.fire,x,ne),ne.add(N)},onDidRemoveLastListener:()=>{ne.dispose()}});return x.event}registerChannel(ie,V){this.a.set(ie,V),this.f.forEach(re=>{re.channelServer.registerChannel(ie,V)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.$6g=p;class R{constructor(ie,V,re=null){const pe=new t;l(pe,V),ie.send(pe.buffer),this.a=new d(ie,re),this.d=new y(ie,V,re)}getChannel(ie){return this.a.getChannel(ie)}registerChannel(ie,V){this.d.registerChannel(ie,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.$7g=R;function O(se){return{call(ie,V,re){return se.then(pe=>pe.call(ie,V,re))},listen(ie,V){const re=new w.$nc;return se.then(pe=>re.input=pe.listen(ie,V)),re.event}}}e.$8g=O;function j(se){let ie=!1;return{call(V,re,pe){return ie?se.call(V,re,pe):(0,F.$vg)(0).then(()=>ie=!0).then(()=>se.call(V,re,pe))},listen(V,re){if(ie)return se.listen(V,re);const pe=new w.$nc;return(0,F.$vg)(0).then(()=>ie=!0).then(()=>pe.input=se.listen(V,re)),pe.event}}}e.$9g=j;class T{constructor(ie){this.a=ie}routeCall(ie){return this.b(ie)}routeEvent(ie){return this.b(ie)}async b(ie){for(const V of ie.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await w.Event.toPromise(ie.onDidAddConnection),await this.b(ie)}}e.$0g=T;var z;(function(se){function ie(ae,ne){const x=ae,N=ne&&ne.disableMarshalling,q=new Map;for(const de in x)re(de)&&q.set(de,w.Event.buffer(x[de],!0));return new class{listen(de,ye,ve){const we=q.get(ye);if(we)return we;if(pe(ye)){const Ee=x[ye];if(typeof Ee=="function")return Ee.call(x,ve)}throw new f.$ab(`Event not found: ${ye}`)}call(de,ye,ve){const we=x[ye];if(typeof we=="function"){if(!N&&Array.isArray(ve))for(let Ee=0;Ee<ve.length;Ee++)ve[Ee]=(0,P.$Yg)(ve[Ee]);return we.apply(x,ve)}throw new f.$ab(`Method not found: ${ye}`)}}}se.fromService=ie;function V(ae,ne){const x=ne&&ne.disableMarshalling;return new Proxy({},{get(N,q){if(typeof q=="string")return ne?.properties?.has(q)?ne.properties.get(q):pe(q)?function(de){return ae.listen(q,de)}:re(q)?ae.listen(q):async function(...de){let ye;ne&&!(0,$.$re)(ne.context)?ye=[ne.context,...de]:ye=de;const ve=await ae.call(q,ye);return x?ve:(0,P.$Yg)(ve)};throw new f.$ab(`Property not found: ${String(q)}`)}})}se.toService=V;function re(ae){return ae[0]==="o"&&ae[1]==="n"&&I.$Kd(ae.charCodeAt(2))}function pe(ae){return/^onDynamic/.test(ae)&&I.$Kd(ae.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(se){if(Array.isArray(se))return se;if(se&&typeof se=="object"&&typeof se.toString=="function"){const ie=se.toString();if(ie!=="[object Object]")return ie}return se}function Y(se){return Array.isArray(se)?se.map(M):M(se)}function J(se,ie,V,re,pe,ae,ne){ne=Y(ne);const x=B[pe],N=x[re%x.length];let q=[`%c[${se}]%c[${String(ie).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(ae)?(q=q.concat(ne),q.push(")")):q.push(ne),console.log.apply(console,q)}class fe{constructor(ie,V){this.d=ie,this.f=V,this.a=0,this.b=0}logOutgoing(ie,V,re,pe,ae){this.b+=ie,J(this.d,this.b,ie,V,re,pe,ae)}logIncoming(ie,V,re,pe,ae){this.a+=ie,J(this.f,this.a,ie,V,re,pe,ae)}}e.$$g=fe}),define(Se[80],De([1,0,21,4,3,79]),function(me,e,S,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dh=e.$ch=e.$bh=e.$ah=e.ProtocolConstants=e.$_g=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var f;(function(i){i.enableDiagnostics=!1,i.records=[];const c=new WeakMap;let l=0;function b(u,d){if(!c.has(u)){const p=String(++l);c.set(u,p)}return c.get(u)}function y(u,d,p,R){if(!i.enableDiagnostics)return;const O=b(u,d);if(R instanceof S.$Ec||R instanceof Uint8Array||R instanceof ArrayBuffer||ArrayBuffer.isView(R)){const j=S.$Ec.alloc(R.byteLength);j.set(R),i.records.push({timestamp:Date.now(),id:O,label:d,type:p,buff:j})}else i.records.push({timestamp:Date.now(),id:O,label:d,type:p,data:R})}i.traceSocketEvent=y})(f||(e.SocketDiagnostics=f={}));var w;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w||(e.SocketCloseEventType=w={}));let g=null;function P(){return g||(g=S.$Ec.alloc(0)),g}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(c){this.a.push(c),this.b+=c.byteLength}read(c){return this.c(c,!0)}peek(c){return this.c(c,!1)}c(c,l){if(c===0)return P();if(c>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===c){const d=this.a[0];return l&&(this.a.shift(),this.b-=c),d}if(this.a[0].byteLength>c){const d=this.a[0].slice(0,c);return l&&(this.a[0]=this.a[0].slice(c),this.b-=c),d}const b=S.$Ec.alloc(c);let y=0,u=0;for(;c>0;){const d=this.a[u];if(d.byteLength>c){const p=d.slice(0,c);b.set(p,y),y+=c,l&&(this.a[u]=d.slice(c),this.b-=c),c-=c}else b.set(d,y),y+=d.byteLength,l?(this.a.shift(),this.b-=d.byteLength):u++,c-=d.byteLength}return b}}e.$_g=I;var $;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})($||($={}));function k(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var C;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(C||(e.ProtocolConstants=C={}));class E{constructor(c,l,b,y){this.type=c,this.id=l,this.ack=b,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class n extends h.$lb{constructor(c){super(),this.f=this.B(new F.$ec),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=c,this.b=!1,this.c=new I,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(c);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:k(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const b=this.g.messageType,y=this.g.id,u=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new E(b,y,u,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(c){this.k=null,this.a=!1,this.b=!1,this.c=c,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(c){if(this.a)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=S.$Ec.alloc(13);l.writeUInt8(c.type,0),l.writeUInt32BE(c.id,1),l.writeUInt32BE(c.ack,5),l.writeUInt32BE(c.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:k(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",c.data),this.j(l,c.data)}g(c,l){const b=this.f===0;return this.d.push(c,l),this.f+=c.byteLength+l.byteLength,b}h(){const c=S.$Ec.concat(this.d,this.f);return this.d.length=0,this.f=0,c}j(c,l){this.g(c,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const c=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:c.byteLength}),this.c.write(c)}}class a extends h.$lb{constructor(c){super(),this.f=new F.$ec,this.onMessage=this.f.event,this.g=new F.$ec,this.onDidDispose=this.g.event,this.a=c,this.b=this.B(new o(this.a)),this.c=this.B(new n(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(c){this.b.write(new E(1,0,0,c))}}e.$ah=a;class m extends L.$7g{static fromSocket(c,l){return new m(new a(c),l)}get onDidDispose(){return this.b.onDidDispose}constructor(c,l,b=null){super(c,l,b),this.b=c}dispose(){super.dispose();const c=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),c.end()}}e.$bh=m;class v{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new F.$ec({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(c){this.b?this.d.length>0?this.d.push(c):this.a.fire(c):this.d.push(c)}flushBuffer(){this.d=[]}}e.$ch=v;class D{constructor(c){this.data=c,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let c=0,l=this.a;for(;l;)l=l.next,c++;return c}peek(){return this.a?this.a.data:null}toArray(){const c=[];let l=0,b=this.a;for(;b;)c[l++]=b.data,b=b.next;return c}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(c){const l=new D(c);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const c=Date.now();for(let l=0;l<r.a;l++)this.c[l]=c-1e3*l;setInterval(()=>{for(let l=r.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const c=Date.now(),l=(1+r.a)*1e3;let b=0;for(let y=0;y<r.a;y++)c-this.c[y]<=l&&b++;return 1-b/r.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(c){this.u=new v,this.onControlMessage=this.u.event,this.v=new v,this.onMessage=this.v.event,this.w=new v,this.onDidDispose=this.w.event,this.x=new v,this.onSocketClose=this.x.event,this.y=new v,this.onSocketTimeout=this.y.event,this.s=c.loadEstimator??r.getInstance(),this.t=c.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new h.$kb,this.o=c.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new n(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),c.initialChunk&&this.q.acceptChunk(c.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const c=new E(5,0,0,P());this.p.write(c),this.p.flush()}sendPause(){const c=new E(7,0,0,P());this.p.write(c)}sendResume(){const c=new E(8,0,0,P());this.p.write(c)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(c,l){this.a=!0,this.r.dispose(),this.r=new h.$kb,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=c,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new n(this.o)),this.r.add(this.q.onMessage(b=>this.z(b))),this.r.add(this.o.onClose(b=>this.x.fire(b))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const c=new E(3,0,this.h,P());this.p.write(c);const l=this.b.toArray();for(let b=0,y=l.length;b<y;b++)this.p.write(l[b]);this.B()}acceptDisconnect(){this.w.fire()}z(c){if(c.ack>this.d){this.d=c.ack;do{const l=this.b.peek();if(l&&l.id<=c.ack)this.b.pop();else break}while(!0)}switch(c.type){case 0:break;case 1:{if(c.id>this.g)if(c.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new E(6,0,0,P())))}else this.g=c.id,this.j=Date.now(),this.A(),this.v.fire(c.data);break}case 2:{this.u.fire(c.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const l=this.b.toArray();for(let b=0,y=l.length;b<y;b++)this.p.write(l[b]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(c){const l=++this.c;this.h=this.g;const b=new E(1,l,this.h,c);this.b.push(b),this.a||(this.p.write(b),this.B())}sendControl(c){const l=new E(2,0,0,c);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const c=Date.now()-this.j;if(c>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-c+5)}B(){if(this.c<=this.d||this.f||this.a)return;const c=this.b.peek(),l=Date.now()-c.writtenTime,b=Date.now()-this.q.lastReadTime,y=Date.now()-this.n;if(l>=2e4&&b>=2e4&&y>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:b});return}const u=Math.max(2e4-l,2e4-b,2e4-y,500);this.f=setTimeout(()=>{this.f=null,this.B()},u)}C(){if(this.g<=this.h)return;this.h=this.g;const c=new E(3,0,this.h,P());this.p.write(c)}D(){this.h=this.g;const c=new E(9,0,this.h,P());this.p.write(c)}}e.$dh=s}),define(Se[180],De([1,0,46,13,21,22,178,8,4,3,23,100,98,79]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=void 0;class C extends k.$4g{constructor(o){super({send:a=>{try{process.send?.(a.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",a=>h.$Ec.wrap(Buffer.from(a,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$Ip=C;class E{constructor(o,a){this.i=o,this.j=a,this.c=new Set,this.g=new Map,this.h=new w.$ec,this.onDidProcessExit=this.h.event;const m=a&&a.timeout?a.timeout:6e4;this.b=new F.$rg(m),this.d=null,this.f=null}getChannel(o){const a=this;return{call(m,v,D){return a.k(o,m,v,D)},listen(m,v){return a.l(o,m,v)}}}k(o,a,m,v=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(f.$4());this.b.cancel();const D=this.n(o),t=(0,F.$ig)(i=>D.call(a,m,i)),r=v.onCancellationRequested(()=>t.cancel()),s=(0,g.$jb)(()=>t.cancel());return this.c.add(s),t.finally(()=>{r.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,a,m){if(!this.b)return w.Event.None;this.b.cancel();let v;const D=new w.$ec({onWillAddFirstListener:()=>{v=this.n(o).listen(a,m)(D.fire,D),this.c.add(v)},onDidRemoveLastListener:()=>{this.c.delete(v),v.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return D.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],a=Object.create(null);a.env={...(0,P.$Im)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(a.env={...a.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(a.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(a.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(a.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),a.execArgv===void 0&&(a.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c)).filter(c=>!c.startsWith("--vscode-"))),(0,$.$gl)(a.env),this.d=(0,S.fork)(this.i,o,a);const m=new w.$ec;w.Event.fromNodeEventEmitter(this.d,"message",c=>c)(c=>{if((0,A.$Ep)(c)){(0,A.log)(c,`IPC Library: ${this.j.serverName}`);return}m.fire(h.$Ec.wrap(Buffer.from(c,"base64")))});const D=this.j.useQueue?(0,I.$il)(this.d):this.d,t=c=>this.d&&this.d.connected&&D.send(c.buffer.toString("base64")),r=m.event,s={send:t,onMessage:r};this.f=new k.$5g(s);const i=()=>this.o();process.once("exit",i),this.d.on("error",c=>console.warn('IPC "'+this.j.serverName+'" errored with '+c)),this.d.on("exit",(c,l)=>{process.removeListener("exit",i),this.c.forEach(b=>(0,g.$gb)(b)),this.c.clear(),c!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+c+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:c,signal:l})})}return this.f}n(o){let a=this.g.get(o);return a||(a=this.m.getChannel(o),this.g.set(o,a)),a}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Jp=E}),define(Se[181],De([1,0,35,14]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4E=void 0;function h(L,A,f,w,g,P){if(Array.isArray(L)){let I=0;for(const $ of L){const k=h($,A,f,w,g,P);if(k===10)return k;k>I&&(I=k)}return I}else{if(typeof L=="string")return w?L==="*"?5:L===f?10:0:0;if(L){const{language:I,pattern:$,scheme:k,hasAccessToAllModels:C,notebookType:E}=L;if(!w&&!C)return 0;E&&g&&(A=g);let n=0;if(k)if(k===A.scheme)n=10;else if(k==="*")n=5;else return 0;if(I)if(I===f)n=10;else if(I==="*")n=Math.max(n,5);else return 0;if(E)if(E===P)n=10;else if(E==="*"&&P!==void 0)n=Math.max(n,5);else return 0;if($){let o;if(typeof $=="string"?o=$:o={...$,base:(0,F.$6c)($.base)},o===A.fsPath||(0,S.$dj)(o,A.fsPath))n=10;else return 0}return n}else return 0}}e.$4E=h}),define(Se[128],De([1,0,21,9]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$59=e.$49=void 0;var h;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(h||(h={}));function L(I){for(let $=0,k=I.length;$<k;$+=4){const C=I[$+0],E=I[$+1],n=I[$+2],o=I[$+3];I[$+0]=o,I[$+1]=n,I[$+2]=E,I[$+3]=C}}function A(I){const $=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return F.$C()||L($),S.$Ec.wrap($)}function f(I){const $=I.buffer;if(F.$C()||L($),$.byteOffset%4===0)return new Uint32Array($.buffer,$.byteOffset,$.length/4);{const k=new Uint8Array($.byteLength);return k.set($),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function w(I){const $=new Uint32Array(g(I));let k=0;if($[k++]=I.id,I.type==="full")$[k++]=1,$[k++]=I.data.length,$.set(I.data,k),k+=I.data.length;else{$[k++]=2,$[k++]=I.deltas.length;for(const C of I.deltas)$[k++]=C.start,$[k++]=C.deleteCount,C.data?($[k++]=C.data.length,$.set(C.data,k),k+=C.data.length):$[k++]=0}return A($)}e.$49=w;function g(I){let $=0;if($+=1+1,I.type==="full")$+=1+I.data.length;else{$+=1,$+=(1+1+1)*I.deltas.length;for(const k of I.deltas)k.data&&($+=k.data.length)}return $}function P(I){const $=f(I);let k=0;const C=$[k++];if($[k++]===1){const a=$[k++],m=$.subarray(k,k+a);return k+=a,{id:C,type:"full",data:m}}const n=$[k++],o=[];for(let a=0;a<n;a++){const m=$[k++],v=$[k++],D=$[k++];let t;D>0&&(t=$.subarray(k,k+D),k+=D),o[a]={start:m,deleteCount:v,data:t}}return{id:C,type:"delta",deltas:o}}e.$59=P}),define(Se[182],De([11,12]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(Se[129],De([1,0,18,23,9,163,122,182]),function(me,e,S,F,h,L,A,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var w;(function(ue){ue[ue.None=0]="None",ue[ue.Keep=1]="Keep",ue[ue.Brackets=2]="Brackets",ue[ue.Advanced=3]="Advanced",ue[ue.Full=4]="Full"})(w||(e.EditorAutoIndentStrategy=w={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(ce){this.c=ce}hasChanged(ce){return this.c[ce]}}e.ConfigurationChangedEvent=g;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class I{constructor(ce,Ce,Ve,je){this.id=ce,this.name=Ce,this.defaultValue=Ve,this.schema=je}applyUpdate(ce,Ce){return k(ce,Ce)}compute(ce,Ce,Ve){return Ve}}class ${constructor(ce,Ce){this.newValue=ce,this.didChange=Ce}}e.ApplyUpdateResult=$;function k(ue,ce){if(typeof ue!="object"||typeof ce!="object"||!ue||!ce)return new $(ce,ue!==ce);if(Array.isArray(ue)||Array.isArray(ce)){const Ve=Array.isArray(ue)&&Array.isArray(ce)&&S.$$e(ue,ce);return new $(ce,!Ve)}let Ce=!1;for(const Ve in ce)if(ce.hasOwnProperty(Ve)){const je=k(ue[Ve],ce[Ve]);je.didChange&&(ue[Ve]=je.newValue,Ce=!0)}return new $(ue,Ce)}class C{constructor(ce){this.schema=void 0,this.id=ce,this.name="_never_",this.defaultValue=void 0}applyUpdate(ce,Ce){return k(ce,Ce)}validate(ce){return this.defaultValue}}class E{constructor(ce,Ce,Ve,je){this.id=ce,this.name=Ce,this.defaultValue=Ve,this.schema=je}applyUpdate(ce,Ce){return k(ce,Ce)}validate(ce){return typeof ce>"u"?this.defaultValue:ce}compute(ce,Ce,Ve){return Ve}}function n(ue,ce){return typeof ue>"u"?ce:ue==="false"?!1:!!ue}e.boolean=n;class o extends E{constructor(ce,Ce,Ve,je=void 0){typeof je<"u"&&(je.type="boolean",je.default=Ve),super(ce,Ce,Ve,je)}validate(ce){return n(ce,this.defaultValue)}}function a(ue,ce,Ce,Ve){if(typeof ue>"u")return ce;let je=parseInt(ue,10);return isNaN(je)?ce:(je=Math.max(Ce,je),je=Math.min(Ve,je),je|0)}e.clampedInt=a;class m extends E{static clampedInt(ce,Ce,Ve,je){return a(ce,Ce,Ve,je)}constructor(ce,Ce,Ve,je,Xe,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=Ve,rt.minimum=je,rt.maximum=Xe),super(ce,Ce,Ve,rt),this.minimum=je,this.maximum=Xe}validate(ce){return m.clampedInt(ce,this.defaultValue,this.minimum,this.maximum)}}function v(ue,ce,Ce,Ve){if(typeof ue>"u")return ce;const je=D.float(ue,ce);return D.clamp(je,Ce,Ve)}e.clampedFloat=v;class D extends E{static clamp(ce,Ce,Ve){return ce<Ce?Ce:ce>Ve?Ve:ce}static float(ce,Ce){if(typeof ce=="number")return ce;if(typeof ce>"u")return Ce;const Ve=parseFloat(ce);return isNaN(Ve)?Ce:Ve}constructor(ce,Ce,Ve,je,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=Ve),super(ce,Ce,Ve,Xe),this.validationFn=je}validate(ce){return this.validationFn(D.float(ce,this.defaultValue))}}class t extends E{static string(ce,Ce){return typeof ce!="string"?Ce:ce}constructor(ce,Ce,Ve,je=void 0){typeof je<"u"&&(je.type="string",je.default=Ve),super(ce,Ce,Ve,je)}validate(ce){return t.string(ce,this.defaultValue)}}function r(ue,ce,Ce,Ve){return typeof ue!="string"?ce:Ve&&ue in Ve?Ve[ue]:Ce.indexOf(ue)===-1?ce:ue}e.stringSet=r;class s extends E{constructor(ce,Ce,Ve,je,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=je,Xe.default=Ve),super(ce,Ce,Ve,Xe),this.c=je}validate(ce){return r(ce,this.defaultValue,this.c)}}class i extends I{constructor(ce,Ce,Ve,je,Xe,rt,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=Xe,ot.default=je),super(ce,Ce,Ve,ot),this.c=Xe,this.d=rt}validate(ce){return typeof ce!="string"?this.defaultValue:this.c.indexOf(ce)===-1?this.defaultValue:this.d(ce)}}function c(ue){switch(ue){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[f.localize(0,null),f.localize(1,null),f.localize(2,null)],default:"auto",tags:["accessibility"],description:f.localize(3,null)})}validate(ce){switch(ce){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ce,Ce,Ve){return Ve===0?ce.accessibilitySupport:Ve}}class b extends I{constructor(){const ce={insertSpace:!0,ignoreEmptyLines:!0};super(22,"comments",ce,{"editor.comments.insertSpace":{type:"boolean",default:ce.insertSpace,description:f.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ce.ignoreEmptyLines,description:f.localize(5,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ce=ce;return{insertSpace:n(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var y;(function(ue){ue[ue.Hidden=0]="Hidden",ue[ue.Blink=1]="Blink",ue[ue.Smooth=2]="Smooth",ue[ue.Phase=3]="Phase",ue[ue.Expand=4]="Expand",ue[ue.Solid=5]="Solid"})(y||(e.TextEditorCursorBlinkingStyle=y={}));function u(ue){switch(ue){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(ue){ue[ue.Line=1]="Line",ue[ue.Block=2]="Block",ue[ue.Underline=3]="Underline",ue[ue.LineThin=4]="LineThin",ue[ue.BlockOutline=5]="BlockOutline",ue[ue.UnderlineThin=6]="UnderlineThin"})(d||(e.TextEditorCursorStyle=d={}));function p(ue){switch(ue){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=p;function R(ue){switch(ue){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class O extends C{constructor(){super(139)}compute(ce,Ce,Ve){const je=["monaco-editor"];return Ce.get(38)&&je.push(Ce.get(38)),ce.extraEditorClassName&&je.push(ce.extraEditorClassName),Ce.get(72)==="default"?je.push("mouse-default"):Ce.get(72)==="copy"&&je.push("mouse-copy"),Ce.get(109)&&je.push("showUnused"),Ce.get(137)&&je.push("showDeprecated"),je.join(" ")}}class j extends o{constructor(){super(36,"emptySelectionClipboard",!0,{description:f.localize(6,null)})}compute(ce,Ce,Ve){return Ve&&ce.emptySelectionClipboard}}class T extends I{constructor(){const ce={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(40,"find",ce,{"editor.find.cursorMoveOnType":{type:"boolean",default:ce.cursorMoveOnType,description:f.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ce.seedSearchStringFromSelection,enumDescriptions:[f.localize(8,null),f.localize(9,null),f.localize(10,null)],description:f.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ce.autoFindInSelection,enumDescriptions:[f.localize(12,null),f.localize(13,null),f.localize(14,null)],description:f.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ce.globalFindClipboard,description:f.localize(16,null),included:h.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ce.addExtraSpaceOnTop,description:f.localize(17,null)},"editor.find.loop":{type:"boolean",default:ce.loop,description:f.localize(18,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ce=ce;return{cursorMoveOnType:n(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ce.seedSearchStringFromSelection=="boolean"?ce.seedSearchStringFromSelection?"always":"never":r(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ce.autoFindInSelection=="boolean"?ce.autoFindInSelection?"always":"never":r(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(Ce.loop,this.defaultValue.loop)}}}class z extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(50,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:f.localize(19,null)},{type:"string",description:f.localize(20,null)}],description:f.localize(21,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"?z.OFF:ce==="true"?z.ON:ce:ce?z.ON:z.OFF}}e.EditorFontLigatures=z;class B extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(53,"fontVariations",B.OFF,{anyOf:[{type:"boolean",description:f.localize(22,null)},{type:"string",description:f.localize(23,null)}],description:f.localize(24,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"?B.OFF:ce==="true"?B.TRANSLATE:ce:ce?B.TRANSLATE:B.OFF}compute(ce,Ce,Ve){return ce.fontInfo.fontVariationSettings}}e.EditorFontVariations=B;class M extends C{constructor(){super(49)}compute(ce,Ce,Ve){return ce.fontInfo}}class Y extends E{constructor(){super(51,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:f.localize(25,null)})}validate(ce){const Ce=D.float(ce,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:D.clamp(Ce,6,100)}compute(ce,Ce,Ve){return ce.fontInfo.fontSize}}class J extends I{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(52,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:J.d,maximum:J.e,errorMessage:f.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:J.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:f.localize(27,null)})}validate(ce){return ce==="normal"||ce==="bold"?ce:String(m.clampedInt(ce,e.EDITOR_FONT_DEFAULTS.fontWeight,J.d,J.e))}}class fe extends I{constructor(){const ce={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:ce.multiple,enumDescriptions:[f.localize(28,null),f.localize(29,null),f.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(57,"gotoLocation",ce,{"editor.gotoLocation.multiple":{deprecationMessage:f.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:f.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:f.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:f.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:f.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:f.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ce.alternativeDefinitionCommand,enum:Ve,description:f.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ce.alternativeTypeDefinitionCommand,enum:Ve,description:f.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ce.alternativeDeclarationCommand,enum:Ve,description:f.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ce.alternativeImplementationCommand,enum:Ve,description:f.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ce.alternativeReferenceCommand,enum:Ve,description:f.localize(41,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ce=ce;return{multiple:r(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??r(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??r(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??r(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??r(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??r(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class se extends I{constructor(){const ce={enabled:!0,delay:300,sticky:!0,above:!0};super(59,"hover",ce,{"editor.hover.enabled":{type:"boolean",default:ce.enabled,description:f.localize(42,null)},"editor.hover.delay":{type:"number",default:ce.delay,minimum:0,maximum:1e4,description:f.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ce.sticky,description:f.localize(44,null)},"editor.hover.above":{type:"boolean",default:ce.above,description:f.localize(45,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ce=ce;return{enabled:n(Ce.enabled,this.defaultValue.enabled),delay:m.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:n(Ce.sticky,this.defaultValue.sticky),above:n(Ce.above,this.defaultValue.above)}}}var ie;(function(ue){ue[ue.None=0]="None",ue[ue.Text=1]="Text",ue[ue.Blocks=2]="Blocks"})(ie||(e.RenderMinimap=ie={}));class V extends C{constructor(){super(142)}compute(ce,Ce,Ve){return V.computeLayout(Ce,{memory:ce.memory,outerWidth:ce.outerWidth,outerHeight:ce.outerHeight,isDominatedByLongLines:ce.isDominatedByLongLines,lineHeight:ce.fontInfo.lineHeight,viewLineCount:ce.viewLineCount,lineNumbersDigitCount:ce.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ce.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ce.fontInfo.maxDigitWidth,pixelRatio:ce.pixelRatio,glyphMarginDecorationLaneCount:ce.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ce){const Ce=ce.height/ce.lineHeight,Ve=Math.floor(ce.paddingTop/ce.lineHeight);let je=Math.floor(ce.paddingBottom/ce.lineHeight);ce.scrollBeyondLastLine&&(je=Math.max(je,Ce-1));const Xe=(Ve+ce.viewLineCount+je)/(ce.pixelRatio*ce.height),rt=Math.floor(ce.viewLineCount/Xe);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:je,desiredRatio:Xe,minimapLineCount:rt}}static c(ce,Ce){const Ve=ce.outerWidth,je=ce.outerHeight,Xe=ce.pixelRatio;if(!ce.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:je};const rt=Ce.stableMinimapLayoutInput,ot=rt&&ce.outerHeight===rt.outerHeight&&ce.lineHeight===rt.lineHeight&&ce.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&ce.pixelRatio===rt.pixelRatio&&ce.scrollBeyondLastLine===rt.scrollBeyondLastLine&&ce.paddingTop===rt.paddingTop&&ce.paddingBottom===rt.paddingBottom&&ce.minimap.enabled===rt.minimap.enabled&&ce.minimap.side===rt.minimap.side&&ce.minimap.size===rt.minimap.size&&ce.minimap.showSlider===rt.minimap.showSlider&&ce.minimap.renderCharacters===rt.minimap.renderCharacters&&ce.minimap.maxColumn===rt.minimap.maxColumn&&ce.minimap.scale===rt.minimap.scale&&ce.verticalScrollbarWidth===rt.verticalScrollbarWidth&&ce.isViewportWrapping===rt.isViewportWrapping,$t=ce.lineHeight,Ct=ce.typicalHalfwidthCharacterWidth,Qt=ce.scrollBeyondLastLine,qt=ce.minimap.renderCharacters;let vt=Xe>=2?Math.round(ce.minimap.scale*2):ce.minimap.scale;const Mt=ce.minimap.maxColumn,Nt=ce.minimap.size,Jt=ce.minimap.side,Lt=ce.verticalScrollbarWidth,Rt=ce.viewLineCount,zt=ce.remainingWidth,Ut=ce.isViewportWrapping,Vt=qt?2:3;let Bt=Math.floor(Xe*je);const ct=Bt/Xe;let ht=!1,Ht=!1,At=Vt*vt,kt=vt/Xe,ft=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Ae,extraLinesBeforeFirstLine:te,extraLinesBeyondLastLine:Me,desiredRatio:Ke,minimapLineCount:xe}=V.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Qt,paddingTop:ce.paddingTop,paddingBottom:ce.paddingBottom,height:je,lineHeight:$t,pixelRatio:Xe});if(Rt/xe>1)ht=!0,Ht=!0,vt=1,At=1,kt=vt/Xe;else{let nt=!1,bt=vt+1;if(Nt==="fit"){const Et=Math.ceil((te+Rt+Me)*At);Ut&&ot&&zt<=Ce.stableFitRemainingWidth?(nt=!0,bt=Ce.stableFitMaxMinimapScale):nt=Et>Bt}if(Nt==="fill"||nt){ht=!0;const Et=vt;At=Math.min($t*Xe,Math.max(1,Math.floor(1/Ke))),Ut&&ot&&zt<=Ce.stableFitRemainingWidth&&(bt=Ce.stableFitMaxMinimapScale),vt=Math.min(bt,Math.max(1,Math.floor(At/Vt))),vt>Et&&(ft=Math.min(2,vt/Et)),kt=vt/Xe/ft,Bt=Math.ceil(Math.max(Ae,te+Rt+Me)*At),Ut?(Ce.stableMinimapLayoutInput=ce,Ce.stableFitRemainingWidth=zt,Ce.stableFitMaxMinimapScale=vt):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const It=Math.floor(Mt*kt),Ot=Math.min(It,Math.max(0,Math.floor((zt-Lt-2)*kt/(Ct+kt)))+e.MINIMAP_GUTTER_WIDTH);let yt=Math.floor(Xe*Ot);const He=yt/Xe;yt=Math.floor(yt*ft);const Fe=qt?1:2,Te=Jt==="left"?0:Ve-Ot-Lt;return{renderMinimap:Fe,minimapLeft:Te,minimapWidth:Ot,minimapHeightIsEditorHeight:ht,minimapIsSampling:Ht,minimapScale:vt,minimapLineHeight:At,minimapCanvasInnerWidth:yt,minimapCanvasInnerHeight:Bt,minimapCanvasOuterWidth:He,minimapCanvasOuterHeight:ct}}static computeLayout(ce,Ce){const Ve=Ce.outerWidth|0,je=Ce.outerHeight|0,Xe=Ce.lineHeight|0,rt=Ce.lineNumbersDigitCount|0,ot=Ce.typicalHalfwidthCharacterWidth,$t=Ce.maxDigitWidth,Ct=Ce.pixelRatio,Qt=Ce.viewLineCount,qt=ce.get(134),vt=qt==="inherit"?ce.get(133):qt,Mt=vt==="inherit"?ce.get(129):vt,Nt=ce.get(132),Jt=Ce.isDominatedByLongLines,Lt=ce.get(56),Rt=ce.get(66).renderType!==0,zt=ce.get(67),Ut=ce.get(103),Vt=ce.get(82),Bt=ce.get(71),ct=ce.get(101),ht=ct.verticalScrollbarSize,Ht=ct.verticalHasArrows,At=ct.arrowSize,kt=ct.horizontalScrollbarSize,ft=ce.get(42),It=ce.get(108)!=="never";let Ot=ce.get(64);ft&&It&&(Ot+=16);let yt=0;if(Rt){const ut=Math.max(rt,zt);yt=Math.round(ut*$t)}let He=0;Lt&&(He=Xe*Ce.glyphMarginDecorationLaneCount);let Fe=0,Te=Fe+He,Ae=Te+yt,te=Ae+Ot;const Me=Ve-He-yt-Ot;let Ke=!1,xe=!1,Ge=-1;vt==="inherit"&&Jt?(Ke=!0,xe=!0):Mt==="on"||Mt==="bounded"?xe=!0:Mt==="wordWrapColumn"&&(Ge=Nt);const nt=V.c({outerWidth:Ve,outerHeight:je,lineHeight:Xe,typicalHalfwidthCharacterWidth:ot,pixelRatio:Ct,scrollBeyondLastLine:Ut,paddingTop:Vt.top,paddingBottom:Vt.bottom,minimap:Bt,verticalScrollbarWidth:ht,viewLineCount:Qt,remainingWidth:Me,isViewportWrapping:xe},Ce.memory||new P);nt.renderMinimap!==0&&nt.minimapLeft===0&&(Fe+=nt.minimapWidth,Te+=nt.minimapWidth,Ae+=nt.minimapWidth,te+=nt.minimapWidth);const bt=Me-nt.minimapWidth,Et=Math.max(1,Math.floor((bt-ht-2)/ot)),pt=Ht?At:0;return xe&&(Ge=Math.max(1,Et),Mt==="bounded"&&(Ge=Math.min(Ge,Nt))),{width:Ve,height:je,glyphMarginLeft:Fe,glyphMarginWidth:He,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:Te,lineNumbersWidth:yt,decorationsLeft:Ae,decorationsWidth:Ot,contentLeft:te,contentWidth:bt,minimap:nt,viewportColumn:Et,isWordWrapMinified:Ke,isViewportWrapping:xe,wrappingColumn:Ge,verticalScrollbarWidth:ht,horizontalScrollbarHeight:kt,overviewRuler:{top:pt,width:ht,height:je-2*pt,right:0}}}}e.EditorLayoutInfoComputer=V;class re extends I{constructor(){super(136,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[f.localize(46,null),f.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:f.localize(48,null)}})}validate(ce){return r(ce,"simple",["simple","advanced"])}compute(ce,Ce,Ve){return Ce.get(2)===2?"advanced":Ve}}class pe extends I{constructor(){const ce={enabled:!0};super(63,"lightbulb",ce,{"editor.lightbulb.enabled":{type:"boolean",default:ce.enabled,description:f.localize(49,null)}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{enabled:n(ce.enabled,this.defaultValue.enabled)}}}class ae extends I{constructor(){const ce={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(113,"stickyScroll",ce,{"editor.stickyScroll.enabled":{type:"boolean",default:ce.enabled,description:f.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ce.maxLineCount,minimum:1,maximum:10,description:f.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ce.defaultModel,description:f.localize(52,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ce.scrollWithEditor,description:f.localize(53,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ce=ce;return{enabled:n(Ce.enabled,this.defaultValue.enabled),maxLineCount:m.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:n(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ne extends I{constructor(){const ce={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(138,"inlayHints",ce,{"editor.inlayHints.enabled":{type:"string",default:ce.enabled,description:f.localize(54,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[f.localize(55,null),f.localize(56,null,h.$j?"Ctrl+Option":"Ctrl+Alt"),f.localize(57,null,h.$j?"Ctrl+Option":"Ctrl+Alt"),f.localize(58,null)]},"editor.inlayHints.fontSize":{type:"number",default:ce.fontSize,markdownDescription:f.localize(59,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ce.fontFamily,markdownDescription:f.localize(60,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ce.padding,description:f.localize(61,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ce=ce;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:r(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:m.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:n(Ce.padding,this.defaultValue.padding)}}}class x extends I{constructor(){super(64,"lineDecorationsWidth",10)}validate(ce){return typeof ce=="string"&&/^\d+(\.\d+)?ch$/.test(ce)?-parseFloat(ce.substring(0,ce.length-2)):m.clampedInt(ce,this.defaultValue,0,1e3)}compute(ce,Ce,Ve){return Ve<0?m.clampedInt(-Ve*ce.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class N extends D{constructor(){super(65,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ce=>D.clamp(ce,0,150),{markdownDescription:f.localize(62,null)})}compute(ce,Ce,Ve){return ce.fontInfo.lineHeight}}class q extends I{constructor(){const ce={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(71,"minimap",ce,{"editor.minimap.enabled":{type:"boolean",default:ce.enabled,description:f.localize(63,null)},"editor.minimap.autohide":{type:"boolean",default:ce.autohide,description:f.localize(64,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[f.localize(65,null),f.localize(66,null),f.localize(67,null)],default:ce.size,description:f.localize(68,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ce.side,description:f.localize(69,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ce.showSlider,description:f.localize(70,null)},"editor.minimap.scale":{type:"number",default:ce.scale,minimum:1,maximum:3,enum:[1,2,3],description:f.localize(71,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ce.renderCharacters,description:f.localize(72,null)},"editor.minimap.maxColumn":{type:"number",default:ce.maxColumn,description:f.localize(73,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ce=ce;return{enabled:n(Ce.enabled,this.defaultValue.enabled),autohide:n(Ce.autohide,this.defaultValue.autohide),size:r(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(Ce.side,this.defaultValue.side,["right","left"]),showSlider:r(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:m.clampedInt(Ce.scale,1,1,3),maxColumn:m.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function de(ue){return ue==="ctrlCmd"?h.$j?"metaKey":"ctrlKey":"altKey"}class ye extends I{constructor(){super(82,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(74,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(75,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ce=ce;return{top:m.clampedInt(Ce.top,0,0,1e3),bottom:m.clampedInt(Ce.bottom,0,0,1e3)}}}class ve extends I{constructor(){const ce={enabled:!0,cycle:!0};super(84,"parameterHints",ce,{"editor.parameterHints.enabled":{type:"boolean",default:ce.enabled,description:f.localize(76,null)},"editor.parameterHints.cycle":{type:"boolean",default:ce.cycle,description:f.localize(77,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ce=ce;return{enabled:n(Ce.enabled,this.defaultValue.enabled),cycle:n(Ce.cycle,this.defaultValue.cycle)}}}class we extends C{constructor(){super(140)}compute(ce,Ce,Ve){return ce.pixelRatio}}class Ee extends I{constructor(){const ce={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[f.localize(78,null),f.localize(79,null),f.localize(80,null)]}];super(87,"quickSuggestions",ce,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:ce.strings,description:f.localize(81,null)},comments:{anyOf:Ce,default:ce.comments,description:f.localize(82,null)},other:{anyOf:Ce,default:ce.other,description:f.localize(83,null)}},default:ce,markdownDescription:f.localize(84,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ce}validate(ce){if(typeof ce=="boolean"){const Ct=ce?"on":"off";return{comments:Ct,strings:Ct,other:Ct}}if(!ce||typeof ce!="object")return this.defaultValue;const{other:Ce,comments:Ve,strings:je}=ce,Xe=["on","inline","off"];let rt,ot,$t;return typeof Ce=="boolean"?rt=Ce?"on":"off":rt=r(Ce,this.defaultValue.other,Xe),typeof Ve=="boolean"?ot=Ve?"on":"off":ot=r(Ve,this.defaultValue.comments,Xe),typeof je=="boolean"?$t=je?"on":"off":$t=r(je,this.defaultValue.strings,Xe),{other:rt,comments:ot,strings:$t}}}var K;(function(ue){ue[ue.Off=0]="Off",ue[ue.On=1]="On",ue[ue.Relative=2]="Relative",ue[ue.Interval=3]="Interval",ue[ue.Custom=4]="Custom"})(K||(e.RenderLineNumbersType=K={}));class ee extends I{constructor(){super(66,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[f.localize(85,null),f.localize(86,null),f.localize(87,null),f.localize(88,null)],default:"on",description:f.localize(89,null)})}validate(ce){let Ce=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof ce<"u"&&(typeof ce=="function"?(Ce=4,Ve=ce):ce==="interval"?Ce=3:ce==="relative"?Ce=2:ce==="on"?Ce=1:Ce=0),{renderType:Ce,renderFn:Ve}}}function G(ue){const ce=ue.get(96);return ce==="editable"?ue.get(89):ce!=="on"}e.filterValidationDecorations=G;class X extends I{constructor(){const ce=[],Ce={type:"number",description:f.localize(90,null)};super(100,"rulers",ce,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:f.localize(91,null),format:"color-hex"}}}]},default:ce,description:f.localize(92,null)})}validate(ce){if(Array.isArray(ce)){const Ce=[];for(const Ve of ce)if(typeof Ve=="number")Ce.push({column:m.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const je=Ve;Ce.push({column:m.clampedInt(je.column,0,0,1e4),color:je.color})}return Ce.sort((Ve,je)=>Ve.column-je.column),Ce}return this.defaultValue}}class he extends I{constructor(){super(90,"readOnlyMessage",void 0)}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:ce}}function Ie(ue,ce){if(typeof ue!="string")return ce;switch(ue){case"hidden":return 2;case"visible":return 3;default:return 1}}class U extends I{constructor(){const ce={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(101,"scrollbar",ce,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(93,null),f.localize(94,null),f.localize(95,null)],default:"auto",description:f.localize(96,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(97,null),f.localize(98,null),f.localize(99,null)],default:"auto",description:f.localize(100,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ce.verticalScrollbarSize,description:f.localize(101,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ce.horizontalScrollbarSize,description:f.localize(102,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ce.scrollByPage,description:f.localize(103,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ce=ce,Ve=m.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),je=m.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:m.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(Ce.vertical,this.defaultValue.vertical),horizontal:Ie(Ce.horizontal,this.defaultValue.horizontal),useShadows:n(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:m.clampedInt(Ce.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:je,verticalSliderSize:m.clampedInt(Ce.verticalSliderSize,je,0,1e3),scrollByPage:n(Ce.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends I{constructor(){const ce={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(123,"unicodeHighlight",ce,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.nonBasicASCII,description:f.localize(104,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ce.invisibleCharacters,description:f.localize(105,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ce.ambiguousCharacters,description:f.localize(106,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeComments,description:f.localize(107,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeStrings,description:f.localize(108,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ce.allowedCharacters,description:f.localize(109,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ce.allowedLocales,description:f.localize(110,null)}})}applyUpdate(ce,Ce){let Ve=!1;Ce.allowedCharacters&&ce&&(F.$Mm(ce.allowedCharacters,Ce.allowedCharacters)||(ce={...ce,allowedCharacters:Ce.allowedCharacters},Ve=!0)),Ce.allowedLocales&&ce&&(F.$Mm(ce.allowedLocales,Ce.allowedLocales)||(ce={...ce,allowedLocales:Ce.allowedLocales},Ve=!0));const je=super.applyUpdate(ce,Ce);return Ve?new $(je.newValue,!0):je}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ce=ce;return{nonBasicASCII:le(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:n(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:n(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:le(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:le(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ce.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ce.allowedLocales,this.defaultValue.allowedLocales)}}c(ce,Ce){if(typeof ce!="object"||!ce)return Ce;const Ve={};for(const[je,Xe]of Object.entries(ce))Xe===!0&&(Ve[je]=!0);return Ve}}class _ extends I{constructor(){const ce={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(61,"inlineSuggest",ce,{"editor.inlineSuggest.enabled":{type:"boolean",default:ce.enabled,description:f.localize(111,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ce.showToolbar,enum:["always","onHover"],enumDescriptions:[f.localize(112,null),f.localize(113,null)],description:f.localize(114,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ce.suppressSuggestions,description:f.localize(115,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ce=ce;return{enabled:n(Ce.enabled,this.defaultValue.enabled),mode:r(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:n(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:n(Ce.keepOnBlur,this.defaultValue.keepOnBlur)}}}class oe extends I{constructor(){const ce={enabled:L.$Lr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$Lr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(14,"bracketPairColorization",ce,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ce.enabled,markdownDescription:f.localize(116,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ce.independentColorPoolPerBracketType,description:f.localize(117,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ce=ce;return{enabled:n(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:n(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Z extends I{constructor(){const ce={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(15,"guides",ce,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[f.localize(118,null),f.localize(119,null),f.localize(120,null)],default:ce.bracketPairs,description:f.localize(121,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[f.localize(122,null),f.localize(123,null),f.localize(124,null)],default:ce.bracketPairsHorizontal,description:f.localize(125,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ce.highlightActiveBracketPair,description:f.localize(126,null)},"editor.guides.indentation":{type:"boolean",default:ce.indentation,description:f.localize(127,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[f.localize(128,null),f.localize(129,null),f.localize(130,null)],default:ce.highlightActiveIndentation,description:f.localize(131,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ce=ce;return{bracketPairs:le(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:le(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:le(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function le(ue,ce,Ce){const Ve=Ce.indexOf(ue);return Ve===-1?ce:Ce[Ve]}class be extends I{constructor(){const ce={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(116,"suggest",ce,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[f.localize(132,null),f.localize(133,null)],default:ce.insertMode,description:f.localize(134,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ce.filterGraceful,description:f.localize(135,null)},"editor.suggest.localityBonus":{type:"boolean",default:ce.localityBonus,description:f.localize(136,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ce.shareSuggestSelections,markdownDescription:f.localize(137,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[f.localize(138,null),f.localize(139,null),f.localize(140,null),f.localize(141,null)],default:ce.selectionMode,markdownDescription:f.localize(142,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ce.snippetsPreventQuickSuggestions,description:f.localize(143,null)},"editor.suggest.showIcons":{type:"boolean",default:ce.showIcons,description:f.localize(144,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ce.showStatusBar,description:f.localize(145,null)},"editor.suggest.preview":{type:"boolean",default:ce.preview,description:f.localize(146,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ce.showInlineDetails,description:f.localize(147,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:f.localize(148,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:f.localize(149,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:f.localize(150,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:f.localize(151,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:f.localize(152,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:f.localize(153,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:f.localize(154,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:f.localize(155,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:f.localize(156,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:f.localize(157,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:f.localize(158,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:f.localize(159,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:f.localize(160,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:f.localize(161,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:f.localize(162,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:f.localize(163,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:f.localize(164,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:f.localize(165,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:f.localize(166,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:f.localize(167,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:f.localize(168,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:f.localize(169,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:f.localize(170,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:f.localize(171,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:f.localize(172,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:f.localize(173,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:f.localize(174,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:f.localize(175,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:f.localize(176,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:f.localize(177,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:f.localize(178,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:f.localize(179,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ce=ce;return{insertMode:r(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:n(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:n(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:n(Ce.preview,this.defaultValue.preview),previewMode:r(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(Ce.showMethods,this.defaultValue.showMethods),showFunctions:n(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:n(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:n(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:n(Ce.showFields,this.defaultValue.showFields),showVariables:n(Ce.showVariables,this.defaultValue.showVariables),showClasses:n(Ce.showClasses,this.defaultValue.showClasses),showStructs:n(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:n(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:n(Ce.showModules,this.defaultValue.showModules),showProperties:n(Ce.showProperties,this.defaultValue.showProperties),showEvents:n(Ce.showEvents,this.defaultValue.showEvents),showOperators:n(Ce.showOperators,this.defaultValue.showOperators),showUnits:n(Ce.showUnits,this.defaultValue.showUnits),showValues:n(Ce.showValues,this.defaultValue.showValues),showConstants:n(Ce.showConstants,this.defaultValue.showConstants),showEnums:n(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:n(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(Ce.showKeywords,this.defaultValue.showKeywords),showWords:n(Ce.showWords,this.defaultValue.showWords),showColors:n(Ce.showColors,this.defaultValue.showColors),showFiles:n(Ce.showFiles,this.defaultValue.showFiles),showReferences:n(Ce.showReferences,this.defaultValue.showReferences),showFolders:n(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:n(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:n(Ce.showUsers,this.defaultValue.showUsers),showIssues:n(Ce.showIssues,this.defaultValue.showIssues)}}}class ze extends I{constructor(){super(111,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:f.localize(180,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:f.localize(181,null),default:!0,type:"boolean"}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(ce.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:n(ce.selectSubwords,this.defaultValue.selectSubwords)}}}var qe;(function(ue){ue[ue.None=0]="None",ue[ue.Same=1]="Same",ue[ue.Indent=2]="Indent",ue[ue.DeepIndent=3]="DeepIndent"})(qe||(e.WrappingIndent=qe={}));class _e extends I{constructor(){super(135,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[f.localize(182,null),f.localize(183,null),f.localize(184,null),f.localize(185,null)],description:f.localize(186,null),default:"same"}})}validate(ce){switch(ce){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ce,Ce,Ve){return Ce.get(2)===2?0:Ve}}class Ze extends C{constructor(){super(143)}compute(ce,Ce,Ve){const je=Ce.get(142);return{isDominatedByLongLines:ce.isDominatedByLongLines,isWordWrapMinified:je.isWordWrapMinified,isViewportWrapping:je.isViewportWrapping,wrappingColumn:je.wrappingColumn}}}class it extends I{constructor(){const ce={enabled:!0,showDropSelector:"afterDrop"};super(35,"dropIntoEditor",ce,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ce.enabled,markdownDescription:f.localize(187,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:f.localize(188,null),enum:["afterDrop","never"],enumDescriptions:[f.localize(189,null),f.localize(190,null)],default:"afterDrop"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ce=ce;return{enabled:n(Ce.enabled,this.defaultValue.enabled),showDropSelector:r(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class et extends I{constructor(){const ce={enabled:!0,showPasteSelector:"afterPaste"};super(83,"pasteAs",ce,{"editor.pasteAs.enabled":{type:"boolean",default:ce.enabled,markdownDescription:f.localize(191,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:f.localize(192,null),enum:["afterPaste","never"],enumDescriptions:[f.localize(193,null),f.localize(194,null)],default:"afterPaste"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ce=ce;return{enabled:n(Ce.enabled,this.defaultValue.enabled),showPasteSelector:r(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Pe="Consolas, 'Courier New', monospace",Oe="Menlo, Monaco, 'Courier New', monospace",We="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:h.$j?Oe:h.$k?We:Pe,fontWeight:"normal",fontSize:h.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Re(ue){return e.editorOptionsRegistry[ue.id]=ue,ue}var Qe;(function(ue){ue[ue.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ue[ue.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ue[ue.accessibilitySupport=2]="accessibilitySupport",ue[ue.accessibilityPageSize=3]="accessibilityPageSize",ue[ue.ariaLabel=4]="ariaLabel",ue[ue.ariaRequired=5]="ariaRequired",ue[ue.autoClosingBrackets=6]="autoClosingBrackets",ue[ue.screenReaderAnnounceInlineSuggestion=7]="screenReaderAnnounceInlineSuggestion",ue[ue.autoClosingDelete=8]="autoClosingDelete",ue[ue.autoClosingOvertype=9]="autoClosingOvertype",ue[ue.autoClosingQuotes=10]="autoClosingQuotes",ue[ue.autoIndent=11]="autoIndent",ue[ue.automaticLayout=12]="automaticLayout",ue[ue.autoSurround=13]="autoSurround",ue[ue.bracketPairColorization=14]="bracketPairColorization",ue[ue.guides=15]="guides",ue[ue.codeLens=16]="codeLens",ue[ue.codeLensFontFamily=17]="codeLensFontFamily",ue[ue.codeLensFontSize=18]="codeLensFontSize",ue[ue.colorDecorators=19]="colorDecorators",ue[ue.colorDecoratorsLimit=20]="colorDecoratorsLimit",ue[ue.columnSelection=21]="columnSelection",ue[ue.comments=22]="comments",ue[ue.contextmenu=23]="contextmenu",ue[ue.copyWithSyntaxHighlighting=24]="copyWithSyntaxHighlighting",ue[ue.cursorBlinking=25]="cursorBlinking",ue[ue.cursorSmoothCaretAnimation=26]="cursorSmoothCaretAnimation",ue[ue.cursorStyle=27]="cursorStyle",ue[ue.cursorSurroundingLines=28]="cursorSurroundingLines",ue[ue.cursorSurroundingLinesStyle=29]="cursorSurroundingLinesStyle",ue[ue.cursorWidth=30]="cursorWidth",ue[ue.disableLayerHinting=31]="disableLayerHinting",ue[ue.disableMonospaceOptimizations=32]="disableMonospaceOptimizations",ue[ue.domReadOnly=33]="domReadOnly",ue[ue.dragAndDrop=34]="dragAndDrop",ue[ue.dropIntoEditor=35]="dropIntoEditor",ue[ue.emptySelectionClipboard=36]="emptySelectionClipboard",ue[ue.experimentalWhitespaceRendering=37]="experimentalWhitespaceRendering",ue[ue.extraEditorClassName=38]="extraEditorClassName",ue[ue.fastScrollSensitivity=39]="fastScrollSensitivity",ue[ue.find=40]="find",ue[ue.fixedOverflowWidgets=41]="fixedOverflowWidgets",ue[ue.folding=42]="folding",ue[ue.foldingStrategy=43]="foldingStrategy",ue[ue.foldingHighlight=44]="foldingHighlight",ue[ue.foldingImportsByDefault=45]="foldingImportsByDefault",ue[ue.foldingMaximumRegions=46]="foldingMaximumRegions",ue[ue.unfoldOnClickAfterEndOfLine=47]="unfoldOnClickAfterEndOfLine",ue[ue.fontFamily=48]="fontFamily",ue[ue.fontInfo=49]="fontInfo",ue[ue.fontLigatures=50]="fontLigatures",ue[ue.fontSize=51]="fontSize",ue[ue.fontWeight=52]="fontWeight",ue[ue.fontVariations=53]="fontVariations",ue[ue.formatOnPaste=54]="formatOnPaste",ue[ue.formatOnType=55]="formatOnType",ue[ue.glyphMargin=56]="glyphMargin",ue[ue.gotoLocation=57]="gotoLocation",ue[ue.hideCursorInOverviewRuler=58]="hideCursorInOverviewRuler",ue[ue.hover=59]="hover",ue[ue.inDiffEditor=60]="inDiffEditor",ue[ue.inlineSuggest=61]="inlineSuggest",ue[ue.letterSpacing=62]="letterSpacing",ue[ue.lightbulb=63]="lightbulb",ue[ue.lineDecorationsWidth=64]="lineDecorationsWidth",ue[ue.lineHeight=65]="lineHeight",ue[ue.lineNumbers=66]="lineNumbers",ue[ue.lineNumbersMinChars=67]="lineNumbersMinChars",ue[ue.linkedEditing=68]="linkedEditing",ue[ue.links=69]="links",ue[ue.matchBrackets=70]="matchBrackets",ue[ue.minimap=71]="minimap",ue[ue.mouseStyle=72]="mouseStyle",ue[ue.mouseWheelScrollSensitivity=73]="mouseWheelScrollSensitivity",ue[ue.mouseWheelZoom=74]="mouseWheelZoom",ue[ue.multiCursorMergeOverlapping=75]="multiCursorMergeOverlapping",ue[ue.multiCursorModifier=76]="multiCursorModifier",ue[ue.multiCursorPaste=77]="multiCursorPaste",ue[ue.multiCursorLimit=78]="multiCursorLimit",ue[ue.occurrencesHighlight=79]="occurrencesHighlight",ue[ue.overviewRulerBorder=80]="overviewRulerBorder",ue[ue.overviewRulerLanes=81]="overviewRulerLanes",ue[ue.padding=82]="padding",ue[ue.pasteAs=83]="pasteAs",ue[ue.parameterHints=84]="parameterHints",ue[ue.peekWidgetDefaultFocus=85]="peekWidgetDefaultFocus",ue[ue.definitionLinkOpensInPeek=86]="definitionLinkOpensInPeek",ue[ue.quickSuggestions=87]="quickSuggestions",ue[ue.quickSuggestionsDelay=88]="quickSuggestionsDelay",ue[ue.readOnly=89]="readOnly",ue[ue.readOnlyMessage=90]="readOnlyMessage",ue[ue.renameOnType=91]="renameOnType",ue[ue.renderControlCharacters=92]="renderControlCharacters",ue[ue.renderFinalNewline=93]="renderFinalNewline",ue[ue.renderLineHighlight=94]="renderLineHighlight",ue[ue.renderLineHighlightOnlyWhenFocus=95]="renderLineHighlightOnlyWhenFocus",ue[ue.renderValidationDecorations=96]="renderValidationDecorations",ue[ue.renderWhitespace=97]="renderWhitespace",ue[ue.revealHorizontalRightPadding=98]="revealHorizontalRightPadding",ue[ue.roundedSelection=99]="roundedSelection",ue[ue.rulers=100]="rulers",ue[ue.scrollbar=101]="scrollbar",ue[ue.scrollBeyondLastColumn=102]="scrollBeyondLastColumn",ue[ue.scrollBeyondLastLine=103]="scrollBeyondLastLine",ue[ue.scrollPredominantAxis=104]="scrollPredominantAxis",ue[ue.selectionClipboard=105]="selectionClipboard",ue[ue.selectionHighlight=106]="selectionHighlight",ue[ue.selectOnLineNumbers=107]="selectOnLineNumbers",ue[ue.showFoldingControls=108]="showFoldingControls",ue[ue.showUnused=109]="showUnused",ue[ue.snippetSuggestions=110]="snippetSuggestions",ue[ue.smartSelect=111]="smartSelect",ue[ue.smoothScrolling=112]="smoothScrolling",ue[ue.stickyScroll=113]="stickyScroll",ue[ue.stickyTabStops=114]="stickyTabStops",ue[ue.stopRenderingLineAfter=115]="stopRenderingLineAfter",ue[ue.suggest=116]="suggest",ue[ue.suggestFontSize=117]="suggestFontSize",ue[ue.suggestLineHeight=118]="suggestLineHeight",ue[ue.suggestOnTriggerCharacters=119]="suggestOnTriggerCharacters",ue[ue.suggestSelection=120]="suggestSelection",ue[ue.tabCompletion=121]="tabCompletion",ue[ue.tabIndex=122]="tabIndex",ue[ue.unicodeHighlighting=123]="unicodeHighlighting",ue[ue.unusualLineTerminators=124]="unusualLineTerminators",ue[ue.useShadowDOM=125]="useShadowDOM",ue[ue.useTabStops=126]="useTabStops",ue[ue.wordBreak=127]="wordBreak",ue[ue.wordSeparators=128]="wordSeparators",ue[ue.wordWrap=129]="wordWrap",ue[ue.wordWrapBreakAfterCharacters=130]="wordWrapBreakAfterCharacters",ue[ue.wordWrapBreakBeforeCharacters=131]="wordWrapBreakBeforeCharacters",ue[ue.wordWrapColumn=132]="wordWrapColumn",ue[ue.wordWrapOverride1=133]="wordWrapOverride1",ue[ue.wordWrapOverride2=134]="wordWrapOverride2",ue[ue.wrappingIndent=135]="wrappingIndent",ue[ue.wrappingStrategy=136]="wrappingStrategy",ue[ue.showDeprecated=137]="showDeprecated",ue[ue.inlayHints=138]="inlayHints",ue[ue.editorClassName=139]="editorClassName",ue[ue.pixelRatio=140]="pixelRatio",ue[ue.tabFocusMode=141]="tabFocusMode",ue[ue.layoutInfo=142]="layoutInfo",ue[ue.wrappingInfo=143]="wrappingInfo",ue[ue.defaultColorDecorators=144]="defaultColorDecorators",ue[ue.colorDecoratorsActivatedOn=145]="colorDecoratorsActivatedOn",ue[ue.inlineCompletionsAccessibilityVerbose=146]="inlineCompletionsAccessibilityVerbose"})(Qe||(e.EditorOption=Qe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Re(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:f.localize(195,null)})),acceptSuggestionOnEnter:Re(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",f.localize(196,null),""],markdownDescription:f.localize(197,null)})),accessibilitySupport:Re(new l),accessibilityPageSize:Re(new m(3,"accessibilityPageSize",10,1,1073741824,{description:f.localize(198,null),tags:["accessibility"]})),ariaLabel:Re(new t(4,"ariaLabel",f.localize(199,null))),ariaRequired:Re(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Re(new o(7,"screenReaderAnnounceInlineSuggestion",!0,{description:f.localize(200,null),tags:["accessibility"]})),autoClosingBrackets:Re(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(201,null),f.localize(202,null),""],description:f.localize(203,null)})),autoClosingDelete:Re(new s(8,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",f.localize(204,null),""],description:f.localize(205,null)})),autoClosingOvertype:Re(new s(9,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",f.localize(206,null),""],description:f.localize(207,null)})),autoClosingQuotes:Re(new s(10,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(208,null),f.localize(209,null),""],description:f.localize(210,null)})),autoIndent:Re(new i(11,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[f.localize(211,null),f.localize(212,null),f.localize(213,null),f.localize(214,null),f.localize(215,null)],description:f.localize(216,null)})),automaticLayout:Re(new o(12,"automaticLayout",!1)),autoSurround:Re(new s(13,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[f.localize(217,null),f.localize(218,null),f.localize(219,null),""],description:f.localize(220,null)})),bracketPairColorization:Re(new oe),bracketPairGuides:Re(new Z),stickyTabStops:Re(new o(114,"stickyTabStops",!1,{description:f.localize(221,null)})),codeLens:Re(new o(16,"codeLens",!0,{description:f.localize(222,null)})),codeLensFontFamily:Re(new t(17,"codeLensFontFamily","",{description:f.localize(223,null)})),codeLensFontSize:Re(new m(18,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:f.localize(224,null)})),colorDecorators:Re(new o(19,"colorDecorators",!0,{description:f.localize(225,null)})),colorDecoratorActivatedOn:Re(new s(145,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[f.localize(226,null),f.localize(227,null),f.localize(228,null)],description:f.localize(229,null)})),colorDecoratorsLimit:Re(new m(20,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:f.localize(230,null)})),columnSelection:Re(new o(21,"columnSelection",!1,{description:f.localize(231,null)})),comments:Re(new b),contextmenu:Re(new o(23,"contextmenu",!0)),copyWithSyntaxHighlighting:Re(new o(24,"copyWithSyntaxHighlighting",!0,{description:f.localize(232,null)})),cursorBlinking:Re(new i(25,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:f.localize(233,null)})),cursorSmoothCaretAnimation:Re(new s(26,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[f.localize(234,null),f.localize(235,null),f.localize(236,null)],description:f.localize(237,null)})),cursorStyle:Re(new i(27,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:f.localize(238,null)})),cursorSurroundingLines:Re(new m(28,"cursorSurroundingLines",0,0,1073741824,{description:f.localize(239,null)})),cursorSurroundingLinesStyle:Re(new s(29,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[f.localize(240,null),f.localize(241,null)],description:f.localize(242,null)})),cursorWidth:Re(new m(30,"cursorWidth",0,0,1073741824,{markdownDescription:f.localize(243,null)})),disableLayerHinting:Re(new o(31,"disableLayerHinting",!1)),disableMonospaceOptimizations:Re(new o(32,"disableMonospaceOptimizations",!1)),domReadOnly:Re(new o(33,"domReadOnly",!1)),dragAndDrop:Re(new o(34,"dragAndDrop",!0,{description:f.localize(244,null)})),emptySelectionClipboard:Re(new j),dropIntoEditor:Re(new it),stickyScroll:Re(new ae),experimentalWhitespaceRendering:Re(new s(37,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[f.localize(245,null),f.localize(246,null),f.localize(247,null)],description:f.localize(248,null)})),extraEditorClassName:Re(new t(38,"extraEditorClassName","")),fastScrollSensitivity:Re(new D(39,"fastScrollSensitivity",5,ue=>ue<=0?5:ue,{markdownDescription:f.localize(249,null)})),find:Re(new T),fixedOverflowWidgets:Re(new o(41,"fixedOverflowWidgets",!1)),folding:Re(new o(42,"folding",!0,{description:f.localize(250,null)})),foldingStrategy:Re(new s(43,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[f.localize(251,null),f.localize(252,null)],description:f.localize(253,null)})),foldingHighlight:Re(new o(44,"foldingHighlight",!0,{description:f.localize(254,null)})),foldingImportsByDefault:Re(new o(45,"foldingImportsByDefault",!1,{description:f.localize(255,null)})),foldingMaximumRegions:Re(new m(46,"foldingMaximumRegions",5e3,10,65e3,{description:f.localize(256,null)})),unfoldOnClickAfterEndOfLine:Re(new o(47,"unfoldOnClickAfterEndOfLine",!1,{description:f.localize(257,null)})),fontFamily:Re(new t(48,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:f.localize(258,null)})),fontInfo:Re(new M),fontLigatures2:Re(new z),fontSize:Re(new Y),fontWeight:Re(new J),fontVariations:Re(new B),formatOnPaste:Re(new o(54,"formatOnPaste",!1,{description:f.localize(259,null)})),formatOnType:Re(new o(55,"formatOnType",!1,{description:f.localize(260,null)})),glyphMargin:Re(new o(56,"glyphMargin",!0,{description:f.localize(261,null)})),gotoLocation:Re(new fe),hideCursorInOverviewRuler:Re(new o(58,"hideCursorInOverviewRuler",!1,{description:f.localize(262,null)})),hover:Re(new se),inDiffEditor:Re(new o(60,"inDiffEditor",!1)),letterSpacing:Re(new D(62,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ue=>D.clamp(ue,-5,20),{description:f.localize(263,null)})),lightbulb:Re(new pe),lineDecorationsWidth:Re(new x),lineHeight:Re(new N),lineNumbers:Re(new ee),lineNumbersMinChars:Re(new m(67,"lineNumbersMinChars",5,1,300)),linkedEditing:Re(new o(68,"linkedEditing",!1,{description:f.localize(264,null)})),links:Re(new o(69,"links",!0,{description:f.localize(265,null)})),matchBrackets:Re(new s(70,"matchBrackets","always",["always","near","never"],{description:f.localize(266,null)})),minimap:Re(new q),mouseStyle:Re(new s(72,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Re(new D(73,"mouseWheelScrollSensitivity",1,ue=>ue===0?1:ue,{markdownDescription:f.localize(267,null)})),mouseWheelZoom:Re(new o(74,"mouseWheelZoom",!1,{markdownDescription:f.localize(268,null)})),multiCursorMergeOverlapping:Re(new o(75,"multiCursorMergeOverlapping",!0,{description:f.localize(269,null)})),multiCursorModifier:Re(new i(76,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],de,{markdownEnumDescriptions:[f.localize(270,null),f.localize(271,null)],markdownDescription:f.localize(272,null)})),multiCursorPaste:Re(new s(77,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[f.localize(273,null),f.localize(274,null)],markdownDescription:f.localize(275,null)})),multiCursorLimit:Re(new m(78,"multiCursorLimit",1e4,1,1e5,{markdownDescription:f.localize(276,null)})),occurrencesHighlight:Re(new o(79,"occurrencesHighlight",!0,{description:f.localize(277,null)})),overviewRulerBorder:Re(new o(80,"overviewRulerBorder",!0,{description:f.localize(278,null)})),overviewRulerLanes:Re(new m(81,"overviewRulerLanes",3,0,3)),padding:Re(new ye),pasteAs:Re(new et),parameterHints:Re(new ve),peekWidgetDefaultFocus:Re(new s(85,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[f.localize(279,null),f.localize(280,null)],description:f.localize(281,null)})),definitionLinkOpensInPeek:Re(new o(86,"definitionLinkOpensInPeek",!1,{description:f.localize(282,null)})),quickSuggestions:Re(new Ee),quickSuggestionsDelay:Re(new m(88,"quickSuggestionsDelay",10,0,1073741824,{description:f.localize(283,null)})),readOnly:Re(new o(89,"readOnly",!1)),readOnlyMessage:Re(new he),renameOnType:Re(new o(91,"renameOnType",!1,{description:f.localize(284,null),markdownDeprecationMessage:f.localize(285,null)})),renderControlCharacters:Re(new o(92,"renderControlCharacters",!0,{description:f.localize(286,null),restricted:!0})),renderFinalNewline:Re(new s(93,"renderFinalNewline",h.$k?"dimmed":"on",["off","on","dimmed"],{description:f.localize(287,null)})),renderLineHighlight:Re(new s(94,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",f.localize(288,null)],description:f.localize(289,null)})),renderLineHighlightOnlyWhenFocus:Re(new o(95,"renderLineHighlightOnlyWhenFocus",!1,{description:f.localize(290,null)})),renderValidationDecorations:Re(new s(96,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Re(new s(97,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",f.localize(291,null),f.localize(292,null),f.localize(293,null),""],description:f.localize(294,null)})),revealHorizontalRightPadding:Re(new m(98,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Re(new o(99,"roundedSelection",!0,{description:f.localize(295,null)})),rulers:Re(new X),scrollbar:Re(new U),scrollBeyondLastColumn:Re(new m(102,"scrollBeyondLastColumn",4,0,1073741824,{description:f.localize(296,null)})),scrollBeyondLastLine:Re(new o(103,"scrollBeyondLastLine",!0,{description:f.localize(297,null)})),scrollPredominantAxis:Re(new o(104,"scrollPredominantAxis",!0,{description:f.localize(298,null)})),selectionClipboard:Re(new o(105,"selectionClipboard",!0,{description:f.localize(299,null),included:h.$k})),selectionHighlight:Re(new o(106,"selectionHighlight",!0,{description:f.localize(300,null)})),selectOnLineNumbers:Re(new o(107,"selectOnLineNumbers",!0)),showFoldingControls:Re(new s(108,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[f.localize(301,null),f.localize(302,null),f.localize(303,null)],description:f.localize(304,null)})),showUnused:Re(new o(109,"showUnused",!0,{description:f.localize(305,null)})),showDeprecated:Re(new o(137,"showDeprecated",!0,{description:f.localize(306,null)})),inlayHints:Re(new ne),snippetSuggestions:Re(new s(110,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[f.localize(307,null),f.localize(308,null),f.localize(309,null),f.localize(310,null)],description:f.localize(311,null)})),smartSelect:Re(new ze),smoothScrolling:Re(new o(112,"smoothScrolling",!1,{description:f.localize(312,null)})),stopRenderingLineAfter:Re(new m(115,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Re(new be),inlineSuggest:Re(new _),inlineCompletionsAccessibilityVerbose:Re(new o(146,"inlineCompletionsAccessibilityVerbose",!1,{description:f.localize(313,null)})),suggestFontSize:Re(new m(117,"suggestFontSize",0,0,1e3,{markdownDescription:f.localize(314,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Re(new m(118,"suggestLineHeight",0,0,1e3,{markdownDescription:f.localize(315,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Re(new o(119,"suggestOnTriggerCharacters",!0,{description:f.localize(316,null)})),suggestSelection:Re(new s(120,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[f.localize(317,null),f.localize(318,null),f.localize(319,null)],description:f.localize(320,null)})),tabCompletion:Re(new s(121,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[f.localize(321,null),f.localize(322,null),f.localize(323,null)],description:f.localize(324,null)})),tabIndex:Re(new m(122,"tabIndex",0,-1,1073741824)),unicodeHighlight:Re(new Q),unusualLineTerminators:Re(new s(124,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[f.localize(325,null),f.localize(326,null),f.localize(327,null)],description:f.localize(328,null)})),useShadowDOM:Re(new o(125,"useShadowDOM",!0)),useTabStops:Re(new o(126,"useTabStops",!0,{description:f.localize(329,null)})),wordBreak:Re(new s(127,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[f.localize(330,null),f.localize(331,null)],description:f.localize(332,null)})),wordSeparators:Re(new t(128,"wordSeparators",A.$Mr,{description:f.localize(333,null)})),wordWrap:Re(new s(129,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[f.localize(334,null),f.localize(335,null),f.localize(336,null),f.localize(337,null)],description:f.localize(338,null)})),wordWrapBreakAfterCharacters:Re(new t(130,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Re(new t(131,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Re(new m(132,"wordWrapColumn",80,1,1073741824,{markdownDescription:f.localize(339,null)})),wordWrapOverride1:Re(new s(133,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Re(new s(134,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Re(new O),defaultColorDecorators:Re(new o(144,"defaultColorDecorators",!1,{markdownDescription:f.localize(340,null)})),pixelRatio:Re(new we),tabFocusMode:Re(new o(141,"tabFocusMode",!1,{markdownDescription:f.localize(341,null)})),layoutInfo:Re(new V),wrappingInfo:Re(new Ze),wrappingIndent:Re(new _e),wrappingStrategy:Re(new re)}}),define(Se[183],De([11,12]),function(me,e){return me.create("vs/editor/common/languages",e)}),define(Se[81],De([1,0,76,2,161,34,171,183]),function(me,e,S,F,h,L,A,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$Cs=e.$Bs=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$As=e.$zs=e.SymbolKinds=e.SymbolTag=e.$ys=e.$xs=e.SymbolKind=e.$ws=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$vs=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$us=e.$ts=e.$ss=void 0;class w{constructor(z,B,M){this.offset=z,this.type=B,this.language=M,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$ss=w;class g{constructor(z,B){this.tokens=z,this.endState=B,this._tokenizationResultBrand=void 0}}e.$ts=g;class P{constructor(z,B){this.tokens=z,this.endState=B,this._encodedTokenizationResultBrand=void 0}}e.$us=P;var I;(function(T){T[T.Method=0]="Method",T[T.Function=1]="Function",T[T.Constructor=2]="Constructor",T[T.Field=3]="Field",T[T.Variable=4]="Variable",T[T.Class=5]="Class",T[T.Struct=6]="Struct",T[T.Interface=7]="Interface",T[T.Module=8]="Module",T[T.Property=9]="Property",T[T.Event=10]="Event",T[T.Operator=11]="Operator",T[T.Unit=12]="Unit",T[T.Value=13]="Value",T[T.Constant=14]="Constant",T[T.Enum=15]="Enum",T[T.EnumMember=16]="EnumMember",T[T.Keyword=17]="Keyword",T[T.Text=18]="Text",T[T.Color=19]="Color",T[T.File=20]="File",T[T.Reference=21]="Reference",T[T.Customcolor=22]="Customcolor",T[T.Folder=23]="Folder",T[T.TypeParameter=24]="TypeParameter",T[T.User=25]="User",T[T.Issue=26]="Issue",T[T.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var $;(function(T){const z=new Map;z.set(0,S.$Cj.symbolMethod),z.set(1,S.$Cj.symbolFunction),z.set(2,S.$Cj.symbolConstructor),z.set(3,S.$Cj.symbolField),z.set(4,S.$Cj.symbolVariable),z.set(5,S.$Cj.symbolClass),z.set(6,S.$Cj.symbolStruct),z.set(7,S.$Cj.symbolInterface),z.set(8,S.$Cj.symbolModule),z.set(9,S.$Cj.symbolProperty),z.set(10,S.$Cj.symbolEvent),z.set(11,S.$Cj.symbolOperator),z.set(12,S.$Cj.symbolUnit),z.set(13,S.$Cj.symbolValue),z.set(15,S.$Cj.symbolEnum),z.set(14,S.$Cj.symbolConstant),z.set(15,S.$Cj.symbolEnum),z.set(16,S.$Cj.symbolEnumMember),z.set(17,S.$Cj.symbolKeyword),z.set(27,S.$Cj.symbolSnippet),z.set(18,S.$Cj.symbolText),z.set(19,S.$Cj.symbolColor),z.set(20,S.$Cj.symbolFile),z.set(21,S.$Cj.symbolReference),z.set(22,S.$Cj.symbolCustomColor),z.set(23,S.$Cj.symbolFolder),z.set(24,S.$Cj.symbolTypeParameter),z.set(25,S.$Cj.account),z.set(26,S.$Cj.issues);function B(J){let fe=z.get(J);return fe||(console.info("No codicon found for CompletionItemKind "+J),fe=S.$Cj.symbolProperty),fe}T.toIcon=B;const M=new Map;M.set("method",0),M.set("function",1),M.set("constructor",2),M.set("field",3),M.set("variable",4),M.set("class",5),M.set("struct",6),M.set("interface",7),M.set("module",8),M.set("property",9),M.set("event",10),M.set("operator",11),M.set("unit",12),M.set("value",13),M.set("constant",14),M.set("enum",15),M.set("enum-member",16),M.set("enumMember",16),M.set("keyword",17),M.set("snippet",27),M.set("text",18),M.set("color",19),M.set("file",20),M.set("reference",21),M.set("customcolor",22),M.set("folder",23),M.set("type-parameter",24),M.set("typeParameter",24),M.set("account",25),M.set("issue",26);function Y(J,fe){let se=M.get(J);return typeof se>"u"&&!fe&&(se=9),se}T.fromString=Y})($||(e.CompletionItemKinds=$={}));var k;(function(T){T[T.Deprecated=1]="Deprecated"})(k||(e.CompletionItemTag=k={}));var C;(function(T){T[T.None=0]="None",T[T.KeepWhitespace=1]="KeepWhitespace",T[T.InsertAsSnippet=4]="InsertAsSnippet"})(C||(e.CompletionItemInsertTextRule=C={}));var E;(function(T){T[T.Invoke=0]="Invoke",T[T.TriggerCharacter=1]="TriggerCharacter",T[T.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(E||(e.CompletionTriggerKind=E={}));var n;(function(T){T[T.Automatic=0]="Automatic",T[T.Explicit=1]="Explicit"})(n||(e.InlineCompletionTriggerKind=n={}));class o{constructor(z,B,M,Y){this.range=z,this.text=B,this.completionKind=M,this.isSnippetText=Y}equals(z){return L.$Ur.lift(this.range).equalsRange(z.range)&&this.text===z.text&&this.completionKind===z.completionKind&&this.isSnippetText===z.isSnippetText}}e.$vs=o;var a;(function(T){T[T.Invoke=1]="Invoke",T[T.Auto=2]="Auto"})(a||(e.CodeActionTriggerType=a={}));var m;(function(T){T[T.Invoke=1]="Invoke",T[T.TriggerCharacter=2]="TriggerCharacter",T[T.ContentChange=3]="ContentChange"})(m||(e.SignatureHelpTriggerKind=m={}));var v;(function(T){T[T.Text=0]="Text",T[T.Read=1]="Read",T[T.Write=2]="Write"})(v||(e.DocumentHighlightKind=v={}));function D(T){return T&&F.URI.isUri(T.uri)&&L.$Ur.isIRange(T.range)&&(L.$Ur.isIRange(T.originSelectionRange)||L.$Ur.isIRange(T.targetSelectionRange))}e.$ws=D;var t;(function(T){T[T.File=0]="File",T[T.Module=1]="Module",T[T.Namespace=2]="Namespace",T[T.Package=3]="Package",T[T.Class=4]="Class",T[T.Method=5]="Method",T[T.Property=6]="Property",T[T.Field=7]="Field",T[T.Constructor=8]="Constructor",T[T.Enum=9]="Enum",T[T.Interface=10]="Interface",T[T.Function=11]="Function",T[T.Variable=12]="Variable",T[T.Constant=13]="Constant",T[T.String=14]="String",T[T.Number=15]="Number",T[T.Boolean=16]="Boolean",T[T.Array=17]="Array",T[T.Object=18]="Object",T[T.Key=19]="Key",T[T.Null=20]="Null",T[T.EnumMember=21]="EnumMember",T[T.Struct=22]="Struct",T[T.Event=23]="Event",T[T.Operator=24]="Operator",T[T.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$xs={[17]:(0,f.localize)(0,null),[16]:(0,f.localize)(1,null),[4]:(0,f.localize)(2,null),[13]:(0,f.localize)(3,null),[8]:(0,f.localize)(4,null),[9]:(0,f.localize)(5,null),[21]:(0,f.localize)(6,null),[23]:(0,f.localize)(7,null),[7]:(0,f.localize)(8,null),[0]:(0,f.localize)(9,null),[11]:(0,f.localize)(10,null),[10]:(0,f.localize)(11,null),[19]:(0,f.localize)(12,null),[5]:(0,f.localize)(13,null),[1]:(0,f.localize)(14,null),[2]:(0,f.localize)(15,null),[20]:(0,f.localize)(16,null),[15]:(0,f.localize)(17,null),[18]:(0,f.localize)(18,null),[24]:(0,f.localize)(19,null),[3]:(0,f.localize)(20,null),[6]:(0,f.localize)(21,null),[14]:(0,f.localize)(22,null),[22]:(0,f.localize)(23,null),[25]:(0,f.localize)(24,null),[12]:(0,f.localize)(25,null)};function r(T,z){return(0,f.localize)(26,null,T,e.$xs[z])}e.$ys=r;var s;(function(T){T[T.Deprecated=1]="Deprecated"})(s||(e.SymbolTag=s={}));var i;(function(T){const z=new Map;z.set(0,S.$Cj.symbolFile),z.set(1,S.$Cj.symbolModule),z.set(2,S.$Cj.symbolNamespace),z.set(3,S.$Cj.symbolPackage),z.set(4,S.$Cj.symbolClass),z.set(5,S.$Cj.symbolMethod),z.set(6,S.$Cj.symbolProperty),z.set(7,S.$Cj.symbolField),z.set(8,S.$Cj.symbolConstructor),z.set(9,S.$Cj.symbolEnum),z.set(10,S.$Cj.symbolInterface),z.set(11,S.$Cj.symbolFunction),z.set(12,S.$Cj.symbolVariable),z.set(13,S.$Cj.symbolConstant),z.set(14,S.$Cj.symbolString),z.set(15,S.$Cj.symbolNumber),z.set(16,S.$Cj.symbolBoolean),z.set(17,S.$Cj.symbolArray),z.set(18,S.$Cj.symbolObject),z.set(19,S.$Cj.symbolKey),z.set(20,S.$Cj.symbolNull),z.set(21,S.$Cj.symbolEnumMember),z.set(22,S.$Cj.symbolStruct),z.set(23,S.$Cj.symbolEvent),z.set(24,S.$Cj.symbolOperator),z.set(25,S.$Cj.symbolTypeParameter);function B(M){let Y=z.get(M);return Y||(console.info("No codicon found for SymbolKind "+M),Y=S.$Cj.symbolProperty),Y}T.toIcon=B})(i||(e.SymbolKinds=i={}));class c{static asEditOperation(z){return h.$2r.replace(L.$Ur.lift(z.range),z.text)}}e.$zs=c;class l{static{this.Comment=new l("comment")}static{this.Imports=new l("imports")}static{this.Region=new l("region")}static fromValue(z){switch(z){case"comment":return l.Comment;case"imports":return l.Imports;case"region":return l.Region}return new l(z)}constructor(z){this.value=z}}e.$As=l;var b;(function(T){function z(B){return!B||typeof B!="object"?!1:typeof B.id=="string"&&typeof B.title=="string"}T.is=z})(b||(e.Command=b={}));var y;(function(T){T[T.Collapsed=0]="Collapsed",T[T.Expanded=1]="Expanded"})(y||(e.CommentThreadCollapsibleState=y={}));var u;(function(T){T[T.Unresolved=0]="Unresolved",T[T.Resolved=1]="Resolved"})(u||(e.CommentThreadState=u={}));var d;(function(T){T[T.Editing=0]="Editing",T[T.Preview=1]="Preview"})(d||(e.CommentMode=d={}));var p;(function(T){T[T.Published=0]="Published",T[T.Draft=1]="Draft"})(p||(e.CommentState=p={}));var R;(function(T){T[T.Type=1]="Type",T[T.Parameter=2]="Parameter"})(R||(e.InlayHintKind=R={}));class O{constructor(z){this.b=z,this.a=null}dispose(){this.a&&this.a.then(z=>{z&&z.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Bs=O,e.$Cs=new A.$ks;var j;(function(T){T[T.None=0]="None",T[T.Option=1]="Option",T[T.Default=2]="Default",T[T.Preferred=3]="Preferred"})(j||(e.ExternalUriOpenerPriority=j={}))}),define(Se[184],De([11,12]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[185],De([11,12]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[186],De([11,12]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(Se[187],De([11,12]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[188],De([11,12]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[189],De([11,12]),function(me,e){return me.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[190],De([11,12]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(Se[191],De([11,12]),function(me,e){return me.create("vs/platform/files/common/io",e)}),define(Se[192],De([11,12]),function(me,e){return me.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Se[193],De([11,12]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(Se[194],De([11,12]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[195],De([11,12]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(Se[196],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostChat",e)}),define(Se[197],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[198],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[199],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[200],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[201],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[202],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostProgress",e)}),define(Se[203],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[204],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[205],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[206],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[207],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[208],De([11,12]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[209],De([11,12]),function(me,e){return me.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[210],De([11,12]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(Se[211],De([11,12]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(Se[212],De([11,12]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[213],De([11,12]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[214],De([11,12]),function(me,e){return me.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[215],De([11,12]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[216],De([11,12]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[217],De([11,12]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[218],De([11,12]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[219],De([11,12]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[220],De([1,0,8,186]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.TokenType=void 0;var h;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(h||(e.TokenType=h={}));function L(...g){switch(g.length){case 1:return(0,F.localize)(0,null,g[0]);case 2:return(0,F.localize)(1,null,g[0],g[1]);case 3:return(0,F.localize)(2,null,g[0],g[1],g[2]);default:return}}const A=(0,F.localize)(3,null),f=(0,F.localize)(4,null);class w{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,S.$6)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const I=this.d,$=this.c.substring(this.d,this.e),k={type:19,offset:this.d,lexeme:$};this.g.push({offset:I,lexeme:$,additionalInfo:P}),this.f.push(k)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const I=this.c.substring(this.d,this.e),$=w.b.get(I);$?this.k($):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,I=!1,$=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(f);return}const C=this.c.charCodeAt(P);if(I)I=!1;else if(C===47&&!$){P++;break}else C===91?$=!0:C===92?I=!0:C===93&&($=!1);P++}for(;P<this.c.length&&w.a.has(this.c.charCodeAt(P));)P++;this.e=P;const k=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:k,offset:this.d})}r(){return this.e>=this.c.length}}e.$si=w}),define(Se[221],De([1,0,24,40,188,361]),function(me,e,S,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,f=/^-(\d{4})(\d{2})(\d{2})$/;function w(o){return o=o.trim(),o==="*"||A.test(o)}e.$to=w;function g(o){if(!w(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const a=o.match(A);return a?{hasCaret:a[1]==="^",hasGreaterEquals:a[1]===">=",majorBase:a[2]==="x"?0:parseInt(a[2],10),majorMustEqual:a[2]!=="x",minorBase:a[4]==="x"?0:parseInt(a[4],10),minorMustEqual:a[4]!=="x",patchBase:a[6]==="x"?0:parseInt(a[6],10),patchMustEqual:a[6]!=="x",preRelease:a[8]||null}:null}e.$uo=g;function P(o){if(!o)return null;const a=o.majorBase,m=o.majorMustEqual,v=o.minorBase;let D=o.minorMustEqual;const t=o.patchBase;let r=o.patchMustEqual;o.hasCaret&&(a===0||(D=!1),r=!1);let s=0;if(o.preRelease){const i=f.exec(o.preRelease);if(i){const[,c,l,b]=i;s=Date.UTC(Number(c),Number(l)-1,Number(b))}}return{majorBase:a,majorMustEqual:m,minorBase:v,minorMustEqual:D,patchBase:t,patchMustEqual:r,isMinimum:o.hasGreaterEquals,notBefore:s}}e.$vo=P;function I(o,a,m){let v;typeof o=="string"?v=P(g(o)):v=o;let D;a instanceof Date?D=a.getTime():typeof a=="string"&&(D=new Date(a).getTime());let t;if(typeof m=="string"?t=P(g(m)):t=m,!v||!t)return!1;const r=v.majorBase,s=v.minorBase,i=v.patchBase;let c=t.majorBase,l=t.minorBase,b=t.patchBase;const y=t.notBefore;let u=t.majorMustEqual,d=t.minorMustEqual,p=t.patchMustEqual;return t.isMinimum?r>c?!0:r<c?!1:s>l?!0:s<l||D&&D<y?!1:i>=b:(r===1&&c===0&&(!u||!d||!p)&&(c=1,l=0,b=0,u=!0,d=!1,p=!1),r<c?!1:r>c?!u:s<l?!1:s>l?!d:i<b?!1:i>b?!p:!(D&&D<y))}e.$wo=I;function $(o,a,m,v,D){const t=[];if(typeof v.publisher<"u"&&typeof v.publisher!="string")return t.push([F.default.Error,h.localize(0,null)]),t;if(typeof v.name!="string")return t.push([F.default.Error,h.localize(1,null,"name")]),t;if(typeof v.version!="string")return t.push([F.default.Error,h.localize(2,null,"version")]),t;if(!v.engines)return t.push([F.default.Error,h.localize(3,null,"engines")]),t;if(typeof v.engines.vscode!="string")return t.push([F.default.Error,h.localize(4,null,"engines.vscode")]),t;if(typeof v.extensionDependencies<"u"&&!n(v.extensionDependencies))return t.push([F.default.Error,h.localize(5,null,"extensionDependencies")]),t;if(typeof v.activationEvents<"u"){if(!n(v.activationEvents))return t.push([F.default.Error,h.localize(6,null,"activationEvents")]),t;if(typeof v.main>"u"&&typeof v.browser>"u")return t.push([F.default.Error,h.localize(7,null,"activationEvents","main","browser")]),t}if(typeof v.extensionKind<"u"&&typeof v.main>"u"&&t.push([F.default.Warning,h.localize(8,null,"extensionKind")]),typeof v.main<"u"){if(typeof v.main!="string")return t.push([F.default.Error,h.localize(9,null,"main")]),t;{const i=(0,S.$9f)(m,v.main);(0,S.$3f)(i,m)||t.push([F.default.Warning,h.localize(10,null,i.path,m.path)])}}if(typeof v.browser<"u"){if(typeof v.browser!="string")return t.push([F.default.Error,h.localize(11,null,"browser")]),t;{const i=(0,S.$9f)(m,v.browser);(0,S.$3f)(i,m)||t.push([F.default.Warning,h.localize(12,null,i.path,m.path)])}}if(!L.valid(v.version))return t.push([F.default.Error,h.localize(13,null)]),t;const r=[];if(!k(o,a,v,D,r))for(const i of r)t.push([F.default.Error,i]);return t}e.$xo=$;function k(o,a,m,v,D){return v||typeof m.main>"u"&&typeof m.browser>"u"?!0:E(o,a,m.engines.vscode,D)}e.$yo=k;function C(o,a,m){return o==="*"||E(a,m,o)}e.$zo=C;function E(o,a,m,v=[]){const D=P(g(m));if(!D)return v.push(h.localize(14,null,m)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return v.push(h.localize(15,null,m)),!1}else if(!D.majorMustEqual)return v.push(h.localize(16,null,m)),!1;return I(o,a,D)?!0:(v.push(h.localize(17,null,o,m)),!1)}function n(o){if(!Array.isArray(o))return!1;for(let a=0,m=o.length;a<m;a++)if(typeof o[a]!="string")return!1;return!0}}),define(Se[101],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=void 0;class S{constructor(h,L=[],A=!1){this.ctor=h,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.$mh=S}),define(Se[102],De([1,0,101]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=e.InstantiationType=void 0;const F=[];var h;(function(f){f[f.Eager=0]="Eager",f[f.Delayed=1]="Delayed"})(h||(e.InstantiationType=h={}));function L(f,w,g){w instanceof S.$mh||(w=new S.$mh(w,[],!!g)),F.push([f,w])}e.$dr=L;function A(){return F}e.$er=A}),define(Se[222],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=void 0;class S{constructor(L,A){this.key=L,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Up=S;class F{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const A of this.a.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const f=this.lookupOrInsertNode(L),w=this.lookupOrInsertNode(A);f.outgoing.set(w.key,w),w.incoming.set(f.key,f)}removeNode(L){const A=this.b(L);this.a.delete(A);for(const f of this.a.values())f.outgoing.delete(A),f.incoming.delete(A)}lookupOrInsertNode(L){const A=this.b(L);let f=this.a.get(A);return f||(f=new S(A,L),this.a.set(A,f)),f}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[A,f]of this.a)L.push(`${A}
	(-> incoming)[${[...f.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...f.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this.a){const f=new Set([L]),w=this.c(A,f);if(w)return w}}c(L,A){for(const[f,w]of L.outgoing){if(A.has(f))return[...A,f].join(" -> ");A.add(f);const g=this.c(w,A);if(g)return g;A.delete(f)}}}e.$Vp=F}),define(Se[6],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qh=e.$ph=e.$oh=e._util=void 0;var S;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function f(w){return w[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=f})(S||(e._util=S={})),e.$oh=h("instantiationService");function F(A,f,w){f[S.DI_TARGET]===f?f[S.DI_DEPENDENCIES].push({id:A,index:w}):(f[S.DI_DEPENDENCIES]=[{id:A,index:w}],f[S.DI_TARGET]=f)}function h(A){if(S.serviceIds.has(A))return S.serviceIds.get(A);const f=function(w,g,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(f,w,P)};return f.toString=()=>A,S.serviceIds.set(A,f),f}e.$ph=h;function L(A){return A}e.$qh=L}),define(Se[50],De([1,0,19,2,6]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.ConfigurationTarget=e.$Xh=e.$Wh=e.$Vh=void 0,e.$Vh=(0,h.$ph)("configurationService");function L(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof F.URI)}e.$Wh=L;function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof F.URI)}e.$Xh=A;var f;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(f||(e.ConfigurationTarget=f={}));function w(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Yh=w;function g(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.$Zh=g;function P(o,a){const m=Object.create(null);for(const v in o)I(m,v,o[v],a);return m}e.$1h=P;function I(o,a,m,v){const D=a.split("."),t=D.pop();let r=o;for(let s=0;s<D.length;s++){const i=D[s];let c=r[i];switch(typeof c){case"undefined":c=r[i]=Object.create(null);break;case"object":break;default:v(`Ignoring ${a} as ${D.slice(0,s+1).join(".")} is ${JSON.stringify(c)}`);return}r=c}if(typeof r=="object"&&r!==null)try{r[t]=m}catch{v(`Ignoring ${a} as ${D.join(".")} is ${JSON.stringify(r)}`)}else v(`Ignoring ${a} as ${D.join(".")} is ${JSON.stringify(r)}`)}e.$2h=I;function $(o,a){const m=a.split(".");k(o,m)}e.$3h=$;function k(o,a){const m=a.shift();if(a.length===0){delete o[m];return}if(Object.keys(o).indexOf(m)!==-1){const v=o[m];typeof v=="object"&&!Array.isArray(v)&&(k(v,a),Object.keys(v).length===0&&delete o[m])}}function C(o,a,m){function v(r,s){let i=r;for(const c of s){if(typeof i!="object"||i===null)return;i=i[c]}return i}const D=a.split("."),t=v(o,D);return typeof t>"u"?m:t}e.$4h=C;function E(o,a,m){Object.keys(a).forEach(v=>{v!=="__proto__"&&(v in o?S.$ke(o[v])&&S.$ke(a[v])?E(o[v],a[v],m):m&&(o[v]=a[v]):o[v]=a[v])})}e.$5h=E;function n(o){return o.replace(/[\[\]]/g,"")}e.$6h=n}),define(Se[47],De([1,0,9,15,220,6,185,8]),function(me,e,S,F,h,L,A,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.ContextKeyExprType=e.$ti=void 0;const w=new Map;w.set("false",!1),w.set("true",!0),w.set("isMac",S.$j),w.set("isLinux",S.$k),w.set("isWindows",S.$i),w.set("isWeb",S.$o),w.set("isMacNative",S.$j&&!S.$o),w.set("isEdge",S.$G),w.set("isFirefox",S.$E),w.set("isChrome",S.$D),w.set("isSafari",S.$F);function g(x,N){if(w.get(x)!==void 0)throw(0,f.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");w.set(x,N)}e.$ti=g;const P=Object.prototype.hasOwnProperty;var I;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const $={regexParsingWithErrorRecovery:!0},k=(0,A.localize)(0,null),C=(0,A.localize)(1,null),E=(0,A.localize)(2,null),n=(0,A.localize)(3,null),o=(0,A.localize)(4,null),a=(0,A.localize)(5,null),m=(0,A.localize)(6,null),v=(0,A.localize)(7,null);class D{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(N=$){this.k=N,this.d=new h.$si,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(N){if(N===""){this.h.push({message:k,offset:0,lexeme:"",additionalInfo:C});return}this.f=this.d.reset(N).scan(),this.g=0,this.h=[];try{const q=this.l();if(!this.E()){const de=this.D(),ye=de.type===17?a:void 0;throw this.h.push({message:o,offset:de.offset,lexeme:h.$si.getLexeme(de),additionalInfo:ye}),D.c}return q}catch(q){if(q!==D.c)throw q;return}}l(){return this.m()}m(){const N=[this.o()];for(;this.y(16);){const q=this.o();N.push(q)}return N.length===1?N[0]:t.or(...N)}o(){const N=[this.s()];for(;this.y(15);){const q=this.s();N.push(q)}return N.length===1?N[0]:t.and(...N)}s(){if(this.y(2)){const N=this.D();switch(N.type){case 11:return this.z(),c.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const q=this.l();return this.A(1,n),q?.negate()}case 17:return this.z(),R.create(N.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",N)}}return this.t()}t(){const N=this.D();switch(N.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const q=this.l();return this.A(1,n),q}case 17:{const q=N.lexeme;if(this.z(),this.y(9)){const ye=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ye.type!==10)throw this.B("REGEX",ye);const ve=ye.lexeme,we=ve.lastIndexOf("/"),Ee=we===ve.length-1?void 0:this.w(ve.substring(we+1));let K;try{K=new RegExp(ve.substring(1,we),Ee)}catch{throw this.B("REGEX",ye)}return M.create(q,K)}switch(ye.type){case 10:case 19:{const ve=[ye.lexeme];this.z();let we=this.D(),Ee=0;for(let he=0;he<ye.lexeme.length;he++)ye.lexeme.charCodeAt(he)===40?Ee++:ye.lexeme.charCodeAt(he)===41&&Ee--;for(;!this.E()&&we.type!==15&&we.type!==16;){switch(we.type){case 0:Ee++;break;case 1:Ee--;break;case 10:case 18:for(let he=0;he<we.lexeme.length;he++)we.lexeme.charCodeAt(he)===40?Ee++:ye.lexeme.charCodeAt(he)===41&&Ee--}if(Ee<0)break;ve.push(h.$si.getLexeme(we)),this.z(),we=this.D()}const K=ve.join(""),ee=K.lastIndexOf("/"),G=ee===K.length-1?void 0:this.w(K.substring(ee+1));let X;try{X=new RegExp(K.substring(1,ee),G)}catch{throw this.B("REGEX",ye)}return t.regex(q,X)}case 18:{const ve=ye.lexeme;this.z();let we=null;if(!(0,F.$ld)(ve)){const Ee=ve.indexOf("/"),K=ve.lastIndexOf("/");if(Ee!==K&&Ee>=0){const ee=ve.slice(Ee+1,K),G=ve[K+1]==="i"?"i":"";try{we=new RegExp(ee,G)}catch{throw this.B("REGEX",ye)}}}if(we===null)throw this.B("REGEX",ye);return M.create(q,we)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,E);const ye=this.u();return t.notIn(q,ye)}switch(this.D().type){case 3:{this.z();const ye=this.u();if(this.x().type===18)return t.equals(q,ye);switch(ye){case"true":return t.has(q);case"false":return t.not(q);default:return t.equals(q,ye)}}case 4:{this.z();const ye=this.u();if(this.x().type===18)return t.notEquals(q,ye);switch(ye){case"true":return t.not(q);case"false":return t.has(q);default:return t.notEquals(q,ye)}}case 5:return this.z(),z.create(q,this.u());case 6:return this.z(),B.create(q,this.u());case 7:return this.z(),j.create(q,this.u());case 8:return this.z(),T.create(q,this.u());case 13:return this.z(),t.in(q,this.u());default:return t.has(q)}}case 20:throw this.h.push({message:m,offset:N.offset,lexeme:"",additionalInfo:v}),D.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const N=this.D();switch(N.type){case 17:case 18:return this.z(),N.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(N){return N.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(N){return this.C(N)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(N,q){if(this.C(N))return this.z();throw this.B(q,this.D())}B(N,q,de){const ye=(0,A.localize)(8,null,N,h.$si.getLexeme(q)),ve=q.offset,we=h.$si.getLexeme(q);return this.h.push({message:ye,offset:ve,lexeme:we,additionalInfo:de}),D.c}C(N){return this.D().type===N}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$ui=D;class t{static false(){return c.INSTANCE}static true(){return l.INSTANCE}static has(N){return b.create(N)}static equals(N,q){return y.create(N,q)}static notEquals(N,q){return p.create(N,q)}static regex(N,q){return M.create(N,q)}static in(N,q){return u.create(N,q)}static notIn(N,q){return d.create(N,q)}static not(N){return R.create(N)}static and(...N){return fe.create(N,null,!0)}static or(...N){return se.create(N,null,!0)}static greater(N,q){return j.create(N,q)}static greaterEquals(N,q){return T.create(N,q)}static smaller(N,q){return z.create(N,q)}static smallerEquals(N,q){return B.create(N,q)}static{this.c=new D({regexParsingWithErrorRecovery:!1})}static deserialize(N){return N==null?void 0:this.c.parse(N)}}e.$vi=t;function r(x){const N=new D({regexParsingWithErrorRecovery:!1});return x.map(q=>(N.parse(q),N.lexingErrors.length>0?N.lexingErrors.map(de=>({errorMessage:de.additionalInfo?(0,A.localize)(9,null,de.additionalInfo):(0,A.localize)(10,null),offset:de.offset,length:de.lexeme.length})):N.parsingErrors.length>0?N.parsingErrors.map(de=>({errorMessage:de.additionalInfo?`${de.message}. ${de.additionalInfo}`:de.message,offset:de.offset,length:de.lexeme.length})):[]))}e.$wi=r;function s(x,N){const q=x?x.substituteConstants():void 0,de=N?N.substituteConstants():void 0;return!q&&!de?!0:!q||!de?!1:q.equals(de)}e.$xi=s;function i(x,N){return x.cmp(N)}class c{static{this.INSTANCE=new c}constructor(){this.type=0}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!1}serialize(){return"false"}keys(){return[]}map(N){return this}negate(){return l.INSTANCE}}e.$yi=c;class l{static{this.INSTANCE=new l}constructor(){this.type=1}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!0}serialize(){return"true"}keys(){return[]}map(N){return this}negate(){return c.INSTANCE}}e.$zi=l;class b{static create(N,q=null){const de=w.get(N);return typeof de=="boolean"?de?l.INSTANCE:c.INSTANCE:new b(N,q)}constructor(N,q){this.key=N,this.c=q,this.type=2}cmp(N){return N.type!==this.type?this.type-N.type:V(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=w.get(this.key);return typeof N=="boolean"?N?l.INSTANCE:c.INSTANCE:this}evaluate(N){return!!N.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(N){return N.mapDefined(this.key)}negate(){return this.c||(this.c=R.create(this.key,this)),this.c}}e.$Ai=b;class y{static create(N,q,de=null){if(typeof q=="boolean")return q?b.create(N,de):R.create(N,de);const ye=w.get(N);return typeof ye=="boolean"?q===(ye?"true":"false")?l.INSTANCE:c.INSTANCE:new y(N,q,de)}constructor(N,q,de){this.c=N,this.d=q,this.f=de,this.type=4}cmp(N){return N.type!==this.type?this.type-N.type:re(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=w.get(this.c);if(typeof N=="boolean"){const q=N?"true":"false";return this.d===q?l.INSTANCE:c.INSTANCE}return this}evaluate(N){return N.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(N){return N.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.$Bi=y;class u{static create(N,q){return new u(N,q)}constructor(N,q){this.d=N,this.f=q,this.type=10,this.c=null}cmp(N){return N.type!==this.type?this.type-N.type:re(this.d,this.f,N.d,N.f)}equals(N){return N.type===this.type?this.d===N.d&&this.f===N.f:!1}substituteConstants(){return this}evaluate(N){const q=N.getValue(this.f),de=N.getValue(this.d);return Array.isArray(q)?q.includes(de):typeof de=="string"&&typeof q=="object"&&q!==null?P.call(q,de):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(N){return N.mapIn(this.d,this.f)}negate(){return this.c||(this.c=d.create(this.d,this.f)),this.c}}e.$Ci=u;class d{static create(N,q){return new d(N,q)}constructor(N,q){this.d=N,this.f=q,this.type=11,this.c=u.create(N,q)}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(N){return N.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Di=d;class p{static create(N,q,de=null){if(typeof q=="boolean")return q?R.create(N,de):b.create(N,de);const ye=w.get(N);return typeof ye=="boolean"?q===(ye?"true":"false")?c.INSTANCE:l.INSTANCE:new p(N,q,de)}constructor(N,q,de){this.c=N,this.d=q,this.f=de,this.type=5}cmp(N){return N.type!==this.type?this.type-N.type:re(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=w.get(this.c);if(typeof N=="boolean"){const q=N?"true":"false";return this.d===q?c.INSTANCE:l.INSTANCE}return this}evaluate(N){return N.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(N){return N.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Ei=p;class R{static create(N,q=null){const de=w.get(N);return typeof de=="boolean"?de?c.INSTANCE:l.INSTANCE:new R(N,q)}constructor(N,q){this.c=N,this.d=q,this.type=3}cmp(N){return N.type!==this.type?this.type-N.type:V(this.c,N.c)}equals(N){return N.type===this.type?this.c===N.c:!1}substituteConstants(){const N=w.get(this.c);return typeof N=="boolean"?N?c.INSTANCE:l.INSTANCE:this}evaluate(N){return!N.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(N){return N.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$Fi=R;function O(x,N){if(typeof x=="string"){const q=parseFloat(x);isNaN(q)||(x=q)}return typeof x=="string"||typeof x=="number"?N(x):c.INSTANCE}class j{static create(N,q,de=null){return O(q,ye=>new j(N,ye,de))}constructor(N,q,de){this.c=N,this.d=q,this.f=de,this.type=12}cmp(N){return N.type!==this.type?this.type-N.type:re(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Gi=j;class T{static create(N,q,de=null){return O(q,ye=>new T(N,ye,de))}constructor(N,q,de){this.c=N,this.d=q,this.f=de,this.type=13}cmp(N){return N.type!==this.type?this.type-N.type:re(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Hi=T;class z{static create(N,q,de=null){return O(q,ye=>new z(N,ye,de))}constructor(N,q,de){this.c=N,this.d=q,this.f=de,this.type=14}cmp(N){return N.type!==this.type?this.type-N.type:re(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Ii=z;class B{static create(N,q,de=null){return O(q,ye=>new B(N,ye,de))}constructor(N,q,de){this.c=N,this.d=q,this.f=de,this.type=15}cmp(N){return N.type!==this.type?this.type-N.type:re(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Ji=B;class M{static create(N,q){return new M(N,q)}constructor(N,q){this.d=N,this.f=q,this.type=7,this.c=null}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.d<N.d)return-1;if(this.d>N.d)return 1;const q=this.f?this.f.source:"",de=N.f?N.f.source:"";return q<de?-1:q>de?1:0}equals(N){if(N.type===this.type){const q=this.f?this.f.source:"",de=N.f?N.f.source:"";return this.d===N.d&&q===de}return!1}substituteConstants(){return this}evaluate(N){const q=N.getValue(this.d);return this.f?this.f.test(q):!1}serialize(){const N=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${N}`}keys(){return[this.d]}map(N){return N.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Y.create(this)),this.c}}e.$Ki=M;class Y{static create(N){return new Y(N)}constructor(N){this.c=N,this.type=8}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(N){return new Y(this.c.map(N))}negate(){return this.c}}e.$Li=Y;function J(x){let N=null;for(let q=0,de=x.length;q<de;q++){const ye=x[q].substituteConstants();if(x[q]!==ye&&N===null){N=[];for(let ve=0;ve<q;ve++)N[ve]=x[ve]}N!==null&&(N[q]=ye)}return N===null?x:N}class fe{static create(N,q,de){return fe.d(N,q,de)}constructor(N,q){this.expr=N,this.c=q,this.type=6}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let q=0,de=this.expr.length;q<de;q++){const ye=i(this.expr[q],N.expr[q]);if(ye!==0)return ye}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let q=0,de=this.expr.length;q<de;q++)if(!this.expr[q].equals(N.expr[q]))return!1;return!0}return!1}substituteConstants(){const N=J(this.expr);return N===this.expr?this:fe.create(N,this.c,!1)}evaluate(N){for(let q=0,de=this.expr.length;q<de;q++)if(!this.expr[q].evaluate(N))return!1;return!0}static d(N,q,de){const ye=[];let ve=!1;for(const we of N)if(we){if(we.type===1){ve=!0;continue}if(we.type===0)return c.INSTANCE;if(we.type===6){ye.push(...we.expr);continue}ye.push(we)}if(ye.length===0&&ve)return l.INSTANCE;if(ye.length!==0){if(ye.length===1)return ye[0];ye.sort(i);for(let we=1;we<ye.length;we++)ye[we-1].equals(ye[we])&&(ye.splice(we,1),we--);if(ye.length===1)return ye[0];for(;ye.length>1;){const we=ye[ye.length-1];if(we.type!==9)break;ye.pop();const Ee=ye.pop(),K=ye.length===0,ee=se.create(we.expr.map(G=>fe.create([G,Ee],null,de)),null,K);ee&&(ye.push(ee),ye.sort(i))}if(ye.length===1)return ye[0];if(de){for(let we=0;we<ye.length;we++)for(let Ee=we+1;Ee<ye.length;Ee++)if(ye[we].negate().equals(ye[Ee]))return c.INSTANCE;if(ye.length===1)return ye[0]}return new fe(ye,q)}}serialize(){return this.expr.map(N=>N.serialize()).join(" && ")}keys(){const N=[];for(const q of this.expr)N.push(...q.keys());return N}map(N){return new fe(this.expr.map(q=>q.map(N)),null)}negate(){if(!this.c){const N=[];for(const q of this.expr)N.push(q.negate());this.c=se.create(N,this,!0)}return this.c}}e.$Mi=fe;class se{static create(N,q,de){return se.d(N,q,de)}constructor(N,q){this.expr=N,this.c=q,this.type=9}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let q=0,de=this.expr.length;q<de;q++){const ye=i(this.expr[q],N.expr[q]);if(ye!==0)return ye}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let q=0,de=this.expr.length;q<de;q++)if(!this.expr[q].equals(N.expr[q]))return!1;return!0}return!1}substituteConstants(){const N=J(this.expr);return N===this.expr?this:se.create(N,this.c,!1)}evaluate(N){for(let q=0,de=this.expr.length;q<de;q++)if(this.expr[q].evaluate(N))return!0;return!1}static d(N,q,de){let ye=[],ve=!1;if(N){for(let we=0,Ee=N.length;we<Ee;we++){const K=N[we];if(K){if(K.type===0){ve=!0;continue}if(K.type===1)return l.INSTANCE;if(K.type===9){ye=ye.concat(K.expr);continue}ye.push(K)}}if(ye.length===0&&ve)return c.INSTANCE;ye.sort(i)}if(ye.length!==0){if(ye.length===1)return ye[0];for(let we=1;we<ye.length;we++)ye[we-1].equals(ye[we])&&(ye.splice(we,1),we--);if(ye.length===1)return ye[0];if(de){for(let we=0;we<ye.length;we++)for(let Ee=we+1;Ee<ye.length;Ee++)if(ye[we].negate().equals(ye[Ee]))return l.INSTANCE;if(ye.length===1)return ye[0]}return new se(ye,q)}}serialize(){return this.expr.map(N=>N.serialize()).join(" || ")}keys(){const N=[];for(const q of this.expr)N.push(...q.keys());return N}map(N){return new se(this.expr.map(q=>q.map(N)),null)}negate(){if(!this.c){const N=[];for(const q of this.expr)N.push(q.negate());for(;N.length>1;){const q=N.shift(),de=N.shift(),ye=[];for(const ve of ne(q))for(const we of ne(de))ye.push(fe.create([ve,we],null,!1));N.unshift(se.create(ye,null,!1))}this.c=se.create(N,this,!0)}return this.c}}e.$Ni=se;class ie extends b{static{this.d=[]}static all(){return ie.d.values()}constructor(N,q,de){super(N,null),this.f=q,typeof de=="object"?ie.d.push({...de,key:N}):de!==!0&&ie.d.push({key:N,description:de,type:q!=null?typeof q:void 0})}bindTo(N){return N.createKey(this.key,this.f)}getValue(N){return N.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(N){return y.create(this.key,N)}notEqualsTo(N){return p.create(this.key,N)}}e.$Oi=ie,e.$Pi=(0,L.$ph)("contextKeyService");function V(x,N){return x<N?-1:x>N?1:0}function re(x,N,q,de){return x<q?-1:x>q?1:N<de?-1:N>de?1:0}function pe(x,N){if(x.type===0||N.type===1)return!0;if(x.type===9)return N.type===9?ae(x.expr,N.expr):!1;if(N.type===9){for(const q of N.expr)if(pe(x,q))return!0;return!1}if(x.type===6){if(N.type===6)return ae(N.expr,x.expr);for(const q of x.expr)if(pe(q,N))return!0;return!1}return x.equals(N)}e.$Qi=pe;function ae(x,N){let q=0,de=0;for(;q<x.length&&de<N.length;){const ye=x[q].cmp(N[de]);if(ye<0)return!1;ye===0&&q++,de++}return q===x.length}function ne(x){return x.type===9?x.expr:[x]}}),define(Se[223],De([1,0,6]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=void 0,e.$wh=(0,S.$ph)("environmentService"),e.$xh=(0,S.$qh)(e.$wh)}),define(Se[130],De([1,0,187,6]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Rn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=void 0,e.$En="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Fn=new RegExp(e.$En),e.$Gn="__web_extension",e.$Hn="skipWalkthrough",e.$In="extensionsSync",e.$Jn="dependecyOrPackExtensionInstall";function h(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Kn=h;function L(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Ln=L;function A(a,m){switch(a){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Mn=A;function f(a,m){return m==="web"&&!a.includes("web")}e.$Nn=f;function w(a,m,v){return f(m,v)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===v?!0:g(v).includes(a)}e.$On=w;function g(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Pn=g;function P(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.$Qn=P;var I;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(I||(e.SortBy=I={}));var $;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})($||(e.SortOrder=$={}));var k;(function(a){a.Install="install",a.Uninstall="uninstall"})(k||(e.StatisticType=k={}));var C;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(C||(e.InstallOperation=C={})),e.$Rn=(0,F.$ph)("extensionGalleryService");var E;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Signature="Signature",a.Internal="Internal"})(E||(e.ExtensionManagementErrorCode=E={}));var n;(function(a){a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(n||(e.ExtensionSignaturetErrorCode=n={}));class o extends Error{constructor(m,v){super(m),this.code=v,this.name=v}}e.$Sn=o,e.$Tn=(0,F.$ph)("extensionManagementService"),e.$Un="extensionsIdentifiers/disabled",e.$Vn="extensionsIdentifiers/enabled",e.$Wn=(0,F.$ph)("IGlobalExtensionEnablementService"),e.$Xn=(0,F.$ph)("IExtensionTipsService"),e.$Yn=(0,S.localize)(0,null),e.$Zn={value:e.$Yn,original:"Extensions"},e.$1n={value:(0,S.localize)(1,null),original:"Preferences"}}),define(Se[224],De([1,0,6]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uWb=e.$tWb=e.$sWb=void 0,e.$sWb=(0,S.$ph)("externalTerminal"),e.$tWb="Terminal.app",e.$uWb=(0,S.$ph)("externalTerminal")}),define(Se[225],De([1,0,46,16,14,9,98,29,100,189,224]),function(me,e,S,F,h,L,A,f,w,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k5b=e.$j5b=e.$i5b=void 0;const I=g.localize(0,null);class ${async getDefaultTerminalForPlatforms(){return{windows:k.getDefaultTerminalWindows(),linux:await E.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class k extends ${static{this.b="cmd.exe"}openTerminal(v,D){return this.spawnTerminal(S,v,w.$hl(),D)}spawnTerminal(v,D,t,r){const s=D.windowsExec||k.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const i=h.$_c(s,".exe").toLowerCase();if(i==="cmder")return v.spawn(s,r?[r]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return s.indexOf(" ")>=0&&c.push('""'),c.push(s),i==="wt"&&c.push("-d ."),new Promise((l,b)=>{const y=n(process),u=v.spawn(t,c,{cwd:r,env:y});u.on("error",b),u.on("exit",()=>l())})}runInTerminal(v,D,t,r,s){const i="windowsExec"in s&&s.windowsExec?s.windowsExec:k.getDefaultTerminalWindows();return new Promise((c,l)=>{const b=`"${D} - ${I}"`,y=`""${t.join('" "')}" & pause"`,u=Object.assign({},n(process),r);Object.keys(u).filter(j=>u[j]===null).forEach(j=>delete u[j]);const d={cwd:D,env:u,windowsVerbatimArguments:!0};let p,R;h.$_c(i,".exe")==="wt"?(p=i,R=["-d",".",k.b,"/c",y]):(p=k.b,R=["/c","start",b,"/wait",i,"/c",y]),S.spawn(p,R,d).on("error",j=>{l(o(j))}),c(void 0)})}static getDefaultTerminalWindows(){if(!k.d){const v=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");k.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${v?"Sysnative":"System32"}\\cmd.exe`}return k.d}}e.$i5b=k;class C extends ${static{this.b="/usr/bin/osascript"}openTerminal(v,D){return this.spawnTerminal(S,v,D)}runInTerminal(v,D,t,r,s){const i=s.osxExec||P.$tWb;return new Promise((c,l)=>{if(i===P.$tWb||i==="iTerm.app"){const b=i===P.$tWb?"TerminalHelper":"iTermHelper",u=[F.$1e.asFileUri(`vs/workbench/contrib/externalTerminal/node/${b}.scpt`).fsPath,"-t",v||I,"-w",D];for(const R of t)u.push("-a"),u.push(R);if(r){const R=Object.assign({},n(process),r);for(const O in R){const j=R[O];j===null?(u.push("-u"),u.push(O)):(u.push("-e"),u.push(`${O}=${j}`))}}let d="";const p=S.spawn(C.b,u);p.on("error",R=>{l(o(R))}),p.stderr.on("data",R=>{d+=R.toString()}),p.on("exit",R=>{if(R===0)c(void 0);else if(d){const O=d.split(`
`,1);l(new Error(O[0]))}else l(new Error(g.localize(1,null,b,R)))})}else l(new Error(g.localize(2,null,i)))})}spawnTerminal(v,D,t){const r=D.osxExec||P.$tWb;return new Promise((s,i)=>{const c=["-a",r];t&&c.push(t);const l=n(process),b=v.spawn("/usr/bin/open",c,{cwd:t,env:l});b.on("error",i),b.on("exit",()=>s())})}}e.$j5b=C;class E extends ${static{this.b=g.localize(3,null)}openTerminal(v,D){return this.spawnTerminal(S,v,D)}runInTerminal(v,D,t,r,s){const i=s.linuxExec?Promise.resolve(s.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((c,l)=>{const b=[];i.then(y=>{y.indexOf("gnome-terminal")>=0?b.push("-x"):b.push("-e"),b.push("bash"),b.push("-c");const u=`${a(t)}; echo; read -p "${E.b}" -n1;`;b.push(`''${u}''`);const d=Object.assign({},n(process),r);Object.keys(d).filter(j=>d[j]===null).forEach(j=>delete d[j]);const p={cwd:D,env:d};let R="";const O=S.spawn(y,b,p);O.on("error",j=>{l(o(j))}),O.stderr.on("data",j=>{R+=j.toString()}),O.on("exit",j=>{if(j===0)c(void 0);else if(R){const T=R.split(`
`,1);l(new Error(T[0]))}else l(new Error(g.localize(4,null,y,j)))})})})}static async getDefaultTerminalLinuxReady(){if(!E.d)if(!L.$k)E.d=Promise.resolve("xterm");else{const v=await f.Promises.exists("/etc/debian_version");E.d=new Promise(D=>{v?D("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?D("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?D("konsole"):process.env.COLORTERM?D(process.env.COLORTERM):process.env.TERM?D(process.env.TERM):D("xterm")})}return E.d}spawnTerminal(v,D,t){const r=D.linuxExec?Promise.resolve(D.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((s,i)=>{r.then(c=>{const l=n(process),b=v.spawn(c,[],{cwd:t,env:l});b.on("error",i),b.on("exit",()=>s())})})}}e.$k5b=E;function n(m){const v={...m.env};return(0,A.$fl)(v),v}function o(m){return"errno"in m&&m.errno==="ENOENT"&&"path"in m&&typeof m.path=="string"?new Error(g.localize(5,null,m.path)):m}function a(m){let v="";for(const D of m)D.indexOf(" ")>=0?v+='"'+D+'"':v+=D,v+=" ";return v}}),define(Se[30],De([1,0,75,14,15,19,2,190,6,9,16]),function(me,e,S,F,h,L,A,f,w,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileKind=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.FileOperationResult=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.FileChangeType=e.$0j=e.FileOperation=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.FileSystemProviderErrorCode=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Tj=e.$Sj=void 0,e.$Sj=(0,w.$ph)("fileService");function I(V){return V.create===!0}e.$Tj=I;var $;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var k;(function(V){V[V.Readonly=1]="Readonly",V[V.Locked=2]="Locked"})(k||(e.FilePermission=k={}));var C;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileAtomicWrite=32768]="FileAtomicWrite",V[V.FileAtomicDelete=65536]="FileAtomicDelete",V[V.FileClone=131072]="FileClone"})(C||(e.FileSystemProviderCapabilities=C={}));function E(V){return!!(V.capabilities&2)}e.$Uj=E;function n(V){return!!(V.capabilities&8)}e.$Vj=n;function o(V){return!!(V.capabilities&131072)}e.$Wj=o;function a(V){return!!(V.capabilities&4)}e.$Xj=a;function m(V){return!!(V.capabilities&16)}e.$Yj=m;function v(V){return E(V)?!!(V.capabilities&16384):!1}e.$Zj=v;function D(V){return E(V)?!!(V.capabilities&32768):!1}e.$1j=D;function t(V){return!!(V.capabilities&65536)}e.$2j=t;function r(V){return!!(V.capabilities&2048)}e.$3j=r;var s;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsStorageQuota="EntryExceedsStorageQuota",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class i extends Error{static create(re,pe){const ae=new i(re.toString(),pe);return b(ae,pe),ae}constructor(re,pe){super(re),this.code=pe}}e.$4j=i;function c(V,re){return i.create(V,re)}e.$5j=c;function l(V){return V||c((0,f.localize)(0,null),s.Unknown)}e.$6j=l;function b(V,re){return V.name=re?`${re} (FileSystemError)`:"FileSystemError",V}e.$7j=b;function y(V){if(!V)return s.Unknown;if(V instanceof i)return V.code;const re=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!re)return s.Unknown;switch(re[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}e.$8j=y;function u(V){if(V instanceof T)return V.fileOperationResult;switch(y(V)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}e.$9j=u;var d;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(d||(e.FileOperation=d={}));class p{constructor(re,pe,ae){this.resource=re,this.operation=pe,this.target=ae}isOperation(re){return this.operation===re}}e.$0j=p;var R;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(R||(e.FileChangeType=R={}));class O{constructor(re,pe){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ae=new Map;for(const ne of re){const x=ae.get(ne.type);switch(x?x.push([ne.resource,ne]):ae.set(ne.type,[[ne.resource,ne]]),ne.type){case 1:this.rawAdded.push(ne.resource);break;case 0:this.rawUpdated.push(ne.resource);break;case 2:this.rawDeleted.push(ne.resource);break}}for(const[ne,x]of ae)switch(ne){case 1:this.a=S.$vh.forUris(()=>pe),this.a.fill(x);break;case 0:this.b=S.$vh.forUris(()=>pe),this.b.fill(x);break;case 2:this.c=S.$vh.forUris(()=>pe),this.c.fill(x);break}}contains(re,...pe){return this.d(re,{includeChildren:!1},...pe)}affects(re,...pe){return this.d(re,{includeChildren:!0},...pe)}d(re,pe,...ae){if(!re)return!1;const ne=ae.length>0;return!!((!ne||ae.includes(1))&&(this.a?.get(re)||pe.includeChildren&&this.a?.findSuperstr(re))||(!ne||ae.includes(0))&&(this.b?.get(re)||pe.includeChildren&&this.b?.findSuperstr(re))||(!ne||ae.includes(2))&&(this.c?.findSubstr(re)||pe.includeChildren&&this.c?.findSuperstr(re)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$$j=O;function j(V,re,pe){return!V||!re||V===re||re.length>V.length?!1:(re.charAt(re.length-1)!==F.sep&&(re+=F.sep),pe?(0,h.$Md)(V,re):V.indexOf(re)===0)}e.$_j=j;class T extends Error{constructor(re,pe,ae){super(re),this.fileOperationResult=pe,this.options=ae}}e.$ak=T;class z extends T{constructor(re,pe,ae,ne){super(re,pe,ne),this.fileOperationResult=pe,this.size=ae}}e.$bk=z;class B extends T{constructor(re,pe,ae){super(re,2,ae),this.stat=pe}}e.$ck=B;var M;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(M||(e.FileOperationResult=M={})),e.$dk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ek={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$fk="files.associations",e.$gk="files.exclude",e.$hk="files.readonlyInclude",e.$ik="files.readonlyExclude",e.$jk="files.readonlyFromPermissions";var Y;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(Y||(e.FileKind=Y={})),e.$kk="";function J(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.$lk=J;async function fe(V,re){if(!re.hasProvider(A.URI.from({scheme:V.scheme})))return new Promise(pe=>{const ae=re.onDidChangeFileSystemProviderRegistrations(ne=>{ne.scheme===V.scheme&&ne.added&&(ae.dispose(),pe())})})}e.$mk=fe;class se{static{this.KB=1024}static{this.MB=se.KB*se.KB}static{this.GB=se.MB*se.KB}static{this.TB=se.GB*se.KB}static formatSize(re){return(0,L.$me)(re)||(re=0),re<se.KB?(0,f.localize)(1,null,re.toFixed(0)):re<se.MB?(0,f.localize)(2,null,(re/se.KB).toFixed(2)):re<se.GB?(0,f.localize)(3,null,(re/se.MB).toFixed(2)):re<se.TB?(0,f.localize)(4,null,(re/se.GB).toFixed(2)):(0,f.localize)(5,null,(re/se.TB).toFixed(2))}}e.$nk=se;function ie(V){const re=typeof V=="string"||V?.scheme===P.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===P.Schemas.file?1024*se.MB:re?10*se.MB:g.$o?50*se.MB:1024*se.MB}e.$ok=ie}),define(Se[226],De([1,0,21,8,191,30]),function(me,e,S,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=void 0;async function A(P,I,$,k,C,E){let n;try{await f(P,I,$,k,C,E)}catch(o){n=o}finally{n&&C.errorTransformer&&(n=C.errorTransformer(n)),typeof n<"u"&&$.error(n),$.end()}}e.$tp=A;async function f(P,I,$,k,C,E){w(E);const n=await P.open(I,{create:!1});try{w(E);let o=0,a=0,m=C&&typeof C.length=="number"?C.length:void 0,v=S.$Ec.alloc(Math.min(C.bufferSize,typeof m=="number"?m:C.bufferSize)),D=C&&typeof C.position=="number"?C.position:0,t=0;do a=await P.read(n,D,v.buffer,t,v.byteLength-t),D+=a,t+=a,o+=a,typeof m=="number"&&(m-=a),t===v.byteLength&&(await $.write(k(v)),v=S.$Ec.alloc(Math.min(C.bufferSize,typeof m=="number"?m:C.bufferSize)),t=0);while(a>0&&(typeof m!="number"||m>0)&&w(E)&&g(o,C));if(t>0){let r=t;typeof m=="number"&&(r=Math.min(t,m)),$.write(k(v.slice(0,r)))}}catch(o){throw(0,L.$6j)(o)}finally{await P.close(n)}}function w(P){if(P.isCancellationRequested)throw(0,F.$4)();return!0}function g(P,I){if(typeof I?.limits?.size=="number"&&P>I.limits.size)throw(0,L.$5j)((0,h.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Se[82],De([1,0,35,3,14,9,2,30]),function(me,e,S,F,h,L,A,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=void 0;function w(o){return o.recursive===!0}e.$vp=w;class g extends F.$lb{static{this.a=5}constructor(a,m,v,D){super(),this.h=a,this.i=m,this.j=v,this.k=D,this.c=this.B(new F.$mb),this.f=void 0,this.g=0}m(){const a=new F.$kb;this.c.value=a,this.b=this.l(a),this.b.setVerboseLogging(this.j),a.add(this.b.onDidChangeFile(m=>this.h(m))),a.add(this.b.onDidLogMessage(m=>this.i(m))),a.add(this.b.onDidError(m=>this.n(m)))}n(a){this.k.restartOnError?this.g<g.a&&this.f?(this.r(`restarting watcher after error: ${a}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${a}`):this.r(a)}p(a){this.g++,this.m(),this.watch(a)}async watch(a){this.f=a,await this.b?.watch(a)}async setVerboseLogging(a){this.j=a,await this.b?.setVerboseLogging(a)}r(a){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${a}`})}s(a){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${a}`})}dispose(){return this.b=void 0,super.dispose()}}e.$wp=g;class P extends g{constructor(a,m,v){super(a,m,v,{type:"node.js",restartOnError:!1})}}e.$xp=P;class I extends g{constructor(a,m,v){super(a,m,v,{type:"universal",restartOnError:!0})}}e.$yp=I;function $(o){return o.map(a=>({type:a.type,resource:A.URI.file(a.path)}))}e.$zp=$;function k(o){const a=new n;for(const m of o)a.processEvent(m);return a.coalesce()}e.$Ap=k;function C(o,a){return typeof a=="string"&&!a.startsWith(S.$aj)&&!(0,h.$7c)(a)?{base:o,pattern:a}:a}e.$Bp=C;function E(o,a){const m=[];for(const v of a)m.push((0,S.$ej)(C(o,v)));return m}e.$Cp=E;class n{constructor(){this.a=new Set,this.b=new Map}c(a){return L.$k?a.path:a.path.toLowerCase()}processEvent(a){const m=this.b.get(this.c(a));let v=!1;if(m){const D=m.type,t=a.type;m.path!==a.path&&(a.type===2||a.type===1)?v=!0:D===1&&t===2?(this.b.delete(this.c(a)),this.a.delete(m)):D===2&&t===1?m.type=0:D===1&&t===0||(m.type=t)}else v=!0;v&&(this.a.add(a),this.b.set(this.c(a),a))}coalesce(){const a=[],m=[];return Array.from(this.a).filter(v=>v.type!==2?(a.push(v),!1):!0).sort((v,D)=>v.path.length-D.path.length).filter(v=>m.some(D=>(0,f.$_j)(v.path,D,!L.$k))?!1:(m.push(v.path),!0)).concat(a)}}}),define(Se[227],De([1,0,49,13,22,32,3,73,14,9,99,29,82]),function(me,e,S,F,h,L,A,f,w,g,P,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Pp=void 0;class k extends A.$lb{static{this.a=100}static{this.b=75}constructor(n,o,a,m){super(),this.j=n,this.k=o,this.l=a,this.m=m,this.c=this.B(new F.$Jg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},v=>this.k(v))),this.f=this.B(new F.$Ig(v=>this.u(v),k.b)),this.g=(0,$.$Cp)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,$.$Cp)(this.j.path,this.j.includes):void 0,this.i=new h.$oc,this.ready=this.n()}async n(){try{const n=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const o=await I.Promises.stat(n);this.B(await this.s(n,o.isDirectory()))}catch(n){n.code!=="ENOENT"?this.w(n):this.z(n)}}async r(n){let o=n.path;try{o=await I.Promises.realpath(n.path),n.path===o&&(o=await(0,P.$Mp)(n.path)??n.path),n.path!==o&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${o})`)}catch{}return o}async s(n,o){if(g.$j&&(0,L.$He)(n,"/Volumes/",!0))return this.w(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$lb.None;const a=new h.$oc(this.i.token),m=new A.$kb;try{const v=(0,w.$_c)(n),D=(0,S.watch)(n);m.add((0,A.$jb)(()=>{D.removeAllListeners(),D.close()})),this.z(`Started watching: '${n}'`);const t=new Set;if(o)try{for(const s of await I.Promises.readdir(n))t.add(s)}catch(s){this.w(s)}const r=new Map;m.add((0,A.$jb)(()=>{for(const[,s]of r)s.dispose();r.clear()})),D.on("error",(s,i)=>{this.w(`Failed to watch ${n} for changes using fs.watch() (${s}, ${i})`),this.dispose()}),D.on("change",(s,i)=>{if(a.token.isCancellationRequested)return;this.z(`[raw] ["${s}"] ${i}`);let c="";if(i&&(c=i.toString(),g.$j&&(c=(0,f.$7k)(c))),!(!c||s!=="change"&&s!=="rename"))if(o)if(s==="rename"){r.get(c)?.dispose();const l=setTimeout(async()=>{if(r.delete(c),c===v&&!await I.Promises.exists(n)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const b=await this.v((0,w.$8c)(n,c));if(a.token.isCancellationRequested)return;let y;b?t.has(c)?y=0:(y=1,t.add(c)):(t.delete(c),y=2),this.t({path:(0,w.$8c)(this.j.path,c),type:y})},k.a);r.set(c,(0,A.$jb)(()=>clearTimeout(l)))}else{let l;t.has(c)?l=0:(l=1,t.add(c)),this.t({path:(0,w.$8c)(this.j.path,c),type:l})}else if(s==="rename"||c!==v){const l=setTimeout(async()=>{const b=await I.Promises.exists(n);a.token.isCancellationRequested||(b?(this.t({path:this.j.path,type:0},!0),m.add(await this.s(n,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},k.a);m.clear(),m.add((0,A.$jb)(()=>clearTimeout(l)))}else this.t({path:this.j.path,type:0},!0)})}catch(v){await I.Promises.exists(n)&&!a.token.isCancellationRequested&&this.w(`Failed to watch ${n} for changes using fs.watch() (${v.toString()})`)}return(0,A.$jb)(()=>{a.dispose(!0),m.dispose()})}t(n,o=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.path}`),!o&&this.g.some(a=>a(n.path))?this.m&&this.z(` >> ignored (excluded) ${n.path}`):!o&&this.h&&this.h.length>0&&!this.h.some(a=>a(n.path))?this.m&&this.z(` >> ignored (not included) ${n.path}`):this.f.work(n))}u(n){const o=(0,$.$Ap)(n);if(o.length>0){if(this.m)for(const m of o)this.z(`>> normalized ${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.path}`);this.c.work(o)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${o[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(n){if(g.$k)return I.Promises.exists(n);try{const o=(0,w.$_c)(n);return(await I.Promises.readdir((0,w.$$c)(n))).some(m=>m===o)}catch(o){return this.z(o),!1}}setVerboseLogging(n){this.m=n}w(n){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}y(n){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}z(n){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.$Pp=k;async function C(E,n,o,a,m=512){const v=await I.Promises.open(E,"r"),D=Buffer.allocUnsafe(m),t=new h.$oc(a);let r,s=!1;const i={path:E,excludes:[],recursive:!1},c=new k(i,l=>{(async()=>{for(const{type:b}of l)if(b===0){if(s)return;s=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:y}=await I.Promises.read(v,D,0,m,null);if(!y||t.token.isCancellationRequested)break;n(D.slice(0,y))}}catch(y){r=new Error(y),t.dispose(!0)}finally{s=!1}}})()});return await c.ready,o(),new Promise((l,b)=>{t.token.onCancellationRequested(async()=>{c.dispose();try{await I.Promises.close(v)}catch(y){r=new Error(y)}r?b(r):l()})})}e.$Qp=C}),define(Se[228],De([1,0,4,35,3,9,227]),function(me,e,S,F,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0;class f extends h.$lb{constructor(){super(...arguments),this.a=this.B(new S.$ec),this.onDidChangeFile=this.a.event,this.b=this.B(new S.$ec),this.onDidLogMessage=this.b.event,this.onDidError=S.Event.None,this.c=new Map,this.f=!1}async watch(g){const P=this.i(g),I=P.filter(k=>{const C=this.c.get(k.path);return C?!(0,F.$ij)(C.request.excludes,k.excludes)||!(0,F.$ij)(C.request.includes,k.includes):!0}),$=Array.from(this.c.values()).filter(({request:k})=>!P.find(C=>C.path===k.path&&(0,F.$ij)(C.excludes,k.excludes)&&(0,F.$ij)(C.includes,k.includes))).map(({request:k})=>k.path);I.length&&this.j(`Request to start watching: ${I.map(k=>`${k.path} (excludes: ${k.excludes.length>0?k.excludes:"<none>"}, includes: ${k.includes&&k.includes.length>0?JSON.stringify(k.includes):"<all>"})`).join(",")}`),$.length&&this.j(`Request to stop watching: ${$.join(",")}`);for(const k of $)this.h(k);for(const k of I)this.g(k)}g(g){const P=new A.$Pp(g,$=>this.a.fire($),$=>this.b.fire($),this.f),I={request:g,instance:P};this.c.set(g.path,I)}async stop(){for(const[g]of this.c)this.h(g);this.c.clear()}h(g){const P=this.c.get(g);P&&(this.c.delete(g),P.instance.dispose())}i(g){const P=new Map;for(const I of g){const $=L.$k?I.path:I.path.toLowerCase();P.set($,I)}return Array.from(P.values())}async setVerboseLogging(g){this.f=g;for(const[,P]of this.c)P.instance.setVerboseLogging(g)}j(g){this.f&&this.b.fire({type:"trace",message:this.k(g)})}k(g,P){return P?`[File Watcher (node.js)] ${g} (path: ${P.request.path})`:`[File Watcher (node.js)] ${g}`}}e.$Rp=f}),define(Se[229],De([1,0,82,228]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;class h extends S.$xp{constructor(A,f,w){super(A,f,w),this.m()}l(){return new F.$Rp}}e.$Sp=h}),define(Se[230],De([1,0,16,79,180,82]),function(me,e,S,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;class A extends L.$yp{constructor(w,g,P){super(w,g,P),this.m()}l(w){const g=w.add(new h.$Jp(S.$1e.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(g.onDidProcessExit(({code:P,signal:I})=>this.n(`terminated by itself with code ${P}, signal: ${I}`))),F.ProxyChannel.toService((0,F.$9g)(g.getChannel("watcher")))}}e.$Kp=A}),define(Se[103],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=void 0;class S{constructor(...h){this.a=new Map;for(const[L,A]of h)this.set(L,A)}set(h,L){const A=this.a.get(h);return this.a.set(h,L),A}has(h){return this.a.has(h)}get(h){return this.a.get(h)}}e.$nh=S}),define(Se[231],De([1,0,13,8,3,101,222,6,103,72]),function(me,e,S,F,h,L,A,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=void 0;const P=!1;class I extends Error{constructor(n){super("cyclic dependency between services"),this.message=n.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${n.toString()}`}}class ${constructor(n=new w.$nh,o=!1,a,m=P){this.f=n,this.g=o,this.h=a,this.i=m,this.o=new Set,this.f.set(f.$oh,this),this._globalGraph=m?a?._globalGraph??new A.$Vp(v=>v):void 0}createChild(n){return new $(n,this.g,this,this.i)}invokeFunction(n,...o){const a=C.traceInvocation(this.i,n);let m=!1;try{return n({get:D=>{if(m)throw(0,F.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(D,a);if(!t)throw new Error(`[invokeFunction] unknown service '${D}'`);return t}},...o)}finally{m=!0,a.stop()}}createInstance(n,...o){let a,m;return n instanceof L.$mh?(a=C.traceCreation(this.i,n.ctor),m=this.j(n.ctor,n.staticArguments.concat(o),a)):(a=C.traceCreation(this.i,n),m=this.j(n,o,a)),a.stop(),m}j(n,o=[],a){const m=f._util.getServiceDependencies(n).sort((t,r)=>t.index-r.index),v=[];for(const t of m){const r=this.m(t.id,a);r||this.u(`[createInstance] ${n.name} depends on UNKNOWN service ${t.id}.`,!1),v.push(r)}const D=m.length>0?m[0].index:o.length;if(o.length!==D){console.trace(`[createInstance] First service dependency of ${n.name} at position ${D+1} conflicts with ${o.length} static arguments`);const t=D-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,D)}return Reflect.construct(n,o.concat(v))}k(n,o){if(this.f.get(n)instanceof L.$mh)this.f.set(n,o);else if(this.h)this.h.k(n,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(n){const o=this.f.get(n);return!o&&this.h?this.h.l(n):o}m(n,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(n));const a=this.l(n);return a instanceof L.$mh?this.q(n,a,o.branch(n,!0)):(o.branch(n,!1),a)}q(n,o,a){if(this.o.has(n))throw new Error(`illegal state - RECURSIVELY instantiating service '${n}'`);this.o.add(n);try{return this.r(n,o,a)}finally{this.o.delete(n)}}r(n,o,a){const m=new A.$Vp(t=>t.id.toString());let v=0;const D=[{id:n,desc:o,_trace:a}];for(;D.length;){const t=D.pop();if(m.lookupOrInsertNode(t),v++>1e3)throw new I(m);for(const r of f._util.getServiceDependencies(t.desc.ctor)){const s=this.l(r.id);if(s||this.u(`[createInstance] ${n} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),s instanceof L.$mh){const i={id:r.id,desc:s,_trace:t._trace.branch(r.id,!0)};m.insertEdge(t,i),D.push(i)}}}for(;;){const t=m.roots();if(t.length===0){if(!m.isEmpty())throw new I(m);break}for(const{data:r}of t){if(this.l(r.id)instanceof L.$mh){const i=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,i)}m.removeNode(r)}}return this.l(n)}s(n,o,a=[],m,v){if(this.f.get(n)instanceof L.$mh)return this.t(n,o,a,m,v);if(this.h)return this.h.s(n,o,a,m,v);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(n,o,a=[],m,v){if(m){const D=new $(void 0,this.g,this,this.i);D.c=String(n);const t=new Map,r=new S.$Lg(()=>{const s=D.j(o,a,v);for(const[i,c]of t){const l=s[i];if(typeof l=="function")for(const b of c)l.apply(s,b)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,i){if(!r.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let b=t.get(i);return b||(b=new g.$ub,t.set(i,b)),(u,d,p)=>{const R=b.push([u,d,p]);return(0,h.$jb)(R)}}if(i in s)return s[i];const c=r.value;let l=c[i];return typeof l!="function"||(l=l.bind(c),s[i]=l),l},set(s,i,c){return r.value[i]=c,!0},getPrototypeOf(s){return o.prototype}})}else return this.j(o,a,v)}u(n,o){if(o&&console.warn(n),this.g)throw new Error(n)}}e.$Wp=$;var k;(function(E){E[E.None=0]="None",E[E.Creation=1]="Creation",E[E.Invocation=2]="Invocation",E[E.Branch=3]="Branch"})(k||(k={}));class C{static{this.all=new Set}static{this.c=new class extends C{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(n,o){return n?new C(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):C.c}static traceCreation(n,o){return n?new C(1,o.name):C.c}static{this.f=0}constructor(n,o){this.type=n,this.name=o,this.g=Date.now(),this.h=[]}branch(n,o){const a=new C(3,n.toString());return this.h.push([n,o,a]),a}stop(){const n=Date.now()-this.g;C.f+=n;let o=!1;function a(v,D){const t=[],r=new Array(v+1).join("	");for(const[s,i,c]of D.h)if(i&&c){o=!0,t.push(`${r}CREATES -> ${s}`);const l=a(v+1,c);l&&t.push(l)}else t.push(`${r}uses -> ${s}`);return t.join(`
`)}const m=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${a(1,this)}`,`DONE, took ${n.toFixed(2)}ms (grand total ${C.f.toFixed(2)}ms)`];(n>2||o)&&C.all.add(m.join(`
`))}}e.$Xp=C}),define(Se[17],De([1,0,45,4,74,3,28,9,24,19,2,47,6]),function(me,e,S,F,h,L,A,f,w,g,P,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.log=e.$Ui=e.LogLevel=e.$Ti=e.$Si=e.$Ri=void 0,e.$Ri=(0,$.$ph)("logService"),e.$Si=(0,$.$ph)("loggerService");function k(){return new Date().toISOString()}function C(u){return(0,g.$me)(u)}e.$Ti=C;var E;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(E||(e.LogLevel=E={})),e.$Ui=E.Info;function n(u,d,p){switch(d){case E.Trace:u.trace(p);break;case E.Debug:u.debug(p);break;case E.Info:u.info(p);break;case E.Warning:u.warn(p);break;case E.Error:u.error(p);break;case E.Off:break;default:throw new Error(`Invalid log level ${d}`)}}e.log=n;function o(u,d=!1){let p="";for(let R=0;R<u.length;R++){let O=u[R];if(O instanceof Error&&(O=(0,S.$ai)(O,d)),typeof O=="object")try{O=JSON.stringify(O)}catch{}p+=(R>0?" ":"")+O}return p}class a extends L.$lb{constructor(){super(...arguments),this.b=e.$Ui,this.c=this.B(new F.$ec),this.onDidChangeLogLevel=this.c.event}setLevel(d){this.b!==d&&(this.b=d,this.c.fire(this.b))}getLevel(){return this.b}f(d){return this.b!==E.Off&&this.b<=d}}e.$Wi=a;class m extends a{constructor(d){super(),this.h=d}f(d){return this.h||super.f(d)}trace(d,...p){this.f(E.Trace)&&this.g(E.Trace,o([d,...p],!0))}debug(d,...p){this.f(E.Debug)&&this.g(E.Debug,o([d,...p]))}info(d,...p){this.f(E.Info)&&this.g(E.Info,o([d,...p]))}warn(d,...p){this.f(E.Warning)&&this.g(E.Warning,o([d,...p]))}error(d,...p){if(this.f(E.Error))if(d instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=d.stack,this.g(E.Error,o(R))}else this.g(E.Error,o([d,...p]))}flush(){}}e.$Xi=m;class v extends a{constructor(d=e.$Ui){super(),this.setLevel(d),this.g=!f.$i}trace(d,...p){this.f(E.Trace)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,d,...p):console.log(`[main ${k()}]`,d,...p))}debug(d,...p){this.f(E.Debug)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,d,...p):console.log(`[main ${k()}]`,d,...p))}info(d,...p){this.f(E.Info)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,d,...p):console.log(`[main ${k()}]`,d,...p))}warn(d,...p){this.f(E.Warning)&&(this.g?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,d,...p):console.warn(`[main ${k()}]`,d,...p))}error(d,...p){this.f(E.Error)&&(this.g?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,d,...p):console.error(`[main ${k()}]`,d,...p))}dispose(){}flush(){}}e.$Yi=v;class D extends a{constructor(d=e.$Ui,p=!0){super(),this.g=p,this.setLevel(d)}trace(d,...p){this.f(E.Trace)&&(this.g?console.log("%cTRACE","color: #888",d,...p):console.log(d,...p))}debug(d,...p){this.f(E.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",d,...p):console.log(d,...p))}info(d,...p){this.f(E.Info)&&(this.g?console.log("%c INFO","color: #33f",d,...p):console.log(d,...p))}warn(d,...p){this.f(E.Warning)&&(this.g?console.log("%c WARN","color: #993",d,...p):console.log(d,...p))}error(d,...p){this.f(E.Error)&&(this.g?console.log("%c  ERR","color: #f33",d,...p):console.error(d,...p))}dispose(){}flush(){}}e.$Zi=D;class t extends a{constructor(d,p=e.$Ui){super(),this.g=d,this.setLevel(p)}trace(d,...p){this.f(E.Trace)&&this.g.log(E.Trace,[this.h(d),...p])}debug(d,...p){this.f(E.Debug)&&this.g.log(E.Debug,[this.h(d),...p])}info(d,...p){this.f(E.Info)&&this.g.log(E.Info,[this.h(d),...p])}warn(d,...p){this.f(E.Warning)&&this.g.log(E.Warning,[this.h(d),...p])}error(d,...p){this.f(E.Error)&&this.g.log(E.Error,[this.h(d),...p])}h(d){return typeof d=="string"?d:(0,S.$ai)(d,this.f(E.Trace))}dispose(){}flush(){}}e.$1i=t;class r extends a{constructor(d){super(),this.g=d,d.length&&this.setLevel(d[0].getLevel())}setLevel(d){for(const p of this.g)p.setLevel(d);super.setLevel(d)}trace(d,...p){for(const R of this.g)R.trace(d,...p)}debug(d,...p){for(const R of this.g)R.debug(d,...p)}info(d,...p){for(const R of this.g)R.info(d,...p)}warn(d,...p){for(const R of this.g)R.warn(d,...p)}error(d,...p){for(const R of this.g)R.error(d,...p)}flush(){for(const d of this.g)d.flush()}dispose(){for(const d of this.g)d.dispose()}}e.$2i=r;class s extends L.$lb{constructor(d,p,R){if(super(),this.h=d,this.j=p,this.b=new A.$ni,this.c=this.B(new F.$ec),this.onDidChangeLoggers=this.c.event,this.f=this.B(new F.$ec),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new F.$ec),this.onDidChangeVisibility=this.g.event,R)for(const O of R)this.b.set(O.resource,{logger:void 0,info:O})}k(d){return(0,g.$ie)(d)?[...this.b.values()].find(p=>p.info.id===d):this.b.get(d)}getLogger(d){return this.k(d)?.logger}createLogger(d,p){const R=this.l(d),O=(0,g.$ie)(d)?d:p?.id??(0,h.$di)(R.toString()).toString(16);let j=this.b.get(R)?.logger;const T=p?.logLevel==="always"?E.Trace:p?.logLevel;j||(j=this.m(R,T??this.getLogLevel(R)??this.h,{...p,id:O}));const z={logger:j,info:{resource:R,id:O,logLevel:T,name:p?.name,hidden:p?.hidden,extensionId:p?.extensionId,when:p?.when}};return this.registerLogger(z.info),this.b.set(R,z),j}l(d){return(0,g.$ie)(d)?(0,w.$9f)(this.j,`${d}.log`):d}setLogLevel(d,p){if(P.URI.isUri(d)){const R=d,O=p,j=this.b.get(R);j&&O!==j.info.logLevel&&(j.info.logLevel=O===this.h?void 0:O,j.logger?.setLevel(O),this.b.set(j.info.resource,j),this.f.fire([R,O]))}else{this.h=d;for(const[R,O]of this.b.entries())this.b.get(R)?.info.logLevel===void 0&&O.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(d,p){const R=this.k(d);R&&p!==!R.info.hidden&&(R.info.hidden=!p,this.b.set(R.info.resource,R),this.g.fire([R.info.resource,p]))}getLogLevel(d){let p;return d&&(p=this.b.get(d)?.info.logLevel),p??this.h}registerLogger(d){const p=this.b.get(d.resource);p?p.info.hidden!==d.hidden&&this.setVisibility(d.resource,!d.hidden):(this.b.set(d.resource,{info:d,logger:void 0}),this.c.fire({added:[d],removed:[]}))}deregisterLogger(d){const p=this.b.get(d);p&&(p.logger&&p.logger.dispose(),this.b.delete(d),this.c.fire({added:[],removed:[p.info]}))}*getRegisteredLoggers(){for(const d of this.b.values())yield d.info}getRegisteredLogger(d){return this.b.get(d)?.info}dispose(){this.b.forEach(d=>d.logger?.dispose()),this.b.clear(),super.dispose()}}e.$3i=s;class i{constructor(){this.onDidChangeLogLevel=new F.$ec().event}setLevel(d){}getLevel(){return E.Info}trace(d,...p){}debug(d,...p){}info(d,...p){}warn(d,...p){}error(d,...p){}critical(d,...p){}dispose(){}flush(){}}e.$4i=i;class c extends i{}e.$5i=c;function l(u){if(u.verbose)return E.Trace;if(typeof u.logLevel=="string"){const d=y(u.logLevel.toLowerCase());if(d!==void 0)return d}return e.$Ui}e.$6i=l;function b(u){switch(u){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}e.$7i=b;function y(u){switch(u){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.$8i=y,e.$9i=new I.$Oi("logLevel",b(E.Info))}),define(Se[232],De([1,0,18,13,8,4,3,14,82,17]),function(me,e,S,F,h,L,A,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;class P extends A.$lb{constructor($,k){super(),this.a=$,this.b=k,this.c=this.B(new L.$ec),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$ec),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new F.$sg(0)),this.s=[],this.t=this.B(new F.$sg(0))}watch($,k){return k.recursive||this.b?.watcher?.forceUniversal?this.l($,k):this.u($,k)}l($,k){const C={path:this.C($),excludes:k.excludes,includes:k.includes,recursive:k.recursive},E=(0,S.$yf)(this.j,C);return this.m(),(0,A.$jb)(()=>{E(),this.m()})}m(){this.k.trigger(()=>this.n()).catch($=>(0,h.$Y)($))}n(){this.h||(this.h=this.B(this.p(k=>this.c.fire((0,w.$zp)(k)),k=>this.z(k),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const k of this.j)(0,w.$vp)(k)&&(k.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const k of this.j)(0,w.$vp)(k)&&$.includes(k.path)&&(k.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u($,k){const C={path:this.C($),excludes:k.excludes,includes:k.includes,recursive:!1},E=(0,S.$yf)(this.s,C);return this.v(),(0,A.$jb)(()=>{E(),this.v()})}v(){this.t.trigger(()=>this.w()).catch($=>(0,h.$Y)($))}w(){return this.r||(this.r=this.B(this.y($=>this.c.fire((0,w.$zp)($)),$=>this.z($),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.r.watch(this.s)}z($){$.type==="error"&&this.g.fire($.message),this.a[$.type]($.message)}C($){return(0,f.$6c)($.fsPath)}}e.$Dp=P}),define(Se[233],De([1,0,49,362,13,28,21,4,32,3,14,9,24,96,29,192,30,226,232,45,230,229]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E,n,o,a,m,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0,(()=>{try{(0,F.gracefulify)(S)}catch(r){console.error(`Error enabling graceful-fs: ${(0,m.$ai)(r)}`)}})();class t extends a.$Dp{static{this.D=!1}constructor(s,i){super(s,i),this.onDidChangeCapabilities=f.Event.None,this.I=new L.$ni(c=>$.$Zf.getComparisonKey(c)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,I.$k&&(this.F|=1024)),this.F}async stat(s){try{const{stat:i,symbolicLink:c}=await C.SymlinkSupport.stat(this.C(s));return{type:this.H(i,c),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:n.FilePermission.Locked}}catch(i){throw this.ab(i)}}async G(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const i=await C.Promises.readdir(this.C(s),{withFileTypes:!0}),c=[];return await Promise.all(i.map(async l=>{try{let b;l.isSymbolicLink()?b=(await this.stat((0,$.$9f)(s,l.name))).type:b=this.H(l),c.push([l.name,b])}catch(b){this.a.trace(b)}})),c}catch(i){throw this.ab(i)}}H(s,i){let c;return i?.dangling?c=n.FileType.Unknown:s.isFile()?c=n.FileType.File:s.isDirectory()?c=n.FileType.Directory:c=n.FileType.Unknown,i&&(c|=n.FileType.SymbolicLink),c}async J(s){const i=this.C(s);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let c;for(;c=this.I.get(s);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await c.wait();const l=new h.$tg;return this.I.set(s,l),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,g.$jb)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.I.get(s)===l&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.I.delete(s)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),l.open()})}async readFile(s,i){let c;try{i?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(s)})`),c=await this.J(s));const l=this.C(s);return await C.Promises.readFile(l)}catch(l){throw this.ab(l)}finally{c?.dispose()}}L(s){t.D&&this.a.trace(s)}readFileStream(s,i,c){const l=(0,k.$sc)(b=>A.$Ec.concat(b.map(y=>A.$Ec.wrap(y))).buffer);return(0,o.$tp)(this,s,l,b=>b.buffer,{...i,bufferSize:256*1024},c),l}async writeFile(s,i,c){return c?.atomic!==!1&&c?.atomic?.postfix?this.M(s,(0,$.$9f)((0,$.$8f)(s),`${(0,$.$6f)(s)}${c.atomic.postfix}`),i,c):this.N(s,i,c)}async M(s,i,c,l){await this.N(i,c,l);try{await this.rename(i,s,{overwrite:!0})}catch(b){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw b}}async N(s,i,c){let l;try{const b=this.C(s);if(!c.create||!c.overwrite){if(await C.Promises.exists(b)){if(!c.overwrite)throw(0,n.$5j)((0,E.localize)(0,null),n.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,n.$5j)((0,E.localize)(1,null),n.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(s,{create:!0,unlock:c.unlock}),await this.write(l,0,i,0,i.byteLength)}catch(b){throw await this.bb(s,b)}finally{typeof l=="number"&&await this.close(l)}}static{this.R=!0}static configureFlushOnWrite(s){t.R=s}async open(s,i){const c=this.C(s);let l;(0,n.$Tj)(i)&&(l=await this.J(s));let b;try{if((0,n.$Tj)(i)&&i.unlock)try{const{stat:u}=await C.SymlinkSupport.stat(c);u.mode&128||await C.Promises.chmod(c,u.mode|128)}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}let y;if((0,n.$Tj)(i)){if(I.$i)try{await C.Promises.truncate(c,0),y="r+"}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}y||(y="w")}else y="r";b=await C.Promises.open(c,y)}catch(y){throw l?.dispose(),(0,n.$Tj)(i)?await this.bb(s,y):this.ab(y)}if(this.O.set(b,0),(0,n.$Tj)(i)&&this.Q.set(b,s),l){const y=this.P.get(b);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${b} (${c})`),this.P.set(b,l),y&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${b} (${c})`),y.dispose())}return b}async close(s){const i=this.P.get(s);try{if(this.O.delete(s),this.Q.delete(s)&&t.R)try{await C.Promises.fdatasync(s)}catch(c){t.configureFlushOnWrite(!1),this.a.error(c)}return await C.Promises.close(s)}catch(c){throw this.ab(c)}finally{i&&(this.P.get(s)===i&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.P.delete(s)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),i.dispose())}}async read(s,i,c,l,b){const y=this.S(s,i);let u=null;try{u=(await C.Promises.read(s,c,l,b,y)).bytesRead}catch(d){throw this.ab(d)}finally{this.U(s,y,u)}return u}S(s,i){return i===this.O.get(s)?null:i}U(s,i,c){const l=this.O.get(s);typeof l=="number"&&(typeof i=="number"||(typeof c=="number"?this.O.set(s,l+c):this.O.delete(s)))}async write(s,i,c,l,b){return(0,h.$Mg)(()=>this.W(s,i,c,l,b),100,3)}async W(s,i,c,l,b){const y=this.S(s,i);let u=null;try{u=(await C.Promises.write(s,c,l,b,y)).bytesWritten}catch(d){throw await this.bb(this.Q.get(s),d)}finally{this.U(s,y,u)}return u}async mkdir(s){try{await C.Promises.mkdir(this.C(s))}catch(i){throw this.ab(i)}}async delete(s,i){try{const c=this.C(s);if(i.recursive){let l;i?.atomic!==!1&&i.atomic.postfix&&(l=(0,P.$8c)((0,P.$$c)(c),`${(0,P.$_c)(c)}${i.atomic.postfix}`)),await C.Promises.rm(c,C.RimRafMode.MOVE,l)}else try{await C.Promises.unlink(c)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let b=!1;try{const{stat:y,symbolicLink:u}=await C.SymlinkSupport.stat(c);b=y.isDirectory()&&!u}catch{}if(b)await C.Promises.rmdir(c);else throw l}else throw l}}catch(c){throw this.ab(c)}}async rename(s,i,c){const l=this.C(s),b=this.C(i);if(l!==b)try{await this.X(s,i,"move",c.overwrite),await C.Promises.rename(l,b)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,E.localize)(2,null,(0,P.$_c)(l),(0,P.$_c)((0,P.$$c)(b)),y.toString()))),this.ab(y)}}async copy(s,i,c){const l=this.C(s),b=this.C(i);if(l!==b)try{await this.X(s,i,"copy",c.overwrite),await C.Promises.copy(l,b,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,E.localize)(3,null,(0,P.$_c)(l),(0,P.$_c)((0,P.$$c)(b)),y.toString()))),this.ab(y)}}async X(s,i,c,l){const b=this.C(s),y=this.C(i);let u=!1;if(!!(this.capabilities&1024)||(u=(0,w.$Ge)(b,y,!0)),u){if(c==="copy")throw(0,n.$5j)((0,E.localize)(4,null),n.FileSystemProviderErrorCode.FileExists);if(c==="move")return}const p=await this.G(s);if(!p)throw(0,n.$5j)((0,E.localize)(5,null),n.FileSystemProviderErrorCode.FileNotFound);const R=await this.G(i);if(R){if(!l)throw(0,n.$5j)((0,E.localize)(6,null),n.FileSystemProviderErrorCode.FileExists);p.type&n.FileType.File&&R.type&n.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,i){return this.Y(s,i,!1)}async Y(s,i,c){const l=this.C(s),b=this.C(i),y=!!(this.capabilities&1024);if((0,w.$Ge)(l,b,!y))return;const u=new g.$kb;try{const[d,p]=await Promise.all([this.J(s),this.J(i)]);u.add(d),u.add(p),c&&await C.Promises.mkdir((0,P.$$c)(b),{recursive:!0}),await C.Promises.copyFile(l,b)}catch(d){if(d.code==="ENOENT"&&!c)return this.Y(s,i,!0);throw this.ab(d)}finally{u.dispose()}}p(s,i,c){return new v.$Kp(l=>s(l),l=>i(l),c)}y(s,i,c){return new D.$Sp(l=>s(l),l=>i(l),c)}ab(s){if(s instanceof n.$4j)return s;let i=s,c;switch(s.code){case"ENOENT":c=n.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=n.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=n.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=n.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=n.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,c=n.FileSystemProviderErrorCode.Unknown;break;default:c=n.FileSystemProviderErrorCode.Unknown}return(0,n.$5j)(i,c)}async bb(s,i){let c=this.ab(i);if(s&&c.code===n.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await C.SymlinkSupport.stat(this.C(s));l.mode&128||(c=(0,n.$5j)(i,n.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return c}}e.$Tp=t}),define(Se[234],De([1,0,3,17]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9M=void 0;class h extends S.$lb{constructor(A,f=[]){super(),this.a=new F.$2i([A,...f]),this.B(A.onDidChangeLogLevel(w=>this.setLevel(w)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...f){this.a.trace(A,...f)}debug(A,...f){this.a.debug(A,...f)}info(A,...f){this.a.info(A,...f)}warn(A,...f){this.a.warn(A,...f)}error(A,...f){this.a.error(A,...f)}flush(){this.a.flush()}}e.$9M=h}),define(Se[235],De([1,0,30,17]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XM=void 0;var h;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(h||(h={}));async function L(g,P,I,$,k){try{const C=await new Promise((n,o)=>{me(["@vscode/spdlog"],n,o)});C.setFlushOn(h.Trace);const E=await C.createAsyncRotatingLogger(g,P,I,$);return k?E.clearFormatters():E.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),E}catch(C){console.error(C)}return null}function A(g,P,I){switch(P){case F.LogLevel.Trace:g.trace(I);break;case F.LogLevel.Debug:g.debug(I);break;case F.LogLevel.Info:g.info(I);break;case F.LogLevel.Warning:g.warn(I);break;case F.LogLevel.Error:g.error(I);break;case F.LogLevel.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function f(g,P){switch(P){case F.LogLevel.Trace:g.setLevel(h.Trace);break;case F.LogLevel.Debug:g.setLevel(h.Debug);break;case F.LogLevel.Info:g.setLevel(h.Info);break;case F.LogLevel.Warning:g.setLevel(h.Warning);break;case F.LogLevel.Error:g.setLevel(h.Error);break;case F.LogLevel.Off:g.setLevel(h.Off);break;default:throw new Error(`Invalid log level ${P}`)}}class w extends F.$Xi{constructor(P,I,$,k,C){super(),this.k=[],this.setLevel(C),this.l=this.n(P,I,$,k),this.B(this.onDidChangeLogLevel(E=>{this.m&&f(this.m,E)}))}async n(P,I,$,k){const C=$?6:1,E=30/C*S.$nk.MB,n=await L(P,I,E,C,k);if(n){this.m=n,f(this.m,this.getLevel());for(const{level:o,message:a}of this.k)A(this.m,o,a);this.k=[]}}g(P,I){this.m?A(this.m,P,I):this.getLevel()<=P&&this.k.push({level:P,message:I})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.$XM=w}),define(Se[131],De([1,0,40,193,6]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(w){w[w.Unnecessary=1]="Unnecessary",w[w.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var A;(function(w){w[w.Hint=1]="Hint",w[w.Info=2]="Info",w[w.Warning=4]="Warning",w[w.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(w){function g(C,E){return E-C}w.compare=g;const P=Object.create(null);P[w.Error]=(0,F.localize)(0,null),P[w.Warning]=(0,F.localize)(1,null),P[w.Info]=(0,F.localize)(2,null);function I(C){return P[C]||""}w.toString=I;function $(C){switch(C){case S.default.Error:return w.Error;case S.default.Warning:return w.Warning;case S.default.Info:return w.Info;case S.default.Ignore:return w.Hint}}w.fromSeverity=$;function k(C){switch(C){case w.Error:return S.default.Error;case w.Warning:return S.default.Warning;case w.Info:return S.default.Info;case w.Hint:return S.default.Ignore}}w.toSeverity=k}(A||(e.MarkerSeverity=A={}));var f;(function(w){const g="";function P($){return I($,!0)}w.makeKey=P;function I($,k){const C=[g];return $.source?C.push($.source.replace("\xA6","\\\xA6")):C.push(g),$.code?typeof $.code=="string"?C.push($.code.replace("\xA6","\\\xA6")):C.push($.code.value.replace("\xA6","\\\xA6")):C.push(g),$.severity!==void 0&&$.severity!==null?C.push(A.toString($.severity)):C.push(g),$.message&&k?C.push($.message.replace("\xA6","\\\xA6")):C.push(g),$.startLineNumber!==void 0&&$.startLineNumber!==null?C.push($.startLineNumber.toString()):C.push(g),$.startColumn!==void 0&&$.startColumn!==null?C.push($.startColumn.toString()):C.push(g),$.endLineNumber!==void 0&&$.endLineNumber!==null?C.push($.endLineNumber.toString()):C.push(g),$.endColumn!==void 0&&$.endColumn!==null?C.push($.endColumn.toString()):C.push(g),C.push(g),C.join("\xA6")}w.makeKeyOptionalMessage=I})(f||(e.IMarkerData=f={})),e.$rs=(0,h.$ph)("markerService")}),define(Se[236],De([1,0,4,40,6]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qu=e.$Pu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Ou=e.Severity=void 0,e.Severity=F.default,e.$Ou=(0,h.$ph)("notificationService");var L;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var f;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(f||(e.NotificationsFilter=f={}));class w{constructor(){this.progress=new g,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(I){}updateMessage(I){}updateActions(I){}close(){}}e.$Pu=w;class g{infinite(){}done(){}total(I){}worked(I){}}e.$Qu=g}),define(Se[132],De([1,0,15,2,6]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uT=e.$tT=e.$sT=e.$rT=e.$qT=void 0,e.$qT=(0,h.$ph)("openerService");function L(g,P){return F.URI.isUri(g)?(0,S.$Ld)(g.scheme,P):(0,S.$Md)(g,P+":")}e.$rT=L;function A(g,...P){return P.some(I=>L(g,I))}e.$sT=A;function f(g,P){return g.with({fragment:`${P.startLineNumber},${P.startColumn}${P.endLineNumber?`-${P.endLineNumber}${P.endColumn?`,${P.endColumn}`:""}`:""}`})}e.$tT=f;function w(g){let P;const I=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return I&&(P={startLineNumber:parseInt(I[1]),startColumn:I[2]?parseInt(I[2]):1,endLineNumber:I[4]?parseInt(I[4]):void 0,endColumn:I[4]?I[5]?parseInt(I[5]):1:void 0},g=g.with({fragment:""})),{selection:P,uri:g}}e.$uT=w}),define(Se[237],De([1,0,9,41]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let h;if(typeof S.$g.vscode<"u"&&typeof S.$g.vscode.context<"u"){const L=S.$g.vscode.context.configuration();if(L)h=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(h=globalThis._VSCODE_PRODUCT_JSON,F.env.VSCODE_DEV&&Object.assign(h,{nameShort:`${h.nameShort} Dev`,nameLong:`${h.nameLong} Dev`,dataFolderName:`${h.dataFolderName}-dev`,serverDataFolderName:h.serverDataFolderName?`${h.serverDataFolderName}-dev`:void 0}),!h.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(h,{version:L.version})}}else h={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"vscode",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverGreeting:[],serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webUrl:"https://vscode.dev",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json"},profileTemplatesUrl:"https://az764295.vo.msecnd.net/profile-templates/profile-templates.json",extensionRecommendations:{"ms-dotnettools.csharp":{onFileOpen:[{pathGlob:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}",important:!0},{languages:["csharp"],important:!0},{pathGlob:"{**/project.json,**/appsettings.json}"}]},"ms-python.python":{onFileOpen:[{pathGlob:"{**/*.py}",important:!0},{languages:["python"],important:!0},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.jupyter":{onFileOpen:[{pathGlob:"{**/*.py}",contentPattern:"^#\\s*%%$",important:!0,whenInstalled:["ms-python.python"]},{pathGlob:"{**/*.ipynb}"}]},"golang.Go":{onFileOpen:[{pathGlob:"**/*.go",important:!0},{languages:["go"],important:!0}]},"vscjava.vscode-java-pack":{onFileOpen:[{pathGlob:"{**/*.java}",important:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},{languages:["java"],important:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}]},"ms-vscode.PowerShell":{onFileOpen:[{pathGlob:"{**/*.ps1,**/*.psd1,**/*.psm1}",important:!0},{languages:["powershell"],important:!0},{pathGlob:"{**/*.ps.config,**/*.ps1.config}"}]},"ms-vscode.cpptools-extension-pack":{onFileOpen:[{pathGlob:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}",important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]},{languages:["c","cpp"],important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]}]},"ms-azuretools.vscode-docker":{onFileOpen:[{pathGlob:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}",important:!0},{languages:["dockerfile"],important:!0},{pathGlob:"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}"}]},"vue.volar":{onFileOpen:[{pathGlob:"{**/*.vue}",important:!0},{languages:["vue"],important:!0}]},"ms-vscode.makefile-tools":{onFileOpen:[{pathGlob:"{**/makefile,**/Makefile}",important:!0},{languages:["makefile"],important:!0}]},"ms-vscode.cmake-tools":{onFileOpen:[{pathGlob:"{**/CMakeLists.txt}",important:!0}]},"ms-azure-devops.azure-pipelines":{onFileOpen:[{pathGlob:"{**/azure-pipelines.yaml}",important:!0}]},"msazurermtools.azurerm-vscode-tools":{onFileOpen:[{pathGlob:"{**/azuredeploy.json}",important:!0}]},"ms-vscode-remote.remote-containers":{onFileOpen:[{pathGlob:"{**/devcontainer.json}",important:!0}]},"ms-azuretools.vscode-bicep":{onFileOpen:[{pathGlob:"{**/*.bicep}",important:!0}]},"svelte.svelte-vscode":{onFileOpen:[{pathGlob:"{**/*.svelte}",important:!0}]},"ms-vscode.vscode-github-issue-notebooks":{onFileOpen:[{pathGlob:"{**/*.github-issues}",important:!0}]},"ms-playwright.playwright":{onFileOpen:[{pathGlob:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}",important:!0}]},"vscjava.vscode-gradle":{onFileOpen:[{pathGlob:"{**/gradlew,**/gradlew.bat,**/build.gradle,**/build.gradle.kts,**/settings.gradle,**/settings.gradle.kts}",important:!0}]},"REditorSupport.r":{onFileOpen:[{pathGlob:"{**/*.r}",important:!0},{languages:["r"],important:!0}]},"firefox-devtools.vscode-firefox-debug":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}"}]},"ms-edgedevtools.vscode-edge-devtools":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}"}]},"Ionide.Ionide-fsharp":{onFileOpen:[{pathGlob:"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}"}]},"dbaeumer.vscode-eslint":{onFileOpen:[{pathGlob:"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}"}]},"ms-vscode.vscode-typescript-tslint-plugin":{onFileOpen:[{pathGlob:"{**/tslint.json}"}]},"bmewburn.vscode-intelephense-client":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"xdebug.php-debug":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"rust-lang.rust-analyzer":{onFileOpen:[{pathGlob:"{**/*.rs,**/*.rslib}"}]},"DavidAnson.vscode-markdownlint":{onFileOpen:[{pathGlob:"{**/*.md}"}]},"EditorConfig.EditorConfig":{onFileOpen:[{pathGlob:"{**/.editorconfig}"}]},"HookyQR.beautify":{onFileOpen:[{pathGlob:"{**/.jsbeautifyrc}"}]},"donjayamanne.githistory":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"felipecaputo.git-project-manager":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"eamodio.gitlens":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"Shopify.ruby-lsp":{onFileOpen:[{pathGlob:"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}"}]},"DotJoshJohnson.xml":{onFileOpen:[{pathGlob:"{**/*.xml}"}]},"stylelint.vscode-stylelint":{onFileOpen:[{pathGlob:"{**/.stylelintrc,**/stylelint.config.js}"}]},"ms-mssql.mssql":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"mtxr.sqltools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"usqlextpublisher.usql-vscode-ext":{onFileOpen:[{pathGlob:"{**/*.usql}"}]},"ms-vscode.sublime-keybindings":{onFileOpen:[{pathGlob:"{**/.sublime-project,**/.sublime-workspace}"}]},"k--kato.intellij-idea-keybindings":{onFileOpen:[{pathGlob:"{**/.idea}"}]},"christian-kohler.npm-intellisense":{onFileOpen:[{pathGlob:"{**/package.json}"}]},"cake-build.cake-vscode":{onFileOpen:[{pathGlob:"{**/build.cake}"}]},"Angular.ng-template":{onFileOpen:[{pathGlob:"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}"}]},"vscjava.vscode-maven":{onFileOpen:[{pathGlob:"**/pom.xml"}]},"ms-azuretools.vscode-azureterraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"HashiCorp.terraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"vsciot-vscode.vscode-arduino":{onFileOpen:[{pathGlob:"**/*.ino"}]},"ms-kubernetes-tools.vscode-kubernetes-tools":{onFileOpen:[{pathGlob:"{**/Chart.yaml}"}]},"GoogleCloudTools.cloudcode":{onFileOpen:[{pathGlob:"{**/skaffold.yaml}"}]},"Oracle.oracledevtools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"betterthantomorrow.calva":{onFileOpen:[{pathGlob:"{**/*.clj,**/*.cljs}"}]},"Pivotal.vscode-boot-dev-pack":{onFileOpen:[{pathGlob:"{**/application.properties}"}]},"GitHub.copilot":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.py,**/*.go,**/*.rb}"}],onSettingsEditorOpen:{}},"GitHub.vscode-github-actions":{onFileOpen:[{pathGlob:"{**/.github/workflows/*.yml}",important:!0}]},"circleci.circleci":{onFileOpen:[{pathGlob:"{**/.circleci/config.yml}"}]},"mechatroner.rainbow-csv":{onFileOpen:[{pathGlob:"**/*.csv",important:!0}]},"tomoki1207.pdf":{onFileOpen:[{pathGlob:"**/*.pdf",important:!0}]}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csharp","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","Shopify.ruby-lsp","GitHub.copilot"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",contentPattern:"^\\s*url\\s*=\\s*https:\\/\\/github\\.com.*$"},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}},"pyproject-formatter":{configPath:"pyproject.toml",configName:"Python Formatter",recommendations:{"ms-python.black-formatter":{name:"Black Formatter",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?black"?\\s*[\\].])|("black\\s*["[(<=>!~;@])'},"ms-python.autopep8":{name:"Autopep8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?autopep8"?\\s*[\\].])|("autopep8\\s*["[(<=>!~;@])'}}},"pep8-formatter":{configPath:".pep8",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8"}}},"python-setup-cgf-formatter":{configPath:"setup.cfg",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"tox-ini-formatter":{configPath:"tox.ini",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"pyproject-linter":{configPath:"pyproject.toml",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?pylint"?\\s*[\\].])|("pylint\\s*["[(<=>!~;@])'},"charliermarsh.ruff":{name:"Ruff",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?ruff"?\\s*[\\].])|("ruff\\s*["[(<=>!~;@])'},"ms-python.mypy-type-checker":{name:"Mypy Type Checker",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?mypy"?\\s*[\\].])|("mypy\\s*["[(<=>!~;@])'},"ms-python.flake8":{name:"Flake8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?flake8"?\\s*[\\].])|("flake8\\s*["[(<=>!~;@])'}}},".pylintrc-linter":{configPath:".pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"pylintrc-linter":{configPath:"pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"mypy-ini-linter":{configPath:".mypy.ini",configName:"Python Linter",recommendations:{"ms-python.mypy-type-checker":{name:"Mypy Type Checker"}}},"tox-ini-linter":{configPath:"tox.ini",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}},".flake8-linter":{configPath:".flake8",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8"}}},"python-setup-cgf-linter":{configPath:"setup.cfg",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},azd:{friendlyName:"Azure Dev CLI",windowsPath:"%USERPROFILE%\\AppData\\Local\\Programs\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},"azd-user":{friendlyName:"Azure Dev CLI",windowsPath:"%ProgramFiles%\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],virtualWorkspaceExtensionTips:{"vscode-vfs":{friendlyName:"Remote Repositories",extensionId:"ms-vscode.remote-repositories",startEntry:{helpLink:"https://aka.ms/vscode-remote/remote-repositories",startConnectLabel:"Remote Repository",startCommand:"remoteHub.continueOn.openRepository",priority:5}}},remoteExtensionTips:{wsl:{friendlyName:"WSL",extensionId:"ms-vscode-remote.remote-wsl",supportedPlatforms:["Windows","Web"],startEntry:{helpLink:"https://aka.ms/vscode-remote/wsl",startConnectLabel:"WSL",startCommand:"remote-wsl.connect",priority:3}},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/ssh",startConnectLabel:"SSH ",startCommand:"opensshremotes.openEmptyWindowInCurrentWindow",priority:1}},"dev-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/containers",startConnectLabel:"Dev Container",startCommand:"remote-containers.reopenInContainer",priority:2}},"attached-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},codespaces:{friendlyName:"GitHub Codespaces",extensionId:"github.codespaces",startEntry:{helpLink:"https://aka.ms/vscode-remote-codespaces",startConnectLabel:"GitHub Codespace ",startCommand:"github.codespaces.connect",priority:4}},tunnel:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server",startEntry:{helpLink:"https://aka.ms/remote-tunnels-doc",startConnectLabel:"Tunnel",startCommand:"remote-tunnels.connectCurrentWindowToTunnel",priority:0}}},commandPaletteSuggestedCommandIds:["workbench.action.files.openFile","workbench.action.files.openFileFolder","workbench.action.files.openFolder","workbench.action.remote.showMenu","editor.action.formatDocument","editor.action.commentLine","workbench.action.tasks.runTask","workbench.action.openSettings2","workbench.action.selectTheme","workbench.action.openWalkthrough","workbench.action.openIssueReporter"],extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",serverDocumentationUrl:"https://aka.ms/vscode-server-doc",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",youTubeUrl:"https://aka.ms/vscode-youtube",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",serverLicenseUrl:"https://aka.ms/vscode-server-license",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=521839",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",nodejsRepository:"Microsoft/vscode-node",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05},{surveyId:"csharp.1",surveyUrl:"https://www.research.net/r/8KGJ9V8",languageId:"csharp",editCount:10,userProbability:.05}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver","testMessageContextValue"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","contribShareMenu","contribStatusBarItems","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-toolsai.vscode-ai-remote":["resolvers"],"ms-python.python":["contribEditorContentMenu","quickPickSortByLabel","portsAttributes","testObserver","envShellEvent","quickPickItemTooltip","terminalDataWriteEvent","saveEditor"],"ms-dotnettools.dotnet-interactive-vscode":["notebookMessaging","languageConfigurationAutoClosingPairs"],"GitHub.codespaces":["contribEditSessions","contribMenuBarHome","contribRemoteHelp","contribViewsRemote","resolvers","tunnels","terminalDataWriteEvent","treeViewReveal","notebookKernelSource"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["canonicalUriProvider","contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","contribShareMenu","documentFiltersExclusive","editSessionIdentityProvider","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","shareProvider","scmActionButton","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-vscode-remote.remote-wsl":["resolvers","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode.remote-server":["resolvers","tunnels","contribViewsWelcome"],"ms-vscode.remote-explorer":["contribRemoteHelp","contribViewsRemote","extensionsAny"],"ms-vscode-remote.remote-containers":["contribEditSessions","resolvers","tunnels","workspaceTrust","terminalDimensions","contribRemoteHelp","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"GitHub.vscode-pull-request-github":["contribCommentThreadAdditionalMenu","tokenInformation","contribShareMenu","fileComments","contribCommentPeekContext","codiconDecoration","diffCommand","contribCommentEditorActionsMenu","readonlyMessage","treeViewMarkdownMessage","shareProvider","quickDiffProvider"],"GitHub.copilot":["inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsAdditions"],"GitHub.copilot-chat":["handleIssueUri","interactive","interactiveUserActions","terminalContextMenu","terminalDataWriteEvent","terminalSelection","terminalQuickFixProvider","chatSlashCommands","readonlyMessage","mappedEditsProvider","aiRelatedInformation"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-python.gather":["notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookCellExecutionState"],"ms-toolsai.jupyter-renderers":["contribNotebookStaticPreloads"],"ms-toolsai.jupyter":["notebookDeprecated","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource","interactiveWindow","notebookControllerAffinityHidden","contribNotebookStaticPreloads","quickPickItemTooltip","notebookExecution"],"dbaeumer.vscode-eslint":["notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["tunnels"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-azuretools.vscode-azureresourcegroups":["authGetSessions"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"],"redhat.java":["documentPaste"],"ms-dotnettools.csdevkit":["inlineCompletionsAdditions"],"ms-dotnettools.vscodeintellicode-csharp":["inlineCompletionsAdditions"],"microsoft-IsvExpTools.powerplatform-vscode":["fileSearchProvider","textSearchProvider"],"microsoft-IsvExpTools.powerplatform-vscode-preview":["fileSearchProvider","textSearchProvider"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://*.github.com","https://login.microsoftonline.com","https://*.vscode.dev","https://*.github.dev","https://gh.io","https://portal.azure.com"],trustedExtensionAuthAccess:["vscode.git","vscode.github","ms-vscode.remote-repositories","github.remotehub","ms-vscode.azure-repos","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","ms-vsliveshare.vsliveshare","github.copilot","github.copilot-chat","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{github:{scopes:["user:email"]},microsoft:{scopes:["openid","profile","email","offline_access"]}}},"editSessions.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},tunnelServerQualities:{stable:{serverApplicationName:"code-server"},exploration:{serverApplicationName:"code-server-exploration"},insider:{serverApplicationName:"code-server-insiders"}},tunnelApplicationName:"code-tunnel",tunnelApplicationConfig:{editorWebUrl:"https://vscode.dev",extension:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server"},authenticationProviders:{github:{scopes:["user:email","read:org"]}}},win32TunnelServiceMutex:"vscode-tunnelservice",win32TunnelMutex:"vscode-tunnel",commonlyUsedSettings:["files.autoSave","editor.fontSize","editor.fontFamily","GitHub.copilot.manageExtension","editor.tabSize","editor.renderWhitespace","editor.cursorStyle","editor.multiCursorModifier","editor.insertSpaces","editor.wordWrap","files.exclude","files.associations","workbench.editor.enablePreview"],builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.82.0",sha256:"4fba41b4b764c3f5a6591d6d9a5bdc59b417f2d799071c889c2b54163f256282",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",sha256:"b9dab017506d9e6a469a0f82b392e4cb1d7a25a4843f1db8ba396cbee209cfc5",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode-remote.remote-wsl-recommender",version:"0.0.19",sha256:"926095d290dc7cdb9daf40ef5ae7591db12171ba1af1f61afcb5a368d0fc66aa",repo:"https://github.com/microsoft/vscode-remote-wsl-recommender",metadata:{id:"cb296d3c-017a-4dee-83af-ebb5a5a16e9a",publisherId:{publisherId:"ac9410a2-0d75-40ec-90de-b59bb705801d",publisherName:"ms-vscode-remote",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"},platforms:["win32"],clientOnly:!0}],walkthroughMetadata:[{id:"Setup",steps:[{id:"copilotInstall",title:"Supercharge your coding with AI-based suggestions",description:`Throw that rubber duck away! Code more efficiently with AI at your fingertips. Try [GitHub Copilot](command:extension.open?"github.copilot") free for 60 days.
[Install Copilot](command:workbench.extensions.installExtension?%22github.copilot%22)`,media:{type:"image",altText:"Copilot Statistics",path:"copilotStep.png"}}]}],featuredExtensions:[{id:"github.copilot",title:"GitHub Copilot",description:"Supercharge your coding experience for as little as $10/month with cutting edge AI code generation."}],aiGeneratedWorkspaceTrust:{title:"This workspace was generated by GitHub Copilot",checkboxText:"Trust the contents of all files in this workspace",trustOption:"Yes, I trust the contents",dontTrustOption:"No, I don't trust the contents",startupTrustRequestLearnMore:"If you don't trust the contents of the files generated by GitHub Copilot, we recommend continuing in restricted mode. See [our docs](https://aka.ms/vscode-workspace-trust) to learn more. "},version:"1.82.3",commit:"fdb98833154679dbaa7af67a5a29fe19e55c2b73",date:"2023-10-02T10:18:39.850Z"},Object.keys(h).length===0&&Object.assign(h,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=h}),define(Se[133],De([1,0,6]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$0i=void 0,e.$0i=(0,S.$ph)("productService"),e.$$i="vscode://schemas/vscode-product"});var Be=this&&this.__param||function(me,e){return function(S,F){e(S,F,me)}};define(Se[83],De([1,0,13,22,3,6]),function(me,e,S,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wu=e.$Vu=e.$Uu=e.$Tu=e.$Su=e.ProgressLocation=e.$Ru=void 0,e.$Ru=(0,L.$ph)("progressService");var A;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$Su=Object.freeze({total(){},worked(){},done(){}});class f{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(I,$){this.c=I,this.report=$?.async?this.e.bind(this):this.d.bind(this)}d(I){this.a=I,this.c(this.a)}e(I){Promise.resolve(this.b).finally(()=>{this.a=I;const $=this.c(this.a);this.b=Promise.resolve($).finally(()=>this.b=void 0)})}}e.$Tu=f;let w=class extends h.$lb{constructor(I,$){super(),this.a=new S.$Pg,$.withProgress(I,k=>(this.b=k,this.c&&k.report(this.c),this.a.p)),this.B((0,h.$jb)(()=>this.a.complete()))}report(I){this.b?this.b.report(I):this.c=I}};e.$Uu=w,e.$Uu=w=Je([Be(1,e.$Ru)],w);class g extends h.$lb{constructor(I){super(),this.g=I,this.a=0,this.b=this.B(new h.$kb)}start(I){this.stop();const $=++this.a,k=new F.$oc;return this.f=setTimeout(()=>{$===this.a&&(this.c=this.g.show(!0))},I),this.b.add((0,h.$jb)(()=>clearTimeout(this.f))),this.b.add((0,h.$jb)(()=>k.cancel())),this.b.add((0,h.$jb)(()=>this.c?this.c.done():void 0)),{id:$,token:k.token,stop:()=>this.h($),isCurrent:()=>this.a===$}}stop(){this.h(this.a)}h(I){this.a===I&&this.b.clear()}}e.$Vu=g,e.$Wu=(0,L.$ph)("editorProgressService")}),define(Se[42],De([1,0,54,19]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=void 0;class h{constructor(){this.a=new Map}add(A,f){S.ok(F.$ie(A)),S.ok(F.$ke(f)),S.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,f)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$Um=new h}),define(Se[104],De([1,0,4,42]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=void 0,e.$Vm={JSONContribution:"base.contributions.json"};function h(f){return f.length>0&&f.charAt(f.length-1)==="#"?f.substring(0,f.length-1):f}class L{constructor(){this.b=new S.$ec,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(w,g){this.a[h(w)]=g,this.b.fire(w)}notifySchemaChanged(w){this.b.fire(w)}getSchemaContributions(){return{schemas:this.a}}}const A=new L;F.$Um.add(e.$Vm.JSONContribution,A)}),define(Se[134],De([1,0,18,4,19,184,50,104,42]),function(me,e,S,F,h,L,A,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.ConfigurationScope=e.$Zm=e.EditPresentationTypes=void 0;var g;(function(D){D.Multiline="multilineText",D.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$Zm={Configuration:"base.contributions.configuration"};var P;(function(D){D[D.APPLICATION=1]="APPLICATION",D[D.MACHINE=2]="MACHINE",D[D.WINDOW=3]="WINDOW",D[D.RESOURCE=4]="RESOURCE",D[D.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",D[D.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$1m={properties:{},patternProperties:{}},e.$2m={properties:{},patternProperties:{}},e.$3m={properties:{},patternProperties:{}},e.$4m={properties:{},patternProperties:{}},e.$5m={properties:{},patternProperties:{}},e.$6m={properties:{},patternProperties:{}},e.$7m="vscode://schemas/settings/resourceLanguage",e.$8m="vscode://schemas/settings/configurationDefaults";const I=w.$Um.as(f.$Vm.JSONContribution);class ${constructor(){this.h=new Set,this.i=new F.$ec,this.onDidSchemaChange=this.i.event,this.j=new F.$ec,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$7m,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const s=new Set;this.n(t,r,s),I.registerSchema(e.$7m,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const r=new Set;this.o(t,r),I.registerSchema(e.$7m,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const s=new Set;this.o(r,s),this.n(t,!1,s),I.registerSchema(e.$7m,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const s=[];for(const{overrides:i,source:c}of t)for(const l in i)if(r.add(l),e.$0m.test(l)){const b=this.a.get(l),y=b?.valuesSources??new Map;if(c)for(const R of Object.keys(i[l]))y.set(R,c);const u={...b?.value||{},...i[l]};this.a.set(l,{source:c,value:u,valuesSources:y});const d=(0,A.$6h)(l),p={type:"object",default:u,description:L.localize(1,null,d),$ref:e.$7m,defaultDefaultValue:u,source:h.$ie(c)?void 0:c,defaultValueSource:c};s.push(...E(l)),this.d[l]=p,this.b.properties[l]=p}else{this.a.set(l,{value:i[l],source:c});const b=this.d[l];b&&(this.w(l,b),this.r(l,b))}this.m(s)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:s,source:i}of t)for(const c in s){const l=this.a.get(c),b=h.$ie(i)?i:i?.id,y=h.$ie(l?.source)?l?.source:l?.source?.id;if(b===y)if(r.add(c),this.a.delete(c),e.$0m.test(c))delete this.d[c],delete this.b.properties[c];else{const u=this.d[c];u&&(this.w(c,u),this.r(c,u))}}this.u()}deltaConfiguration(t){let r=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,s){t.forEach(i=>{this.p(i,r,i.extensionInfo,i.restrictedProperties,void 0,s),this.c.push(i),this.q(i)})}o(t,r){const s=i=>{if(i.properties)for(const c in i.properties){r.add(c);const l=this.d[c];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[c],this.s(c,i.properties[c])}i.allOf?.forEach(c=>s(c))};for(const i of t){s(i);const c=this.c.indexOf(i);c!==-1&&this.c.splice(c,1)}}p(t,r=!0,s,i,c=3,l){c=h.$re(t.scope)?c:t.scope;const b=t.properties;if(b)for(const u in b){const d=b[u];if(r&&m(u,d)){delete b[u];continue}if(d.source=s,d.defaultDefaultValue=b[u].default,this.w(u,d),e.$0m.test(u)?d.scope=void 0:(d.scope=h.$re(d.scope)?c:d.scope,d.restricted=h.$re(d.restricted)?!!i?.includes(u):d.restricted),b[u].hasOwnProperty("included")&&!b[u].included){this.f[u]=b[u],delete b[u];continue}else this.d[u]=b[u],b[u].policy?.name&&this.e.set(b[u].policy.name,u);!b[u].deprecationMessage&&b[u].markdownDeprecationMessage&&(b[u].deprecationMessage=b[u].markdownDeprecationMessage),l.add(u)}const y=t.allOf;if(y)for(const u of y)this.p(u,r,s,i,c,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=s=>{const i=s.properties;if(i)for(const l in i)this.r(l,i[l]);s.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$1m.properties[t]=r,r.scope){case 1:e.$2m.properties[t]=r;break;case 2:e.$3m.properties[t]=r;break;case 6:e.$4m.properties[t]=r;break;case 3:e.$5m.properties[t]=r;break;case 4:e.$6m.properties[t]=r;break;case 5:e.$6m.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$1m.properties[t],r.scope){case 1:delete e.$2m.properties[t];break;case 2:delete e.$3m.properties[t];break;case 6:delete e.$4m.properties[t];break;case 3:delete e.$5m.properties[t];break;case 4:case 5:delete e.$6m.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,s={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$7m};this.w(r,s),e.$1m.properties[r]=s,e.$2m.properties[r]=s,e.$3m.properties[r]=s,e.$4m.properties[r]=s,e.$5m.properties[r]=s,e.$6m.properties[r]=s}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$7m};e.$1m.patternProperties[e.$9m]=t,e.$2m.patternProperties[e.$9m]=t,e.$3m.patternProperties[e.$9m]=t,e.$4m.patternProperties[e.$9m]=t,e.$5m.patternProperties[e.$9m]=t,e.$6m.patternProperties[e.$9m]=t,this.i.fire()}w(t,r){const s=this.a.get(t);let i=s?.value,c=s?.source;h.$pe(i)&&(i=r.defaultDefaultValue,c=void 0),h.$pe(i)&&(i=o(r.type)),r.default=i,r.defaultValueSource=c}}const k="\\[([^\\]]+)\\]",C=new RegExp(k,"g");e.$9m=`^(${k})+$`,e.$0m=new RegExp(e.$9m);function E(D){const t=[];if(e.$0m.test(D)){let r=C.exec(D);for(;r?.length;){const s=r[1].trim();s&&t.push(s),r=C.exec(D)}}return(0,S.$of)(t)}e.$$m=E;function n(D){return D.reduce((t,r)=>`${t}[${r}]`,"")}e.$_m=n;function o(D){switch(Array.isArray(D)?D[0]:D){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$an=o;const a=new $;w.$Um.add(e.$Zm.Configuration,a);function m(D,t){return D.trim()?e.$0m.test(D)?L.localize(7,null,D):a.getConfigurationProperties()[D]!==void 0?L.localize(8,null,D):t.policy?.name&&a.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,D,t.policy?.name,a.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.$bn=m;function v(){const D=[],t=a.getConfigurationProperties();for(const r of Object.keys(t))D.push([r,t[r].scope]);return D.push(["launch",4]),D.push(["task",4]),D}e.$cn=v}),define(Se[238],De([1,0,18,4,154,3,28,23,19,2,50,134,42]),function(me,e,S,F,h,L,A,f,w,g,P,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=void 0;function k(r){return Object.isFrozen(r)?r:f.$Jm(r)}class C{constructor(s={},i=[],c=[],l){this.b=s,this.c=i,this.d=c,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(i=>{if(i instanceof C)return i;const c=new E("");return c.parseRaw(i),c.configurationModel});this.f=s.reduce((i,c)=>c===i?c:i.merge(c),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,P.$4h)(this.contents,s):this.contents}inspect(s,i){const c=this.rawConfiguration.getValue(s),l=i?this.rawConfiguration.getOverrideValue(s,i):void 0,b=i?this.rawConfiguration.override(i).getValue(s):c;return{value:c,override:l,merged:b}}getOverrideValue(s,i){const c=this.i(i);return c?s?(0,P.$4h)(c,s):c:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const c of this.overrides)c.identifiers.includes(s)&&i.push(...c.keys);return S.$of(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return S.$of(s)}override(s){let i=this.a.get(s);return i||(i=this.g(s),this.a.set(s,i)),i}merge(...s){const i=f.$Im(this.contents),c=f.$Im(this.overrides),l=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const y of s)if(b.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.h(i,y.contents);for(const u of y.overrides){const[d]=c.filter(p=>S.$$e(p.identifiers,u.identifiers));d?(this.h(d.contents,u.contents),d.keys.push(...u.keys),d.keys=S.$of(d.keys)):c.push(f.$Im(u))}for(const u of y.keys)l.indexOf(u)===-1&&l.push(u)}return new C(i,l,c,b.every(y=>y instanceof C)?void 0:b)}g(s){const i=this.i(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const c={};for(const l of S.$of([...Object.keys(this.contents),...Object.keys(i)])){let b=this.contents[l];const y=i[l];y&&(typeof b=="object"&&typeof y=="object"?(b=f.$Im(b),this.h(b,y)):b=y),c[l]=b}return new C(c,this.keys,this.overrides)}h(s,i){for(const c of Object.keys(i)){if(c in s&&w.$ke(s[c])&&w.$ke(i[c])){this.h(s[c],i[c]);continue}s[c]=f.$Im(i[c])}}i(s){let i=null,c=null;const l=b=>{b&&(c?this.h(c,b):c=f.$Im(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===s?i=b.contents:b.identifiers.includes(s)&&l(b.contents);return l(i),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,i){this.j(s,i,!0)}setValue(s,i){this.j(s,i,!1)}removeValue(s){const i=this.keys.indexOf(s);i!==-1&&(this.keys.splice(i,1),(0,P.$3h)(this.contents,s),I.$0m.test(s)&&this.overrides.splice(this.overrides.findIndex(c=>S.$$e(c.identifiers,(0,I.$$m)(s))),1))}j(s,i,c){(0,P.$2h)(this.contents,s,i,l=>console.error(l)),c=c||this.keys.indexOf(s)===-1,c&&this.keys.push(s),I.$0m.test(s)&&this.overrides.push({identifiers:(0,I.$$m)(s),keys:Object.keys(this.contents[s]),contents:(0,P.$1h)(this.contents[s],l=>console.error(l))})}}e.$dn=C;class E{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new C}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,i){if(!w.$re(s)){const c=this.g(s);this.parseRaw(c,i)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,i){this.a=s;const{contents:c,keys:l,overrides:b,restricted:y,hasExcludedProperties:u}=this.h(s,i);this.b=new C(c,l,b,u?[s]:void 0),this.c=y||[]}g(s){let i={},c=null,l=[];const b=[],y=[];function u(p){Array.isArray(l)?l.push(p):c!==null&&(l[c]=p)}const d={onObjectBegin:()=>{const p={};u(p),b.push(l),l=p,c=null},onObjectProperty:p=>{c=p},onObjectEnd:()=>{l=b.pop()},onArrayBegin:()=>{const p=[];u(p),b.push(l),l=p,c=null},onArrayEnd:()=>{l=b.pop()},onLiteralValue:u,onError:(p,R,O)=>{y.push({error:p,offset:R,length:O})}};if(s)try{h.$Fm(s,d),i=l[0]||{}}catch(p){console.error(`Error while parsing settings file ${this.f}: ${p}`),this.d=[p]}return i}h(s,i){const c=$.$Um.as(I.$Zm.Configuration).getConfigurationProperties(),l=this.i(s,c,!0,i);s=l.raw;const b=(0,P.$1h)(s,d=>console.error(`Conflict in settings file ${this.f}: ${d}`)),y=Object.keys(s),u=this.j(s,d=>console.error(`Conflict in settings file ${this.f}: ${d}`));return{contents:b,keys:y,overrides:u,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(s,i,c,l){let b=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:b};const y={},u=[];for(const d in s)if(I.$0m.test(d)&&c){const p=this.i(s[d],i,!1,l);y[d]=p.raw,b=b||p.hasExcludedProperties,u.push(...p.restricted)}else{const p=i[d],R=p?typeof p.scope<"u"?p.scope:3:void 0;p?.restricted&&u.push(d),!l.exclude?.includes(d)&&(l.include?.includes(d)||(R===void 0||l.scopes===void 0||l.scopes.includes(R))&&!(l.skipRestricted&&p?.restricted))?y[d]=s[d]:b=!0}return{raw:y,restricted:u,hasExcludedProperties:b}}j(s,i){const c=[];for(const l of Object.keys(s))if(I.$0m.test(l)){const b={};for(const y in s[l])b[y]=s[l][y];c.push({identifiers:(0,I.$$m)(l),keys:Object.keys(b),contents:(0,P.$1h)(b,i)})}return c}}e.$en=E;class n extends L.$lb{constructor(s,i,c,l){super(),this.c=s,this.f=i,this.g=l,this.b=this.B(new F.$ec),this.onDidChange=this.b.event,this.a=new E(this.c.toString()),this.B(this.g.watch(c.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&c.isEqual(b.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new C}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$fn=n;class o{constructor(s,i,c,l,b,y,u,d,p,R,O,j,T){this.a=s,this.b=i,this.c=c,this.overrideIdentifiers=l,this.d=b,this.f=y,this.g=u,this.h=d,this.i=p,this.j=R,this.k=O,this.l=j,this.m=T}get value(){return k(this.c)}n(s,i,c){const l=s.inspect(i,c);return{get value(){return k(l.value)},get override(){return k(l.override)},get merged(){return k(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class a{constructor(s,i,c,l,b=new C,y=new C,u=new A.$ni,d=new C,p=new A.$ni){this.c=s,this.d=i,this.f=c,this.g=l,this.h=b,this.i=y,this.j=u,this.l=d,this.m=p,this.a=null,this.b=new A.$ni,this.n=null}getValue(s,i,c){return this.q(s,i,c).getValue(s)}updateValue(s,i,c={}){let l;c.resource?(l=this.m.get(c.resource),l||(l=new C,this.m.set(c.resource,l))):l=this.l,i===void 0?l.removeValue(s):l.setValue(s,i),c.resource||(this.a=null)}inspect(s,i,c){const l=this.q(s,i,c),b=this.u(i.resource,c),y=i.resource?this.m.get(i.resource)||this.l:this.l,u=new Set;for(const d of l.overrides)for(const p of d.identifiers)l.getOverrideValue(s,p)!==void 0&&u.add(p);return new o(s,i,l.getValue(s),u.size?[...u]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this.i:void 0,b||void 0,y)}keys(s){const i=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,i){this.j.set(s,i),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const c=[];if(!i){const{added:l,updated:b,removed:y}=D(this.c,s);i=[...l,...b,...y]}for(const l of i)for(const b of(0,I.$$m)(l)){const y=this.c.getKeysForOverrideIdentifier(b),u=s.getKeysForOverrideIdentifier(b),d=[...u.filter(p=>y.indexOf(p)===-1),...y.filter(p=>u.indexOf(p)===-1),...y.filter(p=>!f.$Mm(this.c.override(b).getValue(p),s.override(b).getValue(p)))];c.push([b,d])}return this.updateDefaultConfiguration(s),{keys:i,overrides:c}}compareAndUpdatePolicyConfiguration(s){const{added:i,updated:c,removed:l}=D(this.d,s),b=[...i,...c,...l];return b.length&&this.updatePolicyConfiguration(s),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:i,updated:c,removed:l,overrides:b}=D(this.applicationConfiguration,s),y=[...i,...c,...l];return y.length&&this.updateApplicationConfiguration(s),{keys:y,overrides:b}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:c,removed:l,overrides:b}=D(this.localUserConfiguration,s),y=[...i,...c,...l];return y.length&&this.updateLocalUserConfiguration(s),{keys:y,overrides:b}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:c,removed:l,overrides:b}=D(this.remoteUserConfiguration,s),y=[...i,...c,...l];return y.length&&this.updateRemoteUserConfiguration(s),{keys:y,overrides:b}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:c,removed:l,overrides:b}=D(this.workspaceConfiguration,s),y=[...i,...c,...l];return y.length&&this.updateWorkspaceConfiguration(s),{keys:y,overrides:b}}compareAndUpdateFolderConfiguration(s,i){const c=this.p.get(s),{added:l,updated:b,removed:y,overrides:u}=D(c,i),d=[...l,...b,...y];return(d.length||!c)&&this.updateFolderConfiguration(s,i),{keys:d,overrides:u}}compareAndDeleteFolderConfiguration(s){const i=this.p.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:c,updated:l,removed:b,overrides:y}=D(i,void 0);return{keys:[...c,...l,...b],overrides:y}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,i,c){let l=this.r(i,c);return i.overrideIdentifier&&(l=l.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(l=l.merge(this.d)),l}r({resource:s},i){let c=this.s();if(i&&s){const l=i.getFolder(s);l&&(c=this.t(l.uri)||c);const b=this.m.get(s);b&&(c=c.merge(b))}return c}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let i=this.b.get(s);if(!i){const c=this.s(),l=this.j.get(s);l?(i=c.merge(l),this.b.set(s,i)):i=c}return i}u(s,i){if(i&&s){const c=i.getFolder(s);if(c)return this.j.get(c.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,i)=>{const{contents:c,overrides:l,keys:b}=this.j.get(i);return s.push([i,{contents:c,overrides:l,keys:b}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(i=>s.add(i)),this.userConfiguration.keys.forEach(i=>s.add(i)),this.i.keys.forEach(i=>s.add(i)),this.j.forEach(i=>i.keys.forEach(c=>s.add(c))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(c=>s.add(c))),[...s.values()]}w(s){const i=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(c=>i.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(c=>i.add(c)),this.i.getKeysForOverrideIdentifier(s).forEach(c=>i.add(c)),this.j.forEach(c=>c.getKeysForOverrideIdentifier(s).forEach(l=>i.add(l))),[...i.values()]}static parse(s){const i=this.x(s.defaults),c=this.x(s.policy),l=this.x(s.application),b=this.x(s.user),y=this.x(s.workspace),u=s.folders.reduce((d,p)=>(d.set(g.URI.revive(p[0]),this.x(p[1])),d),new A.$ni);return new a(i,c,l,b,new C,y,u,new C,new A.$ni)}static x(s){return new C(s.contents,s.keys,s.overrides)}}e.$gn=a;function m(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const s=new Set,i=new Map;for(const l of r)l.keys.forEach(b=>s.add(b)),l.overrides.forEach(([b,y])=>{const u=(0,A.$ki)(i,b,new Set);y.forEach(d=>u.add(d))});const c=[];return i.forEach((l,b)=>c.push([b,[...l.values()]])),{keys:[...s.values()],overrides:c}}e.$hn=m;class v{constructor(s,i,c,l){this.change=s,this.f=i,this.g=c,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const b of s.keys)this.affectedKeys.add(b);for(const[,b]of s.overrides)for(const y of b)this.affectedKeys.add(y);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=a.parse(this.f.data)),this.i}affectsConfiguration(s,i){const c=this.a+s,l=this.d.indexOf(c);if(l<0)return!1;const b=l+c.length;if(b>=this.d.length)return!1;const y=this.d.charCodeAt(b);if(y!==this.b&&y!==this.c)return!1;if(i){const u=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.f?.workspace):void 0,d=this.g.getValue(s,i,this.h);return!f.$Mm(u,d)}return!0}}e.$in=v;function D(r,s){const{added:i,removed:c,updated:l}=t(s?.rawConfiguration,r?.rawConfiguration),b=[],y=r?.getAllOverrideIdentifiers()||[],u=s?.getAllOverrideIdentifiers()||[];if(s){const d=u.filter(p=>!y.includes(p));for(const p of d)b.push([p,s.getKeysForOverrideIdentifier(p)])}if(r){const d=y.filter(p=>!u.includes(p));for(const p of d)b.push([p,r.getKeysForOverrideIdentifier(p)])}if(s&&r){for(const d of y)if(u.includes(d)){const p=t({contents:r.getOverrideValue(void 0,d)||{},keys:r.getKeysForOverrideIdentifier(d)},{contents:s.getOverrideValue(void 0,d)||{},keys:s.getKeysForOverrideIdentifier(d)});b.push([d,[...p.added,...p.removed,...p.updated]])}}return{added:i,removed:c,updated:l,overrides:b}}function t(r,s){const i=r?s?r.keys.filter(b=>s.keys.indexOf(b)===-1):[...r.keys]:[],c=s?r?s.keys.filter(b=>r.keys.indexOf(b)===-1):[...s.keys]:[],l=[];if(r&&s){for(const b of s.keys)if(r.keys.indexOf(b)!==-1){const y=(0,P.$4h)(s.contents,b),u=(0,P.$4h)(r.contents,b);f.$Mm(y,u)||l.push(b)}}return{added:i,removed:c,updated:l}}}),define(Se[239],De([1,0,21,4,3,80]),function(me,e,S,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zjb=e.$Yjb=e.$Xjb=e.$Wjb=void 0;const A=(g,P,I)=>{const $=new Uint8Array(16);for(let E=0;E<16;E++)$[E]=Math.round(Math.random()*256);const k=(0,S.$Yc)(S.$Ec.wrap($));return[`GET ws://localhost${g}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${k}`].join(`\r
`)+`\r
\r
`};e.$Wjb=A,e.$Xjb=S.$Ec.fromString(`\r
\r
`);async function f(g,P,I,$,k){g.write(S.$Ec.fromString((0,e.$Wjb)(P,I,$)));const C=new h.$kb;try{return await new Promise((E,n)=>{let o;C.add(g.onData(a=>{o?o=S.$Ec.concat([o,a],o.byteLength+a.byteLength):o=a;const m=o.indexOf(e.$Xjb);if(m===-1)return;E(g),g.pauseData();const v=o.slice(m+e.$Xjb.byteLength);v.byteLength&&k.onData.fire(v)})),C.add(g.onClose(a=>n(a??new Error("socket closed")))),C.add(g.onEnd(()=>n(new Error("socket ended"))))})}catch(E){throw g.dispose(),E}finally{C.dispose()}}e.$Yjb=f;class w extends h.$lb{constructor(P,I){super(),this.g=P,this.a=this.B(new F.$hc),this.onData=(...$)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...$)),this.b=this.B(new F.$ec),this.onDidDispose=this.b.event,this.f=!1,this.B(I.onData),this.B(I.onData.event($=>this.a.fire($))),this.onClose=this.B(I.onClose).event,this.onEnd=this.B(I.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(P,I){L.SocketDiagnostics.traceSocketEvent(this,this.g,P,I)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Zjb=w}),define(Se[84],De([1,0,8,6]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=e.RemoteAuthorityResolverErrorCode=e.$yk=e.$xk=e.RemoteConnectionType=e.$wk=void 0,e.$wk=(0,F.$ph)("remoteAuthorityResolverService");var h;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(h||(e.RemoteConnectionType=h={}));class L{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$xk=L;class A{constructor(I,$){this.host=I,this.port=$,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$yk=A;var f;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(f||(e.RemoteAuthorityResolverErrorCode=f={}));class w extends S.$ab{static isNotAvailable(I){return I instanceof w&&I._code===f.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof w&&I._code===f.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof w&&I._code===f.NoResolverFound}static isInvalidAuthority(I){return I instanceof w&&I._code===f.InvalidAuthority}static isHandled(I){return I instanceof w&&I.isHandled}constructor(I,$=f.Unknown,k){super(I),this._message=I,this._code=$,this._detail=k,this.isHandled=$===f.NotAvailable&&k===!0,Object.setPrototypeOf(this,w.prototype)}}e.$zk=w;function g(P){const I=P.indexOf("+");return I===-1?P:P.substring(0,I)}e.$Ak=g}),define(Se[60],De([1,0,16]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=void 0;function F(g){return g.scheme===S.Schemas.vscodeRemote?g.authority:void 0}e.$Bk=F;function h(g){if(!g)return;const P=g.indexOf("+");return P<0?g:g.substr(0,P)}e.$Ck=h;function L(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$Dk=L;function A(g){const{host:P,port:I}=w(g);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:I}}e.$Ek=A;function f(g,P){let{host:I,port:$}=w(g);return typeof $>"u"&&($=P),{host:I,port:$}}e.$Fk=f;function w(g){const P=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const I=g.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const $=g.match(/(.*):(\d+)$/);return $?{host:$[1],port:parseInt($[2],10)}:{host:g,port:void 0}}}),define(Se[25],De([1,0,15,6,60]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.TargetPlatform=e.ExtensionType=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=void 0,e.$Cl="extensions.user.cache",e.$Dl="extensions.builtin.cache",e.$El="undefined_publisher",e.$Fl=["ui","workspace","web"];function L(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.$Gl=L,e.$Hl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(A||(e.ExtensionType=A={}));var f;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(f||(e.TargetPlatform=f={}));class w{constructor(n){this.value=n,this._lower=n.toLowerCase()}static equals(n,o){if(typeof n>"u"||n===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof n=="string"||typeof o=="string"){const a=typeof n=="string"?n:n.value,m=typeof o=="string"?o:o.value;return S.$Ld(a,m)}return n._lower===o._lower}static toKey(n){return typeof n=="string"?n.toLowerCase():n._lower}}e.$Il=w;class g{get size(){return this.c.size}constructor(n){if(this.c=new Set,n)for(const o of n)this.add(o)}add(n){this.c.add(w.toKey(n))}delete(n){return this.c.delete(w.toKey(n))}has(n){return this.c.has(w.toKey(n))}}e.$Jl=g;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(n){this.c.delete(w.toKey(n))}get(n){return this.c.get(w.toKey(n))}has(n){return this.c.has(w.toKey(n))}set(n,o){this.c.set(w.toKey(n),o)}values(){return this.c.values()}forEach(n){this.c.forEach(n)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Kl=P;function I(E){return $(E)}e.$Ll=I;function $(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.$Ml=$;function k(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.$Nl=k;function C(E,n){if(n){const o=`onResolveRemoteAuthority:${(0,h.$Ck)(n)}`;return!!E.activationEvents?.includes(o)}return!1}e.$Ol=C,e.$Pl=(0,F.$ph)("IBuiltinExtensionsScannerService")}),define(Se[135],De([1,0,8,25]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pF=e.$oF=void 0;class h{constructor(){this.a=new Map,this.b=new WeakMap}register(A,f){this.a.set(A,f)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const f=Object.create(null);for(const w of A){const g=this.readActivationEvents(w);g.length>0&&(f[F.$Il.toKey(w.identifier)]=g)}return f}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const f=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return f;for(const w in A.contributes){const g=this.a.get(w);if(!g)continue;const P=A.contributes[w],I=Array.isArray(P)?P:[P];try{g(I,f)}catch($){(0,S.$Y)($)}}return f}}e.$oF=h,e.$pF=new h}),define(Se[240],De([1,0,13,21,22,8,4,3,61,37,31,80,84,60]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.PersistentConnectionEventType=e.$Mk=e.$Lk=e.$Kk=e.ConnectionType=void 0;const C=30*1e3;var E;(function(x){x[x.Management=1]="Management",x[x.ExtensionHost=2]="ExtensionHost",x[x.Tunnel=3]="Tunnel"})(E||(e.ConnectionType=E={}));function n(x){switch(x){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(x){const N=new h.$oc;return setTimeout(()=>N.cancel(),x),N.token}function a(x,N){if(x.isCancellationRequested||N.isCancellationRequested)return h.CancellationToken.Cancelled;const q=new h.$oc;return x.onCancellationRequested(()=>q.cancel()),N.onCancellationRequested(()=>q.cancel()),q.token}class m{get didTimeout(){return this.c==="timedout"}constructor(N){this.c="pending",this.d=new f.$kb,this.promise=new Promise((q,de)=>{this.f=q,this.g=de}),N.isCancellationRequested?this.h():this.d.add(N.onCancellationRequested(()=>this.h()))}registerDisposable(N){this.c==="pending"?this.d.add(N):N.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const N=new Error("Time limit reached");return N.code="ETIMEDOUT",N.syscall="connect",N}resolve(N){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(N))}reject(N){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(N))}}function v(x,N){const q=new m(N);return q.registerDisposable(x.onControlMessage(de=>{const ye=JSON.parse(de.toString()),ve=ie(ye);ve?q.reject(ve):q.resolve(ye)})),q.promise}function D(x,N,q,de,ye,ve,we,Ee){const K=new m(Ee),ee=g.$ac.create(!1);return x.info(`Creating a socket (${we})...`),w.mark(`code/willCreateSocket/${ve}`),N.connect(q,de,ye,we).then(G=>{K.didTimeout?(w.mark(`code/didCreateSocketError/${ve}`),x.info(`Creating a socket (${we}) finished after ${ee.elapsed()} ms, but this is too late and has timed out already.`),G?.dispose()):(w.mark(`code/didCreateSocketOK/${ve}`),x.info(`Creating a socket (${we}) was successful after ${ee.elapsed()} ms.`),K.resolve(G))},G=>{w.mark(`code/didCreateSocketError/${ve}`),x.info(`Creating a socket (${we}) returned an error after ${ee.elapsed()} ms.`),x.error(G),K.reject(G)}),K.promise}function t(x,N){const q=new m(N);return x.then(de=>{q.didTimeout||q.resolve(de)},de=>{q.didTimeout||q.reject(de)}),q.promise}async function r(x,N,q,de){const ye=ae(x,N);x.logService.trace(`${ye} 1/6. invoking socketFactory.connect().`);let ve;try{ve=await D(x.logService,x.remoteSocketFactoryService,x.connectTo,(0,k.$Dk)(x),`reconnectionToken=${x.reconnectionToken}&reconnection=${x.reconnectionProtocol?"true":"false"}`,n(N),`renderer-${n(N)}-${x.reconnectionToken}`,de)}catch(G){throw x.logService.error(`${ye} socketFactory.connect() failed or timed out. Error:`),x.logService.error(G),G}x.logService.trace(`${ye} 2/6. socketFactory.connect() was successful.`);let we,Ee;x.reconnectionProtocol?(x.reconnectionProtocol.beginAcceptReconnection(ve,null),we=x.reconnectionProtocol,Ee=!1):(we=new I.$dh({socket:ve}),Ee=!0),x.logService.trace(`${ye} 3/6. sending AuthRequest control message.`);const K=await t(x.signService.createNewMessage((0,P.$3e)()),de),ee={type:"auth",auth:x.connectionToken||"00000000000000000000",data:K.data};we.sendControl(F.$Ec.fromString(JSON.stringify(ee)));try{const G=await v(we,a(de,o(1e4)));if(G.type!=="sign"||typeof G.data!="string"){const U=new Error("Unexpected handshake message");throw U.code="VSCODE_CONNECTION_ERROR",U}if(x.logService.trace(`${ye} 4/6. received SignRequest control message.`),!await t(x.signService.validate(K,G.signedData),de)){const U=new Error("Refused to connect to unsupported server");throw U.code="VSCODE_CONNECTION_ERROR",U}const he=await t(x.signService.sign(G.data),de),Ie={type:"connectionType",commit:x.commit,signedData:he,desiredConnectionType:N};return q&&(Ie.args=q),x.logService.trace(`${ye} 5/6. sending ConnectionTypeRequest control message.`),we.sendControl(F.$Ec.fromString(JSON.stringify(Ie))),{protocol:we,ownsProtocol:Ee}}catch(G){throw G&&G.code==="ETIMEDOUT"&&(x.logService.error(`${ye} the handshake timed out. Error:`),x.logService.error(G)),G&&G.code==="VSCODE_CONNECTION_ERROR"&&(x.logService.error(`${ye} received error control message when negotiating connection. Error:`),x.logService.error(G)),Ee&&se(we),G}}async function s(x,N,q,de){const ye=Date.now(),ve=ae(x,N),{protocol:we,ownsProtocol:Ee}=await r(x,N,q,de),K=new m(de);return K.registerDisposable(we.onControlMessage(ee=>{const G=JSON.parse(ee.toString()),X=ie(G);X?(x.logService.error(`${ve} received error control message when negotiating connection. Error:`),x.logService.error(X),Ee&&se(we),K.reject(X)):(x.reconnectionProtocol?.endAcceptReconnection(),x.logService.trace(`${ve} 6/6. handshake finished, connection is up and running after ${ne(ye)}!`),K.resolve({protocol:we,firstMessage:G}))})),K.promise}async function i(x,N){const{protocol:q}=await s(x,1,void 0,N);return{protocol:q}}async function c(x,N,q){const{protocol:de,firstMessage:ye}=await s(x,2,N,q),ve=ye&&ye.debugPort;return{protocol:de,debugPort:ve}}async function l(x,N,q){const de=Date.now(),ye=ae(x,3),{protocol:ve}=await r(x,3,N,q);return x.logService.trace(`${ye} 6/6. handshake finished, connection is up and running after ${ne(de)}!`),ve}async function b(x,N,q){const{connectTo:de,connectionToken:ye}=await x.addressProvider.getAddress();return{commit:x.commit,quality:x.quality,connectTo:de,connectionToken:ye,reconnectionToken:N,reconnectionProtocol:q,remoteSocketFactoryService:x.remoteSocketFactoryService,signService:x.signService,logService:x.logService}}async function y(x,N,q){return d(x,async de=>{const{protocol:ye}=await i(de,h.CancellationToken.None);return new J(x,N,q,de.reconnectionToken,ye)})}e.$Kk=y;async function u(x,N){return d(x,async q=>{const{protocol:de,debugPort:ye}=await c(q,N,h.CancellationToken.None);return new fe(x,N,q.reconnectionToken,de,ye)})}e.$Lk=u;async function d(x,N){for(let de=1;;de++)try{const ye=(0,P.$3e)(),ve=await b(x,ye,null);return await N(ve)}catch(ye){if(de<5)x.logService.error(`[remote-connection][attempt ${de}] An error occurred in initial connection! Will retry... Error:`),x.logService.error(ye);else throw x.logService.error(`[remote-connection][attempt ${de}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),x.logService.error(ye),Y.triggerPermanentFailure(0,0,$.$zk.isHandled(ye)),ye}}async function p(x,N,q){const de=await b(x,(0,P.$3e)(),null);return await l(de,{host:N,port:q},h.CancellationToken.None)}e.$Mk=p;function R(x){return(0,S.$ig)(N=>new Promise((q,de)=>{const ye=setTimeout(q,x*1e3);N.onCancellationRequested(()=>{clearTimeout(ye),q()})}))}var O;(function(x){x[x.ConnectionLost=0]="ConnectionLost",x[x.ReconnectionWait=1]="ReconnectionWait",x[x.ReconnectionRunning=2]="ReconnectionRunning",x[x.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",x[x.ConnectionGain=4]="ConnectionGain"})(O||(e.PersistentConnectionEventType=O={}));class j{constructor(N,q){this.reconnectionToken=N,this.millisSinceLastIncomingData=q,this.type=0}}e.$Nk=j;class T{constructor(N,q,de,ye){this.reconnectionToken=N,this.millisSinceLastIncomingData=q,this.durationSeconds=de,this.c=ye,this.type=1}skipWait(){this.c.cancel()}}e.$Ok=T;class z{constructor(N,q,de){this.reconnectionToken=N,this.millisSinceLastIncomingData=q,this.attempt=de,this.type=2}}e.$Pk=z;class B{constructor(N,q,de){this.reconnectionToken=N,this.millisSinceLastIncomingData=q,this.attempt=de,this.type=4}}e.$Qk=B;class M{constructor(N,q,de,ye){this.reconnectionToken=N,this.millisSinceLastIncomingData=q,this.attempt=de,this.handled=ye,this.type=3}}e.$Rk=M;class Y extends f.$lb{static triggerPermanentFailure(N,q,de){this._permanentFailure=!0,this.f=N,this.g=q,this.h=de,this.i.forEach(ye=>ye.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(N=>N.s())}static debugPauseSocketWriting(){this.i.forEach(N=>N.w())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.i=[]}get k(){return this.c||Y._permanentFailure}constructor(N,q,de,ye,ve){super(),this.n=N,this.p=q,this.reconnectionToken=de,this.protocol=ye,this.r=ve,this.j=this.B(new A.$ec),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new B(this.reconnectionToken,0,0)),this.B(ye.onSocketClose(we=>{const Ee=pe(this.n,this.reconnectionToken,!0);we?we.type===0?(this.p.logService.info(`${Ee} received socket close event (hadError: ${we.hadError}).`),we.error&&this.p.logService.error(we.error)):(this.p.logService.info(`${Ee} received socket close event (wasClean: ${we.wasClean}, code: ${we.code}, reason: ${we.reason}).`),we.event&&this.p.logService.error(we.event)):this.p.logService.info(`${Ee} received socket close event.`),this.s()})),this.B(ye.onSocketTimeout(we=>{const Ee=pe(this.n,this.reconnectionToken,!0);this.p.logService.info(`${Ee} received socket timeout event (unacknowledgedMsgCount: ${we.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${we.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${we.timeSinceLastReceivedSomeData}).`),this.s()})),Y.i.push(this),this.B((0,f.$jb)(()=>{const we=Y.i.indexOf(this);we>=0&&Y.i.splice(we,1)})),this.k&&this.v(Y.f,Y.g,Y.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const N=pe(this.n,this.reconnectionToken,!0);this.p.logService.info(`${N} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const q=[0,5,5,10,10,10,10,10,30];let de=-1;do{de++;const ye=de<q.length?q[de]:q[q.length-1];try{if(ye>0){const we=R(ye);this.j.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye,we)),this.p.logService.info(`${N} waiting for ${ye} seconds before reconnecting...`);try{await we}catch{}}if(this.k){this.p.logService.error(`${N} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),de+1)),this.p.logService.info(`${N} resolving connection...`);const ve=await b(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${N} connecting to ${ve.connectTo}...`),await this.y(ve,o(C)),this.p.logService.info(`${N} reconnected!`),this.j.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),de+1));break}catch(ve){if(ve.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${N} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(ve),this.u(this.protocol.getMillisSinceLastIncomingData(),de+1,!1);break}if(de>360){this.p.logService.error(`${N} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(ve),this.u(this.protocol.getMillisSinceLastIncomingData(),de+1,!1);break}if($.$zk.isTemporarilyNotAvailable(ve)){this.p.logService.info(`${N} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(ve);continue}if((ve.code==="ETIMEDOUT"||ve.code==="ENETUNREACH"||ve.code==="ECONNREFUSED"||ve.code==="ECONNRESET")&&ve.syscall==="connect"){this.p.logService.info(`${N} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(ve);continue}if((0,L.$2)(ve)){this.p.logService.info(`${N} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(ve);continue}if(ve instanceof $.$zk){this.p.logService.error(`${N} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(ve),this.u(this.protocol.getMillisSinceLastIncomingData(),de+1,$.$zk.isHandled(ve));break}this.p.logService.error(`${N} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(ve),this.u(this.protocol.getMillisSinceLastIncomingData(),de+1,!1);break}}while(!this.k&&!this.m)}u(N,q,de){this.r?Y.triggerPermanentFailure(N,q,de):this.v(N,q,de)}v(N,q,de){this.j.fire(new M(this.reconnectionToken,N,q,de)),se(this.protocol)}w(){this.protocol.pauseSocketWriting()}}e.$Sk=Y;class J extends Y{constructor(N,q,de,ye,ve){super(1,N,ye,ve,!0),this.client=this.B(new I.$bh(ve,{remoteAuthority:q,clientId:de},N.ipcLogger))}async y(N,q){await i(N,q)}}e.$Tk=J;class fe extends Y{constructor(N,q,de,ye,ve){super(2,N,de,ye,!1),this.z=q,this.debugPort=ve}async y(N,q){await c(N,this.z,q)}}e.$Uk=fe;function se(x){try{x.acceptDisconnect();const N=x.getSocket();x.dispose(),N.dispose()}catch(N){(0,L.$Y)(N)}}function ie(x){if(x&&x.type==="error"){const N=new Error(`Connection error: ${x.reason}`);return N.code="VSCODE_CONNECTION_ERROR",N}return null}function V(x,N){for(;x.length<N;)x+=" ";return x}function re(x,N){return`[remote-connection][${V(n(x),13)}][${N.substr(0,5)}\u2026]`}function pe(x,N,q){return`${re(x,N)}[${q?"reconnect":"initial"}]`}function ae(x,N){return`${pe(N,x.reconnectionToken,!!x.reconnectionProtocol)}[${x.connectTo}]`}function ne(x){return`${Date.now()-x} ms`}}),define(Se[241],De([1,0,3,6]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=void 0,e.$Gk=(0,F.$ph)("remoteSocketFactoryService");class h{constructor(){this.a={}}register(A,f){return this.a[A]??=[],this.a[A].push(f),(0,S.$jb)(()=>{const w=this.a[A]?.indexOf(f);typeof w=="number"&&w>=0&&this.a[A]?.splice(w,1)})}b(A){return(this.a[A.type]||[]).find(w=>w.supports(A))}connect(A,f,w,g){const P=this.b(A);if(!P)throw new Error(`No socket factory found for ${A}`);return P.connect(A,f,w,g)}}e.$Hk=h}),define(Se[242],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M1b=void 0;class S{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(h){try{const L=await this.c();if(L){const A=String(S.a++);return this.b.set(A,L),{id:A,data:L.createNewMessage(h)}}}catch{}return{id:"",data:h}}async validate(h,L){if(!h.id)return!0;const A=this.b.get(h.id);if(!A)return!1;this.b.delete(h.id);try{return A.validate(L)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(h){try{return await this.d(h)}catch{}return h}}e.$M1b=S}),define(Se[105],De([1,0,6]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=e.$Ik=void 0,e.$Ik="signService",e.$Jk=(0,S.$ph)(e.$Ik)}),define(Se[136],De([1,0,242]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A6b=void 0;class F extends S.$M1b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(A=>new A.signer().sign(L))}h(){return new Promise((L,A)=>me(["vsda"],L,A))}}e.$A6b=F}),define(Se[243],De([1,0,9,41,31]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=e.$2n=void 0;function L(w){if(S.$t===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}function A(w,g,P,I,$,k,C,E){const n=Object.create(null);n["common.machineId"]=k,n.sessionID=(0,h.$3e)()+Date.now(),n.commitHash=I,n.version=$,n["common.platformVersion"]=(w||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),n["common.platform"]=(0,S.$h)(S.$t),n["common.nodePlatform"]=F.$2c,n["common.nodeArch"]=P,n["common.product"]=E||"desktop",C&&(n["common.msftInternal"]=C);let o=0;const a=Date.now();Object.defineProperties(n,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),S.$l&&(n["common.snap"]="true");const m=L(g);return m&&(n["common.platformDetail"]=m),n}e.$2n=A;function f(w){const g=F.env.USERDNSDOMAIN;if(!g)return!1;const P=g.toLowerCase();return w.some(I=>P===I)}e.$3n=f}),define(Se[244],De([1,0,6]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=void 0,e.$Vk=(0,S.$ph)("telemetryService"),e.$Wk=(0,S.$ph)("customEndpointTelemetryService"),e.$Xk="telemetry.currentSessionDate",e.$Yk="telemetry.firstSessionDate",e.$Zk="telemetry.lastSessionDate",e.$1k="telemetry.machineId",e.$2k="telemetry",e.$3k="telemetry.telemetryLevel",e.$4k="telemetry.enableCrashReporter",e.$5k="telemetry.enableTelemetry";var F;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var h;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(h||(e.TelemetryConfiguration=h={}))}),define(Se[85],De([1,0,23,19,4,50,60,243,244]),function(me,e,S,F,h,L,A,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=void 0;class g{constructor(c){this.value=c,this.isTrustedTelemetryValue=!0}}e.$4n=g;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$5n=P,e.$6n=new P;class I{async publicLog(c,l,b){}async publicLogError(c,l,b){}}e.$7n=I,e.$8n="telemetry",e.$9n="extensionTelemetryLog",e.$0n={log:()=>null,flush:()=>Promise.resolve(null)};function $(i,c){return h.Event.debounce(c.onDidChangeConfiguration,(b,y)=>{const u=b?new Set([...b.affectedKeys,...y.affectedKeys]):y.affectedKeys;return{...y,affectedKeys:u}},1e3,!0)(b=>{b.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,L.$Yh)(b.source),configurationKeys:Array.from(b.affectedKeys)})})}e.$$n=$;function k(i,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!i.enableTelemetry||c.extensionTestsLocationURI)}e.$_n=k;function C(i,c){return!(c.isBuilt||c.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$ao=C;function E(i){const c=i.getValue(w.$3k),l=i.getValue(w.$4k);if(i.getValue(w.$5k)===!1||l===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$bo=E;function n(i){const c={},l={},b={};m(i,b);for(let y in b){y=y.length>150?y.substr(y.length-149):y;const u=b[y];typeof u=="number"?l[y]=u:typeof u=="boolean"?l[y]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${y} has been trimmed to 8192, the original length is ${u.length}`),c[y]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(c[y]=u)}return{properties:c,measurements:l}}e.$co=n;const o=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(i){if(!i)return"none";const c=(0,A.$Ck)(i);return o.has(c)?c:"other"}e.$do=a;function m(i,c,l=0,b){if(i)for(const y of Object.getOwnPropertyNames(i)){const u=i[y],d=b?b+y:y;Array.isArray(u)?c[d]=(0,S.$Nm)(u):u instanceof Date?c[d]=u.toISOString():(0,F.$ke)(u)?l<2?m(u,c,l+1,d+"."):c[d]=(0,S.$Nm)(u):c[d]=u}}function v(i,c){const l=i.msftInternalDomains||[],b=c.getValue("telemetry.internalTesting");return(0,f.$3n)(l)||b}e.$eo=v;function D(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$fo=D;function t(i,c){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let l=i;const b=[];for(const p of c)for(;;){const R=p.exec(i);if(!R)break;b.push([R.index,p.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let d=0;for(l="";;){const p=u.exec(i);if(!p)break;const R=b.some(([O,j])=>p.index<j&&O<u.lastIndex);!y.test(p[0])&&!R&&(l+=i.substring(d,p.index)+"<REDACTED: user-file-path>",d=u.lastIndex)}return d<i.length&&(l+=i.substr(d)),l}function r(i){if(!i)return i;const c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of c)if(l.regex.test(i))return`<REDACTED: ${l.label}>`;return i}function s(i,c){return(0,S.$Km)(i,l=>{if(l instanceof g||Object.hasOwnProperty.call(l,"isTrustedTelemetryValue"))return l.value;if(typeof l=="string"){let b=l.replaceAll("%20"," ");b=t(b,c);for(const y of c)b=b.replace(y,"");return b=r(b),b}})}e.$go=s}),define(Se[245],De([1,0,15,130,25,9,2,8,41,85]),function(me,e,S,F,h,L,A,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=void 0;function P(s,i){return s.uuid&&i.uuid?s.uuid===i.uuid:s.id===i.id?!0:(0,S.$Gd)(s.id,i.id)===0}e.$ho=P;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(i){const c=i.manifest?i.manifest.version:i.version,l=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new $(i.identifier,c,l)}static parse(i){const c=I.exec(i);return c&&c[1]&&c[2]?new $({id:c[1]},c[2],c[4]||void 0):null}constructor(i,c,l="undefined"){this.version=c,this.targetPlatform=l,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof $?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$io=$;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function C(s){const i=k.exec(s);return i&&i[1]?[n(i[1]),i[2]]:[n(s),void 0]}e.$jo=C;function E(s,i){return`${s}.${i}`}e.$ko=E;function n(s){return s.toLowerCase()}e.$lo=n;function o(s,i){return n(E(s??h.$El,i))}e.$mo=o;function a(s,i){const c=[],l=b=>{for(const y of c)if(y.some(u=>P(i(u),i(b))))return y;return null};for(const b of s){const y=l(b);y?y.push(b):c.push([b])}return c}e.$no=a;function m(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$oo=m;function v(s){return{id:new g.$4n(s.identifier.id),name:new g.$4n(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$po=v,e.$qo=new h.$Il("pprice.better-merge");function D(s,i){const c=[],l=i.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const b=l.shift();if(b&&c.every(y=>!P(y.identifier,{id:b}))){const y=s.filter(u=>P(u.identifier,{id:b}));y.length===1&&(c.push(y[0]),l.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.$ro=D;async function t(s,i){if(!L.$k)return!1;let c;try{c=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){i.debug("Error while getting the os-release file.",(0,f.$9)(b))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(s,i){const c=await t(s,i),l=(0,F.$Mn)(c?"alpine":L.$t,w.$3c);return i.debug("ComputeTargetPlatform:",l),l}e.$so=r}),define(Se[246],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=e.$7q=e.$6q=e.$5q=e.$4q=void 0;function S(w){return[...w.entries()]}e.$4q=S;function F(w){return w?[...w.entries()]:[]}e.$5q=F;function h(w){return new Map(w)}e.$6q=h;function L(w){return new Map(w??[])}e.$7q=L;function A(w){return Array.from(w.entries()).map(g=>[g[0],S(g[1].map),F(g[1].descriptionMap)])}e.$8q=A;function f(w){return new Map(w.map(g=>[g[0],{map:h(g[1]),descriptionMap:L(g[2])}]))}e.$9q=f}),define(Se[247],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dkb=void 0;class S{constructor(h){this.b=h,this.a=new Map}dispose(){for(const h of this.a.values())h.dispose()}startBuffering(h,L,A=5){const f=L(w=>{const g=typeof w=="string"?w:w.data;let P=this.a.get(h);if(P){P.data.push(g);return}const I=setTimeout(()=>this.flushBuffer(h),A);P={data:[g],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(h),f.dispose()}},this.a.set(h,P)});return f}stopBuffering(h){this.a.get(h)?.dispose()}flushBuffer(h){const L=this.a.get(h);L&&(this.a.delete(h),this.b(h,L.data.join("")))}}e.$dkb=S}),define(Se[248],De([1,0,13,76,56,4,19,2,194,104,42]),function(me,e,S,F,h,L,A,f,w,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6u=e.$5u=e.$4u=e.$3u=e.$2u=e.$1u=e.$Zu=e.$Yu=e.IconFontDefinition=e.IconContribution=e.$Xu=void 0,e.$Xu={IconContribution:"base.contributions.icons"};var I;(function(v){function D(t,r){let s=t.defaults;for(;h.ThemeIcon.isThemeIcon(s);){const i=C.getIcon(s.id);if(!i)return;s=i.defaults}return s}v.getDefinition=D})(I||(e.IconContribution=I={}));var $;(function(v){function D(r){return{weight:r.weight,style:r.style,src:r.src.map(s=>({format:s.format,location:s.location.toString()}))}}v.toJSONObject=D;function t(r){const s=i=>(0,A.$ie)(i)?i:void 0;if(r&&Array.isArray(r.src)&&r.src.every(i=>(0,A.$ie)(i.format)&&(0,A.$ie)(i.location)))return{weight:s(r.weight),style:s(r.style),src:r.src.map(i=>({format:i.format,location:f.URI.parse(i.location)}))}}v.fromJSONObject=t})($||(e.IconFontDefinition=$={}));class k{constructor(){this.a=new L.$ec,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,w.localize)(0,null)},fontCharacter:{type:"string",description:(0,w.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${h.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(D,t,r,s){const i=this.b[D];if(i){if(r&&!i.description){i.description=r,this.d.properties[D].markdownDescription=`${r} $(${D})`;const b=this.e.enum.indexOf(D);b!==-1&&(this.e.enumDescriptions[b]=r),this.a.fire()}return i}const c={id:D,description:r,defaults:t,deprecationMessage:s};this.b[D]=c;const l={$ref:"#/definitions/icons"};return s&&(l.deprecationMessage=s),r&&(l.markdownDescription=`${r}: $(${D})`),this.d.properties[D]=l,this.e.enum.push(D),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:D}}deregisterIcon(D){delete this.b[D],delete this.d.properties[D];const t=this.e.enum.indexOf(D);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(D=>this.b[D])}getIcon(D){return this.b[D]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(D,t){const r=this.f[D];return r||(this.f[D]=t,this.a.fire(),t)}deregisterIconFont(D){delete this.f[D]}getIconFont(D){return this.f[D]}toString(){const D=(i,c)=>i.id.localeCompare(c.id),t=i=>{for(;h.ThemeIcon.isThemeIcon(i.defaults);)i=this.b[i.defaults.id];return`codicon codicon-${i?i.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(i=>this.b[i]);for(const i of s.filter(c=>!!c.description).sort(D))r.push(`|<i class="${t(i)}"></i>|${i.id}|${h.ThemeIcon.isThemeIcon(i.defaults)?i.defaults.id:i.id}|${i.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const i of s.filter(c=>!h.ThemeIcon.isThemeIcon(c.defaults)).sort(D))r.push(`|<i class="${t(i)}"></i>|${i.id}|`);return r.join(`
`)}}const C=new k;P.$Um.add(e.$Xu.IconContribution,C);function E(v,D,t,r){return C.registerIcon(v,D,t,r)}e.$Yu=E;function n(){return C}e.$Zu=n;function o(){const v=(0,F.$Aj)();for(const D in v){const t="\\"+v[D].toString(16);C.registerIcon(D,{fontCharacter:t})}}o(),e.$1u="vscode://schemas/icons";const a=P.$Um.as(g.$Vm.JSONContribution);a.registerSchema(e.$1u,C.getIconSchema());const m=new S.$Gg(()=>a.notifySchemaChanged(e.$1u),200);C.onDidChange(()=>{m.isScheduled()||m.schedule()}),e.$2u=E("widget-close",F.$Cj.close,(0,w.localize)(2,null)),e.$3u=E("goto-previous-location",F.$Cj.arrowUp,(0,w.localize)(3,null)),e.$4u=E("goto-next-location",F.$Cj.arrowDown,(0,w.localize)(4,null)),e.$5u=h.ThemeIcon.modify(F.$Cj.sync,"spin"),e.$6u=h.ThemeIcon.modify(F.$Cj.loading,"spin")}),define(Se[106],De([1,0,4,50,6,17]),function(me,e,S,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vz=e.$Uz=e.$Tz=e.$Sz=e.$Rz=e.$Qz=e.$Pz=e.$Oz=e.ProvidedOnAutoForward=e.$Nz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Mz=e.$Lz=void 0,e.$Lz=(0,h.$ph)("tunnelService"),e.$Mz=(0,h.$ph)("sharedTunnelsService");var A;(function(n){n.Http="http",n.Https="https"})(A||(e.TunnelProtocol=A={}));var f;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(f||(e.TunnelPrivacyId=f={}));function w(n){return!!n.forwardPort}e.$Nz=w;var g;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function P(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(o)return{address:o[1],port:+o[2]}}e.$Oz=P,e.$Pz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(n){return e.$Pz.indexOf(n)>=0}e.$Qz=I,e.$Rz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function $(n){return e.$Rz.indexOf(n)>=0}e.$Sz=$;function k(n,o,a,m){if(a===1)return!1;if(a===2&&$(o)){const v=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(v?.length===4&&parseInt(v[1])>=18)return!1}return n<1024}e.$Tz=k;class C{constructor(o,a,m){this.remoteAddress=o,this.localAddress=a,this.b=m,this.a=new S.$ec,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Uz=C;let E=class{constructor(o,a){this.j=o,this.k=a,this.a=new S.$ec,this.onTunnelOpened=this.a.event,this.b=new S.$ec,this.onTunnelClosed=this.b.event,this.c=new S.$ec,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const o=this.k.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.f=o,o?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.g=o.elevation,this.h=o.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const o=[],a=Array.from(this.e.values());for(const m of a){const v=Array.from(m.values());for(const D of v){const t=await D.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this.e.values()){for(const{value:a}of o.values())await a.then(m=>typeof m!="string"?m?.dispose():void 0);o.clear()}this.e.clear()}setEnvironmentTunnel(o,a,m,v,D){this.p(o,a,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:a,localAddress:m,privacy:v,protocol:D,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,a){($(o)||I(o))&&(o=e.$Pz[0]);const m=this.r(o,a);if(m)return++m.refcount,m.value}openTunnel(o,a,m,v,D,t=!1,r,s){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${m} on local port ${D}.`);const i=this.f??o;if(!i)return;if(a||(a="localhost"),v||(v=this.l),this.f&&this.i.has(m)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const c=this.s(i,a,m,v,D,t,r,s);return c?c.then(l=>{if(l){if(typeof l=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(a,m),l}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(a,m);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const b=this.n(l);return(l.tunnelRemoteHost!==a||l.tunnelRemotePort!==m)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&l.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(b),b}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}n(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const a=this.e.get(o.tunnelRemoteHost);if(a){const m=a.get(o.tunnelRemotePort);m&&(m.refcount--,await this.o(o.tunnelRemoteHost,o.tunnelRemotePort,m))}}}}async o(o,a,m){if(m.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${a}.`);const v=m.value.then(async D=>{D&&typeof D!="string"&&(await D.dispose(!0),this.b.fire({host:D.tunnelRemoteHost,port:D.tunnelRemotePort}))});return this.e.has(o)&&this.e.get(o).delete(a),v}}async closeTunnel(o,a){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${a} `);const m=this.e.get(o);if(m&&m.has(a)){const v=m.get(a);v.refcount=0,await this.o(o,a,v)}}p(o,a,m){this.e.has(o)||this.e.set(o,new Map),this.e.get(o).set(a,{refcount:1,value:m})}async q(o,a){const m=this.e.get(o);if(m){const v=m.get(a),D=v?await v.value:void 0;(!D||typeof D=="string")&&m.delete(a),m.size===0&&this.e.delete(o)}}r(o,a){const m=[o];I(o)?(m.push(...e.$Pz),m.push(...e.$Rz)):$(o)&&m.push(...e.$Rz);const v=m.map(D=>this.e.get(D));for(const D of v){const t=D?.get(a);if(t)return t}}canTunnel(o){return!!P(o)}t(o,a,m,v,D,t,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${m} on local port ${v}.`);const s=m;this.i.add(s);const i=v===void 0?m:v,c={elevationRequired:D?this.isPortPrivileged(i):!1},l={remoteAddress:{host:a,port:m},localAddressPort:v,privacy:t,public:t?t!==f.Private:void 0,protocol:r},b=o.forwardPort(l,c);return b?(this.p(a,m,b),b.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(s)})):this.i.delete(s),b}};e.$Vz=E,e.$Vz=E=Je([Be(0,L.$Ri),Be(1,F.$Vh)],E)}),define(Se[249],De([1,0,6]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Wz=void 0,e.$Wz=(0,S.$ph)("editSessionIdentityService");var F;(function(h){h[h.Complete=100]="Complete",h[h.Partial=50]="Partial",h[h.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(Se[250],De([1,0,16]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=void 0;function F(w){return w.scheme!==S.Schemas.file&&w.scheme!==S.Schemas.vscodeRemote}e.$aJ=F;function h(w){if(w.folders.length)return w.folders.every(g=>F(g.uri))?w.folders[0].uri:void 0;if(w.configuration&&F(w.configuration))return w.configuration}e.$bJ=h;function L(w){return h(w)?.scheme}e.$cJ=L;function A(w){return h(w)?.authority}e.$dJ=A;function f(w){return h(w)!==void 0}e.$eJ=f}),define(Se[51],De([1,0,195,14,75,24,2,6,16]),function(me,e,S,F,h,L,A,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.WorkbenchState=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0,e.$yh=(0,f.$ph)("contextService");function g(i){const c=i;return typeof c?.id=="string"&&A.URI.isUri(c.uri)}e.$zh=g;function P(i){return typeof i?.id=="string"&&!g(i)&&!$(i)}e.$Ah=P,e.$Bh={id:"ext-dev"},e.$Ch={id:"empty-window"};function I(i,c){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,F.$_c)(i)}:c?e.$Bh:e.$Ch;const l=i;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.$Dh=I;function $(i){const c=i;return typeof c?.id=="string"&&A.URI.isUri(c.configPath)}e.$Eh=$;function k(i){const c=i;if(c?.uri)return{id:c.id,uri:A.URI.revive(c.uri)};const l=i;if(l?.configPath)return{id:l.id,configPath:A.URI.revive(l.configPath)};if(i?.id)return{id:i.id}}e.$Fh=k;var C;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(C||(e.WorkbenchState=C={}));function E(i){const c=i;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.$Gh=E;function n(i){const c=i;return!!(c&&typeof c=="object"&&A.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.$Hh=n;class o{constructor(c,l,b,y,u){this.h=c,this.j=b,this.k=y,this.l=u,this.c=h.$vh.forUris(this.l,()=>!0),this.folders=l}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=h.$vh.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ih=o;class a{constructor(c,l){this.raw=l,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,L.$9f)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Jh=a;function m(i){return new a({uri:i,index:0,name:(0,L.$5f)(i)},{uri:i.toString()})}e.$Kh=m,e.$Lh="code-workspace",e.$Mh=`.${e.$Lh}`,e.$Nh=[{name:(0,S.localize)(0,null),extensions:[e.$Lh]}],e.$Oh="workspace.json";function v(i,c){return L.$Zf.isEqualOrParent(i,c.untitledWorkspacesHome)}e.$Ph=v;function D(i){let c;return A.URI.isUri(i)?c=i:c=i.configuration,c?.scheme===w.Schemas.tmp}e.$Qh=D,e.$Rh="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$Rh}e.$Sh=t;function r(i,c){return!v(i,c)&&!D(i)}e.$Th=r;function s(i){return(typeof i=="string"?(0,F.$ad)(i):(0,L.$7f)(i))===e.$Mh}e.$Uh=s}),define(Se[86],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jac=void 0;class S{static{this.a=!1}constructor(h){this.d=h,this.b=new Map,this.c=1}add(h){const L=this.c++;return this.b.set(L,h),this.e(),L}get(h,L){return this.b.has(h)?this.b.get(h)[L]:void 0}delete(h){this.b.delete(h),this.e()}e(){S.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$jac=S}),define(Se[52],De([1,0,16,24,6]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mac=e.$lac=void 0;class L{constructor(){this.a=new Set(Object.keys(S.Schemas)),this.b=new Map,this.extUri=new F.$Xf(f=>{const w=this.b.get(f.scheme);return!(w===void 0||w&1024)})}$acceptProviderInfos(f,w){w===null?this.b.delete(f.scheme):this.b.set(f.scheme,w)}isFreeScheme(f){return!this.b.has(f)&&!this.a.has(f)}getCapabilities(f){return this.b.get(f)}}e.$lac=L,e.$mac=(0,h.$ph)("IExtHostFileSystemInfo")}),define(Se[26],De([1,0,6]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2L=void 0,e.$2L=(0,S.$ph)("IExtHostInitDataService")}),define(Se[251],De([1,0,200,17,234,26]),function(me,e,S,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=void 0;let A=class extends h.$9M{constructor(w,g,P){const I=P.remote.isRemote?"remoteexthost":w?"workerexthost":"exthost",$=P.remote.isRemote?(0,S.localize)(0,null):w?(0,S.localize)(1,null):(0,S.localize)(2,null);super(g.createLogger(I,{name:$}))}};e.$scc=A,e.$scc=A=Je([Be(1,F.$Si),Be(2,L.$2L)],A)}),define(Se[252],De([1,0,13]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pac=e.$Oac=void 0;class F{constructor(A,f,w){this.h=new Map,this.a=A,this.b=f,this.c=w,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(g=>(this.f=g,this)),this.g=this.c.onDidChangeStorage(g=>{g.shared===this.b&&g.key===this.a&&(this.f=g.value)}),this.i=new S.$Gg(()=>{const g=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const P of g.values())P.complete()}catch(P){for(const I of g.values())I.error(P)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,f){let w=this.f[A];return typeof w>"u"&&(w=f),w}update(A,f){this.f[A]=f;const w=this.h.get(A);if(w!==void 0)return w.p;const g=new S.$Pg;return this.h.set(A,g),this.i.isScheduled()||this.i.schedule(),g.p}dispose(){this.g.dispose()}}e.$Oac=F;class h extends F{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,f){super(A.identifier.value,!0,f),this.j=A}}e.$Pac=h}),define(Se[253],De([1,0,4,2]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=void 0;class h{constructor(A){this.c=A,this.a=new S.$ec,this.onDidSaveNotebookDocument=this.a.event,this.b=new S.$ec,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,f,w,g){const I=this.c.getNotebookDocument(F.URI.revive(A)).acceptModelChanged(f.value,w,g);this.b.fire(I)}$acceptDirtyStateChanged(A,f){this.c.getNotebookDocument(F.URI.revive(A)).acceptDirty(f)}$acceptModelSaved(A){const f=this.c.getNotebookDocument(F.URI.revive(A));this.a.fire(f.apiNotebook)}}e.$bcc=h}),define(Se[20],De([1,0,6]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ML=e.$LL=void 0,e.$LL=(0,S.$ph)("IExtHostRpcService");class F{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$ML=F}),define(Se[254],De([1,0,25,4]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ac=void 0;class h{#e;constructor(A,f){this.b=new F.$ec,this.onDidChange=this.b.event,this.a=S.$Il.toKey(A.identifier),this.#e=f,this.#e.onDidChangePassword(w=>{w.extensionId===this.a&&this.b.fire({key:w.key})})}get(A){return this.#e.get(this.a,A)}store(A,f){return this.#e.store(this.a,A,f)}delete(A){return this.#e.delete(this.a,A)}}e.$1ac=h}),define(Se[62],De([1,0,6]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xac=e.$wac=void 0,e.$wac=(0,S.$ph)("IURITransformerService");class F{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$xac=F}),define(Se[255],De([1,0,21]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ybb=e.$xbb=void 0;class F{constructor(){this.buffers=[]}add(w){let g=this.buffers.indexOf(w);return g<0&&(g=this.buffers.length,this.buffers.push(w)),g}}function h(f,w){if(w.serializeBuffersForPostMessage){const g=new F,I=JSON.stringify(f,(k,C)=>{if(C instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:g.add(C)};if(ArrayBuffer.isView(C)){const E=L(C);if(E)return{$$vscode_array_buffer_reference$$:!0,index:g.add(C.buffer),view:{type:E,byteLength:C.byteLength,byteOffset:C.byteOffset}}}return C}),$=g.buffers.map(k=>{const C=new Uint8Array(k);return S.$Ec.wrap(C)});return{message:I,buffers:$}}else return{message:JSON.stringify(f),buffers:[]}}e.$xbb=h;function L(f){switch(f.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(f,w){const g=w.map($=>{const k=new ArrayBuffer($.byteLength);return new Uint8Array(k).set($.buffer),k}),P=w.length?($,k)=>{if(k&&typeof k=="object"&&k.$$vscode_array_buffer_reference$$){const C=k,{index:E}=C,n=g[E];if(C.view)switch(C.view.type){case 1:return new Int8Array(n,C.view.byteOffset,C.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(n,C.view.byteOffset,C.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(n,C.view.byteOffset,C.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(n,C.view.byteOffset,C.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(n,C.view.byteOffset,C.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(n,C.view.byteOffset,C.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(n,C.view.byteOffset,C.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(n,C.view.byteOffset,C.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(n,C.view.byteOffset,C.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(n,C.view.byteOffset,C.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(n,C.view.byteOffset,C.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return n}return k}:void 0;return{message:JSON.parse(f,P),arrayBuffers:g}}e.$ybb=A}),define(Se[256],De([1,0,257,363,364,57,2,365]),function(me,e,S,F,h,L,A,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=void 0;const w=!1;function g(a,m,v,D,t,r){const s=r.environment.useHostProxy,i=typeof s=="boolean"?s:!r.remote.isRemote,c={resolveProxy:y=>a.resolveProxy(y),lookupProxyAuthorization:E.bind(void 0,D,t,m,{},r.remote.isRemote),getProxyURL:()=>m.getConfiguration("http").get("proxy"),getProxySupport:()=>m.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>I(m),getSystemCertificatesV2:()=>$(m),log:(y,u,...d)=>{switch(y){case f.LogLevel.Trace:D.trace(u,...d);break;case f.LogLevel.Debug:D.debug(u,...d);break;case f.LogLevel.Info:D.info(u,...d);break;case f.LogLevel.Warning:D.warn(u,...d);break;case f.LogLevel.Error:D.error(u,...d);break;case f.LogLevel.Critical:D.error(u,...d);break;case f.LogLevel.Off:break;default:p(y,u,d);break}function p(R,O,...j){D.error("Unknown log level",R),D.error(O,...j)}},getLogLevel:()=>D.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:i,addCertificates:[],env:process.env},l=(0,f.createProxyResolver)(c),b=P(c,l);return C(v,b)}e.$1cc=g;function P(a,m){return{http:Object.assign(S,(0,f.createHttpPatch)(a,S,m)),https:Object.assign(F,(0,f.createHttpPatch)(a,F,m)),net:Object.assign(L,(0,f.createNetPatch)(a,L)),tls:Object.assign(h,(0,f.createTlsPatch)(a,h))}}function I(a){const m=a.getConfiguration("http");return!m.get("experimental.systemCertificatesV2",w)&&!!m.get("systemCertificates")}function $(a){const m=a.getConfiguration("http");return!!m.get("experimental.systemCertificatesV2",w)&&!!m.get("systemCertificates")}const k=new Map;function C(a,m){return a.getExtensionPathIndex().then(v=>{const D=globalThis._VSCODE_NODE_MODULES.module,t=D._load;D._load=function(s,i,c){if(s==="net")return m.net;if(s==="tls")return m.tls;if(s!=="http"&&s!=="https")return t.apply(this,arguments);const l=v.findSubstr(A.URI.file(i.filename));let b=k.get(l);if(b||k.set(l,b={}),!b[s]){const y=m[s];b[s]={...y}}return b[s]}})}async function E(a,m,v,D,t,r,s,i){const c=D[r];s&&(D[r]=s),a.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${r}`,`proxyAuthenticate:${s}`,`proxyAuthenticateCache:${c}`);const l=s||c,b=Array.isArray(l)?l:typeof l=="string"?[l]:[];if(o(m,b,t),b.some(y=>/^(Negotiate|Kerberos)( |$)/i.test(y))&&!i.kerberosRequested)try{i.kerberosRequested=!0;const y=await new Promise((O,j)=>{me(["kerberos"],O,j)}),u=new URL(r),d=v.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${u.hostname}`:`HTTP@${u.hostname}`);return a.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${r}`,`spn:${d}`),"Negotiate "+await(await y.initializeClient(d)).step("")}catch(y){a.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",y)}}let n=!1;function o(a,m,v){n||!m.length||(n=!0,a.$publicLog2("proxyAuthenticationRequest",{authenticationType:m.map(D=>D.split(" ")[0]).join(","),extensionHostType:v?"remote":"local"}))}}),define(Se[258],De([1,0,127]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;function F(L){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:L,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function h(L){return new S.$om(F(L))}e.$hr=h}),define(Se[137],De([1,0,210,19,2,3,6,42,30,16,45,173,40]),function(me,e,S,F,h,L,A,f,w,g,P,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VE=e.$UE=e.$TE=e.EditorsOrder=e.$SE=e.CloseDirection=e.$RE=e.$QE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$PE=e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.$IE=e.EditorInputCapabilities=e.$HE=e.SaveReason=e.Verbosity=e.$GE=e.$FE=e.$EE=e.$DE=e.$CE=e.$BE=e.$AE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$zE=e.$yE=e.$xE=e.$wE=e.$vE=void 0,e.$vE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$wE={id:"default",displayName:(0,S.localize)(0,null),providerDisplayName:(0,S.localize)(1,null)},e.$xE="workbench.editor.sidebysideEditor",e.$yE="workbench.editors.textDiffEditor",e.$zE="workbench.editors.binaryResourceDiffEditor";var k;(function(ae){ae[ae.PROGRAMMATIC=1]="PROGRAMMATIC",ae[ae.USER=2]="USER",ae[ae.EDIT=3]="EDIT",ae[ae.NAVIGATION=4]="NAVIGATION",ae[ae.JUMP=5]="JUMP"})(k||(e.EditorPaneSelectionChangeReason=k={}));var C;(function(ae){ae[ae.IDENTICAL=1]="IDENTICAL",ae[ae.SIMILAR=2]="SIMILAR",ae[ae.DIFFERENT=3]="DIFFERENT"})(C||(e.EditorPaneSelectionCompareResult=C={}));function E(ae){const ne=ae;return!!ne&&typeof ne.getSelection=="function"&&!!ne.onDidChangeSelection}e.$AE=E;function n(ae,ne,x){for(const N of x.visibleEditorPanes)if(N.group.id===ne&&ae.matches(N.input))return N.getViewState()}e.$BE=n;function o(ae){if(l(ae))return!1;const ne=ae;return h.URI.isUri(ne?.resource)}e.$CE=o;function a(ae){if(l(ae))return!1;const ne=ae;return ne?.original!==void 0&&ne.modified!==void 0}e.$DE=a;function m(ae){if(l(ae)||a(ae))return!1;const ne=ae;return ne?.primary!==void 0&&ne.secondary!==void 0}e.$EE=m;function v(ae){if(l(ae))return!1;const ne=ae;return ne?ne.resource===void 0||ne.resource.scheme===g.Schemas.untitled||ne.forceUntitled===!0:!1}e.$FE=v;function D(ae){if(l(ae))return!1;const ne=ae;return h.URI.isUri(ne?.base?.resource)&&h.URI.isUri(ne?.input1?.resource)&&h.URI.isUri(ne?.input2?.resource)&&h.URI.isUri(ne?.result?.resource)}e.$GE=D;var t;(function(ae){ae[ae.SHORT=0]="SHORT",ae[ae.MEDIUM=1]="MEDIUM",ae[ae.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var r;(function(ae){ae[ae.EXPLICIT=1]="EXPLICIT",ae[ae.AUTO=2]="AUTO",ae[ae.FOCUS_CHANGE=3]="FOCUS_CHANGE",ae[ae.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r||(e.SaveReason=r={}));class s{constructor(){this.a=new Map}registerSource(ne,x){let N=this.a.get(ne);return N||(N={source:ne,label:x},this.a.set(ne,N)),N.source}getSourceLabel(ne){return this.a.get(ne)?.label??ne}}e.$HE=new s;var i;(function(ae){ae[ae.None=0]="None",ae[ae.Readonly=2]="Readonly",ae[ae.Untitled=4]="Untitled",ae[ae.Singleton=8]="Singleton",ae[ae.RequiresTrust=16]="RequiresTrust",ae[ae.CanSplitInGroup=32]="CanSplitInGroup",ae[ae.ForceDescription=64]="ForceDescription",ae[ae.CanDropIntoEditor=128]="CanDropIntoEditor",ae[ae.MultipleEditors=256]="MultipleEditors",ae[ae.Scratchpad=512]="Scratchpad"})(i||(e.EditorInputCapabilities=i={}));class c extends L.$lb{}e.$IE=c;function l(ae){return ae instanceof c}e.$JE=l;function b(ae){const ne=ae;return h.URI.isUri(ne?.preferredResource)}function y(ae){const ne=ae;return l(ne?.primary)&&l(ne?.secondary)}e.$KE=y;function u(ae){const ne=ae;return l(ne?.modified)&&l(ne?.original)}e.$LE=u;function d(ae,ne,x,N,q){return pe(N,[(0,I.$_h)({id:"workbench.action.openLargeFile",label:(0,S.localize)(2,null),run:()=>{const de={...x,limits:{size:Number.MAX_VALUE}};ae.openEditor(ne,de)}}),(0,I.$_h)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,S.localize)(3,null),run:()=>q.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:$.default.Warning})}e.$ME=d;function p(ae){return l(ae?.editor)}e.$NE=p;function R(ae){const ne=ae;return p(ae)&&ne?.group!==void 0}e.$OE=R;function O(ae){const ne=ae;return typeof ne?.groupId=="number"&&l(ne.editor)}e.$PE=O;var j;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.REPLACE=1]="REPLACE",ae[ae.MOVE=2]="MOVE",ae[ae.UNPIN=3]="UNPIN"})(j||(e.EditorCloseContext=j={}));var T;(function(ae){ae[ae.GROUP_ACTIVE=0]="GROUP_ACTIVE",ae[ae.GROUP_INDEX=1]="GROUP_INDEX",ae[ae.GROUP_LOCKED=2]="GROUP_LOCKED",ae[ae.EDITOR_OPEN=3]="EDITOR_OPEN",ae[ae.EDITOR_CLOSE=4]="EDITOR_CLOSE",ae[ae.EDITOR_MOVE=5]="EDITOR_MOVE",ae[ae.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ae[ae.EDITOR_LABEL=7]="EDITOR_LABEL",ae[ae.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ae[ae.EDITOR_PIN=9]="EDITOR_PIN",ae[ae.EDITOR_STICKY=10]="EDITOR_STICKY",ae[ae.EDITOR_DIRTY=11]="EDITOR_DIRTY",ae[ae.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(T||(e.GroupModelChangeKind=T={}));var z;(function(ae){ae[ae.PRIMARY=1]="PRIMARY",ae[ae.SECONDARY=2]="SECONDARY",ae[ae.BOTH=3]="BOTH",ae[ae.ANY=4]="ANY"})(z||(e.SideBySideEditor=z={}));class B{getOriginalUri(ne,x){if(!ne)return;if(D(ne))return e.$RE.getOriginalUri(ne.result,x);if(x?.supportSideBySide){const{primary:q,secondary:de}=this.a(ne);if(q&&de){if(x?.supportSideBySide===z.BOTH)return{primary:this.getOriginalUri(q,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(de,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===z.ANY)return this.getOriginalUri(q,{filterByScheme:x.filterByScheme})??this.getOriginalUri(de,{filterByScheme:x.filterByScheme});ne=x.supportSideBySide===z.PRIMARY?q:de}}if(a(ne)||m(ne)||D(ne))return;const N=b(ne)?ne.preferredResource:ne.resource;return!N||!x||!x.filterByScheme?N:this.b(N,x.filterByScheme)}a(ne){return y(ne)||m(ne)?{primary:ne.primary,secondary:ne.secondary}:u(ne)||a(ne)?{primary:ne.modified,secondary:ne.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ne,x){if(!ne)return;if(D(ne))return e.$RE.getCanonicalUri(ne.result,x);if(x?.supportSideBySide){const{primary:q,secondary:de}=this.a(ne);if(q&&de){if(x?.supportSideBySide===z.BOTH)return{primary:this.getCanonicalUri(q,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(de,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===z.ANY)return this.getCanonicalUri(q,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(de,{filterByScheme:x.filterByScheme});ne=x.supportSideBySide===z.PRIMARY?q:de}}if(a(ne)||m(ne)||D(ne))return;const N=ne.resource;return!N||!x||!x.filterByScheme?N:this.b(N,x.filterByScheme)}b(ne,x){if(Array.isArray(x)){if(x.some(N=>ne.scheme===N))return ne}else if(x===ne.scheme)return ne}}var M;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.KEYBOARD=1]="KEYBOARD",ae[ae.MOUSE=2]="MOUSE"})(M||(e.EditorCloseMethod=M={}));function Y(ae,ne,x,N){if(!ae.isSticky(ne))return!1;switch(N.preventPinnedEditorClose){case"keyboardAndMouse":return x===M.MOUSE||x===M.KEYBOARD;case"mouse":return x===M.MOUSE;case"keyboard":return x===M.KEYBOARD}return!1}e.$QE=Y,e.$RE=new B;var J;(function(ae){ae[ae.LEFT=0]="LEFT",ae[ae.RIGHT=1]="RIGHT"})(J||(e.CloseDirection=J={}));class fe{constructor(){this.c=new Map,this.d=new Map}start(ne){const x=this.a=ne.get(A.$oh);for(const[N,q]of this.c)this.e(N,q,x);this.c.clear()}e(ne,x,N){const q=N.createInstance(x);this.d.set(ne,q)}registerFileEditorFactory(ne){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ne}getFileEditorFactory(){return(0,F.$te)(this.b)}registerEditorSerializer(ne,x){if(this.c.has(ne)||this.d.has(ne))throw new Error(`A editor serializer with type ID '${ne}' was already registered.`);return this.a?this.e(ne,x,this.a):this.c.set(ne,x),(0,L.$jb)(()=>{this.c.delete(ne),this.d.delete(ne)})}getEditorSerializer(ne){return this.d.get(typeof ne=="string"?ne:ne.typeId)}}f.$Um.add(e.$vE.EditorFactory,new fe);async function se(ae,ne,x){return!ae||!ae.length?[]:await Promise.all(ae.map(async N=>{const q=h.URI.revive(N.fileUri);if(!q){x.info("Cannot resolve the path because it is not valid.",N);return}if(!await ne.canHandleResource(q)){x.info("Cannot resolve the path because it cannot be handled",N);return}let ye=N.exists,ve=N.type;if(typeof ye!="boolean"||typeof ve!="number")try{ve=(await ne.stat(q)).isDirectory?w.FileType.Directory:w.FileType.Unknown,ye=!0}catch(Ee){x.error(Ee),ye=!1}if(!ye&&N.openOnlyIfExists){x.info("Cannot resolve the path because it does not exist",N);return}if(ve===w.FileType.Directory){x.info("Cannot resolve the path because it is a directory",N);return}const we={...N.options,pinned:!0};return ye?{resource:q,options:we}:{resource:q,options:we,forceUntitled:!0}}))}e.$SE=se;var ie;(function(ae){ae[ae.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ae[ae.SEQUENTIAL=1]="SEQUENTIAL"})(ie||(e.EditorsOrder=ie={}));function V(ae){const ne=ae;if(!ne)return!1;const x=ne;if(x.modified)return V(x.modified);const N=ne;return!!(N.contributionsState&&N.viewState&&Array.isArray(N.cursorState))}e.$TE=V;function re(ae){return(0,P.$bi)(ae)}e.$UE=re;function pe(ae,ne,x){const N=(0,P.$ci)(ae,ne);return N.forceMessage=x?.forceMessage,N.forceSeverity=x?.forceSeverity,N.allowDialog=x?.allowDialog,N}e.$VE=pe}),define(Se[259],De([1,0,4,211,6,3,28,42,18,69,23,76,248]),function(me,e,S,F,h,L,A,f,w,g,P,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3E=e.$2E=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$1E=e.$ZE=e.ViewContentGroups=e.$YE=e.$XE=e.ViewContainerLocation=e.Extensions=e.$WE=void 0,e.$WE=(0,$.$Yu)("default-view-icon",I.$Cj.window,(0,F.localize)(0,null));var k;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(k||(e.Extensions=k={}));var C;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(C||(e.ViewContainerLocation=C={})),e.$XE=[0,1,2];function E(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$YE=E;class n extends L.$lb{constructor(){super(...arguments),this.c=this.B(new S.$ec),this.onDidRegister=this.c.event,this.f=this.B(new S.$ec),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,w.$vf)([...this.g.values()])}registerViewContainer(i,c,l){const b=this.get(i.id);if(b)return b;const y=i;return y.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:y.openCommandActionDescriptor??{id:y.id},(0,A.$ki)(this.g,c,[]).push(y),l?.isDefault&&this.h.push(y),this.c.fire({viewContainer:y,viewContainerLocation:c}),y}deregisterViewContainer(i){for(const c of this.g.keys()){const l=this.g.get(c),b=l?.indexOf(i);if(b!==-1){l?.splice(b,1),l.length===0&&this.g.delete(c),this.f.fire({viewContainer:i,viewContainerLocation:c});return}}}get(i){return this.all.filter(c=>c.id===i)[0]}getViewContainers(i){return[...this.g.get(i)||[]]}getViewContainerLocation(i){return[...this.g.keys()].filter(c=>this.getViewContainers(c).filter(l=>l?.id===i.id).length>0)[0]}getDefaultViewContainer(i){return this.h.find(c=>this.getViewContainerLocation(c)===i)}}f.$Um.add(k.ViewContainersRegistry,new n);var o;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(o||(e.ViewContentGroups=o={}));function a(s,i){const c=s.group??o.More,l=i.group??o.More;return c!==l?c.localeCompare(l):(s.order??5)-(i.order??5)}class m extends L.$lb{constructor(){super(...arguments),this.c=this.B(new S.$ec),this.onViewsRegistered=this.c.event,this.f=this.B(new S.$ec),this.onViewsDeregistered=this.f.event,this.g=this.B(new S.$ec),this.onDidChangeContainer=this.g.event,this.h=this.B(new S.$ec),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new g.$L}registerViews(i,c){this.registerViews2([{views:i,viewContainer:c}])}registerViews2(i){i.forEach(({views:c,viewContainer:l})=>this.l(c,l)),this.c.fire(i)}deregisterViews(i,c){const l=this.m(i,c);l.length&&this.f.fire({views:l,viewContainer:c})}moveViews(i,c){for(const l of this.j.keys())if(l!==c){const b=this.m(i,l);b.length&&(this.l(b,c),this.g.fire({views:b,from:l,to:c}))}}getViews(i){return this.j.get(i)||[]}getView(i){for(const c of this.i){const l=(this.j.get(c)||[]).filter(b=>b.id===i)[0];if(l)return l}return null}getViewContainer(i){for(const c of this.i)if((this.j.get(c)||[]).filter(b=>b.id===i)[0])return c;return null}registerViewWelcomeContent(i,c){return this.k.add(i,c),this.h.fire(i),(0,L.$jb)(()=>{this.k.delete(i,c),this.h.fire(i)})}registerViewWelcomeContent2(i,c){const l=new Map;for(const[b,y]of c)this.k.add(i,y),l.set(b,(0,L.$jb)(()=>{this.k.delete(i,y),this.h.fire(i)}));return this.h.fire(i),l}getViewWelcomeContent(i){const c=[];return this.k.forEach(i,l=>c.push(l)),c.sort(a)}l(i,c){let l=this.j.get(c);l||(l=[],this.j.set(c,l),this.i.push(c));for(const b of i){if(this.getView(b.id)!==null)throw new Error((0,F.localize)(1,null,b.id));l.push(b)}}m(i,c){const l=this.j.get(c);if(!l)return[];const b=[],y=[];for(const u of l)i.includes(u)?b.push(u):y.push(u);return b.length&&(y.length?this.j.set(c,y):(this.j.delete(c),this.i.splice(this.i.indexOf(c),1))),b}}f.$Um.add(k.ViewsRegistry,new m),e.$ZE=(0,h.$ph)("viewsService"),e.$1E=(0,h.$ph)("viewDescriptorService");var v;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(v||(e.ViewVisibilityState=v={}));var D;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(D||(e.TreeItemCollapsibleState=D={}));class t{constructor(i,c){this.c=!1,this.d=!1,(0,P.$Lm)(this,i),this.d=!!c,this.resolve=async l=>{if(c&&!this.c){const b=await c(l);b&&(this.tooltip=this.tooltip??b.tooltip,this.command=this.command??b.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$2E=t;class r extends Error{constructor(i){super((0,F.localize)(2,null,i)),this.name="NoTreeViewError"}static is(i){return i.name==="NoTreeViewError"}}e.$3E=r}),define(Se[138],De([1,0,4,13,212]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bb=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new S.$ec,this.n=new S.$ec,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(f){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=f}onEvent(f){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=f}onRequest(f){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=f}sendResponse(f){f.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${f.command}`)):this.s("response",f)}sendRequest(f,w,g,P){const I={command:f};if(w&&Object.keys(w).length>0&&(I.arguments=w),this.s("request",I),typeof P=="number"){const $=setTimeout(()=>{clearTimeout($);const k=this.f.get(I.seq);if(k){this.f.delete(I.seq);const C={type:"response",seq:0,request_seq:I.seq,success:!1,command:f,message:(0,h.localize)(0,null,P,f)};k(C)}},P)}return g&&this.f.set(I.seq,g),I.seq}acceptMessage(f){this.j?this.j(f):(this.k.push(f),this.k.length===1&&this.q())}o(f,w){return f.type!=="event"||w.type!=="event"}async q(){let f;for(;this.k.length;){if((!f||this.o(this.k[0],f))&&await(0,F.$vg)(0),f=this.k.shift(),!f)return;switch(f.type){case"event":this.i?.(f);break;case"request":this.g?.(f);break;case"response":{const w=f,g=this.f.get(w.request_seq);g&&(this.f.delete(w.request_seq),g(w));break}}}}s(f,w){w.type=f,w.seq=this.d++,this.sendMessage(w)}async u(){if(this.f.size===0)return Promise.resolve();const f=new Map;this.f.forEach((w,g)=>f.set(g,w)),await(0,F.$vg)(500),f.forEach((w,g)=>{w({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.f.delete(g)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$4bb=L}),define(Se[260],De([1,0,213,47,6]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$bH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$aH=e.MemoryRangeType=e.$_G=e.State=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=void 0,e.$0F="workbench.view.debug",e.$$F="workbench.debug.variablesView",e.$_F="workbench.debug.watchExpressionsView",e.$aG="workbench.debug.callStackView",e.$bG="workbench.debug.loadedScriptsView",e.$cG="workbench.debug.breakPointsView",e.$dG="workbench.debug.disassemblyView",e.$eG="workbench.panel.repl",e.$fG="workbench.panel.repl.view",e.$gG=new F.$Oi("debugType",void 0,{type:"string",description:S.localize(0,null)}),e.$hG=new F.$Oi("debugConfigurationType",void 0,{type:"string",description:S.localize(1,null)}),e.$iG=new F.$Oi("debugState","inactive",{type:"string",description:S.localize(2,null)}),e.$jG="debugUx",e.$kG=new F.$Oi(e.$jG,"default",{type:"string",description:S.localize(3,null)}),e.$lG=new F.$Oi("hasDebugged",!1,{type:"boolean",description:S.localize(4,null)}),e.$mG=new F.$Oi("inDebugMode",!1,{type:"boolean",description:S.localize(5,null)}),e.$nG=new F.$Oi("inDebugRepl",!1,{type:"boolean",description:S.localize(6,null)}),e.$oG=new F.$Oi("breakpointWidgetVisible",!1,{type:"boolean",description:S.localize(7,null)}),e.$pG=new F.$Oi("inBreakpointWidget",!1,{type:"boolean",description:S.localize(8,null)}),e.$qG=new F.$Oi("breakpointsFocused",!0,{type:"boolean",description:S.localize(9,null)}),e.$rG=new F.$Oi("watchExpressionsFocused",!0,{type:"boolean",description:S.localize(10,null)}),e.$sG=new F.$Oi("watchExpressionsExist",!1,{type:"boolean",description:S.localize(11,null)}),e.$tG=new F.$Oi("variablesFocused",!0,{type:"boolean",description:S.localize(12,null)}),e.$uG=new F.$Oi("expressionSelected",!1,{type:"boolean",description:S.localize(13,null)}),e.$vG=new F.$Oi("breakpointInputFocused",!1,{type:"boolean",description:S.localize(14,null)}),e.$wG=new F.$Oi("callStackItemType",void 0,{type:"string",description:S.localize(15,null)}),e.$xG=new F.$Oi("callStackSessionIsAttach",!1,{type:"boolean",description:S.localize(16,null)}),e.$yG=new F.$Oi("callStackItemStopped",!1,{type:"boolean",description:S.localize(17,null)}),e.$zG=new F.$Oi("callStackSessionHasOneThread",!1,{type:"boolean",description:S.localize(18,null)}),e.$AG=new F.$Oi("watchItemType",void 0,{type:"string",description:S.localize(19,null)}),e.$BG=new F.$Oi("canViewMemory",void 0,{type:"boolean",description:S.localize(20,null)}),e.$CG=new F.$Oi("breakpointItemType",void 0,{type:"string",description:S.localize(21,null)}),e.$DG=new F.$Oi("breakpointSupportsCondition",!1,{type:"boolean",description:S.localize(22,null)}),e.$EG=new F.$Oi("loadedScriptsSupported",!1,{type:"boolean",description:S.localize(23,null)}),e.$FG=new F.$Oi("loadedScriptsItemType",void 0,{type:"string",description:S.localize(24,null)}),e.$GG=new F.$Oi("focusedSessionIsAttach",!1,{type:"boolean",description:S.localize(25,null)}),e.$HG=new F.$Oi("stepBackSupported",!1,{type:"boolean",description:S.localize(26,null)}),e.$IG=new F.$Oi("restartFrameSupported",!1,{type:"boolean",description:S.localize(27,null)}),e.$JG=new F.$Oi("stackFrameSupportsRestart",!1,{type:"boolean",description:S.localize(28,null)}),e.$KG=new F.$Oi("jumpToCursorSupported",!1,{type:"boolean",description:S.localize(29,null)}),e.$LG=new F.$Oi("stepIntoTargetsSupported",!1,{type:"boolean",description:S.localize(30,null)}),e.$MG=new F.$Oi("breakpointsExist",!1,{type:"boolean",description:S.localize(31,null)}),e.$NG=new F.$Oi("debuggersAvailable",!1,{type:"boolean",description:S.localize(32,null)}),e.$OG=new F.$Oi("debugExtensionAvailable",!0,{type:"boolean",description:S.localize(33,null)}),e.$PG=new F.$Oi("debugProtocolVariableMenuContext",void 0,{type:"string",description:S.localize(34,null)}),e.$QG=new F.$Oi("debugSetVariableSupported",!1,{type:"boolean",description:S.localize(35,null)}),e.$RG=new F.$Oi("debugSetExpressionSupported",!1,{type:"boolean",description:S.localize(36,null)}),e.$SG=new F.$Oi("breakWhenValueChangesSupported",!1,{type:"boolean",description:S.localize(37,null)}),e.$TG=new F.$Oi("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:S.localize(38,null)}),e.$UG=new F.$Oi("breakWhenValueIsReadSupported",!1,{type:"boolean",description:S.localize(39,null)}),e.$VG=new F.$Oi("terminateDebuggeeSupported",!1,{type:"boolean",description:S.localize(40,null)}),e.$WG=new F.$Oi("suspendDebuggeeSupported",!1,{type:"boolean",description:S.localize(41,null)}),e.$XG=new F.$Oi("variableEvaluateNamePresent",!1,{type:"boolean",description:S.localize(42,null)}),e.$YG=new F.$Oi("variableIsReadonly",!1,{type:"boolean",description:S.localize(43,null)}),e.$ZG=new F.$Oi("exceptionWidgetVisible",!1,{type:"boolean",description:S.localize(44,null)}),e.$1G=new F.$Oi("multiSessionRepl",!1,{type:"boolean",description:S.localize(45,null)}),e.$2G=new F.$Oi("multiSessionDebug",!1,{type:"boolean",description:S.localize(46,null)}),e.$3G=new F.$Oi("disassembleRequestSupported",!1,{type:"boolean",description:S.localize(47,null)}),e.$4G=new F.$Oi("disassemblyViewFocus",!1,{type:"boolean",description:S.localize(48,null)}),e.$5G=new F.$Oi("languageSupportsDisassembleRequest",!1,{type:"boolean",description:S.localize(49,null)}),e.$6G=new F.$Oi("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:S.localize(50,null)});const L=$=>S.localize(51,null,$);e.$7G=L,e.$8G="editor.contrib.debug",e.$9G="editor.contrib.breakpoint",e.$0G="debug",e.$$G={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:S.localize(52,null)};var A;(function($){$[$.Inactive=0]="Inactive",$[$.Initializing=1]="Initializing",$[$.Stopped=2]="Stopped",$[$.Running=3]="Running"})(A||(e.State=A={}));function f($){switch($){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$_G=f;var w;(function($){$[$.Valid=0]="Valid",$[$.Unreadable=1]="Unreadable",$[$.Error=2]="Error"})(w||(e.MemoryRangeType=w={})),e.$aH="vscode-debug-memory";var g;(function($){$[$.Initial=1]="Initial",$[$.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var P;(function($){$.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$bH=(0,h.$ph)("debugService");var I;(function($){$[$.CONDITION=0]="CONDITION",$[$.HIT_COUNT=1]="HIT_COUNT",$[$.LOG_MESSAGE=2]="LOG_MESSAGE"})(I||(e.BreakpointWidgetContext=I={}))}),define(Se[261],De([1,0,15,2,14,23,16,34,22,18]),function(me,e,S,F,h,L,A,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iF=e.$hF=e.$gF=e.$fF=e.$eF=e.$dF=e.$cF=e.$bF=e.$aF=e.$_E=e.$$E=e.$0E=void 0;const P=/{([^}]+)}/g;function I(b,y,u){return b.replace(P,function(d,p){return y&&p.length>0&&p[0]!=="_"?d:u&&u.hasOwnProperty(p)?u[p]:d})}e.$0E=I;function $(b){const y={};for(const u of Object.keys(b))u.startsWith("!")||(y[u]=b[u]);return y}e.$$E=$;function k(b){return b.configuration.request==="attach"&&!C(b)&&(!b.parentSession||k(b.parentSession))}e.$_E=k;function C(b){let y=b.configuration.type;if(y)return y==="vslsShare"&&(y=b.configuration.adapterProxy.configuration.type),(0,S.$Ld)(y,"extensionhost")||(0,S.$Ld)(y,"pwa-extensionhost")?b:b.parentSession?C(b.parentSession):void 0}e.$aF=C;function E(b){return b.type&&(b.label||b.program||b.runtime)}e.$bF=E;function n(b,y,u){let d,p=0;const R=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let O=null;for(;O=R.exec(b);){const j=O.index+1,T=j+O[0].length;if(j<=y&&T>=u){d=O[0],p=j;break}}if(d){const j=/\w+/g;let T=null;for(;(T=j.exec(d))&&!(T.index+1+p+T[0].length>=u););T&&(d=d.substring(0,j.lastIndex))}return d?{start:p,end:p+d.length-1}:{start:0,end:0}}e.$cF=n;async function o(b,y,u,d){if(b.evaluatableExpressionProvider.has(y)){const p=b.evaluatableExpressionProvider.ordered(y),R=(0,g.$jf)(await Promise.all(p.map(async O=>{try{return await O.provideEvaluatableExpression(y,u,d??w.CancellationToken.None)}catch{return}})));if(R.length>0){let O=R[0].expression;const j=R[0].range;return O||(O=y.getLineContent(u.lineNumber).substring(j.startColumn-1,j.endColumn-1)),{range:j,matchingExpression:O}}}else{const p=y.getLineContent(u.lineNumber),{start:R,end:O}=n(p,u.column,u.column),j=p.substring(R-1,O);return{matchingExpression:j,range:new f.$Ur(u.lineNumber,R,u.lineNumber,R+j.length)}}return null}e.$dF=o;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function m(b){return!!(b&&b.match(a))}e.$eF=m;function v(b){if(typeof b.path=="string"&&!(typeof b.sourceReference=="number"&&b.sourceReference>0)){if(m(b.path))return F.URI.parse(b.path);if((0,h.$7c)(b.path))return F.URI.file(b.path)}return b.path}function D(b){if(typeof b.path=="object"){const y=F.URI.revive(b.path);if(y)return y.scheme===A.Schemas.file?y.fsPath:y.toString()}return b.path}function t(b,y){const u=y?v:D,d=(0,L.$Im)(b);return s(d,(p,R)=>{p&&R&&(R.path=u(R))}),d}e.$fF=t;function r(b,y){const u=y?v:D,d=(0,L.$Im)(b);return s(d,(p,R)=>{!p&&R&&(R.path=u(R))}),d}e.$gF=r;function s(b,y){switch(b.type){case"event":{const u=b;switch(u.event){case"output":y(!1,u.body.source);break;case"loadedSource":y(!1,u.body.source);break;case"breakpoint":y(!1,u.body.breakpoint.source);break;default:break}break}case"request":{const u=b;switch(u.command){case"setBreakpoints":y(!0,u.arguments.source);break;case"breakpointLocations":y(!0,u.arguments.source);break;case"source":y(!0,u.arguments.source);break;case"gotoTargets":y(!0,u.arguments.source);break;case"launchVSCode":u.arguments.args.forEach(d=>y(!1,d));break;default:break}break}case"response":{const u=b;if(u.success&&u.body)switch(u.command){case"stackTrace":u.body.stackFrames.forEach(d=>y(!1,d.source));break;case"loadedSources":u.body.sources.forEach(d=>y(!1,d));break;case"scopes":u.body.scopes.forEach(d=>y(!1,d.source));break;case"setFunctionBreakpoints":u.body.breakpoints.forEach(d=>y(!1,d.source));break;case"setBreakpoints":u.body.breakpoints.forEach(d=>y(!1,d.source));break;case"disassemble":u.body?.instructions.forEach(p=>y(!1,p.location));break;default:break}break}}}function i(b){return b.filter(y=>!y.presentation?.hidden).sort((y,u)=>y.presentation?u.presentation?y.presentation.group?u.presentation.group?y.presentation.group!==u.presentation.group?y.presentation.group.localeCompare(u.presentation.group):c(y.presentation.order,u.presentation.order):-1:u.presentation.group?1:c(y.presentation.order,u.presentation.order):-1:u.presentation?1:0)}e.$hF=i;function c(b,y){return typeof b!="number"?typeof y!="number"?0:1:typeof y!="number"?-1:b-y}async function l(b,y){const u=b.getValue("debug.saveBeforeStart",{overrideIdentifier:y.activeTextEditorLanguageId});if(u!=="none"&&(await y.saveAll(),u==="allEditorsInActiveGroup")){const d=y.activeEditorPane;d&&d.input.resource?.scheme===A.Schemas.untitled&&await y.save({editor:d.input,groupId:d.group.id})}await b.reloadConfiguration()}e.$iF=l}),define(Se[262],De([1,0,46,57,23,14,9,15,29,214,138]),function(me,e,S,F,h,L,A,f,w,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=e.$Bcc=e.$Acc=e.$zcc=e.$ycc=void 0;class I extends P.$4bb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(o,a){this.p=a,this.r=Buffer.allocUnsafe(0),this.t=-1,o.on("data",m=>this.w(m))}sendMessage(o){if(this.p){const a=JSON.stringify(o);this.p.write(`Content-Length: ${Buffer.byteLength(a,"utf8")}${I.a}${a}`,"utf8")}}w(o){for(this.r=Buffer.concat([this.r,o]);;){if(this.t>=0){if(this.r.length>=this.t){const a=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,a.length>0)try{this.acceptMessage(JSON.parse(a))}catch(m){this.m.fire(new Error((m.message||m)+`
`+a))}continue}}else{const a=this.r.indexOf(I.a);if(a!==-1){const v=this.r.toString("utf8",0,a).split(I.b);for(const D of v){const t=D.split(I.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(a+I.a.length);continue}}break}}}e.$ycc=I;class $ extends I{startSession(){return new Promise((o,a)=>{let m=!1;this.x=this.y(()=>{this.v(this.x,this.x),o(),m=!0}),this.x.on("close",()=>{m?this.m.fire(new Error("connection closed")):a(new Error("connection closed"))}),this.x.on("error",v=>{m?this.m.fire(v):a(v)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$zcc=$;class k extends ${constructor(o){super(),this.z=o}y(o){return F.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$Acc=k;class C extends ${constructor(o){super(),this.z=o}y(o){return F.createConnection(this.z.path,o)}}e.$Bcc=C;class E extends I{constructor(o,a){super(),this.y=o,this.z=a}async startSession(){const o=this.y.command,a=this.y.args,m=this.y.options||{};try{if(o)if(L.$7c(o)){if(!await w.Promises.exists(o))throw new Error(g.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(g.localize(1,null,this.z));let v=process.env;if(m.env&&Object.keys(m.env).length>0&&(v=h.$Lm(h.$Im(process.env),m.env)),o==="node")if(Array.isArray(a)&&a.length>0){const D=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:v,execArgv:D?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};m.cwd&&(t.cwd=m.cwd);const r=S.fork(a[0],a.slice(1),t);if(!r.pid)throw new Error(g.localize(2,null,a[0]));this.x=r}else throw new Error(g.localize(3,null));else{const D={env:v};m.cwd&&(D.cwd=m.cwd),this.x=S.spawn(o,a,D)}this.x.on("error",D=>{this.m.fire(D)}),this.x.on("exit",(D,t)=>{this.n.fire(D)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",D=>{this.m.fire(D)}),this.x.stdin.on("error",D=>{this.m.fire(D)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(v){this.m.fire(v)}}async stopSession(){return this.x?(await this.u(),A.$i?new Promise((o,a)=>{const m=S.exec(`taskkill /F /T /PID ${this.x.pid}`,function(v,D,t){if(v)return a(v)});m.on("exit",o),m.on("error",a)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,a){if(!o)return;const m=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?m.runtime=L.$8c(a,o.runtime):m.runtime=o.runtime),o.runtimeArgs&&(m.runtimeArgs=o.runtimeArgs),o.program&&(L.$7c(o.program)?m.program=o.program:m.program=L.$8c(a,o.program)),o.args&&(m.args=o.args);const v=o;return v.win&&(m.win=E.A(v.win,a)),v.winx86&&(m.winx86=E.A(v.winx86,a)),v.windows&&(m.windows=E.A(v.windows,a)),v.osx&&(m.osx=E.A(v.osx,a)),v.linux&&(m.linux=E.A(v.linux,a)),m}static platformAdapterExecutable(o,a){let m=Object.create(null);a=a.toLowerCase();for(const i of o)if(i.contributes){const c=i.contributes.debuggers;c&&c.length>0&&c.filter(l=>typeof l.type=="string"&&f.$Ld(l.type,a)).forEach(l=>{const b=E.A(l,i.extensionLocation.fsPath);m=h.$Lm(m,b,i.isBuiltin)})}let v;A.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?v=m.winx86||m.win||m.windows:A.$i?v=m.win||m.windows:A.$j?v=m.osx:A.$k&&(v=m.linux),v=v||m;const D=v.program||m.program,t=v.args||m.args,r=v.runtime||m.runtime,s=v.runtimeArgs||m.runtimeArgs;if(r)return{type:"executable",command:r,args:(s||[]).concat(typeof D=="string"?[D]:[]).concat(t||[])};if(D)return{type:"executable",command:D,args:t||[]}}}e.$Ccc=E}),define(Se[263],De([1,0,46,32,9]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=e.$Dcc=void 0;function L(g,P){return new Promise((I,$)=>{let k="";const C=S.spawn(g,P);C.pid&&C.stdout.on("data",E=>{k+=E.toString()}),C.on("error",E=>{$(E)}),C.on("close",E=>{I(k)})})}async function A(g){if(g)if(h.$i){const P=await new Promise((I,$)=>{me(["@vscode/windows-process-tree"],I,$)});return new Promise(I=>{P.getProcessTree(g,$=>{I(!!$&&$.children.length>0)})})}else return L("/usr/bin/pgrep",["-lP",String(g)]).then(P=>{const I=P.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},P=>!0);return Promise.resolve(!0)}e.$Dcc=A;var f;(function(g){g[g.cmd=0]="cmd",g[g.powershell=1]="powershell",g[g.bash=2]="bash"})(f||(f={}));function w(g,P,I,$,k){g=g.trim().toLowerCase();let C;g.indexOf("powershell")>=0||g.indexOf("pwsh")>=0?C=1:g.indexOf("cmd.exe")>=0?C=0:g.indexOf("bash")>=0?C=2:h.$i?C=0:C=2;let E,n=" ";switch(C){case 1:if(E=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),$){const o=(0,F.$Me)($);o&&(n+=`${o}:; `),n+=`cd ${E($)}; `}if(k)for(const o in k){const a=k[o];a===null?n+=`Remove-Item env:${o}; `:n+=`\${env:${o}}='${a}'; `}if(P.length>0){const o=P.shift(),a=I?o:E(o);n+=a[0]==="'"?`& ${a} `:`${a} `;for(const m of P)n+=m==="<"||m===">"||I?m:E(m),n+=" "}break;case 0:if(E=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(a=>o.includes(a))||o.length===0?`"${o}"`:o),$){const o=(0,F.$Me)($);o&&(n+=`${o}: && `),n+=`cd ${E($)} && `}if(k){n+='cmd /C "';for(const o in k){let a=k[o];a===null?n+=`set "${o}=" && `:(a=a.replace(/[&^|<>]/g,m=>`^${m}`),n+=`set "${o}=${a}" && `)}}for(const o of P)n+=o==="<"||o===">"||I?o:E(o),n+=" ";k&&(n+='"');break;case 2:{E=a=>(a=a.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),a.length===0?'""':a);const o=a=>/[^\w@%\/+=,.:^-]/.test(a)?`'${a.replace(/'/g,"'\\''")}'`:a;if($&&(n+=`cd ${E($)} ; `),k){n+="/usr/bin/env";for(const a in k){const m=k[a];m===null?n+=` -u ${o(a)}`:n+=` ${o(`${a}=${m}`)}`}n+=" "}for(const a of P)n+=a==="<"||a===">"||I?a:E(a),n+=" ";break}}return n}e.$Ecc=w}),define(Se[107],De([1,0,21,35,48,97,16,14,9,47]),function(me,e,S,F,h,L,A,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TH=e.$SH=e.$RH=e.$QH=e.CellStatusbarAlignment=e.$PH=e.$OH=e.$NH=e.NotebookEditorPriority=e.$MH=e.$LH=e.$KH=e.$JH=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$IH=e.$HH=e.$GH=e.$FH=e.CellKind=e.$EH=e.$DH=e.$CH=void 0,e.$CH="workbench.editor.notebook",e.$DH="workbench.editor.notebookTextDiffEditor",e.$EH="workbench.editor.interactive";var P;(function(M){M[M.Markup=1]="Markup",M[M.Code=2]="Code"})(P||(e.CellKind=P={})),e.$FH=["application/json","application/javascript","text/html","image/svg+xml",L.$yr.latex,L.$yr.markdown,"image/png","image/jpeg",L.$yr.text],e.$GH=[L.$yr.latex,L.$yr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$yr.text],e.$HH=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$IH="_notAvailable";var I;(function(M){M[M.Running=1]="Running",M[M.Idle=2]="Idle"})(I||(e.NotebookRunState=I={}));var $;(function(M){M[M.Unconfirmed=1]="Unconfirmed",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})($||(e.NotebookCellExecutionState=$={}));var k;(function(M){M[M.Unconfirmed=1]="Unconfirmed",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(k||(e.NotebookExecutionState=k={}));var C;(function(M){M[M.WithHardKernelDependency=0]="WithHardKernelDependency",M[M.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",M[M.Pure=2]="Pure",M[M.Never=3]="Never"})(C||(e.NotebookRendererMatch=C={}));var E;(function(M){M.Always="always",M.Never="never",M.Optional="optional"})(E||(e.RendererMessagingSpec=E={}));var n;(function(M){M[M.ModelChange=1]="ModelChange",M[M.Move=2]="Move",M[M.ChangeCellLanguage=5]="ChangeCellLanguage",M[M.Initialize=6]="Initialize",M[M.ChangeCellMetadata=7]="ChangeCellMetadata",M[M.Output=8]="Output",M[M.OutputItem=9]="OutputItem",M[M.ChangeCellContent=10]="ChangeCellContent",M[M.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",M[M.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",M[M.ChangeCellMime=13]="ChangeCellMime",M[M.Unknown=100]="Unknown"})(n||(e.NotebookCellsChangeType=n={}));var o;(function(M){M[M.Handle=0]="Handle",M[M.Index=1]="Index"})(o||(e.SelectionStateType=o={}));var a;(function(M){M[M.Replace=1]="Replace",M[M.Output=2]="Output",M[M.Metadata=3]="Metadata",M[M.CellLanguage=4]="CellLanguage",M[M.DocumentMetadata=5]="DocumentMetadata",M[M.Move=6]="Move",M[M.OutputItems=7]="OutputItems",M[M.PartialMetadata=8]="PartialMetadata",M[M.PartialInternalMetadata=9]="PartialInternalMetadata"})(a||(e.CellEditType=a={}));var m;(function(M){M.scheme=A.Schemas.vscodeNotebookCell;const Y=["W","X","Y","Z","a","b","c","d","e","f"],J=new RegExp(`^[${Y.join("")}]+`),fe=7;function se(ne,x){const N=x.toString(fe),de=`${N.length<Y.length?Y[N.length-1]:"z"}${N}s${(0,S.$Yc)(S.$Ec.fromString(ne.scheme),!0,!0)}`;return ne.with({scheme:M.scheme,fragment:de})}M.generate=se;function ie(ne){if(ne.scheme!==M.scheme)return;const x=ne.fragment.indexOf("s");if(x<0)return;const N=parseInt(ne.fragment.substring(0,x).replace(J,""),fe),q=(0,S.$Xc)(ne.fragment.substring(x+1)).toString();if(!isNaN(N))return{handle:N,notebook:ne.with({scheme:q,fragment:null})}}M.parse=ie;function V(ne,x){return ne.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${x??""},${ne.scheme!==A.Schemas.file?ne.scheme:""}`})}M.generateCellOutputUri=V;function re(ne){if(ne.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const x=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ne.fragment);if(!x)return;const N=x[1]&&x[1]!==""?x[1]:void 0,q=x[2];return{outputId:N,notebook:ne.with({scheme:q||A.Schemas.file,fragment:null})}}M.parseCellOutputUri=re;function pe(ne,x,N){return M.generate(ne,x).with({scheme:N})}M.generateCellPropertyUri=pe;function ae(ne,x){if(ne.scheme===x)return M.parse(ne.with({scheme:M.scheme}))}M.parseCellPropertyUri=ae})(m||(e.CellUri=m={}));const v=M=>w.$i?M.replace(/\//g,"\\"):M;class D{constructor(Y=[],J=e.$FH){this.e=J,this.d=[...new Set(Y)].map(fe=>({pattern:fe,matches:F.$ej(v(fe))}))}sort(Y){const J=new Map(h.Iterable.map(Y,se=>[se,v(se)]));let fe=[];for(const{matches:se}of this.d)for(const[ie,V]of J)if(se(V)){fe.push(ie),J.delete(ie);break}return J.size&&(fe=fe.concat([...J.keys()].sort((se,ie)=>this.e.indexOf(se)-this.e.indexOf(ie)))),fe}prioritize(Y,J){const fe=this.f(Y);if(fe===-1){this.d.unshift({pattern:Y,matches:F.$ej(v(Y))});return}const se=new Set(J.map(V=>this.f(V,fe)));se.delete(-1);const ie=Array.from(se).sort();this.d.splice(fe+1,0,...ie.map(V=>this.d[V]));for(let V=ie.length-1;V>=0;V--)this.d.splice(ie[V],1)}toArray(){return this.d.map(Y=>Y.pattern)}f(Y,J=this.d.length){const fe=v(Y);for(let se=0;se<J;se++)if(this.d[se].matches(fe))return se;return-1}}e.$JH=D;function t(M,Y,J,fe=(se,ie)=>se===ie){const se=[];function ie(pe,ae,ne){if(ae===0&&ne.length===0)return;const x=se[se.length-1];x&&x.start+x.deleteCount===pe?(x.deleteCount+=ae,x.toInsert.push(...ne)):se.push({start:pe,deleteCount:ae,toInsert:ne})}let V=0,re=0;for(;;){if(V===M.length){ie(V,0,Y.slice(re));break}if(re===Y.length){ie(V,M.length-V,[]);break}const pe=M[V],ae=Y[re];if(fe(pe,ae)){V+=1,re+=1;continue}J(ae)?(ie(V,1,[]),V+=1):(ie(V,0,[ae]),re+=1)}return se}e.$KH=t,e.$LH=new g.$Oi("notebookEditorCursorAtBoundary","none"),e.$MH=new g.$Oi("notebookEditorCursorAtLineBoundary","none");var r;(function(M){M.default="default",M.option="option"})(r||(e.NotebookEditorPriority=r={}));function s(M){const Y=M;return!!((typeof Y.include=="string"||F.$fj(Y.include))&&(typeof Y.exclude=="string"||F.$fj(Y.exclude)))}e.$NH=s;function i(M,Y,J){if(Array.isArray(M.viewType)&&M.viewType.indexOf(Y)>=0||M.viewType===Y)return!0;if(M.filenamePattern){const fe=s(M.filenamePattern)?M.filenamePattern.include:M.filenamePattern,se=s(M.filenamePattern)?M.filenamePattern.exclude:void 0;if(F.$dj(fe,(0,f.$_c)(J.fsPath).toLowerCase()))return!(se&&F.$dj(se,(0,f.$_c)(J.fsPath).toLowerCase()))}return!1}e.$OH=i,e.$PH={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave"};var c;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(c||(e.CellStatusbarAlignment=c={}));class l{static{this.d="notebook/"}static create(Y){return`${l.d}${Y}`}static parse(Y){if(Y.startsWith(l.d))return Y.substring(l.d.length)}}e.$QH=l;function b(M){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(M)}e.$RH=b;const y=new TextDecoder;function u(M){const Y=[];let J=!1;for(const V of M)(Y.length===0||J)&&(Y.push(V),J=!0);let fe=R(Y);const se=S.$Ec.concat(Y.map(V=>S.$Ec.wrap(V))),ie=B(se);return fe=fe||ie.byteLength!==se.byteLength,{data:ie,didCompression:fe}}e.$SH=u,e.$TH=`${String.fromCharCode(27)}[A`;const d=e.$TH.split("").map(M=>M.charCodeAt(0)),p=10;function R(M){let Y=!1;return M.forEach((J,fe)=>{if(fe===0||J.length<e.$TH.length)return;const se=M[fe-1],ie=J.subarray(0,e.$TH.length);if(ie[0]===d[0]&&ie[1]===d[1]&&ie[2]===d[2]){const V=se.lastIndexOf(p);if(V===-1)return;Y=!0,M[fe-1]=se.subarray(0,V),M[fe]=J.subarray(e.$TH.length)}}),Y}function O(M){let Y=M;do M=Y,Y=M.replace(/[^\n]\x08/gm,"");while(Y.length<M.length);return M}function j(M){for(M=M.replace(/\r+\n/gm,`
`);M.search(/\r[^$]/g)>-1;){const Y=M.match(/^(.*)\r+/m)[1];let J=M.match(/\r+(.*)$/m)[1];J=J+Y.slice(J.length,Y.length),M=M.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,J)}return M}const T="\b".charCodeAt(0),z="\r".charCodeAt(0);function B(M){return!M.buffer.includes(T)&&!M.buffer.includes(z)?M:S.$Ec.fromString(j(O(y.decode(M.buffer))))}}),define(Se[7],De([1,0,18,8,78,28,97,15,19,2,31,25,30,84,107]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C){"use strict";var E,n,o,a,m,v,D,t,r,s,i,c,l,b,y,u,d,p;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$AL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.TestRunProfileKind=e.TestResultState=e.$hL=e.$gL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$fL=e.$eL=e.$dL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$cL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.ColorThemeKind=e.$9K=e.$8K=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$7K=e.DebugConsoleMode=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$1K=e.$ZK=e.FileChangeType=e.$YK=e.$XK=e.$WK=e.$VK=e.InlineCompletionTriggerKind=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.ConfigurationTarget=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$yK=e.ViewBadge=e.ProgressLocation=e.$xK=e.$wK=e.TaskScope=e.ShellQuoting=e.$vK=e.$uK=e.$tK=e.TaskPanelKind=e.TaskRevealKind=e.$sK=e.TerminalLocation=e.$rK=e.$qK=e.$pK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$oK=e.$nK=e.$mK=e.$lK=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$kK=e.StatusBarAlignment=e.ViewColumn=e.$jK=e.$iK=e.$hK=e.$gK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$fK=e.$eK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.LanguageStatusSeverity=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.CodeActionTriggerKind=e.$4J=e.$3J=e.SymbolTag=e.SymbolKind=e.$2J=e.DocumentHighlightKind=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.DiagnosticSeverity=e.DiagnosticTag=e.$WJ=e.$VJ=e.FileEditType=e.$UJ=e.$TJ=e.$SJ=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function R(H){return Object.assign(H,{apply:function(){const $e=arguments.length===1?[]:arguments[1];return Reflect.construct(H,$e,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(H,[]);{const[$e,...Le]=arguments;return Reflect.construct(H,Le,$e.constructor)}}})}var O;(function(H){H[H.Top=0]="Top",H[H.Bottom=1]="Bottom"})(O||(e.TerminalOutputAnchor=O={}));var j;(function(H){H[H.TerminalCommand=0]="TerminalCommand",H[H.Opener=1]="Opener",H[H.Command=3]="Command"})(j||(e.TerminalQuickFixType=j={}));let T=E=class{static from(...W){let $e=W;return new E(function(){if($e){for(const Le of $e)Le&&typeof Le.dispose=="function"&&Le.dispose();$e=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$LJ=T,e.$LJ=T=E=Je([R],T);let z=n=class{static Min(...W){if(W.length===0)throw new TypeError;let $e=W[0];for(let Le=1;Le<W.length;Le++){const Ye=W[Le];Ye.isBefore($e)&&($e=Ye)}return $e}static Max(...W){if(W.length===0)throw new TypeError;let $e=W[0];for(let Le=1;Le<W.length;Le++){const Ye=W[Le];Ye.isAfter($e)&&($e=Ye)}return $e}static isPosition(W){if(!W)return!1;if(W instanceof n)return!0;const{line:$e,character:Le}=W;return typeof $e=="number"&&typeof Le=="number"}static of(W){if(W instanceof n)return W;if(this.isPosition(W))return new n(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,$e){if(W<0)throw(0,F.$5)("line must be non-negative");if($e<0)throw(0,F.$5)("character must be non-negative");this.c=W,this.e=$e}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,$e=0){if(W===null||$e===null)throw(0,F.$5)();let Le;return typeof W>"u"?Le=0:typeof W=="number"?Le=W:(Le=typeof W.lineDelta=="number"?W.lineDelta:0,$e=typeof W.characterDelta=="number"?W.characterDelta:0),Le===0&&$e===0?this:new n(this.line+Le,this.character+$e)}with(W,$e=this.character){if(W===null||$e===null)throw(0,F.$5)();let Le;return typeof W>"u"?Le=this.line:typeof W=="number"?Le=W:(Le=typeof W.line=="number"?W.line:this.line,$e=typeof W.character=="number"?W.character:this.character),Le===this.line&&$e===this.character?this:new n(Le,$e)}toJSON(){return{line:this.line,character:this.character}}};e.$MJ=z,e.$MJ=z=n=Je([R],z);let B=o=class{static isRange(W){return W instanceof o?!0:W?z.isPosition(W.start)&&z.isPosition(W.end):!1}static of(W){if(W instanceof o)return W;if(this.isRange(W))return new o(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,$e,Le,Ye){let tt,at;if(typeof W=="number"&&typeof $e=="number"&&typeof Le=="number"&&typeof Ye=="number"?(tt=new z(W,$e),at=new z(Le,Ye)):z.isPosition(W)&&z.isPosition($e)&&(tt=z.of(W),at=z.of($e)),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this.c=tt,this.e=at):(this.c=at,this.e=tt)}contains(W){return o.isRange(W)?this.contains(W.start)&&this.contains(W.end):z.isPosition(W)?!(z.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const $e=z.Max(W.start,this.c),Le=z.Min(W.end,this.e);if(!$e.isAfter(Le))return new o($e,Le)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const $e=z.Min(W.start,this.c),Le=z.Max(W.end,this.end);return new o($e,Le)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,$e=this.end){if(W===null||$e===null)throw(0,F.$5)();let Le;return W?z.isPosition(W)?Le=W:(Le=W.start||this.start,$e=W.end||this.end):Le=this.start,Le.isEqual(this.c)&&$e.isEqual(this.end)?this:new o(Le,$e)}toJSON(){return[this.start,this.end]}};e.$NJ=B,e.$NJ=B=o=Je([R],B);let M=a=class extends B{static isSelection(W){return W instanceof a?!0:W?B.isRange(W)&&z.isPosition(W.anchor)&&z.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,$e,Le,Ye){let tt,at;if(typeof W=="number"&&typeof $e=="number"&&typeof Le=="number"&&typeof Ye=="number"?(tt=new z(W,$e),at=new z(Le,Ye)):z.isPosition(W)&&z.isPosition($e)&&(tt=z.of(W),at=z.of($e)),!tt||!at)throw new Error("Invalid arguments");super(tt,at),this.f=tt,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$OJ=M,e.$OJ=M=a=Je([R],M);const Y=H=>{if(typeof H!="string"||H.length===0||!/^[0-9A-Za-z_\-]+$/.test(H))throw(0,F.$5)("connectionToken")};class J{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,$e,Le){if(typeof W!="string"||W.length===0)throw(0,F.$5)("host");if(typeof $e!="number"||$e===0||Math.round($e)!==$e)throw(0,F.$5)("port");typeof Le<"u"&&Y(Le),this.host=W,this.port=Math.round($e),this.connectionToken=Le}}e.$PJ=J;class fe{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,$e){this.makeConnection=W,this.connectionToken=$e,typeof $e<"u"&&Y($e)}}e.$QJ=fe;class se extends Error{static NotAvailable(W,$e){return new se(W,k.RemoteAuthorityResolverErrorCode.NotAvailable,$e)}static TemporarilyNotAvailable(W){return new se(W,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,$e=k.RemoteAuthorityResolverErrorCode.Unknown,Le){super(W),this._message=W,this._code=$e,this._detail=Le,Object.setPrototypeOf(this,se.prototype)}}e.$RJ=se;var ie;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(ie||(e.EndOfLine=ie={}));var V;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(V||(e.EnvironmentVariableMutatorType=V={}));let re=m=class{static isTextEdit(W){return W instanceof m?!0:W?B.isRange(W)&&typeof W.newText=="string":!1}static replace(W,$e){return new m(W,$e)}static insert(W,$e){return m.replace(new B(W,W),$e)}static delete(W){return m.replace(W,"")}static setEndOfLine(W){const $e=new m(new B(new z(0,0),new z(0,0)),"");return $e.newEol=W,$e}get range(){return this.c}set range(W){if(W&&!B.isRange(W))throw(0,F.$5)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,F.$5)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,F.$5)("newEol");this.f=W}constructor(W,$e){this.c=W,this.e=$e}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$SJ=re,e.$SJ=re=m=Je([R],re);let pe=v=class{static isNotebookCellEdit(W){return W instanceof v?!0:W?Xt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,$e){return new v(W,$e)}static insertCells(W,$e){return new v(new Xt(W,W),$e)}static deleteCells(W){return new v(W,[])}static updateCellMetadata(W,$e){const Le=new v(new Xt(W,W),[]);return Le.newCellMetadata=$e,Le}static updateNotebookMetadata(W){const $e=new v(new Xt(0,0),[]);return $e.newNotebookMetadata=W,$e}constructor(W,$e){this.range=W,this.newCells=$e}};e.$TJ=pe,e.$TJ=pe=v=Je([R],pe);class ae{static isSnippetTextEdit(W){return W instanceof ae?!0:W?B.isRange(W.range)&&N.isSnippetString(W.snippet):!1}static replace(W,$e){return new ae(W,$e)}static insert(W,$e){return ae.replace(new B(W,W),$e)}constructor(W,$e){this.range=W,this.snippet=$e}}e.$UJ=ae;var ne;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace",H[H.Snippet=6]="Snippet"})(ne||(e.FileEditType=ne={}));let x=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,$e,Le,Ye){this.c.push({_type:1,from:W,to:$e,options:Le,metadata:Ye})}createFile(W,$e,Le){this.c.push({_type:1,from:void 0,to:W,options:$e,metadata:Le})}deleteFile(W,$e,Le){this.c.push({_type:1,from:W,to:void 0,options:$e,metadata:Le})}e(W,$e,Le){this.c.push({_type:3,metadata:Le,uri:W,edit:{editType:5,metadata:$e},notebookMetadata:$e})}f(W,$e,Le,Ye){const tt=$e.start,at=$e.end;(tt!==at||Le.length>0)&&this.c.push({_type:5,uri:W,index:tt,count:at-tt,cells:Le,metadata:Ye})}g(W,$e,Le,Ye){this.c.push({_type:3,metadata:Ye,uri:W,edit:{editType:3,index:$e,metadata:Le}})}replace(W,$e,Le,Ye){this.c.push({_type:2,uri:W,edit:new re($e,Le),metadata:Ye})}insert(W,$e,Le,Ye){this.replace(W,new B($e,$e),Le,Ye)}delete(W,$e,Le){this.replace(W,$e,"",Le)}has(W){return this.c.some($e=>$e._type===2&&$e.uri.toString()===W.toString())}set(W,$e){if($e)for(const Le of $e){if(!Le)continue;let Ye,tt;Array.isArray(Le)?(Ye=Le[0],tt=Le[1]):Ye=Le,pe.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.g(W,Ye.range.start,Ye.newCellMetadata,tt):Ye.newNotebookMetadata?this.e(W,Ye.newNotebookMetadata,tt):this.f(W,Ye.range,Ye.newCells,tt):ae.isSnippetTextEdit(Ye)?this.c.push({_type:6,uri:W,range:Ye.range,edit:Ye.snippet,metadata:tt}):this.c.push({_type:2,uri:W,edit:Ye,metadata:tt})}else{for(let Le=0;Le<this.c.length;Le++){const Ye=this.c[Le];switch(Ye._type){case 2:case 6:case 3:case 5:Ye.uri.toString()===W.toString()&&(this.c[Le]=void 0);break}}(0,S.$kf)(this.c)}}get(W){const $e=[];for(const Le of this.c)Le._type===2&&Le.uri.toString()===W.toString()&&$e.push(Le.edit);return $e}entries(){const W=new L.$ni;for(const $e of this.c)if($e._type===2){let Le=W.get($e.uri);Le||(Le=[$e.uri,[]],W.set($e.uri,Le)),Le[1].push($e.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$VJ=x,e.$VJ=x=Je([R],x);let N=D=class{static isSnippetString(W){return W instanceof D?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=D.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,$e=this.e++){if(typeof W=="function"){const Le=new D;Le.e=this.e,W(Le),this.e=Le.e,W=Le.value}else W=D.c(W);return this.value+="${",this.value+=$e,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,$e=this.e++){const Le=W.map(Ye=>Ye.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=$e,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(W,$e){if(typeof $e=="function"){const Le=new D;Le.e=this.e,$e(Le),this.e=Le.e,$e=Le.value}else typeof $e=="string"&&($e=$e.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,$e&&(this.value+=":",this.value+=$e),this.value+="}",this}};e.$WJ=N,e.$WJ=N=D=Je([R],N);var q;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(q||(e.DiagnosticTag=q={}));var de;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(de||(e.DiagnosticSeverity=de={}));let ye=t=class{static isLocation(W){return W instanceof t?!0:W?B.isRange(W.range)&&g.URI.isUri(W.uri):!1}constructor(W,$e){if(this.uri=W,$e)if(B.isRange($e))this.range=B.of($e);else if(z.isPosition($e))this.range=new B($e,$e);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$XJ=ye,e.$XJ=ye=t=Je([R],ye);let ve=class{static is(W){return W?typeof W.message=="string"&&W.location&&B.isRange(W.location.range)&&g.URI.isUri(W.location.uri):!1}constructor(W,$e){this.location=W,this.message=$e}static isEqual(W,$e){return W===$e?!0:!W||!$e?!1:W.message===$e.message&&W.location.range.isEqual($e.location.range)&&W.location.uri.toString()===$e.location.uri.toString()}};e.$YJ=ve,e.$YJ=ve=Je([R],ve);let we=class{constructor(W,$e,Le=de.Error){if(!B.isRange(W))throw new TypeError("range must be set");if(!$e)throw new TypeError("message must be set");this.range=W,this.message=$e,this.severity=Le}toJSON(){return{severity:de[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,$e){return W===$e?!0:!W||!$e?!1:W.message===$e.message&&W.severity===$e.severity&&W.code===$e.code&&W.severity===$e.severity&&W.source===$e.source&&W.range.isEqual($e.range)&&(0,S.$$e)(W.tags,$e.tags)&&(0,S.$$e)(W.relatedInformation,$e.relatedInformation,ve.isEqual)}};e.$ZJ=we,e.$ZJ=we=Je([R],we);let Ee=class{constructor(W,$e){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=$e}};e.$1J=Ee,e.$1J=Ee=Je([R],Ee);var K;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(K||(e.DocumentHighlightKind=K={}));let ee=class{constructor(W,$e=K.Text){this.range=W,this.kind=$e}toJSON(){return{range:this.range,kind:K[this.kind]}}};e.$2J=ee,e.$2J=ee=Je([R],ee);var G;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(G||(e.SymbolKind=G={}));var X;(function(H){H[H.Deprecated=1]="Deprecated"})(X||(e.SymbolTag=X={}));let he=r=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,$e,Le,Ye,tt){this.name=W,this.kind=$e,this.containerName=tt,typeof Le=="string"&&(this.containerName=Le),Ye instanceof ye?this.location=Ye:Le instanceof B&&(this.location=new ye(Ye,Le)),r.validate(this)}toJSON(){return{name:this.name,kind:G[this.kind],location:this.location,containerName:this.containerName}}};e.$3J=he,e.$3J=he=r=Je([R],he);let Ie=s=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(s.validate)}constructor(W,$e,Le,Ye,tt){this.name=W,this.detail=$e,this.kind=Le,this.range=Ye,this.selectionRange=tt,this.children=[],s.validate(this)}};e.$4J=Ie,e.$4J=Ie=s=Je([R],Ie);var U;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(U||(e.CodeActionTriggerKind=U={}));let Q=class{constructor(W,$e){this.title=W,this.kind=$e}};e.$5J=Q,e.$5J=Q=Je([R],Q);let _=class{static{i=this}static{this.c="."}constructor(W){this.value=W}append(W){return new i(this.value?this.value+i.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+i.c)}};e.$6J=_,e.$6J=_=i=Je([R],_);class oe extends _{constructor(W){super(W),this.value=W}}e.$7J=oe,_.Empty=new _(""),_.QuickFix=_.Empty.append("quickfix"),_.Refactor=_.Empty.append("refactor"),_.RefactorExtract=_.Refactor.append("extract"),_.RefactorInline=_.Refactor.append("inline"),_.RefactorMove=_.Refactor.append("move"),_.RefactorRewrite=_.Refactor.append("rewrite"),_.Source=_.Empty.append("source"),_.SourceOrganizeImports=_.Source.append("organizeImports"),_.SourceFixAll=_.Source.append("fixAll"),_.Notebook=_.Empty.append("notebook");let Z=class{constructor(W,$e){if(this.range=W,this.parent=$e,$e&&!$e.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$8J=Z,e.$8J=Z=Je([R],Z);class le{constructor(W,$e,Le,Ye,tt,at){this.kind=W,this.name=$e,this.detail=Le,this.uri=Ye,this.range=tt,this.selectionRange=at}}e.$9J=le;class be{constructor(W,$e){this.fromRanges=$e,this.from=W}}e.$0J=be;class ze{constructor(W,$e){this.fromRanges=$e,this.to=W}}e.$$J=ze;var qe;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(qe||(e.LanguageStatusSeverity=qe={}));let _e=class{constructor(W,$e){this.range=W,this.command=$e}get isResolved(){return!!this.command}};e.$_J=_e,e.$_J=_e=Je([R],_e);let Ze=c=class{#e;static isMarkdownString(W){return W instanceof c?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,$e=!1){this.#e=new h.$Kj(W,{supportThemeIcons:$e})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,$e){return this.#e.appendCodeblock($e??"",W),this}};e.$aK=Ze,e.$aK=Ze=c=Je([R],Ze);let it=class{constructor(W,$e){this.label=W,this.documentation=$e}};e.$bK=it,e.$bK=it=Je([R],it);let et=class{constructor(W,$e){this.label=W,this.documentation=$e,this.parameters=[]}};e.$cK=et,e.$cK=et=Je([R],et);let Pe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$dK=Pe,e.$dK=Pe=Je([R],Pe);var Oe;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(Oe||(e.SignatureHelpTriggerKind=Oe={}));var We;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(We||(e.InlayHintKind=We={}));let Re=class{constructor(W){this.value=W}};e.$eK=Re,e.$eK=Re=Je([R],Re);let Qe=class{constructor(W,$e,Le){this.position=W,this.label=$e,this.kind=Le}};e.$fK=Qe,e.$fK=Qe=Je([R],Qe);var ue;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ue||(e.CompletionTriggerKind=ue={}));var ce;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(ce||(e.CompletionItemKind=ce={}));var Ce;(function(H){H[H.Deprecated=1]="Deprecated"})(Ce||(e.CompletionItemTag=Ce={}));let Ve=class{constructor(W,$e){this.label=W,this.kind=$e}toJSON(){return{label:this.label,kind:this.kind&&ce[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$gK=Ve,e.$gK=Ve=Je([R],Ve);let je=class{constructor(W=[],$e=!1){this.items=W,this.isIncomplete=$e}};e.$hK=je,e.$hK=je=Je([R],je);let Xe=class{constructor(W,$e,Le){this.insertText=W,this.range=$e,this.command=Le}};e.$iK=Xe,e.$iK=Xe=Je([R],Xe);let rt=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$jK=rt,e.$jK=rt=Je([R],rt);var ot;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(ot||(e.ViewColumn=ot={}));var $t;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})($t||(e.StatusBarAlignment=$t={}));function Ct(H,W){return`${I.$Il.toKey(H)}.${W}`}e.$kK=Ct;var Qt;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(Qt||(e.TextEditorLineNumbersStyle=Qt={}));var qt;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(qt||(e.TextDocumentSaveReason=qt={}));var vt;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(vt||(e.TextEditorRevealType=vt={}));var Mt;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(Mt||(e.TextEditorSelectionChangeKind=Mt={}));var Nt;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(Nt||(e.TextDocumentChangeReason=Nt={}));var Jt;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Jt||(e.DecorationRangeBehavior=Jt={})),function(H){function W($e){switch($e){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=W}(Mt||(e.TextEditorSelectionChangeKind=Mt={}));let Lt=class{constructor(W,$e){if($e&&!g.URI.isUri($e))throw(0,F.$5)("target");if(!B.isRange(W)||W.isEmpty)throw(0,F.$5)("range");this.range=W,this.target=$e}};e.$lK=Lt,e.$lK=Lt=Je([R],Lt);let Rt=class{constructor(W,$e,Le,Ye){this.red=W,this.green=$e,this.blue=Le,this.alpha=Ye}};e.$mK=Rt,e.$mK=Rt=Je([R],Rt);let zt=class{constructor(W,$e){if($e&&!($e instanceof Rt))throw(0,F.$5)("color");if(!B.isRange(W)||W.isEmpty)throw(0,F.$5)("range");this.range=W,this.color=$e}};e.$nK=zt,e.$nK=zt=Je([R],zt);let Ut=class{constructor(W){if(!W||typeof W!="string")throw(0,F.$5)("label");this.label=W}};e.$oK=Ut,e.$oK=Ut=Je([R],Ut);var Vt;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(Vt||(e.ColorFormat=Vt={}));var Bt;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(Bt||(e.SourceControlInputBoxValidationType=Bt={}));var ct;(function(H){H[H.Unknown=0]="Unknown",H[H.Shutdown=1]="Shutdown",H[H.Process=2]="Process",H[H.User=3]="User",H[H.Extension=4]="Extension"})(ct||(e.TerminalExitReason=ct={}));class ht{constructor(W,$e,Le){if(this.startIndex=W,this.length=$e,this.tooltip=Le,typeof W!="number"||W<0)throw(0,F.$5)("startIndex");if(typeof $e!="number"||$e<1)throw(0,F.$5)("length");if(Le!==void 0&&typeof Le!="string")throw(0,F.$5)("tooltip")}}e.$pK=ht;class Ht{constructor(W){this.uri=W}}e.$qK=Ht;class At{constructor(W){this.terminalCommand=W}}e.$rK=At;var kt;(function(H){H[H.Panel=1]="Panel",H[H.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class ft{constructor(W){if(this.options=W,typeof W!="object")throw(0,F.$5)("options")}}e.$sK=ft;var It;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(It||(e.TaskRevealKind=It={}));var Ot;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(Ot||(e.TaskPanelKind=Ot={}));let yt=class{static{l=this}static{this.Clean=new l("clean","Clean")}static{this.Build=new l("build","Build")}static{this.Rebuild=new l("rebuild","Rebuild")}static{this.Test=new l("test","Test")}static from(W){switch(W){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}constructor(W,$e){if(this.label=$e,typeof W!="string"||typeof $e!="string")throw(0,F.$5)("name");this.c=W}get id(){return this.c}};e.$tK=yt,e.$tK=yt=l=Je([R],yt);function He(H){let W="";for(let $e=0;$e<H.length;$e++)W+=H[$e].replace(/,/g,",,")+",";return W}let Fe=class{constructor(W,$e,Le){if(typeof W!="string")throw(0,F.$5)("process");this.e=[],this.c=W,$e!==void 0&&(Array.isArray($e)?(this.e=$e,this.f=Le):this.f=$e)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,F.$5)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const $e of this.e)W.push($e);return He(W)}};e.$uK=Fe,e.$uK=Fe=Je([R],Fe);let Te=class{constructor(W,$e,Le){if(this.f=[],Array.isArray($e)){if(!W)throw(0,F.$5)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,F.$5)("command");this.e=W,this.f=$e,this.g=Le}else{if(typeof W!="string")throw(0,F.$5)("commandLine");this.c=W,this.g=$e}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,F.$5)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,F.$5)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const $e of this.f)W.push(typeof $e=="string"?$e:$e.value);return He(W)}};e.$vK=Te,e.$vK=Te=Je([R],Te);var Ae;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Ae||(e.ShellQuoting=Ae={}));var te;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(te||(e.TaskScope=te={}));class Me{constructor(W){this.c=W}computeId(){return"customExecution"+(0,P.$3e)()}set callback(W){this.c=W}get callback(){return this.c}}e.$wK=Me;let Ke=class{static{b=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(W,$e,Le,Ye,tt,at){this.j=!1,this.k=this.definition=W;let dt;typeof $e=="string"?(this.m=this.name=$e,this.t=this.source=Le,this.execution=Ye,dt=tt,this.j=!0):$e===te.Global||$e===te.Workspace?(this.target=$e,this.m=this.name=Le,this.t=this.source=Ye,this.execution=tt,dt=at):(this.target=$e,this.m=this.name=Le,this.t=this.source=Ye,this.execution=tt,dt=at),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof Fe?this.k={type:b.e,id:this.n.computeId()}:this.n instanceof Te?this.k={type:b.f,id:this.n.computeId()}:this.n instanceof Me?this.k={type:b.c,id:this.n.computeId()}:this.k={type:b.g,id:(0,P.$3e)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,F.$5)("Kind can't be undefined or null");this.y(),this.k=W}get scope(){return this.l}set target(W){this.y(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,F.$5)("name");this.y(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.y(),this.n=W;const $e=this.k.type;(b.g===$e||b.e===$e||b.f===$e||b.c===$e)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.y(),this.o=W,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.y(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,F.$5)("source must be a string of length > 0");this.y(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.y(),this.u=W}get detail(){return this.x}set detail(W){W===null&&(W=void 0),this.x=W}get presentationOptions(){return this.v}set presentationOptions(W){W==null&&(W=Object.create(null)),this.y(),this.v=W}get runOptions(){return this.w}set runOptions(W){W==null&&(W=Object.create(null)),this.y(),this.w=W}};e.$xK=Ke,e.$xK=Ke=b=Je([R],Ke);var xe;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(xe||(e.ProgressLocation=xe={}));var Ge;(function(H){function W($e){const Le=$e;return(0,w.$me)(Le.value)?Le.tooltip&&!(0,w.$ie)(Le.tooltip)?(console.log("INVALID view badge, invalid tooltip",Le.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Le.value),!1)}H.isViewBadge=W})(Ge||(e.ViewBadge=Ge={}));let nt=y=class{static isTreeItem(W,$e){const Le=W;if(Le.checkboxState!==void 0){const Ye=(0,w.$me)(Le.checkboxState)?Le.checkboxState:(0,w.$ke)(Le.checkboxState)&&(0,w.$me)(Le.checkboxState.state)?Le.checkboxState.state:void 0,tt=!(0,w.$me)(Le.checkboxState)&&(0,w.$ke)(Le.checkboxState)?Le.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==Et.Checked&&Ye!==Et.Unchecked||tt!==void 0&&!(0,w.$ie)(tt))return console.log("INVALID tree item, invalid checkboxState",Le.checkboxState),!1}if(W instanceof y)return!0;if(Le.label!==void 0&&!(0,w.$ie)(Le.label)&&!Le.label?.label)return console.log("INVALID tree item, invalid label",Le.label),!1;if(Le.id!==void 0&&!(0,w.$ie)(Le.id))return console.log("INVALID tree item, invalid id",Le.id),!1;if(Le.iconPath!==void 0&&!(0,w.$ie)(Le.iconPath)&&!g.URI.isUri(Le.iconPath)&&(!Le.iconPath||!(0,w.$ie)(Le.iconPath.id))){const Ye=Le.iconPath;if(!Ye||!(0,w.$ie)(Ye.light)&&!g.URI.isUri(Ye.light)&&!(0,w.$ie)(Ye.dark)&&!g.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Le.iconPath),!1}return Le.description!==void 0&&!(0,w.$ie)(Le.description)&&typeof Le.description!="boolean"?(console.log("INVALID tree item, invalid description",Le.description),!1):Le.resourceUri!==void 0&&!g.URI.isUri(Le.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Le.resourceUri),!1):Le.tooltip!==void 0&&!(0,w.$ie)(Le.tooltip)&&!(Le.tooltip instanceof Ze)?(console.log("INVALID tree item, invalid tooltip",Le.tooltip),!1):Le.command!==void 0&&!Le.command.command?(console.log("INVALID tree item, invalid command",Le.command),!1):Le.collapsibleState!==void 0&&Le.collapsibleState<bt.None&&Le.collapsibleState>bt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Le.collapsibleState),!1):Le.contextValue!==void 0&&!(0,w.$ie)(Le.contextValue)?(console.log("INVALID tree item, invalid contextValue",Le.contextValue),!1):Le.accessibilityInformation!==void 0&&!Le.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Le.accessibilityInformation),!1):!0}constructor(W,$e=bt.None){this.collapsibleState=$e,g.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$yK=nt,e.$yK=nt=y=Je([R],nt);var bt;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(bt||(e.TreeItemCollapsibleState=bt={}));var Et;(function(H){H[H.Unchecked=0]="Unchecked",H[H.Checked=1]="Checked"})(Et||(e.TreeItemCheckboxState=Et={}));let pt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$zK=pt,e.$zK=pt=Je([R],pt);class ut extends pt{}e.$AK=ut;class gt extends ut{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.$BK=gt;class St{constructor(W,$e,Le,Ye){this.name=W,this.uri=$e,this._itemId=Le,this.c=Ye}data(){return this.c()}}e.$CK=St;let mi=class{#e=new Map;constructor(W){for(const[$e,Le]of W??[]){const Ye=this.#e.get(this.#t($e));Ye?Ye.push(Le):this.#e.set(this.#t($e),[Le])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,$e){this.#e.set(this.#t(W),[$e])}forEach(W,$e){for(const[Le,Ye]of this.#e)for(const tt of Ye)W.call($e,tt,Le,this)}*[Symbol.iterator](){for(const[W,$e]of this.#e)for(const Le of $e)yield[W,Le]}#t(W){return W.toLowerCase()}};e.$DK=mi,e.$DK=mi=Je([R],mi);let Kt=class{constructor(W){this.insertText=W}};e.$EK=Kt,e.$EK=Kt=Je([R],Kt);let Ei=class{constructor(W,$e){this.label=$e,this.insertText=W}};e.$FK=Ei,e.$FK=Ei=Je([R],Ei);let Wt=class{constructor(W,$e){this.id=W,this.color=$e}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$GK=Wt,e.$GK=Wt=Je([R],Wt),Wt.File=new Wt("file"),Wt.Folder=new Wt("folder");let gi=class{constructor(W){this.id=W}};e.$HK=gi,e.$HK=gi=Je([R],gi);var Pt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(Pt||(e.ConfigurationTarget=Pt={}));let ki=class{get base(){return this.c}set base(W){this.c=W,this.e=g.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,$e){if(typeof W!="string"&&(!W||!g.URI.isUri(W)&&!g.URI.isUri(W.uri)))throw(0,F.$5)("base");if(typeof $e!="string")throw(0,F.$5)("pattern");typeof W=="string"?this.baseUri=g.URI.file(W):g.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=$e}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$IK=ki,e.$IK=ki=Je([R],ki);const qi=new WeakMap;function Dt(H,W){qi.set(H,W)}e.$JK=Dt;let ti=class{constructor(W,$e,Le,Ye){this.enabled=typeof W=="boolean"?W:!0,typeof $e=="string"&&(this.condition=$e),typeof Le=="string"&&(this.hitCondition=Le),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this.c||(this.c=qi.get(this)??(0,P.$3e)()),this.c}};e.$KK=ti,e.$KK=ti=Je([R],ti);let $i=class extends ti{constructor(W,$e,Le,Ye,tt){if(super($e,Le,Ye,tt),W===null)throw(0,F.$5)("location");this.location=W}};e.$LK=$i,e.$LK=$i=Je([R],$i);let si=class extends ti{constructor(W,$e,Le,Ye,tt){super($e,Le,Ye,tt),this.functionName=W}};e.$MK=si,e.$MK=si=Je([R],si);let Si=class extends ti{constructor(W,$e,Le,Ye,tt,at,dt){if(super(Ye,tt,at,dt),!$e)throw(0,F.$5)("dataId");this.label=W,this.dataId=$e,this.canPersist=Le}};e.$NK=Si,e.$NK=Si=Je([R],Si);let Di=class{constructor(W,$e,Le){this.command=W,this.args=$e||[],this.options=Le}};e.$OK=Di,e.$OK=Di=Je([R],Di);let Ft=class{constructor(W,$e){this.port=W,this.host=$e}};e.$PK=Ft,e.$PK=Ft=Je([R],Ft);let bi=class{constructor(W){this.path=W}};e.$QK=bi,e.$QK=bi=Je([R],bi);let Ci=class{constructor(W){this.implementation=W}};e.$RK=Ci,e.$RK=Ci=Je([R],Ci);let oi=class{constructor(W,$e,Le){this.session=W,this.threadId=$e,this.frameId=Le}};e.$SK=oi,e.$SK=oi=Je([R],oi);let ai=class{constructor(W,$e){this.session=W,this.threadId=$e}};e.$TK=ai,e.$TK=ai=Je([R],ai);let lt=class{constructor(W,$e){this.range=W,this.expression=$e}};e.$UK=lt,e.$UK=lt=Je([R],lt);var Vi;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Vi||(e.InlineCompletionTriggerKind=Vi={}));let Zt=class{constructor(W,$e){this.range=W,this.text=$e}};e.$VK=Zt,e.$VK=Zt=Je([R],Zt);let ii=class{constructor(W,$e,Le=!0){this.range=W,this.variableName=$e,this.caseSensitiveLookup=Le}};e.$WK=ii,e.$WK=ii=Je([R],ii);let pi=class{constructor(W,$e){this.range=W,this.expression=$e}};e.$XK=pi,e.$XK=pi=Je([R],pi);let Ii=class{constructor(W,$e){this.frameId=W,this.stoppedLocation=$e}};e.$YK=Ii,e.$YK=Ii=Je([R],Ii);var Ki;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Ki||(e.FileChangeType=Ki={}));let Pi=u=class extends Error{static FileExists(W){return new u(W,$.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(W){return new u(W,$.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(W){return new u(W,$.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(W){return new u(W,$.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(W){return new u(W,$.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(W){return new u(W,$.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}constructor(W,$e=$.FileSystemProviderErrorCode.Unknown,Le){super(g.URI.isUri(W)?W.toString(!0):W),this.code=Le?.name??"Unknown",(0,$.$7j)(this,$e),Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.$ZK=Pi,e.$ZK=Pi=u=Je([R],Pi);let vi=class{constructor(W,$e,Le){this.start=W,this.end=$e,this.kind=Le}};e.$1K=vi,e.$1K=vi=Je([R],vi);var Ji;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(Ji||(e.FoldingRangeKind=Ji={}));var Ai;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var ci;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(ci||(e.CommentMode=ci={}));var Hi;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(Hi||(e.CommentState=Hi={}));var wi;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Li{constructor(W,$e=[]){this.tokenTypes=W,this.tokenModifiers=$e}}e.$2K=Li;function cn(H){return typeof H>"u"||(0,w.$je)(H)}class Ri{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let $e=0,Le=W.tokenTypes.length;$e<Le;$e++)this.j.set(W.tokenTypes[$e],$e);for(let $e=0,Le=W.tokenModifiers.length;$e<Le;$e++)this.k.set(W.tokenModifiers[$e],$e)}}push(W,$e,Le,Ye,tt){if(typeof W=="number"&&typeof $e=="number"&&typeof Le=="number"&&typeof Ye=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.n(W,$e,Le,Ye,tt);if(B.isRange(W)&&typeof $e=="string"&&cn(Le))return this.m(W,$e,Le);throw(0,F.$5)()}m(W,$e,Le){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has($e))throw new Error("`tokenType` is not in the provided legend");const Ye=W.start.line,tt=W.start.character,at=W.end.character-W.start.character,dt=this.j.get($e);let jt=0;if(Le)for(const Yt of Le){if(!this.k.has(Yt))throw new Error("`tokenModifier` is not in the provided legend");const _t=this.k.get(Yt);jt|=1<<_t>>>0}this.n(Ye,tt,at,dt,jt)}n(W,$e,Le,Ye,tt){if(this.f&&(W<this.c||W===this.c&&$e<this.e)){this.f=!1;const jt=this.g.length/5|0;let Yt=0,_t=0;for(let ei=0;ei<jt;ei++){let ri=this.g[5*ei],Bi=this.g[5*ei+1];ri===0?(ri=Yt,Bi+=_t):ri+=Yt,this.g[5*ei]=ri,this.g[5*ei+1]=Bi,Yt=ri,_t=Bi}}let at=W,dt=$e;this.f&&this.h>0&&(at-=this.c,at===0&&(dt-=this.e)),this.g[this.h++]=at,this.g[this.h++]=dt,this.g[this.h++]=Le,this.g[this.h++]=Ye,this.g[this.h++]=tt,this.c=W,this.e=$e}static o(W){const $e=[],Le=W.length/5|0;for(let dt=0;dt<Le;dt++)$e[dt]=dt;$e.sort((dt,jt)=>{const Yt=W[5*dt],_t=W[5*jt];if(Yt===_t){const ei=W[5*dt+1],ri=W[5*jt+1];return ei-ri}return Yt-_t});const Ye=new Uint32Array(W.length);let tt=0,at=0;for(let dt=0;dt<Le;dt++){const jt=5*$e[dt],Yt=W[jt+0],_t=W[jt+1],ei=W[jt+2],ri=W[jt+3],Bi=W[jt+4],wn=Yt-tt,Rn=wn===0?_t-at:_t,Wi=5*dt;Ye[Wi+0]=wn,Ye[Wi+1]=Rn,Ye[Wi+2]=ei,Ye[Wi+3]=ri,Ye[Wi+4]=Bi,tt=Yt,at=_t}return Ye}build(W){return this.f?new ni(new Uint32Array(this.g),W):new ni(Ri.o(this.g),W)}}e.$3K=Ri;class ni{constructor(W,$e){this.resultId=$e,this.data=W}}e.$4K=ni;class un{constructor(W,$e,Le){this.start=W,this.deleteCount=$e,this.data=Le}}e.$5K=un;class ln{constructor(W,$e){this.resultId=$e,this.edits=W}}e.$6K=ln;var Gi;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(Gi||(e.DebugConsoleMode=Gi={}));let fi=class{static{this.Back={iconPath:new Wt("arrow-left")}}constructor(){}};e.$7K=fi,e.$7K=fi=Je([R],fi);var Yi;(function(H){H[H.Separator=-1]="Separator",H[H.Default=0]="Default"})(Yi||(e.QuickPickItemKind=Yi={}));var Qi;(function(H){H[H.Info=1]="Info",H[H.Warning=2]="Warning",H[H.Error=3]="Error"})(Qi||(e.InputBoxValidationSeverity=Qi={}));var ui;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(ui||(e.ExtensionKind=ui={}));class Zi{static validate(W){if(typeof W.badge=="string"){let $e=(0,f.$Vd)(W.badge,0);if($e<W.badge.length&&($e+=(0,f.$Vd)(W.badge,$e)),W.badge.length>$e)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Wt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,$e,Le){this.badge=W,this.tooltip=$e,this.color=Le}}e.$8K=Zi;let Fi=class{constructor(W){this.kind=W}};e.$9K=Fi,e.$9K=Fi=Je([R],Fi);var Xi;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast",H[H.HighContrastLight=4]="HighContrastLight"})(Xi||(e.ColorThemeKind=Xi={}));class Xt{static isNotebookRange(W){return W instanceof Xt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,$e){if(W<0)throw(0,F.$5)("start must be positive");if($e<0)throw(0,F.$5)("end must be positive");W<=$e?(this.c=W,this.e=$e):(this.c=$e,this.e=W)}with(W){let $e=this.c,Le=this.e;return W.start!==void 0&&($e=W.start),W.end!==void 0&&(Le=W.end),$e===this.c&&Le===this.e?this:new Xt($e,Le)}}e.$0K=Xt;class yi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every($e=>yi.isNotebookCellData($e))}static isNotebookCellData(W){return!0}constructor(W,$e,Le,Ye,tt,at,dt){this.kind=W,this.value=$e,this.languageId=Le,this.mime=Ye,this.outputs=tt??[],this.metadata=at,this.executionSummary=dt,yi.validate(this)}}e.$$K=yi;class hn{constructor(W){this.cells=W}}e.$_K=hn;class Gt{static isNotebookCellOutputItem(W){return W instanceof Gt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const $e={name:W.name,message:W.message,stack:W.stack};return Gt.json($e,"application/vnd.code.notebook.error")}static stdout(W){return Gt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Gt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,$e="application/octet-stream"){return new Gt(W,$e)}static#e=new TextEncoder;static text(W,$e=A.$yr.text){const Le=Gt.#e.encode(String(W));return new Gt(Le,$e)}static json(W,$e="text/x-json"){const Le=JSON.stringify(W,void 0,"	");return Gt.text(Le,$e)}constructor(W,$e){this.data=W,this.mime=$e;const Le=(0,A.$Cr)($e,!0);if(!Le)throw new Error(`INVALID mime type: ${$e}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.$aL=Gt;class li{static isNotebookCellOutput(W){return W instanceof li?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,$e=!1){const Le=new Set,Ye=new Set;for(let tt=0;tt<W.length;tt++){const at=W[tt],dt=(0,A.$Cr)(at.mime);if(!Le.has(dt)||(0,C.$RH)(dt)){Le.add(dt);continue}Ye.add(tt),$e&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ye.size===0?W:W.filter((tt,at)=>!Ye.has(at))}constructor(W,$e,Le){this.items=li.ensureUniqueMimeTypes(W,!0),typeof $e=="string"?(this.id=$e,this.metadata=Le):(this.id=(0,P.$3e)(),this.metadata=$e??Le)}}e.$bL=li;var Ti;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(Ti||(e.NotebookCellKind=Ti={}));var Ue;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(Ue||(e.NotebookCellExecutionState=Ue={}));var xt;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(xt||(e.NotebookCellStatusBarAlignment=xt={}));var Mi;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Mi||(e.NotebookEditorRevealType=Mi={}));class mt{constructor(W,$e){this.text=W,this.alignment=$e}}e.$cL=mt;var xi;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(xi||(e.NotebookControllerAffinity=xi={}));var _i;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred",H[H.Hidden=-1]="Hidden"})(_i||(e.NotebookControllerAffinity2=_i={}));class en{constructor(W,$e=[]){this.uri=W,this.provides=(0,S.$Gf)($e)}}e.$dL=en;class dn{constructor(W){this.label=W}}e.$eL=dn;let hi=class{constructor(W,$e){this.label=W,this.timestamp=$e}};e.$fL=hi,e.$fL=hi=Je([R],hi);var tn;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(W,$e){this.ranges=W,this.wordPattern=$e}}e.$gL=sn;class fn{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$hL=fn;var on;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Oi=class{constructor(W=void 0,$e=void 0,Le=void 0,Ye=!1){this.include=W,this.exclude=$e,this.profile=Le,this.continuous=Ye}};e.$iL=Oi,e.$iL=Oi=Je([R],Oi);let Ni=d=class{static diff(W,$e,Le){const Ye=new d(W);return Ye.expectedOutput=$e,Ye.actualOutput=Le,Ye}constructor(W){this.message=W}};e.$jL=Ni,e.$jL=Ni=d=Je([R],Ni);let zi=class{constructor(W){this.id=W}};e.$kL=zi,e.$kL=zi=Je([R],zi);let di=class{constructor(W,$e){this.covered=W,this.total=$e}};e.$lL=di,e.$lL=di=Je([R],di);let ji=p=class{static fromDetails(W,$e){const Le=new di(0,0),Ye=new di(0,0),tt=new di(0,0);for(const dt of $e)if("branches"in dt){Le.total+=1,Le.covered+=dt.executionCount>0?1:0;for(const jt of dt.branches)Ye.total+=1,Ye.covered+=jt.executionCount>0?1:0}else tt.total+=1,tt.covered+=dt.executionCount>0?1:0;const at=new p(W,Le,Ye.total>0?Ye:void 0,tt.total>0?tt:void 0);return at.detailedCoverage=$e,at}constructor(W,$e,Le,Ye){this.uri=W,this.statementCoverage=$e,this.branchCoverage=Le,this.functionCoverage=Ye}};e.$mL=ji,e.$mL=ji=p=Je([R],ji);let Ui=class{constructor(W,$e,Le=[]){this.executionCount=W,this.location=$e,this.branches=Le}};e.$nL=Ui,e.$nL=Ui=Je([R],Ui);let ge=class{constructor(W,$e){this.executionCount=W,this.location=$e}};e.$oL=ge,e.$oL=ge=Je([R],ge);let ke=class{constructor(W,$e){this.executionCount=W,this.location=$e}};e.$pL=ke,e.$pL=ke=Je([R],ke);var Ne;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(Ne||(e.ExternalUriOpenerPriority=Ne={}));var st;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(st||(e.WorkspaceTrustState=st={}));var wt;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(wt||(e.PortAutoForwardAction=wt={}));class Tt{constructor(W,$e,Le,Ye,tt,at){this.kind=W,this.name=$e,this.detail=Le,this.uri=Ye,this.range=tt,this.selectionRange=at}}e.$qL=Tt;class yn{constructor(W){this.uri=W}}e.$rL=yn;class En{constructor(W,$e){this.original=W,this.modified=$e}}e.$sL=En;class kn{constructor(W,$e,Le,Ye){this.base=W,this.input1=$e,this.input2=Le,this.result=Ye}}e.$tL=kn;class Sn{constructor(W,$e){this.uri=W,this.viewType=$e}}e.$uL=Sn;class Dn{constructor(W){this.viewType=W}}e.$vL=Dn;class Cn{constructor(W,$e){this.uri=W,this.notebookType=$e}}e.$wL=Cn;class In{constructor(W,$e,Le){this.original=W,this.modified=$e,this.notebookType=Le}}e.$xL=In;class Pn{constructor(){}}e.$yL=Pn;class An{constructor(W,$e){this.uri=W,this.inputBoxUri=$e}}e.$zL=An;var mn;(function(H){H[H.Up=1]="Up",H[H.Down=2]="Down"})(mn||(e.InteractiveSessionVoteDirection=mn={}));var gn;(function(H){H[H.Action=1]="Action",H[H.Toolbar=2]="Toolbar"})(gn||(e.InteractiveSessionCopyKind=gn={}));var $n;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful",H[H.Undone=2]="Undone",H[H.Accepted=3]="Accepted"})($n||(e.InteractiveEditorResponseFeedbackKind=$n={}));var bn;(function(H){H[H.System=0]="System",H[H.User=1]="User",H[H.Assistant=2]="Assistant",H[H.Function=3]="Function"})(bn||(e.ChatMessageRole=bn={}));var pn;(function(H){H[H.Short=1]="Short",H[H.Medium=2]="Medium",H[H.Full=3]="Full"})(pn||(e.ChatVariableLevel=pn={}));class Ln{constructor(W,$e){this.role=W,this.content=$e}}e.$AL=Ln;var vn;(function(H){H[H.SymbolInformation=1]="SymbolInformation",H[H.CommandInformation=2]="CommandInformation",H[H.SearchInformation=3]="SearchInformation",H[H.SettingInformation=4]="SettingInformation"})(vn||(e.RelatedInformationType=vn={}))}),define(Se[139],De([1,0,54,16,15,168,122,7,18]),function(me,e,S,F,h,L,A,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PL=e.$OL=e.$NL=void 0;const g=new Map;function P(C,E){E?g.set(C,E):g.delete(C)}e.$NL=P;function I(C){return g.get(C)}class $ extends L.$Cu{constructor(E,n,o,a,m,v,D,t){super(n,o,a,m),this.c=E,this.m=v,this.q=D,this.notebook=t,this.b=!1}dispose(){(0,S.ok)(!this.b),this.b=!0,this.q=!1}equalLines(E){return(0,w.$$e)(this.f,E)}get document(){if(!this.a){const E=this;this.a={get uri(){return E.d},get fileName(){return E.d.fsPath},get isUntitled(){return E.d.scheme===F.Schemas.untitled},get languageId(){return E.m},get version(){return E.h},get isClosed(){return E.b},get isDirty(){return E.q},save(){return E.r()},getText(n){return n?E.s(n):E.getText()},get eol(){return E.g===`
`?f.EndOfLine.LF:f.EndOfLine.CRLF},get lineCount(){return E.f.length},lineAt(n){return E.t(n)},offsetAt(n){return E.u(n)},positionAt(n){return E.v(n)},validateRange(n){return E.w(n)},validatePosition(n){return E.x(n)},getWordRangeAtPosition(n,o){return E.y(n,o)}}}return Object.freeze(this.a)}_acceptLanguageId(E){(0,S.ok)(!this.b),this.m=E}_acceptIsDirty(E){(0,S.ok)(!this.b),this.q=E}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(E){const n=this.w(E);if(n.isEmpty)return"";if(n.isSingleLine)return this.f[n.start.line].substring(n.start.character,n.end.character);const o=this.g,a=n.start.line,m=n.end.line,v=[];v.push(this.f[a].substring(n.start.character));for(let D=a+1;D<m;D++)v.push(this.f[D]);return v.push(this.f[m].substring(0,n.end.character)),v.join(o)}t(E){let n;if(E instanceof f.$MJ?n=E.line:typeof E=="number"&&(n=E),typeof n!="number"||n<0||n>=this.f.length||Math.floor(n)!==n)throw new Error("Illegal value for `line`");return new k(n,this.f[n],n===this.f.length-1)}u(E){return E=this.x(E),this.l(),this.j.getPrefixSum(E.line-1)+E.character}v(E){E=Math.floor(E),E=Math.max(0,E),this.l();const n=this.j.getIndexOf(E),o=this.f[n.index].length;return new f.$MJ(n.index,Math.min(n.remainder,o))}w(E){if(!(E instanceof f.$NJ))throw new Error("Invalid argument");const n=this.x(E.start),o=this.x(E.end);return n===E.start&&o===E.end?E:new f.$NJ(n.line,n.character,o.line,o.character)}x(E){if(!(E instanceof f.$MJ))throw new Error("Invalid argument");if(this.f.length===0)return E.with(0,0);let{line:n,character:o}=E,a=!1;if(n<0)n=0,o=0,a=!0;else if(n>=this.f.length)n=this.f.length-1,o=this.f[n].length,a=!0;else{const m=this.f[n].length;o<0?(o=0,a=!0):o>m&&(o=m,a=!0)}return a?new f.$MJ(n,o):E}y(E,n){const o=this.x(E);if(!n)n=I(this.m);else if((0,h.$yd)(n))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${n.source}' because it matches the empty string.`);const a=(0,A.$Qr)(o.character+1,(0,A.$Or)(n),this.f[o.line],0);if(a)return new f.$NJ(o.line,a.startColumn-1,o.line,a.endColumn-1)}}e.$OL=$;class k{constructor(E,n,o){this.a=E,this.b=n,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new f.$NJ(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new f.$NJ(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$PL=k}),define(Se[264],De([1,0,7,20,4]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wbc=void 0;let L=class{constructor(f){this.a=new S.$9K(S.ColorThemeKind.Dark),this.b=new h.$ec}get activeColorTheme(){return this.a}$onColorThemeChange(f){let w;switch(f){case"light":w=S.ColorThemeKind.Light;break;case"hcDark":w=S.ColorThemeKind.HighContrast;break;case"hcLight":w=S.ColorThemeKind.HighContrastLight;break;default:w=S.ColorThemeKind.Dark}this.a=new S.$9K(w),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Wbc=L,e.$Wbc=L=Je([Be(0,F.$LL)],L)}),define(Se[265],De([1,0,6]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VH=e.CellExecutionUpdateType=void 0;var F;(function(h){h[h.Output=1]="Output",h[h.OutputItems=2]="OutputItems",h[h.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$VH=(0,S.$ph)("INotebookExecutionService")}),define(Se[63],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wI=e.TestPosition=e.TestIdPathParts=void 0;var S;(function(L){L.Delimiter="\0"})(S||(e.TestIdPathParts=S={}));var F;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class h{static fromExtHostTestItem(A,f,w=A.parent){if(A._isRoot)return new h([f]);const g=[A.id];for(let P=w;P&&P.id!==f;P=P.parent)g.push(P.id);return g.push(f),new h(g.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const f=A.indexOf("\0");return f===-1?A:A.slice(0,f)}static fromString(A){return new h(A.split("\0"))}static join(A,f){return new h([...A.path,f])}static joinToString(A,f){return A.toString()+"\0"+f}static parentId(A){const f=A.lastIndexOf("\0");return f===-1?void 0:A.slice(0,f)}static localId(A){const f=A.lastIndexOf("\0");return f===-1?A:A.slice(f+1)}static isChild(A,f){return f.startsWith(A)&&f[A.length]==="\0"}static compare(A,f){return A===f?0:h.isChild(A,f)?2:h.isChild(f,A)?3:1}constructor(A,f=A.length){if(this.path=A,this.d=f,A.length===0||f<1)throw new Error("cannot create test with empty path")}get rootId(){return new h(this.path,1)}get parentId(){return this.d>1?new h(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new h(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new h(this.path,A)}compare(A){if(typeof A=="string")return h.compare(this.toString(),A);for(let f=0;f<A.d&&f<this.d;f++)if(A.path[f]!==this.path[f])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$wI=h}),define(Se[87],De([1,0,2,34,63]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DI=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$CI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$BI=e.$AI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$zI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$yI=e.$xI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(y){y[y.Unset=0]="Unset",y[y.Queued=1]="Queued",y[y.Running=2]="Running",y[y.Passed=3]="Passed",y[y.Failed=4]="Failed",y[y.Skipped=5]="Skipped",y[y.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var A;(function(y){y[y.Run=1]="Run",y[y.Debug=2]="Debug",y[y.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var f;(function(y){y[y.Run=2]="Run",y[y.Debug=4]="Debug",y[y.Coverage=8]="Coverage",y[y.HasNonDefaultProfile=16]="HasNonDefaultProfile",y[y.HasConfigurable=32]="HasConfigurable",y[y.SupportsContinuousRun=64]="SupportsContinuousRun"})(f||(e.TestRunProfileBitset=f={})),e.$xI=[2,4,8,16,32,64];const w=y=>"runId"in y;e.$yI=w;var g;(function(y){y.serialize=u=>({range:u.range.toJSON(),uri:u.uri.toJSON()}),y.deserialize=u=>({range:F.$Ur.lift(u.range),uri:S.URI.revive(u.uri)})})(g||(e.IRichLocation=g={}));var P;(function(y){y[y.Error=0]="Error",y[y.Output=1]="Output"})(P||(e.TestMessageType=P={}));var I;(function(y){y.serialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&g.serialize(u.location)}),y.deserialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&g.deserialize(u.location)})})(I||(e.ITestErrorMessage=I={}));const $=(y,u)=>`${u?"s":"e"}${y}`;e.$zI=$;var k;(function(y){y.serialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&g.serialize(u.location)}),y.deserialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&g.deserialize(u.location)})})(k||(e.ITestOutputMessage=k={}));var C;(function(y){y.serialize=u=>u.type===0?I.serialize(u):k.serialize(u),y.deserialize=u=>u.type===0?I.deserialize(u):k.deserialize(u)})(C||(e.ITestMessage=C={}));var E;(function(y){y.serializeWithoutMessages=u=>({state:u.state,duration:u.duration,messages:[]}),y.serialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(C.serialize)}),y.deserialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(C.deserialize)})})(E||(e.ITestTaskState=E={}));const n="\0",o=(y,u)=>y+n+u;e.$AI=o;const a=y=>{const u=y.indexOf(n);return{ctrlId:y.slice(0,u),tagId:y.slice(u+1)}};e.$BI=a;var m;(function(y){y.serialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?.toJSON(),range:u.range?.toJSON()||null,description:u.description,error:u.error,sortText:u.sortText}),y.deserialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?S.URI.revive(u.uri):void 0,range:u.range?F.$Ur.lift(u.range):null,description:u.description,error:u.error,sortText:u.sortText})})(m||(e.ITestItem=m={}));var v;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(v||(e.TestItemExpandState=v={}));var D;(function(y){y.serialize=u=>({expand:u.expand,item:m.serialize(u.item)}),y.deserialize=u=>({controllerId:h.$wI.root(u.item.extId),expand:u.expand,item:m.deserialize(u.item)})})(D||(e.InternalTestItem=D={}));var t;(function(y){y.serialize=u=>{let d;return u.item&&(d={},u.item.label!==void 0&&(d.label=u.item.label),u.item.tags!==void 0&&(d.tags=u.item.tags),u.item.busy!==void 0&&(d.busy=u.item.busy),u.item.uri!==void 0&&(d.uri=u.item.uri?.toJSON()),u.item.range!==void 0&&(d.range=u.item.range?.toJSON()),u.item.description!==void 0&&(d.description=u.item.description),u.item.error!==void 0&&(d.error=u.item.error),u.item.sortText!==void 0&&(d.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:d}},y.deserialize=u=>{let d;return u.item&&(d={},u.item.label!==void 0&&(d.label=u.item.label),u.item.tags!==void 0&&(d.tags=u.item.tags),u.item.busy!==void 0&&(d.busy=u.item.busy),u.item.range!==void 0&&(d.range=u.item.range?F.$Ur.lift(u.item.range):null),u.item.description!==void 0&&(d.description=u.item.description),u.item.error!==void 0&&(d.error=u.item.error),u.item.sortText!==void 0&&(d.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:d}}})(t||(e.ITestItemUpdate=t={}));const r=(y,u)=>{u.expand!==void 0&&(y.expand=u.expand),u.item!==void 0&&(y.item=y.item?Object.assign(y.item,u.item):u.item)};e.$CI=r;var s;(function(y){y.serializeWithoutMessages=u=>({...D.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(E.serializeWithoutMessages)}),y.serialize=u=>({...D.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(E.serialize)}),y.deserialize=u=>({...D.deserialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(E.deserialize),retired:!0})})(s||(e.TestResultItem=s={}));var i;(function(y){y[y.Function=0]="Function",y[y.Statement=1]="Statement"})(i||(e.DetailType=i={}));var c;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.DocumentSynced=2]="DocumentSynced",y[y.Remove=3]="Remove",y[y.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",y[y.Retire=5]="Retire",y[y.AddTag=6]="AddTag",y[y.RemoveTag=7]="RemoveTag"})(c||(e.TestDiffOpType=c={}));var l;(function(y){y.deserialize=u=>u.op===0?{op:u.op,item:D.deserialize(u.item)}:u.op===1?{op:u.op,item:t.deserialize(u.item)}:u.op===2?{op:u.op,uri:S.URI.revive(u.uri),docv:u.docv}:u,y.serialize=u=>u.op===0?{op:u.op,item:D.serialize(u.item)}:u.op===1?{op:u.op,item:t.serialize(u.item)}:u})(l||(e.TestsDiffOp=l={}));class b{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(u){const d=this.p();for(const p of u)switch(p.op){case 0:this.k(D.deserialize(p.item),d);break;case 1:this.l(t.deserialize(p.item),d);break;case 3:this.m(p.itemId,d);break;case 5:this.o(p.itemId);break;case 4:this.updatePendingRoots(p.amount);break;case 6:this.d.set(p.tag.id,p.tag);break;case 7:this.d.delete(p.id);break}d.complete?.()}k(u,d){const p=h.$wI.parentId(u.item.extId)?.toString();let R;if(!p)R=this.q(u),this.g.add(R),this.f.set(u.item.extId,R);else if(this.f.has(p)){const O=this.f.get(p);O.children.add(u.item.extId),R=this.q(u,O),this.f.set(u.item.extId,R)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(u)}`);return}return d.add?.(R),u.expand===2&&this.h++,R}l(u,d){const p=this.f.get(u.extId);if(p)return u.expand!==void 0&&(p.expand===2&&this.h--,u.expand===2&&this.h++),(0,e.$CI)(p,u),d.update?.(p),p}m(u,d){const p=this.f.get(u);if(!p)return;const R=h.$wI.parentId(p.item.extId)?.toString();R?this.f.get(R).children.delete(p.item.extId):this.g.delete(p);const O=[[u]];for(;O.length;)for(const j of O.pop()){const T=this.f.get(j);T&&(O.push(T.children),this.f.delete(j),d.remove?.(T,T!==p),T.expand===2&&this.h--)}}o(u){}updatePendingRoots(u){this.j+=u}p(){return{}}}e.$DI=b}),define(Se[108],De([1,0,13,4,3,54,87,63]),function(me,e,S,F,h,L,A,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.TestItemEventOp=void 0;var w;(function(a){a[a.Upsert=0]="Upsert",a[a.SetTags=1]="SetTags",a[a.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",a[a.RemoveChild=3]="RemoveChild",a[a.SetProp=4]="SetProp",a[a.Bulk=5]="Bulk",a[a.DocumentSynced=6]="DocumentSynced"})(w||(e.TestItemEventOp=w={}));const g=(a,m)=>a===m,I=Object.entries({range:(a,m)=>a===m?!0:!a||!m?!1:a.equalsRange(m),busy:g,label:g,description:g,error:g,sortText:g,tags:(a,m)=>!(a.length!==m.length||a.some(v=>!m.includes(v)))}),$=(a,m)=>{let v;for(const[D,t]of I)t(a[D],m[D])||(v?v[D]=m[D]:v={[D]:m[D]});return v};class k extends h.$lb{get root(){return this.m.root}constructor(m){super(),this.m=m,this.f=this.B(new S.$Gg(()=>this.flushDiff(),200)),this.g=this.B(new F.$ec),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(m){this.h=m;for(const v of this.tree.values())this.G(v)}get resolveHandler(){return this.h}collectDiff(){const m=this.k;return this.k=[],m}pushDiff(m){switch(m.op){case 2:{for(const v of this.k)if(v.op===2&&v.uri===m.uri){v.docv=m.docv;return}break}case 1:{const v=this.k[this.k.length-1];if(v){if(v.op===1&&v.item.extId===m.item.extId){(0,A.$CI)(v.item,m.item);return}if(v.op===0&&v.item.item.extId===m.item.extId){(0,A.$CI)(v.item,m.item);return}}break}}this.k.push(m),this.f.isScheduled()||this.f.schedule()}expand(m,v){const D=this.tree.get(m);if(D){if((D.expandLevels===void 0||v>D.expandLevels)&&(D.expandLevels=v),D.expand===1){const t=this.I(D);return t.isOpen()?this.H(D,v-1):t.wait().then(()=>this.H(D,v-1))}else if(D.expand===3)return D.resolveBarrier?.isOpen()===!1?D.resolveBarrier.wait().then(()=>this.H(D,v-1)):this.H(D,v-1)}}dispose(){for(const m of this.tree.values())this.m.getApiFor(m.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(m,v){switch(v.op){case 3:this.L(f.$wI.joinToString(m.fullId,v.id));break;case 0:this.u(v.item,m);break;case 5:for(const D of v.ops)this.p(m,D);break;case 1:this.w(v.new,v.old,m.fullId.toString());break;case 2:this.G(m);break;case 4:this.pushDiff({op:1,item:{extId:m.fullId.toString(),item:v.update}});break;case 6:this.s(m.actual.uri);break;default:(0,L.$wb)(v)}}s(m){m&&this.pushDiff({op:2,uri:m,docv:this.m.getDocumentVersion(m)})}u(m,v){const D=f.$wI.fromExtHostTestItem(m,this.root.id,v?.actual),t=this.m.getApiFor(m);t.parent&&t.parent!==v?.actual&&this.m.getChildren(t.parent).delete(m.id);let r=this.tree.get(D.toString());if(!r){r={fullId:D,actual:m,expandLevels:v?.expandLevels?v.expandLevels-1:void 0,expand:0},m.tags.forEach(this.y,this),this.tree.set(r.fullId.toString(),r),this.C(m,v),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:r.expand,item:this.m.toITestItem(m)}}),this.F(m,r,v);return}if(r.actual===m){this.D(m,r,v);return}if(r.actual.uri?.toString()!==m.uri?.toString())return this.L(D.toString()),this.u(m,v);const s=this.m.getChildren(r.actual),i=r.actual,c=$(this.m.toITestItem(i),this.m.toITestItem(m));this.m.getApiFor(i).listener=void 0,r.actual=m,r.expand=0,c&&(c.hasOwnProperty("tags")&&(this.w(m.tags,i.tags,D.toString()),delete c.tags),this.p(r,{op:4,update:c})),this.F(m,r,v);for(const[l,b]of s)this.m.getChildren(m).get(b.id)||this.L(f.$wI.joinToString(D,b.id));this.s(r.actual.uri)}w(m,v,D){const t=new Set(v.map(r=>r.id));for(const r of m)t.delete(r.id)||this.y(r);this.pushDiff({op:1,item:{extId:D,item:{tags:m.map(r=>(0,A.$AI)(this.m.controllerId,r.id))}}}),t.forEach(this.z,this)}y(m){const v=this.j.get(m.id);v?v.refCount++:(this.j.set(m.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$AI)(this.m.controllerId,m.id)}}))}z(m){const v=this.j.get(m);v&&!--v.refCount&&(this.j.delete(m),this.pushDiff({op:7,id:(0,A.$AI)(this.m.controllerId,m)}))}C(m,v){this.m.getApiFor(m).parent=v&&v.actual!==this.root?v.actual:void 0}D(m,v,D){this.C(m,D);const t=this.m.getApiFor(m);t.parent=D?.actual,t.listener=r=>this.p(v,r),this.G(v)}F(m,v,D){this.D(m,v,D);for(const[t,r]of this.m.getChildren(m))this.u(r,v)}G(m){let v;this.h?m.resolveBarrier?v=m.resolveBarrier.isOpen()?3:2:v=m.actual.canResolveChildren?1:0:v=0,v!==m.expand&&(m.expand=v,this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:v}}),v===1&&m.expandLevels!==void 0&&this.I(m))}H(m,v){if(v<0)return;const D=[];for(const[t,r]of this.m.getChildren(m.actual)){const s=this.expand(f.$wI.joinToString(m.fullId,r.id),v);(0,S.$hg)(s)&&D.push(s)}if(D.length)return Promise.all(D).then(()=>{})}I(m){if(m.resolveBarrier)return m.resolveBarrier;if(!this.h){const r=new S.$tg;return r.open(),r}m.expand=2,this.J(m);const v=m.resolveBarrier=new S.$tg,D=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,r)};let t;try{t=this.h(m.actual===this.root?void 0:m.actual)}catch(r){D(r)}return(0,S.$hg)(t)?t.catch(D).then(()=>{v.open(),this.G(m)}):(v.open(),this.G(m)),m.resolveBarrier}J(m){this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:m.expand}})}L(m){const v=this.tree.get(m);if(!v)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:m});const D=[v];for(;D.length;){const t=D.pop();if(t){this.m.getApiFor(t.actual).listener=void 0;for(const r of t.actual.tags)this.z(r.id);this.tree.delete(t.fullId.toString());for(const[r,s]of this.m.getChildren(t.actual))D.push(this.tree.get(f.$wI.joinToString(t.fullId,s.id)))}}}flushDiff(){const m=this.collectDiff();m.length&&this.g.fire(m)}}e.$BL=k;class C extends Error{constructor(m){super(`Attempted to insert a duplicate test item ID ${m}`)}}e.$CL=C;class E extends Error{constructor(m){super(`TestItem with ID "${m}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$DL=E;class n extends Error{constructor(m,v,D){super(`TestItem with ID "${m}" is from controller "${v}" and cannot be added as a child of an item from controller "${D}".`)}}e.$EL=n;const o=(a,m,v)=>{let D=new Map;return{get size(){return D.size},forEach(t,r){for(const s of D.values())t.call(r,s,this)},[Symbol.iterator](){return D.entries()},replace(t){const r=new Map,s=new Set(D.keys()),i={op:5,ops:[]};for(const c of t){if(!(c instanceof v))throw new E(c.id);const l=m(c).controllerId;if(l!==a.controllerId)throw new n(c.id,l,a.controllerId);if(r.has(c.id))throw new C(c.id);r.set(c.id,c),s.delete(c.id),i.ops.push({op:0,item:c})}for(const c of s.keys())i.ops.push({op:3,id:c});a.listener?.(i),D=r},add(t){if(!(t instanceof v))throw new E(t.id);D.set(t.id,t),a.listener?.({op:0,item:t})},delete(t){D.delete(t)&&a.listener?.({op:3,id:t})},get(t){return D.get(t)},toJSON(){return Array.from(D.values())}}};e.$FL=o}),define(Se[140],De([1,0,108]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HL=e.$GL=void 0;const F=new WeakMap,h=(A,f)=>{const w={controllerId:f};return F.set(A,w),w};e.$GL=h;const L=A=>{const f=F.get(A);if(!f)throw new S.$DL(A?.id||"<unknown>");return f};e.$HL=L}),define(Se[109],De([1,0,16,2]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kob=e.$job=e.$iob=e.$hob=e.$gob=void 0,e.$gob="vscode-cdn.net",e.$hob=`vscode-resource.${e.$gob}`,e.$iob=`'self' https://*.${e.$gob}`;function h(f,w){return f.scheme===S.Schemas.http||f.scheme===S.Schemas.https?f:(w&&w.authority&&w.isRemote&&f.scheme===S.Schemas.file&&(f=F.URI.from({scheme:S.Schemas.vscodeRemote,authority:w.authority,path:f.path})),F.URI.from({scheme:S.Schemas.https,authority:`${f.scheme}+${L(f.authority)}.${e.$hob}`,path:f.path,fragment:f.fragment,query:f.query}))}e.$job=h;function L(f){return f.replace(/./g,w=>{const g=w.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?w:"-"+g.toString(16).padStart(4,"0")})}function A(f){return f.replace(/-([0-9a-f]{4})/g,(w,g)=>String.fromCharCode(parseInt(g,16)))}e.$kob=A}),define(Se[266],De([1,0,4,3,109]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ubc=void 0;class L{constructor(f,w,g){this.d=f,this.e=w,this.f=g,this.a=0,this.b=new F.$kb,this.c=new Map,this.b.add(w.onDidChangeVisibleTextEditors(()=>{const P=w.getVisibleTextEditors();for(const I of this.c.values())P.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(f=>f.inset.dispose()),this.b.dispose()}createWebviewEditorInset(f,w,g,P,I){let $;for(const m of this.e.getVisibleTextEditors(!0))if(m.value===f){$=m;break}if(!$)throw new Error("not a visible editor");const k=this,C=this.a++,E=new S.$ec,n=new S.$ec,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(m){return(0,h.$job)(m,k.f)}get cspSource(){return h.$iob}set options(m){this.b=m,k.d.$setOptions(C,m)}get options(){return this.b}set html(m){this.a=m,k.d.$setHtml(C,m)}get html(){return this.a}get onDidReceiveMessage(){return E.event}postMessage(m){return k.d.$postMessage(C,m)}},a=new class{constructor(){this.editor=f,this.line=w,this.height=g,this.webview=o,this.onDidDispose=n.event}dispose(){k.c.has(C)&&(k.c.delete(C),k.d.$disposeEditorInset(C),n.fire(),n.dispose(),E.dispose())}};return this.d.$createEditorInset(C,$.id,$.value.document.uri,w+1,g,P||{},I.identifier,I.extensionLocation),this.c.set(C,{editor:f,inset:a,onDidReceiveMessage:E}),a}$onDidDispose(f){const w=this.c.get(f);w&&w.inset.dispose()}$onDidReceiveMessage(f,w){this.c.get(f)?.onDidReceiveMessage.fire(w)}}e.$ubc=L}),define(Se[267],De([1,0,6]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yM=e.VariableKind=e.$xM=void 0,e.$xM=(0,S.$ph)("configurationResolverService");var F;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(F||(e.VariableKind=F={}));class h extends Error{constructor(A,f){super(f),this.variable=A}}e.$yM=h}),define(Se[268],De([1,0,14,41,19,23,9,126,217,267,15]),function(me,e,S,F,h,L,A,f,w,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(k,C,E,n){this.h=new Map,this.a=k,this.b=C,this.g=E,n&&(this.c=n.then(o=>this.i(o)))}i(k){if(A.$i){const C=Object.create(null);return Object.keys(k).forEach(E=>{C[E.toLowerCase()]=k[E]}),C}return k}resolveWithEnvironment(k,C,E){return this.l({env:this.i(k),userHome:void 0},C?C.uri:void 0,E)}async resolveAsync(k,C){const E={env:await this.c,userHome:await this.g};return this.l(E,k?k.uri:void 0,C)}async j(k,C,E,n){const o=L.$Im(C);A.$i&&o.windows?Object.keys(o.windows).forEach(m=>o[m]=o.windows[m]):A.$j&&o.osx?Object.keys(o.osx).forEach(m=>o[m]=o.osx[m]):A.$k&&o.linux&&Object.keys(o.linux).forEach(m=>o[m]=o.linux[m]),delete o.windows,delete o.osx,delete o.linux;const a={env:await this.c,userHome:await this.g};return this.l(a,k?k.uri:void 0,o,E,n)}async resolveAnyAsync(k,C,E){return this.j(k,C,E)}async resolveAnyMap(k,C,E){const n=new Map;return{newConfig:await this.j(k,C,E,n),resolvedVariables:n}}resolveWithInteractionReplace(k,C,E,n){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,C,E,n){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,C){if(this.h.has(k))throw new Error("Variable "+k+" is contributed twice.");this.h.set(k,C)}async l(k,C,E,n,o){if(h.$ie(E))return this.m(k,C,E,n,o);if(Array.isArray(E))return Promise.all(E.map(a=>this.l(k,C,a,n,o)));if(h.$ke(E)){const a=Object.create(null),m=await Promise.all(Object.keys(E).map(async v=>[await this.m(k,C,v,n,o),await this.l(k,C,E[v],n,o)]));for(const[v,D]of m)a[v]=D;return a}return E}m(k,C,E,n,o){return(0,P.$Dd)(E,I.VARIABLE_REGEXP,async(a,m)=>{if(m.includes(I.VARIABLE_LHS))return a;let v=await this.o(k,a,m,C,n);return o?.set(m,v),v!==a&&h.$ie(v)&&v.match(I.VARIABLE_REGEXP)&&(v=await this.m(k,C,v,n,o)),v})}n(k){return this.b?this.b.getUriLabel(k,{noPrefix:!0}):k.fsPath}async o(k,C,E,n,o){let a;const m=E.split(":");m.length>1&&(E=m[0],a=m[1]);const v=r=>{const s=this.a.getFilePath();if(s)return(0,f.$7z)(s);throw new g.$yM(r,(0,w.localize)(0,null,C))},D=r=>{const s=v(r);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,f.$7z)(i)}throw new g.$yM(r,(0,w.localize)(1,null,C,S.$_c(s)))},t=r=>{if(a){const s=this.a.getFolderUri(a);if(s)return s;throw new g.$yM(r,(0,w.localize)(2,null,C,a))}if(n)return n;throw this.a.getWorkspaceFolderCount()>1?new g.$yM(r,(0,w.localize)(3,null,C)):new g.$yM(r,(0,w.localize)(4,null,C))};switch(E){case"env":if(a){if(k.env){const r=k.env[A.$i?a.toLowerCase():a];if(h.$ie(r))return r}return""}throw new g.$yM(g.VariableKind.Env,(0,w.localize)(5,null,C));case"config":if(a){const r=this.a.getConfigurationValue(n,a);if(h.$re(r))throw new g.$yM(g.VariableKind.Config,(0,w.localize)(6,null,C,a));if(h.$ke(r))throw new g.$yM(g.VariableKind.Config,(0,w.localize)(7,null,C,a));return r}throw new g.$yM(g.VariableKind.Config,(0,w.localize)(8,null,C));case"command":return this.p(g.VariableKind.Command,C,a,o,"command");case"input":return this.p(g.VariableKind.Input,C,a,o,"input");case"extensionInstallFolder":if(a){const r=await this.a.getExtension(a);if(!r)throw new g.$yM(g.VariableKind.ExtensionInstallFolder,(0,w.localize)(9,null,C,a));return this.n(r.extensionLocation)}throw new g.$yM(g.VariableKind.ExtensionInstallFolder,(0,w.localize)(10,null,C));default:switch(E){case"workspaceRoot":case"workspaceFolder":return(0,f.$7z)(this.n(t(g.VariableKind.WorkspaceFolder)));case"cwd":return n||a?(0,f.$7z)(this.n(t(g.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,f.$7z)(S.$_c(this.n(t(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(k.userHome)return k.userHome;throw new g.$yM(g.VariableKind.UserHome,(0,w.localize)(11,null,C))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new g.$yM(g.VariableKind.LineNumber,(0,w.localize)(12,null,C))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new g.$yM(g.VariableKind.SelectedText,(0,w.localize)(13,null,C))}case"file":return v(g.VariableKind.File);case"fileWorkspaceFolder":return D(g.VariableKind.FileWorkspaceFolder);case"relativeFile":return n||a?S.$0c(this.n(t(g.VariableKind.RelativeFile)),v(g.VariableKind.RelativeFile)):v(g.VariableKind.RelativeFile);case"relativeFileDirname":{const r=S.$$c(v(g.VariableKind.RelativeFileDirname));if(n||a){const s=S.$0c(this.n(t(g.VariableKind.RelativeFileDirname)),r);return s.length===0?".":s}return r}case"fileDirname":return S.$$c(v(g.VariableKind.FileDirname));case"fileExtname":return S.$ad(v(g.VariableKind.FileExtname));case"fileBasename":return S.$_c(v(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=S.$_c(v(g.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-S.$ad(r).length)}case"fileDirnameBasename":return S.$_c(S.$$c(v(g.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||C}case"execInstallFolder":{const r=this.a.getAppRoot();return r||C}case"pathSeparator":return S.sep;default:try{const r=a?`${E}:${a}`:E;return this.p(g.VariableKind.Unknown,C,r,o,void 0)}catch{return C}}}}p(k,C,E,n,o){if(E&&n){const a=o===void 0?n[E]:n[o+":"+E];if(typeof a=="string")return a;throw new g.$yM(k,(0,w.localize)(14,null,C))}return C}}e.$MM=I}),define(Se[141],De([1,0,6,137]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WC=e.$VC=e.OpenEditorContext=e.GroupsOrder=e.$UC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$TC=void 0,e.$TC=(0,S.$ph)("editorGroupsService");var h;(function(C){C[C.UP=0]="UP",C[C.DOWN=1]="DOWN",C[C.LEFT=2]="LEFT",C[C.RIGHT=3]="RIGHT"})(h||(e.GroupDirection=h={}));var L;(function(C){C[C.HORIZONTAL=0]="HORIZONTAL",C[C.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var A;(function(C){C[C.FIRST=0]="FIRST",C[C.LAST=1]="LAST",C[C.NEXT=2]="NEXT",C[C.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var f;(function(C){C[C.MAXIMIZE=0]="MAXIMIZE",C[C.EVEN=1]="EVEN",C[C.TOGGLE=2]="TOGGLE"})(f||(e.GroupsArrangement=f={}));var w;(function(C){C[C.COPY_EDITORS=0]="COPY_EDITORS",C[C.MOVE_EDITORS=1]="MOVE_EDITORS"})(w||(e.MergeGroupMode=w={}));function g(C){const E=C;return(0,F.$JE)(E?.editor)&&(0,F.$JE)(E?.replacement)}e.$UC=g;var P;(function(C){C[C.CREATION_TIME=0]="CREATION_TIME",C[C.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",C[C.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var I;(function(C){C[C.NEW_EDITOR=1]="NEW_EDITOR",C[C.MOVE_EDITOR=2]="MOVE_EDITOR",C[C.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function $(C){const E=C;return!!E&&typeof E.id=="number"&&Array.isArray(E.editors)}e.$VC=$;function k(C){return C.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$WC=k}),define(Se[269],De([1,0,6,141]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1C=e.$ZC=e.$YC=e.$XC=void 0,e.$XC=(0,S.$ph)("editorService"),e.$YC=-1,e.$ZC=-2;function h(L){const A=L;return typeof L=="number"||(0,F.$VC)(A)}e.$1C=h}),define(Se[10],De([1,0,18,21,159,71,78,28,155,77,97,23,19,2,34,81,131,140,137,107,63,87,269,7]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E,n,o,a,m,v,D,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$KL=e.$JL=e.MarkdownString=e.$IL=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(Fe){function Te(te){const{selectionStartLineNumber:Me,selectionStartColumn:Ke,positionLineNumber:xe,positionColumn:Ge}=te,nt=new r.$MJ(Me-1,Ke-1),bt=new r.$MJ(xe-1,Ge-1);return new r.$OJ(nt,bt)}Fe.to=Te;function Ae(te){const{anchor:Me,active:Ke}=te;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Ke.line+1,positionColumn:Ke.character+1}}Fe.from=Ae})(s||(e.Selection=s={}));var i;(function(Fe){function Te(te){if(!te)return;const{start:Me,end:Ke}=te;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Ke.line+1,endColumn:Ke.character+1}}Fe.from=Te;function Ae(te){if(!te)return;const{startLineNumber:Me,startColumn:Ke,endLineNumber:xe,endColumn:Ge}=te;return new r.$NJ(Me-1,Ke-1,xe-1,Ge-1)}Fe.to=Ae})(i||(e.Range=i={}));var c;(function(Fe){function Te(Ae){switch(Ae){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Fe.to=Te})(c||(e.TokenType=c={}));var l;(function(Fe){function Te(te){return new r.$MJ(te.lineNumber-1,te.column-1)}Fe.to=Te;function Ae(te){return{lineNumber:te.line+1,column:te.character+1}}Fe.from=Ae})(l||(e.Position=l={}));var b;(function(Fe){function Te(Me,Ke,xe){return(0,S.$jf)((0,S.$Gf)(Me).map(Ge=>Ae(Ge,Ke,xe)))}Fe.from=Te;function Ae(Me,Ke,xe){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:xe?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:te(Me.scheme,Ke),pattern:Qe.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:xe?.isBuiltin}}function te(Me,Ke){return Ke&&typeof Me=="string"?Ke.transformOutgoingScheme(Me):Me}})(b||(e.DocumentSelector=b={}));var y;(function(Fe){function Te(te){switch(te){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Fe.from=Te;function Ae(te){switch(te){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Fe.to=Ae})(y||(e.DiagnosticTag=y={}));var u;(function(Fe){function Te(te){let Me;return te.code&&((0,$.$ie)(te.code)||(0,$.$me)(te.code)?Me=String(te.code):Me={value:String(te.code.value),target:te.code.target}),{...i.from(te.range),message:te.message,source:te.source,code:Me,severity:p.from(te.severity),relatedInformation:te.relatedInformation&&te.relatedInformation.map(d.from),tags:Array.isArray(te.tags)?(0,S.$jf)(te.tags.map(y.from)):void 0}}Fe.from=Te;function Ae(te){const Me=new r.$ZJ(i.to(te),te.message,p.to(te.severity));return Me.source=te.source,Me.code=(0,$.$ie)(te.code)?te.code:te.code?.value,Me.relatedInformation=te.relatedInformation&&te.relatedInformation.map(d.to),Me.tags=te.tags&&(0,S.$jf)(te.tags.map(y.to)),Me}Fe.to=Ae})(u||(e.Diagnostic=u={}));var d;(function(Fe){function Te(te){return{...i.from(te.location.range),message:te.message,resource:te.location.uri}}Fe.from=Te;function Ae(te){return new r.$YJ(new r.$XJ(te.resource,i.to(te)),te.message)}Fe.to=Ae})(d||(e.DiagnosticRelatedInformation=d={}));var p;(function(Fe){function Te(te){switch(te){case r.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}Fe.from=Te;function Ae(te){switch(te){case n.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Fe.to=Ae})(p||(e.DiagnosticSeverity=p={}));var R;(function(Fe){function Te(te){return typeof te=="number"&&te>=r.ViewColumn.One?te-1:te===r.ViewColumn.Beside?t.$ZC:t.$YC}Fe.from=Te;function Ae(te){if(typeof te=="number"&&te>=0)return te+1;throw new Error("invalid 'EditorGroupColumn'")}Fe.to=Ae})(R||(e.ViewColumn=R={}));function O(Fe){return typeof Fe.range<"u"}function j(Fe){return Fe.length===0?!0:!!O(Fe[0])}e.$IL=j;var T;(function(Fe){function Te(Ge){return Ge.map(Fe.from)}Fe.fromMany=Te;function Ae(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function te(Ge){let nt;if(Ae(Ge)){const{language:ut,value:gt}=Ge;nt={value:"```"+ut+`
`+gt+"\n```\n"}}else r.$aK.isMarkdownString(Ge)?nt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?nt={value:Ge}:nt={value:""};const bt=Object.create(null);nt.uris=bt;const Et=ut=>{try{let gt=k.URI.parse(ut,!0);gt=gt.with({query:Me(gt.query,bt)}),bt[ut]=gt}catch{}return""},pt=new w.marked.Renderer;return pt.link=Et,pt.image=ut=>typeof ut=="string"?Et(A.$Rj(ut).href):"",(0,w.marked)(nt.value,{renderer:pt}),nt}Fe.from=te;function Me(Ge,nt){if(!Ge)return Ge;let bt;try{bt=(0,g.$Xg)(Ge)}catch{}if(!bt)return Ge;let Et=!1;return bt=(0,I.$Km)(bt,pt=>{if(k.URI.isUri(pt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return nt[ut]=pt,Et=!0,ut}else return}),Et?JSON.stringify(bt):Ge}function Ke(Ge){const nt=new r.$aK(Ge.value,Ge.supportThemeIcons);return nt.isTrusted=Ge.isTrusted,nt.supportHtml=Ge.supportHtml,nt.baseUri=Ge.baseUri?k.URI.from(Ge.baseUri):void 0,nt}Fe.to=Ke;function xe(Ge){if(Ge)return typeof Ge=="string"?Ge:Fe.from(Ge)}Fe.fromStrict=xe})(T||(e.MarkdownString=T={}));function z(Fe){return j(Fe)?Fe.map(Te=>({range:i.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?T.fromMany(Te.hoverMessage):Te.hoverMessage?T.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Fe.map(Te=>({range:i.from(Te)}))}e.$JL=z;function B(Fe){return typeof Fe>"u"?Fe:typeof Fe=="string"?k.URI.file(Fe):Fe}e.$KL=B;var M;(function(Fe){function Te(Ae){return typeof Ae>"u"?Ae:{contentText:Ae.contentText,contentIconPath:Ae.contentIconPath?B(Ae.contentIconPath):void 0,border:Ae.border,borderColor:Ae.borderColor,fontStyle:Ae.fontStyle,fontWeight:Ae.fontWeight,textDecoration:Ae.textDecoration,color:Ae.color,backgroundColor:Ae.backgroundColor,margin:Ae.margin,width:Ae.width,height:Ae.height}}Fe.from=Te})(M||(e.ThemableDecorationAttachmentRenderOptions=M={}));var Y;(function(Fe){function Te(Ae){return typeof Ae>"u"?Ae:{backgroundColor:Ae.backgroundColor,outline:Ae.outline,outlineColor:Ae.outlineColor,outlineStyle:Ae.outlineStyle,outlineWidth:Ae.outlineWidth,border:Ae.border,borderColor:Ae.borderColor,borderRadius:Ae.borderRadius,borderSpacing:Ae.borderSpacing,borderStyle:Ae.borderStyle,borderWidth:Ae.borderWidth,fontStyle:Ae.fontStyle,fontWeight:Ae.fontWeight,textDecoration:Ae.textDecoration,cursor:Ae.cursor,color:Ae.color,opacity:Ae.opacity,letterSpacing:Ae.letterSpacing,gutterIconPath:Ae.gutterIconPath?B(Ae.gutterIconPath):void 0,gutterIconSize:Ae.gutterIconSize,overviewRulerColor:Ae.overviewRulerColor,before:Ae.before?M.from(Ae.before):void 0,after:Ae.after?M.from(Ae.after):void 0}}Fe.from=Te})(Y||(e.ThemableDecorationRenderOptions=Y={}));var J;(function(Fe){function Te(Ae){if(typeof Ae>"u")return Ae;switch(Ae){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Fe.from=Te})(J||(e.DecorationRangeBehavior=J={}));var fe;(function(Fe){function Te(Ae){return{isWholeLine:Ae.isWholeLine,rangeBehavior:Ae.rangeBehavior?J.from(Ae.rangeBehavior):void 0,overviewRulerLane:Ae.overviewRulerLane,light:Ae.light?Y.from(Ae.light):void 0,dark:Ae.dark?Y.from(Ae.dark):void 0,backgroundColor:Ae.backgroundColor,outline:Ae.outline,outlineColor:Ae.outlineColor,outlineStyle:Ae.outlineStyle,outlineWidth:Ae.outlineWidth,border:Ae.border,borderColor:Ae.borderColor,borderRadius:Ae.borderRadius,borderSpacing:Ae.borderSpacing,borderStyle:Ae.borderStyle,borderWidth:Ae.borderWidth,fontStyle:Ae.fontStyle,fontWeight:Ae.fontWeight,textDecoration:Ae.textDecoration,cursor:Ae.cursor,color:Ae.color,opacity:Ae.opacity,letterSpacing:Ae.letterSpacing,gutterIconPath:Ae.gutterIconPath?B(Ae.gutterIconPath):void 0,gutterIconSize:Ae.gutterIconSize,overviewRulerColor:Ae.overviewRulerColor,before:Ae.before?M.from(Ae.before):void 0,after:Ae.after?M.from(Ae.after):void 0}}Fe.from=Te})(fe||(e.DecorationRenderOptions=fe={}));var se;(function(Fe){function Te(te){return{text:te.newText,eol:te.newEol&&et.from(te.newEol),range:i.from(te.range)}}Fe.from=Te;function Ae(te){const Me=new r.$SJ(i.to(te.range),te.text);return Me.newEol=typeof te.eol>"u"?void 0:et.to(te.eol),Me}Fe.to=Ae})(se||(e.TextEdit=se={}));var ie;(function(Fe){function Te(te,Me){const Ke={edits:[]};if(te instanceof r.$VJ){const xe=new f.$oi;for(const Ge of te._allEntries())Ge._type===1&&k.URI.isUri(Ge.to)&&Ge.from===void 0&&xe.add(Ge.to);for(const Ge of te._allEntries())if(Ge._type===1){let nt;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?nt={type:"base64",value:(0,F.$Yc)(F.$Ec.wrap(Ge.options.contents))}:nt={type:"dataTransferItem",id:Ge.options.contents._itemId}),Ke.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:nt},metadata:Ge.metadata})}else Ge._type===2?Ke.edits.push({resource:Ge.uri,textEdit:se.from(Ge.edit),versionId:xe.has(Ge.uri)?void 0:Me?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?Ke.edits.push({resource:Ge.uri,textEdit:{range:i.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:xe.has(Ge.uri)?void 0:Me?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?Ke.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&Ke.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Me?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(ot.from)}})}return Ke}Fe.from=Te;function Ae(te){const Me=new r.$VJ,Ke=new f.$ni;for(const xe of te.edits)if(xe.textEdit){const Ge=xe,nt=k.URI.revive(Ge.resource),bt=i.to(Ge.textEdit.range),Et=Ge.textEdit.text,pt=Ge.textEdit.insertAsSnippet;let ut;pt?ut=r.$UJ.replace(bt,new r.$WJ(Et)):ut=r.$SJ.replace(bt,Et);const gt=Ke.get(nt);gt?gt.push(ut):Ke.set(nt,[ut])}else Me.renameFile(k.URI.revive(xe.oldResource),k.URI.revive(xe.newResource),xe.options);for(const[xe,Ge]of Ke)Me.set(xe,Ge);return Me}Fe.to=Ae})(ie||(e.WorkspaceEdit=ie={}));var V;(function(Fe){const Te=Object.create(null);Te[r.SymbolKind.File]=0,Te[r.SymbolKind.Module]=1,Te[r.SymbolKind.Namespace]=2,Te[r.SymbolKind.Package]=3,Te[r.SymbolKind.Class]=4,Te[r.SymbolKind.Method]=5,Te[r.SymbolKind.Property]=6,Te[r.SymbolKind.Field]=7,Te[r.SymbolKind.Constructor]=8,Te[r.SymbolKind.Enum]=9,Te[r.SymbolKind.Interface]=10,Te[r.SymbolKind.Function]=11,Te[r.SymbolKind.Variable]=12,Te[r.SymbolKind.Constant]=13,Te[r.SymbolKind.String]=14,Te[r.SymbolKind.Number]=15,Te[r.SymbolKind.Boolean]=16,Te[r.SymbolKind.Array]=17,Te[r.SymbolKind.Object]=18,Te[r.SymbolKind.Key]=19,Te[r.SymbolKind.Null]=20,Te[r.SymbolKind.EnumMember]=21,Te[r.SymbolKind.Struct]=22,Te[r.SymbolKind.Event]=23,Te[r.SymbolKind.Operator]=24,Te[r.SymbolKind.TypeParameter]=25;function Ae(Me){return typeof Te[Me]=="number"?Te[Me]:6}Fe.from=Ae;function te(Me){for(const Ke in Te)if(Te[Ke]===Me)return Number(Ke);return r.SymbolKind.Property}Fe.to=te})(V||(e.SymbolKind=V={}));var re;(function(Fe){function Te(te){switch(te){case r.SymbolTag.Deprecated:return 1}}Fe.from=Te;function Ae(te){switch(te){case 1:return r.SymbolTag.Deprecated}}Fe.to=Ae})(re||(e.SymbolTag=re={}));var pe;(function(Fe){function Te(te){return{name:te.name,kind:V.from(te.kind),tags:te.tags&&te.tags.map(re.from),containerName:te.containerName,location:q.from(te.location)}}Fe.from=Te;function Ae(te){const Me=new r.$3J(te.name,V.to(te.kind),te.containerName,q.to(te.location));return Me.tags=te.tags&&te.tags.map(re.to),Me}Fe.to=Ae})(pe||(e.WorkspaceSymbol=pe={}));var ae;(function(Fe){function Te(te){const Me={name:te.name||"!!MISSING: name!!",detail:te.detail,range:i.from(te.range),selectionRange:i.from(te.selectionRange),kind:V.from(te.kind),tags:te.tags?.map(re.from)??[]};return te.children&&(Me.children=te.children.map(Te)),Me}Fe.from=Te;function Ae(te){const Me=new r.$4J(te.name,te.detail,V.to(te.kind),i.to(te.range),i.to(te.selectionRange));return(0,S.$nf)(te.tags)&&(Me.tags=te.tags.map(re.to)),te.children&&(Me.children=te.children.map(Ae)),Me}Fe.to=Ae})(ae||(e.DocumentSymbol=ae={}));var ne;(function(Fe){function Te(te){const Me=new r.$9J(V.to(te.kind),te.name,te.detail||"",k.URI.revive(te.uri),i.to(te.range),i.to(te.selectionRange));return Me._sessionId=te._sessionId,Me._itemId=te._itemId,Me}Fe.to=Te;function Ae(te,Me,Ke){if(Me=Me??te._sessionId,Ke=Ke??te._itemId,Me===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ke,name:te.name,detail:te.detail,kind:V.from(te.kind),uri:te.uri,range:i.from(te.range),selectionRange:i.from(te.selectionRange),tags:te.tags?.map(re.from)}}Fe.from=Ae})(ne||(e.CallHierarchyItem=ne={}));var x;(function(Fe){function Te(Ae){return new r.$0J(ne.to(Ae.from),Ae.fromRanges.map(te=>i.to(te)))}Fe.to=Te})(x||(e.CallHierarchyIncomingCall=x={}));var N;(function(Fe){function Te(Ae){return new r.$$J(ne.to(Ae.to),Ae.fromRanges.map(te=>i.to(te)))}Fe.to=Te})(N||(e.CallHierarchyOutgoingCall=N={}));var q;(function(Fe){function Te(te){return{range:te.range&&i.from(te.range),uri:te.uri}}Fe.from=Te;function Ae(te){return new r.$XJ(k.URI.revive(te.uri),i.to(te.range))}Fe.to=Ae})(q||(e.location=q={}));var de;(function(Fe){function Te(te){const Me=te,Ke=te;return{originSelectionRange:Me.originSelectionRange?i.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Ke.uri,range:i.from(Me.targetRange?Me.targetRange:Ke.range),targetSelectionRange:Me.targetSelectionRange?i.from(Me.targetSelectionRange):void 0}}Fe.from=Te;function Ae(te){return{targetUri:k.URI.revive(te.uri),targetRange:i.to(te.range),targetSelectionRange:te.targetSelectionRange?i.to(te.targetSelectionRange):void 0,originSelectionRange:te.originSelectionRange?i.to(te.originSelectionRange):void 0}}Fe.to=Ae})(de||(e.DefinitionLink=de={}));var ye;(function(Fe){function Te(te){return{range:i.from(te.range),contents:T.fromMany(te.contents)}}Fe.from=Te;function Ae(te){return new r.$1J(te.contents.map(T.to),i.to(te.range))}Fe.to=Ae})(ye||(e.Hover=ye={}));var ve;(function(Fe){function Te(te){return{range:i.from(te.range),expression:te.expression}}Fe.from=Te;function Ae(te){return new r.$UK(i.to(te.range),te.expression)}Fe.to=Ae})(ve||(e.EvaluatableExpression=ve={}));var we;(function(Fe){function Te(te){if(te instanceof r.$VK)return{type:"text",range:i.from(te.range),text:te.text};if(te instanceof r.$WK)return{type:"variable",range:i.from(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};if(te instanceof r.$XK)return{type:"expression",range:i.from(te.range),expression:te.expression};throw new Error("Unknown 'InlineValue' type")}Fe.from=Te;function Ae(te){switch(te.type){case"text":return{range:i.to(te.range),text:te.text};case"variable":return{range:i.to(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};case"expression":return{range:i.to(te.range),expression:te.expression}}}Fe.to=Ae})(we||(e.InlineValue=we={}));var Ee;(function(Fe){function Te(te){return{frameId:te.frameId,stoppedLocation:i.from(te.stoppedLocation)}}Fe.from=Te;function Ae(te){return new r.$YK(te.frameId,i.to(te.stoppedLocation))}Fe.to=Ae})(Ee||(e.InlineValueContext=Ee={}));var K;(function(Fe){function Te(te){return{range:i.from(te.range),kind:te.kind}}Fe.from=Te;function Ae(te){return new r.$2J(i.to(te.range),te.kind)}Fe.to=Ae})(K||(e.DocumentHighlight=K={}));var ee;(function(Fe){function Te(Ae){switch(Ae){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Fe.to=Te})(ee||(e.CompletionTriggerKind=ee={}));var G;(function(Fe){function Te(Ae){return{triggerKind:ee.to(Ae.triggerKind),triggerCharacter:Ae.triggerCharacter}}Fe.to=Te})(G||(e.CompletionContext=G={}));var X;(function(Fe){function Te(te){switch(te){case r.CompletionItemTag.Deprecated:return 1}}Fe.from=Te;function Ae(te){switch(te){case 1:return r.CompletionItemTag.Deprecated}}Fe.to=Ae})(X||(e.CompletionItemTag=X={}));var he;(function(Fe){const Te=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function Ae(Ke){return Te.get(Ke)??9}Fe.from=Ae;const te=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Me(Ke){return te.get(Ke)??r.CompletionItemKind.Property}Fe.to=Me})(he||(e.CompletionItemKind=he={}));var Ie;(function(Fe){function Te(Ae,te){const Me=new r.$gK(Ae.label);return Me.insertText=Ae.insertText,Me.kind=he.to(Ae.kind),Me.tags=Ae.tags?.map(X.to),Me.detail=Ae.detail,Me.documentation=A.$Mj(Ae.documentation)?T.to(Ae.documentation):Ae.documentation,Me.sortText=Ae.sortText,Me.filterText=Ae.filterText,Me.preselect=Ae.preselect,Me.commitCharacters=Ae.commitCharacters,C.$Ur.isIRange(Ae.range)?Me.range=i.to(Ae.range):typeof Ae.range=="object"&&(Me.range={inserting:i.to(Ae.range.insert),replacing:i.to(Ae.range.replace)}),Me.keepWhitespace=typeof Ae.insertTextRules>"u"?!1:!!(Ae.insertTextRules&1),typeof Ae.insertTextRules<"u"&&Ae.insertTextRules&4?Me.insertText=new r.$WJ(Ae.insertText):(Me.insertText=Ae.insertText,Me.textEdit=Me.range instanceof r.$NJ?new r.$SJ(Me.range,Me.insertText):void 0),Ae.additionalTextEdits&&Ae.additionalTextEdits.length>0&&(Me.additionalTextEdits=Ae.additionalTextEdits.map(Ke=>se.to(Ke))),Me.command=te&&Ae.command?te.fromInternal(Ae.command):void 0,Me}Fe.to=Te})(Ie||(e.CompletionItem=Ie={}));var U;(function(Fe){function Te(te){if(typeof te.label!="string"&&!Array.isArray(te.label))throw new TypeError("Invalid label");return{label:te.label,documentation:T.fromStrict(te.documentation)}}Fe.from=Te;function Ae(te){return{label:te.label,documentation:A.$Mj(te.documentation)?T.to(te.documentation):te.documentation}}Fe.to=Ae})(U||(e.ParameterInformation=U={}));var Q;(function(Fe){function Te(te){return{label:te.label,documentation:T.fromStrict(te.documentation),parameters:Array.isArray(te.parameters)?te.parameters.map(U.from):[],activeParameter:te.activeParameter}}Fe.from=Te;function Ae(te){return{label:te.label,documentation:A.$Mj(te.documentation)?T.to(te.documentation):te.documentation,parameters:Array.isArray(te.parameters)?te.parameters.map(U.to):[],activeParameter:te.activeParameter}}Fe.to=Ae})(Q||(e.SignatureInformation=Q={}));var _;(function(Fe){function Te(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(Q.from):[]}}Fe.from=Te;function Ae(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(Q.to):[]}}Fe.to=Ae})(_||(e.SignatureHelp=_={}));var oe;(function(Fe){function Te(Ae,te){const Me=new r.$fK(l.to(te.position),typeof te.label=="string"?te.label:te.label.map(Z.to.bind(void 0,Ae)),te.kind&&le.to(te.kind));return Me.textEdits=te.textEdits&&te.textEdits.map(se.to),Me.tooltip=A.$Mj(te.tooltip)?T.to(te.tooltip):te.tooltip,Me.paddingLeft=te.paddingLeft,Me.paddingRight=te.paddingRight,Me}Fe.to=Te})(oe||(e.InlayHint=oe={}));var Z;(function(Fe){function Te(Ae,te){const Me=new r.$eK(te.label);return Me.tooltip=A.$Mj(te.tooltip)?T.to(te.tooltip):te.tooltip,E.Command.is(te.command)&&(Me.command=Ae.fromInternal(te.command)),te.location&&(Me.location=q.to(te.location)),Me}Fe.to=Te})(Z||(e.InlayHintLabelPart=Z={}));var le;(function(Fe){function Te(te){return te}Fe.from=Te;function Ae(te){return te}Fe.to=Ae})(le||(e.InlayHintKind=le={}));var be;(function(Fe){function Te(te){return{range:i.from(te.range),url:te.target,tooltip:te.tooltip}}Fe.from=Te;function Ae(te){let Me;if(te.url)try{Me=typeof te.url=="string"?k.URI.parse(te.url,!0):k.URI.revive(te.url)}catch{}return new r.$lK(i.to(te.range),Me)}Fe.to=Ae})(be||(e.DocumentLink=be={}));var ze;(function(Fe){function Te(te){const Me=new r.$oK(te.label);return te.textEdit&&(Me.textEdit=se.to(te.textEdit)),te.additionalTextEdits&&(Me.additionalTextEdits=te.additionalTextEdits.map(Ke=>se.to(Ke))),Me}Fe.to=Te;function Ae(te){return{label:te.label,textEdit:te.textEdit?se.from(te.textEdit):void 0,additionalTextEdits:te.additionalTextEdits?te.additionalTextEdits.map(Me=>se.from(Me)):void 0}}Fe.from=Ae})(ze||(e.ColorPresentation=ze={}));var qe;(function(Fe){function Te(te){return new r.$mK(te[0],te[1],te[2],te[3])}Fe.to=Te;function Ae(te){return[te.red,te.green,te.blue,te.alpha]}Fe.from=Ae})(qe||(e.Color=qe={}));var _e;(function(Fe){function Te(te){return{range:i.from(te.range)}}Fe.from=Te;function Ae(te){return new r.$8J(i.to(te.range))}Fe.to=Ae})(_e||(e.SelectionRange=_e={}));var Ze;(function(Fe){function Te(Ae){switch(Ae){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Fe.to=Te})(Ze||(e.TextDocumentSaveReason=Ze={}));var it;(function(Fe){function Te(te){switch(te){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Fe.from=Te;function Ae(te){switch(te){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Fe.to=Ae})(it||(e.TextEditorLineNumbersStyle=it={}));var et;(function(Fe){function Te(te){if(te===r.EndOfLine.CRLF)return 1;if(te===r.EndOfLine.LF)return 0}Fe.from=Te;function Ae(te){if(te===1)return r.EndOfLine.CRLF;if(te===0)return r.EndOfLine.LF}Fe.to=Ae})(et||(e.EndOfLine=et={}));var Pe;(function(Fe){function Te(Ae){if(typeof Ae=="object")return Ae.viewId;switch(Ae){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Fe.from=Te})(Pe||(e.ProgressLocation=Pe={}));var Oe;(function(Fe){function Te(te){const Me={start:te.start+1,end:te.end+1};return te.kind&&(Me.kind=We.from(te.kind)),Me}Fe.from=Te;function Ae(te){const Me={start:te.start-1,end:te.end-1};return te.kind&&(Me.kind=We.to(te.kind)),Me}Fe.to=Ae})(Oe||(e.FoldingRange=Oe={}));var We;(function(Fe){function Te(te){if(te)switch(te){case r.FoldingRangeKind.Comment:return E.$As.Comment;case r.FoldingRangeKind.Imports:return E.$As.Imports;case r.FoldingRangeKind.Region:return E.$As.Region}}Fe.from=Te;function Ae(te){if(te)switch(te.value){case E.$As.Comment.value:return r.FoldingRangeKind.Comment;case E.$As.Imports.value:return r.FoldingRangeKind.Imports;case E.$As.Region.value:return r.FoldingRangeKind.Region}}Fe.to=Ae})(We||(e.FoldingRangeKind=We={}));var Re;(function(Fe){function Te(Ae){if(Ae)return{pinned:typeof Ae.preview=="boolean"?!Ae.preview:void 0,inactive:Ae.background,preserveFocus:Ae.preserveFocus,selection:typeof Ae.selection=="object"?i.from(Ae.selection):void 0,override:typeof Ae.override=="boolean"?a.$wE.id:void 0}}Fe.from=Te})(Re||(e.TextEditorOpenOptions=Re={}));var Qe;(function(Fe){function Te(Ke){return Ke instanceof r.$IK?Ke.toJSON():typeof Ke=="string"?Ke:Ae(Ke)||te(Ke)?new r.$IK(Ke.baseUri??Ke.base,Ke.pattern).toJSON():Ke}Fe.from=Te;function Ae(Ke){const xe=Ke;return xe?k.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function te(Ke){const xe=Ke;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Me(Ke){return typeof Ke=="string"?Ke:new r.$IK(k.URI.revive(Ke.baseUri),Ke.pattern)}Fe.to=Me})(Qe||(e.GlobPattern=Qe={}));var ue;(function(Fe){function Te(Ae){if(Ae){if(Array.isArray(Ae))return Ae.map(Te);if(typeof Ae=="string")return Ae;{const te=Ae;return{language:te.language,scheme:te.scheme,pattern:Qe.from(te.pattern),exclusive:te.exclusive,notebookType:te.notebookType}}}else return}Fe.from=Te})(ue||(e.LanguageSelector=ue={}));var ce;(function(Fe){function Te(te){return!!te&&typeof te=="object"&&"selections"in te&&Array.isArray(te.selections)&&te.selections.every(Me=>Me instanceof r.$OJ)&&"related"in te&&Array.isArray(te.related)&&te.related.every(Me=>Me&&typeof Me=="object"&&k.URI.isUri(Me.uri)&&Me.range instanceof r.$NJ)}Fe.is=Te;function Ae(te){return{selections:te.selections.map(Me=>s.from(Me)),related:te.related.map(Me=>({uri:k.URI.from(Me.uri),range:i.from(Me.range)}))}}Fe.from=Ae})(ce||(e.MappedEditsContext=ce={}));var Ce;(function(Fe){function Te(te){return{start:te.start,end:te.end}}Fe.from=Te;function Ae(te){return new r.$0K(te.start,te.end)}Fe.to=Ae})(Ce||(e.NotebookRange=Ce={}));var Ve;(function(Fe){function Te(te){return{timing:typeof te.runStartTime=="number"&&typeof te.runEndTime=="number"?{startTime:te.runStartTime,endTime:te.runEndTime}:void 0,executionOrder:te.executionOrder,success:te.lastRunSuccess}}Fe.to=Te;function Ae(te){return{lastRunSuccess:te.success,runStartTime:te.timing?.startTime,runEndTime:te.timing?.endTime,executionOrder:te.executionOrder}}Fe.from=Ae})(Ve||(e.NotebookCellExecutionSummary=Ve={}));var je;(function(Fe){function Te(Ae){if(Ae===m.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(Ae===m.NotebookCellExecutionState.Pending)return;if(Ae===m.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ae}`)}Fe.to=Te})(je||(e.NotebookCellExecutionState=je={}));var Xe;(function(Fe){function Te(te){switch(te){case r.NotebookCellKind.Markup:return m.CellKind.Markup;case r.NotebookCellKind.Code:default:return m.CellKind.Code}}Fe.from=Te;function Ae(te){switch(te){case m.CellKind.Markup:return r.NotebookCellKind.Markup;case m.CellKind.Code:default:return r.NotebookCellKind.Code}}Fe.to=Ae})(Xe||(e.NotebookCellKind=Xe={}));var rt;(function(Fe){function Te(te){const Me={metadata:te.metadata??Object.create(null),cells:[]};for(const Ke of te.cells)r.$$K.validate(Ke),Me.cells.push(ot.from(Ke));return Me}Fe.from=Te;function Ae(te){const Me=new r.$_K(te.cells.map(ot.to));return(0,$.$ve)(te.metadata)||(Me.metadata=te.metadata),Me}Fe.to=Ae})(rt||(e.NotebookData=rt={}));var ot;(function(Fe){function Te(te){return{cellKind:Xe.from(te.kind),language:te.languageId,mime:te.mime,source:te.value,metadata:te.metadata,internalMetadata:Ve.from(te.executionSummary??{}),outputs:te.outputs?te.outputs.map(Ct.from):[]}}Fe.from=Te;function Ae(te){return new r.$$K(Xe.to(te.cellKind),te.source,te.language,te.mime,te.outputs?te.outputs.map(Ct.to):void 0,te.metadata,te.internalMetadata?Ve.to(te.internalMetadata):void 0)}Fe.to=Ae})(ot||(e.NotebookCellData=ot={}));var $t;(function(Fe){function Te(te){return{mime:te.mime,valueBytes:F.$Ec.wrap(te.data)}}Fe.from=Te;function Ae(te){return new r.$aL(te.valueBytes.buffer,te.mime)}Fe.to=Ae})($t||(e.NotebookCellOutputItem=$t={}));var Ct;(function(Fe){function Te(te){return{outputId:te.id,items:te.items.map($t.from),metadata:te.metadata}}Fe.from=Te;function Ae(te){const Me=te.items.map($t.to);return new r.$bL(Me,te.outputId,te.metadata)}Fe.to=Ae})(Ct||(e.NotebookCellOutput=Ct={}));var Qt;(function(Fe){function Te(Me){return te(Me)?{include:Qe.from(Me.include)??void 0,exclude:Qe.from(Me.exclude)??void 0}:Qe.from(Me)??void 0}Fe.from=Te;function Ae(Me){return te(Me)?{include:Qe.to(Me.include),exclude:Qe.to(Me.exclude)}:Qe.to(Me)}Fe.to=Ae;function te(Me){const Ke=Me;return Ke?!(0,$.$re)(Ke.include)&&!(0,$.$re)(Ke.exclude):!1}})(Qt||(e.NotebookExclusiveDocumentPattern=Qt={}));var qt;(function(Fe){function Te(Ae,te,Me){const Ke=typeof Ae.command=="string"?{title:"",command:Ae.command}:Ae.command;return{alignment:Ae.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:te.toInternal(Ke,Me),text:Ae.text,tooltip:Ae.tooltip,accessibilityInformation:Ae.accessibilityInformation,priority:Ae.priority}}Fe.from=Te})(qt||(e.NotebookStatusBarItem=qt={}));var vt;(function(Fe){function Te(Ae,te,Me){const Ke=typeof Ae.command=="string"?{title:"",command:Ae.command}:Ae.command;return{command:te.toInternal(Ke,Me),label:Ae.label,description:Ae.description,detail:Ae.detail,documentation:Ae.documentation}}Fe.from=Te})(vt||(e.NotebookKernelSourceAction=vt={}));var Mt;(function(Fe){function Te(Ae){return{transientOutputs:Ae?.transientOutputs??!1,transientCellMetadata:Ae?.transientCellMetadata??{},transientDocumentMetadata:Ae?.transientDocumentMetadata??{},cellContentMetadata:Ae?.cellContentMetadata??{}}}Fe.from=Te})(Mt||(e.NotebookDocumentContentOptions=Mt={}));var Nt;(function(Fe){function Te(te){return{uri:te.uri,provides:te.provides}}Fe.from=Te;function Ae(te){return new r.$dL(k.URI.revive(te.uri),te.provides)}Fe.to=Ae})(Nt||(e.NotebookRendererScript=Nt={}));var Jt;(function(Fe){function Te(te){return{message:T.fromStrict(te.message)||"",type:0,expected:te.expectedOutput,actual:te.actualOutput,contextValue:te.contextValue,location:te.location&&{range:i.from(te.location.range),uri:te.location.uri}}}Fe.from=Te;function Ae(te){const Me=new r.$jL(typeof te.message=="string"?te.message:T.to(te.message));return Me.actualOutput=te.actual,Me.expectedOutput=te.expected,Me.contextValue=te.contextValue,Me.location=te.location?q.to(te.location):void 0,Me}Fe.to=Ae})(Jt||(e.TestMessage=Jt={}));var Lt;(function(Fe){Fe.namespace=D.$AI,Fe.denamespace=D.$BI})(Lt||(e.TestTag=Lt={}));var Rt;(function(Fe){function Te(te){const Me=(0,o.$HL)(te).controllerId;return{extId:v.$wI.fromExtHostTestItem(te,Me).toString(),label:te.label,uri:k.URI.revive(te.uri),busy:te.busy,tags:te.tags.map(Ke=>Lt.namespace(Me,Ke.id)),range:C.$Ur.lift(i.from(te.range)),description:te.description||null,sortText:te.sortText||null,error:te.error&&T.fromStrict(te.error)||null}}Fe.from=Te;function Ae(te){return{parent:void 0,error:void 0,id:v.$wI.fromString(te.extId).localId,label:te.label,uri:k.URI.revive(te.uri),tags:(te.tags||[]).map(Me=>{const{tagId:Ke}=Lt.denamespace(Me);return new r.$kL(Ke)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(te.range||void 0),canResolveChildren:!1,busy:te.busy,description:te.description||void 0,sortText:te.sortText||void 0}}Fe.toPlain=Ae})(Rt||(e.TestItem=Rt={})),function(Fe){function Te(te){return{id:te.id}}Fe.from=Te;function Ae(te){return new r.$kL(te.id)}Fe.to=Ae}(Lt||(e.TestTag=Lt={}));var zt;(function(Fe){const Te=(te,Me)=>{const Ke=[];for(const[Ge,nt]of Me)v.$wI.compare(nt.item.extId,Ge)===2&&(Me.delete(Ge),Ke.push(nt));const xe={...Rt.toPlain(te.item),parent:void 0,taskStates:te.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(nt=>nt.type===0).map(Jt.to)})),children:Ke.map(Ge=>Te(Ge,Me))};for(const Ge of xe.children)Ge.parent=xe;return xe};function Ae(te){const Me=[],Ke=new Map;for(const xe of te.items){Ke.set(xe.item.extId,xe);const Ge=v.$wI.root(xe.item.extId);te.request.targets.some(nt=>nt.controllerId===Ge&&nt.testIds.includes(xe.item.extId))&&Me.push(xe)}return{completedAt:te.completedAt,results:Me.map(xe=>Te(xe,Ke))}}Fe.to=Ae})(zt||(e.TestResults=zt={}));var Ut;(function(Fe){function Te(Ke){return{covered:Ke.covered,total:Ke.covered}}function Ae(Ke){return"line"in Ke?l.from(Ke):i.from(Ke)}function te(Ke){return"branches"in Ke?{count:Ke.executionCount,location:Ae(Ke.location),type:1,branches:Ke.branches.length?Ke.branches.map(xe=>({count:xe.executionCount,location:xe.location&&Ae(xe.location)})):void 0}:{type:0,count:Ke.executionCount,location:Ae(Ke.location)}}Fe.fromDetailed=te;function Me(Ke){return{uri:Ke.uri,statement:Te(Ke.statementCoverage),branch:Ke.branchCoverage&&Te(Ke.branchCoverage),function:Ke.functionCoverage&&Te(Ke.functionCoverage),details:Ke.detailedCoverage?.map(te)}}Fe.fromFile=Me})(Ut||(e.TestCoverage=Ut={}));var Vt;(function(Fe){function Te(Ae){switch(Ae){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Fe.to=Te})(Vt||(e.CodeActionTriggerKind=Vt={}));var Bt;(function(Fe){function Te(te){const Me=new r.$qL(V.to(te.kind),te.name,te.detail||"",k.URI.revive(te.uri),i.to(te.range),i.to(te.selectionRange));return Me._sessionId=te._sessionId,Me._itemId=te._itemId,Me}Fe.to=Te;function Ae(te,Me,Ke){if(Me=Me??te._sessionId,Ke=Ke??te._itemId,Me===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ke,kind:V.from(te.kind),name:te.name,detail:te.detail??"",uri:te.uri,range:i.from(te.range),selectionRange:i.from(te.selectionRange),tags:te.tags?.map(re.from)}}Fe.from=Ae})(Bt||(e.TypeHierarchyItem=Bt={}));var ct;(function(Fe){function Te(Ae){if(Ae)return{value:Ae.value,tooltip:Ae.tooltip}}Fe.from=Te})(ct||(e.ViewBadge=ct={}));var ht;(function(Fe){function Te(Ke,xe,Ge){const nt=xe.fileData;return nt?new r.$BK(new r.$CK(nt.name,k.URI.revive(nt.uri),nt.id,(0,L.$cb)(()=>Ge(nt.id)))):Ke===P.$yr.uriList&&xe.uriListData?new r.$AK(Me(xe.uriListData)):new r.$AK(xe.asString)}Fe.to=Te;async function Ae(Ke,xe){const Ge=await xe.asString();if(Ke===P.$yr.uriList)return{asString:Ge,fileData:void 0,uriListData:te(Ge)};const nt=xe.asFile();return{asString:Ge,fileData:nt?{name:nt.name,uri:nt.uri,id:nt._itemId??nt.id}:void 0}}Fe.from=Ae;function te(Ke){return h.$is.split(Ke).map(xe=>{if(xe.startsWith("#"))return xe;try{return k.URI.parse(xe)}catch{}return xe})}function Me(Ke){return h.$is.create(Ke.map(xe=>typeof xe=="string"?xe:k.URI.revive(xe)))}})(ht||(e.DataTransferItem=ht={}));var Ht;(function(Fe){function Te(te,Me){const Ke=te.items.map(([xe,Ge])=>[xe,ht.to(xe,Ge,Me)]);return new r.$DK(Ke)}Fe.toDataTransfer=Te;async function Ae(te){const Me={items:[]},Ke=[];for(const[xe,Ge]of te)Ke.push((async()=>{Me.items.push([xe,await ht.from(xe,Ge)])})());return await Promise.all(Ke),Me}Fe.from=Ae})(Ht||(e.DataTransfer=Ht={}));var At;(function(Fe){function Te(te){return{message:te.message,metadata:te.metadata,title:te.title,tooltip:te.tooltip}}Fe.to=Te;function Ae(te){return{kind:"reply",message:te.message,metadata:te.metadata,title:te.title,tooltip:te.tooltip}}Fe.from=Ae})(At||(e.ChatReplyFollowup=At={}));var kt;(function(Fe){function Te(Ae){return typeof Ae=="string"?{title:Ae,message:Ae,kind:"reply"}:"commandId"in Ae?{kind:"command",title:Ae.title??"",commandId:Ae.commandId??"",when:Ae.when??"",args:Ae.args}:At.from(Ae)}Fe.from=Te})(kt||(e.ChatFollowup=kt={}));var ft;(function(Fe){function Te(te){const Me=new r.$AL(It.to(te.role),te.content);return Me.name=te.name,Me}Fe.to=Te;function Ae(te){return{role:It.from(te.role),content:te.content,name:te.name}}Fe.from=Ae})(ft||(e.ChatMessage=ft={}));var It;(function(Fe){function Te(te){switch(te){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Fe.to=Te;function Ae(te){switch(te){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Fe.from=Ae})(It||(e.ChatMessageRole=It={}));var Ot;(function(Fe){function Te(te){return{level:yt.to(te.level),value:te.value,description:te.description}}Fe.to=Te;function Ae(te){return{level:yt.from(te.level),value:te.value,description:te.description}}Fe.from=Ae})(Ot||(e.ChatVariable=Ot={}));var yt;(function(Fe){function Te(te){switch(te){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Fe.to=Te;function Ae(te){switch(te){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Fe.from=Ae})(yt||(e.ChatVariableLevel=yt={}));var He;(function(Fe){function Te(Ae,te,Me){return"terminalCommand"in Ae?{terminalCommand:Ae.terminalCommand}:"uri"in Ae?{uri:Ae.uri}:te.toInternal(Ae,Me)}Fe.from=Te})(He||(e.TerminalQuickFix=He={}))}),define(Se[270],De([1,0,2,8,7,10,72]),function(me,e,S,F,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fac=void 0;class f{constructor(g,P,I,$={timeout:1500,errors:3}){this.c=g,this.d=P,this.f=I,this.g=$,this.a=new A.$ub,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(g){return(P,I,$)=>{const C={dispose:this.a.push([P,I,g])};return Array.isArray($)&&$.push(C),C}}async $participateInSave(g,P){const I=S.URI.revive(g);let $=!1;const k=setTimeout(()=>$=!0,this.g.timeout),C=[];try{for(const E of[...this.a]){if($)break;const n=this.d.getDocument(I),o=await this.h(E,{document:n,reason:L.TextDocumentSaveReason.to(P)});C.push(o)}}finally{clearTimeout(k)}return C}h([g,P,I],$){const k=this.b.get(g);return typeof k=="number"&&k>this.g.errors?Promise.resolve(!1):this.i(I,g,P,$).then(()=>!0,C=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(C),!(C instanceof Error)||C.message!=="concurrent_edits"){const E=this.b.get(g);this.b.set(g,E?E+1:1),typeof E=="number"&&E>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(g,P,I,$){const k=[],C=Date.now(),{document:E,reason:n}=$,{version:o}=E,a=Object.freeze({document:E,reason:n,waitUntil(m){if(Object.isFrozen(k))throw(0,F.$6)("waitUntil can not be called async");k.push(Promise.resolve(m))}});try{P.apply(I,[a])}catch(m){return Promise.reject(m)}return Object.freeze(k),new Promise((m,v)=>{const D=setTimeout(()=>v(new Error("timeout")),this.g.timeout);return Promise.all(k).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-C}ms`),clearTimeout(D),m(t)}).catch(t=>{clearTimeout(D),v(t)})}).then(m=>{const v={edits:[]};for(const D of m)if(Array.isArray(D)&&D.every(t=>t instanceof h.$SJ))for(const{newText:t,newEol:r,range:s}of D)v.edits.push({resource:E.uri,versionId:void 0,textEdit:{range:s&&L.Range.from(s),text:t,eol:r&&L.EndOfLine.from(r)}});if(v.edits.length!==0)return o===E.version?this.f.$tryApplyWorkspaceEdit(v):Promise.reject(new Error("concurrent_edits"))})}}e.$Fac=f}),define(Se[271],De([1,0,16,2,10,7,107]),function(me,e,S,F,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tbc=e.$Sbc=void 0;class f{constructor(I,$,k,C){this.start=I,this.deletedCount=$,this.deletedItems=k,this.items=C}asApiEvent(){return{range:new L.$0K(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class w{static asModelAddData(I,$){return{EOL:$.eol,lines:$.source,languageId:$.language,uri:$.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,$,k){this.notebook=I,this.h=$,this.j=k,this.handle=k.handle,this.uri=F.URI.revive(k.uri),this.cellKind=k.cellKind,this.a=k.outputs.map(h.NotebookCellOutput.to),this.e=k.internalMetadata??{},this.b=Object.freeze(k.metadata??{}),this.d=Object.freeze(h.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,$=this.h.getDocument(this.uri);if(!$)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:h.NotebookCellKind.to(this.j.cellKind),document:$.document,get mime(){return I.g},set mime(C){I.g=C},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(k)}return this.f}setOutputs(I){this.a=I.map(h.NotebookCellOutput.to)}setOutputItems(I,$,k){const C=k.map(h.NotebookCellOutputItem.to),E=this.a.find(n=>n.id===I);if(E&&($||(E.items.length=0),E.items.push(...C),E.items.length>1&&E.items.every(n=>A.$RH(n.mime)))){const n=new Map,o=[];E.items.forEach(a=>{let m;n.has(a.mime)?m=n.get(a.mime):(m=[],n.set(a.mime,m),o.push(a.mime)),m.push(a.data)}),E.items.length=0,o.forEach(a=>{const m=A.$SH(n.get(a));E.items.push({mime:a,data:m.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(h.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$Sbc=w;class g{static{this.a=0}constructor(I,$,k,C,E){this.k=I,this.l=$,this.m=k,this.uri=C,this.handle=g.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=E.viewType,this.f=Object.freeze(E.metadata??Object.create(null)),this.r([[0,0,E.cells]],!0,void 0),this.g=E.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,$={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===S.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(k){return k=I.n(k),I.b[k].apiCell},getCells(k){return(k?I.p(k):I.b).map(E=>E.apiCell)},save(){return I.q()}};this.e=Object.freeze($)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,$,k){this.g=I.versionId,this.h=$,this.acceptDocumentPropertiesChanged({metadata:k});const C={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},E=[];for(const o of I.rawEvents)o.kind===A.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,C.contentChanges):o.kind===A.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,C.contentChanges):o.kind===A.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),E.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),E.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),E.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===A.NotebookCellsChangeType.ChangeCellContent?E.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),E.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),E.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const n=new Map;for(let o=0;o<E.length;o++){const a=E[o],m=n.get(a.cell);if(m===void 0){const v=C.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...a});n.set(a.cell,v-1)}else C.cellChanges[m]={...C.cellChanges[m],...a}}return Object.freeze(C),Object.freeze(C.cellChanges),Object.freeze(C.contentChanges),C}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let $=I.start|0,k=I.end|0;return $<0&&($=0),k>this.b.length&&(k=this.b.length),I.with({start:$,end:k})}p(I){I=this.o(I);const $=[];for(let k=I.start;k<I.end;k++)$.push(this.b[k]);return $}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,$,k){if(this.j)return;const C=[],E=[],n=[];if(I.reverse().forEach(o=>{const m=o[2].map(t=>{const r=new w(this,this.l,t);return $||E.push(w.asModelAddData(this.apiNotebook,t)),r}),v=new f(o[0],o[1],[],m),D=this.b.splice(o[0],o[1],...m);for(const t of D)n.push(t.uri),v.deletedItems.push(t.apiCell);C.push(v)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:E,removedDocuments:n}),k)for(const o of C)k.push(o.asApiEvent())}s(I,$,k,C){const E=this.b.splice(I,$);this.b.splice(k,0,...E);const n=[new f(I,$,E.map(o=>o.apiCell),[]),new f(k,0,[],E)];for(const o of n)C.push(o.asApiEvent())}t(I,$){this.b[I].setOutputs($)}u(I,$,k,C){this.b[I].setOutputItems($,k,C)}v(I,$){const k=this.b[I];k.apiCell.document.languageId!==$&&this.m.$acceptModelLanguageChanged(k.uri,$)}w(I,$){const k=this.b[I];k.apiCell.mime=$}x(I,$){this.b[I].setMetadata($)}y(I,$){this.b[I].setInternalMetadata($)}getCellFromApiCell(I){return this.b.find($=>$.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find($=>$.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$Tbc=g}),define(Se[272],De([1,0,4,2,10,7]),function(me,e,S,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=void 0;class A{constructor(w,g,P,I={timeout:1500,errors:3}){this.b=w,this.c=g,this.d=P,this.f=I,this.a=new S.$gc}dispose(){}getOnWillSaveNotebookDocumentEvent(w){return(g,P,I)=>{const $=function(C){g.call(P,C)};return $.extension=w,this.a.event($,void 0,I)}}async $participateInSave(w,g,P){const I=F.URI.revive(w),$=this.c.getNotebookDocument(I);if(!$)throw new Error("Unable to resolve notebook document");const k=[];if(await this.a.fireAsync({notebook:$.apiNotebook,reason:h.TextDocumentSaveReason.to(g)},P,async(E,n)=>{const o=Date.now(),a=await await Promise.resolve(E);Date.now()-o>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",n.extension.identifier),!P.isCancellationRequested&&a&&(a instanceof L.$VJ?k.push(a):this.b.warn("onWillSaveNotebookDocument-listener from extension",n.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(k.length===0)return!0;const C={edits:[]};for(const E of k){const{edits:n}=h.WorkspaceEdit.from(E);C.edits=C.edits.concat(n)}return this.d.$tryApplyWorkspaceEdit(C)}}e.$hcc=A}),define(Se[142],De([1,0,8,10,7]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ubc=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(f,w,g,P,I,$){this.id=f,this.f=w,this.notebookData=g,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=P,this.c=$}get apiEditor(){if(!this.e){const f=this;this.e={get notebook(){return f.notebookData.apiNotebook},get selection(){return f.a[0]},set selection(w){this.selections=[w]},get selections(){return f.a},set selections(w){if(!Array.isArray(w)||!w.every(h.$0K.isNotebookRange))throw(0,S.$5)("selections");f.a=w,f.g(w)},get visibleRanges(){return f.b},revealRange(w,g){f.f.$tryRevealRange(f.id,F.NotebookRange.from(w),g??h.NotebookEditorRevealType.Default)},get viewColumn(){return f.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(f){this.d=f}_acceptVisibleRanges(f){this.b=f}_acceptSelections(f){this.a=f}g(f){this.f.$trySetSelections(this.id,f.map(F.NotebookRange.from))}_acceptViewColumn(f){this.c=f}}e.$Ubc=L}),define(Se[273],De([1,0,8,4,17,10]),function(me,e,S,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$acc=void 0;let A=class{constructor(w,g){this.c=w,this.d=g,this.a=new F.$ec({onListenerError:S.$Z}),this.b=new F.$ec({onListenerError:S.$Z}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(w,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",w,g);const P=this.d.getEditorById(w);g.visibleRanges&&P._acceptVisibleRanges(g.visibleRanges.ranges.map(L.NotebookRange.to)),g.selections&&P._acceptSelections(g.selections.selections.map(L.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(w){for(const g in w)this.d.getEditorById(g)._acceptViewColumn(L.ViewColumn.to(w[g]))}};e.$acc=A,e.$acc=A=Je([Be(0,h.$Ri)],A)}),define(Se[274],De([1,0,10,83,202,22,70,8]),function(me,e,S,F,h,L,A,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ebc=void 0;class w{constructor($){this.b=0,this.c=new Map,this.a=$}async withProgress($,k,C){const E=this.b++,{title:n,location:o,cancellable:a}=k,m={label:(0,h.localize)(0,null,$.displayName||$.name),id:$.identifier.value};return this.a.$startProgress(E,{location:S.ProgressLocation.from(o),title:n,source:m,cancellable:a},$.isUnderDevelopment?void 0:$.identifier.value).catch(f.$Z),this.d(E,C,!!a)}d($,k,C){let E;C&&(E=new L.$oc,this.c.set($,E));const n=a=>{this.a.$progressEnd(a),this.c.delete(a),E?.dispose()};let o;try{o=k(new P(this.a,$),C&&E?E.token:L.CancellationToken.None)}catch(a){throw n($),a}return o.then(a=>n($),a=>n($)),o}$acceptProgressCanceled($){const k=this.c.get($);k&&(k.cancel(),this.c.delete($))}}e.$ebc=w;function g(I,$){return I.message=$.message,typeof $.increment=="number"&&(typeof I.increment=="number"?I.increment+=$.increment:I.increment=$.increment),I}class P extends F.$Tu{constructor($,k){super(C=>this.throttledReport(C)),this.f=$,this.g=k}throttledReport($){this.f.$progressReport(this.g,$)}}Je([(0,A.$Vg)(100,(I,$)=>g(I,$),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(Se[143],De([1,0,34,140,63,108,87,10,2]),function(me,e,S,F,h,L,A,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1L=e.$ZL=e.$YL=e.$XL=void 0;const g=(m,v,D,t)=>{let r=v;return{enumerable:!0,configurable:!1,get(){return r},set(s){if(!D(r,s)){const i=r;r=s,m.listener?.(t(s,i))}}}},P=(m,v)=>m===v,I={range:(m,v)=>m===v?!0:!m||!v?!1:m.isEqual(v),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(m,v)=>!(m.length!==v.length||m.some(D=>!v.find(t=>D.id===t.id)))},$=m=>v=>({op:4,update:m(v)}),k=(m,v)=>({range:(()=>{let D;const t=$(r=>({range:S.$Ur.lift(f.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return D},set(r){m.listener?.({op:6}),I.range(D,r)||(D=r,m.listener?.(t(r)))}}})(),label:g(m,v,I.label,$(D=>({label:D}))),description:g(m,void 0,I.description,$(D=>({description:D}))),sortText:g(m,void 0,I.sortText,$(D=>({sortText:D}))),canResolveChildren:g(m,!1,I.canResolveChildren,D=>({op:2,state:D})),busy:g(m,!1,I.busy,$(D=>({busy:D}))),error:g(m,void 0,I.error,$(D=>({error:f.MarkdownString.fromStrict(D)||null}))),tags:g(m,[],I.tags,(D,t)=>({op:1,new:D.map(f.TestTag.from),old:t.map(f.TestTag.from)}))}),C=m=>{const v=h.$wI.fromString(m.extId),D=new n(v.controllerId,v.localId,m.label,w.URI.revive(m.uri)||void 0);return D.range=f.Range.to(m.range||void 0),D.description=m.description||void 0,D.sortText=m.sortText||void 0,D.tags=m.tags.map(t=>f.TestTag.to({id:(0,A.$BI)(t).tagId})),D},E=m=>{let v;for(const D of m.tests){const t=C(D.item);(0,F.$HL)(t).parent=v,v=t}return v};e.$XL=E;class n{constructor(v,D,t,r){if(D.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(D)} symbol`);const s=(0,F.$GL)(this,v);Object.defineProperties(this,{id:{value:D,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof o?void 0:s.parent}},children:{value:(0,L.$FL)(s,F.$HL,n),enumerable:!0,writable:!1},...k(s,t)})}}e.$YL=n;class o extends n{constructor(v,D){super(v,v,D,void 0),this._isRoot=!0}}e.$ZL=o;class a extends L.$BL{constructor(v,D,t){super({controllerId:v,getDocumentVersion:r=>r&&t.getDocument(r)?.version,getApiFor:F.$HL,getChildren:r=>r.children,root:new o(v,D),toITestItem:f.TestItem.from})}}e.$1L=a}),define(Se[144],De([1,0,54,8,117,10,7]),function(me,e,S,F,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UL=e.$TL=e.$SL=void 0;class f{static{this.c=new h.$QL("TextEditorDecorationType")}constructor($,k,C){const E=f.c.nextId();$.$registerTextEditorDecorationType(k.identifier,E,L.DecorationRenderOptions.from(C)),this.value=Object.freeze({key:E,dispose(){$.$removeTextEditorDecorationType(E)}})}}e.$SL=f;class w{constructor($,k){this.g=[],this.h=void 0,this.j=!1,this.c=$,this.d=$.version,this.e=k.undoStopBefore,this.f=k.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace($,k){this.k();let C=null;if($ instanceof A.$MJ)C=new A.$NJ($,$);else if($ instanceof A.$NJ)C=$;else throw new Error("Unrecognized location");this.l(C,k,!1)}insert($,k){this.k(),this.l(new A.$NJ($,$),k,!0)}delete($){this.k();let k=null;if($ instanceof A.$NJ)k=$;else throw new Error("Unrecognized location");this.l(k,null,!0)}l($,k,C){const E=this.c.validateRange($);this.g.push({range:E,text:k,forceMoveMarkers:C})}setEndOfLine($){if(this.k(),$!==A.EndOfLine.LF&&$!==A.EndOfLine.CRLF)throw(0,F.$5)("endOfLine");this.h=$}}class g{constructor($,k,C,E){this.c=$,this.d=k,this._accept(C),this.e=E;const n=this;this.value={get tabSize(){return n.f},set tabSize(o){n.m(o)},get indentSize(){return n.g},set indentSize(o){n.o(o)},get insertSpaces(){return n.h},set insertSpaces(o){n.q(o)},get cursorStyle(){return n.j},set cursorStyle(o){n.s(o)},get lineNumbers(){return n.k},set lineNumbers(o){n.t(o)}}}_accept($){this.f=$.tabSize,this.g=$.indentSize,this.h=$.insertSpaces,this.j=$.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to($.lineNumbers)}l($){if($==="auto")return"auto";if(typeof $=="number"){const k=Math.floor($);return k>0?k:null}if(typeof $=="string"){const k=parseInt($,10);return isNaN(k)?null:k>0?k:null}return null}m($){const k=this.l($);if(k!==null){if(typeof k=="number"){if(this.f===k)return;this.f=k}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:k}))}}n($){if($==="tabSize")return"tabSize";if(typeof $=="number"){const k=Math.floor($);return k>0?k:null}if(typeof $=="string"){const k=parseInt($,10);return isNaN(k)?null:k>0?k:null}return null}o($){const k=this.n($);if(k!==null){if(typeof k=="number"){if(this.g===k)return;this.g=k}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:k}))}}p($){return $==="auto"?"auto":$==="false"?!1:!!$}q($){const k=this.p($);if(typeof k=="boolean"){if(this.h===k)return;this.h=k}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:k}))}s($){this.j!==$&&(this.j=$,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:$})))}t($){this.k!==$&&(this.k=$,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from($)})))}assign($){const k={};let C=!1;if(typeof $.tabSize<"u"){const E=this.l($.tabSize);E==="auto"?(C=!0,k.tabSize=E):typeof E=="number"&&this.f!==E&&(this.f=E,C=!0,k.tabSize=E)}if(typeof $.indentSize<"u"){const E=this.n($.indentSize);E==="tabSize"?(C=!0,k.indentSize=E):typeof E=="number"&&this.g!==E&&(this.g=E,C=!0,k.indentSize=E)}if(typeof $.insertSpaces<"u"){const E=this.p($.insertSpaces);E==="auto"?(C=!0,k.insertSpaces=E):this.h!==E&&(this.h=E,C=!0,k.insertSpaces=E)}typeof $.cursorStyle<"u"&&this.j!==$.cursorStyle&&(this.j=$.cursorStyle,C=!0,k.cursorStyle=$.cursorStyle),typeof $.lineNumbers<"u"&&this.k!==$.lineNumbers&&(this.k=$.lineNumbers,C=!0,k.lineNumbers=L.TextEditorLineNumbersStyle.from($.lineNumbers)),C&&this.u("setOptions",this.c.$trySetOptions(this.d,k))}u($,k){k.catch(C=>{this.e.warn(`ExtHostTextEditorOptions '${$}' failed:'`),this.e.warn(C)})}}e.$TL=g;class P{constructor($,k,C,E,n,o,a,m){this.id=$,this.j=k,this.k=C,this.g=!1,this.h=new Set,this.c=n,this.d=new g(this.j,this.id,o,C),this.e=a,this.f=m;const v=this;this.value=Object.freeze({get document(){return E.value},set document(D){throw(0,F.$7)("document")},get selection(){return v.c&&v.c[0]},set selection(D){if(!(D instanceof A.$OJ))throw(0,F.$5)("selection");v.c=[D],v.l()},get selections(){return v.c},set selections(D){if(!Array.isArray(D)||D.some(t=>!(t instanceof A.$OJ)))throw(0,F.$5)("selections");v.c=D,v.l()},get visibleRanges(){return v.e},set visibleRanges(D){throw(0,F.$7)("visibleRanges")},get options(){return v.d.value},set options(D){v.g||v.d.assign(D)},get viewColumn(){return v.f},set viewColumn(D){throw(0,F.$7)("viewColumn")},edit(D,t={undoStopBefore:!0,undoStopAfter:!0}){if(v.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new w(E.value,t);return D(r),v.m(r)},insertSnippet(D,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(v.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=v.c.map(i=>L.Range.from(i));else if(t instanceof A.$MJ){const{lineNumber:i,column:c}=L.Position.from(t);s=[{startLineNumber:i,startColumn:c,endLineNumber:i,endColumn:c}]}else if(t instanceof A.$NJ)s=[L.Range.from(t)];else{s=[];for(const i of t)if(i instanceof A.$NJ)s.push(L.Range.from(i));else{const{lineNumber:c,column:l}=L.Position.from(i);s.push({startLineNumber:c,startColumn:l,endLineNumber:c,endColumn:l})}}return k.$tryInsertSnippet($,E.value.version,D.value,s,r)},setDecorations(D,t){const r=t.length===0;r&&!v.h.has(D.key)||(r?v.h.delete(D.key):v.h.add(D.key),v.n(()=>{if(L.$IL(t))return k.$trySetDecorations($,D.key,L.$JL(t));{const s=new Array(4*t.length);for(let i=0,c=t.length;i<c;i++){const l=t[i];s[4*i]=l.start.line+1,s[4*i+1]=l.start.character+1,s[4*i+2]=l.end.line+1,s[4*i+3]=l.end.character+1}return k.$trySetDecorationsFast($,D.key,s)}}))},revealRange(D,t){v.n(()=>k.$tryRevealRange($,L.Range.from(D),t||A.TextEditorRevealType.Default))},show(D){k.$tryShowEditor($,L.ViewColumn.from(D))},hide(){k.$tryHideEditor($)}})}dispose(){(0,S.ok)(!this.g),this.g=!0}_acceptOptions($){(0,S.ok)(!this.g),this.d._accept($)}_acceptVisibleRanges($){(0,S.ok)(!this.g),this.e=$}_acceptViewColumn($){(0,S.ok)(!this.g),this.f=$}_acceptSelections($){(0,S.ok)(!this.g),this.c=$}async l(){const $=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,$)),this.value}m($){const k=$.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const C=k.edits.map(n=>n.range);C.sort((n,o)=>n.end.line===o.end.line?n.end.character===o.end.character?n.start.line===o.start.line?n.start.character-o.start.character:n.start.line-o.start.line:n.end.character-o.end.character:n.end.line-o.end.line);for(let n=0,o=C.length-1;n<o;n++){const a=C[n].end;if(C[n+1].start.isBefore(a))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const E=k.edits.map(n=>({range:L.Range.from(n.range),text:n.text,forceMoveMarkers:n.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,k.documentVersionId,E,{setEndOfLine:typeof k.setEndOfLine=="number"?L.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}n($){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):$().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this.k.warn(k),null))}}e.$UL=P}),define(Se[275],De([1,0,6,223]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1I=void 0,e.$1I=(0,S.$qh)(F.$wh)}),define(Se[145],De([1,0,25,4,14,3]),function(me,e,S,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S2b=e.$R2b=e.$Q2b=e.$P2b=e.$O2b=void 0;class A{constructor(n){this.removedDueToLooping=n}}e.$O2b=A;class f{static isHostExtension(n,o,a){if(o.getExtensionDescription(n))return!1;const m=a.getExtensionDescription(n);return m?!!((m.main||m.browser)&&m.api==="none"):!1}constructor(n,o){this.h=n,this.c=new F.$ec,this.onDidChange=this.c.event,this.d=o,this.j()}j(){this.d.sort(k),this.e=new S.$Kl,this.f=[],this.g=new Map;for(const n of this.d){if(this.e.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.e.set(n.identifier,n),this.f.push(n);const o=this.h.readActivationEvents(n);if(Array.isArray(o))for(let a of o)a==="onUri"&&(a=`onUri:${S.$Il.toKey(n.identifier)}`),this.g.has(a)||this.g.set(a,[]),this.g.get(a).push(n)}}set(n){this.d=n,this.j(),this.c.fire(void 0)}deltaExtensions(n,o){this.d=C(this.d,o),this.d=this.d.concat(n);const a=f.k(this.d);return this.d=C(this.d,a.map(m=>m.identifier)),this.j(),this.c.fire(void 0),new A(a)}static k(n){const o=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(t){this.d.has(t)||(this.d.add(t),this.e.push(t))}addArc(t,r){this.addNode(t),this.addNode(r),this.c.has(t)?this.c.get(t).push(r):this.c.set(t,[r])}getArcs(t){return this.c.has(t)?this.c.get(t):[]}hasOnlyGoodArcs(t,r){const s=o.getArcs(t);for(let i=0;i<s.length;i++)if(!r.has(s[i]))return!1;return!0}getNodes(){return this.e}},a=new S.$Kl;for(const t of n)if(a.set(t.identifier,t),t.extensionDependencies)for(const r of t.extensionDependencies)o.addArc(S.$Il.toKey(t.identifier),S.$Il.toKey(r));const m=new Set;o.getNodes().filter(t=>o.getArcs(t).length===0).forEach(t=>m.add(t));const v=o.getNodes().filter(t=>!m.has(t));let D;do{D=!1;for(let t=0;t<v.length;t++){const r=v[t];o.hasOnlyGoodArcs(r,m)&&(v.splice(t,1),t--,m.add(r),D=!0)}}while(D);return v.map(t=>a.get(t))}containsActivationEvent(n){return this.g.has(n)}containsExtension(n){return this.e.has(n)}getExtensionDescriptionsForActivationEvent(n){const o=this.g.get(n);return o?o.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(n){const o=this.e.get(n);return o||void 0}getExtensionDescriptionByUUID(n){for(const o of this.f)if(o.uuid===n)return o}getExtensionDescriptionByIdOrUUID(n,o){return this.getExtensionDescription(n)??(o?this.getExtensionDescriptionByUUID(o):void 0)}}e.$P2b=f,e.$Q2b={readActivationEvents:E=>E.activationEvents};class w{constructor(n){this.d=new I,this.c=new f(n,[])}async acquireLock(n){const o=await this.d.acquire(n);return new g(this,o)}deltaExtensions(n,o,a){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(o,a)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,o){return this.c.getExtensionDescriptionByIdOrUUID(n,o)}}e.$R2b=w;class g extends L.$lb{constructor(n,o){super(),this.f=n,this.c=!1,this.B(o)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$S2b=g;class P{constructor(n){this.name=n,this.promise=new Promise((o,a)=>{this.c=o})}resolve(n){this.c(n)}}class I{constructor(){this.c=[],this.d=!1}async acquire(n){const o=new P(n);return this.c.push(o),this.e(),o.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let o=!0;const a=setTimeout(()=>{o&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),m=()=>{o&&(clearTimeout(a),o=!1,this.d=!1,this.e())};n.resolve((0,L.$jb)(m))}}var $;(function(E){E[E.Builtin=0]="Builtin",E[E.User=1]="User",E[E.Dev=2]="Dev"})($||($={}));function k(E,n){const o=E.isBuiltin?0:E.isUnderDevelopment?2:1,a=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(o!==a)return o-a;const m=h.$5c.basename(E.extensionLocation.path),v=h.$5c.basename(n.extensionLocation.path);return m<v?-1:m>v?1:0}function C(E,n){const o=new S.$Jl(n);return E.filter(a=>!o.has(a.identifier))}}),define(Se[276],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.ExtHostConnectionType=void 0;var S;(function(P){P[P.IPC=1]="IPC",P[P.Socket=2]="Socket",P[P.MessagePort=3]="MessagePort"})(S||(e.ExtHostConnectionType=S={}));class F{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[F.ENV_KEY]=this.pipeName}}e.$am=F;class h{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[h.ENV_KEY]="1"}}e.$bm=h;class L{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[L.ENV_KEY]="1"}}e.$cm=L;function A(P){delete P[F.ENV_KEY],delete P[h.ENV_KEY],delete P[L.ENV_KEY]}function f(P,I){A(I),P.serialize(I)}e.$dm=f;function w(P){if(P[F.ENV_KEY])return g(P,new F(P[F.ENV_KEY]));if(P[h.ENV_KEY])return g(P,new h);if(P[L.ENV_KEY])return g(P,new L);throw new Error("No connection information defined in environment!")}e.$em=w;function g(P,I){return A(P),I}}),define(Se[110],De([1,0,21]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$Rl=e.$Ql=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(F||(e.UIKind=F={}));var h;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(h||(e.ExtensionHostExitCode=h={}));var L;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function A(g){const P=S.$Ec.alloc(1);switch(g){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.$Ql=A;function f(g,P){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.$Rl=f;var w;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(w||(e.NativeLogMarkers=w={}))}),define(Se[88],De([1,0,6,4,17,26,110,60,85,23,2,3,204]),function(me,e,S,F,h,L,A,f,w,g,P,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6L=e.$5L=e.$4L=e.$3L=void 0;let k=class extends I.$lb{constructor(o,a){super(),this.n=o,this.p=a,this.a=this.B(new F.$ec),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$ec),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.m=new Map,this.j=P.URI.revive(this.n.environment.extensionTelemetryLogResource),this.i=this.n.environment.isExtensionTelemetryLoggingOnly,this.k=a.createLogger(this.j,{id:w.$9n,name:(0,$.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(a.onDidChangeLogLevel(m=>{(0,h.$Ti)(m)&&this.r()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}r(){this.p.setVisibility(this.j,this.g&&this.p.getLogLevel()===h.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,a,m){const v=this.getTelemetryDetails(),D=new C(a,m,o,this.k,this.i,this.getBuiltInCommonProperties(o),{isUsageEnabled:v.isUsageEnabled,isErrorsEnabled:v.isErrorsEnabled}),t=this.m.get(o.identifier.value)??[];return this.m.set(o.identifier.value,[...t,D]),D.apiTelemetryLogger}$initializeTelemetryLevel(o,a,m){this.f=o,this.g=a,this.c=m??{usage:!0,error:!0},this.r()}getBuiltInCommonProperties(o){const a=Object.create(null);switch(a["common.extname"]=`${o.publisher}.${o.name}`,a["common.extversion"]=o.version,a["common.vscodemachineid"]=this.n.telemetryInfo.machineId,a["common.vscodesessionid"]=this.n.telemetryInfo.sessionId,a["common.vscodeversion"]=this.n.version,a["common.isnewappinstall"]=E(this.n.telemetryInfo.firstSessionDate),a["common.product"]=this.n.environment.appHost,this.n.uiKind){case A.UIKind.Web:a["common.uikind"]="web";break;case A.UIKind.Desktop:a["common.uikind"]="desktop";break;default:a["common.uikind"]="unknown"}return a["common.remotename"]=(0,f.$Ck)((0,w.$do)(this.n.remote.authority)),a}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const a=this.getTelemetryDetails();this.m.forEach((m,v)=>{const D=m.filter(t=>!t.isDisposed);D.length===0?this.m.delete(v):this.m.set(v,D)}),this.m.forEach(m=>{for(const v of m)v.updateTelemetryEnablements(a.isUsageEnabled,a.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.r()}onExtensionError(o,a){const v=this.m.get(o.value)?.filter(t=>!t.isDisposed);if(!v)return this.m.delete(o.value),!1;let D=!1;for(const t of v)t.ignoreUnhandledExtHostErrors||(t.logError(a),D=!0);return D}};e.$3L=k,e.$3L=k=Je([Be(0,L.$2L),Be(1,h.$Si)],k);class C{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,a,m,v,D,t,r){this.g=m,this.h=v,this.i=D,this.j=t,this.a=new F.$ec,this.ignoreUnhandledExtHostErrors=a?.ignoreUnhandledErrors??!1,this.b=a?.ignoreBuiltInCommonProperties??!1,this.c=a?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(o,a){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:a},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let a="properties"in o?o.properties??{}:o;return a=(0,w.$go)(a,[]),this.c&&(a=(0,g.$Lm)(a,this.c)),this.b||(a=(0,g.$Lm)(a,this.j)),"properties"in o?o.properties=a:o=a,o}k(o,a){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,a=this.mixInCommonPropsAndCleanData(a||{}),this.i||this.f?.sendEventData(o,a),this.h.trace(o,a))}logUsage(o,a){this.d.isUsageEnabled&&this.k(o,a)}logError(o,a){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,a);else{const m={name:o.name,message:o.message,stack:o.stack,cause:o.cause},v=(0,w.$go)(m,[]),D=new Error(v.message,{cause:v.cause});D.stack=v.stack,D.name=v.name,a=this.mixInCommonPropsAndCleanData(a||{}),this.i||this.f.sendErrorData(D,a),this.h.trace("exception",a)}}get apiTelemetryLogger(){if(!this.e){const o=this,a={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(a)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$4L=C;function E(n){const o=Date.now()-new Date(n).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$5L=E,e.$6L=(0,S.$ph)("IExtHostTelemetry")}),define(Se[27],De([1,0,4,2,245,135,25,6]),function(me,e,S,F,h,L,A,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JF=e.$IF=e.$HF=e.ActivationKind=e.$GF=e.$FF=e.$EF=e.$DF=e.$CF=e.ExtensionHostStartup=e.$BF=e.$AF=e.$zF=e.$yF=void 0,e.$yF=Object.freeze({identifier:new A.$Il("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$zF="extensions.webWorker",e.$AF=(0,f.$ph)("extensionService");class w{constructor(D){this.dependency=D}}e.$BF=w;var g;(function(v){v[v.EagerAutoStart=1]="EagerAutoStart",v[v.EagerManualStart=2]="EagerManualStart",v[v.Lazy=3]="Lazy"})(g||(e.ExtensionHostStartup=g={}));class P{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:L.$pF.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(D,t){const r=[],s=[],i=[],c=[],l=I(this.c),b=I(D),y=(O,j)=>O.extensionLocation.toString()===j.extensionLocation.toString()||O.isBuiltin===j.isBuiltin||O.isUserBuiltin===j.isUserBuiltin||O.isUnderDevelopment===j.isUnderDevelopment;for(const O of this.c){const j=b.get(O.identifier);if(!j){r.push(O.identifier),l.delete(O.identifier);continue}if(!y(O,j)){r.push(O.identifier),l.delete(O.identifier);continue}}for(const O of D){const j=l.get(O.identifier);if(!j){s.push(O);continue}if(!y(j,O)){r.push(j.identifier),l.delete(j.identifier);continue}}const u=new A.$Jl(this.d),d=new A.$Jl(t);for(const O of this.d)d.has(O)||i.push(O);for(const O of t)u.has(O)||c.push(O);const p=L.$pF.createActivationEventsMap(s),R={toRemove:r,toAdd:s,addActivationEvents:p,myToRemove:i,myToAdd:c};return this.delta(R),R}delta(D){const{toRemove:t,toAdd:r,myToRemove:s,myToAdd:i}=D,c=new A.$Jl(t),l=new A.$Jl(s);for(let b=0;b<this.c.length;b++)c.has(this.c[b].identifier)&&(this.c.splice(b,1),b--);for(let b=0;b<this.d.length;b++)l.has(this.d[b])&&(this.d.splice(b,1),b--);for(const b of r)this.c.push(b);for(const b of i)this.d.push(b)}containsExtension(D){for(const t of this.d)if(A.$Il.equals(t,D))return!0;return!1}}e.$CF=P;function I(v){const D=new A.$Kl;for(const t of v)D.set(t.identifier,t);return D}function $(v,D){return v.enabledApiProposals?v.enabledApiProposals.includes(D):!1}e.$DF=$;function k(v,D){if(!$(v,D))throw new Error(`Extension '${v.identifier.value}' CANNOT use API proposal: ${D}.
Its package.json#enabledApiProposals-property declares: ${v.enabledApiProposals?.join(", ")??"[]"} but NOT ${D}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${v.identifier.value}`)}e.$EF=k;class C{constructor(D,t,r,s){this.codeLoadingTime=D,this.activateCallTime=t,this.activateResolvedTime=r,this.activationReason=s}}e.$FF=C;class E{constructor(D,t){this.description=D,this.value=t}}e.$GF=E;var n;(function(v){v[v.Normal=0]="Normal",v[v.Immediate=1]="Immediate"})(n||(e.ActivationKind=n={}));function o(v){return{type:v.isBuiltin?0:1,isBuiltin:v.isBuiltin||v.isUserBuiltin,identifier:{id:(0,h.$mo)(v.publisher,v.name),uuid:v.uuid},manifest:v,location:v.extensionLocation,targetPlatform:v.targetPlatform,validations:[],isValid:!0}}e.$HF=o;function a(v,D){return{identifier:new A.$Il((0,h.$ko)(v.manifest.publisher,v.manifest.name)),isBuiltin:v.type===0,isUserBuiltin:v.type===1&&v.isBuiltin,isUnderDevelopment:!!D,extensionLocation:v.location,...v.manifest,uuid:v.identifier.uuid,targetPlatform:v.targetPlatform}}e.$IF=a;class m{constructor(){this.onDidRegisterExtensions=S.Event.None,this.onDidChangeExtensionsStatus=S.Event.None,this.onDidChangeExtensions=S.Event.None,this.onWillActivateByEvent=S.Event.None,this.onDidChangeResponsiveChange=S.Event.None,this.onWillStop=S.Event.None,this.extensions=[]}activateByEvent(D){return Promise.resolve(void 0)}activationEventIsDone(D){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(D){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(D,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(D){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$JF=m}),define(Se[277],De([1,0,8,145,25,27,17,13]),function(me,e,S,F,h,L,A,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lac=e.$Kac=e.$Jac=e.$Iac=e.$Hac=e.$Gac=void 0;class w{static{this.NONE=new w(!1,-1,-1,-1)}constructor(o,a,m,v){this.startup=o,this.codeLoadingTime=a,this.activateCallTime=m,this.activateResolvedTime=v}}e.$Gac=w;class g{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,a){return o===-1||a===-1?-1:a-o}build(){return new w(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Hac=g;class P{constructor(o,a,m,v,D,t){this.activationFailed=o,this.activationFailedError=a,this.activationTimes=m,this.module=v,this.exports=D,this.subscriptions=t}}e.$Iac=P;class I extends P{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Jac=I;class $ extends P{constructor(){super(!1,null,w.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Kac=$;class k extends P{constructor(o){super(!0,o,w.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let C=class{constructor(o,a,m,v){this.g=v,this.a=o,this.b=a,this.c=m,this.d=new h.$Kl,this.f=Object.create(null)}dispose(){for(const[o,a]of this.d)a.dispose()}async waitForActivatingExtensions(){const o=[];for(const[a,m]of this.d)o.push(m.wait());await Promise.all(o)}isActivated(o){const a=this.d.get(o);return!!(a&&a.value)}getActivatedExtension(o){const a=this.d.get(o);if(!a||!a.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return a.value}async activateByEvent(o,a){if(this.f[o])return;const m=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(m.map(v=>({id:v.identifier,reason:{startup:a,extensionId:v.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,a){const m=this.a.getExtensionDescription(o);if(!m)throw new Error(`Extension '${o}' is not known`);return this.h([{id:m.identifier,reason:a}])}async h(o){const a=o.filter(m=>!this.isActivated(m.id)).map(m=>this.j(m));await Promise.all(a.map(m=>m.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const a=this.a.getExtensionDescription(o.id);if(!a){const D=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new k(D));return this.c.onExtensionActivationError(o.id,D,new L.$BF(o.id.value)),t}const m=[],v=typeof a.extensionDependencies>"u"?[]:a.extensionDependencies;for(const D of v){if(this.m(D))continue;const t=this.d.get(D);if(t){m.push(t);continue}if(this.l(D)){m.push(this.j({id:this.b.getExtensionDescription(D).identifier,reason:o.reason}));continue}const r=this.a.getExtensionDescription(D);if(r){if(!r.main&&!r.browser)continue;m.push(this.j({id:r.identifier,reason:o.reason}));continue}const s=a.displayName||a.identifier.value,i=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${D}'`),c=this.k(o,a.displayName,[],new k(i));return this.c.onExtensionActivationError(a.identifier,i,new L.$BF(D)),c}return this.k(o,a.displayName,m,null)}k(o,a,m,v){const D=new E(o.id,a,o.reason,m,v,this.c,this.g);return this.d.set(o.id,D),D}l(o){return F.$P2b.isHostExtension(o,this.a,this.b)}m(o){const a=this.b.getExtensionDescription(o);return a?!a.main&&!a.browser:!1}};e.$Lac=C,e.$Lac=C=Je([Be(3,A.$Ri)],C);let E=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,a,m,v,D,t,r){this.c=o,this.d=a,this.f=m,this.g=v,this.h=D,this.j=t,this.k=r,this.a=new f.$tg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const a=this.g[o];if(a.value&&!a.value.activationFailed){this.g.splice(o,1),o--;continue}if(a.value&&a.value.activationFailed){const m=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${a.friendlyName}' failed to activate`);m.detail=a.value.activationFailedError,this.h=new k(m),this.j.onExtensionActivationError(this.c,m,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const a=new Error;if(o&&o.name&&(a.name=o.name),o&&o.message?a.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:a.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(a.stack=o.stack),this.h=new k(a),this.b&&S.$2(o))return;this.j.onExtensionActivationError(this.c,a,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};E=Je([Be(6,A.$Ri)],E)}),define(Se[278],De([1,0,206,7,24,2,4,3,259,13,7,19,18,10,78,22,170,27]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lbc=void 0;function a(D,t){if((0,I.$ie)(D))return{label:D};if(D&&typeof D=="object"&&typeof D.label=="string"){let r;return Array.isArray(D.highlights)&&(r=D.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),r=r.length?r:void 0),{label:D.label,highlights:r}}}class m{constructor(t,r,s){this.d=t,this.e=r,this.f=s,this.a=new Map,this.b=new n.$V6;function i(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}r.registerArgumentProcessor({processArgument:c=>i(c)?this.i(c):Array.isArray(c)&&c.length>0?c.map(l=>i(l)?this.i(l):l):c})}registerTreeDataProvider(t,r,s){const i=this.createTreeView(t,{treeDataProvider:r},s);return{dispose:()=>i.dispose()}}createTreeView(t,r,s){if(!r||!r.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=r.dragAndDropController?.dropMimeTypes??[],c=r.dragAndDropController?.dragMimeTypes??[],l=!!r.dragAndDropController?.handleDrag,b=!!r.dragAndDropController?.handleDrop,y=this.h(t,r,s),u={showCollapseAll:!!r.showCollapseAll,canSelectMany:!!r.canSelectMany,dropMimeTypes:i,dragMimeTypes:c,hasHandleDrag:l,hasHandleDrop:b,manuallyManageCheckboxes:!!r.manageCheckboxStateManually},d=this.d.$registerTreeViewDataProvider(t,u);return{get onDidCollapseElement(){return y.onDidCollapseElement},get onDidExpandElement(){return y.onDidExpandElement},get selection(){return y.selectedElements},get onDidChangeSelection(){return y.onDidChangeSelection},get activeItem(){return(0,o.$EF)(s,"treeViewActiveItem"),y.focusedElement},get onDidChangeActiveItem(){return(0,o.$EF)(s,"treeViewActiveItem"),y.onDidChangeActiveItem},get visible(){return y.visible},get onDidChangeVisibility(){return y.onDidChangeVisibility},get onDidChangeCheckboxState(){return y.onDidChangeCheckboxState},get message(){return y.message},set message(R){(0,C.$Mj)(R)&&(0,o.$EF)(s,"treeViewMarkdownMessage"),y.message=R},get title(){return y.title},set title(R){y.title=R},get description(){return y.description},set description(R){y.description=R},get badge(){return y.badge},set badge(R){R!==void 0&&P.ViewBadge.isViewBadge(R)?y.badge={value:Math.floor(Math.abs(R.value)),tooltip:R.tooltip}:R===void 0&&(y.badge=void 0)},reveal:(R,O)=>y.reveal(R,O),dispose:async()=>{await d,this.a.delete(t),y.dispose()}}}$getChildren(t,r){const s=this.a.get(t);return s?s.getChildren(r):Promise.reject(new w.$3E(t))}async $handleDrop(t,r,s,i,c,l,b,y){const u=this.a.get(t);if(!u)return Promise.reject(new w.$3E(t));const d=k.DataTransfer.toDataTransfer(s,async p=>(await this.d.$resolveDropFileData(t,r,p)).buffer);return b===t&&y&&await this.g(d,u,y,c,l),u.onDrop(d,i,c)}async g(t,r,s,i,c){const l=this.b.removeDragOperationTransfer(c);if(l)(await l)?.forEach((b,y)=>{b&&t.set(y,b)});else if(c&&r.handleDrag){const b=r.handleDrag(s,t,i);this.b.addDragOperationTransfer(c,b),await b}return t}async $handleDrag(t,r,s,i){const c=this.a.get(t);if(!c)return Promise.reject(new w.$3E(t));const l=await this.g(new F.$DK,c,r,i,s);if(!(!l||i.isCancellationRequested))return k.DataTransfer.from(l)}async $hasResolve(t){const r=this.a.get(t);if(!r)throw new w.$3E(t);return r.hasResolve}$resolve(t,r,s){const i=this.a.get(t);if(!i)throw new w.$3E(t);return i.resolveTreeItem(r,s)}$setExpanded(t,r,s){const i=this.a.get(t);if(!i)throw new w.$3E(t);i.setExpanded(r,s)}$setSelectionAndFocus(t,r,s){const i=this.a.get(t);if(!i)throw new w.$3E(t);i.setSelectionAndFocus(r,s)}$setVisible(t,r){const s=this.a.get(t);if(!s){if(!r)return;throw new w.$3E(t)}s.setVisible(r)}$changeCheckboxState(t,r){const s=this.a.get(t);if(!s)throw new w.$3E(t);s.setCheckboxState(r)}h(t,r,s){const i=new v(t,r,this.d,this.e.converter,this.f,s);return this.a.set(t,i),i}i(t){const r=this.a.get(t.$treeViewId);return r&&"$treeItemHandle"in t?r.getExtensionElement(t.$treeItemHandle):r&&"$focusedTreeItem"in t&&t.$focusedTreeItem?r.focusedElement:null}}e.$lbc=m;class v extends f.$lb{static{this.a="0"}static{this.b="1"}get visible(){return this.k}get selectedElements(){return this.l.map(t=>this.getExtensionElement(t)).filter(t=>!(0,I.$re)(t))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(t,r,s,i,c,l){if(super(),this.D=t,this.F=s,this.G=i,this.H=c,this.I=l,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new A.$ec),this.onDidExpandElement=this.r.event,this.s=this.B(new A.$ec),this.onDidCollapseElement=this.s.event,this.t=this.B(new A.$ec),this.onDidChangeSelection=this.t.event,this.u=this.B(new A.$ec),this.onDidChangeActiveItem=this.u.event,this.v=this.B(new A.$ec),this.onDidChangeVisibility=this.v.event,this.w=this.B(new A.$ec),this.onDidChangeCheckboxState=this.w.event,this.y=this.B(new A.$ec),this.z=Promise.resolve(),this.C=Promise.resolve(),this.J="",this.L="",this.U=new E.$oc,l.contributes&&l.contributes.views)for(const u in l.contributes.views)for(const d of l.contributes.views[u])d.id===t&&(this.L=d.name);this.f=r.treeDataProvider,this.g=r.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(u=>this.y.fire({message:!1,element:u})));let b,y;this.B(A.Event.debounce(this.y.event,(u,d)=>(u||(u={message:!1,elements:[]}),d.element!==!1&&(b||(b=new Promise(p=>y=p),this.z=this.z.then(()=>b)),Array.isArray(d.element)?u.elements.push(...d.element):u.elements.push(d.element)),d.message&&(u.message=!0),u),200,!0)(({message:u,elements:d})=>{d.length&&(this.C=this.C.then(()=>{const p=y;return b=null,this.W(d).then(()=>p())})),u&&this.F.$setMessage(this.D,k.MarkdownString.fromStrict(this.J)??"")}))}async getChildren(t){const r=t?this.getExtensionElement(t):void 0;if(t&&!r)return this.H.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let s=this.R(t);return s||(s=await this.S(r)),s?s.map(i=>i.item):void 0}getExtensionElement(t){return this.i.get(t)}reveal(t,r){r=r||{select:!0,focus:!1};const s=(0,I.$re)(r.select)?!0:r.select,i=(0,I.$re)(r.focus)?!1:r.focus,c=(0,I.$re)(r.expand)?!1:r.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.z.then(()=>this.O(t)).then(l=>this.Q(t,l[l.length-1]).then(b=>this.F.$reveal(this.D,{item:b.item,parentChain:l.map(y=>y.item)},{select:s,focus:i,expand:c})),l=>this.H.error(l)):this.F.$reveal(this.D,void 0,{select:s,focus:i,expand:c})}get message(){return this.J}set message(t){this.J=t,this.y.fire({message:!0,element:!1})}get title(){return this.L}set title(t){this.L=t,this.F.$setTitle(this.D,t,this.M)}get description(){return this.M}set description(t){this.M=t,this.F.$setTitle(this.D,this.L,t)}get badge(){return this.N}set badge(t){this.N?.value===t?.value&&this.N?.tooltip===t?.tooltip||(this.N=k.ViewBadge.from(t),this.F.$setBadge(this.D,t))}setExpanded(t,r){const s=this.getExtensionElement(t);s&&(r?this.r.fire(Object.freeze({element:s})):this.s.fire(Object.freeze({element:s})))}setSelectionAndFocus(t,r){const s=!(0,$.$$e)(this.l,t);this.l=t;const i=this.m!==r;this.m=r,s&&this.t.fire(Object.freeze({selection:this.selectedElements})),i&&this.u.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.k&&(this.k=t,this.v.fire(Object.freeze({visible:this.k})))}async setCheckboxState(t){const r=(await Promise.all(t.map(async s=>{const i=this.getExtensionElement(s.treeItemHandle);return i?{extensionItem:i,treeItem:await this.f.getTreeItem(i),newState:s.newState?P.TreeItemCheckboxState.Checked:P.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);r.forEach(s=>{s.treeItem.checkboxState=s.newState?P.TreeItemCheckboxState.Checked:P.TreeItemCheckboxState.Unchecked}),this.w.fire({items:r.map(s=>[s.extensionItem,s.newState])})}async handleDrag(t,r,s){const i=[];for(const c of t){const l=this.getExtensionElement(c);l&&i.push(l)}if(!(!this.g?.handleDrag||i.length===0))return await this.g.handleDrag(i,r,s),r}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,r,s){const i=r?this.getExtensionElement(r):void 0;if(!(!i&&r||!this.g?.handleDrop))return(0,g.$ng)(()=>this.g?.handleDrop?this.g.handleDrop(i,t,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,r){if(!this.f.resolveTreeItem)return;const s=this.i.get(t);if(s){const i=this.j.get(s);if(i){const c=await this.f.resolveTreeItem(i.extensionItem,s,r)??i.extensionItem;return this.db(c),i.item.tooltip=this.ab(c.tooltip),i.item.command=this.bb(i.disposableStore,c.command),i.item}}}O(t){return this.P(t).then(r=>r?this.O(r).then(s=>this.Q(r,s[s.length-1]).then(i=>(s.push(i),s))):Promise.resolve([]))}P(t){const r=this.j.get(t);return r?Promise.resolve(r.parent?this.i.get(r.parent.item.handle):void 0):(0,g.$ng)(()=>this.f.getParent(t))}Q(t,r){const s=this.j.get(t);return s?Promise.resolve(s):(0,g.$ng)(()=>this.f.getTreeItem(t)).then(i=>this.gb(t,i,r,!0)).then(i=>this.getChildren(r?r.item.handle:void 0).then(()=>{const c=this.getExtensionElement(i);if(c){const l=this.j.get(c);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${i} from extension ${this.I.identifier.value}`)}))}R(t){if(t){let r;if(typeof t=="string"){const s=this.getExtensionElement(t);r=s?this.j.get(s):void 0}else r=t;return r&&r.children||void 0}return this.h}async S(t){this.nb(t);const r=new E.$oc(this.U.token);try{const s=t?this.j.get(t):void 0,i=await this.f.getChildren(t);if(r.token.isCancellationRequested)return;const c=await Promise.all((0,$.$jf)(i||[]).map(async l=>{const b=await this.f.getTreeItem(l);return b&&!r.token.isCancellationRequested?this.$(l,b,s):null}));return r.token.isCancellationRequested?void 0:(0,$.$jf)(c)}finally{r.dispose()}}W(t){if(t.some(s=>!s))return this.U.dispose(!0),this.U=new E.$oc,this.pb(),this.F.$refresh(this.D);{const s=this.X(t);if(s.length)return this.Y(s)}return Promise.resolve(void 0)}X(t){const r=new Set,s=t.map(c=>this.j.get(c));for(const c of s)if(c&&!r.has(c.item.handle)){let l=c;for(;l&&l.parent&&s.findIndex(b=>l&&l.parent&&b&&b.item.handle===l.parent.item.handle)===-1;){const b=this.i.get(l.parent.item.handle);l=b?this.j.get(b):void 0}l&&!l.parent&&r.add(c.item.handle)}const i=[];return r.forEach(c=>{const l=this.i.get(c);if(l){const b=this.j.get(l);b&&(!b.parent||!r.has(b.parent.item.handle))&&i.push(c)}}),i}Y(t){const r={};return Promise.all(t.map(s=>this.Z(s).then(i=>{i&&(r[s]=i.item)}))).then(()=>Object.keys(r).length?this.F.$refresh(this.D,r):void 0)}Z(t){const r=this.getExtensionElement(t);if(r){const s=this.j.get(r);if(s)return this.nb(r),(0,g.$ng)(()=>this.f.getTreeItem(r)).then(i=>{if(i){const c=this.eb(r,i,s.parent);return this.lb(r,c,s,s.parent),s.dispose(),c}return null})}return Promise.resolve(null)}$(t,r,s){const i=this.eb(t,r,s);if(r.id&&this.i.has(i.item.handle))throw new Error((0,S.localize)(0,null,r.id));return this.kb(t,i),this.mb(i,s),i}ab(t){return P.$aK.isMarkdownString(t)?k.MarkdownString.from(t):t}bb(t,r){return r?{...this.G.toInternal(r,t),originalId:r.command}:void 0}cb(t){if(t.checkboxState===void 0)return;let r,s,i;return typeof t.checkboxState=="number"?r=t.checkboxState:(r=t.checkboxState.state,s=t.checkboxState.tooltip,i=t.checkboxState.accessibilityInformation),{isChecked:r===P.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:i}}db(t){if(!P.$yK.isTreeItem(t,this.I))throw new Error(`Extension ${this.I.identifier.value} has provided an invalid tree item.`)}eb(t,r,s){this.db(r);const i=new f.$kb,c=this.gb(t,r,s),l=this.hb(r);return{item:{handle:c,parentHandle:s?s.item.handle:void 0,label:a(r.label,this.I),description:r.description,resourceUri:r.resourceUri,tooltip:this.ab(r.tooltip),command:this.bb(i,r.command),contextValue:r.contextValue,icon:l,iconDark:this.ib(r)||l,themeIcon:this.fb(r),collapsibleState:(0,I.$re)(r.collapsibleState)?P.TreeItemCollapsibleState.None:r.collapsibleState,accessibilityInformation:r.accessibilityInformation,checkbox:this.cb(r)},extensionItem:r,parent:s,children:void 0,disposableStore:i,dispose(){i.dispose()}}}fb(t){return t.iconPath instanceof P.$GK?t.iconPath:void 0}gb(t,{id:r,label:s,resourceUri:i},c,l){if(r)return`${v.b}/${r}`;const b=a(s,this.I),y=c?c.item.handle:v.a;let u=b?b.label:i?(0,h.$6f)(i):"";u=u.indexOf("/")!==-1?u.replace("/","//"):u;const d=this.j.has(t)?this.j.get(t).item.handle:void 0,p=this.R(c)||[];let R,O=0;do{if(R=`${y}/${O}:${u}`,l||!this.i.has(R)||d===R)break;O++}while(O<=p.length);return R}hb(t){if(t.iconPath&&!(t.iconPath instanceof P.$GK))return typeof t.iconPath=="string"||L.URI.isUri(t.iconPath)?this.jb(t.iconPath):this.jb(t.iconPath.light)}ib(t){if(t.iconPath&&!(t.iconPath instanceof P.$GK)&&t.iconPath.dark)return this.jb(t.iconPath.dark)}jb(t){return L.URI.isUri(t)?t:L.URI.file(t)}kb(t,r){this.i.set(r.item.handle,t),this.j.set(t,r)}lb(t,r,s,i){this.i.delete(r.item.handle),this.j.delete(t),r.item.handle!==s.item.handle&&this.i.delete(s.item.handle),this.kb(t,r);const c=this.R(i)||[],l=c.filter(b=>b.item.handle===s.item.handle)[0];l&&c.splice(c.indexOf(l),1,r)}mb(t,r){r?(r.children||(r.children=[]),r.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}nb(t){if(t){const r=this.j.get(t);if(r){if(r.children)for(const s of r.children){const i=this.i.get(s.item.handle);i&&this.ob(i)}r.children=void 0}}else this.pb()}ob(t){const r=this.j.get(t);if(r){if(r.children)for(const s of r.children){const i=this.i.get(s.item.handle);i&&this.ob(i)}this.j.delete(t),this.i.delete(r.item.handle),r.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(t=>t.dispose()),this.j.clear()}dispose(){this.U.dispose(),this.pb(),this.F.$disposeTree(this.D)}}}),define(Se[279],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatSlashCommands.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageConfigurationAutoClosingPairs:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageConfigurationAutoClosingPairs.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalContextMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalContextMenu.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[280],De([1,0,218,8,40,130,104,42,25,279,133,135]),function(me,e,S,F,h,L,A,f,w,g,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PF=e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=void 0;const $=f.$Um.as(A.$Vm.JSONContribution);class k{constructor(D,t,r){this.a=D,this.b=t,this.c=r}d(D,t){this.a({type:D,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(D){this.d(h.default.Error,D)}warn(D){this.d(h.default.Warning,D)}info(D){this.d(h.default.Info,D)}}e.$KF=k;class C{static a(D){const t=new w.$Jl;for(let r=0,s=D.length;r<s;r++)t.add(D[r].description.identifier);return t}static compute(D,t){if(!D||!D.length)return new C(t,[]);if(!t||!t.length)return new C([],D);const r=this.a(D),s=this.a(t),i=t.filter(l=>!r.has(l.description.identifier)),c=D.filter(l=>!s.has(l.description.identifier));return new C(i,c)}constructor(D,t){this.added=D,this.removed=t}}e.$LF=C;class E{constructor(D,t){this.name=D,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(D){if(this.a!==null)throw new Error("Handler already set!");this.a=D,this.d()}acceptUsers(D){this.c=C.compute(this.b,D),this.b=D,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(D){(0,F.$Y)(D)}}}e.$MF=E;const n={type:"string",enum:["ui","workspace"],enumDescriptions:[S.localize(0,null),S.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$NF={properties:{engines:{type:"object",description:S.localize(2,null),properties:{vscode:{type:"string",description:S.localize(3,null),default:"^1.22.0"}}},publisher:{description:S.localize(4,null),type:"string"},displayName:{description:S.localize(5,null),type:"string"},categories:{description:S.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:w.$Hl},{type:"string",const:"Languages",deprecationMessage:S.localize(7,null)}]}},galleryBanner:{type:"object",description:S.localize(8,null),properties:{color:{description:S.localize(9,null),type:"string"},theme:{description:S.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:S.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:S.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:S.localize(13,null)},enabledApiProposals:{markdownDescription:S.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:S.localize(15,null),type:"string",enum:["none"],enumDescriptions:[S.localize(16,null)]},activationEvents:{description:S.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:S.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:S.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:S.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:S.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:S.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:S.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:S.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:S.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:S.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:S.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:S.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:S.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:S.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:S.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:S.localize(32,null)},{label:"onUri",body:"onUri",description:S.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:S.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:S.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:S.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:S.localize(37,null)},{label:"onRenderer",description:S.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:S.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:S.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:S.localize(41,null)},{label:"*",description:S.localize(42,null),body:"*"}]}},badges:{type:"array",description:S.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:S.localize(44,null)},href:{type:"string",description:S.localize(45,null)},description:{type:"string",description:S.localize(46,null)}}}},markdown:{type:"string",description:S.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:S.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:S.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$En}},extensionPack:{description:S.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$En}},extensionKind:{description:S.localize(51,null),type:"array",items:n,default:["workspace"],defaultSnippets:[{body:["ui"],description:S.localize(52,null)},{body:["workspace"],description:S.localize(53,null)},{body:["ui","workspace"],description:S.localize(54,null)},{body:["workspace","ui"],description:S.localize(55,null)},{body:[],description:S.localize(56,null)}]},capabilities:{description:S.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:S.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:S.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(60,null),S.localize(61,null),S.localize(62,null)]},description:{type:"string",markdownDescription:S.localize(63,null)}}},untrustedWorkspaces:{description:S.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:S.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(66,null),S.localize(67,null),S.localize(68,null)]},restrictedConfigurations:{description:S.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:S.localize(70,null)}}}}},sponsor:{description:S.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:S.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:S.localize(73,null),type:"string"},"vscode:uninstall":{description:S.localize(74,null),type:"string"}}},icon:{type:"string",description:S.localize(75,null)},l10n:{type:"string",description:S.localize(76,null)},pricing:{type:"string",markdownDescription:S.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class a{constructor(){this.a=new Map}registerExtensionPoint(D){if(this.a.has(D.extensionPoint))throw new Error("Duplicate extension point: "+D.extensionPoint);const t=new E(D.extensionPoint,D.defaultExtensionKind);return this.a.set(D.extensionPoint,t),D.activationEventsGenerator&&I.$pF.register(D.extensionPoint,D.activationEventsGenerator),e.$NF.properties.contributes.properties[D.extensionPoint]=D.jsonSchema,$.registerSchema(o,e.$NF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$OF=a;const m={ExtensionsRegistry:"ExtensionsRegistry"};f.$Um.add(m.ExtensionsRegistry,new a),e.$PF=f.$Um.as(m.ExtensionsRegistry),$.registerSchema(o,e.$NF),$.registerSchema(P.$$i,{properties:{extensionEnabledApiProposals:{description:S.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(Se[281],De([1,0,215,19,23,280,47,4]),function(me,e,S,F,h,L,A,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YF=void 0;const w={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:S.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:S.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:S.localize(2,null),default:""}}};var g;(function($){function k(C,E,n){if(!C)return;const o=F.$ie(C.type)?C.type:void 0;if(!o||o.length===0){n.error(S.localize(3,null));return}const a=[];if(Array.isArray(C.required))for(const m of C.required)F.$ie(m)&&a.push(m);return{extensionId:E.value,taskType:o,required:a,properties:C.properties?h.$Im(C.properties):{},when:C.when?A.$vi.deserialize(C.when):void 0}}$.from=k})(g||(g={}));const P=L.$PF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:($,k)=>{for(const C of $)C.type&&k.push(`onTaskType:${C.type}`)},jsonSchema:{description:S.localize(4,null),type:"array",items:w}});class I{constructor(){this.d=new f.$ec,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((k,C)=>{P.setHandler((E,n)=>{this.c=void 0;try{for(const o of n.removed){const a=o.value;for(const m of a)this.a&&m.type&&this.a[m.type]&&delete this.a[m.type]}for(const o of n.added){const a=o.value;for(const m of a){const v=g.from(m,o.description.identifier,o.collector);v&&(this.a[v.taskType]=v)}}(n.removed.length>0||n.added.length>0)&&this.d.fire()}catch{}k(void 0)})})}onReady(){return this.b}get(k){return this.a[k]}all(){return Object.keys(this.a).map(k=>this.a[k])}getJsonSchema(){if(this.c===void 0){const k=[];for(const C of this.all()){const E={type:"object",additionalProperties:!1};C.required.length>0&&(E.required=C.required.slice(0)),C.properties!==void 0?E.properties=h.$Im(C.properties):E.properties=Object.create(null),E.properties.type={type:"string",enum:[C.taskType]},k.push(E)}this.c={oneOf:k}}return this.c}}e.$YF=new I}),define(Se[282],De([1,0,216,19,24,23,47,281]),function(me,e,S,F,h,L,A,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$9F=e.JsonSchemaVersion=e.ExecutionEngine=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$3F=e.ShellQuoting=e.$2F=e.$1F=e.$ZF=void 0,e.$ZF="settings",e.$1F=new A.$Oi("taskRunning",!1,S.localize(0,null)),e.$2F={value:S.localize(1,null),original:"Tasks"};var w;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(w||(e.ShellQuoting=w={})),e.$3F="$customized",function(B){function M(Y){if(!Y)return B.Strong;switch(Y.toLowerCase()){case"escape":return B.Escape;case"strong":return B.Strong;case"weak":return B.Weak;default:return B.Strong}}B.from=M}(w||(e.ShellQuoting=w={}));var g;(function(B){B.defaults={cwd:"${workspaceFolder}"}})(g||(e.CommandOptions=g={}));var P;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(P||(e.RevealKind=P={})),function(B){function M(Y){switch(Y.toLowerCase()){case"always":return B.Always;case"silent":return B.Silent;case"never":return B.Never;default:return B.Always}}B.fromString=M}(P||(e.RevealKind=P={}));var I;(function(B){B[B.Never=1]="Never",B[B.OnProblem=2]="OnProblem",B[B.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(B){function M(Y){switch(Y.toLowerCase()){case"always":return B.Always;case"never":return B.Never;case"onproblem":return B.OnProblem;default:return B.OnProblem}}B.fromString=M}(I||(e.RevealProblemKind=I={}));var $;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})($||(e.PanelKind=$={})),function(B){function M(Y){switch(Y.toLowerCase()){case"shared":return B.Shared;case"dedicated":return B.Dedicated;case"new":return B.New;default:return B.Shared}}B.fromString=M}($||(e.PanelKind=$={}));var k;(function(B){B.defaults={echo:!0,reveal:P.Always,revealProblems:I.Never,focus:!1,panel:$.Shared,showReuseMessage:!0,clear:!1}})(k||(e.PresentationOptions=k={}));var C;(function(B){B[B.Shell=1]="Shell",B[B.Process=2]="Process",B[B.CustomExecution=3]="CustomExecution"})(C||(e.RuntimeType=C={})),function(B){function M(J){switch(J.toLowerCase()){case"shell":return B.Shell;case"process":return B.Process;case"customExecution":return B.CustomExecution;default:return B.Process}}B.fromString=M;function Y(J){switch(J){case B.Shell:return"shell";case B.Process:return"process";case B.CustomExecution:return"customExecution";default:return"process"}}B.toString=Y}(C||(e.RuntimeType=C={}));var E;(function(B){function M(Y){return F.$ie(Y)?Y:Y.value}B.value=M})(E||(e.CommandString=E={}));var n;(function(B){B.Clean={_id:"clean",isDefault:!1},B.Build={_id:"build",isDefault:!1},B.Rebuild={_id:"rebuild",isDefault:!1},B.Test={_id:"test",isDefault:!1};function M(J){return J===B.Clean._id||J===B.Build._id||J===B.Rebuild._id||J===B.Test._id}B.is=M;function Y(J){if(J!==void 0)return F.$ie(J)?M(J)?{_id:J,isDefault:!1}:void 0:J}B.from=Y})(n||(e.TaskGroup=n={}));var o;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var a;(function(B){B.Workspace="workspace",B.Extension="extension",B.InMemory="inMemory",B.WorkspaceFile="workspaceFile",B.User="user";function M(Y){switch(Y){case B.User:return 2;case B.WorkspaceFile:return 5;default:return 6}}B.toConfigurationTarget=M})(a||(e.TaskSourceKind=a={}));var m;(function(B){B.parallel="parallel",B.sequence="sequence"})(m||(e.DependsOrder=m={}));var v;(function(B){B[B.default=1]="default",B[B.folderOpen=2]="folderOpen"})(v||(e.RunOnOptions=v={}));var D;(function(B){B.defaults={reevaluateOnRerun:!0,runOn:v.default,instanceLimit:1}})(D||(e.RunOptions=D={}));class t{constructor(M,Y,J,fe,se,ie){this._label="",this._id=M,Y&&(this._label=Y),J&&(this.type=J),this.runOptions=fe,this.configurationProperties=se,this._source=ie}getDefinition(M){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const M={folder:this.d(),id:this._id};return JSON.stringify(M)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(M,Y=!1){if(M===void 0)return!1;if(F.$ie(M))return M===this._label||M===this.configurationProperties.identifier||Y&&M===this._id;const J=this.getDefinition(!0);return J!==void 0&&J._key===M._key}getQualifiedLabel(){const M=this.getWorkspaceFolder();return M?`${this._label} (${M.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(M){this.c===void 0&&(this.c=[]),M&&(this.c=this.c.concat(M))}get taskLoadMessages(){return this.c}}e.$4F=t;class r extends t{constructor(M,Y,J,fe,se,ie,V,re){super(M,J,void 0,V,re,Y),this.command={},this._source=Y,this.hasDefinedMatchers=ie,se&&(this.command=se)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(M=!1){if(M&&this._source.customizes!==void 0)return this._source.customizes;{let Y;switch(this.command?this.command.runtime:void 0){case C.Shell:Y="shell";break;case C.Process:Y="process";break;case C.CustomExecution:Y="customExecution";break;case void 0:Y="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:Y,_key:this._id,id:this._id}}}static is(M){return M instanceof r}getMapKey(){const M=this._source.config.workspaceFolder;return M?`${M.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===a.User?e.$ZF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const M=this.d();if(!M)return;let Y=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(Y+=this._source.kind);const J={type:e.$3F,folder:M,id:Y};return JSON.stringify(J)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?h.$6f(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(M){return new r(M._id,M._source,M._label,M.type,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.$5F=r;class s extends t{constructor(M,Y,J,fe,se,ie,V){super(M,J,fe,ie,V,Y),this._source=Y,this.configures=se}static is(M){return M instanceof s}f(M){return M}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?h.$6f(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===a.User?e.$ZF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const M=this.d();if(!M)return;let Y=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(Y+=this._source.kind);const J={type:e.$3F,folder:M,id:Y};return JSON.stringify(J)}}e.$6F=s;class i extends t{constructor(M,Y,J,fe,se,ie,V,re,pe){super(M,J,fe,re,pe,Y),this.defines=se,this.hasDefinedMatchers=V,this.command=ie,this.icon=pe.icon,this.hide=pe.hide}clone(){return new i(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(M){return M instanceof i}getMapKey(){const M=this._source.workspaceFolder;return M?`${this._source.scope.toString()}|${M.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const M={type:"contributed",scope:this._source.scope,id:this._id};return M.folder=this.d(),JSON.stringify(M)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(M){return new i(M._id,M._source,M._label,M.type,M.defines,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.$7F=i;class c extends t{constructor(M,Y,J,fe,se,ie){super(M,J,fe,se,ie,Y),this._source=Y}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(M){return M instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(M){return new c(M._id,M._source,M._label,M.type,M.runOptions,M.configurationProperties)}}e.$8F=c;var l;(function(B){B[B.Process=1]="Process",B[B.Terminal=2]="Terminal"})(l||(e.ExecutionEngine=l={})),function(B){B._default=B.Terminal}(l||(e.ExecutionEngine=l={}));var b;(function(B){B[B.V0_1_0=1]="V0_1_0",B[B.V2_0_0=2]="V2_0_0"})(b||(e.JsonSchemaVersion=b={}));class y{constructor(M){this.c=new Map;for(let Y=0;Y<M.length;Y++)this.c.set(M[Y].uri.toString(),Y)}compare(M,Y){const J=M.getWorkspaceFolder(),fe=Y.getWorkspaceFolder();if(J&&fe){let se=this.c.get(J.uri.toString());se=se===void 0?0:se+1;let ie=this.c.get(fe.uri.toString());return ie=ie===void 0?0:ie+1,se===ie?M._label.localeCompare(Y._label):se-ie}else return!J&&fe?-1:J&&!fe?1:0}}e.$9F=y;var u;(function(B){B.DependsOnStarted="dependsOnStarted",B.AcquiredInput="acquiredInput",B.Start="start",B.ProcessStarted="processStarted",B.Active="active",B.Inactive="inactive",B.Changed="changed",B.Terminated="terminated",B.ProcessEnded="processEnded",B.End="end"})(u||(e.TaskEventKind=u={}));var d;(function(B){B.SingleRun="singleRun",B.Background="background"})(d||(e.TaskRunType=d={}));var p;(function(B){B[B.System=0]="System",B[B.User=1]="User",B[B.FolderOpen=2]="FolderOpen",B[B.ConfigurationChange=3]="ConfigurationChange",B[B.Reconnect=4]="Reconnect"})(p||(e.TaskRunSource=p={}));var R;(function(B){function M(Y,J,fe,se){if(J){const ie={kind:Y,taskId:J._id,taskName:J.configurationProperties.name,runType:J.configurationProperties.isBackground?"background":"singleRun",group:J.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:fe,__task:J};return Y==="start"?ie.resolvedVariables=se:Y==="processStarted"?ie.processId=se:Y==="processEnded"&&(ie.exitCode=se),Object.freeze(ie)}else return Object.freeze({kind:"changed"})}B.create=M})(R||(e.TaskEvent=R={}));var O;(function(B){function M(J){const fe=Object.keys(J).sort();let se="";for(const ie of fe){let V=J[ie];V instanceof Object?V=M(V):typeof V=="string"&&(V=V.replace(/,/g,",,")),se+=ie+","+V+","}return se}function Y(J){const se={_key:M(J),type:J.taskType};return Object.assign(se,J),se}B.create=Y})(O||(e.KeyedTaskIdentifier=O={}));var j;(function(B){B.AutoDetect="task.autoDetect",B.SaveBeforeRun="task.saveBeforeRun",B.ShowDecorations="task.showDecorations",B.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",B.SlowProviderWarning="task.slowProviderWarning",B.QuickOpenHistory="task.quickOpen.history",B.QuickOpenDetail="task.quickOpen.detail",B.QuickOpenSkip="task.quickOpen.skip",B.QuickOpenShowAll="task.quickOpen.showAll",B.AllowAutomaticTasks="task.allowAutomaticTasks",B.Reconnection="task.reconnection"})(j||(e.TaskSettingId=j={}));var T;(function(B){B.Tasks="tasks",B.SuppressTaskName="tasks.suppressTaskName",B.Windows="tasks.windows",B.Osx="tasks.osx",B.Linux="tasks.linux",B.ShowOutput="tasks.showOutput",B.IsShellCommand="tasks.isShellCommand",B.ServiceTestSetting="tasks.service.testSetting"})(T||(e.TasksSchemaProperties=T={}));var z;(function(B){function M(Y,J){const fe=f.$YF.get(Y.type);if(fe===void 0){const re=L.$Im(Y);return delete re._key,O.create(re)}const se=Object.create(null);se.type=fe.taskType;const ie=new Set;fe.required.forEach(re=>ie.add(re));const V=fe.properties;for(const re of Object.keys(V)){const pe=Y[re];if(pe!=null)se[re]=pe;else if(ie.has(re)){const ae=V[re];if(ae.default!==void 0)se[re]=L.$Im(ae.default);else switch(ae.type){case"boolean":se[re]=!1;break;case"number":case"integer":se[re]=0;break;case"string":se[re]="";break;default:J.error(S.localize(2,null,JSON.stringify(Y,void 0,0),re));return}}}return O.create(se)}B.createTaskIdentifier=M})(z||(e.TaskDefinition=z={}))}),define(Se[283],De([1,0,8]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U2b=e.$T2b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,f)=>{this.b=A,this.d=f,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,S.$Y)(A))}then(A,f){return this.j().then(A,f)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$T2b=F;class h extends F{constructor(){super(),this.h=!0,this.i=new S.$3}}e.$U2b=h}),define(Se[64],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5z=e.$4z=e.$3z=e.$2z=void 0;class S{static{this.count=0}constructor(w){this._proxyIdentifierBrand=void 0,this.sid=w,this.nid=++S.count}}e.$2z=S;const F=[];function h(f){const w=new S(f);return F[w.nid]=w,w}e.$3z=h;function L(f){return F[f].sid}e.$4z=L;class A{constructor(w){this.value=w}}e.$5z=A}),define(Se[5],De([1,0,64]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KJ=e.$JJ=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$IJ=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(E){E[E.Default=0]="Default",E[E.InCenter=1]="InCenter",E[E.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",E[E.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var h;(function(E){E[E.UnknownInput=0]="UnknownInput",E[E.TextInput=1]="TextInput",E[E.TextDiffInput=2]="TextDiffInput",E[E.TextMergeInput=3]="TextMergeInput",E[E.NotebookInput=4]="NotebookInput",E[E.NotebookDiffInput=5]="NotebookDiffInput",E[E.CustomEditorInput=6]="CustomEditorInput",E[E.WebviewEditorInput=7]="WebviewEditorInput",E[E.TerminalEditorInput=8]="TerminalEditorInput",E[E.InteractiveEditorInput=9]="InteractiveEditorInput"})(h||(e.TabInputKind=h={}));var L;(function(E){E[E.TAB_OPEN=0]="TAB_OPEN",E[E.TAB_CLOSE=1]="TAB_CLOSE",E[E.TAB_UPDATE=2]="TAB_UPDATE",E[E.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var A;(function(E){E[E.Editable=0]="Editable",E[E.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var f;(function(E){E[E.Int8Array=1]="Int8Array",E[E.Uint8Array=2]="Uint8Array",E[E.Uint8ClampedArray=3]="Uint8ClampedArray",E[E.Int16Array=4]="Int16Array",E[E.Uint16Array=5]="Uint16Array",E[E.Int32Array=6]="Int32Array",E[E.Uint32Array=7]="Uint32Array",E[E.Float32Array=8]="Float32Array",E[E.Float64Array=9]="Float64Array",E[E.BigInt64Array=10]="BigInt64Array",E[E.BigUint64Array=11]="BigUint64Array"})(f||(e.WebviewMessageArrayBufferViewType=f={}));var w;(function(E){E[E.Text=1]="Text",E[E.Error=2]="Error",E[E.Rich=3]="Rich"})(w||(e.CellOutputKind=w={}));var g;(function(E){E[E.Default=0]="Default",E[E.InCenter=1]="InCenter",E[E.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",E[E.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var P;(function(E){E[E.None=0]="None",E[E.Process=1]="Process",E[E.Output=2]="Output"})(P||(e.CandidatePortSource=P={}));class I{static{this.a=0}static mixin(n){return n._id=I.a++,n}}e.$IJ=I;var $;(function(E){E.label="a",E.kind="b",E.detail="c",E.documentation="d",E.sortText="e",E.filterText="f",E.preselect="g",E.insertText="h",E.insertTextRules="i",E.range="j",E.commitCharacters="k",E.additionalTextEdits="l",E.kindModifier="m",E.commandIdent="n",E.commandId="o",E.commandArguments="p"})($||(e.ISuggestDataDtoField=$={}));var k;(function(E){E.defaultRanges="a",E.completions="b",E.isIncomplete="c",E.duration="d"})(k||(e.ISuggestResultDtoField=k={}));var C;(function(E){E[E.Workspace=0]="Workspace",E[E.TextDocument=1]="TextDocument"})(C||(e.ExtHostTestingResource=C={})),e.$JJ={MainThreadAuthentication:(0,S.$3z)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.$3z)("MainThreadBulkEdits"),MainThreadChatProvider:(0,S.$3z)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,S.$3z)("MainThreadChatSlashCommands"),MainThreadChatVariables:(0,S.$3z)("MainThreadChatVariables"),MainThreadClipboard:(0,S.$3z)("MainThreadClipboard"),MainThreadCommands:(0,S.$3z)("MainThreadCommands"),MainThreadComments:(0,S.$3z)("MainThreadComments"),MainThreadConfiguration:(0,S.$3z)("MainThreadConfiguration"),MainThreadConsole:(0,S.$3z)("MainThreadConsole"),MainThreadDebugService:(0,S.$3z)("MainThreadDebugService"),MainThreadDecorations:(0,S.$3z)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.$3z)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.$3z)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.$3z)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.$3z)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.$3z)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.$3z)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.$3z)("MainThreadEditorTabs"),MainThreadErrors:(0,S.$3z)("MainThreadErrors"),MainThreadTreeViews:(0,S.$3z)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.$3z)("MainThreadDownloadService"),MainThreadKeytar:(0,S.$3z)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,S.$3z)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.$3z)("MainThreadLanguages"),MainThreadLogger:(0,S.$3z)("MainThreadLogger"),MainThreadMessageService:(0,S.$3z)("MainThreadMessageService"),MainThreadOutputService:(0,S.$3z)("MainThreadOutputService"),MainThreadProgress:(0,S.$3z)("MainThreadProgress"),MainThreadQuickDiff:(0,S.$3z)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,S.$3z)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.$3z)("MainThreadStatusBar"),MainThreadSecretState:(0,S.$3z)("MainThreadSecretState"),MainThreadStorage:(0,S.$3z)("MainThreadStorage"),MainThreadTelemetry:(0,S.$3z)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.$3z)("MainThreadTerminalService"),MainThreadWebviews:(0,S.$3z)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.$3z)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.$3z)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.$3z)("MainThreadCustomEditors"),MainThreadUrls:(0,S.$3z)("MainThreadUrls"),MainThreadUriOpeners:(0,S.$3z)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,S.$3z)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,S.$3z)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.$3z)("MainThreadFileSystem"),MainThreadExtensionService:(0,S.$3z)("MainThreadExtensionService"),MainThreadSCM:(0,S.$3z)("MainThreadSCM"),MainThreadSearch:(0,S.$3z)("MainThreadSearch"),MainThreadShare:(0,S.$3z)("MainThreadShare"),MainThreadTask:(0,S.$3z)("MainThreadTask"),MainThreadWindow:(0,S.$3z)("MainThreadWindow"),MainThreadLabelService:(0,S.$3z)("MainThreadLabelService"),MainThreadNotebook:(0,S.$3z)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.$3z)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.$3z)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.$3z)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.$3z)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.$3z)("MainThreadInteractive"),MainThreadChat:(0,S.$3z)("MainThreadChat"),MainThreadInlineChat:(0,S.$3z)("MainThreadInlineChatShape"),MainThreadTheming:(0,S.$3z)("MainThreadTheming"),MainThreadTunnelService:(0,S.$3z)("MainThreadTunnelService"),MainThreadManagedSockets:(0,S.$3z)("MainThreadManagedSockets"),MainThreadTimeline:(0,S.$3z)("MainThreadTimeline"),MainThreadTesting:(0,S.$3z)("MainThreadTesting"),MainThreadLocalization:(0,S.$3z)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,S.$3z)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,S.$3z)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,S.$3z)("MainThreadIssueReporter")},e.$KJ={ExtHostCommands:(0,S.$3z)("ExtHostCommands"),ExtHostConfiguration:(0,S.$3z)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.$3z)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.$3z)("ExtHostDebugService"),ExtHostDecorations:(0,S.$3z)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.$3z)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.$3z)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.$3z)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.$3z)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.$3z)("ExtHostEditors"),ExtHostTreeViews:(0,S.$3z)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.$3z)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.$3z)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.$3z)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,S.$3z)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,S.$3z)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.$3z)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,S.$3z)("ExtHostQuickDiff"),ExtHostStatusBar:(0,S.$3z)("ExtHostStatusBar"),ExtHostShare:(0,S.$3z)("ExtHostShare"),ExtHostExtensionService:(0,S.$3z)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,S.$3z)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,S.$3z)("ExtHostTerminalService"),ExtHostSCM:(0,S.$3z)("ExtHostSCM"),ExtHostSearch:(0,S.$3z)("ExtHostSearch"),ExtHostTask:(0,S.$3z)("ExtHostTask"),ExtHostWorkspace:(0,S.$3z)("ExtHostWorkspace"),ExtHostWindow:(0,S.$3z)("ExtHostWindow"),ExtHostWebviews:(0,S.$3z)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.$3z)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.$3z)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.$3z)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.$3z)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.$3z)("ExtHostEditorTabs"),ExtHostProgress:(0,S.$3z)("ExtHostProgress"),ExtHostComments:(0,S.$3z)("ExtHostComments"),ExtHostSecretState:(0,S.$3z)("ExtHostSecretState"),ExtHostStorage:(0,S.$3z)("ExtHostStorage"),ExtHostUrls:(0,S.$3z)("ExtHostUrls"),ExtHostUriOpeners:(0,S.$3z)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,S.$3z)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,S.$3z)("ExtHostOutputService"),ExtHosLabelService:(0,S.$3z)("ExtHostLabelService"),ExtHostNotebook:(0,S.$3z)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.$3z)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.$3z)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.$3z)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.$3z)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,S.$3z)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,S.$3z)("ExtHostInteractive"),ExtHostInlineChat:(0,S.$3z)("ExtHostInlineChatShape"),ExtHostChat:(0,S.$3z)("ExtHostChat"),ExtHostChatSlashCommands:(0,S.$3z)("ExtHostChatSlashCommands"),ExtHostChatVariables:(0,S.$3z)("ExtHostChatVariables"),ExtHostChatProvider:(0,S.$3z)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,S.$3z)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,S.$3z)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,S.$3z)("ExtHostTheming"),ExtHostTunnelService:(0,S.$3z)("ExtHostTunnelService"),ExtHostManagedSockets:(0,S.$3z)("ExtHostManagedSockets"),ExtHostAuthentication:(0,S.$3z)("ExtHostAuthentication"),ExtHostTimeline:(0,S.$3z)("ExtHostTimeline"),ExtHostTesting:(0,S.$3z)("ExtHostTesting"),ExtHostTelemetry:(0,S.$3z)("ExtHostTelemetry"),ExtHostLocalization:(0,S.$3z)("ExtHostLocalization"),ExtHostIssueReporter:(0,S.$3z)("ExtHostIssueReporter")}}),define(Se[284],De([1,0,5,7]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=void 0;class h{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(S.$JJ.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,f,w){if(this.a.size===0)throw new Error("No related information providers registered");const g=this.a.get(A);if(!g)throw new Error("related information provider not found");return await g.provideRelatedInformation(f,w)??[]}getRelatedInformation(A,f,w){return this.c.$getAiRelatedInformation(f,w)}registerRelatedInformationProvider(A,f,w){const g=this.b;return this.b++,this.a.set(g,w),this.c.$registerAiRelatedInformationProvider(g,f),new F.$LJ(()=>{this.c.$unregisterAiRelatedInformationProvider(g),this.a.delete(g)})}}e.$ncc=h}),define(Se[89],De([1,0,6,17,5,20]),function(me,e,S,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rac=e.$qac=e.$pac=void 0,e.$pac=(0,S.$ph)("IExtHostApiDeprecationService");let A=class{constructor(w,g){this.c=g,this.a=new Set,this.b=w.getProxy(h.$JJ.MainThreadTelemetry)}report(w,g,P){const I=this.d(w,g);this.a.has(I)||(this.a.add(I),g.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${w}' is deprecated. ${P}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:w}))}d(w,g){return`${w}-${g.identifier.value}`}};e.$qac=A,e.$qac=A=Je([Be(0,L.$LL),Be(1,F.$Ri)],A),e.$rac=Object.freeze(new class{report(f,w,g){}})}),define(Se[285],De([1,0,4,5,7,25]),function(me,e,S,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xbc=void 0;class A{constructor(g){this.b=new Map,this.c=[],this.d=new S.$ec,this.onDidChangeSessions=this.d.event,this.f=new f,this.g=new f,this.a=g.getProxy(F.$JJ.MainThreadAuthentication)}$setProviders(g){return this.c=g,Promise.resolve()}async getSession(g,P,I,$={}){const k=L.$Il.toKey(g.identifier),C=[...I].sort().join(" ");return await this.f.getOrCreate(`${k} ${P} ${C}`,async()=>{await this.a.$ensureProvider(P);const E=g.displayName||g.name;return this.a.$getSession(P,I,k,E,$)})}async getSessions(g,P,I){const $=L.$Il.toKey(g.identifier),k=[...I].sort().join(" ");return await this.g.getOrCreate(`${$} ${k}`,async()=>{await this.a.$ensureProvider(P);const C=g.displayName||g.name;return this.a.$getSessions(P,I,$,C)})}async removeSession(g,P){const I=this.b.get(g);return I?I.provider.removeSession(P):this.a.$removeSession(g,P)}registerAuthenticationProvider(g,P,I,$){if(this.b.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this.b.set(g,{label:P,provider:I,options:$??{supportsMultipleAccounts:!1}}),this.c.find(C=>C.id===g)||this.c.push({id:g,label:P});const k=I.onDidChangeSessions(C=>{this.a.$sendDidChangeSessions(g,{added:C.added??[],changed:C.changed??[],removed:C.removed??[]})});return this.a.$registerAuthenticationProvider(g,P,$?.supportsMultipleAccounts??!1),new h.$LJ(()=>{k.dispose(),this.b.delete(g);const C=this.c.findIndex(E=>E.id===g);C>-1&&this.c.splice(C),this.a.$unregisterAuthenticationProvider(g)})}$createSession(g,P,I){const $=this.b.get(g);if($)return Promise.resolve($.provider.createSession(P,I));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$removeSession(g,P){const I=this.b.get(g);if(I)return Promise.resolve(I.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$getSessions(g,P){const I=this.b.get(g);if(I)return Promise.resolve(I.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,P){return this.d.fire({provider:{id:g,label:P}}),Promise.resolve()}}e.$Xbc=A;class f{constructor(){this.a=new Map}getOrCreate(g,P){const I=this.a.get(g);if(I)return I;const $=P().finally(()=>this.a.delete(g));return this.a.set(g,$),$}}}),define(Se[286],De([1,0,5,20,10]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bc=void 0;let L=class{constructor(f,w){this.a=f.getProxy(S.$JJ.MainThreadBulkEdits),this.b={getTextDocumentVersion:g=>w.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(f,w,g){const P=h.WorkspaceEdit.from(f,this.b);return this.a.$tryApplyWorkspaceEdit(P,void 0,g?.isRefactoring??!1)}};e.$4bc=L,e.$4bc=L=Je([Be(0,F.$LL)],L)}),define(Se[287],De([1,0,13,4,48,3,37,196,5,10]),function(me,e,S,F,h,L,A,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=void 0;class P{static{this.a=0}constructor(k,C){this.extension=k,this.provider=C,this.handle=P.a++}}class I{static{this.a=0}constructor(k,C){this.h=C,this.b=new Map,this.d=new Map,this.e=new F.$ec,this.onDidPerformUserAction=this.e.event,this.g=k.getProxy(w.$JJ.MainThreadChat)}registerChatProvider(k,C,E){const n=new P(k,E);return this.b.set(n.handle,n),this.g.$registerChatProvider(n.handle,C),(0,L.$jb)(()=>{this.g.$unregisterChatProvider(n.handle),this.b.delete(n.handle)})}transferChatSession(k,C){const E=h.Iterable.find(this.d.keys(),n=>this.d.get(n)===k)??0;typeof E=="number"&&this.g.$transferChatSession(E,C)}addChatRequest(k){this.g.$addRequest(k)}sendInteractiveRequestToProvider(k,C){this.g.$sendRequestToProvider(k,C)}async $prepareChat(k,C,E){const n=this.b.get(k);if(!n)return;const o=await n.provider.prepareSession(C,E);if(!o)return;const a=I.a++;return this.d.set(a,o),{id:a,requesterUsername:o.requester?.name,requesterAvatarIconUri:o.requester?.icon,responderUsername:o.responder?.name,responderAvatarIconUri:o.responder?.icon,inputPlaceholder:o.inputPlaceholder}}async $resolveRequest(k,C,E,n){const o=this.b.get(k);if(!o)return;const a=this.d.get(C);if(!a||!o.provider.resolveRequest)return;const m=await o.provider.resolveRequest(a,E,n);if(m)return{message:typeof m.message=="string"?m.message:g.ChatReplyFollowup.from(m.message)}}async $provideWelcomeMessage(k,C){const E=this.b.get(k);if(!E||!E.provider.provideWelcomeMessage)return;const n=await E.provider.provideWelcomeMessage(C);if(n)return n.map(o=>typeof o=="string"?o:o.map(a=>g.ChatReplyFollowup.from(a)))}async $provideFollowups(k,C,E){const n=this.b.get(k);if(!n)return;const o=this.d.get(C);return!o||!n.provider.provideFollowups?void 0:(await n.provider.provideFollowups(o,E))?.map(m=>g.ChatFollowup.from(m))}$removeRequest(k,C,E){const n=this.b.get(k);if(!n)return;const o=this.d.get(C);o&&n.provider.removeRequest&&n.provider.removeRequest(o,E)}async $provideReply(k,C,E,n){const o=this.b.get(k);if(!o)return;const a=this.d.get(C);if(!a)return;const m={session:a,message:typeof E.message=="string"?E.message:g.ChatReplyFollowup.to(E.message),variables:{}};if(E.variables)for(const i of Object.keys(E.variables))m.variables[i]=E.variables[i].map(g.ChatVariable.to);const v=A.$ac.create(!1);let D;const t={report:i=>{if(!n.isCancellationRequested)if(typeof D>"u"&&(D=v.elapsed()),"responseId"in i)this.g.$acceptResponseProgress(k,C,{requestId:i.responseId});else if("placeholder"in i&&"resolvedContent"in i){const c=Promise.all([this.g.$acceptResponseProgress(k,C,{placeholder:i.placeholder}),i.resolvedContent]);(0,S.$jg)(c,n).then(l=>{if(!l)return;const[b,y]=l;this.g.$acceptResponseProgress(k,C,y,b??void 0)})}else"content"in i?this.g.$acceptResponseProgress(k,C,{content:typeof i.content=="string"?i.content:g.MarkdownString.from(i.content)}):this.g.$acceptResponseProgress(k,C,i)}};let r;try{r=await o.provider.provideResponseWithProgress(m,t,n),r||(r={errorDetails:{message:(0,f.localize)(0,null)}})}catch(i){r={errorDetails:{message:(0,f.localize)(1,null,i.message),responseIsIncomplete:!0}},this.h.error(i)}try{if(a.saveState&&this.d.has(C)){const i=a.saveState();this.g.$acceptChatState(C,i)}}catch(i){this.h.warn(i)}const s={firstProgress:D??0,totalElapsed:v.elapsed()};return{errorDetails:r.errorDetails,timings:s}}async $provideSlashCommands(k,C,E){const n=this.b.get(k);if(!n)return;const o=this.d.get(C);return!o||!n.provider.provideSlashCommands?void 0:(await n.provider.provideSlashCommands(o,E))?.map(m=>({...m,kind:g.CompletionItemKind.from(m.kind)}))}$releaseSession(k){this.d.delete(k)}async $onDidPerformUserAction(k){this.e.fire(k)}}e.$fcc=I}),define(Se[288],De([1,0,3,5,10,83,25]),function(me,e,S,F,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=void 0;class f{static{this.a=1}constructor(g,P){this.d=P,this.c=new Map,this.e=new Map,this.f=new A.$Kl,this.b=g.getProxy(F.$JJ.MainThreadChatProvider)}registerProvider(g,P,I,$){const k=f.a++;return this.c.set(k,{extension:g,provider:I}),this.b.$registerProvider(k,P,{extension:g,displayName:$.name??g.value}),(0,S.$jb)(()=>{this.b.$unregisterProvider(k),this.c.delete(k)})}async $provideChatResponse(g,P,I,$,k){const C=this.c.get(g);if(!C)return;const E=new L.$Tu(async n=>{if(k.isCancellationRequested){this.d.warn(`[CHAT](${C.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(P,{index:n.index,part:n.part})},{async:!0});return C.provider.provideChatResponse(I.map(h.ChatMessage.to),$,E,k)}allowListExtensionWhile(g,P){this.f.set(g,P),P.finally(()=>this.f.delete(g))}async requestChatResponseProvider(g,P){if(!this.f.has(g))throw new Error("Extension is NOT allowed to make chat requests");const I=this;return{get isRevoked(){return!I.f.has(g)},async makeRequest($,k,C,E){if(!I.f.has(g))throw new Error("Access to chat has been revoked");const n=Math.random()*1e6|0;I.e.set(n,C);try{await I.b.$fetchResponse(g,P,n,$.map(h.ChatMessage.from),k,E)}finally{I.e.delete(n)}}}}async $handleResponseFragment(g,P){this.e.get(g)?.report(P)}}e.$kcc=f}),define(Se[289],De([1,0,3,5,7,10,83,13]),function(me,e,S,F,h,L,A,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=void 0;class w{static{this.a=0}constructor(P,I,$){this.d=I,this.e=$,this.b=new Map,this.c=P.getProxy(F.$JJ.MainThreadChatSlashCommands)}registerCommand(P,I,$,k){const C=w.a++;return this.b.set(C,{extension:P,command:$}),this.c.$registerCommand(C,I,k.description),(0,S.$jb)(()=>{this.c.$unregisterCommand(C),this.b.delete(C)})}async $executeCommand(P,I,$,k,C){const E=this.b.get(P);if(!E){this.e.warn(`[CHAT](${P}) CANNOT execute command because the command is not registered`);return}let n=!1;function o(){if(n)throw new Error("Only valid while executing the command")}const a=new f.$Pg;C.onCancellationRequested(()=>a.complete()),setTimeout(()=>a.complete(),3*1e3),this.d.allowListExtensionWhile(E.extension,a.p);const m=E.command({role:h.ChatMessageRole.User,content:$},{history:k.history.map(L.ChatMessage.to)},new A.$Tu(v=>{o(),this.c.$handleProgressChunk(I,{content:v.message.value})}),C);try{await(0,f.$jg)(Promise.resolve(m),C)}finally{n=!0,a.complete()}}}e.$lcc=w}),define(Se[290],De([1,0,3,5,8,10]),function(me,e,S,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=void 0;class A{static{this.a=0}constructor(w){this.b=new Map,this.c=w.getProxy(F.$JJ.MainThreadChatVariables)}async $resolveVariable(w,g,P){const I=this.b.get(w);if(I)try{const $=await I.resolver.resolve(I.data.name,{message:g},P);if($)return $.map(L.ChatVariable.from)}catch($){(0,h.$Z)($)}}registerVariableResolver(w,g,P,I){const $=A.a++;return this.b.set($,{extension:w.identifier,data:{name:g,description:P},resolver:I}),this.c.$registerVariable($,{name:g,description:P}),(0,S.$jb)(()=>{this.b.delete($),this.c.$unregisterVariable($)})}}e.$mcc=A}),define(Se[291],De([1,0,5]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uac=void 0;class F{constructor(L){const A=L.getProxy(S.$JJ.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(f){return A.$writeText(f)}})}}e.$uac=F}),define(Se[33],De([1,0,19,7,10,23,5,18,17,77,34,58,2,3,6,20,143,21,64,45,37,85,88]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E,n,o,a,m,v,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=void 0;let r=class{#e;#t;#i;constructor(y,u,d){this.b=new Map,this.c=new Map,this.#e=y.getProxy(A.$JJ.MainThreadCommands),this.d=u,this.#i=d,this.#t=y.getProxy(A.$JJ.MainThreadTelemetry),this.converter=new s(this,p=>{const R=this.c.get(p);return R?.result===c.Void?R:void 0},u),this.f=[{processArgument(p){return(0,g.$Yg)(p)}},{processArgument(p){return(0,L.$Km)(p,function(R){if(P.$Ur.isIRange(R))return h.Range.to(R);if(I.$Tr.isIPosition(R))return h.Position.to(R);if(P.$Ur.isIRange(R.range)&&$.URI.isUri(R.uri))return h.location.to(R);if(R instanceof o.$Ec)return R.buffer.buffer;if(!Array.isArray(R))return R})}}]}registerArgumentProcessor(y){this.f.push(y)}registerApiCommand(y){const u=this.registerCommand(!1,y.id,async(...d)=>{const p=y.args.map((O,j)=>{if(!O.validate(d[j]))throw new Error(`Invalid argument '${O.name}' when running '${y.id}', received: ${d[j]}`);return O.convert(d[j])}),R=await this.executeCommand(y.internalId,...p);return y.result.convert(R,d,this.converter)},void 0,{description:y.description,args:y.args,returns:y.result.description});return this.c.set(y.id,y),new F.$LJ(()=>{u.dispose(),this.c.delete(y.id)})}registerCommand(y,u,d,p,R,O){if(this.d.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this.b.has(u))throw new Error(`command '${u}' already exists`);return this.b.set(u,{callback:d,thisArg:p,description:R,extension:O}),y&&this.#e.$registerCommand(u),new F.$LJ(()=>{this.b.delete(u)&&y&&this.#e.$unregisterCommand(u)})}executeCommand(y,...u){return this.d.trace("ExtHostCommands#executeCommand",y),this.g(y,u,!0)}async g(y,u,d){if(this.b.has(y))return this.#e.$fireCommandActivationEvent(y),this.h(y,u,!1);{let p=!1;const R=(0,L.$Km)(u,function(O){if(O instanceof F.$MJ)return h.Position.from(O);if(O instanceof F.$NJ)return h.Range.from(O);if(O instanceof F.$XJ)return h.location.from(O);if(F.$0K.isNotebookRange(O))return h.NotebookRange.from(O);if(O instanceof ArrayBuffer)return p=!0,o.$Ec.wrap(new Uint8Array(O));if(O instanceof Uint8Array)return p=!0,o.$Ec.wrap(O);if(O instanceof o.$Ec)return p=!0,O;if(!Array.isArray(O))return O});try{const O=await this.#e.$executeCommand(y,p?new a.$5z(R):R,d);return(0,g.$Yg)(O)}catch(O){if(O instanceof Error&&O.message==="$executeCommand:retry")return this.g(y,u,!1);throw O}}}async h(y,u,d){const p=this.b.get(y);if(!p)throw new Error("Unknown command");const{callback:R,thisArg:O,description:j}=p;if(j)for(let z=0;z<j.args.length;z++)try{(0,S.$ze)(u[z],j.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${y}' failed. Illegal argument '${j.args[z].name}' - ${j.args[z].description}`)}const T=v.$ac.create();try{return await R.apply(O,u)}catch(z){if(y===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...u);B&&(y=B.command)}if(this.d.error(z,y,p.extension?.identifier),!d)throw z;if(p.extension?.identifier){const B=this.#i.onExtensionError(p.extension.identifier,z);this.d.trace("forwarded error to extension?",B,p.extension?.identifier)}throw new class extends Error{constructor(){super((0,m.$ai)(z)),this.id=y,this.source=p.extension?.displayName??p.extension?.name}}}finally{this.j(p,y,T.elapsed())}}j(y,u,d){y.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:y.extension.identifier.value,id:new D.$4n(u),duration:d})}$executeContributedCommand(y,...u){this.d.trace("ExtHostCommands#$executeContributedCommand",y);const d=this.b.get(y);return d?(u=u.map(p=>this.f.reduce((R,O)=>O.processArgument(R,d.extension?.identifier),p)),this.h(y,u,!0)):Promise.reject(new Error(`Contributed command '${y}' does not exist.`))}getCommands(y=!1){return this.d.trace("ExtHostCommands#getCommands",y),this.#e.$getCommands().then(u=>(y&&(u=u.filter(d=>d[0]!=="_")),u))}$getContributedCommandHandlerDescriptions(){const y=Object.create(null);for(const[u,d]of this.b){const{description:p}=d;p&&(y[u]=p)}return Promise.resolve(y)}};e.$7L=r,e.$7L=r=Je([Be(0,E.$LL),Be(1,w.$Ri),Be(2,t.$6L)],r),e.$8L=(0,C.$ph)("IExtHostCommands");class s{constructor(y,u,d){this.d=y,this.f=u,this.g=d,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(y,u){if(!y)return;const d={$ident:void 0,id:y.command,title:y.title,tooltip:y.tooltip};if(!y.command)return d;const p=this.f(y.command);if(p)d.id=p.internalId,d.arguments=p.args.map((R,O)=>R.convert(y.arguments&&y.arguments[O]));else if((0,f.$nf)(y.arguments)){const R=`${y.command}/${++this.c}`;this.b.set(R,y),u.add((0,k.$jb)(()=>{this.b.delete(R),this.g.trace("CommandsConverter#DISPOSE",R)})),d.$ident=R,d.id=this.delegatingCommandId,d.arguments=[R],this.g.trace("CommandsConverter#CREATE",y.command,R)}return d}fromInternal(y){return typeof y.$ident=="string"?this.b.get(y.$ident):{command:y.id,title:y.title,arguments:y.arguments}}getActualCommand(...y){return this.b.get(y[0])}h(...y){const u=this.getActualCommand(...y);return this.g.trace("CommandsConverter#EXECUTE",y[0],u?u.command:"MISSING"),u?this.d.executeCommand(u.command,...u.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${y[0]}`)}}e.$9L=s;class i{static{this.Uri=new i("uri","Uri of a text document",y=>$.URI.isUri(y),y=>y)}static{this.Position=new i("position","A position in a text document",y=>F.$MJ.isPosition(y),h.Position.from)}static{this.Range=new i("range","A range in a text document",y=>F.$NJ.isRange(y),h.Range.from)}static{this.Selection=new i("selection","A selection in a text document",y=>F.$OJ.isSelection(y),h.Selection.from)}static{this.Number=new i("number","",y=>typeof y=="number",y=>y)}static{this.String=new i("string","",y=>typeof y=="string",y=>y)}static{this.StringArray=i.Arr(i.String)}static Arr(y){return new i(`${y.name}_array`,`Array of ${y.name}, ${y.description}`,u=>Array.isArray(u)&&u.every(d=>y.validate(d)),u=>u.map(d=>y.convert(d)))}static{this.CallHierarchyItem=new i("item","A call hierarchy item",y=>y instanceof F.$9J,h.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new i("item","A type hierarchy item",y=>y instanceof F.$qL,h.TypeHierarchyItem.from)}static{this.TestItem=new i("testItem","A VS Code TestItem",y=>y instanceof n.$YL,h.TestItem.from)}constructor(y,u,d,p){this.name=y,this.description=u,this.validate=d,this.convert=p}optional(){return new i(this.name,`(optional) ${this.description}`,y=>y==null||this.validate(y),y=>y===void 0?void 0:y===null?null:this.convert(y))}with(y,u){return new i(y??this.name,u??this.description,this.validate,this.convert)}}e.$0L=i;class c{static{this.Void=new c("no result",y=>y)}constructor(y,u){this.description=y,this.convert=u}}e.$$L=c;class l{constructor(y,u,d,p,R){this.id=y,this.internalId=u,this.description=d,this.args=p,this.result=R}}e.$_L=l}),define(Se[292],De([1,0,18,16,2,81,128,47,132,33,10,7]),function(me,e,S,F,h,L,A,f,w,g,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tac=void 0;const $=[new g.$_L("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$0L.Uri,g.$0L.Position],new g.$$L("A promise that resolves to an array of DocumentHighlight-instances.",C(P.DocumentHighlight.to))),new g.$_L("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$0L.Uri],new g.$$L("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,o)=>{if((0,S.$mf)(n))return;class a extends I.$3J{static to(v){const D=new a(v.name,P.SymbolKind.to(v.kind),v.containerName||"",new I.$XJ(o[0],P.Range.to(v.range)));return D.detail=v.detail,D.range=D.location.range,D.selectionRange=P.Range.to(v.selectionRange),D.children=v.children?v.children.map(a.to):[],D}}return n.map(a.to)})),new g.$_L("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$0L.Uri,new g.$0L("options","Formatting options",n=>!0,n=>n)],new g.$$L("A promise that resolves to an array of TextEdits.",C(P.TextEdit.to))),new g.$_L("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$0L.Uri,g.$0L.Range,new g.$0L("options","Formatting options",n=>!0,n=>n)],new g.$$L("A promise that resolves to an array of TextEdits.",C(P.TextEdit.to))),new g.$_L("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$0L.Uri,g.$0L.Position,new g.$0L("ch","Trigger character",n=>typeof n=="string",n=>n),new g.$0L("options","Formatting options",n=>!0,n=>n)],new g.$$L("A promise that resolves to an array of TextEdits.",C(P.TextEdit.to))),new g.$_L("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$0L.Uri,g.$0L.Position],new g.$$L("A promise that resolves to an array of Location or LocationLink instances.",E)),new g.$_L("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$0L.Uri,g.$0L.Position],new g.$$L("A promise that resolves to an array of Location or LocationLink instances.",E)),new g.$_L("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$0L.Uri,g.$0L.Position],new g.$$L("A promise that resolves to an array of Location or LocationLink instances.",E)),new g.$_L("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$0L.Uri,g.$0L.Position],new g.$$L("A promise that resolves to an array of Location or LocationLink instances.",E)),new g.$_L("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$0L.Uri,g.$0L.Position],new g.$$L("A promise that resolves to an array of Location-instances.",C(P.location.to))),new g.$_L("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$0L.Uri,g.$0L.Position],new g.$$L("A promise that resolves to an array of Hover-instances.",C(P.Hover.to))),new g.$_L("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$0L.Uri,new g.$0L("position","A position in a text document",n=>Array.isArray(n)&&n.every(o=>I.$MJ.isPosition(o)),n=>n.map(P.Position.from))],new g.$$L("A promise that resolves to an array of ranges.",n=>n.map(o=>{let a;for(const m of o.reverse())a=new I.$8J(P.Range.to(m),a);return a}))),new g.$_L("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$0L.String.with("query","Search string")],new g.$$L("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(P.WorkspaceSymbol.to))),new g.$_L("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$0L.Uri,g.$0L.Position],new g.$$L("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(P.CallHierarchyItem.to))),new g.$_L("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$0L.CallHierarchyItem],new g.$$L("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(P.CallHierarchyIncomingCall.to))),new g.$_L("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$0L.CallHierarchyItem],new g.$$L("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(P.CallHierarchyOutgoingCall.to))),new g.$_L("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$0L.Uri,g.$0L.Position],new g.$$L("A promise that resolves to a range and placeholder text.",n=>{if(n)return{range:P.Range.to(n.range),placeholder:n.text}})),new g.$_L("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$0L.Uri,g.$0L.Position,g.$0L.String.with("newName","The new symbol name")],new g.$$L("A promise that resolves to a WorkspaceEdit.",n=>{if(n){if(n.rejectReason)throw new Error(n.rejectReason);return P.WorkspaceEdit.to(n)}})),new g.$_L("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$0L.Uri,g.$0L.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$$L("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(P.DocumentLink.to))),new g.$_L("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$0L.Uri],new g.$$L("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new I.$2K(n.tokenTypes,n.tokenModifiers)})),new g.$_L("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$0L.Uri],new g.$$L("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,A.$59)(n);if(o.type==="full")return new I.$4K(o.data,void 0)})),new g.$_L("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$0L.Uri,g.$0L.Range.optional()],new g.$$L("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new I.$2K(n.tokenTypes,n.tokenModifiers)})),new g.$_L("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$0L.Uri,g.$0L.Range],new g.$$L("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,A.$59)(n);if(o.type==="full")return new I.$4K(o.data,void 0)})),new g.$_L("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$0L.Uri,g.$0L.Position,g.$0L.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$0L.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$$L("A promise that resolves to a CompletionList-instance.",(n,o,a)=>{if(!n)return new I.$hK([]);const m=n.suggestions.map(v=>P.CompletionItem.to(v,a));return new I.$hK(m,n.incomplete)})),new g.$_L("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$0L.Uri,g.$0L.Position,g.$0L.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$$L("A promise that resolves to SignatureHelp.",n=>{if(n)return P.SignatureHelp.to(n)})),new g.$_L("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$0L.Uri,g.$0L.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$$L("A promise that resolves to an array of CodeLens-instances.",(n,o,a)=>C(m=>new I.$_J(P.Range.to(m.range),m.command&&a.fromInternal(m.command)))(n))),new g.$_L("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$0L.Uri,new g.$0L("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>I.$NJ.isRange(n),n=>I.$OJ.isSelection(n)?P.Selection.from(n):P.Range.from(n)),g.$0L.String.with("kind","Code action kind to return code actions for").optional(),g.$0L.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$$L("A promise that resolves to an array of Command-instances.",(n,o,a)=>C(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(m.command)}else{const v=new I.$5J(m.title,m.kind?new I.$6J(m.kind):void 0);return m.edit&&(v.edit=P.WorkspaceEdit.to(m.edit)),m.command&&(v.command=a.fromInternal(m.command)),v.isPreferred=m.isPreferred,v}})(n))),new g.$_L("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$0L.Uri],new g.$$L("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(o=>new I.$nK(P.Range.to(o.range),P.Color.to(o.color))):[])),new g.$_L("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$0L("color","The color to show and insert",n=>n instanceof I.$mK,P.Color.from),new g.$0L("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:P.Range.from(n.range)}))],new g.$$L("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(P.ColorPresentation.to):[])),new g.$_L("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$0L.Uri,g.$0L.Range],new g.$$L("A promise that resolves to an array of Inlay objects",(n,o,a)=>n.map(P.InlayHint.to.bind(void 0,a)))),new g.$_L("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$0L.Uri],new g.$$L("A promise that resolves to an array of FoldingRange objects",(n,o)=>{if(n)return n.map(P.FoldingRange.to)})),new g.$_L("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$$L("A promise that resolves to an array of NotebookContentProvider static info objects.",C(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(o=>P.NotebookExclusiveDocumentPattern.to(o))})))),new g.$_L("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$0L.Uri,g.$0L.Range],new g.$$L("A promise that resolves to an array of InlineValue objects",n=>n.map(P.InlineValue.to))),new g.$_L("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$0L("uriOrString","Uri-instance or string (only http/https)",n=>h.URI.isUri(n)||typeof n=="string"&&(0,w.$sT)(n,F.Schemas.http,F.Schemas.https),n=>n),new g.$0L("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[P.ViewColumn.from(n),void 0]:[P.ViewColumn.from(n.viewColumn),P.TextEditorOpenOptions.from(n)])).optional(),g.$0L.String.with("label","").optional()],g.$$L.Void),new g.$_L("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$0L.Uri.with("resource","Resource to open"),g.$0L.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new g.$0L("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[P.ViewColumn.from(n),void 0]:[P.ViewColumn.from(n.viewColumn),P.TextEditorOpenOptions.from(n)])).optional()],g.$$L.Void),new g.$_L("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$0L.Uri.with("left","Left-hand side resource of the diff editor"),g.$0L.Uri.with("right","Right-hand side resource of the diff editor"),g.$0L.String.with("title","Human readable title for the diff editor").optional(),new g.$0L("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[P.ViewColumn.from(n.viewColumn),P.TextEditorOpenOptions.from(n)]).optional()],g.$$L.Void),new g.$_L("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$0L.Uri,g.$0L.Position],new g.$$L("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(P.TypeHierarchyItem.to))),new g.$_L("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$0L.TypeHierarchyItem],new g.$$L("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(P.TypeHierarchyItem.to))),new g.$_L("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$0L.TypeHierarchyItem],new g.$$L("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(P.TypeHierarchyItem.to))),new g.$_L("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$0L.TestItem],g.$$L.Void),new g.$_L("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$0L.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$$L.Void),new g.$_L("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$0L.String.with("name","The context key name"),new g.$0L("value","The context key value",()=>!0,n=>n)],g.$$L.Void),new g.$_L("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$0L.Uri,g.$0L.StringArray,new g.$0L("MappedEditsContext","Mapped Edits Context",n=>P.MappedEditsContext.is(n),n=>P.MappedEditsContext.from(n))],new g.$$L("A promise that resolves to a workspace edit or null",n=>n?P.WorkspaceEdit.to(n):null))];class k{static register(o){$.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",f.$wi)}}e.$tac=k;function C(n){return o=>{if(Array.isArray(o))return o.map(n)}}function E(n){if(!Array.isArray(n))return;const o=[];for(const a of n)L.$ws(a)?o.push(P.DefinitionLink.to(a)):o.push(P.location.to(a));return o}}),define(Se[293],De([1,0,13,70,4,3,2,81,25,10,7,5,27]),function(me,e,S,F,h,L,A,f,w,g,P,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vac=void 0;function k(C,E,n){const o=C.getProxy(I.$JJ.MainThreadComments);class a{static{this.a=0}constructor(){this.b=new Map,this.c=new w.$Kl,E.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const b=this.b.get(l.handle);return b?b.value:l}else if(l&&l.$mid===7){const b=this.b.get(l.commentControlHandle);if(!b)return l;const y=b.getCommentThread(l.commentThreadHandle);return y?y.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const b=this.b.get(l.thread.commentControlHandle);if(!b)return l;const y=b.getCommentThread(l.thread.commentThreadHandle);return y?l.$mid===8?y.value:{thread:y.value,text:l.text}:l}else if(l&&l.$mid===10){const b=this.b.get(l.thread.commentControlHandle);if(!b)return l;const y=b.getCommentThread(l.thread.commentThreadHandle);if(!y)return l;const u=l.commentUniqueId,d=y.getCommentByUniqueId(u);return d||l}else if(l&&l.$mid===11){const b=this.b.get(l.thread.commentControlHandle);if(!b)return l;const y=b.getCommentThread(l.thread.commentThreadHandle);if(!y)return l;const u=l.text,d=l.commentUniqueId,p=y.getCommentByUniqueId(d);return p?(typeof p.body=="string"?p.body=u:p.body=new P.$aK(u),p):l}return l}})}createCommentController(l,b,y){const u=a.a++,d=new v(l,u,b,y);this.b.set(d.handle,d);const p=this.c.get(l.identifier)||[];return p.push(d),this.c.set(l.identifier,p),d.value}$createCommentThreadTemplate(l,b,y){const u=this.b.get(l);u&&u.$createCommentThreadTemplate(b,y)}async $updateCommentThreadTemplate(l,b,y){const u=this.b.get(l);u&&u.$updateCommentThreadTemplate(b,y)}$deleteCommentThread(l,b){this.b.get(l)?.$deleteCommentThread(b)}$provideCommentingRanges(l,b,y){const u=this.b.get(l);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const d=n.getDocument(A.URI.revive(b));return(0,S.$ng)(async()=>{const p=await u.commentingRangeProvider.provideCommentingRanges(d,y);let R;return Array.isArray(p)?R={ranges:p,fileComments:!1}:p?R={ranges:p.ranges||[],fileComments:p.fileComments||!1}:R=p??void 0,R}).then(p=>{let R;return p&&(R={ranges:p.ranges.map(O=>g.Range.from(O)),fileComments:p.fileComments}),R})}$toggleReaction(l,b,y,u,d){const p=this.b.get(l);return!p||!p.reactionHandler?Promise.resolve(void 0):(0,S.$ng)(()=>{const R=p.getCommentThread(b);if(R){const O=R.getCommentByUniqueId(u.uniqueIdInThread);if(p!==void 0&&O&&p.reactionHandler)return p.reactionHandler(O,r(d))}return Promise.resolve(void 0)})}}class m{static{this.a=0}set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){(l===void 0!=(this.p===void 0)||!l||!this.p||!l.isEqual(this.p))&&(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,b,y,u,d,p,R,O){this.m=b,this.n=y,this.o=u,this.p=d,this.q=p,this.extensionDescription=R,this.r=O,this.handle=m.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new h.$ec,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$mb,this.l.value=new L.$kb,this.n===void 0&&(this.n=`${l}.${this.handle}`),o.$createCommentThread(b,this.handle,this.n,this.o,g.Range.from(this.p),R.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=p,this.i.push({dispose:()=>{o.$deleteCommentThread(b,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range(T){j.range=T},get comments(){return j.comments},set comments(T){j.comments=T},get collapsibleState(){return j.collapsibleState},set collapsibleState(T){j.collapsibleState=T},get canReply(){return j.canReply},set canReply(T){j.canReply=T},get contextValue(){return j.contextValue},set contextValue(T){j.contextValue=T},get label(){return j.label},set label(T){j.label=T},get state(){return j.state},set state(T){j.state=T},dispose:()=>{j.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$kb);const l=y=>Object.prototype.hasOwnProperty.call(this.b,y),b={};l("range")&&(b.range=g.Range.from(this.p)),l("label")&&(b.label=this.label),l("contextValue")&&(b.contextValue=this.contextValue??null),l("comments")&&(b.comments=this.q.map(y=>D(this,y,this.k,this.extensionDescription))),l("collapsibleState")&&(b.collapseState=s(this.g)),l("canReply")&&(b.canReply=this.canReply),l("state")&&(b.state=i(this.h)),l("isTemplate")&&(b.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,b)}getCommentByUniqueId(l){for(const b of this.k){const y=b[0],u=b[1];if(l===u)return y}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}Je([(0,F.$Ug)(100)],m.prototype,"eventuallyUpdateCommentThread",null);class v{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(l,b,y,u){this.f=l,this.g=b,this.h=y,this.i=u,this.a=new Map,o.$registerCommentController(this.handle,y,u);const d=this;this.value=Object.freeze({id:d.id,label:d.label,get options(){return d.options},set options(p){d.options=p},get commentingRangeProvider(){return d.commentingRangeProvider},set commentingRangeProvider(p){d.commentingRangeProvider=p},get reactionHandler(){return d.reactionHandler},set reactionHandler(p){d.reactionHandler=p},createCommentThread(p,R,O){return d.createCommentThread(p,R,O).value},dispose:()=>{d.dispose()}}),this.e=[],this.e.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(l,b,y){b===void 0&&(0,$.$EF)(this.f,"fileComments");const u=new m(this.id,this.handle,void 0,l,b,y,this.f,!1);return this.a.set(u.handle,u),u}$createCommentThreadTemplate(l,b){const y=new m(this.id,this.handle,void 0,A.URI.revive(l),g.Range.to(b),[],this.f,!0);return y.collapsibleState=f.CommentThreadCollapsibleState.Expanded,this.a.set(y.handle,y),y}$updateCommentThreadTemplate(l,b){const y=this.a.get(l);y&&(y.range=g.Range.to(b))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.e.forEach(l=>l.dispose())}}function D(c,l,b,y){let u=b.get(l);return u||(u=++c.commentHandle,b.set(l,u)),l.state!==void 0&&(0,$.$EF)(y,"commentsDraftState"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:u,body:typeof l.body=="string"?l.body:g.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(d=>t(d)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function t(c){return{label:c.label,iconPath:c.iconPath?g.$KL(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function r(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?A.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function s(c){if(c!==void 0)switch(c){case P.CommentThreadCollapsibleState.Expanded:return f.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return f.CommentThreadCollapsibleState.Collapsed}return f.CommentThreadCollapsibleState.Collapsed}function i(c){if(c!==void 0)switch(c){case P.CommentThreadState.Unresolved:return f.CommentThreadState.Unresolved;case P.CommentThreadState.Resolved:return f.CommentThreadState.Resolved}return f.CommentThreadState.Unresolved}return new a}e.$vac=k}),define(Se[294],De([1,0,23,5,26,20]),function(me,e,S,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=void 0;let A=class{constructor(P,I){this.a=P.getProxy(F.$JJ.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(P,I){const $=this,k=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){$.e(P,I,k,arguments)}})}e(P,I,$,k){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:w(k,this.b)}),this.c&&this.f(P,$,k)}};e.$rcc=A,e.$rcc=A=Je([Be(0,L.$LL),Be(1,h.$2L)],A);const f=1e5;function w(g,P){const I=[];if(g.length)for(let $=0;$<g.length;$++){let k=g[$];if(typeof k>"u")k="undefined";else if(k instanceof Error){const C=k;C.stack?k=C.stack:k=C.toString()}I.push(k)}if(P){const $=new Error().stack;$&&I.push({__$stack:$.split(`
`).slice(3).join(`
`)})}try{const $=(0,S.$Nm)(I);return $.length>f?"Output omitted for a large object that exceeds the limits":$}catch($){return`Output omitted for an object that cannot be inspected ('${$.toString()}')`}}}),define(Se[146],De([1,0,2,5,7,6,20,17,18,15,14,27]),function(me,e,S,F,h,L,A,f,w,g,P,I){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$xbc=e.$wbc=void 0;let k=class{static{$=this}static{this.c=0}static{this.d=250}constructor(E,n){this.h=n,this.f=new Map,this.g=E.getProxy(F.$JJ.MainThreadDecorations)}registerFileDecorationProvider(E,n){const o=$.c++;this.f.set(o,{provider:E,extensionDescription:n}),this.g.$registerDecorationProvider(o,n.identifier.value);const a=E.onDidChangeFileDecorations&&E.onDidChangeFileDecorations(m=>{if(!m){this.g.$onDidChange(o,null);return}const v=(0,w.$Gf)(m);if(v.length<=$.d){this.g.$onDidChange(o,v);return}this.h.warn("[Decorations] CAPPING events from decorations provider",n.identifier.value,v.length);const D=v.map(s=>({uri:s,rank:(0,g.$qd)(s.path,"/")})),t=(0,w.$ef)(D,(s,i)=>s.rank-i.rank||(0,g.$Ed)(s.uri.path,i.uri.path)),r=[];e:for(const s of t){let i;for(const c of s){const l=(0,P.$$c)(c.uri.path);if(i!==l&&(i=l,r.push(c.uri)>=$.d))break e}}this.g.$onDidChange(o,r)});return new h.$LJ(()=>{a?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(E,n,o){if(!this.f.has(E))return Object.create(null);const a=Object.create(null),{provider:m,extensionDescription:v}=this.f.get(E);return await Promise.all(n.map(async D=>{try{const{uri:t,id:r}=D,s=await Promise.resolve(m.provideFileDecoration(S.URI.revive(t),o));if(!s)return;try{h.$8K.validate(s),s.badge&&typeof s.badge!="string"&&(0,I.$EF)(v,"codiconDecoration"),a[r]=[s.propagate,s.tooltip,s.badge,s.color]}catch(i){this.h.warn(`INVALID decoration from extension '${v.identifier.value}': ${i}`)}}catch(t){this.h.error(t)}})),a}};e.$wbc=k,e.$wbc=k=$=Je([Be(0,A.$LL),Be(1,f.$Ri)],k),e.$xbc=(0,L.$ph)("IExtHostDecorations")}),define(Se[295],De([1,0,197,131,2,5,7,10,4,17,28,52]),function(me,e,S,F,h,L,A,f,w,g,P,I){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$oac=e.$nac=void 0;class k{#e;#t;#i;constructor(n,o,a,m,v,D,t,r){this.d=n,this.e=o,this.f=a,this.g=m,this.h=v,this.c=!1,this.f=Math.max(m,a),this.#i=new P.$ni(s=>D.getComparisonKey(s)),this.#e=t,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(n,o){if(!n){this.clear();return}this.j();let a=[];if(h.URI.isUri(n)){if(!o){this.delete(n);return}this.#i.set(n,o.slice()),a=[n]}else if(Array.isArray(n)){a=[];let D;n=[...n].sort(k.k);for(const t of n){const[r,s]=t;if((!D||r.toString()!==D.toString())&&(D&&this.#i.get(D).length===0&&this.#i.delete(D),D=r,a.push(r),this.#i.set(r,[])),s)this.#i.get(r)?.push(...s);else{const i=this.#i.get(r);i&&(i.length=0)}}}if(this.#t.fire(a),!this.#e)return;const m=[];let v=0;for(const D of a){let t=[];const r=this.#i.get(D);if(r)if(r.length>this.g){t=[];const s=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(const c of r)if(c.severity===s[i]&&t.push({...f.Diagnostic.from(c),modelVersionId:this.h(D)})===this.g)break e;t.push({severity:F.MarkerSeverity.Info,message:(0,S.localize)(0,null,r.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=r.map(s=>({...f.Diagnostic.from(s),modelVersionId:this.h(D)}));if(m.push([D,t]),v+=t.length,v>this.f)break}this.#e.$changeMany(this.e,m)}delete(n){this.j(),this.#t.fire([n]),this.#i.delete(n),this.#e?.$changeMany(this.e,[[n,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(n,o){this.j();for(const[a,m]of this)n.call(o,a,m,this)}*[Symbol.iterator](){this.j();for(const n of this.#i.keys())yield[n,this.get(n)]}get(n){this.j();const o=this.#i.get(n);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(n){return this.j(),Array.isArray(this.#i.get(n))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(n,o){return n[0].toString()<o[0].toString()?-1:n[0].toString()>o[0].toString()?1:0}}e.$nac=k;let C=class{static{$=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*$.d}static _mapper(n){const o=new P.$ni;for(const a of n)o.set(a,a);return{uris:Object.freeze(Array.from(o.values()))}}constructor(n,o,a,m){this.j=o,this.k=a,this.l=m,this.g=new Map,this.h=new w.$ic({merge:v=>v.flat(),delay:50}),this.onDidChangeDiagnostics=w.Event.map(this.h.event,$._mapper),this.f=n.getProxy(L.$JJ.MainThreadDiagnostics)}createDiagnosticCollection(n,o){const{g:a,f:m,h:v,j:D,k:t,l:r}=this,s=new class{$changeMany(l,b){m.$changeMany(l,b),D.trace("[DiagnosticCollection] change many (extension, owner, uris)",n.value,l,b.length===0?"CLEARING":b)}$clear(l){m.$clear(l),D.trace("[DiagnosticCollection] remove all (extension, owner)",n.value,l)}dispose(){m.dispose()}};let i;if(!o)o="_generated_diagnostic_collection_name_#"+$.c++,i=o;else if(!a.has(o))i=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do i=o+$.c++;while(a.has(i))}return new class extends k{constructor(){super(o,i,$.e,$.d,l=>r.getDocument(l)?.version,t.extUri,s,v),a.set(i,this)}dispose(){super.dispose(),a.delete(i)}}}getDiagnostics(n){if(n)return this.m(n);{const o=new Map,a=[];for(const m of this.g.values())m.forEach((v,D)=>{let t=o.get(v.toString());typeof t>"u"&&(t=a.length,o.set(v.toString(),t),a.push([v,[]])),a[t][1]=a[t][1].concat(...D)});return a}}m(n){let o=[];for(const a of this.g.values())a.has(n)&&(o=o.concat(a.get(n)));return o}$acceptMarkersChange(n){if(!this.n){const o="_generated_mirror",a=new k(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,m=>{},this.k.extUri,void 0,this.h);this.g.set(o,a),this.n=a}for(const[o,a]of n)this.n.set(h.URI.revive(o),a.map(f.Diagnostic.to))}};e.$oac=C,e.$oac=C=$=Je([Be(1,g.$Ri),Be(2,I.$mac)],C)}),define(Se[296],De([1,0,2,5,27]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dac=void 0;class L{constructor(f){this.a=f.getProxy(F.$JJ.MainThreadDialogs)}showOpenDialog(f,w){return w?.allowUIResources&&(0,h.$EF)(f,"showLocal"),this.a.$showOpenDialog(w).then(g=>g?g.map(P=>S.URI.revive(P)):void 0)}showSaveDialog(f){return this.a.$showSaveDialog(f).then(w=>w?S.URI.revive(w):void 0)}}e.$Dac=L}),define(Se[297],De([1,0,8,2,7,5,16,22,15]),function(me,e,S,F,h,L,A,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eac=void 0;class g{static{this.a=0}constructor(I,$,k){this.d=$,this.e=k,this.b=new Map,this.c=I.getProxy(L.$JJ.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,$){if(Object.keys(A.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const k=g.a++;this.b.set(k,$),this.c.$registerTextContentProvider(k,I);let C;return typeof $.onDidChange=="function"&&(C=$.onDidChange(E=>{if(E.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${E.scheme}' which will be IGNORED`);return}this.d.getDocument(E)&&this.$provideTextDocumentContent(k,E).then(n=>{if(!n&&typeof n!="string")return;const o=this.d.getDocument(E);if(!o)return;const a=(0,w.$zd)(n);if(!o.equalLines(a))return this.c.$onVirtualDocumentChange(E,n)},S.$Y)})),new h.$LJ(()=>{this.b.delete(k)&&this.c.$unregisterTextContentProvider(k),C&&(C.dispose(),C=void 0)})}$provideTextDocumentContent(I,$){const k=this.b.get(I);return k?Promise.resolve(k.provideTextDocumentContent(F.URI.revive($),f.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${$.scheme}`))}}e.$Eac=g}),define(Se[298],De([1,0,4,3,2,5,139,10,19,23,7,8]),function(me,e,S,F,h,L,A,f,w,g,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kac=void 0;class ${constructor(C,E){this.a=new S.$ec({onListenerError:I.$Z}),this.b=new S.$ec({onListenerError:I.$Z}),this.c=new S.$ec({onListenerError:I.$Z}),this.d=new S.$ec({onListenerError:I.$Z}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$kb,this.h=new Map,this.f=C.getProxy(L.$JJ.MainThreadDocuments),this.g=E,this.g.onDidRemoveDocuments(n=>{for(const o of n)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(n=>{for(const o of n)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(C){if(!C)return;const E=this.g.getDocument(C);if(E)return E}getDocument(C){const E=this.getDocumentData(C);if(!E?.document)throw new Error(`Unable to retrieve document from URI '${C}'`);return E.document}ensureDocumentData(C){const E=this.g.getDocument(C);if(E)return Promise.resolve(E);let n=this.h.get(C.toString());return n||(n=this.f.$tryOpenDocument(C).then(o=>{this.h.delete(C.toString());const a=h.URI.revive(o);return(0,w.$te)(this.g.getDocument(a))},o=>(this.h.delete(C.toString()),Promise.reject(o))),this.h.set(C.toString(),n)),n}createDocumentData(C){return this.f.$tryCreateDocument(C).then(E=>h.URI.revive(E))}$acceptModelLanguageChanged(C,E){const n=h.URI.revive(C),o=this.g.getDocument(n);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(E),this.a.fire(o.document)}$acceptModelSaved(C){const E=h.URI.revive(C),n=this.g.getDocument(E);if(!n)throw new Error("unknown document");this.$acceptDirtyStateChanged(C,!1),this.d.fire(n.document)}$acceptDirtyStateChanged(C,E){const n=h.URI.revive(C),o=this.g.getDocument(n);if(!o)throw new Error("unknown document");o._acceptIsDirty(E),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(C,E,n){const o=h.URI.revive(C),a=this.g.getDocument(o);if(!a)throw new Error("unknown document");a._acceptIsDirty(n),a.onEvents(E);let m;E.isUndoing?m=P.TextDocumentChangeReason.Undo:E.isRedoing&&(m=P.TextDocumentChangeReason.Redo),this.c.fire((0,g.$Jm)({document:a.document,contentChanges:E.changes.map(v=>({range:f.Range.to(v.range),rangeOffset:v.rangeOffset,rangeLength:v.rangeLength,text:v.text})),reason:m}))}setWordDefinitionFor(C,E){(0,A.$NL)(C,E)}}e.$kac=$}),define(Se[65],De([1,0,54,4,3,2,6,5,139,20,144,10,17,28,16,48,55]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WL=e.$VL=void 0;class o{constructor(v){this.value=v,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let a=class{constructor(v,D){this.h=v,this.i=D,this.a=null,this.b=new Map,this.c=new k.$ni,this.d=new F.$ec,this.e=new F.$ec,this.f=new F.$ec,this.g=new F.$ec,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(v){this.acceptDocumentsAndEditorsDelta(v)}acceptDocumentsAndEditorsDelta(v){const D=[],t=[],r=[];if(v.removedDocuments)for(const s of v.removedDocuments){const i=L.URI.revive(s),c=this.c.get(i);c?.unref()&&(this.c.delete(i),D.push(c.value))}if(v.addedDocuments)for(const s of v.addedDocuments){const i=L.URI.revive(s.uri);let c=this.c.get(i);if(c&&i.scheme!==C.Schemas.vscodeNotebookCell&&i.scheme!==C.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);c||(c=new o(new w.$OL(this.h.getProxy(f.$JJ.MainThreadDocuments),i,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(i,c),t.push(c.value)),c.ref()}if(v.removedEditors)for(const s of v.removedEditors){const i=this.b.get(s);this.b.delete(s),i&&r.push(i)}if(v.addedEditors)for(const s of v.addedEditors){const i=L.URI.revive(s.documentUri);S.ok(this.c.has(i),`document '${i}' does not exist`),S.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const c=this.c.get(i).value,l=new P.$UL(s.id,this.h.getProxy(f.$JJ.MainThreadTextEditors),this.i,new n.$T(()=>c.document),s.selections.map(I.Selection.to),s.options,s.visibleRanges.map(b=>I.Range.to(b)),typeof s.editorPosition=="number"?I.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,l)}v.newActiveEditor!==void 0&&(S.ok(v.newActiveEditor===null||this.b.has(v.newActiveEditor),`active editor '${v.newActiveEditor}' does not exist`),this.a=v.newActiveEditor),(0,h.$gb)(D),(0,h.$gb)(r),v.removedDocuments&&this.e.fire(D),v.addedDocuments&&this.d.fire(t),(v.removedEditors||v.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),v.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(v){return this.c.get(v)?.value}allDocuments(){return E.Iterable.map(this.c.values(),v=>v.value)}getEditor(v){return this.b.get(v)}activeEditor(v){if(!this.a)return;const D=this.b.get(this.a);return v?D:D?.value}allEditors(){return[...this.b.values()]}};e.$VL=a,e.$VL=a=Je([Be(0,g.$LL),Be(1,$.$Ri)],a),e.$WL=(0,A.$ph)("IExtHostDocumentsAndEditors")}),define(Se[66],De([1,0,10,5,2,4,6,7,20,19,69]),function(me,e,S,F,h,L,A,f,w,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cbc=e.$Bbc=void 0,e.$Bbc=(0,A.$ph)("IExtHostEditorTabs");class I{constructor(n,o,a){this.e=a,this.d=o,this.acceptDtoUpdate(n)}get apiObject(){if(!this.a){const n=this,o={get isActive(){return n.b.id===n.e()},get label(){return n.b.label},get input(){return n.c},get isDirty(){return n.b.isDirty},get isPinned(){return n.b.isPinned},get isPreview(){return n.b.isPreview},get group(){return n.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(n){this.b=n,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new f.$rL(h.URI.revive(this.b.input.uri));case 2:return new f.$sL(h.URI.revive(this.b.input.original),h.URI.revive(this.b.input.modified));case 3:return new f.$tL(h.URI.revive(this.b.input.base),h.URI.revive(this.b.input.input1),h.URI.revive(this.b.input.input2),h.URI.revive(this.b.input.result));case 6:return new f.$uL(h.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new f.$vL(this.b.input.viewType);case 4:return new f.$wL(h.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new f.$xL(h.URI.revive(this.b.input.original),h.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new f.$yL;case 9:return new f.$zL(h.URI.revive(this.b.input.uri),h.URI.revive(this.b.input.inputBoxUri));default:return}}}class ${constructor(n,o){this.c=[],this.d="",this.b=n,this.e=o;for(const a of n.tabs)a.isActive&&(this.d=a.id),this.c.push(new I(a,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const n=this,o={get isActive(){return n.b.groupId===n.e()},get viewColumn(){return S.ViewColumn.to(n.b.viewColumn)},get activeTab(){return n.c.find(a=>a.tabId===n.d)?.apiObject},get tabs(){return Object.freeze(n.c.map(a=>a.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(n){this.b=n}acceptTabOperation(n){if(n.kind===0){const a=new I(n.tabDto,this,()=>this.activeTabId());return this.c.splice(n.index,0,a),n.tabDto.isActive&&(this.d=a.tabId),a}else if(n.kind===1){const a=this.c.splice(n.index,1)[0];if(!a)throw new Error(`Tab close updated received for index ${n.index} which does not exist`);return a.tabId===this.d&&(this.d=""),a}else if(n.kind===3){if(n.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const a=this.c.splice(n.oldIndex,1)[0];if(!a)throw new Error(`Tab move updated received for index ${n.oldIndex} which does not exist`);return this.c.splice(n.index,0,a),a}const o=this.c.find(a=>a.tabId===n.tabDto.id);if(!o)throw new Error("INVALID tab");return n.tabDto.isActive?this.d=n.tabDto.id:this.d===n.tabDto.id&&!n.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(n.tabDto),o}activeTabId(){return this.d}}let k=class{constructor(n){this.b=new L.$ec,this.c=new L.$ec,this.e=[],this.a=n.getProxy(F.$JJ.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const n=this,o={onDidChangeTabGroups:n.c.event,onDidChangeTabs:n.b.event,get all(){return Object.freeze(n.e.map(a=>a.apiObject))},get activeTabGroup(){const a=n.d;return(0,g.$te)(n.e.find(v=>v.groupId===a)?.apiObject)},close:async(a,m)=>{const v=Array.isArray(a)?a:[a];return v.length?C(v[0])?this.j(v,m):this.i(v,m):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(n){const o=new Set(this.e.map(s=>s.groupId)),a=new Set(n.map(s=>s.groupId)),m=(0,P.$J)(o,a),v=this.e.filter(s=>m.removed.includes(s.groupId)).map(s=>s.apiObject),D=[],t=[];this.e=n.map(s=>{const i=new $(s,()=>this.d);return m.added.includes(i.groupId)?D.push(i.apiObject):t.push(i.apiObject),i});const r=(0,g.$te)(n.find(s=>s.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:D,closed:v,changed:t}))}$acceptTabGroupUpdate(n){const o=this.e.find(a=>a.groupId===n.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(n),n.isActive&&(this.d=n.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(n){const o=this.e.find(m=>m.groupId===n.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const a=o.acceptTabOperation(n);switch(n.kind){case 0:this.b.fire(Object.freeze({opened:[a.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[a.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[a.apiObject]}));return}}g(n){for(const o of this.e)for(const a of o.tabs)if(a.apiObject===n)return a}h(n){return this.e.find(o=>o.apiObject===n)}async i(n,o){const a=[];for(const m of n){const v=this.g(m);if(!v)throw new Error("Tab close: Invalid tab not found!");a.push(v.tabId)}return this.a.$closeTab(a,o)}async j(n,o){const a=[];for(const m of n){const v=this.h(m);if(!v)throw new Error("Group close: Invalid group not found!");a.push(v.groupId)}return this.a.$closeGroup(a,o)}};e.$Cbc=k,e.$Cbc=k=Je([Be(0,w.$LL)],k);function C(E){return E.tabs!==void 0}}),define(Se[299],De([1,0,5,7]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=void 0;class h{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(S.$JJ.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,f,w){if(this.a.size===0)throw new Error("No embedding vector providers registered");const g=this.a.get(A);if(!g)throw new Error("Embedding vector provider not found");const P=await g.provideEmbeddingVector(f,w);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(A,f,w){const g=this.b;return this.b++,this.a.set(g,w),this.c.$registerAiEmbeddingVectorProvider(f,g),new F.$LJ(()=>{this.c.$unregisterAiEmbeddingVectorProvider(g),this.a.delete(g)})}}e.$occ=h}),define(Se[300],De([1,0,2,5,3,7,10,166,15,21,27,78]),function(me,e,S,F,h,L,A,f,w,g,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ac=void 0;class ${constructor(){this.a=[]}add(E){this.b=void 0,this.a.push(E)}delete(E){const n=this.a.indexOf(E);n>=0&&(this.a.splice(n,1),this.b=void 0)}c(){if(!this.b){const E=this.a.sort(),n=[];let o,a,m=14,v=14;for(const D of E){let t=o?(0,w.$Nd)(o,D):0;for(t===0?a=1:a=v;t<D.length;t++)t+1===D.length?(m=v,v=9):v+=1,n.push([a,D.toUpperCase().charCodeAt(t),v]),n.push([a,D.toLowerCase().charCodeAt(t),v]),a=v;o=D,v=m}n.push([9,58,10]),n.push([10,47,12]),this.b=new f.$qY(n)}}provideDocumentLinks(E){this.c();const n=[],o=f.$rY.computeLinks({getLineContent(a){return E.lineAt(a-1).text},getLineCount(){return E.lineCount}},this.b);for(const a of o){const m=A.DocumentLink.to(a);m.target&&n.push(m)}return n}}class k{constructor(E,n){this.i=n,this.b=new $,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=E.getProxy(F.$JJ.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(E,n,o,a={}){if(k.j(o),this.d.has(n))throw new Error(`a provider for the scheme '${n}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(E,"*",this.b));const m=this.h++;this.b.add(n),this.d.add(n),this.c.set(m,o);let v=2;a.isCaseSensitive&&(v+=1024),a.isReadonly&&(v+=2048),typeof o.copy=="function"&&(v+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,P.$EF)(E,"fsChunks"),v+=4);let D;a.isReadonly&&(0,I.$Mj)(a.isReadonly)&&((0,P.$EF)(E,"readonlyMessage"),D={value:a.isReadonly.value,isTrusted:a.isReadonly.isTrusted,supportThemeIcons:a.isReadonly.supportThemeIcons,supportHtml:a.isReadonly.supportHtml,baseUri:a.isReadonly.baseUri,uris:a.isReadonly.uris}),this.a.$registerFileSystemProvider(m,n,v,D).catch(r=>{console.error(`FAILED to register filesystem provider of ${E.identifier.value}-extension for the scheme ${n}`),console.error(r)});const t=o.onDidChangeFile(r=>{const s=[];for(const i of r){const{uri:c,type:l}=i;if(c.scheme!==n)continue;let b;switch(l){case L.FileChangeType.Changed:b=0;break;case L.FileChangeType.Created:b=1;break;case L.FileChangeType.Deleted:b=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:c,type:b})}this.a.$onFileSystemChange(m,s)});return(0,h.$jb)(()=>{t.dispose(),this.b.delete(n),this.d.delete(n),this.c.delete(m),this.a.$unregisterProvider(m)})}static j(E){if(!E)throw new Error("MISSING provider");if(typeof E.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof E.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof E.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof E.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof E.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof E.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof E.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof E.rename!="function")throw new Error("Provider does NOT implement rename")}static k(E){const{type:n,ctime:o,mtime:a,size:m,permissions:v}=E;return{type:n,ctime:o,mtime:a,size:m,permissions:v}}$stat(E,n){return Promise.resolve(this.l(E).stat(S.URI.revive(n))).then(o=>k.k(o))}$readdir(E,n){return Promise.resolve(this.l(E).readDirectory(S.URI.revive(n)))}$readFile(E,n){return Promise.resolve(this.l(E).readFile(S.URI.revive(n))).then(o=>g.$Ec.wrap(o))}$writeFile(E,n,o,a){return Promise.resolve(this.l(E).writeFile(S.URI.revive(n),o.buffer,a))}$delete(E,n,o){return Promise.resolve(this.l(E).delete(S.URI.revive(n),o))}$rename(E,n,o,a){return Promise.resolve(this.l(E).rename(S.URI.revive(n),S.URI.revive(o),a))}$copy(E,n,o,a){const m=this.l(E);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(S.URI.revive(n),S.URI.revive(o),a))}$mkdir(E,n){return Promise.resolve(this.l(E).createDirectory(S.URI.revive(n)))}$watch(E,n,o,a){const m=this.l(E).watch(S.URI.revive(o),a);this.f.set(n,m)}$unwatch(E,n){const o=this.f.get(n);o&&(o.dispose(),this.f.delete(n))}$open(E,n,o){const a=this.l(E);if(!a.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(a.open(S.URI.revive(n),o))}$close(E,n){const o=this.l(E);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(n))}$read(E,n,o,a){const m=this.l(E);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const v=g.$Ec.alloc(a);return Promise.resolve(m.read(n,o,v.buffer,0,a)).then(D=>v.slice(0,D))}$write(E,n,o,a){const m=this.l(E);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(n,o,a.buffer,0,a.byteLength))}l(E){const n=this.c.get(E);if(!n){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return n}}e.$$ac=k}),define(Se[67],De([1,0,5,30,7,21,6,20,52,3,13,24,16]),function(me,e,S,F,h,L,A,f,w,g,P,I,$){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rac=e.$Qac=void 0;let C=k=class{constructor(n,o){this.b=new Map,this.c=new P.$Dg,this.a=n.getProxy(S.$JJ.MainThreadFileSystem);const a=this;this.value=Object.freeze({async stat(m){try{let v;const D=a.b.get(m.scheme);return D?(await a.a.$ensureActivation(m.scheme),v=await D.impl.stat(m)):v=await a.a.$stat(m),{type:v.type,ctime:v.ctime,mtime:v.mtime,size:v.size,permissions:v.permissions===F.FilePermission.Readonly?1:void 0}}catch(v){k.e(v)}},async readDirectory(m){try{const v=a.b.get(m.scheme);return v?(await a.a.$ensureActivation(m.scheme),(await v.impl.readDirectory(m)).slice()):await a.a.$readdir(m)}catch(v){return k.e(v)}},async createDirectory(m){try{const v=a.b.get(m.scheme);return v&&!v.isReadonly?(await a.a.$ensureActivation(m.scheme),await a.d(v.impl,v.extUri,m)):await a.a.$mkdir(m)}catch(v){return k.e(v)}},async readFile(m){try{const v=a.b.get(m.scheme);return v?(await a.a.$ensureActivation(m.scheme),(await v.impl.readFile(m)).slice()):(await a.a.$readFile(m)).buffer}catch(v){return k.e(v)}},async writeFile(m,v){try{const D=a.b.get(m.scheme);return D&&!D.isReadonly?(await a.a.$ensureActivation(m.scheme),await a.d(D.impl,D.extUri,D.extUri.dirname(m)),await a.c.queueFor(m).queue(()=>Promise.resolve(D.impl.writeFile(m,v,{create:!0,overwrite:!0})))):await a.a.$writeFile(m,L.$Ec.wrap(v))}catch(D){return k.e(D)}},async delete(m,v){try{const D=a.b.get(m.scheme);return D&&!D.isReadonly?(await a.a.$ensureActivation(m.scheme),await D.impl.delete(m,{recursive:!1,...v})):await a.a.$delete(m,{recursive:!1,useTrash:!1,atomic:!1,...v})}catch(D){return k.e(D)}},async rename(m,v,D){try{return await a.a.$rename(m,v,{overwrite:!1,...D})}catch(t){return k.e(t)}},async copy(m,v,D){try{return await a.a.$copy(m,v,{overwrite:!1,...D})}catch(t){return k.e(t)}},isWritableFileSystem(m){const v=o.getCapabilities(m);if(typeof v=="number")return!(v&2048)}})}async d(n,o,a){const m=[];for(;!o.isEqual(a,o.dirname(a));)try{if(!((await n.stat(a)).type&F.FileType.Directory))throw h.$ZK.FileExists(`Unable to create folder '${a.scheme===$.Schemas.file?a.fsPath:a.toString(!0)}' that already exists but is not a directory`);break}catch(v){if(F.$8j(v)!==F.FileSystemProviderErrorCode.FileNotFound)throw v;m.push(o.basename(a)),a=o.dirname(a)}for(let v=m.length-1;v>=0;v--){a=o.joinPath(a,m[v]);try{await n.createDirectory(a)}catch(D){if(F.$8j(D)!==F.FileSystemProviderErrorCode.FileExists)throw D}}}static e(n){if(n instanceof h.$ZK)throw n;if(n instanceof F.$4j)switch(n.code){case F.FileSystemProviderErrorCode.FileExists:throw h.$ZK.FileExists(n.message);case F.FileSystemProviderErrorCode.FileNotFound:throw h.$ZK.FileNotFound(n.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw h.$ZK.FileNotADirectory(n.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw h.$ZK.FileIsADirectory(n.message);case F.FileSystemProviderErrorCode.NoPermissions:throw h.$ZK.NoPermissions(n.message);case F.FileSystemProviderErrorCode.Unavailable:throw h.$ZK.Unavailable(n.message);default:throw new h.$ZK(n.message,n.name)}if(!(n instanceof Error))throw new h.$ZK(String(n));if(n.name==="ENOPRO"||n.message.includes("ENOPRO"))throw h.$ZK.Unavailable(n.message);switch(n.name){case F.FileSystemProviderErrorCode.FileExists:throw h.$ZK.FileExists(n.message);case F.FileSystemProviderErrorCode.FileNotFound:throw h.$ZK.FileNotFound(n.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw h.$ZK.FileNotADirectory(n.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw h.$ZK.FileIsADirectory(n.message);case F.FileSystemProviderErrorCode.NoPermissions:throw h.$ZK.NoPermissions(n.message);case F.FileSystemProviderErrorCode.Unavailable:throw h.$ZK.Unavailable(n.message);default:throw new h.$ZK(n.message,n.name)}}addFileSystemProvider(n,o,a){return this.b.set(n,{impl:o,extUri:a?.isCaseSensitive?I.$Yf:I.$1f,isReadonly:!!a?.isReadonly}),(0,g.$jb)(()=>this.b.delete(n))}getFileSystemProviderExtUri(n){return this.b.get(n)?.extUri??I.$Yf}};e.$Qac=C,e.$Qac=C=k=Je([Be(0,f.$LL),Be(1,w.$mac)],C),e.$Rac=(0,A.$ph)("IExtHostConsumerFileSystem")}),define(Se[301],De([1,0,4,35,2,5,10,7]),function(me,e,S,F,h,L,A,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ac=void 0;class w{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(I,$,k,C,E,n,o,a){this.a=new S.$ec,this.b=new S.$ec,this.c=new S.$ec;const m=this.h(I,k,E);this.g=0,n&&(this.g+=1),o&&(this.g+=2),a&&(this.g+=4);const v=(0,F.$ej)(E),D=typeof E=="string",t=C(r=>{if(!n)for(const s of r.created){const i=h.URI.revive(s);v(i.fsPath)&&(!D||$.getWorkspaceFolder(i))&&this.a.fire(i)}if(!o)for(const s of r.changed){const i=h.URI.revive(s);v(i.fsPath)&&(!D||$.getWorkspaceFolder(i))&&this.b.fire(i)}if(!a)for(const s of r.deleted){const i=h.URI.revive(s);v(i.fsPath)&&(!D||$.getWorkspaceFolder(i))&&this.c.fire(i)}});this.d=f.$LJ.from(m,this.a,this.b,this.c,t)}h(I,$,k){const C=f.$LJ.from();if(typeof k=="string")return C;const E=I.getProxy(L.$JJ.MainThreadFileSystem);let n=!1;(k.pattern.includes(F.$aj)||k.pattern.includes(F.$bj))&&(n=!0);const o=Math.random();return E.$watch($.identifier.value,o,k.baseUri,{recursive:n,excludes:[]}),f.$LJ.from({dispose:()=>E.$unwatch(o)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class g{constructor(I,$,k){this.j=I,this.k=$,this.l=k,this.a=new S.$ec,this.b=new S.$ec,this.c=new S.$ec,this.d=new S.$ec,this.g=new S.$gc,this.h=new S.$gc,this.i=new S.$gc,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(I,$,k,C,E,n){return new w(this.j,I,$,this.a.event,A.GlobPattern.from(k),C,E,n)}$onFileEvent(I){this.a.fire(I)}$onDidRunFileOperation(I,$){switch(I){case 2:this.b.fire(Object.freeze({files:$.map(k=>({oldUri:h.URI.revive(k.source),newUri:h.URI.revive(k.target)}))}));break;case 1:this.d.fire(Object.freeze({files:$.map(k=>h.URI.revive(k.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:$.map(k=>h.URI.revive(k.target))}));break;default:}}getOnWillRenameFileEvent(I){return this.m(I,this.g)}getOnWillCreateFileEvent(I){return this.m(I,this.h)}getOnWillDeleteFileEvent(I){return this.m(I,this.i)}m(I,$){return(k,C,E)=>{const n=function(a){k.call(C,a)};return n.extension=I,$.event(n,void 0,E)}}async $onWillRunFileOperation(I,$,k,C){switch(I){case 2:return await this.n(this.g,{files:$.map(E=>({oldUri:h.URI.revive(E.source),newUri:h.URI.revive(E.target)}))},k,C);case 1:return await this.n(this.i,{files:$.map(E=>h.URI.revive(E.target))},k,C);case 0:case 3:return await this.n(this.h,{files:$.map(E=>h.URI.revive(E.target))},k,C)}}async n(I,$,k,C){const E=new Set,n=[];if(await I.fireAsync($,C,async(a,m)=>{const v=Date.now(),D=await Promise.resolve(a);D instanceof f.$VJ&&(n.push([m.extension,D]),E.add(m.extension.displayName??m.extension.identifier.value)),Date.now()-v>k&&this.k.warn("SLOW file-participant",m.extension.identifier)}),C.isCancellationRequested||n.length===0)return;const o={edits:[]};for(const[,a]of n){const{edits:m}=A.WorkspaceEdit.from(a,{getTextDocumentVersion:v=>this.l.getDocument(v)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(m)}return{edit:o,extensionNames:Array.from(E)}}}e.$_ac=g}),define(Se[302],De([1,0,3,2,5,10,7,33]),function(me,e,S,F,h,L,A,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=void 0;class w{static{this.a=0}constructor($,k){this.extension=$,this.provider=k,this.handle=w.a++}}class g{constructor($){this.session=$,this.responses=[]}}class P{static{this.a=0}constructor($,k,C,E){this.f=C,this.g=E,this.b=new Map,this.d=new Map,this.e=$.getProxy(h.$JJ.MainThreadInlineChat),k.registerApiCommand(new f.$_L("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new f.$0L("Run arguments","",n=>!0,n=>{if(n)return{initialRange:n.initialRange?L.Range.from(n.initialRange):void 0,initialSelection:n.initialSelection?L.Selection.from(n.initialSelection):void 0,message:n.message,autoSend:n.autoSend,position:n.position?L.Position.from(n.position):void 0}})],f.$$L.Void))}registerProvider($,k){const C=new w($,k);return this.b.set(C.handle,C),this.e.$registerInteractiveEditorProvider(C.handle,k.label,$.identifier.value,typeof k.handleInteractiveEditorResponseFeedback=="function"),(0,S.$jb)(()=>{this.e.$unregisterInteractiveEditorProvider(C.handle),this.b.delete(C.handle)})}async $prepareSession($,k,C,E){const n=this.b.get($);if(!n){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const o=this.f.getDocument(F.URI.revive(k)),a=L.Selection.to(C),m=await n.provider.prepareInteractiveEditorSession({document:o,selection:a},E);if(!m)return;if(m.wholeRange&&!m.wholeRange.contains(a))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const v=P.a++;return this.d.set(v,new g(m)),{id:v,placeholder:m.placeholder,slashCommands:m.slashCommands?.map(D=>({command:D.command,detail:D.detail,refer:D.refer,executeImmediately:D.executeImmediately})),wholeRange:L.Range.from(m.wholeRange),message:m.message}}async $provideResponse($,k,C,E){const n=this.b.get($);if(!n)return;const o=this.d.get(k.id);if(!o)return;const a={session:o.session,prompt:C.prompt,selection:L.Selection.to(C.selection),wholeRange:L.Range.to(C.wholeRange),attempt:C.attempt,live:C.live};let m=!1;const v={report:r=>{if(!C.live)throw new Error("Progress reporting is only supported for live sessions");m||E.isCancellationRequested||!r.message&&!r.edits||this.e.$handleProgressChunk(C.requestId,{message:r.message,edits:r.edits?.map(L.TextEdit.from)})}},D=typeof n.provider.provideInteractiveEditorResponse2=="function"?n.provider.provideInteractiveEditorResponse2(a,v,E):n.provider.provideInteractiveEditorResponse(a,E);Promise.resolve(D).finally(()=>m=!0);const t=await D;if(t){const r=o.responses.push(t)-1,s={wholeRange:L.Range.from(t.wholeRange),placeholder:t.placeholder};if(P.h(t))return{...s,id:r,type:"message",message:L.MarkdownString.from(t.contents)};const{edits:i}=t;if(i instanceof A.$VJ)return{...s,id:r,type:"bulkEdit",edits:L.WorkspaceEdit.from(i)};if(Array.isArray(i))return{...s,id:r,type:"editorEdit",edits:i.map(L.TextEdit.from)}}}$handleFeedback($,k,C,E){const n=this.b.get($),o=this.d.get(k),a=o?.responses[C];if(n&&a){let m;switch(E){case 1:m=A.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:m=A.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:m=A.InteractiveEditorResponseFeedbackKind.Undone;break;case 3:m=A.InteractiveEditorResponseFeedbackKind.Accepted;break}n.provider.handleInteractiveEditorResponseFeedback?.(o.session,a,m)}}$releaseSession($,k){const C=this.d.get(k),E=this.b.get($);C&&E&&E.provider.releaseInteractiveEditorSession?.(C.session),this.d.delete(k)}static h($){return typeof $=="object"&&typeof $.contents=="object"}}e.$gcc=P}),define(Se[303],De([1,0,2,33]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ccc=void 0;class h{constructor(A,f,w,g,P){this.a=f,this.b=w,this.c=g;const I=new F.$_L("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$0L("showOptions","Show Options",$=>!0,$=>$),new F.$0L("resource","Interactive resource Uri",$=>!0,$=>$),new F.$0L("controllerId","Notebook controller Id",$=>!0,$=>$),new F.$0L("title","Interactive editor title",$=>!0,$=>$)],new F.$$L("Notebook and input URI",$=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",$.notebookEditorId),$.notebookEditorId!==void 0){const k=this.a.getEditorById($.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:S.URI.revive($.notebookUri),inputUri:S.URI.revive($.inputUri),notebookEditor:k.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",$.notebookUri,$.inputUri),{notebookUri:S.URI.revive($.notebookUri),inputUri:S.URI.revive($.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(A,f,w,g){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:f,lines:[""],languageId:w,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(S.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,f){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$ccc=h}),define(Se[304],De([1,0,5,7]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=void 0;class h{constructor(A){this.a=new Map,this.b=A.getProxy(S.$JJ.MainThreadIssueReporter)}async $getIssueReporterUri(A,f){if(this.a.size===0)throw new Error("No issue request handlers registered");const w=this.a.get(A);if(!w)throw new Error("Issue request handler not found");const g=await w.handleIssueUrlRequest();if(!g)throw new Error("Issue request handler returned no result");return g}registerIssueUriRequestHandler(A,f){const w=A.identifier.value;return this.a.set(w,f),this.b.$registerIssueUriRequestHandler(w),new F.$LJ(()=>{this.b.$unregisterIssueUriRequestHandler(w),this.a.delete(w)})}}e.$icc=h}),define(Se[305],De([1,0,3,5]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vbc=void 0;class h{constructor(A){this.b=0,this.a=A.getProxy(F.$JJ.MainThreadLabelService)}$registerResourceLabelFormatter(A){const f=this.b++;return this.a.$registerResourceLabelFormatter(f,A),(0,S.$jb)(()=>{this.a.$unregisterResourceLabelFormatter(f)})}}e.$vbc=h}),define(Se[306],De([1,0,2,23,10,7,81,5,15,34,18,19,162,22,25,3,128,117,86,37,8,13,27,199]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E,n,o,a,m,v,D,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sac=void 0;class s{constructor(U,Q){this.d=U,this.e=Q}async provideDocumentSymbols(U,Q){const _=this.d.getDocument(U),oe=await this.e.provideDocumentSymbols(_,Q);if(!(0,P.$mf)(oe))return oe[0]instanceof L.$4J?oe.map(h.DocumentSymbol.from):s.f(oe)}static f(U){U=U.slice(0).sort((oe,Z)=>{let le=oe.location.range.start.compareTo(Z.location.range.start);return le===0&&(le=Z.location.range.end.compareTo(oe.location.range.end)),le});const Q=[],_=[];for(const oe of U){const Z={name:oe.name||"!!MISSING: name!!",kind:h.SymbolKind.from(oe.kind),tags:oe.tags?.map(h.SymbolTag.from)||[],detail:"",containerName:oe.containerName,range:h.Range.from(oe.location.range),selectionRange:h.Range.from(oe.location.range),children:[]};for(;;){if(_.length===0){_.push(Z),Q.push(Z);break}const le=_[_.length-1];if(g.$Ur.containsRange(le.range,Z.range)&&!g.$Ur.equalsRange(le.range,Z.range)){le.children?.push(Z),_.push(Z);break}_.pop()}}return Q}}class i{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(U,Q,_){this.g=U,this.h=Q,this.j=_,this.e=new a.$jac("CodeLens"),this.f=new Map}async provideCodeLenses(U,Q){const _=this.g.getDocument(U),oe=await this.j.provideCodeLenses(_,Q);if(!oe||Q.isCancellationRequested)return;const Z=this.e.add(oe),le=new E.$kb;this.f.set(Z,le);const be={cacheId:Z,lenses:[]};for(let ze=0;ze<oe.length;ze++)be.lenses.push({cacheId:[Z,ze],range:h.Range.from(oe[ze].range),command:this.h.toInternal(oe[ze].command,le)});return be}async resolveCodeLens(U,Q){const _=U.cacheId&&this.e.get(...U.cacheId);if(!_)return;let oe;if(typeof this.j.resolveCodeLens!="function"||_.isResolved?oe=_:oe=await this.j.resolveCodeLens(_,Q),oe||(oe=_),Q.isCancellationRequested)return;const Z=U.cacheId&&this.f.get(U.cacheId[0]);if(Z)return U.command=this.h.toInternal(oe.command??i.d,Z),U}releaseCodeLenses(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}}function c(Ie){return Array.isArray(Ie)?Ie.map(h.DefinitionLink.from):Ie?[h.DefinitionLink.from(Ie)]:[]}class l{constructor(U,Q){this.d=U,this.e=Q}async provideDefinition(U,Q,_){const oe=this.d.getDocument(U),Z=h.Position.to(Q),le=await this.e.provideDefinition(oe,Z,_);return c(le)}}class b{constructor(U,Q){this.d=U,this.e=Q}async provideDeclaration(U,Q,_){const oe=this.d.getDocument(U),Z=h.Position.to(Q),le=await this.e.provideDeclaration(oe,Z,_);return c(le)}}class y{constructor(U,Q){this.d=U,this.e=Q}async provideImplementation(U,Q,_){const oe=this.d.getDocument(U),Z=h.Position.to(Q),le=await this.e.provideImplementation(oe,Z,_);return c(le)}}class u{constructor(U,Q){this.d=U,this.e=Q}async provideTypeDefinition(U,Q,_){const oe=this.d.getDocument(U),Z=h.Position.to(Q),le=await this.e.provideTypeDefinition(oe,Z,_);return c(le)}}class d{constructor(U,Q){this.d=U,this.e=Q}async provideHover(U,Q,_){const oe=this.d.getDocument(U),Z=h.Position.to(Q),le=await this.e.provideHover(oe,Z,_);if(!(!le||(0,P.$mf)(le.contents)))return le.range||(le.range=oe.getWordRangeAtPosition(Z)),le.range||(le.range=new L.$NJ(Z,Z)),h.Hover.from(le)}}class p{constructor(U,Q){this.d=U,this.e=Q}async provideEvaluatableExpression(U,Q,_){const oe=this.d.getDocument(U),Z=h.Position.to(Q),le=await this.e.provideEvaluatableExpression(oe,Z,_);if(le)return h.EvaluatableExpression.from(le)}}class R{constructor(U,Q){this.d=U,this.e=Q}async provideInlineValues(U,Q,_,oe){const Z=this.d.getDocument(U),le=await this.e.provideInlineValues(Z,h.Range.to(Q),h.InlineValueContext.to(_),oe);if(Array.isArray(le))return le.map(be=>h.InlineValue.from(be))}}class O{constructor(U,Q){this.d=U,this.e=Q}async provideDocumentHighlights(U,Q,_){const oe=this.d.getDocument(U),Z=h.Position.to(Q),le=await this.e.provideDocumentHighlights(oe,Z,_);if(Array.isArray(le))return le.map(h.DocumentHighlight.from)}}class j{constructor(U,Q){this.d=U,this.e=Q}async provideLinkedEditingRanges(U,Q,_){const oe=this.d.getDocument(U),Z=h.Position.to(Q),le=await this.e.provideLinkedEditingRanges(oe,Z,_);if(le&&Array.isArray(le.ranges))return{ranges:(0,P.$jf)(le.ranges.map(h.Range.from)),wordPattern:le.wordPattern}}}class T{constructor(U,Q){this.d=U,this.e=Q}async provideReferences(U,Q,_,oe){const Z=this.d.getDocument(U),le=h.Position.to(Q),be=await this.e.provideReferences(Z,le,_,oe);if(Array.isArray(be))return be.map(h.location.from)}}class z{static{this.d=1e3}constructor(U,Q,_,oe,Z,le,be){this.h=U,this.j=Q,this.k=_,this.l=oe,this.m=Z,this.n=le,this.o=be,this.e=new a.$jac("CodeAction"),this.f=new Map,this.g=new L.$6J("notebook")}async provideCodeActions(U,Q,_,oe){const Z=this.h.getDocument(U),le=$.$3r.isISelection(Q)?h.Selection.to(Q):h.Range.to(Q),be=[];for(const et of this.k.getDiagnostics(U))if(le.intersection(et.range)&&be.push(et)>z.d)break;const ze={diagnostics:be,only:_.only?new L.$6J(_.only):void 0,triggerKind:h.CodeActionTriggerKind.to(_.trigger)},qe=await this.l.provideCodeActions(Z,le,ze,oe);if(!(0,P.$nf)(qe)||oe.isCancellationRequested)return;const _e=this.e.add(qe),Ze=new E.$kb;this.f.set(_e,Ze);const it=[];for(let et=0;et<qe.length;et++){const Pe=qe[et];if(Pe)if(z.p(Pe))this.o.report("CodeActionProvider.provideCodeActions - return commands",this.n,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Pe.title,command:this.j.toInternal(Pe,Ze)});else{if(ze.triggerKind!==L.CodeActionTriggerKind.Invoke&&Pe.kind&&this.g.contains(Pe.kind))continue;ze.only&&(Pe.kind?ze.only.contains(Pe.kind)||this.m.warn(`${this.n.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action is of kind '${Pe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.m.warn(`${this.n.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[_e,et],title:Pe.title,command:Pe.command&&this.j.toInternal(Pe.command,Ze),diagnostics:Pe.diagnostics&&Pe.diagnostics.map(h.Diagnostic.from),edit:Pe.edit&&h.WorkspaceEdit.from(Pe.edit,void 0),kind:Pe.kind&&Pe.kind.value,isPreferred:Pe.isPreferred,disabled:Pe.disabled?.reason})}}return{cacheId:_e,actions:it}}async resolveCodeAction(U,Q){const[_,oe]=U,Z=this.e.get(_,oe);if(!Z||z.p(Z))return{};if(!this.l.resolveCodeAction)return{};const le=await this.l.resolveCodeAction(Z,Q)??Z;let be;le.edit&&(be=h.WorkspaceEdit.from(le.edit,void 0));let ze;if(le.command){const qe=this.f.get(_);qe&&(ze=this.j.toInternal(le.command,qe))}return{edit:be,command:ze}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static p(U){return typeof U.command=="string"&&typeof U.title=="string"}}class B{static toInternalProviderId(U,Q){return U+"."+Q}constructor(U,Q,_,oe,Z){this.d=U,this.e=Q,this.f=_,this.g=oe,this.h=Z}async prepareDocumentPaste(U,Q,_,oe){if(!this.f.prepareDocumentPaste)return;const Z=this.e.getDocument(U),le=Q.map(qe=>h.Range.to(qe)),be=h.DataTransfer.toDataTransfer(_,()=>{throw new v.$0});if(await this.f.prepareDocumentPaste(Z,le,be,oe),oe.isCancellationRequested)return;const ze=Array.from(be).filter(([,qe])=>!(qe instanceof L.$AK));return h.DataTransfer.from(ze)}async providePasteEdits(U,Q,_,oe,Z){if(!this.f.provideDocumentPasteEdits)return;const le=this.e.getDocument(Q),be=_.map(_e=>h.Range.to(_e)),ze=h.DataTransfer.toDataTransfer(oe,async _e=>(await this.d.$resolvePasteFileData(this.g,U,_e)).buffer),qe=await this.f.provideDocumentPasteEdits(le,be,ze,Z);if(qe)return{label:qe.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:qe.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:B.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof qe.insertText=="string"?qe.insertText:{snippet:qe.insertText.value},additionalEdit:qe.additionalEdit?h.WorkspaceEdit.from(qe.additionalEdit,void 0):void 0}}}class M{constructor(U,Q){this.d=U,this.e=Q}async provideDocumentFormattingEdits(U,Q,_){const oe=this.d.getDocument(U),Z=await this.e.provideDocumentFormattingEdits(oe,Q,_);if(Array.isArray(Z))return Z.map(h.TextEdit.from)}}class Y{constructor(U,Q){this.d=U,this.e=Q}async provideDocumentRangeFormattingEdits(U,Q,_,oe){const Z=this.d.getDocument(U),le=h.Range.to(Q),be=await this.e.provideDocumentRangeFormattingEdits(Z,le,_,oe);if(Array.isArray(be))return be.map(h.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,Q,_,oe){(0,I.$se)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Z=this.d.getDocument(U),le=Q.map(h.Range.to),be=await this.e.provideDocumentRangesFormattingEdits(Z,le,_,oe);if(Array.isArray(be))return be.map(h.TextEdit.from)}}class J{constructor(U,Q){this.d=U,this.e=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,Q,_,oe,Z){const le=this.d.getDocument(U),be=h.Position.to(Q),ze=await this.e.provideOnTypeFormattingEdits(le,be,_,oe,Z);if(Array.isArray(ze))return ze.map(h.TextEdit.from)}}class fe{constructor(U,Q){this.e=U,this.f=Q,this.d=new a.$jac("WorkspaceSymbols")}async provideWorkspaceSymbols(U,Q){const _=await this.e.provideWorkspaceSymbols(U,Q);if(!(0,P.$nf)(_))return{symbols:[]};const oe=this.d.add(_),Z={cacheId:oe,symbols:[]};for(let le=0;le<_.length;le++){const be=_[le];if(!be||!be.name){this.f.warn("INVALID SymbolInformation",be);continue}Z.symbols.push({...h.WorkspaceSymbol.from(be),cacheId:[oe,le]})}return Z}async resolveWorkspaceSymbol(U,Q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const _=this.d.get(...U.cacheId);if(_){const oe=await this.e.resolveWorkspaceSymbol(_,Q);return oe&&(0,F.$Lm)(U,h.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class se{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,Q,_){this.d=U,this.e=Q,this.f=_}async provideRenameEdits(U,Q,_,oe){const Z=this.d.getDocument(U),le=h.Position.to(Q);try{const be=await this.e.provideRenameEdits(Z,le,_,oe);return be?h.WorkspaceEdit.from(be):void 0}catch(be){const ze=se.g(be);return ze?{rejectReason:ze,edits:void 0}:Promise.reject(be)}}async resolveRenameLocation(U,Q,_){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const oe=this.d.getDocument(U),Z=h.Position.to(Q);try{const le=await this.e.prepareRename(oe,Z,_);let be,ze;if(L.$NJ.isRange(le)?(be=le,ze=oe.getText(le)):(0,I.$ke)(le)&&(be=le.range,ze=le.placeholder),!be||!ze)return;if(be.start.line>Z.line||be.end.line<Z.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:h.Range.from(be),text:ze}}catch(le){const be=se.g(le);return be?{rejectReason:be,range:void 0,text:void 0}:Promise.reject(le)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class ie{constructor(U,Q){this.resultId=U,this.tokens=Q}}class V{constructor(U,Q){this.f=U,this.g=Q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,Q,_){const oe=this.f.getDocument(U),Z=Q!==0?this.d.get(Q):null;let le=typeof Z?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(oe,Z.resultId,_):await this.g.provideDocumentSemanticTokens(oe,_);return Z&&this.d.delete(Q),le?(le=V.h(le),this.o(V.n(Z,le),le)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return V.j(U)?V.k(U)?U:new L.$4K(new Uint32Array(U.data),U.resultId):V.l(U)?V.m(U)?U:new L.$6K(U.edits.map(Q=>new L.$5K(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const Q of U.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static n(U,Q){if(!V.j(Q)||!U||!U.tokens)return Q;const _=U.tokens,oe=_.length,Z=Q.data,le=Z.length;let be=0;const ze=Math.min(oe,le);for(;be<ze&&_[be]===Z[be];)be++;if(be===oe&&be===le)return new L.$6K([],Q.resultId);let qe=0;const _e=ze-be;for(;qe<_e&&_[oe-qe-1]===Z[le-qe-1];)qe++;return new L.$6K([{start:be,deleteCount:oe-be-qe,data:Z.subarray(be,le-qe)}],Q.resultId)}o(U,Q){if(V.j(U)){const _=this.e++;return this.d.set(_,new ie(U.resultId,U.data)),(0,n.$49)({id:_,type:"full",data:U.data})}if(V.l(U)){const _=this.e++;return V.j(Q)?this.d.set(_,new ie(Q.resultId,Q.data)):this.d.set(_,new ie(U.resultId)),(0,n.$49)({id:_,type:"delta",deltas:(U.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}class re{constructor(U,Q){this.d=U,this.e=Q}async provideDocumentRangeSemanticTokens(U,Q,_){const oe=this.d.getDocument(U),Z=await this.e.provideDocumentRangeSemanticTokens(oe,h.Range.to(Q),_);return Z?this.f(Z):null}f(U){return(0,n.$49)({id:0,type:"full",data:U.data})}}class pe{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,Q,_,oe,Z){this.f=U,this.g=Q,this.h=_,this.j=oe,this.k=Z,this.d=new a.$jac("CompletionItem"),this.e=new Map}async provideCompletionItems(U,Q,_,oe){const Z=this.f.getDocument(U),le=h.Position.to(Q),be=Z.getWordRangeAtPosition(le)||new L.$NJ(le,le),ze=be.with({end:le}),qe=new m.$ac,_e=await this.h.provideCompletionItems(Z,le,oe,h.CompletionContext.to(_));if(!_e||oe.isCancellationRequested)return;const Ze=Array.isArray(_e)?new L.$hK(_e):_e,it=pe.supportsResolving(this.h)?this.d.add(Ze.items):this.d.add([]),et=new E.$kb;this.e.set(it,et);const Pe=[],Oe={x:it,b:Pe,a:{replace:h.Range.from(be),insert:h.Range.from(ze)},c:Ze.isIncomplete||void 0,d:qe.elapsed()};for(let We=0;We<Ze.items.length;We++){const Re=Ze.items[We],Qe=this.l(Re,[it,We],ze,be);Pe.push(Qe)}return Oe}async resolveCompletionItem(U,Q){if(typeof this.h.resolveCompletionItem!="function")return;const _=this.d.get(...U);if(!_)return;const oe=this.l(_,U),Z=await this.h.resolveCompletionItem(_,Q);if(!Z)return;const le=this.l(Z,U);return(oe.h!==le.h||oe.i!==le.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(oe.n!==le.n||oe.o!==le.o||!(0,F.$Mm)(oe.p,le.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...oe,d:le.d,c:le.c,l:le.l,h:le.h,i:le.i,n:le.n,o:le.o,p:le.p}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,Q,_,oe){const Z=this.e.get(Q[0]);if(!Z)throw Error("DisposableStore is missing...");const le=this.g.toInternal(U.command,Z),be={x:Q,a:U.label,b:U.kind!==void 0?h.CompletionItemKind.from(U.kind):void 0,m:U.tags&&U.tags.map(h.CompletionItemTag.from),c:U.detail,d:typeof U.documentation>"u"?void 0:h.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters?.join(""),l:U.additionalTextEdits&&U.additionalTextEdits.map(h.TextEdit.from),n:le?.$ident,o:le?.id,p:le?.$ident?void 0:le?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),be.h=U.textEdit.newText):typeof U.insertText=="string"?be.h=U.insertText:U.insertText instanceof L.$WJ&&(be.h=U.insertText.value,be.i|=4);let ze;return U.textEdit?ze=U.textEdit.range:U.range&&(ze=U.range),L.$NJ.isRange(ze)?be.j=h.Range.from(ze):ze&&(!_?.isEqual(ze.inserting)||!oe?.isEqual(ze.replacing))&&(be.j={insert:h.Range.from(ze.inserting),replace:h.Range.from(ze.replacing)}),be}}class ae{async provideInlineCompletions(U,Q,_,oe){}disposeCompletions(U){}handleDidShowCompletionItem(U,Q,_){}handlePartialAccept(U,Q,_){}}class ne extends ae{constructor(U,Q,_,oe){super(),this.f=U,this.g=Q,this.h=_,this.j=oe,this.d=new x,this.e=(0,t.$DF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$DF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,Q,_,oe){const Z=this.g.getDocument(U),le=h.Position.to(Q),be=await this.h.provideInlineCompletionItems(Z,le,{selectedCompletionInfo:_.selectedSuggestionInfo?{range:h.Range.to(_.selectedSuggestionInfo.range),text:_.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[_.triggerKind]},oe);if(!be||oe.isCancellationRequested)return;const ze=Array.isArray(be)?be:be.items,qe=this.e?Array.isArray(be)?[]:be.commands||[]:[],_e=this.e&&!Array.isArray(be)?be.enableForwardStability:void 0;let Ze;return{pid:this.d.createReferenceId({dispose(){Ze?.dispose()},items:ze}),items:ze.map((et,Pe)=>{let Oe;et.command&&(Ze||(Ze=new E.$kb),Oe=this.j.toInternal(et.command,Ze));const We=et.insertText;return{insertText:typeof We=="string"?We:{snippet:We.value},filterText:et.filterText,range:et.range?h.Range.from(et.range):void 0,command:Oe,idx:Pe,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:qe.map(et=>(Ze||(Ze=new E.$kb),this.j.toInternal(et,Ze))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,Q,_){const oe=this.d.get(U)?.items[Q];oe&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(oe,_)}handlePartialAccept(U,Q,_){const oe=this.d.get(U)?.items[Q];oe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(oe,_)}}class x{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const Q=this.e++;return this.d.set(Q,U),Q}disposeReferenceId(U){const Q=this.d.get(U);return this.d.delete(U),Q}get(U){return this.d.get(U)}}class N{constructor(U,Q){this.e=U,this.f=Q,this.d=new a.$jac("SignatureHelp")}async provideSignatureHelp(U,Q,_,oe){const Z=this.e.getDocument(U),le=h.Position.to(Q),be=this.g(_),ze=await this.f.provideSignatureHelp(Z,le,oe,be);if(ze){const qe=this.d.add([ze]);return{...h.SignatureHelp.from(ze),id:qe}}}g(U){let Q;if(U.activeSignatureHelp){const _=h.SignatureHelp.to(U.activeSignatureHelp),oe=this.d.get(U.activeSignatureHelp.id,0);oe?(Q=oe,Q.activeSignature=_.activeSignature,Q.activeParameter=_.activeParameter):Q=_}return{...U,activeSignatureHelp:Q}}releaseSignatureHelp(U){this.d.delete(U)}}class q{constructor(U,Q,_,oe,Z){this.f=U,this.g=Q,this.h=_,this.j=oe,this.k=Z,this.d=new a.$jac("InlayHints"),this.e=new Map}async provideInlayHints(U,Q,_){const oe=this.f.getDocument(U),Z=h.Range.to(Q),le=await this.h.provideInlayHints(oe,Z,_);if(!Array.isArray(le)||le.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${Q}`);return}if(_.isCancellationRequested)return;const be=this.d.add(le);this.e.set(be,new E.$kb);const ze={hints:[],cacheId:be};for(let qe=0;qe<le.length;qe++)this.l(le[qe],Z)&&ze.hints.push(this.m(le[qe],[be,qe]));return this.j.trace(`[InlayHints] ${ze.hints.length} inlay hints from '${this.k.identifier.value}' for ${Q}`),ze}async resolveInlayHint(U,Q){if(typeof this.h.resolveInlayHint!="function")return;const _=this.d.get(...U);if(!_)return;const oe=await this.h.resolveInlayHint(_,Q);if(oe&&this.l(oe))return this.m(oe,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,Q){return U.label.length===0||Array.isArray(U.label)&&U.label.every(_=>_.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(Q&&!Q.contains(U.position))}m(U,Q){const _=this.e.get(Q[0]);if(!_)throw Error("DisposableStore is missing...");const oe={label:"",cacheId:Q,tooltip:h.MarkdownString.fromStrict(U.tooltip),position:h.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(h.TextEdit.from),kind:U.kind&&h.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};return typeof U.label=="string"?oe.label=U.label:oe.label=U.label.map(Z=>{const le={label:Z.value};return le.tooltip=h.MarkdownString.fromStrict(Z.tooltip),L.$XJ.isLocation(Z.location)&&(le.location=h.location.from(Z.location)),Z.command&&(le.command=this.g.toInternal(Z.command,_)),le}),oe}}class de{constructor(U,Q){this.e=U,this.f=Q,this.d=new a.$jac("DocumentLink")}async provideLinks(U,Q){const _=this.e.getDocument(U),oe=await this.f.provideDocumentLinks(_,Q);if(!(!Array.isArray(oe)||oe.length===0)&&!Q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:oe.filter(de.g).map(h.DocumentLink.from)};{const Z=this.d.add(oe),le={links:[],cacheId:Z};for(let be=0;be<oe.length;be++){if(!de.g(oe[be]))continue;const ze=h.DocumentLink.from(oe[be]);ze.cacheId=[Z,be],le.links.push(ze)}return le}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,Q){if(typeof this.f.resolveDocumentLink!="function")return;const _=this.d.get(...U);if(!_)return;const oe=await this.f.resolveDocumentLink(_,Q);if(!(!oe||!de.g(oe)))return h.DocumentLink.from(oe)}releaseLinks(U){this.d.delete(U)}}class ye{constructor(U,Q){this.d=U,this.e=Q}async provideColors(U,Q){const _=this.d.getDocument(U),oe=await this.e.provideDocumentColors(_,Q);return Array.isArray(oe)?oe.map(le=>({color:h.Color.from(le.color),range:h.Range.from(le.range)})):[]}async provideColorPresentations(U,Q,_){const oe=this.d.getDocument(U),Z=h.Range.to(Q.range),le=h.Color.to(Q.color),be=await this.e.provideColorPresentations(le,{document:oe,range:Z},_);if(Array.isArray(be))return be.map(h.ColorPresentation.from)}}class ve{constructor(U,Q){this.d=U,this.e=Q}async provideFoldingRanges(U,Q,_){const oe=this.d.getDocument(U),Z=await this.e.provideFoldingRanges(oe,Q,_);if(Array.isArray(Z))return Z.map(h.FoldingRange.from)}}class we{constructor(U,Q,_){this.d=U,this.e=Q,this.f=_}async provideSelectionRanges(U,Q,_){const oe=this.d.getDocument(U),Z=Q.map(h.Position.to),le=await this.e.provideSelectionRanges(oe,Z,_);if(!(0,P.$nf)(le))return[];if(le.length!==Z.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const be=[];for(let ze=0;ze<Z.length;ze++){const qe=[];be.push(qe);let _e=Z[ze],Ze=le[ze];for(;;){if(!Ze.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(qe.push(h.SelectionRange.from(Ze)),!Ze.parent)break;_e=Ze.range,Ze=Ze.parent}}return be}}class Ee{constructor(U,Q){this.f=U,this.g=Q,this.d=new o.$QL(""),this.e=new Map}async prepareSession(U,Q,_){const oe=this.f.getDocument(U),Z=h.Position.to(Q),le=await this.g.prepareCallHierarchy(oe,Z,_);if(!le)return;const be=this.d.nextId();return this.e.set(be,new Map),Array.isArray(le)?le.map(ze=>this.h(be,ze)):[this.h(be,le)]}async provideCallsTo(U,Q,_){const oe=this.j(U,Q);if(!oe)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyIncomingCalls(oe,_);if(Z)return Z.map(le=>({from:this.h(U,le.from),fromRanges:le.fromRanges.map(be=>h.Range.from(be))}))}async provideCallsFrom(U,Q,_){const oe=this.j(U,Q);if(!oe)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyOutgoingCalls(oe,_);if(Z)return Z.map(le=>({to:this.h(U,le.to),fromRanges:le.fromRanges.map(be=>h.Range.from(be))}))}releaseSession(U){this.e.delete(U)}h(U,Q){const _=this.e.get(U),oe=h.CallHierarchyItem.from(Q,U,_.size.toString(36));return _.set(oe._itemId,Q),oe}j(U,Q){return this.e.get(U)?.get(Q)}}class K{constructor(U,Q){this.f=U,this.g=Q,this.d=new o.$QL(""),this.e=new Map}async prepareSession(U,Q,_){const oe=this.f.getDocument(U),Z=h.Position.to(Q),le=await this.g.prepareTypeHierarchy(oe,Z,_);if(!le)return;const be=this.d.nextId();return this.e.set(be,new Map),Array.isArray(le)?le.map(ze=>this.h(be,ze)):[this.h(be,le)]}async provideSupertypes(U,Q,_){const oe=this.j(U,Q);if(!oe)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySupertypes(oe,_);if(Z)return Z.map(le=>this.h(U,le))}async provideSubtypes(U,Q,_){const oe=this.j(U,Q);if(!oe)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySubtypes(oe,_);if(Z)return Z.map(le=>this.h(U,le))}releaseSession(U){this.e.delete(U)}h(U,Q){const _=this.e.get(U),oe=h.TypeHierarchyItem.from(Q,U,_.size.toString(36));return _.set(oe._itemId,Q),oe}j(U,Q){return this.e.get(U)?.get(Q)}}class ee{static toInternalProviderId(U,Q){return U+"."+Q}constructor(U,Q,_,oe,Z){this.d=U,this.e=Q,this.f=_,this.g=oe,this.h=Z}async provideDocumentOnDropEdits(U,Q,_,oe,Z){const le=this.e.getDocument(Q),be=h.Position.to(_),ze=h.DataTransfer.toDataTransfer(oe,async _e=>(await this.d.$resolveDocumentOnDropFileData(this.g,U,_e)).buffer),qe=await this.f.provideDocumentDropEdits(le,be,ze,Z);if(qe)return{label:qe.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:qe.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:ee.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof qe.insertText=="string"?qe.insertText:{snippet:qe.insertText.value},additionalEdit:qe.additionalEdit?h.WorkspaceEdit.from(qe.additionalEdit,void 0):void 0}}}class G{constructor(U,Q){this.d=U,this.e=Q}async provideMappedEdits(U,Q,_,oe){const Z=S.URI.revive(U),le=this.d.getDocument(Z),be={selections:_.selections.map(qe=>h.Selection.to(qe)),related:_.related.map(qe=>({uri:S.URI.revive(qe.uri),range:h.Range.to(qe.range)}))},ze=await this.e.provideMappedEdits(le,Q,be,oe);return ze?h.WorkspaceEdit.from(ze):null}}class X{constructor(U,Q){this.adapter=U,this.extension=Q}}class he{static{this.d=0}constructor(U,Q,_,oe,Z,le,be,ze){this.g=Q,this.h=_,this.j=oe,this.k=Z,this.l=le,this.m=be,this.n=ze,this.f=new Map,this.e=U.getProxy(f.$JJ.MainThreadLanguageFeatures)}o(U,Q){return h.DocumentSelector.from(U,this.g,Q)}p(U){return new L.$LJ(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return he.d++}async t(U,Q,_,oe,Z,le=!1){const be=this.f.get(U);if(!be||!(be.adapter instanceof Q))return oe;const ze=Date.now();le||this.l.trace(`[${be.extension.identifier.value}] INVOKE provider '${_.toString().replace(/[\r\n]/g,"")}'`);const qe=_(be.adapter,be.extension);return Promise.resolve(qe).catch(_e=>{(0,v.$2)(_e)||(this.l.error(`[${be.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(be.extension.identifier,_e))}).finally(()=>{le||this.l.trace(`[${be.extension.identifier.value}] provider DONE after ${Date.now()-ze}ms`)}),k.CancellationToken.isCancellationToken(Z)?(0,D.$kg)(qe,Z):qe}u(U,Q){const _=this.q();return this.f.set(_,new X(U,Q)),_}static w(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,Q,_,oe){const Z=this.u(new s(this.h,_),U),le=oe&&oe.label||he.w(U);return this.e.$registerDocumentSymbolProvider(Z,this.o(Q,U),le),this.p(Z)}$provideDocumentSymbols(U,Q,_){return this.t(U,s,oe=>oe.provideDocumentSymbols(S.URI.revive(Q),_),void 0,_)}registerCodeLensProvider(U,Q,_){const oe=this.q(),Z=typeof _.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(oe,new X(new i(this.h,this.j.converter,_),U)),this.e.$registerCodeLensSupport(oe,this.o(Q,U),Z);let le=this.p(oe);if(Z!==void 0){const be=_.onDidChangeCodeLenses(ze=>this.e.$emitCodeLensEvent(Z));le=L.$LJ.from(le,be)}return le}$provideCodeLenses(U,Q,_){return this.t(U,i,oe=>oe.provideCodeLenses(S.URI.revive(Q),_),void 0,_)}$resolveCodeLens(U,Q,_){return this.t(U,i,oe=>oe.resolveCodeLens(Q,_),void 0,void 0)}$releaseCodeLenses(U,Q){this.t(U,i,_=>Promise.resolve(_.releaseCodeLenses(Q)),void 0,void 0)}registerDefinitionProvider(U,Q,_){const oe=this.u(new l(this.h,_),U);return this.e.$registerDefinitionSupport(oe,this.o(Q,U)),this.p(oe)}$provideDefinition(U,Q,_,oe){return this.t(U,l,Z=>Z.provideDefinition(S.URI.revive(Q),_,oe),[],oe)}registerDeclarationProvider(U,Q,_){const oe=this.u(new b(this.h,_),U);return this.e.$registerDeclarationSupport(oe,this.o(Q,U)),this.p(oe)}$provideDeclaration(U,Q,_,oe){return this.t(U,b,Z=>Z.provideDeclaration(S.URI.revive(Q),_,oe),[],oe)}registerImplementationProvider(U,Q,_){const oe=this.u(new y(this.h,_),U);return this.e.$registerImplementationSupport(oe,this.o(Q,U)),this.p(oe)}$provideImplementation(U,Q,_,oe){return this.t(U,y,Z=>Z.provideImplementation(S.URI.revive(Q),_,oe),[],oe)}registerTypeDefinitionProvider(U,Q,_){const oe=this.u(new u(this.h,_),U);return this.e.$registerTypeDefinitionSupport(oe,this.o(Q,U)),this.p(oe)}$provideTypeDefinition(U,Q,_,oe){return this.t(U,u,Z=>Z.provideTypeDefinition(S.URI.revive(Q),_,oe),[],oe)}registerHoverProvider(U,Q,_,oe){const Z=this.u(new d(this.h,_),U);return this.e.$registerHoverProvider(Z,this.o(Q,U)),this.p(Z)}$provideHover(U,Q,_,oe){return this.t(U,d,Z=>Z.provideHover(S.URI.revive(Q),_,oe),void 0,oe)}registerEvaluatableExpressionProvider(U,Q,_,oe){const Z=this.u(new p(this.h,_),U);return this.e.$registerEvaluatableExpressionProvider(Z,this.o(Q,U)),this.p(Z)}$provideEvaluatableExpression(U,Q,_,oe){return this.t(U,p,Z=>Z.provideEvaluatableExpression(S.URI.revive(Q),_,oe),void 0,oe)}registerInlineValuesProvider(U,Q,_,oe){const Z=typeof _.onDidChangeInlineValues=="function"?this.q():void 0,le=this.u(new R(this.h,_),U);this.e.$registerInlineValuesProvider(le,this.o(Q,U),Z);let be=this.p(le);if(Z!==void 0){const ze=_.onDidChangeInlineValues(qe=>this.e.$emitInlineValuesEvent(Z));be=L.$LJ.from(be,ze)}return be}$provideInlineValues(U,Q,_,oe,Z){return this.t(U,R,le=>le.provideInlineValues(S.URI.revive(Q),_,oe,Z),void 0,Z)}registerDocumentHighlightProvider(U,Q,_){const oe=this.u(new O(this.h,_),U);return this.e.$registerDocumentHighlightProvider(oe,this.o(Q,U)),this.p(oe)}$provideDocumentHighlights(U,Q,_,oe){return this.t(U,O,Z=>Z.provideDocumentHighlights(S.URI.revive(Q),_,oe),void 0,oe)}registerLinkedEditingRangeProvider(U,Q,_){const oe=this.u(new j(this.h,_),U);return this.e.$registerLinkedEditingRangeProvider(oe,this.o(Q,U)),this.p(oe)}$provideLinkedEditingRanges(U,Q,_,oe){return this.t(U,j,async Z=>{const le=await Z.provideLinkedEditingRanges(S.URI.revive(Q),_,oe);if(le)return{ranges:le.ranges,wordPattern:le.wordPattern?he.y(le.wordPattern):void 0}},void 0,oe)}registerReferenceProvider(U,Q,_){const oe=this.u(new T(this.h,_),U);return this.e.$registerReferenceSupport(oe,this.o(Q,U)),this.p(oe)}$provideReferences(U,Q,_,oe,Z){return this.t(U,T,le=>le.provideReferences(S.URI.revive(Q),_,oe,Z),void 0,Z)}registerCodeActionProvider(U,Q,_,oe){const Z=new E.$kb,le=this.u(new z(this.h,this.j.converter,this.k,_,this.l,U,this.m),U);return this.e.$registerQuickFixSupport(le,this.o(Q,U),{providedKinds:oe?.providedCodeActionKinds?.map(be=>be.value),documentation:oe?.documentation?.map(be=>({kind:be.kind.value,command:this.j.converter.toInternal(be.command,Z)}))},he.w(U),!!_.resolveCodeAction),Z.add(this.p(le)),Z}$provideCodeActions(U,Q,_,oe,Z){return this.t(U,z,le=>le.provideCodeActions(S.URI.revive(Q),_,oe,Z),void 0,Z)}$resolveCodeAction(U,Q,_){return this.t(U,z,oe=>oe.resolveCodeAction(Q,_),{},void 0)}$releaseCodeActions(U,Q){this.t(U,z,_=>Promise.resolve(_.releaseCodeActions(Q)),void 0,void 0)}registerDocumentFormattingEditProvider(U,Q,_){const oe=this.u(new M(this.h,_),U);return this.e.$registerDocumentFormattingSupport(oe,this.o(Q,U),U.identifier,U.displayName||U.name),this.p(oe)}$provideDocumentFormattingEdits(U,Q,_,oe){return this.t(U,M,Z=>Z.provideDocumentFormattingEdits(S.URI.revive(Q),_,oe),void 0,oe)}registerDocumentRangeFormattingEditProvider(U,Q,_){const oe=typeof _.provideDocumentRangesFormattingEdits=="function",Z=this.u(new Y(this.h,_),U);return this.e.$registerRangeFormattingSupport(Z,this.o(Q,U),U.identifier,U.displayName||U.name,oe),this.p(Z)}$provideDocumentRangeFormattingEdits(U,Q,_,oe,Z){return this.t(U,Y,le=>le.provideDocumentRangeFormattingEdits(S.URI.revive(Q),_,oe,Z),void 0,Z)}$provideDocumentRangesFormattingEdits(U,Q,_,oe,Z){return this.t(U,Y,le=>le.provideDocumentRangesFormattingEdits(S.URI.revive(Q),_,oe,Z),void 0,Z)}registerOnTypeFormattingEditProvider(U,Q,_,oe){const Z=this.u(new J(this.h,_),U);return this.e.$registerOnTypeFormattingSupport(Z,this.o(Q,U),oe,U.identifier),this.p(Z)}$provideOnTypeFormattingEdits(U,Q,_,oe,Z,le){return this.t(U,J,be=>be.provideOnTypeFormattingEdits(S.URI.revive(Q),_,oe,Z,le),void 0,le)}registerWorkspaceSymbolProvider(U,Q){const _=this.u(new fe(Q,this.l),U);return this.e.$registerNavigateTypeSupport(_,typeof Q.resolveWorkspaceSymbol=="function"),this.p(_)}$provideWorkspaceSymbols(U,Q,_){return this.t(U,fe,oe=>oe.provideWorkspaceSymbols(Q,_),{symbols:[]},_)}$resolveWorkspaceSymbol(U,Q,_){return this.t(U,fe,oe=>oe.resolveWorkspaceSymbol(Q,_),void 0,void 0)}$releaseWorkspaceSymbols(U,Q){this.t(U,fe,_=>_.releaseWorkspaceSymbols(Q),void 0,void 0)}registerRenameProvider(U,Q,_){const oe=this.u(new se(this.h,_,this.l),U);return this.e.$registerRenameSupport(oe,this.o(Q,U),se.supportsResolving(_)),this.p(oe)}$provideRenameEdits(U,Q,_,oe,Z){return this.t(U,se,le=>le.provideRenameEdits(S.URI.revive(Q),_,oe,Z),void 0,Z)}$resolveRenameLocation(U,Q,_,oe){return this.t(U,se,Z=>Z.resolveRenameLocation(S.URI.revive(Q),_,oe),void 0,oe)}registerDocumentSemanticTokensProvider(U,Q,_,oe){const Z=this.u(new V(this.h,_),U),le=typeof _.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Z,this.o(Q,U),oe,le);let be=this.p(Z);if(le){const ze=_.onDidChangeSemanticTokens(qe=>this.e.$emitDocumentSemanticTokensEvent(le));be=L.$LJ.from(be,ze)}return be}$provideDocumentSemanticTokens(U,Q,_,oe){return this.t(U,V,Z=>Z.provideDocumentSemanticTokens(S.URI.revive(Q),_,oe),null,oe)}$releaseDocumentSemanticTokens(U,Q){this.t(U,V,_=>_.releaseDocumentSemanticColoring(Q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,Q,_,oe){const Z=this.u(new re(this.h,_),U);return this.e.$registerDocumentRangeSemanticTokensProvider(Z,this.o(Q,U),oe),this.p(Z)}$provideDocumentRangeSemanticTokens(U,Q,_,oe){return this.t(U,re,Z=>Z.provideDocumentRangeSemanticTokens(S.URI.revive(Q),_,oe),null,oe)}registerCompletionItemProvider(U,Q,_,oe){const Z=this.u(new pe(this.h,this.j.converter,_,this.m,U),U);return this.e.$registerCompletionsProvider(Z,this.o(Q,U),oe,pe.supportsResolving(_),U.identifier),this.p(Z)}$provideCompletionItems(U,Q,_,oe,Z){return this.t(U,pe,le=>le.provideCompletionItems(S.URI.revive(Q),_,oe,Z),void 0,Z)}$resolveCompletionItem(U,Q,_){return this.t(U,pe,oe=>oe.resolveCompletionItem(Q,_),void 0,_)}$releaseCompletionItems(U,Q){this.t(U,pe,_=>_.releaseCompletionItems(Q),void 0,void 0)}registerInlineCompletionsProvider(U,Q,_,oe){const Z=new ne(U,this.h,_,this.j.converter),le=this.u(Z,U);return this.e.$registerInlineCompletionsSupport(le,this.o(Q,U),Z.supportsHandleEvents,C.$Il.toKey(U.identifier.value),oe?.yieldTo?.map(be=>C.$Il.toKey(be))||[]),this.p(le)}$provideInlineCompletions(U,Q,_,oe,Z){return this.t(U,ae,le=>le.provideInlineCompletions(S.URI.revive(Q),_,oe,Z),void 0,Z)}$handleInlineCompletionDidShow(U,Q,_,oe){this.t(U,ae,async Z=>{Z.handleDidShowCompletionItem(Q,_,oe)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,Q,_,oe){this.t(U,ae,async Z=>{Z.handlePartialAccept(Q,_,oe)},void 0,void 0)}$freeInlineCompletionsList(U,Q){this.t(U,ae,async _=>{_.disposeCompletions(Q)},void 0,void 0)}registerSignatureHelpProvider(U,Q,_,oe){const Z=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,le=this.u(new N(this.h,_),U);return this.e.$registerSignatureHelpProvider(le,this.o(Q,U),Z),this.p(le)}$provideSignatureHelp(U,Q,_,oe,Z){return this.t(U,N,le=>le.provideSignatureHelp(S.URI.revive(Q),_,oe,Z),void 0,Z)}$releaseSignatureHelp(U,Q){this.t(U,N,_=>_.releaseSignatureHelp(Q),void 0,void 0)}registerInlayHintsProvider(U,Q,_){const oe=typeof _.onDidChangeInlayHints=="function"?this.q():void 0,Z=this.u(new q(this.h,this.j.converter,_,this.l,U),U);this.e.$registerInlayHintsProvider(Z,this.o(Q,U),typeof _.resolveInlayHint=="function",oe,he.w(U));let le=this.p(Z);if(oe!==void 0){const be=_.onDidChangeInlayHints(ze=>this.e.$emitInlayHintsEvent(oe));le=L.$LJ.from(le,be)}return le}$provideInlayHints(U,Q,_,oe){return this.t(U,q,Z=>Z.provideInlayHints(S.URI.revive(Q),_,oe),void 0,oe)}$resolveInlayHint(U,Q,_){return this.t(U,q,oe=>oe.resolveInlayHint(Q,_),void 0,_)}$releaseInlayHints(U,Q){this.t(U,q,_=>_.releaseHints(Q),void 0,void 0)}registerDocumentLinkProvider(U,Q,_){const oe=this.u(new de(this.h,_),U);return this.e.$registerDocumentLinkProvider(oe,this.o(Q,U),typeof _.resolveDocumentLink=="function"),this.p(oe)}$provideDocumentLinks(U,Q,_){return this.t(U,de,oe=>oe.provideLinks(S.URI.revive(Q),_),void 0,_,Q.scheme==="output")}$resolveDocumentLink(U,Q,_){return this.t(U,de,oe=>oe.resolveLink(Q,_),void 0,void 0,!0)}$releaseDocumentLinks(U,Q){this.t(U,de,_=>_.releaseLinks(Q),void 0,void 0,!0)}registerColorProvider(U,Q,_){const oe=this.u(new ye(this.h,_),U);return this.e.$registerDocumentColorProvider(oe,this.o(Q,U)),this.p(oe)}$provideDocumentColors(U,Q,_){return this.t(U,ye,oe=>oe.provideColors(S.URI.revive(Q),_),[],_)}$provideColorPresentations(U,Q,_,oe){return this.t(U,ye,Z=>Z.provideColorPresentations(S.URI.revive(Q),_,oe),void 0,oe)}registerFoldingRangeProvider(U,Q,_){const oe=this.q(),Z=typeof _.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(oe,new X(new ve(this.h,_),U)),this.e.$registerFoldingRangeProvider(oe,this.o(Q,U),U.identifier,Z);let le=this.p(oe);if(Z!==void 0){const be=_.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Z));le=L.$LJ.from(le,be)}return le}$provideFoldingRanges(U,Q,_,oe){return this.t(U,ve,Z=>Z.provideFoldingRanges(S.URI.revive(Q),_,oe),void 0,oe)}registerSelectionRangeProvider(U,Q,_){const oe=this.u(new we(this.h,_,this.l),U);return this.e.$registerSelectionRangeProvider(oe,this.o(Q,U)),this.p(oe)}$provideSelectionRanges(U,Q,_,oe){return this.t(U,we,Z=>Z.provideSelectionRanges(S.URI.revive(Q),_,oe),[],oe)}registerCallHierarchyProvider(U,Q,_){const oe=this.u(new Ee(this.h,_),U);return this.e.$registerCallHierarchyProvider(oe,this.o(Q,U)),this.p(oe)}$prepareCallHierarchy(U,Q,_,oe){return this.t(U,Ee,Z=>Promise.resolve(Z.prepareSession(S.URI.revive(Q),_,oe)),void 0,oe)}$provideCallHierarchyIncomingCalls(U,Q,_,oe){return this.t(U,Ee,Z=>Z.provideCallsTo(Q,_,oe),void 0,oe)}$provideCallHierarchyOutgoingCalls(U,Q,_,oe){return this.t(U,Ee,Z=>Z.provideCallsFrom(Q,_,oe),void 0,oe)}$releaseCallHierarchy(U,Q){this.t(U,Ee,_=>Promise.resolve(_.releaseSession(Q)),void 0,void 0)}registerTypeHierarchyProvider(U,Q,_){const oe=this.u(new K(this.h,_),U);return this.e.$registerTypeHierarchyProvider(oe,this.o(Q,U)),this.p(oe)}$prepareTypeHierarchy(U,Q,_,oe){return this.t(U,K,Z=>Promise.resolve(Z.prepareSession(S.URI.revive(Q),_,oe)),void 0,oe)}$provideTypeHierarchySupertypes(U,Q,_,oe){return this.t(U,K,Z=>Z.provideSupertypes(Q,_,oe),void 0,oe)}$provideTypeHierarchySubtypes(U,Q,_,oe){return this.t(U,K,Z=>Z.provideSubtypes(Q,_,oe),void 0,oe)}$releaseTypeHierarchy(U,Q){this.t(U,K,_=>Promise.resolve(_.releaseSession(Q)),void 0,void 0)}registerDocumentOnDropEditProvider(U,Q,_,oe){const Z=this.q();this.f.set(Z,new X(new ee(this.e,this.h,_,Z,U),U));const le=(0,t.$DF)(U,"dropMetadata")&&oe?ee.toInternalProviderId(U.identifier.value,oe.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Z,this.o(Q,U),le,(0,t.$DF)(U,"dropMetadata")?oe:void 0),this.p(Z)}$provideDocumentOnDropEdits(U,Q,_,oe,Z,le){return this.t(U,ee,be=>Promise.resolve(be.provideDocumentOnDropEdits(Q,S.URI.revive(_),oe,Z,le)),void 0,void 0)}registerMappedEditsProvider(U,Q,_){const oe=this.u(new G(this.h,_),U);return this.e.$registerMappedEditsProvider(oe,this.o(Q,U)),this.p(oe)}$provideMappedEdits(U,Q,_,oe,Z){return this.t(U,G,le=>Promise.resolve(le.provideMappedEdits(Q,_,oe,Z)),null,Z)}registerDocumentPasteEditProvider(U,Q,_,oe){const Z=this.q();this.f.set(Z,new X(new B(this.e,this.h,_,Z,U),U));const le=B.toInternalProviderId(U.identifier.value,oe.id);return this.e.$registerPasteEditProvider(Z,this.o(Q,U),le,{supportsCopy:!!_.prepareDocumentPaste,supportsPaste:!!_.provideDocumentPasteEdits,copyMimeTypes:oe.copyMimeTypes,pasteMimeTypes:oe.pasteMimeTypes}),this.p(Z)}$prepareDocumentPaste(U,Q,_,oe,Z){return this.t(U,B,le=>le.prepareDocumentPaste(S.URI.revive(Q),_,oe,Z),void 0,Z)}$providePasteEdits(U,Q,_,oe,Z,le){return this.t(U,B,be=>be.providePasteEdits(Q,S.URI.revive(_),oe,Z,le),void 0,le)}static y(U){return{pattern:U.source,flags:U.flags}}static z(U){return{decreaseIndentPattern:he.y(U.decreaseIndentPattern),increaseIndentPattern:he.y(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?he.y(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?he.y(U.unIndentedLinePattern):void 0}}static B(U){return{beforeText:he.y(U.beforeText),afterText:U.afterText?he.y(U.afterText):void 0,previousLineText:U.previousLineText?he.y(U.previousLineText):void 0,action:U.action}}static C(U){return U.map(he.B)}setLanguageConfiguration(U,Q,_){const{wordPattern:oe}=_;if(oe&&(0,w.$yd)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this.h.setWordDefinitionFor(Q,oe):this.h.setWordDefinitionFor(Q,void 0),_.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),_.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use."),_.autoClosingPairs&&(0,t.$EF)(U,"languageConfigurationAutoClosingPairs");const Z=this.q(),le={comments:_.comments,brackets:_.brackets,wordPattern:_.wordPattern?he.y(_.wordPattern):void 0,indentationRules:_.indentationRules?he.z(_.indentationRules):void 0,onEnterRules:_.onEnterRules?he.C(_.onEnterRules):void 0,__electricCharacterSupport:_.__electricCharacterSupport,__characterPairSupport:_.__characterPairSupport,autoClosingPairs:_.autoClosingPairs};return this.e.$setLanguageConfiguration(Z,Q,le),this.p(Z)}$setWordDefinitions(U){for(const Q of U)this.h.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.$sac=he}),define(Se[307],De([1,0,5,10,7,40,13,3]),function(me,e,S,F,h,L,A,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$abc=void 0;class w{constructor(P,I,$,k){this.c=I,this.d=$,this.e=k,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(S.$JJ.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,I){await this.a.$changeLanguage(P,I);const $=this.c.getDocumentData(P);if(!$)throw new Error(`document '${P.toString()}' NOT found`);return $.document}async tokenAtPosition(P,I){const $=P.version,k=F.Position.from(I),C=await this.a.$tokensAtPosition(P.uri,k),E={type:h.StandardTokenType.Other,range:P.getWordRangeAtPosition(I)??new h.$NJ(I.line,I.character,I.line,I.character)};if(!C)return E;const n={range:F.Range.to(C.range),type:F.TokenType.to(C.type)};return!n.range.contains(I)||$!==P.version?E:n}createLanguageStatusItem(P,I,$){const k=this.f++,C=this.a,E=this.g,n=`${P.identifier.value}/${I}`;if(E.has(n))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);E.add(n);const o={selector:$,id:I,name:P.displayName??P.name,severity:h.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let a;const m=new f.$kb,v=()=>{if(a?.dispose(),!E.has(n)){console.warn(`LanguageStatusItem (${I}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}a=(0,A.$wg)(()=>{m.clear(),this.a.$setLanguageStatus(k,{id:n,name:o.name??P.displayName??P.name,source:P.displayName??P.name,selector:F.DocumentSelector.from(o.selector,this.e),label:o.text,detail:o.detail??"",severity:o.severity===h.LanguageStatusSeverity.Error?L.default.Error:o.severity===h.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:o.command&&this.d.toInternal(o.command,m),accessibilityInfo:o.accessibilityInformation,busy:o.busy})},0)},D={dispose(){m.dispose(),a?.dispose(),C.$removeLanguageStatus(k),E.delete(n)},get id(){return o.id},get name(){return o.name},set name(t){o.name=t,v()},get selector(){return o.selector},set selector(t){o.selector=t,v()},get text(){return o.text},set text(t){o.text=t,v()},get detail(){return o.detail},set detail(t){o.detail=t,v()},get severity(){return o.severity},set severity(t){o.severity=t,v()},get accessibilityInformation(){return o.accessibilityInformation},set accessibilityInformation(t){o.accessibilityInformation=t,v()},get command(){return o.command},set command(t){o.command=t,v()},get busy(){return o.busy},set busy(t){o.busy=t,v()}};return v(),D}}e.$abc=w}),define(Se[111],De([1,0,9,15,2,6,17,5,26,20]),function(me,e,S,F,h,L,A,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ac=e.$2ac=void 0;let P=class{constructor($,k,C){this.f=C,this.d=new Map,this.a=k.getProxy(f.$JJ.MainThreadLocalization),this.b=$.environment.appLanguage,this.c=this.b===S.$f}getMessage($,k){const{message:C,args:E,comment:n}=k;if(this.c)return(0,F.$nd)(C,E??{});let o=C;n&&n.length>0&&(o+=`/${Array.isArray(n)?n.join(""):n}`);const a=this.d.get($)?.contents[o];return a||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,F.$nd)(a??C,E??{})}getBundle($){return this.d.get($)?.contents}getBundleUri($){return this.d.get($)?.uri}async initializeLocalizedMessages($){if(this.c||!$.l10n&&!$.isBuiltin||this.d.has($.identifier.value))return;let k;const C=await this.g($);if(!C){this.f.error(`No bundle location found for extension ${$.identifier.value}`);return}try{const E=await this.a.$fetchBundleContents(C),n=JSON.parse(E);k=$.isBuiltin?n.contents?.bundle:n}catch(E){this.f.error(`Failed to load translations for ${$.identifier.value} from ${C}: ${E.message}`);return}k&&this.d.set($.identifier.value,{contents:k,uri:C})}async g($){if($.isBuiltin){const k=await this.a.$fetchBuiltInBundleUri($.identifier.value,this.b);return h.URI.revive(k)}return $.l10n?h.URI.joinPath($.extensionLocation,$.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$2ac=P,e.$2ac=P=Je([Be(0,w.$2L),Be(1,g.$LL),Be(2,A.$Ri)],P),e.$3ac=(0,L.$ph)("IExtHostLocalizationService")}),define(Se[147],De([1,0,17,5,26,20,2,77]),function(me,e,S,F,h,L,A,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=void 0;let w=class extends S.$3i{constructor(I,$){super($.logLevel,$.logsLocation,$.loggers.map(k=>(0,f.$Yg)(k))),this.n=I.getProxy(F.$JJ.MainThreadLogger)}$setLogLevel(I,$){$?this.setLogLevel(A.URI.revive($),I):this.setLogLevel(I)}setVisibility(I,$){super.setVisibility(I,$),this.n.$setVisibility(I,$)}m(I,$,k){return new g(this.n,I,$,k)}};e.$qcc=w,e.$qcc=w=Je([Be(0,L.$LL),Be(1,h.$2L)],w);class g extends S.$Xi{constructor(I,$,k,C){super(C?.logLevel==="always"),this.m=I,this.n=$,this.k=!1,this.l=[],this.setLevel(k),this.m.$createLogger($,C).then(()=>{this.r(this.l),this.k=!0})}g(I,$){const k=[[I,$]];this.k?this.r(k):this.l.push(...k)}r(I){this.m.$log(this.n,I)}flush(){this.m.$flush(this.n)}}}),define(Se[112],De([1,0,5,6,3,20,21]),function(me,e,S,F,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ac=e.$4ac=void 0,e.$4ac=(0,F.$ph)("IExtHostManagedSockets");let f=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(S.$JJ.MainThreadManagedSockets)}setFactory(I,$){for(const k of this.d.values())k.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new w(I,$),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const $=++this.b,k=await this.c.makeConnection(),C=new h.$kb;return this.d.set($,new g($,k,C)),C.add((0,h.$jb)(()=>this.d.delete($))),C.add(k.onDidEnd(()=>{this.a.$onDidManagedSocketEnd($),C.dispose()})),C.add(k.onDidClose(E=>{this.a.$onDidManagedSocketClose($,E?.stack??E?.message),C.dispose()})),C.add(k.onDidReceiveMessage(E=>this.a.$onDidManagedSocketHaveData($,A.$Ec.wrap(E)))),$}$remoteSocketWrite(I,$){this.d.get(I)?.actual.send($.buffer)}$remoteSocketEnd(I){const $=this.d.get(I);$&&($.actual.end(),$.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$5ac=f,e.$5ac=f=Je([Be(0,L.$LL)],f);class w{constructor(I,$){this.socketFactoryId=I,this.makeConnection=$}}class g extends h.$lb{constructor(I,$,k){super(),this.socketId=I,this.actual=$,this.B(k)}}}),define(Se[308],De([1,0,5,17,27]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bbc=void 0;function L(f){return f&&f.title}let A=class{constructor(w,g){this.b=g,this.a=w.getProxy(S.$JJ.MainThreadMessageService)}showMessage(w,g,P,I,$){const k={source:{identifier:w.identifier,label:w.displayName||w.name}};let C;typeof I=="string"||L(I)?C=[I,...$]:(k.modal=I?.modal,k.useCustom=I?.useCustom,k.detail=I?.detail,C=$),k.useCustom&&(0,h.$EF)(w,"resolvers");const E=[];for(let n=0;n<C.length;n++){const o=C[n];if(typeof o=="string")E.push({title:o,handle:n,isCloseAffordance:!1});else if(typeof o=="object"){const{title:a,isCloseAffordance:m}=o;E.push({title:a,isCloseAffordance:!!m,handle:n})}else this.b.warn("Invalid message item:",o)}return this.a.$showMessage(g,P,k,E).then(n=>{if(typeof n=="number")return C[n]})}};e.$bbc=A,e.$bbc=A=Je([Be(1,F.$Ri)],A)}),define(Se[309],De([1,0,201,21,4,3,28,15,19,2,30,86,5,33,10,7,64,271,142,8,23,16]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E,n,o,a,m,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vbc=void 0;class t{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(s=>s.apiEditor)}constructor(s,i,c,l,b){this.q=c,this.r=l,this.s=b,this.f=new Map,this.g=new A.$ni,this.h=new Map,this.j=new h.$ec({onListenerError:m.$Z}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new h.$ec({onListenerError:m.$Z}),this.onDidOpenNotebookDocument=this.m.event,this.n=new h.$ec({onListenerError:m.$Z}),this.onDidCloseNotebookDocument=this.n.event,this.o=new h.$ec({onListenerError:m.$Z}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$jac("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=s.getProxy($.$JJ.MainThreadNotebook),this.c=s.getProxy($.$JJ.MainThreadNotebookDocuments),this.d=s.getProxy($.$JJ.MainThreadNotebookEditors),this.i=i.converter,i.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const u=y.notebookEditor?.notebookUri,d=y.cell.handle,R=this.g.get(u)?.getCell(d);if(R)return R.apiCell}if(y&&y.$mid===14){const u=y.uri,d=this.g.get(u);if(d)return d.apiNotebook}return y}}),t.A(i)}getEditorById(s){const i=this.h.get(s);if(!i)throw new Error(`unknown text editor: ${s}. known editors: ${[...this.h.keys()]} `);return i}getIdByEditor(s){for(const[i,c]of this.h)if(c.apiEditor===s)return i}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(s,i){const c=this.g.get(s);if(!c&&!i)throw new Error(`NO notebook document for '${s}'`);return c}static t(s,i){if(!i)return;const c=i.filenamePattern.map(l=>C.NotebookExclusiveDocumentPattern.from(l)).filter(l=>l!==void 0);if(i.filenamePattern&&!c){console.warn(`Notebook content provider view options file name pattern is invalid ${i.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:i.displayName,filenamePattern:c,exclusive:i.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,i,c){const l=t.a++,b=typeof c.onDidChangeCellStatusBarItems=="function"?t.a++:void 0;this.f.set(l,c),this.b.$registerNotebookCellStatusBarItemProvider(l,b,i);let y;return b!==void 0&&(y=c.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(b))),new E.$LJ(()=>{this.f.delete(l),this.b.$unregisterNotebookCellStatusBarItemProvider(l,b),y?.dispose()})}async createNotebookDocument(s){const i=await this.c.$tryCreateNotebook({viewType:s.viewType,content:s.content&&C.NotebookData.from(s.content)});return g.URI.revive(i)}async openNotebookDocument(s){const i=this.g.get(s);if(i)return i.apiNotebook;const c=await this.c.$tryOpenNotebook(s),l=this.g.get(g.URI.revive(c));return(0,w.$te)(l?.apiNotebook)}async showNotebookDocument(s,i){g.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let c;typeof i=="object"?c={position:C.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus,selections:i.selections&&i.selections.map(C.NotebookRange.from),pinned:typeof i.preview=="boolean"?!i.preview:void 0}:c={preserveFocus:!1};const l=await this.d.$tryShowNotebookDocument(s.uri,s.notebookType,c),b=l&&this.h.get(l)?.apiEditor;if(b)return b;throw l?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,i,c,l){const b=this.f.get(s),y=g.URI.revive(i),u=this.g.get(y);if(!u||!b)return;const d=u.getCellFromIndex(c);if(!d)return;const p=await b.provideCellStatusBarItems(d.apiCell,l);if(!p)return;const R=new L.$kb,O=this.p.add([R]),T=(Array.isArray(p)?p:[p]).map(z=>C.NotebookStatusBarItem.from(z,this.i,R));return{cacheId:O,items:T}}$releaseNotebookCellStatusBarItems(s){this.p.delete(s)}registerNotebookSerializer(s,i,c,l,b){if((0,f.$ld)(i))throw new Error("viewType cannot be empty or just whitespace");const y=this.u++;return this.w.set(y,{viewType:i,serializer:c,options:l}),this.b.$registerNotebookSerializer(y,{id:s.identifier,location:s.extensionLocation},i,C.NotebookDocumentContentOptions.from(l),t.t(s,b)),(0,L.$jb)(()=>{this.b.$unregisterNotebookSerializer(y)})}async $dataToNotebook(s,i,c){const l=this.w.get(s);if(!l)throw new Error("NO serializer found");const b=await l.serializer.deserializeNotebook(i.buffer,c);return new n.$5z(C.NotebookData.from(b))}async $notebookToData(s,i,c){const l=this.w.get(s);if(!l)throw new Error("NO serializer found");const b=await l.serializer.serializeNotebook(C.NotebookData.to(i.value),c);return F.$Ec.wrap(b)}async $saveNotebook(s,i,c,l,b){const y=g.URI.revive(i),u=this.w.get(s);if(!u)throw new Error("NO serializer found");const d=this.g.get(y);if(!d)throw new Error("Document NOT found");if(d.versionId!==c)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(y.scheme))throw new P.$ak((0,S.localize)(0,null,this.y(y)),6);await this.x(y,l);const p={metadata:(0,v.$Qm)(d.apiNotebook.metadata,z=>!(u.options?.transientDocumentMetadata??{})[z]),cells:[]};for(const z of d.apiNotebook.getCells()){const B=new E.$$K(z.kind,z.document.getText(),z.document.languageId,z.mime,u.options?.transientOutputs?[]:[...z.outputs],z.metadata,z.executionSummary);B.metadata=(0,v.$Qm)(z.metadata,M=>!(u.options?.transientCellMetadata??{})[M]),p.cells.push(B)}const R=await u.serializer.serializeNotebook(p,b);await this.s.value.writeFile(y,R);const O=this.s.getFileSystemProviderExtUri(y.scheme),j=await this.s.value.stat(y);return{name:O.basename(y),isFile:(j.type&P.FileType.File)!==0,isDirectory:(j.type&P.FileType.Directory)!==0,isSymbolicLink:(j.type&P.FileType.SymbolicLink)!==0,mtime:j.mtime,ctime:j.ctime,size:j.size,readonly:!!((j.permissions??0)&P.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(y.scheme),locked:!!((j.permissions??0)&P.FilePermission.Locked),etag:P.$lk({mtime:j.mtime,size:j.size}),children:void 0}}async x(s,i){const c=await this.s.value.stat(s);if(typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==P.$kk&&typeof c.mtime=="number"&&typeof c.size=="number"&&i.mtime<c.mtime&&i.etag!==P.$lk({mtime:i.mtime,size:c.size}))throw new P.$ak((0,S.localize)(1,null),3,i)}y(s){return s.scheme===D.Schemas.file?s.fsPath:s.toString()}z(s,i,c){if(this.h.has(i))throw new Error(`editor with id ALREADY EXSIST: ${i}`);const l=new a.$Ubc(i,this.d,s,c.visibleRanges.map(C.NotebookRange.to),c.selections.map(C.NotebookRange.to),typeof c.viewColumn=="number"?C.ViewColumn.to(c.viewColumn):void 0);this.h.set(i,l)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const c of s.value.removedDocuments){const l=g.URI.revive(c),b=this.g.get(l);b&&(b.dispose(),this.g.delete(l),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(y=>y.document.uri)}),this.n.fire(b.apiNotebook));for(const y of this.h.values())y.notebookData.uri.toString()===l.toString()&&this.h.delete(y.id)}if(s.value.addedDocuments){const c=[];for(const l of s.value.addedDocuments){const b=g.URI.revive(l.uri);if(this.g.has(b))throw new Error(`adding EXISTING notebook ${b} `);const y=new o.$Tbc(this.c,this.q,this.r,b,l);c.push(...l.cells.map(u=>o.$Sbc.asModelAddData(y.apiNotebook,u))),this.g.get(b)?.dispose(),this.g.set(b,y),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:c}),this.m.fire(y.apiNotebook)}}if(s.value.addedEditors)for(const c of s.value.addedEditors){if(this.h.has(c.id))return;const l=g.URI.revive(c.documentUri),b=this.g.get(l);b&&this.z(b,c.id,c)}const i=[];if(s.value.removedEditors)for(const c of s.value.removedEditors){const l=this.h.get(c);l&&(this.h.delete(c),this.k?.id===l.id&&(this.k=void 0),i.push(l))}if(s.value.visibleEditors){this.l=s.value.visibleEditors.map(l=>this.h.get(l)).filter(l=>!!l);const c=new Set;this.l.forEach(l=>c.add(l.id));for(const l of this.h.values()){const b=c.has(l.id);l._acceptVisibility(b)}this.l=[...this.h.values()].map(l=>l).filter(l=>l.visible),this.o.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this.k=void 0:s.value.newActiveEditor&&(this.h.get(s.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${s.value.newActiveEditor}`),this.k=this.h.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(s){const i=k.$0L.String.with("notebookType","A notebook type"),c=new k.$_L("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[i,new k.$0L("data","Bytes to convert to data",b=>b instanceof Uint8Array,b=>F.$Ec.wrap(b))],new k.$$L("Notebook Data",b=>C.NotebookData.to(b.value))),l=new k.$_L("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[i,new k.$0L("NotebookData","Notebook data to convert to bytes",b=>!0,b=>new n.$5z(C.NotebookData.from(b)))],new k.$$L("Bytes",b=>b.buffer));s.registerApiCommand(c),s.registerApiCommand(l)}}e.$Vbc=t}),define(Se[310],De([1,0,18,13,22,4,3,28,2,25,17,86,5,33,10,7,109,265,27,64]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E,n,o,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=e.$0bc=void 0;let v=class{constructor(b,y,u,d,p){this.m=y,this.n=u,this.o=d,this.q=p,this.b=new f.$ni,this.c=new f.$ni,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new I.$jac("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new L.$ec,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=b.getProxy($.$JJ.MainThreadNotebookKernels);const R=new k.$_L("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new k.$0L("options","Select kernel options",O=>!0,O=>{if(O&&"notebookEditor"in O&&"id"in O){const j=this.n.getIdByEditor(O.notebookEditor);return{id:O.id,extension:O.extension,notebookEditorId:j}}else if(O&&"notebookEditor"in O){const j=this.n.getIdByEditor(O.notebookEditor);if(j===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${O.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:j}}return O})],k.$$L.Void);this.o.registerApiCommand(R)}createNotebookController(b,y,u,d,p,R){for(const ae of this.j.values())if(ae.controller.id===y&&g.$Il.equals(b.identifier,ae.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const O=this.k++,j=this;this.q.trace(`NotebookController[${O}], CREATED by ${b.identifier.value}, ${y}`);const T=()=>console.warn(`NO execute handler from notebook controller '${J.id}' of extension: '${b.identifier}'`);let z=!1;const B=new A.$kb,M=new L.$ec,Y=new L.$ec,J={id:c(b.identifier,y),notebookType:u,extensionId:b.identifier,extensionLocation:b.extensionLocation,label:d||b.identifier.value,preloads:R?R.map(C.NotebookRendererScript.from):[]};let fe=p??T,se;this.a.$addKernel(O,J).catch(ae=>{console.log(ae),z=!0});let ie=0;const V=()=>{if(z)return;const ae=++ie;Promise.resolve().then(()=>{ae===ie&&this.a.$updateKernel(O,J)})},re=new f.$ni,pe={get id(){return y},get notebookType(){return J.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return J.label},set label(ae){J.label=ae??b.displayName??b.name,V()},get detail(){return J.detail??""},set detail(ae){J.detail=ae,V()},get description(){return J.description??""},set description(ae){J.description=ae,V()},get supportedLanguages(){return J.supportedLanguages},set supportedLanguages(ae){J.supportedLanguages=ae,V()},get supportsExecutionOrder(){return J.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){J.supportsExecutionOrder=ae,V()},get rendererScripts(){return J.preloads?J.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return fe},set executeHandler(ae){fe=ae??T},get interruptHandler(){return se},set interruptHandler(ae){se=ae,J.supportsInterrupt=!!ae,V()},createNotebookCellExecution(ae){if(z)throw new Error("notebook controller is DISPOSED");if(!re.has(ae.notebook.uri))throw j.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(re.keys()).map(ne=>ne.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return j._createNotebookCellExecution(ae,c(b.identifier,this.id))},createNotebookExecution(ae){if((0,a.$EF)(b,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!re.has(ae.uri))throw j.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(re.keys()).map(ne=>ne.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.uri.toString()}`);return j._createNotebookExecution(ae,c(b.identifier,this.id))},dispose:()=>{z||(this.q.trace(`NotebookController[${O}], DISPOSED`),z=!0,this.j.delete(O),B.dispose(),M.dispose(),Y.dispose(),this.a.$removeKernel(O))},updateNotebookAffinity(ae,ne){ne===E.NotebookControllerAffinity2.Hidden&&(0,a.$EF)(b,"notebookControllerAffinityHidden"),j.a.$updateNotebookPriority(O,ae.uri,ne)},onDidReceiveMessage:Y.event,postMessage(ae,ne){return(0,a.$EF)(b,"notebookMessaging"),j.a.$postMessage(O,ne&&j.n.getIdByEditor(ne),ae)},asWebviewUri(ae){return(0,a.$EF)(b,"notebookMessaging"),(0,n.$job)(ae,j.m.remote)}};return this.j.set(O,{extensionId:b.identifier,controller:pe,onDidReceiveMessage:Y,onDidChangeSelection:M,associatedNotebooks:re}),pe}getIdByController(b){for(const[y,u]of this.j)if(u.controller===b)return c(u.extensionId,b.id);return null}createNotebookControllerDetectionTask(b,y){const u=this.f++,d=this;this.q.trace(`NotebookControllerDetectionTask[${u}], CREATED by ${b.identifier.value}`),this.a.$addKernelDetectionTask(u,y);const p={dispose:()=>{this.e.delete(u),d.a.$removeKernelDetectionTask(u)}};return this.e.set(u,p),p}registerKernelSourceActionProvider(b,y,u){const d=this.h++,p=typeof u.onDidChangeNotebookKernelSourceActions=="function"?d:void 0,R=this;this.g.set(d,u),this.q.trace(`NotebookKernelSourceActionProvider[${d}], CREATED by ${b.identifier.value}`),this.a.$addKernelSourceActionProvider(d,d,y);let O;return p!==void 0&&(O=u.onDidChangeNotebookKernelSourceActions(j=>this.a.$emitNotebookKernelSourceActionsChangeEvent(p))),{dispose:()=>{this.g.delete(d),R.a.$removeKernelSourceActionProvider(d,d),O?.dispose()}}}async $provideKernelSourceActions(b,y){const u=this.g.get(b);if(u){const d=new A.$kb;return this.i.add([d]),(await u.provideNotebookKernelSourceActions(y)??[]).map(R=>C.NotebookKernelSourceAction.from(R,this.o.converter,d))}return[]}$acceptNotebookAssociation(b,y,u){const d=this.j.get(b);if(d){const p=this.n.getNotebookDocument(w.URI.revive(y));u?d.associatedNotebooks.set(p.uri,!0):d.associatedNotebooks.delete(p.uri),this.q.trace(`NotebookController[${b}] ASSOCIATE notebook`,p.uri.toString(),u),d.onDidChangeSelection.fire({selected:u,notebook:p.apiNotebook})}}async $executeCells(b,y,u){const d=this.j.get(b);if(!d)return;const p=this.n.getNotebookDocument(w.URI.revive(y)),R=[];for(const O of u){const j=p.getCell(O);j&&R.push(j.apiCell)}try{this.q.trace(`NotebookController[${b}] EXECUTE cells`,p.uri.toString(),R.length),await d.controller.executeHandler.call(d.controller,R,p.apiNotebook,d.controller)}catch(O){this.q.error(`NotebookController[${b}] execute cells FAILED`,O),console.error(O)}}async $cancelCells(b,y,u){const d=this.j.get(b);if(!d)return;const p=this.n.getNotebookDocument(w.URI.revive(y));if(d.controller.interruptHandler)await d.controller.interruptHandler.call(d.controller,p.apiNotebook);else for(const R of u){const O=p.getCell(R);O&&this.b.get(O.uri)?.cancel()}if(d.controller.interruptHandler){const R=this.c.get(p.uri);u.length&&Array.isArray(R)&&R.length&&R.forEach(O=>O.dispose())}}$acceptKernelMessageFromRenderer(b,y,u){const d=this.j.get(b);if(!d)return;const p=this.n.getEditorById(y);d.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:u}))}$cellExecutionChanged(b,y,u){const p=this.n.getNotebookDocument(w.URI.revive(b)).getCell(y);if(p){const R=u?C.NotebookCellExecutionState.to(u):E.NotebookCellExecutionState.Idle;R!==void 0&&this.l.fire({cell:p.apiCell,state:R})}}_createNotebookCellExecution(b,y){if(b.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const d=this.n.getNotebookDocument(b.notebook.uri).getCellFromApiCell(b);if(!d)throw new Error("invalid cell");if(this.b.has(d.uri))throw new Error(`duplicate execution for ${d.uri}`);const p=new t(y,d,this.a);this.b.set(d.uri,p);const R=p.onDidChangeState(()=>{p.state===D.Resolved&&(p.dispose(),R.dispose(),this.b.delete(d.uri))});return p.asApiObject()}_createNotebookExecution(b,y){const u=this.n.getNotebookDocument(b.uri),d=b.getCells().find(O=>{const j=u.getCellFromApiCell(O);return j&&this.b.has(j.uri)});if(d)throw new Error(`duplicate cell execution for ${d.document.uri}`);if(this.c.has(u.uri))throw new Error(`duplicate notebook execution for ${u.uri}`);const p=new s(y,u,this.a),R=p.onDidChangeState(()=>{p.state===r.Resolved&&(p.dispose(),R.dispose(),this.c.delete(u.uri))});return this.c.set(u.uri,[p,R]),p.asApiObject()}};e.$0bc=v,e.$0bc=v=Je([Be(4,P.$Ri)],v);var D;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(D||(D={}));class t extends A.$lb{static{this.a=0}get state(){return this.f}constructor(b,y,u){super(),this.j=y,this.k=u,this.b=t.a++,this.c=new L.$ec,this.onDidChangeState=this.c.event,this.f=D.Init,this.g=this.B(new h.$oc),this.h=new i(10,d=>this.m(d)),this.i=y.internalMetadata.executionOrder,this.k.$createExecution(this.b,b,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(b){await this.h.addItem(b)}async m(b){const y=Array.isArray(b)?b:[b];return this.k.$updateExecution(this.b,new m.$5z(y))}n(){if(this.f===D.Init)throw new Error("Must call start before modifying cell output");if(this.f===D.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(b){let y=this.j;if(b&&(y=this.j.notebook.getCellFromApiCell(b)),!y)throw new Error("INVALID cell");return y.handle}s(b){return b.map(y=>{const u=E.$bL.ensureUniqueMimeTypes(y.items,!0);return u===y.items?C.NotebookCellOutput.from(y):C.NotebookCellOutput.from({items:u,id:y.id,metadata:y.metadata})})}async t(b,y,u){const d=this.r(y),p=this.s((0,S.$Gf)(b));return this.l({editType:o.CellExecutionUpdateType.Output,cellHandle:d,append:u,outputs:p})}async w(b,y,u){return b=E.$bL.ensureUniqueMimeTypes((0,S.$Gf)(b),!0),this.l({editType:o.CellExecutionUpdateType.OutputItems,items:b.map(C.NotebookCellOutputItem.from),outputId:y.id,append:u})}asApiObject(){const b=this;return Object.freeze({get token(){return b.g.token},get cell(){return b.j.apiCell},get executionOrder(){return b.i},set executionOrder(u){b.i=u,b.m([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:b.i}])},start(u){if(b.f===D.Resolved||b.f===D.Started)throw new Error("Cannot call start again");b.f=D.Started,b.c.fire(),b.m({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:u})},end(u,d){if(b.f===D.Resolved)throw new Error("Cannot call resolve twice");b.f=D.Resolved,b.c.fire(),b.h.flush(),b.k.$completeExecution(b.b,new m.$5z({runEndTime:d,lastRunSuccess:u}))},clearOutput(u){return b.n(),b.t([],u,!1)},appendOutput(u,d){return b.n(),b.t(u,d,!0)},replaceOutput(u,d){return b.n(),b.t(u,d,!1)},appendOutputItems(u,d){return b.n(),b.w(u,d,!0)},replaceOutputItems(u,d){return b.n(),b.w(u,d,!1)}})}}var r;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(r||(r={}));class s extends A.$lb{static{this.a=0}get state(){return this.f}constructor(b,y,u){super(),this.h=y,this.i=u,this.b=s.a++,this.c=new L.$ec,this.onDidChangeState=this.c.event,this.f=r.Init,this.g=this.B(new h.$oc),this.i.$createNotebookExecution(this.b,b,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===r.Resolved||this.f===r.Started)throw new Error("Cannot call start again");this.f=r.Started,this.c.fire(),this.i.$beginNotebookExecution(this.b)},end:()=>{if(this.f===r.Resolved)throw new Error("Cannot call resolve twice");this.f=r.Resolved,this.c.fire(),this.i.$completeNotebookExecution(this.b)}})}}class i{constructor(b,y){this.e=b,this.f=y,this.a=[],this.b=Date.now()}addItem(b){return this.a.push(b),this.c||(this.c=new F.$Pg,this.b=Date.now(),(0,F.$vg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const b=this.c;this.c=void 0;const y=this.a;return this.a=[],this.f(y).finally(()=>b.complete())}}function c(l,b){return`${l.value}/${b}`}e.$$bc=c}),define(Se[311],De([1,0,4,5,142]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_bc=void 0;class L{constructor(f,w){this.c=w,this.a=new Map,this.b=f.getProxy(F.$JJ.MainThreadNotebookRenderers)}$postRendererMessage(f,w,g){const P=this.c.getEditorById(f);this.a.get(w)?.fire({editor:P.apiEditor,message:g})}createRendererMessaging(f,w){if(!f.contributes?.notebookRenderer?.some(P=>P.id===w))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${w})`);return{onDidReceiveMessage:(P,I,$)=>this.d(w).event(P,I,$),postMessage:(P,I)=>{h.$Ubc.apiEditorsToExtHost.has(P)&&([P,I]=[I,P]);const $=I&&h.$Ubc.apiEditorsToExtHost.get(I);return this.b.$postMessage($?.id,w,P)}}}d(f){let w=this.a.get(f);return w||(w=new S.$ec({onDidRemoveLastListener:()=>{w?.dispose(),this.a.delete(f)}}),this.a.set(f,w),w)}}e.$_bc=L}),define(Se[312],De([1,0,3,19,2,27,5]),function(me,e,S,F,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dcc=void 0;class f{constructor(g){this.b=new Map,this.a=g.getProxy(A.$JJ.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,P,I){if((0,L.$EF)(g,"profileContentHandlers"),this.b.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.b.set(P,I),this.a.$registerProfileContentHandler(P,I.name,I.description,g.identifier.value),(0,S.$jb)(()=>{this.b.delete(P),this.a.$unregisterProfileContentHandler(P)})}async $saveProfile(g,P,I,$){const k=this.b.get(g);if(!k)throw new Error(`Unknown handler with id: ${g}`);return k.saveProfile(P,I,$)}async $readProfile(g,P,I){const $=this.b.get(g);if(!$)throw new Error(`Unknown handler with id: ${g}`);return $.readProfile((0,F.$ie)(P)?P:h.URI.revive(P),I)}}e.$dcc=f}),define(Se[313],De([1,0,2,5,13,10]),function(me,e,S,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=void 0;class A{static{this.a=0}constructor(w,g){this.d=g,this.c=new Map,this.b=w.getProxy(F.$JJ.MainThreadQuickDiff)}$provideOriginalResource(w,g,P){const I=S.URI.revive(g),$=this.c.get(w);return $?(0,h.$ng)(()=>$.provideOriginalResource(I,P)).then(k=>k||null):Promise.resolve(null)}registerQuickDiffProvider(w,g,P,I){const $=A.a++;return this.c.set($,g),this.b.$registerQuickDiffProvider($,L.DocumentSelector.from(w,this.d),P,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider($),this.c.delete($)}}}}e.$ecc=A}),define(Se[314],De([1,0,22,4,3,5,2,7,8,18,40,56,27,10]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fbc=void 0;function C(E,n,o){const a=E.getProxy(L.$JJ.MainThreadQuickOpen);class m{constructor(b,y){this.e=new Map,this.f=0,this.a=b,this.b=y}showQuickPick(b,y,u,d=S.CancellationToken.None){this.c=void 0;const p=Promise.resolve(y),R=++this.f,O=a.$show(R,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},d),j={},T=O.then(()=>j);return Promise.race([T,p]).then(z=>{if(z===j)return;const B=(0,$.$DF)(b,"quickPickItemTooltip");return p.then(M=>{const Y=[];for(let J=0;J<M.length;J++){const fe=M[J];if(typeof fe=="string")Y.push({label:fe,handle:J});else if(fe.kind===f.QuickPickItemKind.Separator)Y.push({type:"separator",label:fe.label});else{fe.tooltip&&!B&&console.warn(`Extension '${b.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${b.identifier.value}`);const se=fe.iconPath?s(fe.iconPath):void 0;Y.push({label:fe.label,iconPath:se?.iconPath,iconClass:se?.iconClass,description:fe.description,detail:fe.detail,picked:fe.picked,alwaysShow:fe.alwaysShow,tooltip:B?k.MarkdownString.fromStrict(fe.tooltip):void 0,handle:J})}}return u&&typeof u.onDidSelectItem=="function"&&(this.c=J=>{u.onDidSelectItem(M[J])}),a.$setItems(R,Y),O.then(J=>{if(typeof J=="number")return M[J];if(Array.isArray(J))return J.map(fe=>M[fe])})})}).then(void 0,z=>{if(!(0,w.$2)(z))return a.$setError(R,z),Promise.reject(z)})}$onItemSelected(b){this.c?.(b)}showInput(b,y=S.CancellationToken.None){return this.d=b?.validateInput,a.$input(b,typeof this.d=="function",y).then(void 0,u=>{if(!(0,w.$2)(u))return Promise.reject(u)})}async $validateInput(b){if(!this.d)return;const y=await this.d(b);if(!y||typeof y=="string")return y;let u;switch(y.severity){case f.InputBoxValidationSeverity.Info:u=P.default.Info;break;case f.InputBoxValidationSeverity.Warning:u=P.default.Warning;break;case f.InputBoxValidationSeverity.Error:u=P.default.Error;break;default:u=y.message?P.default.Error:P.default.Ignore;break}return{content:y.message,severity:u}}async showWorkspaceFolderPick(b,y=S.CancellationToken.None){const u=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[b]);if(!u)return;const d=await this.a.getWorkspaceFolders2();if(d)return d.find(p=>p.uri.toString()===u.uri.toString())}createQuickPick(b){const y=new i(b,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(b){const y=new c(b,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(b,y){this.e.get(b)?._fireDidChangeValue(y)}$onDidAccept(b){this.e.get(b)?._fireDidAccept()}$onDidChangeActive(b,y){const u=this.e.get(b);u instanceof i&&u._fireDidChangeActive(y)}$onDidChangeSelection(b,y){const u=this.e.get(b);u instanceof i&&u._fireDidChangeSelection(y)}$onDidTriggerButton(b,y){this.e.get(b)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(b,y,u){const d=this.e.get(b);d instanceof i&&d._fireDidTriggerItemButton(y,u)}$onDidHide(b){this.e.get(b)?._fireDidHide()}}class v{static{this.a=1}constructor(b,y){this.x=b,this.y=y,this._id=i.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$ec,this.q=new F.$ec,this.r=new F.$ec,this.s=new F.$ec,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(b){this.b=b,this.z({title:b})}get step(){return this.c}set step(b){this.c=b,this.z({step:b})}get totalSteps(){return this.d}set totalSteps(b){this.d=b,this.z({totalSteps:b})}get enabled(){return this.g}set enabled(b){this.g=b,this.z({enabled:b})}get busy(){return this.j}set busy(b){this.j=b,this.z({busy:b})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(b){this.k=b,this.z({ignoreFocusOut:b})}get value(){return this.l}set value(b){this.l=b,this.z({value:b})}get placeholder(){return this.m}set placeholder(b){this.m=b,this.z({placeholder:b})}get buttons(){return this.n}set buttons(b){this.n=b.slice(),this.o.clear(),b.forEach((y,u)=>{const d=y===f.$7K.Back?-1:u;this.o.set(d,y)}),this.z({buttons:b.map((y,u)=>({...s(y.iconPath),tooltip:y.tooltip,handle:y===f.$7K.Back?-1:u}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(b){this.l=b,this.q.fire(b)}_fireDidTriggerButton(b){const y=this.o.get(b);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,h.$gb)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),a.$dispose(this._id))}z(b){if(!this.v){for(const y of Object.keys(b)){const u=b[y];this.u[y]=u===void 0?null:u}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){a.$createOrUpdate(this.u),this.u={id:this._id}}}function D(l){if(l instanceof f.$GK)return{id:l.id};const b=r(l),y=t(l);return{dark:typeof b=="string"?A.URI.file(b):b,light:typeof y=="string"?A.URI.file(y):y}}function t(l){return typeof l=="object"&&"light"in l?l.light:l}function r(l){return typeof l=="object"&&"dark"in l?l.dark:l}function s(l){const b=D(l);let y,u;return"id"in b?u=I.ThemeIcon.asClassName(b):y=b,{iconPath:y,iconClass:u}}class i extends v{constructor(b,y){super(b.identifier,y),this.O=b,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$ec,this.L=[],this.M=new F.$ec,this.N=new F.$ec,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(b){this.B=b.slice(),this.C.clear(),this.D.clear(),b.forEach((d,p)=>{this.C.set(p,d),this.D.set(d,p)});const y=(0,$.$DF)(this.O,"quickPickItemTooltip"),u=[];for(let d=0;d<b.length;d++){const p=b[d];if(p.kind===f.QuickPickItemKind.Separator)u.push({type:"separator",label:p.label});else{p.tooltip&&!y&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const R=p.iconPath?s(p.iconPath):void 0;u.push({handle:d,label:p.label,iconPath:R?.iconPath,iconClass:R?.iconClass,description:p.description,detail:p.detail,picked:p.picked,alwaysShow:p.alwaysShow,tooltip:y?k.MarkdownString.fromStrict(p.tooltip):void 0,buttons:p.buttons?.map((O,j)=>({...s(O.iconPath),tooltip:O.tooltip,handle:j}))})}}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(b){this.E=b,this.z({canSelectMany:b})}get matchOnDescription(){return this.F}set matchOnDescription(b){this.F=b,this.z({matchOnDescription:b})}get matchOnDetail(){return this.G}set matchOnDetail(b){this.G=b,this.z({matchOnDetail:b})}get sortByLabel(){return this.H}set sortByLabel(b){this.H=b,this.z({sortByLabel:b})}get keepScrollPosition(){return this.I}set keepScrollPosition(b){this.I=b,this.z({keepScrollPosition:b})}get activeItems(){return this.J}set activeItems(b){this.J=b.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(b){this.L=b.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(b){const y=(0,g.$jf)(b.map(u=>this.C.get(u)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(b){const y=(0,g.$jf)(b.map(u=>this.C.get(u)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(b,y){const u=this.C.get(b);if(!u||!u.buttons||!u.buttons.length)return;const d=u.buttons[y];d&&this.N.fire({button:d,item:u})}}class c extends v{constructor(b,y){super(b.identifier,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(b){this.B=b,this.z({password:b})}get prompt(){return this.C}set prompt(b){this.C=b,this.z({prompt:b})}get valueSelection(){return this.D}set valueSelection(b){this.D=b,this.z({valueSelection:b})}get validationMessage(){return this.E}set validationMessage(b){this.E=b,b?typeof b=="string"?this.z({validationMessage:b,severity:P.default.Error}):this.z({validationMessage:b.message,severity:b.severity??P.default.Error}):this.z({validationMessage:void 0,severity:P.default.Ignore})}}return new m(n,o)}e.$fbc=C}),define(Se[315],De([1,0,2,4,70,3,13,5,18,124,17,25,56,10,27,16]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$hbc=e.$gbc=void 0;function o(y){if(y)return typeof y.iconPath=="string"?S.URI.file(y.iconPath):S.URI.isUri(y.iconPath)||$.ThemeIcon.isThemeIcon(y.iconPath)?y.iconPath:void 0}function a(y,u){if(!y.iconPath&&!u.iconPath)return 0;if(y.iconPath){if(!u.iconPath)return 1}else return-1;const d=typeof y.iconPath=="string"?y.iconPath:S.URI.isUri(y.iconPath)?y.iconPath.fsPath:y.iconPath.id,p=typeof u.iconPath=="string"?u.iconPath:S.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id;return(0,g.$$p)(d,p)}function m(y,u){let d=0;if(y.strikeThrough!==u.strikeThrough)return y.strikeThrough?1:-1;if(y.faded!==u.faded)return y.faded?1:-1;if(y.tooltip!==u.tooltip)return(y.tooltip||"").localeCompare(u.tooltip||"");if(d=a(y,u),d!==0)return d;if(y.light&&u.light)d=a(y.light,u.light);else{if(y.light)return 1;if(u.light)return-1}if(d!==0)return d;if(y.dark&&u.dark)d=a(y.dark,u.dark);else{if(y.dark)return 1;if(u.dark)return-1}return d}function v(y,u){if(y.command!==u.command)return y.command<u.command?-1:1;if(y.title!==u.title)return y.title<u.title?-1:1;if(y.tooltip!==u.tooltip){if(y.tooltip!==void 0&&u.tooltip!==void 0)return y.tooltip<u.tooltip?-1:1;if(y.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(y.arguments===u.arguments)return 0;if(y.arguments)if(u.arguments){if(y.arguments.length!==u.arguments.length)return y.arguments.length-u.arguments.length}else return 1;else return-1;for(let d=0;d<y.arguments.length;d++){const p=y.arguments[d],R=u.arguments[d];if(p!==R)return p<R?-1:1}return 0}function D(y,u){let d=(0,g.$$p)(y.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(d!==0)return d;if(y.command&&u.command)d=v(y.command,u.command);else{if(y.command)return 1;if(u.command)return-1}if(d!==0)return d;if(y.decorations&&u.decorations)d=m(y.decorations,u.decorations);else{if(y.decorations)return 1;if(u.decorations)return-1}return d}function t(y,u){for(let d=0;d<y.length;d++)if(y[d]!==u[d])return!1;return!0}function r(y,u){return y.command===u.command&&y.title===u.title&&y.tooltip===u.tooltip&&(y.arguments&&u.arguments?t(y.arguments,u.arguments):y.arguments===u.arguments)}function s(y,u){return(0,w.$$e)(y,u,r)}class i{#e;#t;get value(){return this.d}set value(u){u=u??"",this.#e.$setInputBoxValue(this.l,u),this.n(u)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(u){this.#e.$setInputBoxPlaceholder(this.l,u),this.f=u}get validateInput(){return(0,C.$EF)(this.k,"scmValidation"),this.g}set validateInput(u){if((0,C.$EF)(this.k,"scmValidation"),u&&typeof u!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=u,this.#e.$setValidationProviderIsEnabled(this.l,!!u)}get enabled(){return this.h}set enabled(u){u=!!u,this.h!==u&&(this.h=u,this.#e.$setInputBoxEnablement(this.l,u))}get visible(){return this.j}set visible(u){u=!!u,this.j!==u&&(this.j=u,this.#e.$setInputBoxVisibility(this.l,u))}get document(){return(0,C.$EF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(u,d,p,R,O){this.k=u,this.l=R,this.m=O,this.d="",this.e=new F.$ec,this.f="",this.h=!0,this.j=!0,this.#t=d,this.#e=p}showValidationMessage(u,d){(0,C.$EF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,u,d)}$onInputBoxValueChange(u){this.n(u)}n(u){this.d=u,this.e.fire(u)}}e.$gbc=i;class c{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(u){this.v=u,this.q.$updateGroupLabel(this.t,this.handle,u)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(u){this.p=u,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(u){this.f=[...u],this.k.fire()}constructor(u,d,p,R,O){this.q=u,this.s=d,this.t=p,this.u=R,this.v=O,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$ec,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$ec,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=c.d++}getResourceState(u){return this.g.get(u)}$executeResourceCommand(u,d){const p=this.h.get(u);return p?(0,A.$ng)(()=>this.s.executeCommand(p.command,...p.arguments||[],d)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const u=[...this.f].sort(D),p=(0,w.$ff)(this.o,u,D).map(j=>{const T=j.toInsert.map(z=>{const B=this.e++;this.g.set(B,z);const M=z.resourceUri;let Y;if(z.command)if(z.command.command==="vscode.open"||z.command.command==="vscode.diff"){const x=new L.$kb;Y=this.s.converter.toInternal(z.command,x),this.j.set(B,x)}else this.h.set(B,z.command);const J=o(z.decorations),fe=z.decorations&&o(z.decorations.light)||J,se=z.decorations&&o(z.decorations.dark)||J,ie=[fe,se],V=z.decorations&&z.decorations.tooltip||"",re=z.decorations&&!!z.decorations.strikeThrough,pe=z.decorations&&!!z.decorations.faded,ae=z.contextValue||"";return{rawResource:[B,M,ie,V,re,pe,ae,Y],handle:B}});return{start:j.start,deleteCount:j.deleteCount,toInsert:T}}),R=p.map(({start:j,deleteCount:T,toInsert:z})=>[j,T,z.map(B=>B.rawResource)]),O=p.reverse();for(const{start:j,deleteCount:T,toInsert:z}of O){const B=z.map(Y=>Y.handle),M=this.n.splice(j,T,...B);for(const Y of M)this.g.delete(Y),this.h.delete(Y),this.j.get(Y)?.dispose(),this.j.delete(Y)}return this.o=u,R}dispose(){this.l=!0,this.m.fire()}}class l{static{this.d=0}#e;get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(u){this.g!==u&&(this.g=u,this.#e.$updateSourceControl(this.t,{count:u}))}get quickDiffProvider(){return this.h}set quickDiffProvider(u){this.h=u;let d;(0,C.$DF)(this.u,"quickDiffProvider")&&(d=u?.label),this.#e.$updateSourceControl(this.t,{hasQuickDiffProvider:!!u,quickDiffLabel:d})}get commitTemplate(){return this.j}set commitTemplate(u){u!==this.j&&(this.j=u,this.#e.$updateSourceControl(this.t,{commitTemplate:u}))}get acceptInputCommand(){return this.l}set acceptInputCommand(u){this.k.value=new L.$kb,this.l=u;const d=this.v.converter.toInternal(u,this.k.value);this.#e.$updateSourceControl(this.t,{acceptInputCommand:d})}get actionButton(){return(0,C.$EF)(this.u,"scmActionButton"),this.n}set actionButton(u){(0,C.$EF)(this.u,"scmActionButton"),this.m.value=new L.$kb,this.n=u;const d=u!==void 0?{command:this.v.converter.toInternal(u.command,this.m.value),secondaryCommands:u.secondaryCommands?.map(p=>p.map(R=>this.v.converter.toInternal(R,this.m.value))),description:u.description,enabled:u.enabled}:void 0;this.#e.$updateSourceControl(this.t,{actionButton:d??null})}get statusBarCommands(){return this.p}set statusBarCommands(u){if(this.p&&u&&s(this.p,u))return;this.o.value=new L.$kb,this.p=u;const d=(u||[]).map(p=>this.v.converter.toInternal(p,this.o.value));this.#e.$updateSourceControl(this.t,{statusBarCommands:d})}get selected(){return this.q}constructor(u,d,p,R,O,j,T){this.u=u,this.v=R,this.w=O,this.x=j,this.y=T,this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new L.$mb,this.l=void 0,this.m=new L.$mb,this.o=new L.$mb,this.p=void 0,this.q=!1,this.s=new F.$ec,this.onDidChangeSelection=this.s.event,this.t=l.d++,this.z=new Map,this.A=new Set,this.#e=p;const z=S.URI.from({scheme:E.Schemas.vscodeSourceControl,path:`${O}/scm${this.t}/input`,query:T?`rootUri=${encodeURIComponent(T.toString())}`:void 0});this.f=new i(u,d,this.#e,this.t,z),this.#e.$registerSourceControl(this.t,O,j,T,z)}createResourceGroup(u,d){const p=new c(this.#e,this.v,this.t,u,d),R=F.Event.once(p.onDidDispose)(()=>this.z.delete(p));return this.z.set(p,R),this.eventuallyAddResourceGroups(),p}eventuallyAddResourceGroups(){const u=[],d=[];for(const[p,R]of this.z){R.dispose();const O=p.onDidUpdateResourceStates(()=>{this.A.add(p),this.eventuallyUpdateResourceStates()});F.Event.once(p.onDidDispose)(()=>{this.A.delete(p),O.dispose(),this.e.delete(p.handle),this.#e.$unregisterGroup(this.t,p.handle)}),u.push([p.handle,p.id,p.label,p.features]);const j=p._takeResourceStateSnapshot();j.length>0&&d.push([p.handle,j]),this.e.set(p.handle,p)}this.#e.$registerGroups(this.t,u,d),this.z.clear()}eventuallyUpdateResourceStates(){const u=[];this.A.forEach(d=>{const p=d._takeResourceStateSnapshot();p.length!==0&&u.push([d.handle,p])}),u.length>0&&this.#e.$spliceResourceStates(this.t,u),this.A.clear()}getResourceGroup(u){return this.e.get(u)}setSelectionState(u){this.q=u,this.s.fire(u)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(u=>u.dispose()),this.#e.$unregisterSourceControl(this.t)}}Je([(0,h.$Ug)(100)],l.prototype,"eventuallyAddResourceGroups",null),Je([(0,h.$Ug)(100)],l.prototype,"eventuallyUpdateResourceStates",null);let b=class{static{n=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(u,d,p,R){this.l=d,this.m=p,this.n=R,this.g=new Map,this.h=new I.$Kl,this.j=new F.$ec,this.e=u.getProxy(f.$JJ.MainThreadSCM),this.f=u.getProxy(f.$JJ.MainThreadTelemetry),d.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const j=this.g.get(O.sourceControlHandle);if(!j)return O;const T=j.getResourceGroup(O.groupHandle);return T?T.getResourceState(O.handle):O}else if(O&&O.$mid===4){const j=this.g.get(O.sourceControlHandle);return j?j.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const j=this.g.get(O.handle);return j||O}return O}})}createSourceControl(u,d,p,R){this.n.trace("ExtHostSCM#createSourceControl",u.identifier.value,d,p,R),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const O=n.d++,j=new l(u,this.m,this.e,this.l,d,p,R);this.g.set(O,j);const T=this.h.get(u.identifier)||[];return T.push(j),this.h.set(u.identifier,T),j}getLastInputBox(u){this.n.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const d=this.h.get(u.identifier),p=d&&d[d.length-1];return p&&p.inputBox}$provideOriginalResource(u,d,p){const R=S.URI.revive(d);this.n.trace("ExtHostSCM#$provideOriginalResource",u,R.toString());const O=this.g.get(u);return!O||!O.quickDiffProvider||!O.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$ng)(()=>O.quickDiffProvider.provideOriginalResource(R,p)).then(j=>j||null)}$onInputBoxValueChange(u,d){this.n.trace("ExtHostSCM#$onInputBoxValueChange",u);const p=this.g.get(u);return p&&p.inputBox.$onInputBoxValueChange(d),Promise.resolve(void 0)}$executeResourceCommand(u,d,p,R){this.n.trace("ExtHostSCM#$executeResourceCommand",u,d,p);const O=this.g.get(u);if(!O)return Promise.resolve(void 0);const j=O.getResourceGroup(d);return j?j.$executeResourceCommand(p,R):Promise.resolve(void 0)}$validateInput(u,d,p){this.n.trace("ExtHostSCM#$validateInput",u);const R=this.g.get(u);return!R||!R.inputBox.validateInput?Promise.resolve(void 0):(0,A.$ng)(()=>R.inputBox.validateInput(d,p)).then(O=>{if(!O)return Promise.resolve(void 0);const j=k.MarkdownString.fromStrict(O.message);return j?Promise.resolve([j,O.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(u){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&this.g.get(u)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=u,Promise.resolve(void 0)}};e.$hbc=b,e.$hbc=b=n=Je([Be(3,P.$Ri)],b)}),define(Se[113],De([1,0,5,4,6]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zac=e.$Yac=void 0;class L{constructor(f){this.b=new F.$ec,this.onDidChangePassword=this.b.event,this.a=f.getProxy(S.$JJ.MainThreadSecretState)}async $onDidChangePassword(f){this.b.fire(f)}get(f,w){return this.a.$getPassword(f,w)}store(f,w,g){return this.a.$setPassword(f,w,g)}delete(f,w){return this.a.$deletePassword(f,w)}}e.$Yac=L,e.$Zac=(0,h.$ph)("IExtHostSecretState")}),define(Se[316],De([1,0,5,10,2]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=void 0;class L{static{this.a=0}constructor(f,w){this.d=w,this.c=new Map,this.b=f.getProxy(S.$JJ.MainThreadShare)}async $provideShare(f,w,g){return await this.c.get(f)?.provideShare({selection:F.Range.to(w.selection),resourceUri:h.URI.revive(w.resourceUri)},g)??void 0}registerShareProvider(f,w){const g=L.a++;return this.c.set(g,w),this.b.$registerShareProvider(g,F.DocumentSelector.from(f,this.d),w.id,w.label,w.priority),{dispose:()=>{this.b.$unregisterShareProvider(g),this.c.delete(g)}}}}e.$jcc=L}),define(Se[317],De([1,0,7,5,203,3,10,19]),function(me,e,S,F,h,L,A,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jbc=e.$ibc=void 0;class w{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new S.$HK("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new S.$HK("statusBarItem.warningForeground")]])}#e;#t;constructor($,k,C,E,n,o=S.StatusBarAlignment.Left,a){if(this.i=!1,this.k="",this.q=new L.$kb,this.#e=$,this.#t=k,n&&E){this.c=(0,S.$kK)(E.identifier,n);const m=C.get(this.c);m&&(o=m.alignLeft?S.StatusBarAlignment.Left:S.StatusBarAlignment.Right,a=m.priority,this.j=!0,this.name=m.name,this.text=m.text,this.tooltip=m.tooltip,this.command=m.command,this.accessibilityInformation=m.accessibilityInformation)}else this.c=String(w.a++);this.e=E,this.f=n,this.g=o,this.h=this.u(a)}u($){if((0,f.$me)($))return $===Number.POSITIVE_INFINITY?Number.MAX_VALUE:$===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:$}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text($){this.k=$,this.v()}set name($){this.m=$,this.v()}set tooltip($){this.l=$,this.v()}set color($){this.n=$,this.v()}set backgroundColor($){$&&!w.b.has($.id)&&($=void 0),this.o=$,this.v()}set command($){this.r?.fromApi!==$&&(this.p&&this.q.add(this.p),this.p=new L.$kb,typeof $=="string"?this.r={fromApi:$,internal:this.#t.toInternal({title:"",command:$},this.p)}:$?this.r={fromApi:$,internal:this.#t.toInternal($,this.p)}:this.r=void 0,this.v())}set accessibilityInformation($){this.t=$,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let $;this.e?this.f?$=`${this.e.identifier.value}.${this.f}`:$=this.e.identifier.value:$=this.f;let k;this.m?k=this.m:k=(0,h.localize)(0,null,this.e.displayName||this.e.name);let C=this.n;this.o&&(C=w.b.get(this.o.id));const E=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,$,this.e?.identifier.value,k,this.k,E,this.r?.internal,C,this.o,this.g===S.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$ibc=w;class g{constructor($){this.b=[],this.a=$.createStatusBarEntry(void 0,"status.extensionMessage",S.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,h.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage($){const k={message:$};return this.b.unshift(k),this.c(),new S.$LJ(()=>{const C=this.b.indexOf(k);C>=0&&(this.b.splice(C,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class P{constructor($,k){this.e=new Map,this.a=$.getProxy(F.$JJ.MainThreadStatusBar),this.b=k,this.c=new g(this)}$acceptStaticEntries($){for(const k of $)this.e.set(k.entryId,k)}createStatusBarEntry($,k,C,E){return new w(this.a,this.b,this.e,$,k,C,E)}setStatusBarMessage($,k){const C=this.c.setMessage($);let E;return typeof k=="number"?E=setTimeout(()=>C.dispose(),k):typeof k<"u"&&k.then(()=>C.dispose(),()=>C.dispose()),new S.$LJ(()=>{C.dispose(),clearTimeout(E)})}}e.$jbc=P}),define(Se[114],De([1,0,5,4,6]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nac=e.$Mac=void 0;class L{constructor(f,w){this.c=w,this.b=new F.$ec,this.onDidChangeStorage=this.b.event,this.a=f.getProxy(S.$JJ.MainThreadStorage)}registerExtensionStorageKeysToSync(f,w){this.a.$registerExtensionStorageKeysToSync(f,w)}async initializeExtensionStorage(f,w,g){const P=await this.a.$initializeExtensionStorage(f,w);let I;return P&&(I=this.d(f,w,P)),I||g}setValue(f,w,g){return this.a.$setValue(f,w,g)}$acceptValue(f,w,g){const P=this.d(f,w,g);P&&this.b.fire({shared:f,key:w,value:P})}d(f,w,g){try{return JSON.parse(g)}catch(P){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${w}, global: ${f}): ${P}`)}}}e.$Mac=L,e.$Nac=(0,h.$ph)("IExtHostStorage")}),define(Se[90],De([1,0,6,26,17,67,2]),function(me,e,S,F,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tac=e.$Sac=void 0,e.$Sac=(0,S.$ph)("IExtensionStoragePaths");let f=class{constructor(g,P,I){this.d=P,this.f=I,this.a=g.workspace??void 0,this.b=g.environment,this.whenReady=this.h().then($=>this.c=$)}async g(g){return A.URI.joinPath(this.b.workspaceStorageHome,g)}async h(){if(!this.a)return Promise.resolve(void 0);const g=this.a.id,P=await this.g(g);try{return await this.f.value.stat(P),this.d.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",P),await this.f.value.createDirectory(P),await this.f.value.writeFile(A.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),P}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(g){if(this.c)return A.URI.joinPath(this.c,g.identifier.value)}globalValue(g){return A.URI.joinPath(this.b.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Tac=f,e.$Tac=f=Je([Be(0,F.$2L),Be(1,h.$Ri),Be(2,L.$Rac)],f)}),define(Se[43],De([1,0,4,5,6,2,20,3,7,205,8,246,22,31,247,56,13,10,33]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E,n,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xac=e.$Wac=e.$Vac=e.$Uac=void 0,e.$Uac=(0,h.$ph)("IExtHostTerminalService");class m{constructor(u,d,p,R){this.k=u,this._id=d,this.l=p,this.m=R,this.a=!1,this.i={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(j=>this.f=j);const O=this;this.value={get name(){return O.m||""},get processId(){return O.b},get creationOptions(){return O.l},get exitStatus(){return O.h},get state(){return O.i},get selection(){return O.j},sendText(j,T=!0){O.o(),O.k.$sendText(O._id,j,T)},show(j){O.o(),O.k.$show(O._id,j)},hide(){O.o(),O.k.$hide(O._id)},dispose(){O.a||(O.a=!0,O.k.$dispose(O._id))},get dimensions(){if(!(O.d===void 0||O.g===void 0))return{columns:O.d,rows:O.g}}}}async create(u,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:u.name,shellPath:u.shellPath??void 0,shellArgs:u.shellArgs??void 0,cwd:u.cwd??void 0,env:u.env??void 0,icon:c(u.iconPath)??void 0,color:E.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:u.message??void 0,strictEnv:u.strictEnv??void 0,hideFromUser:u.hideFromUser??void 0,isFeatureTerminal:d?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:d?.useShellEnvironment??void 0,location:d?.location||this.n(u.location,d?.resolvedExtHostIdentifier),isTransient:u.isTransient??void 0})}async createExtensionTerminal(u,d,p,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:p,color:E.ThemeColor.isThemeColor(R)?R.id:void 0,location:this.n(u,d),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(u,d){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&d?{parentTerminal:d}:"viewColumn"in u?{viewColumn:o.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus}:void 0:u}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(u){this.m=u}setExitStatus(u,d){this.h=Object.freeze({code:u,reason:d})}setDimensions(u,d){return u===this.d&&d===this.g||u===0||d===0?!1:(this.d=u,this.g=d,!0)}setInteractedWith(){return this.i.isInteractedWith?!1:(this.i={isInteractedWith:!0},!0)}setSelection(u){this.j=u}_setProcessId(u){this.f?(this.f(u),this.f=void 0):this.b.then(d=>{d!==u&&(this.b=Promise.resolve(u))})}}e.$Vac=m;class v{get onProcessReady(){return this.b.event}constructor(u){this.g=u,this.id=0,this.shouldPersist=!1,this.a=new S.$ec,this.onProcessData=this.a.event,this.b=new S.$ec,this.d=new S.$ec,this.onDidChangeProperty=this.d.event,this.f=new S.$ec,this.onProcessExit=this.f.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,d){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${d}`)}async start(){}shutdown(){this.g.close()}input(u){this.g.handleInput?.(u)}resize(u,d){this.g.setDimensions?.({columns:u,rows:d})}clearBuffer(){}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(u){this.g.onDidWrite(d=>this.a.fire(d)),this.g.onDidClose?.((d=void 0)=>{this.f.fire(d===void 0?void 0:d)}),this.g.onDidOverrideDimensions?.(d=>{d&&this.d.fire({type:"overrideDimensions",value:{cols:d.columns,rows:d.rows}})}),this.g.onDidChangeName?.(d=>{this.d.fire({type:"title",value:d})}),this.g.open(u||void 0),u&&this.g.setDimensions?.(u),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let D=1,t=class extends f.$lb{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(u=>u.value)}constructor(u,d,p){super(),this.M=d,this.f=[],this.g=new Map,this.h={},this.i={},this.j={},this.k=new Map,this.n=this.B(new f.$mb),this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new S.$ec,this.onDidCloseTerminal=this.C.event,this.D=new S.$ec,this.onDidOpenTerminal=this.D.event,this.F=new S.$ec,this.onDidChangeActiveTerminal=this.F.event,this.G=new S.$ec,this.onDidChangeTerminalDimensions=this.G.event,this.H=new S.$ec,this.onDidChangeTerminalState=this.H.event,this.I=new S.$ec,this.onDidChangeShell=this.I.event,this.J=new S.$ec({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.J.event,this.L=new S.$ec({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.L.event,this.a=p.getProxy(F.$JJ.MainThreadTerminalService),this.s=new C.$dkb(this.a.$sendProcessData),this.a.$registerProcessSupport(u),this.B({dispose:()=>{for(const[R,O]of this.g)O.shutdown(!0)}})}getDefaultShell(u){return(u?this.m:this.l)?.path||""}getDefaultShellArgs(u){return(u?this.m:this.l)?.args||[]}createExtensionTerminal(u,d){const p=new m(this.a,(0,k.$3e)(),u,u.name),R=new v(u.pty);return p.createExtensionTerminal(u.location,this.N(u,d).resolvedExtHostIdentifier,c(u.iconPath),l(u.color)).then(O=>{const j=this.O(O,R);this.h[O]=j}),this.f.push(p),p.value}N(u,d){if(d=d||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const p=u.location.parentTerminal;if(p){const R=this.f.find(O=>O.value===p);R&&(d.resolvedExtHostIdentifier=R._id)}}else u.location&&typeof u.location!="object"?d.location=u.location:d.location&&typeof d.location=="object"&&"splitActiveTerminal"in d.location&&(d.location={splitActiveTerminal:!0});return d}attachPtyToTerminal(u,d){if(!this.Q(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const R=new v(d),O=this.O(u,R);this.h[u]=O}async $acceptActiveTerminalChanged(u){const d=this.b;if(u===null){this.b=void 0,d!==this.b&&this.F.fire(this.b);return}const p=this.Q(u);p&&(this.b=p,d!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(u,d){const p=this.Q(u);p&&this.J.fire({terminal:p.value,data:d})}async $acceptTerminalDimensions(u,d,p){const R=this.Q(u);R&&R.setDimensions(d,p)&&this.G.fire({terminal:R.value,dimensions:R.value.dimensions})}async $acceptDidExecuteCommand(u,d){const p=this.Q(u);p&&this.L.fire({terminal:p.value,...d})}async $acceptTerminalMaximumDimensions(u,d,p){this.g.get(u)?.resize(d,p)}async $acceptTerminalTitleChange(u,d){const p=this.Q(u);p&&(p.name=d)}async $acceptTerminalClosed(u,d,p){const R=this.S(this.f,u);if(R!==null){const O=this.f.splice(R,1)[0];O.setExitStatus(d,p),this.C.fire(O.value)}}$acceptTerminalOpened(u,d,p,R){if(d){const T=this.S(this.f,d);if(T!==null){this.f[T]._id=u,this.D.fire(this.terminals[T]),this.f[T].isOpen=!0;return}}const O={name:R.name,shellPath:R.executable,shellArgs:R.args,cwd:typeof R.cwd=="string"?R.cwd:L.URI.revive(R.cwd),env:R.env,hideFromUser:R.hideFromUser},j=new m(this.a,u,O,p);this.f.push(j),this.D.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(u,d){this.Q(u)?._setProcessId(d)}async $startExtensionTerminal(u,d){const p=this.Q(u);if(!p)return{message:(0,g.localize)(0,null,u)};p.isOpen||await new Promise(O=>{const j=this.onDidOpenTerminal(async T=>{T===p.value&&(j.dispose(),O())})});const R=this.g.get(u);R?R.startSendingEvents(d):this.i[u]={initialDimensions:d}}O(u,d){const p=new f.$kb;p.add(d.onProcessReady(O=>this.a.$sendProcessReady(u,O.pid,O.cwd,O.windowsPty))),p.add(d.onDidChangeProperty(O=>this.a.$sendProcessProperty(u,O))),this.s.startBuffering(u,d.onProcessData),p.add(d.onProcessExit(O=>this.P(u,O))),this.g.set(u,d);const R=this.i[u];return R&&d instanceof v&&(d.startSendingEvents(R.initialDimensions),delete this.i[u]),p}$acceptProcessAckDataEvent(u,d){this.g.get(u)?.acknowledgeDataEvent(d)}$acceptProcessInput(u,d){this.g.get(u)?.input(d)}$acceptTerminalInteraction(u){const d=this.Q(u);d?.setInteractedWith()&&this.H.fire(d.value)}$acceptTerminalSelection(u,d){this.Q(u)?.setSelection(d)}$acceptProcessResize(u,d,p){try{this.g.get(u)?.resize(d,p)}catch(R){if(R.code!=="EPIPE"&&R.code!=="ERR_IPC_CHANNEL_CLOSED")throw R}}$acceptProcessShutdown(u,d){this.g.get(u)?.shutdown(d)}$acceptProcessRequestInitialCwd(u){this.g.get(u)?.getInitialCwd().then(d=>this.a.$sendProcessProperty(u,{type:"initialCwd",value:d}))}$acceptProcessRequestCwd(u){this.g.get(u)?.getCwd().then(d=>this.a.$sendProcessProperty(u,{type:"cwd",value:d}))}$acceptProcessRequestLatency(u){return Promise.resolve(u)}registerLinkProvider(u){return this.u.add(u),this.u.size===1&&this.a.$startLinkProvider(),new w.$LJ(()=>{this.u.delete(u),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(u,d,p){if(this.v.has(d))throw new Error(`Terminal profile provider "${d}" already registered`);return this.v.set(d,p),this.a.$registerProfileProvider(d,u.identifier.value),new w.$LJ(()=>{this.v.delete(d),this.a.$unregisterProfileProvider(d)})}registerTerminalQuickFixProvider(u,d,p){if(this.w.has(u))throw new Error(`Terminal quick fix provider "${u}" is already registered`);return this.w.set(u,p),this.a.$registerQuickFixProvider(u,d),new w.$LJ(()=>{this.w.delete(u),this.a.$unregisterQuickFixProvider(u)})}async $provideTerminalQuickFixes(u,d){const p=new $.$oc().token;if(p.isCancellationRequested)return;const R=this.w.get(u);if(!R)return;const O=await R.provideTerminalQuickFixes(d,p);if(O===null||Array.isArray(O)&&O.length===0)return;const j=new f.$kb;if(this.n.value=j,!Array.isArray(O))return O?o.TerminalQuickFix.from(O,this.M.converter,j):void 0;const T=[];for(const z of O){const B=o.TerminalQuickFix.from(z,this.M.converter,j);B&&T.push(B)}return T}async $createContributedProfileTerminal(u,d){const p=new $.$oc().token;let R=await this.v.get(u)?.provideTerminalProfile(p);if(!p.isCancellationRequested){if(R&&!("options"in R)&&(R={options:R}),!R||!("options"in R))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in R.options){this.createExtensionTerminal(R.options,d);return}this.createTerminalFromOptions(R.options,d)}}async $provideLinks(u,d){const p=this.Q(u);if(!p)return[];this.y.delete(u),this.z.get(u)?.dispose(!0);const O=new $.$oc;this.z.set(u,O);const j=[],T={terminal:p.value,line:d},z=[];for(const Y of this.u)z.push(n.Promises.withAsyncBody(async J=>{O.token.onCancellationRequested(()=>J({provider:Y,links:[]}));const fe=await Y.provideTerminalLinks(T,O.token)||[];O.token.isCancellationRequested||J({provider:Y,links:fe})}));const B=await Promise.all(z);if(O.token.isCancellationRequested)return[];const M=new Map;for(const Y of B)Y&&Y.links.length>0&&j.push(...Y.links.map(J=>{const fe={id:D++,startIndex:J.startIndex,length:J.length,label:J.tooltip};return M.set(fe.id,{provider:Y.provider,link:J}),fe}));return this.y.set(u,M),j}$activateLink(u,d){const p=this.y.get(u)?.get(d);p&&p.provider.handleTerminalLink(p.link)}P(u,d){this.s.stopBuffering(u),this.g.delete(u),delete this.i[u];const p=this.h[u];p&&(p.dispose(),delete this.h[u]),this.a.$sendProcessExit(u,d)}Q(u){return this.R(this.f,u)}R(u,d){const p=this.S(u,d);return p!==null?u[p]:null}S(u,d){const p=u.findIndex(R=>R._id===d);return p===-1?null:p}getEnvironmentVariableCollection(u){let d=this.k.get(u.identifier.value);return d||(d=new r,this.W(u.identifier.value,d)),d.getScopedEnvironmentVariableCollection(void 0)}U(u,d){const p=(0,I.$4q)(d.map),R=(0,I.$5q)(d.descriptionMap);this.a.$setEnvironmentVariableCollection(u,d.persistent,p.length===0?void 0:p,R)}$initEnvironmentVariableCollections(u){u.forEach(d=>{const p=d[0],R=new r(d[1]);this.W(p,R)})}$acceptDefaultProfile(u,d){const p=this.l;this.l=u,this.m=d,p?.path!==u.path&&this.I.fire(u.path)}W(u,d){this.k.set(u,d),d.onDidChangeCollection(()=>{this.U(u,d)})}};e.$Wac=t,e.$Wac=t=Je([Be(1,a.$8L),Be(2,A.$LL)],t);class r{get persistent(){return this.b}set persistent(u){this.b=u,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(u){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new S.$ec,this.map=new Map(u)}getScopedEnvironmentVariableCollection(u){const d=this.h(u);let p=this.a.get(d);return p||(p=new s(this,u),this.a.set(d,p),p.onDidChangeCollection(()=>this.d.fire())),p}replace(u,d,p,R){this.f(u,{value:d,type:w.EnvironmentVariableMutatorType.Replace,options:p??{applyAtProcessCreation:!0},scope:R})}append(u,d,p,R){this.f(u,{value:d,type:w.EnvironmentVariableMutatorType.Append,options:p??{applyAtProcessCreation:!0},scope:R})}prepend(u,d,p,R){this.f(u,{value:d,type:w.EnvironmentVariableMutatorType.Prepend,options:p??{applyAtProcessCreation:!0},scope:R})}f(u,d){if(d.options&&d.options.applyAtProcessCreation===!1&&!d.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const p=this.g(u,d.scope),R=this.map.get(p),O=d.options?{applyAtProcessCreation:d.options.applyAtProcessCreation??!1,applyAtShellIntegration:d.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!R||R.value!==d.value||R.type!==d.type||R.options?.applyAtProcessCreation!==O.applyAtProcessCreation||R.options?.applyAtShellIntegration!==O.applyAtShellIntegration||R.scope?.workspaceFolder?.index!==d.scope?.workspaceFolder?.index){const j=this.g(u,d.scope),T={variable:u,...d,options:O};this.map.set(j,T),this.d.fire()}}get(u,d){const p=this.g(u,d),R=this.map.get(p);return R?b(R):void 0}g(u,d){const p=this.h(d);return p.length?`${u}:::${p}`:u}h(u){return this.i(u?.workspaceFolder)??""}i(u){return u?u.uri.toString():void 0}getVariableMap(u){const d=new Map;for(const[p,R]of this.map)this.h(R.scope)===this.h(u)&&d.set(R.variable,b(R));return d}delete(u,d){const p=this.g(u,d);this.map.delete(p),this.d.fire()}clear(u){if(u?.workspaceFolder){for(const[d,p]of this.map)p.scope?.workspaceFolder?.index===u.workspaceFolder.index&&this.map.delete(d);this.j(u)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(u,d){const p=this.h(d),R=this.descriptionMap.get(p);if(!R||R.description!==u){let O;typeof u=="string"?O=u:O=u?.value.split(`

`)[0];const j={description:O,scope:d};this.descriptionMap.set(p,j),this.d.fire()}}getDescription(u){const d=this.h(u);return this.descriptionMap.get(d)?.description}j(u){const d=this.h(u);this.descriptionMap.delete(d)}}class s{get persistent(){return this.b.persistent}set persistent(u){this.b.persistent=u}get onDidChangeCollection(){return this.a&&this.a.event}constructor(u,d){this.b=u,this.d=d,this.a=new S.$ec}getScoped(u){return this.b.getScopedEnvironmentVariableCollection(u)}replace(u,d,p){this.b.replace(u,d,p,this.d)}append(u,d,p){this.b.append(u,d,p,this.d)}prepend(u,d,p){this.b.prepend(u,d,p,this.d)}get(u){return this.b.get(u,this.d)}forEach(u,d){this.b.getVariableMap(this.d).forEach((p,R)=>u.call(d,R,p,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(u){this.b.delete(u,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(u){this.b.setDescription(u,this.d)}get description(){return this.b.getDescription(this.d)}}let i=class extends t{constructor(u,d){super(!1,u,d)}createTerminal(u,d,p){throw new P.$$}createTerminalFromOptions(u,d){throw new P.$$}};e.$Xac=i,e.$Xac=i=Je([Be(0,a.$8L),Be(1,A.$LL)],i);function c(y){if(!(!y||typeof y=="string"))return"id"in y?{id:y.id,color:y.color}:y}function l(y){return E.ThemeColor.isThemeColor(y)?y:void 0}function b(y){const u={...y};return delete u.scope,u.options=u.options??void 0,delete u.variable,u}}),define(Se[318],De([1,0,18,13,21,22,4,71,74,3,23,19,31,5,20,143,10,7,63,108,87,27]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E,n,o,a,m,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=e.$7bc=e.$6bc=e.$5bc=void 0;let t=class{constructor(T,z,B){this.k=B,this.d=new A.$ec,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=T.getProxy(k.$JJ.MainThreadTesting),this.j=new p(this.g),this.h=new c(this.g),z.registerArgumentProcessor({processArgument:M=>{switch(M?.$mid){case 15:{const Y=M,J=Y.tests[Y.tests.length-1].item.extId;return this.f.get(a.$wI.root(J))?.collection.tree.get(J)?.actual??(0,E.$XL)(M)}case 17:{const{extId:Y,message:J}=M;return{test:this.f.get(a.$wI.root(Y))?.collection.tree.get(Y)?.actual,message:n.TestMessage.to(J)}}default:return M}}}),z.registerCommand(!1,"testing.getExplorerSelection",async()=>{const M=await z.executeCommand("_testing.getExplorerSelection"),Y=J=>{const fe=this.f.get(a.$wI.root(J));if(fe)return a.$wI.isRoot(J)?fe.controller:fe.collection.tree.get(J)?.actual};return{include:M?.include.map(Y).filter(I.$qe)||[],exclude:M?.exclude.map(Y).filter(I.$qe)||[]}})}createTestController(T,z,B,M){if(this.f.has(z))throw new Error(`Attempt to insert a duplicate controller with ID "${z}"`);const Y=new g.$kb,J=Y.add(new E.$1L(z,B,this.k));J.root.label=B;const fe=new Map,se=this.g,ie={items:J.root.children,get label(){return B},set label(re){B=re,J.root.label=re,se.$updateController(z,{label:B})},get refreshHandler(){return M},set refreshHandler(re){M=re,se.$updateController(z,{canRefresh:!!re})},get id(){return z},createRunProfile:(re,pe,ae,ne,x,N)=>{let q=(0,w.$di)(re);for(;fe.has(q);)q++;return new R(this.g,fe,z,q,re,pe,ae,ne,x,N)},createTestItem(re,pe,ae){return new E.$YL(z,re,pe,ae)},createTestRun:(re,pe,ae=!0)=>this.h.createTestRun(T,z,J,re,pe,ae),invalidateTestResults:re=>{if(re===void 0)this.g.$markTestRetired(void 0);else{const pe=re instanceof Array?re:[re];this.g.$markTestRetired(pe.map(ae=>a.$wI.fromExtHostTestItem(ae,z).toString()))}},set resolveHandler(re){J.resolveHandler=re},get resolveHandler(){return J.resolveHandler},dispose:()=>{Y.dispose()}};se.$registerTestController(z,B,!!M),Y.add((0,g.$jb)(()=>se.$unregisterTestController(z)));const V={controller:ie,collection:J,profiles:fe,extension:T};return this.f.set(z,V),Y.add((0,g.$jb)(()=>this.f.delete(z))),Y.add(J.onDidGenerateDiff(re=>se.$publishDiff(z,re.map(v.TestsDiffOp.serialize)))),ie}createTestObserver(){return this.j.checkout()}async runTests(T,z=L.CancellationToken.None){const B=l(T);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const M=this.f.get(B.controllerId);if(!M)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:T.include?.map(Y=>a.$wI.fromExtHostTestItem(Y,M.collection.root.id).toString())??[M.collection.root.id],profileGroup:O[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:T.exclude?.map(Y=>Y.id)},z)}$syncTests(){for(const{collection:T}of this.f.values())T.flushDiff();return Promise.resolve()}$provideFileCoverage(T,z,B){return(0,S.$If)(this.h.trackers,Y=>Y.id===T?Y.getCoverage(z):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(T,z,B,M){return(0,S.$If)(this.h.trackers,J=>J.id===T?J.getCoverage(z):void 0)?.resolveFileCoverage(B,M)??Promise.resolve([])}$configureRunProfile(T,z){this.f.get(T)?.profiles.get(z)?.configureHandler?.()}async $refreshTests(T,z){await this.f.get(T)?.controller.refreshHandler?.(z)}$publishTestResults(T){this.results=Object.freeze(T.map(z=>(0,P.$Jm)(n.TestResults.to(z))).concat(this.results).sort((z,B)=>B.completedAt-z.completedAt).slice(0,32)),this.d.fire()}async $expandTest(T,z){const B=this.f.get(a.$wI.fromString(T).controllerId)?.collection;B&&(await B.expand(T,z<0?1/0:z),B.flushDiff())}$acceptDiff(T){this.j.applyDiff(T.map(v.TestsDiffOp.deserialize))}async $runControllerTests(T,z){return Promise.all(T.map(B=>this.l(B,!1,z)))}async $startContinuousRun(T,z){const B=new L.$oc(z),M=await Promise.all(T.map(Y=>this.l(Y,!0,B.token)));return!z.isCancellationRequested&&!M.some(Y=>Y.error)&&await new Promise(Y=>z.onCancellationRequested(Y)),B.dispose(!0),M}async l(T,z,B){const M=this.f.get(T.controllerId);if(!M)return{};const{collection:Y,profiles:J,extension:fe}=M,se=J.get(T.profileId);if(!se)return{};const ie=T.testIds.map(ae=>Y.tree.get(ae)).filter(I.$qe),V=T.excludeExtIds.map(ae=>M.collection.tree.get(ae)).filter(I.$qe).filter(ae=>ie.some(ne=>ne.fullId.compare(ae.fullId)===2));if(!ie.length)return{};const re=new o.$iL(ie.some(ae=>ae.actual instanceof E.$ZL)?void 0:ie.map(ae=>ae.actual),V.map(ae=>ae.actual),se,z),pe=(0,v.$yI)(T)&&this.h.prepareForMainThreadTestRun(re,b.fromInternal(T,M.collection),fe,B);try{return await se.runHandler(re,B),{}}catch(ae){return{error:String(ae)}}finally{pe&&(pe.hasRunningTasks&&!B.isCancellationRequested&&await A.Event.toPromise(pe.onEnd),pe.dispose())}}$cancelExtensionTestRun(T){T===void 0?this.h.cancelAllRuns():this.h.cancelRunById(T)}};e.$5bc=t,e.$5bc=t=Je([Be(0,C.$LL)],t);const r=1e4;var s;(function(j){j[j.Running=0]="Running",j[j.Cancelling=1]="Cancelling",j[j.Ended=2]="Ended"})(s||(s={}));class i extends g.$lb{get hasRunningTasks(){return this.g.size>0}get id(){return this.l.id}constructor(T,z,B,M){super(),this.l=T,this.m=z,this.p=B,this.f=0,this.g=new Map,this.h=new Set,this.k=this.B(new A.$ec),this.onEnd=this.k.event,this.j=this.B(new L.$oc(M));const Y=this.B(new F.$Gg(()=>this.s(),r));this.B(this.j.token.onCancellationRequested(()=>Y.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.s()}getCoverage(T){return this.g.get(T)?.coverage}createRun(T){const z=this.l.id,B=this.l.controllerId,M=(0,$.$3e)(),Y=new y(this.m,z,M),J=V=>(re,...pe)=>{if(se){console.warn(`Setting the state of test "${re.id}" is a no-op after the run ends.`);return}this.l.isIncluded(re)&&(this.v(re),V(re,...pe))},fe=(V,re)=>{const pe=re instanceof Array?re.map(n.TestMessage.from):[n.TestMessage.from(re)];if(pe.some(ae=>ae.contextValue!==void 0)&&(0,D.$EF)(this.p,"testMessageContextValue"),V.uri&&V.range){const ae={range:n.Range.from(V.range),uri:V.uri};for(const ne of pe)ne.location=ne.location||ae}this.m.$appendTestMessagesInRun(z,M,a.$wI.fromExtHostTestItem(V,B).toString(),pe)};let se=!1;const ie={isPersisted:this.l.isPersisted,token:this.j.token,name:T,get coverageProvider(){return Y.coverageProvider},set coverageProvider(V){Y.coverageProvider=V},enqueued:J(V=>{this.m.$updateTestStateInRun(z,M,a.$wI.fromExtHostTestItem(V,B).toString(),1)}),skipped:J(V=>{this.m.$updateTestStateInRun(z,M,a.$wI.fromExtHostTestItem(V,B).toString(),5)}),started:J(V=>{this.m.$updateTestStateInRun(z,M,a.$wI.fromExtHostTestItem(V,B).toString(),2)}),errored:J((V,re,pe)=>{fe(V,re),this.m.$updateTestStateInRun(z,M,a.$wI.fromExtHostTestItem(V,B).toString(),6,pe)}),failed:J((V,re,pe)=>{fe(V,re),this.m.$updateTestStateInRun(z,M,a.$wI.fromExtHostTestItem(V,B).toString(),4,pe)}),passed:J((V,re)=>{this.m.$updateTestStateInRun(z,M,a.$wI.fromExtHostTestItem(V,this.l.controllerId).toString(),3,re)}),appendOutput:(V,re,pe)=>{se||(pe&&(this.l.isIncluded(pe)?this.v(pe):pe=void 0),this.m.$appendOutputToRun(z,M,h.$Ec.fromString(V),re&&n.location.from(re),pe&&a.$wI.fromExtHostTestItem(pe,B).toString()))},end:()=>{se||(se=!0,this.m.$finishedTestRunTask(z,M),this.g.delete(M),this.g.size||this.u())}};return this.g.set(M,{run:ie,coverage:Y}),this.m.$startedTestRunTask(z,{id:M,name:T,running:!0}),ie}s(){for(const{run:T}of this.g.values())T.end()}u(){this.f!==2&&(this.f=2,this.k.fire())}v(T){if(!(T instanceof E.$YL))throw new m.$DL(T.id);if(this.h.has(a.$wI.fromExtHostTestItem(T,this.l.controllerId).toString()))return;const z=[],B=this.l.colllection.root;for(;;){const M=n.TestItem.from(T);if(z.unshift(M),this.h.has(M.extId)||(this.h.add(M.extId),T===B))break;T=T.parent||B}this.m.$addTestsToRun(this.l.controllerId,this.l.id,z)}}class c{get trackers(){return this.d.values()}constructor(T){this.f=T,this.d=new Map}prepareForMainThreadTestRun(T,z,B,M){return this.g(T,z,B,M)}cancelRunById(T){for(const z of this.d.values())if(z.id===T){z.cancel();return}}cancelAllRuns(){for(const T of this.d.values())T.cancel()}createTestRun(T,z,B,M,Y,J){const fe=this.d.get(M);if(fe)return fe.createRun(Y);const se=b.fromPublic(z,B,M,J),ie=l(M);this.f.$startedExtensionTestRun({controllerId:z,continuous:!!M.continuous,profile:ie&&{group:O[ie.kind],id:ie.profileId},exclude:M.exclude?.map(re=>a.$wI.fromExtHostTestItem(re,B.root.id).toString())??[],id:se.id,include:M.include?.map(re=>a.$wI.fromExtHostTestItem(re,B.root.id).toString())??[B.root.id],persist:J});const V=this.g(M,se,T);return V.onEnd(()=>{this.f.$finishedExtensionTestRun(se.id),V.dispose()}),V.createRun(Y)}g(T,z,B,M){const Y=new i(z,this.f,B,M);return this.d.set(T,Y),Y.onEnd(()=>this.d.delete(T)),Y}}e.$6bc=c;const l=j=>{if(j.profile){if(!(j.profile instanceof R))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return j.profile}};class b{static fromPublic(T,z,B,M){return new b(T,(0,$.$3e)(),B.include?.map(Y=>a.$wI.fromExtHostTestItem(Y,T).toString())??[T],B.exclude?.map(Y=>a.$wI.fromExtHostTestItem(Y,T).toString())??[],M,z)}static fromInternal(T,z){return new b(T.controllerId,T.runId,T.testIds,T.excludeExtIds,!0,z)}constructor(T,z,B,M,Y,J){this.controllerId=T,this.id=z,this.isPersisted=Y,this.colllection=J,this.d=B.map(fe=>fe+"\0"),this.f=M.map(fe=>fe+"\0")}isIncluded(T){const z=a.$wI.fromExtHostTestItem(T,this.controllerId).toString()+"\0";for(const B of this.f)if(z===B||z.startsWith(B))return!1;for(const B of this.d)if(z===B||z.startsWith(B))return!0;return!1}}e.$7bc=b;class y{set coverageProvider(T){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");T&&(this.d=T,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(T,z,B){this.g=T,this.h=z,this.j=B}async provideFileCoverage(T){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(T))());try{return(await this.f)?.map(n.TestCoverage.fromFile)??[]}catch(z){throw this.f=void 0,z}}async resolveFileCoverage(T,z){const B=await this.f;let M=B?.[T];return!this.d||!B||!M?[]:(M.detailedCoverage||(M=B[T]=await this.d.resolveFileCoverage?.(M,z)??M),M.detailedCoverage?.map(n.TestCoverage.fromDetailed)??[])}}class u{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(T){this.j=T,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(T){this.d.add(T)}update(T){Object.assign(T.revived,n.TestItem.toPlain(T.item)),this.d.has(T)||this.f.add(T)}remove(T){if(this.d.has(T)){this.d.delete(T);return}this.f.delete(T);const z=a.$wI.parentId(T.item.extId);if(z&&this.h.has(z.toString())){this.h.add(T.item.extId);return}this.g.add(T)}getChangeEvent(){const{d:T,f:z,g:B}=this;return{get added(){return[...T].map(M=>M.revived)},get updated(){return[...z].map(M=>M.revived)},get removed(){return[...B].map(M=>M.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class d extends v.$DI{constructor(){super(...arguments),this.s=new A.$ec,this.onDidChangeTests=this.s.event}get rootTests(){return super.g}getMirroredTestDataById(T){return this.f.get(T)}getMirroredTestDataByReference(T){return this.f.get(T.id)}q(T,z){return{...T,revived:n.TestItem.toPlain(T.item),depth:z?z.depth+1:0,children:new Set}}p(){return new u(this.s)}}class p{constructor(T){this.f=T}checkout(){this.d||(this.d=this.g());const T=this.d;return T.observers++,{onDidChangeTest:T.tests.onDidChangeTests,get tests(){return[...T.tests.rootTests].map(z=>z.revived)},dispose:(0,f.$cb)(()=>{--T.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(T){return this.d?.tests.getMirroredTestDataByReference(T)}applyDiff(T){this.d?.tests.apply(T)}g(){const T=new d;return this.f.$subscribeToDiffs(),{observers:0,tests:T}}}class R{#e;#t;get label(){return this.f}set label(T){T!==this.f&&(this.f=T,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:T}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(T){T!==this.h&&(this.h=T,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:T}))}get isDefault(){return this.g}set isDefault(T){T!==this.g&&(this.g=T,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:T}))}get tag(){return this._tag}set tag(T){T?.id!==this._tag?.id&&(this._tag=T,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:T?n.TestTag.namespace(this.controllerId,T.id):null}))}get configureHandler(){return this.d}set configureHandler(T){T!==this.d&&(this.d=T,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!T}))}constructor(T,z,B,M,Y,J,fe,se=!1,ie=void 0,V=!1){this.controllerId=B,this.profileId=M,this.f=Y,this.kind=J,this.runHandler=fe,this.g=se,this._tag=ie,this.h=V,this.#e=T,this.#t=z,z.set(M,this);const re=O[J];if(typeof re!="number")throw new Error(`Unknown TestRunProfile.group ${J}`);this.#e.$publishTestRunProfile({profileId:M,controllerId:B,tag:ie?n.TestTag.namespace(this.controllerId,ie.id):null,label:Y,group:re,isDefault:se,hasConfigurationHandler:!1,supportsContinuousRun:V})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$8bc=R;const O={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Se[319],De([1,0,18,8,4,5,144,10,7]),function(me,e,S,F,h,L,A,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kbc=void 0;class g{constructor(I,$){this.i=$,this.a=new h.$ec({onListenerError:F.$Z}),this.b=new h.$ec({onListenerError:F.$Z}),this.c=new h.$ec({onListenerError:F.$Z}),this.d=new h.$ec({onListenerError:F.$Z}),this.f=new h.$ec({onListenerError:F.$Z}),this.g=new h.$ec({onListenerError:F.$Z}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=I.getProxy(L.$JJ.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(k=>this.g.fire(k)),this.i.onDidChangeActiveTextEditor(k=>this.f.fire(k))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(I){const $=this.i.allEditors();return I?$:$.map(k=>k.value)}async showTextDocument(I,$,k){let C;typeof $=="number"?C={position:f.ViewColumn.from($),preserveFocus:k}:typeof $=="object"?C={position:f.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus,selection:typeof $.selection=="object"?f.Range.from($.selection):void 0,pinned:typeof $.preview=="boolean"?!$.preview:void 0}:C={preserveFocus:!1};const E=await this.h.$tryShowTextDocument(I.uri,C),n=E&&this.i.getEditor(E);if(n)return n.value;throw E?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,$){return new A.$SL(this.h,I,$).value}$acceptEditorPropertiesChanged(I,$){const k=this.i.getEditor(I);if(!k)throw new Error("unknown text editor");if($.options&&k._acceptOptions($.options),$.selections){const C=$.selections.selections.map(f.Selection.to);k._acceptSelections(C)}if($.visibleRanges){const C=S.$jf($.visibleRanges.map(f.Range.to));k._acceptVisibleRanges(C)}if($.options&&this.b.fire({textEditor:k.value,options:{...$.options,lineNumbers:f.TextEditorLineNumbersStyle.to($.options.lineNumbers)}}),$.selections){const C=w.TextEditorSelectionChangeKind.fromValue($.selections.source),E=$.selections.selections.map(f.Selection.to);this.a.fire({textEditor:k.value,selections:E,kind:C})}if($.visibleRanges){const C=S.$jf($.visibleRanges.map(f.Range.to));this.c.fire({textEditor:k.value,visibleRanges:C})}}$acceptEditorPositionData(I){for(const $ in I){const k=this.i.getEditor($);if(!k)throw new Error("Unknown text editor");const C=f.ViewColumn.to(I[$]);k.value.viewColumn!==C&&(k._acceptViewColumn(C),this.d.fire({textEditor:k.value,viewColumn:C}))}}getDiffInformation(I){return Promise.resolve(this.h.$getDiffInformation(I))}}e.$kbc=g}),define(Se[320],De([1,0,2,6,5,3,7,10,25,19]),function(me,e,S,F,h,L,A,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=e.$Ybc=void 0,e.$Ybc=(0,F.$ph)("IExtHostTimeline");class P{constructor(k,C){this.b=new Map,this.c=new Map,this.a=k.getProxy(h.$JJ.MainThreadTimeline),C.registerArgumentProcessor({processArgument:(E,n)=>{if(E&&E.$mid===12)if(this.b.get(E.source)&&w.$Il.equals(n,this.b.get(E.source)?.extension)){const o=E.uri===void 0?void 0:S.URI.revive(E.uri);return this.c.get(E.source)?.get(I(o))?.get(E.handle)}else return;return E}})}async $getTimeline(k,C,E,n){return this.b.get(k)?.provider.provideTimeline(S.URI.revive(C),E,n)}registerTimelineProvider(k,C,E,n){const o=new L.$kb,a=this.d(C.id,n,o).bind(this);let m;C.onDidChange&&(m=C.onDidChange(D=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...D,id:C.id}),this));const v=this.c;return this.f({...C,scheme:k,onDidChange:void 0,async provideTimeline(D,t,r){t?.resetCache&&(o.clear(),v.get(C.id)?.clear());const s=await C.provideTimeline(D,t,r);if(s==null)return;const i=a(D,t);return{...s,source:C.id,items:s.items.map(i)}},dispose(){for(const D of v.values())D.get(C.id)?.clear();m?.dispose(),o.dispose()}},E)}d(k,C,E){return(n,o)=>{let a;if(o?.cacheResults){let m=this.c.get(k);m===void 0&&(m=new Map,this.c.set(k,m));const v=I(n);a=m.get(v),a===void 0&&(a=new Map,m.set(v,a))}return m=>{const{iconPath:v,...D}=m,t=`${k}|${m.id??m.timestamp}`;a?.set(t,m);let r,s,i;m.iconPath&&(v instanceof A.$GK?i={id:v.id,color:v.color}:S.URI.isUri(v)?(r=v,s=v):{light:r,dark:s}=v);let c;return A.$aK.isMarkdownString(D.tooltip)?c=f.MarkdownString.from(D.tooltip):(0,g.$ie)(D.tooltip)?c=D.tooltip:A.$aK.isMarkdownString(D.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=f.MarkdownString.from(D.detail)):(0,g.$ie)(D.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=D.detail),{...D,id:D.id??void 0,handle:t,source:k,command:m.command?C.toInternal(m.command,E):void 0,icon:r,iconDark:s,themeIcon:i,tooltip:c,accessibilityInformation:m.accessibilityInformation}}}}f(k,C){if(this.b.get(k.id))throw new Error(`Timeline Provider ${k.id} already exists.`);return this.a.$registerTimelineProvider({id:k.id,label:k.label,scheme:k.scheme}),this.b.set(k.id,{provider:k,extension:C}),(0,L.$jb)(()=>{for(const n of this.c.values())n.get(k.id)?.clear();this.b.delete(k.id),this.a.$unregisterTimelineProvider(k.id),k.dispose()})}}e.$Zbc=P;function I($){return $?.toString()}}),define(Se[68],De([1,0,22,4,3,207,6,17,106,5,26,20,7]),function(me,e,S,F,h,L,A,f,w,g,P,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mrb=e.$Lrb=e.TunnelDtoConverter=void 0;class k extends w.$Uz{}var C;(function(n){function o(m){return{remoteAddress:m.remoteAddress,localAddress:m.localAddress,public:!!m.public,privacy:m.privacy??(m.public?w.TunnelPrivacyId.Public:w.TunnelPrivacyId.Private),protocol:m.protocol}}n.fromApiTunnel=o;function a(m){return{remoteAddress:{host:m.tunnelRemoteHost,port:m.tunnelRemotePort},localAddress:m.localAddress,public:m.privacy!==w.TunnelPrivacyId.ConstantPrivate&&m.privacy!==w.TunnelPrivacyId.ConstantPrivate,privacy:m.privacy,protocol:m.protocol}}n.fromServiceTunnel=a})(C||(e.TunnelDtoConverter=C={})),e.$Lrb=(0,A.$ph)("IExtHostTunnelService");let E=class extends h.$lb{constructor(o,a,m){super(),this.n=m,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$ec,this.onDidChangeTunnels=this.h.event,this.k=0,this.l=new Map,this.a=o.getProxy(g.$JJ.MainThreadTunnelService)}async openTunnel(o,a){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${a.remoteAddress.host}:${a.remoteAddress.port}.`);const m=await this.a.$openTunnel(a,o.displayName);if(m){const v=new k(m.remoteAddress,m.localAddress,()=>this.a.$closeTunnel(m.remoteAddress));return this.B(v),v}}async getTunnels(){return this.a.$getTunnels()}p(){return this.k++}registerPortsAttributesProvider(o,a){const m=this.p();return this.l.set(m,{selector:o,provider:a}),this.a.$registerPortsAttributesProvider(o,m),new $.$LJ(()=>{this.l.delete(m),this.a.$unregisterPortsAttributesProvider(m)})}async $providePortAttributes(o,a,m,v,D){const t=[];for(const s of o){const i=this.l.get(s);if(!i)return[];t.push(...await Promise.all(a.map(async c=>{let l;try{l=await i.provider.providePortAttributes({port:c,pid:m,commandLine:v},D)}catch{l=await i.provider.providePortAttributes(c,m,v,D)}return{providedAttributes:l,port:c}})))}const r=t.filter(s=>!!s.providedAttributes);return r.length>0?r.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,a){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(v,D)=>await o.provideTunnel(v,D,new S.$oc().token)??void 0;const m=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,privacyOptions:a.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(m),Promise.resolve((0,h.$jb)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,a){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const m=o.tunnelFactory??(a?this.r(a):void 0);if(m){this.b=m;let v=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&v.length===0&&(v=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const D=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:v}:void 0;this.a.$setTunnelProvider(D)}}else this.b=void 0;return(0,h.$jb)(()=>{this.b=void 0})}r(o){}async $closeTunnel(o,a){if(this.g.has(o.host)){const m=this.g.get(o.host);m.has(o.port)&&(a&&m.get(o.port).disposeListener.dispose(),await m.get(o.port).tunnel.dispose(),m.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,a){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const m=this.b(o,a);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),m!==void 0){const v=await m;if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),v===void 0){this.n.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const D=this.B(v.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(v.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:v,disposeListener:D}),C.fromApiTunnel(v)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(m){if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),m instanceof Error)return m.message}}async $applyCandidateFilter(o){const a=await Promise.all(o.map(v=>this.f(v.host,v.port,v.detail??""))),m=o.filter((v,D)=>a[D]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(v=>v.port).join(", ")} to ${m.map(v=>v.port).join(", ")}`),m}};e.$Mrb=E,e.$Mrb=E=Je([Be(0,I.$LL),Be(1,P.$2L),Be(2,f.$Ri)],E)}),define(Se[321],De([1,0,3,16,2,5]),function(me,e,S,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9bc=void 0;class A{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor(w){this.c=new Map,this.b=w.getProxy(L.$JJ.MainThreadUriOpeners)}registerExternalUriOpener(w,g,P,I){if(this.c.has(g))throw new Error(`Opener with id '${g}' already registered`);const $=I.schemes.find(k=>!A.a.has(k));if($)throw new Error(`Scheme '${$}' is not supported. Only http and https are currently supported.`);return this.c.set(g,P),this.b.$registerUriOpener(g,I.schemes,w,I.label),(0,S.$jb)(()=>{this.c.delete(g),this.b.$unregisterUriOpener(g)})}async $canOpenUri(w,g,P){const I=this.c.get(w);if(!I)throw new Error(`Unknown opener with id: ${w}`);const $=h.URI.revive(g);return I.canOpenExternalUri($,P)}async $openUri(w,g,P){const I=this.c.get(w);if(!I)throw new Error(`Unknown opener id: '${w}'`);return I.openExternalUri(h.URI.revive(g.resolvedUri),{sourceUri:h.URI.revive(g.sourceUri)},P)}}e.$9bc=A}),define(Se[322],De([1,0,5,2,3,8,25]),function(me,e,S,F,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mbc=void 0;class f{static{this.a=0}constructor(g){this.c=new A.$Jl,this.d=new Map,this.b=g.getProxy(S.$JJ.MainThreadUrls)}registerUriHandler(g,P){const I=g.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const $=f.a++;return this.c.add(I),this.d.set($,P),this.b.$registerUriHandler($,I,g.displayName||g.name),(0,h.$jb)(()=>{this.c.delete(I),this.d.delete($),this.b.$unregisterUriHandler($)})}$handleExternalUri(g,P){const I=this.d.get(g);if(!I)return Promise.resolve(void 0);try{I.handleUri(F.URI.revive(P))}catch($){(0,L.$Y)($)}return Promise.resolve(void 0)}async createAppUri(g){return F.URI.revive(await this.b.$createAppUri(g))}}e.$mbc=f}),define(Se[91],De([1,0,4,16,23,2,221,255,109,5]),function(me,e,S,F,h,L,A,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rbc=e.$qbc=e.$pbc=e.$obc=e.$nbc=void 0;class P{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(m,v,D,t,r,s,i){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new S.$ec,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new S.$ec,this._onDidDispose=this.#h.event,this.#e=m,this.#t=v,this.#r=D,this.#l=t,this.#u=r,this.#n=s,this.#c=I(s),this.#d=$(s),this.#i=i}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return this.#a=!0,(0,w.$job)(m,this.#l)}get cspSource(){const m=this.#n.extensionLocation;if(m.scheme===F.Schemas.https||m.scheme===F.Schemas.http){let v=m.toString();return v.endsWith("/")||(v+="/"),v+" "+w.$iob}return w.$iob}get html(){return this.a(),this.#s}set html(m){this.a(),this.#s!==m&&(this.#s=m,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(m)))}get options(){return this.a(),this.#r}set options(m){this.a(),h.$Mm(this.#r,m)||this.#t.$setOptions(this.#e,E(this.#n,this.#u,m)),this.#r=m}async postMessage(m){if(this.#o)return!1;const v=(0,f.$xbb)(m,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,v.message,...v.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(m){if(!this.#d)return m;const v=this.#n.extensionLocation?.scheme===F.Schemas.vscodeRemote,D=this.#n.extensionLocation.scheme===F.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return m.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(t,r,s,i,c,l)=>{const b=L.URI.from({scheme:i||"file",path:decodeURIComponent(c)}),y=(0,w.$job)(b,{isRemote:v,authority:D}).toString();return`${r}${y}${l}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(t,r,s,i,c,l)=>{const b=L.URI.from({scheme:i||"file",path:decodeURIComponent(c)}),y=(0,w.$job)(b,{isRemote:v,authority:D}).toString();return`${r}${y}${l}`})}}e.$nbc=P;function I(a){try{const m=(0,A.$vo)((0,A.$uo)(a.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.$obc=I;function $(a){try{const m=(0,A.$vo)((0,A.$uo)(a.engines.vscode));return m?m.majorBase<1||m.majorBase===1&&m.minorBase<60:!1}catch{return!1}}class k{constructor(m,v,D,t,r){this.c=v,this.d=D,this.e=t,this.f=r,this.b=new Map,this.a=m.getProxy(g.$JJ.MainThreadWebviews)}$onMessage(m,v,D){const t=this.g(m);if(t){const{message:r}=(0,f.$ybb)(v,D.value);t._onMessageEmitter.fire(r)}}$onMissingCsp(m,v){this.e.warn(`${v} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,v,D){const t=new P(m,this.a,n(v),this.c,this.d,D,this.f);return this.b.set(m,t),t._onDidDispose(()=>{this.b.delete(m)}),t}deleteWebview(m){this.b.delete(m)}g(m){return this.b.get(m)}}e.$pbc=k;function C(a){return{id:a.identifier,location:a.extensionLocation}}e.$qbc=C;function E(a,m,v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,enableForms:v.enableForms,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots||o(a,m)}}e.$rbc=E;function n(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(m=>L.URI.from(m))}}function o(a,m){return[...(m?.getWorkspaceFolders()||[]).map(v=>v.uri),a.extensionLocation]}}),define(Se[323],De([1,0,22,74,3,16,24,2,10,91,86,5,7]),function(me,e,S,F,h,L,A,f,w,g,P,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3bc=void 0;class k{constructor(r,s){this.document=r,this.b=s,this.a=1,this.c=new P.$jac("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,s){await this.f(r).undo(),s||this.disposeBackup()}async redo(r,s){await this.f(r).redo(),s||this.disposeBackup()}disposeEdits(r){for(const s of r)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=D(this.document.uri)+this.a++;return(0,A.$9f)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const s=this.c.get(r,0);if(!s)throw new Error("No edit found");return s}}class C{constructor(){this.a=new Map}get(r,s){return this.a.get(this.b(r,s))}add(r,s,i){const c=this.b(r,s.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${r} resource:${s.uri}`);const l=new k(s,i);return this.a.set(c,l),l}delete(r,s){const i=this.b(r,s.uri);this.a.delete(i)}b(r,s){return`${r}@@@${s}`}}var E;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(E||(E={}));class n{constructor(){this.a=new Map}addTextProvider(r,s,i){return this.b(0,r,s,i)}addCustomProvider(r,s,i){return this.b(1,r,s,i)}get(r){return this.a.get(r)}b(r,s,i,c){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:r,extension:i,provider:c}),new $.$LJ(()=>this.a.delete(s))}}class o{constructor(r,s,i,c,l){this.d=s,this.f=i,this.g=c,this.h=l,this.b=new n,this.c=new C,this.a=r.getProxy(I.$JJ.MainThreadCustomEditors)}registerCustomEditorProvider(r,s,i,c){const l=new h.$kb;return m(i)?(l.add(this.b.addTextProvider(s,r,i)),this.a.$registerTextEditorProvider((0,g.$qbc)(r),s,c.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,g.$obc)(r))):(l.add(this.b.addCustomProvider(s,r,i)),a(i)&&l.add(i.onDidChangeCustomDocument(b=>{const y=this.i(s,b.document.uri);if(v(b)){const u=y.addEdit(b);this.a.$onDidEdit(b.document.uri,s,u,b.label)}else this.a.$onContentChange(b.document.uri,s)})),this.a.$registerCustomEditorProvider((0,g.$qbc)(r),s,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,g.$obc)(r))),$.$LJ.from(l,new $.$LJ(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(r,s,i,c,l){const b=this.b.get(s);if(!b)throw new Error(`No provider found for '${s}'`);if(b.type!==1)throw new Error(`Invalid provide type for '${s}'`);const y=f.URI.revive(r),u=await b.provider.openCustomDocument(y,{backupId:i,untitledDocumentData:c?.buffer},l);let d;return a(b.provider)&&this.f&&(d=this.f.workspaceValue(b.extension)??this.f.globalValue(b.extension)),this.c.add(s,u,d),{editable:a(b.provider)}}async $disposeCustomDocument(r,s){const i=this.b.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${s}'`);const c=f.URI.revive(r),{document:l}=this.i(s,c);this.c.delete(s,l),l.dispose()}async $resolveCustomEditor(r,s,i,c,l,b){const y=this.b.get(i);if(!y)throw new Error(`No provider found for '${i}'`);const u=w.ViewColumn.to(l),d=this.g.createNewWebview(s,c.contentOptions,y.extension),p=this.h.createNewWebviewPanel(s,i,c.title,u,c.options,d,c.active),R=f.URI.revive(r);switch(y.type){case 1:{const{document:O}=this.i(i,R);return y.provider.resolveCustomEditor(O,p,b)}case 0:{const O=this.d.getDocument(R);return y.provider.resolveCustomTextEditor(O,p,b)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,s,i){this.i(s,r).disposeEdits(i)}async $onMoveCustomEditor(r,s,i){const c=this.b.get(i);if(!c)throw new Error(`No provider found for '${i}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const l=this.h.getWebviewPanel(r);if(!l)throw new Error("No webview found");const b=f.URI.revive(s),y=this.d.getDocument(b);await c.provider.moveCustomTextEditor(y,l,S.CancellationToken.None)}async $undo(r,s,i,c){return this.i(s,r).undo(i,c)}async $redo(r,s,i,c){return this.i(s,r).redo(i,c)}async $revert(r,s,i){const c=this.i(s,r);await this.j(s).revertCustomDocument(c.document,i),c.disposeBackup()}async $onSave(r,s,i){const c=this.i(s,r);await this.j(s).saveCustomDocument(c.document,i),c.disposeBackup()}async $onSaveAs(r,s,i,c){const l=this.i(s,r);return this.j(s).saveCustomDocumentAs(l.document,f.URI.revive(i),c)}async $backup(r,s,i){const c=this.i(s,r),b=await this.j(s).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},i);return c.updateBackup(b),b.id}i(r,s){const i=this.c.get(r,f.URI.revive(s));if(!i)throw new Error("No custom document found");return i}j(r){const i=this.b.get(r)?.provider;if(!i||!a(i))throw new Error("Custom document is not editable");return i}}e.$3bc=o;function a(t){return!!t.onDidChangeCustomDocument}function m(t){return typeof t.resolveCustomTextEditor=="function"}function v(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function D(t){const r=t.scheme===L.Schemas.file||t.scheme===L.Schemas.untitled?t.fsPath:t.toString();return(0,F.$di)(r)+""}}),define(Se[324],De([1,0,4,3,2,31,10,91,5,7]),function(me,e,S,F,h,L,A,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=void 0;class P extends F.$lb{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(C,E,n,o){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new S.$ec),this.onDidDispose=this.#d.event,this.#h=this.B(new S.$ec),this.onDidChangeViewState=this.#h.event,this.#e=C,this.#t=E,this.#l=n,this.#i=o.viewType,this.#u=o.panelOptions,this.#r=o.viewColumn,this.#n=o.title,this.#a=o.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(C){this.c(),this.#n!==C&&(this.#n=C,this.#t.$setTitle(this.#e,C))}get iconPath(){return this.c(),this.#s}set iconPath(C){this.c(),this.#s!==C&&(this.#s=C,this.#t.$setIconPath(this.#e,h.URI.isUri(C)?{light:C,dark:C}:C))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(C){this.#c||(this.active!==C.active||this.visible!==C.visible||this.viewColumn!==C.viewColumn)&&(this.#a=C.active,this.#o=C.visible,this.#r=C.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(C,E){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof C>"u"?void 0:A.ViewColumn.from(C),preserveFocus:!!E})}c(){if(this.#c)throw new Error("Webview is disposed")}}class I{static c(){return(0,L.$3e)()}constructor(C,E,n){this.g=E,this.h=n,this.e=new Map,this.f=new Map,this.d=C.getProxy(w.$JJ.MainThreadWebviewPanels)}createWebviewPanel(C,E,n,o,a={}){const m=typeof o=="object"?o.viewColumn:o,v={viewColumn:A.ViewColumn.from(m),preserveFocus:typeof o=="object"&&!!o.preserveFocus},D=(0,f.$obc)(C),t=I.c();this.d.$createWebviewPanel((0,f.$qbc)(C),t,E,{title:n,panelOptions:$(a),webviewOptions:(0,f.$rbc)(C,this.h,a),serializeBuffersForPostMessage:D},v);const r=this.g.createNewWebview(t,a,C);return this.createNewWebviewPanel(t,E,n,m,a,r,!0)}$onDidChangeWebviewPanelViewStates(C){const E=Object.keys(C);E.sort((n,o)=>{const a=C[n],m=C[o];return a.active?1:m.active?-1:+a.visible-+m.visible});for(const n of E){const o=this.getWebviewPanel(n);if(!o)continue;const a=C[n];o._updateViewState({active:a.active,visible:a.visible,viewColumn:A.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(C){this.getWebviewPanel(C)?.dispose(),this.e.delete(C),this.g.deleteWebview(C)}registerWebviewPanelSerializer(C,E,n){if(this.f.has(E))throw new Error(`Serializer for '${E}' already registered`);return this.f.set(E,{serializer:n,extension:C}),this.d.$registerSerializer(E,{serializeBuffersForPostMessage:(0,f.$obc)(C)}),new g.$LJ(()=>{this.f.delete(E),this.d.$unregisterSerializer(E)})}async $deserializeWebviewPanel(C,E,n,o){const a=this.f.get(E);if(!a)throw new Error(`No serializer found for '${E}'`);const{serializer:m,extension:v}=a,D=this.g.createNewWebview(C,n.webviewOptions,v),t=this.createNewWebviewPanel(C,E,n.title,o,n.panelOptions,D,n.active);await m.deserializeWebviewPanel(t,n.state)}createNewWebviewPanel(C,E,n,o,a,m,v){const D=new P(C,this.d,m,{viewType:E,title:n,viewColumn:o,panelOptions:a,active:v});return this.e.set(C,D),D}getWebviewPanel(C){return this.e.get(C)}}e.$2bc=I;function $(k){return{enableFindWidget:k.enableFindWidget,retainContextWhenHidden:k.retainContextWhenHidden}}}),define(Se[325],De([1,0,4,3,91,10,5,7]),function(me,e,S,F,h,L,A,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1bc=void 0;class w extends F.$lb{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(I,$,k,C,E,n){super(),this.#u=!1,this.#a=this.B(new S.$ec),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new S.$ec),this.onDidDispose=this.#c.event,this.#i=k,this.#s=C,this.#e=I,this.#t=$,this.#l=E,this.#n=n}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(I){this.a(),this.#s!==I&&(this.#s=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.a(),this.#r}set description(I){this.a(),this.#r!==I&&(this.#r=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(I){I===this.#n||this.#u||(this.#n=I,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(I){this.a(),!(I?.value===this.#o?.value&&I?.tooltip===this.#o?.tooltip)&&(this.#o=L.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.a(),this.#t.$show(this.#e,!!I)}a(){if(this.#u)throw new Error("Webview is disposed")}}class g{constructor(I,$){this.d=$,this.b=new Map,this.c=new Map,this.a=I.getProxy(A.$JJ.MainThreadWebviewViews)}registerWebviewViewProvider(I,$,k,C){if(this.b.has($))throw new Error(`View provider for '${$}' already registered`);return this.b.set($,{provider:k,extension:I}),this.a.$registerWebviewViewProvider((0,h.$qbc)(I),$,{retainContextWhenHidden:C?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,h.$obc)(I)}),new f.$LJ(()=>{this.b.delete($),this.a.$unregisterWebviewViewProvider($)})}async $resolveWebviewView(I,$,k,C,E){const n=this.b.get($);if(!n)throw new Error(`No view provider found for '${$}'`);const{provider:o,extension:a}=n,m=this.d.createNewWebview(I,{},a),v=new w(I,this.a,$,k,m,!0);this.c.set(I,v),await o.resolveWebviewView(v,{state:C},E)}async $onDidChangeWebviewViewVisibility(I,$){this.e(I)._setVisible($)}async $disposeWebviewView(I){const $=this.e(I);this.c.delete(I),$.dispose(),this.d.deleteWebview(I)}e(I){const $=this.c.get(I);if(!$)throw new Error("No webview found");return $}}e.$1bc=g}),define(Se[148],De([1,0,4,5,2,16,15,6,20,27]),function(me,e,S,F,h,L,A,f,w,g){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$tbc=e.$sbc=void 0;let I=class{static{P=this}static{this.a={focused:!0,active:!0}}getState(k){const C=this.d;return{get focused(){return C.focused},get active(){return(0,g.$EF)(k,"windowActivity"),C.active}}}constructor(k){this.c=new S.$ec,this.onDidChangeWindowState=this.c.event,this.d=P.a,this.b=k.getProxy(F.$JJ.MainThreadWindow),this.b.$getInitialState().then(({isFocused:C,isActive:E})=>{this.onDidChangeWindowProperty("focused",C),this.onDidChangeWindowProperty("active",E)})}$onDidChangeWindowFocus(k){this.onDidChangeWindowProperty("focused",k)}$onDidChangeWindowActive(k){this.onDidChangeWindowProperty("active",k)}onDidChangeWindowProperty(k,C){C!==this.d[k]&&(this.d={...this.d,[k]:C},this.c.fire(this.d))}openUri(k,C){let E;if(typeof k=="string"){E=k;try{k=h.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,A.$ld)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this.b.$openUri(k,E,C)}async asExternalUri(k,C){if((0,A.$ld)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const E=await this.b.$asExternalUri(k,C);return h.URI.from(E)}};e.$sbc=I,e.$sbc=I=P=Je([Be(0,w.$LL)],I),e.$tbc=(0,f.$ph)("IExtHostWindow")}),define(Se[326],De([1,0,294,26,20]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=void 0;const L=1024*1024;let A=class extends S.$rcc{constructor(w,g){super(w,g),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(w,g,P){const I=w==="error"||w==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),g.apply(console,P),I.write(`
END_NATIVE_LOG
`),this.g=!1}j(w,g){const P=process[w],I=P.write;let $="";Object.defineProperty(P,"write",{set:()=>{},get:()=>(k,C,E)=>{if(!this.g){$+=k.toString(C);const n=$.length>L?$.length:$.lastIndexOf(`
`);n!==-1&&(console[g]($.slice(0,n)),$=$.slice(n+1))}I.call(P,k,C,E)}})}};e.$3cc=A,e.$3cc=A=Je([Be(0,h.$LL),Be(1,F.$2L)],A)}),define(Se[327],De([1,0,67,16,17,233,30,9]),function(me,e,S,F,h,L,A,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=void 0;let w=class{constructor(I,$){I.addFileSystemProvider(F.Schemas.file,new g($),{isCaseSensitive:f.$k})}};e.$4cc=w,e.$4cc=w=Je([Be(0,S.$Rac),Be(1,h.$Ri)],w);class g{constructor(I){this.b=I,this.a=new L.$Tp(this.b)}async stat(I){const $=await this.a.stat(I);return{type:$.type,ctime:$.ctime,mtime:$.mtime,size:$.size,permissions:$.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,$,k){return this.a.writeFile(I,$,{...k,unlock:!1,atomic:!1})}delete(I,$){return this.a.delete(I,{...$,useTrash:!1,atomic:!1})}rename(I,$,k){return this.a.rename(I,$,k)}copy(I,$,k){return this.a.copy(I,$,k)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,$){throw new Error("Method not implemented.")}}}),define(Se[328],De([1,0,14,59,31,33,3,5,2,20]),function(me,e,S,F,h,L,A,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=void 0;let P=class extends A.$lb{constructor($,k){super();const C=$.getProxy(f.$JJ.MainThreadDownloadService);k.registerCommand(!1,"_workbench.downloadResource",async E=>{const n=w.URI.file((0,S.$8c)((0,F.tmpdir)(),(0,h.$3e)()));return await C.$download(E,n),n})}};e.$2cc=P,e.$2cc=P=Je([Be(0,g.$LL),Be(1,L.$8L)],P)}),define(Se[329],De([1,0,147,16,235,31]),function(me,e,S,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=void 0;class A extends S.$qcc{m(w,g,P){return w.scheme===F.Schemas.file?new h.$XM(P?.name||(0,L.$3e)(),w.fsPath,!P?.donotRotate,!!P?.donotUseFormatters,g):super.m(w,g,P)}registerLogger(w){super.registerLogger(w),this.n.$registerLogger(w)}deregisterLogger(w){super.deregisterLogger(w),this.n.$deregisterLogger(w)}}e.$cdc=A}),define(Se[330],De([1,0,49,14,2,90,3,16,13,29]),function(me,e,S,F,h,L,A,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bdc=void 0;class P extends L.$Tac{constructor(){super(...arguments),this.i=null}async g(t){const r=await super.g(t);if(r.scheme!==f.Schemas.file)return r;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${r.fsPath}.`),r;const s=r.fsPath;let i=0;do{let c;i===0?c=s:c=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${i}`:`${s}-${i}`,await I(c);const l=F.$8c(c,"vscode.lock"),b=await E(this.d,l,!1);if(b)return this.i=b,process.on("exit",()=>{b.dispose()}),h.URI.file(c);i++}while(i<10);return r}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$bdc=P;async function I(D){try{await g.Promises.stat(D);return}catch{}try{await g.Promises.mkdir(D,{recursive:!0})}catch{}}const $=1e3,k=10*60*1e3;class C extends A.$lb{constructor(t,r){super(),this.b=t,this.c=r,this.a=this.B(new w.$Fg),this.a.cancelAndSet(async()=>{const s=await n(t,r);(!s||s.pid!==process.pid)&&(t.info(`Lock '${r}': The lock was lost unexpectedly.`),this.a.cancel());try{await g.Promises.utimes(r,new Date,new Date)}catch(i){t.error(i),t.info(`Lock '${r}': Could not update mtime.`)}},$)}dispose(){super.dispose();try{S.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const r={pid:process.pid,willReleaseAt:Date.now()+t};await g.Promises.writeFile(this.c,JSON.stringify(r),{flag:"w"})}catch(r){this.b.error(r)}}}async function E(D,t,r){try{const i={pid:process.pid,willReleaseAt:0};await g.Promises.writeFile(t,JSON.stringify(i),{flag:"wx"})}catch(i){D.error(i)}const s=await n(D,t);return!s||s.pid!==process.pid?r?(D.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(D.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),m(D,t)):(D.info(`Lock '${t}': Lock acquired.`),new C(D,t))}async function n(D,t){let r;try{r=await g.Promises.readFile(t)}catch(s){return D.error(s),null}try{return JSON.parse(String(r))}catch(s){return D.error(s),null}}async function o(D,t){let r;try{r=await g.Promises.stat(t)}catch(s){return D.error(s),0}return r.mtime.getTime()}function a(D){try{return process.kill(D,0),!0}catch{return!1}}async function m(D,t){const r=await n(D,t);if(!r)return D.info(`Lock '${t}': Could not read pid of lock holder.`),v(D,t);if(r.willReleaseAt){let b=r.willReleaseAt-Date.now();if(b<5e3){for(b>0?D.info(`Lock '${t}': The lockfile is scheduled to be released in ${b} ms.`):D.info(`Lock '${t}': The lockfile is scheduled to have been released.`);b>0;){if(await(0,w.$vg)(Math.min(100,b)),await o(D,t)===0)return v(D,t);b=r.willReleaseAt-Date.now()}return v(D,t)}}if(!a(r.pid))return D.info(`Lock '${t}': The pid ${r.pid} appears to be gone.`),v(D,t);const s=await o(D,t),i=Date.now()-s;if(i<=k)return D.info(`Lock '${t}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;D.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,w.$vg)(2e3);const c=await o(D,t),l=Date.now()-c;return l<=k?(D.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null):(D.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),v(D,t))}async function v(D,t){D.info(`Lock '${t}': Deleting a stale lock.`);try{await g.Promises.unlink(t)}catch{}return E(D,t,!0)}}),define(Se[331],De([1,0,31,20,43,33]),function(me,e,S,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=void 0;let A=class extends h.$Wac{constructor(w,g){super(!0,w,g)}createTerminal(w,g,P){return this.createTerminalFromOptions({name:w,shellPath:g,shellArgs:P})}createTerminalFromOptions(w,g){const P=new h.$Vac(this.a,(0,S.$3e)(),w,w.name);return this.f.push(P),P.create(w,this.N(w,g)),P.value}};e.$wcc=A,e.$wcc=A=Je([Be(0,L.$8L),Be(1,F.$LL)],A)}),define(Se[332],De([1,0,13,21,22,8,4,3,127,283,64]),function(me,e,S,F,h,L,A,f,w,g,P){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$X2b=e.ResponsiveState=e.RequestInitiator=e.$W2b=e.$V2b=void 0;function $(d,p){try{return JSON.stringify(d,p)}catch{return"null"}}const k="$$ref$$",C={[k]:-1};class E{constructor(p,R){this.jsonString=p,this.referencedBuffers=R}}function n(d,p=null,R=!1){const O=[];return{jsonString:(R?$:JSON.stringify)(d,(T,z)=>{if(typeof z>"u")return C;if(typeof z=="object"){if(z instanceof F.$Ec){const B=O.push(z)-1;return{[k]:B}}if(p)return p(T,z)}return z}),referencedBuffers:O}}e.$V2b=n;function o(d,p,R){return JSON.parse(d,(O,j)=>{if(j){const T=j[k];if(typeof T=="number")return p[T];if(R&&j.$mid===1)return R.transformIncoming(j)}return j})}e.$W2b=o;function a(d,p){return JSON.stringify(d,p)}function m(d){return d?(p,R)=>R&&R.$mid===1?d.transformOutgoing(R):R:null}var v;(function(d){d[d.LocalSide=0]="LocalSide",d[d.OtherSide=1]="OtherSide"})(v||(e.RequestInitiator=v={}));var D;(function(d){d[d.Responsive=0]="Responsive",d[d.Unresponsive=1]="Unresponsive"})(D||(e.ResponsiveState=D={}));const t=()=>{},r=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class i extends f.$lb{static{I=r}static{this.a=3*1e3}constructor(p,R=null,O=null){super(),this[I]=!0,this.b=this.B(new A.$ec),this.onDidChangeResponsiveState=this.b.event,this.c=p,this.f=R,this.g=O,this.h=m(this.g),this.j=!1,this.k=[],this.l=[];for(let j=0,T=P.$2z.count;j<T;j++)this.k[j]=null,this.l[j]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new S.$Gg(()=>this.C(),1e3)),this.c.onMessage(j=>this.G(j))}dispose(){this.j=!0,Object.keys(this.s).forEach(p=>{this.s[p].resolveErr(L.$4())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(p){this.u===0&&(this.v=Date.now()+i.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(p){this.v=Date.now()+i.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(p){this.t!==p&&(this.t=p,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(p){return this.g?(0,w.$rm)(p,this.g):p}getProxy(p){const{nid:R,sid:O}=p;return this.l[R]||(this.l[R]=this.F(R,O)),this.l[R]}F(p,R){const O={get:(j,T)=>(typeof T=="string"&&!j[T]&&T.charCodeAt(0)===36&&(j[T]=(...z)=>this.O(p,T,z)),T===s?R:j[T])};return new Proxy(Object.create(null),O)}set(p,R){return this.k[p.nid]=R,R}assertRegistered(p){for(let R=0,O=p.length;R<O;R++){const j=p[R];if(!this.k[j.nid])throw new Error(`Missing proxy instance ${j.sid}`)}}G(p){if(this.j)return;const R=p.byteLength,O=c.read(p,0),j=O.readUInt8(),T=O.readUInt32();switch(j){case 1:case 2:{let{rpcId:z,method:B,args:M}=b.deserializeRequestJSONArgs(O);this.g&&(M=(0,w.$rm)(M,this.g)),this.H(R,T,z,B,M,j===2);break}case 3:case 4:{let{rpcId:z,method:B,args:M}=b.deserializeRequestMixedArgs(O);this.g&&(M=(0,w.$rm)(M,this.g)),this.H(R,T,z,B,M,j===4);break}case 5:{this.f?.logIncoming(R,T,0,"ack"),this.z(T);break}case 6:{this.I(R,T);break}case 7:{this.J(R,T,void 0);break}case 9:{let z=b.deserializeReplyOKJSON(O);this.g&&(z=(0,w.$rm)(z,this.g)),this.J(R,T,z);break}case 10:{const z=b.deserializeReplyOKJSONWithBuffers(O,this.g);this.J(R,T,z);break}case 8:{const z=b.deserializeReplyOKVSBuffer(O);this.J(R,T,z);break}case 11:{let z=b.deserializeReplyErrError(O);this.g&&(z=(0,w.$rm)(z,this.g)),this.L(R,T,z);break}case 12:{this.L(R,T,void 0);break}default:console.error("received unexpected message"),console.error(p)}}H(p,R,O,j,T,z){this.f?.logIncoming(p,R,1,`receiveRequest ${(0,P.$4z)(O)}.${j}(`,T);const B=String(R);let M,Y;if(z){const fe=new h.$oc;T.push(fe.token),M=this.M(O,j,T),Y=()=>fe.cancel()}else M=this.M(O,j,T),Y=t;this.p[B]=Y;const J=b.serializeAcknowledged(R);this.f?.logOutgoing(J.byteLength,R,1,"ack"),this.c.send(J),M.then(fe=>{delete this.p[B];const se=b.serializeReplyOK(R,fe,this.h);this.f?.logOutgoing(se.byteLength,R,1,"reply:",fe),this.c.send(se)},fe=>{delete this.p[B];const se=b.serializeReplyErr(R,fe);this.f?.logOutgoing(se.byteLength,R,1,"replyErr:",fe),this.c.send(se)})}I(p,R){this.f?.logIncoming(p,R,1,"receiveCancel");const O=String(R);this.p[O]?.()}J(p,R,O){this.f?.logIncoming(p,R,0,"receiveReply:",O);const j=String(R);if(!this.s.hasOwnProperty(j))return;const T=this.s[j];delete this.s[j],T.resolveOk(O)}L(p,R,O){this.f?.logIncoming(p,R,0,"receiveReplyErr:",O);const j=String(R);if(!this.s.hasOwnProperty(j))return;const T=this.s[j];delete this.s[j];let z;O&&(O.$isError?(z=new Error,z.name=O.name,z.message=O.message,z.stack=O.stack):z=O),T.resolveErr(z)}M(p,R,O){try{return Promise.resolve(this.N(p,R,O))}catch(j){return Promise.reject(j)}}N(p,R,O){const j=this.k[p];if(!j)throw new Error("Unknown actor "+(0,P.$4z)(p));const T=j[R];if(typeof T!="function")throw new Error("Unknown method "+R+" on actor "+(0,P.$4z)(p));return T.apply(j,O)}O(p,R,O){if(this.j)return new g.$U2b;let j=null;if(O.length>0&&h.CancellationToken.isCancellationToken(O[O.length-1])&&(j=O.pop()),j&&j.isCancellationRequested)return Promise.reject(L.$4());const T=b.serializeRequestArguments(O,this.h),z=++this.m,B=String(z),M=new g.$T2b;j&&j.onCancellationRequested(()=>{const J=b.serializeCancel(z);this.f?.logOutgoing(J.byteLength,z,0,"cancel"),this.c.send(b.serializeCancel(z))}),this.s[B]=M,this.y(z);const Y=b.serializeRequest(z,p,R,T,!!j);return this.f?.logOutgoing(Y.byteLength,z,0,`request: ${(0,P.$4z)(p)}.${R}(`,O),this.c.send(Y),M}}e.$X2b=i;class c{static alloc(p,R,O){const j=new c(F.$Ec.alloc(O+1+4),0);return j.writeUInt8(p),j.writeUInt32(R),j}static read(p,R){return new c(p,R)}get buffer(){return this.a}constructor(p,R){this.a=p,this.b=R}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(p){this.a.writeUInt8(p,this.b),this.b+=1}readUInt8(){const p=this.a.readUInt8(this.b);return this.b+=1,p}writeUInt32(p){this.a.writeUInt32BE(p,this.b),this.b+=4}readUInt32(){const p=this.a.readUInt32BE(this.b);return this.b+=4,p}static sizeShortString(p){return 1+p.byteLength}writeShortString(p){this.a.writeUInt8(p.byteLength,this.b),this.b+=1,this.a.set(p,this.b),this.b+=p.byteLength}readShortString(){const p=this.a.readUInt8(this.b);this.b+=1;const O=this.a.slice(this.b,this.b+p).toString();return this.b+=p,O}static sizeLongString(p){return 4+p.byteLength}writeLongString(p){this.a.writeUInt32BE(p.byteLength,this.b),this.b+=4,this.a.set(p,this.b),this.b+=p.byteLength}readLongString(){const p=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+p).toString();return this.b+=p,O}writeBuffer(p){this.a.writeUInt32BE(p.byteLength,this.b),this.b+=4,this.a.set(p,this.b),this.b+=p.byteLength}static sizeVSBuffer(p){return 4+p.byteLength}writeVSBuffer(p){this.a.writeUInt32BE(p.byteLength,this.b),this.b+=4,this.a.set(p,this.b),this.b+=p.byteLength}readVSBuffer(){const p=this.a.readUInt32BE(this.b);this.b+=4;const R=this.a.slice(this.b,this.b+p);return this.b+=p,R}static sizeMixedArray(p){let R=0;R+=1;for(let O=0,j=p.length;O<j;O++){const T=p[O];switch(R+=1,T.type){case 1:R+=this.sizeLongString(T.value);break;case 2:R+=this.sizeVSBuffer(T.value);break;case 3:R+=this.sizeUInt32,R+=this.sizeLongString(T.value);for(let z=0;z<T.buffers.length;++z)R+=this.sizeVSBuffer(T.buffers[z]);break;case 4:break}}return R}writeMixedArray(p){this.a.writeUInt8(p.length,this.b),this.b+=1;for(let R=0,O=p.length;R<O;R++){const j=p[R];switch(j.type){case 1:this.writeUInt8(1),this.writeLongString(j.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(j.value);break;case 3:this.writeUInt8(3),this.writeUInt32(j.buffers.length),this.writeLongString(j.value);for(let T=0;T<j.buffers.length;++T)this.writeBuffer(j.buffers[T]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const p=this.a.readUInt8(this.b);this.b+=1;const R=new Array(p);for(let O=0;O<p;O++)switch(this.readUInt8()){case 1:R[O]=this.readLongString();break;case 2:R[O]=this.readVSBuffer();break;case 3:{const T=this.readUInt32(),z=this.readLongString(),B=[];for(let M=0;M<T;++M)B.push(this.readVSBuffer());R[O]=new P.$5z(o(z,B,null));break}case 4:R[O]=void 0;break}return R}}var l;(function(d){d[d.Simple=0]="Simple",d[d.Mixed=1]="Mixed"})(l||(l={}));class b{static a(p){for(let R=0,O=p.length;R<O;R++)if(p[R]instanceof F.$Ec||p[R]instanceof P.$5z||typeof p[R]>"u")return!0;return!1}static serializeRequestArguments(p,R){if(this.a(p)){const O=[];for(let j=0,T=p.length;j<T;j++){const z=p[j];if(z instanceof F.$Ec)O[j]={type:2,value:z};else if(typeof z>"u")O[j]={type:4};else if(z instanceof P.$5z){const{jsonString:B,referencedBuffers:M}=n(z.value,R);O[j]={type:3,value:F.$Ec.fromString(B),buffers:M}}else O[j]={type:1,value:F.$Ec.fromString(a(z,R))}}return{type:1,args:O}}return{type:0,args:a(p,R)}}static serializeRequest(p,R,O,j,T){switch(j.type){case 0:return this.b(p,R,O,j.args,T);case 1:return this.c(p,R,O,j.args,T)}}static b(p,R,O,j,T){const z=F.$Ec.fromString(O),B=F.$Ec.fromString(j);let M=0;M+=c.sizeUInt8(),M+=c.sizeShortString(z),M+=c.sizeLongString(B);const Y=c.alloc(T?2:1,p,M);return Y.writeUInt8(R),Y.writeShortString(z),Y.writeLongString(B),Y.buffer}static deserializeRequestJSONArgs(p){const R=p.readUInt8(),O=p.readShortString(),j=p.readLongString();return{rpcId:R,method:O,args:JSON.parse(j)}}static c(p,R,O,j,T){const z=F.$Ec.fromString(O);let B=0;B+=c.sizeUInt8(),B+=c.sizeShortString(z),B+=c.sizeMixedArray(j);const M=c.alloc(T?4:3,p,B);return M.writeUInt8(R),M.writeShortString(z),M.writeMixedArray(j),M.buffer}static deserializeRequestMixedArgs(p){const R=p.readUInt8(),O=p.readShortString(),j=p.readMixedArray(),T=new Array(j.length);for(let z=0,B=j.length;z<B;z++){const M=j[z];typeof M=="string"?T[z]=JSON.parse(M):T[z]=M}return{rpcId:R,method:O,args:T}}static serializeAcknowledged(p){return c.alloc(5,p,0).buffer}static serializeCancel(p){return c.alloc(6,p,0).buffer}static serializeReplyOK(p,R,O){if(typeof R>"u")return this.d(p);if(R instanceof F.$Ec)return this.e(p,R);if(R instanceof P.$5z){const{jsonString:j,referencedBuffers:T}=n(R.value,O,!0);return this.g(p,j,T)}else return this.f(p,$(R,O))}static d(p){return c.alloc(7,p,0).buffer}static e(p,R){let O=0;O+=c.sizeVSBuffer(R);const j=c.alloc(8,p,O);return j.writeVSBuffer(R),j.buffer}static deserializeReplyOKVSBuffer(p){return p.readVSBuffer()}static f(p,R){const O=F.$Ec.fromString(R);let j=0;j+=c.sizeLongString(O);const T=c.alloc(9,p,j);return T.writeLongString(O),T.buffer}static g(p,R,O){const j=F.$Ec.fromString(R);let T=0;T+=c.sizeUInt32,T+=c.sizeLongString(j);for(const B of O)T+=c.sizeVSBuffer(B);const z=c.alloc(10,p,T);z.writeUInt32(O.length),z.writeLongString(j);for(const B of O)z.writeBuffer(B);return z.buffer}static deserializeReplyOKJSON(p){const R=p.readLongString();return JSON.parse(R)}static deserializeReplyOKJSONWithBuffers(p,R){const O=p.readUInt32(),j=p.readLongString(),T=[];for(let z=0;z<O;++z)T.push(p.readVSBuffer());return new P.$5z(o(j,T,R))}static serializeReplyErr(p,R){const O=R?$(L.$1(R),null):void 0;if(typeof O!="string")return this.h(p);const j=F.$Ec.fromString(O);let T=0;T+=c.sizeLongString(j);const z=c.alloc(11,p,T);return z.writeLongString(j),z.buffer}static deserializeReplyErrError(p){const R=p.readLongString();return JSON.parse(R)}static h(p){return c.alloc(12,p,0).buffer}}var y;(function(d){d[d.RequestJSONArgs=1]="RequestJSONArgs",d[d.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",d[d.RequestMixedArgs=3]="RequestMixedArgs",d[d.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",d[d.Acknowledged=5]="Acknowledged",d[d.Cancel=6]="Cancel",d[d.ReplyOKEmpty=7]="ReplyOKEmpty",d[d.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",d[d.ReplyOKJSON=9]="ReplyOKJSON",d[d.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",d[d.ReplyErrError=11]="ReplyErrError",d[d.ReplyErrEmpty=12]="ReplyErrEmpty"})(y||(y={}));var u;(function(d){d[d.String=1]="String",d[d.VSBuffer=2]="VSBuffer",d[d.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",d[d.Undefined=4]="Undefined"})(u||(u={}))}),define(Se[333],De([1,0,4,42,47,6]),function(me,e,S,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZI=e.$YI=e.OutputChannelUpdateMode=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=void 0,e.$NI="text/x-code-output",e.$OI="output",e.$PI="Log",e.$QI="text/x-code-log-output",e.$RI="log",e.$SI="log",e.$TI="workbench.panel.output",e.$UI=new h.$Oi("inOutput",!1),e.$VI=new h.$Oi("activeLogOutput",!1),e.$WI=new h.$Oi("outputView.scrollLock",!1),e.$XI=(0,L.$ph)("outputService");var A;(function(w){w[w.Append=1]="Append",w[w.Replace=2]="Replace",w[w.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$YI={OutputChannels:"workbench.contributions.outputChannels"};class f{constructor(){this.a=new Map,this.b=new S.$ec,this.onDidRegisterChannel=this.b.event,this.c=new S.$ec,this.onDidRemoveChannel=this.c.event}registerChannel(g){this.a.has(g.id)||(this.a.set(g.id,g),this.b.fire(g.id))}getChannels(){const g=[];return this.a.forEach(P=>g.push(P)),g}getChannel(g){return this.a.get(g)}removeChannel(g){this.a.delete(g),this.c.fire(g)}}F.$Um.add(e.$YI.OutputChannels,new f),e.$ZI=new h.$Oi("activeOutputChannel","")}),define(Se[149],De([1,0,5,6,20,25,17,333,67,26,52,175,21,19,30,4,3]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dbc=e.$cbc=void 0;class o extends A.$Xi{get disposed(){return this.l}constructor(D,t,r,s,i){super(),this.id=D,this.name=t,this.m=r,this.n=s,this.extension=i,this.k=0,this.l=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(D){this.append(D+`
`)}append(D){this.info(D)}clear(){const D=this.k;this.m.flush(),this.n.$update(this.id,f.OutputChannelUpdateMode.Clear,D)}replace(D){const t=this.k;this.info(D),this.n.$update(this.id,f.OutputChannelUpdateMode.Replace,t),this.visible&&this.m.flush()}show(D,t){this.m.flush(),this.n.$reveal(this.id,!!(typeof D=="boolean"?D:t))}hide(){this.n.$close(this.id)}g(D,t){this.k+=$.$Ec.fromString(t).byteLength,(0,A.log)(this.m,D,t),this.visible&&(this.m.flush(),this.n.$update(this.id,f.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class a extends o{appendLine(D){this.append(D)}}let m=class{constructor(D,t,r,s,i,c){this.i=t,this.j=r,this.k=s,this.l=i,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=D.getProxy(S.$JJ.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.$Tl)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(D){this.h=D;for(const[t,r]of this.g)r.visible=t===this.h}createOutputChannel(D,t,r){if(D=D.trim(),!D)throw new Error("illegal argument `name`. must not be falsy");const s=typeof t=="object"&&t.log,i=(0,k.$ie)(t)?t:void 0;if((0,k.$ie)(i)&&!i.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const l=this.i.environment.extensionLogLevel?.find(([y])=>L.$Il.equals(r.identifier,y))?.[1];l&&(c=(0,A.$8i)(l));const b=s?this.o(D,c,r):this.n(D,i,r);return b.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),s?this.r(D,c??this.m.getLevel(),b):this.q(D,b)}async n(D,t,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,i=this.k.extUri.joinPath(s,`${this.f++}-${D.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(i,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),l=await this.a.$register(D,i,t,r.identifier.value);return new o(l,D,c,this.a,r)}async o(D,t,r){const s=await this.p(r),i=D.replace(/[\\/:\*\?"<>\|]/g,""),c=this.k.extUri.joinPath(s,`${i}.log`),l=`${r.identifier.value}.${i}`,b=this.l.createLogger(c,{id:l,name:D,logLevel:t,extensionId:r.identifier.value});return new a(l,D,b,this.a,r)}p(D){let t=this.d.get(D.identifier.value);if(!t){const r=this.k.extUri.joinPath(this.i.logsLocation,D.identifier.value);this.d.set(D.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(r)}catch(s){if((0,C.$8j)(s)!==C.FileSystemProviderErrorCode.FileExists)throw s}return r})())}return t}q(D,t){let r=!1;const s=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return D},append(i){s(),t.then(c=>c.append(i))},appendLine(i){s(),t.then(c=>c.appendLine(i))},clear(){s(),t.then(i=>i.clear())},replace(i){s(),t.then(c=>c.replace(i))},show(i,c){s(),t.then(l=>l.show(i,c))},hide(){s(),t.then(i=>i.hide())},dispose(){r=!0,t.then(i=>i.dispose())}}}r(D,t,r){const s=new n.$kb,i=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},c=s.add(new E.$ec);function l(b){t=b,c.fire(b)}return r.then(b=>{s.add(b),b.logLevel!==t&&l(b.logLevel),s.add(b.onDidChangeLogLevel(y=>l(y)))}),{...this.q(D,r),get logLevel(){return t},onDidChangeLogLevel:c.event,trace(b,...y){i(),r.then(u=>u.trace(b,...y))},debug(b,...y){i(),r.then(u=>u.debug(b,...y))},info(b,...y){i(),r.then(u=>u.info(b,...y))},warn(b,...y){i(),r.then(u=>u.warn(b,...y))},error(b,...y){i(),r.then(u=>u.error(b,...y))},dispose(){s.dispose()}}}};e.$cbc=m,e.$cbc=m=Je([Be(0,h.$LL),Be(1,g.$2L),Be(2,w.$Rac),Be(3,P.$mac),Be(4,A.$Si),Be(5,A.$Ri)],m),e.$dbc=(0,F.$ph)("IExtHostOutputService")}),define(Se[334],De([1,0,6,13]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=void 0,e.$9l=(0,S.$ph)("remoteAgentService"),e.$0l=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(h){let L=1/0;for(let f=0;f<this.maxSampleCount;f++){const w=await h.getRoundTripTime();if(w===void 0)return;L=Math.min(L,w/2),await(0,F.$vg)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(L):A=this.initial.reduce((f,w)=>f+w,0)/this.initial.length,this.lastMeasurement={initial:A,current:L,average:this.average.reduce((f,w)=>f+w,0)/this.average.length,high:(()=>typeof A>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Se[335],De([1,0,32,16,14,9,24,2,6,250,51,275,334]),function(me,e,S,F,h,L,A,f,w,g,P,I,$){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$gJ=e.$fJ=void 0,e.$fJ=(0,w.$ph)("pathService");let C=k=class{constructor(n,o,a,m){this.d=n,this.e=o,this.f=a,this.g=m,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const v=await this.e.getEnvironment();return this.c=v?.userHome??n})()}hasValidBasename(n,o,a){return typeof o=="string"||typeof o>"u"?this.a.then(m=>this.h(n,m,o)):this.h(n,o,a)}h(n,o,a){return n.scheme===F.Schemas.file||n.scheme===F.Schemas.vscodeRemote?(0,S.$Fe)(a??(0,A.$6f)(n),o===1):!0}get defaultUriScheme(){return k.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(n,o){if(n.remoteAuthority)return F.Schemas.vscodeRemote;const a=(0,g.$cJ)(o.getWorkspace());if(a)return a;const m=o.getWorkspace().folders[0];if(m)return m.uri.scheme;const v=o.getWorkspace().configuration;return v?v.scheme:F.Schemas.file}userHome(n){return n?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(n=>n===1?h.$4c:h.$5c)}async fileURI(n){let o="";if(await this.a===1&&(n=n.replace(/\\/g,"/")),n[0]==="/"&&n[1]==="/"){const m=n.indexOf("/",2);m===-1?(o=n.substring(2),n="/"):(o=n.substring(2,m),n=n.substring(m)||"/")}return f.URI.from({scheme:F.Schemas.file,authority:o,path:n,query:"",fragment:""})}};e.$gJ=C,e.$gJ=C=k=Je([Be(1,$.$9l),Be(2,I.$1I),Be(3,P.$yh)],C)}),define(Se[92],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$3H=e.$2H=void 0;class S{constructor(A,f){this.line=A,this.character=f}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,f){return new S(0,0)}with(A){return new S(0,0)}}e.$2H=S;class F{constructor(A,f,w,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new S(A,f),this.end=new S(w,g)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new F(0,0,0,0)}with(A){return new F(0,0,0,0)}}e.$3H=F;var h;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(h||(e.TextSearchCompleteMessageType=h={}))}),define(Se[36],De([1,0,18,35,23,32,15,6,14,8,92,13]),function(me,e,S,F,h,L,A,f,w,g,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.SearchErrorCode=e.$eI=e.$dI=e.SearchSortOrder=e.ViewMode=e.$cI=e.$bI=e.$aI=e.$_H=e.SearchCompletionExitCode=e.$$H=e.$0H=e.$9H=e.QueryType=e.SearchProviderType=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.$4H="workbench.view.search",e.$5H="workbench.panel.search",e.$6H="workbench.view.search",e.$7H="search.exclude";const $="\u27EA ",k=" characters skipped \u27EB",C=($.length+k.length+5)*2;e.$8H=(0,f.$ph)("searchService");var E;(function(V){V[V.file=0]="file",V[V.text=1]="text"})(E||(e.SearchProviderType=E={}));var n;(function(V){V[V.File=1]="File",V[V.Text=2]="Text"})(n||(e.QueryType=n={}));function o(V){return!!V.preview}e.$9H=o;function a(V){return!!V.resource}e.$0H=a;function m(V){return!!V.message}e.$$H=m;var v;(function(V){V[V.Normal=0]="Normal",V[V.NewSearchStarted=1]="NewSearchStarted"})(v||(e.SearchCompletionExitCode=v={}));class D{constructor(re){this.resource=re,this.results=[]}}e.$_H=D;class t{constructor(re,pe,ae,ne){this.ranges=pe,this.webviewIndex=ne;const x=Array.isArray(pe)?pe:[pe];if(ae&&ae.matchLines===1&&r(x)){re=(0,A.$be)(re,ae.matchLines);let N="",q=0,de=0;const ye=Math.floor(ae.charsPerLine/5),ve=[];for(const we of x){const Ee=Math.max(we.startColumn-ye,0),K=we.startColumn+ae.charsPerLine;if(Ee>de+ye+C){const ee=$+(Ee-de)+k;N+=ee+re.slice(Ee,K),q+=Ee-(de+ee.length)}else N+=re.slice(de,K);ve.push(new i(0,we.startColumn-q,we.endColumn-q)),de=K}this.preview={text:N,matches:Array.isArray(this.ranges)?ve:ve[0]}}else{const N=Array.isArray(pe)?pe[0].startLineNumber:pe.startLineNumber;this.preview={text:re,matches:(0,S.$Ff)(pe,q=>new s(q.startLineNumber-N,q.startColumn,q.endLineNumber-N,q.endColumn))}}}}e.$aI=t;function r(V){const re=V[0].startLineNumber;for(const pe of V)if(pe.startLineNumber!==re||pe.endLineNumber!==re)return!1;return!0}class s{constructor(re,pe,ae,ne){this.startLineNumber=re,this.startColumn=pe,this.endLineNumber=ae,this.endColumn=ne}}e.$bI=s;class i extends s{constructor(re,pe,ae){super(re,pe,re,ae)}}e.$cI=i;var c;(function(V){V.List="list",V.Tree="tree"})(c||(e.ViewMode=c={}));var l;(function(V){V.Default="default",V.FileNames="fileNames",V.Type="type",V.Modified="modified",V.CountDescending="countDescending",V.CountAscending="countAscending"})(l||(e.SearchSortOrder=l={}));function b(V,re=!0){const pe=V&&V.files&&V.files.exclude,ae=re&&V&&V.search&&V.search.exclude;if(!pe&&!ae)return;if(!pe||!ae)return pe||ae;let ne=Object.create(null);return ne=h.$Lm(ne,h.$Im(pe)),ne=h.$Lm(ne,h.$Im(ae),!0),ne}e.$dI=b;function y(V,re){return V.excludePattern&&F.$dj(V.excludePattern,re)?!1:V.includePattern||V.usingSearchPaths?V.includePattern&&F.$dj(V.includePattern,re)?!0:V.usingSearchPaths?!!V.folderQueries&&V.folderQueries.some(pe=>{const ae=pe.folder.fsPath;if(L.$He(re,ae)){const ne=w.$0c(ae,re);return!pe.includePattern||!!F.$dj(pe.includePattern,ne)}else return!1}):!1:!0}e.$eI=y;var u;(function(V){V[V.unknownEncoding=1]="unknownEncoding",V[V.regexParseError=2]="regexParseError",V[V.globParseError=3]="globParseError",V[V.invalidLiteral=4]="invalidLiteral",V[V.rgProcessError=5]="rgProcessError",V[V.other=6]="other",V[V.canceled=7]="canceled"})(u||(e.SearchErrorCode=u={}));class d extends Error{constructor(re,pe){super(re),this.code=pe}}e.$fI=d;function p(V){const re=V.message;if((0,g.$2)(V))return new d(re,u.canceled);try{const pe=JSON.parse(re);return new d(pe.message,pe.code)}catch{return new d(re,u.other)}}e.$gI=p;function R(V){const re={message:V.message,code:V.code};return new Error(JSON.stringify(re))}e.$hI=R;function O(V){return V.type==="error"?!0:V.type==="success"}e.$iI=O;function j(V){return V.type==="success"}e.$jI=j;function T(V){return!!V.path}e.$kI=T;function z(V,re){const pe=V.searchPath?V.searchPath:V.relativePath;return(0,A.$$d)(pe,re)}e.$lI=z;class B{constructor(re){this.path=re,this.results=[]}addMatch(re){this.results.push(re)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$mI=B;function M(V,re){const pe={...V||{},...re||{}};return Object.keys(pe).filter(ae=>{const ne=pe[ae];return typeof ne=="boolean"&&ne})}e.$nI=M;class Y{constructor(re,pe){this.c=null,this.a={...re.excludePattern||{},...pe.excludePattern||{}},this.b=F.$ej(this.a);let ae=re.includePattern;pe.includePattern&&(ae?ae={...ae,...pe.includePattern}:ae=pe.includePattern),ae&&(this.c=F.$ej(ae))}matchesExcludesSync(re,pe,ae){return!!(this.b&&this.b(re,pe,ae))}includedInQuerySync(re,pe,ae){return!(this.b&&this.b(re,pe,ae)||this.c&&!this.c(re,pe,ae))}includedInQuery(re,pe,ae){const ne=this.b(re,pe,ae),x=()=>this.c?!!this.c(re,pe,ae):!0;return(0,I.$hg)(ne)?ne.then(N=>N?!1:x()):x()}hasSiblingExcludeClauses(){return J(this.a)}}e.$oI=Y;function J(V){for(const re in V)if(typeof V[re]!="boolean")return!0;return!1}function fe(V){if(!V)return;let re;return pe=>(re||(re=(V()||Promise.resolve([])).then(ae=>ae?ie(ae):{})),re.then(ae=>!!ae[pe]))}e.$pI=fe;function se(V){if(!V)return;let re;return pe=>{if(!re){const ae=V();re=ae?ie(ae):{}}return!!re[pe]}}e.$qI=se;function ie(V){const re={};for(const pe of V)re[pe]=!0;return re}}),define(Se[38],De([1,0,18,13,22,4,3,75,16,118,24,15,2,208,6,17,236,51,52,26,20,10,7,62,36,5]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E,n,o,a,m,v,D,t,r,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zac=e.$yac=void 0;function c(O,j,T){return new P.$Xf(z=>u(z,T)).isEqual(O,j)}function l(O,j,T){return c(O.uri,j.uri,T)?0:(0,I.$Ed)(O.uri.toString(),j.uri.toString())}function b(O,j,T){return O.index!==j.index?O.index<j.index?-1:1:c(O.uri,j.uri,T)?(0,I.$Ed)(O.name,j.name):(0,I.$Ed)(O.uri.toString(),j.uri.toString())}function y(O,j,T,z){const B=O.slice(0).sort((Y,J)=>T(Y,J,z)),M=j.slice(0).sort((Y,J)=>T(Y,J,z));return(0,S.$gf)(B,M,(Y,J)=>T(Y,J,z))}function u(O,j){const T=j.getCapabilities(O.scheme);return!(T&&T&1024)}class d extends o.$Ih{static toExtHostWorkspace(j,T,z,B){if(!j)return{workspace:null,added:[],removed:[]};const{id:M,name:Y,folders:J,configuration:fe,transient:se,isUntitled:ie}=j,V=[],re=T;T?J.forEach((x,N)=>{const q=$.URI.revive(x.uri),de=d.o(z||T,q,B);de?(de.name=x.name,de.index=x.index,V.push(de)):V.push({uri:q,name:x.name,index:N})}):V.push(...J.map(({uri:x,name:N,index:q})=>({uri:$.URI.revive(x),name:N,index:q}))),V.sort((x,N)=>x.index<N.index?-1:1);const pe=new d(M,Y,V,!!se,fe?$.URI.revive(fe):null,!!ie,x=>u(x,B)),{added:ae,removed:ne}=y(re?re.workspaceFolders:[],pe.workspaceFolders,l,B);return{workspace:pe,added:ae,removed:ne}}static o(j,T,z){for(let B=0;B<j.folders.length;B++){const M=j.workspaceFolders[B];if(c(M.uri,T,z))return M}}constructor(j,T,z,B,M,Y,J){super(j,z.map(fe=>new o.$Jh(fe)),B,M,J),this.t=T,this.u=Y,this.q=[],this.s=f.$vh.forUris(J),z.forEach(fe=>{this.q.push(fe),this.s.set(fe.uri,fe)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,T){return T&&this.s.get(j)&&(j=(0,P.$8f)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let p=class{constructor(j,T,z,B,M){this.c=new L.$ec,this.onDidChangeWorkspace=this.c.event,this.g=new L.$ec,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$gc,this.B=new Map,this.h=B,this.s=z,this.t=M,this.j=new g.$wl,this.k=new F.$tg,this.o=j.getProxy(i.$JJ.MainThreadWorkspace),this.q=j.getProxy(i.$JJ.MainThreadMessageService);const Y=T.workspace;this.l=Y?new d(Y.id,Y.name,[],!!Y.transient,Y.configuration?$.URI.revive(Y.configuration):null,!!Y.isUntitled,J=>u(J,z)):void 0}$initializeWorkspace(j,T){this.v=T,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?$.URI.from({scheme:w.Schemas.untitled,path:(0,P.$6f)((0,P.$8f)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,T,z,...B){const M=[];if(Array.isArray(B)&&B.forEach(ie=>{$.URI.isUri(ie.uri)&&!M.some(V=>c(V.uri,ie.uri,this.s))&&M.push({uri:ie.uri,name:ie.name||(0,P.$5f)(ie.uri)})}),this.n||[T,z].some(ie=>typeof ie!="number"||ie<0)||z===0&&M.length===0)return!1;const Y=this.x?this.x.workspaceFolders:[];if(T+z>Y.length)return!1;const J=Y.slice(0);J.splice(T,z,...M.map(ie=>({uri:ie.uri,name:ie.name||(0,P.$5f)(ie.uri),index:void 0})));for(let ie=0;ie<J.length;ie++){const V=J[ie];if(J.some((re,pe)=>pe!==ie&&c(V.uri,re.uri,this.s)))return!1}J.forEach((ie,V)=>ie.index=V);const{added:fe,removed:se}=y(Y,J,b,this.s);if(fe.length===0&&se.length===0)return!1;if(this.o){const ie=j.displayName||j.name;this.o.$updateWorkspaceFolders(ie,T,z,M).then(void 0,V=>{this.n=void 0;const re={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(n.Severity.Error,(0,k.localize)(0,null,ie,V.toString()),re,[])})}return this.y(J),!0}getWorkspaceFolder(j,T){if(this.x)return this.x.getWorkspaceFolder(j,T)}async getWorkspaceFolder2(j,T){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,T)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,T){let z,B="";if(typeof j=="string"?(z=$.URI.file(j),B=j):typeof j<"u"&&(z=j,B=j.fsPath),!z)return B;const M=this.getWorkspaceFolder(z,!0);if(!M)return B;typeof T>"u"&&this.x&&(T=this.x.folders.length>1);let Y=(0,P.$$f)(M.uri,z);return T&&M.name&&(Y=`${M.name}/${Y}`),Y}y(j){this.x&&(this.n=d.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:T,added:z,removed:B}=d.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=T||void 0,this.n=void 0,this.c.fire(Object.freeze({added:z,removed:B}))}findFiles(j,T,z,B,M=h.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let Y;if(T===null?Y=!1:T&&(typeof T=="string"?Y=T:Y=T.pattern),M&&M.isCancellationRequested)return Promise.resolve([]);const{includePattern:J,folder:fe}=R(D.GlobPattern.from(j));return this.o.$startFileSearch(J??null,fe??null,Y??null,z??null,M).then(se=>Array.isArray(se)?se.map(ie=>$.URI.revive(ie)):[])}async findTextInFiles(j,T,z,B,M=h.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const Y=this.j.getNext(),J=typeof T.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:T.previewOptions,{includePattern:fe,folder:se}=R(D.GlobPattern.from(T.include)),ie=typeof T.exclude=="string"?T.exclude:T.exclude?T.exclude.pattern:void 0,V={ignoreSymlinks:typeof T.followSymlinks=="boolean"?!T.followSymlinks:void 0,disregardIgnoreFiles:typeof T.useIgnoreFiles=="boolean"?!T.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof T.useGlobalIgnoreFiles=="boolean"?!T.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof T.useParentIgnoreFiles=="boolean"?!T.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof T.useDefaultExcludes=="boolean"?!T.useDefaultExcludes:!0,fileEncoding:T.encoding,maxResults:T.maxResults,previewOptions:J,afterContext:T.afterContext,beforeContext:T.beforeContext,includePattern:fe,excludePattern:ie},re=!1;if(this.u[Y]=pe=>{if(re)return;const ae=$.URI.revive(pe.resource);pe.results.forEach(ne=>{(0,s.$9H)(ne)?z({uri:ae,preview:{text:ne.preview.text,matches:(0,S.$Ff)(ne.preview.matches,x=>new t.$NJ(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))},ranges:(0,S.$Ff)(ne.ranges,x=>new t.$NJ(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))}):z({uri:ae,text:ne.text,lineNumber:ne.lineNumber})})},M.isCancellationRequested)return{};try{const pe=await this.o.$startTextSearch(j,se??null,V,Y,M);return delete this.u[Y],pe||{}}catch(pe){throw delete this.u[Y],pe}}$handleTextSearchResult(j,T){this.u[T]?.(j)}async save(j){const T=await this.o.$save(j,{saveAs:!1});return $.URI.revive(T)}async saveAs(j){const T=await this.o.$save(j,{saveAs:!0});return $.URI.revive(T)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,T){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,T);const z=this.t.transformOutgoingScheme(j),B=this.z++;return this.o.$registerEditSessionIdentityProvider(B,z),(0,A.$jb)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(j,T){this.h.info("Getting edit session identifier for workspaceFolder",j);const z=await this.resolveWorkspaceFolder($.URI.revive(j));if(!z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const B=this.w.get(z.uri.scheme);if(this.h.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!B),!B)return;const M=await B.provideEditSessionIdentity(z,T);if(this.h.info("Provider returned edit session identifier: ",M),!!M)return M}async $provideEditSessionIdentityMatch(j,T,z,B){this.h.info("Getting edit session identifier for workspaceFolder",j);const M=await this.resolveWorkspaceFolder($.URI.revive(j));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const Y=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!Y),!Y)return;const J=await Y.provideEditSessionIdentityMatch?.(T,z,B);if(this.h.info("Provider returned edit session identifier match result: ",J),!!J)return J}getOnWillCreateEditSessionIdentityEvent(j){return(T,z,B)=>{const M=function(J){T.call(z,J)};return M.extension=j,this.A.event(M,void 0,B)}}async $onWillCreateEditSessionIdentity(j,T,z){const B=await this.resolveWorkspaceFolder($.URI.revive(j));if(B===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:B},T,async(M,Y)=>{const J=Date.now();await Promise.resolve(M),Date.now()-J>z&&this.h.warn("SLOW edit session create-participant",Y.extension.identifier)}),T.isCancellationRequested}registerCanonicalUriProvider(j,T){if(this.B.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.B.set(j,T);const z=this.t.transformOutgoingScheme(j),B=this.z++;return this.o.$registerCanonicalUriProvider(B,z),(0,A.$jb)(()=>{this.B.delete(j),this.o.$unregisterCanonicalUriProvider(B)})}async provideCanonicalUri(j,T,z){const B=this.B.get(j.scheme);if(!B)return;const M=await B.provideCanonicalUri?.($.URI.revive(j),T,z);if(M)return M}async $provideCanonicalUri(j,T,z){return this.provideCanonicalUri($.URI.revive(j),{targetScheme:T},z)}};e.$yac=p,e.$yac=p=Je([Be(0,v.$LL),Be(1,m.$2L),Be(2,a.$mac),Be(3,E.$Ri),Be(4,r.$wac)],p),e.$zac=(0,C.$ph)("IExtHostWorkspace");function R(O){let j,T;return O&&(typeof O=="string"?j=O:(j=O.pattern,T=$.URI.revive(O.baseUri))),{includePattern:j,folder:T}}}),define(Se[39],De([1,0,23,4,38,5,7,238,134,19,13,6,20,17,2]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cac=e.$Bac=e.$Aac=void 0;function E(r,s){if(s){const i=s.split(".");let c=r;for(let l=0;c&&l<i.length;l++)c=c[i[l]];return c}}function n(r){return r instanceof C.URI}function o(r){return r&&r.uri instanceof C.URI&&r.languageId&&typeof r.languageId=="string"}function a(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function m(r){return r&&r.uri instanceof C.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function v(r){if(n(r))return{resource:r};if(o(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(a(r))return{overrideIdentifier:r.languageId};if(m(r))return{resource:r.uri};if(r===null)return{resource:null}}let D=class{constructor(s,i,c){this.a=s.getProxy(L.$JJ.MainThreadConfiguration),this.c=i,this.b=c,this.d=new P.$tg,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new t(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,i){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(s,i))}};e.$Aac=D,e.$Aac=D=Je([Be(0,$.$LL),Be(1,h.$zac),Be(2,k.$Ri)],D);class t{constructor(s,i,c,l){this.a=new F.$ec,this.b=s,this.f=l,this.c=i,this.e=f.$gn.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,i){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=f.$gn.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(i,c))}getConfiguration(s,i,c){const l=v(i)||{},b=this.g(s?E(this.e.getValue(void 0,l,this.c.workspace),s):this.e.getValue(void 0,l,this.c.workspace));s&&this.h(s,l,c?.identifier);function y(d){if(d==null)return null;if(typeof d=="boolean")return d?2:5;switch(d){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const u={has(d){return typeof E(b,d)<"u"},get:(d,p)=>{this.h(s?`${s}.${d}`:d,l,c?.identifier);let R=E(b,d);if(typeof R>"u")R=p;else{let O;const j=(T,z)=>{if((0,g.$ke)(T)){let B;const M=()=>{O=O||(0,S.$Im)(b),B=B||E(O,z)};return new Proxy(T,{get:(Y,J)=>{if(typeof J=="string"&&J.toLowerCase()==="tojson")return M(),()=>B;if(O)return B=B||E(O,z),B[J];const fe=Y[J];return typeof J=="string"?j(fe,`${z}.${J}`):fe},set:(Y,J,fe)=>(M(),B&&(B[J]=fe),!0),deleteProperty:(Y,J)=>(M(),B&&delete B[J],!0),defineProperty:(Y,J,fe)=>(M(),B&&Object.defineProperty(B,J,fe),!0)})}return Array.isArray(T)?(0,S.$Im)(T):T};R=j(R,d)}return R},update:(d,p,R,O)=>{d=s?`${s}.${d}`:d;const j=y(R);return p!==void 0?this.b.$updateConfigurationOption(j,d,p,l,O):this.b.$removeConfigurationOption(j,d,l,O)},inspect:d=>{d=s?`${s}.${d}`:d;const p=this.e.inspect(d,l,this.c.workspace);if(p)return{key:d,defaultValue:(0,S.$Im)(p.policy?.value??p.default?.value),globalValue:(0,S.$Im)(p.user?.value??p.application?.value),workspaceValue:(0,S.$Im)(p.workspace?.value),workspaceFolderValue:(0,S.$Im)(p.workspaceFolder?.value),defaultLanguageValue:(0,S.$Im)(p.default?.override),globalLanguageValue:(0,S.$Im)(p.user?.override??p.application?.override),workspaceLanguageValue:(0,S.$Im)(p.workspace?.override),workspaceFolderLanguageValue:(0,S.$Im)(p.workspaceFolder?.override),languageIds:(0,S.$Im)(p.overrideIdentifiers)}}};return typeof b=="object"&&(0,S.$Lm)(u,b,!1),Object.freeze(u)}g(s){const i=c=>(0,g.$ke)(c)?new Proxy(c,{get:(l,b)=>i(l[b]),set:(l,b,y)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(l,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(l,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return i(s)}h(s,i,c){const l=w.$0m.test(s)?4:this.d.get(s),b=c?`[${c.value}] `:"";if(l===4){typeof i?.resource>"u"&&this.f.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){i?.resource&&this.f.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,i){const c=new f.$in(s,i,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(l,b)=>c.affectsConfiguration(l,v(b))})}k(s){return s.reduce((i,c)=>(i.set(c[0],c[1]),i),new Map)}}e.$Bac=t,e.$Cac=(0,I.$ph)("IExtHostConfiguration")}),define(Se[93],De([1,0,2,13,4,5,7,38,65,39,22,43,20,26,6,16,9,17,89,282,8]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E,n,o,a,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Abc=e.$zbc=e.$ybc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var D;(function(j){function T(B){if(B!=null)return B}j.from=T;function z(B){if(B!=null)return B}j.to=z})(D||(D={}));var t;(function(j){function T(B){if(B!=null)return B}j.from=T;function z(B){if(B!=null)return B}j.to=z})(t||(t={}));var r;(function(j){function T(B){if(B!=null)return B}j.from=T;function z(B){if(B!=null)return B}j.to=z})(r||(r={}));var s;(function(j){function T(M){if(M){const Y=M;return Y&&!!Y.process}else return!1}j.is=T;function z(M){if(M==null)return;const Y={process:M.process,args:M.args};return M.options&&(Y.options=r.from(M.options)),Y}j.from=z;function B(M){if(M!=null)return new A.$uK(M.process,M.args,M.options)}j.to=B})(s||(s={}));var i;(function(j){function T(B){if(B!=null)return B}j.from=T;function z(B){if(B!=null)return B}j.to=z})(i||(i={}));var c;(function(j){function T(M){if(M){const Y=M;return Y&&(!!Y.commandLine||!!Y.command)}else return!1}j.is=T;function z(M){if(M==null)return;const Y={};return M.commandLine!==void 0?Y.commandLine=M.commandLine:(Y.command=M.command,Y.args=M.args),M.options&&(Y.options=i.from(M.options)),Y}j.from=z;function B(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new A.$vK(M.commandLine,M.options):new A.$vK(M.command,M.args?M.args:[],M.options)}j.to=B})(c||(c={}));var l;(function(j){function T(M){if(M){const Y=M;return Y&&Y.customExecution==="customExecution"}else return!1}j.is=T;function z(M){return{customExecution:"customExecution"}}j.from=z;function B(M,Y){return Y.get(M)}j.to=B})(l||(e.CustomExecutionDTO=l={}));var b;(function(j){function T(z,B){let M;return z.scope!==void 0&&typeof z.scope!="number"?M=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===A.TaskScope.Workspace&&B&&B.workspaceFile?M=B.workspaceFile:M=m.$ZF),{id:z._id,workspaceFolder:M}}j.from=T})(b||(e.TaskHandleDTO=b={}));var y;(function(j){function T(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}j.from=T})(y||(y={}));var u;(function(j){function T(M,Y){if(M==null)return[];const J=[];for(const fe of M){const se=z(fe,Y);se&&J.push(se)}return J}j.fromMany=T;function z(M,Y){if(M==null)return;let J;M.execution instanceof A.$uK?J=s.from(M.execution):M.execution instanceof A.$vK?J=c.from(M.execution):M.execution&&M.execution instanceof A.$wK&&(J=l.from(M.execution));const fe=D.from(M.definition);let se;return M.scope?typeof M.scope=="number"?se=M.scope:se=M.scope.uri:se=A.TaskScope.Workspace,!fe||!se?void 0:{_id:M._id,definition:fe,name:M.name,source:{extensionId:Y.identifier.value,label:M.source,scope:se},execution:J,isBackground:M.isBackground,group:y.from(M.group),presentationOptions:t.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}j.from=z;async function B(M,Y,J){if(M==null)return;let fe;s.is(M.execution)?fe=s.to(M.execution):c.is(M.execution)?fe=c.to(M.execution):l.is(M.execution)&&(fe=l.to(M._id,J));const se=D.to(M.definition);let ie;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?ie=M.source.scope:ie=await Y.resolveWorkspaceFolder(S.URI.revive(M.source.scope)):ie=A.TaskScope.Workspace),!se||!ie)return;const V=new A.$xK(se,ie,M.name,M.source.label,fe,M.problemMatchers);return M.isBackground!==void 0&&(V.isBackground=M.isBackground),M.group!==void 0&&(V.group=A.$tK.from(M.group._id),V.group&&M.group.isDefault&&(V.group=new A.$tK(V.group.id,V.group.label),M.group.isDefault===!0&&(V.group.isDefault=M.group.isDefault))),M.presentationOptions&&(V.presentationOptions=t.to(M.presentationOptions)),M._id&&(V._id=M._id),M.detail&&(V.detail=M.detail),V}j.to=B})(u||(e.TaskDTO=u={}));var d;(function(j){function T(B){return B}j.from=T;function z(B){if(B)return Object.assign(Object.create(null),B)}j.to=z})(d||(d={}));class p{#e;constructor(T,z,B){this._id=z,this.a=B,this.#e=T}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(T){}fireDidEndProcess(T){}}let R=class{constructor(T,z,B,M,Y,J,fe,se){this.q=new h.$ec,this.r=new h.$ec,this.s=new h.$ec,this.t=new h.$ec,this.a=T.getProxy(L.$JJ.MainThreadTask),this.b=B,this.c=M,this.d=Y,this.e=J,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=fe,this.g=se,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(T,z,B){if(!B)return new A.$LJ(()=>{});const M=this.w();return this.j.set(M,{type:z,provider:B,extension:T}),this.a.$registerTaskProvider(M,z),new A.$LJ(()=>{this.j.delete(M),this.a.$unregisterTaskProvider(M)})}registerTaskSystem(T,z){this.a.$registerTaskSystem(T,z)}fetchTasks(T){return this.a.$fetchTasks(d.from(T)).then(async z=>{const B=[];for(const M of z){const Y=await u.to(M,this.b,this.m);Y&&B.push(Y)}return B})}get taskExecutions(){const T=[];return this.k.forEach(z=>T.push(z)),T}terminateTask(T){if(!(T instanceof p))throw new Error("No valid task execution provided");return this.a.$terminateTask(T._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(T,z,B){const M=this.m.get(T.id);M&&(this.o.set(T.id,M),this.e.attachPtyToTerminal(z,await M.callback(B))),this.p=T.id,this.q.fire({execution:await this.y(T)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(T){const z=await this.y(T);this.l.delete(T.id),this.k.delete(T.id),this.A(T),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(T){const z=await this.y(T.id);this.s.fire({execution:z,processId:T.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(T){const z=await this.y(T.id);this.t.fire({execution:z,exitCode:T.exitCode})}$provideTasks(T,z){const B=this.j.get(T);if(!B)return Promise.reject(new Error("no handler found"));const M=[],Y=(0,F.$ng)(()=>B.provider.provideTasks(P.CancellationToken.None)).then(J=>this.u(z,M,B,J));return new Promise(J=>{Y.then(fe=>{Promise.all(M).then(()=>{J(fe)})})})}async $resolveTask(T,z){const B=this.j.get(T);if(!B)return Promise.reject(new Error("no handler found"));if(z.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${B.type}].`);const M=await u.to(z,this.b,this.m);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const Y=await B.provider.resolveTask(M,P.CancellationToken.None);if(!Y)return;this.z(Y,B);const J=u.from(Y,B.extension);if(!J)throw new Error("Unexpected: Task cannot be resolved.");if(Y.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(J.execution)&&await this.x(J,Y,!0),await this.v(J)}w(){return this.h++}async x(T,z,B){const M=await this.a.$createTaskId(T);!B&&!this.m.has(M)&&(this.n.add(M),this.o.set(M,z.execution)),this.m.set(M,z.execution)}async y(T,z){if(typeof T=="string"){const Y=this.l.get(T);if(!Y)throw new v.$ab("Unexpected: The specified task is missing an execution");return Y}const B=this.l.get(T.id);if(B)return B;const M=new Promise((Y,J)=>{function fe(se,ie,V){V?Y(new p(se,ie.id,V)):J("Unexpected: Task does not exist.")}z?fe(this,T,z):u.to(T.task,this.b,this.m).then(se=>fe(this,T,se))});return this.l.set(T.id,M),M.then(Y=>(this.k.set(T.id,Y),Y),Y=>Promise.reject(Y))}z(T,z){T._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}A(T){this.o.get(T.id)&&this.o.delete(T.id),this.n.has(T.id)&&this.p!==T.id&&(this.m.delete(T.id),this.n.delete(T.id));const B=this.n.values();let M=B.next();for(;!M.done;)!this.o.has(M.value)&&this.p!==M.value&&(this.m.delete(M.value),this.n.delete(M.value)),M=B.next()}};e.$ybc=R,e.$ybc=R=Je([Be(0,$.$LL),Be(1,k.$2L),Be(2,f.$zac),Be(3,w.$WL),Be(4,g.$Cac),Be(5,I.$Uac),Be(6,o.$Ri),Be(7,a.$pac)],R);let O=class extends R{constructor(T,z,B,M,Y,J,fe,se){super(T,z,B,M,Y,J,fe,se),this.registerTaskSystem(E.Schemas.vscodeRemote,{scheme:E.Schemas.vscodeRemote,authority:"",platform:n.$h(0)})}async executeTask(T,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const B=u.from(z,T);if(B===void 0)throw new Error("Task is not valid");if(l.is(B.execution))await this.x(B,z,!1);else throw new v.$$;const M=await this.y(await this.a.$getTaskExecution(B),z);return this.a.$executeTask(B).catch(Y=>{throw new Error(Y)}),M}u(T,z,B,M){const Y=[];if(M)for(const J of M){this.z(J,B),(!J.definition||!T[J.definition.type])&&this.f.warn(`The task [${J.source}, ${J.name}] uses an undefined task type. The task will be ignored in the future.`);const fe=u.from(J,B.extension);fe&&l.is(fe.execution)?(Y.push(fe),z.push(this.x(fe,J,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:Y,extension:B.extension}}async v(T){if(l.is(T.execution))return T;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(T,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(T,z,B){}};e.$zbc=O,e.$zbc=O=Je([Be(0,$.$LL),Be(1,k.$2L),Be(2,f.$zac),Be(3,w.$WL),Be(4,g.$Cac),Be(5,I.$Uac),Be(6,o.$Ri),Be(7,a.$pac)],O),e.$Abc=(0,C.$ph)("IExtHostTask")}),define(Se[336],De([1,0,14,22,45,35,24,37,36]),function(me,e,S,F,h,L,A,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=void 0;class g{constructor($,k,C){this.k=$,this.l=k,this.o=C,this.e=!1,this.f=0,this.g=!1,this.a=$.filePattern,this.b=$.includePattern&&L.$ej($.includePattern),this.c=$.maxResults||void 0,this.d=$.exists,this.h=new Set,this.j=$.excludePattern&&L.$ej($.excludePattern)}cancel(){this.g=!0,this.h.forEach($=>$.cancel()),this.h=new Set}search($){const k=this.k.folderQueries||[];return new Promise((C,E)=>{const n=o=>{this.f++,$(o)};if(this.g)return C({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const a=o.toString(),m=S.$_c(a);this.j&&this.j(a,m)||this.v(n,{base:o,basename:m})}),Promise.all(k.map(o=>this.p(o,n))).then(o=>{C({limitHit:this.e,stats:o[0]||void 0})},o=>{E(new Error((0,h.$ai)(o)))})})}async p($,k){const C=new F.$oc,E=this.q($),n=this.r(),o=new w.$oI(this.k,$),a=!o.hasSiblingExcludeClauses();let m;try{this.h.add(C),m=f.$ac.create();const v=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},E,C.token),D=m.elapsed(),t=f.$ac.create();return this.g&&!this.e||(v&&v.forEach(r=>{const s=S.$5c.relative($.folder.path,r.path);if(a){const i=S.$_c(r.path);this.v(k,{base:$.folder,relativePath:s,basename:i});return}this.s(n,$.folder,s,k)}),this.g&&!this.e)?null:(this.u(n,o,k),{providerTime:D,postProcessTime:t.elapsed()})}finally{C.dispose(),this.h.delete(C)}}q($){const k=(0,w.$nI)(this.k.includePattern,$.includePattern),C=(0,w.$nI)(this.k.excludePattern,$.excludePattern);return{folder:$.folder,excludes:C,includes:k,useIgnoreFiles:!$.disregardIgnoreFiles,useGlobalIgnoreFiles:!$.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!$.disregardParentIgnoreFiles,followSymlinks:!$.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const $={rootEntries:[],pathToEntries:Object.create(null)};return $.pathToEntries["."]=$.rootEntries,$}s({pathToEntries:$},k,C,E){if(C===this.a){const o=S.$_c(this.a);this.v(E,{base:k,relativePath:this.a,basename:o})}function n(o){const a=S.$_c(o),m=S.$$c(o);let v=$[m];v||(v=$[m]=[],n(m)),v.push({base:k,relativePath:o,basename:a})}n(C)}u({rootEntries:$,pathToEntries:k},C,E){const n=this,o=this.a;function a(m){const v=(0,w.$qI)(()=>m.map(D=>D.basename));for(let D=0,t=m.length;D<t;D++){const r=m[D],{relativePath:s,basename:i}=r;if(C.matchesExcludesSync(s,i,o!==i?v:void 0))continue;const c=k[s];if(c)a(c);else{if(s===o)continue;n.v(E,r)}if(n.e)break}}a($)}v($,k){(!this.b||k.relativePath&&this.b(k.relativePath,k.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||$(k))}}class P{constructor(){this.b=new Map}static{this.a=512}fileSearch($,k,C,E){const n=this.c($.cacheKey),o=new g($,k,n&&n.token);let a=0;const m=v=>{a+=v.length,C(v.map(D=>this.d(D)))};return this.e(o,P.a,m,E).then(v=>({limitHit:v.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:a,detailStats:v.stats}}))}clearCache($){this.c($)?.cancel()}c($){if($)return this.b.has($)||this.b.set($,new F.$oc),this.b.get($)}d($){return $.relativePath?{resource:A.$9f($.base,$.relativePath)}:{resource:$.base}}e($,k,C,E){E.onCancellationRequested(()=>{$.cancel()});const n=a=>{a&&(o.push(a),k>0&&o.length>=k&&(C(o),o=[]))};let o=[];return $.search(n).then(a=>(o.length&&C(o),a),a=>(o.length&&C(o),Promise.reject(a)))}}e.$Kbc=P}),define(Se[337],De([1,0,18,69,35,126,28,16,14,24,15,19,2,169,219,50,17,51,141,335,36]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E,n,o,a,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iJ=e.$hJ=void 0;let D=class{constructor(d,p,R,O,j){this.a=d,this.b=p,this.c=R,this.d=O,this.e=j}text(d,p,R={}){d=this.f(d,R);const O=this.a.getValue(),j=p&&p.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(p?.map(o.$Kh),R),type:2,contentPattern:d,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:O.search.usePCRE2||j||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}f(d,p){const R=this.a.getValue();d.isRegExp&&(d.pattern=d.pattern.replace(/\r?\n/g,"\\n"));const O={...d,wordSeparators:R.editor.wordSeparators};return this.j(d,p)&&(O.isCaseSensitive=!0),this.k(d)&&(O.isMultiline=!0),p.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=p.notebookSearchConfig.includeMarkupInput),p.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=p.notebookSearchConfig.includeMarkupPreview),p.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=p.notebookSearchConfig.includeCodeInput),p.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=p.notebookSearchConfig.includeOutput),O}file(d,p={}){return{...this.h(d,p),type:1,filePattern:p.filePattern?p.filePattern.trim():p.filePattern,exists:p.exists,sortByScore:p.sortByScore,cacheKey:p.cacheKey}}g(d,p){return d?(d=Array.isArray(d)?d.map(c):c(d),p?this.parseSearchPaths(d):{pattern:r(...Array.isArray(d)?d:[d])}):{}}h(d=[],p={}){const R=this.g(p.includePattern,p.expandPatterns),O=this.g(p.excludePattern,p.expandPatterns),j=d.length>1,T=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(M=>this.q(M,p,O)):d.map(M=>this.r(M,p,O,j))).filter(M=>!!M),z={_reason:p._reason,folderQueries:T,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:p.extraFileResources,excludePattern:O.pattern,includePattern:R.pattern,onlyOpenEditors:p.onlyOpenEditors,maxResults:p.maxResults};if(p.onlyOpenEditors){const M=S.$jf(S.$vf(this.c.groups.map(fe=>fe.editors.map(se=>se.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(M));const Y=M.filter(fe=>(0,v.$eI)(z,fe.fsPath)),J=this.i(Y);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(J)),{...z,...J}}const B=p.extraFileResources&&p.extraFileResources.filter(M=>(0,v.$eI)(z,M.fsPath));return z.extraFileResources=B&&B.length?B:void 0,z}i(d){const p=[],R=new A.$ni,O={};let j=!1;return d.forEach(T=>{if(T.scheme===f.Schemas.walkThrough)return;if((0,g.$ag)(T)){const B=this.b.getWorkspaceFolder(T)?.uri??T.with({path:w.$$c(T.fsPath)});let M=R.get(B);M||(j=!0,M={folder:B,includePattern:{}},p.push(M),R.set(B,M));const Y=w.$0c(B.fsPath,T.fsPath);(0,I.$te)(M.includePattern)[Y.replace(/\\/g,"/")]=!0}else T.fsPath&&(j=!0,O[T.fsPath]=!0)}),{folderQueries:p,includePattern:O,usingSearchPaths:!0,excludePattern:j?void 0:{"**/*":!0}}}j(d,p){if(p.isSmartCase){if(d.isRegExp){if(P.$_d(d.pattern,!0))return!0}else if(P.$_d(d.pattern))return!0}return!!d.isCaseSensitive}k(d){return d.isMultiline||d.isRegExp&&(0,k.$0B)(d.pattern)||d.pattern.indexOf(`
`)>=0?!0:!!d.isMultiline}parseSearchPaths(d){const p=J=>w.$7c(J)||/^\.\.?([\/\\]|$)/.test(J),O=(Array.isArray(d)?d:s(d)).map(J=>{const fe=this.e.resolvedUserHome;return fe?(0,L.$9z)(J,fe.scheme===f.Schemas.file?fe.fsPath:fe.path):J}),j=F.$I(O,J=>p(J)?"searchPaths":"exprSegments"),T=(j.exprSegments||[]).map(J=>P.$ud(J,"/")).map(J=>P.$ud(J,"\\")).map(J=>(J[0]==="."&&(J="*"+J),i(J))),z={},B=this.m(j.searchPaths||[]);B&&B.length&&(z.searchPaths=B);const M=S.$vf(T),Y=r(...M);return Y&&(z.pattern=Y),z}l(d,p){return p.disregardExcludeSettings?void 0:(0,v.$dI)(d,!p.disregardSearchExcludeSettings)}m(d){if(!d||!d.length)return[];const p=d.flatMap(O=>{let{pathPortion:j,globPortion:T}=t(O);return T&&(T=l(T)),this.n(j).flatMap(B=>this.o(B,T))}),R=new Map;return p.forEach(O=>{const j=O.searchPath.toString(),T=R.get(j);T?O.pattern&&(T.pattern=T.pattern||{},T.pattern[O.pattern]=!0):R.set(j,{searchPath:O.searchPath,pattern:O.pattern?r(O.pattern):void 0})}),Array.from(R.values())}n(d){if(w.$7c(d)){const p=this.b.getWorkspace().folders;return p[0]&&p[0].uri.scheme!==f.Schemas.file?[{searchPath:p[0].uri.with({path:d})}]:[{searchPath:$.URI.file(w.$6c(d))}]}if(this.b.getWorkbenchState()===2){const p=this.b.getWorkspace().folders[0].uri;if(d=c(d),d.startsWith("../")||d===".."){const O=w.$5c.resolve(p.path,d);return[{searchPath:p.with({path:O})}]}const R=l(d);return[{searchPath:p,pattern:R}]}else{if(d==="./"||d===".\\")return[];{const p=d.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(j=>{const T=p.match(new RegExp(`^${P.$pd(j.name)}(?:/(.*)|$)`));return T?{match:T,folder:j}:null}).filter(I.$qe);if(O.length)return O.map(j=>{const T=j.match[1];return{searchPath:j.folder.uri,pattern:T&&l(T)}});{const j=d.match(/\.[\/\\](.+)[\/\\]?/),T=j?j[1]:d,z=C.localize(0,null,T);throw new Error(z)}}}}o(d,p){const R=d.pattern&&p?`${d.pattern}/${p}`:d.pattern||p,O=[{searchPath:d.searchPath,pattern:R}];return R&&!R.endsWith("**")&&O.push({searchPath:d.searchPath,pattern:R+"/**"}),O}q(d,p,R){const O=this.r((0,o.$Kh)(d.searchPath),p,R,!1);return O?{...O,includePattern:d.pattern}:null}r(d,p,R,O){let j;const T=$.URI.isUri(d)?d:d.uri;if(R.searchPaths){const J=R.searchPaths.filter(fe=>(0,g.$2f)(fe.searchPath,T))[0];if(J&&!J.pattern)return null;J&&(j=J.pattern)}const z=this.a.getValue({resource:T}),M={...this.l(z,p)||{},...j||{}},Y=$.URI.isUri(d)?(0,g.$6f)(d):d.name;return{folder:T,folderName:O?Y:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof p.disregardIgnoreFiles=="boolean"?p.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof p.disregardGlobalIgnoreFiles=="boolean"?p.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof p.disregardParentIgnoreFiles=="boolean"?p.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof p.ignoreSymlinks=="boolean"?p.ignoreSymlinks:!z.search.followSymlinks}}};e.$hJ=D,e.$hJ=D=Je([Be(0,E.$Vh),Be(1,o.$yh),Be(2,a.$TC),Be(3,n.$Ri),Be(4,m.$fJ)],D);function t(u){const d=u.match(/[\*\{\}\(\)\[\]\?]/);if(d){const p=d.index,R=u.substr(0,p).match(/[/|\\][^/\\]*$/);if(R){let O=u.substr(0,R.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:u.substr((R.index||0)+1)}}}return{pathPortion:u}}function r(...u){return u.length?u.reduce((d,p)=>(d[p]=!0,d),Object.create(null)):void 0}function s(u){return h.$cj(u,",").map(d=>d.trim()).filter(d=>!!d.length)}function i(u){return[`**/${u}/**`,`**/${u}`].map(p=>p.replace(/\*\*\/\*\*/g,"**"))}function c(u){return u.replace(/\\/g,"/")}function l(u){return c(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function b(u){return u.replace(/([?*[\]])/g,"[$1]")}function y(u,d){u=S.$of(u,O=>O.toString());const p=[],R=d.getWorkspace();return u&&u.forEach(O=>{let j;if(d.getWorkbenchState()===2)j=(0,g.$$f)(R.folders[0].uri,O),j&&j!=="."&&(j="./"+j);else{const T=d.getWorkspaceFolder(O);if(T){const z=T.name;if(R.folders.filter(M=>M.name===z).length===1){const M=(0,g.$$f)(T.uri,O);M===""?j=`./${T.name}`:j=`./${T.name}/${M}`}else j=O.fsPath}}j&&p.push(b(j))}),p}e.$iJ=y}),define(Se[338],De([1,0,24,2,22,8,6,337,36,51]),function(me,e,S,F,h,L,A,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xkb=e.$Wkb=void 0;const P=7e3;function I(E,n){const o=n.activationEvents;if(!o)return Promise.resolve(void 0);const a=[],m=[];for(const i of o)if(/^workspaceContains:/.test(i)){const c=i.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||E.forceUsingSearch?m.push(c):a.push(c)}if(a.length===0&&m.length===0)return Promise.resolve(void 0);let v;const D=new Promise((i,c)=>{v=i}),t=i=>v({activationEvent:i}),r=Promise.all(a.map(i=>$(E,i,t))).then(()=>{}),s=k(E,n.identifier,m,t);return Promise.all([r,s]).then(()=>{v(void 0)}),D}e.$Wkb=I;async function $(E,n,o){for(const a of E.folders)if(await E.exists(S.$9f(F.URI.revive(a),n))){o(`workspaceContains:${n}`);return}}async function k(E,n,o,a){if(o.length===0)return Promise.resolve(void 0);const m=new h.$oc,v=E.checkExists(E.folders,o,m.token),D=setTimeout(async()=>{m.cancel(),E.logService.info(`Not activating extension '${n.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},P);let t=!1;try{t=await v}catch(r){L.$2(r)||L.$Y(r)}m.dispose(),clearTimeout(D),t&&a(`workspaceContains:${o.join(",")}`)}function C(E,n,o,a){const m=E.get(A.$oh),v=E.get(w.$8H),t=m.createInstance(f.$hJ).file(n.map(r=>(0,g.$Kh)(F.URI.revive(r))),{_reason:"checkExists",includePattern:o,exists:!0});return v.fileSearch(t,a).then(r=>!!r.limitHit,r=>L.$2(r)?!1:Promise.reject(r))}e.$Xkb=C}),define(Se[44],De([1,0,198,14,61,24,13,3,75,2,17,5,39,277,114,38,27,145,8,25,21,252,7,84,6,26,90,20,103,68,43,4,338,113,254,16,111,37,9,112]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E,n,o,a,m,v,D,t,r,s,i,c,l,b,y,u,d,p,R,O,j,T,z,B,M){"use strict";var Y;Object.defineProperty(e,"__esModule",{value:!0}),e.$0ac=e.$9ac=e.$8ac=e.$7ac=e.$6ac=void 0,e.$6ac=(0,s.$ph)("IHostUtils");let J=Y=class extends f.$lb{constructor(ne,x,N,q,de,ye,ve,we,Ee,K,ee,G){super(),this.R=G,this.a=this.B(new d.$ec),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=x,this.g=N,this.f=ve,this.j=q,this.k=de,this.l=ye,this.m=Ee,this.p=K,this.s=ee,this.t=this.g.getProxy(I.$JJ.MainThreadWorkspace),this.u=this.g.getProxy(I.$JJ.MainThreadTelemetry),this.v=this.g.getProxy(I.$JJ.MainThreadExtensionService),this.w=new A.$tg,this.y=new A.$tg,this.z=new A.$tg,this.C=new A.$tg,this.D=new pe(this.f.activationEvents),this.G=new o.$P2b(this.D,this.f.allExtensions);const X=new m.$Jl(this.f.myExtensions);this.F=new o.$P2b(this.D,V(this.G,X)),this.H=new C.$Mac(this.g,this.l),this.I=new R.$Yac(this.g),this.J=we,this.h=ne.createChild(new b.$nh([C.$Nac,this.H],[R.$Zac,this.I])),this.L=this.B(new k.$Lac(this.F,this.G,{onExtensionActivationError:(he,Ie,U)=>{this.v.$onExtensionActivationError(he,a.$1(Ie),U)},actualActivateExtension:async(he,Ie)=>{if(o.$P2b.isHostExtension(he,this.F,this.G))return await this.v.$activateExtension(he,Ie),new k.$Kac;const U=this.F.getExtensionDescription(he);return this.$(U,Ie)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.pb(),this.w.open(),await this.j.waitForInitializeCall(),h.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.nb()}catch(ne){a.$Y(ne)}}async S(){this.J.onWillDeactivateAll();let ne=[];try{ne=this.F.getAllExtensionDescriptions().map(de=>de.identifier).filter(de=>this.isActivated(de)).map(de=>this.Z(de))}catch{}await Promise.all(ne)}terminate(ne,x=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${ne}`),this.l.flush(),this.p.dispose(),this.L.dispose(),a.setUnexpectedErrorHandler(q=>{this.l.error(q)}),this.g.dispose();const N=this.S();Promise.race([(0,A.$vg)(5e3),N]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${x}`):this.l.info(`Extension host exiting with code ${x}`),this.l.flush(),this.l.dispose(),this.c.exit(x)})}isActivated(ne){return this.z.isOpen()?this.L.isActivated(ne):!1}async getExtension(ne){const x=await this.v.$getExtension(ne);return x&&{...x,identifier:new m.$Il(x.identifier.value),extensionLocation:g.URI.revive(x.extensionLocation)}}U(ne,x){return this.L.activateByEvent(ne,x)}W(ne,x){return this.L.activateById(ne,x)}activateByIdWithErrors(ne,x){return this.W(ne,x).then(()=>{const N=this.L.getActivatedExtension(ne);if(N.activationFailed)return Promise.reject(N.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(ne=>this.F)}getExtensionExports(ne){if(this.z.isOpen())return this.L.getActivatedExtension(ne).exports;try{return this.L.getActivatedExtension(ne).exports}catch{return null}}async X(ne){if(ne.scheme===j.Schemas.file&&this.c.fsRealpath){const x=await this.c.fsRealpath(ne.fsPath);return g.URI.file(x)}return ne}async getExtensionPathIndex(){return this.M||(this.M=this.Y(this.F.getAllExtensionDescriptions()).then(ne=>new re(ne))),this.M}async Y(ne){const x=w.$vh.forUris(N=>L.$Zf.ignorePathCasing(N));return await Promise.all(ne.map(async N=>{if(this.qb(N)){const q=await this.X(N.extensionLocation);x.set(q,N)}})),x}Z(ne){let x=Promise.resolve(void 0);if(!this.z.isOpen()||!this.L.isActivated(ne))return x;const N=this.L.getActivatedExtension(ne);if(!N)return x;try{typeof N.module.deactivate=="function"&&(x=Promise.resolve(N.module.deactivate()).then(void 0,q=>(this.l.error(q),Promise.resolve(void 0))))}catch(q){this.l.error(`An error occurred when deactivating the extension '${ne.value}':`),this.l.error(q)}try{(0,f.$gb)(N.subscriptions)}catch(q){this.l.error(`An error occurred when deactivating the subscriptions for extension '${ne.value}':`),this.l.error(q)}return x}async $(ne,x){return this.f.remote.isRemote?this.v.$onWillActivateExtension(ne.identifier):await this.v.$onWillActivateExtension(ne.identifier),this.bb(ne,x).then(N=>{const q=N.activationTimes;return this.v.$onDidActivateExtension(ne.identifier,q.codeLoadingTime,q.activateCallTime,q.activateResolvedTime,x),this.ab(ne,x,"success",q),N},N=>{throw this.ab(ne,x,"failure"),N})}ab(ne,x,N,q){const de=se(ne,x);this.u.$publicLog2("extensionActivationTimes",{...de,...q||{},outcome:N})}bb(ne,x){const N=se(ne,x);this.u.$publicLog2("activatePlugin",N);const q=this.qb(ne);if(!q)return Promise.resolve(new k.$Jac(k.$Gac.NONE));this.l.info(`ExtensionService#_doActivateExtension ${ne.identifier.value}, startup: ${x.startup}, activationEvent: '${x.activationEvent}'${ne.identifier.value!==x.extensionId.value?`, root cause: ${x.extensionId.value}`:""}`),this.l.flush();const de=new k.$Hac(x.startup);return Promise.all([this.rb(ne,(0,L.$9f)(ne.extensionLocation,q),de),this.cb(ne)]).then(ye=>(h.mark(`code/extHost/willActivateExtension/${ne.identifier.value}`),Y.db(this.l,ne.identifier,ye[0],ye[1],de))).then(ye=>(h.mark(`code/extHost/didActivateExtension/${ne.identifier.value}`),ye))}cb(ne){const x=new D.$Pac(ne,this.H),N=new D.$Oac(ne.identifier.value,!1,this.H),q=new O.$1ac(ne,this.I),de=ne.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ye=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${ne.identifier.value}`),Promise.all([x.whenReady,N.whenReady,this.J.whenReady]).then(()=>{const ve=this;let we,Ee;const K=(0,n.$DF)(ne,"ipc")?this.f.messagePorts?.get(m.$Il.toKey(ne.identifier)):void 0;return Object.freeze({globalState:x,workspaceState:N,secrets:q,subscriptions:[],get extensionUri(){return ne.extensionLocation},get extensionPath(){return ne.extensionLocation.fsPath},asAbsolutePath(ee){return F.$8c(ne.extensionLocation.fsPath,ee)},get storagePath(){return ve.J.workspaceValue(ne)?.fsPath},get globalStoragePath(){return ve.J.globalValue(ne).fsPath},get logPath(){return F.$8c(ve.f.logsLocation.fsPath,ne.identifier.value)},get logUri(){return g.URI.joinPath(ve.f.logsLocation,ne.identifier.value)},get storageUri(){return ve.J.workspaceValue(ne)},get globalStorageUri(){return ve.J.globalValue(ne)},get extensionMode(){return de},get extension(){return we===void 0&&(we=new ie(ve,ne.identifier,ne,ye,!1)),we},get extensionRuntime(){return(0,n.$EF)(ne,"extensionRuntime"),ve.extensionRuntime},get environmentVariableCollection(){return ve.p.getEnvironmentVariableCollection(ne)},get messagePassingProtocol(){if(!Ee){if(!K)return;const ee=d.Event.buffer(d.Event.fromDOMEventEmitter(K,"message",G=>G.data));K.start(),Ee={onDidReceiveMessage:ee,postMessage:K.postMessage.bind(K)}}return Ee}})})}static db(ne,x,N,q,de){return N=N||{activate:void 0,deactivate:void 0},this.eb(ne,x,N,q,de).then(ye=>new k.$Iac(!1,null,de.build(),N,ye,q.subscriptions))}static eb(ne,x,N,q,de){if(typeof N.activate=="function")try{de.activateCallStart(),ne.trace(`ExtensionService#_callActivateOptional ${x.value}`);const ye=typeof global=="object"?global:self,ve=N.activate.apply(ye,[q]);return de.activateCallStop(),de.activateResolveStart(),Promise.resolve(ve).then(we=>(de.activateResolveStop(),we))}catch(ye){return Promise.reject(ye)}else return Promise.resolve(N)}fb(ne,x){this.W(ne.identifier,{startup:!1,extensionId:ne.identifier,activationEvent:x}).then(void 0,N=>{this.l.error(N)})}gb(ne,x=0){const q=Date.now();(0,B.$A)(()=>{for(let de=x;de<ne.length;de+=1){const ye=ne[de];for(const ve of ye.activationEvents??[])if(ve==="onStartupFinished")if(Date.now()-q>50){this.gb(ne,de);break}else this.fb(ye,ve)}})}hb(){this.v.$setPerformanceMarks(h.getMarks()),this.k.getConfigProvider().then(ne=>{const x=ne.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),N=this.F.getAllExtensionDescriptions();if(x)this.gb(N);else for(const q of N)if(q.activationEvents)for(const de of q.activationEvents)de==="onStartupFinished"&&this.fb(q,de)})}ib(){const ne=this.U("*",!0).then(void 0,ye=>{this.l.error(ye)});this.B(this.j.onDidChangeWorkspace(ye=>this.jb(ye.added)));const x=this.j.workspace?this.j.workspace.folders:[],N=this.jb(x),q=this.lb(),de=Promise.all([q,ne,N]).then(()=>{});return Promise.race([de,(0,A.$vg)(1e4)]).then(()=>{this.hb()}),de}jb(ne){return ne.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(x=>this.kb(ne,x))).then(()=>{})}async kb(ne,x){if(this.isActivated(x.identifier))return;const N=!this.f.remote.isRemote&&!!this.f.remote.authority,q={logService:this.l,folders:ne.map(ye=>ye.uri),forceUsingSearch:N||!this.c.fsExists,exists:ye=>this.c.fsExists(ye.fsPath),checkExists:(ye,ve,we)=>this.t.$checkExists(ye,ve,we)},de=await(0,p.$Wkb)(q,x);if(de)return this.W(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:de.activationEvent}).then(void 0,ye=>this.l.error(ye))}async lb(){if(this.f.remote.authority)return this.U(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.C.wait();try{return await this.mb()}catch(ne){throw console.error(ne),ne}}async mb(){const{extensionDevelopmentLocationURI:ne,extensionTestsLocationURI:x}=this.f.environment;if(!ne||!x)throw new Error(S.localize(0,null));const N=await this.rb(null,x,new k.$Hac(!1));if(!N||typeof N.run!="function")throw new Error(S.localize(1,null,x.toString()));return new Promise((q,de)=>{const ye=(Ee,K)=>{Ee?de(Ee):q(typeof K=="number"&&K>0?1:0)},ve=(0,L.$Wf)(x),we=N.run(ve,ye);we&&we.then&&we.then(()=>{q(0)}).catch(Ee=>{de(Ee instanceof Error&&Ee.stack?Ee.stack:String(Ee))})})}nb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.y.wait().then(()=>this.z.open()).then(()=>Promise.race([this.L.waitForActivatingExtensions(),(0,A.$vg)(1e3)])).then(()=>this.ib()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ne,x){return this.N[ne]=x,(0,f.$jb)(()=>{delete this.N[ne]})}async getRemoteExecServer(ne){const{resolver:x}=await this.ob(ne);return x?.resolveExecServer?.(ne,{resolveAttempt:0})}async ob(ne){const x=ne.indexOf("+");if(x===-1)throw new t.$RJ("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const N=ne.substr(0,x);return await this.w.wait(),await this.U(`onResolveRemoteAuthority:${N}`,!1),{authorityPrefix:N,resolver:this.N[N]}}async $resolveAuthority(ne,x){const N=z.$ac.create(!1),q=()=>`[resolveAuthority(${(0,r.$Ak)(ne)},${x})][${N.elapsed()}ms] `,de=_=>this.l.info(`${q()}${_}`),ye=_=>this.l.warn(`${q()}${_}`),ve=(_,oe=void 0)=>this.l.error(`${q()}${_}`,oe),we=_=>{if(_ instanceof t.$RJ)return{type:"error",error:{code:_._code,message:_._message,detail:_._detail}};throw _},Ee=async _=>{de(`activating resolver for ${_}...`);const{resolver:oe,authorityPrefix:Z}=await this.ob(_);if(!oe)throw ve(`no resolver for ${Z}`),new t.$RJ(`No remote extension installed to resolve ${Z}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:oe,authorityPrefix:Z,remoteAuthority:_}},K=ne.split(/@|%40/g).reverse();de(`activating remote resolvers ${K.join(" -> ")}`);let ee;try{ee=await Promise.all(K.map(Ee)).catch(async _=>{if(!(_ instanceof t.$RJ)||_._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw _;return ye(`resolving nested authorities failed: ${_.message}`),[await Ee(ne)]})}catch(_){return we(_)}const G=new A.$Fg;G.cancelAndSet(()=>de("waiting..."),1e3);let X,he;for(const[_,{authorityPrefix:oe,resolver:Z,remoteAuthority:le}]of ee.entries())try{if(_===ee.length-1)de("invoking final resolve()..."),h.mark(`code/extHost/willResolveAuthority/${oe}`),X=await Z.resolve(le,{resolveAttempt:x,execServer:he}),h.mark(`code/extHost/didResolveAuthorityOK/${oe}`),de("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(Z,t.$QJ.isManagedResolvedAuthority(X)?X:void 0));else{if(de(`invoking resolveExecServer() for ${le}`),h.mark(`code/extHost/willResolveExecServer/${oe}`),he=await Z.resolveExecServer?.(le,{resolveAttempt:x,execServer:he}),!he)throw new t.$RJ(`Exec server was not available for ${le}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);h.mark(`code/extHost/didResolveExecServerOK/${oe}`)}}catch(be){return h.mark(`code/extHost/didResolveAuthorityError/${oe}`),ve("returned an error",be),G.dispose(),we(be)}G.dispose();const Ie={environmentTunnels:X.environmentTunnels,features:X.tunnelFeatures},U={extensionHostEnv:X.extensionHostEnv,isTrusted:X.isTrusted,authenticationSession:X.authenticationSessionForInitializingExtensions?{id:X.authenticationSessionForInitializingExtensions.id,providerId:X.authenticationSessionForInitializingExtensions.providerId}:void 0};de(`returned ${t.$QJ.isManagedResolvedAuthority(X)?"managed authority":`${X.host}:${X.port}`}`);let Q;if(t.$QJ.isManagedResolvedAuthority(X)){const _=x;this.R.setFactory(_,X.makeConnection),Q={authority:ne,connectTo:new r.$xk(_),connectionToken:X.connectionToken}}else Q={authority:ne,connectTo:new r.$yk(X.host,X.port),connectionToken:X.connectionToken};return{type:"ok",value:{authority:Q,options:U,tunnelInformation:Ie}}}async $getCanonicalURI(ne,x){this.l.info(`$getCanonicalURI invoked for authority (${(0,r.$Ak)(ne)})`);const{resolver:N}=await this.ob(ne);if(!N)return null;const q=g.URI.revive(x);if(typeof N.getCanonicalURI>"u")return q;const de=await(0,A.$ng)(()=>N.getCanonicalURI(q));return de||q}$startExtensionHost(ne){ne.toAdd.forEach(q=>q.extensionLocation=g.URI.revive(q.extensionLocation));const{globalRegistry:x,myExtensions:N}=fe(this.D,this.G,this.F,ne);return this.G.set(x.getAllExtensionDescriptions()),this.F.set(N),this.nb()}$activateByEvent(ne,x){return x===1?this.w.wait().then(N=>this.U(ne,!1)):this.z.wait().then(N=>this.U(ne,!1))}async $activate(ne,x){return await this.z.wait(),this.F.getExtensionDescription(ne)?(await this.W(ne,x),!0):!1}async $deltaExtensions(ne){ne.toAdd.forEach(ye=>ye.extensionLocation=g.URI.revive(ye.extensionLocation));const{globalRegistry:x,myExtensions:N}=fe(this.D,this.G,this.F,ne),q=await this.Y(N);return(await this.getExtensionPathIndex()).setSearchTree(q),this.G.set(x.getAllExtensionDescriptions()),this.F.set(N),Promise.resolve(void 0)}async $test_latency(ne){return ne}async $test_up(ne){return ne.byteLength}async $test_down(ne){const x=v.$Ec.alloc(ne),N=Math.random()%256;for(let q=0;q<ne;q++)x.writeUInt8(N,q);return x}async $updateRemoteConnectionData(ne){this.Q=ne,this.a.fire()}};e.$7ac=J,e.$7ac=J=Y=Je([Be(0,s.$oh),Be(1,e.$6ac),Be(2,l.$LL),Be(3,E.$zac),Be(4,$.$Cac),Be(5,P.$Ri),Be(6,i.$2L),Be(7,c.$Sac),Be(8,y.$Lrb),Be(9,u.$Uac),Be(10,T.$3ac),Be(11,M.$4ac)],J);function fe(ae,ne,x,N){ae.addActivationEvents(N.addActivationEvents);const q=new o.$P2b(ae,ne.getAllExtensionDescriptions());q.deltaExtensions(N.toAdd,N.toRemove);const de=new m.$Jl(x.getAllExtensionDescriptions().map(ve=>ve.identifier));for(const ve of N.myToRemove)de.delete(ve);for(const ve of N.myToAdd)de.add(ve);const ye=V(q,de);return{globalRegistry:q,myExtensions:ye}}function se(ae,ne){return{id:ae.identifier.value,name:ae.name,extensionVersion:ae.version,publisherDisplayName:ae.publisher,activationEvents:ae.activationEvents?ae.activationEvents.join(","):null,isBuiltin:ae.isBuiltin,reason:ne.activationEvent,reasonId:ne.extensionId.value}}e.$8ac=(0,s.$ph)("IExtHostExtensionService");class ie{#e;#t;#i;constructor(ne,x,N,q,de){this.#e=ne,this.#t=x,this.#i=N.identifier,this.id=N.identifier.value,this.extensionUri=N.extensionLocation,this.extensionPath=F.$6c((0,L.$Wf)(N.extensionLocation)),this.packageJSON=N,this.extensionKind=q,this.isFromDifferentExtensionHost=de}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$9ac=ie;function V(ae,ne){return ae.getAllExtensionDescriptions().filter(x=>ne.has(x.identifier))}class re{constructor(ne){this.a=ne}setSearchTree(ne){this.a=ne}findSubstr(ne){return this.a.findSubstr(ne)}forEach(ne){return this.a.forEach(ne)}}e.$0ac=re;class pe{constructor(ne){this.a=new m.$Kl,this.addActivationEvents(ne)}readActivationEvents(ne){return this.a.get(ne.identifier)}addActivationEvents(ne){for(const x of Object.keys(ne))this.a.set(x,ne[x])}}}),define(Se[339],De([1,0,61,2,5,39,27,25,20,26,6,44,41,17,15]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=void 0;let n=class{constructor(t,r,s,i,c,l,b){this.c=t,this.d=r,this.e=s,this.f=i,this.g=c,this.h=l,this.i=b,this.a=new Map,this.b=[]}async install(){this.j(),S.mark("code/extHost/willWaitForConfig");const t=await this.f.getConfigProvider();S.mark("code/extHost/didWaitForConfig");const r=await this.g.getExtensionPathIndex();this.register(new a(this.c,r,this.d,t,this.i)),this.register(this.e.createInstance(m,r)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(v,r,this.h.environment.appUriScheme))}register(t){if("nodeModuleName"in t)if(Array.isArray(t.nodeModuleName))for(const r of t.nodeModuleName)this.a.set(r,t);else this.a.set(t.nodeModuleName,t);typeof t.alternativeModuleName=="function"&&this.b.push(r=>t.alternativeModuleName(r))}};e.$tcc=n,e.$tcc=n=Je([Be(2,P.$oh),Be(3,L.$Cac),Be(4,I.$8ac),Be(5,g.$2L),Be(6,k.$Ri)],n);let o=class{static{E=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(t){if(t.environment.appRoot&&E.a.size){const r=(0,C.$pd)(this.c(t.environment.appRoot.fsPath)),s="[a-z0-9_.-]",i=`@${s}+\\/${s}+|${s}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${r}/${c}\\/)(${i})(.*)$`,"i")}}alternativeModuleName(t){if(!this.b)return;const r=this.b.exec(this.c(t));if(!r)return;const[,s,i,c]=r,l=E.a.get(i);if(l!==void 0)return console.warn(`${i} as been renamed to ${l}, please update your imports`),s+l+c}c(t){return t.replace(/\\/g,"/")}};o=E=Je([Be(0,g.$2L)],o);class a{constructor(t,r,s,i,c){this.c=t,this.d=r,this.e=s,this.f=i,this.g=c,this.nodeModuleName="vscode",this.a=new f.$Kl}load(t,r){const s=this.d.findSubstr(r);if(s){let i=this.a.get(s.identifier);return i||(i=this.c(s,this.e,this.f),this.a.set(s.identifier,i)),i}if(!this.b){let i="";this.d.forEach((c,l)=>i+=`	${l} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${i}`),this.b=this.c(A.$yF,this.e,this.f)}return this.b}}let m=class{constructor(t,r,s){this.d=t,this.nodeModuleName="keytar",this.a=r.getProxy(h.$JJ.MainThreadTelemetry);const{environment:i}=s,c=r.getProxy(h.$JJ.MainThreadKeytar);if(i.appRoot){let l=i.appRoot.fsPath;$.$2c==="win32"&&(l=l.replace(/\\/g,"/")),l[l.length-1]==="/"&&(l=l.substr(0,l.length-1)),this.b=new Set,this.b.add(`${l}/node_modules.asar/keytar`),this.b.add(`${l}/node_modules/keytar`)}this.c={getPassword:(l,b)=>c.$getPassword(l,b),setPassword:(l,b,y)=>c.$setPassword(l,b,y),deletePassword:(l,b)=>c.$deletePassword(l,b),findPassword:l=>c.$findPassword(l),findCredentials(l){return c.$findCredentials(l)}}}load(t,r){const s=this.d.findSubstr(r);return this.a.$publicLog2("shimming.keytar",{extension:s?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(t){const r=t.length;if(r<=7||!this.b)return;const s=r-7;if((t.charAt(s)==="/"||t.charAt(s)==="\\")&&t.endsWith("keytar")&&(t=t.replace(/\\/g,"/"),this.b.has(t)))return"keytar"}};m=Je([Be(1,w.$LL),Be(2,g.$2L)],m);let v=class{constructor(t,r,s){this.e=t,this.f=r,this.nodeModuleName=["open","opn"],this.d=s.getProxy(h.$JJ.MainThreadTelemetry);const i=s.getProxy(h.$JJ.MainThreadWindow);this.c=(c,l)=>{const b=F.URI.parse(c);return l?this.g(c,l):b.scheme==="http"||b.scheme==="https"?i.$openUri(b,c,{allowTunneling:!0}):b.scheme==="mailto"||b.scheme===this.f?i.$openUri(b,c,{}):this.g(c,l)}}load(t,r,s){const i=this.e.findSubstr(r);return i&&(this.a=i.identifier.value,this.h()),this.b=s(t),this.c}g(t,r){return this.i(),this.b(t,r)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};v=Je([Be(2,w.$LL)],v)}),define(Se[53],De([1,0,55,3,14,41,6,65,66,44,7,38,268,39]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ebc=e.$Dbc=void 0,e.$Dbc=(0,A.$ph)("IExtHostVariableResolverProvider");class C extends $.$MM{constructor(o,a,m,v,D,t,r){function s(){if(m){const i=m.activeEditor();if(i)return i.document.uri;const c=v.tabGroups.all.find(l=>l.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof P.$sL||c.input instanceof P.$xL)return c.input.modified;if(c.input instanceof P.$rL||c.input instanceof P.$wL||c.input instanceof P.$uL)return c.input.uri}}}super({getFolderUri:i=>{const c=t.folders.filter(l=>l.name===i);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(i,c)=>D.getConfiguration(void 0,i).get(c),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const i=s();if(i)return h.$6c(i.fsPath)},getWorkspaceFolderPathForFile:()=>{if(a){const i=s();if(i){const c=a.getWorkspaceFolder(i);if(c)return h.$6c(c.uri.fsPath)}}},getSelectedText:()=>{if(m){const i=m.activeEditor();if(i&&!i.selection.isEmpty)return i.document.getText(i.selection)}},getLineNumber:()=>{if(m){const i=m.activeEditor();if(i)return String(i.selection.end.line+1)}},getExtension:i=>o.getExtension(i)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(L.env))}}let E=class extends F.$lb{constructor(o,a,m,v,D){super(),this.b=o,this.c=a,this.g=m,this.h=v,this.i=D,this.a=new S.$T(async()=>{const t=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async i=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new C(this.b,this.c,this.g,this.i,t,s,this.j())})}getResolver(){return this.a.value}j(){}};e.$Ebc=E,e.$Ebc=E=Je([Be(0,g.$8ac),Be(1,I.$zac),Be(2,f.$WL),Be(3,k.$Cac),Be(4,w.$Bbc)],E)}),define(Se[94],De([1,0,13,4,2,6,5,66,44,20,7,38,138,261,39,53]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=e.$Ibc=e.$Hbc=e.$Gbc=e.$Fbc=void 0,e.$Fbc=(0,L.$ph)("IExtHostDebugService");let n=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,s,i,c,l,b){this.E=s,this.F=i,this.G=c,this.H=l,this.I=b,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new F.$ec,this.n=new F.$ec,this.o=new F.$ec,this.u=new F.$ec,this.k=r.getProxy(A.$JJ.MainThreadDebugService),this.y=new F.$ec,this.A=new F.$ec,this.v=new a(this.k),this.w=new Map,this.F.getExtensionRegistry().then(y=>{y.onDidChange(u=>{this.J(y)}),this.J(y)})}asDebugSourceUri(r,s){const i=r;if(typeof i.sourceReference=="number"&&i.sourceReference>0){let c=`debug:${encodeURIComponent(i.path||"")}`,l="?";return s&&(c+=`${l}session=${encodeURIComponent(s.id)}`,l="&"),c+=`${l}ref=${i.sourceReference}`,h.URI.parse(c)}else{if(i.path)return h.URI.file(i.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const s=[];for(const i of r.getAllExtensionDescriptions())if(i.contributes){const c=i.contributes.debuggers;if(c&&c.length>0)for(const l of c)(0,k.$bF)(l)&&s.push(l.type)}this.k.$registerDebugTypes(s)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(s=>r.push(s)),r}addBreakpoints(r){const s=r.filter(l=>{const b=l.id;return this.w.has(b)?!1:(this.w.set(b,l),!0)});this.U(s,[],[]);const i=[],c=new Map;for(const l of s)if(l instanceof P.$LK){let b=c.get(l.location.uri.toString());b||(b={type:"sourceMulti",uri:l.location.uri,lines:[]},c.set(l.location.uri.toString(),b),i.push(b)),b.lines.push({id:l.id,enabled:l.enabled,condition:l.condition,hitCondition:l.hitCondition,logMessage:l.logMessage,line:l.location.range.start.line,character:l.location.range.start.character})}else l instanceof P.$MK&&i.push({type:"function",id:l.id,enabled:l.enabled,hitCondition:l.hitCondition,logMessage:l.logMessage,condition:l.condition,functionName:l.functionName});return this.k.$registerBreakpoints(i)}removeBreakpoints(r){const s=r.filter(b=>this.w.delete(b.id));this.U([],s,[]);const i=s.filter(b=>b instanceof P.$LK).map(b=>b.id),c=s.filter(b=>b instanceof P.$MK).map(b=>b.id),l=s.filter(b=>b instanceof P.$NK).map(b=>b.id);return this.k.$unregisterBreakpoints(i,c,l)}startDebugging(r,s,i){return this.k.$startDebugging(r?r.uri:void 0,s,{parentSessionID:i.parentSession?i.parentSession.id:void 0,lifecycleManagedByParent:i.lifecycleManagedByParent,repl:i.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:i.noDebug,compact:i.compact,suppressSaveBeforeStart:i.suppressSaveBeforeStart,suppressDebugStatusbar:i.suppressDebugStatusbar??i.debugUI?.simple,suppressDebugToolbar:i.suppressDebugToolbar??i.debugUI?.simple,suppressDebugView:i.suppressDebugView??i.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,s,i){if(!s)return new P.$LJ(()=>{});const c=this.d++;return this.f.push({type:r,handle:c,provider:s}),this.k.$registerDebugConfigurationProvider(r,i,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,c),new P.$LJ(()=>{this.f=this.f.filter(l=>l.provider!==s),this.k.$unregisterDebugConfigurationProvider(c)})}registerDebugAdapterDescriptorFactory(r,s,i){if(!i)return new P.$LJ(()=>{});if(!this.Q(r,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.N(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const c=this.g++;return this.h.push({type:s,handle:c,factory:i}),this.k.$registerDebugAdapterDescriptorFactory(s,c),new P.$LJ(()=>{this.h=this.h.filter(l=>l.factory!==i),this.k.$unregisterDebugAdapterDescriptorFactory(c)})}registerDebugAdapterTrackerFactory(r,s){if(!s)return new P.$LJ(()=>{});const i=this.i++;return this.j.push({type:r,handle:i,factory:s}),new P.$LJ(()=>{this.j=this.j.filter(c=>c.factory!==s)})}async $runInTerminal(r,s){return Promise.resolve(void 0)}async $substituteVariables(r,s){let i;const c=await this.W(r);return c&&(i={uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(i,s)}K(r,s){if(r.type==="implementation")return new v(r.implementation)}L(){}async $startDASession(r,s){const i=this,c=await this.V(s);return this.S(this.N(c.type),c).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}' (extension might have failed to activate)`);const b=this.M(l),y=this.K(b,c);if(!y)throw new Error(`Couldn't create a debug adapter for type '${c.type}'.`);const u=y;return this.B.set(r,u),this.R(c).then(d=>(d&&this.C.set(r,d),u.onMessage(async p=>{if(p.type==="request"&&p.command==="handshake"){const R=p,O={type:"response",seq:0,command:R.command,request_seq:R.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const j=await this.D.sign(R.arguments.value);O.body={signature:j},u.sendResponse(O)}else throw new Error("no signer")}catch(j){O.success=!1,O.message=j.message,u.sendResponse(O)}}else d&&d.onDidSendMessage&&d.onDidSendMessage(p),p=(0,k.$gF)(p,!0),i.k.$acceptDAMessage(r,p)}),u.onError(p=>{d&&d.onError&&d.onError(p),this.k.$acceptDAError(r,p.name,p.message,p.stack)}),u.onExit(p=>{d&&d.onExit&&d.onExit(p??void 0,void 0),this.k.$acceptDAExit(r,p??void 0,void 0)}),d&&d.onWillStartSession&&d.onWillStartSession(),u.startSession()))})}$sendDAMessage(r,s){s=(0,k.$fF)(s,!1);const i=this.C.get(r);i&&i.onWillReceiveMessage&&i.onWillReceiveMessage(s),this.B.get(r)?.sendMessage(s)}$stopDASession(r){const s=this.C.get(r);this.C.delete(r),s&&s.onWillStopSession&&s.onWillStopSession();const i=this.B.get(r);return this.B.delete(r),i?i.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const s=[],i=[],c=[];if(r.added)for(const l of r.added){const b=l.id;if(b&&!this.w.has(b)){let y;if(l.type==="function")y=new P.$MK(l.functionName,l.enabled,l.condition,l.hitCondition,l.logMessage);else if(l.type==="data")y=new P.$NK(l.label,l.dataId,l.canPersist,l.enabled,l.hitCondition,l.condition,l.logMessage);else{const u=h.URI.revive(l.uri);y=new P.$LK(new P.$XJ(u,new P.$MJ(l.line,l.character)),l.enabled,l.condition,l.hitCondition,l.logMessage)}(0,P.$JK)(y,b),this.w.set(b,y),s.push(y)}}if(r.removed)for(const l of r.removed){const b=this.w.get(l);b&&(this.w.delete(l),i.push(b))}if(r.changed){for(const l of r.changed)if(l.id){const b=this.w.get(l.id);if(b){if(b instanceof P.$MK&&l.type==="function"){const y=b;y.enabled=l.enabled,y.condition=l.condition,y.hitCondition=l.hitCondition,y.logMessage=l.logMessage,y.functionName=l.functionName}else if(b instanceof P.$LK&&l.type==="source"){const y=b;y.enabled=l.enabled,y.condition=l.condition,y.hitCondition=l.hitCondition,y.logMessage=l.logMessage,y.location=new P.$XJ(h.URI.revive(l.uri),new P.$MJ(l.line,l.character))}c.push(b)}}}this.U(s,i,c)}async $acceptStackFrameFocus(r){let s;const i=r.sessionId?await this.V(r.sessionId):void 0;if(!i)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?s=new P.$TK(i,r.threadId):s=new P.$SK(i,r.threadId,r.frameId),this.z=s,this.A.fire(this.z)}$provideDebugConfigurations(r,s,i){return(0,S.$ng)(async()=>{const c=this.P(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const l=await this.W(s);return c.provideDebugConfigurations(l,i)}).then(c=>{if(!c)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return c})}$resolveDebugConfiguration(r,s,i,c){return(0,S.$ng)(async()=>{const l=this.P(r);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const b=await this.W(s);return l.resolveDebugConfiguration(b,i,c)})}$resolveDebugConfigurationWithSubstitutedVariables(r,s,i,c){return(0,S.$ng)(async()=>{const l=this.P(r);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const b=await this.W(s);return l.resolveDebugConfigurationWithSubstitutedVariables(b,i,c)})}async $provideDebugAdapter(r,s){const i=this.O(r);if(!i)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const c=await this.V(s);return this.S(i,c).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}'`);return this.M(l)})}async $acceptDebugSessionStarted(r){const s=await this.V(r);this.m.fire(s)}async $acceptDebugSessionTerminated(r){const s=await this.V(r);s&&(this.n.fire(s),this.l.delete(s.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,s){(await this.V(r))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(r,s){const c={session:await this.V(r),event:s.event,body:s.body};this.u.fire(c)}M(r){if(r instanceof P.$OK)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof P.$PK)return{type:"server",port:r.port,host:r.host};if(r instanceof P.$QK)return{type:"pipeServer",path:r.path};if(r instanceof P.$RK)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const s=this.h.filter(i=>i.type===r);if(s.length>0)return s[0].factory}O(r){const s=this.h.filter(i=>i.handle===r);if(s.length>0)return s[0].factory}P(r){const s=this.f.filter(i=>i.handle===r);if(s.length>0)return s[0].provider}Q(r,s){if(r.contributes){const i=r.contributes.debuggers;if(i&&i.length>0){for(const c of i)if(c.label&&c.type&&c.type===s)return!0}}return!1}R(r){const i=r.configuration.type,c=this.j.filter(l=>l.type===i||l.type==="*").map(l=>(0,S.$ng)(()=>l.factory.createDebugAdapterTracker(r)).then(b=>b,b=>null));return Promise.race([Promise.all(c).then(l=>{const b=l.filter(y=>!!y);if(b.length>0)return new m(b)}),new Promise(l=>setTimeout(()=>l(void 0),1e3))]).catch(l=>{})}async S(r,s){const i=s.configuration.debugServer;if(typeof i=="number")return Promise.resolve(new P.$PK(i));if(r){const l=await this.F.getExtensionRegistry();return(0,S.$ng)(()=>r.createDebugAdapterDescriptor(s,this.T(s,l))).then(b=>{if(b)return b})}const c=await this.F.getExtensionRegistry();return Promise.resolve(this.T(s,c))}T(r,s){}U(r,s,i){(r.length>0||s.length>0||i.length>0)&&this.y.fire(Object.freeze({added:r,removed:s,changed:i}))}async V(r){if(r)if(typeof r=="string"){const s=this.l.get(r);if(s)return s}else{let s=this.l.get(r.id);if(!s){const i=await this.W(r.folderUri),c=r.parent?this.l.get(r.parent):void 0;s=new o(this.k,r.id,r.type,r.name,i,r.configuration,c),this.l.set(s.id,s),this.k.$sessionCached(s.id)}return s}throw new Error("cannot find session")}W(r){if(r){const s=h.URI.revive(r);return this.E.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.$Gbc=n,e.$Gbc=n=Je([Be(0,g.$LL),Be(1,I.$zac),Be(2,w.$8ac),Be(3,C.$Cac),Be(4,f.$Bbc),Be(5,E.$Dbc)],n);class o{constructor(r,s,i,c,l,b,y){this.d=r,this.f=s,this.g=i,this.h=c,this.i=l,this.j=b,this.k=y}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,s){return this.d.$customDebugAdapterRequest(this.f,r,s)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$Hbc=o;class a{constructor(r){this.value=Object.freeze({append(s){r.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.$Ibc=a;class m{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(s=>s.onError?s.onError(r):void 0)}onExit(r,s){this.d.forEach(i=>i.onExit?i.onExit(r,s):void 0)}}class v extends $.$4bb{constructor(r){super(),this.h=r,r.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let D=class extends n{constructor(r,s,i,c,l,b){super(r,s,i,c,l,b)}};e.$Jbc=D,e.$Jbc=D=Je([Be(0,g.$LL),Be(1,I.$zac),Be(2,w.$8ac),Be(3,C.$Cac),Be(4,f.$Bbc),Be(5,E.$Dbc)],D)}),define(Se[340],De([1,0,8,61,2,5,332,17,102,103,26,231,20,62,44,88]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=e.$ucc=void 0;class n{static async installEarlyHandler(m){Error.stackTraceLimit=100;const v=m.get(f.$Ri),t=m.get($.$LL).getProxy(L.$JJ.MainThreadErrors);S.setUnexpectedErrorHandler(r=>{v.error(r);const s=S.$1(r);t.$onUnexpectedError(s)})}static async installFullHandler(m){const v=m.get(f.$Ri),D=m.get($.$LL),t=m.get(C.$8ac),r=m.get(E.$6L),s=D.getProxy(L.$JJ.MainThreadExtensionService),i=D.getProxy(L.$JJ.MainThreadErrors),c=await t.getExtensionPathIndex(),l=new WeakMap;function b(d,p){if(l.has(d))return l.get(d).stack;let R="",O,j;for(const z of p)R+=`
	at ${z.toString()}`,j=z.getFileName(),!O&&j&&(O=c.findSubstr(h.URI.file(j)));const T=`${d.name||"Error"}: ${d.message||""}${R}`;return l.set(d,{extensionIdentifier:O?.identifier,stack:T}),T}const y=Symbol("prepareStackTrace wrapped");let u=b;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return u},set(d){if(d===b||!d||d[y]){u=d||b;return}u=function(p,R){return b(p,R),d.call(Error,p,R)},Object.assign(u,{[y]:!0})}}),S.setUnexpectedErrorHandler(d=>{v.error(d);const p=S.$1(d),R=l.get(d);if(!R?.extensionIdentifier){i.$onUnexpectedError(p);return}s.$onExtensionRuntimeError(R.extensionIdentifier,p);const O=r.onExtensionError(R.extensionIdentifier,d);v.trace("forwarded error to extension?",O,R)})}}e.$ucc=n;class o{constructor(m,v,D,t,r){this.a=D,this.b=new A.$X2b(m,null,t),v=o.e(v,this.b);const s=new g.$nh(...(0,w.$er)());s.set(P.$2L,{_serviceBrand:void 0,...v,messagePorts:r}),s.set($.$LL,new $.$ML(this.b)),s.set(k.$wac,new k.$xac(t)),s.set(C.$6ac,D);const i=new I.$Wp(s,!0);i.invokeFunction(n.installEarlyHandler),this.d=i.invokeFunction(c=>c.get(f.$Ri)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",v),this.c=i.invokeFunction(c=>c.get(C.$8ac)),this.c.initialize(),i.invokeFunction(n.installFullHandler)}async asBrowserUri(m){const v=this.b.getProxy(L.$JJ.MainThreadExtensionService);return h.URI.revive(await v.$asBrowserUri(m))}terminate(m){this.c.terminate(m)}static e(m,v){m.allExtensions.forEach(t=>{t.extensionLocation=h.URI.revive(v.transformIncomingURIs(t.extensionLocation))}),m.environment.appRoot=h.URI.revive(v.transformIncomingURIs(m.environment.appRoot));const D=m.environment.extensionDevelopmentLocationURI;return D&&(m.environment.extensionDevelopmentLocationURI=D.map(t=>h.URI.revive(v.transformIncomingURIs(t)))),m.environment.extensionTestsLocationURI=h.URI.revive(v.transformIncomingURIs(m.environment.extensionTestsLocationURI)),m.environment.globalStorageHome=h.URI.revive(v.transformIncomingURIs(m.environment.globalStorageHome)),m.environment.workspaceStorageHome=h.URI.revive(v.transformIncomingURIs(m.environment.workspaceStorageHome)),m.environment.extensionTelemetryLogResource=h.URI.revive(v.transformIncomingURIs(m.environment.extensionTelemetryLogResource)),m.nlsBaseUrl=h.URI.revive(v.transformIncomingURIs(m.nlsBaseUrl)),m.logsLocation=h.URI.revive(v.transformIncomingURIs(m.logsLocation)),m.workspace=v.transformIncomingURIs(m.workspace),m}}e.$vcc=o}),define(Se[341],De([1,0,13,9,209,225,136,94,66,44,20,43,7,53,38,262,263,39]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=void 0;let a=class extends f.$Gbc{constructor(r,s,i,c,l,b,y){super(r,s,i,c,b,y),this.Z=l,this.X=new D}K(r,s){switch(r.type){case"server":return new E.$Acc(r);case"pipeServer":return new E.$Bcc(r);case"executable":return new E.$Ccc(r,s.type)}return super.K(r,s)}T(r,s){const i=E.$Ccc.platformAdapterExecutable(s.getAllExtensionDescriptions(),r.type);if(i)return new $.$OK(i.command,i.args,i.options)}L(){return new A.$A6b}async $runInTerminal(r,s){if(r.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(T=>{this.X.onTerminalClosed(T)}));const i=await this.G.getConfigProvider(),c=this.Z.getDefaultShell(!0),l=this.Z.getDefaultShellArgs(!0),b=r.title||h.localize(0,null),y=JSON.stringify({shell:c,shellArgs:l});let u=await this.X.checkout(y,b),d,p=!1;if(u)d=r.cwd;else{const T={shellPath:c,shellArgs:l,cwd:r.cwd,name:b,iconPath:new $.$GK("debug")};p=!0,u=this.Z.createTerminalFromOptions(T,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(u,y)}u.show(!0);const R=await u.processId;p?await new Promise(T=>setTimeout(T,1e3)):i.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0||c.indexOf("cmd.exe")>=0?u.sendText("cls"):c.indexOf("bash")>=0?u.sendText("clear"):F.$i?u.sendText("cls"):u.sendText("clear"));const O=(0,n.$Ecc)(c,r.args,!!r.argsCanBeInterpretedByShell,d,r.env);u.sendText(O);const j=this.onDidTerminateDebugSession(T=>{T.id===s&&(this.X.free(u),j.dispose())});return R}else if(r.kind==="external")return v(r,await this.G.getConfigProvider());return super.$runInTerminal(r,s)}};e.$Fcc=a,e.$Fcc=a=Je([Be(0,P.$LL),Be(1,C.$zac),Be(2,g.$8ac),Be(3,o.$Cac),Be(4,I.$Uac),Be(5,w.$Bbc),Be(6,k.$Dbc)],a);let m;function v(t,r){if(!m)if(F.$i)m=new L.$i5b;else if(F.$j)m=new L.$j5b;else if(F.$k)m=new L.$k5b;else throw new Error("external terminals not supported on this platform");const s=r.getConfiguration("terminal");return m.runInTerminal(t.title,t.cwd,t.args,t.env||{},s.external||{})}class D{constructor(){this.b=new Map}static{this.a=1e3}async checkout(r,s){const c=[...this.b.entries()].map(([l,b])=>(0,S.$ig)(async y=>{if(l.name!==s||b.lastUsedAt!==-1&&await(0,n.$Dcc)(await l.processId))return null;const u=Date.now();return b.lastUsedAt+D.a>u||y.isCancellationRequested||b.config!==r?null:(b.lastUsedAt=u,l)}));return await(0,S.$zg)(c,l=>!!l)}insert(r,s){this.b.set(r,{lastUsedAt:Date.now(),config:s})}free(r){const s=this.b.get(r);s&&(s.lastUsedAt=-1)}onTerminalClosed(r){this.b.delete(r)}}}),define(Se[342],De([1,0,14,2,100,38,65,39,51,43,20,26,93,16,17,89,24,59,53]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E,n,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=void 0;let m=class extends $.$ybc{constructor(D,t,r,s,i,c,l,b,y){super(D,t,r,s,i,c,l,b),this.B=r,this.C=y,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(k.Schemas.vscodeRemote,{scheme:k.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(k.Schemas.file,{scheme:k.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(D,t){const r=t;if(!t.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const s=$.TaskHandleDTO.from(r,this.B),i=await this.a.$getTaskExecution(s);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.y(i,t);return this.a.$executeTask(s).catch(()=>{}),c}else{const s=$.TaskDTO.from(t,D);if(s===void 0)return Promise.reject(new Error("Task is not valid"));$.CustomExecutionDTO.is(s.execution)&&await this.x(s,t,!1);const i=await this.y(await this.a.$getTaskExecution(s),t);return this.a.$executeTask(s).catch(()=>{}),i}}u(D,t,r,s){const i=[];if(s)for(const c of s){this.z(c,r),(!c.definition||!D[c.definition.type])&&this.f.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const l=$.TaskDTO.from(c,r.extension);l&&(i.push(l),$.CustomExecutionDTO.is(l.execution)&&t.push(this.x(l,c,!0)))}return{tasks:i,extension:r.extension}}async v(D){return D}async F(D){let t=D&&D.length>0?D[0]:void 0;if(!t){const r=F.URI.file((0,o.homedir)());t=new w.$Jh({uri:r,name:n.$6f(r),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(D,t){const r=F.URI.revive(D),s={process:void 0,variables:Object.create(null)},i=await this.b.resolveWorkspaceFolder(r),c=await this.b.getWorkspaceFolders2()??[],l=await this.C.getResolver(),b=i?{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(c);for(const y of t.variables)s.variables[y]=await l.resolveAsync(b,y);if(t.process!==void 0){let y;if(t.process.path!==void 0){y=t.process.path.split(S.$fd);for(let u=0;u<y.length;u++)y[u]=await l.resolveAsync(b,y[u])}s.process=await h.win32.findExecutable(await l.resolveAsync(b,t.process.name),t.process.cwd!==void 0?await l.resolveAsync(b,t.process.cwd):void 0,y)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(D,t,r){return h.win32.findExecutable(D,t,r)}};e.$xcc=m,e.$xcc=m=Je([Be(0,P.$LL),Be(1,I.$2L),Be(2,L.$zac),Be(3,A.$WL),Be(4,f.$Cac),Be(5,g.$Uac),Be(6,C.$Ri),Be(7,E.$pac),Be(8,a.$Dbc)],m)}),define(Se[343],De([1,0,59,53]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ddc=void 0;class h extends F.$Ebc{j(){return(0,S.homedir)()}}e.$ddc=h}),define(Se[150],De([1,0,18,13,22,45,16,14,24,2,36]),function(me,e,S,F,h,L,A,f,w,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=e.$Nbc=e.$Mbc=e.$Lbc=void 0;class I{constructor(a,m,v,D){this.d=a,this.e=m,this.f=v,this.g=D,this.a=null,this.b=!1,this.c=0}search(a,m){const v=this.d.folderQueries||[],D=new h.$oc;return m.onCancellationRequested(()=>D.cancel()),new Promise((t,r)=>{this.a=new k(a);let s=!1;const i=(c,l)=>{if(!s&&!this.b){const b=this.h(c);E(c)&&typeof this.d.maxResults=="number"&&this.c+b>this.d.maxResults&&(this.b=!0,s=!0,D.cancel(),c=this.j(c,this.d.maxResults-this.c));const y=this.h(c);this.c+=y,(y>0||!E(c))&&this.a.add(c,l)}};Promise.all(v.map((c,l)=>this.k(c,b=>i(b,l),D.token))).then(c=>{D.dispose(),this.a.flush();const l=c.some(b=>!!b&&!!b.limitHit);t({limitHit:this.b||l,messages:(0,S.$vf)(c.map(b=>b?.message?Array.isArray(b.message)?b.message:[b.message]:[])),stats:{type:this.g}})},c=>{D.dispose();const l=(0,L.$ai)(c);r(new Error(l))})})}h(a){return E(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}j(a,m){const v=Array.isArray(a.ranges)?a.ranges:[a.ranges],D=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:v.slice(0,m),preview:{matches:D.slice(0,m),text:a.preview.text},uri:a.uri}}async k(a,m,v){const D=new P.$oI(this.d,a),t=[],r={report:c=>{if(!this.l(c))return;const l=a.folder.scheme===A.Schemas.file?(0,P.$pI)(()=>this.f.readdir(w.$8f(c.uri))):void 0,b=w.$$f(a.folder,c.uri);if(b){const y=D.includedInQuery(b,f.$_c(b),l);(0,F.$hg)(y)?t.push(y.then(u=>{u&&m(c)})):y&&m(c)}}},s=this.n(a),i=await this.e.provideTextSearchResults($(this.d.contentPattern),s,r,v);return t.length&&await Promise.all(t),i}l(a){if(E(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(a){const m=(0,P.$nI)(this.d.includePattern,a.includePattern),v=(0,P.$nI)(this.d.excludePattern,a.excludePattern),D={folder:g.URI.from(a.folder),excludes:v,includes:m,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.f.toCanonicalName(a.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return D.usePCRE2=this.d.usePCRE2,D}}e.$Lbc=I;function $(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class k{constructor(a){this.e=a,this.b=-1,this.d=null,this.a=new n(512,m=>this.g(m))}add(a,m){this.d&&(this.b!==m||!w.$2f(this.c,a.uri))&&(this.f(),this.d=null),this.d||(this.b=m,this.d={resource:a.uri,results:[]}),this.d.results.push(C(a))}f(){const a=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,a)}flush(){this.f(),this.a.flush()}g(a){this.e(a)}}e.$Mbc=k;function C(o){return E(o)?{preview:{matches:(0,S.$Ff)(o.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:o.preview.text},ranges:(0,S.$Ff)(o.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function E(o){return!!o.preview}e.$Nbc=E;class n{static{this.a=4e3}static{this.b=50}constructor(a,m){this.g=a,this.h=m,this.c=0,this.d=[],this.e=0}addItem(a,m){a&&this.j(a,m)}addItems(a,m){a&&this.k(a,m)}j(a,m){this.d.push(a),this.e+=m,this.l()}k(a,m){this.d=this.d.concat(a),this.e+=m,this.l()}l(){this.c<n.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},n.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Obc=n}),define(Se[95],De([1,0,3,5,6,336,20,62,17,2,150]),function(me,e,S,F,h,L,A,f,w,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rbc=e.$Qbc=e.$Pbc=void 0,e.$Pbc=(0,h.$ph)("IExtHostSearch");let I=class{constructor(E,n,o){this.k=E,this.l=n,this.n=o,this.c=this.k.getProxy(F.$JJ.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$Kbc}o(E){return this.l.transformOutgoingScheme(E)}registerTextSearchProvider(E,n){if(this.g.has(E))throw new Error(`a text search provider for the scheme '${E}' is already registered`);this.g.add(E);const o=this.d++;return this.e.set(o,n),this.c.$registerTextSearchProvider(o,this.o(E)),(0,S.$jb)(()=>{this.g.delete(E),this.e.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(E,n){if(this.i.has(E))throw new Error(`a file search provider for the scheme '${E}' is already registered`);this.i.add(E);const o=this.d++;return this.h.set(o,n),this.c.$registerFileSearchProvider(o,this.o(E)),(0,S.$jb)(()=>{this.i.delete(E),this.h.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(E,n,o,a){const m=$(o),v=this.h.get(E);if(v)return this.j.fileSearch(m,v,D=>{this.c.$handleFileMatch(E,n,D.map(t=>t.resource))},a);throw new Error("unknown provider: "+E)}$clearCache(E){return this.j.clearCache(E),Promise.resolve(void 0)}$provideTextSearchResults(E,n,o,a){const m=this.e.get(E);if(!m||!m.provideTextSearchResults)throw new Error(`Unknown provider ${E}`);const v=$(o);return this.q(v,m).search(t=>this.c.$handleTextMatch(E,n,t),a)}$enableExtensionHostSearch(){}q(E,n){return new P.$Lbc(E,n,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};e.$Qbc=I,e.$Qbc=I=Je([Be(0,A.$LL),Be(1,f.$wac),Be(2,w.$Ri)],I);function $(C){return{...C,folderQueries:C.folderQueries&&C.folderQueries.map(k),extraFileResources:C.extraFileResources&&C.extraFileResources.map(E=>g.URI.revive(E))}}e.$Rbc=$;function k(C){return{...C,folder:g.URI.revive(C.folder)}}}),define(Se[344],De([1,0,22,8,4,40,2,129,123,165,181,30,5,110,292,291,33,293,39,295,296,297,270,298,65,44,300,301,306,307,308,149,274,314,315,317,114,43,319,278,10,7,85,322,91,148,38,25,266,305,60,146,93,94,95,17,62,20,26,309,264,68,89,285,320,90,67,325,323,324,286,52,318,321,113,66,88,310,92,311,16,132,273,253,303,3,27,260,111,249,312,313,287,302,272,304,112,316,288,289,290,284,299]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E,n,o,a,m,v,D,t,r,s,i,c,l,b,y,u,d,p,R,O,j,T,z,B,M,Y,J,fe,se,ie,V,re,pe,ae,ne,x,N,q,de,ye,ve,we,Ee,K,ee,G,X,he,Ie,U,Q,_,oe,Z,le,be,ze,qe,_e,Ze,it,et,Pe,Oe,We,Re,Qe,ue,ce,Ce,Ve,je,Xe,rt,ot,$t,Ct,Qt,qt,vt,Mt,Nt,Jt,Lt,Rt,zt,Ut,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=void 0;function Bt(ct){const ht=ct.get(K.$2L),Ht=ct.get(ze.$mac),At=ct.get(_.$Rac),kt=ct.get(i.$8ac),ft=ct.get(re.$zac),It=ct.get(et.$6L),Ot=ct.get(a.$Cac),yt=ct.get(we.$wac),He=ct.get(Ee.$LL),Fe=ct.get(T.$Nac),Te=ct.get(Q.$Sac),Ae=ct.get(ve.$Si),te=ct.get(ve.$Ri),Me=ct.get(X.$Lrb),Ke=ct.get(he.$pac),xe=ct.get(V.$tbc),Ge=ct.get(Ze.$Zac),nt=ct.get(it.$Bbc),bt=ct.get(Nt.$4ac);He.set($.$KJ.ExtHostFileSystemInfo,Ht),He.set($.$KJ.ExtHostLogLevelServiceShape,Ae),He.set($.$KJ.ExtHostWorkspace,ft),He.set($.$KJ.ExtHostConfiguration,Ot),He.set($.$KJ.ExtHostExtensionService,kt),He.set($.$KJ.ExtHostStorage,Fe),He.set($.$KJ.ExtHostTunnelService,Me),He.set($.$KJ.ExtHostWindow,xe),He.set($.$KJ.ExtHostSecretState,Ge),He.set($.$KJ.ExtHostTelemetry,It),He.set($.$KJ.ExtHostEditorTabs,nt),He.set($.$KJ.ExtHostManagedSockets,bt);const Et=He.set($.$KJ.ExtHostDecorations,ct.get(N.$xbc)),pt=He.set($.$KJ.ExtHostDocumentsAndEditors,ct.get(s.$WL)),ut=He.set($.$KJ.ExtHostCommands,ct.get(n.$8L)),gt=He.set($.$KJ.ExtHostTerminalService,ct.get(z.$Uac)),St=He.set($.$KJ.ExtHostDebugService,ct.get(de.$Fbc)),mi=He.set($.$KJ.ExtHostSearch,ct.get(ye.$Pbc)),Kt=He.set($.$KJ.ExtHostTask,ct.get(q.$Abc)),Ei=He.set($.$KJ.ExtHostOutputService,ct.get(d.$dbc)),Wt=He.set($.$KJ.ExtHostLocalization,ct.get(rt.$3ac)),gi=He.set($.$KJ.ExtHostUrls,new se.$mbc(He)),Pt=He.set($.$KJ.ExtHostDocuments,new r.$kac(He,pt)),ki=He.set($.$KJ.ExtHostDocumentContentProviders,new D.$Eac(He,pt,te)),qi=He.set($.$KJ.ExtHostDocumentSaveParticipant,new t.$Fac(te,Pt,He.getProxy($.$JJ.MainThreadBulkEdits))),Dt=He.set($.$KJ.ExtHostNotebook,new ee.$Vbc(He,ut,pt,Pt,At)),ti=He.set($.$KJ.ExtHostNotebookDocuments,new ce.$bcc(Dt)),$i=He.set($.$KJ.ExtHostNotebookEditors,new ue.$acc(te,Dt)),si=He.set($.$KJ.ExtHostNotebookKernels,new Pe.$0bc(He,ht,Dt,ut,te)),Si=He.set($.$KJ.ExtHostNotebookRenderers,new We.$_bc(He,Dt)),Di=He.set($.$KJ.ExtHostNotebookDocumentSaveParticipant,new vt.$hcc(te,Dt,He.getProxy($.$JJ.MainThreadBulkEdits))),Ft=He.set($.$KJ.ExtHostEditors,new B.$kbc(He,pt)),bi=He.set($.$KJ.ExtHostTreeViews,new M.$lbc(He.getProxy($.$JJ.MainThreadTreeViews),ut,te)),Ci=He.set($.$KJ.ExtHostEditorInsets,new ae.$ubc(He.getProxy($.$JJ.MainThreadEditorInsets),Ft,ht.remote)),oi=He.set($.$KJ.ExtHostDiagnostics,new m.$oac(He,te,Ht,pt)),ai=He.set($.$KJ.ExtHostLanguages,new y.$abc(He,Pt,ut.converter,yt)),lt=He.set($.$KJ.ExtHostLanguageFeatures,new b.$sac(He,yt,Pt,ut,oi,te,Ke,It)),Vi=He.set($.$KJ.ExtHostFileSystem,new c.$$ac(He,lt)),Zt=He.set($.$KJ.ExtHostFileSystemEventService,new l.$_ac(He,te,pt)),ii=He.set($.$KJ.ExtHostQuickOpen,(0,R.$fbc)(He,ft,ut)),pi=He.set($.$KJ.ExtHostSCM,new O.$hbc(He,ut,Pt,te)),Ii=He.set($.$KJ.ExtHostQuickDiff,new Ct.$ecc(He,yt)),Ki=He.set($.$KJ.ExtHostShare,new Jt.$jcc(He,yt)),Pi=He.set($.$KJ.ExtHostComments,(0,o.$vac)(He,ut,Pt)),vi=He.set($.$KJ.ExtHostProgress,new p.$ebc(He.getProxy($.$JJ.MainThreadProgress))),Ji=He.set($.$KJ.ExtHosLabelService,new ne.$vbc(He)),Ai=He.set($.$KJ.ExtHostTheming,new G.$Wbc(He)),ci=He.set($.$KJ.ExtHostAuthentication,new Ie.$Xbc(He)),Hi=He.set($.$KJ.ExtHostTimeline,new U.$Zbc(He,ut)),wi=He.set($.$KJ.ExtHostWebviews,new ie.$pbc(He,ht.remote,ft,te,Ke)),Li=He.set($.$KJ.ExtHostWebviewPanels,new le.$2bc(He,wi,ft)),cn=He.set($.$KJ.ExtHostCustomEditors,new Z.$3bc(He,Pt,Te,wi,Li)),Ri=He.set($.$KJ.ExtHostWebviewViews,new oe.$1bc(He,wi)),ni=He.set($.$KJ.ExtHostTesting,new qe.$5bc(He,ut,pt)),un=He.set($.$KJ.ExtHostUriOpeners,new _e.$9bc(He)),ln=He.set($.$KJ.ExtHostProfileContentHandlers,new $t.$dcc(He));He.set($.$KJ.ExtHostInteractive,new Ce.$ccc(He,Dt,pt,ut,te));const Gi=He.set($.$KJ.ExtHostInlineChat,new qt.$gcc(He,ut,Pt,te)),fi=He.set($.$KJ.ExtHostChatProvider,new Lt.$kcc(He,te)),Yi=He.set($.$KJ.ExtHostChatSlashCommands,new Rt.$lcc(He,fi,te)),Qi=He.set($.$KJ.ExtHostChatVariables,new zt.$mcc(He)),ui=He.set($.$KJ.ExtHostChat,new Qt.$fcc(He,te)),Zi=He.set($.$KJ.ExtHostAiRelatedInformation,new Ut.$ncc(He)),Fi=He.set($.$KJ.ExtHostAiEmbeddingVector,new Vt.$occ(He)),Xi=He.set($.$KJ.ExtHostIssueReporter,new Mt.$icc(He)),Xt=He.set($.$KJ.ExtHostStatusBar,new j.$jbc(He,ut.converter)),yi=Object.values($.$KJ);He.assertRegistered(yi);const hn=new be.$4bc(He,pt),Gt=new E.$uac(He),li=new u.$bbc(He,te),Ti=new v.$Dac(He);return C.$tac.register(ut),function(Ue,xt,Mi){const mt=function(){let ge=!Ue.isUnderDevelopment;function ke(){ge||(te.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Ne(st){if(Array.isArray(st))st.forEach(Ne);else if(typeof st=="string")ke();else{const wt=st;typeof wt.scheme>"u"&&ke(),typeof wt.exclusive=="boolean"&&(0,je.$EF)(Ue,"documentFiltersExclusive")}return st}}(),xi={getSession(ge,ke,Ne){return ci.getSession(Ue,ge,ke,Ne)},getSessions(ge,ke){return(0,je.$EF)(Ue,"authGetSessions"),ci.getSessions(Ue,ge,ke)},async hasSession(ge,ke){return(0,je.$EF)(Ue,"authSession"),!!await ci.getSession(Ue,ge,ke,{silent:!0})},get onDidChangeSessions(){return ci.onDidChangeSessions},registerAuthenticationProvider(ge,ke,Ne,st){return ci.registerAuthenticationProvider(ge,ke,Ne,st)}},_i={registerCommand(ge,ke,Ne){return ut.registerCommand(!0,ge,ke,Ne,void 0,Ue)},registerTextEditorCommand(ge,ke,Ne){return ut.registerCommand(!0,ge,(...st)=>{const wt=Ft.getActiveTextEditor();if(!wt){te.warn("Cannot execute "+ge+" because there is no active text editor.");return}return wt.edit(Tt=>{ke.apply(Ne,[wt,Tt,...st])}).then(Tt=>{Tt||te.warn("Edits from command "+ge+" were not applied.")},Tt=>{te.warn("An error occurred while running command "+ge,Tt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ge,ke,Ne)=>((0,je.$EF)(Ue,"diffCommand"),ut.registerCommand(!0,ge,async(...st)=>{const wt=pt.activeEditor(!0);if(!wt){te.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Tt=await Ft.getDiffInformation(wt.id);ke.apply(Ne,[Tt,...st])},void 0,void 0,Ue)),executeCommand(ge,...ke){return ut.executeCommand(ge,...ke)},getCommands(ge=!1){return ut.getCommands(ge)}},en={get machineId(){return ht.telemetryInfo.machineId},get sessionId(){return ht.telemetryInfo.sessionId},get language(){return ht.environment.appLanguage},get appName(){return ht.environment.appName},get appRoot(){return ht.environment.appRoot?.fsPath??""},get appHost(){return ht.environment.appHost},get uriScheme(){return ht.environment.appUriScheme},get clipboard(){return Gt.value},get shell(){return gt.getDefaultShell(!1)},get onDidChangeShell(){return(0,je.$EF)(Ue,"envShellEvent"),gt.onDidChangeShell},get isTelemetryEnabled(){return It.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return It.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,je.$EF)(Ue,"telemetry"),It.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,je.$EF)(Ue,"telemetry"),It.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.$5L)(ht.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge,ke){return et.$4L.validateSender(ge),It.instantiateLogger(Ue,ge,ke)},openExternal(ge,ke){return xe.openUri(ge,{allowTunneling:!!ht.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===ht.environment.appUriScheme)return gi.createAppUri(ge);try{return await xe.asExternalUri(ge,{allowTunneling:!!ht.remote.authority})}catch(ke){if((0,Qe.$rT)(ge,Re.Schemas.http)||(0,Qe.$rT)(ge,Re.Schemas.https))return ge;throw ke}},get remoteName(){return(0,x.$Ck)(ht.remote.authority)},get remoteAuthority(){return(0,je.$EF)(Ue,"resolvers"),ht.remote.authority},get uiKind(){return ht.uiKind},get logLevel(){return te.getLevel()},get onDidChangeLogLevel(){return te.onDidChangeLogLevel},registerIssueUriRequestHandler(ge){return(0,je.$EF)(Ue,"handleIssueUri"),Xi.registerIssueUriRequestHandler(Ue,ge)},get appQuality(){return(0,je.$EF)(Ue,"resolvers"),ht.quality},get appCommit(){return(0,je.$EF)(Ue,"resolvers"),ht.commit}};ht.environment.extensionTestsLocationURI||Object.freeze(en);const dn={createTestController(ge,ke,Ne){return ni.createTestController(Ue,ge,ke,Ne)},createTestObserver(){return(0,je.$EF)(Ue,"testObserver"),ni.createTestObserver()},runTests(ge){return(0,je.$EF)(Ue,"testObserver"),ni.runTests(ge)},get onDidChangeTestResults(){return(0,je.$EF)(Ue,"testObserver"),ni.onResultsChanged},get testResults(){return(0,je.$EF)(Ue,"testObserver"),ni.results}},hi=ht.remote.isRemote?J.ExtensionKind.Workspace:J.ExtensionKind.UI,tn={getExtension(ge,ke){(0,je.$DF)(Ue,"extensionsAny")||(ke=!1);const Ne=xt.mine.getExtensionDescription(ge);if(Ne)return new i.$9ac(kt,Ue.identifier,Ne,hi,!1);if(ke){const st=xt.all.getExtensionDescription(ge);if(st)return new i.$9ac(kt,Ue.identifier,st,hi,!0)}},get all(){const ge=[];for(const ke of xt.mine.getAllExtensionDescriptions())ge.push(new i.$9ac(kt,Ue.identifier,ke,hi,!1));return ge},get allAcrossExtensionHosts(){(0,je.$EF)(Ue,"extensionsAny");const ge=new pe.$Jl(xt.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),ke=[];for(const Ne of xt.all.getAllExtensionDescriptions()){const st=!ge.has(Ne.identifier);ke.push(new i.$9ac(kt,Ue.identifier,Ne,hi,st))}return ke},get onDidChange(){return(0,je.$DF)(Ue,"extensionsAny")?h.Event.any(xt.mine.onDidChange,xt.all.onDidChange):xt.mine.onDidChange}},nn={createDiagnosticCollection(ge){return oi.createDiagnosticCollection(Ue.identifier,ge)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:ge=>oi.getDiagnostics(ge),getLanguages(){return ai.getLanguages()},setTextDocumentLanguage(ge,ke){return ai.changeLanguage(ge.uri,ke)},match(ge,ke){const Ne=Pt.getDocumentData(ke.uri)?.notebook;return(0,P.$4E)(Y.LanguageSelector.from(ge),ke.uri,ke.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(ge,ke,Ne){return lt.registerCodeActionProvider(Ue,mt(ge),ke,Ne)},registerDocumentPasteEditProvider(ge,ke,Ne){return(0,je.$EF)(Ue,"documentPaste"),lt.registerDocumentPasteEditProvider(Ue,mt(ge),ke,Ne)},registerCodeLensProvider(ge,ke){return lt.registerCodeLensProvider(Ue,mt(ge),ke)},registerDefinitionProvider(ge,ke){return lt.registerDefinitionProvider(Ue,mt(ge),ke)},registerDeclarationProvider(ge,ke){return lt.registerDeclarationProvider(Ue,mt(ge),ke)},registerImplementationProvider(ge,ke){return lt.registerImplementationProvider(Ue,mt(ge),ke)},registerTypeDefinitionProvider(ge,ke){return lt.registerTypeDefinitionProvider(Ue,mt(ge),ke)},registerHoverProvider(ge,ke){return lt.registerHoverProvider(Ue,mt(ge),ke,Ue.identifier)},registerEvaluatableExpressionProvider(ge,ke){return lt.registerEvaluatableExpressionProvider(Ue,mt(ge),ke,Ue.identifier)},registerInlineValuesProvider(ge,ke){return lt.registerInlineValuesProvider(Ue,mt(ge),ke,Ue.identifier)},registerDocumentHighlightProvider(ge,ke){return lt.registerDocumentHighlightProvider(Ue,mt(ge),ke)},registerLinkedEditingRangeProvider(ge,ke){return lt.registerLinkedEditingRangeProvider(Ue,mt(ge),ke)},registerReferenceProvider(ge,ke){return lt.registerReferenceProvider(Ue,mt(ge),ke)},registerRenameProvider(ge,ke){return lt.registerRenameProvider(Ue,mt(ge),ke)},registerDocumentSymbolProvider(ge,ke,Ne){return lt.registerDocumentSymbolProvider(Ue,mt(ge),ke,Ne)},registerWorkspaceSymbolProvider(ge){return lt.registerWorkspaceSymbolProvider(Ue,ge)},registerDocumentFormattingEditProvider(ge,ke){return lt.registerDocumentFormattingEditProvider(Ue,mt(ge),ke)},registerDocumentRangeFormattingEditProvider(ge,ke){return lt.registerDocumentRangeFormattingEditProvider(Ue,mt(ge),ke)},registerOnTypeFormattingEditProvider(ge,ke,Ne,...st){return lt.registerOnTypeFormattingEditProvider(Ue,mt(ge),ke,[Ne].concat(st))},registerDocumentSemanticTokensProvider(ge,ke,Ne){return lt.registerDocumentSemanticTokensProvider(Ue,mt(ge),ke,Ne)},registerDocumentRangeSemanticTokensProvider(ge,ke,Ne){return lt.registerDocumentRangeSemanticTokensProvider(Ue,mt(ge),ke,Ne)},registerSignatureHelpProvider(ge,ke,Ne,...st){return typeof Ne=="object"?lt.registerSignatureHelpProvider(Ue,mt(ge),ke,Ne):lt.registerSignatureHelpProvider(Ue,mt(ge),ke,typeof Ne>"u"?[]:[Ne,...st])},registerCompletionItemProvider(ge,ke,...Ne){return lt.registerCompletionItemProvider(Ue,mt(ge),ke,Ne)},registerInlineCompletionItemProvider(ge,ke,Ne){return ke.handleDidShowCompletionItem&&(0,je.$EF)(Ue,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,je.$EF)(Ue,"inlineCompletionsAdditions"),Ne&&(0,je.$EF)(Ue,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Ue,mt(ge),ke,Ne)},registerDocumentLinkProvider(ge,ke){return lt.registerDocumentLinkProvider(Ue,mt(ge),ke)},registerColorProvider(ge,ke){return lt.registerColorProvider(Ue,mt(ge),ke)},registerFoldingRangeProvider(ge,ke){return lt.registerFoldingRangeProvider(Ue,mt(ge),ke)},registerSelectionRangeProvider(ge,ke){return lt.registerSelectionRangeProvider(Ue,ge,ke)},registerCallHierarchyProvider(ge,ke){return lt.registerCallHierarchyProvider(Ue,ge,ke)},registerTypeHierarchyProvider(ge,ke){return lt.registerTypeHierarchyProvider(Ue,ge,ke)},setLanguageConfiguration:(ge,ke)=>lt.setLanguageConfiguration(Ue,ge,ke),getTokenInformationAtPosition(ge,ke){return(0,je.$EF)(Ue,"tokenInformation"),ai.tokenAtPosition(ge,ke)},registerInlayHintsProvider(ge,ke){return lt.registerInlayHintsProvider(Ue,ge,ke)},createLanguageStatusItem(ge,ke){return ai.createLanguageStatusItem(Ue,ge,ke)},registerDocumentDropEditProvider(ge,ke,Ne){return lt.registerDocumentOnDropEditProvider(Ue,ge,ke,(0,je.$DF)(Ue,"dropMetadata")?Ne:void 0)}},rn={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(ge,ke,Ne){const st=await(A.URI.isUri(ge)?Promise.resolve(sn.openTextDocument(ge)):Promise.resolve(ge));return Ft.showTextDocument(st,ke,Ne)},createTextEditorDecorationType(ge){return Ft.createTextEditorDecorationType(Ue,ge)},onDidChangeActiveTextEditor(ge,ke,Ne){return Ft.onDidChangeActiveTextEditor(ge,ke,Ne)},onDidChangeVisibleTextEditors(ge,ke,Ne){return Ft.onDidChangeVisibleTextEditors(ge,ke,Ne)},onDidChangeTextEditorSelection(ge,ke,Ne){return Ft.onDidChangeTextEditorSelection(ge,ke,Ne)},onDidChangeTextEditorOptions(ge,ke,Ne){return Ft.onDidChangeTextEditorOptions(ge,ke,Ne)},onDidChangeTextEditorVisibleRanges(ge,ke,Ne){return Ft.onDidChangeTextEditorVisibleRanges(ge,ke,Ne)},onDidChangeTextEditorViewColumn(ge,ke,Ne){return Ft.onDidChangeTextEditorViewColumn(ge,ke,Ne)},onDidCloseTerminal(ge,ke,Ne){return gt.onDidCloseTerminal(ge,ke,Ne)},onDidOpenTerminal(ge,ke,Ne){return gt.onDidOpenTerminal(ge,ke,Ne)},onDidChangeActiveTerminal(ge,ke,Ne){return gt.onDidChangeActiveTerminal(ge,ke,Ne)},onDidChangeTerminalDimensions(ge,ke,Ne){return(0,je.$EF)(Ue,"terminalDimensions"),gt.onDidChangeTerminalDimensions(ge,ke,Ne)},onDidChangeTerminalState(ge,ke,Ne){return gt.onDidChangeTerminalState(ge,ke,Ne)},onDidWriteTerminalData(ge,ke,Ne){return(0,je.$EF)(Ue,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(ge,ke,Ne)},onDidExecuteTerminalCommand(ge,ke,Ne){return(0,je.$EF)(Ue,"terminalExecuteCommandEvent"),gt.onDidExecuteTerminalCommand(ge,ke,Ne)},get state(){return xe.getState(Ue)},onDidChangeWindowState(ge,ke,Ne){return xe.onDidChangeWindowState(ge,ke,Ne)},showInformationMessage(ge,...ke){return li.showMessage(Ue,L.default.Info,ge,ke[0],ke.slice(1))},showWarningMessage(ge,...ke){return li.showMessage(Ue,L.default.Warning,ge,ke[0],ke.slice(1))},showErrorMessage(ge,...ke){return li.showMessage(Ue,L.default.Error,ge,ke[0],ke.slice(1))},showQuickPick(ge,ke,Ne){return ii.showQuickPick(Ue,ge,ke,Ne)},showWorkspaceFolderPick(ge){return ii.showWorkspaceFolderPick(ge)},showInputBox(ge,ke){return ii.showInput(ge,ke)},showOpenDialog(ge){return Ti.showOpenDialog(Ue,ge)},showSaveDialog(ge){return Ti.showSaveDialog(ge)},createStatusBarItem(ge,ke,Ne){let st,wt,Tt;return typeof ge=="string"?(st=ge,wt=ke,Tt=Ne):(wt=ge,Tt=ke),Xt.createStatusBarEntry(Ue,st,wt,Tt)},setStatusBarMessage(ge,ke){return Xt.setStatusBarMessage(ge,ke)},withScmProgress(ge){return Ke.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),vi.withProgress(Ue,{location:J.ProgressLocation.SourceControl},(ke,Ne)=>ge({report(st){}}))},withProgress(ge,ke){return vi.withProgress(Ue,ge,ke)},createOutputChannel(ge,ke){return Ei.createOutputChannel(ge,ke,Ue)},createWebviewPanel(ge,ke,Ne,st){return Li.createWebviewPanel(Ue,ge,ke,Ne,st)},createWebviewTextEditorInset(ge,ke,Ne,st){return(0,je.$EF)(Ue,"editorInsets"),Ci.createWebviewEditorInset(ge,ke,Ne,st,Ue)},createTerminal(ge,ke,Ne){return typeof ge=="object"?"pty"in ge?gt.createExtensionTerminal(ge):gt.createTerminalFromOptions(ge):gt.createTerminal(ge,ke,Ne)},registerTerminalLinkProvider(ge){return gt.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,ke){return gt.registerProfileProvider(Ue,ge,ke)},registerTerminalQuickFixProvider(ge,ke){return(0,je.$EF)(Ue,"terminalQuickFixProvider"),gt.registerTerminalQuickFixProvider(ge,Ue.identifier.value,ke)},registerTreeDataProvider(ge,ke){return bi.registerTreeDataProvider(ge,ke,Ue)},createTreeView(ge,ke){return bi.createTreeView(ge,ke,Ue)},registerWebviewPanelSerializer:(ge,ke)=>Li.registerWebviewPanelSerializer(Ue,ge,ke),registerCustomEditorProvider:(ge,ke,Ne={})=>cn.registerCustomEditorProvider(Ue,ge,ke,Ne),registerFileDecorationProvider(ge){return Et.registerFileDecorationProvider(ge,Ue)},registerUriHandler(ge){return gi.registerUriHandler(Ue,ge)},createQuickPick(){return ii.createQuickPick(Ue)},createInputBox(){return ii.createInputBox(Ue)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(ge,ke,Ne){return Ai.onDidChangeActiveColorTheme(ge,ke,Ne)},registerWebviewViewProvider(ge,ke,Ne){return Ri.registerWebviewViewProvider(Ue,ge,ke,Ne?.webviewOptions)},get activeNotebookEditor(){return Dt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,ke,Ne){return Dt.onDidChangeActiveNotebookEditor(ge,ke,Ne)},get visibleNotebookEditors(){return Dt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Dt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ge,ke,Ne){return $i.onDidChangeNotebookEditorSelection(ge,ke,Ne)},onDidChangeNotebookEditorVisibleRanges(ge,ke,Ne){return $i.onDidChangeNotebookEditorVisibleRanges(ge,ke,Ne)},showNotebookDocument(ge,ke){return Dt.showNotebookDocument(ge,ke)},registerExternalUriOpener(ge,ke,Ne){return(0,je.$EF)(Ue,"externalUriOpener"),un.registerExternalUriOpener(Ue.identifier,ge,ke,Ne)},registerProfileContentHandler(ge,ke){return(0,je.$EF)(Ue,"profileContentHandlers"),ln.registrProfileContentHandler(Ue,ge,ke)},registerQuickDiffProvider(ge,ke,Ne,st){return(0,je.$EF)(Ue,"quickDiffProvider"),Ii.registerQuickDiffProvider(mt(ge),ke,Ne,st)},get tabGroups(){return nt.tabGroups},registerShareProvider(ge,ke){return(0,je.$EF)(Ue,"shareProvider"),Ki.registerShareProvider(mt(ge),ke)}},sn={get rootPath(){return Ke.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ge){throw F.$7()},getWorkspaceFolder(ge){return ft.getWorkspaceFolder(ge)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ge){throw F.$7()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ge){throw F.$7()},updateWorkspaceFolders:(ge,ke,...Ne)=>ft.updateWorkspaceFolders(Ue,ge,ke||0,...Ne),onDidChangeWorkspaceFolders:function(ge,ke,Ne){return ft.onDidChangeWorkspace(ge,ke,Ne)},asRelativePath:(ge,ke)=>ft.getRelativePath(ge,ke),findFiles:(ge,ke,Ne,st)=>ft.findFiles(ge,ke,Ne,Ue.identifier,st),findTextInFiles:(ge,ke,Ne,st)=>{(0,je.$EF)(Ue,"findTextInFiles");let wt,Tt;return typeof ke=="object"?(wt=ke,Tt=Ne):(wt={},Tt=ke,st=Ne),ft.findTextInFiles(ge,wt||{},Tt,Ue.identifier,st)},save:ge=>((0,je.$EF)(Ue,"saveEditor"),ft.save(ge)),saveAs:ge=>((0,je.$EF)(Ue,"saveEditor"),ft.saveAs(ge)),saveAll:ge=>ft.saveAll(ge),applyEdit(ge,ke){return hn.applyWorkspaceEdit(ge,Ue,ke)},createFileSystemWatcher:(ge,ke,Ne,st)=>Zt.createFileSystemWatcher(ft,Ue,ge,ke,Ne,st),get textDocuments(){return Pt.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw F.$7()},openTextDocument(ge){let ke;const Ne=ge;if(typeof ge=="string")ke=Promise.resolve(A.URI.file(ge));else if(A.URI.isUri(ge))ke=Promise.resolve(ge);else if(!Ne||typeof Ne=="object")ke=Pt.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(st=>Pt.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(ge,ke,Ne)=>Pt.onDidAddDocument(ge,ke,Ne),onDidCloseTextDocument:(ge,ke,Ne)=>Pt.onDidRemoveDocument(ge,ke,Ne),onDidChangeTextDocument:(ge,ke,Ne)=>Pt.onDidChangeDocument(ge,ke,Ne),onDidSaveTextDocument:(ge,ke,Ne)=>Pt.onDidSaveDocument(ge,ke,Ne),onWillSaveTextDocument:(ge,ke,Ne)=>qi.getOnWillSaveTextDocumentEvent(Ue)(ge,ke,Ne),get notebookDocuments(){return Dt.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,ke){let Ne;if(A.URI.isUri(ge))Ne=ge,await Dt.openNotebookDocument(ge);else if(typeof ge=="string")Ne=A.URI.revive(await Dt.createNotebookDocument({viewType:ge,content:ke}));else throw new Error("Invalid arguments");return Dt.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(ge,ke,Ne){return ti.onDidSaveNotebookDocument(ge,ke,Ne)},onDidChangeNotebookDocument(ge,ke,Ne){return ti.onDidChangeNotebookDocument(ge,ke,Ne)},onWillSaveNotebookDocument(ge,ke,Ne){return Di.getOnWillSaveNotebookDocumentEvent(Ue)(ge,ke,Ne)},get onDidOpenNotebookDocument(){return Dt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Dt.onDidCloseNotebookDocument},registerNotebookSerializer(ge,ke,Ne,st){return Dt.registerNotebookSerializer(Ue,ge,ke,Ne,(0,je.$DF)(Ue,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(ge,ke,Ne)=>Mi.onDidChangeConfiguration(ge,ke,Ne),getConfiguration(ge,ke){return ke=arguments.length===1?void 0:ke,Mi.getConfiguration(ge,ke,Ue)},registerTextDocumentContentProvider(ge,ke){return ki.registerTextDocumentContentProvider(ge,ke)},registerTaskProvider:(ge,ke)=>(Ke.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Kt.registerTaskProvider(Ue,ge,ke)),registerFileSystemProvider(ge,ke,Ne){return(0,Ve.$ib)(Vi.registerFileSystemProvider(Ue,ge,ke,Ne),At.addFileSystemProvider(ge,ke,Ne))},get fs(){return At.value},registerFileSearchProvider:(ge,ke)=>((0,je.$EF)(Ue,"fileSearchProvider"),mi.registerFileSearchProvider(ge,ke)),registerTextSearchProvider:(ge,ke)=>((0,je.$EF)(Ue,"textSearchProvider"),mi.registerTextSearchProvider(ge,ke)),registerRemoteAuthorityResolver:(ge,ke)=>((0,je.$EF)(Ue,"resolvers"),kt.registerRemoteAuthorityResolver(ge,ke)),registerResourceLabelFormatter:ge=>((0,je.$EF)(Ue,"resolvers"),Ji.$registerResourceLabelFormatter(ge)),getRemoteExecServer:ge=>((0,je.$EF)(Ue,"resolvers"),kt.getRemoteExecServer(ge)),onDidCreateFiles:(ge,ke,Ne)=>Zt.onDidCreateFile(ge,ke,Ne),onDidDeleteFiles:(ge,ke,Ne)=>Zt.onDidDeleteFile(ge,ke,Ne),onDidRenameFiles:(ge,ke,Ne)=>Zt.onDidRenameFile(ge,ke,Ne),onWillCreateFiles:(ge,ke,Ne)=>Zt.getOnWillCreateFileEvent(Ue)(ge,ke,Ne),onWillDeleteFiles:(ge,ke,Ne)=>Zt.getOnWillDeleteFileEvent(Ue)(ge,ke,Ne),onWillRenameFiles:(ge,ke,Ne)=>Zt.getOnWillRenameFileEvent(Ue)(ge,ke,Ne),openTunnel:ge=>((0,je.$EF)(Ue,"tunnels"),Me.openTunnel(Ue,ge).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,je.$EF)(Ue,"tunnels"),Me.getTunnels()},onDidChangeTunnels:(ge,ke,Ne)=>((0,je.$EF)(Ue,"tunnels"),Me.onDidChangeTunnels(ge,ke,Ne)),registerPortAttributesProvider:(ge,ke)=>((0,je.$EF)(Ue,"portsAttributes"),Me.registerPortsAttributesProvider(ge,ke)),registerTunnelProvider:(ge,ke)=>((0,je.$EF)(Ue,"tunnelFactory"),Me.registerTunnelProvider(ge,ke)),registerTimelineProvider:(ge,ke)=>((0,je.$EF)(Ue,"timeline"),Hi.registerTimelineProvider(ge,ke,Ue.identifier,ut.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ge=>((0,je.$EF)(Ue,"workspaceTrust"),ft.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,ke,Ne)=>ft.onDidGrantWorkspaceTrust(ge,ke,Ne),registerEditSessionIdentityProvider:(ge,ke)=>((0,je.$EF)(Ue,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ge,ke)),onWillCreateEditSessionIdentity:(ge,ke,Ne)=>((0,je.$EF)(Ue,"editSessionIdentityProvider"),ft.getOnWillCreateEditSessionIdentityEvent(Ue)(ge,ke,Ne)),registerCanonicalUriProvider:(ge,ke)=>((0,je.$EF)(Ue,"canonicalUriProvider"),ft.registerCanonicalUriProvider(ge,ke)),getCanonicalUri:(ge,ke,Ne)=>((0,je.$EF)(Ue,"canonicalUriProvider"),ft.provideCanonicalUri(ge,ke,Ne))},fn={get inputBox(){return Ke.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),pi.getLastInputBox(Ue)},createSourceControl(ge,ke,Ne){return pi.createSourceControl(Ue,ge,ke,Ne)}},on={createCommentController(ge,ke){return Pi.createCommentController(Ue,ge,ke)}},an={get activeDebugSession(){return St.activeDebugSession},get activeDebugConsole(){return St.activeDebugConsole},get breakpoints(){return St.breakpoints},get stackFrameFocus(){return St.stackFrameFocus},onDidStartDebugSession(ge,ke,Ne){return St.onDidStartDebugSession(ge,ke,Ne)},onDidTerminateDebugSession(ge,ke,Ne){return St.onDidTerminateDebugSession(ge,ke,Ne)},onDidChangeActiveDebugSession(ge,ke,Ne){return St.onDidChangeActiveDebugSession(ge,ke,Ne)},onDidReceiveDebugSessionCustomEvent(ge,ke,Ne){return St.onDidReceiveDebugSessionCustomEvent(ge,ke,Ne)},onDidChangeBreakpoints(ge,ke,Ne){return St.onDidChangeBreakpoints(ge,ke,Ne)},onDidChangeStackFrameFocus(ge,ke,Ne){return(0,je.$EF)(Ue,"debugFocus"),St.onDidChangeStackFrameFocus(ge,ke,Ne)},registerDebugConfigurationProvider(ge,ke,Ne){return St.registerDebugConfigurationProvider(ge,ke,Ne||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,ke){return St.registerDebugAdapterDescriptorFactory(Ue,ge,ke)},registerDebugAdapterTrackerFactory(ge,ke){return St.registerDebugAdapterTrackerFactory(ge,ke)},startDebugging(ge,ke,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?St.startDebugging(ge,ke,{parentSession:Ne}):St.startDebugging(ge,ke,Ne||{})},stopDebugging(ge){return St.stopDebugging(ge)},addBreakpoints(ge){return St.addBreakpoints(ge)},removeBreakpoints(ge){return St.removeBreakpoints(ge)},asDebugSourceUri(ge,ke){return St.asDebugSourceUri(ge,ke)}},Oi={registerTaskProvider:(ge,ke)=>Kt.registerTaskProvider(Ue,ge,ke),fetchTasks:ge=>Kt.fetchTasks(ge),executeTask:ge=>Kt.executeTask(Ue,ge),get taskExecutions(){return Kt.taskExecutions},onDidStartTask:(ge,ke,Ne)=>Kt.onDidStartTask(ge,ke,Ne),onDidEndTask:(ge,ke,Ne)=>Kt.onDidEndTask(ge,ke,Ne),onDidStartTaskProcess:(ge,ke,Ne)=>Kt.onDidStartTaskProcess(ge,ke,Ne),onDidEndTaskProcess:(ge,ke,Ne)=>Kt.onDidEndTaskProcess(ge,ke,Ne)},Ni={createNotebookController(ge,ke,Ne,st,wt){return si.createNotebookController(Ue,ge,ke,Ne,st,(0,je.$DF)(Ue,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(ge,ke)=>Dt.registerNotebookCellStatusBarItemProvider(Ue,ge,ke),createRendererMessaging(ge){return Si.createRendererMessaging(Ue,ge)},createNotebookControllerDetectionTask(ge){return(0,je.$EF)(Ue,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Ue,ge)},registerKernelSourceActionProvider(ge,ke){return(0,je.$EF)(Ue,"notebookKernelSource"),si.registerKernelSourceActionProvider(Ue,ge,ke)},onDidChangeNotebookCellExecutionState(ge,ke,Ne){return(0,je.$EF)(Ue,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(ge,ke,Ne)}},zi={t(...ge){if(typeof ge[0]=="string"){const ke=ge.shift(),Ne=!ge||typeof ge[0]!="object"?ge:ge[0];return Wt.getMessage(Ue.identifier.value,{message:ke,args:Ne})}return Wt.getMessage(Ue.identifier.value,ge[0])},get bundle(){return Wt.getBundle(Ue.identifier.value)},get uri(){return Wt.getBundleUri(Ue.identifier.value)}},di={_version:1,registerInteractiveEditorSessionProvider(ge){return(0,je.$EF)(Ue,"interactive"),Gi.registerProvider(Ue,ge)},registerInteractiveSessionProvider(ge,ke){return(0,je.$EF)(Ue,"interactive"),ui.registerChatProvider(Ue,ge,ke)},addInteractiveRequest(ge){return(0,je.$EF)(Ue,"interactive"),ui.addChatRequest(ge)},sendInteractiveRequestToProvider(ge,ke){return(0,je.$EF)(Ue,"interactive"),ui.sendInteractiveRequestToProvider(ge,ke)},get onDidPerformUserAction(){return(0,je.$EF)(Ue,"interactiveUserActions"),ui.onDidPerformUserAction},transferChatSession(ge,ke){return(0,je.$EF)(Ue,"interactive"),ui.transferChatSession(ge,ke)}},ji={getRelatedInformation(ge,ke){return(0,je.$EF)(Ue,"aiRelatedInformation"),Zi.getRelatedInformation(Ue,ge,ke)},registerRelatedInformationProvider(ge,ke){return(0,je.$EF)(Ue,"aiRelatedInformation"),Zi.registerRelatedInformationProvider(Ue,ge,ke)},registerEmbeddingVectorProvider(ge,ke){return(0,je.$EF)(Ue,"aiRelatedInformation"),Fi.registerEmbeddingVectorProvider(Ue,ge,ke)}},Ui={registerChatResponseProvider(ge,ke,Ne){return(0,je.$EF)(Ue,"chatProvider"),fi.registerProvider(Ue.identifier,ge,ke,Ne)},registerSlashCommand(ge,ke,Ne){return(0,je.$EF)(Ue,"chatSlashCommands"),Yi.registerCommand(Ue.identifier,ge,ke,Ne??{description:""})},requestChatAccess(ge){return(0,je.$EF)(Ue,"chatRequestAccess"),fi.requestChatResponseProvider(Ue.identifier,ge)},registerVariable(ge,ke,Ne){return(0,je.$EF)(Ue,"chatVariables"),Qi.registerVariableResolver(Ue,ge,ke,Ne)},registerMappedEditsProvider(ge,ke){return(0,je.$EF)(Ue,"mappedEditsProvider"),lt.registerMappedEditsProvider(Ue,ge,ke)}};return{version:ht.version,ai:ji,authentication:xi,commands:_i,comments:on,chat:Ui,debug:an,env:en,extensions:tn,interactive:di,l10n:zi,languages:nn,notebooks:Ni,scm:fn,tasks:Oi,tests:dn,window:rn,workspace:sn,Breakpoint:J.$KK,TerminalOutputAnchor:J.TerminalOutputAnchor,ChatMessage:J.$AL,ChatMessageRole:J.ChatMessageRole,ChatVariableLevel:J.ChatVariableLevel,CallHierarchyIncomingCall:J.$0J,CallHierarchyItem:J.$9J,CallHierarchyOutgoingCall:J.$$J,CancellationError:F.$3,CancellationTokenSource:S.$oc,CandidatePortSource:$.CandidatePortSource,CodeAction:J.$5J,CodeActionKind:J.$6J,CodeActionTriggerKind:J.CodeActionTriggerKind,CodeLens:J.$_J,Color:J.$mK,ColorInformation:J.$nK,ColorPresentation:J.$oK,ColorThemeKind:J.ColorThemeKind,CommentMode:J.CommentMode,CommentState:J.CommentState,CommentThreadCollapsibleState:J.CommentThreadCollapsibleState,CommentThreadState:J.CommentThreadState,CompletionItem:J.$gK,CompletionItemKind:J.CompletionItemKind,CompletionItemTag:J.CompletionItemTag,CompletionList:J.$hK,CompletionTriggerKind:J.CompletionTriggerKind,ConfigurationTarget:J.ConfigurationTarget,CustomExecution:J.$wK,DebugAdapterExecutable:J.$OK,DebugAdapterInlineImplementation:J.$RK,DebugAdapterNamedPipeServer:J.$QK,DebugAdapterServer:J.$PK,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:J.DebugConsoleMode,DecorationRangeBehavior:J.DecorationRangeBehavior,Diagnostic:J.$ZJ,DiagnosticRelatedInformation:J.$YJ,DiagnosticSeverity:J.DiagnosticSeverity,DiagnosticTag:J.DiagnosticTag,Disposable:J.$LJ,DocumentHighlight:J.$2J,DocumentHighlightKind:J.DocumentHighlightKind,DocumentLink:J.$lK,DocumentSymbol:J.$4J,EndOfLine:J.EndOfLine,EnvironmentVariableMutatorType:J.EnvironmentVariableMutatorType,EvaluatableExpression:J.$UK,InlineValueText:J.$VK,InlineValueVariableLookup:J.$WK,InlineValueEvaluatableExpression:J.$XK,InlineCompletionTriggerKind:J.InlineCompletionTriggerKind,EventEmitter:h.$ec,ExtensionKind:J.ExtensionKind,ExtensionMode:J.ExtensionMode,ExternalUriOpenerPriority:J.ExternalUriOpenerPriority,FileChangeType:J.FileChangeType,FileDecoration:J.$8K,FileDecoration2:J.$8K,FileSystemError:J.$ZK,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:J.$1K,FoldingRangeKind:J.FoldingRangeKind,FunctionBreakpoint:J.$MK,InlineCompletionItem:J.$iK,InlineCompletionList:J.$jK,Hover:J.$1J,IndentAction:g.IndentAction,Location:J.$XJ,MarkdownString:J.$aK,OverviewRulerLane:w.OverviewRulerLane,ParameterInformation:J.$bK,PortAutoForwardAction:J.PortAutoForwardAction,Position:J.$MJ,ProcessExecution:J.$uK,ProgressLocation:J.ProgressLocation,QuickInputButtons:J.$7K,Range:J.$NJ,RelativePattern:J.$IK,Selection:J.$OJ,SelectionRange:J.$8J,SemanticTokens:J.$4K,SemanticTokensBuilder:J.$3K,SemanticTokensEdit:J.$5K,SemanticTokensEdits:J.$6K,SemanticTokensLegend:J.$2K,ShellExecution:J.$vK,ShellQuoting:J.ShellQuoting,SignatureHelp:J.$dK,SignatureHelpTriggerKind:J.SignatureHelpTriggerKind,SignatureInformation:J.$cK,SnippetString:J.$WJ,SourceBreakpoint:J.$LK,StandardTokenType:J.StandardTokenType,StatusBarAlignment:J.StatusBarAlignment,SymbolInformation:J.$3J,SymbolKind:J.SymbolKind,SymbolTag:J.SymbolTag,Task:J.$xK,TaskGroup:J.$tK,TaskPanelKind:J.TaskPanelKind,TaskRevealKind:J.TaskRevealKind,TaskScope:J.TaskScope,TerminalLink:J.$pK,TerminalQuickFixExecuteTerminalCommand:J.$rK,TerminalQuickFixOpener:J.$qK,TerminalLocation:J.TerminalLocation,TerminalProfile:J.$sK,TerminalExitReason:J.TerminalExitReason,TextDocumentSaveReason:J.TextDocumentSaveReason,TextEdit:J.$SJ,SnippetTextEdit:J.$UJ,TextEditorCursorStyle:f.TextEditorCursorStyle,TextEditorLineNumbersStyle:J.TextEditorLineNumbersStyle,TextEditorRevealType:J.TextEditorRevealType,TextEditorSelectionChangeKind:J.TextEditorSelectionChangeKind,TextDocumentChangeReason:J.TextDocumentChangeReason,ThemeColor:J.$HK,ThemeIcon:J.$GK,TreeItem:J.$yK,TreeItemCheckboxState:J.TreeItemCheckboxState,TreeItemCollapsibleState:J.TreeItemCollapsibleState,TypeHierarchyItem:J.$qL,UIKind:k.UIKind,Uri:A.URI,ViewColumn:J.ViewColumn,WorkspaceEdit:J.$VJ,DocumentDropEdit:J.$EK,DocumentPasteEdit:J.$FK,InlayHint:J.$fK,InlayHintLabelPart:J.$eK,InlayHintKind:J.InlayHintKind,RemoteAuthorityResolverError:J.$RJ,ResolvedAuthority:J.$PJ,ManagedResolvedAuthority:J.$QJ,SourceControlInputBoxValidationType:J.SourceControlInputBoxValidationType,ExtensionRuntime:J.ExtensionRuntime,TimelineItem:J.$fL,NotebookRange:J.$0K,NotebookCellKind:J.NotebookCellKind,NotebookCellExecutionState:J.NotebookCellExecutionState,NotebookCellData:J.$$K,NotebookData:J.$_K,NotebookRendererScript:J.$dL,NotebookCellStatusBarAlignment:J.NotebookCellStatusBarAlignment,NotebookEditorRevealType:J.NotebookEditorRevealType,NotebookCellOutput:J.$bL,NotebookCellOutputItem:J.$aL,NotebookCellStatusBarItem:J.$cL,NotebookControllerAffinity:J.NotebookControllerAffinity,NotebookControllerAffinity2:J.NotebookControllerAffinity2,NotebookEdit:J.$TJ,NotebookKernelSourceAction:J.$eL,PortAttributes:J.$hL,LinkedEditingRanges:J.$gL,TestResultState:J.TestResultState,TestRunRequest:J.$iL,TestMessage:J.$jL,TestMessage2:J.$jL,TestTag:J.$kL,TestRunProfileKind:J.TestRunProfileKind,TextSearchCompleteMessageType:Oe.TextSearchCompleteMessageType,DataTransfer:J.$DK,DataTransferItem:J.$zK,CoveredCount:J.$lL,FileCoverage:J.$mL,StatementCoverage:J.$nL,BranchCoverage:J.$oL,FunctionCoverage:J.$pL,WorkspaceTrustState:J.WorkspaceTrustState,LanguageStatusSeverity:J.LanguageStatusSeverity,QuickPickItemKind:J.QuickPickItemKind,InputBoxValidationSeverity:J.InputBoxValidationSeverity,TabInputText:J.$rL,TabInputTextDiff:J.$sL,TabInputTextMerge:J.$tL,TabInputCustom:J.$uL,TabInputNotebook:J.$wL,TabInputNotebookDiff:J.$xL,TabInputWebview:J.$vL,TabInputTerminal:J.$yL,TabInputInteractiveWindow:J.$zL,TelemetryTrustedValue:fe.$4n,LogLevel:ve.LogLevel,EditSessionIdentityMatch:ot.EditSessionIdentityMatch,InteractiveSessionVoteDirection:J.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:J.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:J.InteractiveEditorResponseFeedbackKind,StackFrameFocus:J.$SK,ThreadFocus:J.$TK,NotebookCodeActionKind:J.$7J,RelatedInformationType:J.RelatedInformationType}}}e.$pcc=Bt}),define(Se[345],De([1,0,102,149,38,146,39,33,65,43,93,94,95,114,68,89,148,67,52,113,88,66,147,17,53,111,112]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E,n,o,a,m,v,D,t,r,s,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,S.$dr)(i.$3ac,i.$2ac,1),(0,S.$dr)(r.$Si,t.$qcc,1),(0,S.$dr)(E.$pac,E.$qac,1),(0,S.$dr)(f.$8L,f.$7L,0),(0,S.$dr)(A.$Cac,A.$Aac,0),(0,S.$dr)(o.$Rac,o.$Qac,0),(0,S.$dr)(I.$Fbc,I.$Jbc,0),(0,S.$dr)(L.$xbc,L.$wbc,0),(0,S.$dr)(w.$WL,w.$VL,0),(0,S.$dr)(c.$4ac,c.$5ac,0),(0,S.$dr)(a.$mac,a.$lac,0),(0,S.$dr)(F.$dbc,F.$cbc,1),(0,S.$dr)($.$Pbc,$.$Qbc,0),(0,S.$dr)(k.$Nac,k.$Mac,0),(0,S.$dr)(P.$Abc,P.$zbc,0),(0,S.$dr)(g.$Uac,g.$Xac,0),(0,S.$dr)(C.$Lrb,C.$Mrb,0),(0,S.$dr)(n.$tbc,n.$sbc,0),(0,S.$dr)(h.$zac,h.$yac,0),(0,S.$dr)(m.$Zac,m.$Yac,0),(0,S.$dr)(v.$6L,v.$3L,0),(0,S.$dr)(D.$Bbc,D.$Cbc,0),(0,S.$dr)(s.$Dbc,s.$Ebc,0)}),define(Se[115],De([1,0,18,17,36,92]),function(me,e,S,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Icc=e.$Hcc=e.$Gcc=void 0;function A(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.$Gcc=A;function f(I,$,k,C){const E=(0,S.$Ff)(k,w),n=new h.$aI($,E,C),o=n.preview.matches;return{ranges:(0,S.$Ff)(E,g),uri:I,preview:{text:n.preview.text,matches:(0,S.$Ff)(o,g)}}}e.$Hcc=f;function w(I){return new h.$bI(I.start.line,I.start.character,I.end.line,I.end.character)}function g(I){return new L.$3H(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let P=class{constructor($,k){this.a=$,this.b=k}appendLine($){this.b.debug(`${this.a}#search`,$)}};e.$Icc=P,e.$Icc=P=Je([Be(1,F.$Ri)],P)}),define(Se[346],De([1,0,46,14,73,32,9,15,115,347]),function(me,e,S,F,h,L,A,f,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=e.$Kcc=e.$Jcc=void 0;const P=g.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(m,v,D,t){const r=$(m,v,D,t),s=v.folder.fsPath;return{cmd:S.spawn(P,r.args,{cwd:s}),rgDiskPath:P,siblingClauses:r.siblingClauses,rgArgs:r,cwd:s}}e.$Jcc=I;function $(m,v,D,t){const r=["--files","--hidden","--case-sensitive","--no-require-git"];C([v],D,!1).forEach(i=>{const c=(0,w.$Gcc)(i);if(r.push("-g",c),A.$j){const l=(0,h.$8k)(c);l!==c&&r.push("-g",l)}});const s=k([v],t,void 0,!1);return s.globArgs.forEach(i=>{const c=`!${(0,w.$Gcc)(i)}`;if(r.push("-g",c),A.$j){const l=(0,h.$8k)(c);l!==c&&r.push("-g",l)}}),v.disregardIgnoreFiles!==!1?r.push("--no-ignore"):v.disregardParentIgnoreFiles!==!1&&r.push("--no-ignore-parent"),v.ignoreSymlinks||r.push("--follow"),m.exists&&r.push("--quiet"),r.push("--no-config"),v.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:s.siblingClauses}}function k(m,v,D,t=!0){const r=[];let s={};return m.forEach(i=>{const c=Object.assign({},i.excludePattern||{},v||{}),l=E(c,t?i.folder.fsPath:void 0,D);r.push(...l.globArgs),l.siblingClauses&&(s=Object.assign(s,l.siblingClauses))}),{globArgs:r,siblingClauses:s}}function C(m,v,D=!0){const t=[];return m.forEach(r=>{const s=Object.assign({},v||{},r.includePattern||{}),i=E(s,D?r.folder.fsPath:void 0);t.push(...i.globArgs)}),t}function E(m,v,D){const t=[],r={};return Object.keys(m).forEach(s=>{if(D&&D.has(s)||!s)return;const i=m[s];s=o(v?n(v,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof i=="boolean"&&i?(s.startsWith("\\\\")&&(s+="**"),t.push(a(s))):i&&i.when&&(r[s]=i)}),{globArgs:t,siblingClauses:r}}function n(m,v){return F.$7c(v)?v:F.$8c(m,v)}e.$Kcc=n;function o(m){return m=f.$ud(m,"\\"),f.$ud(m,"/")}function a(m){return L.$De(m).toLowerCase()==="c:/"?m.replace(/^c:[/\\]/i,"/"):m}e.$Lcc=a}),define(Se[348],De([1,0,46,49,14,349,18,45,35,73,32,9,37,15,19,29,36,346,125]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E,n,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=e.$Mcc=void 0;const m=new Set;process.on("exit",()=>{m.forEach(s=>s())});class v{constructor(i){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=i,this.b=i.filePattern||"",this.d=i.includePattern&&w.$ej(i.includePattern),this.f=i.maxResults||null,this.g=!!i.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,a.$fq)(this.b).normalizedLowercase),this.u=i.excludePattern&&w.$ej(i.excludePattern),this.t=new Map,i.folderQueries.forEach(c=>{const l=Object.assign({},c.excludePattern||{},this.a.excludePattern||{}),b=c.folder.fsPath;i.folderQueries.map(y=>y.folder.fsPath).filter(y=>y!==b).forEach(y=>{(0,P.$He)(y,b)&&(l[h.$0c(b,y)]=!0)}),this.t.set(b,new t(l,b))})}cancel(){this.l=!0,m.forEach(i=>i())}walk(i,c,l,b,y){if(this.m=$.$ac.create(!1),this.l)return y(null,this.j);c.forEach(u=>{const d=h.$_c(u.fsPath);this.u&&this.u(u.fsPath,d)||this.J(l,{relativePath:u.fsPath,searchPath:void 0})}),this.r=$.$ac.create(!1),this.w(i,(u,d)=>{this.x(this.y,this,u,l,b,p=>{if(p){const R=(0,f.$ai)(p);console.error(R),this.q.push(R),d(p,void 0)}else d(null,void 0)})},(u,d)=>{this.m.stop();const p=u?A.$jf(u)[0]:null;y(p,this.j)})}w(i,c,l){const b=new Array(i.length),y=new Array(i.length);let u=!1,d=0;if(i.length===0)return l(null,[]);i.forEach((p,R)=>{c(p,(O,j)=>{if(O?(u=!0,b[R]=null,y[R]=O):(b[R]=j,y[R]=null),++d===i.length)return l(u?y:null,b)})})}x(i,c,...l){try{i.apply(c,l)}catch(b){l[l.length-1](b)}}y(i,c,l,b){const y=i.folder.fsPath,u=I.$j,d=()=>T&&T.kill();m.add(d);let p=Y=>{m.delete(d),p=()=>{},b(Y)},R="";const O=this.D(),j=(0,o.$Jcc)(this.a,i,this.a.includePattern,this.t.get(i.folder.fsPath).expression),T=j.cmd,z=!Object.keys(j.siblingClauses).length,B=j.rgArgs.args.map(Y=>Y.match(/^-/)?Y:`'${Y}'`).join(" ");let M=`${j.rgDiskPath} ${B}
 - cwd: ${j.cwd}`;j.rgArgs.siblingClauses&&(M+=`
 - Sibling clauses: ${JSON.stringify(j.rgArgs.siblingClauses)}`),l({message:M}),this.s=0,this.z(T,"utf8",l,(Y,J,fe)=>{if(Y){p(Y);return}if(this.j){p();return}const ie=(R+(u?g.$7k(J||""):J)).split(`
`);if(fe){const V=ie.length;ie[V-1]=ie[V-1].trim(),ie[V-1]||ie.pop()}else R=ie.pop()||"";if(ie.length&&ie[0].indexOf(`
`)!==-1){p(new Error("Splitting up files failed"));return}if(this.s+=ie.length,z){for(const V of ie)if(this.J(c,{base:y,relativePath:V,searchPath:this.N(i,V)}),this.j){d();break}(fe||this.j)&&p();return}this.G(i,O,y,ie,c),fe&&(this.H(O,y,c),p())})}spawnFindCmd(i){const c=this.t.get(i.folder.fsPath),l=c.getBasenameTerms(),b=c.getPathTerms(),y=["-L","."];if(l.length||b.length){y.push("-not","(","(");for(const u of l)y.push("-name",u),y.push("-o");for(const u of b)y.push("-path",u),y.push("-o");y.pop(),y.push(")","-prune",")")}return y.push("-type","f"),S.spawn("find",y,{cwd:i.folder.fsPath})}readStdout(i,c,l){let b="";this.z(i,c,()=>{},(y,u,d)=>{if(y){l(y);return}b+=u,d&&l(null,b)})}z(i,c,l,b){let y=(p,R,O)=>{(p||O)&&(y=()=>{},this.r?.stop()),b(p,R,O)},u=!1;i.stdout?(this.A(i.stdout,c,y),i.stdout.once("data",()=>u=!0)):l({message:"stdout is null"});let d;i.stderr?d=this.B(i.stderr):l({message:"stderr is null"}),i.on("error",p=>{y(p)}),i.on("close",p=>{let R;!u&&(R=this.C(d,c))&&r(R)?y(new Error(`command failed with error code ${p}: ${this.C(d,c)}`)):(this.g&&p===0&&(this.j=!0),y(null,"",!0))})}A(i,c,l){const b=new L.StringDecoder(c);return i.on("data",y=>{l(null,b.write(y))}),b}B(i){const c=[];return i.on("data",l=>{c.push(l)}),c}C(i,c){const l=new L.StringDecoder(c);return i.map(b=>l.write(b)).join("")}D(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}G(i,{pathToEntries:c},l,b,y){b.indexOf(this.b)!==-1&&this.J(y,{base:l,relativePath:this.b,searchPath:this.N(i,this.b)});const u=d=>{const p=h.$_c(d),R=h.$$c(d);let O=c[R];O||(O=c[R]=[],u(R)),O.push({base:l,relativePath:d,basename:p,searchPath:this.N(i,d)})};b.forEach(u)}H({rootEntries:i,pathToEntries:c},l,b){const y=this,u=this.t.get(l),d=this.b;function p(R){y.o++;const O=(0,n.$qI)(()=>R.map(j=>j.basename));for(let j=0,T=R.length;j<T;j++){const z=R[j],{relativePath:B,basename:M}=z;if(u.test(B,M,d!==M?O:void 0))continue;const Y=c[B];if(Y)p(Y);else{if(y.p++,B===d)continue;y.J(b,z)}if(y.j)break}}p(i)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(i,c,l,b,y){const u=i.folder,d=(0,n.$qI)(()=>l);this.w(l,(p,R)=>{if(this.l||this.j)return R(null);const O=c?[c,p].join(h.sep):p;if(this.t.get(i.folder.fsPath).test(O,p,this.a.filePattern!==p?d:void 0))return R(null);const j=[u.fsPath,O].join(h.sep);F.lstat(j,(T,z)=>{if(T||this.l||this.j)return R(null);this.L(j,z,(B,M)=>B||this.l||this.j?R(null):M.isDirectory()?(this.o++,this.M(j,z,(Y,J)=>Y||this.l||this.j||(J=J||"",this.v[J])?R(null):(this.v[J]=!0,E.Promises.readdir(j).then(fe=>{if(this.l||this.j)return R(null);this.I(i,O,fe,b,se=>R(se||null))},fe=>{R(null)})))):(this.p++,O===this.b||this.h&&C.$me(M.size)&&M.size>this.h||this.J(b,{base:u.fsPath,relativePath:O,searchPath:this.N(i,O)}),R(null,void 0)))})},p=>{const R=p&&A.$jf(p);return y(R&&R.length>0?R[0]:void 0)})}J(i,c){this.K(c)&&(!this.d||this.d(c.relativePath,h.$_c(c.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||i(c))}K(i){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,n.$lI)(i,this.c)}return!0}L(i,c,l){return c.isSymbolicLink()?F.stat(i,l):l(null,c)}M(i,c,l){return c.isSymbolicLink()?F.realpath(i,(b,y)=>b?l(b):l(null,y)):l(null,i)}N(i,c){return i.folderName?h.$8c(i.folderName,c):c}}e.$Mcc=v;class D{constructor(i){this.a=i.folderQueries,this.b=i.extraFileResources||[],this.c=new v(i)}search(i,c,l){this.c.walk(this.a,this.b,i,c,(b,y)=>{l(b,{limitHit:y,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Ncc=D;class t{constructor(i,c){this.expression=i,this.c=c,this.d(i)}d(i){let c,l;Object.keys(i).filter(b=>i[b]).forEach(b=>{h.$7c(b)?(c=c||w.$_i(),c[b]=i[b]):(l=l||w.$_i(),l[b]=i[b])}),this.a=c&&w.$ej(c,{trimForExclusions:!0}),this.b=l&&w.$ej(l,{trimForExclusions:!0})}test(i,c,l){return this.b&&this.b(i,c,l)||this.a&&this.a(h.$8c(this.c,i),c,l)}getBasenameTerms(){const i=[];return this.a&&i.push(...w.$gj(this.a)),this.b&&i.push(...w.$gj(this.b)),i}getPathTerms(){const i=[];return this.a&&i.push(...w.$hj(this.a)),this.b&&i.push(...w.$hj(this.b)),i}}function r(s){const i=s.trim().split(`
`),c=i[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return k.$ae(i[i.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(Se[350],De([1,0,96,21,179,22]),function(me,e,S,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gD=e.$fD=e.$eD=e.$dD=e.$cD=e.$bD=e.$aD=e.$_C=e.$$C=e.DecodeStreamErrorKind=e.$0C=e.$9C=e.$8C=e.$7C=e.$6C=e.$5C=e.$4C=e.$3C=void 0,e.$3C="utf8",e.$4C="utf8bom",e.$5C="utf16be",e.$6C="utf16le";function A(c){return[e.$3C,e.$4C,e.$5C,e.$6C].some(l=>l===c)}e.$7C=A,e.$8C=[254,255],e.$9C=[255,254],e.$0C=[239,187,191];const f=512,w=512,g=512*8,P=512*128;var I;(function(c){c[c.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class $ extends Error{constructor(l,b){super(l),this.decodeStreamErrorKind=b}}e.$$C=$;class k{static async create(l){let b;if(l!==e.$3C)b=(await(0,h.$2C)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(l));else{const y=new TextDecoder;b={write(u){return y.decode(u,{stream:!0})},end(){return y.decode()}}}return new k(b)}constructor(l){this.a=l}write(l){return this.a.write(l)}end(){return this.a.end()}}function C(c,l){const b=l.minBytesRequiredForDetection??l.guessEncoding?g:w;return new Promise((y,u)=>{const d=(0,S.$sc)(z=>z.join("")),p=[];let R=0,O;const j=new L.$oc,T=async()=>{try{const z=await i({buffer:F.$Ec.concat(p),bytesRead:R},l.guessEncoding);if(z.seemsBinary&&l.acceptTextOnly)throw new $("Stream is binary but only text is accepted for decoding",1);z.encoding=await l.overwriteEncoding(z.encoding),O=await k.create(z.encoding);const B=O.write(F.$Ec.concat(p).buffer);d.write(B),p.length=0,R=0,y({stream:d,detected:z})}catch(z){j.cancel(),d.destroy(),u(z)}};(0,S.$wc)(c,{onData:async z=>{O?d.write(O.write(z.buffer)):(p.push(z),R+=z.byteLength,R>=b&&(c.pause(),await T(),setTimeout(()=>c.resume())))},onError:z=>d.error(z),onEnd:async()=>{O||await T(),d.end(O?.end())}},j.token)})}e.$_C=C;async function E(c,l,b){const u=(await(0,h.$2C)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(l),b);let d=!1,p=!1;return{read(){if(p)return null;const R=c.read();if(typeof R!="string"){if(p=!0,!d&&b?.addBOM)switch(l){case e.$3C:case e.$4C:return F.$Ec.wrap(Uint8Array.from(e.$0C));case e.$5C:return F.$Ec.wrap(Uint8Array.from(e.$8C));case e.$6C:return F.$Ec.wrap(Uint8Array.from(e.$9C))}const O=u.end();return O&&O.length>0?(d=!0,F.$Ec.wrap(O)):null}return d=!0,F.$Ec.wrap(u.write(R))}}}e.$aD=E;async function n(c){return(await(0,h.$2C)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(c))}e.$bD=n;function o(c){return c===e.$4C||c===null?e.$3C:c}e.$cD=o;function a(c,l){if(!c||l<e.$8C.length)return null;const b=c.readUInt8(0),y=c.readUInt8(1);if(b===e.$8C[0]&&y===e.$8C[1])return e.$5C;if(b===e.$9C[0]&&y===e.$9C[1])return e.$6C;if(l<e.$0C.length)return null;const u=c.readUInt8(2);return b===e.$0C[0]&&y===e.$0C[1]&&u===e.$0C[2]?e.$4C:null}e.$dD=a;const m=["ascii","utf-16","utf-32"];async function v(c){const l=await(0,h.$2C)("jschardet","dist/jschardet.min.js"),b=c.slice(0,P),y=r(b.buffer),u=l.detect(y);if(!u||!u.encoding)return null;const d=u.encoding.toLowerCase();return 0<=m.indexOf(d)?null:t(u.encoding)}const D={ibm866:"cp866",big5:"cp950"};function t(c){const l=c.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return D[l]||l}function r(c){let l="";for(let b=0;b<c.length;b++)l+=String.fromCharCode(c[b]);return l}function s(c){switch(c){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const l=c.match(/windows(\d+)/);return l?"windows-"+l[1]:c}}}e.$eD=s;function i({buffer:c,bytesRead:l},b){let y=a(c,l),u=!1;if(y!==e.$5C&&y!==e.$6C&&c){let d=!0,p=!0,R=!1;for(let O=0;O<l&&O<f;O++){const j=O%2===1,T=c.readUInt8(O)===0;if(T&&(R=!0),d&&(j&&!T||!j&&T)&&(d=!1),p&&(j&&T||!j&&!T)&&(p=!1),T&&!d&&!p)break}R&&(d?y=e.$6C:p?y=e.$5C:u=!0)}return b&&!u&&!y&&c?v(c.slice(0,l)).then(d=>({seemsBinary:!1,encoding:d})):{seemsBinary:u,encoding:y}}e.$fD=i,e.$gD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[151],De([1,0,350,29,150]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=void 0;class L extends h.$Lbc{constructor(f,w,g=F,P="searchProcess"){super(f,w,{readdir:I=>g.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,S.$eD)(I)},P)}}e.$Vcc=L}),define(Se[152],De([1,0,46,366,349,18,69,35,14,15,2,36,92,367,347,115]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ucc=e.$Tcc=e.$Scc=e.$Rcc=e.$Qcc=e.$Pcc=e.$Occ=void 0;const n=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class o{constructor(p){this.a=p}provideTextSearchResults(p,R,O,j){return this.a.appendLine(`provideTextSearchResults ${p.pattern}, ${JSON.stringify({...R,folder:R.folder.toString()})}`),new Promise((T,z)=>{j.onCancellationRequested(()=>V());const B=r(p,R),M=R.folder.fsPath,Y=B.map(x=>x.match(/^-/)?x:`'${x}'`).join(" ");this.a.appendLine(`${n} ${Y}
 - cwd: ${M}`);let J=S.spawn(n,B,{cwd:M});J.on("error",x=>{console.error(x),this.a.appendLine("Error: "+(x&&x.message)),z((0,I.$hI)(new I.$fI(x&&x.message,I.SearchErrorCode.rgProcessError)))});let fe=!1;const se=new v(R.maxResults,M,R.previewOptions);se.on("result",x=>{fe=!0,pe="",O.report(x)});let ie=!1;const V=()=>{ie=!0,J?.kill(),se?.cancel()};let re=!1;se.on("hitLimit",()=>{re=!0,V()});let pe="";J.stdout.on("data",x=>{se.handleData(x),fe||(pe+=x)});let ae=!1;J.stdout.once("data",()=>ae=!0);let ne="";J.stderr.on("data",x=>{const N=x.toString();this.a.appendLine(N),ne.length+N.length<1e6&&(ne+=N)}),J.on("close",()=>{if(this.a.appendLine(ae?"Got data from stdout":"No data from stdout"),this.a.appendLine(fe?"Got result from parser":"No result from parser"),pe&&this.a.appendLine(`Got data without result: ${pe}`),this.a.appendLine(""),ie)T({limitHit:re});else{se.flush(),J=null;let x;ne&&!ae&&(x=a(ne))?z((0,I.$hI)(new I.$fI(x.message,x.code))):T({limitHit:re})}})})}}e.$Occ=o;function a(d){const p=d.split(`
`),R=p[0].trim();if(p.some(j=>j.startsWith("regex parse error")))return new I.$fI(m(p),I.SearchErrorCode.regexParseError);const O=R.match(/grep config error: unknown encoding: (.*)/);if(O)return new I.$fI(`Unknown encoding: ${O[1]}`,I.SearchErrorCode.unknownEncoding);if(R.startsWith("error parsing glob"))return new I.$fI(R.charAt(0).toUpperCase()+R.substr(1),I.SearchErrorCode.globParseError);if(R.startsWith("the literal"))return new I.$fI(R.charAt(0).toUpperCase()+R.substr(1),I.SearchErrorCode.invalidLiteral);if(R.startsWith("PCRE2: error compiling pattern"))return new I.$fI(R,I.SearchErrorCode.regexParseError)}function m(d){const p=["Regex parse error"],R=d.filter(O=>O.startsWith("PCRE2:"));if(R.length>=1){const O=R[0].replace("PCRE2:","");if(O.indexOf(":")!==-1&&O.split(":").length>=2){const j=O.split(":")[1];p.push(":"+j)}}return p.join("")}class v extends F.EventEmitter{constructor(p,R,O){super(),this.g=p,this.h=R,this.j=O,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new h.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(p,R){return super.on(p,R),this}handleData(p){if(this.b)return;const R=typeof p=="string"?p:this.d.write(p);this.k(R)}k(p){let R=p.indexOf(`
`);const O=this.a+p;if(R>=0)R+=this.a.length;else{this.a=O;return}let j=0;for(;R>=0;)this.m(O.substring(j,R).trim()),j=R+1,R=O.indexOf(`
`,j);this.a=O.substring(j)}m(p){if(this.b||!p)return;let R;try{R=JSON.parse(p)}catch{throw new Error(`malformed line from rg: ${p}`)}if(R.type==="match"){const O=D(R.data.path),j=P.URI.file(w.$8c(this.h,O)),T=this.n(R.data,j);this.p(T),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(R.type==="context"){const O=D(R.data.path),j=P.URI.file(w.$8c(this.h,O));this.o(R.data,j).forEach(z=>this.p(z))}}n(p,R){const O=p.line_number-1,j=D(p.lines),T=Buffer.from(j);let z=0,B=0,M=O;p.submatches.length===0&&p.submatches.push(j.length?{start:0,end:1,match:{text:j[0]}}:{start:0,end:0,match:{text:""}});const Y=(0,L.$jf)(p.submatches.map((J,fe)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const se=D(J.match),ie=T.slice(z,J.start).toString(),V=t(ie),re=V.numLines>0?V.lastLineLength:V.lastLineLength+B,pe=t(se),ae=V.numLines+M,ne=pe.numLines+ae,x=pe.numLines>0?pe.lastLineLength:pe.lastLineLength+re;return z=J.end,B=x,M=ne,new $.$3H(ae,re,ne,x)}));return(0,E.$Hcc)(R,j,Y,this.j)}o(p,R){const O=D(p.lines),j=p.line_number;return O.replace(/\r?\n$/,"").split(`
`).map((T,z)=>({text:T,uri:R,lineNumber:j+z}))}p(p){this.emit("result",p)}}e.$Pcc=v;function D(d){return d.bytes?Buffer.from(d.bytes,"base64").toString():d.text}function t(d){const p=/\n/g;let R=0,O=-1,j;for(;j=p.exec(d);)R++,O=j.index;const T=O>=0?d.length-O-1:d.length;return{numLines:R,lastLineLength:T}}function r(d,p){const R=["--hidden","--no-require-git"];R.push(d.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:O,otherIncludes:j}=(0,A.$I)(p.includes,z=>z.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(j&&j.length){const z=new Set;j.forEach(B=>{z.add(B)}),R.push("-g","!*"),z.forEach(B=>{s(B).map(E.$Gcc).forEach(M=>{R.push("-g",M)})})}O&&O.length&&O.forEach(z=>{R.push("-g",z)}),p.excludes.map(E.$Gcc).forEach(z=>R.push("-g",`!${z}`)),p.maxFileSize&&R.push("--max-filesize",p.maxFileSize+""),p.useIgnoreFiles?p.useParentIgnoreFiles||R.push("--no-ignore-parent"):R.push("--no-ignore"),p.followSymlinks&&R.push("--follow"),p.encoding&&p.encoding!=="utf8"&&R.push("--encoding",p.encoding),d.pattern==="--"&&(d.isRegExp=!0,d.pattern="\\-\\-"),d.isMultiline&&!d.isRegExp&&(d.pattern=(0,g.$pd)(d.pattern),d.isRegExp=!0),p.usePCRE2&&R.push("--pcre2"),R.push("--crlf"),d.isRegExp&&(d.pattern=i(d.pattern),R.push("--engine","auto"));let T;if(d.isWordMatch){const B=(0,g.$xd)(d.pattern,!!d.isRegExp,{wholeWord:d.isWordMatch}).source.replace(/\\\//g,"/");R.push("--regexp",B)}else if(d.isRegExp){let z=l(d.pattern);z=b(z),R.push("--regexp",z)}else T=d.pattern,R.push("--fixed-strings");return R.push("--no-config"),p.useGlobalIgnoreFiles||R.push("--no-ignore-global"),R.push("--json"),d.isMultiline&&R.push("--multiline"),p.beforeContext&&R.push("--before-context",p.beforeContext+""),p.afterContext&&R.push("--after-context",p.afterContext+""),R.push("--"),T&&R.push(T),R.push("."),R}e.$Qcc=r;function s(d){return u(d).flatMap(R=>{const O=(0,f.$cj)(R,"/");return O.map((j,T)=>O.slice(0,T+1).join("/"))})}function i(d){const p=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;d.match(p);)d=d.replace(p,"$1\\x{$2}");const R=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;d.match(R);)d=d.replace(R,"$1\\x{$2}");return d}e.$Rcc=i;const c=d=>d.type==="Assertion"&&d.kind==="lookbehind";function l(d){let p;try{p=new k.RegExpParser().parsePattern(d)}catch{return d}let R="",O=0;const j=(B,M,Y)=>{R+=d.slice(O,B)+Y,O=M},T=[];return new k.RegExpVisitor({onCharacterEnter(B){if(B.raw!=="\\n")return;const M=T[0];if(!M)j(B.start,B.end,"\\r?\\n");else if(!T.some(c))if(M.type==="CharacterClass")if(M.negate){const Y=d.slice(M.start+2,B.start)+d.slice(B.end,M.end-1);M.parent?.type==="Quantifier"?j(M.start,M.end,Y?`[^${Y}]`:"."):j(M.start,M.end,"(?!\\r?\\n"+(Y?`|[${Y}]`:"")+")")}else{const Y=d.slice(M.start+1,B.start)+d.slice(B.end,M.end-1);j(M.start,M.end,Y===""?"\\r?\\n":`(?:[${Y}]|\\r?\\n)`)}else M.type==="Quantifier"&&j(B.start,B.end,"(?:\\r?\\n)")},onQuantifierEnter(B){T.unshift(B)},onQuantifierLeave(){T.shift()},onCharacterClassRangeEnter(B){T.unshift(B)},onCharacterClassRangeLeave(){T.shift()},onCharacterClassEnter(B){T.unshift(B)},onCharacterClassLeave(){T.shift()},onAssertionEnter(B){c(B)&&T.push(B)},onAssertionLeave(B){T[0]===B&&T.shift()}}).visit(p),R+=d.slice(O),R}e.$Scc=l;function b(d){return d.replace(/\n/g,"\\r?\\n")}e.$Tcc=b;function y(d){let p=!1,R=!1,O="",j="";for(let T=0;T<d.length;T++){const z=d[T];switch(z){case"\\":R?(p?j+="\\"+z:O+="\\"+z,R=!1):R=!0;break;case"{":if(R)p?j+=z:O+=z,R=!1;else{if(p)return{strInBraces:O+"{"+j+"{"+d.substring(T+1)};p=!0}break;case"}":if(R)p?j+=z:O+=z,R=!1;else{if(p)return{fixedStart:O,strInBraces:j,fixedEnd:d.substring(T+1)};O+=z}break;default:p?j+=(R?"\\":"")+z:O+=(R?"\\":"")+z,R=!1;break}}return{strInBraces:O+(p?"{"+j:"")}}function u(d){const{fixedStart:p,strInBraces:R,fixedEnd:O}=y(d);if(p===void 0||O===void 0)return[R];let j=(0,f.$cj)(R,",");j.length||(j=[""]);const T=u(O);return j.flatMap(z=>{const B=p+z;return T.map(M=>B+M)})}e.$Ucc=u}),define(Se[351],De([1,0,22,152,83,16]),function(me,e,S,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=void 0;class A{constructor(g){this.b=g,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(g,P,I,$){const k=new F.$Occ(this.b);if(P.folder.scheme===L.Schemas.vscodeUserData){const C={...P,folder:P.folder.with({scheme:L.Schemas.file})},E=new h.$Tu(n=>I.report({...n,uri:n.uri.with({scheme:P.folder.scheme})}));return this.c($,n=>k.provideTextSearchResults(g,C,E,n))}else return this.c($,C=>k.provideTextSearchResults(g,P,I,C))}async c(g,P){const I=f(g);this.a.add(I);const $=await P(I.token);return this.a.delete(I),$}d(){this.a.forEach(g=>g.cancel())}}e.$Ycc=A;function f(w){const g=new S.$oc;return w.onCancellationRequested(()=>g.cancel()),g}}),define(Se[352],De([1,0,29,152,151]),function(me,e,S,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=void 0;class L{constructor(w){this.a=w}search(w,g,P){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(k){P({message:k})}},$=new h.$Vcc(this.a,new F.$Occ(I),S);return new Promise((k,C)=>$.search(E=>{g(E.map(A))},w).then(E=>k({limitHit:E.limitHit,type:"success",stats:E.stats}),C))}}e.$Wcc=L;function A(f){return{path:f.resource&&f.resource.fsPath,results:f.results,numMatches:(f.results||[]).reduce((w,g)=>{if(g.ranges){const P=g;return w+(Array.isArray(P.ranges)?P.ranges.length:1)}else return w+1},0)}}}),define(Se[353],De([1,0,18,13,8,4,125,14,37,2,30,36,348,352]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=void 0;class C{static{this.a=512}constructor(v="searchProcess"){this.d=v,this.b=Object.create(null)}fileSearch(v){let D;const t=o(v),r=new L.$ec({onDidAddFirstListener:()=>{D=(0,F.$ig)(s=>this.doFileSearchWithEngine($.$Ncc,t,i=>r.fire(i),s)),D.then(s=>r.fire(s),s=>r.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{D.cancel()}});return r.event}textSearch(v){let D;const t=o(v),r=new L.$ec({onDidAddFirstListener:()=>{D=(0,F.$ig)(s=>this.f(t,i=>r.fire(i),s)),D.then(s=>r.fire(s),s=>r.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{D.cancel()}});return r.event}f(v,D,t){return v.maxFileSize=this.g().maxFileSize,new k.$Wcc(v).search(t,D,D)}g(){return{maxFileSize:process.arch==="ia32"?300*P.$nk.MB:16*P.$nk.GB}}doFileSearch(v,D,t){return this.doFileSearchWithEngine($.$Ncc,v,D,t)}doFileSearchWithEngine(v,D,t,r,s=C.a){let i=0;const c=b=>{Array.isArray(b)?(i+=b.length,t(b.map(y=>this.h(y)))):b.relativePath?(i++,t(this.h(b))):t(b)};if(D.sortByScore){let b=this.l(D,c,r);if(!b){const y=D.maxResults?Object.assign({},D,{maxResults:null}):D,u=new v(y);b=this.j(u,D,t,c,r)}return new Promise((y,u)=>{b.then(([d,p])=>{const R=p.map(O=>this.h(O));this.o(R,t,s),y(d)},u)})}const l=new v(D);return this.r(l,c,s,r).then(b=>({limitHit:b.limitHit,type:"success",stats:{detailStats:b.stats,type:this.d,fromCache:!1,resultCount:i,sortingTime:void 0}}))}h(v){return{path:v.base?(0,f.$8c)(v.base,v.relativePath):v.relativePath}}j(v,D,t,r,s){const i=new L.$ec;let c=(0,F.$ig)(b=>{let y=[];const u=d=>{Array.isArray(d)?y=d:(r(d),i.fire(d))};return this.r(v,u,-1,b).then(d=>[d,y])}),l;if(D.cacheKey){l=this.k(D.cacheKey);const b={promise:c,event:i.event,resolved:!1};l.resultsToSearchCache[D.filePattern||""]=b,c.then(()=>{b.resolved=!0},y=>{delete l.resultsToSearchCache[D.filePattern||""]}),c=this.s(c)}return c.then(([b,y])=>{const u=l?l.scorerCache:Object.create(null),d=(typeof D.maxResults!="number"||D.maxResults>0)&&w.$ac.create(!1);return this.n(D,y,u,s).then(p=>{const R=d?d.elapsed():-1;return[{type:"success",stats:{detailStats:b.stats,sortingTime:R,fromCache:!1,type:this.d,workspaceFolderCount:D.folderQueries.length,resultCount:p.length},messages:b.messages,limitHit:b.limitHit||typeof D.maxResults=="number"&&y.length>D.maxResults},p]})})}k(v){const D=this.b[v];return D||(this.b[v]=new E)}l(v,D,t){const r=v.cacheKey&&this.b[v.cacheKey];if(!r)return;const s=this.q(r,v.filePattern||"",D,t);if(s)return s.then(([i,c,l])=>{const b=w.$ac.create(!1);return this.n(v,c,r.scorerCache,t).then(y=>{const u=b.elapsed(),d={fromCache:!0,detailStats:l,type:this.d,resultCount:c.length,sortingTime:u};return[{type:"success",limitHit:i.limitHit||typeof v.maxResults=="number"&&c.length>v.maxResults,stats:d},y]})})}n(v,D,t,r){const s=(0,A.$fq)(v.filePattern||""),i=(l,b)=>(0,A.$eq)(l,b,s,!0,n,t),c=typeof v.maxResults=="number"?v.maxResults:Number.MAX_VALUE;return S.$if(D,i,c,1e4,r)}o(v,D,t){if(t&&t>0)for(let r=0;r<v.length;r+=t)D(v.slice(r,r+t));else D(v)}q(v,D,t,r){const s=w.$ac.create(!1),i=D.indexOf(f.sep)>=0;let c;for(const u in v.resultsToSearchCache)if(D.startsWith(u)){if(i&&u.indexOf(f.sep)<0&&u!=="")continue;const d=v.resultsToSearchCache[u];c={promise:this.s(d.promise),event:d.event,resolved:d.resolved};break}if(!c)return null;const l=s.elapsed(),b=w.$ac.create(!1),y=c.event(t);return r&&r.onCancellationRequested(()=>{y.dispose()}),c.promise.then(([u,d])=>{if(r&&r.isCancellationRequested)throw(0,h.$4)();const p=[],R=(0,A.$fq)(D).normalizedLowercase;for(const O of d)(0,I.$lI)(O,R)&&p.push(O);return[u,p,{cacheWasResolved:c.resolved,cacheLookupTime:l,cacheFilterTime:b.elapsed(),cacheEntryCount:d.length}]})}r(v,D,t,r){return new Promise((s,i)=>{let c=[];r?.onCancellationRequested(()=>v.cancel()),v.search(l=>{l&&(t?(c.push(l),t>0&&c.length>=t&&(D(c),c=[])):D(l))},l=>{D(l)},(l,b)=>{c.length&&D(c),l?i(l):s(b)})})}clearCache(v){return delete this.b[v],Promise.resolve(void 0)}s(v){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(D,t){return v.then(D,t)}catch(D){return this.then(void 0,D)}finally(D){return v.finally(D)}}}}e.$Xcc=C;class E{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const n=new class{getItemLabel(m){return(0,f.$_c)(m.relativePath)}getItemDescription(m){return(0,f.$$c)(m.relativePath)}getItemPath(m){return m.relativePath}};function o(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(a),extraFileResources:m.extraFileResources&&m.extraFileResources.map(v=>g.URI.revive(v))}}function a(m){return{...m,folder:g.URI.revive(m.folder)}}}),define(Se[354],De([1,0,3,16,2,29,17,26,20,95,62,36,353,351,115,151]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=void 0;let n=class extends g.$Qbc{constructor(a,m,v,D){super(a,v,D),this.s=L,this.t=-1,this.v=null,this.w=!1;const t=new C.$Icc("RipgrepSearchUD",this.n);this.registerTextSearchProvider(F.Schemas.vscodeUserData,new k.$Ycc(t)),m.remote.isRemote&&m.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const a=new C.$Icc("RipgrepSearchEH",this.n);this.registerTextSearchProvider(F.Schemas.file,new k.$Ycc(a)),this.y(F.Schemas.file,new $.$Xcc("fileSearchProvider"))}y(a,m){const v=this.d++;return this.v=m,this.t=v,this.c.$registerFileSearchProvider(v,this.o(a)),(0,S.$jb)(()=>{this.v=null,this.c.$unregisterProvider(v)})}$provideFileSearchResults(a,m,v,D){const t=(0,g.$Rbc)(v);return a===this.t?this.z(a,m,t,D):super.$provideFileSearchResults(a,m,v,D)}z(a,m,v,D){const t=r=>{if((0,I.$kI)(r)&&(r=[r]),Array.isArray(r)){this.c.$handleFileMatch(a,m,r.map(s=>h.URI.file(s.path)));return}r.message&&this.n.debug("ExtHostSearch",r.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(v,t,D)}$clearCache(a){return this.v?.clearCache(a),super.$clearCache(a)}q(a,m){return new E.$Vcc(a,m,void 0,"textSearchProvider")}};e.$Zcc=n,e.$Zcc=n=Je([Be(0,w.$LL),Be(1,f.$2L),Be(2,P.$wac),Be(3,A.$Ri)],n)}),define(Se[116],De([1,0,368,57,59,369,21,8,4,3,14,9,31,79,80]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=void 0;class E{traceSocketEvent(d,p){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,d,p)}constructor(d,p=""){this.f=!0,this.debugLabel=p,this.socket=d,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=R=>{if(this.traceSocketEvent("error",{code:R?.code,message:R?.message}),R){if(R.code==="EPIPE")return;(0,f.$Y)(R)}},this.socket.on("error",this.a),this.b=R=>{this.traceSocketEvent("close",{hadError:R}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(d){const p=R=>{this.traceSocketEvent("read",R),d(A.$Ec.wrap(R))};return this.socket.on("data",p),{dispose:()=>this.socket.off("data",p)}}onClose(d){const p=R=>{d({type:0,hadError:R,error:void 0})};return this.socket.on("close",p),{dispose:()=>this.socket.off("close",p)}}onEnd(d){const p=()=>{d()};return this.socket.on("end",p),{dispose:()=>this.socket.off("end",p)}}write(d){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",d),this.socket.write(d.buffer,p=>{if(p){if(p.code==="EPIPE")return;(0,f.$Y)(p)}})}catch(p){if(p.code==="EPIPE")return;(0,f.$Y)(p)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((d,p)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),d();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),this.traceSocketEvent("nodeDrainEnd"),d()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.$eh=E;var n;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize",u[u.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(n||(n={}));var o;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(o||(o={}));class a extends g.$lb{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(d,p){this.socket.traceSocketEvent(d,p)}constructor(d,p,R,O){super(),this.f=this.B(new w.$ec),this.g=this.B(new w.$ec),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=d,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:p,inflateBytesLength:R?.byteLength||0,recordInflateBytes:O}),this.a=this.B(new m(this,p,R,O,this.f,(j,T)=>this.k(j,T))),this.B(this.a.onError(j=>{console.error(j),(0,f.$Y)(j),this.g.fire({type:0,hadError:!0,error:j})})),this.b=new C.$_g,this.B(this.socket.onData(j=>this.l(j))),this.B(this.socket.onClose(async j=>{this.a.isProcessingReadQueue()&&await w.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(j)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(d){return this.f.event(d)}onClose(d){return this.g.event(d)}onEnd(d){return this.socket.onEnd(d)}write(d){let p=0;for(;p<d.byteLength;)this.a.writeMessage(d.slice(p,Math.min(p+262144,d.byteLength))),p+=262144}k(d,p){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",d);let R=2;d.byteLength<126?R+=0:d.byteLength<2**16?R+=2:R+=8;const O=A.$Ec.alloc(R);if(p?O.writeUInt8(194,0):O.writeUInt8(130,0),d.byteLength<126)O.writeUInt8(d.byteLength,1);else if(d.byteLength<2**16){O.writeUInt8(126,1);let j=1;O.writeUInt8(d.byteLength>>>8&255,++j),O.writeUInt8(d.byteLength>>>0&255,++j)}else{O.writeUInt8(127,1);let j=1;O.writeUInt8(0,++j),O.writeUInt8(0,++j),O.writeUInt8(0,++j),O.writeUInt8(0,++j),O.writeUInt8(d.byteLength>>>24&255,++j),O.writeUInt8(d.byteLength>>>16&255,++j),O.writeUInt8(d.byteLength>>>8&255,++j),O.writeUInt8(d.byteLength>>>0&255,++j)}this.socket.write(A.$Ec.concat([O,d]))}end(){this.h=!0,this.socket.end()}l(d){if(d.byteLength!==0){for(this.b.acceptChunk(d);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const p=this.b.peek(this.j.readLen),R=p.readUInt8(0),O=(R&128)>>>7,j=(R&64)>>>6,T=p.readUInt8(1),z=(T&128)>>>7,B=T&127;this.j.state=2,this.j.readLen=2+(z?4:0)+(B===126?2:0)+(B===127?8:0),this.j.fin=O,this.j.firstFrameOfMessage&&(this.j.compressed=!!j),this.j.firstFrameOfMessage=!!O,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const p=this.b.read(this.j.readLen),R=p.readUInt8(1),O=(R&128)>>>7;let j=R&127,T=1;j===126?j=p.readUInt8(++T)*2**8+p.readUInt8(++T):j===127&&(j=p.readUInt8(++T)*0+p.readUInt8(++T)*0+p.readUInt8(++T)*0+p.readUInt8(++T)*0+p.readUInt8(++T)*2**24+p.readUInt8(++T)*2**16+p.readUInt8(++T)*2**8+p.readUInt8(++T));let z=0;O&&(z=p.readUInt8(++T)*2**24+p.readUInt8(++T)*2**16+p.readUInt8(++T)*2**8+p.readUInt8(++T)),this.j.state=3,this.j.readLen=j,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const p=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",p),t(p,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",p),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(p,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await w.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$fh=a;class m extends g.$lb{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$Ec.alloc(0)}constructor(d,p,R,O,j,T){super(),this.l=d,this.m=j,this.n=T,this.a=this.B(new w.$ec),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new w.$ec),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new w.$ec),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,p?(this.b=this.B(new v(this.l,O,R,{windowBits:15})),this.f=this.B(new D(this.l,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(d){this.g.push(d),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const d=this.g.shift();if(this.f){const p=await this.s(this.f,d);this.n(p,!0)}else this.n(d,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(d,p){return new Promise((R,O)=>{d.write(p),d.flush(j=>R(j))})}acceptFrame(d,p,R){this.h.push({data:d,isCompressed:p,isLastFrameOfMessage:R}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const d=this.h.shift();if(this.b&&d.isCompressed){const p=await this.w(this.b,d.data,d.isLastFrameOfMessage);this.m.fire(p)}else this.m.fire(d.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(d,p,R){return new Promise((O,j)=>{d.write(p),R&&d.write(A.$Ec.fromByteArray([0,0,255,255])),d.flush(T=>O(T))})}}class v extends g.$lb{get recordedInflateBytes(){return this.j?A.$Ec.concat(this.f):A.$Ec.alloc(0)}constructor(d,p,R,O){super(),this.h=d,this.j=p,this.a=this.B(new w.$ec),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(O),this.b.on("error",j=>{this.h.traceSocketEvent("zlibInflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.h.traceSocketEvent("zlibInflateData",j),this.g.push(A.$Ec.wrap(j))}),R&&(this.h.traceSocketEvent("zlibInflateInitialWrite",R.buffer),this.b.write(R.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(d){this.j&&this.f.push(d.clone()),this.h.traceSocketEvent("zlibInflateWrite",d),this.b.write(d.buffer)}flush(d){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const p=A.$Ec.concat(this.g);this.g.length=0,d(p)})}}class D extends g.$lb{constructor(d,p){super(),this.g=d,this.a=this.B(new w.$ec),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",R=>{this.g.traceSocketEvent("zlibDeflateError",{message:R?.message,code:R?.code}),this.a.fire(R)}),this.b.on("data",R=>{this.g.traceSocketEvent("zlibDeflateData",R),this.f.push(A.$Ec.wrap(R))})}write(d){this.g.traceSocketEvent("zlibDeflateWrite",d.buffer),this.b.write(d.buffer)}flush(d){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let p=A.$Ec.concat(this.f);this.f.length=0,p=p.slice(0,p.byteLength-4),d(p)})}}function t(u,d){if(d===0)return;const p=u.byteLength>>>2;for(let B=0;B<p;B++){const M=u.readUInt32BE(B*4);u.writeUInt32BE(M^d,B*4)}const R=p*4,O=u.byteLength-R,j=d>>>24&255,T=d>>>16&255,z=d>>>8&255;O>=1&&u.writeUInt8(u.readUInt8(R)^j,R),O>=2&&u.writeUInt8(u.readUInt8(R+1)^T,R+1),O>=3&&u.writeUInt8(u.readUInt8(R+2)^z,R+2)}e.$gh=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function s(){const u=(0,$.$3e)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;const d=process.platform!=="darwin"&&e.$gh?e.$gh:(0,h.tmpdir)(),p=(0,P.$8c)(d,`vscode-ipc-${u}.sock`);return c(p),p}e.$hh=s;function i(u,d,p){const R=(0,S.createHash)("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${p}-${d}-sock`;const O=p.substr(0,4),j=d.substr(0,6),T=R.substr(0,8);let z;return process.platform!=="darwin"&&e.$gh&&!process.env.VSCODE_PORTABLE?z=(0,P.$8c)(e.$gh,`vscode-${T}-${O}-${j}.sock`):z=(0,P.$8c)(u,`${O}-${j}.sock`),c(z),z}e.$ih=i;function c(u){const d=r[I.$t];typeof d=="number"&&u.length>=d&&console.warn(`WARNING: IPC handle "${u}" is longer than ${d} chars, try a shorter --user-data-dir`)}class l extends k.$6g{static b(d){const p=w.Event.fromNodeEventEmitter(d,"connection");return w.Event.map(p,R=>({protocol:new C.$ah(new E(R,"ipc-server-connection")),onDidClientDisconnect:w.Event.once(w.Event.fromNodeEventEmitter(R,"close"))}))}constructor(d){super(l.b(d)),this.d=d}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$jh=l;function b(u){return new Promise((d,p)=>{const R=(0,F.createServer)();R.on("error",p),R.listen(u,()=>{R.removeListener("error",p),d(new l(R))})})}e.$kh=b;function y(u,d){return new Promise((p,R)=>{const O=(0,F.createConnection)(u,()=>{O.removeListener("error",R),p(C.$bh.fromSocket(new E(O,`ipc-client${d}`),d))});O.once("error",R)})}e.$lh=y}),define(Se[355],De([1,0,57,59,160,116,13,3,9,50,17,133,240,241,105,106,21]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y6b=e.$x6b=e.$w6b=e.$v6b=void 0;async function o(t,r,s,i,c){let l;for(let b=3;b&&(l?.dispose(),l=await new a(t,r,s,i,c).waitForReady(),!(c&&h.$6e[c]||!h.$6e[l.tunnelLocalPort]));b--);return l}class a extends f.$lb{constructor(r,s,i,c,l){super(),this.j=s,this.k=l,this.privacy=E.TunnelPrivacyId.Private,this.i=new Map,this.a=r,this.b=S.createServer(),this.c=new A.$tg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=b=>this.l(b),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=c,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(s=>{s()})}async waitForReady(){const r=this.k??this.tunnelRemotePort,s=(0,E.$Sz)(this.j)?"0.0.0.0":"127.0.0.1";let i=await(0,h.$7e)(r,2,1e3,s),c=null;return this.b.listen(i,this.j),await this.c.wait(),c=this.b.address(),c||(i=0,this.b.listen(i,this.j),await this.c.wait(),c=this.b.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async l(r){r.pause();const s=(0,E.$Qz)(this.tunnelRemoteHost)||(0,E.$Sz)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,$.$Mk)(this.a,s,this.tunnelRemotePort),c=i.getSocket(),l=i.readEntireBuffer();i.dispose(),l.byteLength>0&&r.write(l.buffer),r.on("end",()=>{r.localAddress&&this.i.delete(r.localAddress),c.end()}),r.on("close",()=>c.end()),r.on("error",()=>{r.localAddress&&this.i.delete(r.localAddress),c instanceof L.$eh?c.socket.destroy():c.end()}),c instanceof L.$eh?this.n(r,c):this.m(r,c),r.localAddress&&this.i.set(r.localAddress,()=>{r.end(),c.end()})}m(r,s){s.onClose(()=>r.destroy()),s.onEnd(()=>r.end()),s.onData(i=>r.write(i.buffer)),r.on("data",i=>s.write(n.$Ec.wrap(i))),r.resume()}n(r,s){const i=s.socket;i.on("end",()=>r.end()),i.on("close",()=>r.end()),i.on("error",()=>{r.destroy()}),i.pipe(r),r.pipe(i)}}e.$v6b=a;let m=class extends E.$Vz{constructor(r,s,i,c,l){super(s,l),this.u=r,this.v=i,this.w=c}isPortPrivileged(r){return(0,E.$Tz)(r,this.l,w.OS,F.release())}s(r,s,i,c,l,b,y,u){const d=this.r(s,i);if(d)return++d.refcount,d.value;if((0,E.$Nz)(r))return this.t(r,s,i,l,b,y,u);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${i} on local port ${l}.`);const p={commit:this.w.commit,quality:this.w.quality,addressProvider:r,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},R=o(p,c,s,i,l);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(s,i,R),R}}};e.$w6b=m,e.$w6b=m=Je([Be(0,k.$Gk),Be(1,P.$Ri),Be(2,C.$Jk),Be(3,I.$0i),Be(4,g.$Vh)],m);let v=class extends m{constructor(r,s,i,c,l){super(r,s,i,c,l)}};e.$x6b=v,e.$x6b=v=Je([Be(0,k.$Gk),Be(1,P.$Ri),Be(2,C.$Jk),Be(3,I.$0i),Be(4,g.$Vh)],v);let D=class extends f.$lb{constructor(r,s,i,c,l){super(),this.b=r,this.c=s,this.f=i,this.g=c,this.h=l,this.a=new Map}async openTunnel(r,s,i,c,l,b,y,u,d){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${c} on local port ${b}.`),!this.a.has(r)){const p=new v(this.b,this.c,this.g,this.f,this.h);this.B(p),this.a.set(r,p),p.onTunnelClosed(async()=>{(await p.tunnels).length===0&&(p.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(s,i,c,l,b,y,u,d)}};e.$y6b=D,e.$y6b=D=Je([Be(0,k.$Gk),Be(1,P.$Ri),Be(2,I.$0i),Be(3,C.$Jk),Be(4,g.$Vh)],D)}),define(Se[356],De([1,0,116,257,49,33,2,17,51]),function(me,e,S,F,h,L,A,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bM=e.$aM=void 0;class g{constructor($,k,C){this.b=$,this.c=k,this.f=C,this.a=F.createServer((E,n)=>this.h(E,n)),this.g().catch(E=>(k.error(E),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",$=>this.c.error($))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h($,k){const C=(n,o)=>{k.writeHead(n,{"content-type":"application/json"}),k.end(JSON.stringify(o||null),a=>a&&this.c.error(a))},E=[];$.setEncoding("utf8"),$.on("data",n=>E.push(n)),$.on("end",async()=>{try{const n=JSON.parse(E.join(""));let o;switch(n.type){case"open":o=await this.i(n);break;case"openExternal":o=await this.j(n);break;case"status":o=await this.l(n);break;case"extensionManagement":o=await this.k(n);break;default:C(404,`Unknown message type: ${n.type}`);break}C(200,o)}catch(n){const o=n instanceof Error?n.message:JSON.stringify(n);C(500,o),this.c.error("Error while processing pipe request",n)}})}async i($){const{fileURIs:k,folderURIs:C,forceNewWindow:E,diffMode:n,mergeMode:o,addMode:a,forceReuseWindow:m,gotoLineMode:v,waitMarkerFilePath:D,remoteAuthority:t}=$,r=[];if(Array.isArray(C))for(const l of C)try{r.push({folderUri:A.URI.parse(l)})}catch{}if(Array.isArray(k))for(const l of k)try{(0,w.$Uh)(l)?r.push({workspaceUri:A.URI.parse(l)}):r.push({fileUri:A.URI.parse(l)})}catch{}const s=D?A.URI.file(D):void 0,c={forceNewWindow:E,diffMode:n,mergeMode:o,addMode:a,gotoLineMode:v,forceReuseWindow:m,preferNewWindow:!m&&!s&&!a,waitMarkerFileURI:s,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",r,c)}async j($){for(const k of $.uris){const C=A.URI.parse(k),E=C.scheme==="file"?C:k;await this.b.executeCommand("_remoteCLI.openExternal",E)}}async k($){const k=E=>E?.map(n=>/\.vsix$/i.test(n)?A.URI.parse(n):n),C={list:$.list,install:k($.install),uninstall:k($.uninstall),force:$.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",C)}async l($){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&h.existsSync(this.f)&&h.unlinkSync(this.f)}}e.$aM=g;let P=class extends g{constructor($,k){super($,k,(0,S.$hh)())}};e.$bM=P,e.$bM=P=Je([Be(0,L.$8L),Be(1,f.$Ri)],P)}),define(Se[357],De([1,0,61,344,339,256,44,328,2,16,7,356,99,326,327]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=void 0;class E extends h.$tcc{j(){const a=this,m=globalThis._VSCODE_NODE_MODULES.module,v=m._load;m._load=function(s,i,c){return s=t(s),a.a.has(s)?a.a.get(s).load(s,w.URI.file((0,$.$Op)(i.filename)),l=>v.apply(this,[l,i,c])):v.apply(this,arguments)};const D=m._resolveLookupPaths;m._resolveLookupPaths=(r,s)=>D.call(this,t(r),s);const t=r=>{for(const s of a.b){const i=s(r);if(i){r=i;break}}return r}}}class n extends A.$7ac{constructor(){super(...arguments),this.extensionRuntime=P.ExtensionRuntime.Node}async pb(){this.h.createInstance(k.$3cc);const a=this.h.invokeFunction(F.$pcc);if(this.h.createInstance(f.$2cc),this.f.remote.isRemote&&this.f.remote.authority){const D=this.h.createInstance(I.$bM);process.env.VSCODE_IPC_HOOK_CLI=D.ipcHandlePath}this.h.createInstance(C.$4cc),await this.h.createInstance(E,a,{mine:this.F,all:this.G}).install(),S.mark("code/extHost/didInitAPI");const v=await this.k.getConfigProvider();await(0,L.$1cc)(this.j,v,this,this.l,this.u,this.f),S.mark("code/extHost/didInitProxyResolver")}qb(a){return a.main}async rb(a,m,v){if(m.scheme!==g.Schemas.file)throw new Error(`Cannot load URI: '${m}', must be of file-scheme`);let D=null;v.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${m.toString(!0)}`),this.l.flush();const t=a?.identifier.value;a&&await this.s.initializeLocalizedMessages(a);try{t&&S.mark(`code/extHost/willLoadExtensionCode/${t}`),D=me.__$__nodeRequire(m.fsPath)}finally{t&&S.mark(`code/extHost/didLoadExtensionCode/${t}`),v.codeLoadingStop()}return D}async $setRemoteEnvironment(a){if(this.f.remote.isRemote)for(const m in a){const v=a[m];v===null?delete process.env[m]:process.env[m]=v}}}e.$5cc=n}),define(Se[358],De([1,0,46,21,4,3,118,9,24,2,29,17,239,84,105,106,355,26,20,68]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E,n,o,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=e.$_cc=e.$$cc=e.$0cc=e.$9cc=e.$8cc=e.$7cc=e.$6cc=void 0;function v(u){const d=u.trim().split(`
`),p=[];return d.forEach(O=>{const j=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(O);j&&j.length>=3&&p.push({pid:parseInt(j[1],10),socket:parseInt(j[2],10)})}),p.reduce((O,j)=>(O[j.socket]=j,O),{})}e.$6cc=v;function D(...u){const d=[].concat(...u.map(r));return[...new Map(d.filter(p=>p.st==="0A").map(p=>{const R=p.local_address.split(":");return{socket:parseInt(p.inode,10),ip:t(R[0]),port:parseInt(R[1],16)}}).map(p=>[p.ip+":"+p.port,p])).values()]}e.$7cc=D;function t(u){let d="";if(u.length===8)for(let p=u.length-2;p>=0;p-=2)d+=parseInt(u.substr(p,2),16),p!==0&&(d+=".");else for(let p=0;p<u.length;p+=8){const R=u.substring(p,p+8);let O="";for(let j=8;j>=2;j-=2)O+=R.substring(j-2,j),(j===6||j===2)&&(O=parseInt(O,16).toString(16),d+=`${O}`,O="",p+j!==u.length-6&&(d+=":"))}return d}e.$8cc=t;function r(u){const d=u.trim().split(`
`),p=d.shift().trim().split(/\s+/).filter(O=>O!=="rx_queue"&&O!=="tm->when");return d.map(O=>O.trim().split(/\s+/).reduce((j,T,z)=>(j[p[z]||z]=T,j),{}))}e.$9cc=r;function s(u){return!!u.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||u.indexOf("out/server-main.js")!==-1||u.indexOf("_productName=VSCode")!==-1}function i(u){const d=u.trim().split(`
`),p=[];return d.forEach(R=>{const O=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(R);O&&O.length>=4&&p.push({pid:parseInt(O[1],10),ppid:parseInt(O[2]),cmd:O[3]})}),p}e.$0cc=i;async function c(u,d,p){const R=p.reduce((j,T)=>(j[T.pid]=T,j),{}),O=[];return u.forEach(({socket:j,ip:T,port:z})=>{const B=d[j]?d[j].pid:void 0,M=B?R[B]?.cmd:void 0;B&&M&&!s(M)&&O.push({host:T,port:z,detail:M,pid:B})}),O}e.$$cc=c;function l(u,d,p){const R=new Map,O=i(d);for(const j of u){const T=p.get(j.port);if(T){R.set(j.port,T);continue}const z=O.find(B=>B.cmd.includes(`${j.port}`));if(z){let B=z,M;do M=O.find(Y=>Y.ppid===B.pid),M&&(B=M);while(M);R.set(j.port,{host:j.ip,port:j.port,pid:B.pid,detail:B.cmd,ppid:B.ppid})}else R.set(j.port,{host:j.ip,port:j.port,ppid:Number.MAX_VALUE})}return R}e.$_cc=l;let b=class extends m.$Mrb{constructor(d,p,R,O){super(d,p,R),this.w=p,this.y=O,this.s=void 0,this.u=new Map,this.v=!1,f.$k&&p.remote.isRemote&&p.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.C())}async $registerCandidateFinder(d){if(d&&this.v)return;this.v=d;let p;this.s&&(p=this.s,await this.a.$onFoundNewCandidates(this.s));const R=new A.$xl;let O=0;for(;this.v;){const j=new Date().getTime(),T=(await this.D()).filter(M=>(0,E.$Qz)(M.host)||(0,E.$Sz)(M.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${T.map(M=>M.port).join(", ")}`);const z=new Date().getTime()-j;this.n.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${z} ms.`),O++>3&&R.update(z),(!p||JSON.stringify(p)!==JSON.stringify(T))&&(p=T,await this.a.$onFoundNewCandidates(p));const B=this.z(R.value);this.n.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${B} ms.`),await new Promise(M=>setTimeout(()=>M(),B))}}z(d){return Math.max(d*20,2e3)}async C(){this.s=await this.D(),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.s.map(d=>d.port).join(", ")}`)}async D(){let d="",p="";try{d=await P.Promises.readFile("/proc/net/tcp","utf8"),p=await P.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const R=D(d,p),O=await new Promise(fe=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(se,ie,V)=>{fe(ie)})}),j=v(O),T=await P.Promises.readdir("/proc"),z=[];for(const fe of T)try{const se=Number(fe),ie=w.$9f(g.URI.file("/proc"),fe);if((await P.Promises.stat(ie.fsPath)).isDirectory()&&!isNaN(se)){const re=await P.Promises.readlink(w.$9f(ie,"cwd").fsPath),pe=await P.Promises.readFile(w.$9f(ie,"cmdline").fsPath,"utf8");z.push({pid:se,cwd:re,cmd:pe})}}catch{}const B=[],M=R.filter(fe=>{const se=j[fe.socket];return se||B.push(fe),se}),Y=c(M,j,z);let J;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${B.length}`),B.length>0){const fe=await new Promise(se=>{(0,S.exec)("ps -F -A -l | grep root",(ie,V,re)=>{se(V)})});this.u=l(B,fe,this.u),J=Array.from(this.u.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${J.map(se=>se.port).join(", ")}`)}return Y.then(fe=>J?fe.concat(J):fe)}r(d){return async p=>{const R=new n.$v6b({commit:this.w.commit,quality:this.w.quality,logService:this.n,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(j,T,z,B){const M=await d.makeConnection();return y.connect(M,T,z,B)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new k.$xk(0),connectionToken:d.connectionToken})}},signService:this.y},"localhost",p.remoteAddress.host||"localhost",p.remoteAddress.port,p.localAddressPort);await R.waitForReady();const O=new h.$ec;return{localAddress:R.localAddress,remoteAddress:{port:R.tunnelRemotePort,host:R.tunnelRemoteHost},onDidDispose:O.event,dispose:()=>{R.dispose(),O.fire(),O.dispose()}}}}};e.$adc=b,e.$adc=b=Je([Be(0,a.$LL),Be(1,o.$2L),Be(2,I.$Ri),Be(3,C.$Jk)],b);class y extends $.$Zjb{static connect(d,p,R,O){const j=new L.$kb,T={onClose:j.add(new h.$ec),onData:j.add(new h.$ec),onEnd:j.add(new h.$ec)};j.add(d.onDidReceiveMessage(B=>T.onData.fire(F.$Ec.wrap(B)))),j.add(d.onDidEnd(()=>T.onEnd.fire())),j.add(d.onDidClose(B=>T.onClose.fire({type:0,error:B,hadError:!!B})));const z=new y(d,O,T);return z.B(j),(0,$.$Yjb)(z,p,R,O,T)}constructor(d,p,R){super(p,R),this.k=d}write(d){this.k.send(d.buffer)}h(){this.k.end()}async drain(){await this.k.drain?.()}}}),define(Se[359],De([1,0,102,331,342,341,354,357,358,94,44,95,93,43,68,90,330,329,17,343,53,251,101,105,136]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E,n,o,a,m,v,D,t,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,S.$dr)(P.$8ac,f.$5cc,0),(0,S.$dr)(a.$Si,o.$cdc,1),(0,S.$dr)(a.$Ri,new t.$mh(D.$scc,[!1],!0)),(0,S.$dr)(r.$Jk,s.$A6b,1),(0,S.$dr)(E.$Sac,n.$bdc,0),(0,S.$dr)(g.$Fbc,L.$Fcc,0),(0,S.$dr)(I.$Pbc,A.$Zcc,0),(0,S.$dr)($.$Abc,h.$xcc,0),(0,S.$dr)(k.$Uac,F.$wcc,0),(0,S.$dr)(C.$Lrb,w.$adc,0),(0,S.$dr)(v.$Dbc,m.$ddc,0)}),define(Se[370],De([1,0,57,371,61,8,80,116,237,110,340,21,29,99,13,129,258,276,345,359]),function(me,e,S,F,h,L,A,f,w,g,P,I,$,k,C,E,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let l=0;l<process.execArgv.length;l++)process.execArgv[l]==="--inspect-port=0"&&(process.execArgv.splice(l,1),l--)}();const a=F(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const c=globalThis._VSCODE_NODE_MODULES.module,l=c._load;c._load=function(b){if(b==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return l.apply(this,arguments)}})();const m=process.exit.bind(process);function v(c){process.exit=function(l){if(c)m(l);else{const b=new Error("An extension called process.exit() and this was prevented.");console.warn(b.stack)}},process.crash=function(){const l=new Error("An extension called process.crash() and this was prevented.");console.warn(l.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let D=function(c){m()};function t(){const c=(0,o.$em)(process.env);if(c.type===3)return new Promise((l,b)=>{const y=u=>{const d=u[0],p=new A.$ch;d.on("message",R=>p.fire(I.$Ec.wrap(R.data))),d.on("close",()=>{D("renderer closed the MessagePort")}),d.start(),l({onMessage:p.event,send:R=>d.postMessage(R.buffer)})};process.parentPort.on("message",u=>y(u.ports))});if(c.type===2)return new Promise((l,b)=>{let y=null;const u=setTimeout(()=>{D("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),d=108e5,p=3e5,R=new C.$Hg(()=>D("renderer disconnected for too long (1)"),d),O=new C.$Hg(()=>D("renderer disconnected for too long (2)"),p);process.on("message",(T,z)=>{if(T&&T.type==="VSCODE_EXTHOST_IPC_SOCKET"){z.setNoDelay(!0);const B=I.$Ec.wrap(Buffer.from(T.initialDataChunk,"base64"));let M;if(T.skipWebSocketFrames)M=new f.$eh(z,"extHost-socket");else{const Y=I.$Ec.wrap(Buffer.from(T.inflateBytes,"base64"));M=new f.$fh(new f.$eh(z,"extHost-socket"),T.permessageDeflate,Y,!1)}y?(R.cancel(),O.cancel(),y.beginAcceptReconnection(M,B),y.endAcceptReconnection(),y.sendResume()):(clearTimeout(u),y=new A.$dh({socket:M,initialChunk:B}),y.sendResume(),y.onDidDispose(()=>D("renderer disconnected")),l(y),y.onSocketClose(()=>{R.schedule()}))}if(T&&T.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(O.isScheduled())return;R.isScheduled()&&O.schedule()}});const j={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(j)});{const l=c.pipeName;return new Promise((b,y)=>{const u=S.createConnection(l,()=>{u.removeListener("error",y);const d=new A.$dh({socket:new f.$eh(u,"extHost-renderer")});d.sendResume(),b(d)});u.once("error",y),u.on("close",()=>{D("renderer closed the socket")})})}}async function r(){const c=await t();return new class{constructor(){this.a=new A.$ch,this.onMessage=this.a.event,this.b=!1,c.onMessage(l=>{(0,g.$Rl)(l,2)?(this.b=!0,D("received terminate message from renderer")):this.a.fire(l)})}send(l){this.b||c.send(l)}async drain(){if(c.drain)return c.drain()}}}function s(c){return new Promise(l=>{const b=c.onMessage(y=>{b.dispose();const u=JSON.parse(y.toString()),d=u.commit,p=w.default.commit;if(d&&p&&d!==p&&m(55),u.parentPid){let R=0;setInterval(function(){try{process.kill(u.parentPid,0),R=0}catch(j){j&&j.code==="EPERM"?(R++,R>=3&&D(`parent process ${u.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):D(`parent process ${u.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let O;try{O=globalThis._VSCODE_NODE_MODULES["native-watchdog"],O.start(u.parentPid)}catch(j){(0,L.$Y)(j)}}c.send((0,g.$Ql)(0)),l({protocol:c,initData:u})});c.send((0,g.$Ql)(1))})}async function i(){const c=[];process.on("unhandledRejection",(R,O)=>{c.push(O),setTimeout(()=>{const j=c.indexOf(O);j>=0&&O.catch(T=>{c.splice(j,1),(0,L.$2)(T)||(console.warn(`rejected promise not handled within 1 second: ${T}`),T&&T.stack&&console.warn(`stack trace: ${T.stack}`),R&&(0,L.$Y)(R))})},1e3)}),process.on("rejectionHandled",R=>{const O=c.indexOf(R);O>=0&&c.splice(O,1)}),process.on("uncaughtException",function(R){(0,L.$X)(R)||(0,L.$Y)(R)}),h.mark("code/extHost/willConnectToRenderer");const l=await r();h.mark("code/extHost/didConnectToRenderer");const b=await s(l);h.mark("code/extHost/didWaitForInitData");const{initData:y}=b;v(!!y.environment.extensionTestsLocationURI),y.environment.useHostProxy=a.useHostProxy!==void 0?a.useHostProxy!=="false":void 0,y.environment.skipWorkspaceStorageLock=(0,E.boolean)(a.skipWorkspaceStorageLock,!1);const u=new class{constructor(){this.pid=process.pid}exit(O){m(O)}fsExists(O){return $.Promises.exists(O)}fsRealpath(O){return(0,k.$Np)(O)}};let d=null;y.remote.authority&&a.transformURIs&&(d=(0,n.$hr)(y.remote.authority));const p=new P.$vcc(b.protocol,y,u,d);D=R=>p.terminate(R)}i().catch(c=>console.log(c))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/fdb98833154679dbaa7af67a5a29fe19e55c2b73/core/vs/workbench/api/node/extensionHostProcess.js.map
